var $ng__COMBINED = true;
var $MODULE_FACTORY_REGISTRY = typeof $MODULE_FACTORY_REGISTRY !== 'undefined' ? $MODULE_FACTORY_REGISTRY : {};
var $MODULE_REGISTRY = typeof $MODULE_REGISTRY !== 'undefined' ? $MODULE_REGISTRY : {};

var assert = typeof assert !== 'undefined' ? assert : function(x, y) { if(!x) throw new Error(y ? y:'Assertion Failed'); };

// override the require function anyway.
var require = function(path) {
    if (!$MODULE_FACTORY_REGISTRY[path]) {
        var e = new Error("RequireError: Module Missing or not yet Loaded ["+JSON.stringify(path)+"]");
        e.relatedFile = path;
        throw e;
    } else if (!require.cache[path]) {
        require.cache[path] = $MODULE_FACTORY_REGISTRY[path]();
    }
    return require.cache[path];
}

require.resolve = require.resolve || function(path) {return path;}
require.cache = require.cache || $MODULE_REGISTRY;
if (typeof(console) === 'undefined'){console = { log: (typeof __underscore_SysLog == 'function') ? __underscore_SysLog: function(str) {} };}
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/NGJSEnvironmentSupport.js';

/**

 # NGJSEnvironmentSupport.js
 # webgame
 #
 # Created by Frederic Barthelemy on 10/01/10.
 # Copyright 2010 ngmoco:). All rights reserved.

 */

/**
 * Provides Environmental support for features missing on certain platforms.
 */


/**
 * setTimeout and setInterval implementation for platforms that don't have it.
 *	It fires timers at the beginning of the first frame past the requested millisecond,
 *	before it processes messages for a particular frame.
 *
 * Platform Consumers:
 *	- Android
 *
 * Note:
 *	- Only accurate to within the frame.
 *	- Does behaves like webkit in that it lets clearInterval and clearTimeout
 *		clear timers created by each other's constructor style.
 *
 */
var NGSetTimeoutCustom = false;
var NGSetTimeoutCallbacks = {};
var NGSetTimeoutUIDGenerator = 0;

exports.NGSetTimeoutRunTimers = function() {
	if(NGSetTimeoutCustom) {
		var timersToExecute = [];
		var curTime = new Date().getTime();
		for (var tk in NGSetTimeoutCallbacks) {
			if (NGSetTimeoutCallbacks.hasOwnProperty(tk) && NGSetTimeoutCallbacks[tk].shouldExecute(curTime)) {
				timersToExecute.push(NGSetTimeoutCallbacks[tk]);
			}
		}

		for (var i in timersToExecute) {
			if (timersToExecute.hasOwnProperty(i)) {
				timersToExecute[i].execute();
			}
		}
	}
};

if(typeof(setTimeout) != "function") {
	NGSetTimeoutCustom = true;

	var NGSingleTimeoutInstance = function(fptr, timeMs) {
		this.uid = NGSetTimeoutUIDGenerator++;
		if (NGSetTimeoutUIDGenerator == Infinity)
		{
			NGSetTimeoutUIDGenerator = 0;
		}
		this.fptr = fptr;
		this.interval = timeMs;
		this.requestedTime = new Date().getTime() + timeMs;
	};

	NGSingleTimeoutInstance.prototype.shouldExecute = function(curTime) {
		if(curTime < this.requestedTime) {
			return false;
		}
		return true;
	};

	NGSingleTimeoutInstance.prototype.execute = function() {
		delete NGSetTimeoutCallbacks[this.uid];
		this.fptr();
	};
	/**
	*
	*/
	setTimeout = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	/**
	*
	*/
	clearTimeout = function(uid) {
		if(NGSetTimeoutCallbacks.hasOwnProperty(uid)) {
			delete NGSetTimeoutCallbacks[uid];
		}
	};
	/**
	*
	*/
	setInterval = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		/*Special setIntervalMagic */
		inst.execute = function() {
			this.requestedTime = new Date().getTime() + this.interval;
			this.fptr();
		};
		/*End setIntervalMagic */
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	clearInterval = clearTimeout;
	
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Class'] || {}; $MODULE_REGISTRY['NGCore/Shared/Class'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Class.js';

/**
 * @constructor
 * @class <code>Core.Class</code> provides an object-oriented programming (OOP) framework for ngCore
 * apps.
 * @name Core.Class
 */
var Class = function() {};
exports.Class = Class;

/**
 * Create a new class by extending <code>Core.Class</code> or another existing class.
 * <br /><br />
 * The <code>extensions</code> parameter is an object literal whose properties will be added to the
 * new class. See the <a href="https://developer.mobage.com/en/resources/app_development">App
 * Development</a> documentation on the <a href="https://developer.mobage.com/">Mobage Developer
 * Portal</a> for more information about using the <code>extensions</code> parameter.
 * <br /><br />
 * The <code>conditions</code> parameter, which is optional, allows you to create design-by-contract
 * checks for the class. This parameter was added in ngCore 1.8.
 * <br /><br />
 * <strong>Note</strong>: By default, the development server disables design-by-contract checks. You
 * must enable the checks when you start the development server. See the SDK's
 * <code>README-server</code> file for details.
 * <br /><br />
 * Design-by-contract checks can examine any of the following:
 * <ul>
 * <li><strong>Precondition checks</strong> examine characteristics of the method call, such as the
 * presence and type of arguments. The class calls its precondition checks before it executes the
 * method. The parameters from the method call are passed to the precondition check.</li>
 * <li><strong>Postcondition checks</strong> examine the results of the method call. The class calls
 * its postcondition checks after it completes the method call. The method call's return value,
 * followed by the parameters from the method call, is passed to the postcondition check.</li>
 * <li><strong>Invariant checks</strong> examine characteristics of the class that should never
 * change, such as the type of an object property. The class calls its invariant checks after it
 * completes a method call and evaluates the postcondition checks for the method call.</li>
 * </ul>
 * Design-by-contract checks should return either <code>true</code> if the check was successful or
 * <code>false</code> if the check failed.
 * <br /><br />
 * <strong>Note</strong>: If a design-by-contract check fails, the method will throw an error. You
 * can use <code>try</code> and <code>catch</code> blocks to trap the error and handle it
 * appropriately.
 * @example
 * // Create a new class.
 * var MyClass = Class.subclass({
 *    classname: "MyClass",
 *
 *    initialize: function() {
 *        console.log("constructor");
 *    },
 *
 *    foo: function(v) {
 *        console.log("MyClass.foo('" + v + "')");
 *    }
 * });
 * var instance = new MyClass();  // logs "constructor"
 * instance.foo("param");         // logs "MyClass.foo('param')"
 * @example
 * // Create a new class with design-by-contract checks.
 * var checks = {
 *     "setA.pre": function(a) {
 *         return a > 0;
 *     },
 *     invariant: function() {
 *         // If a is defined, ensure that a is a number.
 *         // The assert() function throws an error if a is not a number.
 *         if(typeof this.a !== "undefined") {
 *             assert(typeof this.a === "number", "this.a is not a number!");
 *         }
 *         // If b is defined, ensure that b is a boolean.
 *         // The assert() function throws an error if b is not a boolean.
 *         if(typeof this.b !== "undefined") {
 *             assert(typeof this.b === "boolean", "this.b is not a boolean!");
 *         }
 *         // We will only get here if both of the checks passed.
 *         return true;
 *     }
 * };
 *
 * var MyClass = Class.subclass({
 *     initialize: function() {
 *         this.a = 23;
 *         this.b = true;
 *     },
 *
 *     setA: function(a) {
 *         this.a = a;
 *     },
 *
 *     setB: function(b) {
 *         this.b = b;
 *     }
 * }, checks);
 *
 * var instance = new MyClass();
 * instance.setA(-1);             // Error! The setA.pre check fails.
 * instance.setB({});             // Error! The invariant check fails.
 * @name Core.Class.subclass
 * @function
 * @static
 * @param {Object} extensions Object literal containing new methods for the class.
 * @param {Object} [conditions] Object literal containing design-by-contract checks. Each check
 *		should return <code>true</code> if the check passes or <code>false</code> if the check
 *		fails. Available since ngCore 1.8.
 * @param {Function} [conditions.invariant] The invariant checks for the class. Called after the
 *		method and its postcondition checks have executed.
 * @param {Function} [conditions.methodName.post] The postcondition checks for the method
 *		<code>methodName</code> (replace <code>methodName</code> with the name of your method).
 *		Called after the method has executed.
 * @param {Function} [conditions.methodName.pre] The precondition checks for the method
 *		<code>methodName</code> (replace <code>methodName</code> with the name of your method).
 *		Called before the method has executed.
 * @returns {Function} A function for instantiating the derived class.
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
	        var names;
		// optimized path for SpiderMonkey
		if (Function.prototype.__arguments) {
			names = body.__arguments();
			if (names) {
			    return names;   
			}
		}
		names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
	    var override;
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments); };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			};
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			};
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf(); };
		override.toString = function() { return overrideBody.toString(); };
		return override;
	}


	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
	        var conditions = arguments[1];
	        var property;


		var classname = properties.classname || "AnonymousClass";
		if (typeof $_ASSIGNENGINEBINDINGS !== "undefined" && typeof properties._classId !== "undefined")
			$_ASSIGNENGINEBINDINGS(properties, properties._classId);
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
	        var value;		
		// Copy properties into NewClass prototype.
		for(property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property);
			var setter = properties.__lookupSetter__(property);

		        if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize;
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy;
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		if (typeof $_REGISTERCLASSTOENGINE !== "undefined" && typeof properties._classId !== "undefined")
			$_REGISTERCLASSTOENGINE(properties, properties._classId);

		return NewClass;
	};
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * <br /><br />
 * The <code>extensions</code> parameter is an object literal whose properties will be added to the
 * new singleton. See the <a href="https://developer.mobage.com/en/resources/app_development">App
 * Development</a> documentation on the <a href="https://developer.mobage.com/">Mobage Developer
 * Portal</a> for more information about using the <code>extensions</code> parameter.
 * <br /><br />
 * The <code>conditions</code> parameter, which is optional, allows you to create design-by-contract
 * checks for the singleton. See the <code>{@link Core.Class.subclass}</code> documentation for
 * details.
 * @example
 * // Create a new singleton.
 * var MySingleton = Class.singleton({
 *    classname: "MySingleton",
 *
 *    initialize: function() {
 *        console.log("constructor");
 *    },
 *
 *    foo: function(v) {
 *        console.log("MySingleton.foo('" + v + "')");
 *    }
 * });
 * MySingleton.foo("param");   // logs "constructor", then "MySingleton.foo('param')"
 * @function
 * @name Core.Class.singleton
 * @static
 * @param {Object} extensions Object literal containing new methods for the class.
 * @param {Object} [conditions] Object literal containing design-by-contract checks. Each check
 *		should return <code>true</code> if the check passes or <code>false</code> if the check
 *		fails. Accepts the same properties as the <code>conditions</code> parameter to
 *		<code>{@link Core.Class.subclass}</code>.
 * @returns {Object} The singleton instance.
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @inner
	 * @status iOS, Android, Flash
	 */
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	};
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
};

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		};
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		};
	}
};

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
};

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Class'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Class.js';

exports.Class = require('NGCore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] = exports; 
var __dirname = 'NGCore/Shared/Lib';
var __filename = 'NGCore/Shared/Lib/base64.js';

/**
 * @class The <code>Core.Base64</code> class provides methods for converting strings and binary data
 * to and from Base64 format.
 * @name Core.Base64
 */

/*
 * $Id: base64.js,v 1.1 2009/03/01 22:38:45 dankogai Exp dankogai $
 *
 * History:
 *   dankogai's original: character-based
 *   drry's fix: split string to array then join
 *   new version: regexp-based
 */

var Base64 = (function() {
/** @lends Core.Base64.prototype */
    var b64chars
        = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    var b64tab = function(bin){
        var t = {};
        for (var i = 0, l = bin.length; i < l; i++) {
            t[bin.charAt(i)] = i;
        }
        return t;
    }(b64chars);

    var fromCharCode = String.fromCharCode;

    var sub_toBase64 = function(m){
        var n = (m.charCodeAt(0) << 16)
              | (m.charCodeAt(1) <<  8)
              | (m.charCodeAt(2)      );
        return b64chars.charAt( n >>> 18)
             + b64chars.charAt((n >>> 12) & 63)
             + b64chars.charAt((n >>>  6) & 63)
             + b64chars.charAt( n         & 63);
    };

    var toBase64 = function(bin){
        if (bin.match(/[^\x00-\xFF]/)) {
            throw 'unsupported character found';
        }
        var padlen = 0;
        while(bin.length % 3) {
            bin += '\x00';
            padlen++;
        }
        var b64 = bin.replace(/[\x00-\xFF]{3}/g, sub_toBase64);
        if (!padlen) return b64;
        b64 = b64.substr(0, b64.length - padlen);
        while(padlen--) b64 += '=';
        return b64;
    };

    // use native btoa() if it exists
    var _btoa = typeof(btoa) !== "undefined" ? btoa : toBase64;

    var sub_fromBase64 = function(m){
            var n = (b64tab[ m.charAt(0) ] << 18)
                |   (b64tab[ m.charAt(1) ] << 12)
                |   (b64tab[ m.charAt(2) ] <<  6)
                |   (b64tab[ m.charAt(3) ]);
        return fromCharCode(  n >> 16 )
            +  fromCharCode( (n >>  8) & 0xff )
            +  fromCharCode(  n        & 0xff );
    };

    var fromBase64 = function(b64){
        b64 = b64.replace(/[^A-Za-z0-9\+\/]/g, '');
        var padlen = b64.length % 4;
        while(b64.length % 4){
            b64 += 'A';
        }
        var bin = b64.replace(/[A-Za-z0-9\+\/]{4}/g, sub_fromBase64);
        if (padlen >= 2)
            bin = bin.substring(0, bin.length - [0,0,2,1][padlen]);
        return bin;
    };

    // use native atob() if it exists
    var _atob = typeof(atob) !== "undefined" ? atob : fromBase64;

    var re_char_nonascii = /[^\x00-\x7F]/g;

    var sub_char_nonascii = function(m){
        var n = m.charCodeAt(0);
        return n < 0x800 ? fromCharCode(0xc0 | (n >>>  6))
                         + fromCharCode(0x80 | (n & 0x3f))
            :              fromCharCode(0xe0 | ((n >>> 12) & 0x0f))
                         + fromCharCode(0x80 | ((n >>>  6) & 0x3f))
                         + fromCharCode(0x80 |  (n         & 0x3f))
            ;
    };

    var utob = function(uni){
        return unescape(encodeURIComponent(uni));
    };

    var re_bytes_nonascii
        = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;

    var sub_bytes_nonascii = function(m){
        var c0 = m.charCodeAt(0);
        var c1 = m.charCodeAt(1);
        if(c0 < 0xe0){
            return fromCharCode(((c0 & 0x1f) << 6) | (c1 & 0x3f));
        }else{
            var c2 = m.charCodeAt(2);
            return fromCharCode(
                ((c0 & 0x0f) << 12) | ((c1 & 0x3f) <<  6) | (c2 & 0x3f)
            );
        }
    };

    var btou = function(bin){
        return decodeURIComponent(escape(bin));
    };
    return {
        fromBase64:fromBase64,
        toBase64:toBase64,
        atob:_atob,
        btoa:_btoa,
        utob:utob,
        btou:btou,
        
		/**
		 * Encode a string in Base64 format.
		 * @name encode
		 * @function
		 * @memberOf Core.Base64
		 * @example
		 * var str = "Test string";
		 * var encoded = Core.Base64.encode(str);  // returns "VGVzdCBzdHJpbmc="
		 * @param {String} u The string to encode.
		 * @returns {String} A Base64-encoded version of the string.
		 * @since 1.3.1b
		 */
        encode:function(u){
            if(!u) {
                return "";
            }
            return _btoa(utob(new String(u)));
        },
	
		/**
		 * Encode binary data in Base64 format.
		 * @name encodeBinary
		 * @function
		 * @memberOf Core.Base64
		 * @example
		 * var fileSys = Storage.FileSystem;
		 * fileSys.readFileIn(Storage.FileSystem.Store.Local, "file.bin", { },
		 *   function(err, data) {
		 *     if (err) {
		 *         console.log("An error occurred while reading " + fileName + ": " + err);
		 *     } else {
		 *         var encoded = Core.Base64.encodeBinary(data);
		 *     }
		 * });
		 * @param {String} u The binary data to encode.
		 * @returns {String} A Base64-encoded version of the data.
		 */
		// do not process unicode coversion for binary data.
		encodeBinary: function(u) {
            if(!u) {
                return "";
            }
	    	return _btoa(new String(u));
		},
	
		/**
		 * Decode a Base64-encoded string.
		 * @name decode
		 * @function
		 * @example
		 * var encoded = "VGVzdCBzdHJpbmc=";
		 * var str = Core.Base64.decode(encoded);  // returns "Test string"
		 * @memberOf Core.Base64
		 * @param {String} a A Base64-encoded string.
		 * @returns {String} The decoded string.
		 * @since 1.4.1
		 */
        decode:function(a){
            if(!a) {
                return "";
            }

        	if(a.length % 4 == 1)
			{
				throw new Error("Invalid Base64 string: " + a);
			}

            return btou(_atob(a.replace(/[\-_]/g, function(m0){
                return m0 == '-' ? '+' : '/';
            })));
		},
       
		/**
		 * Decode Base64-encoded binary data.
		 * @name decodeBinary
		 * @function
		 * @example
		 * var fileSys = Storage.FileSystem;
		 * fileSys.readFileIn(Storage.FileSystem.Store.Local, "file.bin.b64", { },
		 *   function(err, data) {
		 *     if (err) {
		 *         console.log("An error occurred while reading " + fileName + ": " + err);
		 *     } else {
		 *         var decoded = Core.Base64.decodeBinary(data);
		 *     }
		 * });
		 * @memberOf Core.Base64
		 * @param {String} a Base64-encoded binary data.
		 * @returns {String} The decoded data.
		 */
		// do not process unicode conversion for binary data.
		decodeBinary: function(a) {
            if(!a) {
                return "";
            }
            return _atob(a.replace(/[\-_]/g, function(m0){
                return m0 == '-' ? '+' : '/';
            }));
       }
    };
})();

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Base64'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Base64'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Base64.js';

exports.Base64 = require('NGCore/Shared/Lib/base64').Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/ResultSet'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] = exports; 
var __dirname = 'NGCore/Client/Plus';
var __filename = 'NGCore/Client/Plus/ResultSet.js';

var ClassReq = require("NGCore/Client/Core/Class");
var SystemBindingReq = require('NGCore/Client/UI/SystemBinding');

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBindingReq.SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBindingReq.SystemBinding._closeContactsResultSet(this);
    }
});

exports.ResultSet = ResultSet;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/SystemBinding'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/SystemBinding.js';

var ClassReq = require("NGCore/Client/Core/Class");
var Base64 = require("NGCore/Client/Core/Base64").Base64;
var ResultSetReq = require("NGCore/Client/Plus/ResultSet");

var NGSystemBindingCommands = {
    HandleAction: 0
};

var SystemBinding = ClassReq.Class.subclass({
    classname: "SystemBinding",
    callbacks: {},
    callbacksUidGenerator: 0,
    _contResultSets: {},
    _contResultSetIdxs: {}
});

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBinding._closeContactsResultSet(this);
    }
});

SystemBinding._pushContactsCmd = function(cmdname, callbackFunc, continueId) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: cmdname,
        callbackId: callbackId
    };
    if (typeof continueId != 'undefined') {
        message.continueId = continueId;
    }
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding._closeContactsResultSetfunction = function(rSet) {
    // Passing empty callback as caller does not need to know when the close
    // is complete
    var cb = function() {};
    SystemBinding._pushContactsCmd('closecontacts', cb, rSet._continueId);
};

SystemBinding._getMoreContacts = function(rSet, callbackFunc) {
    if ((typeof rSet._continueId != 'undefined') &&
    (rSet.items.length < rSet.totalLength)) {
        SystemBinding._pushContactsCmd('morecontacts', callbackFunc, rSet._continueId);
        return true;
    }
    return false;
};

SystemBinding.getContacts = function(callbackFunc) {
    SystemBinding._pushContactsCmd('contacts', callbackFunc, undefined);
};

SystemBinding.getDeviceToken = function(callbackFunc) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: 'devicetoken',
        callbackId: callbackId
    };
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding.handleCommand = function(command) {
    var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
    var cmd = JSON.parse(fields[1]);
    if (cmd.name == 'callback') {
    	var cb = SystemBinding.callbacks[cmd.callbackId];
		if (typeof cb == "function") {
            if (cmd.callbackname == 'contacts') {
                var obj = SystemBinding._contResultSets[cmd.continueId];
                if (typeof obj == 'undefined') {
                    // First time for this callback
                    obj = new ResultSetReq.ResultSet(cmd.continueId);
                    SystemBinding._contResultSets[cmd.continueId] = obj;
                    SystemBinding._contResultSetIdxs[cmd.continueId] = 0;
                }

                var addedCount = cmd.list.length;
                while (cmd.list.length > 0) {
                    var item = cmd.list.shift();
                    obj.items.push(item);
                }

                var newIdx = SystemBinding._contResultSetIdxs[cmd.continueId];
				if ((typeof newIdx) != 'undefined') {
                	SystemBinding._contResultSetIdxs[cmd.continueId] = newIdx + addedCount;
				}

                // Invalidate the continueId if done - when total is return (no
                // more result) or when result set is explicitly closed (cmd.closed)
                if ((typeof cmd.total != 'undefined') ||
                (typeof cmd.rsclosed != 'undefined')) {
                    if (typeof cmd.total != 'undefined') {
                        obj.totalLength = cmd.total;
                    }
                    delete obj._continueId;
                    delete SystemBinding._contResultSets[cmd.continueId];
                    delete SystemBinding._contResultSetIdxs[cmd.continueId];
                }

                delete SystemBinding.callbacks[cmd.callbackId];
				if (cmd.success) {
                	cb(undefined, obj, newIdx, addedCount);
				} else {
                	cb(cmd.error, obj, newIdx, addedCount);
				}
            } else {
                // other callbacks
                delete SystemBinding.callbacks[cmd.callbackId];
                cb(cmd);
            }
        }
    }
};

exports.SystemBinding = SystemBinding;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageListener'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/MessageListener.js';

var Class = require('NGCore/Shared/Class').Class;

exports.MessageListener = Class.subclass(
/** @lends Core.MessageListener.prototype */
{
	classname: 'MessageListener',
	
	/**
	 * @class The <code>MessageListener</code> class is a base class for constructing objects that listen for notifications from emitters 
	 * (see <code>{@link Core.MessageEmitter}</code>). Objects of this type are registered with emitters.
	 * When <code>{@link Core.MessageEmitter#emit}</code> or <code>{@link Core.MessageEmitter#chain}</code> is called on an emitter
	 * all registered listeners will generate a callback function.
	 * <br /><br />
	 * Applications must unregister listener objects when they are no longer required in one of three ways: 
	 * <ul>
	 * <li>Calling <code>{@link Core.MessageEmitter#removeListener}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageEmitter#destroy}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageListener#destroy}</code> on the <code>MessageListener</code></li>
	 * </ul><br />
	 * <p><b>Note:</b> Applications should not attempt to register a listener with an emitter more than once. Registering a listener with an emitter
	 * multiple times results in exceptions.</p>
	 * @example
	 * var MyListener = Core.MessageListener.subclass({
	 *     myCallback: function(verb, value) {
	 *         console.log('MyListener.myCallback(' + verb + ', ' + value + ')');
	 *     }
	 * });
	 * var listener = new MyListener();
	 * emitter.addListener(listener, listener.myCallback);
	 * emitter.emit('fun', 5);
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	initialize: function()
	{
		this._messageEmitters = [];
	},
	
	/**
	 * Unregister this <code>MessageListener</code> from all emitters.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		// Unregister from all emitters.
		var emitters = this._messageEmitters;
		while(emitters.length)
			emitters[0].removeListener(this);
	},
	
	// Called by MessageEmitter when this receiver starts listening.
	_startListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index !== -1)
			return false;
		
		emitters.push(emitter);
		return true;
	},
	
	// Called by MessageEmitter when this receiver stops listening.
	_stopListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index === -1)
			return false;
		
		emitters.splice(index, 1);
		return true;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/MessageListener.js';

exports.MessageListener = require('NGCore/Shared/MessageListener').MessageListener;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/ObjectRegistry.js';

var Class = require('NGCore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** 
	  * @private 
	  * @class 
	  * @status 
	  */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** 
	  * @status
	  * @since 1.0
	  */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');

		var id = ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** 
	  * @status
	  * @since 1.0
	  */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** 
	  * @status
	  * @since 1.0
	  */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** 
	  * @status
	  * @since 1.0
	  */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** 
	  * @status
	  * @since 1.0
	  */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** 
	  * @status
	  * @since 1.0
	  */
	idToObject: function(id)
	{
		return this._objects[id];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Proc'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Proc'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Proc'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Proc.js';

////////////////////////////////////////////////////////////////////////////////
// Class Proc
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

// Command stream.
var $ = "";

var CSAppendMethods = {
	strPreCat: function(mid, obj, args) {
		var objId;
		if (mid << 16 < 0) {
			objId = '';
			// the "obj" arg will be missing here
			args = obj;
		} else {
			objId = ','+obj.__objectRegistryId;
		}
		mid = ":" + (mid >> 16) + "," + (mid << 16 >> 16);
		
		switch (args ? args.length : 0) {
			case  0: $+=mid+objId+',';break;
			case  1: $+=mid+objId+','+args[0];break;
			case  2: $+=mid+objId+','+args[0]+','+args[1];break;
			case  3: $+=mid+objId+','+args[0]+','+args[1]+','+args[2];break;
			case  4: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3];break;
			case  5: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4];break;
			case  6: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5];break;
			case  7: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6];break;
			case  8: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7];break;
			case  9: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7]+','+args[8];break;
			case 10: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7]+','+args[8]+','+args[9];break;
			case 11: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7]+','+args[8]+','+args[9]+','+args[10];break;
			case 12: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7]+','+args[8]+','+args[9]+','+args[10]+','+args[11];break;
			case 13: $+=mid+objId+','+args[0]+','+args[1]+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7]+','+args[8]+','+args[9]+','+args[10]+','+args[11]+','+args[12];break;
			default:
				$+=mid+objId+','+args[2]+','+args[3]+','+args[4]+','+args[5]+','+args[6]+','+args[7]+','+args[8]+','+args[9]+','+args[10]+','+args[11]+','+args[12];
				for (var x = 13; x < args.length; x++) {
					$+= ','+args[x];
				}
		}
	},
	strMulCat: function(mid, obj, args) {
		var objId;
		if (mid << 16 < 0) {
			objId = '';
			// the "obj" arg will be missing here
			args = obj;
		} else {
			objId = ','+obj.__objectRegistryId;
		}
		mid = ":" + (mid >> 16) + "," + (mid << 16 >> 16);
		
		switch (args ? args.length : 0) {
			case  0: $+=mid;$+=objId;break;
			case  1: $+=mid;$+=objId;$+=args[0];break;
			case  2: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];break;
			case  3: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];break;
			case  4: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];break;
			case  5: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];break;
			case  6: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];break;
			case  7: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];break;
			case  8: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];break;
			case  9: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];$+=',';$+=args[8];break;
			case 10: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];$+=',';$+=args[8];$+=',';$+=args[9];break;
			case 11: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];$+=',';$+=args[8];$+=',';$+=args[9];$+=',';$+=args[10];break;
			case 12: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];$+=',';$+=args[8];$+=',';$+=args[9];$+=',';$+=args[10];$+=',';$+=args[11];break;
			case 13: $+=mid;$+=objId;$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];$+=',';$+=args[8];$+=',';$+=args[9];$+=',';$+=args[10];$+=',';$+=args[11];$+=',';$+=args[12];break;
			default:
				$+=mid;$+=objId;$+=',';$+=args[0];$+=',';$+=args[1];$+=',';$+=args[2];$+=',';$+=args[3];$+=',';$+=args[4];$+=',';$+=args[5];$+=',';$+=args[6];$+=',';$+=args[7];$+=',';$+=args[8];$+=',';$+=args[9];$+=',';$+=args[10];$+=',';$+=args[11];$+=',';$+=args[12];
				for (var x = 13; x < args.length; x++) {
					$+= ','; $+= args[x];
				}
		}
	},
	strLoop: function(mid, obj, args) {
		var objId;
		if (mid << 16 < 0) {
			objId = '';
			// the "obj" arg will be missing here
			args = obj;
		} else {
			objId = ','+obj.__objectRegistryId;
		}
		mid = ":" + (mid >> 16) + "," + (mid << 16 >> 16);
		
		var _ = mid + objId;
		if (args) for (var i = 0, l = args.length; i < l; i++) {
			_ += ',' + args[i];
		}
		$+=_;
	}
};

var Proc = exports.Proc = Class.singleton(
{
	classname: 'Proc',
	
	initialize: function()
	{
		// $_GETENGINEENV is optional and should be added to the global scope before ngCore loads.
		/* $_GETENGINEENV() returns {
			'engine': "JSEngineType",	// eg, "v8", "SpiderMonkey", "JavaScriptCore", etc.
			'boundFunctions': {
				queueCommand: <native function>,
				queueSubcommand: <native function>,
				getCommand: <native function>,
				clearCommand: <native function>,
				
				parseInt: function,
				parseFloat: function,
				parseString: function,
				parseBinary: function,
				parseObject: function,
				
				encodeString: function,
				encodeBinary: function,
				encodeObject: function,
			}
		} */
		var env = typeof $_GETENGINEENV !== "undefined" ? $_GETENGINEENV() : undefined;
		var engine = typeof env == 'object' ? env['engine'] : undefined;
		if ( typeof env == 'object'
				&& typeof env.boundFunctions == 'object')
		{
			var bF = env.boundFunctions;
			if (bF.queueCommand) 
				this.appendToCommandString = bF.queueCommand;
			if (bF.queueSubcommand)
				this.appendSubcommandToCommandString = bF.queueSubcommand;
			if (bF.getCommand)
				this.getCommandString = bF.getCommand;
			if (bF.clearCommand)
				this.clearCommandString = bF.clearCommand;
			
			if (bF.parseInt)
				this.parseInt = bF.parseInt;
			if (bF.parseFloat)
				this.parseFloat = bF.parseFloat;
			if (bF.parseString)
				this.parseString = bF.parseString;
			if (bF.parseObject)
				this.parseObject = bF.parseObject;
			if (bF.parseBinary)
				this.parseBinary = bF.parseBinary;
			
			if (bF.encodeString)
				this.encodeString = bF.encodeString;
			if (bF.encodeObject)
				this.encodeObject = bF.encodeObject;
			if (bF.encodeBinary)
				this.encodeBinary = bF.encodeBinary;
		} else {
			// String.
			switch (engine) {
				case 'v8':
				case 'spiderMonkey':
					this.appendToCommandString = CSAppendMethods.strLoop;
					break;
				case 'webCore':
					this.appendToCommandString = CSAppendMethods.strPreCat;
					break;
				default:
				// Todo: Switch on Core.Capabilities.getPlatformOS(); Not sure it's safe to require_ here
					this.appendToCommandString = CSAppendMethods.strLoop;
			}
			this.appendSubcommandToCommandString = function(args) { $+= ','+args.join() };
		}
		this.clearCommandString();
	},
	
	appendToCommandString: function( str )
	{
		// Let this function initialize the singleton, but ensure pass through to real implementation.
		this.appendToCommandString.apply(this, arguments);
	},
	
	getCommandString: function()
	{
		return $;
	},
	
	clearCommandString: function ()
	{
		$ = "";
	},
	
	encodeString: Base64.encode,
	encodeBinary: Base64.encodeBinary,
	encodeObject: function(v) {
		return this.encodeString( JSON.stringify(v) );
	},
	
	parseBool: function( v )
	{
		return v == 1 ? true : false;
	},

	parseInt: function( v )
	{
		return parseInt( v, 10 );
	},
	
	parseFloat: parseFloat,
	parseString: Base64.decode,
	parseBinary: Base64.decodeBinary,
	parseObject: function( v )
	{
		return JSON.parse( this.parseString( v ) );
	},

	setPrivileged: function()
	{
		this._privileged = true;
	},

	isPrivileged: function()
	{
		return this._privileged ? true : false;
	},

// {{?Wg Generated Code}}
	///////
	// Class constants (for internal use only):
	_classId: 355,
	// Method setCoreJSVersion = -1
	// Method _loadScripts = -2
	// Method _loadScripts_push = -3
	// Method _loadScriptsComplete = -4
	
	_classRecvGen: function( cmd )
	{
		var classId = parseInt( cmd.shift(), 10 );
		
		var handler = PROC_DISPATCH_TABLE[classId];
		if(handler)
		{
			try
			{
				handler(cmd);
			}
			catch (ex)
			{
				NgHandleException(ex);
			}
		}
		else
		{
			NgLogE( "Unknown class id " + classId + " in _classRecvGen" );
		}
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 355
	// Method setCoreJSVersion = -1
	// Method _loadScripts = -2
	// Method _loadScripts_push = -3
	// Method _loadScriptsComplete = -4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Proc._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -4:
					Proc.__loadScriptsCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Proc._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[355] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$__loadScriptsCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Proc._loadScriptsComplete from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in Proc._loadScriptsComplete from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in Proc._loadScriptsComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_setCoreJSVersionSendGen: function( packedVersion )
	{
		this.appendToCommandString( 0x163ffff, [ +packedVersion ] );
	},
	
	/** @private */
	$__loadScriptsSendGen: function( callbackId, numFiles )
	{
		this.appendToCommandString( 0x163fffe, [ Proc.encodeString( callbackId ), +numFiles ] );
	},
	
	/** @private */
	$__loadScripts_pushSendGen: function( executableFilePath )
	{
		this.appendSubcommandToCommandString( [ Proc.encodeString( executableFilePath ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $setCoreJSVersion: function( packedVersion ) {}
	
	// $_loadScripts: function( callbackId, numFiles ) {}
	
	// $_loadScripts_push: function( executableFilePath ) {}
	
	// $__loadScriptsCompleteRecv: function( cmd ) {}
	
// {{/Wg Generated Code}}

	/** @private */
	$_loadScripts: function(files, callback ) {
        if(!this._codeAddingCallbacks){
            this._codeAddingCallbacks = {uidGenerator:1};
        }
        this._codeAddingCallbacks[++this._codeAddingCallbacks.uidGenerator] = callback;
        this.__loadScriptsSendGen(this._codeAddingCallbacks.uidGenerator,files.length);
        for(var i = 0; i < files.length; i++ ){
            this.__loadScripts_pushSendGen(files[i]);
        }
    },
    
    /** @private */
	// $_loadScripts_push: function( executableFilePath ) {} -- not needed
	
	/** @private */
	$__loadScriptsCompleteRecv: function( cmd ) {
        var obj = {};
        this.__loadScriptsCompleteRecvGen(cmd,obj);

        if(this._codeAddingCallbacks.hasOwnProperty(obj.callbackId)){
            this._codeAddingCallbacks[obj.callbackId](obj.error);
            delete this._codeAddingCallbacks[obj.callbackId];
        }
    },
    /** @private */
	$load: function(file, callback) {
		if ($ng__COMBINED === true) {
		//	console.log("COMBINE MODE LAZY REQUIRE: " + file);
			setTimeout( callback.bind(null, require(file)), 1 );
			return;
		}
		
		if(this._pendingLoadCalls && arguments.length == 2){
			NgLogD("Proc.load: call already pending. Saving "+file+" for later.");
			if (typeof exception_demangle_require != "undefined") {
				NgLogD(exception_demangle_require(file));
			}
			this._pendingLoadCalls.push(function(){
				NgLogD("Proc.load: resuming saved load call for "+file);
				if (typeof exception_demangle_require != "undefined") {
					NgLogD(exception_demangle_require(file));
				}
				Proc.load(file,callback,true);
});
			return;
		} else if(!this._pendingLoadCalls){
			this._pendingLoadCalls = [];
		}
		
		var file_noext = file.replace(/\.js/,'');
		
//		var entryPointIndex = $APP_VALIDENTRYPOINTS.indexOf(file);
//		if (entryPointIndex == -1){
//			NgLogD("Proc.load: illegal program entry point! Entry must match manifest.loadable! '"+file+"'");
//		}
		
		//Convert Human readable to name-mangled if necessary.
		if(typeof $APP_REQUIREPATHMAP != "undefined" && file in $APP_REQUIREPATHMAP){
			file = $APP_REQUIREPATHMAP[file];
		}
		
		var postLoad = function(){
			NgLogD("Proc.load (postLoad) "+file);
			
			if(this._pendingLoadCalls.length){
				var next = this._pendingLoadCalls.shift();
				next();
			} else {
				this._pendingLoadCalls = null;
			}
			
			// Finally we call the 'previous' Proc.load's callback.
			callback(require(file));
		}.bind(this);
		
		//if (Core.Capabilities.getRequireIsSynchronous()) {
		//	postLoad();
		//} else {
			var array = [];
			// Scan the $APP_REQUIREPATHS array for the requested file.
			// This will be our only linear scan, because dependencies are tracked by ID.
		if (typeof $APP_REQUIREPATHS != "undefined") { //check for reference error
			var rPathIndex = $APP_REQUIREPATHS.indexOf(file);
			if (rPathIndex >= 0) {
				// All this means is that the file has not been included from anywhere else yet.
				delete $APP_REQUIREPATHS[rPathIndex];
				addDependencies(array, rPathIndex);
				/*jsl:ignore*/
				if(!$MODULE_FACTORY_REGISTRY[file]){
				/*jsl:end*/
					array.push(file + ".js");
				}
				
				// Call the system call to actually load the file.
				if(array.length){
					NgLogD("Proc.load: Loading '" + file + "'!");
					NgLogD(JSON.stringify(array));
					Proc._loadScripts(array,postLoad);
				} else {
					NgLogD("Proc.load: no files to load "+file);
					setTimeout(postLoad,1);
				}
			} else {
				NgLogD("Proc.load: Skipping '" + file + "' because it was already included.");
				setTimeout(postLoad,1);
			}
	 	}
	}
});


// Destructive Pre-order traversal of flattened n-ary tree 
var addDependencies = function(array, rPathIndex) {
	if (!$APP_DEPENDENCYTABLE || !$APP_REQUIREPATHS){return;}
	var dependencies = $APP_DEPENDENCYTABLE[rPathIndex];
	if (!(dependencies instanceof Array)) return;
	var depRPIndex;
	while (depRPIndex = dependencies.shift()) {
		// Read the file's name from the $APP_REQUIREPATHS array, if it exists.
		var depRPath = $APP_REQUIREPATHS[depRPIndex];
		// This is our condition to prevent cycles, since we delete it when processing.
		if (depRPath) {
			// Delete this entry from the array before traversing into it.
			delete $APP_REQUIREPATHS[depRPIndex];
			// If there are dependencies for this file, process them first.
			addDependencies(array, depRPIndex);
			// Add the file itself right after the dependencies.
			/*jsl:ignore*/
			if(!$MODULE_FACTORY_REGISTRY[depRPath]){ // Only if it hasn't already been loaded.
			/*jsl:end*/
				array.push(depRPath + ".js");
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Capabilities'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Capabilities.js';

	////////////////////////////////////////////////////////////////////////////////
// Class Capabilities
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;


////////////////////////////////////////////////////////////////////////////////

function packVersion(arg1, arg2, arg3, arg4, arg5) {
	if (arg1 instanceof Array) return packVersion.apply(null, arg1);
	return arg1 << 24 | arg2 << 18 | arg3 << 12 | arg4 << 6 | arg5;
}

function unpackVersion(pVers) {
	return [
		pVers >> 24 & 0x03F,
		pVers >> 18 & 0x03F,
		pVers >> 12 & 0x03F,
		pVers >> 6 & 0x03F,
		pVers & 0x03F
	];
}

function packStringVersion(str) {
	return packVersion.apply(null,str.split(/\D/));
}

function stringForVersion(a) {
	if (typeof a == "number") a = unpackVersion(a);
	// Drop trailing zeroes
	while (a.length && (0 | a[a.length - 1]) === 0) {
		a.pop();
	}
	return a.length ? a.join('.') : "Invalid Version";
}

////////////////////////////////////////////////////////////////////////////////

exports.Capabilities = Class.singleton(
/** @lends Core.Capabilities.prototype */
{
	classname: 'Capabilities',
	_configFile: 'configuration.json',
	// The packed integer for the binary version string
	_binaryVersion: 0,
	// The lower of the JS and Binary versions.
	_effectiveVersion: 0,

	/**
	 * @class The <code>Capabilities</code> class provides information about the capabilities of the
	 * device that is running the app. The class also provides details about the app's
	 * configuration and the ngCore binary that is running the app. The information that is provided
	 * by the <code>Capabilities</code> class remains the same throughout the lifetime of the app.
	 * @singleton
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

        // Please keep this on one line, sed won't update otherwise
		this._fields = {version: '1.8.0.3', buildDate: '20120702', buildHash: 'g7da6adf'};
	},

	_getConfigFile:			function() {return this._configFile;},
	_getAccts:				function() {return this._fields._accts;},

	/**
	 * Compare an ngCore version number to the ngCore binary version that is currently running. The
	 * return value indicates whether the current ngCore binary is older than, identical to, or
	 * newer than the specified version.
	 * @example
	 * // Check whether the current ngCore binary version is later than 1.3.2.
	 * var compare = Core.Capabilities.compareBinaryVersion("1.3.2");
	 * if (compare > 0) {
	 *     console.log("The current binary version is more recent than 1.3.2.");
	 * }
	 * @param {String} v The ngCore version number to compare against the current binary.
	 * @returns {Number} A negative number if the specified version is older than the current
	 *		binary; a positive number if the specified version is newer than the current binary;
	 *		or <code>0</code> if the two versions are equal.
	 * @since 1.8
	 */
	compareBinaryVersion: function(v) {
		var version = (arguments.length == 1 && typeof v == "string")
			? packStringVersion(v)
			: packVersion.apply(null, arguments);
		// Compare to version. Will be positive if binary version is newer, zero if equal, negative if binary is older
		return this._binaryVersion - version;
	},

	/**
	 * Check whether the current ngCore binary meets a minimum version number.
	 * @example
	 * // Check whether the current ngCore binary version is 1.8 or greater.
	 * if (Core.Capabilities.meetsBinaryVersion("1.8")) {
	 *     console.log("The current binary version is 1.8 or greater.");
	 * }
	 * @param {String} v The ngCore version number to compare against the current binary.
	 * @returns {Boolean} Set to <code>true</code> if the specified version is equal to or
	 *		greater than the version of the current ngCore binary.
	 * @since 1.8
	 */
	meetsBinaryVersion: function(v)
	{
		return this.compareBinaryVersion(v) >= 0;
	},
	
	/**
	 * Return the object stored in configuration.json for your game.
	 * @returns {Object} The JSON.parsed object represented in your configuration.json file.
	 * @status
	 * @since 1.0
	 */
	getConfigs:			function() {return this._configuration;},

	/**
	 * Return the SDK version number from the <code>Capabilities</code> of this device.
	 * @returns {String} The version of the SDK on the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getSDKVersion:           function() { return this._fields.version; },

	/**
	 * Return the build date for the currently installed SDK. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the SDK on the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getSDKBuildDate:           function() { return this._fields.buildDate; },
	
	/**
	 * Return the build hash of the currently installed SDK.
	 * @returns {String} The build hash for the SDK on the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getSDKBuildHash:           function() { return this._fields.buildHash; },

	/**
	 * Return the version of ngCore that is currently running.
	 * @returns {String} The version of ngCore that is running.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.1.5
	 */
	getBinaryVersion:           function() { return this._fields.binaryVersion; },
	
	/**
	 * Return the version of ngCore's host application.
	 * @returns {String} The version of the host application.
	 * @status Android
	 * @since 1.7
	 */
	getApplicationVersion:           function() { return this._fields.applicationVersion; },

	/**
	 * Return the version code of ngCore's host application.
	 * @returns {String} The version code of the host application.
	 * @type String
	 * @status Android
	 * @since 1.8
	 */
	getApplicationVersionCode:       function() { return this._fields.applicationVersionCode; },

	/**
	 * Return the build date for the currently running ngCore binary. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the ngCore binary.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.1.5
	 */
	getBinaryBuildDate:           function() { return this._fields.binaryBuildDate; },

	/**
	 * Return the build hash of the currently running ngCore binary.
	 * @returns {String} The build hash for the ngCore binary.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.1.5
	 */
	getBinaryBuildHash:           function() { return this._fields.binaryBuildHash; },
	
	/**
	 * Return the device ID. 
	 * @returns {String} The device ID for the device running the application.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getUniqueId:           function() { return this._fields.uniqueId; },

	/**
	 * Return the lifetime constant value of the device.<br /><br />
	 * <b>Note:</b> Currently only available on Android.
	 * @returns {String} <code>Settings.Secure.ANDROID_ID</code>: A 64-bit number as a hex string randomly generated on first boot of the device if platform is Android. Mac address if platform is iOS.
	 * <b>Note:</b> This value only changes when the device is reset.
	 * @status iOS, Android
	 * @since 1.0
	 */
	getLifetimeName: function() { return this._fields.lifetimeName; },
	
	/**
	 * Return the device name.
	 * @returns {String} The device name for the device running the application.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getDeviceName:         function() { return this._fields.deviceName; },
	
	/**
	 * Return the operating system.
	 * @returns {String} The operating system of the device running the application.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getPlatformOS:         function() { return this._fields.platformOs; },
	
	/**
	 * Return the operating system version number.
	 * @returns {String} The version number of the operating system running on the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getPlatformOSVersion:  function() { return this._fields.platformOsVersion; },
	
	/**
	 * Return the device hardware type.
	 * @returns {String} The type of device hardware running the application.
	 * @status iOS, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getPlatformHW:         function() { return this._fields.platformHw; },
	
	/**
	 * Return the total amount of installed memory.
	 * @returns {Number} The amount of installed memory on the device running the application.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getPhysicalMem:        function() { return this._fields.physicalMemory; },
	
	/**
	 * Return the total number of installed CPUs.
	 * @returns {Number} The number of CPUs installed on the device running the application.
	 * @status iOS, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getPhysicalCpus:       function() { return this._fields.physicalCpus; },
	
	/**
	 * Return the number of active CPUs.
	 * @returns {Number} The number of active CPUs on the device running the application.
	 * @status iOS, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getActiveCpus:         function() { return this._fields.activeCpus; },
	
	/**
	 * Return the installed user language. 
	 * @returns {String} The installed user language on the device running the application.
	 * Expressed as a canonicalized IETF BCP 47 language identifier.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getLanguage:         function() { return this._fields.language; },

	_getBoot: function() { return this._fields.boot; },
	_getBootServer: function() { return this._fields.bootServer; },

	getBootDir: function () { return this._fields.bootDir; },
	getGameDir: function () { return this._fields.gameDir; },
	getProductName: function () { return this._fields.prodName; },
	_getReferrer: function() { return this._fields.referrer; },

	/**
	 * Return the URL for the content of this application.
	 * @returns {String} The URL to content for this application.
	 * @status Flash
	 * @since 1.0
	 */
	getContentUrl:			function() {return this._fields.contentUrl;},

	/**
	 * Return the name of the root application. Root application refers to the application that launches when the user taps the application icon.
	 * @returns {String} The directory name for the root application.
	 * @status Flash
	 * @since 1.0
	 */
	getBootGame:         function() { return this._fields.bootgame; },

	/**
	 * Return the starting server for an application.
	 * @returns {String} The start server.
	 * @status
	 * @since 1.0
	 */
	getStartingServer:         function() { return this._fields.startingServer; },

	/**
	 * Return the name of the application bundled with the binary of this build.
	 * @returns {String} The name of the bundled game.
	 * @status
	 * @since 1.0
	 */
	getBundleGame:         function() { return this._fields.bundleGame; },

	/**
	 * Return the server bundled with the binary of this build.
	 * @returns {String} The bundle server.
	 * @status
	 * @since 1.0
	 */
	getBundleServer:         function() { return this._fields.bundleServer; },

	/**
	 * Return the bundle identifier for the binary of this build.
	 * @returns {String} The bundle identifier.
	 * @status
	 * @since 1.0
	 */
	getBundleIdentifier:         function() { return this._fields.bundleIdentifier; },
	
	/**
	 * Return the directory name of the currently running application.
	 * @returns {String} The current folder name for the application.
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	getGame:         function() { return this._fields.game; },

	/**
	 * Return the server from which an application was downloaded.
	 * @returns {String} The download server.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getServer:         function() { return this._fields.server; },

	/**
	 * Return the full URL for the current application.
	 * @returns {String} The URL from which a application is downloaded.
	 * @status Flash
	 * @since 1.0
	 */
	getUrl:         function() { return this._fields.url; },

	/**
	 * Return the logical screen width for this device.
	 * @returns {Number} The current screen width of the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getScreenWidth:        function() { return this._fields.screenWidth; },
	
	/**
	 * Return the logical screen height for this device.
	 * @returns {Number} The current screen height of the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getScreenHeight:       function() { return this._fields.screenHeight; },
	
	/**
	 * Return a reasonable factor for scaling logical coordinates to the current display.
	 * @returns {Number} Logically scaled screen units for the device.
	 * @status
	 * @since 1.0
	 */
	getScreenUnits:        function() { return this._fields.screenUnits; },
	
	/**
	 * Return the number of physical pixels associated with one unit of logical space.
	 * @returns {Number} The total number of pixels that equal one screen unit.
	 * @status
	 * @since 1.0
	 */
	getScreenPixelUnits:       function() { return this._fields.screenPixelUnits; },
	
	/**
	 * Return the maximum number of supported textures.
	 * @returns {Number} The maximum number of supported textures per coordinate (<i>x</i>,<i>y</i>).
	 * @status Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getMaxTextureSize:     function() { return this._fields.maxTextureSize; },
	
	/**
	 * Return the maximum number of supported texture units.
	 * @returns {Number} The maximum number of supported texture units per coordinate (<i>x</i>,<i>y</i>).
	 * @status Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getMaxTextureUnits:    function() { return this._fields.maxTextureUnits; },
	
	/**
	 * Deprecated method for retrieving information about OpenGL extensions.
	 * @deprecated Replaced by {@link UI.GLView#getGLExtensions}.
	 * @returns {String[]} A list of supported extensions.
	 * @since 1.0
	 */
	getOglExtensions:      function()
	{
		if (this._fields.oglExtensions)
			return this._fields.oglExtensions;

		// This table should stay in sync with:
		// https://spreadsheets.google.com/a/ngmoco.com/spreadsheet/ccc?key=0AinqDSqLOjJtdDMwNGk0eDgtRFdvQ2N0eWRUcGlsc0E&hl=en_US&authkey=CMWLyoAC
		switch (this._fields.deviceName)
		{
			case "Droid":                // Motorola Droid
			case "DROID2":               // Motorola Droid 2
			case "DROIDX":               // Motorola Droid X
			case "SGH-T959":             // Samsung Galaxy S 19000 8GB
			case "SGH-T959V":            // Samsung Galaxy S 4G
			case "SAMSUNG-SGH-I997":     // Samsung Galaxy S2
			case "SAMSUNG-SGH-I897":     // Samsung Captivate
			case "Nexus S":              // Google Nexus S
				return ["GL_IMG_texture_compression_pvrtc"];
			case "HTC Desire":           // HTC Desire GSM
			case "PC36100":              // HTC Evo 4G
			case "ADR6300":              // HTC Droid Incredible
			case "001HT":                // HTC Desire HD
			case "Nexus One":            // Google Nexus One
			case "HTC Glacier":          // HTC myTouch 4G
				return ["GL_AMD_compressed_ATC_texture"];
			default:
				return [];
		}
	},

	/**
	 * Return the directory path to the temp directory for this device.
	 * @returns {String} The directory path to the temp directory on the device.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getTmpDir:           function() { return this._fields.tmpDir; },

	/**
	 * Check the <code>Capabilities</code> of this device for an accelerometer.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an accelerometer.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasAccel:           function() { return this._fields.hasAccel; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a gyroscope.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an gyroscope.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasGyro:            function() { return this._fields.hasGyro; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for touchscreen input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports touchscreen input.
	 * @status iOS, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasTouch:           function() { return this._fields.hasTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for multi-touch input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports multi-touch input.
	 * @status iOS, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasMultiTouch:      function() { return this._fields.hasMultiTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a GPS unit.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a GPS unit.
	 * @status Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasGps:             function() { return this._fields.hasGps; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a magnetic compass.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a magnetic compass.
	 * @status Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasCompass:         function() { return this._fields.hasCompass; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a hardware keyboard.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a hardware keyboard.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasHwKeyboard:      function() { return this._fields.hasHwKeyboard; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a <b>Back</b> button.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a <b>Back</b> button.
	 * @status Flash, Test, FlashTested
	 * @since 1.0
	 */
	getHasBackButton:      function() { return this._fields.hasBackButton; },

	/**
	 * Check the <code>Capabilities</code> of this device for a camera.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a camera.
	 * @status Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasCamera:          function() { return this._fields.hasCamera; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for access to a wide area network (WAN).
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to a WAN.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasWwan:            function() { return this._fields.hasWwan; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHasWifi:            function() { return this._fields.hasWifi; },

	/**
	 * Return the name of the mobile phone carrier this device was using at program startup.
	 * @returns {String} Returns the name of the mobile phone carrier, or an empty string if no carrier 
	 * was used (for example, if the device is not connected to a carrier or does not include
	 * hardware for mobile phone service).
	 * @status
	 * @since 1.0
	 */
	getCarrier:            function() { return this._fields.carrier; },

	/**
	 * Return the URL used to launch this application.
	 * @returns {String} The URL for launching this application. If the application is not launched from a URL, returns an empty string.
	 * @status Flash, Test, FlashTested
	 * @since 1.0
	 */
	getIntentUrl:            function() { return this._fields.intentUrl; },
	
	/**
	 * Return the Action used to launch this application.
	 * @returns {String} The action for launching this application. If the application is not launched from an action, returns undefined.
	 * @private
	 * @status
	 * @since 1.6
	 */
	getIntentAction:            function() { return this._fields.intentAction; },
	
	/**
	 * Return the height of the system status bar.
	 * @returns {Number} The status bar height rounded to the nearest integer (in pixels).
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @status Android
	* @since 1.0
	 */
     getStatusBarHeight:            function() { return this._fields.statusBarHeight; },
	
	/**
	 * Return the device locale.
	 * @returns {String} The regional location of a device.
	 * The <code>locale</code> string is a combination of ISO 639-1 and ISO 3166-1. For example, <code>en_US</code>, <code>ja_JP</code>.
	 * @status Flash
	 * @since 1.0
	 */
	getLocale: function() { return this._fields.locale; },

	/**
	 * Return a list of installed fonts on this device.
	 * @returns {String[]} An array of font names installed on the system or addressable by name.
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	getAvailableFonts: function()
	{
		return this._deserializedFonts || (this._deserializedFonts = JSON.parse(this._fields.availableFonts));
	},
	
	/** @private */
	getAutorotateDisabled: function()
	{
		return this._fields.autorotateDisabled || false;
	},
	
	/** @private */
	getInstallReferrer: function() { return this._fields.installReferrer; },
	
	/**
	 * Return the social server used for this application.
	 * @returns {String} The social server URL. For example, partner.plusplus.com.
	 * @status
	 * @since 1.0
	 */	
	getSocialServer: function()
	{
		return this.socialServer;
	},

	/**
	 * Return the name of the Mobage distribution first installed on the device.
	 * @returns {String} The name of the distribution.
	 * @private
	 */
	getDistributionName: function() 
	{
		return this._fields.distributionName;
	},

	/**
	 * Return the name of the Mobage distribution currently installed on the device.
	 * @returns {String} The name of the distribution.
	 * @private
	 */
	getBinaryDistributionName: function() 
	{
		return this._fields.binaryDistributionName;
	},

	/**
	 * @private
	 */	
	getSourceAppID: function()
	{
		return this._fields.sourceAppID;
	},

	/**
	 * @private
	 * @status Android
	 */	
	getAppSignatures: function()
	{
		return this._fields.appSignatures;
	},
	
	/**
	 * Return the release version of this application, as specified in the
	 * <code>configuration.json</code> file's <code>releaseVersion</code> property.
	 * @returns {String} The version identifier.
	 * @status
	 * @since 1.7
	 */
	getAppReleaseVersion: function()
	{
		return this._releaseVersion;
	},

	/**
	 * Return the ISO country code of the SIM card that the device is using.
	 * @returns {String} The ISO country code of the SIM card that the device is using.
	 * @since 1.7
	 */
	getSimCountryCode: function()
	{
		return this._fields.simCountryCode;
	},

	/**
	 * Return the ISO country code of the mobile phone network that the device is using.
	 * @returns {String} The ISO country code of the mobile phone network that the device is using.
	 * @since 1.7
	 */
	getNetworkCountryCode: function()
	{
		return this._fields.networkCountryCode;
	},

	/**
	 * Returns true of the app is disaggregated
	 * @returns {bool}
	 * @since 1.6
	 * @private
	 */
	getIsDisaggregated: function() { return this._fields.isDisaggregated; },
	
    /**
     * Returns true of the app should send the log to the timing performance server
     * @returns {bool}
     * @private
     */
    _getLogToFile: function() { return this._fields.logToFile; },

	/**
	 * Check whether a UDP socket can be created using the <code>{@link Network.Socket}</code>
	 * class.
	 * @returns {Boolean} Returns <code>true</code> if UDP sockets are supported on the current
	 *		device and binary.
	 * @since 1.7
	 */
	getUdpAvailable: function()
	{
		if(this.getPlatformOS() == 'Android' || this.getPlatformOS() == 'iPhone OS') {
			if(this.compareBinaryVersion(1, 6, 5) >= 0) {
				return true;
			}
		}
		return false;
	},

	/**
	 * Check whether an unencrypted TCP socket can be created using the 
	 * <code>{@link Network.Socket}</code> class.
	 * @returns {Boolean} Returns <code>true</code> if unencrypted TCP sockets are supported on the
	 *		current device and binary.
	 * @since 1.7
	 */
	getTcpAvailable: function()
	{
		if(this.getPlatformOS() == 'Android' || this.getPlatformOS() == 'iPhone OS') {
			if(this.compareBinaryVersion(1, 6, 5) >= 0) {
				return true;
			}
		}
		return false;
	},

	/**
	 * Check whether a TCP socket with SSL encryption can be created using the
	 * <code>{@link Network.Socket}</code> class.
	 * @returns {Boolean} Returns <code>true</code> if SSL-encrypted TCP sockets are supported on
	 *		the current device and binary.
	 * @since 1.7
	 */
	getSslAvailable: function()
	{
		if(this.getPlatformOS() == 'Android' || this.getPlatformOS() == 'iPhone OS') {
			if(this.compareBinaryVersion(1, 6, 5) >= 0) {
				return true;
			}
		}
		return false;
	},
	
	_getPendingNotification: function () {
		var pending = this._fields.pendingNotification;
		this._fields.pendingNotification = null;
		if (pending) {
			return JSON.parse(pending);
		}
		return null;
	},

	/** @private */
	_init: function(dict)
	{
		// parse the dict
		var ifields = [];
		NgParseCommandDictionary(dict, 2, this._fields, ifields);

		try {
			// Change server based on URL passed in
			var items = /(https?:\/\/.+?)\/(.*)/.exec(this._fields.url);
			this._fields.server = items[1];
			this._fields.game  = items[2];
		}
		catch (e)
		{
			NgLogException(e);
		}

		// KJ this is necessary because an empty string passed becomes undefined
		if (!this._fields.intentUrl)
			this._fields.intentUrl = "";

		if (this._fields.oglExtensions)
		try
		{
			this._fields.oglExtensions = JSON.parse(this._fields.oglExtensions);
		}
		catch (e)
		{
			NgLogE("Unable to parse OGL Extensions! " + this._fields.oglExtensions);
			NgLogException(e);
		}

		if (this._fields._accts)
		try
		{
			this._fields._accts = JSON.parse(this._fields._accts);
		}
		catch (e)
		{
			NgLogE("Unable to parse Accounts! " + this._fields._accts);
			NgLogException(e);
		}

		try
		{
			this._configuration = JSON.parse(this._fields.configJSON);
			this._fields.contentUrl = this._configuration.contentUrl;
			this.socialServer = this._configuration.socialServer;
			this._releaseVersion = this._configuration.releaseVersion;
		}
		catch (e)
		{
			NgLogE("Unable to parse config!! (" + this._fields.configJSON + ")");
			NgLogException(e);
		}

		try {
			var jsVersion = packStringVersion((this.getSDKVersion() || "1.0").match(/[\.\d]+$/)[0]);
			Proc._setCoreJSVersionSendGen(jsVersion);
			this._binaryVersion = packStringVersion((this.getBinaryVersion() || "1.0").match(/[\.\d]+$/)[0]);
			this._effectiveVersion = Math.min(this._binaryVersion, jsVersion);
		}
		catch (e) {
			NgLogE("Unable to parse version strings!");
			NgLogException(e);
		}

		console.log( "dict : JS version : " + this.getSDKVersion() );
		console.log( "dict : JS build date : " + this.getSDKBuildDate() );
		console.log( "dict : JS build hash : " + this.getSDKBuildHash() );

		console.log("dict : contentUrl : " + this._fields.contentUrl);
		console.log("dict : socialServer : " + this.socialServer);
		console.log("dict : releaseVersion : " + this._releaseVersion);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 301,
	// Method create = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[301] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x12dffff, [ +__objectRegistryId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/MessageEmitter.js';

var Class = require('NGCore/Shared/Class').Class;
var MessageListener = require('NGCore/Shared/MessageListener').MessageListener;

exports.MessageEmitter = Class.subclass(
/** @lends Core.MessageEmitter.prototype */
{
	classname: 'MessageEmitter',
	
	/**
	 * @class The <code>MessageEmitter</code> class constructs emitter objects that send messages to registered <code>{@link Core.MessageListener}</code> objects. 
	 * When a defined condition triggers an emitter, all registered listener objects are in turn triggered.
	 * <br /><br />
	 * Emitter objects support two communication modes: emit and chain. When emitting, each listener is called in turn.
	 * When chaining, each listener can halt the propagation of a message to 
	 * other listeners by returning <code>true</code> from their callback.
	 * <br /><br />
	 * Each listener can include an optional priority ranking. Priority determines the order
	 * in which an emitter calls each listener. 
	 * If two listener objects are registered with the same priority, the emitter calls them in the order they were registered. 
	 * The default priority is <code>0</code>. 
	 * <br /><br />
	 * The classes in ngCore provide a variety of built-in message emitters. For example, if an
	 * application adds a listener to <code>{@link Device.ShakeEmitter}</code>, the listener will
	 * receive a message when the user shakes the device. You can also use the
	 * <code>MessageEmitter</code> class to create custom message emitters for your application.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @since 1.0
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._messageListenersCount = 0;
		this._messageListenerRecords = [];
		this._messageDeferredWork = [];
		this._messageShouldDefer = false;
	},
	
	/**
	 * Unregister all <code>MessageListener</code> objects from this <code>MessageEmitter</code>.<br /><br />
	 * <b>Note:</b> Do not use the emitter after calling this.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function($super)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._destroyActual.bind(this, $super));
		}
		else
		{
			this._destroyActual($super);
		}
	},
	
	_destroyActual: function(superDestroy)
	{
		// Unregister all listeners.
		var records = this._messageListenerRecords;
		while(records.length)
		{
			this.removeListener(records[0].l);
		}
		
		if(superDestroy)
			superDestroy();
	},
	
	/**
	 * Retrieve the number of <code>MessageListener</code> objects registered with this <code>MessageEmitter</code>.
	 * @returns {Number} The current number of <code>MessageListener</code> objects.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getListenerCount: function()
	{
		return this._messageListenersCount;
	},
	
	/**
	 * Add a <code>MessageListener</code> to this <code>MessageEmitter</code>. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br /><br />
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br /><br />
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @cb {Function} func The function to call when an application triggers this emitter. The
	 *		callback function can accept any number of parameters. All parameters that are passed to
	 *		<code>emit()</code> or <code>chain()</code> will be passed to the callback function.
	 * @cb-returns {void}
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {Error} The specified listener is already listening to the emitter.
	 * @throws {Error} The specified listener is not an instance of <code>Core.MessageListener</code>.
	 * @see Core.MessageEmitter#removeListener
	 * @see Core.MessageEmitter#emit
	 * @see Core.MessageEmitter#chain
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	addListener: function(listener, func, priority)
	{
		if(!listener instanceof MessageListener)
			throw new Error('MessageEmitter.addListener: listener must be instances of MessageListener');
			
		if(!listener._startListeningEmitter(this))
			throw new Error('MessageEmitter.addListener: listener is already listening');
			
		if(!priority)
		{
			priority = 0;
		}
		
		this._messageListenersCount++;	
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._addListenerActual.bind(this, listener, func, priority));
		}
		else
		{
			this._addListenerActual(listener, func, priority);
		}
	},
	
	_addListenerActual: function(listener, func, priority)
	{
		//  The priority for default value is <code>0</code>
		if ((typeof priority) == 'undefined') {
			priority = 0;
		}
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			if(records[i].p <= priority)
				break;
		}
		records.splice(i, 0, {l: listener, f: func, p: priority});
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this <code>MessageEmitter</code>.<br /><br /> 
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	removeListener: function(listener)
	{
		if(!listener._stopListeningEmitter(this))
			//throw new Error('MessageEmitter.removeListner: listener is not listening');
			return false;
		
		this._messageListenersCount--;
		if(this._messageShouldDefer)
		{
			// TODO Replace with binary search.
			var records = this._messageListenerRecords;
			var len = records.length;
			for(var i=0; i < len; ++i)
			{
				var record = records[i];
				if(record.l == listener)
				{
					record.f = null;
					break;
				}
			}
			
			this._messageDeferredWork.push(this._removeListenerActual.bind(this, listener));
		}
		else
		{
			this._removeListenerActual(listener);
		}
		
		return true;
	},
	
	_removeListenerActual: function(listener)
	{
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(record.l == listener)
			{
				records.splice(i, 1);
				break;
			}
		}
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code>. This emitter will trigger all listeners
	 * in descending order based on the listener priority. All listener callback functions are generated
	 * with parameters passed to <code>emit()</code>.
	 * @param {String} params Parameters to pass to the generated callback function. Any
	 *		number and type of parameters may be passed in.
	 * @returns {Boolean} Returns <code>true</code> if the message was sent immediately. Returns
	 * <code>false</code> if the message was deferred.
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	emit: function(params)
	{
		var handled = false;
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._emitActual.bind(this, arguments, false));
		}
		else
		{
			handled = this._emitActual(arguments, true);
		}
		return handled;
	},
	
	_emitActual: function(params, executeDeferred)
	{
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		var handled = false;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
				handled = true;
		}

		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}

		return handled;
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code> through a chain of command. 
	 * This emitter will trigger all listeners in descending order based on the listener priority.
	 * All listener callback functions are generated with parameters passed to <code>chain()</code>.	 
	 * <br /><br />
	 * Unlike <code>emit()</code>, <code>chain()</code> allows a <code>MessageListener</code> to halt propagation of a message 
	 * to other listener objects by returning <code>true</code> for the callback function.
	 * This is useful for things like touch event handling. A <code>MessageListener</code> can respond to a touch event
	 * by returning <code>true</code>, masking the touch event from other listener objects.
	 *
	 * @param {String} params Parameters to pass in the generated callback function. Any number and
	 *		type of parameters may be passed in.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener responded. Returns <code>false</code> in all other cases.
	 * <br /><br />
	 * <b>Note:</b> If the application calls <code>chain()</code> recursively from
	 * within a message handler callback, it will always return <code>undefined</code>
	 * regardless of if a <code>MessageListener</code> responds or not.
	 * @see Core.MessageEmitter#emit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	chain: function(params)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._chainActual.bind(this, arguments, false));
			return undefined;
		}
		else
		{
			return this._chainActual(arguments, true);
		}
	},
	
	_chainActual: function(params, executeDeferred)
	{
		var result = false;
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
			{
				result = true;
				break;
			}
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}
		
		return result;
	},
	
	_executeDeferred: function()
	{
		// NOTE: Don't factor out deferred.length. Deferred work can add more deferred work.
		var deferred = this._messageDeferredWork;
		for(var i=0; i < deferred.length; ++i)
		{
			deferred[i]();
		}
		this._messageDeferredWork = [];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/MessageEmitter.js';

exports.MessageEmitter = require('NGCore/Shared/MessageEmitter').MessageEmitter;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadFile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/DownloadFile.js';

////////////////////////////////////////////////////////////////////////////////
// Class DownloadFile
// Downloads a file to the sandbox
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFile = Class.subclass(
/** @lends Network.DownloadFile.prototype */
{
	classname: 'DownloadFile',
	/**
	 * @class The `DownloadFile` class constructs objects that conduct a file download through an
	 * HTTP request.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function() {},

	/**
	 * Initiate a file download.
	 * @example
	 * var url = "http://example.com/sample-file.png";
	 * var filename = "./Content/sample-file.png";
	 * var downloader = new Network.DownloadFile();
	 * downloader.start(filename, "GET", url, [{item: "From", content: "user@example.com"}],
	 *   function(status, md5, responseHeaders) {
	 *     console.log("Downloaded " + filename + ". Status code: " + status + 
	 *       ", MD5: " + md5);
	 *     console.log("Response headers: " + JSON.stringify(responseHeaders));
	 * });
	 * @param {String} filename A local and relative path for storing the downloaded data.
	 * @param {String} method The HTTP method to use.  Specify either `GET` or
	 *		`POST`.
	 * @param {String} url The URL of the downloaded file.
	 * @param {Object[]|String[]} headers An array providing custom headers for the HTTP request.
	 *		The array can contain either strings that contain raw text for the headers (for example,
	 *		`["From: user@example.com"]`) or objects with an `item` property representing a key and
	 *		a `content` property representing a value (for example, `[{item: "From", content:
	 *		"user@example.com"}]`). If you do not need to provide custom headers, pass in an empty
	 *		array.
	 * @cb {Function} [callback] The function to call after the download is complete.
	 * @cb-param {String} statusCode The status code that was received when downloading the file.
	 * @cb-param {String} fileSignature An MD5 checksum of the downloaded file.
	 * @cb-param {Object[]} responseHeaders An array of headers from the HTTP response. The array
	 *		contains objects with an `item` property representing a key and a `content` property
	 *		representing a value (for example, `[{item: "Location", content:
	 *		"http://example.com/sample-file.png"}]`).
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	start: function(filename, method, url, headers, callback)
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		url = url.split(' ').join('%20');
		// Check headers
		if (!(headers instanceof Array))
		{
			if(headers){
				NgLogE('Improper headers sent('+headers+'). Need an array, ex: [{item:"Content-Easter", content:"egg"}]');
			}
			headers = [];
		}

		// Send the goods
		this.__sendSendGen( filename, method, url, headers.length );

		// Send headers
		for (var i in headers)
		{
			this.__headerSendGen(headers[i].item, headers[i].content);
		}

		// Save the callback
		this.mCB = callback;
	},

    /**
      * Stop a file download.
      * @returns {void}
      * @status Flash, Test, FlashTested
      * @since 1.4.1
      */
	abort: function()
	{
		this._destroySendGen();
		ObjectRegistry.unregister(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 341,
	// Method create = -1
	// Method destroy = 2
	// Method _send = 3
	// Method _header = 4
	// Method finish = 5
	// Method finishWithHeaders = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._finishRecv( cmd );
					break;
				case 6:
					instance._finishWithHeadersRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[341] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_finishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishWithHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finishWithHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finishWithHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finishWithHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in DownloadFile.finishWithHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x155ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1550002, this );
	},
	
	/** @private */
	__sendSendGen: function( fileName, method, url, headers )
	{
		Core.Proc.appendToCommandString( 0x1550003, this, [ Core.Proc.encodeString( fileName ), Core.Proc.encodeString( method ), Core.Proc.encodeString( url ), +headers ] );
	},
	
	/** @private */
	__headerSendGen: function( item, content )
	{
		Core.Proc.appendSubcommandToCommandString( [ Core.Proc.encodeString( item ), Core.Proc.encodeString( content ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _send: function( fileName, method, url, headers ) {}
	
	// _header: function( item, content ) {}
	
	// _finishRecv: function( cmd ) {}
	// _finishWithHeadersRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,
	_finishRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishRecvGen(cmd, obj);

		if (this.mCB)
			this.mCB(obj.status, obj.signature, {});

		ObjectRegistry.unregister(this);
	},

	_finishWithHeadersRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishWithHeadersRecvGen(cmd, obj);


		if (this.mCB)
		{
			var headerEx = /^([\w-]+):\s*([^\n]+?)\s*$/;

			var headers = [];
			var lines = obj.headers.split('\n');

			for(var i = 0; i < lines.length; i++)
			{
				var match = headerEx.exec(lines[i]);
				if(match)
					headers.push({"item": match[1], "content": match[2]});
			}

			this.mCB(obj.status, obj.signature, headers);
		}
	
		ObjectRegistry.unregister(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/_int_Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/_int_Util.js';

///////////////////////////////////////////////////////////////////////////////
// Class _int_Util
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;
////////////////////////////////////////////////////////////////////////////////

var _int_Util = exports._int_Util = Class.singleton(
/** @lends Network._int_Util.prototype */
{
	classname: '_int_Util',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._callbackID = 0;
		this._callbacks = [];

		// Only set this to false if we do not meet this version. Otherwise we have to say true;
		this.valid = !Core.Capabilities.meetsBinaryVersion("1.3.5.10");
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		Persist: -1,
		Game: -2
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 350,
	// Method create = -1
	// Method destroy = 2
	// Method sign = 3
	// Method signCallback = 4
	// Method adTapjoySendActionComplete = -5
	// Method verified = -6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._signCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -6:
					_int_Util._verifiedRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[350] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_signCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	$_verifiedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.verified from command: " + cmd );
			return false;
		}
		
		obj[ "b" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "b" ] === undefined )
		{
			NgLogE("Could not parse b in _int_Util.verified from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x15effff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x15e0002, this );
	},
	
	/** @private */
	_signSendGen: function( baseString, callbackID, environment )
	{
		Core.Proc.appendToCommandString( 0x15e0003, this, [ Core.Proc.encodeString( baseString ), +callbackID, Core.Proc.encodeString( environment ) ] );
	},
	
	/** @private */
	$_adTapjoySendActionCompleteSendGen: function( actionId )
	{
		Core.Proc.appendToCommandString( 0x15efffb, [ Core.Proc.encodeString( actionId ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// sign: function( baseString, callbackID, environment ) {}
	
	// _signCallbackRecv: function( cmd ) {}
	// $adTapjoySendActionComplete: function( actionId ) {}
	
	// $_verifiedRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,
	$_verifiedRecv: function( cmd )
	{
		this.valid = true;
		if (this._verifiedCallback)
		{
			this._verifiedCallback();
		}
	},

	sign: function( baseString, environment, callback) {
		// Save requests
		if (this.valid)
		{
			this._callbacks[this._callbackID] = callback;
			this._signSendGen(baseString,this._callbackID++, environment);
		}
		else
		{
			callback(false);
		}
	},
	_signCallbackRecv: function( cmd ) {
		var msg = {};
		if (! this._signCallbackRecvGen(cmd, msg)) {
			return;
		}
		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signature);
		}
	},

	signable: function()
	{
		return this.valid;
	},

	registerVerifiedCB: function(cb)
	{
		if (this.valid)
		{
			cb();
		}
		else
		{
			this._verifiedCallback = cb;
		}
	},

	$adTapjoySendActionComplete: function(actionId) {
		console.log('_int_Util.adTapjoysendActionComplete: ' + actionId);
		this._adTapjoySendActionCompleteSendGen(actionId);
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Socket'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Socket'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Socket'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/Socket.js';

////////////////////////////////////////////////////////////////////////////////
// Class Socket
//   Low-level (BSD-like) network API
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////


exports.Socket = Class.subclass(
/** @lends Network.Socket.prototype */
{
	classname: 'Socket',
	
	/**
	 * @class The `Network.Socket` class enables applications to connect to a server using
	 * Transmission Control Protocol (TCP) or User Datagram Protocol (UDP) sockets, without the 
	 * additional overhead of an HTTP or HTTPS request. The current implementation is based on
	 * Internet Protocol version 4 (IPv4).
	 * 
	 * TCP is designed to ensure reliable, accurate delivery of messages, at the cost of increased
	 * latency when there is a problem sending or receiving data. Use TCP for network operations
	 * that depend on this increased accuracy. In contrast, UDP delivers messages as quickly as
	 * possible, with no error checking; messages may be dropped, arrive out of order, or contain
	 * errors. Use UDP for network operations that are more error-tolerant and depend upon low
	 * latency.
	 *
	 * Secure Sockets Layer (SSL) encryption is supported for TCP sockets. An encrypted TCP socket
	 * can connect to servers that use SSLv3 or Transport Layer Security (TLS) v1. SSLv2, which has
	 * been deprecated due to security issues, is not supported.
	 * 
	 * **Note**: `Network.Socket` is designed to support low-level network operations. Use the
	 * `{@link Network.DownloadFile}` and `{@link Network.XHR}` classes for HTTP/HTTPS requests.
	 *
	 * After creating the socket, your application should use the following methods to specify
	 * callback functions for the socket:
	 *
	 * + `{@link Network.Socket#setOnReadable}`: The function to call when there is data available
	 * to be read from the socket.
	 * + `{@link Network.Socket#setOnWritable}`: The function to call when the socket is ready to
	 * transmit data.
	 * + `{@link Network.Socket#setOnError}`: The function to call when an error occurs while
	 * transmitting data.
	 * 
	 * **Important**: Before your application creates a socket connection, it should verify that
	 * socket support is available by calling `{@link Core.Capabilities#getTcpAvailable}` (for TCP)
	 * or `{@link Core.Capabilities#getUdpAvailable}` (for UDP).
	 * @name Network.Socket
	 * @constructs Create a network socket.
	 * @augments Core.Class
	 * @example
	 * // Create a TCP socket without security (the default).
	 * var socket;
	 *
	 * if (Core.Capabilities.getTcpAvailable()) {
	 *     socket = new Network.Socket();
	 * } else {
	 *     // Use another network connection method, or report that the
	 *     // application is not supported on the current platform.
	 * }
	 * @example
	 * // If SSL is available, create a TCP socket with SSL security. Otherwise,
	 * // create a TCP socket without security.
	 * var security;
	 * var socket;
	 *
	 * if (Core.Capabilities.getTcpAvailable()) {
	 *     if (Core.Capabilities.getSslAvailable()) {
	 *         security = Network.Socket.Security.SecSSL;
	 *     } else {
	 *         security = Network.Socket.Security.SecNone;  
	 *     }
	 *     socket = new Network.Socket(Network.Socket.Protocol.TCP4, security);
	 * } else {
	 *     // Use another network connection method, or report that the
	 *     // application is not supported on the current platform.
	 * }
	 * @example
	 * // 1. Create a TCP socket, bind it to a local port selected by the device, 
	 * //    and connect it to a remote host at 10.16.10.200:9876.
	 * // 2. Write "Hello World!" to the socket.
	 * // 3. Log the remote host's response to the console, then close the socket.
	 * var tcpSocket;
	 * var readBuffer;
	 * var writeBuffer;
	 * var connected = false;
	 * var bytesRead;
	 * var server;
	 *
	 * if (Core.Capabilities.getTcpAvailable()) {
	 *     tcpSocket = new Network.Socket();
	 *     readBuffer = new Core.Buffer();
	 *     writeBuffer = new Core.Buffer();
	 *
	 *     tcpSocket.setOnWritable(function(socket) {
	 *         // Make sure we only send the message once.
	 *         if (!connected) {
	 *             connected = true;
	 *             writeBuffer.writeBytes("Hello World!");
	 *             socket.send(writeBuffer);
	 *         }
	 *     });
	 *
	 *     tcpSocket.setOnReadable(function(socket) {
	 *         bytesRead = socket.recv(readBuffer);
	 *         if (bytesRead !== 0) {
	 *             // We received data from the remote host.
	 *             // Read the data, then close the socket.
	 *             console.log("Received the following data from the socket: " + 
	 *               readBuffer.readBytes(readBuffer.getSize()));
	 *             socket.close();
	 *         }
	 *     });
	 *
	 *     tcpSocket.setOnError(function(err, socket) {
	 *         console.log("A socket error occurred: " + err.description);
	 *         // Take action based on the type of error.
	 *         switch(err.code) {
	 *             case Network.Socket.Error.NotConnected:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             case Network.Socket.Error.ConnectionTimeout:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             // Add code to handle other errors as needed.
	 *             default:
	 *                 // Add code to handle the error.
	 *                 break;
	 *         }
	 *     });
	 *
	 *     tcpSocket.bind(0, function(err, socket, port) {
	 *         if (err) {
	 *             console.log("Unable to bind the socket to a local port: " + 
	 *               err.description);
	 *             // Take action based on the type of error.
	 *             switch(err.code) {
	 *                 case Network.Socket.Error.AddrInUse:
	 *                     // Add code to handle the error.
	 *                     break;
	 *                 // Add code to handle other errors as needed.
	 *                 default:
	 *                     // Add code to handle the error.
	 *                     break;
	 *             }
	 *         } else {
	 *             server = {
	 *                 host: "10.16.10.200",
	 *                 port: 9876
	 *             };
	 *             socket.connect(server);
	 *         }
	 *     });
	 * } else {
	 *     // Use another network connection method, or report that the
	 *     // application is not supported on the current platform.
	 * }
	 * @param {Network.Socket.Protocol} [protocol=Network.Socket.Protocol.TCP4] The transport
	 *		protocol to use for the socket. **Note**: Call
	 *		`{@link Core.Capabilities#getTcpAvailable}` or
	 *		`{@link Core.Capabilities#getUdpAvailable}` to verify that the requested transport
	 *		protocol is supported.
	 * @param {Network.Socket.Security} [security=Network.Socket.Security.SecNone] The type of
	 *		security to use for the socket. **Note**: When using SSL, call
	 *		`{@link Core.Capabilities#getSslAvailable}` to verify that SSL is supported.
	 * @see Core.Buffer
	 * @see Core.Capabilities#getSslAvailable
	 * @see Core.Capabilities#getTcpAvailable
	 * @see Core.Capabilities#getUdpAvailable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.6.5
	 */
	initialize: function(protocol, security)
	{
		this._protocol = (protocol === undefined)?this.Protocol.TCP4:protocol;
		this._security = (security === undefined)?this.Security.SecNone:security;
		this._isStream = (this._protocol != this.Protocol.UDP4);
		this._isServer = false;
		this._state = this.State.CLOSED;
		this._maxSndBufSize = 64*1024;
		this._curSndBufSize = this._maxSndBufSize;
		this._rcvBuf = '';
		this._rcvBufInfo = []; // each item has a form of { size:64, host:'10.1.1.2', port:5678 }
		this._EOS = false;
		this._localAddr = null;
		this._peerAddr = null;
		this._nextCbId = 0;
		this._pendingChildren = [];
		this._cb = {};
		this._onReadable = null;
		this._onWritable = null;
		this._onError = null;
		this._storeCb = function(cb) {
			var cbId = -1;
			if(cb) {
				cbId = this._nextCbId++;
				this._cb[cbId] = cb?cb:function(){};
			}
			return cbId;
		};
		this._restoreCb = function(cbId) {
			var cb = this._cb[cbId];
			delete this._cb[cbId];
			return cb;
		};
		if(this._parentId === undefined || this._childId === undefined) {
			this._parentId = -1;
			this._childId = -1;
		} else {
			this._state = this.State.READY;
			this._isServer = true;
		}

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId, this._protocol, this._security, this._parentId, this._childId);
	},

// API

	/**
	 * Specify a value for one of the socket's configuration options. See
	 * `{@link Network.Socket#Option}` for details about the options that are supported.
	 * @example
	 * // Set the connection timeout to 10 seconds for the existing socket
	 * // 'tcpSocket'.
	 * tcpSocket.setOption(Network.Socket.Option.OpConnectionTimeout, 10000, 
	 *   function(err, soc) {
	 *     if (err) {
	 *         console.log("Unable to set the socket's connection timeout: " +
	 *           err.description);
	 *         // Take action based on the type of error.
	 *         switch(err.code) {
	 *             case Network.Socket.Error.Invalid:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             // Add code to handle other errors as needed.
	 *             default:
	 *                 // Add code to handle the error.
	 *                 break;
	 *         }
	 *     } else {
	 *         // Continue using the socket object ('soc').
	 *     }
	 * });
	 * @param {Network.Socket#Option} op The configuration option to set.
	 * @param {Number} val The value to use for the configuration option.
	 * @cb {Function} cb The function to call after setting the configuration option.
	 * @cb-param {Object} err Information about the error, if any.
	 * @cb-param {Network.Socket#Error} [err.code] A code identifying the type of error.
	 * @cb-param {String} [err.description] A description of the error.
	 * @cb-param {Network.Socket} [soc] The socket whose configuration option was set.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see Network.Socket#getOption
	 * @see Network.Socket#Option
	 * @since 1.6.5
	 */
	setOption: function(op, val, cb)
	{
		var cbId = this._storeCb(cb);
		this._setOptionSendGen(op, val, '', cbId);
	},

	/**
	 * Retrieve the current value of one of the socket's configuration options. See
	 * `{@link Network.Socket#Option}` for details about the options that are supported.
	 * @example
	 * // Retrieve the connection timeout for the existing socket 'tcpSocket'.
	 * tcpSocket.getOption(Network.Socket.Option.OpConnectionTimeout,
	 *   function(err, soc, val) {
	 *     if (err) {
	 *         console.log("Unable to retrieve the socket's connection timeout: " +
	 *           err.description);
	 *         // Take action based on the type of error.
	 *         switch(err.code) {
	 *             case Network.Socket.Error.Invalid:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             // Add code to handle other errors as needed.
	 *             default:
	 *                 // Add code to handle the error.
	 *                 break;
	 *         }
	 *     } else {
	 *         console.log("The current connection timeout is " + val);
	 *         // Continue using the socket object ('soc').
	 *     }
	 * });
	 * @param {Network.Socket#Option} op The configuration option to retrieve.
	 * @cb {Function} cb The function to call after retrieving the configuration option.
	 * @cb-param {Object} err Information about the error, if any.
	 * @cb-param {Network.Socket#Error} [err.code] A code identifying the type of error.
	 * @cb-param {String} [err.description] A description of the error.
	 * @cb-param {Network.Socket} [soc] The socket whose configuration option was retrieved.
	 * @cb-param {Number} val The value of the configuration option.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see Network.Socket#Option
	 * @see Network.Socket#setOption
	 * @since 1.6.5
	 */
	getOption: function(op, cb)
	{
		var cbId = this._storeCb(cb);
		this._getOptionSendGen(op, cbId);
	},

	/**
	 * Set the function to call when there is data available to be read from the socket.
	 * @example
	 * // For the existing socket 'tcpSocket', read data from the socket,
	 * // then write the data to the console.
	 * var readBuffer = new Core.Buffer();
	 *
	 * tcpSocket.setOnReadable(function(socket) {
	 *     var bytesRead = socket.recv(readBuffer);
	 *     if (bytesRead !== 0) {
	 *         // We received data from the remote host.
	 *         console.log("Received the following data from the socket: " + 
	 *           readBuffer.readBytes(readBuffer.getSize()));
	 *     }
	 * });
	 * @cb {Function} callback The function to call when there is data available to be read from the
	 *		socket.
	 * @cb-param {Network.Socket} [soc] The socket for which data is available.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see Core.Buffer
	 * @since 1.6.5
	 */
	setOnReadable: function(callback)
	{
		this._onReadable = callback;
	},

	/**
	 * Set the function to call when the socket is ready to transmit data. For TCP sockets, when
	 * this function is called for the first time, it indicates that the connection has been
	 * established.
	 * @example
	 * // If there is data available in the write buffer, write it to the 
	 * // existing socket 'tcpSocket'.
	 * var writeBuffer = new Core.Buffer();
	 * writeBuffer.writeBytes("Hello World!");
	 *
	 * tcpSocket.setOnWritable(function(socket) {
	 *     if (writeBuffer.getSize() > 0) {
	 *         tcpSocket.send(writeBuffer);
	 *     }
	 * });
	 * @cb {Function} callback The function to call when the socket is ready to transmit data.
	 * @cb-param {Network.Socket} [soc] The socket that is ready to transmit data.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see Core.Buffer
	 * @since 1.6.5
	 */
	setOnWritable: function(callback)
	{
		this._onWritable = callback;
	},

	/**
	 * Set the function to call when an error occurs while transmitting data.
	 * @example
	 * // If the existing socket 'tcpSocket' experiences an error, log a message
	 * // to the console, then handle the error.
	 * tcpSocket.setOnError(function(err, socket) {
	 *     console.log("A socket error occurred: " + err.description);
	 *     // Take action based on the type of error.
	 *     switch(err.code) {
	 *         case Network.Socket.Error.NotConnected:
	 *             // Add code to handle the error.
	 *             break;
	 *         case Network.Socket.Error.ConnectionTimeout:
	 *             // Add code to handle the error.
	 *             break;
	 *         // Add code to handle other errors as needed.
	 *         default:
	 *             // Add code to handle the error.
	 *             break;
	 *     }
	 * });
	 * @cb {Function} callback The function to call when an error occurs while transmitting data.
	 * @cb-param {Object} err Information about the error.
	 * @cb-param {Network.Socket#Error} err.code A code identifying the type of error.
	 * @cb-param {String} err.description A description of the error.
	 * @cb-param {Network.Socket} [soc] The socket for which an error occurred.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.6.5
	 */
	setOnError: function(callback)
	{
		this._onError = callback;
	},

	/**
	 * Bind the socket to a local port.
	 * @example
	 * // Bind the existing socket 'tcpSocket' to a port number assigned by
	 * // the device. If an error occurs, log a message and handle the error.
	 * var port;
	 * tcpSocket.bind(0, function(err, soc, port) {
	 *     if (err) {
	 *         console.log("Unable to bind the socket to a local port: " + 
	 *           err.description);
	 *         // Take action based on the type of error.
	 *         switch(err.code) {
	 *             case Network.Socket.Error.AddrInUse:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             // Add code to handle other errors as needed.
	 *             default:
	 *                 // Add code to handle the error.
	 *                 break;
	 *         }
	 *     } else {
	 *         // Connect the socket object ('soc') to a remote host.
	 *     }
	 * });
	 * @param {Number} port The local port number to bind to this socket. Use the value `0` to allow
	 *		the device to assign a port number.
	 * @cb {Function} [callback] The function to call after binding the socket to a port number.
	 * @cb-param {Object} err Information about the error, if any.
	 * @cb-param {Network.Socket#Error} [err.code] A code identifying the type of error.
	 * @cb-param {String} [err.description] A description of the error.
	 * @cb-param {Network.Socket} [soc] The socket that was bound to a local port.
	 * @cb-param {Number} [port] The local port number to which the socket was bound.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.6.5
	 */
	bind: function(port, callback)
	{
		if(this._state == this.State.CLOSED) {
			var cbId = this._storeCb(callback);
			this._bindSendGen(port, 0/*future-use*/, cbId);
		}
	},

	/**
	 * Add the socket as a member of a specified multicast group. Used only for UDP sockets.
	 * @example
	 * // Add the existing UDP socket 'udpSocket' to a multicast group, setting
	 * // the time-to-live for outgoing packets to 2. If an error occurs, log a
	 * // message and handle the error.
	 * var options = {
	 *     ttl: 2
	 * };
	 * udpSocket.addMembership("10.16.1.105", options, function(err, soc) {
	 *     if (err) {
	 *         console.log("Unable to add the socket to a multicast group: " + 
	 *           err.description);
	 *         // Take action based on the type of error.
	 *         switch(err.code) {
	 *             case Network.Socket.Error.NotConnected:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             // Add code to handle other errors as needed.
	 *             default:
	 *                 // Add code to handle the error.
	 *                 break;
	 *         }
	 *     } else {
	 *         // Continue using the socket object ('soc').
	 *     }
	 * });
	 * @param {String} mcgrp The IP address of the multicast group.
	 * @param {Object} [options] Options for multicasting.
	 * @param {Boolean} [options.loop=false] Set to `true` to receive packets sent to the multicast
	 *		group.
	 * @param {Number} [options.ttl=1] The time-to-live (TTL) for outgoing packets, which controls
	 *		how many times the packet will be forwarded.
	 * @cb {Function} [callback] The function to call after adding the socket to the multicast
	 *		group.
	 * @cb-param {Object} err Information about the error, if any.
	 * @cb-param {Network.Socket#Error} [err.code] A code identifying the type of error.
	 * @cb-param {Number} [err.description] A description of the error.
	 * @cb-param {Network.Socket} [soc] The socket that was added to the multicast group.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.6.5
	 */
	addMembership: function(mcgrp, options, callback)
	{
		if(!this._isStream) {
			var flags = 0;
			var ttl = 1;
			if(typeof(options) == 'object') {
				if(options) {
					if(options['loop']) {
						flags |= this.MulticastFlag['loop'];
					}
					if(options['ttl']) {
						ttl = options['ttl'];
					}
				}
			} else {
				callback = options;
			}
			var cbId = this._storeCb(callback);
			this._addMembershipSendGen( mcgrp, flags, ttl, cbId );
		}
	},

	/**
	 * Remove the socket from a specified multicast group. Used only for UDP sockets.
	 * @example
	 * // Remove the existing UDP socket 'udpSocket' from a multicast group.
	 * // If an error occurs, log a message and handle the error.
	 * udpSocket.dropMembership("10.16.1.105", function(err, soc) {
	 *     if (err) {
	 *         console.log("Unable to remove the socket from a multicast group: " +
	 *           err.description);
	 *         // Take action based on the type of error.
	 *         switch(err.code) {
	 *             case Network.Socket.Error.NotConnected:
	 *                 // Add code to handle the error.
	 *                 break;
	 *             // Add code to handle other errors as needed.
	 *             default:
	 *                 // Add code to handle the error.
	 *                 break;
	 *         }
	 *     } else {
	 *         // Continue using the socket object ('soc').
	 *     }
	 * });
	 * @param {String} mcgrp The IP address of the multicast group.
	 * @cb {Function} [callback] The function to call after removing the socket from the multicast
	 *		group.
	 * @cb-param {Object} err Information about the error, if any.
	 * @cb-param {Network.Socket#Error} [err.code] A code identifying the type of error.
	 * @cb-param {Number} [err.description] A description of the error.
	 * @cb-param {Socket} [soc] The socket that was removed from the multicast group.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.6.5
	 */
	dropMembership: function(mcgrp, callback)
	{
		if(!this._isStream) {
			var cbId = this._storeCb(callback);
			this._dropMembershipSendGen( mcgrp, cbId );
		}
	},

	/**
	 * Connect the socket to a remote host. For TCP sockets, you must call this method before you
	 * transmit data through the socket. For UDP sockets, you can call this method to connect the
	 * socket to a remote host, or you can specify a remote host when you call
	 * `{@link Network.Socket#send}` or `{@link Network.Socket#recv}`.
	 * @example
	 * // Connect the existing socket 'tcpSocket' to a remote host at
	 * // 10.16.10.200:9876.
	 * var server = {
	 *     host: "10.16.10.200",
	 *     port: 9876
	 * };
	 * tcpSocket.connect(server);
	 * @param {Object} to Information about the remote host.
	 * @param {String} [to.cn] The remote host's fully qualified domain name (FQDN). If this 
	 *		parameter is included, and the socket is using SSL security, the FQDN will be used to
	 *		verify the common name (CN) used to generate the remote host's SSL certificate. If this
	 *		parameter is omitted, or if the socket is not using SSL, verification will be skipped.
	 *		Available since ngCore 1.7.
	 * @param {String} to.host The IP address of the remote host.
	 * @param {Number} to.port The port number of the remote host.
	 * @returns {void}
	 * @since 1.6.5
	 */
	connect: function(to)
	{
		if(this._isStream) {
			if(this._state == this.State.CLOSED) {
				this._state = this.State.CONNECTING;
				if(!to.cn) to.cn = '';
				this._connectSendGen(to.host, to.port, to.cn);
			}
		} else {
			if(this._state == this.State.CLOSED || this._state == this.State.READY) {
				if(!this._peerAddr) {
					this._state = this.State.CONNECTING;
				}
				this._connectSendGen(to.host, to.port, '');
			}
		}
	},

	/**
	 * @private
	 * Listen on a socket. (TCP only)
	 */
	listen: function()
	{
		if(this._state == this.State.CLOSED) {
			if(this._isStream) {
				var backlog = 8;
				this._state = this.State.LISTENING;
				this._listenSendGen(backlog);
			}
		}
	},

	/**
	 * @private
	 * Accept a new socket. (TCP listener only)
	 * @return Non-null Socket object is returned on success, or null on failure.
	 */
	accept: function()
	{
		var newSoc = null;
		if(this._isStream && this._state == this.State.LISTENING) {
			var child = this._pendingChildren.shift();
			if(child) {
				newSoc = new TcpServerSocket(this._protocol, this._security, child['parentId'], child['childId']);
				newSoc._peerAddr = { host:child['host'], port:child['port'] };
				newSoc._localAddr = this._localAddr;
			}
		}
		return newSoc;
	},

	/** @private */
	/*
	_dumpDigits: function(s) {
		var str = '';
		for(var i = 0; i < s.length; ++i) {
			var val = s.charCodeAt(i);
			var digit = val.toString(16);
			if(digit.length < 2) {
				digit = '0' + digit;
			}

			str += (digit + ' ');

			if((i % 8) == 7) {
				if((i % 32) == 31) {
					str += '\n';
				} else {
					str += ' ';
				}
			}
		}

		return str;
	},
	*/

	/**
	 * Send data from a buffer to a socket, removing the data from the buffer. Returns the number of
	 * characters that were written to the socket.
	 * @example
	 * // Create a new buffer that contains the string "Hello World", and send the
	 * // entire contents of the buffer using the existing TCP socket 'tcpSocket'.
	 * var writeBuffer = new Core.Buffer();
	 * writeBuffer.writeBytes("Hello World");
	 * var charsWritten = tcpSocket.send(writeBuffer);
	 * @example
	 * // Create a new buffer that contains 2,500 characters. Send the buffer's
	 * // contents in several messages that contain up to 1,000 characters each,
	 * // using the existing UDP socket 'udpSocket' and the remote host
	 * // 10.16.10.200:9876.
	 * var writeBuffer = new Core.Buffer(),
	 *     string = "";
	 * for (var i = 0; i < 2500; i++) {
	 *     string += "a";
	 * }
	 * writeBuffer.writeBytes(string);
	 *
	 * var server = {
	 *     host: "10.16.10.200",
	 *     port: 9876
	 * };
	 * var charsWritten;
	 *
	 * while (writeBuffer.getSize() > 0) {
	 *     charsWritten = udpSocket.send(writeBuffer, 1000, server);
	 *     console.log("Wrote " + charsWritten + " characters to the socket. " +
	 *       writeBuffer.getSize() + " characters left to write.");
	 * }
	 * @param {Core.Buffer} buf The buffer that contains data to be sent. The data that was written
	 *		to the socket will be removed from the buffer.
	 * @param {Number} [len=-1] The number of characters to send, or a negative number to send all 
	 *		data in the buffer. For UDP sockets, use a value less than `1400` to reduce
	 *		fragmentation at the IP layer; UDP packets larger than 2 KB will be discarded by the
	 *      receiver.
	 * @param {Object} [to] Information about the remote host. Required for UDP sockets; after the
	 *		UDP socket has connected to a remote host, the value of this parameter will be ignored.
	 *		Not used for TCP sockets.
	 * @param {String} [to.host] The IP address of the remote host.
	 * @param {Number} [to.port] The port number of the remote host.
	 * @returns {Number} The number of characters that were written to the socket.
	 * @see Core.Buffer
	 * @since 1.6.5
	 */
	send: function(buf, len, to) {
		if(this._isStream) {
			if(this._state != this.State.READY) {
				return this.Error.Invalid;
			}
		} else {
			if(this._state == this.State.CLOSED) {
				this._state = this.State.READY;
			} else {
				if(this._state != this.State.CONNECTING && this._state != this.State.READY) {
					return this.Error.Invalid;
				}
			}
		}
		if(len === undefined) {
			len = -1;
		} else {
			if(typeof(len) == 'object') {
				to = len;
				len = -1;
			}
		}
    if(len < 0 || len > buf.getSize()) {
			len = buf.getSize();
		}
		if(len > this._curSndBufSize) {
			if(!this._isStream) {
				return exports.Socket.Error.TryAgain;
			}
			len = this._curSndBufSize;
			if(!len) {
				return 0;
			}
		}
		var data = buf.readBytes(len);
		if(!to)
			to = {host:'',port:0};
		this._curSndBufSize -= data.length;
		this._sendSendGen(data, to.host, to.port);
		return data.length;
	},

	/**
	 * Read data from a socket and write it to a buffer. Returns the number of characters that were
	 * written to the buffer.
	 *
	 * If the method's return value is `0`, the remote server has closed the connection. Your
	 * application can call `{@link Network.Socket#close}` to close the socket.
	 * @example
	 * // Read all of the data from the existing TCP socket 'tcpSocket', and store 
	 * // the data in a new buffer.
	 * var readBuffer = new Core.Buffer();
	 * tcpSocket.recv(readBuffer);
	 * @example
	 * // Read all of the data from the existing UDP socket 'udpSocket', using 
	 * // the remote host 10.16.10.200:9876, and store the data in a new buffer.
	 * var readBuffer = new Core.Buffer();
	 * var server = {
	 *     host: "10.16.10.200",
	 *     port: 9876;
	 * };
	 * udpSocket.recv(readBuffer, server);
	 * @param {Core.Buffer} buf The buffer in which to write data. If the buffer already contains
	 *		data, the new data will be appended to the existing data.
	 * @param {Number} [len=-1] The number of bytes to read, or a negative number to read all
	 *		available data. Used only for TCP sockets.
	 * @param {Object} [from] Information about the remote host. Required for UDP sockets; after the
	 *		UDP socket has connected to a remote host, the value of this parameter will be ignored.
	 *		Not used for TCP sockets.
	 * @param {String} [from.host] The IP address of the remote host.
	 * @param {Number} [from.port] The port number of the remote host.
	 * @returns {Number} The number of characters that were written to the buffer.
	 * @see Core.Buffer
	 * @since 1.6.5
	 */
	recv: function(buf, len, from) {
		if(this._state != this.State.READY && this._state != this.State.CLOSING) {
			return this.Error.Invalid;
		}
		if(len === undefined) {
			len = -1;
		} else {
			if(typeof(len) == 'object') {
				from = len;
				len = -1;
			}
		}
		var orgSize = buf.getSize();
		if(this._isStream) {
			if(!this._rcvBuf.length) {
				return this._EOS? 0:exports.Socket.Error.TryAgain;
			}
			if(len < 0 || len >= this._rcvBuf.length) {
				buf.writeBytes(this._rcvBuf);
				this._rcvBuf = '';
			} else {
				buf.writeBytes(this._rcvBuf.slice(0, len));
				this._rcvBuf = this._rcvBuf.slice(len);
			}
			if(from) {
				from['host'] = this._peerAddr['host'];
				from['port'] = this._peerAddr['port'];
			}
		} else {
			if(!this._rcvBufInfo.length)
			{
				this._rcvBuf = ''; // for just in case.
				return exports.Socket.Error.TryAgain;
			}
			var info = this._rcvBufInfo.shift();
			len = info['size'];
			if(len > 0) {
				buf.writeBytes(this._rcvBuf.slice(0, len));
				this._rcvBuf = this._rcvBuf.slice(len);
			}
			if(from) {
				from['host'] = info['host'];
				from['port'] = info['port'];
			}
		}
		if(buf.getSize() > 0) {
			this._updateSendGen( this.UpdateId.U_SizeRcvd, buf.getSize(), '' );
		}
		return buf.getSize() - orgSize;
	},

	/**
	 * Initiate a graceful shutdown process for the socket. For TCP sockets, call this method prior
	 * to calling `{@link Network.Socket#close}`. Do not call this method on UDP sockets.
	 *
	 * If the shutdown process is successful, the following steps occur:
	 *
	 * 1. The remote server notifies the socket that it has closed the connection.
	 * 2. The socket executes the callback function defined by calling
	 * `{@link Network.Socket#setOnReadable}`. This callback function will normally include a call
	 * to the method `{@link Network.Socket#recv}`.
	 * 3. The `{@link Network.Socket#recv}` method returns the value `0`, indicating that the
	 * application can close the socket by calling `{@link Network.Socket#close}`.
	 * @deprecated Since ngCore 1.8. Because of device limitations, it is not possible to complete a
	 *		graceful shutdown on many devices. This method may be removed in a future version of
	 *		ngCore.
	 * @returns {void}
	 * @since 1.6.5
	 */
	shutdown: function() {
		if(this._state == this.State.READY) {
			this._state = this.State.CLOSING;
			this._shutdownSendGen(0/*not used*/);
		}
	},

	/**
	 * Close the socket. Do not reuse the `Network.Socket` object after calling this method.
	 *
	 * **Note**: Calling this method closes the socket immediately. If you need to close the
	 * connection more gracefully, add code to your app that notifies the remote server that the
	 * connection is closing, and add code to your server that acknowledges the notification. The
	 * app can then close the connection after it receives the acknowledgement.
	 * @returns {void}
	 * @since 1.6.5
	 */
	close: function() {
		this._closeSendGen();
		this._state = this.State.CLOSED;
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the socket's current state.
	 * @example
	 * // Retrieve the state of the existing TCP socket 'tcpSocket', and
	 * // take an action based on the current state.
	 * var state = tcpSocket.getState();
	 * switch (state) {
	 *     case Network.Socket.State.READY:
	 *         // Your code here.
	 *         break;
	 *     case Network.Socket.State.CLOSED:
	 *         // Your code here.
	 *         break;
	 *     // Continue through each enumerated value that you want to test.
	 *     default:
	 *         // Your code here.
	 *         break;
	 * }
	 * @returns {Network.Socket#State} The socket's current state.
	 * @since 1.6.5
	 */
	getState: function() {
		return this._state;
	},

	/**
	 * Retrieve the number of bytes that can be written to the socket's send buffer before it 
	 * reaches its maximum size.
	 * @returns {Number} The send buffer's writable size, in bytes.
	 * @since 1.6.5
	 */
	getSizeWritable: function() {
		return this._curSndBufSize;
	},

	/**
	 * Retrieve the number of bytes that are available to be read from the socket.
	 * @returns {Number} The size of the socket's available data, in bytes.
	 * @since 1.6.5
	 */
	getSizeReadable: function() {
		return this._rcvBuf.length;
	},

	/**
	 * Retrieve the address of the remote server for a TCP socket. The value `null` will be returned
	 * if the connection has not been established.
	 * @returns {Object} The remote server's address, or null if the socket is not yet active. The
	 *		"host" property contains the IP address, and the "port" property contains the port
	 *		number.
	 * @since 1.6.5
	 */
	getPeerAddr: function() {
		return this._peerAddr;
	},

	/**
	 * Retrieve the local address for the socket. For TCP sockets, the value `null` will be returned
	 * if the connection has not been established. For UDP sockets, the value `null` will be
	 * returned if no data has been received.
	 * @returns {Object} The local address, or null if the socket is not yet active. The "host"
	 *		property contains the IP address, and the "port" property contains the port number.
	 * @since 1.6.5
	 */
	getLocalAddr: function() {
		return this._localAddr;
	},

// Receivers

	_onSetOptionCbRecv: function( cmd )
	{
		var obj = {};
		if(this._onSetOptionCbRecvGen(cmd, obj)) {
			if(obj['cbId'] >= 0) {
				var cb = this._restoreCb(obj['cbId']);
				var err = obj['errCode']? { code:obj['errCode'], description:obj['errStr'] }:null;
				cb(err, this);
			}
		}
	},

	_onGetOptionCbRecv: function( cmd )
	{
		var obj = {};
		if(this._onGetOptionCbRecvGen(cmd, obj)) {
			if(obj['cbId'] >= 0) {
				var cb = this._restoreCb(obj['cbId']);
				var err = obj['errCode']? { code:obj['errCode'], description:obj['errStr'] }:null;
				cb(err, this, obj['numVal']);
			}
		}
	},

	_onBindCbRecv: function( cmd )
	{
		var obj = {};
		if(this._onBindCbRecvGen(cmd, obj)) {
			var notifyUdpWritable = false;
			if(!obj['errCode']) {
				this._localAddr = { host: obj['lhost'], port: obj['lport'] };
				if(!this._isStream && this._state == this.State.CLOSED) {
					this._state = this.State.READY;
					notifyUdpWritable = true;
				}
			}
			if(obj['cbId'] >= 0) {
				var cb = this._restoreCb(obj['cbId']);
				var err = obj['errCode']? { code:obj['errCode'], description:obj['errStr'] }:null;
				cb(err, this, obj['lport']);
			}
			if(notifyUdpWritable && this._state == this.State.READY /* checking if still in ready state */) {
				if(this._onWritable && this._curSndBufSize == this._maxSndBufSize ) {
						this._onWritable(this);
				}
			}
		}
	},

	/*
	 * @status Not tested yet
	 */
	_onConnectRecv: function( cmd )
	{
		if(this._state == this.State.CONNECTING) {
			this._state = this.State.READY;
			var obj = {};
			if(this._onConnectRecvGen(cmd, obj)) {
				// {String} obj['rhost'] Dotted-decimal IP address of peer's.
				// {Number} obj['rport'] Peer's port number.
				this._peerAddr = { host: obj['rhost'], port: obj['rport'] };
				if(this._onWritable && this._curSndBufSize == this._maxSndBufSize) {
					this._onWritable(this);
				}
			}
		}
	},

	/*
	 * @status Not tested yet
	 */
	_onAcceptRecv: function( cmd )
	{
		var obj = {};
		if(this._onAcceptRecvGen(cmd, obj)) {
			// {String} obj['rhost'] Dotted-decimal IP address of peer's.
			// {Number} obj['rport'] Peer's port number.
			// {Number} obj['parentId'] Parent socket ID.
			// {Number} obj['childId'] Child socket ID.
			this._pendingChildren.push({
				host: obj['rhost'],
				port: obj['rport'],
				parentId: obj['parentId'],
				childId: obj['childId']
			});
			if(this._onReadable) {
				this._onReadable(this);
			}
		}
	},

	/*
	 * @status Not tested yet
	 */
	_onReceiveRecv: function( cmd )
	{
		var obj = {};
		if(this._onReceiveRecvGen(cmd, obj)) {
			// {String} obj['buf'] Received data.
			// {String} obj['rhost'] Dotted-decimal IP address of peer's.
			// {Number} obj['rport'] Peer's port number.
			var rlen = obj['buf'].length;
			if(rlen > 0) {
				this._rcvBuf += obj['buf'];
			}
			if(this._isStream) {
				if(!rlen) {
					this._EOS = true;
				}
			} else {
				this._rcvBufInfo.push({ size:rlen, host:obj['rhost'], port:obj['rport'] });
			}
			if(this._onReadable) {
				this._onReadable(this);
			}
		}
	},

	/*
	 * @status Not tested yet
	 */
	_onErrorRecv: function( cmd )
	{
		var obj = {};
		if(this._onErrorRecvGen(cmd, obj)) {
			var err = obj['errCode']? { code:obj['errCode'], description:obj['errStr'] }:null;
			if(this._onError && err) {
				this._onError(err, this);
			}
		}
	},

	_onUpdateRecv: function( cmd )
	{
		var obj = {};
		if(this._onUpdateRecvGen(cmd, obj)) {
			// {Number} obj[ "updateId" ]
			// {Number} obj[ "val" ]
			// {String} obj[ "optional" ]
			switch(obj['updateId']) {
				case this.UpdateId.U_SizeSent:
					this._curSndBufSize += obj['val'];
					if(this._onWritable && this._curSndBufSize == this._maxSndBufSize) {
						if(this._state == this.State.READY) {
							this._onWritable(this);
						}
					}
					break;
				default:
					NgLogE('Unknown OnUpdate ID ' + obj['updateId']);
					break;
			}
		}
	},
	

	_onMembershipCbRecv: function( cmd )
	{
		var obj = {};
		if(this._onMembershipCbRecvGen(cmd, obj)) {
			if(obj['cbId'] >= 0) {
				var cb = this._restoreCb(obj['cbId']);
				var err = obj['errCode']? { code:obj['errCode'], description:obj['errStr'] }:null;
				cb(err, this);
			}
		}
	},


	/**
	 * Enumeration for transport protocols that a socket can use.
	 * @name Protocol
	 * @fieldOf Network.Socket#
	 */
	/**
	 * User Datagram Protocol (UDP) over Internet Protocol version 4 (IPv4).
	 * @name Protocol.UDP4
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * Transmission Control Protocol (TCP) over Internet Protocol version 4 (IPv4).
	 * @name Protocol.TCP4
	 * @fieldOf Network.Socket#
	 * @constant
	 */

	/**
	 * Enumeration for types of security that a socket can use.
	 * @name Security
	 * @fieldOf Network.Socket#
	 */
	/**
	 * No security.
	 * @name Security.SecNone
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * Secure Sockets Layer (SSL) security, using SSLv3 or TLSv1. Available only for TCP sockets.
	 * @name Security.SecSSL
	 * @fieldOf Network.Socket#
	 * @constant
	 */

	/**
	 * Enumeration for socket states.
	 * @name State
	 * @fieldOf Network.Socket#
	 */
	/**
	 * The socket is closed.
	 * @name State.CLOSED
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The socket is connecting to a remote host.
	 * @name State.CONNECTING
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The socket is listening for connections. Used only for TCP sockets.
	 * @name State.LISTENING
	 * @fieldOf Network.Socket#
	 * @private
	 * @constant
	 */
	/**
	 * The socket is connected and is ready for reading and writing.
	 * @name State.READY
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The socket is closing. Used only for TCP sockets.
	 * @name State.CLOSING
	 * @fieldOf Network.Socket#
	 * @constant
	 */

	/**
	 * Enumeration for the names of configuration options for the socket.
	 *
	 * **Note**: Do not change the enumerated values themselves. To change an option's value, call
	 * `{@link Network.Socket#setOption}`, and use the `op` parameter to specify which option to
	 * change. To retrieve an option's value, call `{@link Network.Socket#getOption}`, and use the
	 * `op` parameter to specify which option to retrieve.
	 * @name Option
	 * @fieldOf Network.Socket#
	 */
	/**
	 * The size of the socket's send buffer. The default size is 65,536 bytes.
	 * @name Option.OpSendBufSize
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The size of the socket's receive buffer. The default size is 65,536 bytes.
	 * @name Option.OpRecvBufSize
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * Indicates whether to send outgoing messages immediately rather than combining small messages
	 * into a single packet. Accepts the values `0`, to disable the option, or `1`, to enable the
	 * option. This option is enabled by default.
	 * @name Option.OpNoDelay
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The timeout value, in milliseconds, for establishing a connection. The default timeout is
	 * 30,000 milliseconds (30 seconds).
	 * @name Option.OpConnectionTimeout
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The timeout value, in milliseconds, for shutting down a connection. Used only for TCP
	 * sockets. The default timeout is 10,000 milliseconds (10 seconds).
	 * @name Option.OpShutdownTimeout
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * Indicates whether other sockets will be allowed to bind to the same port as this socket,
	 * provided that this socket is not active. Accepts the values `0`, to disable the option, or
	 * `1`, to enable the option. This option is disabled by default.
	 * @name Option.OpReuseAddr
	 * @fieldOf Network.Socket#
	 * @constant
	 */

	/**
	 * Enumeration for types of socket errors.
	 * @name Error
	 * @fieldOf Network.Socket#
	 */
	/**
	 * An unknown error occurred.
	 * @name Error.Unknown
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The requested operation is invalid, or an invalid parameter was specified.
	 * @name Error.Invalid
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The requested operation is not supported.
	 * @name Error.NotSupported
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The socket is not currently available for the requested operation.
	 * @name Error.TryAgain
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The requested address for the socket is already in use.
	 * @name Error.AddrInUse
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The device does not have enough memory available for the requested operation.
	 * @name Error.NoMemory
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The socket is not connected.
	 * @name Error.NotConnected
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The connection timed out.
	 * @name Error.ConnectionTimeout
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The attempt to shut down the socket timed out. Used only for TCP sockets.
	 * @name Error.ShutdownTimeout
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The SSL handshake failed.
	 * @name Error.SSLError
	 * @fieldOf Network.Socket#
	 * @constant
	 */
	/**
	 * The remote host is unreachable.
	 * @name Error.Unreachable
	 * @fieldOf Network.Socket#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	Protocol:
	{ 
		UDP4: 0,
		TCP4: 1
	},
	
	Security:
	{ 
		SecNone: 0,
		SecSSL: 1
	},
	
	State:
	{ 
		CLOSED: 0,
		CONNECTING: 1,
		LISTENING: 2,
		READY: 3,
		CLOSING: 4
	},
	
	Option:
	{ 
		OpSendBufSize: 0,
		OpRecvBufSize: 1,
		OpNoDelay: 2,
		OpConnectionTimeout: 3,
		OpShutdownTimeout: 4,
		OpReuseAddr: 5
	},
	
	Error:
	{ 
		Unknown: -1,
		Invalid: -2,
		NotSupported: -3,
		TryAgain: -4,
		AddrInUse: -5,
		NoMemory: -6,
		NotConnected: -7,
		ConnectionTimeout: -8,
		ShutdownTimeout: -9,
		SSLError: -10,
		Unreachable: -11,
		ConnectionRefused: -12
	},
	
	/** @private Enumeration for multicast flags. */
	MulticastFlag:
	{ 
		McLoop: 0x00000001
	},
	
	/** @private Enumeration for update ID. */
	UpdateId:
	{ 
		U_NOP: 0,
		U_SizeSent: 1,
		U_SizeRcvd: 1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 360,
	// Method create = -1
	// Method setOption = 2
	// Method getOption = 3
	// Method bind = 4
	// Method connect = 5
	// Method listen = 6
	// Method send = 7
	// Method shutdown = 8
	// Method close = 9
	// Method addMembership = 10
	// Method dropMembership = 11
	// Method update = 12
	// Method onSetOptionCb = 13
	// Method onGetOptionCb = 14
	// Method onBindCb = 15
	// Method onConnect = 16
	// Method onAccept = 17
	// Method onReceive = 18
	// Method onError = 19
	// Method onUpdate = 20
	// Method onMembershipCb = 21
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 13:
					instance._onSetOptionCbRecv( cmd );
					break;
				case 14:
					instance._onGetOptionCbRecv( cmd );
					break;
				case 15:
					instance._onBindCbRecv( cmd );
					break;
				case 16:
					instance._onConnectRecv( cmd );
					break;
				case 17:
					instance._onAcceptRecv( cmd );
					break;
				case 18:
					instance._onReceiveRecv( cmd );
					break;
				case 19:
					instance._onErrorRecv( cmd );
					break;
				case 20:
					instance._onUpdateRecv( cmd );
					break;
				case 21:
					instance._onMembershipCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Socket._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Socket._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[360] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onSetOptionCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 4 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onSetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "opId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "opId" ] === undefined )
		{
			NgLogE("Could not parse opId in Socket.onSetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "cbId" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cbId" ] === undefined )
		{
			NgLogE("Could not parse cbId in Socket.onSetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Socket.onSetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Socket.onSetOptionCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onGetOptionCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 6 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "opId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "opId" ] === undefined )
		{
			NgLogE("Could not parse opId in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "numVal" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "numVal" ] === undefined )
		{
			NgLogE("Could not parse numVal in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "strVal" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "strVal" ] === undefined )
		{
			NgLogE("Could not parse strVal in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "cbId" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "cbId" ] === undefined )
		{
			NgLogE("Could not parse cbId in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Socket.onGetOptionCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onBindCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onBindCb from command: " + cmd );
			return false;
		}
		
		obj[ "lhost" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "lhost" ] === undefined )
		{
			NgLogE("Could not parse lhost in Socket.onBindCb from command: " + cmd );
			return false;
		}
		
		obj[ "lport" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "lport" ] === undefined )
		{
			NgLogE("Could not parse lport in Socket.onBindCb from command: " + cmd );
			return false;
		}
		
		obj[ "cbId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "cbId" ] === undefined )
		{
			NgLogE("Could not parse cbId in Socket.onBindCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Socket.onBindCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Socket.onBindCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onConnectRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onConnect from command: " + cmd );
			return false;
		}
		
		obj[ "rhost" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "rhost" ] === undefined )
		{
			NgLogE("Could not parse rhost in Socket.onConnect from command: " + cmd );
			return false;
		}
		
		obj[ "rport" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "rport" ] === undefined )
		{
			NgLogE("Could not parse rport in Socket.onConnect from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onAcceptRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 4 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onAccept from command: " + cmd );
			return false;
		}
		
		obj[ "rhost" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "rhost" ] === undefined )
		{
			NgLogE("Could not parse rhost in Socket.onAccept from command: " + cmd );
			return false;
		}
		
		obj[ "rport" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "rport" ] === undefined )
		{
			NgLogE("Could not parse rport in Socket.onAccept from command: " + cmd );
			return false;
		}
		
		obj[ "parentId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "parentId" ] === undefined )
		{
			NgLogE("Could not parse parentId in Socket.onAccept from command: " + cmd );
			return false;
		}
		
		obj[ "childId" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "childId" ] === undefined )
		{
			NgLogE("Could not parse childId in Socket.onAccept from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onReceiveRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onReceive from command: " + cmd );
			return false;
		}
		
		obj[ "buf" ] = Core.Proc.parseBinary( cmd[ 0 ] );
		if( obj[ "buf" ] === undefined )
		{
			NgLogE("Could not parse buf in Socket.onReceive from command: " + cmd );
			return false;
		}
		
		obj[ "rhost" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "rhost" ] === undefined )
		{
			NgLogE("Could not parse rhost in Socket.onReceive from command: " + cmd );
			return false;
		}
		
		obj[ "rport" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "rport" ] === undefined )
		{
			NgLogE("Could not parse rport in Socket.onReceive from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onErrorRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onError from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Socket.onError from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Socket.onError from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "updateId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "updateId" ] === undefined )
		{
			NgLogE("Could not parse updateId in Socket.onUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "val" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "val" ] === undefined )
		{
			NgLogE("Could not parse val in Socket.onUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "optional" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "optional" ] === undefined )
		{
			NgLogE("Could not parse optional in Socket.onUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onMembershipCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Socket.onMembershipCb from command: " + cmd );
			return false;
		}
		
		obj[ "cbId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "cbId" ] === undefined )
		{
			NgLogE("Could not parse cbId in Socket.onMembershipCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Socket.onMembershipCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Socket.onMembershipCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId, proto, sec, parentId, childId )
	{
		Core.Proc.appendToCommandString( 0x168ffff, [ +__objectRegistryId, +proto, +sec, +parentId, +childId ] );
	},
	
	/** @private */
	_setOptionSendGen: function( opId, numVal, strVal, cbId )
	{
		Core.Proc.appendToCommandString( 0x1680002, this, [ +opId, +numVal, Core.Proc.encodeString( strVal ), +cbId ] );
	},
	
	/** @private */
	_getOptionSendGen: function( opId, cbId )
	{
		Core.Proc.appendToCommandString( 0x1680003, this, [ +opId, +cbId ] );
	},
	
	/** @private */
	_bindSendGen: function( lport, flags, cbId )
	{
		Core.Proc.appendToCommandString( 0x1680004, this, [ +lport, +flags, +cbId ] );
	},
	
	/** @private */
	_connectSendGen: function( rhost, rport, cn )
	{
		Core.Proc.appendToCommandString( 0x1680005, this, [ Core.Proc.encodeString( rhost ), +rport, Core.Proc.encodeString( cn ) ] );
	},
	
	/** @private */
	_listenSendGen: function( backlog )
	{
		Core.Proc.appendToCommandString( 0x1680006, this, [ +backlog ] );
	},
	
	/** @private */
	_sendSendGen: function( buf, rhost, rport )
	{
		Core.Proc.appendToCommandString( 0x1680007, this, [ Core.Proc.encodeBinary( buf ), Core.Proc.encodeString( rhost ), +rport ] );
	},
	
	/** @private */
	_shutdownSendGen: function( how )
	{
		Core.Proc.appendToCommandString( 0x1680008, this, [ +how ] );
	},
	
	/** @private */
	_closeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1680009, this );
	},
	
	/** @private */
	_addMembershipSendGen: function( mcgrp, flags, ttl, cbId )
	{
		Core.Proc.appendToCommandString( 0x168000a, this, [ Core.Proc.encodeString( mcgrp ), +flags, +ttl, +cbId ] );
	},
	
	/** @private */
	_dropMembershipSendGen: function( mcgrp, cbId )
	{
		Core.Proc.appendToCommandString( 0x168000b, this, [ Core.Proc.encodeString( mcgrp ), +cbId ] );
	},
	
	/** @private */
	_updateSendGen: function( updateId, val, optional )
	{
		Core.Proc.appendToCommandString( 0x168000c, this, [ +updateId, +val, Core.Proc.encodeString( optional ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId, proto, sec, parentId, childId ) {}
	
	// setOption: function( opId, numVal, strVal, cbId ) {}
	
	// getOption: function( opId, cbId ) {}
	
	// bind: function( lport, flags, cbId ) {}
	
	// connect: function( rhost, rport, cn ) {}
	
	// listen: function( backlog ) {}
	
	// send: function( buf, rhost, rport ) {}
	
	// shutdown: function( how ) {}
	
	// close: function(  ) {}
	
	// addMembership: function( mcgrp, flags, ttl, cbId ) {}
	
	// dropMembership: function( mcgrp, cbId ) {}
	
	// update: function( updateId, val, optional ) {}
	
	// _onSetOptionCbRecv: function( cmd ) {}
	// _onGetOptionCbRecv: function( cmd ) {}
	// _onBindCbRecv: function( cmd ) {}
	// _onConnectRecv: function( cmd ) {}
	// _onAcceptRecv: function( cmd ) {}
	// _onReceiveRecv: function( cmd ) {}
	// _onErrorRecv: function( cmd ) {}
	// _onUpdateRecv: function( cmd ) {}
	// _onMembershipCbRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});

TcpServerSocket = exports.Socket.subclass(
{
	classname: 'TcpServerSocket',
	initialize: function($super, protocol, security, parentId, childId)
	{
		this._parentId = parentId;
		this._childId = parentId;
		$super(protocol, security);
	}
});

// vim: ts=2:sw=2:noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DNS'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DNS'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DNS'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/DNS.js';

////////////////////////////////////////////////////////////////////////////////
// Class DNS
// DNS resolver
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DNS = Class.singleton(
/** @lends Network.DNS.prototype */
{
	classname: 'DNS',
	
	/**
	 * @class The `Network.DNS` class enables applications to obtain the IP addresses that are 
	 * associated with a domain name.
	 * @singleton
	 * @constructs
	 * @augments Core.Class
	 * @since 1.6.5
	 */
	initialize: function()
	{
		this._nextCbId = 0;
		this._cb = {};
		this._storeCb = function(cb) {
			var cbId = -1;
			if(cb) {
				cbId = this._nextCbId++;
				this._cb[cbId] = cb?cb:function(){};
			}
			return cbId;
		};
		this._restoreCb = function(cbId) {
			var cb = this._cb[cbId];
			delete this._cb[cbId];
			return cb;
		};

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Retrieve a list of IP addresses that are associated with a domain name.
	 * @example
	 * // Obtain the IP addresses that are associated with the domain name mobage.com.
	 * var ip = [];
	 * Network.DNS.resolve("mobage.com", function(err, addrs) {
	 *     if (err) {
	 *         console.log("An error occurred while resolving the domain name: " +
	 *           err.code + ": " + err.description);
	 *     } else {
	 *         ip = addrs;
	 *     }
	 * });
	 * @param {String} host The domain name to resolve.
	 * @cb {Function} cb The function to call after resolving the domain name.
	 * @cb-param {Object} err Information about the error, if any.
	 * @cb-param {Network.DNS#Error} [err.code] A code identifying the error.
	 * @cb-param {String} [err.description] A description of the error.
	 * @cb-param {String[]} addrs The IP addresses associated with the domain name.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.6.5
	 */
	resolve: function(host, cb)
	{
		var cbId = this._storeCb(cb);
		this._resolveSendGen(host, 0,  cbId);
	},

	_onResolveCbRecv: function( cmd )
	{
		var obj = {};
		if(this._onResolveCbRecvGen(cmd, obj)) {
			if(obj['cbId'] >= 0) {
				var cb = this._restoreCb(obj['cbId']);
				if(obj['errCode']) {
					cb({ code:obj['errCode'], description:obj['errStr'] }, []);
				} else {
					cb(null, obj['addrs']?JSON.parse(obj['addrs']):[]);
				}
			}
		}
	},
	
	/**
	 * Enumeration for types of DNS errors.
	 * @name Error
	 * @fieldOf Network.DNS#
	 */
	
	/**
	 * An unknown error occurred.
	 * @name Error.Unknown
	 * @fieldOf Network.DNS#
	 * @constant
	 */
	
	/**
	 * The domain name is invalid.
	 * @name Error.Invalid
	 * @fieldOf Network.DNS#
	 * @constant
	 */
	
	/**
	 * The requested operation is not supported.
	 * @name Error.NotSupported
	 * @fieldOf Network.DNS#
	 * @constant
	 */
	
	/**
	 * The domain name could not be found.
	 * @name Error.NotFound
	 * @fieldOf Network.DNS#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	Error:
	{ 
		Unknown: -100,
		Invalid: -101,
		NotSupported: -102,
		NotFound: -103
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 361,
	// Method create = -1
	// Method resolve = 2
	// Method onResolveCb = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._onResolveCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DNS._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DNS._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[361] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResolveCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 4 )
		{
			NgLogE("Could not parse due to wrong argument count in DNS.onResolveCb from command: " + cmd );
			return false;
		}
		
		obj[ "cbId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "cbId" ] === undefined )
		{
			NgLogE("Could not parse cbId in DNS.onResolveCb from command: " + cmd );
			return false;
		}
		
		obj[ "addrs" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "addrs" ] === undefined )
		{
			NgLogE("Could not parse addrs in DNS.onResolveCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in DNS.onResolveCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in DNS.onResolveCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x169ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_resolveSendGen: function( host, flags, cbId )
	{
		Core.Proc.appendToCommandString( 0x1690002, this, [ Core.Proc.encodeString( host ), +flags, +cbId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// resolve: function( host, flags, cbId ) {}
	
	// _onResolveCbRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Color'] || {}; $MODULE_REGISTRY['NGCore/Shared/Color'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Color.js';

var Class = require('NGCore/Shared/Class').Class;

exports.Color = Class.subclass(
/** @lends Core.Color.prototype */
{
	classname: 'Color',
	
	/**
	 * @class The <code>Color</code> class constructs objects that control the RGB components of a device. 
	 * RGB is a color model used for rendering objects on-screen and is derived 
	 * from the three primary colors used in the model: red, green, and blue.
	 * Each value ranges from <code>(0-1)</code> and determines the color saturation level.	 
	 * @constructs The default constructor.
	 * @example
	 * // Create a new color with all components set to one (1 = white).
	 * var style1 = new Core.Color();
	 * @example
	 * // Copy an existing color.
	 * var style2 = new Core.Color(style1);
	 * @example
	 * // Specify all three components.
	 * var style3 = new Core.Color(1.0, 1.0, 1.0);
	 * @example
	 * // Specify the color as solid blue.
	 * var style4 = new Core.Color([0, 0, 1.0]);
	 * @example
	 * // Specify the color as solid red.
	 * var style5 = new Core.Color([1.0, 0, 0]);
	 * @example
	 * // Specify the color as a dark shade of red.
	 * var style6 = new Core.Color([.5, 0, 0]);
	 * @augments Core.Class
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @throws {Wrong number of arguments for a Color} Number of parameters passed by this call is invalid.
	 * @since 1.0
	 */
	initialize: function(red, green, blue)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._red = 1.0;
				this._green = 1.0;
				this._blue = 1.0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._red = 1.0;
					this._green = 1.0;
					this._blue = 1.0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (color)
					this._red = rhs.getRed();
					this._green = rhs.getGreen();
					this._blue = rhs.getBlue();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._red = 1.0;
							this._green = 1.0;
							this._blue = 1.0;
							break;
						case 1:
							// ([color])
							rhs = rhs[0];
							this._red = rhs.getRed();
							this._green = rhs.getGreen();
							this._blue = rhs.getBlue();
							break;
						case 3:
							// ([red, green, blue])
							this._red = rhs[0];
							this._green = rhs[1];
							this._blue = rhs[2];
							break;
						default:
							throw new Error('Wrong number of arguments for a Color');
					}
				}
				break;
			case 3:
				// (red, gree, blue)
				this._red = arguments[0];
				this._green = arguments[1];
				this._blue = arguments[2];
				break;
			default:
				throw new Error('Wrong number of arguments for a Color');
		}
		return this;
	},
	
	/**
	 * Set the saturation level for all three color components.
	 * @example Core.Color.setAll(0.5, 0.5, 1.0);
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @returns {this}
	 * @see Core.Color for a full list of supported calling styles.
	 * @since 1.0
	 */
	setAll: function(red, green, blue)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Retrieve the saturation level for the red component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the red component.
	 * @since 1.0
	 */
	getRed: function()
	{
		return this._red;
	},
	
	/**
	 * Retrieve the saturation level for the green component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the green component.
	 * @since 1.0
	 */
	getGreen: function()
	{
		return this._green;
	},
	
	/**
	 * Retrieve the saturation level for the blue component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the blue component.
	 * @since 1.0
	 */
	getBlue: function()
	{
		return this._blue;
	},
	
	/**
	 * Set the saturation level for the red component of this <code>Color</code>.
	 * @example Core.Color.setRed(0.7);
	 * @param {Number} red The new saturation level for the red component.
	 * @returns {this}
	 * @see Core.Color#getRed
	 * @since 1.0
	 */
	setRed: function(red)
	{
		this._red = red;
		return this;
	},
	
	/**
	 * Set the saturation level for the green component of this <code>Color</code>.
	 * @example Core.Color.setGreen(0.3);
	 * @param {Number} green The new saturation level for the green component.
	 * @returns {this}
	 * @see Core.Color#getGreen
	 * @since 1.0
	 */
	setGreen: function(green)
	{
		this._green = green;
		return this;
	},
	
	/**
	 * Set the saturation level for the blue component of this <code>Color</code>.
	 * @example Core.Color.setBlue(1.0);
	 * @param {Number} blue The new saturation level for the blue component.
	 * @returns {this}
	 * @see Core.Color#getBlue
	 * @since 1.0
	 */
	setBlue: function(blue)
	{
		this._blue = blue;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Color'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Color'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Color.js';

exports.Color = require('NGCore/Shared/Color').Color;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Vector'] || {}; $MODULE_REGISTRY['NGCore/Shared/Vector'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Vector.js';

var Class = require('NGCore/Shared/Class').Class;

exports.Vector = Class.subclass(
/** @lends Core.Vector.prototype */
{
	classname: 'Vector',
	
	/**
	 * @class The <code>Vector</code> class constructs objects that define vector point values for the <i>x</i> and <i>y</i> components. 
	 * @constructs The default constructor.
	 * @example
	 * // All components are set to zero.
	 * var style1 = new Core.Vector();
	 * @example
	 * // Copy an existing vector.
	 * var style2 = new Core.Vector(style1);
	 * @example
	 * // Specify a value for both components.
	 * var style3 = new Core.Vector(1.0, 1.0);
	 * @example
	 * // Specify a value for both components.
	 * var style4 = new Core.Vector([1.0, 1.0]);
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> component.
	 * @param {Number} [y=0] The <i>y</i> component.
	 * @throws {Error} The number of parameters is invalid.
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	initialize: function()
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (vector)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([vector])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Vector');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Vector');
		}
	},
	
	/**
	 * Set the value of both components for this <code>Vector</code>. 
	 * @param {Number} [x=0] The new <i>x</i> coordinate.
	 * @param {Number} [y=0] The new <i>y</i> coordinate.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setAll: function()
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Vector</code>.
	 * @returns {Core.Vector} A new vector with identical coordinates to the duplicated vector.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Vector#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Vector</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns {this}
	 * @see Core.Vector#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Vector#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Vector</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns {this}
	 * @see Core.Vector#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Vector'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Vector'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Vector.js';

exports.Vector = require('NGCore/Shared/Vector').Vector;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Point'] || {}; $MODULE_REGISTRY['NGCore/Shared/Point'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Point.js';

var Class = require('NGCore/Shared/Class').Class;

var setAll = function(x, y)
{
	switch(arguments.length)
	{
		case 0:
			// ()
			this._x = 0;
			this._y = 0;
			break;
		case 1:
			var rhs = arguments[0];
			if(rhs === undefined)
			{
				// (undefined)
				this._x = 0;
				this._y = 0;
			}
			else if(!rhs.hasOwnProperty('length'))
			{
				// (point)
				this._x = rhs.getX();
				this._y = rhs.getY();
			}
			else
			{
				switch(rhs.length)
				{
					case 0:
						// ([])
						this._x = 0;
						this._y = 0;
						break;
					case 1:
						// ([point])
						rhs = rhs[0];
						this._x = rhs.getX();
						this._y = rhs.getY();
						break;
					case 2:
						// ([x, y])
						this._x = rhs[0];
						this._y = rhs[1];
						break;
					default:
						throw new Error('Wrong number of arguments for a Point');
				}
			}
			break;
		case 2:
			// (x, y)
			this._x = arguments[0];
			this._y = arguments[1];
			break;
		default:
			throw new Error('Wrong number of arguments for a Point');
	}
	return this;
};

exports.Point = Class.subclass(
/** @lends Core.Point.prototype */
{
	classname: 'Point',
	
	/**
	 * @class The <code>Point</code> class defines a 2D point coordinate (<i>x</i> and <i>y</i>). 
	 * @status iOS, Android, Flash, Test
	 * @constructs The default constructor.
	 * @example
	 * // All components are set to zero.
	 * var style1 = new Core.Point();
	 * @example
	 * // Copy an existing point.
	 * var style2 = new Core.Point(style1);
	 * @example
	 * // Specify a value for both components.
	 * var style3 = new Core.Point(1.0, 1.0);
	 * @example
	 * // Specify a value for both components.
	 * var style4 = new Core.Point([1.0, 1.0]);
	 * @name Core.Point
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> coordinate.
	 * @param {Number} [y=0] The <i>y</i> coordinate.
	 * @throws {Wrong number of arguments for a Point} Number of parameters passed by this call is invalid.
	 * @since 1.0
	 */
	initialize: setAll,
	
	/**
	 * Set the value of both the <i>x</i> and <i>y</i> components. 
	 * @param {Number} [<i>x</i>=0] The new <i>x</i> coordinate.
	 * @param {Number} [<i>y</i>=0] The new <i>y</i> coordinate.
	 * @returns {this}
	 * @see Core.Point for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setAll: setAll,
	
	/**
	 * Duplicate this <code>Point</code>.
	 * @returns {Core.Point} A new point with identical <i>x</i> and <i>y</i> coordinates to the cloned point.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Point#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Point</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns {this}
	 * @see Core.Point#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Point#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Point</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns {this}
	 * @see Core.Point#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Point'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Point'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Point.js';

exports.Point = require('NGCore/Shared/Point').Point;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Size'] || {}; $MODULE_REGISTRY['NGCore/Shared/Size'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Size.js';

var Class = require('NGCore/Shared/Class').Class;

exports.Size = Class.subclass(
/** @lends Core.Size.prototype */
{
	classname: 'Size',
	
	/**
	 * @class The <code>Size</code> class constructs objects that define size values for the <i>height</i> and <i>width</i> components. 
	 * @status iOS, Android, Flash
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor.
	 * @example
	 * // Set both component values to 0.
	 * var style1 = new Core.Size();
	 * @example
	 * // Copy an existing size.
	 * var style2 = new Core.Size(style1);
	 * @example
	 * // Specify a value for both components.
	 * var style3 = new Core.Size(1.0, 1.0);
	 * @example
	 * // Specify a value for both components.
	 * var style4 = new Core.Size([1.0, 1.0]);
	 * @augments Core.Class
	 * @param {Number} [width=0] The <i>width</i> component.
	 * @param {Number} [height=0] The <i>height</i> component.
	 * @since 1.0
	 */
	initialize: function(width, height)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._width = 0;
				this._height = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._width = 0;
					this._height = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (size)
					this._width = rhs.getWidth();
					this._height = rhs.getHeight();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._width = 0;
							this._height = 0;
							break;
						case 1:
							// ([size])
							rhs = rhs[0];
							this._width = rhs.getWidth();
							this._height = rhs.getHeight();
							break;
						case 2:
							// ([x, y])
							this._width = rhs[0];
							this._height = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Size');
					}
				}
				break;
			case 2:
				// (x, y)
				this._width = arguments[0];
				this._height = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Size');
		}
	},
	
	/**
	 * Set the value of all components for this <code>Size</code>. 
	 * @param {Number} [width=0] The new <i>width</i>.
	 * @param {Number} [height=0] The new <i>height</i>.
	 * @throws {Wrong number of arguments for a Size} Number of parameters passed by this call is invalid.
	 * @returns {this}
	 * @see Core.Size for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setAll: function(width, height)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Size</code>.
	 * @returns {Core.Size} A new size with identical <i>height</i> and <i>width</i> components.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>width</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>width</i>.
	 * @see Core.Size#setWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Set the value of the <i>width</i> component for this <code>Size</code>.
	 * @param {Number} width The new <i>width</i>.
	 * @returns {this}
	 * @see Core.Size#getWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setWidth: function(width)
	{
		this._width = width;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>height</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>height</i>.
	 * @see Core.Size#setHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * Set the value of the <i>height</i> component for this <code>Size</code>.
	 * @param {Number} height The new <i>height</i>.
	 * @returns {this}
	 * @see Core.Size#getHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setHeight: function(height)
	{
		this._height = height;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Size'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Size'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Size.js';

exports.Size = require('NGCore/Shared/Size').Size;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Rect'] || {}; $MODULE_REGISTRY['NGCore/Shared/Rect'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Rect.js';

var Class = require('NGCore/Shared/Class').Class;
var Point = require('NGCore/Shared/Point').Point;
var Size = require('NGCore/Shared/Size').Size;

exports.Rect = Class.subclass(
/** @lends Core.Rect.prototype */
{
	classname: 'Rect',
	
	/**
	 * @class The <code>Rect</code> class constructs a rectangle object that is derived from two values: a point of origin  
	 * and a size.	 
	 * @status iOS, Android, Flash
	 * @constructs The default constructor.
	 * @example
	 * // All components set to zero.
	 * var style1 = new Core.Rect();
	 * @example
	 * // Copy an existing rect.
	 * var style2 = new Core.Rect(style1);
	 * @example
	 * // Specify a point and size.
	 * var style3 = new Core.Rect(new Core.Point(), new Core.Size());
	 * @example
	 * // Specify four components.
	 * var style4 = new Core.Rect(0, 0, 100, 100);
	 * @augments Core.Class
	 * @param {Core.Point} [origin=0] The rectangle point of origin.
	 * @param {Core.Size} [size=0] The rectangle size.
	 * @throws {Wrong number of arguments for a Rect} Number of parameters passed by this call is invalid.
	 * @since 1.0
	 */
	initialize: function(origin, size)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._origin = new Point();
				this._size = new Size();
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._origin = new Point();
					this._size = new Size();
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (rect)
					this._origin = new Point(rhs.getOrigin());
					this._size = new Size(rhs.getSize());
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._origin = new Point();
							this._size = new Size();
							break;
						case 1:
							// ([rect])
							rhs = rhs[0];
							this._origin = new Point(rhs.getOrigin());
							this._size = new Size(rhs.getSize());
							break;
						case 2:
							// ([point, size])
							// ([[x, y], [width, height]])
							this._origin = new Point(rhs[0]);
							this._size = new Size(rhs[1]);
							break;
						case 4:
							// ([x, y, width, height])
							this._origin = new Point(rhs[0], rhs[1]);
							this._size = new Size(rhs[2], rhs[3]);
							break;
						default:
							throw new Error('Wrong number of arguments for a Rect');
					}
				}
				break;
			case 2:
				// (point, size)
				this._origin = new Point(arguments[0]);
				this._size = new Size(arguments[1]);
				break;
			case 4:
				// (x, y, width, height)
				this._origin = new Point(arguments[0], arguments[1]);
				this._size = new Size(arguments[2], arguments[3]);
				break;
			default:
				throw new Error('Wrong number of arguments for a Rect');
		}
	},
	
	/**
	 * Set the value of all components for this <code>rect</code>. 
	 * @param {Core.Point} [origin=0] The new point of origin.
	 * @param {Core.Size} [size=0] The new rectangle size.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setAll: function(origin, size)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate the point of origin of this <code>rect</code>.
	 * @returns {Core.Point} A new rectangle with an identical origin and size.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the point of origin for this <code>rect</code>.
	 * @returns {Core.Point} The current point of origin.
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getOrigin: function()
	{
		return this._origin;
	},
	
	/**
	 * Set the point of origin for this <code>rect</code>.
	 * @param {Core.Point} origin The new point of origin.
	 * @returns {this}
	 * @see Core.Rect#getOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setOrigin: function(origin)
	{
		this._origin.setAll(origin);
		return this;
	},
	
	/**
	 * Change the point of origin so that the center of this <code>rect</code> is at the specified location.
	 * @param {Core.Point} origin The new point of origin that results in a rectangle with a center position at the specified location.
	 * @returns {this}
	 * @see Core.Rect#setSizeCentered
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setOriginCentered: function(origin)
	{
		origin = new Core.Point(origin);
		this._origin.setX(origin.getX() - this._size.getWidth()/2);
		this._origin.setY(origin.getY() - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the size of this <code>rect</code>.
	 * @returns {Core.Size} The current rectangle size.
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size of this <code>rect</code>.
	 * @param {Core.Size} size The new rectangle size.
	 * @returns {this}
	 * @see Core.Rect#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setSize: function(size)
	{
		this._size.setAll(size);
		return this;
	},
	
	/**
	 * Set the size of this <code>rect</code> and preserve the current center position.
	 * @param {Core.Size} size The new rectangle size that retains the current center position.
	 * @returns {this}
	 * @see Core.Rect#setOriginCentered
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setSizeCentered: function(size)
	{
		var oldWidth = this._size.getWidth();
		var oldHeight = this._size.getHeight();
		
		this._size.setAll(size);

		this._origin.setX(this._origin.getX() + oldWidth/2 - this._size.getWidth()/2);
		this._origin.setY(this._origin.getY() + oldHeight/2 - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the minimum value for <i>x</i>. This is represented by the left coordinate.
	 * @returns {Number} The current minimum value of  the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getMinX: function()
	{
		return this._origin.getX();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>x</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>x</i> coordinate values. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getMidX: function()
	{
		return this._origin.getX() +  this._size.getWidth()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>x</i>. This is the right coordinate.
	 * @returns {Number} The current maximum value of the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getMaxX: function()
	{
		return this._origin.getX() + this._size.getWidth();
	},
	
	/**
	 * Retrieve the minimum value for <i>y</i>. This is the top coordinate.
	 * @returns {Number} The current minimum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getMinY: function()
	{
		return this._origin.getY();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>y</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>y</i> coordinate values.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getMidY: function()
	{
		return this._origin.getY() + this._size.getHeight()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>y</i>. This is the bottom coordinate.
	 * @returns {Number} The current maximum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getMaxY: function()
	{
		return this._origin.getY() + this._size.getHeight();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Rect'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Rect'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Rect.js';

exports.Rect = require('NGCore/Shared/Rect').Rect;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/md5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] = exports; 
var __dirname = 'NGCore/Shared/Lib';
var __filename = 'NGCore/Shared/Lib/md5.js';

/*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s)
{
  return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input)
{
  var hex_tab = "0123456789abcdef";
  var output = "";
  var x;
  for(var i = 0; i < input.length; i++)
  {
    x = input.charCodeAt(i);
    output += hex_tab.charAt((x >>> 4) & 0x0F)
           +  hex_tab.charAt( x        & 0x0F);
  }
  return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input)
{
  var output = "";
  var i = -1;
  var x, y;

  while(++i < input.length)
  {
    /* Decode utf-16 surrogate pairs */
    x = input.charCodeAt(i);
    y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
    if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF)
    {
      x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
      i++;
    }

    /* Encode output as utf-8 */
    if(x <= 0x7F)
      output += String.fromCharCode(x);
    else if(x <= 0x7FF)
      output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0xFFFF)
      output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0x1FFFFF)
      output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                    0x80 | ((x >>> 12) & 0x3F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
  }
  return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input)
{
  var output = Array(input.length >> 2);
  for(var i = 0; i < output.length; i++)
    output[i] = 0;
  for(i = 0; i < input.length * 8; i += 8)
    output[i>>5] |= (input.charCodeAt(i / 8) & 0xFF) << (i%32);
  return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input)
{
  var output = "";
  for(var i = 0; i < input.length * 32; i += 8)
    output += String.fromCharCode((input[i>>5] >>> (i % 32)) & 0xFF);
  return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/**
 * Find the MD5 hash of a string.
 * @name toMD5
 * @function
 * @memberOf Core
 * @example
 * var md5 = Core.toMD5("Test string");  // returns 0fd3dbec9730101bff92acc820befc34
 * @param {String} s The string that will be hashed.
 * @returns {String} An MD5 hash of the string.
 */
var toMD5 = function(s) { return rstr2hex(rstr_md5(str2rstr_utf8(s))); };

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return toMD5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

exports.toMD5 = toMD5;
exports.testMD5 = md5_vm_test;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/toMD5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/toMD5.js';

exports.toMD5 = require('NGCore/Shared/Lib/md5').toMD5;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] = exports; 
var __dirname = 'NGCore/Shared/Lib';
var __filename = 'NGCore/Shared/Lib/sha1.js';

/**
 * @class The <code>Core.SHA1</code> class provides a JavaScript implementation of the Secure Hash
 * Algorithm (SHA-1), as defined in
 * <a href="http://www.itl.nist.gov/fipspubs/fip180-1.htm">FIPS PUB 180-1</a>.
 * @name Core.SHA1
 */

/*
	Version 2.1a Copyright Paul Johnston 2000 - 2002.
	Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet.
	Distributed under the BSD License.
	See http://pajhome.org.uk/crypt/md5 for details.
*/

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
  if(t < 20) { return (b & c) | ((~b) & d); }
  if(t < 40) { return b ^ c ^ d; }
  if(t < 60) { return (b & c) | (b & d) | (c & d); }
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */

function sha1_kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << (24 - len % 32);
  x[((len + 64 >> 9) << 4) + 15] = len;

  var w = Array(80);
  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) { w[j] = x[i + j]; }
      else {
		w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	  }
      var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                       safe_add(safe_add(e, w[j]), sha1_kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
    e = safe_add(e, olde);
  }
  return Array(a, b, c, d, e);

}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
  var bin = [];
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz) {
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
  }
  return bin;
}

function core_hmac_sha1(key, data)
{
  var bkey = str2binb(key);
  if(bkey.length > 16) {
	bkey = core_sha1(bkey, key.length * chrsz);
  }

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
  return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz) {
    str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16) |
                  (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 ) |
                   ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32){
		str += b64pad;
	  } else {
		str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	  }
    }
  }
  return str;
}

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */

/**
 * Encode a string in hexidecimal SHA-1 format.
 * @memberOf Core.SHA1
 * @example
 * var str = "Test string";
 * var hexSHA1 = Core.SHA1.hex_sha1(str);  // returns 18af819125b70879d36378431c4e8d9bfa6a2599
 * @param {String} s The string to encode.
 * @returns {String} A hexidecimal SHA-1 encoded version of the string.
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}

/**
 * Encode a string in Base64 SHA-1 format.
 * @memberOf Core.SHA1
 * @example
 * var str = "Test string";
 * var base64SHA1 = Core.SHA1.b64_sha1(str);  // returns GK+BkSW3CHnTY3hDHE6Nm/pqJZk
 * @param {String} s The string to encode.
 * @returns {String} A Base64 SHA-1 encoded version of the string.
 */
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}

function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}

function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}

function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}

/**
 * Encode a string in Base64 SHA-1 format using a specified key.
 * @memberOf Core.SHA1
 * @example
 * var key = "testkey";
 * var str = "Test string";
 * var pad = "=";
 * var base64SHA1 = Core.SHA1.b64_hmac_sha1(key, str, pad);  // returns d/KEmi5KvmH91Pv8eu3UPcTSXBw=
 * @param {String} key The key to use when encoding the string.
 * @param {String} data The string to encode.
 * @param {String} [padChar] A single character that is used to pad the encoded string. Use
 *                           <code>=</code> to comply with
 *                           <a href="http://tools.ietf.org/html/rfc4648">RFC 4648</a>, which
 *                           specifies the Base64 format. By default, the encoded string is not
 *                           padded.
 * @returns {String} A Base64 SHA-1 encoded version of the string. If a value is passed in the
 *                   <code>padChar</code> parameter, it is used to pad the end of the string.
 */
function b64_hmac_sha1(key, data, padChar){
	if ((typeof padChar != "undefined") && padChar) {
        b64pad = padChar;
	}
	return binb2b64(core_hmac_sha1(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
  return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.b64_hmac_sha1 = b64_hmac_sha1;
	exports.hex_sha1 = hex_sha1;
	exports.b64_sha1 = b64_sha1;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/SHA1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/SHA1.js';

var sha1 = require('NGCore/Shared/Lib/sha1');

exports.SHA1 = {
	b64_hmac_sha1: sha1.b64_hmac_sha1,
	hex_sha1: sha1.hex_sha1,
	b64_sha1: sha1.b64_sha1
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/UpdateEmitter.js';

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Time = require('NGCore/Client/Core/Time').Time;

exports.UpdateEmitter = MessageEmitter.singleton(
/** @lends Core.UpdateEmitter.prototype */
{
	classname: 'UpdateEmitter',
		
	/**
	 * @class The <code>UpdateEmitter</code> class constructs a singleton object that emits every
	 * frame and sends its listeners the delta, in milliseconds, since the last frame.<br /><br />
	 * <b>Note:</b> <code>{@link Core.UpdateEmitter#setTickRate}</code> is also used to define the framerate of any animation reproduced by a sprite 
	 * (see <code>{@link GL2.Sprite#setAnimation}</code>).<br /><br />
	 * <strong>Note<strong>: If your app uses the <code>{@link UI.WebView}</code> class to display a
	 * web-based game, avoid adding listeners to <code>UpdateEmitter</code> when possible. Attaching
	 * a listener to <code>UpdateEmitter</code> can limit the performance of web-based games.
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this.__clubObject = new NgEngineEntity();
		this.__clubObject.mIsUpdatable = true;
		this.__clubObject.onUpdate = this._emitTime.bind(this);
		this.__clubObject.register();
		
		this._createSendGen(this.__objectRegistryId);
		
		if (!Core.Capabilities.meetsBinaryVersion("1.8")) {
			this._setListenerCountSendGen = function() {};
		}
		this._setListenerCountSendGen(0);
	},
	
	_emitTime: function()
	{
		this.emit(Time.getFrameDelta());
	},
	/**
	 * Set the number of seconds between updates from this <code>UpdateEmitter</code>.<br /><br />
	 * <b>Note</b>: The new value will take effect after the current update completes. The actual
	 * tick rate will be less than or equal to the requested tick rate.
	 * @example
	 * // Send updates every 0.1 seconds, or 100 milliseconds, to any MessageListener objects
	 * // that are listening to this UpdateEmitter
	 * Core.UpdateEmitter.setTickRate(0.1);
	 * @param {Number} r The number of seconds between updates from this <code>UpdateEmitter</code>.
	 * @see GL2.Sprite
	 * @returns {void}
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	setTickRate: function( r ) 
	{
		this._setTickRateSendGen(r);
	},
	
	addListener: function($super, listener, func, priority) {
		$super(listener, func, priority);
		this._setListenerCountSendGen(this.getListenerCount());
	},
	
	removeListener: function($super, listener) {
		$super(listener);
		this._setListenerCountSendGen(this.getListenerCount());
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 304,
	// Method create = -1
	// Method setTickRate = 2
	// Method setListenerCount = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[304] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x130ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_setTickRateSendGen: function( rate )
	{
		Proc.appendToCommandString( 0x1300002, this, [ +rate ] );
	},
	
	/** @private */
	_setListenerCountSendGen: function( count )
	{
		Proc.appendToCommandString( 0x1300003, this, [ +count ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setTickRate: function( rate ) {}
	
	// setListenerCount: function( count ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sprintf'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] = exports; 
var __dirname = 'NGCore/Shared/Lib';
var __filename = 'NGCore/Shared/Lib/sprintf.js';

/**
sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2007.04.03 - 0.1:
 - initial release
2007.09.11 - 0.2:
 - feature: added argument swapping
2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
2007.10.21 - 0.4:
 - unit test and patch (David Baird)
2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license
2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.
**/



exports.sprintf = function() {
	var str_repeat = function(i, m) {
		for (var o = []; m > 0; o[--m] = i) {}
		return o.join('');
	};

	var params = [];
	var outputArray = false;
	var paramsConsumed = 1;
        var i;
	if (typeof(arguments[0]) == 'object' && arguments[0].length) {
		outputArray = true;
		for (i = 0; i < arguments[0].length; ++i) {
			params[i] = arguments[0][i];
		}
	} else {
		for (i = 0; i < arguments.length; ++i) {
			params[i] = arguments[i];
		}
	}
        i=0;
	var a, f = params[i++], o = [], m, p, c, x, s = '';
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) {
			o.push(m[0]);
		}
		else if (m = /^\x25{2}/.exec(f)) {
			o.push('%');
		}
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = params[m[1] || i++]) === null) || (a === undefined)) {
				throw('Too few arguments.');
			}
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number')) {
				throw('Expecting number but found ' + typeof(a));
			}
			switch (m[7]) {
				case 'b': a = a.toString(2); break;
				case 'c': a = String.fromCharCode(a); break;
				case 'd': a = parseInt(a, 10); break;
				case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
				case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
				case 'o': a = a.toString(8); break;
				case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
				case 'u': a = Math.abs(a); break;
				case 'x': a = a.toString(16); break;
				case 'X': a = a.toString(16).toUpperCase(); break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+'+ a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length - s.length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(s + (m[4] ? a + p : p + a));
			if (outputArray) ++paramsConsumed;
		}
		else {
			throw('Huh ?!');
		}
		f = f.substring(m[0].length);
	}
	if (outputArray && paramsConsumed > 0) {
		arguments[0].splice(0, paramsConsumed);
	}
	return o.join('');
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Logger'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Logger'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Logger'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Logger.js';

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var sprintf = require('NGCore/Shared/Lib/sprintf').sprintf;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

var Logger = Class.singleton(
/** @lends Core.Logger.prototype */
{
	classname: 'Logger',

	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
        timingLog = function(message, argv) {};
	},

	/** @private */
	_disable: function()
	{
		console.log("Logger : javascript logging disabled");
        console.log = Logger.log = function(message, argv) {};
        timingLog = function(message, argv) {};
	},

	_enable: function(timingOnly)
	{

        timingLog = function(message, argv)
        {
	    var i;
            if (arguments.length > 1) {
                try {
                    var params = [];
                    for (i = 0; i < arguments.length; ++i) {
                        params[i] = arguments[i];
                    }
                    var result = sprintf(params);
                    params.unshift(result);
                    message = params.join(" ");
                } catch (err) {
                    var concat = [];
                    for (i = 0; i < arguments.length; ++i) {
                        concat[i] = arguments[i];
                    }
                    message = concat.join(" ");
                }
            }
            __underscore_SysLog(message);
        };

        if (timingOnly) {
            return;
        }

        console.log = Logger.log = function(message, argv)
        {
            if (arguments.length > 1) {
		var i;
                try {
                    var params = [];
                    for (i = 0; i < arguments.length; ++i) {
                        params[i] = arguments[i];
                    }
                    var result = sprintf(params);
                    params.unshift(result);
                    message = params.join(" ");
                } catch (err) {
                    var concat = [];
                    for (i = 0; i < arguments.length; ++i) {
                        concat[i] = arguments[i];
                    }
                    message = concat.join(" ");
                }
            }
            __underscore_SysLog(message);
        };
        console.log("Logger : javascript logging enabled");
	},

	/**
	 * Log a message to the development console.
	 * @param {string} message
	 * @param {Array} argv Additional arguments to log.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	log: function(message, argv)
	{
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 305,
	// Method create = -1
	// Method log = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[305] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x131ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_logSendGen: function( msg )
	{
		Proc.appendToCommandString( 0x1310002, this, [ Proc.encodeString( msg ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// log: function( msg ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});

Logger.instantiate();

__underscore_SysLog = function(_massage)
{
	Logger._logSendGen( _massage );
};

// JMarr Don't override console.log when on flash.
if(typeof(_NG_TARGET_FLASH) == 'undefined')
	console.log = Logger.log;

exports.Logger = Logger;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/OrientationEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class OrientationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.OrientationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.OrientationEmitter.prototype */
{
	classname: 'OrientationEmitter',
		
	/**
	 * @class <code>OrientationEmitter</code> constructs a singleton object that tracks the physical
	 * orientation of the device, as well as the orientation of the device's interface. When the
	 * physical or interface orientation changes, the listener receives an object that has the
	 * following properties:
	 * <ul>
	 *		<li><code>orientation</code>: The new orientation. Corresponds to an enumerated value of
	 *		<code>{@link Device.OrientationEmitter#Orientation}</code>.</li>
	 *		<li><code>type</code>: Indicates whether the physical or interface orientation changed.
	 *		Corresponds to an enumerated value of
	 *		<code>{@link Device.OrientationEmitter#OrientationType}</code>.</li>
	 * </ul>
	 * Rotating the device does not automatically rotate the interface presented to the user.
	 * Applications must explicitly call
	 * <code>{@link Device.OrientationEmitter#setInterfaceOrientation}</code> to rotate the
	 * interface. This allows an application to selectively choose which device orientations will
	 * result in a change to the interface orientation.<br /><br />
	 * @constructs The default constructor.
	 * @singleton
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastDeviceOrientation    = this.Orientation.Portrait;
		this._lastInterfaceOrientation = this.Orientation.Portrait;
	},
	
	/**
	 * Retrieve the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current device orienation.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getDeviceOrientation: function()
	{
		return this._lastDeviceOrientation;
	},
	
	/**
	 * Retrieve the interface orientation. Initially, this is the same as the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current interface orientation.
	 * @see Device.OrientationEmitter#setInterfaceOrientation
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getInterfaceOrientation: function()
	{
		return this._lastInterfaceOrientation;
	},
	
	/**
	 * Set the interface orientation. The <code>LandscapeRight</code> and <code>PortraitUpsideDown</code>
	 * orientations are supported on iOS and on Android 2.3 and later.
	 * @example
	 * Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.Portrait);
	 * @param {Device.OrientationEmitter#Orientation} orientation The new device orientation.
	 * @param {Boolean} [animated] Set to <code>true</code> to render the orientation change with an animated effect.
	 * @returns {void}
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @see Device.OrientationEmitter#isInterfaceOrientation
	 * @status iOS, Test
	 * @since 1.0
	 */
	setInterfaceOrientation: function(orientation, animated)
	{
		if( !this.isInterfaceOrientation( orientation ) )
		{
			NgLogE("Unknown orientation specified: " + orientation);
			return;
		}

		if (orientation != this._lastInterfaceOrientation)
		{
			NgLogD("setInterfaceOrientation to " + orientation);
			this._setInterfaceOrientationSendGen(orientation,animated);
			this._lastInterfaceOrientation = orientation;
		}
	},
	
	/**
	 * Check whether a specified orientation can be used as a parameter to
	 * <code>{@link Device.OrientationEmitter#setInterfaceOrientation}</code>.
	 * @param {Device.OrientationEmitter#Orientation} orientation The orientation to check.
	 * @returns {Boolean} Set to <code>true</code> if the specified orientation can be used to set
	 *		the interface orientation.
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @since 1.6
	 */
	isInterfaceOrientation: function(orientation)
	{
		return orientation == this.Orientation.Portrait
			|| orientation == this.Orientation.PortraitUpsideDown
			|| orientation == this.Orientation.LandscapeLeft
			|| orientation == this.Orientation.LandscapeRight;
	},
	
	/**
	 * Enumeration for device orientation.
	 * @fieldOf Device.OrientationEmitter#
	 */
	Orientation:
	{ 
		/** 
		* Portrait orientation. 
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		Portrait: 0,
		/** 
		* Portrait orientation, but rotated 180 degrees. Used only on iOS and on Android 2.3 and later.
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		PortraitUpsideDown: 1,
		/** 
		* Landscape orientation with the top of the device to the left. 
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		LandscapeLeft: 2,
		/** 
		* Landscape orientation with the top of the device to the right. Used only on iOS and on Android 2.3 and later.
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		LandscapeRight: 3,
		/** 
		* Oriented with the face of the device up. Used only on iOS.
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		FaceUp: 4,
		/** 
		* Oriented with the face of the device down. Used only on iOS.
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		FaceDown: 5
	},

	/**
	 * Enumeration for the type of orientation change that occurred.
	 * @fieldOf Device.OrientationEmitter#
	 */
	OrientationType:
	{
		/**
		* Device orientation has changed.
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		Device: 0,
		/**
		* Interface orientation has changed.
		* @fieldOf Device.OrientationEmitter#
		* @constant
		*/
		Interface: 1
	},

	_orientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._orientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastDeviceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Device, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._orientationChangedSendGen(msg.orientation);
	},
	
	_interfaceOrientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._interfaceOrientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastInterfaceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Interface, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._interfaceOrientationChangedSendGen(msg.orientation);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 335,
	// Method create = -1
	// Method orientationChanged = 2
	// Method setInterfaceOrientation = 3
	// Method interfaceOrientationChanged = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._orientationChangedRecv( cmd );
					break;
				case 4:
					instance._interfaceOrientationChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[335] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_orientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_interfaceOrientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x14fffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_orientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( 0x14f0002, this, [ +orientation ] );
	},
	
	/** @private */
	_setInterfaceOrientationSendGen: function( orientation, animated )
	{
		Core.Proc.appendToCommandString( 0x14f0003, this, [ +orientation, ( animated ? 1 : 0 ) ] );
	},
	
	/** @private */
	_interfaceOrientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( 0x14f0004, this, [ +orientation ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _orientationChangedRecv: function( cmd ) {}
	// orientationChanged: function( orientation ) {}
	
	// setInterfaceOrientation: function( orientation, animated ) {}
	
	// _interfaceOrientationChangedRecv: function( cmd ) {}
	// interfaceOrientationChanged: function( orientation ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/Storage';
var __filename = 'NGCore/Client/Storage/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// Storage diagnostic emitter; collects info from Storage subsystem.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////
    
//
// Create and export a DiagnosticEmitter for Storage.
//

exports.Diagnostics = Core.DiagnosticEmitter.singleton(
{
    classname: 'Storage_Diagnostics',

	/**
	 * @class The `Storage.Diagnostics` class provides detailed diagnostic information about classes
	 * in the `Storage` module. You can use this information to debug your app's use of the
	 * `Storage` module and learn more about the app's performance.
	 *
	 * The emitter emits an object of the form:
	 *
	 *     {
	 *         name: "Storage",                         // The emitter's name
	 *         getItem: {
	 *             count: {Number}                      // The number of calls to Storage.KeyValue.getItem()
	 *         },
	 *         setItem: {
	 *             count: {Number}                      // The number of calls to Storage.KeyValue.setItem()
	 *         },
	 *         removeItem: {
	 *             count: {Number}                      // The number of calls to Storage.KeyValue.removeItem()
	 *         },
	 *         readFile: {
	 *             count: {Number}                      // The number of calls to read a file
	 *         },
	 *         writeFile: {
	 *             count: {Number}                      // The number of calls to write a file
	 *         },
	 *         deleteFile: {
	 *             count: {Number}                      // The number of calls to delete a file
	 *         },
	 *         renameFile: {
	 *             count: {Number}                      // The number of calls to rename a file
	 *         },
	 *         decompressFile: {
	 *             count: {Number}                      // The number of calls to decompress a file
	 *         },
	 *         readFile: {
	 *             count: {Number}                      // The number of calls to read a file
	 *         },
	 *         stat: {
	 *             count: {Number}                      // The number of calls to get information about a file
	 *         },
	 *         KeyValue: {                              // Detailed information for Storage.KeyValue
	 *             bytesSetItem: {KeyValueBytes},       // Amount of data written through setItem()
	 *             bytesGetItem: {KeyValueBytes}        // Amount of data read through getItem()
	 *         },
	 *         FileSystem: {                            // Detailed information for Storage.FileSystem
	 *             bytesRead: {FileSystemBytes},        // Number of bytes read from file system
	 *             bytesWritten: {FileSystemBytes}      // Number of bytes written to file system
	 *         }
	 *     }
	 *
	 * The `KeyValueBytes` type is an object of the form:
	 *
	 *     {
	 *         perSecondGlobal: {Number},   // Transfer rate, in bytes per second, for the global store
	 *         perSecondLocal: {Number},    // Transfer rate, in bytes per second, for the local store
	 *         accumGlobal: {Number},       // Total bytes transferred for the global store
	 *         accumLocal: {Number}         // Total bytes transferred for the local store
	 *     }
	 *
	 * The `FileSystemBytes` type is an object of the form:
	 *
	 *     {
	 *         perSecondLocal: {Number},    // Transfer rate, in bytes per second, for the
	 *                                      // persistent file store
	 *         perSecondTemp: {Number},     // Transfer rate, in bytes per second, for the
	 *                                      // temporary file store
	 *         accumLocal: {Number},        // Total bytes transferred for the persistent file store
	 *         accumTemp: {Number}          // Total bytes transferred for the temporary file store
	 *     }
	 * @name Storage.Diagnostics
	 * @constructs
	 * @augments Core.DiagnosticEmitter
	 * @singleton
	 * @since 1.8
	 */
	
	initialize: function($super)
	{
	$super('Storage');
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/KeyValue'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] = exports; 
var __dirname = 'NGCore/Client/Storage';
var __filename = 'NGCore/Client/Storage/KeyValue.js';

////////////////////////////////////////////////////////////////////////////////
// Class KeyValue
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;
var Diagnostics = require('NGCore/Client/Storage/Diagnostics').Diagnostics;

////////////////////////////////////////////////////////////////////////////////

function KeyValueCache() {

}

exports.KeyValueCache = KeyValueCache;
/** @lends Storage.KeyValueCache.prototype 
*/

/** @private */
KeyValueCache.lruMeanCacheSize = 100;
/** @private */
KeyValueCache.instanceMap = {};
//TODO: rename this later
var StorageGlobalScopes = [];

KeyValueCache.optimizeCaches = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			KeyValueCache.instanceMap[storeKey].optimize();
		}
	}
};

KeyValueCache.lowMemoryWarning = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			var instance = KeyValueCache.instanceMap[storeKey];
			instance.data = {};

			//Purge entries in callbacks
			var newCallbacks = {};
			newCallbacks.uidGenerator = instance.callbacks.uidGenerator;
			for(var cbId in instance.callbacks)
			{
				if(instance.callbacks.hasOwnProperty(cbId)) {
					if(instance.callbacks[cbId]) {
						newCallbacks = instance.callbacks[cbId];
					}
				}
			}
			instance.callbacks = newCallbacks;
		}
	}
};

/**
* @class Provides access to the local key-value data store.
*
* The data you store with `Storage.KeyValueCache` is not tied to a specific Mobage user.
* Access the local `Storage.KeyValueCache` by using {@link Storage.KeyValueCache#local}. 
*
* If you need to store user-specific data, do one of the following:
*
* 1. Verify that your application is storing and retrieving data for the correct Mobage user. 
* Keep in mind that several different Mobage users could all use the same application on the
* same device.
* 2. As an alternative to `Storage.KeyValueCache`, consider using the
* `{@link Social.Common.Appdata}` class, which stores application data that is tied to a specific
* Mobage user.
*
* @name Storage.KeyValueCache
* @singleton
* @constructs
*/
KeyValueCache.init = function()
{
	KeyValueCache.local = new Storage.KeyValue();
	KeyValueCache.local.registerForKey("local");
};

/**
* Returns a `Storage.KeyValue` object for the local data store of the device.
*
* @name local
* @fieldOf Storage.KeyValueCache#
* @example
* var keys = Storage.KeyValueCache.local;
* 
* keys.getItem("nextQuest", {}, function(err, val, name) {
*     if (err) {
*         console.log("An error occurred while retrieving the value of " +
*           name + ": " + err);
*         return;
*     } else {
*         console.log("The value of " + name + " is " + val);
*     }
* });
*
*/

/**
 * @static Scopes this `KeyValueCache` object as global. A globally scoped KeyValueCache object can
 * be used by multiple applications for the same data. 
 * @param {String} globalKey The store key for the `KeyValueCache` object.
 * @ignore
 * @private
 */
KeyValueCache.global = function(globalKey)
{
	if(StorageGlobalScopes[globalKey])
	{
		return StorageGlobalScopes[globalKey];
	}

	//Miss Global Table Cache.
	var scope = new exports.KeyValue();
	scope.registerForKey(globalKey);
	StorageGlobalScopes[globalKey] = scope;
	return scope;
};

exports.KeyValue = Core.Class.subclass(
/** @lends Storage.KeyValue.prototype */
{
	classname: "KeyValue",

  /** @private */
  _options: {
    blocking    : 0x0001  /* legacy blocking(main thread) mode operation for backward compatibility */
  },
	
	/**
	 * @class The `KeyValue` class constructs objects that allow you to manage application key/value
	 * pairs in a datastore.
	 * 
	 * + Use `KeyValueCache.local` to access the `local` datastore for your application.
	 *
	 * The data you store with `Storage.KeyValue` is not tied to a specific Mobage user. If you need
	 * to store user-specific data, do one of the following:
	 *
	 * 1. Verify that your application is storing and retrieving data for the correct Mobage user. 
	 * Keep in mind that several different Mobage users could all use the same application on the
	 * same device.
	 * 2. As an alternative to `Storage.KeyValue`, consider using the
	 * `{@link Social.Common.Appdata}` class, which stores application data that is tied to a specific
	 * Mobage user.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		/** @private */
		this.initialized = false;
		/** @private */
		this.origin = null;
		/** @private */
		this.callbacks = {};
		/** @private */
		this.callbacks.uidGenerator = 0;
		/** @private */
		this.local = false;
		/** @private */
		this.lruCacheShrinkCounter = 0;
	
		/** @private */
		this.data = {};
		/** @private */
		this.usage = {};
		
		this.oldBinary = !Core.Capabilities.meetsBinaryVersion("1.4");

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._getItemCount = 0;
		this._setItemCount = 0;
		this._removeItemCount = 0;

		Diagnostics.pushCollector(this.collectDiagnostics.bind(this));
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @returns {void}
	 * @since 1.0
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
    /*
	 * @private
	 * Call `registerForKey()` to access a datastore identified by the value of the `storeKey`
	 * parameter.
	 * @param {String} storeKey The unique identifier of the datastore.
	 * @returns {this}
     * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */	
	registerForKey: function(storeKey) 
	{
		this.origin = storeKey;
		KeyValueCache.instanceMap[storeKey] = this;

		//Push this instance across the native bridge
		this._registerCommandSendGen(this.origin,KeyValueCache.lruMeanCacheSize);
		
		return this;
	},
	/**
	 * Retrieve the value of a key.
	 * @param {String} key The key that is associated with the value.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to retrieve the value synchronously
	 *		(i.e, the application pauses until the value is retrieved). This option can cause  
	 *		significant delays on some devices and should be used only if your application cannot
	 *		function without synchronous retrieval of a key's value.
	 * @param {Boolean} [options.ignoreCache=false] Set to `true` to retrieve the value from the 
	 *		device's storage, ignoring the cache.
	 * @cb {Function} callbackFunc The function to call after retrieving the value.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String} val The value associated with the key.
	 * @cb-param {String} name The name of the key.
	 * @cb-returns {void}
	 * @example
	 * var keys = new Storage.KeyValue();
	 * keys.getItem("nextQuest", {}, function(err, val, name) {
	 *     if (err) {
	 *         console.log("An error occurred while retrieving the value of " +
	 *           name + ": " + err);
	 *         return;
	 *     } else {
	 *         console.log("The value of " + name + " is " + val);
	 *     }
	 * });
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getItem: function(key, options, callbackFunc) {
		this._getItemCount++;

		if (this.oldBinary && typeof options == 'object') {
			var ignCache = options['ignoreCache'];
			options = callbackFunc;
			callbackFunc = ignCache;
		}
		
    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      if (!this.oldBinary) NgLogW("KeyValue.getItem(): using deprecated function signature");
      var ignoreCache = callbackFunc;
      callbackFunc = options;
      var callbackId;

      if(!ignoreCache)
      {
        if(this.data[key]) {
          callbackFunc(null,this.data[key],key);
          this.usage[key]++;
          return;
        }
        else
        {
          NgLogD("Value not found in cache for..falling back to native");
        }
      }

      //Generate unused callbackEntry
      callbackId = this.callbacks.uidGenerator++;

      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._getItemSendGen(this.origin,callbackId,key);
    }
    else
    {
      if(!options['ignoreCache'])
      {
        if(this.data[key]) {
          callbackFunc(null,this.data[key],key);
          this.usage[key]++;
          return;
        }

        //NgLogD("Value not found in cache for..falling back to native");
      }
      else
      {
        //NgLogD("KeyValue: ignoring cache...");
      }

      var op = 0;
      if(options['blocking'])
        op |= this._options.blocking;

      //Generate unused callbackEntry
      callbackId = this.callbacks.uidGenerator++;

      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._getItemAsyncSendGen(this.origin,callbackId,key,op);
    }
	},

	/**
	 * Deprecated signature to retrieve the value of a key.
	 * @name getItem^2
	 * @function
	 * @memberOf Storage.KeyValue#
	 * @deprecated Since version 1.4.1. Use the signature getItem(key, options, callbackFunc)
	 * rather than this signature.
	 * @example
	 * var keys = new Storage.KeyValue();
	 * keys.getItem("key_name", false, function(err, val, name) {
	 *     // Add callback code.
	 * });
	 * @param {String} key The key that is associated with the value.
	 * @param {Boolean} [ignoreCache=false] Set to `true` to retrieve the value from the device's
	 *		storage, ignoring the cache.
	 * @cb {Function} callbackFunc The function to call after retrieving the value.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String} val The value associated with the key.
	 * @cb-param {String} name The name of the key.
	 * @cb-returns {void}
	 * @returns {void}
	 */

	/**
	 * Associate a value with a key.
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to set the key-value pair 
	 *		synchronously (i.e., the application pauses until the key-value pair is set). This
	 *		option can cause significant delays on some devices and should be used only if your
	 *		application cannot function without synchronous storage of key-value pairs.
	 * @cb {Function} [callbackFunc] The function to call after storing the key-value pair.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String} name The name of the key.
	 * @cb-returns {void}
	 * @example
	 * var keys = new Storage.KeyValue();
	 * keys.setItem("nextQuest", "monster_attack", {}, function(err, name) {
	 *     if (err) {
	 *         console.log("Unable to store key-value pair: " + err);
	 *     } else {
	 *         console.log("Updated the value of the key " + name);
	 *     }
	 * });
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setItem: function(key, value, options, callbackFunc)
	{
		this._setItemCount++;

		if (this.oldBinary && typeof options == 'object') {
			options = callbackFunc;
		}

	        var callbackId;

    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      if (!this.oldBinary) NgLogW("KeyValue.setItem(): using deprecated function signature");
      callbackFunc = options;

      this.data[key] = value;

      callbackId = this.callbacks.uidGenerator++;
      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._setItemSendGen(this.origin,callbackId,key,value);
    }
    else
    {
      var op = 0;
      if(options['blocking'])
        op |= this._options.blocking;

      this.data[key] = value;

      callbackId = this.callbacks.uidGenerator++;
      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._setItemAsyncSendGen(this.origin,callbackId,key,value,op);
    }
	},

	/**
	 * Deprecated signature for associating a value with a key.
	 * @name setItem^2
	 * @function
	 * @memberOf Storage.KeyValue#
	 * @deprecated Since version 1.4.1. Use the signature setItem(key, value, options, callbackFunc)
	 * rather than this signature.
	 * @example
	 * var keys = new Storage.KeyValue();
	 * keys.setItem("key_name", "value", function(err, name) {
	 *     // Add callback code.
	 * });
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @cb {Function} [callbackFunc] The function to call after storing the key-value pair.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String} name The name of the key.
	 * @cb-returns {void}
	 * @returns {void}
	 */
	
	/**
	 * Remove the value that is associated with a key.
	 * @param {String} key The key that is associated with the value to remove.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to remove the key-value pair
	 *		synchronously (i.e., the application pauses until the key-value pair is removed). This 
	 *		option can cause significant delays on some devices and should be used only if your
	 *		application cannot function without synchronous storage of key-value pairs.
	 * @cb {Function} [callbackFunc] The function to call after removing the key's value.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String} name The name of the key that was removed.
	 * @cb-returns {void}
	 * @example
	 * var keys = new Storage.KeyValue();
	 * keys.removeItem("nextQuest", {}, function(err, name) {
	 *     if (err) {
	 *         console.log("Unable to remove a key's value: " + err);
	 *     } else {
	 *         console.log("The key " + name + " was removed.");
	 *     }
	 * });
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	removeItem: function(key, options, callbackFunc)
	{
		this._removeItemCount++;

		if (this.oldBinary && typeof options == 'object') {
			options = callbackFunc;
		}
	    var callbackId;
    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
     if (!this.oldBinary) NgLogW("KeyValue.removeItem(): using deprecated function signature");
      callbackFunc = options;

      callbackId = this.callbacks.uidGenerator++;
      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._removeItemSendGen(this.origin,callbackId,key);
    }
    else
    {
      var op = 0;
      if(options['blocking'])
        op |= this._options.blocking;

      callbackId = this.callbacks.uidGenerator++;
      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._removeItemAsyncSendGen(this.origin,callbackId,key,op);
    }
	},

	/**
	 * Deprecated signature for removing the value that is associated with a key.
	 * @name removeItem^2
	 * @function
	 * @memberOf Storage.KeyValue#
	 * @deprecated Since version 1.4.1. Use the signature removeItem(key, options, callbackFunc)
	 * rather than this signature.
	 * @example
	 * var keys = new Storage.KeyValue();
	 * keys.removeItem("key_name", function(err, name) {
	 *     // Add callback code.
	 * });
	 * @param {String} key The key that is associated with the value to remove.
	 * @cb {Function} [callbackFunc] The function to call after removing the key's value.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String} name The name of the key that was removed.
	 * @cb-returns {void}
	 * @returns {void}
	 */


	/**
	 * @private
	 * Clear all key/value pairs stored within this store
	 * NOTE: Legacy function signature, clear([{Function}cb]) is still supported but deprecated.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to make the operation block the main
	 *		thread (not recommended).
	 * @param {Function} [callbackFunc] The callback function to be called
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	clear: function(options, callbackFunc)
	{
		if (this.oldBinary && typeof options == 'object') {
			options = callbackFunc;
		}
	    var callbackId;
    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      if (!this.oldBinary) NgLogW("KeyValue.clear(): using deprecated function signature");
      callbackFunc = options;

      callbackId = this.callbacks.uidGenerator++;
      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._clearSendGen(this.origin,callbackId);
    }
    else
    {
      var op = 0;
      if(options['blocking'])
        op |= this._options.blocking;

      callbackId = this.callbacks.uidGenerator++;
      if(!!!callbackFunc) {
      	/** @inner */
        callbackFunc = function(){};
      }
      this.callbacks[callbackId] = callbackFunc;

      this._clearAsyncSendGen(this.origin,callbackId,op);
    }
	},
	/**
	 * @ignore
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	enforceLRUCacheSize: function()
	{
		NgLogD("Enforcing KeyValue Cache Size");
		var tmp = [];
		for (var k in this.data) {
			if (this.data.hasOwnProperty(k)) {
				tmp.push(k);
			}
		}
		var usage = this.usage;
		tmp.sort(function(a,b) {
			var p1 = usage[a];
			if (!p1) {
				p1 = 0;
			}

			var p2 = usage[b];
			if (!p2) {
				p2 = 0;
			}

			if (p1 == p2) { return 0; }
			return p1 < p2 ? 1 : -1;
		});

		var oldData = this.data;
		this.data = {};
		//Copy over the lruMeanCache(number) most used entries
		var stopPoint = KeyValueCache.lruMeanCacheSize;
		for (var i = 0; i < stopPoint && i < tmp.length; i++)
		{
			if(!oldData[tmp[i]]) {
				//Case cache didn't contain that key at this point in time
				stopPoint++;
			}
			else {
				this.data[tmp[i]] = oldData[tmp[i]];
			}
		}
	},
	
	_getInstanceRecv : function(cmd)
	{
		var msg = {};
		if(!this._getInstanceRecvGen(cmd, msg))
			return;
			
		var storeKey = msg["storeKey"];

		var instance = KeyValueCache.instanceMap[storeKey];
		//NgLogD("Storage.getInstanceForCommand Found instance for key [" + storeKey + "]: " + instance + " (" + command + ")");
		return instance;
	},
	
	_registerCommandCbRecv : function(cmd)
	{		
		var msg = {};
		if(!this._registerCommandCbRecvGen(cmd, msg))
			return;
		
		//NgLogD("Storage registerCallback: "+command+"\n");
		if(msg["error"]){
			console.log("Storage: Error registering for KeyValue location '"+msg["error"]+"'");
			if(!this.initialized) {
				delete StorageGlobalScopes[msg["originalStoreKey"]];
			}
			return;
		}

		if(this.origin == "local") {
			this.local = true;
			StorageGlobalScopes[this.origin] = this;
		}

		this.origin = msg["storeKey"];
		this.initialized = true;
		
		for(var i=0; i < msg.preloadDataCount; ++i)
		{
			var preload = {};
			if(!this._preloadDataRecvGen(cmd, preload))
				return;
			
			this.data[preload.key] = preload.value;
		}
	},
	
	_getItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._getItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		var value = msg["value"];
		if (error) {
			value = null;
		}

		this.data[key] = value;
		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}

		var cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,value,key);
			this.callbacks[cbId] = null;
		}

		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
		return this;
	},
	
	_setItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._setItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];

		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}
		
		//NgLogD("Storage.setItemCommand Found instance for key [" + key + "]: " + " (" + cbId + ")");

		var cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			//NgLogD("Storage.setItemCommand Found callback");
			cb(error,key);
			this.callbacks[cbId] = null;
		}
		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
	},
	
	_removeItemCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._removeItemCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		delete this.usage[key];
		delete this.data[key];

		var cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,key);
			this.callbacks[cbId] = null;
		}
	},
	
	_clearCommandCbRecv : function(cmd)
	{
		var msg ={};
		if(!this._clearCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];

		this.data = {};
		this.usage = {};

		var cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,this.origin);
			this.callbacks[cbId] = null;
		}

	},
	
	/**
	 * Enumeration for response types.
	 * @name Responses
	 * @fieldOf Storage.KeyValue#
	 * @ignore
	 */
	
	/**
	 * Register storage.
	 * @name Responses.Register
	 * @fieldOf Storage.KeyValue#
	 * @constant
	 * @ignore
	 */
	
	/**
	 * Get item.
	 * @name Responses.GetItem
	 * @fieldOf Storage.KeyValue#
	 * @constant
	 * @ignore
	 */
	
	/**
	 * Set item.
	 * @name Responses.SetItem
	 * @fieldOf Storage.KeyValue#
	 * @constant
	 * @ignore
	 */
	
	/**
	 * Remove item.
	 * @name Responses.RemoveItem
	 * @fieldOf Storage.KeyValue#
	 * @constant
	 * @ignore
	 */
	
	/**
	 * Clear all items.
	 * @name Responses.Clear
	 * @fieldOf Storage.KeyValue#
	 * @constant
	 * @ignore
	 */
	
// {{?Wg Generated Code}}
	
	// Enums.
	Responses:
	{ 
		Register: 0,
		GetItem: 1,
		SetItem: 2,
		RemoveItem: 3,
		Clear: 4
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 339,
	// Method create = -1
	// Method destroy = 2
	// Method registerCommand = 3
	// Method getItem = 4
	// Method setItem = 5
	// Method removeItem = 6
	// Method clear = 7
	// Method getInstance = 8
	// Method registerCommandCb = 9
	// Method preloadData = 10
	// Method getItemCommandCb = 11
	// Method setItemCommandCb = 12
	// Method removeItemCb = 13
	// Method clearCommandCb = 14
	// Method getItemAsync = 15
	// Method setItemAsync = 16
	// Method removeItemAsync = 17
	// Method clearAsync = 18
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._getInstanceRecv( cmd );
					break;
				case 9:
					instance._registerCommandCbRecv( cmd );
					break;
				case 10:
					instance._preloadDataRecv( cmd );
					break;
				case 11:
					instance._getItemCommandCbRecv( cmd );
					break;
				case 12:
					instance._setItemCommandCbRecv( cmd );
					break;
				case 13:
					instance._removeItemCbRecv( cmd );
					break;
				case 14:
					instance._clearCommandCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[339] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getInstanceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "originalStoreKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "originalStoreKey" ] === undefined )
		{
			NgLogE("Could not parse originalStoreKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "preloadDataCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "preloadDataCount" ] === undefined )
		{
			NgLogE("Could not parse preloadDataCount in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_preloadDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_getItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_removeItemCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_clearCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 4 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x153ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1530002, this );
	},
	
	/** @private */
	_registerCommandSendGen: function( storeKey, lruMeanCacheSize )
	{
		Core.Proc.appendToCommandString( 0x1530003, this, [ Core.Proc.encodeString( storeKey ), +lruMeanCacheSize ] );
	},
	
	/** @private */
	_getItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( 0x1530004, this, [ Core.Proc.encodeString( storeKey ), +callbackId, Core.Proc.encodeString( key ) ] );
	},
	
	/** @private */
	_setItemSendGen: function( storeKey, callbackId, key, value )
	{
		Core.Proc.appendToCommandString( 0x1530005, this, [ Core.Proc.encodeString( storeKey ), +callbackId, Core.Proc.encodeString( key ), Core.Proc.encodeString( value ) ] );
	},
	
	/** @private */
	_removeItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( 0x1530006, this, [ Core.Proc.encodeString( storeKey ), +callbackId, Core.Proc.encodeString( key ) ] );
	},
	
	/** @private */
	_clearSendGen: function( storeKey, callbackId )
	{
		Core.Proc.appendToCommandString( 0x1530007, this, [ Core.Proc.encodeString( storeKey ), +callbackId ] );
	},
	
	/** @private */
	_getItemAsyncSendGen: function( storeKey, callbackId, key, options )
	{
		Core.Proc.appendToCommandString( 0x153000f, this, [ Core.Proc.encodeString( storeKey ), +callbackId, Core.Proc.encodeString( key ), +options ] );
	},
	
	/** @private */
	_setItemAsyncSendGen: function( storeKey, callbackId, key, value, options )
	{
		Core.Proc.appendToCommandString( 0x1530010, this, [ Core.Proc.encodeString( storeKey ), +callbackId, Core.Proc.encodeString( key ), Core.Proc.encodeString( value ), +options ] );
	},
	
	/** @private */
	_removeItemAsyncSendGen: function( storeKey, callbackId, key, options )
	{
		Core.Proc.appendToCommandString( 0x1530011, this, [ Core.Proc.encodeString( storeKey ), +callbackId, Core.Proc.encodeString( key ), +options ] );
	},
	
	/** @private */
	_clearAsyncSendGen: function( storeKey, callbackId, options )
	{
		Core.Proc.appendToCommandString( 0x1530012, this, [ Core.Proc.encodeString( storeKey ), +callbackId, +options ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// registerCommand: function( storeKey, lruMeanCacheSize ) {}
	
	// getItem: function( storeKey, callbackId, key ) {}
	
	// setItem: function( storeKey, callbackId, key, value ) {}
	
	// removeItem: function( storeKey, callbackId, key ) {}
	
	// clear: function( storeKey, callbackId ) {}
	
	// _getInstanceRecv: function( cmd ) {}
	// _registerCommandCbRecv: function( cmd ) {}
	// _preloadDataRecv: function( cmd ) {}
	// _getItemCommandCbRecv: function( cmd ) {}
	// _setItemCommandCbRecv: function( cmd ) {}
	// _removeItemCbRecv: function( cmd ) {}
	// _clearCommandCbRecv: function( cmd ) {}
	// getItemAsync: function( storeKey, callbackId, key, options ) {}
	
	// setItemAsync: function( storeKey, callbackId, key, value, options ) {}
	
	// removeItemAsync: function( storeKey, callbackId, key, options ) {}
	
	// clearAsync: function( storeKey, callbackId, options ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,

//Diagnostics collector
	collectDiagnostics: function(type, interval)
	{
		var collectedInfo = {
			getItem: {
				count: this._getItemCount
			},
			setItem: {
				count: this._setItemCount
			},
			removeItem: {
				count: this._removeItemCount
			}
         };

		 return collectedInfo;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_int_LGL'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/_int_LGL.js';

////////////////////////////////////////////////////////////////////////////////
// Class _int_LGL
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////
function getCorrectedPlatformOS() {
	var os = Capabilities.getPlatformOS();
	switch (os) {
		case 'Android': return 'android';
		case 'iPhone OS': return 'ios';
	}
	return os;
}

function expandTexName(name)
{
	var list =
	{
		"pvr": "GL_IMG_texture_compression_pvrtc",
		"atc": "GL_AMD_compressed_ATC_texture",
		"etc1": "GL_OES_compressed_ETC1_RGB8_texture",
		"3dc": "GL_AMD_compressed_3DC_texture"
	};

	return list[name] || name;
}

var overridePropertyEvaluators = {
	isMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		}
		// Consume any characters we detected, then set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		if (condition == value) {
			return (symbol == '=' || symbol == '<=' || symbol == '>=');
		} else if (condition < value) {
			return (symbol == '<' || symbol == '<=');
		} else {
			return (symbol == '>' || symbol == '>=');
		}
	},

	isVersionMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		if (condition.length > 0) switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		case '=':
			symbol = (condition.charAt(1) == '=') ? '==' : '=';
			break;
		}
		// Consume any characters we detected, or set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		var con = condition.split('.');
		var val = value.split('.');

		var l = Math.max(con.length, val.length);

		for (var i = 0; i < l; i++) {
			var ci = '0.' + (con[i] || 0);
			var vi = '0.' + (val[i] || 0);
			if (ci == vi) continue;
			if (ci < vi) {
				return (symbol == '<' || symbol == '<=');
			} else {
				return (symbol == '>' || symbol == '>=');
			}
		}
		return true;
	},

	'sdkVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getSDKVersion());
	},

	'binaryVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getBinaryVersion());
	},

	'platformOS': function(v) {
		return v == getCorrectedPlatformOS();
	},

	'platformOSVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getPlatformOSVersion());
	},

	'platformHW': function(v) {
		return v == Capabilities.getPlatformHW();
	},

	'physicalMem': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalMem());
	},

	'physicalCpus': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalCpus());
	},

	'activeCpus': function(v) {
		return this.isMatch(v, Capabilities.getActiveCpus());
	},

	'language': function(v) {
		return v == Capabilities.getLanguage();
	},

	'textureMatch': "none",
	'textureCompression': function(v) {
		var matched = Capabilities.getOglExtensions().indexOf(expandTexName(v)) > -1;
		if (matched) this.textureMatch = v;
		return matched;
	},

	'screenWidth': function(v) {
		return this.isMatch(v, Capabilities.getScreenWidth());
	},

	'screenHeight': function(v) {
		return this.isMatch(v, Capabilities.getScreenHeight());
	},

	'screenResolution': function(v) {
		return v == (Capabilities.getScreenWidth() + 'x' + Capabilities.getScreenHeight());
	},

	'screenUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenUnits());
	},

	'screenPixelUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenPixelUnits());
	},

	'maxTextureSize': function(v) {
		return this.isMatch(v, Capabilities.getMaxTextureSize());
	},
	
	'reset': function(v) {
		this.textureMatch = "none";
	}
};

var _int_LGL = Class.singleton(
/** @lends Core._int_LGL.prototype */
{
	classname: '_int_LGL',

	initialize: function()
	{
		this._loadCallbacks = {};
	},

	launch: function(url, proc)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		// Default to game proc. Games should actually not be aware of the third option,
		//	as they cannot use it anyway.
		if (!proc)
			proc = _int_LGL.ProcID.Game;

		url = Util.NormalizeUrl(url);

		var run = (function()
		{
			gNgShutdownPending = true;
			this._launchSendGen(url,proc);
		}).bind(this);

		if (proc == _int_LGL.ProcID.Game)
		{
			this.updateGameUse(url, run);
		}
		else
		{
			run();
		}
	},

	loadGame: function(url, callback)
	{
		var Util = require('NGCore/Client/Network/Util').Util;

		url = Util.NormalizeUrl(url);

		this._loadCallbacks[url] = callback;
		this._loadGameSendGen(url);
	},

	_gameLoadedRecv: function( cmd ) {
		var msg = {};
		this._gameLoadedRecvGen(cmd, msg);

		var url = msg.url;

		if(this._loadCallbacks[url])
		{
			var cb = this._loadCallbacks[url];
			delete this._loadCallbacks[url];
			cb();
		}
	},

	launchLoadedGame: function()
	{
		this._launchLoadedGameSendGen();
	},
	
	updateAvailable: function(game, doneCB, errorCB)
	{
		// Normalize URL
		var url = game;
		if (! url.match(/^\//) && !url.match(/https?:\/\//))
			url = '/' + url;

		var caps = require("NGCore/Client/Core/Capabilities").Capabilities;

		// If we are testing ourselves, we don't to md5 our url
		var name = "";
		if (caps.getUrl() != game)
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			url = Util.NormalizeUrl(url);
			name = Util.GetMD5HashDirectoryFromUrl(url);
		}

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var build = "/" + buildPath[caps.getPlatformOS()];

		var DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		var dm = new DownloadManifest();

		dm.isUpdated(url + build, name, false, doneCB, errorCB);
	},

// Utility (non-generated) functionality
	updateGameUse: function(game, doneCB)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var url = Util.NormalizeUrl(game);
		var name = Util.GetMD5HashDirectoryFromUrl(url);
		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";

		// Get our list of games
		this.mGameStore.getItem(this.mActiveGameKey, {},
			function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				var item;
				for (var i in list)
				{
					if (list[i].name == name)
					{
						item = list[i];
						break;
					}
				}

				if (!item)
				{
					item = {"name": name};
					list.push(item);
				}

				item.lastRun = (new Date()).getTime();
				item.url = game;

				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list), {});

                LocalGameList.updateGameList(list);
 				doneCB();
			}, true
		);
	},
	
	getManifestName: function(config) {
		var manifestName = 'webgame.ngmanifest';

		if (config && config.manifestOverrides) {
			try {
				var overrides = config.manifestOverrides;

				for (var i = 0; i < overrides.length; i++) {
					var override = overrides[i];
					if (override && override.criteria) {
						// Clear any matched values...
						overridePropertyEvaluators.reset();

						var criteria = override.criteria;
						var key, overrideMatched = true;
						for (key in criteria) {
							if (!criteria.hasOwnProperty(key)) continue;
							var value = criteria[key];

							var evaluator = overridePropertyEvaluators[key];
							if (typeof evaluator != 'function') {
								console.log("ERROR! Undefined criterion " + key + " in configuration.json");
								overrideMatched = false;
								break;
							}

							var criterionMatched = false;
							if (value instanceof Array) {
								for (var vi = 0; vi < value.length; vi++) {
									criterionMatched |= evaluator.call(overridePropertyEvaluators, value[vi]);
									if (criterionMatched) break;
								}
							} else {
								criterionMatched = evaluator(value);
							}

							if (!criterionMatched) {
								overrideMatched = false;
								break;
							}
						}

						// At this point, the override has matched. Figure out its name and return the value.
						if (overrideMatched) {
							console.log("MATCHED Override: " + JSON.stringify(override));

							// Format the override manifest name:
							var format = override.manifest.slice(0);
							for (var fi = 1; fi < format.length; fi++) {
								key = format[fi];
								switch (key) {
								case 'textureCompression':
									format[fi] = overridePropertyEvaluators.textureMatch;
									break;
								case 'platformOS':
									format[fi] = getCorrectedPlatformOS();
									break;
								default:
									// Look up the named property on Capabilities.
									var cap = Capabilities['get' + key.charAt(0).toUpperCase() + key.slice(1)]();
									format[fi] = cap.replace(' ', '_');
								}
							}

							return require('NGCore/Shared/Lib/sprintf').sprintf(format);
						} else {
							console.log("DID NOT MATCH Override: " + JSON.stringify(override));
						}
					}
				}
			} catch (e) {
				console.log("ERROR! Exception occurred in manifest overrides: " + e);
			}
		}

		return manifestName;
	},

// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		Persist: -1,
		Game: -2
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 342,
	// Method launch = -1
	// Method loadGame = -2
	// Method gameLoaded = -3
	// Method launchLoadedGame = -4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -3:
					_int_LGL._gameLoadedRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[342] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_gameLoadedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_LGL.gameLoaded from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _int_LGL.gameLoaded from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_launchSendGen: function( url, proc )
	{
		Proc.appendToCommandString( 0x156ffff, [ Proc.encodeString( url ), +proc ] );
	},
	
	/** @private */
	$_loadGameSendGen: function( url )
	{
		Proc.appendToCommandString( 0x156fffe, [ Proc.encodeString( url ) ] );
	},
	
	/** @private */
	$_launchLoadedGameSendGen: function(  )
	{
		Proc.appendToCommandString( 0x156fffc );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $launch: function( url, proc ) {}
	
	// $loadGame: function( url ) {}
	
	// $_gameLoadedRecv: function( cmd ) {}
	// $launchLoadedGame: function(  ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});

exports._int_LGL = _int_LGL;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/LocalGameList.js';

////////////////////////////////////////////////////////////////////////////////
// Class LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
var OrientationEmitter = require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;

////////////////////////////////////////////////////////////////////////////////

var LifeListener = MessageListener.subclass(
{
	initialize: function(listen)
	{
		LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
		this._listener = listen;
	},

	destroy: function()
	{
		LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate: function(event)
	{
		switch (event)
		{
			case Device.LifecycleEmitter.Event.Resume:
				this._listener.onResume();
				break;
		}
	}
});

exports.LocalGameList = Class.singleton (
/** @lends Core.LocalGameList.prototype */
{
	classname: 'LocalGameList',

	/**
	 * @class The <code>LocalGameList</code> class constructs objects that handle the loading and updating of a user's application list.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @constructs The default constructor.
	 * @singleton
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		new LifeListener(this);
		this.mRefCount = 0;
		this.mRefTable = [];
		this.mSpaceAvailable = 0;
		this.mRequiredAvailableSpace = 0;
		
		this.mSpaceCB = [];

		this._getRepoSpaceSendGen();

		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";
		this.onResume();
	},


	/** @private */
	onResume: function()
	{
		this._reloadGameList();
	},

	_reloadGameList: function()
	{
		this.mGameStore.getItem(this.mActiveGameKey, {},
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				this.mGameList = list;
				if (typeof this.mListListen == 'function')
					this.mListListen();
			}).bind(this),
			true
		);
	},

	/** @private */
	setListListener: function(funk)
	{
		this.mListListen = funk;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 302,
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method _setUpdateProgressVisible = 7
	// Method _setUpdateProgressBounds = 8
	// Method pauseUpdate = 9
	// Method resumeUpdate = 10
	// Method cancelUpdate = 11
	// Method updateProgress = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method _forwardException = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._updateDoneRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 12:
					instance._updateProgressRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[302] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDoneRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateProgressRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "cur" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cur" ] === undefined )
		{
			NgLogE("Could not parse cur in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "total" ] = Proc.parseInt( cmd[ 2 ] );
		if( obj[ "total" ] === undefined )
		{
			NgLogE("Could not parse total in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseBool( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x12effff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_updateGameSendGen: function( url, id )
	{
		Proc.appendToCommandString( 0x12e0002, this, [ Proc.encodeString( url ), +id ] );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( 0x12e0004, this );
	},
	
	/** @private */
	_deleteGameSendGen: function( mdFive )
	{
		Proc.appendToCommandString( 0x12e0006, this, [ Proc.encodeString( mdFive ) ] );
	},
	
	/** @private */
	__setUpdateProgressVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( 0x12e0007, this, [ ( visible ? 1 : 0 ) ] );
	},
	
	/** @private */
	__setUpdateProgressBoundsSendGen: function( x, y, w, h )
	{
		Proc.appendToCommandString( 0x12e0008, this, [ +x, +y, +w, +h ] );
	},
	
	/** @private */
	_pauseUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( 0x12e0009, this, [ Proc.encodeString( url ) ] );
	},
	
	/** @private */
	_resumeUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( 0x12e000a, this, [ Proc.encodeString( url ) ] );
	},
	
	/** @private */
	_cancelUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( 0x12e000b, this, [ Proc.encodeString( url ) ] );
	},
	
	/** @private */
	_runGameSendGen: function( url )
	{
		Proc.appendToCommandString( 0x12e000d, this, [ Proc.encodeString( url ) ] );
	},
	
	/** @private */
	_finishGameSendGen: function(  )
	{
		Proc.appendToCommandString( 0x12e000e, this );
	},
	
	/** @private */
	__forwardExceptionSendGen: function( exceptionString )
	{
		Proc.appendToCommandString( 0x12e000f, this, [ Proc.encodeString( exceptionString ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// updateGame: function( url, id ) {}
	
	// _updateDoneRecv: function( cmd ) {}
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// deleteGame: function( mdFive ) {}
	
	// _setUpdateProgressVisible: function( visible ) {}
	
	// _setUpdateProgressBounds: function( x, y, w, h ) {}
	
	// pauseUpdate: function( url ) {}
	
	// resumeUpdate: function( url ) {}
	
	// cancelUpdate: function( url ) {}
	
	// _updateProgressRecv: function( cmd ) {}
	// runGame: function( url ) {}
	
	// finishGame: function(  ) {}
	
	// _forwardException: function( exceptionString ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


	,
	_setProgressVisible: function (progressVisible) {
		this.progressVisible = progressVisible;
		this.__setUpdateProgressVisibleSendGen(progressVisible);
	},
	
	_setProgressBounds: function(bounds) {
		this.__setUpdateProgressBoundsSendGen(bounds[0],bounds[1],bounds[2],bounds[3]);
	},

	/**
	 * Restart the current application.
	 * @returns {void}
	 * @since 1.0.6
	 */
	restartGame: function()
	{
		this.runGame(Capabilities.getServer() + "/" + Capabilities.getGame());
	},

	/**
	 * Launch an application from the specified URL.
	 * @param {String} url The URL of an application. On the Japan platform, use the value
	 *		<code>null</code> to exit the application.
	 * @returns {void}
	 * @since 1.0
	 */
	runGame: function( url )
	{
		console.log("Calling runGame with " + url);
		if (!url)
		{
			console.log("Finishing");
			this._finishGame();
		}
		else
		{
			this._runGameSendGen(Util.NormalizeUrl(url));
		}
	},

	/** 
	 * @private 
	 */
	_finishGame: function()
	{
		this._finishGameSendGen();
	},

	// Next 5 functions are for mobage, not developers.

	// callback = function(gameUrl, dl'd, total, error)
	// mobage responsibility to intercept when dl'd == total, update is finished
	//	or know if there was an error by checking that param

    /**
     * @private
     */
	listenUpdates: function(callback)
	{
		this.mUpdateListener = callback;
	},

    /**
     * @private
     */
	stopUpdateListening: function()
	{
		delete this.mUpdateListener;
	},

    /**
     * @private
     */
	pauseUpdate: function(url)
	{
		this._pauseUpdateSendGen(Util.NormalizeUrl(url));
	},

    /**
     * @private
     */
	resumeUpdate: function(url)
	{
		this._resumeUpdateSendGen(Util.NormalizeUrl(url));
	},

    /**
     * @private
     */
	cancelUpdate: function(url)
	{
		this._cancelUpdateSendGen(Util.NormalizeUrl(url));
	},

	/**
	* Update an application at the specified URL.
	* @example Core.LocalGameList.updateGame(url, (function(err)
	*	{
	*		if (err)
	*		{
	*			NgLogE("GameHub error updating game! " + err);
	*			Network.Util.showSimpleNetworkError();
	*			this._loadingGame = false;
	*		}
	*		else
	*		{
	*			Core.LocalGameList.runGame(url);
	*		}
	*	});
	* @param {String} url The specified URL.
	* @cb {Function} cb The function to call after updating the application.
	* @cb-param {String} err The error message, if any.
	* @cb-returns {void}
	* @returns {Number} The number of additional applications being updated.
	* @status Flash, Test, FlashTested
	* @since 1.0
	*/
	updateGame: function( url , cb )
	{
		var reqId = this.mRefCount;
		this.mRefTable[this.mRefCount++] = cb;

		this._updateGameSendGen( Util.NormalizeUrl(url), reqId );
		return reqId;
	},

	/**
	 * Update and restart the current application without restarting the ngCore binary. Calling this
	 * method is equivalent to calling <code>{@link Core.LocalGameList#runUpdatedGame}</code> and
	 * specifying the current application in the <code>url</code> parameter.
	 * @example
	 * Core.LocalGameList.updateAndRestartCurrentGame();
	 * @returns {void}
	 * @since 1.7
	 */
	updateAndRestartCurrentGame : function()
	{
		this.runUpdatedGame(Capabilities.getUrl());
		OrientationEmitter.setInterfaceOrientation(OrientationEmitter.Orientation.Portrait, false);
	},

	/**
	* Launch an updated application from the specified URL.
	* @example Core.LocalGameList.runUpdatedGame('/games/MyGames');
	* @param {String} url The specified URL of an updated application.
	* @returns {void}
	* @status Flash, Test, FlashTested
	* @since 1.0
	*/
	runUpdatedGame: function (url)
	{
		if (!url)
		{
			this._finishGame();
			return;
		}

		this.updateGame(url,
			(function(err)
			{
				if (err)
				{
					NgLogE("LGL Error updating game! " + err);
					Util.showFatalErrorDialog();
				}
				else
				{
					this.runGame(url);
				}
			}).bind(this)
		);
	},

	_updateProgressRecv: function( cmd )
	{
		var obj = {};
		this._updateProgressRecvGen(cmd, obj);
		if (this.mUpdateListener)
			this.mUpdateListener(obj.url, obj.cur, obj.total, obj.error);
	},

	_updateDoneRecv: function( cmd )
	{
		var obj = {};
		this._updateDoneRecvGen(cmd, obj);

		this._reloadGameList();

		var cb = this.mRefTable[obj.id];
		if (cb)
		{
			cb(obj.error);
		}

		delete this.mRefTable[obj.id];
		this._getRepoSpaceSendGen();
	},

	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space - 7340032; // KJ report 7mb less
		console.log('LocalGameList.got response:', this.mSpaceAvailable, 'and need:', this.mRequiredAvailableSpace);
		
		if(this.mRequiredAvailableSpace > this.mSpaceAvailable)
		{
			var errorAlert = new UI.AlertDialog();
			errorAlert.setText(Core.Localization.getString("SD card is full"));
			errorAlert.setChoices([Core.Localization.getString("Exit")]);
			errorAlert.game = this.game;
			errorAlert.onchoice = function(ret)
			{
				errorAlert.hide();
				LifecycleEmitter.exitProcess();
			};
			errorAlert.show();
		}
		else
		{
			for(var i=0; i < this.mSpaceCB.length; ++i)
			{
				this.mSpaceCB[i]();
			}
			this.mSpaceCB = [];
			this.mRequiredAvailableSpace = 0;
		}
	},

	/**
	 * @private
	 */
	getGameList: function()
	{
		// Caveat! This will return an empty list if it is the first call. Must initialize beforehand.-KJ
		return this.mGameList;
	},

	/**
	 * @private
	 */
	updateGameList: function(list)
	{
		this.mGameList = list;
	},

	/**
	 * @private
	 */
	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace += space;
		
		this.mSpaceCB.push(cb);
		console.log('LocalGameList.freeSpace space=', this.mRequiredAvailableSpace);
		if(this.mSpaceCB.length == 1)
		{
			console.log('LocalGameList.sending request to native');
			// Send request to native if this is the first requester.
			this._getRepoSpaceSendGen();
		}
	},

	/**
	 * @private
	 */
	deleteGame: function(url)
	{
		url = Util.NormalizeUrl(url);
		var hash = toMD5(url);
		this._deleteGameSendGen(hash);

		var self = this;
		var doneCB = function ()
		{
			NgLogD("LocalGameList finished deleting game from " + self.mActiveGameKey + " for " + hash );
		};

		// Update cached game list to match what's going to happen outside of game proc.
		// Matches logic in _LocalGameList._deleteGameFromStorage, but doesn't
		// write to Storage key.
		if( this.mGameList )
		{
			var list = this.mGameList;
			var good = false;
			var ind;
			var out = [];
			for(ind = 0; ind < list.length; ++ind)
			{
				if(list[ind].name == hash)
					good = true;
				else
					out.push(list[ind]);
			}

			if( good )
			{
				NgLogD("LocalGameList found and removed " + hash);
				this.mGameList = out;
			}
			else
				NgLogD("LocalGameList failed to find and remove " + hash);
		}
		else
			NgLogD("LocalGameList cache not warm, can't remove " + hash);
	},

	/**
	 * Check if an update is available for the specified application.<br /><br />
	 * The following code illustrates how to retrieve an application name to pass in for this call.
	 * @param {String} game The specified game. Use <code>{@link Core.Capabilities#getGame}</code> to return the game name.
	 * @cb {Function} doneCB The function to call after checking for an update.
	 * @cb-param {Boolean} updated Set to <code>true</code> if an update is available for the
	 *		application.
	 * @cb-param {Number} spaceNeeded The amount of space, in bytes, that is required to download
	 *		the update.
	 * @cb-returns {void}
	 * @cb {Function} errorCB The function to call if an error occurs.
	 * @cb-param {String} err The error message, if any.
	 * @cb-returns {void}
	 * @example
	 *
	 * updateButton.onclick = function() {
	 *     LocalGameList.updateAvailable(Core.Capabilities.getUrl(), function(updated, spaceNeeded) {
	 *         if (updated)
	 *             LGL.runUpdatedGame(Core.Capabilities.getUrl());
	 *     },
     *     function (error) {
     *         console.log("An error occurred while checking for an application update: " + error);
	 *     });
	 * };
	 * @returns {void}
	 * @status
	 * @since 1.0
	 */
	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	_forwardException: function( exceptionString )
	{
		this.__forwardExceptionSendGen(exceptionString);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] = exports; 
var __dirname = 'NGCore/Client/Storage';
var __filename = 'NGCore/Client/Storage/FileSystem.js';

////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;
var Diagnostics = require('NGCore/Client/Storage/Diagnostics').Diagnostics;

////////////////////////////////////////////////////////////////////////////////

var FSError = function(code, description) {
	this.code = code;
	this.description = description;
	return this;
};

FSError.prototype = {
	classname:"FileSystemError",
	toString: function() {
		return this.className + " " + this.code + ": " + this.description;
	}
};

exports.FileSystem = Core.Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',

  /** @private */
  _options: {
    blocking    : 0x0001, /* legacy blocking(main thread) mode operation for backward compatibility */
    binary      : 0x0002,
    useBinaryCb : 0x0004, /* if _NOT_ set, uses readFileCb for returning binary (legacy) */
    returnFiles : 0x0100,
    returnMd5   : 0x0200
  },
	
	/**
	 * @class The `Storage.FileSystem` class constructs a singleton object that enables an 
	 * application to work with files stored on a device. Use this class to read, write, rename, 
	 * delete, decompress, and retrieve information about files.
	 *
	 * The files you store with `Storage.FileSystem` are not tied to a specific Mobage user. If you 
	 * need to store user-specific files, verify that your application is storing and retrieving 
	 * files for the correct Mobage user. Keep in mind that several different Mobage users could all
	 * use the same application on the same device.
	 * @singleton
	 * @constructs
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
        /** @private */
		this.statRequests = {};
		/** @private */
		this.cbIdCounter = 1;

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._readCount = 0;
		this._writeCount = 0;
		this._deleteCount = 0;
		this._renameCount = 0;
		this._decompressCount = 0;
		this._statCount = 0;

		Diagnostics.pushCollector(this.collectDiagnostics.bind(this));
	},

	/**
	 * Read a file into memory from local storage. Calling this method is equivalent to calling
	 * `{@link Storage.FileSystem#readFileIn}` with the `store` parameter set to
	 * `Storage.FileSystem.Store.Local`.
	 * @example
	 * // Read a binary-format game level into memory.
	 * var levelName = "level.bin";
	 *
	 * // Call readFile(), and use the options parameter to indicate that the file is in
	 * // binary format.
	 * Storage.FileSystem.readFile(levelName, { binary: true }, function(err, data) {
	 *     if (err) {
	 *         console.log("An error occurred while reading " + fileName + ": " + err);
	 *     } else {
	 *         // parse the game level file
	 *     }	
	 * });
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to read the file synchronously
	 *		(i.e., the application pauses until the entire file is read). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot
	 *		function without synchronous file access.
	 * @param {Boolean} [options.binary=false] Set to `true` to assume that the file is in binary
	 *		format.
	 * @cb {Function} cb The function to call after reading the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-param {String} [data] The file data, if the file loaded successfully.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	readFile: function( fname, options, cb )
	{
		this.readFileIn(this.Store.Local, fname, options, cb);
	},
	
	/**
	 * Deprecated signature for reading a file into memory from local storage.
	 * @name readFile^2
	 * @function
	 * @memberOf Storage.FileSystem#
	 * @deprecated Since version 1.4.1. Use the signature readFile(fname, options, cb) rather than
	 * this signature.
	 * @example
	 * Storage.FileSystem.readFile("filename", true, function(err, data) {
	 *     // Add callback code.
	 * });
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set to `true` if `readFile()` should assume that the file is
	 *		in binary format.
	 * @cb {Function} cb The function to call after reading the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-param {String} [data] The file data, if the file loaded successfully.
	 * @cb-returns {void}
	 * @returns {void}
	 */

	/**
	 * Read a file into memory from a specified local file store. There are separate stores for
	 * persistent files, which are intended to be saved between application sessions, and temporary
	 * files, which can be deleted at any time.
	 * @example
	 * // Cache a user's first name.
	 * var firstName = "Danielle";
	 * Storage.FileSystem.writeFileIn(Storage.FileSystem.Store.Temp, "first-name.txt", 
	 *   firstName, {}, function (err) {
	 *     if (err) {
	 *         console.log("An error occurred while writing " + fileName + ": " + err);
	 *     } else {
	 *         // Read the user's first name.
	 *         Storage.FileSystem.readFileIn(Storage.FileSystem.Store.Temp,
	 *           "first-name.txt", {}, function(err, data) {
	 *             if (err) {
	 *                 console.log("An error occurred while reading " + fileName + 
	 *                   ": " + err);
	 *             } else {
	 *                 console.log("The user's first name is " + data);
	 *             }
	 *         });
	 *     }	
	 * });
	 * @param {Storage.FileSystem#Store} store The local file store to read from. Use
	 *		`Storage.FileSystem.Store.Local` for persistent files and
	 *		`Storage.FileSystem.Store.Temp` for temporary files.
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to read the file synchronously
	 *		(i.e., the application pauses until the entire file is read). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot
	 *		function without synchronous file access.
	 * @param {Boolean} [options.binary=false] Set to `true` to assume that the file is in binary
	 *		format.
	 * @cb {Function} cb The function to call after reading the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-param {String} [data] The file data, if the file loaded successfully.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	readFileIn: function( store, fname, options, cb )
	{
		var op, cbId = 0;

		this._readCount++;

		if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      NgLogW("FileSystem.readFile/readFileIn(): using deprecated function signature");
      var binary = options;

      if(typeof(binary) == 'function')
      {
        cb = binary;
        binary = false;
      }
      binary = binary || false;

      if ( cb )
      {
        cbId = this.cbIdCounter++;
        this.readRequests[ cbId ] = cb;
      }

      op = this._options.blocking;
      if (binary)
          op |= this._options.binary | this._options.useBinaryCb;
      this._readFileAsyncSendGen(cbId,store,fname,op);
    }
    else
    {
      op = 0;
      if(options['blocking'])
        op |= this._options.blocking;
      if(options['binary'])
        op |= this._options.binary | this._options.useBinaryCb;

      if(cb)
      {
        cbId = this.cbIdCounter++;
        this.readRequests[ cbId ] = cb;
      }

      this._readFileAsyncSendGen(cbId,store,fname,op);
    }
	},

	/**
	 * Write a file to local storage. Calling this method is equivalent to calling
	 * `{@link Storage.FileSystem#writeFileIn}` with the `store` parameter set to
	 * `Storage.FileSystem.Store.Local`.
	 * @example
	 * var fileName = "write_test";
	 * var data = "test data";
	 * 
	 * Storage.FileSystem.writeFile(fileName, data, {}, function(err) {
	 *     if (err) {
	 *         console.log("An error occurred while reading " + fileName + ": " + err);
	 *     }	
	 * });
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to write the file synchronously
	 *		(i.e., the application pauses until the entire file is written). This option can
	 *		cause significant delays on some devices and should be used only if your application
	 *		cannot function without synchronous file access.
	 * @param {Boolean} [options.binary=false] Set to `true` to assume that the data is in binary
	 *		format.
	 * @cb {Function} cb The function to call after writing the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	writeFile: function( fname, data, options, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, options, cb);
	},

	/**
	 * Deprecated signature for writing a file to local storage.
	 * @name writeFile^2
	 * @function
	 * @memberOf Storage.FileSystem#
	 * @deprecated Since version 1.4.1. Use the signature writeFile(fname, data, options, cb)
	 * rather than this signature.
	 * @example
	 * Storage.FileSystem.writeFile("filename", true, function(err) {
	 *     // Add callback code.
	 * });
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Boolean} [binary=false] Set to `true` if `writeFile()` should assume that the file is
	 *		in binary format.
	 * @cb {Function} cb The function to call after writing the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 */

	/**
	 * Write a file to a specified local file store. There are separate stores for persistent files,
	 * which are intended to be saved between application sessions, and temporary files, which can
	 * be deleted at any time.
	 * @example
	 * var fileName = "write_test";
	 * var data = "test data";
	 * 
	 * Storage.FileSystem.writeFileIn(Storage.FileSystem.Store.Temp, fileName, 
	 *   data, {}, function(err) {
	 *     if (err) {
	 *         console.log("An error occurred while reading " + fileName + ": " + err);
	 *     }
	 * });
	 * @param {Storage.FileSystem#Store} store The local file store to write to. Use
	 *		`Storage.FileSystem.Store.Local` for persistent files and
	 *		`Storage.FileSystem.Store.Temp` for temporary files.
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to write the file synchronously
	 *		(i.e., the application pauses until the entire file is written). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot 
	 *		function without synchronous file access.
	 * @param {Boolean} [options.binary=false] Set to `true` to assume that the data is in binary 
	 *		format.
	 * @cb {Function} cb The function to call after writing the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	writeFileIn: function( store, fname, data, options, cb )
	{
		var cbId = 0;

		this._writeCount++;

    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      NgLogW("FileSystem.writeFile/writeFileIn(): using deprecated function signature");
      var binary = options;

      if(typeof(binary) == 'function')
      {
        cb = binary;
        binary = false;
      }
      binary = binary || false;

      if ( cb )
      {
        cbId = this.cbIdCounter++;
        this.writeRequests[ cbId ] = cb;
      }

      this._writeFileSendGen(cbId,store,fname,data,binary);
    }
    else
    {
      var op = 0;
      if(options['blocking'])
        op |= this._options.blocking;
      if(options['binary'])
        op |= this._options.binary;

      if(cb)
      {
        cbId = this.cbIdCounter++;
        this.writeRequests[ cbId ] = cb;
      }

      if((op & this._options.binary) !== 0 && Core.Capabilities.compareBinaryVersion(1, 4) >= 0)
        this._writeFileAsyncBinarySendGen(cbId,store,fname,data,op);
      else
        this._writeFileAsyncSendGen(cbId,store,fname,data,op);
    }
	},

	/**
	 * Delete a file from local storage. Calling this method is equivalent to calling
	 * `{@link Storage.FileSystem#deleteFileIn}` with the `store` parameter set to
	 * `Storage.FileSystem.Store.Local`.
	 * @example
	 * var fileName = "delete_test";
	 * 
	 * Storage.FileSystem.deleteFile(fileName, {}, function(err) {
	 *     if (err) {
	 *         console.log("An error occurred while deleting " + fileName + ": " + err);
	 *     }	
	 * });
	 * @param {String} fname The name of the file to delete.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to delete the file synchronously
	 *		(i.e., the application pauses until the entire file is deleted). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot 
	 *		function without synchronous file access.
	 * @cb {Function} cb The function to call after deleting the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	deleteFile: function ( fname, options, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, options, cb);
	},

	/**
	 * Deprecated signature for deleting a file from local storage.
	 * @name deleteFile^2
	 * @function
	 * @memberOf Storage.FileSystem#
	 * @deprecated Since version 1.4.1. Use the signature deleteFile(fname, options, cb) rather
	 * than this signature.
	 * @example
	 * Storage.FileSystem.deleteFile("filename", function(err) {
	 *     // Add callback code.
	 * });
	 * @param {String} fname The name of the file to delete.
	 * @cb {Function} cb The function to call after deleting the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 */

	/**
	 * Delete a file from a specified local file store. There are separate stores for persistent 
	 * files, which are intended to be saved between application sessions, and temporary files, 
	 * which can be deleted at any time.
	 * @example
	 * var fileName = "delete_test";
	 * 
	 * Storage.FileSystem.deleteFile(Storage.FileSystem.Store.Temp, fileName, {},
	 *   function(err) {
	 *     if (err) {
	 *         console.log("An error occurred while deleting " + fileName + ": " + err);
	 *     }	
	 * });
	 * @param {Storage.FileSystem#Store} store The local file store to delete from. Use
	 *		`Storage.FileSystem.Store.Local` for persistent files and
	 *		`Storage.FileSystem.Store.Temp` for temporary files.
	 * @param {String} fname The name of the file to delete.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to delete the file synchronously
	 *		(i.e., the application pauses until the entire file is deleted). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot 
	 *		function without synchronous file access.
	 * @cb {Function} cb The function to call after deleting the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	deleteFileIn: function ( store, fname, options, cb )
	{
		var cbId = 0;

		this._deleteCount++;

    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      NgLogW("FileSystem.deleteFile/deleteFileIn(): using deprecated function signature");
      cb = options;

      if ( cb )
      {
        cbId = this.cbIdCounter++;
        this.writeRequests[ cbId ] = cb;
      }
      this._deleteFileSendGen(cbId,store,fname);
    }
    else
    {
      var op = 0;

      if(options['blocking'])
      {
        op |= this._options.blocking;
      }

      if(cb)
      {
        cbId = this.cbIdCounter++;
        this.writeRequests[ cbId ] = cb;
      }
      this._deleteFileAsyncSendGen(cbId, store, fname, op);
    }
	},
	
	/**
	 * Decompress a .zip file from local storage. Calling this method is equivalent to calling
	 * `{@link Storage.FileSystem#decompressFileIn}` with the `store` parameter set to
	 * `Storage.FileSystem.Store.Local`.
	 * @example
	 * var fileName = "unzip_test";
	 * var fileDir = "dir_test";
	 * 
	 * Storage.FileSystem.decompressFile(fileName, fileDir, {}, function(err) {
	 *     if (err) {
	 *         console.log("An error occurred while decompressing " + fileName +
	 *           ": " + err);
	 *     }	
	 * });
	 * @example
	 * var fileName = "unzip_test";
	 * var fileDir = "dir_test";
	 * 
	 * Storage.FileSystem.decompressFile(fileName, fileDir, { returnFiles: true },
	 *   function(err, files) {
	 *     if (err) {
	 *         console.log("An error occurred while decompressing " + fileName +
	 *           ": " + err);
	 *     } else {
	 *         for (var i = 0; files[i]; i++) {
	 *             console.log("The file " + files[i].name + " has the MD5 hash " +
	 *               files[i].hash + " and is " + files[i].size + " bytes");
	 *         }
	 *     }
	 * });
	 * @param {String} fname The name of the .zip file to decompress.
	 * @param {String} destination The directory where the contents of the decompressed file are
	 *		stored.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to decompress the file synchronously
	 *		(i.e., the application pauses until the entire file is decompressed). This option can
	 *		cause significant delays on some devices and should be used only if your application
	 *		cannot function without synchronous file access.
	 * @param {Boolean} [options.returnFiles=false] If this is set to `true`, an array will be
	 *		passed to the callback function containing a list of the files that were decompressed,
	 *		each file's MD5 hash, and each file's size in bytes.
	 * @cb {Function} cb The function to call after decompressing the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-param {Object[]} [files] Information about the files that were decompressed.
	 * @cb-param {String} [files[].name] The relative path of the file that was decompressed.
	 * @cb-param {String} [files[].hash] The MD5 hash of the file.
	 * @cb-param {Number} [files[].size] The file's size in bytes.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android
	 * @since 1.0
	 */
	decompressFile: function( fname, destination, options, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, options, cb);
	},
	
	/**
	 * Deprecated signature for decompressing a .zip file.
	 * @name decompressFile^2
	 * @function
	 * @memberOf Storage.FileSystem#
	 * @deprecated Since version 1.4.1. Use the signature decompressFile(fname, destination,
	 * options, cb) rather than this signature.
	 * @example
	 * Storage.FileSystem.decompressFile("filename", "dir_test", true,
	 *   function(err, files) {
	 *     // Add callback code.
	 * });
	 * @param {String} fname The name of the .zip file to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file
	 *		are written.
	 * @param {Boolean} [returnFiles=false] If this is set to `true`, an array will be passed to the
	 *		callback function containing a list of the files that were decompressed, each file's MD5
	 *		hash, and each file's size in bytes.
	 * @cb {Function} cb The function to call after decompressing the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-param {Object[]} [files] Information about the files that were decompressed.
	 * @cb-param {String} [files[].name] The relative path of the file that was decompressed.
	 * @cb-param {String} [files[].hash] The MD5 hash of the file.
	 * @cb-param {Number} [files[].size] The file's size in bytes.
	 * @cb-returns {void}
	 * @returns {void}
	 */

	/**
	 * Decompress a .zip file in a specified local file store. There are separate stores for
	 * persistent files, which are intended to be saved between application sessions, and temporary 
	 * files, which can be deleted at any time.
	 * @example
	 * var fileName = "unzip_test";
	 * var fileDir = "dir_test";
	 * 
	 * Storage.FileSystem.decompressFileIn(Storage.FileSystem.Store.Temp, fileName,
	 *   fileDir, {}, function(err) {
	 *     if (err) {
	 *         console.log("An error occurred while decompressing " + fileName + 
	 *           ": " + err);
	 *     }	
	 * });
	 * @example
	 * var fileName = "unzip_test";
	 * var fileDir = "dir_test";
	 * 
	 * Storage.FileSystem.decompressFileIn(Storage.FileSystem.Store.Temp, fileName,
	 *   fileDir, { returnFiles: true }, function(err, files) {
	 *     if (err) {
	 *         console.log("An error occurred while decompressing " + fileName + 
	 *           ": " + err);
	 *     } else {
	 *         for (var i = 0; files[i]; i++) {
	 *             console.log("The file " + files[i].name + " has the MD5 hash " + 
	 *               files[i].hash + " and is " + files[i].size + " bytes");
	 *         }
	 *     }
	 * });
	 * @param {Storage.FileSystem#Store} store The local file store for the .zip file to decompress. 
	 *		Use `Storage.FileSystem.Store.Local` for persistent files and
	 *		`Storage.FileSystem.Store.Temp` for temporary files.
	 * @param {String} fname The name of the .zip file to decompress.
	 * @param {String} destination The directory where the contents of the decompressed file are
	 *		stored.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to decompress the file synchronously
	 *		(i.e., the application pauses until the entire file is decompressed). This option can
	 *		cause significant delays on some devices and should be used only if your application 
	 *		cannot function without synchronous file access.
	 * @param {Boolean} [options.returnFiles=false] If this is set to `true`, an array will be
	 *		passed to the callback function containing a list of the files that were decompressed,
	 *		each file's MD5 hash, and each file's size in bytes.
	 * @cb {Function} cb The function to call after decompressing the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-param {Object[]} [files] Information about the files that were decompressed.
	 * @cb-param {String} [files[].name] The relative path of the file that was decompressed.
	 * @cb-param {String} [files[].hash] The MD5 hash of the file.
	 * @cb-param {Number} [files[].size] The file's size in bytes.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android    
	 * @since 1.0
	 */
	decompressFileIn: function( store, fname, destination, options, cb )
	{
		var cbId = 0;

		this._decompressCount++;

    if(typeof(options) !== 'object')
    {
      /* Legacy function signature */
      NgLogW("FileSystem.decompressFile/decompressFileIn(): using deprecated function signature");
      var returnFiles = options;
      if ( cb )
      {
        cbId = this.cbIdCounter++;
        this.writeRequests[ cbId ] = cb;
      }
      this._decompressFileSendGen(cbId,store,fname,destination,returnFiles);
    }
    else
    {
      var op = 0;

      if(options['blocking'])
      {
        op |= this._options.blocking;
      }
      if(options['returnFiles'])
      {
        op |= this._options.returnFiles;
      }

      if ( cb )
      {
        cbId = this.cbIdCounter++;
        this.writeRequests[ cbId ] = cb;
      }
      this._decompressFileAsyncSendGen(cbId, store, fname, destination, op);
    }
	},
	
	/**
	 * Rename a file on local storage. Calling this method is equivalent to calling
	 * `{@link Storage.FileSystem#renameFileIn}` with the `store` parameter set to
	 * `Storage.FileSystem.Store.Local`.
	 * @example
	 * var filenameOld = "important_file.txt";
	 * var filenameNew = "important_file.xml";
	 *
	 * Storage.FileSystem.writeFile(filenameOld, "test", {}, function (err) {
	 *     if (err) {
	 *         log("An error occurred while writing " + filenameOld + ": " + err);
	 *     } else {
	 *         Storage.FileSystem.renameFile(filenameOld, filenameNew, {},
	 *           function(err) {
	 *             if (err) {
	 *                 log("An error occurred while renaming the file: " + err);
	 *             }
	 *         });
	 *     }
	 * });
	 * @param {String} oldPath The full path of the file to rename.
	 * @param {String} newPath The full path of the file's new name.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to rename the file synchronously
	 *		(i.e., the application pauses until the file is renamed). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot
	 *		function without synchronous file access.
	 * @cb {Function} cb The function to call after renaming the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.4.1
	 */
	renameFile: function ( oldPath, newPath, options, cb )
	{
		this.renameFileIn(this.Store.Local, oldPath, newPath, options, cb);
	},
	/**
	 * Rename a file in a specified local file store. There are separate stores for persistent
	 * files, which are intended to be saved between application sessions, and temporary files, 
	 * which can be deleted at any time.
	 * @example
	 * var filenameOld = "temp_file.txt";
	 * var filenameNew = "temp_file.xml";
	 *
	 * Storage.FileSystem.writeFileIn(Storage.FileSystem.Store.Temp, filenameOld,
	 *   "test", {}, function (err) {
	 *     if (err) {
	 *         log("An error occurred while writing " + filenameOld + ": " + err);
	 *     } else {
	 *         fileSys.renameFileIn(Storage.FileSystem.Store.Temp, filenameOld,
	 *           filenameNew, {}, function(err) {
	 *             if (err) {
	 *                 log("An error occurred while renaming the file: " + err);
	 *             }
	 *         });
	 *     }
	 * });
	 * @param {Storage.FileSystem#Store} store The local file store for the file to rename. Use
	 *		`Storage.FileSystem.Store.Local` for persistent files and
	 *		`Storage.FileSystem.Store.Temp` for temporary files.
	 * @param {String} oldPath The full path of the file to rename.
	 * @param {String} newPath The full path of the file's new name.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to rename the file synchronously
	 *		(i.e., the application pauses until the file is renamed). This option can cause
	 *		significant delays on some devices and should be used only if your application cannot
	 *		function without synchronous file access.
	 * @cb {Function} cb The function to call after renaming the file.
	 * @cb-param {String} [err] The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.4.1
	 */
	renameFileIn: function ( store, oldPath, newPath, options, cb )
	{
		var cbId = 0;
		var op = 0;

		this._renameCount++;

		if(Core.Capabilities.compareBinaryVersion(1, 4) < 0)
		{
			if(typeof(options) == 'function')
			{
				cb = options;
			}
		
			if(cb)
			{
				cb('Not supported');
			}

			return;
		}

		if(typeof(options) !== 'object')
		{
			// assume 'options' arg is not supplied.
			// default behavior is non-blocking.
			cb = options;
		}
		else
		{
			if(options['blocking'])
			{
				op |= this._options.blocking;
			}
		}

		if(cb)
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._renameFileAsyncSendGen(cbId, store, oldPath, newPath, op);
	},
	/**
	 * Retrieve information about a file on local storage. Calling this method is equivalent to 
	 * calling `{@link Storage.FileSystem#statIn}` with the `store` parameter set to
	 * `Storage.FileSystem.Store.Local`.
	 * @example
	 * var newFileName = "important_file.txt";
	 *
	 * Storage.FileSystem.writeFile(newFileName, "test", {}, function (err) {
	 *     if (err) {
	 *         log("An error occurred while writing " + newFileName + ": " + err);
	 *     } else {
	 *         Storage.FileSystem.stat(newFileName, {}, function(err, stats) {
	 *             if (err) {
	 *                 log("An error occurred while retrieving file information: " + 
	 *                   JSON.stringify(err));
	 *             }
	 *             else {
	 *                 log("Retrieved file information: " + JSON.stringify(stats));
	 *             }
	 *         });
	 *     }
	 * });
	 * @param {String} filePath The full path of the file for which to retrieve information.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to retrieve information about the
	 *		file synchronously (i.e., the application pauses until the information is obtained).
	 *		This option can cause significant delays on some devices and should be used only if your
	 *		application cannot function without synchronous file access.
	 * @param {Boolean} [options.returnMd5=false] Set to `true` to retrieve the MD5 hash of the
	 *		file's contents. Available since ngCore 1.7.
	 * @cb {Function} cb The function that is called after retrieving information about the file.
	 * @cb-param {Object} [err] Information about the error, if any.
	 * @cb-param {String} [err.description] A description of the error.
	 * @cb-param {Storage.FileSystem#ErrorCode} [err.code] A code identifying the type of
	 *		error.
	 * @cb-param {Object} [stats] Information about the file.
	 * @cb-param {Number} [stats.atime] The time when the file was last accessed. Expressed in
	 *		Unix time (milliseconds since 00:00:00 UTC on January 1, 1970).
	 * @cb-param {Number} [stats.ctime] The time when the file's status was last changed (for 
	 *		example, the file was modified, or its owner or permissions changed). Expressed in
	 *		Unix time (milliseconds since 00:00:00 UTC on January 1, 1970).
	 * @cb-param {String} [stats.hash] The MD5 hash of the file's contents. Returned only if the
	 *		parameter `options.returnMd5` is set to `true`. Available since ngCore 1.7.
	 * @cb-param {Number} [stats.mtime] The time when the file was last modified. Expressed in
	 *		Unix time (milliseconds since 00:00:00 UTC on January 1, 1970).
	 * @cb-param {Number} [stats.size] The size of the file, in bytes.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.6
	 */
	stat: function ( filePath, options, cb )
	{
		this.statIn(this.Store.Local, filePath, options, cb);
	},
	/**
	 * Retrieve information about a file in a specified local file store. There are separate stores 
	 * for persistent files, which are intended to be saved between application sessions, and 
	 * temporary files, which can be deleted at any time.
	 * @example
	 * var newFileName = "temp_file.txt";
	 *
	 * Storage.FileSystem.writeFileIn(Storage.FileSystem.Store.Temp, newFileName,
	 *   "test", {}, function (err) {
	 *     if (err) {
	 *         log("An error occurred while writing " + newFileName + ": " + err);
	 *     } else {
	 *         Storage.FileSystem.statIn(Storage.FileSystem.Store.Temp, newFileName, 
	 *           {}, function(err, stats) {
	 *             if (err) {
	 *                 log("An error occurred while retrieving file information: " + 
	 *                   JSON.stringify(err));
	 *             }
	 *             else {
	 *                 log("Retrieved file information: " + JSON.stringify(stats));
	 *             }
	 *         });
	 *     }
	 * });
	 * @param {Object} store The local file store for the file for which to retrieve information.
	 *		Use `Storage.FileSystem.Store.Local` for persistent files and
	 *		`Storage.FileSystem.Store.Temp` for temporary files.
	 * @param {String} filePath The full path of the file for which to retrieve information.
	 * @param {Object} options Options for the method call.
	 * @param {Boolean} [options.blocking=false] Set to `true` to retrieve information about the
	 *		file synchronously (i.e., the application pauses until the information is obtained).
	 *		This option can cause significant delays on some devices and should be used only if your
	 *		application cannot function without synchronous file access.
	 * @param {Boolean} [options.returnMd5=false] Set to `true` to retrieve the MD5 hash of the
	 *		file's contents. Available since ngCore 1.7.
	 * @cb {Function} cb The function that is called after retrieving information about the file.
	 * @cb-param {Object} [err] Information about the error, if any.
	 * @cb-param {String} [err.description] A description of the error.
	 * @cb-param {Storage.FileSystem#ErrorCode} [err.code] A code identifying the type of
	 *		error.
	 * @cb-param {Object} [stats] Information about the file.
	 * @cb-param {Number} [stats.atime] The time when the file was last accessed. Expressed in
	 *		Unix time (milliseconds since 00:00:00 UTC on January 1, 1970).
	 * @cb-param {Number} [stats.ctime] The time when the file's status was last changed (for 
	 *		example, the file was modified, or its owner or permissions changed). Expressed in
	 *		Unix time (milliseconds since 00:00:00 UTC on January 1, 1970).
	 * @cb-param {String} [stats.hash] The MD5 hash of the file's contents. Returned only if the
	 *		parameter `options.returnMd5` is set to `true`. Available since ngCore 1.7.
	 * @cb-param {Number} [stats.mtime] The time when the file was last modified. Expressed in
	 *		Unix time (milliseconds since 00:00:00 UTC on January 1, 1970).
	 * @cb-param {Number} [stats.size] The size of the file, in bytes.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.6
	 */
	statIn: function ( store, filePath, options, cb )
	{
		var cbId = 0;
		var op = 0;

		this._statCount++;

		if(Core.Capabilities.compareBinaryVersion(1, 6) < 0)
		{
			if(typeof(options) == 'function')
			{
				cb = options;
			}

			if(cb)
			{
				cb(new FSError(this.ErrorCode.Unsupported, "Not Supported"));
			}

			return;
		}

		if(typeof(options) !== 'object')
		{
			// assume 'options' arg is not supplied.
			// default behavior is non-blocking.
			cb = options;
		}
		else
		{
			if(options['blocking'])
			{
				op = this._options.blocking;
			}
			if(options['returnMd5'])
			{
				op |= this._options.returnMd5;
			}
		}

		if(cb)
		{
			cbId = this.cbIdCounter++;
			this.statRequests[ cbId ] = cb;
		}

		this._statAsyncSendGen(cbId, store, filePath, op);
	},

	/**
	 * Enumeration for local file stores.
	 * @name Store
	 * @fieldOf Storage.FileSystem#
	 */
	
	/**
	 * Temporary file store. Used for files that can be deleted at any time.
	 * @name Store.Temp
	 * @fieldOf Storage.FileSystem#
	 * @constant
	 */
	
	/**
	 * Persistent file store. Used for files that are intended to be saved between application
	 * sessions.
	 * @name Store.Local
	 * @fieldOf Storage.FileSystem#
	 * @constant
	 */
	
	
	/**
	 * Enumeration for errors that occurred during a request.
	 * @name ErrorCode
	 * @fieldOf Storage.FileSystem#
	 */
	
	/**
	 * The file was not found.
	 * @name ErrorCode.NotFound
	 * @fieldOf Storage.FileSystem#
	 * @constant
	 */
	
	/**
	 * An unknown error occurred.
	 * @name ErrorCode.Unknown
	 * @fieldOf Storage.FileSystem#
	 * @constant
	 */
	
	/**
	 * The requested operation is not available.
	 * @name ErrorCode.Unsupported
	 * @fieldOf Storage.FileSystem#
	 * @constant
	 */

	

	/**
	  * @private
	  */
	registerManifest: function ( manifest, cb )
	{
		// left for source code-level compatibility from < 1.6
		if ( cb )
		{
			cb( "" );
		}
	},
	
	/**
	 * @private
	 */
        _readFileCbRecv: function(cmd)
        {
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
                this._readFileCbRecvCore(msg["callbackId"], msg["data"], msg["error"]);
        },

	/**
	 * @private
	 */
        _readFileBinaryCbRecv: function(cmd)
        {
		var msg = {};
		if(!this._readFileBinaryCbRecvGen(cmd, msg))
			return;
                this._readFileCbRecvCore(msg["callbackId"], msg["data"], msg["error"]);
        },

	_readFileCbRecvCore: function(cbId, data, err)
	{
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
	/**
	 * @private
	 */
	_renameFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._renameFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},

	/**
	 * @private
	 */
	_statCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._statCbRecvGen(cmd, msg))
			return;

		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];

		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}

		var cb = this.statRequests[ cbId ];

		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.statRequests[ cbId ];

		var errObject = null;
		if(err !== '')
		{
			errObject = JSON.parse(err);
		}

		var dataObject = null;
		if(data !== '')
		{
			dataObject = JSON.parse(data);
		}

		cb ( errObject, dataObject );
	},

	/**
	 * @private
	 */
	_registerManifestCbRecv: function ( cmd )
	{
		var msg = {};
		if ( !this._registerManifestCbRecvGen( cmd, msg ) )
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLocE (" FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.registerManifestRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE (" FileSystem command : No register cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.registerManifestRequests[ cbId ];
		cb( err );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		Temp: 0,
		Local: 1
	},
	
	ErrorCode:
	{ 
		Unknown: -1,
		NotFound: -2,
		Unsupported: -3
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 338,
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	// Method readFileAsync = 10
	// Method writeFileAsync = 11
	// Method deleteFileAsync = 12
	// Method decompressFileAsync = 13
	// Method readFileBinaryCb = 14
	// Method writeFileAsyncBinary = 15
	// Method renameFileAsync = 16
	// Method renameFileCb = 17
	// Method registerManifest = 18
	// Method registerManifestCb = 19
	// Method statAsync = 20
	// Method statCb = 21
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				case 14:
					instance._readFileBinaryCbRecv( cmd );
					break;
				case 17:
					instance._renameFileCbRecv( cmd );
					break;
				case 19:
					instance._registerManifestCbRecv( cmd );
					break;
				case 21:
					instance._statCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_readFileBinaryCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileBinaryCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileBinaryCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseBinary( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileBinaryCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileBinaryCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_renameFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.renameFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.renameFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.renameFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerManifestCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.registerManifestCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.registerManifestCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.registerManifestCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_statCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.statCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.statCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.statCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.statCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x152ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_readFileSendGen: function( callbackId, storeId, filename, binary )
	{
		Core.Proc.appendToCommandString( 0x1520002, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), ( binary ? 1 : 0 ) ] );
	},
	
	/** @private */
	_writeFileSendGen: function( callbackId, storeId, filename, data, binary )
	{
		Core.Proc.appendToCommandString( 0x1520003, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), Core.Proc.encodeString( data ), ( binary ? 1 : 0 ) ] );
	},
	
	/** @private */
	_deleteFileSendGen: function( callbackId, storeId, filename )
	{
		Core.Proc.appendToCommandString( 0x1520004, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ) ] );
	},
	
	/** @private */
	_decompressFileSendGen: function( callbackId, storeId, filename, destination, returnFiles )
	{
		Core.Proc.appendToCommandString( 0x1520005, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), Core.Proc.encodeString( destination ), ( returnFiles ? 1 : 0 ) ] );
	},
	
	/** @private */
	_readFileAsyncSendGen: function( callbackId, storeId, filename, options )
	{
		Core.Proc.appendToCommandString( 0x152000a, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), +options ] );
	},
	
	/** @private */
	_writeFileAsyncSendGen: function( callbackId, storeId, filename, data, options )
	{
		Core.Proc.appendToCommandString( 0x152000b, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), Core.Proc.encodeString( data ), +options ] );
	},
	
	/** @private */
	_deleteFileAsyncSendGen: function( callbackId, storeId, filename, options )
	{
		Core.Proc.appendToCommandString( 0x152000c, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), +options ] );
	},
	
	/** @private */
	_decompressFileAsyncSendGen: function( callbackId, storeId, filename, destination, options )
	{
		Core.Proc.appendToCommandString( 0x152000d, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), Core.Proc.encodeString( destination ), +options ] );
	},
	
	/** @private */
	_writeFileAsyncBinarySendGen: function( callbackId, storeId, filename, data, options )
	{
		Core.Proc.appendToCommandString( 0x152000f, this, [ +callbackId, +storeId, Core.Proc.encodeString( filename ), Core.Proc.encodeBinary( data ), +options ] );
	},
	
	/** @private */
	_renameFileAsyncSendGen: function( callbackId, storeId, oldPath, newPath, options )
	{
		Core.Proc.appendToCommandString( 0x1520010, this, [ +callbackId, +storeId, Core.Proc.encodeString( oldPath ), Core.Proc.encodeString( newPath ), +options ] );
	},
	
	/** @private */
	_registerManifestSendGen: function( callbackId, filename )
	{
		Core.Proc.appendToCommandString( 0x1520012, this, [ +callbackId, Core.Proc.encodeString( filename ) ] );
	},
	
	/** @private */
	_statAsyncSendGen: function( callbackId, storeId, filePath, options )
	{
		Core.Proc.appendToCommandString( 0x1520014, this, [ +callbackId, +storeId, Core.Proc.encodeString( filePath ), +options ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}
	// readFileAsync: function( callbackId, storeId, filename, options ) {}
	
	// writeFileAsync: function( callbackId, storeId, filename, data, options ) {}
	
	// deleteFileAsync: function( callbackId, storeId, filename, options ) {}
	
	// decompressFileAsync: function( callbackId, storeId, filename, destination, options ) {}
	
	// _readFileBinaryCbRecv: function( cmd ) {}
	// writeFileAsyncBinary: function( callbackId, storeId, filename, data, options ) {}
	
	// renameFileAsync: function( callbackId, storeId, oldPath, newPath, options ) {}
	
	// _renameFileCbRecv: function( cmd ) {}
	// registerManifest: function( callbackId, filename ) {}
	
	// _registerManifestCbRecv: function( cmd ) {}
	// statAsync: function( callbackId, storeId, filePath, options ) {}
	
	// _statCbRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,

	//Diagnostics collector
	collectDiagnostics: function(type, interval)
	{
		var collectedInfo = {
			readFile: {
				count: this._readCount
			},
			writeFile: {
				count: this._writeCount
			},
			deleteFile: {
				count: this._deleteCount
			},
			renameFile: {
				count: this._renameCount
			},
			decompressFile: {
				count: this._decompressCount
			},
			stat: {
				count: this._statCount
			}
         };

		 return collectedInfo;
	}
});

// vim: ts=2:sw=2:noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Localization'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Localization'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Localization'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Localization.js';

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var LocalizationEngine = exports.LocalizationEngine = MessageEmitter.subclass(
/** @lends Core.Localization.prototype */
{
	classname: 'Localization',
    
    /**
     * Specifies the directory path to language files this object will load.
     */
    directoryPath:null,
    
    /**
     * Specifies the directory path to a language file for a specific language.
     */
	languageFilePath:null,
    
	/**
	 * @class The <code>Localization</code> class provides applications with access to localized strings.
	 * Applications supply a language code corresponding to a file in <code>Content/Localization/</code> or a JSON object.<br /><br /> 
     * Loading of dictionary files is an anynchronous process. Applications need to listen for emitted notifications from <code>Localization</code> objects that signal when the language dictionary
     * is modified. When a <code>Localization</code> object emits a notification, localized strings are available to the application (see <code>{@link Core.MessageEmitter#emit}</code>).
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	initialize: function(directoryPath)
	{
		if(!directoryPath){directoryPath = "./Content/Localization/";}
	    NgLogD("Localization : init ("+directoryPath+")");
	    this.directoryPath = directoryPath;
	    
        this.setLanguage(Capabilities.getLanguage());
	},
    
	/**
	 * Aynchronously load the localization dictionary for the specified language.
     * <br /><br />
	 * <b>Notes:</b> 
	 * <ul>
	 * <li>This function looks for the corresponding JSON dictionary file in the <code>Content/Localization</code> directory.
     * For example, <code>Content/Localization/fr.json</code>. If the application cannot load a dictionary, this call has no effect.</li>
     * <li><code>Localization</code> objects emit a notification with the new language string if this call succeeds.</li>
     *</ul>
	 *
	 * @example
	 * Core.Localization.addListener(listener, function()
     * {
     *     listener.label.setText(Core.Localization.getString("Hello World"));
     * });
	 * Core.Localization.setLanguage('es');
	 *
	 * @param {String} language The base name of a JSON dictionary file in <code>./Content/Language</code>.
	 * @see Core.Localization#setDictionary
	 * @see Core.MessageListener
	 * @returns {void}
	 * @status Flash, Test, FlashTested
	 * @since 1.0
	 */    
    setLanguage: function(language)
    {
        var dictionaryPath = this.languageFilePath = this.directoryPath + language + '.json';
        var self = this;
        NgLogD("Localization : reading json file "+ dictionaryPath);
        
        NgLogT("@@@ Localization.setLanguage readFile " + dictionaryPath + " +");
		FileSystem.readFile(dictionaryPath, {}, function(error, data)
        {
            NgLogT("@@@ Localization.setLanguage readFile " + dictionaryPath + " -");
            if(error === '')
            {
                NgLogD("Localization : successfully read json file "+ dictionaryPath);  
                self.setDictionary(language, JSON.parse(data));
            }
            else
            {
                NgLogD("Localization: unable to read json file "+ dictionaryPath + ", use default english setting instead");                
                self.setDictionary(language, null);
            }
        });
    },

	/**
	 * Directly set the language code and localization dictionary.
     * <code>Localization</code> objects emit a message with the new language string during this call.
	 * 
	 * @example
     * var chDictionary =    
     * {
     *     "Hello World": "&#20320;&#22909;&#19990;&#30028;"
     * };
	 * Core.Localization.setDictionary('ch', chDictionary);
	 * label.setText(Core.Localization.getString("Hello World"));
	 *
	 * @param {String} language A string identifying the specified language or localization.
	 * @param {Object} dictionary An object containing key/value pairs for the specified language.
	 * @see Core.Localization#setLanguage
	 * @see Core.MessageEmitter#emit
	 * @returns {void}
	 * @status Flash, Test, FlashTested
	 * @since 1.0
	 */    
    setDictionary: function(lang, dictionary)
    {
        this._lang = lang;
        this._dictionary = dictionary;
        this.emit(this._lang);
    },    
    
    /**
	 * Retrieve a localized string.
     * @param {String} str A localization key.
	 * @returns {String} The localized string or the provided key if the application is unable to lcoate the specified string.
	 * @status Flash, Test, FlashTested
	 * @since 1.0
	 */
	getString: function(str)
	{        
        if(this._dictionary && typeof this._dictionary === 'object')
        {
            var value = this._dictionary[str];
            if(value && typeof value !== 'undefined')
            {
                return value;
            }
        }
        
        return this.unknownString(str);
	},
	
	/** 
	  * @private
	  */
	unknownString:function(str){
		NgLogD("Localization: ... No localization for "+str+" in "+this._lang);
		return str;
	}
});

/**
 * Global Localization Singleton, gets initialized when the device locale is known.
 * @ignore
 */
exports.Localization = LocalizationEngine.singleton({});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Storage.js';

/**
 * @name Storage
 * @namespace Access files and key/value pairs.
 * @description The `Storage` module is a collection of classes that support data manipulation
 * operations. Each class handles a specific aspect of the module implementation and contains APIs
 * that support the class:
 *
 * + `{@link Storage.Diagnostics}`: Provide diagnostic information about the app's use of the
 * `Storage` module.
 * + `{@link Storage.FileSystem}`: Construct objects for reading a file, writing to a file, deleting
 * a file, decompressing a file, or retrieving information about a file.
 * + `{@link Storage.KeyValue}`: Construct objects that store key/value pairs on the device.
 * + `{@link Storage.KeyValueCache}`: Obtain access to the local key/value store.
 *
 * When you use these classes, the data you store is not tied to a specific Mobage user. If you need
 * to store user-specific data, do one of the following:
 *
 * 1. Verify that your application is storing and retrieving data for the correct Mobage user. Keep
 * in mind that several different Mobage users could all use the same application on the same
 * device.
 * 2. As an alternative to `{@link Storage.KeyValue}`, consider using the
 * `{@link Social.Common.Appdata}` class, which stores application data that is tied to a specific
 * Mobage user.
 */
function StorageLoader(map) {
	this.add = function(key, toEval) {
		this.__defineGetter__(key, function() {
			delete this[key];
			return this[key] = toEval();
		});
	};
	for (var k in map) {
		if (map.hasOwnProperty(k)) this.add(k, map[k]);
	}
}

exports.Storage = new StorageLoader({
	'KeyValue': function() { return require('NGCore/Client/Storage/KeyValue').KeyValue; },
	'KeyValueCache': function() { return require('NGCore/Client/Storage/KeyValue').KeyValueCache; },
	'FileSystem': function() { return require('NGCore/Client/Storage/FileSystem').FileSystem; },
	'Diagnostics': function() { return require('NGCore/Client/Storage/Diagnostics').Diagnostics; }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/_LocalGameList.js';

////////////////////////////////////////////////////////////////////////////////
// Class _LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

var _LocalGameList = exports._LocalGameList = Class.singleton (
/** @lends Core._LocalGameList.prototype */
{
	classname: '_LocalGameList',

	/**
	 * The <code>_LocalGameList</code> class constructs a singleton object that identifies all of the
	 * applications that a client can download. It also manages downloading of updated applications and
	 * ensures that adequate space is available to save updated files on the device.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this.mGameList = [];
		var Storage = require('NGCore/Client/Storage').Storage;
		this.mFile = Storage.FileSystem;
		this.mGameStore = Storage.KeyValueCache.global("Core.GameList");

		this.mLoadingGames = {};
		this.mActiveGameKey = "activeGames";
		this.mRequiredAvailableSpace = 0;
		this.mSpaceAvailable = 0;
		this.mSpaceFreeCallbacks = [];
		this._firstBootGameLaunch = true;

		this._getRepoSpaceSendGen();

		this._setStage(this.ProgressStage.BootFirst);
		this._reloadGameList();
		this._allowDeterminateProgress = true;
	},
	
	ProgressStage:
	{
		BootFirst: {boot:[-1,0], progressBar:[0,0.25]},
		CheckConfiguration: {boot:[-1,0], progressBar:[0.25,0.25]},
		CheckManifest: {boot:[-1,0], progressBar:[0.25,0.25]},
		DownloadFiles: {boot:[0.1,0.9], progressBar:[0.25,0.75]},
		Launching: {boot:[-1,0], progressBar:[0.75,1]}
	},
	
	_setStage: function(stage)
	{
		this._progressStage = stage;
		if (typeof stage == 'object') {
			this._progressMin = this._progressStage[ this._hasProgressBar ? "progressBar" : "boot"][0];
			this._progressRange = this._progressStage[ this._hasProgressBar ? "progressBar" : "boot"][1];
		} else {
			this._progressMin = -1;
			this._progressRange = 0;
		}
		console.log('min:', this._progressMin, 'range:', this._progressRange);
		this._setProgress(0);
	},
	
	_nextStage: function()
	{
		switch(this._progressStage)
		{
			case this.ProgressStage.BootFirst:
				this._setStage(this.ProgressStage.CheckConfiguration);
				break;
			case this.ProgressStage.CheckConfiguration:
				this._setStage(this.ProgressStage.CheckManifest);
				break;
			case this.ProgressStage.CheckManifest:
				this._setStage(this.ProgressStage.DownloadFiles);
				break;
			case this.ProgressStage.DownloadFiles:
				this._setStage(this.ProgressStage.Launching);
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 303,
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method setUpdateProgress = 7
	// Method pauseUpdate = 8
	// Method resumeUpdate = 9
	// Method cancelUpdate = 10
	// Method updateProgress = 11
	// Method allowBGUpdates = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method setProgressText = 15
	// Method setSplashVisible = 16
	// Method exceptionForwarded = 17
	// Method setHasCustomProgressBar = 18
	// Method gameUnbundled = -19
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._updateGameRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 6:
					instance._deleteGameRecv( cmd );
					break;
				case 8:
					instance._pauseUpdateRecv( cmd );
					break;
				case 9:
					instance._resumeUpdateRecv( cmd );
					break;
				case 10:
					instance._cancelUpdateRecv( cmd );
					break;
				case 12:
					instance._allowBGUpdatesRecv( cmd );
					break;
				case 13:
					instance._runGameRecv( cmd );
					break;
				case 14:
					instance._finishGameRecv( cmd );
					break;
				case 17:
					instance._exceptionForwardedRecv( cmd );
					break;
				case 18:
					instance._setHasCustomProgressBarRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -19:
					_LocalGameList._gameUnbundledRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[303] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "mdFive" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "mdFive" ] === undefined )
		{
			NgLogE("Could not parse mdFive in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "game" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "game" ] === undefined )
		{
			NgLogE("Could not parse game in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_pauseUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_resumeUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_cancelUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_allowBGUpdatesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		obj[ "allow" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "allow" ] === undefined )
		{
			NgLogE("Could not parse allow in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_runGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.finishGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_exceptionForwardedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		obj[ "exceptionString" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "exceptionString" ] === undefined )
		{
			NgLogE("Could not parse exceptionString in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setHasCustomProgressBarRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.setHasCustomProgressBar from command: " + cmd );
			return false;
		}
		
		obj[ "hasProgressBar" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "hasProgressBar" ] === undefined )
		{
			NgLogE("Could not parse hasProgressBar in _LocalGameList.setHasCustomProgressBar from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	$_gameUnbundledRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.gameUnbundled from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x12fffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_updateDoneSendGen: function( id, error )
	{
		Proc.appendToCommandString( 0x12f0003, this, [ +id, Proc.encodeString( error ) ] );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( 0x12f0004, this );
	},
	
	/** @private */
	_setUpdateProgressSendGen: function( progress )
	{
		Proc.appendToCommandString( 0x12f0007, this, [ +progress ] );
	},
	
	/** @private */
	_updateProgressSendGen: function( url, cur, total, error )
	{
		Proc.appendToCommandString( 0x12f000b, this, [ Proc.encodeString( url ), +cur, +total, ( error ? 1 : 0 ) ] );
	},
	
	/** @private */
	_setProgressTextSendGen: function( text )
	{
		Proc.appendToCommandString( 0x12f000f, this, [ Proc.encodeString( text ) ] );
	},
	
	/** @private */
	_setSplashVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( 0x12f0010, this, [ ( visible ? 1 : 0 ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _updateGameRecv: function( cmd ) {}
	// updateDone: function( id, error ) {}
	
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// _deleteGameRecv: function( cmd ) {}
	// setUpdateProgress: function( progress ) {}
	
	// _pauseUpdateRecv: function( cmd ) {}
	// _resumeUpdateRecv: function( cmd ) {}
	// _cancelUpdateRecv: function( cmd ) {}
	// updateProgress: function( url, cur, total, error ) {}
	
	// _allowBGUpdatesRecv: function( cmd ) {}
	// _runGameRecv: function( cmd ) {}
	// _finishGameRecv: function( cmd ) {}
	// setProgressText: function( text ) {}
	
	// setSplashVisible: function( visible ) {}
	
	// _exceptionForwardedRecv: function( cmd ) {}
	// _setHasCustomProgressBarRecv: function( cmd ) {}
	// $_gameUnbundledRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


	,
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	_updateGameRecv: function( cmd )
	{
		this._getRepoSpaceSendGen();

		var o = {};
		this._updateGameRecvGen(cmd, o);

		if (o.url in this.mLoadingGames)
		{
			this.mLoadingGames[o.url].id = o.id;
			this.mLoadingGames[o.url].dlman.resume();
		}
		else
		{
			this.updateGame(o.url, o.id,
				(function (url, newFiles, err)
				{
					o.id = this.mLoadingGames[url].id;
					this._updateDoneSendGen(o.id, err || ""); // err should be a string.
				}).bind(this, o.url)
			);
		}
	},
	mobageRunGame: function (funk)
	{
		this._gameRunner = funk;
	},
	_runGameRecv: function( cmd )
	{
		var o = {};
		this._runGameRecvGen(cmd, o);
		if (this._gameRunner)
		{
			console.log("_LGL running gameRunner " + o.url);
			this._gameRunner(o.url);
		}
		else
		{
			console.log("_LGL running game " + o.url);
			var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
			_int_LGL.launch(o.url, _int_LGL.ProcID.Game);
		}
	},
	/**
	 * set the function that kills the current game app
	 */
	setFinishGameHandler: function(funk)
	{
		this._finishGameHandler = funk;
	},
	_finishGameRecv: function()
	{
		if (this._finishGameHandler)
		{
			this._finishGameHandler();
		} else {
			console.log("_LocalGameList: finishGameHandler is not set");
		}
	},
	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space;
		console.log("SD card space available(b): " + this.mSpaceAvailable);

		var length = this.mSpaceFreeCallbacks.length;
		while (length--)
		{
			(this.mSpaceFreeCallbacks.pop())();
		}
	},

	_deleteGameRecv: function( cmd )
	{
		// site to calc md5: http://pajhome.org.uk/crypt/md5/
		var allowedGames =
		[
			"http://10.15.", // Allow partial ones, for testing
			'http://10.16.',
			'http://gamehub.mobage.com/app/1.0s/gamehub',
			'url of allowed game'
		];

		var obj = {};
		this._deleteGameRecvGen(cmd, obj);
		var i;
		for(i in allowedGames)
		{
			var match = obj.game.match(allowedGames[i]);
			if(match && !match.index)
			{
				NgLogD("Deleting " + obj.mdFive);
				this.deleteGameFiles(obj.mdFive);

				var doneCB = (function ()
				{
					NgLogD("Finished deleting game from " + this.mActiveGameKey + " for " + obj.mdFive );
				}).bind(this);
				this._deleteGameFromStorage(obj.mdFive,doneCB);

				return;
			}
			else
			{
				// for testing, allow any local server starting with 10.15
			}
		}
		NgLogE("_LocalGameList unauthorized call to deleteGame from "+obj.game+"!");
	},

// _deleteGameFromStorage is for deleting the games info from LGL storage, not the game's storage

	_deleteGameFromStorage: function(mdFive,doneCB)
	{
		var self = this;
		this.mGameStore.getItem(this.mActiveGameKey, {},
			function(error, value)
			{
				var list = JSON.parse(value);
				
				var good = false;
				var ind;
				var out = [];
				for(ind = 0; ind < list.length; ++ind)
				{
					if(list[ind].name == mdFive)
						good = true;
					else
						out.push(list[ind]);
				}
				
				if( good )
				{
					NgLogD("_LocalGameList found and removed " + mdFive);
					self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(out), { blocking: true }, doneCB);
				}
				else
				{
					NgLogD("_LocalGameList failed to find and remove " + mdFive);
					doneCB("Could not remove item: " + error);
				}
				
			}, true
		);
	},

	getGameConfig: function(identifier, isMDFive, callBack)
	{
		if (typeof isMDFive == 'function')
		{
			callBack = isMDFive;
			isMDFive = false;
		}

		var folder;
		if (isMDFive)
		{
			folder = identifier;
		}
		else
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			var norm = Util.NormalizeUrl(identifier);
			folder = toMD5(norm);
		}

		NgLogT("@@@ _LocalGameList.getGameConfig readFile +");

		this.mFile.readFile(folder + "/" + Capabilities._getConfigFile(), {},
			function (err, contents)
			{
				NgLogT("@@@ _LocalGameList.getGameConfig readFile -");
				
				var ret = {};
				if (err || !contents)
				{
					console.log("Could not get config from %s! err: %s", identifier, err);
				}
				else
				{
					ret = JSON.parse(contents);
				}
				callBack(ret);
			}
		);
	},

	getRepoSpace: function()
	{
		return this.mSpaceAvailable;
	},

	getConfig: function(gameOrigin, name, callback, failEarly)
	{// callback = function (config, err)
		// XHR
		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var Util = require('NGCore/Client/Network/Util').Util;
		
		var httpStatus = 0;
		
		Util.OperationWithRetries(function(failCb)
		{
			var req = new XHR();
			req.onreadystatechange = function()
			{
				if(req.readyState == 4)
				{
					httpStatus = req.status;
					if(httpStatus == 200)
					{
						// Succes.
						callback(req.responseText);
					}
					else if(httpStatus == 404)
					{
						// File not on server, so load from the regular location
						console.log("no configuration file found at %s, using root server", gameOrigin + name);
						callback( "{}" );
					}
					else
					{
						//Error! Retry
						failCb();
					}
				}
			};
			req.setRequestHeader("X-Distribution", Capabilities.getDistributionName());
			req.open('GET', gameOrigin + name + Util.getCacheBustingString(), true);
			req.send();
		}, function()
		{
			callback(null, true, httpStatus);
		}, failEarly);
	},

	// gameOrigin: url to folder holding webgame.ngmanifest
	// doneCB = function(totalBytes, error)
	updateGame: function(gameOrigin, id, doneCB, failEarly, failAllowed)
	{
		// console.log ( "LGL.updateGame url = " + gameOrigin );
		// console.log ( "LGL.updateGame boot game = " + Capabilities.getBootGame() );
		
		var re = new RegExp(".*" + Capabilities.getBootGame());
		var match = gameOrigin.match(re);
		
		if (match) 
			this._firstBootGameLaunch = false;
			
		// console.log ( "_LocalGameList.updateGame updating game." );

		// Normalize URL
		var Util = require('NGCore/Client/Network/Util').Util;
		gameOrigin = Util.NormalizeUrl(gameOrigin);

		var name = Util.GetMD5HashDirectoryFromUrl(gameOrigin);
		this.mLoadingGames[gameOrigin] = {id: id};

		NgLogI("_LocalGameList.updateGame(): url = " + gameOrigin + " name = " + name);

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var caps = require("NGCore/Client/Core/Capabilities").Capabilities;
		var build = "/" + buildPath[caps.getPlatformOS()];

		this._setStage(this.ProgressStage.CheckConfiguration);

		var curContUrl = "";
		var configFile = name + "/" + caps._getConfigFile();
		
		// This is guaranteed to be synchronous, so will always occur before the callback for subsequent operations.
		this.mFile.readFile(configFile, {},
			function(err, data)
			{
				if (data)
				{
					var obj = JSON.parse(data);
					curContUrl = obj.contentUrl;
				}
			}
		);

		var url = gameOrigin + build + "/" + caps._getConfigFile();
		NgLogI("_LocalGameList.updateGame(): downloading configuration.json, url = " + url);
		this.getConfig(gameOrigin + build, "/" + caps._getConfigFile(),
        (function(config, error, status)
		{
			if (error)
			{
				NgLogI("_LocalGameList.updateGame(): ERROR downloading configuration.json, url = " + url);
				this._setStage(-1); // ERROR
				doneCB(0, error);
				delete this.mLoadingGames[gameOrigin];
			}
			else
			{
				// Read config
				var parsedConfig = JSON.parse(config);
				if(!parsedConfig.contentUrl)
				{
					parsedConfig.contentUrl = gameOrigin + build;
				}
				else if (parsedConfig.contentUrl == curContUrl)
				{
					NgLogI("_LocalGameList.updateGame(): Game is up to date! url = " + url);

					// no need to update.
					this._setStage(this.ProgressStage.Launching);
					this.mFile.writeFile(configFile, JSON.stringify(parsedConfig), {}, (function(err)
					{
						if(err) {
							NgLogE("gameUpdate failed to write config:" + err);
						}
						doneCB(0, err);
						delete this.mLoadingGames[gameOrigin];
					}).bind(this));
					return;
				}

				NgLogI("_LocalGameList.updateGame(): Downloading game! url = " + url);
				this._setStage(this.ProgressStage.CheckManifest);
				this._callDownloadManifest(parsedConfig, gameOrigin, name, failEarly, failAllowed, (function(bytes, error)
				{
					NgLogI("_LocalGameList.updateGame(): Finished Downloading game! url = " + url);

					if (! error) {
						var that = this;
						this._reloadGameList({name:name, url:gameOrigin}, function()
						{
							if (doneCB && (typeof doneCB == 'function')) {
								doneCB(bytes, error);
								delete that.mLoadingGames[gameOrigin];
							}
						});
					} else {
						doneCB(bytes, error);
						delete this.mLoadingGames[gameOrigin];
					}
				}).bind(this));
			}
		}).bind(this), failEarly);
	},

	_allowBGUpdatesRecv: function( cmd )
	{
		var o = {};
		this._allowBGUpdatesRecvGen(cmd, o);
		this._pauseOrResumeAll(o.allow);
	},

	_pauseOrResumeAll: function(resume)
	{
		for (var i in this.mLoadingGames)
		{
			if (resume)
			{
				console.log("Resuming download of " + i);
				this.resumeUpdate(i);
			}
			else
			{
				console.log("Pausing download of " + i);
				this.pauseUpdate(i);
			}
		}
	},

	pauseUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.pause();
				this.mLoadingGames[url].userPause = true;
			}
		}
	},

	_pauseUpdateRecv: function(cmd)
	{
		var o = {};
		this._pauseUpdateRecvGen(cmd, o);
		this.pauseUpdate(o.url);
	},

	resumeUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.resume();
				this.mLoadingGames[url].userPause = false;
			}
		}
	},

	_resumeUpdateRecv: function(cmd)
	{
		var o = {};
		this._resumeUpdateRecvGen(cmd, o);
		this.resumeUpdate(o.url);
	},

	cancelUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if (this.mLoadingGames[url].dlman) {
                this.mLoadingGames[url].dlman.abort();
            }
			delete this.mLoadingGames[url];

			//Cancel the keep alive request as well
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

			LifecycleEmitter.cancelEngineKeepAlive(_LocalGameList.classname);
		}
	},

	_cancelUpdateRecv: function(cmd)
	{
		var o = {};
		this._cancelUpdateRecvGen(cmd, o);
		this.cancelUpdate(o.url);
	},

	_setProgress: function (progress) {
		if(progress > 1) progress = 1;
		// Indeterminate
		if(progress < 0) progress = -1;
		this._progress = progress;
		if (progress >= 0 && this._allowDeterminateProgress) {
			this._setUpdateProgressSendGen( this._progressMin + progress * this._progressRange );
		} else {
			this._setUpdateProgressSendGen(-1);
		}
	},
	
	_setAllowDeterminateProgress: function (allow) {
		this._allowDeterminateProgress = allow;
		this._setProgress(this._progress);
	},

	listenToProgress: function (listener)
	{
		this._privListener = listener;
	},

	_updateProgress: function(url, prog, total, err)
	{
		//console.log("Updating progress for: %s, %d, %d " + err, url, prog, total);
		if (this._privListener)
			this._privListener(url, prog, total, err);

		if (this.mLoadingGames[url] && this.mLoadingGames[url].id >=0)
			this._updateProgressSendGen(url,prog,total,err);
	},

	// doneCB = function(totalBytes, error)
	_callDownloadManifest: function (config, gameOrigin, name, failEarly, failAllowed, doneCB)
	{
		var contentUrl = config.contentUrl;
		var reportTotalBytes = 0;
		var self = this;
		var Downloader = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		
		var manifestName = require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config);

		// Do download
		(function doDownload()
		{
			var dler = new Downloader();
			dler.mLocalGameList = self;
			var firstProgress = true;
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
			LifecycleEmitter.requestEngineKeepAlive(_LocalGameList.classname);

			// Only allow this on iOS
			config.omitJsUpdate = config.omitJsUpdate && (Capabilities.getPlatformOS() == "iPhone OS");
			dler._setConfig(config);
			dler.start(contentUrl, name, {'webgame.ngmanifest':manifestName}, function(bytesDownloaded, bytesTotal)
			{
				if(firstProgress)
				{
					// First progress callback is made when manifest is downloaded.
					firstProgress = false;
					self._setStage(bytesDownloaded < bytesTotal ? self.ProgressStage.DownloadFiles : self.ProgressStage.Launching);
					reportTotalBytes = bytesTotal;
				}
				else
				{
					self._setProgress( bytesDownloaded / bytesTotal );
				}

				// update LGL
				self._updateProgress(gameOrigin, bytesDownloaded, bytesTotal);
			}, function(error, manifest, wasCached)
			{
				LifecycleEmitter.cancelEngineKeepAlive(_LocalGameList.classname);

				if (failAllowed)
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes, error);
					}
				}
				else if(error)
				{
					NgLogE("Error: " + error);
					// update LGL
					self._updateProgress(gameOrigin, 0, 0, error);
					doneCB(0, error);
				}
				else
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes);
					}
				}
			}, false, failEarly);
			self.mLoadingGames[gameOrigin].dlman = dler;
		})();
	},

	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace = space;
		this.mSpaceFreeCallbacks.push(
			(function()
			{
				if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
				{
					if (this._privListener)
					{
						this._privListener("", 0, 0, "SD card is full");
					}
					else
					{
						console.log("Warning!! Mobage is not handling SD card full error!");
						// This is Preservation of ancient code which has and will likely never execute
						var checkAgain = function()
						{
							if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
							{
								this.pruneGames(1);
								this.mSpaceFreeCallbacks.push(checkAgain);
							}
							else
							{
								cb();
							}
						};
						// Is a redundant check on space, but looks better/is simpler/won't ever be used anyhow
						checkAgain();
					}
				}
				else
				{
					cb();
				}
			}).bind(this)
		);

		this._getRepoSpaceSendGen();
	},

	pruneGames: function(number)
	{
		var self = this;

		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this.mGameStore.getItem(this.mActiveGameKey, {},
			function(error, value)
			{
				var list = JSON.parse(value);
				list.sort(sort);
				while (number-- && (list.length - 1))
				{
					var game = list.pop();

					// Do not delete the currently loading game
					if (!(game.name in self.mLoadingGames))
					{
						// delete game
						self.deleteGameFiles(game.name);
					}
					else
					{
						list.push(game);
					}
				}

				// Save the data
				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list), {});
			}, true
		);
	},

	deleteGame: function (url, callBack)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var norm = Util.NormalizeUrl(url);
		var mdFive = toMD5(norm);

		this.deleteGameFiles(mdFive);
		this._deleteGameFromStorage(mdFive, callBack);
	},

	// Delete the KeyValueCache.local of the given game
	deleteGameKeyValue: function(mdFive)
	{
		var kvm = require('NGCore/Client/Storage').KeyValueCache;
		kvm.global(mdFive).clear({});
	},

	deleteGameFiles: function(game)
	{
		var self = this;
		self.mFile.deleteFile( game, {},
			function(err)
				{
					if(err === "" )
						NgLogI('Deleted');
					else
						NgLogD("Could not delete game");

					self._getRepoSpaceSendGen();
				});
	},

	getGameList: function()
	{
		return this.mGameList;
	},

	clearWatch: function()
	{
		var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
		fs.deleteFile(".watch", {});
	},

	/**
	 * @private
	 */
	_reloadGameList: function(newItem, cb)
	{
		this.mGameStore.getItem(this.mActiveGameKey, {},
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				if (newItem)
				{
					var bNew = true;
					for (var i in list)
					{
						if (list[i].name == newItem.name)
						{
							bNew = false;
							newItem.lastRun = list[i].lastRun;
							list[i] = newItem;
							break;
						}
					}

					if (bNew)
					{
						list.push(newItem);
					}
					this.mGameStore.setItem(this.mActiveGameKey, JSON.stringify(list), {});
				}

				this.mGameList = list;

				if (typeof cb == 'function')
					cb();
			}).bind(this),
			true
		);
	},

	_getRunningGame: function(callBack)
	{
		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this._reloadGameList(false, (function(cb)
		{
			var list = this.mGameList;
			list.sort(sort);
			var current = null;
			var len = list.length;
			for (var i = 0; i < len; ++i)
			{
				if (list[i].lastRun)
				{
					current = list[i];
					break;
				}
			}
			if (current && current.url)
				cb(current.url);
		}).bind(this, callBack));
	},

	/** @private */
	_pausingGame: function()
	{
		// true to resume download when pausing a game
		this._pauseOrResumeAll(true);
	},

	/** @private */
	_resumingGame: function()
	{
		// Check if the current game allows downloading
		this._getRunningGame((function(game)
		{
			this.getGameConfig(game, (function(config)
			{
				if (config.noBackgroundUpdates)
				{
					// false to pause download when resuming a game
					this._pauseOrResumeAll(false);
				}
			}).bind(this));
		}).bind(this));
	},

	setSplashVisible: function( visible )
	{
		this._setSplashVisibleSendGen(visible);
	},

	setProgressText: function( text )
	{
		this._progressText = text;
		this._setProgressTextSendGen(text);
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	/*
	 * Set the exception handler. Default is undefined.
	 * @param {Function} the function that handles the exception occurred in the Game proc. signature: function(exceptionString)
	 */
	setExceptionHandler: function(func)
	{
		this._exceptionHandler = func;
	},

	_exceptionForwardedRecv: function( cmd )
	{
		var obj = {};
	        var exception = {};
		this._exceptionForwardedRecvGen(cmd, obj);
		try {
			exception = JSON.parse(obj.exceptionString);
		} catch (e) {
			console.log("ERROR: Unparseable exception: " + obj.exceptionString);
		}
		if (this._exceptionHandler) this._exceptionHandler(exception);
	},
	
	_setHasCustomProgressBarRecv: function( cmd ) {
		var obj = {};
		this._setHasCustomProgressBarRecvGen(cmd, obj);
		this._hasProgressBar = obj.hasProgressBar;
	},

	registerUnbundleListener: function(cb)
	{
		if (this.unbundled)
		{
			cb();
		}
		else
		{
			this.unbundleListener = cb;
		}
	},
	$_gameUnbundledRecv: function( cmd )
	{
		this.unbundled = true;
		if (this.unbundleListener)
		{
			this.unbundleListener();
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/NativeAppLaunch.js';

// @deprecated
var NativeAppLaunch;

exports.NativeAppLaunch = NativeAppLaunch;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewGeometry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ViewGeometry.js';

var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

/**
 * The `UI.ViewGeometry` namespace includes a collection of classes and objects that control spatial
 * components for UI views. Classes that belong to `UI.ViewGeometry` include:
 * 
 * + `{@link UI.ViewGeometry.Rect}`
 * + `{@link UI.ViewGeometry.Scale}`
 * 
 * `UI.ViewGeometry` also includes the following enumerated constants:
 * 
 * + `{@link UI.ViewGeometry#FitMode}`
 * + `{@link UI.ViewGeometry#Gravity}`
 * @name UI.ViewGeometry
 * @namespace
 * @description
 */

var ViewGeometry = exports.ViewGeometry = {};

var Scale = ViewGeometry.Scale = exports.Scale = Class.singleton(
/** @lends UI.ViewGeometry.Scale.prototype */
{
	/**
	 * @name UI.ViewGeometry.Scale
	 * @class The `UI.ViewGeometry.Scale` class is a singleton that provides scaling factors for
	 * modifying the size of a view rectangle.
	 * @singleton
	 * @augments Core.Class
	 */
	initialize: function() {
		var screenUnits = Capabilities.getScreenUnits();
		this.iOSConversion = screenUnits;
		this.pointConversion = this.iOSConversion * 160 / 72; 
	},

	// Use the values of generated constants... Mostly for if we need to send these to native in the future.
	Pixels: Commands.Scaling.Pixels,
	Points: Commands.Scaling.Points,
	Unit: Commands.Scaling.Unit,
	Percent: Commands.Scaling.Percent,
	iPhone: Commands.Scaling.iPhone,
	
	// Internals.
    
	pointConversion: 1.0,
    
	iOSConversion: 1.0,

    /** 
     * Retrieve a scaling factor that can be used when modifying the size of a view rectangle.
     * @param {UI.Commands#Scaling} units The unit of measure.
     * @param {Number} size The width or height, in pixels, of the device's screen. Use the width
	 *		when modifying a view rectangle's width and the height when modifying a view rectangle's
	 *		height.
     * @returns {Number} The scaling factor.
     * @since 1.0
     */
	getScale: function(units, size) {
		switch (+units) {
			case this.Points:
				return this.pointConversion;
			case this.Unit:
				return size;
			case this.Percent:
				return size / 100;
			case this.iPhone:
				return this.iOSConversion;
		}
		return 1.0;
	}
});

/** 
 * Enumeration for image or text gravity in a view. The values in this enumeration can be assigned 
 * to the `imageGravity`, `textGravity`, or `titleGravity` property for any `UI` class that accepts
 * these properties.
 * @name Gravity
 * @fieldOf UI.ViewGeometry#
 */
var Gravity = ViewGeometry.Gravity = exports.Gravity = 

{
	/**
	 * Center of gravity is the top-left corner of the view.
	 * @name Gravity.TopLeft
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	TopLeft: [0.0,0.0],
	
	/** 
	 * Center of gravity is the top-center portion of the view. 
	 * @name Gravity.TopCenter
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	TopCenter: [0.5,0.0],
	
	/** 
	 * Center of gravity is the top-right corner of the view. 
	 * @name Gravity.TopRight
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	TopRight: [1.0, 0.0],
	
	/** 
	 * Center of gravity is the left side of the view. 
	 * @name Gravity.Left
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	Left: [0.0,0.5],
	
	/** 
	 * Center of gravity is the center of the view. 
	 * @name Gravity.Center
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	Center: [0.5,0.5],
	
	/** 
	 * Center of gravity is the right side of the view. 
	 * @name Gravity.Right
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	Right: [1.0,0.5],
	
	/** 
	 * Center of gravity is the bottom-left corner of the view. 
	 * @name Gravity.BottomLeft
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	BottomLeft: [0.0,1.0],
	
	/** 
	 * Center of gravity is the bottom-center portion of the view. 
	 * @name Gravity.BottomCenter
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	BottomCenter: [0.5,1.0],
	
	/** 
	 * Center of gravity is the bottom-right corner of the view. 
	 * @name Gravity.BottomRight
	 * @fieldOf UI.ViewGeometry#
	 * @constant
	 */
	BottomRight: [1.0,1.0]
};

 
var FitModes = ViewGeometry.FitModes = exports.FitModes = Commands.FitMode;
 
/** 
 * Enumeration for different ways to fit an image within a view. The image is resized relative to 
 * the size of the view, minus any insets that have been applied to the view.
 * @name FitMode
 * @fieldOf UI.ViewGeometry#
 */

/**
 * The image is not scaled.
 * @name FitMode.None
 * @fieldOf UI.ViewGeometry#
 * @constant
 */

/**
 * The image is proportionally scaled to fit completely within the view. If the image is smaller
 * than the size of the view, it is upscaled to fill either the width or height of the view.
 * @name FitMode.Inside
 * @fieldOf UI.ViewGeometry#
 * @constant
 */
 
/**
 * The image is proportionally scaled to fill the entire view, clipping any part of the image that
 * does not fit within the view.
 * @name FitMode.Fill
 * @fieldOf UI.ViewGeometry#
 * @constant
 */
 
/**
 * The image is non-proportionally scaled to fill the entire view.
 * @name FitMode.Stretch
 * @fieldOf UI.ViewGeometry#
 * @constant
 */

/**
 * The image is proportionally scaled to fill the entire width of the view, clipping any part of the
 * image that does not fit within the view.
 * @name FitMode.AspectWidth
 * @fieldOf UI.ViewGeometry#
 * @constant
 */

/**
 * The image is proportionally scaled to fill the entire height of the view, clipping any part of 
 * the image that does not fit within the view.
 * @name FitMode.AspectHeight
 * @fieldOf UI.ViewGeometry#
 * @constant
 */

/**
 * The image is scaled down proportionally to fit within the view. If the image is smaller than
 * the size of the view, the image is displayed at its actual size, with no upscaling.
 * @name FitMode.InsideNoUpscaling
 * @fieldOf UI.ViewGeometry#
 * @constant
 */

	
var Rect = ViewGeometry.Rect = exports.Rect = Class.subclass(
/** @lends UI.ViewGeometry.Rect.prototype */
{
	/**
	 * @name UI.ViewGeometry.Rect
	 * @class The `UI.ViewGeometry.Rect` class constructs objects that represent a rectangular
	 * portion of the device's screen. Use these objects to position a user interface's components.
	 *
	 * The constructor must specify the view rectangle's point of origin, width, and height. Your
	 * application can pass these parameters to the constructor in any of the following formats:
	 *
	 * 1. Four individual integers that represent the following, measured in pixels:
	 *     1. The location of the rectangle's upper left corner along the X axis.
	 *     2. The location of the rectangle's upper left corner along the Y axis.
	 *     3. The width of the rectangle.
	 *     4. The height of the rectangle.
	 * 2. An array that contains the four integers described above.
	 * 3. Two arrays of integers. The first array contains the first and second integers described
	 * above. The second array contains the third and fourth integers described above.
	 * 4. A `UI.ViewGeometry.Rect` object.
	 * @constructs Create a view rectangle.
	 * @augments Core.Class
	 * @example
	 * // Create a view rectangle by passing in an array of four integers.
	 * var rect = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * @example
	 * // Create a view rectangle by passing in two arrays.
	 * var rect = new UI.ViewGeometry.Rect([0, 0], [100, 50]);
	 * @example
	 * // Create a view rectangle by passing in another view rectangle.
	 * var rect1 = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * var rect2 = new UI.ViewGeometry.Rect(rect1);
	 * @param {Number|Number[]|UI.ViewGeometry.Rect} arg0 The rectangle's point of origin, width,
	 *		and height in one of the formats specified above.
	 * @since 1.0
	 */
    initialize: function(arg0)
    {
    	if (arg0 instanceof this.constructor){
    		// Another Rect
    		this.x = arg0.x;
    		this.y = arg0.y;
    		this.w = arg0.w;
    		this.h = arg0.h;
    	} else if (arg0 instanceof Array) {
    		if (arguments.length == 2 
    			&& arguments[0].length >= 2 
    			&& arguments[1] instanceof Array 
    			&& arguments[1].length >= 2) {
				
				// Arguments can be two arrays, one of which is a point and one of which is a size,
				this.x = arguments[0][0];
				this.y = arguments[0][1];
				this.w = arguments[1][0];
				this.h = arguments[1][1];
			}
			else if (arguments.length == 1 && arg0.length >= 4) {
				// Single Array
				this.x = arg0[0];
				this.y = arg0[1];
				this.w = arg0[2];
				this.h = arg0[3];
			}
			else {
				NgLogD("UI.ViewGeometry.Rect initialized with unparseable Array(s)");
			}
		} else if (arguments.length == 4) {
			// Four numbers
			this.x = arguments[0];
			this.y = arguments[1];
			this.w = arguments[2];
			this.h = arguments[3];
		}
		return this;
    },
	/**
	 * Determine whether the view rectangle is missing one of its component values or has an area of
	 * 0.
	 * @example
	 * // Create a view rectangle with a height of 0.
	 * var rect = new UI.ViewGeometry.Rect([0, 0, 100, 0]);
	 * // Verify that the view rectangle is empty.
	 * if (rect.isEmpty()) {
	 *     console.log("Empty view rectangle");
	 * }
	 * @returns {Boolean} Set to `true` if any component value is missing or if the view rectangle
	 *		has an area of 0.
	 * @since 1.0
	 */
	isEmpty: function(){
		return (this.w * this.h <= 0) || isNaN(this.x) || isNaN(this.y) || isNaN(this.w) || isNaN(this.h);
	},
	/**
	 * Create a new view rectangle with the same point of origin, width, and height as the existing
	 * view rectangle.
	 * @example
	 * // Create a new view rectangle based on an existing view rectangle.
	 * var rect1 = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * var rect2 = rect1.copy();
	 * @returns {UI.ViewGeometry.Rect} A new view rectangle with the same point of origin, width,
	 *		and height.
	 * @since 1.0
	 */	
	copy: function() {
		return new (this).constructor(this);
	},
    /**
	 * Retrieve the view rectangle's point of origin, width, and height.
	 * @returns {Number[]} An array of integers specifying the view rectangle's X origin, Y origin,
	 *		width, and height.
	 * @since 1.0
	 */	
	array: function() {
		return [this.x, this.y, this.w, this.h];
	},
	
	/**
	 * Replace the view rectangle with an inset of the existing rectangle. The inset will be created
	 * only on the top and right sides of the view rectangle.
	 * @function
	 * @example
	 * // Create a view rectangle, then add a top and right inset of 10 pixels.
	 * var rect = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * rect.inset(10);
	 * @param {Number} tr The inset, in pixels, for the top and right sides of the view rectangle.
	 * @returns {this}
	 * @since 1.0
	 */
	inset: function(t, r, b, l, units) {
		if (arguments.length > 4) {
			var xScale = Scale.getScale(units, this.w);
			var yScale = Scale.getScale(units, this.h);
			t = Math.floor(t * yScale);
			r = Math.floor(r * xScale);
			b = Math.floor(b * yScale);
			l = Math.floor(l * xScale);
		}
		
		if (arguments.length < 2) {
			r = t;
		}
		if (arguments.length < 4) {
			b = t;
			l = r;
		}
		this.y += t;
		this.h -= t + b;
		this.x += l;
		this.w -= l + r;
		return this;
	},
	/**
	 * Replace the view rectangle with an inset of the existing rectangle. The first parameter
	 * represents the top and bottom inset, and the second parameter represents the left and right
	 * inset.
	 * @name inset^2
	 * @function
	 * @memberOf UI.ViewGeometry.Rect#
	 * @example
	 * // Create a view rectangle, then add a top and bottom inset of 10 pixels
	 * // and a left and right inset of 15 pixels.
	 * var rect = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * rect.inset(10, 15);
	 * @param {Number} tb The inset, in pixels, for the top and bottom of the view rectangle.
	 * @param {Number} lr The inset, in pixels, for the left and right sides of the view rectangle.
	 * @returns {this}
	 * @since 1.0
	 */
	/**
	 * Replace the view rectangle with an inset of the existing rectangle, specifying the inset for
	 * each side of the rectangle. If you include the `units` parameter, the inset will be scaled
	 * based on the value you specify.
	 * @name inset^3
	 * @function
	 * @memberOf UI.ViewGeometry.Rect#
	 * @example
	 * // Create a view rectangle, then add a top inset of 10 pixels, a right
	 * // inset of 5 pixels, a bottom inset of 20 pixels, and a left inset of
	 * // 15 pixels.
	 * var rect = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * rect.inset(10, 5, 20, 15);
	 * @param {Number} t The inset, in pixels, for the top of the view rectangle.
	 * @param {Number} r The inset, in pixels, for the right side of the view rectangle.
	 * @param {Number} b The inset, in pixels, for the bottom of the view rectangle.
	 * @param {Number} l The inset, in pixels, for the left side of the view rectangle.
	 * @param {UI.Commands#Scaling} [units] The scaling factor that will be used to adjust the
	 *		specified insets. By default, the inset is not scaled.
	 * @returns {this}
	 * @see UI.Commands#Scaling
	 * @since 1.0
	 */   
	
   /**
	 * Create a new view rectangle by removing a horizontal slice from the top or bottom of an
	 * existing view rectangle. If you include the `units` parameter, the slice's height will be 
	 * scaled based on the value you specify.
	 *
	 * **Note**: This method is called `sliceVertical()` because it modifies the rectangle's height
	 * along the vertical (Y) axis.
	 * @example
	 * // Create a view rectangle that is 50 pixels tall, and remove a 20-pixel-tall
	 * // horizontal slice from the top of the rectangle.
	 * var mainRect = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * var sliceRect = mainRect.sliceVertical(20);
	 * var mainRectInfo = mainRect.array();  // mainRectInfo == [0, 20, 100, 30]
	 * var sliceRectInfo = sliceRect.array();  // sliceRectInfo == [0, 0, 100, 20]
	 * @param {Number} height The height, in pixels, of the slice to remove from the existing view
	 *		rectangle. Use a positive value to remove the top of the existing rectangle and a
	 *		negative value to remove the bottom of the existing rectangle.
	 * @param {UI.Commands#Scaling} [units] The scaling factor that will be used to adjust the 
	 *		specified height. By default, the height is not scaled.
	 * @returns {UI.ViewGeometry.Rect} The new view rectangle that was sliced from the existing
	 *		view rectangle.
	 * @see UI.ViewGeometry.Rect#sliceHorizontal
	 * @since 1.0
	 */	
	sliceVertical: function(height, units) {
		if (arguments.length > 1) height = Math.floor(height * Scale.getScale(units, this.h));
		
		var newRect = this.copy();
		if (height < 0) {
			// Return the bottom area...
			newRect.h = -height;
			this.h += height;
			newRect.y += this.h;
		} else {
			newRect.h = height;
			this.y += height;
			this.h -= height;
		}
		return newRect;
	},
    /**
	 * Create a new view rectangle by removing a vertical slice from the left or right side of an
	 * existing view rectangle. If you include the `units` parameter, the slice's width will be 
	 * scaled based on the value you specify.
	 *
	 * **Note**: This method is called `sliceHorizontal()` because it modifies the rectangle's width
	 * along the horizontal (X) axis.
	 * @example
	 * // Create a view rectangle that is 100 pixels wide, and remove a 10-pixel-wide
	 * // vertical slice from the left side of the rectangle.
	 * var mainRect = new UI.ViewGeometry.Rect([0, 0, 100, 50]);
	 * var sliceRect = mainRect.sliceHorizontal(10);
	 * var mainRectInfo = mainRect.array();  // mainRectInfo is [10, 0, 90, 50]
	 * var sliceRectInfo = sliceRect.array();  // sliceRectInfo is [0, 0, 10, 50]
	 * @param {Number} width The width, in pixels, of the slice to remove from the existing view
	 *		rectangle. Use a positive value to remove the left side of the existing rectangle and a
	 *		negative value to remove the right side of the existing rectangle.
	 * @param {UI.Commands#Scaling} [units] The scaling factor that will be used to adjust the 
	 *		specified width. By default, the width is not scaled.
	 * @returns {UI.ViewGeometry.Rect} The new view rectangle that was sliced from the existing
	 *		view rectangle.
	 * @see UI.ViewGeometry.Rect#sliceVertical
	 * @since 1.0
	 */	
	sliceHorizontal: function(width, units) {
		if (arguments.length > 1) width = Math.floor(width * Scale.getScale(units, this.w));

		var newRect = this.copy();
		if (width < 0) {
			newRect.w = -width;
			this.w += width;
			newRect.x += this.w;
		} else {
			newRect.w = width;
			this.x += width;
			this.w -= width;
		}
		return newRect;
	},

	toString: function() {
		return "Rect: {" + this.array().join(',') + "}";
	},

	/**
	 * Divide an existing view rectangle into a grid, with evenly spaced columns and rows, and
	 * retrieve an array of new view rectangles that represent each cell in the grid. The existing
	 * view rectangle is not modified.
	 *
	 * **Note**: The width and height of each grid cell are rounded to an integer. As a result, the
	 * grid cells may cover a slightly smaller area than the existing view rectangle.
	 * @example
	 * // Create a view rectangle that is 60 pixels wide and 20 pixels high.
	 * var rect = new UI.ViewGeometry.Rect([0, 0, 60, 20]);
	 * // Divide the rectangle into two rows and three columns. Retrieve the grid
	 * // cells in the following format:
	 * // [ [ {row1col1}, {row1col2}, {row1col3} ], [ {row2col1}, {row2col2}, {row2col3} ] ]
	 * var cells = rect.getGrid(2, 3, false);
	 * // Divide the rectangle into two rows and three columns. Retrieve the grid
	 * // cells in the following format:
	 * // [ {row1col1}, {row1col2}, {row1col3}, {row2col1}, {row2col2}, {row2col3} ]
	 * var flatCells = rect.getGrid(2, 3, true);
	 * @param {Number} rows The number of rows in the grid.
	 * @param {Number} columns The number of columns in the grid.
	 * @param {Boolean} flat Set to `true` to retrieve a flat array of grid cells, ordered from left
	 *		to right along each row, starting with the top row and ending with the bottom row. Set
	 *		to `false` to retrieve an array that contains multiple child arrays; the child arrays
	 *		start with the top row and end with the bottom row, and each child array contains the
	 *		grid cells from a single row, ordered from left to right.
	 * @returns {Array[]|UI.ViewGeometry.Rect[]} An array of grid cells, in the format specified by
	 *		the `flat` parameter.
	 * @since 1.0
	 */
	getGrid: function(rows, columns, flat) {
		// Return an array of this rect divided equally into columns and rows.
		flat = (flat === true);
		var cellW = Math.floor(this.w / columns);
		var cellH = Math.floor(this.h / rows);
		
		var rowSet = [];
		for (var i = 0; i < rows; i++) {
			var colSet = [];
			for (var j = 0; j < columns; j++) {
				var r = new this.constructor(this.x + j * cellW, this.y + i * cellH, cellW, cellH);
				(flat ? rowSet : colSet).push(r);
			}
			if (!flat) rowSet.push(colSet);
		}
		return rowSet;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Style'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Style'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Style'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Style.js';

var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var stateMap = {
	'normal': Commands.State.Normal,
	'focused': Commands.State.Focused,
	'selected': Commands.State.Selected,
	'pressed': Commands.State.Pressed,
	'disabled': Commands.State.Disabled
};

var Style = exports.Style = Element.subclass({
/** @lends UI.Style.prototype */
	"type":"style",
	"classname":"UI_Style",
	
	/**
	 * @class The `UI.Style` class creates objects that contain style properties for UI components,
	 * such as the component's fill color and outline; the component's text color; and the text to
	 * display in the component. Use this class wherever your application will display multiple UI
	 * components that use the same style.
	 * 
	 * By creating a single `UI.Style` object and applying it to multiple UI components, you reduce
	 * the amount of communication between ngCore's JavaScript API and the device's native code. As
	 * a result, using `UI.Style` objects can significantly improve your application's performance.
	 *
	 * `UI.Style` objects can be applied to any UI component that extends `{@link UI.AbstractView}`.
	 * To apply a `UI.Style` object to a UI component, call the component's `setStyle()` method,
	 * which is inherited from `{@link UI.AbstractView}`.
	 *
	 * **Note**: If you assign a `UI.Style` object to a UI component, then set one of the
	 * component's style properties, the style property you set will override the value that is
	 * provided by the `UI.Style` object. Keep in mind that many style properties are tied to 
	 * specific view states; for example, if a `UI.Style` object provides a style property for the
	 * `disabled` view state, you must also specify the `disabled` view state when you override the
	 * property. See below for more information about style properties and view states.
	 *
	 * ### Supported Properties ###
	 * A `UI.Style` object can contain any of the style properties that are available through the
	 * class' getter and setter methods, which are described below. Most UI components use only a
	 * subset of these properties. For example, because `{@link UI.Image}` objects cannot contain
	 * text, they do not use the `text` property. See the documentation for each class in the
	 * `{@link UI}` module to determine which properties are used by each UI component.
	 * 
	 * If a UI component does not use a property that is specified in a `UI.Style` object, that 
	 * property will be ignored.
	 *
	 * ### Style Properties and View States ###
	 * A `UI.Style` object can use different properties for different view states. For example, it
	 * can specify that a UI component's text should use a different color when the component is
	 * disabled. To implement this feature, your application can call a `UI.Style` setter method
	 * more than once, passing a different view state in the `flags` parameter for each method call.
	 *
	 * When you pass style properties in the class' constructor method, the properties will apply in
	 * the `normal`, or default, view state. To specify a style property for a different view state, 
	 * add the name of the view state to the beginning of the property name, and capitalize the
	 * property name. For example, to specify an image border for a UI component that has focus,
	 * pass the `focusedImageBorder` property in the constructor. This approach is supported only
	 * for the `normal`, `focused`, `selected`, `pressed`, and `disabled` view states. To specify a
	 * style property for a custom view state, or for a component that is in multiple states, you
	 * must use `UI.Style`'s setter methods.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.Style#setImageGravity}` to control an
	 * image's position within its view, the image gravity you specify will apply in all view
	 * states.
	 * @name UI.Style
	 * @constructs Create a new set of style properties.
	 * @augments UI.Element
	 * @example
	 * // Create a new UI.Style object without setting any of its properties.
	 * var style = new UI.Style();
	 * @example
	 * // Create a UI.Style object, setting several of its style properties, 
	 * // and apply the style properties to three buttons.
	 * var style = new UI.Style({
	 *     gradient: {
	 *         corners: "5.0 5.0 5.0 5.0",
	 *         gradient: ["FF9999FF 0.0", "FF5665FF 0.4", "FF0000FF 1.0"],
	 *         innerShadow: "FFFFFFFF 15.0 {0.0, 0.0}",
	 *         outerLine: "FF5F5F5F 1.0",
	 *         outerShadow: "00000000 0.0 {0.0, 0.0}"
	 *     },
	 *     textColor: "FFFFFF",
	 *     textShadow: "FF666666 2.0 {0.0, -1.0}"
	 * });
	 * var button1 = new UI.Button(),
	 *     button2 = new UI.Button(),
	 *     button3 = new UI.Button();
	 * button1.setStyle(style);
	 * button2.setStyle(style);
	 * button3.setStyle(style);
	 * @param {Object} [properties] An object whose properties will be added to the new `UI.Style`
	 *		object.
	 * @see UI.Commands#State
	 * @since 1.6
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (Style._init) Style._init();
		$super(properties);
	},
	
	/** @private */
	$synthesizePropertyWithState: function(propName, commandsFn) {
		function doSynthesis(caseAdjusted, stateName, stateFlags) {
			var gName = 'get' + caseAdjusted;
			var sName = 'set' + caseAdjusted;
			var getterFn = function() {
				return this[gName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this[sName].call(this, val, stateFlags);
			};

			this.registerAccessors( stateName + caseAdjusted, getterFn, setterFn );
		}
		Element.synthesizePropertyWithState.call(this, propName, commandsFn);
		// Synthesize stateful accessors.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		for (var stateName in stateMap) {
			doSynthesis.call(this, caseAdjusted, stateName, stateMap[stateName]);
		}
	}
});

Style._init = function() {
	delete Style._init;
	if (Element._init) Element._init();

		/**
		 * Set the `gradient` property for a specified view state. You can use this property to add
		 * outlines, shadows, rounded corners, and gradient fills to a view. The `gradient` property
		 * can contain any or all of the following properties:
		 * 
		 * + **`corners`**: The radius, in pixels, for the view's corners. Specified as a string that
		 * contains a list of four floats separated by spaces. The floats start with the top left 
		 * corner of the view and go clockwise around the view. For example, to specify a radius of 
		 * 6 pixels for the top right and bottom left corners: `"0.0 6.0 0.0 6.0"`
		 * + **`gradient`**: The gradient fill for the view, drawn from top to bottom. Specified as 
		 * an array of strings (for example, `["FF0028FF 0.00", "FF6A84FF 0.25"]`). Each string 
		 * contains two values separated by spaces:
		 *     1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
		 *     2. A float, ranging from `0.0` (the top of the button) to `1.0` (the bottom of the
		 *     button), indicating a point at which the color should begin to fade into the prior
		 *     color.
		 * + **`innerLine`**: The line drawn inside the view's edges. Specified as a string (for 
		 * example, `"FFC0EA82 2.0"`) that contains two values separated by a space:
		 *     1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
		 *     2. A float indicating the width, in pixels, of the line.
		 * + **`innerShadow`**: The shadow drawn inside the view's edges, which can be used to 
		 * create a "glowing" effect. Specified as a string (for example, `"FFFFFFFF 5.0 {0.0, 
		 * 0.0}"`) that contains three values separated by spaces:
		 *     1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
		 *     2. The width, in pixels, to blur the edges of the shadow.
		 *     3. Two comma-separated floats enclosed in brackets:
		 *         1. The shadow's X offset from the left, in pixels.
		 *         2. The shadow's Y offset from the top, in pixels.
		 * + **`insets`**: The view's insets, in pixels, from its edges. Specified as a string 
		 * containing four comma-separated floats enclosed in brackets. The floats start at the top 
		 * of the view and go counter-clockwise around the view. For example, to specify a top inset 
		 * of 5 pixels and a right inset of 10 pixels: `{0, 5, 0, 10}`
		 * + **`outerLine`**: The line drawn outside the view's edges. Uses the same format as the
		 * `innerLine` property.
		 * + **`outerShadow`**: The shadow drawn outside the view's edges, which can be used to 
		 * create a "drop shadow" effect. Uses the same format as the `innerShadow` property.
		 * **Note**: The outer shadow is drawn within the view's bounds. This means you must specify
		 * insets in order for the drop shadow to be visible.
		 * @name UI.Style#setGradient
		 * @function
		 * @example
		 * // Create a style for an opaque white inner shadow that has a 
		 * // 10-pixel blur and no offset.
		 * var style = UI.Style();
		 * var gradient = {
		 *     innerShadow: "FFFFFFFF 5.0 {0.0, 0.0}"
		 * };
		 * style.setGradient(gradient);
		 * @example
		 * // Create an opaque gradient that is light blue in the middle and
		 * // dark blue on the top and bottom edges.
		 * var style = UI.Style();
		 * var gradient = {
		 *     gradient: ["FF0028FF 0.00", "FF6A84FF 0.25", "FF6A84FF 0.75",
		 *         "FF0028FF 1.00"]
		 * };
		 * style.setGradient(gradient);
		 * @example
		 * // Create an opaque gradient that is dark blue at the top, bottom,
		 * // and middle and light blue in between.
		 * var style = UI.Style();
		 * var gradient = {
		 *     gradient: ["FF0028FF 0.000", "FF6A84FF 0.250", "FF0028FF 0.500",
		 *         "FF6A84FF 0.750", "FF0028FF 1.000"]
		 * };
		 * style.setGradient(gradient);
		 * @example
		 * // Create a style for a gradient that fades from light blue to dark
		 * // blue, with a white inner shadow and a dark gray border.
		 * var style = UI.Style();
		 * var gradient = {
		 *     corners: "5.0 5.0 5.0 5.0",
		 *     gradient: ["FF9999FF 0.0", "FF5665FF 0.4", "FF0000FF 1.0"],
		 *     innerShadow: "FFFFFFFF 15.0 {0.0, 0.0}",
		 *     outerLine: "FF5F5F5F 1.0",
		 *     outerShadow: "00000000 0.0 {0.0, 0.0}"
		 * };
		 * style.setGradient(gradient);
		 * @param {Object} gradient The new `gradient` property, using the format described above.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this gradient. To specify a gradient for a view that is in multiple states, you 
		 * 		can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getGradient
		 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `gradient` property for a specified view state.
		 * @name UI.Style#getGradient
		 * @function	
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {Object} The current gradient, in the format described in
		 *		`{@link UI.Style#setGradient}`.
		 * @see UI.Style#setGradient
		 * @since 1.6
		 */
		Style.synthesizePropertyWithState('gradient', Commands.setGradient);
		
		/**
		 * Set the `image` property, which contains the path to an image that will be displayed for 
		 * a specified view state.
		 * @name UI.Style#setImage
		 * @function 
		 * @example
		 * var style = new UI.Style();
		 * style.setImage("./Content/splash.png", UI.Commands.State.Selected |
		 *     UI.Commands.State.Focused);
		 * @param {String} imageURL The new image URL.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this image. To specify an image for a view that is in multiple states, you can 
		 * 		use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getImage
		 * @since 1.6
		 */
		/**
		 * Retrieve a path to the image for a specified view state.
		 * @name UI.Style#getImage
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The path to the image for the specified view state.
		 * @see UI.Style#setImage
		 * @since 1.6
		 */
		Style.synthesizePropertyWithState('image', Commands.setImage);
		/**
		 * Set the `imageBorder` property, which defines a border for images in a specified view 
		 * state. See `{@link UI.Style#setGradient}` for information about the format of this
		 * property.
		 * @name UI.Style#setImageBorder
		 * @function
		 * @example
		 * // Create a style for a dark gray image border.
		 * var style = new UI.Style();
		 * var border = {
		 *     outerLine: "FF5F5F5F 1.0"
		 * }; 
		 * style.setImageBorder(border);
		 * @param {Object} imageBorder The new image border.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this border. To specify a border for a view that is in multiple states, you can
		 * 		use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getImageBorder
		 * @see UI.Style#setGradient
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the `imageBorder` property, which defines a border for images in a specified
		 * view state.
		 * @name UI.Style#getImageBorder
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {Object} The current image border.
		 * @see UI.Style#setImageBorder
		 * @since 1.6
		 */
		Style.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
		/**
		 * Set the `imageFit` property, which defines how images will be scaled relative to the
		 * view.
		 * @name UI.Style#setImageFit
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setImageFit(UI.Commands.FitMode.None);
		 * @param {UI.Commands#FitMode} imageFit The scaling option that will be used to scale 
		 * 		images relative to the button.
		 * @returns {void}
		 * @see UI.Commands#FitMode
		 * @see UI.Style#getImageFit
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `imageFit` property, which defines how images will be scaled
		 * relative to the view.
		 * @name UI.Style#getImageFit
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setImageFit(UI.Commands.FitMode.AspectWidth);
		 * var image = new UI.Image();
		 * image.setStyle(style);
		 * // More code here.
		 * // Later, the application takes an action based on the image's
		 * // fit mode:
		 * var imageStyle = image.getStyle();
		 * var imageFitMode = imageStyle.getImageFit();
		 * switch (imageFitMode) {
		 *     case UI.Commands.FitMode.AspectHeight:
		 *         // Your code here
		 *         break;
		 *     case UI.Commands.FitMode.AspectWidth:
		 *         // Your code here
		 *         break;
		 *     // Continue through each enumerated value that you want to test
		 *     default:
		 *         // Your code here
		 *         break;
		 * }
		 * @returns {Number} The current scaling option that will be used to scale images relative
		 * 		to the view. The returned value corresponds to an enumerated value of
		 *		`{@link UI.Commands#FitMode}`.
		 * @see UI.Commands#FitMode
		 * @see UI.Style#setImageFit
	 	 * @since 1.6
		 */
		Style.synthesizeProperty('imageFit', Commands.setImageFitMode);
		/**
		 * Set the `imageInsets` property, which contains insets that are used to clip the edges of
		 * an image. The inset is specified as an array of floats, starting with the top inset and
		 * going clockwise around the image.
		 * @name UI.Style#setImageInsets
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * // Use a top inset of 10, a right inset of 20, a bottom inset of 15, and
		 * // a left inset of 5.
		 * style.setImageInsets([10, 20, 15, 5]);
		 * @param {Number[]} imageInsets The new image insets. Specified as an array of four floats, 
		 *		starting with the top inset and going clockwise around the image.
		 * @returns {void}
		 * @see UI.Style#getImageInsets
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `imageInsets` property, which contains insets that are used to
		 * clip the edges of an image.
		 * @name UI.Style#getImageInsets
		 * @function
		 * @returns {Number[]} The current image insets. Specified as an array of four floats, 
		 *		starting with the top inset and going clockwise around the image.
		 * @see UI.Style#setImageInsets
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
		/**
		 * Set the `imageGravity` property, which defines how an image is positioned within the
		 * viewable area. The image gravity is defined as two floats, one for the X (horizontal)
		 * axis and one for the Y (vertical) axis. Each float represents a percentage of the
		 * whitespace surrounding the image.
		 * 
		 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
		 * image, with the remainder placed to the right of the image. For the Y axis, the specified 
		 * percentage of whitespace will be placed above the image, with the remainder placed below
		 * the image.
		 * 
		 * Each UI component uses a different default value for its image gravity. See the UI
		 * component's documentation for details.
		 * @name UI.Style#setImageGravity
		 * @function
		 * @example
		 * // Set the image gravity so that images are vertically centered
		 * // and horizontally placed near the left edge.
		 * var style = new UI.Style();
		 * style.setImageGravity([0.25, 0.5]);
		 * @param {Number[]|UI.ViewGeometry#Gravity} imageGravity The new image gravity. Specified
		 *		as an array of two floats, where the first represents the X axis and the second
		 *		represents the Y axis. You can also specify an enumerated value of
		 *		`{@link UI.ViewGeometry#Gravity}` in place of the array.
		 * @returns {void}
		 * @see UI.Style#getImageGravity
		 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `imageGravity` property, which defines how an image is
		 * positioned within the viewable area.
		 * @name UI.Style#getImageGravity
		 * @function
		 * @returns {Number[]} The current image gravity. Specified as an array of two floats, where
		 *		the first represents the X axis and the second represents the Y axis.
		 * @see UI.Style#setImageGravity
		 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
		/**
		 * Set the `imageTransform` property, which defines an affine transformation of an image. An
		 * affine transformation makes it possible to move, scale, or skew an image while ensuring 
		 * that straight lines remain straight and parallel lines remain parallel. You can also use 
		 * an affine transformation to rotate an image.
		 * 
		 * The parameters to this method represent a 2 x 3 matrix that contains the following
		 * values:
		 * 
		 *     --      --    a = X scale    tx = X reposition
		 *     | a    b |    b = Y skew     ty = Y reposition
		 *     | c    d |    c = X skew
		 *     | tx  ty |    d = Y scale
		 *     --      --
		 * @name UI.Style#setImageTransform
		 * @function
		 * @example
		 * // Increase an image's size by 20 units along the X axis, and move it
		 * // down 5 units along the Y axis.
		 * var style = new UI.Style();
		 * var scaleX = 20;
		 * var moveY = 5;
		 * style.setImageTransform([scaleX, 0, 0, 0, 0, moveY]);
		 * @example
		 * // Rotate an image 30 degrees to the left.
		 * function degreesToRadians(degrees) {
		 *     return degrees * (Math.PI / 180);
		 * }
		 *
		 * var style = new UI.Style();
		 * var angle = degreesToRadians(30);
		 * style.setImageTransform([Math.cos(angle), Math.sin(angle),
		 *     -Math.sin(angle), Math.cos(angle), 0, 0]);
		 * @example
		 * // Skew the bottom of an image to the right by 10 units along the
		 * // X axis.
		 * var style = new UI.Style();
		 * var skewX = 10;
		 * style.setImageTransform([0, 0, skewX, 0, 0, 0]);
		 * @param {Number[]} imageTransform The new affine transformation to use. Specified as an
		 *		array of six floats: `[a, b, c, d, tx, ty]`.
		 * @returns {void}
		 * @see UI.Style#getImageTransform
		 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `imageTransform` property, which defines an affine transformation
		 * of the image.
		 * @name UI.Style#getImageTransform
		 * @function
		 * @returns {Number[]} The current affine transformation. Specified as an array of six 
		 *		 floats: `[a, b, c, d, tx, ty]`.
		 * @see UI.Style#setImageTransform
		 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
		
		/**
		 * Set the `text` property, which defines text for the view in a specified view state.
		 * @name UI.Style#setText
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setText("More information");
		 * @param {String} text The new text for the view.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this text. To specify text for a view that is in multiple states, you can use 
		 * 		the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getText
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `text` property, which defines text for the view in a specified
		 * view state.
		 * @name UI.Style#getText
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current text for the specified view state.
		 * @see UI.Style#setText
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('text', Commands.setText);
		/**
		 * Set the `textColor` property, which defines the text color for the view in a specified 
		 * view state.
		 * @name UI.Style#setTextColor
		 * @function 
		 * @example
		 * var style = new UI.Style();
		 * style.setTextColor("FFFFFF");
		 * @param {String} textColor The new text color, in hexidecimal RGB format.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this text color. To specify a text color for a view that is in multiple states, 
		 * 		you can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getTextColor
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `textColor` property, which defines the text color for the view
		 * in a specified view state.
		 * @name UI.Style#getTextColor
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current text color for the specified view state, in hexidecimal RGB
		 *		format.
		 * @see UI.Style#setTextColor
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('textColor', Commands.setTextColor);
		/**
		 * Set the `textFont` property, which defines the font that is used for the view's text in a
		 * specified view state.
		 * @name UI.Style#setTextFont
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setTextFont("DroidSans");
		 * @param {String} textFont The name of the new font.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this font. To specify a font for a view that is in multiple states, you can use 
		 * 		the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getTextFont
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `textFont` property, which defines the font that is used for 
		 * the view's text in a specified view state.
		 * @name UI.Style#getTextFont
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The name of the current font for the specified view state.
		 * @see UI.Style#setTextFont
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('textFont', Commands.setTextFont);
		/**
		 * Set the `textShadow` property, which defines the color and size of shadows on the view's 
		 * text in a specified view state. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0,
		 * -1.0}"`) that contains three values separated by spaces:
		 * 
		 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
		 * 2. The width, in pixels, to blur the edges of the shadow.
		 * 3. Two comma-separated floats enclosed in brackets:
		 *     1. The shadow's X offset from the left, in pixels.
		 *     2. The shadow's Y offset from the top, in pixels.
		 * @name UI.Style#setTextShadow
		 * @function
		 * @example
		 * // Use a white text shadow with a two-pixel blur, shifted up one pixel.
		 * var style = new UI.Style();
		 * style.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
		 * @param {String} textShadow The new text shadow, in the format specified above.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this text shadow. To specify a text shadow for a view that is in multiple 
		 * 		states, you can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getTextShadow
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `textShadow` property, which defines the color and size of 
		 * shadows on the view's text in a specified view state.
		 * @name UI.Style#getTextShadow
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current text shadow.
		 * @see UI.Style#setTextShadow
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
		/**
		 * Set the `textGravity` property, which defines how a view's text is positioned within the
		 * viewable area. The text gravity is defined as two floats, one for the X (horizontal) 
		 * axis and one for the Y (vertical) axis. Each float represents a percentage of the 
		 * whitespace surrounding the text.
		 * 
		 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
		 * text, with the remainder placed to the right of the text. For the Y axis, the specified 
		 * percentage of whitespace will be placed above the text, with the remainder placed below 
		 * the text.
		 * 
		 * Each UI component uses a different default value for its text gravity. See the UI
		 * component's documentation for details.
		 * @name UI.Style#setTextGravity
		 * @function
		 * @example
		 * // Set the text gravity so that text is vertically centered and
		 * // horizontally placed near the left edge.
		 * var style = new UI.Style();
		 * style.setTextGravity([0.1, 0.5]);
		 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as
		 *		an array of two floats, where the first represents the X axis and the second
		 *		represents the Y axis. You can also specify an enumerated value of
		 *		`{@link UI.ViewGeometry#Gravity}` in place of the array.
		 * @returns {void}
		 * @see UI.Style#getTextGravity
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `textGravity` property, which defines how a view's text is
		 * positioned within the viewable area.
		 * @name UI.Style#getTextGravity
		 * @function
		 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where 
		 *		the first represents the X axis and the second represents the Y axis.
		 * @see UI.Style#setTextGravity
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
		/**
		 * Set the `textSize` property, which specifies the size, in pixels, of a view's text.
		 * @name UI.Style#setTextSize
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * var textSize = 24;
		 * style.setTextSize(textSize);
		 * @param {Number} textSize The new size, in pixels, of a view's text.
		 * @returns {void}
		 * @see UI.Style#getTextSize
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of a
		 * view's text.
		 * @name UI.Style#getTextSize
		 * @function
		 * @returns {Number} The current size, in pixels, of a view's text.
		 * @see UI.Style#setTextSize
	 	 * @since 1.6
		 */
		Style.synthesizeProperty('textSize', Commands.setTextSize);
		/**
		 * Set the `textInsets` property, which contains insets that are used to clip the edges of
		 * text. The inset is specified as an array of floats, starting with the top inset and going
		 * clockwise around the text.
		 * @name UI.Style#setTextInsets
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * var insetLeft = 10;
		 * style.setTextInsets([0, 0, 0, insetLeft]);
		 * @param {Number[]} textInsets The new text insets. Specified as an array of four floats, 
		 *		starting with the top inset and going clockwise around the text.
		 * @returns {void}
		 * @see UI.Style#getTextInsets
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `textInsets` property, which contains insets that are used to 
		 * clip the edges of text.
		 * @name UI.Style#getTextInsets
		 * @function
		 * @returns {Number[]} The current text insets. Specified as an array of four floats, 
		 *		starting with the top inset and going clockwise around the text.
		 * @see UI.Style#setTextInsets
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
		Style.synthesizeProperty('lineHeight', Commands.setLineHeight);

		/**
		 * Set the `rightImage` property, which defines a path to an image to display on the right 
		 * side of a view for a specified view state.
		 * @name UI.Style#setRightImage
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setRightImage("./Content/right-arrow.png",
		 *     UI.Commands.State.Focused);
		 * @param {String} rightImage The path to the new image.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this right image. To specify a right image for a view that is in multiple 
		 * 		states, you can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getRightImage
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `rightImage` property, which defines a path to an image to 
		 * display on the right side of a view for a specified view state.
		 * @name UI.Style#getRightImage
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current path to the image that will be displayed on the right side 
		 *		of the view.
		 * @see UI.Style#setRightImage
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('rightImage', Commands.setRightImage);
		/**
		 * Set the `rightImageBorder` property, which defines a border for the image that is
		 * specified by the `rightImage` property for a specified view state. See 
		 * `{@link UI.Style#setGradient}` for information about the format of the `rightImageBorder`
		 * property.
		 * @name UI.Style#setRightImageBorder
		 * @function
		 * @example
		 * // Specify a one-pixel dark gray border.
		 * var style = new UI.Style();
		 * style.setRightImageBorder({
		 *     outerLine: "FF5F5F5F 1.0"
		 * });
		 * @param {Object} rightImageBorder The new image border for the right image.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this right image border. To specify a right image border for a view that is in 
		 * 		multiple states, you can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getRightImageBorder
		 * @see UI.Style#setGradient
		 * @see UI.Style#setRightImage
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `rightImageBorder` property, which defines a border for the 
		 * image that is specified by the `rightImage` property for a specified view state.
		 * @name UI.Style#getRightImageBorder
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {Object} The current image border for the right image.
		 * @see UI.Style#setRightImage
		 * @see UI.Style#setRightImageBorder
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
		/**
		 * Set the `rightImageFit` property, which defines how the right image will be scaled 
		 * relative to a view.
		 * @name UI.Style#setRightImageFit
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setRightImageFit(UI.Commands.FitMode.None);
		 * @param {UI.Commands#FitMode} rightImageFit The scaling option that will be used to scale 
		 * 		the right image relative to a view.
		 * @returns {void}
		 * @see UI.Style#getRightImageFit
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `rightImageFit` property, which defines how the right image 
		 * will be scaled relative to a  view.
		 * @name UI.Style#getRightImageFit
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setImageFit(UI.Commands.FitMode.AspectWidth);
		 * var cell = new UI.CellView();
		 * cell.setStyle(style);
		 * // More code here.
		 * // Later, the application takes an action based on the image's fit mode:
		 * var imageStyle = cell.getStyle();
		 * var imageFitMode = imageStyle.getImageFit();
		 * switch (imageFitMode) {
		 *     case UI.Commands.FitMode.AspectHeight:
		 *         // Your code here
		 *         break;
		 *     case UI.Commands.FitMode.AspectWidth:
		 *         // Your code here
		 *         break;
		 *     // Continue through each enumerated value that you want to test
		 *     default:
		 *         // Your code here
		 *         break;
		 * }
		 * @returns {Number} The current scaling option that will be used to scale the right image 
		 * 		relative to the view. The returned value corresponds to an enumerated value of
		 *		`{@link UI.Commands#FitMode}`.
		 * @see UI.Style#setRightImageFit
	 	 * @since 1.6
		 */
		Style.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
		/**
		 * Set the `rightImageInsets` property, which contains insets that are used to clip the 
		 * edges of the right image. The inset is specified as an array of floats, starting with the
		 * top inset and going clockwise around the image.
		 * @name UI.Style#setRightImageInsets
		 * @function
		 * @example
		 * // Use a top inset of 10, a right inset of 20, a bottom inset of 15, and
		 * // a left inset of 5.
		 * var style = new UI.Style();
		 * style.setRightImageInsets([10, 20, 15, 5]);
		 * @param {Number[]} imageInsets The new image insets. Specified as an array of four floats, 
		 *		starting with the top inset and going clockwise around the image.
		 * @returns {void}
		 * @see UI.Style#getRightImageInsets
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `rightImageInsets` property, which contains insets that are 
		 * used to clip the edges of the right image.
		 * @name UI.Style#getRightImageInsets
		 * @function
		 * @returns {Number[]} imageInsets The current image insets. Specified as an array of four 
		 *		floats, starting with the top inset and going clockwise around the image.
		 * @see UI.Style#setRightImageInsets
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('rightImageInsets', Commands.setRightImageInsets);
		/**
		 * Set the `rightImageGravity` property, which defines how the right image is positioned 
		 * within a viewable area. See `{@link UI.Style#setImageGravity}` for information about this
		 * property.
		 * @name UI.Style#setRightImageGravity
		 * @function
		 * @example
		 * // Set the image gravity so that the right image is horizontally
		 * // centered and vertically adjacent to the top side of the view.
		 * var style = new UI.Style();
		 * style.setRightImageGravity([0.5, 0.0]);
		 * @param {Number[]} rightImageGravity The image gravity to use. Specified as an array of 
		 *		two floats, where the first represents the X axis and the second represents the Y
		 *		axis.
		 * @returns {void}
		 * @see UI.Style#getRightImageGravity
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `rightImageGravity` property, which defines how the right image
		 * is positioned within a viewable area.
		 * @name UI.Style#getRightImageGravity
		 * @function
		 * @returns {Number[]} rightImageGravity The current image gravity. Specified as an array of
		 *		two floats, where the first represents the X axis and the second represents the Y
		 *		axis.
		 * @see UI.Style#setRightImageGravity
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('rightImageGravity', Commands.setRightImageGravity);
		/**
		 * Set the `rightImageTransform` property, which defines an affine transformation of the
		 * right image. See `{@link UI.Style#setImageTransform}` for information about this
		 * property.
		 * @name UI.Style#setRightImageTransform
		 * @function
		 * @example 
		 * // Increase an image's size by 20 units along the X axis, and move it
		 * // down 5 units along the Y axis.
		 * var style = new UI.Style();
		 * var scaleX = 20;
		 * var moveY = 5;
		 * style.setRightImageTransform([scaleX, 0, 0, 0, 0, moveY]);
		 * @param {Number[]} rightImageTransform The new affine transformation. Specified as an 
		 *		array of six floats: `[a, b, c, d, tx, ty]`.
		 * @returns {void}
		 * @see UI.Style#getRightImageTransform
		 * @see UI.Style#setImageTransform
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the current value of the `rightImageTransform` property, which defines an affine
		 * transformation of the right image.
		 * @name UI.Style#getRightImageTransform
		 * @function
		 * @returns {Number[]} rightImageTransform The current affine transformation. Specified as
		 *		an array of six floats: `[a, b, c, d, tx, ty]`.
		 * @see UI.Style#setRightImageTransform
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
		
		/**
		 * Set the `title` property, which defines a title for a view in a specified view state.
		 * @name UI.Style#setTitle
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * var title = "Configure Application";
		 * style.setTitle(title);
		 * @param {String} title The new view title.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this title. To specify a title for a view that is in multiple states, you can 
		 * 		use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getTitle
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the current value of the `title` property, which defines a title for a view in a
		 * specified view state.
		 * @name UI.Style#getTitle
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current view title.
		 * @see UI.Style#setTitle
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('title', Commands.setTitle);
		/**
		 * Set the `titleColor` property, which defines the text color for a view's title in a 
		 * specified view state.
		 * @name UI.Style#setTitleColor
		 * @function 
		 * @example
		 * var style = new UI.Style();
		 * style.setTitleColor("FFFFFF");
		 * @param {String} titleColor The new title text color, in hexidecimal RGB format.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this text color. To specify a text color for a view that is in multiple states, 
		 * 		you can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getTitleColor
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `titleColor` property, which defines the text color for a
		 * view's title in a specified view state.
		 * @name UI.Style#getTitleColor
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current title text color, in hexidecimal RGB format.
		 * @see UI.Style#setTitleColor
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
		/**
		 * Set the `titleFont` property, which defines the font that is used for a view's title text
		 * in a specified view state.
		 * @name UI.Style#setTitleFont
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setTitleFont("DroidSans");
		 * @param {String} textFont The name of the new font.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this font. To specify a font for a view that is in multiple states, you can use 
		 * 		the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#getTitleFont
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `titleFont` property, which defines the font that is used for 
		 * a view's title text in a specified view state.
		 * @name UI.Style#getTitleFont	 
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current title text font.
		 * @see UI.Style#setTitleFont
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
		/**
		 * Set the `titleShadow` property, which defines the color and size of shadows on a view's 
		 * title text in a specified view state. See `{@link UI.Style#setTextShadow}` for 
		 * information about this property.
		 * @name UI.Style#setTitleShadow
		 * @function
		 * @example
		 * // Use a white title text shadow with a two-pixel blur, shifted up
		 * // one pixel.
		 * var style = new UI.Style();
		 * style.setTitleShadow("FFCCCCFF 2.0 {0.0, -1.0}");
		 * @param {String} titleShadow The new title text shadow, in the format specified by 
		 *		`{@link UI.Style#setTextShadow}`.
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to 
		 *		use this title text shadow. To specify a text shadow for a view that is in multiple 
		 * 		states, you can use the `|` operator to combine multiple flags.
		 * @returns {void}
		 * @see UI.Style#setTextShadow
		 * @see UI.Style#getTitleShadow
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `titleShadow` property, which defines the color and size of 
		 * shadows on a view's title text in a specified view state.
		 * @name UI.Style#getTitleShadow
		 * @function
		 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
		 * @returns {String} The current title text shadow.
		 * @see UI.Style#setTitleShadow
	 	 * @since 1.6
		 */
		Style.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);
		/**
		 * Set the `titleGravity` property, which defines how a view's title text is positioned 
		 * within the viewable area. See `{@link UI.Style#setTextGravity}` for information about 
		 * this property.
		 * @name UI.Style#setTitleGravity
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * style.setTitleGravity([0.5, 0.0]);	 
		 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new title text gravity. 
		 *		Specified as an array of two floats, where the first represents the X axis and the 
		 *		second represents the Y axis. You can also specify an enumerated value of
		 *		`{@link UI.ViewGeometry#Gravity}` in place of the array.
		 * @returns {void}
		 * @see UI.Style#getTitleGravity
		 * @see UI.Style#setTextGravity
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `titleGravity` property, which defines how a view's title text
		 * is positioned within the viewable area.
		 * @name UI.Style#getTitleGravity
		 * @function
		 * @returns {Number[]} The current title text gravity. Specified as an array of two floats,
		 *		where the first represents the X axis and the second represents the Y axis.
		 * @see UI.Style#setTitleGravity
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);
		/**
		 * Set the `titleSize` property, which specifies the size, in pixels, of a view's title
		 * text.
		 * @name UI.Style#setTitleSize
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * var textSize = 24;
		 * style.setTitleSize(textSize);
		 * @param {Number} titleSize The new size, in pixels, of the title text.
		 * @returns {void}
		 * @see UI.Style#getTitleSize
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `titleSize` property, which specifies the size, in pixels, of
		 * a view's title text.
		 * @name UI.Style#getTitleSize
		 * @function
		 * @returns {Number} The current size, in pixels, of the title text.
		 * @see UI.Style#setTitleSize
	 	 * @since 1.6
		 */
		Style.synthesizeProperty('titleSize', Commands.setTitleSize);
		/**
		 * Set the `titleInsets` property, which contains insets that are used to clip the edges of 
		 * a view's title text. The inset is specified as an array of floats, starting with the top 
		 * inset and going clockwise around the text.
		 * @name UI.Style#setTitleInsets
		 * @function
		 * @example
		 * var style = new UI.Style();
		 * var insetLeft = 10;
		 * style.setTitleInsets([0, 0, 0, insetLeft]);
		 * @param {Number[]} titleInsets The new title text insets. Specified as an array of four 
		 *		floats, starting with the top inset and going clockwise around the text.
		 * @returns {void}
		 * @see UI.Style#getTitleInsets
	 	 * @since 1.6
		 */
		/**
		 * Retrieve the value of the `titleInsets` property, which contains insets that are used to 
		 * clip the edges of a view's title text.
		 * @name UI.Style#getTitleInsets
		 * @function
		 * @returns {Number[]} titleInsets The current title text insets. Specified as an array of 
		 *		four floats, starting with the top inset and going clockwise around the text.
		 * @see UI.Style#setTitleInsets
	 	 * @since 1.6
		 */
		Style.synthesizeCompoundProperty('titleInsets', Commands.setTitleInsets);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AbstractView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/AbstractView.js';

var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Style = require('NGCore/Client/UI/Style').Style;

var stateMap = {
	'normal': Commands.State.Normal,
	'focused': Commands.State.Focused,
	'pressed': Commands.State.Pressed,
	'disabled': Commands.State.Disabled,
	//** extra-deprecated */
	'selected': Commands.State.Focused,
	'highlighted': Commands.State.Pressed
};

var AbstractView = exports.AbstractView = Element.subclass(
/** @lends UI.AbstractView.prototype */
{
	'type':'<com.ngmoco.view.abstract>',
	/**
	 * @class The `UI.AbstractView` class is a base class for derived classes that manage
	 * application views.
	 * 
	 * **Important**: This base class is not exported in the `UI` module. Do not access it directly
	 * or create subclasses of `UI.AbstractView`.
	 * 
	 * Classes that are derived from `UI.AbstractView` include:
	 * 
	 * + `{@link UI.Button}`
	 * + `{@link UI.CellView}`
	 * + `{@link UI.CheckBox}`
	 * + `{@link UI.EditText}`
	 * + `{@link UI.GLView}`
	 * + `{@link UI.Image}`
	 * + `{@link UI.Label}`
	 * + `{@link UI.Spinner}`
	 * + `{@link UI.View}`
	 * + `{@link UI.WebView}`
	 *
	 * The appearance of an object that is derived from `UI.AbstractView` can change automatically
	 * when the object's view state changes. For example, the view's fill color can change
	 * automatically when the view gains focus or is selected. To implement this feature, your
	 * application can call a `UI.AbstractView` setter method more than once, passing a different
	 * value in the `flags` parameter each time. In addition, your application can include
	 * properties for multiple view states in the constructor. See the `{@link UI}` module overview
	 * for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.AbstractView#setBackgroundColor}` to specify
	 * the view's background color, the color you specify will apply in all view states.
	 * @name UI.AbstractView
	 * @constructs Create a new view.
	 * @augments UI.Element
	 * @example
	 * // Create a new UI.Button object (derived from UI.AbstractView) without
	 * // setting any of its properties.
	 * var button = new UI.Button();
	 * @example
	 * // Create a new UI.Button object (derived from UI.AbstractView), setting
	 * // its text and text size.
	 * var button = new UI.Button({
	 *     text: "Back",
	 *     textSize: 32
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.AbstractView` object.
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (AbstractView._init) AbstractView._init();
		
		this._assignedVisible = true;
		$super(properties);
	},
	
	/** @private */
	destroy: function($super){
		this.removeFromParent();
		$super();
	},
	
	/**
	 * Retrieve the view's parent.
	 * @function
	 * @returns {Object} The view's parent, or `undefined` if the view does not have a parent.
	 * @see UI.AbstractView#addToParent
	 * @see UI.AbstractView#removeFromParent
	 * @since 1.0
	 */    
	getParent: function(){
		return this._parent;
	},
    
	/**
	 * Add a node as a child of the specified parent node. If an index is specified, the node will
	 * be added to the parent node at the specified index. Otherwise, the node will be added as the 
	 * last child of the parent node.
	 * @function
	 * @example
	 * var myParent = new UI.View();
	 * var childNode = new UI.View();
	 * childNode.addToParent(myParent); 
	 * @param {Object} parentNode The parent node.
	 * @param {Number} [index] The index at which to add the child node.
	 * @returns {void}
	 * @see UI.AbstractView#getParent
	 * @see UI.AbstractView#removeFromParent
	 * @since 1.0
	 */
	addToParent: function(parentNode, index){
		parentNode.addChild(this, index);
	},
    
	/**
	 * Remove a child node from the parent node.
	 * @function
	 * @example
	 * var myParent = new UI.View();
	 * var childNode = new UI.View();
	 * childNode.addToParent(myParent);
	 * // more code here
	 * childNode.removeFromParent(myParent);
	 * @returns {this}
	 * @see UI.AbstractView#getParent
	 * @see UI.AbstractView#addToParent
	 * @since 1.0
	 */    
	removeFromParent: function(){
		if (this._parent && !this._parent._destroyed) {
			this._parent.removeChild(this);
			this._parent = null;
		}
		return this;
	},
	
	
	/**
	 * Add a view state to the view.
	 * @function
	 * @example
	 * var image = new UI.Image();
	 * image.addState(UI.Commands.State.Focused);
	 * @param {Number} flags The view state for this view.
	 * @returns {void}
	 * @see UI.AbstractView#clearState
	 * @see UI.AbstractView#getState
	 * @see UI.AbstractView#setState
	 * @see UI.Commands#State
	 * @since 1.0
	 */
	addState: function(flags) {
		this.setState(this._state | flags);
	},
	
	/**
	 * Clear the specified state from the view.
	 * @function 
	 * @example
	 * var image.new UI.Image();
	 * image.addState(UI.Commands.State.Focused);
	 * // More code here
	 * image.clearState(UI.Commands.State.Focused);
	 * @param {Number} flags The view state to clear from the view.
	 * @returns {void}
	 * @see UI.AbstractView#addState
	 * @see UI.AbstractView#getState
	 * @see UI.AbstractView#setState
	 * @see UI.Commands#State
	 * @since 1.0
	 */  
	clearState: function(flags) {
		this.setState(this._state & ~flags);
	},
    
	/**
	 * Retrieve the root node for this view.
	 * @function 
	 * @returns {Object} The root node if this is a child node, or `undefined` if it is not a child
	 *		node.
	 * @since 1.0
	 */
	getRoot: function() {
		return this._parent ? this._parent.getRoot() : undefined;
	},

	/**
	 * Retrieve the view's position and size relative to a second view. The second view must share
	 * an ancestor with the view.
	 *
	 * This method returns `undefined` in the following cases:
	 *
	 * + A frame has not been defined for the view.
	 * + The second view is `null` or `undefined`.
	 * + The second view does not share an ancestor with the view.
	 * @example
	 * // 1. Create a 500-pixel by 500-pixel parent view at the screen's 
	 * //    origin, and add it as a child of UI.Window.document.
	 * // 2. Create a 10-pixel by 10-pixel child view, with a 10-pixel X and Y
	 * //    offset from the origin, and add it as a child of the parent view.
	 * // 3. Create a 500-pixel by 500-pixel child view, with a 10-pixel X and Y
	 * //    offset from the origin, and add it as a child of UI.Window.document.
	 * // 4. Retrieve the frame for the second child view relative to the
	 * //    first child view. Because the two views have the same X and Y 
	 * //    offset, the origin is [0, 0]. The width and height are [10, 10],
	 * //    the dimensions of the smaller of the two views.
	 * var myParent = new UI.View();
	 * myParent.setFrame([0, 0, 500, 500]);
	 * UI.Window.document.addChild(myParent);
	 * var childView1 = new UI.View();
	 * childView1.setFrame([10, 10, 10, 10]);
	 * childView1.addToParent(myParent);
	 * var childView2 = new UI.View();
	 * childView2.setFrame([10, 10, 500, 500]);
	 * UI.Window.document.addChild(childView2);
	 * // frameInChildView2 is set to [0, 0, 10, 10]:
	 * var frameInChildView2 = childView1.getFrameIn(childView2);
	 * @param {UI.AbstractView} other The second view that will be used to calculate the view's
	 *		relative position.
	 * @returns {Number[]} An array of four floats identifying the view's width, height, X origin,
	 *		and Y origin relative to the second view, in that order.
	 * @see UI.AbstractView#setFrame
	 * @since 1.7
	 */
	getFrameIn: function(other) {
		if (!other) return undefined;
		if (UI.Window === other) {
			other = UI.Window.document;
		}
		var frame = this.getFrame();
		if (!frame) return undefined;
		frame = [0, 0, frame[2], frame[3]];
		if (this === other) return frame;

		// Create stack for this branch
		var thisBranch = [];
		var visited = {};
		var curView = this;
		do {
			visited[curView] = true;
			thisBranch.push(curView);
			if (curView === other) break;
			curView = curView.getParent();
		} while (curView);

		// Create stack for other branch, stop when common ancestor is found
		var otherBranch = [];
		curView = other;
		while (curView && !visited[curView]) {
			otherBranch.push(curView);
			curView = curView.getParent();
		}
		if (!curView) {
			// If both nodes have roots (WindowLayer as the first layer), then they are comparable since WindowLayers are all the same dimensions
			var thisRoot = this.getRoot();
			if (thisRoot && other.getRoot()) {
				curView = thisRoot;
				otherBranch.pop();
			} else {
				return undefined; // No common ancestor
			}
		}

		// Create array marking path from this to other
		// The common ancestor needs to be excluded since it provides a frame to its parent which isn't included in the path
		var commonAncestorIndex = thisBranch.indexOf(curView);
		for (var endIndex=commonAncestorIndex, l=commonAncestorIndex + otherBranch.length; endIndex<l; ++endIndex) {
			thisBranch[endIndex] = otherBranch.pop();
		}

		// Calculate the frame relative to other by following path
		for (var i=0; i<endIndex; ++i) {
			var curFrame = thisBranch[i].getFrame();
			if (curFrame) {
				if (typeof thisBranch[i].getFrameOffset === 'function') {
					var offset = thisBranch[i].getFrameOffset();
					curFrame[0] += offset[0];
					curFrame[1] += offset[1];
				}
				frame[0] += (i < commonAncestorIndex ? curFrame[0] : -curFrame[0]);
				frame[1] += (i < commonAncestorIndex ? curFrame[1] : -curFrame[1]);
			} else {
				return undefined; // undefined frame for a view between this and other
			}
		}

		return frame;
	},

	/** 
	  * @private
	  */
	_setVisible: function(makeVisible) {
		var willBeVisible = makeVisible && this._assignedVisible && this._parent && this._parent._visible;
		if (this._visible != willBeVisible) {
			this._visible = willBeVisible;
			var fn = (makeVisible ? this.getOnAppear() : this.getOnDisappear());
			if (typeof fn == 'function') fn.call(this);
		}
	},
	
	/**
	 * Cancel any running animations that apply to the object.
	 * @function
	 * @returns {void}
	 */
	clearAnimations: Commands.clearAnimations,
	
	/** 
	  * @private
	  */
	$synthesizePropertyWithState: function(propName, commandsFn) {
		function doSynthesis(caseAdjusted, stateName, stateFlags) {
			var gName = 'get' + caseAdjusted;
			var sName = 'set' + caseAdjusted;
			var getterFn = function() {
				return this[gName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this[sName].call(this, val, stateFlags);
			};

			this.registerAccessors( stateName + caseAdjusted, getterFn, setterFn );
		}
		Element.synthesizePropertyWithState.call(this, propName, commandsFn);
		// Synthesize stateful accessors.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		for (var stateName in stateMap) {
			doSynthesis.call(this, caseAdjusted, stateName, stateMap[stateName]);
		}
	}
});

// Properties
AbstractView._init = function() {
	delete AbstractView._init;
	if (Element._init) Element._init();
	
	var getVisible = function() {
		return this._visible;
	};
	var setVisible = function(makeVisible) {
		this._assignedVisible = makeVisible;
		Commands.setIsVisible.call(this, makeVisible);
		this._setVisible(makeVisible);
	};
	/**
	 * Set the `visible` property for this view, which defines whether the view is visible.
	 * @name UI.AbstractView#setVisible
	 * @example
	 * var myView = new UI.View();
	 * myView.setVisible(false);
	 * @function 
	 * @param {boolean} makeVisible Set to `true` to make this view visible.
	 * @returns {void}
	 * @see UI.AbstractView#getVisible
	 */
	/**
	 * Determine whether this view is visible.
	 * @name UI.AbstractView#getVisible
	 * @function
	 * @returns {Boolean} Set to `true` if this object is visible.
	 * @see UI.AbstractView#setVisible
	 */
	AbstractView.registerAccessors('visible', getVisible, setVisible);
	
	/**
	 * Set the `backgroundColor` property, which defines the background color for a view.
	 * @name UI.AbstractView#setBackgroundColor
	 * @function
	 * @example
	 * var myView = new UI.View();
	 * myView.setBackgroundColor("FF000000");
	 * @param {String} backgroundColor The new background color, in hexidecimal ARGB format (the
	 *		alpha value followed by the RGB color).
	 * @returns {void}
	 * @see UI.AbstractView#getBackgroundColor
	 */
	/**
	 * Retrieve the value of the `backgroundColor` property, which defines the background color for
	 * a view.
	 * @name UI.AbstractView#getBackgroundColor
	 * @function
	 * @returns {String} The current background color, in hexidecimal ARGB format (the alpha value
	 *		followed by the RGB color).
	 * @see UI.AbstractView#setBackgroundColor
	 */
	AbstractView.synthesizeProperty('backgroundColor', Commands.setBackgroundColor);
	/**
	 * Set the `enabled` property, which identifies whether the view is enabled or disabled. Calling
	 * this method with `enabled` set to `true` will clear the view state
	 * `UI.Commands.State.Disabled` from the view.
	 * @name UI.AbstractView#setEnabled
	 * @function
	 * @param {Boolean} enabled Set to `true` to enable the view.
	 * @returns {void}
	 * @see UI.AbstractView#getEnabled
	 * @see UI.AbstractView#clearState
	 */
	/**
	 * Retrieve the `enabled` property, which identifies whether the view is enabled or disabled.
	 * @name UI.AbstractView#getEnabled
	 * @function
	 * @returns {Boolean} The current value of the `enabled` property.
	 * @see UI.AbstractView#setEnabled
	 */
	
	AbstractView.synthesizeProperty('enabled', function(enable) {
		this[ (enable ? 'clearState' : 'setState') ](Commands.State.Disabled);
	});
	/**
	 * Set the `state` property, which defines the view states that apply to a view.
	 * @name UI.AbstractView#setState
	 * @function
	 * @description 
	 * @example
	 * var image = new UI.Image();
	 * image.setState(UI.Commands.State.Focused);
	 * @param {UI.Commands#State} state The new view state. To specify that a view is currently in
	 * 		multiple states, you can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.AbstractView#getState
	 */
	/**
	 * Retrieve the value of the `state` property, which defines the view states that apply to a
	 * view.
	 * @name UI.AbstractView#getState
	 * @function
	 * @returns {Number} The current view state. The returned value corresponds to an enumerated 
	 *		value of`{@link UI.Commands#State}`.
	 * @see UI.AbstractView#setState
	 */
	AbstractView.synthesizeProperty('state', Commands.setState);

	
	/**
	 * Retrieve the value of the `frame` property.
	 * @name UI.AbstractView#getFrame
	 * @function
	 * @returns {Number[]} The current size of the view and its position relative to its parent.
	 *		Specified as an array of four floats.
	 * @see UI.AbstractView#setFrame
	 */
	var getFrame = function() {
		return this._frame;
	};
	/**
	 * Set the `frame` property, which defines the view's size and its position relative to its
	 * parent. This method accepts the following values, which can be passed to the method in
	 * several different ways:
	 * 
	 * + `x`: The view's offset along the X axis relative to its parent.
	 * + `y`: The view's offset along the Y axis relative to its parent.
	 * + `w`: The width of the view.
	 * + `h`: The height of the view.
	 * @name UI.AbstractView#setFrame
	 * @function 
	 * @example
	 * // Set a view's frame by passing in an array of values.
	 * var back = new UI.Button();
	 * back.setFrame([10.0, 10.0, 64.0, 64.0]);
	 * @example
	 * // Set a view's frame by passing in a UI.ViewGeometry.Rect object.
	 * var back = new UI.Button();
	 * var rect = new UI.ViewGeometry.Rect([10.0, 10.0, 64.0, 64.0]);
	 * back.setFrame(rect);
	 * @param {Number[]|Number|UI.Geometry.Rect} arg0 Contains one of the following:
	 * 
	 * 1. An array of four floats that specify the following, in this order:
	 *     + `x`: The view's offset along the X axis relative to its parent.
	 *     + `y`: The view's offset along the Y axis relative to its parent.
	 *     + `w`: The width of the view.
	 *     + `h`: The height of the view.
	 * 2. The four values listed above, passed in as individual parameters.
	 * 3. A `{@link UI.ViewGeometry.Rect}` object that defines the view's size and position.
	 * @returns {void}
	 * @see UI.AbstractView#getFrame
	 */
	var setFrame = function(arg0) {
		if (this.sizeChanged) {
			var w0 = this._frame ? this._frame[2] : 0;
			var h0 = this._frame ? this._frame[3] : 0;
		}
		
		if( arg0 instanceof Rect ){
			this._frame = arg0.array();
		}
		else if( arg0 instanceof Array ){
			this._frame = arg0;
		}
		else {
			this._frame = Array.prototype.slice.call(arguments);
		}
		//Don't allow this error to be thrown out of this method, as we are close to release and some code may be relying on the old behavior.  However, it would be worthwile to have a log of the error.
		try {
			if (!this._frame || isNaN(this._frame[0]) || isNaN(this._frame[1]) || isNaN(this._frame[2]) || isNaN(this._frame[3])) {
				throw new Error("Attempt to call setFrame with at least one undefined element: " + this._frame);
			}
		} catch (e) {
			NgLogException(e);
		}
		
		Commands.setFrame.apply(this, this._frame);
		
		if (this.sizeChanged && ((w0 ^ this._frame[2]) | (h0 ^ this._frame[3]))) {
			this.sizeChanged( this._frame[2], this._frame[3], w0, h0 );
		}
	};
	AbstractView.registerAccessors('frame', getFrame, setFrame);

	/**
	 * Set the `gradient` property for a specified view state. You can use this property to add
	 * outlines, shadows, rounded corners, and gradient fills to a view. For detailed information
	 * about this property, see `{@link UI.Style#setGradient}`.
	 * @name UI.AbstractView#setGradient
	 * @function
	 * @example
	 * // Create a button with an opaque white inner shadow that has a 5-pixel
	 * // blur and no offset.
	 * var button = UI.Button();
	 * var gradient = {
	 *     innerShadow: "FFFFFFFF 5.0 {0.0, 0.0}"
	 * };
	 * button.setGradient(gradient, UI.Commands.State.Normal);
	 * @param {Object} gradient The new `gradient` property, using the format described by
	 * `{@link UI.Style#setGradient}`.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {void}
	 * @see UI.AbstractView#getGradient
	 * @see UI.Style#setGradient
	 */
	/**
	 * Retrieve the value of the `gradient` property for a specified view state.
	 * @name UI.AbstractView#getGradient
	 * @function	
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The current gradient, in the format described in
	 *		`{@link UI.Style#setGradient}`.
	 * @see UI.AbstractView#setGradient
	 * @see UI.Style#setGradient
	 */
	AbstractView.synthesizePropertyWithState('gradient', Commands.setGradient);	
	/**
	 * Set the `touchable` property, which indicates whether touch events will affect this view. The
	 * default value is `true`.
	 * @name UI.AbstractView#setTouchable
	 * @function
	 * @example
	 * var image = new UI.Image();
	 * image.setTouchable(false);
	 * @param {Boolean} touchable Set to `true` to allow touch events to affect this view.
	 * @returns {void}
	 * @see UI.AbstractView#getTouchable
	 */
	/**
	 * Retrieve the current value of the `touchable` property, which indicates whether touch events
	 * will affect this view.
	 * @name UI.AbstractView#getTouchable
	 * @function
	 * @returns {Boolean} The current value of the `touchable` property.
	 * @see UI.AbstractView#setTouchable
	 */
	AbstractView.synthesizeProperty('touchable', Commands.setTouchable);
	/**
	 * Set the `alpha` property, which defines the view's opacity.
	 * @name UI.AbstractView#setAlpha
	 * @function
	 * @param {Number} alpha A float ranging from `0.0`, for completely transparent, to `1.0`, for
	 *		completely opaque.
	 * @returns {void}
	 * @see UI.AbstractView#getAlpha
	 * @status iOS, Flash
	 */
	/**
	 * Retrieve the current value of the `alpha` property, which defines the view's opacity.
	 * @name UI.AbstractView#getAlpha
	 * @function
	 * @returns {Number} A float ranging from `0.0`, for completely transparent, to `1.0`,
	 *		for completely opaque.
	 * @see UI.AbstractView#setAlpha
	 * @status Flash
	 */
	AbstractView.synthesizeProperty('alpha', Commands.setAlpha);
	/**
	 * Set the `style` property, which identifies a `{@link UI.Style}` object whose style properties
	 * will be applied to the view.
	 * @name UI.AbstractView#setStyle
	 * @function
	 * @example
	 * // Create a new checkbox, and apply a UI.Style object that specifies
	 * // the text for the checkbox's label.
	 * var checkBox = new UI.CheckBox();
	 * var style = new UI.Style({
	 *     text: "Flip screen"
	 * });
	 * checkBox.setStyle(style);
	 * @param {UI.Style} newStyle A new `UI.Style` object whose style properties will be applied to 
	 *		the view.
	 * @returns {void}
	 * @see UI.AbstractView#getStyle
	 * @see UI.Style
	 * @since 1.6
	 */
	/**
	 * Retrieve the value of the `style` property, which identifies a `{@link UI.Style}` object
	 * whose style properties will be applied to the view.
	 * @name UI.AbstractView#getStyle
	 * @function
	 * @returns {UI.Style} The current `UI.Style` object whose style properties will be applied to
	 *		the view.
	 * @see UI.AbstractView#setStyle
	 * @see UI.Style
	 * @since 1.6
	 */
	AbstractView.synthesizeProperty('style', function(newStyle) {
		if (newStyle instanceof Style) {
			Commands.setStyle.call(this, ObjectRegistry.objectToId(newStyle));
		}
	});

	// Event Handlers
	// the appear event is not implemented, per jyopp
	/**
	 * Set a function to call when an `appear` event occurs.
	 * @name UI.AbstractView#setOnAppear
	 * @event
	 * @cb {Function} appearCallback The function to call when an `appear` event occurs.
	 * @cb-returns {void}
	 * @see UI.AbstractView#event:getOnAppear
	 * @returns {void}
	 * @ignore
	 */
	/**
	 * Retrieve the function to call when an `appear` event occurs.
	 * @name UI.AbstractView#getOnAppear
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnAppear
	 * @ignore
	 */
	AbstractView.registerEventType('appear');
	/**
	 * Set a function to call when a `disappear` event occurs. This event occurs when a view is
	 * hidden.
	 * @name UI.AbstractView#setOnDisappear
	 * @event
	 * @example
	 * var toast = new UI.Toast();
	 * toast.setOnDisappear(function() {
	 *     // We are done with the object after it disappears.
	 *     toast.destroy();
	 * });
	 * @cb {Function} disappearCallback The function to call when a `disappear` event occurs.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.AbstractView#event:getOnDisappear
	 */
	/**
	 * Retrieve the function to call when a `disappear` event occurs. This event occurs when a view
	 * is hidden.
	 * @name UI.AbstractView#getOnDisappear
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnDisappear
	 */
	AbstractView.registerEventType('disappear');
	/**
	 * Set a function to call when a `click` event occurs. This event occurs when a view is tapped.
	 * 
	 * **Note**: As of version 1.6, `UI.EditText` objects no longer fire `click` events.
	 * @name UI.AbstractView#setOnClick
	 * @event
	 * @example
	 * var checked;
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setOnClick(function(event) {
	 *     checked = event.checked;
	 * });
	 * @cb {Function} clickCallback The function to call when a `click` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {Boolean} event.checked Set to `true` if the view is checked.
	 * @cb-returns {void}
	 * @see UI.AbstractView#event:getOnClick
	 * @returns {void}
	 */
	/**
	 * Retrieve the function to call when a `click` event occurs. This event occurs when a view is
	 * tapped.
	 * @name UI.AbstractView#getOnClick
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnClick
	 */
	AbstractView.registerEventType('click');
	
	AbstractView.registerEventType('clickDown');
	AbstractView.registerEventType('clickCancel');

	/**
	 * Set a function to call when a `swipe` event occurs. This event occurs when the user swipes a
	 * finger across the view.
	 * @name UI.AbstractView#setOnSwipe
	 * @event
	 * @example
	 * // Move back or forward in a web view's history when a swipe event occurs.
	 * var webView = new UI.WebView();
	 * webView.setOnSwipe(function(event) {
	 *     if (event.direction == UI.Commands.SwipeDirection.Right &&
	 *         webView.canGoBack()) {
	 *         webView.goBack();
	 *     } else if (event.direction == UI.Commands.SwipeDirection.Left &&
	 *         webView.canGoForward()) {
	 *         webView.goForward();
	 *     }
	 * });
	 * @cb {Function} swipeCallback The function to call when a `swipe` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#SwipeDirection} event.direction The direction of the swipe.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.AbstractView#event:getOnSwipe
	 */
	/**
	 * Retrieve the function to call when a `swipe` event occurs. This event occurs when the user
	 * swipes a finger across the view.
	 * @name UI.AbstractView#getOnSwipe
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnSwipe
	 */
	AbstractView.registerEventType('swipe');
	/**
	 * Set a function to call when a `longPress` event occurs. This event occurs when the user taps
	 * and holds on a view.
	 * @name UI.AbstractView#setOnLongPress
	 * @event
	 * @example
	 * var image = new UI.Image();
	 * image.setOnLongPress(function() {
	 *     console.log("The user is tapping and holding on an image.");
	 * });
	 * @cb {Function} longPressCallback The function to call when a `longPress` event occurs.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.AbstractView#event:getOnLongPress
	 */
	/**
	 * Retrieve the function to call when a `longPress` event occurs.
	 * @name UI.AbstractView#getOnLongPress
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnLongPress
	 */
	AbstractView.registerEventType('longPress');

	/** @private NOT IMPLEMENTED */
	/*
		AbstractView.registerEventType('touchdown');
		AbstractView.registerEventType('touchup');
		AbstractView.registerEventType('touchmove');
		AbstractView.registerEventType('touchcancel');
	*/
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewParent'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ViewParent.js';

var Commands = require('NGCore/Client/UI/Commands').Commands;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

// CAREFUL! THIS IS NOT A CLASS!
exports.ViewParent = {
	initialize : function() {
		this._children = [];
	},

	getChildCount : function() {
		return this._children.length;
	},

	getChildren : function() {
		return this._children.slice();
	},

	addChild : function(childNode,index) {
		if (childNode === this) throw new Error("Cannot add " + childNode + " as a child of itself!");
		if (childNode instanceof AbstractView) {
			if (childNode._parent) childNode.removeFromParent();

			if (index === 0 || index > 0) {
				index = Math.min(index, this.getChildCount());
				this._children.splice(index, 0, childNode);
			} else {
				index = -1;
				this._children.push(childNode);
			}

			// Must populate parent before setting visibility
			childNode._parent = this;
			childNode._setVisible(this._visible);

			Commands.addSubview.call(this, childNode.__objectRegistryId, index);

		} else throw new Error(this.type + ".addChild: " + childNode + " is not a view!");
		return this;
	},

	removeChild : function(childNode) {
		if (childNode instanceof AbstractView) {
			if (childNode._parent == this) {
				childNode._setVisible(false);

				// Remove this node from parent's child list
				var nodeIndex = this._children.indexOf(childNode);
				if (nodeIndex != -1) {
					this._children.splice(nodeIndex, 1);
				}
			}
			// Clear parent value
			childNode._parent = undefined;

			// Remove from the parent at the system level
			Commands.removeFromSuperview.call(childNode);
		} else throw {message: this.type + ".removeChild: " + childNode + " is not a view!"};
		return childNode;
	}

};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WindowLayer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/WindowLayer.js';

var Element = require('NGCore/Client/UI/Element').Element;
var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private
 * 	This ENTIRE CLASS is private.
 */
var WindowLayer = exports.WindowLayer = Element.subclass( {
	'type':'windowlayer',
	initialize: function($super, props) {
		if (WindowLayer.init) WindowLayer.init();
		$super(props);
		if (WindowLayer._init) WindowLayer._init();
		ViewParent.initialize.call(this);
		this._visible = true;
	},
	getRoot: function(){
		return this;
	},
	getParent: function(){
		return undefined;
	},
	
	getChildCount: ViewParent.getChildCount,
	getChildren: ViewParent.getChildren,
	addChild: ViewParent.addChild,
	removeChild: ViewParent.removeChild
});

WindowLayer.init = function() {
	delete WindowLayer._init;
	if (Element._init) Element._init();
	
	WindowLayer.synthesizeProperty('level', Commands.setIntValue);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Window'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Window'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Window'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Window.js';

var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Element = require('NGCore/Client/UI/Element').Element;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var WindowLayer = require('NGCore/Client/UI/WindowLayer').WindowLayer;

// Singleton
// Methods beginning with an underscore are considered private and should
// not be called from outside of the class.

Commands.Window = exports.Window = Class.singleton({
/** @lends UI.Window.prototype */

	/**
	 * @deprecated Replaced by {@link UI.Window#getWidth}.
	 * @ignore
	 */
	_outerWidth: 0,

	/**
	 * @deprecated Replaced by {@link UI.Window#getHeight}.
	 * @ignore
	 */
	_outerHeight: 0,

	/**
	 * @private
	 */
	_width: 0,
	/**
	 * @private
	 */
	_height: 0,

	 /**
	 * @class The `UI.Window` class provides a singleton that manages an application's access to 
	 * native UI controls.
	 *
	 * To display a UI component, your application must add it as a child of the
	 * `UI.Window.document` singleton, either directly or as a child node of another view. See
	 * `{@link UI.Window#document}` for more information.
	 * @singleton
	 * @name UI.Window
	 * @augments Core.Class	
	 * @see UI.Window#document
	 * @since 1.0
	 */
	initialize: function() {
		if (!this._outerWidth || !this._outerHeight) this.setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		if (!this._width || !this._height) this._setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		
		Commands.instantiate();
		Device.LayoutEmitter._setWindow(this);
		NgLogD("window: outer = " + this._outerWidth + " × " + this._outerHeight + " frame = " + this._width + " × " + this._height);
	},
	
	/**
	 * A singleton that provides a virtual "document" for the window's UI components. To display a 
	 * UI component, your application must call `UI.Window.document.addChild()` to add the
	 * component to the document.The UI component will also be displayed if you add the component as
	 * a child node of another view, then call `UI.Window.document.addChild()` on the parent view.
	 * 
	 * This singleton has the following methods:
	 * 
	 * + `{Object} UI.Window.document.addChild(childNode, index)`: Add a view or UI component to the 
	 * document, causing it to display on the device's screen. The `childNode` parameter is an 
	 * object that represents a view or UI component. The optional `index` parameter is a positive 
	 * integer indicating the array index at which to insert the view or component; by default, the 
	 * view or component is added after the last index. Returns `this` to support method invocation
	 * chaining.
	 * + `{Number} UI.Window.document.getChildCount()`: Retrieve the number of children of
	 * the document. Returns the number of children.
	 * + `{Object[]} UI.Window.document.getChildren()`: Retrieve all children of the document.
	 * Returns an array of objects that represent UI components.
	 * + `{Object} UI.Window.document.removeChild(childNode)`: Remove a view or UI component from 
	 * the document. The `childNode` parameter is an object that represents a view or UI component. 
	 * Returns the view or component that was removed.
	 * @example
	 * // Set up a new button by doing the following:
	 * // 1. Create the button, and set its frame to an 80-pixel by 20-pixel
	 * //    rectangle in the upper left corner of the screen.
	 * // 2. Add the button to a new view, and set the new view's frame to fill
	 * //    the entire screen.
	 * // 3. Add the view to the document.
	 * var button = new UI.Button();
	 * button.setFrame([0, 0, 80, 20]);
	 * var view = new UI.View();
	 * view.addChild(button);
	 * view.setFrame([0, 0, Device.LayoutEmitter.getWidth(),
	 *   Device.LayoutEmitter.getHeight()]);
	 * UI.Window.document.addChild(view);
	 * // Retrieve the number of children of the document.
	 * var childCount = UI.Window.document.getChildCount();  // returns 1
	 * // Retrieve an array of the document's children.
	 * var children = UI.Window.document.getChildren();  // returns [{view}]
	 * // Remove the view from the document.
	 * var oldView = UI.Window.document.removeChild(view);  // returns {view}
	 * @fieldOf UI.Window#
	 */
	document: WindowLayer.singleton({
		'type': 'document',
		register: function() {
			// This is not a registered object.
			this.__objectRegistryId = 0;
		}
	}),
	
	_layers: {},
	_getLayer: function(level) {
		return this._layers[level] || (this._layers[level] = new WindowLayer({'level':level || 0}));
	},
	
	/**
	 * @private
	 */
	destroyObject: function(obj) {
		obj.removeFromParent();
		Commands.destroy.call(obj);
		ObjectRegistry.unregister(obj);
	},
	
	/**
	 * @private
	 */
	handleCommand: function(command) {
		// this.log(["Raw Command", command]);
		var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
	//	this.log(["handleCommand:", fields[1]]);
		this.doCommand(fields[1]);
	},
	/**
	* @private
	*/
	setStatusBarHidden: function(value) {
		Commands.setStatusBarHidden(value);
		this._outerHeight = Capabilities.getScreenHeight() - (value ? 0 : (Capabilities.getStatusBarHeight() || 0));
	},
	
	/**
	 * @private
	 */
	doCommand: function(jsonString) {
		//NgLogD(jsonString);
		var command = JSON.parse(jsonString);
		if(command.name == 'callback'){
			var cb = Commands.takeTemporaryCallback(command.callback_id);
			if (typeof cb == 'function') {
				cb(command);
			}
		} else {
			var object = ObjectRegistry.idToObject(command.objId);
			if (object instanceof Element) {
				switch (command.name) {
					case 'event':
						object.performEventCallback(command);
						break;
					case 'update':
						var properties = command.properties || {};
						for (var property in properties) {
							try {
								var setter = object['update' + property.charAt(0).toUpperCase() + property.substr(1)];
								if (typeof setter == 'function') {
									setter.apply(object, [properties[property]]);
								} else {
									// Set read-only properties!
									object['_'+property] = properties[property];
								}
							} catch (e) {}
						}
						break;
					default:
						object.handleCommand(command);
				}
			} else {
				console.log("Message received for non-element object with id " + command.objId);
				return;
			}
		}
		// log(["Got message back", command]);
	},
    
	/**
	 * @private
	 */    
	log: function(object) {
		NgLogD(object.toString());
		// this.postMessage({name: 'log', message: object});
	},
	/**
	 * Retrieve the available screen width, exclusive of orientation and system status bars.
	 *
	 * **Important**: If the device's orientation has recently changed, this method is not
	 * guaranteed to return the current screen width. Call `{@link Device.LayoutEmitter.getWidth}`
	 * to ensure that your application uses the correct screen width.
	 * @name getWidth
	 * @function
	 * @memberOf UI.Window#
	 * @returns {Number} The drawable width of the screen, in logical units. To determine how many
	 *		pixels the device uses per logical unit, call
	 *		`{@link Core.Capabilities#getScreenPixelUnits}`.
	 * @see Core.Capabilities#getScreenPixelUnits
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.1.5
	 */
	getWidth: function()
	{
		return this._width;
	},

	/**
	 * Retrieve the available screen height, exclusive of orientation and system status bars.
	 *
	 * **Important**: If the device's orientation has recently changed, this method is not
	 * guaranteed to return the current screen height. Call `{@link Device.LayoutEmitter.getHeight}`
	 * to ensure that your application uses the correct screen height.
	 * @name getHeight
	 * @function
	 * @memberOf UI.Window#
	 * @returns {Number} The drawable height of the screen, in logical units. To determine how many
	 *		pixels the device uses per logical unit, call
	 *		`{@link Core.Capabilities#getScreenPixelUnits}`.
	 * @see Core.Capabilities#getScreenPixelUnits
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.1.5
	 */
	getHeight: function()
	{
		return this._height;
	},

	getOuterWidth: function() {
		return this._outerWidth;
	},
	
	getOuterHeight: function() {
		return this._outerHeight;
	},

	getFrame: function() {
		return new Rect(0, 0, this._width, this._height);
	}
});

// Cause property access to initialize the singleton. Needed for backward compatibility.
Commands.Window.__defineGetter__("outerWidth", function() {return this.getOuterWidth()});
Commands.Window.__defineGetter__("outerHeight", function() {return this.getOuterHeight()});

/**
 * @private
 */
Commands.Window._setWidthAndHeight = function(width, height)
{
	console.log("window: set layout size to: " + width + ' × ' + height);
	this._width = width;
	this._height = height;
};

/**
 * @private
 */
Commands.Window.setWidthAndHeight = function(width, height)
{
	console.log("window: set outer size to: " + width + ' × ' + height);
	this._outerWidth = width;
	this._outerHeight = height;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Commands'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Commands'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Commands'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Commands.js';

////////////////////////////////////////////////////////////////////////////////
// Class Commands
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

/** @ignore */
function UIAnimationOptions() {
	this.animationCurve = "EaseInOut";
	return this;
}

var Commands = exports.Commands = Core.Class.singleton(
/** @lends UI.Commands.prototype */
{
	/** @ignore */
	classname: 'Commands',
	
	/**
	 * @class The `UI.Commands` class provides a singleton with enumerated constants that are used 
	 * by other classes in the `UI` module.
	 * @name UI.Commands
	 * @singleton
	 * @augments Core.Class
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this.initializeNative(this.__objectRegistryId);
		this._tempCBs = {};
		this._tempCBCount = 0;
	},
	
	/**
	 * Enumeration for different ways to fit an image within a view. The image is scaled relative
	 * to the boundaries of the view, minus any text insets or image insets that have been applied
	 * to the view.
	 * @name FitMode
	 * @fieldOf UI.Commands#
	 */
	 
	/**
	 * The image will not be scaled. It will be clipped if necessary.
	 * @name FitMode.None
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The image will be proportionally scaled to fit within the view.
	 * @name FitMode.Inside
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The image will be proportionally scaled to fill the entire view. Portions of the image that
	 * fall outside the view will be clipped.
	 * @name FitMode.Fill
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The image will be distorted to fill the entire view.
	 * @name FitMode.Stretch
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The image will be proportionally scaled so that its width fills the view. Portions of the
	 * image that fall outside the view will be clipped.
	 * @name FitMode.AspectWidth
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The image will be proportionally scaled so that its height fills the view. Portions of the
	 * image that fall outside the view will be clipped.
	 * @name FitMode.AspectHeight
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The image will be proportionally scaled down to fit completely within the view. If the image 
	 * is smaller than the view, it will not be upscaled.
	 * @name FitMode.InsideNoUpscaling
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	/**
	 * Enumeration for supported units for dimensions.
	 * @name Scaling
	 * @fieldOf UI.Commands#
	 */
	
	/**
	 * One unit equals one pixel. On Android devices, when your application uses this scaling mode,
	 * use integers to represent coordinates. On iOS devices, it may be appropriate in some cases
	 * to use half-pixels or quarter-pixels to position content.
	 * @name Scaling.Pixels
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * One unit equals roughly one typesetting point, rescaled from 72 dpi to 160 dpi.
	 * @name Scaling.Points
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The value 1.0 represents 100 percent of the view width or height.
	 * @name Scaling.Unit
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * One unit equals one percent of the view width or height.
	 * @name Scaling.Percent
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is scaled so that its width is 320 units.
	 * @name Scaling.iPhone
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	/**
	 * Enumeration for view states that are used by `{@link UI.AbstractView}` and its subclasses.
	 * Your application can set different display properties for each view state, which will cause
	 * a view's appearance to change automatically when its view state changes. For example, a
	 * button's fill color could change when the button is selected, and its text could be displayed
	 * in a lighter color when the button is disabled.
	 * 
	 * A view can be in multiple states simultaneously. You can specify display properties that
	 * apply to a particular combination of view states. For example, you can use one fill color for
	 * a checkbox when it is checked, and a different fill color when it is both pressed and
	 * checked.
	 *
	 * If a view is in multiple states, and there are no display properties defined for that
	 * combination of states, ngCore will use the display properties from the view state that has
	 * the highest priority. The priority order for view states is as follows:
	 *
	 * 1. `{@link UI.Commands#State.Disabled}`
	 * 2. `{@link UI.Commands#State.Custom}`
	 * 3. `{@link UI.Commands#State.Checked}`
	 * 4. `{@link UI.Commands#State.Pressed}`
	 * 5. `{@link UI.Commands#State.Selected}`
	 * 6. `{@link UI.Commands#State.Focused}`
	 * 7. `{@link UI.Commands#State.Normal}`
	 *
	 * Your application can define its own custom view states for UI components. For example, you
	 * could assign two different view states to even and odd rows in a table, so that even and odd
	 * rows could use different background colors. A custom view state should be represented by a
	 * constant that is greater than `0x00FF0000` and less than `0x40000000`. Any value in this
	 * range will have a display priority between `{@link UI.Commands#State.Disabled}` and
	 * `{@link UI.Commands#State.Custom}`; higher numbers will have a higher display priority. If
	 * your application needs only one custom view state, you can use the constant
	 * `{@link UI.Commands#State.Custom}`.
	 *
	 * **Note**: Many methods in the `UI` module are documented as accepting parameters or returning
	 * values that correspond to an enumerated constant of `UI.Commands.State`. These parameters
	 * and return values can also contain a bitwise combination of constants, including any custom
	 * view states that have been defined.
	 * @name State
	 * @fieldOf UI.Commands#
	 * @example
	 * // Create a UI.Button object, defining its text.
	 * var button = new UI.Button({
	 *     text: "Send"
	 * });
	 * // Define a custom view state.
	 * var customViewState = 0x10000000;
	 * // Specify text colors for various view states.
	 * button.setTextColor("4B4B4B", UI.Commands.State.Normal);    // dark gray
	 * button.setTextColor("FFFFFF", UI.Commands.State.Focused);   // black
	 * button.setTextColor("006BDB", UI.Commands.State.Pressed);   // blue
	 * button.setTextColor("DB1A00",                               // red
	 *   customViewState | UI.Commands.State.Pressed);
	 * // Update the button's view state.
	 * button.setState(UI.Commands.State.Focused);    // text is black
	 * button.setState(UI.Commands.State.Pressed);    // text is blue
	 * button.addState(customViewState);              // text is red
	 * button.clearState(customViewState);            // text is blue
	 * button.setState(UI.Commands.State.Normal);     // text is dark gray
	 * @see UI.AbstractView#addState
	 * @see UI.AbstractView#clearState
	 * @see UI.AbstractView#getState
	 * @see UI.AbstractView#setState
	 */
	
	/**
	 * The view is in a normal state.
	 * @name State.Normal
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is focused.
	 * @name State.Focused
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is selected.
	 * @name State.Selected
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is pressed.
	 * @name State.Pressed
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is checked.
	 * @name State.Checked
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is in a custom state whose properties are defined by the application.
	 * @name State.Custom
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The view is disabled.
	 * @name State.Disabled
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Enumeration for the action that will occur when the user types Enter in a text field. For 
	 * devices that have soft keyboards, the device uses this value and the value of 
	 * `{@link UI.Commands#InputType}` to control which keyboard is displayed to the user.
	 * @name EnterKeyType
	 * @fieldOf UI.Commands#
	 * @see UI.Commands#InputType
	 */
	
	/**
	 * Add a line break.
	 * @name EnterKeyType.Return
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Indicate that the user is done editing text.
	 * @name EnterKeyType.Done
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Advance to the next text field.
	 * @name EnterKeyType.Next
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Submit the user's input.
	 * @name EnterKeyType.Submit
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Go to a webpage.
	 * @name EnterKeyType.Go
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Perform a search.
	 * @name EnterKeyType.Search
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Send a message.
	 * @name EnterKeyType.Send
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	/**
	 * Enumeration for the input type to use for a text field. For devices that have soft keyboards,
	 * the device uses this value and the value of `{@link UI.Commands#EnterKeyType}` to control 
	 * which keyboard is displayed to the user.
	 * @name InputType
	 * @fieldOf UI.Commands#
	 * @see UI.Commands#EnterKeyType
	 */
	
	/**
	 * The field will contain text and should not be autocorrected.
	 * @name InputType.None
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field will contain text and should be autocorrected.
	 * @name InputType.TextWithCorrection
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field will contain a password.
	 * @name InputType.Password
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field will contain a numeric value.
	 * @name InputType.Numeric
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field will contain an email address.
	 * @name InputType.Email
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field will contain a URL.
	 * @name InputType.URL
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field will contain a date.
	 * @name InputType.Date
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The field should cover the entire screen in landscape mode. Available only on Android.
	 * @name InputType.ANDROID_LANDSCAPE_FULLSCREEN
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	/**
	 * Arrangement of combinations of text and images for buttons. When stacked, the button rect
	 * will be divided proportionally into two rects that completely cover the button. Gravity will
	 * apply to the image and text within their rects.
	 * @name ButtonLayout
	 * @fieldOf UI.Commands#
	 * @ignore
	 */

	
	/**
	 * Enumeration for the direction in which the user swiped a finger.
	 * @name SwipeDirection
	 * @fieldOf UI.Commands#
	 * @see UI.AbstractView#event:setOnSwipe
	 */
	
	/**
	 * The user swiped left.
	 * @name SwipeDirection.Left
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The user swiped right.
	 * @name SwipeDirection.Right
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The user swiped up.
	 * @name SwipeDirection.Up
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The user swiped down.
	 * @name SwipeDirection.Down
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	/**
	 * Enumeration for the orientations in which a view should be visible.
	 * @name OrientationFlag
	 * @fieldOf UI.Commands#
	 * @see UI.AbstractView#setVisibleInOrientations
	 */
	
	/**
	 * Display the view when in landscape mode.
	 * @name OrientationFlag.Landscape
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Display the view when in portrait mode.
	 * @name OrientationFlag.Portrait
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	/**
	 * Enumeration for controlling the types of fields that are autodetected in web views. Available
	 * only on iOS.
	 * @name Autodetect
	 * @fieldOf UI.Commands#
	 * @see UI.WebView#setAutodetection
	 */
	
	/**
	 * Disable autodetection. Available only on iOS.
	 * @name Autodetect.None
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Autodetect phone numbers, and show them as links. Available only on iOS.
	 * @name Autodetect.Phone
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Enumeration for the types of errors that can result from attempting to retrieve a file. In
	 * addition to these enumerated values, the application may receive a numeric HTTP error code.
	 * @name ResourceError
	 * @fieldOf UI.Commands#
	 */
	
	/**
	 * No error occurred.
	 * @name ResourceError.None
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * An unspecified error occurred.
	 * @name ResourceError.Other
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The requested file could not be found.
	 * @name ResourceError.File_Not_Found
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The file could not be loaded because the device is out of memory.
	 * @name ResourceError.Out_Of_Memory
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The file could not be loaded because of a problem with network connectivity.
	 * @name ResourceError.Connectivity_Error
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * The file could not be decoded.
	 * @name ResourceError.Decode_Failed
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Enumeration for screenshot options.
	 * @name ScreenshotType
	 * @fieldOf UI.Commands#
	 */
	
	/**
	 * Capture graphics drawn with both the `UI` and `{@link GL2}` modules.
	 * @name ScreenshotType.Normal
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Only capture graphics drawn with the `{@link GL2}` module.
	 * @name ScreenshotType.GLOnly
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	/**
	 * Only capture graphics drawn with the `UI` module.
	 * @name ScreenshotType.UIOnly
	 * @fieldOf UI.Commands#
	 * @constant
	 */
	
	
	
// {{?Wg Generated Code}}
	
	// Enums.
	FitMode:
	{ 
		None: 0,
		Inside: 1,
		Fill: 2,
		Stretch: 3,
		AspectWidth: 5,
		AspectHeight: 6,
		InsideNoUpscaling: 7
	},
	
	Scaling:
	{ 
		Pixels: 0,
		Points: 1,
		Unit: 2,
		Percent: 3,
		iPhone: 4
	},
	
	FontStyle:
	{ 
		Normal: 0,
		Bold: 1,
		Italic: 2,
		BoldItalic: 3
	},
	
	State:
	{ 
		Normal: 0x00,
		Focused: 0x01,
		Selected: 0x02,
		Pressed: 0x04,
		Checked: 0x08,
		Custom: 0x00FF0000,
		Disabled: 0x40000000
	},
	
	EnterKeyType:
	{ 
		Return: 0,
		Done: 1,
		Next: 2,
		Submit: 3,
		Go: 4,
		Search: 5,
		Send: 6
	},
	
	InputType:
	{ 
		None: 0,
		TextWithCorrection: 1,
		Password: 2,
		Numeric: 4,
		Email: 5,
		URL: 6,
		Date: 7,
		ANDROID_LANDSCAPE_FULLSCREEN: 8
	},
	
	ButtonLayout:
	{ 
		CenterTextOver: 0,
		StackImageLeft: 1,
		StackImageTop: 2,
		StackImageRight: 3,
		StackImageBottom: 4,
		CenterImageOver: 5
	},
	
	SwipeDirection:
	{ 
		Left: 1,
		Right: 2,
		Up: 3,
		Down: 4
	},
	
	OrientationFlag:
	{ 
		Landscape: 0x01,
		Portrait: 0x02
	},
	
	Autodetect:
	{ 
		None: 0,
		Phone: 1
	},
	
	ResourceError:
	{ 
		None: 0,
		Other: -1,
		File_Not_Found: -2,
		Out_Of_Memory: -3,
		Connectivity_Error: -4,
		Decode_Failed: -5
	},
	
	ScreenshotType:
	{ 
		Normal: 0,
		GLOnly: 1,
		UIOnly: 2
	},
	
	///////
	// Class Summary and Generated Constants (for internal use only):
	_classId: 337,
	// Method -1: _initializeNative ( int reservedId )
	// Method -2: _create ( int newObjectId, str className )
	// Method 3: _destroy (  )
	// Method 4: _setActive ( bool active )
	// Method 5: _setTouchable ( bool touchable )
	// Method 6: _enableEvent ( str eventName )
	// Method 7: _disableEvent ( str eventName )
	// Method -8: _eventOccurred ( json eventObject )
	// Method 9: _setIsVisible ( bool visible )
	// Method 10: _setEnabled ( bool enable )
	// Method 11: _setState ( int state )
	// Method 12: _addSubview ( int __objectRegistryId, int index )
	// Method 13: _removeFromSuperview (  )
	// Method -14: _startAnimation ( int durationMs, str callbackId )
	// Method -15: _executeAnimation ( json options )
	// Method 16: _setFrame ( float x, float y, float w, float h )
	// Method 17: _setOrigin ( float x, float y )
	// Method 18: _setAnchor ( float x, float y )
	// Method 19: _setSize ( float w, float h )
	// Method 20: _setTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 21: _setBackgroundColor ( str color )
	// Method 22: _setImage ( int state, str imageURL )
	// Method 23: _setImageBorder ( int state, json gradientJSON )
	// Method 24: _setImageFitMode ( int fitMode )
	// Method 25: _setImageGravity ( float x, float y )
	// Method 26: _setImageOrigin ( float x, float y )
	// Method 27: _setImageAnchor ( float x, float y )
	// Method 28: _setImageSize ( float w, float h )
	// Method 29: _setImageInsets ( float t, float r, float b, float l )
	// Method 30: _setImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 31: _setText ( int state, str text )
	// Method 32: _setTextColor ( int state, str text )
	// Method 33: _setTextFont ( int state, str fontName )
	// Method 34: _setTextShadow ( int state, str shadow )
	// Method 35: _setTextSize ( float textFontSize )
	// Method 36: _setTextGravity ( float x, float y )
	// Method 37: _setTextInsets ( float t, float r, float b, float l )
	// Method 38: _setTextOverflow ( int overflowMode )
	// Method 39: _setTextMaxLines ( int maxLines )
	// Method 40: _setTextMinSize ( float minSize )
	// Method 41: _setTitle ( int state, str title )
	// Method 42: _setTitleColor ( int state, str title )
	// Method 43: _setTitleFont ( int state, str fontName )
	// Method 44: _setTitleShadow ( int state, str shadow )
	// Method 45: _setTitleSize ( float titleFontSize )
	// Method 46: _setTitleGravity ( float x, float y )
	// Method 47: _setTitleInsets ( float t, float r, float b, float l )
	// Method 48: _setTitleOverflow ( int overflowMode )
	// Method 49: _setTitleMaxLines ( int maxLines )
	// Method 50: _setTitleMinSize ( float minSize )
	// Method 51: _setGradient ( int state, json gradientJSON )
	// Method 52: _setStringValue ( str value )
	// Method 53: _setFloatValue ( float value )
	// Method 54: _setIntValue ( int value )
	// Method 55: _setBoolValue ( bool value )
	// Method 56: _setButtonLayout ( int layoutType )
	// Method 57: _setContentInsets ( float t, float r, float b, float l )
	// Method 58: _setBarGradient ( int state, json gradientJSON )
	// Method 59: _setPlaceholderText ( str placeholder )
	// Method 60: _setPlaceholderTextColor ( str color )
	// Method 61: _setPlaceholderTextShadow ( str shadow )
	// Method 62: _setEnterKeyType ( int enterKeyType )
	// Method 63: _setInputType ( int inputType )
	// Method 64: _setChecked ( bool checked )
	// Method 65: _setScrollPosition ( float x, float y )
	// Method 66: _setScrollableSize ( float w, float h )
	// Method 67: _setSections ( json idArray )
	// Method 68: _setTitleView ( int titleObjectID )
	// Method 69: _setSourceDocument ( str documentURL )
	// Method 70: _setChoices ( json stringArray, int defaultChoiceIndex, int cancelChoiceIndex )
	// Method 71: _show (  )
	// Method 72: _hide (  )
	// Method 73: _setPostData ( str data )
	// Method 74: _loadPostURL ( str url )
	// Method 75: _loadGetURL ( str url )
	// Method 76: _loadURL ( str url, json headers, float timeout )
	// Method 77: _stopLoading (  )
	// Method 78: _reload (  )
	// Method 79: _invoke ( str script )
	// Method 80: _goBack (  )
	// Method 81: _goForward (  )
	// Method 82: _setBasicAuthCredentials ( json credentials )
	// Method 83: _setRightImage ( int state, str rightImageURL )
	// Method 84: _setRightImageBorder ( int state, json gradientJSON )
	// Method 85: _setRightImageFitMode ( int fitMode )
	// Method 86: _setRightImageGravity ( float x, float y )
	// Method 87: _setRightImageOrigin ( float x, float y )
	// Method 88: _setRightImageAnchor ( float x, float y )
	// Method 89: _setRightImageSize ( float w, float h )
	// Method 90: _setRightImageInsets ( float t, float r, float b, float l )
	// Method 91: _setRightImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method -92: _setStatusBarHidden ( bool statusBarStatus )
	// Method 93: _pauseAds (  )
	// Method 94: _resumeAds (  )
	// Method 95: _setAdRefreshRate ( int refreshRate )
	// Method 96: _setAdAllowAutoplay ( bool autoplay )
	// Method 97: _setAlpha ( float alpha )
	// Method 98: _postURL ( str url, str data )
	// Method 99: _setProgressGradient ( int state, json gradientJSON )
	// Method 100: _setSecondaryGradient ( int state, json gradientJSON )
	// Method 101: _setProgress ( float progress, float secondaryProgress )
	// Method 102: _useForUpdateProgress ( bool use )
	// Method 103: _setDarkStyle ( bool use )
	// Method -104: _doCompositeImages ( int w, int h, str filename, json infoArray, str callbackId )
	// Method -105: _REMOVED_doChoosePhoto ( int w, int h, str filename, json options, str callbackId )
	// Method -106: _doChooseCamera ( int w, int h, str filename, json options, str callbackId )
	// Method 107: _setScrollable ( bool enabled )
	// Method 108: _setZoomable ( bool enabled )
	// Method 109: _addAnnotation ( int __objectRegistryId )
	// Method 110: _removeAnnotation ( int __objectRegistryId )
	// Method 111: _selectAnnotation ( int __objectRegistryId )
	// Method 112: _setRegion ( float latitude, float longitude, float latitudeDelta, float longitudeDelta, bool animated )
	// Method 113: _setView ( int __objectRegistryId )
	// Method 114: _setCoordinate ( float latitude, float longitude )
	// Method 115: _setCalloutTitle ( str title )
	// Method 116: _setCalloutSubtitle ( str subTitle )
	// Method 117: _setCalloutEnabled ( bool enabled )
	// Method 118: _setCalloutLeftView ( int __objectRegistryId )
	// Method 119: _setCalloutRightView ( int __objectRegistryId )
	// Method 120: _setCenterOffset ( float xOffset, float yOffset )
	// Method -121: _doChoosePhoto ( int w, int h, str filename, json options, str callbackId, int invokingView )
	// Method 122: _setScrollIndicatorsVisible ( bool enabled )
	// Method -123: _measureText ( str string, int w, int h, str font, float fontSize, str callbackId )
	// Method 124: _setFocus ( bool enabled )
	// Method 125: _setViewportEnabled ( bool enabled )
	// Method 126: _clearAnimations (  )
	// Method 127: _setStyle ( int styleID )
	// Method 128: _setVisibleInOrientations ( int orientationFlags )
	// Method 129: _setAutodetection ( int type )
	// Method 130: _playVideo ( str path, str callbackId )
	// Method 131: _setLineHeight ( float lineHeight )
	// Method -132: _hideKeyboard (  )
	// Method -133: _takeScreenshot ( int w, int h, str filename, json options, str callbackId )
	// Method 134: _setPluginsEnabled ( bool enable )
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -8:
					Commands._eventOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[337] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_eventOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "eventObject" ] = Core.Proc.parseObject( cmd[ 0 ] );
		if( obj[ "eventObject" ] === undefined )
		{
			NgLogE("Could not parse eventObject in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$initializeNative: function( reservedId )
	{
		Core.Proc.appendToCommandString( 0x151ffff, [ +reservedId ] );
	},
	
	/** @private */
	$create: function( newObjectId, className )
	{
		Core.Proc.appendToCommandString( 0x151fffe, [ +newObjectId, Core.Proc.encodeString( className ) ] );
	},
	
	/** @private */
	destroy: function(  )
	{
		Core.Proc.appendToCommandString( 0x1510003, this );
	},
	
	/** @private */
	setActive: function( active )
	{
		Core.Proc.appendToCommandString( 0x1510004, this, [ ( active ? 1 : 0 ) ] );
	},
	
	/** @private */
	setTouchable: function( touchable )
	{
		Core.Proc.appendToCommandString( 0x1510005, this, [ ( touchable ? 1 : 0 ) ] );
	},
	
	/** @private */
	enableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( 0x1510006, this, [ Core.Proc.encodeString( eventName ) ] );
	},
	
	/** @private */
	disableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( 0x1510007, this, [ Core.Proc.encodeString( eventName ) ] );
	},
	
	/** @private */
	setIsVisible: function( visible )
	{
		Core.Proc.appendToCommandString( 0x1510009, this, [ ( visible ? 1 : 0 ) ] );
	},
	
	/** @private */
	setEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( 0x151000a, this, [ ( enable ? 1 : 0 ) ] );
	},
	
	/** @private */
	setState: function( state )
	{
		Core.Proc.appendToCommandString( 0x151000b, this, [ +state ] );
	},
	
	/** @private */
	addSubview: function( __objectRegistryId, index )
	{
		Core.Proc.appendToCommandString( 0x151000c, this, [ +__objectRegistryId, +index ] );
	},
	
	/** @private */
	removeFromSuperview: function(  )
	{
		Core.Proc.appendToCommandString( 0x151000d, this );
	},
	
	/** @private */
	$startAnimation: function( durationMs, callbackId )
	{
		Core.Proc.appendToCommandString( 0x151fff2, [ +durationMs, Core.Proc.encodeString( callbackId ) ] );
	},
	
	/** @private */
	$executeAnimation: function( options )
	{
		Core.Proc.appendToCommandString( 0x151fff1, [ Core.Proc.encodeObject( options ) ] );
	},
	
	/** @private */
	setFrame: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( 0x1510010, this, [ +x, +y, +w, +h ] );
	},
	
	/** @private */
	setOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510011, this, [ +x, +y ] );
	},
	
	/** @private */
	setAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510012, this, [ +x, +y ] );
	},
	
	/** @private */
	setSize: function( w, h )
	{
		Core.Proc.appendToCommandString( 0x1510013, this, [ +w, +h ] );
	},
	
	/** @private */
	setTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( 0x1510014, this, [ +a, +b, +c, +d, +tx, +ty ] );
	},
	
	/** @private */
	setBackgroundColor: function( color )
	{
		Core.Proc.appendToCommandString( 0x1510015, this, [ Core.Proc.encodeString( color ) ] );
	},
	
	/** @private */
	setImage: function( state, imageURL )
	{
		Core.Proc.appendToCommandString( 0x1510016, this, [ +state, Core.Proc.encodeString( imageURL ) ] );
	},
	
	/** @private */
	setImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( 0x1510017, this, [ +state, Core.Proc.encodeObject( gradientJSON ) ] );
	},
	
	/** @private */
	setImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( 0x1510018, this, [ +fitMode ] );
	},
	
	/** @private */
	setImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510019, this, [ +x, +y ] );
	},
	
	/** @private */
	setImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x151001a, this, [ +x, +y ] );
	},
	
	/** @private */
	setImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x151001b, this, [ +x, +y ] );
	},
	
	/** @private */
	setImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( 0x151001c, this, [ +w, +h ] );
	},
	
	/** @private */
	setImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( 0x151001d, this, [ +t, +r, +b, +l ] );
	},
	
	/** @private */
	setImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( 0x151001e, this, [ +a, +b, +c, +d, +tx, +ty ] );
	},
	
	/** @private */
	setText: function( state, text )
	{
		Core.Proc.appendToCommandString( 0x151001f, this, [ +state, Core.Proc.encodeString( text ) ] );
	},
	
	/** @private */
	setTextColor: function( state, text )
	{
		Core.Proc.appendToCommandString( 0x1510020, this, [ +state, Core.Proc.encodeString( text ) ] );
	},
	
	/** @private */
	setTextFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( 0x1510021, this, [ +state, Core.Proc.encodeString( fontName ) ] );
	},
	
	/** @private */
	setTextShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( 0x1510022, this, [ +state, Core.Proc.encodeString( shadow ) ] );
	},
	
	/** @private */
	setTextSize: function( textFontSize )
	{
		Core.Proc.appendToCommandString( 0x1510023, this, [ +textFontSize ] );
	},
	
	/** @private */
	setTextGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510024, this, [ +x, +y ] );
	},
	
	/** @private */
	setTextInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( 0x1510025, this, [ +t, +r, +b, +l ] );
	},
	
	/** @private */
	setTextOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( 0x1510026, this, [ +overflowMode ] );
	},
	
	/** @private */
	setTextMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( 0x1510027, this, [ +maxLines ] );
	},
	
	/** @private */
	setTextMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( 0x1510028, this, [ +minSize ] );
	},
	
	/** @private */
	setTitle: function( state, title )
	{
		Core.Proc.appendToCommandString( 0x1510029, this, [ +state, Core.Proc.encodeString( title ) ] );
	},
	
	/** @private */
	setTitleColor: function( state, title )
	{
		Core.Proc.appendToCommandString( 0x151002a, this, [ +state, Core.Proc.encodeString( title ) ] );
	},
	
	/** @private */
	setTitleFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( 0x151002b, this, [ +state, Core.Proc.encodeString( fontName ) ] );
	},
	
	/** @private */
	setTitleShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( 0x151002c, this, [ +state, Core.Proc.encodeString( shadow ) ] );
	},
	
	/** @private */
	setTitleSize: function( titleFontSize )
	{
		Core.Proc.appendToCommandString( 0x151002d, this, [ +titleFontSize ] );
	},
	
	/** @private */
	setTitleGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x151002e, this, [ +x, +y ] );
	},
	
	/** @private */
	setTitleInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( 0x151002f, this, [ +t, +r, +b, +l ] );
	},
	
	/** @private */
	setTitleOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( 0x1510030, this, [ +overflowMode ] );
	},
	
	/** @private */
	setTitleMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( 0x1510031, this, [ +maxLines ] );
	},
	
	/** @private */
	setTitleMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( 0x1510032, this, [ +minSize ] );
	},
	
	/** @private */
	setGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( 0x1510033, this, [ +state, Core.Proc.encodeObject( gradientJSON ) ] );
	},
	
	/** @private */
	setStringValue: function( value )
	{
		Core.Proc.appendToCommandString( 0x1510034, this, [ Core.Proc.encodeString( value ) ] );
	},
	
	/** @private */
	setFloatValue: function( value )
	{
		Core.Proc.appendToCommandString( 0x1510035, this, [ +value ] );
	},
	
	/** @private */
	setIntValue: function( value )
	{
		Core.Proc.appendToCommandString( 0x1510036, this, [ +value ] );
	},
	
	/** @private */
	setBoolValue: function( value )
	{
		Core.Proc.appendToCommandString( 0x1510037, this, [ ( value ? 1 : 0 ) ] );
	},
	
	/** @private */
	setButtonLayout: function( layoutType )
	{
		Core.Proc.appendToCommandString( 0x1510038, this, [ +layoutType ] );
	},
	
	/** @private */
	setContentInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( 0x1510039, this, [ +t, +r, +b, +l ] );
	},
	
	/** @private */
	setBarGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( 0x151003a, this, [ +state, Core.Proc.encodeObject( gradientJSON ) ] );
	},
	
	/** @private */
	setPlaceholderText: function( placeholder )
	{
		Core.Proc.appendToCommandString( 0x151003b, this, [ Core.Proc.encodeString( placeholder ) ] );
	},
	
	/** @private */
	setPlaceholderTextColor: function( color )
	{
		Core.Proc.appendToCommandString( 0x151003c, this, [ Core.Proc.encodeString( color ) ] );
	},
	
	/** @private */
	setPlaceholderTextShadow: function( shadow )
	{
		Core.Proc.appendToCommandString( 0x151003d, this, [ Core.Proc.encodeString( shadow ) ] );
	},
	
	/** @private */
	setEnterKeyType: function( enterKeyType )
	{
		Core.Proc.appendToCommandString( 0x151003e, this, [ +enterKeyType ] );
	},
	
	/** @private */
	setInputType: function( inputType )
	{
		Core.Proc.appendToCommandString( 0x151003f, this, [ +inputType ] );
	},
	
	/** @private */
	setChecked: function( checked )
	{
		Core.Proc.appendToCommandString( 0x1510040, this, [ ( checked ? 1 : 0 ) ] );
	},
	
	/** @private */
	setScrollPosition: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510041, this, [ +x, +y ] );
	},
	
	/** @private */
	setScrollableSize: function( w, h )
	{
		Core.Proc.appendToCommandString( 0x1510042, this, [ +w, +h ] );
	},
	
	/** @private */
	setSections: function( idArray )
	{
		Core.Proc.appendToCommandString( 0x1510043, this, [ Core.Proc.encodeObject( idArray ) ] );
	},
	
	/** @private */
	setTitleView: function( titleObjectID )
	{
		Core.Proc.appendToCommandString( 0x1510044, this, [ +titleObjectID ] );
	},
	
	/** @private */
	setSourceDocument: function( documentURL )
	{
		Core.Proc.appendToCommandString( 0x1510045, this, [ Core.Proc.encodeString( documentURL ) ] );
	},
	
	/** @private */
	setChoices: function( stringArray, defaultChoiceIndex, cancelChoiceIndex )
	{
		Core.Proc.appendToCommandString( 0x1510046, this, [ Core.Proc.encodeObject( stringArray ), +defaultChoiceIndex, +cancelChoiceIndex ] );
	},
	
	/** @private */
	show: function(  )
	{
		Core.Proc.appendToCommandString( 0x1510047, this );
	},
	
	/** @private */
	hide: function(  )
	{
		Core.Proc.appendToCommandString( 0x1510048, this );
	},
	
	/** @private */
	setPostData: function( data )
	{
		Core.Proc.appendToCommandString( 0x1510049, this, [ Core.Proc.encodeString( data ) ] );
	},
	
	/** @private */
	loadPostURL: function( url )
	{
		Core.Proc.appendToCommandString( 0x151004a, this, [ Core.Proc.encodeString( url ) ] );
	},
	
	/** @private */
	loadGetURL: function( url )
	{
		Core.Proc.appendToCommandString( 0x151004b, this, [ Core.Proc.encodeString( url ) ] );
	},
	
	/** @private */
	loadURL: function( url, headers, timeout )
	{
		Core.Proc.appendToCommandString( 0x151004c, this, [ Core.Proc.encodeString( url ), Core.Proc.encodeObject( headers ), +timeout ] );
	},
	
	/** @private */
	stopLoading: function(  )
	{
		Core.Proc.appendToCommandString( 0x151004d, this );
	},
	
	/** @private */
	reload: function(  )
	{
		Core.Proc.appendToCommandString( 0x151004e, this );
	},
	
	/** @private */
	invoke: function( script )
	{
		Core.Proc.appendToCommandString( 0x151004f, this, [ Core.Proc.encodeString( script ) ] );
	},
	
	/** @private */
	goBack: function(  )
	{
		Core.Proc.appendToCommandString( 0x1510050, this );
	},
	
	/** @private */
	goForward: function(  )
	{
		Core.Proc.appendToCommandString( 0x1510051, this );
	},
	
	/** @private */
	setBasicAuthCredentials: function( credentials )
	{
		Core.Proc.appendToCommandString( 0x1510052, this, [ Core.Proc.encodeObject( credentials ) ] );
	},
	
	/** @private */
	setRightImage: function( state, rightImageURL )
	{
		Core.Proc.appendToCommandString( 0x1510053, this, [ +state, Core.Proc.encodeString( rightImageURL ) ] );
	},
	
	/** @private */
	setRightImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( 0x1510054, this, [ +state, Core.Proc.encodeObject( gradientJSON ) ] );
	},
	
	/** @private */
	setRightImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( 0x1510055, this, [ +fitMode ] );
	},
	
	/** @private */
	setRightImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510056, this, [ +x, +y ] );
	},
	
	/** @private */
	setRightImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510057, this, [ +x, +y ] );
	},
	
	/** @private */
	setRightImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1510058, this, [ +x, +y ] );
	},
	
	/** @private */
	setRightImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( 0x1510059, this, [ +w, +h ] );
	},
	
	/** @private */
	setRightImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( 0x151005a, this, [ +t, +r, +b, +l ] );
	},
	
	/** @private */
	setRightImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( 0x151005b, this, [ +a, +b, +c, +d, +tx, +ty ] );
	},
	
	/** @private */
	$setStatusBarHidden: function( statusBarStatus )
	{
		Core.Proc.appendToCommandString( 0x151ffa4, [ ( statusBarStatus ? 1 : 0 ) ] );
	},
	
	/** @private */
	pauseAds: function(  )
	{
		Core.Proc.appendToCommandString( 0x151005d, this );
	},
	
	/** @private */
	resumeAds: function(  )
	{
		Core.Proc.appendToCommandString( 0x151005e, this );
	},
	
	/** @private */
	setAdRefreshRate: function( refreshRate )
	{
		Core.Proc.appendToCommandString( 0x151005f, this, [ +refreshRate ] );
	},
	
	/** @private */
	setAdAllowAutoplay: function( autoplay )
	{
		Core.Proc.appendToCommandString( 0x1510060, this, [ ( autoplay ? 1 : 0 ) ] );
	},
	
	/** @private */
	setAlpha: function( alpha )
	{
		Core.Proc.appendToCommandString( 0x1510061, this, [ +alpha ] );
	},
	
	/** @private */
	postURL: function( url, data )
	{
		Core.Proc.appendToCommandString( 0x1510062, this, [ Core.Proc.encodeString( url ), Core.Proc.encodeString( data ) ] );
	},
	
	/** @private */
	setProgressGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( 0x1510063, this, [ +state, Core.Proc.encodeObject( gradientJSON ) ] );
	},
	
	/** @private */
	setSecondaryGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( 0x1510064, this, [ +state, Core.Proc.encodeObject( gradientJSON ) ] );
	},
	
	/** @private */
	setProgress: function( progress, secondaryProgress )
	{
		Core.Proc.appendToCommandString( 0x1510065, this, [ +progress, +secondaryProgress ] );
	},
	
	/** @private */
	useForUpdateProgress: function( use )
	{
		Core.Proc.appendToCommandString( 0x1510066, this, [ ( use ? 1 : 0 ) ] );
	},
	
	/** @private */
	setDarkStyle: function( use )
	{
		Core.Proc.appendToCommandString( 0x1510067, this, [ ( use ? 1 : 0 ) ] );
	},
	
	/** @private */
	$doCompositeImages: function( w, h, filename, infoArray, callbackId )
	{
		Core.Proc.appendToCommandString( 0x151ff98, [ +w, +h, Core.Proc.encodeString( filename ), Core.Proc.encodeObject( infoArray ), Core.Proc.encodeString( callbackId ) ] );
	},
	
	/** @private */
	$doChooseCamera: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( 0x151ff96, [ +w, +h, Core.Proc.encodeString( filename ), Core.Proc.encodeObject( options ), Core.Proc.encodeString( callbackId ) ] );
	},
	
	/** @private */
	setScrollable: function( enabled )
	{
		Core.Proc.appendToCommandString( 0x151006b, this, [ ( enabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	setZoomable: function( enabled )
	{
		Core.Proc.appendToCommandString( 0x151006c, this, [ ( enabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	addAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x151006d, this, [ +__objectRegistryId ] );
	},
	
	/** @private */
	removeAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x151006e, this, [ +__objectRegistryId ] );
	},
	
	/** @private */
	selectAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x151006f, this, [ +__objectRegistryId ] );
	},
	
	/** @private */
	setRegion: function( latitude, longitude, latitudeDelta, longitudeDelta, animated )
	{
		Core.Proc.appendToCommandString( 0x1510070, this, [ +latitude, +longitude, +latitudeDelta, +longitudeDelta, ( animated ? 1 : 0 ) ] );
	},
	
	/** @private */
	setView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x1510071, this, [ +__objectRegistryId ] );
	},
	
	/** @private */
	setCoordinate: function( latitude, longitude )
	{
		Core.Proc.appendToCommandString( 0x1510072, this, [ +latitude, +longitude ] );
	},
	
	/** @private */
	setCalloutTitle: function( title )
	{
		Core.Proc.appendToCommandString( 0x1510073, this, [ Core.Proc.encodeString( title ) ] );
	},
	
	/** @private */
	setCalloutSubtitle: function( subTitle )
	{
		Core.Proc.appendToCommandString( 0x1510074, this, [ Core.Proc.encodeString( subTitle ) ] );
	},
	
	/** @private */
	setCalloutEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( 0x1510075, this, [ ( enabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	setCalloutLeftView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x1510076, this, [ +__objectRegistryId ] );
	},
	
	/** @private */
	setCalloutRightView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x1510077, this, [ +__objectRegistryId ] );
	},
	
	/** @private */
	setCenterOffset: function( xOffset, yOffset )
	{
		Core.Proc.appendToCommandString( 0x1510078, this, [ +xOffset, +yOffset ] );
	},
	
	/** @private */
	$doChoosePhoto: function( w, h, filename, options, callbackId, invokingView )
	{
		Core.Proc.appendToCommandString( 0x151ff87, [ +w, +h, Core.Proc.encodeString( filename ), Core.Proc.encodeObject( options ), Core.Proc.encodeString( callbackId ), +invokingView ] );
	},
	
	/** @private */
	setScrollIndicatorsVisible: function( enabled )
	{
		Core.Proc.appendToCommandString( 0x151007a, this, [ ( enabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	$measureText: function( string, w, h, font, fontSize, callbackId )
	{
		Core.Proc.appendToCommandString( 0x151ff85, [ Core.Proc.encodeString( string ), +w, +h, Core.Proc.encodeString( font ), +fontSize, Core.Proc.encodeString( callbackId ) ] );
	},
	
	/** @private */
	setFocus: function( enabled )
	{
		Core.Proc.appendToCommandString( 0x151007c, this, [ ( enabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	setViewportEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( 0x151007d, this, [ ( enabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	clearAnimations: function(  )
	{
		Core.Proc.appendToCommandString( 0x151007e, this );
	},
	
	/** @private */
	setStyle: function( styleID )
	{
		Core.Proc.appendToCommandString( 0x151007f, this, [ +styleID ] );
	},
	
	/** @private */
	setVisibleInOrientations: function( orientationFlags )
	{
		Core.Proc.appendToCommandString( 0x1510080, this, [ +orientationFlags ] );
	},
	
	/** @private */
	setAutodetection: function( type )
	{
		Core.Proc.appendToCommandString( 0x1510081, this, [ +type ] );
	},
	
	/** @private */
	playVideo: function( path, callbackId )
	{
		Core.Proc.appendToCommandString( 0x1510082, this, [ Core.Proc.encodeString( path ), Core.Proc.encodeString( callbackId ) ] );
	},
	
	/** @private */
	setLineHeight: function( lineHeight )
	{
		Core.Proc.appendToCommandString( 0x1510083, this, [ +lineHeight ] );
	},
	
	/** @private */
	$hideKeyboard: function(  )
	{
		Core.Proc.appendToCommandString( 0x151ff7c );
	},
	
	/** @private */
	$takeScreenshot: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( 0x151ff7b, [ +w, +h, Core.Proc.encodeString( filename ), Core.Proc.encodeObject( options ), Core.Proc.encodeString( callbackId ) ] );
	},
	
	/** @private */
	setPluginsEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( 0x1510086, this, [ ( enable ? 1 : 0 ) ] );
	},
	

// {{/Wg Generated Code}}







	_eventOccurredRecv: function( cmd ) {
		var str = Core.Proc.parseString( cmd[ 0 ] );
		if(!Commands.Window){
			//Annoying. TODO fix this!
			require("NGCore/Client/UI/Window");
		}
		Commands.Window.doCommand(str);
	},
	
	registerTemporaryCallback: function( callback ) {
		if (typeof callback != 'function') return null;
		var regId = (++this._tempCBCount).toString(36);
		Commands._tempCBs[regId] = callback;
		return regId;
	},
	
	takeTemporaryCallback: function( regId ) {
		var cb = Commands._tempCBs[regId];
		delete Commands._tempCBs[regId];
		return cb;
	},
    
	// documented as UI#animate
	/** @ignore */
	animate: function(action, duration, callback) {
		if (typeof action == 'function') {
			var cbFn = (typeof callback == 'function') ? callback : duration;
			var dur = (typeof duration == 'number') ? duration : callback;
			if (typeof dur != 'number') dur = 400;

			Commands.startAnimation( dur, Commands.registerTemporaryCallback(callback));
			var options = new UIAnimationOptions();
			action(options);
			Commands.executeAnimation(options);
		}
	}
});

exports.Commands.instantiate();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Element'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Element'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Element'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Element.js';

var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var Element = exports.Element = Class.subclass(
/** @lends UI.Element.prototype */
{
	$subclass: function() {
		if (typeof this._init == 'function') this._init();
		return Class.subclass.apply(this, arguments);
	},
	
	classname: "UI_Element",

	/**
	 * @class The `UI.Element` class is a base class for derived classes that represent components
	 * of a user interface.
	 * 
	 * **Important**: This base class is not exported in the `UI` module. Do not access it directly
	 * or create subclasses of `UI.Element`.
	 * 
	 * Classes that are derived from `UI.Element` include:
	 * 
	 * + `{@link UI.AbstractView}`
	 * + `{@link UI.AlertDialog}`
	 * + `{@link UI.ListViewSection}`
	 * + `{@link UI.ProgressDialog}`	 
	 * @name UI.Element
	 * @constructs Create a user interface component.
	 * @augments Core.Class
	 * @example
	 * // Create a new UI.AlertDialog object without setting any of its properties.
	 * var dialog = new UI.AlertDialog();
	 * @example
	 * // Create a new UI.AlertDialog object, setting its title and text.
	 * var dialogTitle = "Really?";
	 * var dialogText = "Are you sure you want to quit the application?";
	 * var dialog = new UI.AlertDialog({
	 *     title: dialogTitle,
	 *     text: dialogText
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.Element` object.
	 * @since 1.0
	 */
	initialize: function(properties) {
		if (Element._init) Element._init();
		
		this.register();
		
		// Enable events that are being handled at the class level...
		var events = this._eventNames;
		if (events) for (var e in events) {
			if (this[events[e]]) Commands.enableEvent.call(this, e);
		}
		
		//	Reimplement setAttributes here for speed
		var setters = this._setters;
		if (setters) for (var k in properties) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, properties[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		
	/*	This is awesome. Maybe use it in production code, but we want to keep
	//	our stylistic constraints for core development.
	
		for (var propName in this._setters) {
			this.__defineSetter__(propName, this._setters[propName]);
		}
		for (propName in this._getters) {
			this.__defineGetter__(propName, this._getters[propName]);
		}
	*/
	
		return this;
	},
	
	register: function() {
		try {
			ObjectRegistry.register(this);
			Commands.create(this.__objectRegistryId, this.type || this.classname);
		} catch (e) {
			// Nothing yet
		} finally {
			return this.__objectRegistryId;
		}
	},
	
	retain: function() {
		(this.__retainCount) ? ++this.__retainCount : (this.__retainCount = 1);
		return this;
	},
	
	release: function() {
		if (--this.__retainCount === 0) {
			this.destroy();
		}
	},
		
	/**
	 * Retrieve the value of the specified style property.
	 * @param {String} key The name of the style property.
	 * @returns {String|String[]|Number|Number[]|Boolean} The current value of the style property.
	 * @see UI.Element#getAttributes
	 * @see UI.Element#setAttribute
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	getAttribute: function(key) {
		var getter = this._getters[key];
		return (typeof getter == 'function') ? getter.call(this) : undefined;
	},
	
	/**
	 * Set the value of the specified style property.
	 * @example
	 * // Create a new UI.AlertDialog object and set its "choices" property,
	 * // which controls the options that are presented to the user.
	 * var dialog = new UI.AlertDialog();
	 * dialog.setAttribute("choices", ["Cancel", "Save Changes"]);
	 * @param {String} key The name of the style property.
	 * @param {String|String[]|Number|Number[]|Boolean} value The new value of the style property.
	 * @returns {this}
	 * @see UI.Element#getAttribute
	 * @see UI.Element#getAttributes
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	setAttribute: function(key, value){
		var setter = this._setters[key];
		if (typeof setter == 'function') {
			return setter.call(this, value);
		} else {
			NgLogD("Unable to set " + this.type + '.' + key);
		}
		return this;
	},
	
	/**
	 * Set the value of multiple style properties, which are passed in as properties of an object.
	 * @example
	 * // Create a new UI.AlertDialog object and set two of its style properties:
	 * // 1) the "choices" property, which controls the options that are
	 * // presented to the user, and 2) the "dialogText" property, which
	 * // specifies the dialog box's text for the default view state.
	 * var dialog = new UI.AlertDialog();
	 * dialog.setAttributes({
	 *     choices: ["Cancel", "Save Changes"],
	 *     dialogText: "Are you sure you want to quit the application?"
	 * });
	 * @param {Object} dict An object whose properties will be added as style properties of the
	 *		specified object.
	 * @returns {this}
	 * @see UI.Element#getAttribute
	 * @see UI.Element#getAttributes
	 * @see UI.Element#setAttribute
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	setAttributes: function(dict) {
		var setters = this._setters;
		if (setters) for (var k in dict) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, dict[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		return this;
	},
	
	/**
	 * Retrieve an object's style properties, either by specifying the style properties to retrieve
	 * or by requesting all of the object's style properties.
	 * @example
	 * // Create a new UI.AlertDialog object; set two of its style properties; and
	 * // retrieve the values of those style properties, printing each one to the
	 * // console.
	 * var dialog = new UI.AlertDialog();
	 * dialog.setAttributes({
	 *     choices: ["Cancel", "Save Changes"],
	 *     dialogText: "Are you sure you want to quit the application?"
	 * });
	 * 
	 * var dialogProperties = dialog.getAttributes(["choices", "dialogText"]);
	 * console.log("The value of the choices property is " + 
	 *     dialogProperties.choices);
	 * console.log("The value of the dialogText property is " +
	 *     dialogProperties.dialogText);
	 * @param {String[]} [list] A list of style properties to retrieve. If this parameter is
	 *		omitted, all of the object's style properties will be retrieved.
	 * @returns {Object} An object whose properties represent style properties of a `UI.Element`
	 *		object.
	 * @see UI.Element#getAttribute
	 * @see UI.Element#setAttribute
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	getAttributes: function(list) {
		var output = {};
	        var key;
		if (list instanceof Array) {
			for (var i = 0; i < list.length; i++) {
				key = list[i];
				output[key] = this._getters[key].call(this);
			}
		} else {
			for (key in this._getters) {
				output[key] = this._getters[key].call(this);
			}
		}
		return output;
	},

	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	enableEvent: Commands.enableEvent,
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	toString: function() {
		return this.type + '(' + this.__objectRegistryId + ')';
	},

	/**
	 * @function
	 * @description Destroy this object, and release the resources allocated by the object.
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	destroy: function() {
		Commands.destroy.call(this);
		ObjectRegistry.unregister(this);
		delete this.prototype;
		var onBadAccess = function () {
			var err = new Error('Object is destroyed.');
			NgLogD(err.stack);
			throw err;
		};
		for (var i in this) {
			var isPrivateProperty = (i.substring(0,1) === '_' || i.substring(0,2) === 'on');
			if (this.hasOwnProperty(i) || !isPrivateProperty) {
				var propType = typeof this[i];
				delete this[i];
				this[i] = ('function' === propType ? onBadAccess : undefined);
			}
		}
		this._destroyed = true;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	registerCallback: function(func, oneTime) {
		var callbackId = ++this.callbackCounter;
		var obj = this;
		this.callbacks[callbackId] = function(obj, args) {
			try {
				func(obj, args);
				if(oneTime) {
					delete obj.callbacks[callbackId];
				}
			}
			catch(e) {
				NgHandleException(e);
			}
		};
		return callbackId;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performCallback: function(event) {
		var cb = this.callbacks[event.callbackId];
		if(cb) {
			cb(this, event.arguments);
		}
	},
	
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performEventCallback: function(event) {
		try {
			// Look up the event by its 'onXXX' name...
			var eName = this._eventNames[event.eventType];
			var fn = this['_'+eName] || this[eName];
			if (typeof fn == 'function') {
				fn.call(this, event);
			}
		}
		catch(e) {
			NgHandleException(e);
		}
	},	
	
	// STATICS: Setter and Getter Registration
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerAccessors: function(propName, getterFn, setterFn, deprecationMessage) {
		// Put the new setter / getter functions into the prototype.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		var byKeyOnly = Boolean(deprecationMessage || false);
	//	NgLogD("Synthesizing set" + caseAdjusted + (shouldSetClosure ? " (custom)" : " (standard)") +
	//		" and get" + caseAdjusted + (onGetClosure ? " (custom)" : " (standard)") + " for member variable " + localVar);
	
		// If this is an instance, use the instance. Otherwise, if we are a class constructor, modify the prototype.
		var pType = (this instanceof Element) ? this : this.prototype;
	        var heritableMap;
		if (typeof getterFn == 'function') {

			if (!pType.hasOwnProperty('_getters')) {
				try {
					/** @inner */
					heritableMap = function() {return this;};
					var superGetters = pType.superclass._getters;
					if (superGetters) heritableMap.prototype = superGetters;
					pType._getters = new heritableMap();
				} catch (e) {}
			}
			if (byKeyOnly) {
				pType['get'+caseAdjusted] = function() {
					NgLogD("WARNING: Use of get" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					getterFn.apply(this, arguments);
				};
			} else {
				pType['get'+caseAdjusted] = getterFn;
			}
			pType._getters[propName] = getterFn;
		}
		if (typeof setterFn == 'function') {
			if (!pType.hasOwnProperty('_setters')) {
				try {
					heritableMap = function() {return this;};
					var superSetters = pType.superclass._setters;
					if (superSetters) heritableMap.prototype = superSetters;
					pType._setters = new heritableMap();
				} catch (e) {}
			}
			if (byKeyOnly) {
				pType['set'+caseAdjusted] = function() {
					NgLogD("WARNING: Calling set" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					setterFn.apply(this, arguments);
				};
			} else {
				pType['set'+caseAdjusted] = setterFn;
			}
			pType._setters[propName] = setterFn;
		}
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerEventType: function(eventName) {
		var onEventName = 'on' + eventName.charAt(0).toUpperCase() + eventName.substr(1);
		var localVar = '_' + onEventName;
		var pType = this.prototype;
		
		var getterFn = function() {
			return this[localVar] || this[onEventName];
		};
		var setterFn = function(callback) {
			var isFn = (typeof callback == 'function');
			if (isFn) {
				this[localVar] = callback;
			} else {
				delete this[localVar];
			}
			this.enableEvent(eventName, isFn);
		};
		if (!pType.hasOwnProperty('_eventNames')) {
			try {
				/** @inner */
				var heritableMap = function() {return this;};
				var superEvents = pType.superclass._eventNames;
				if (superEvents) heritableMap.prototype = superEvents;
				pType._eventNames = new heritableMap();
			} catch (e) {}
		}
		pType._eventNames[eventName] = onEventName;
		
		this.registerAccessors(onEventName, getterFn, setterFn);
		
		// Legacy support. Let's concentrate on removing this soon or at least fixing the casing.
		pType.__defineGetter__(onEventName.toLowerCase(), getterFn);
		pType.__defineSetter__(onEventName.toLowerCase(), setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizePropertyWithState: function(propName, CommandsFn) {
		var lVarName = '_' + propName + 'Map';
		var setterFn;
		if (propName) {
			/** @inner */
			setterFn = function(value, optState) {
				optState |= 0;
			//	NgLogD("Set " + this.type + "." + propName + "[" + optState + "] = " + value);
				(this[lVarName] || (this[lVarName] = {}))[optState] = value;
				CommandsFn.call(this, optState, value);
				return this;
			};
		} else {
			/** @inner */
			setterFn = function(value, optState) {
				CommandsFn.call(this, (optState | 0), value);
				return this;
			};
		}
		
		var getterFn = function(state) {
			return (this[lVarName] || 0)[(state | 0)];
		};
		
		this.registerAccessors(propName, getterFn, setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeCompoundProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Synthesized setters accept EITHER an array of reasonable length OR individual args.
			/** @inner */
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array)
					? args
					: Array.prototype.slice.call(arguments);
				CommandsFn.apply(this, this[lVarName]);
				return this;
			};
		} else {
			/** @inner */
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array) ? args : Array.prototype.slice.call(arguments);
				return this;
			};
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Optional args are still passed through, even though only the first arg is assigned.
			/** @inner */
			setterFn = function(arg) {
				this[lVarName] = arg;
				CommandsFn.apply(this, arguments);
				return this;
			};
		} else {
			/** @inner */
			setterFn = function(arg) {
				this[lVarName] = arg;
				return this;
			};
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	

	$bindPropertyState:function(propertyName, stateName, stateFlags) {
			var caseAdjusted = propertyName[0].toUpperCase() + propertyName.substr(1);
			var gName = 'get' + caseAdjusted;
			var sName = 'set' + caseAdjusted;
			var getterFn = function() {
				return this[gName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this[sName].call(this, val, stateFlags);
			};

			this.registerAccessors( stateName + caseAdjusted, getterFn, setterFn );
		}

});


// Event Handlers
Element._init = function() {
	delete Element._init;
	
	/**
	 * Set a function to call when a `load` event occurs. This event occurs when data from a URL has
	 * finished loading.
	 * @name UI.Element#setOnLoad
	 * @event
	 * @example
	 * // Create a new UI.Button object, which inherits from UI.Element, and
	 * // set a function to call when a "load" event occurs.
	 * var button = new UI.Button();
	 * button.setOnLoad(function(event) {
	 *     var url = Core.Base64.decode(event.urlEncoded);
	 *     console.log("Loaded the URL " + url);
	 * });
	 * @cb {Function} loadCallback The function to call when the `load` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.urlEncoded A Base64-encoded version of the URL being loaded.
	 * @cb-returns {void}
	 * @see UI.Element#event:getOnLoad
	 * @status Flash
	 * @returns {void}
	 */
	/**
	 * Retrieve the function to call when a `load` event occurs.
	 * @name UI.Element#getOnLoad
	 * @event
	 * @returns {Function} The current function to call when a `load` event occurs.
	 * @see UI.Element#event:setOnLoad
	 * @status Flash
	 */
	Element.registerEventType('load');
	// per JYopp, we never fire `unload` events, so @ignore the next two methods
	/**
	 * Set a function to call when an `unload` event occurs.
	 * @name UI.Element#setOnUnload
	 * @event
	 * @cb {Function} unloadCallback The function to call when an `unload` event occurs.
	 * @cb-returns {void}
	 * @see UI.Element#event:getOnUnload	
	 * @returns {void}
	 * @ignore
	 */
	/**
	 * Retrieve the function to call when an `unload` event occurs.
	 * @name UI.Element#getOnUnload
	 * @event
	 * @returns {Function} The current function to call when an `unload` event occurs.
	 * @see UI.Element#event:setOnUnload
	 * @ignore	 
	 */
	Element.registerEventType('unload');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AlertDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/AlertDialog.js';

var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var AlertDialog = exports.AlertDialog = Element.subclass(
/** @lends UI.AlertDialog.prototype */
{
	'type':'alertdialog',
	/**
	 * @name UI.AlertDialog
	 * @class The `UI.AlertDialog` class provides alert dialogs in an application. When the user
	 * chooses an option in the dialog, `UI.AlertDialog` fires a `choice` event that identifies the
	 * user's choice. Specify a callback function to handle this event by calling
	 * `{@link UI.AlertDialog#event:setOnChoice}`.
	 * 
	 * A `UI.AlertDialog` object's appearance can change automatically when its view state changes. 
	 * For example, the alert dialog's title can change automatically when the view gains focus. To
	 * implement this feature, your application can call a `UI.AlertDialog` setter method more than
	 * once, passing a different value in the `flags` parameter each time. In addition, your
	 * application can include properties for multiple view states in the constructor. See the
	 * `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.AlertDialog#setChoices}` to control the
	 * choices that are displayed to the user, the choices you specify will apply in all view
	 * states.
	 * @constructs Create an alert dialog.
	 * @augments UI.Element
	 * @example
	 * // Create a new UI.AlertDialog object without setting any of its properties.
	 * var dialog = new UI.AlertDialog();
	 * @example
	 * // Create a new UI.AlertDialog object, setting its title and text.
	 * var dialogTitle = "Really?";
	 * var dialogText = "Are you sure you want to quit the application?";
	 * var dialog = new UI.AlertDialog({
	 *     title: dialogTitle,
	 *     text: dialogText
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.AlertDialog` object.
	 * @see UI.Commands#State
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (AlertDialog._init) AlertDialog._init();
		$super(properties);
	},
	
	/** 
	 * Show the alert dialog.
	 * @function
	 * @status Flash, Test, FlashTested
	 * @returns {void}
	 */
	show: Commands.show,
	/** 
	 * Hide the alert dialog.
	 * @function
	 * @status Flash, Test, FlashTested
	 * @returns {void}
	 */
	hide: Commands.hide
});

// Properties
AlertDialog._init = function() {
	delete AlertDialog._init;
	if (Element._init) Element._init();

	/**
	 * Set the `title` property, which defines the alert dialog's title for a specified view state.
	 * @name UI.AlertDialog#setTitle
	 * @example
	 * var dialog = new UI.AlertDialog();
	 * dialog.setTitle("Settings Saved");
	 * @see UI.AlertDialog#getTitle
	 * @param {String} title The title for the alert dialog.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this title. To specify a title for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
 	 * @status iOS, Android, Flash, Test, FlashTested
	 * @function
	 * @returns {void}
	 */
	/**
	 * Retrieve the value of the `title` property, which defines the alert dialog's title for a
	 * specified view state.
	 * @name UI.AlertDialog#getTitle
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current title.
	 * @see UI.AlertDialog#setTitle
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * Set the `text` property, which defines the alert dialog's text for a specified view state.
	 * @name UI.AlertDialog#setText
	 * @function
	 * @example
	 * var dialog = new UI.AlertDialog();
	 * var text = "Your settings have been saved.";
	 * dialog.setText(text);
	 * @param {String} text The text for the alert dialog.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.AlertDialog#getText
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `text` property, which defines the alert dialog's text for a
	 * specified view state.
	 * @name UI.AlertDialog#getText
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text for the alert dialog.
	 * @see UI.AlertDialog#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('text', Commands.setText);
	// Not a compound property; AlertDialog.getChoices() should return the array of strings.
	/**
	 * Set the `choices` property, which defines the options that are presented to the user.
	 * @name UI.AlertDialog#setChoices
	 * @function
	 * @example
	 * var dialog = new UI.AlertDialog();
	 * dialog.setChoices(["Cancel", "Save Changes"], 1, 0);
	 * @param {String[]} choices The options that will be presented to the user.
	 * @param {Number} [defaultChoice] The index of the default choice.
	 * @param {Number} [cancelChoice] The index of the choice that cancels the action.
	 * @returns {void}
	 * @see UI.AlertDialog#getChoices
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `choices` property, which defines the options that are presented to
	 * the user.
	 * @name UI.AlertDialog#getChoices
	 * @function
	 * @returns {String[]} The current options that will be presented to the user.
	 * @see UI.AlertDialog#setChoices
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizeProperty('choices', Commands.setChoices);
	
	// Event will contain .choice, which is the index of the option chosen.
	/**
	 * Set a function to call when a `choice` event occurs. This event occurs when the user selects
	 * an option in an alert dialog.
	 * @name UI.AlertDialog#setOnChoice
	 * @event
	 * @example
	 * // Create an alert dialog, and specify a function to handle choice events.
	 * var dialog = new UI.AlertDialog({
	 *     title: "Unsaved Changes",
	 *     text: "Do you want to save your changes?",
	 *     choices: ["Save", "Don't Save"];
	 * });
	 * dialog.setOnChoice(function(event) {
	 *     if (event.choice == 0) {
	 *         // The user chose "Save"
	 *         // Add code to save
	 *         dialog.hide();
	 *     } else {
	 *         // The user chose "Don't Save"
	 *         dialog.hide();
	 *     }
	 * });
	 * @cb {Function} choiceCallback The function to call when a `choice` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {Number} event.choice The index of the option that the user chose.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.AlertDialog#event:getOnChoice
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the function to call when a `choice` event occurs.
	 * @name UI.AlertDialog#getOnChoice
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.AlertDialog#event:setOnChoice
 	 * @status iOS, Android, Flash, Test
	 */
	 AlertDialog.registerEventType('choice');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ErrorEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ErrorEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ErrorEmitter'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/ErrorEmitter.js';

// Class ErrorEmitter
// Emit an error from native to js.
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

////////////////////////////////////////////////////////////////////////////////

exports.ErrorEmitter = MessageEmitter.singleton(
/** @lends Core.ErrorEmitter.prototype */
{
	classname: 'ErrorEmitter',
	
	/**
	 * @class The <code>Core.ErrorEmitter</code> provides applications a way to gather
	 * data about unexpected error situations. 
	 * It emits two things: 
	 * <ol><li>Errors that have happened in the native side of the Javascript bridge</li>
	 * <li>Uncaught exceptions in the Javascript game code.</li></ol>
	 * 
	 * When these errors occur, they are packaged and sent to a URL specified by 
	 * {@link Core.ErrorEmitter#setErrorReportPostUrl}. The first time an error is 
	 * encountered, the user will be prompted for permission to send this data.<br/><br/>
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @since 1.6
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._errorReportPostUrl = null;
	},

	/**
	 * Set the URL to post the uncaught exception.
	 * If this function is called with a valid URL, the first time an exception is thrown, 
	 * the user will be asked to permit the application to send error diagnosis information 
	 * to the specified URL.
	 * @example
	 * initialize: function ()
	 * {
	 *     Core.ErrorEmitter.setErrorReportPostUrl("https://myhost.com/error_report.php");
	 * }
	 *
	 * @param {String} url The url where the error diagnosis will be sent. For security, 
	 * HTTPS is preferable to HTTP.
	 * @returns {void}
	 * @since 1.7
	 */
	setErrorReportPostUrl: function(url)
	{
		this._errorReportPostUrl = url;
	},

	_raiseRecv: function( cmd )
	{
		var msg = {};
		if (!this._raiseRecvGen(cmd, msg))
			return;

		this.emit(msg.errorMessage);
	},

	_handleUncaughtException: function(error)
	{
		var that = this;
		if (this._hasErrorReportUrl()) {
			this._checkUserHasAcceptedSendingErrorReport(function(hasAccepted) {
				if (hasAccepted) {
					that._sendErrorReport(error);
					return;
				}

				that._checkUserHasAskedForPermission(function(hasAsked) {
					if (hasAsked)
						return;

					that._showErrorReportAskPermissionDialog(function(accepted) {
						if (accepted) {
							that._setUserAcceptedSendingErrorReport();
							that._sendErrorReport(error);
						} else {
							that._setAlreadyAsked();
						}
					});
				});
			});
		}

		this.emit(error);
	},

	_hasErrorReportUrl: function()
	{
		return this._errorReportPostUrl !== null;
	},

	_checkUserHasAcceptedSendingErrorReport: function(callback)
	{
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var ErrorReporterKV = KeyValueCache.global("ErrorReporter");
		return ErrorReporterKV.getItem("userHasAcceptedSendingErrorReport", {}, function(error, value) {
			callback(error ? false : value);
		});
	},

	_checkUserHasAskedForPermission: function(callback)
	{
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var ErrorReporterKV = KeyValueCache.global("ErrorReporter");
		return ErrorReporterKV.getItem("userHasAskedForPermission", {}, function(error, value) {
			callback(error ? false : value);
		});
	},

	_setAlreadyAsked: function()
	{
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var ErrorReporterKV = KeyValueCache.global("ErrorReporter");
		ErrorReporterKV.setItem("userHasAskedForPermission", "true", {}, function() {});
	},

	_setUserAcceptedSendingErrorReport: function()
	{
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var ErrorReporterKV = KeyValueCache.global("ErrorReporter");
		ErrorReporterKV.setItem("userHasAcceptedSendingErrorReport", "true", {}, function() {});
	},

	_showErrorReportAskPermissionDialog: function(callback)
	{
		var AlertDialog = require('NGCore/Client/UI/AlertDialog').AlertDialog;

		// TODO: title and text shuold be customizable
		var dialog = new AlertDialog({
			title: 'Application has a problem',
			text: 'Send an error report to the developer?',
			choices: ['No', 'Yes']
		});
		dialog.setOnChoice(function(event) {
			dialog.hide();
			callback(event.choice === 1);
		});
		dialog.show();
	},

	_sendErrorReport: function(errorString)
	{
		var environment = this._gatherEnvironmentInfo();
		var payload = JSON.stringify({environment:environment, error:errorString});

		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var request  = new XHR();
		request.open('POST', this._errorReportPostUrl, true);
		request.onreadystatechange = function() {
			// TODO:
			//   if cannot post it to the server, like the case user is offline,
			//   retry it or push into the pending queue to post it again when online.
			//NgLogD('XHR request state changed to: ' + this.readyState);
		};
		request.send(payload);
	},

	_gatherEnvironmentInfo: function() {
		var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

		var env = {
			SDKVersion: Capabilities.getSDKVersion(),
			SDKBuildDate: Capabilities.getSDKBuildDate(),
			SDKBuildHash: Capabilities.getSDKBuildHash(),
			BinaryVersion: Capabilities.getBinaryVersion(),
			BinaryBuildDate: Capabilities.getBinaryBuildDate(),
			DeviceName: Capabilities.getDeviceName(),
			PlatformOS: Capabilities.getPlatformOS(),
			PlatformOsVersion: Capabilities.getPlatformOSVersion(),
			PlatformHW: Capabilities.getPlatformHW(),
			PhysicalMem: Capabilities.getPhysicalMem(),
			PhysicalCpus: Capabilities.getPhysicalCpus(),
			ActiveCpus: Capabilities.getActiveCpus(),
			Language: Capabilities.getLanguage(),
			BootDir: Capabilities.getBootDir(),
			GameDir: Capabilities.getGameDir(),
			ProductName: Capabilities.getProductName(),
			ContentUrl: Capabilities.getContentUrl(),
			BootGame: Capabilities.getBootGame(),
			StartingServer: Capabilities.getStartingServer(),
			BundleGame: Capabilities.getBundleGame(),
			BundleServer: Capabilities.getBundleServer(),
			BundleIdentifier: Capabilities.getBundleIdentifier(),
			Game: Capabilities.getGame(),
			Server: Capabilities.getServer(),
			Url: Capabilities.getUrl(),
			ScreenWidth: Capabilities.getScreenWidth(),
			ScreenHeight: Capabilities.getScreenHeight(),
			ScreenUnits: Capabilities.getScreenUnits(),
			ScreenPixelUnits: Capabilities.getScreenPixelUnits(),
			MaxTextureSize: Capabilities.getMaxTextureSize(),
			MaxTextureUnits: Capabilities.getMaxTextureUnits(),
			OglExtentions: Capabilities.getOglExtensions(),
			HasAccel: Capabilities.getHasAccel(),
			HasGyro: Capabilities.getHasGyro(),
			HasTouch: Capabilities.getHasTouch(),
			HasMultiTouch: Capabilities.getHasMultiTouch(),
			HasGps: Capabilities.getHasGps(),
			HasCompass: Capabilities.getHasCompass(),
			HasHwKeyboard: Capabilities.getHasHwKeyboard(),
			HasBackButton: Capabilities.getHasBackButton(),
			HasCamera: Capabilities.getHasCamera(),
			HasWwan: Capabilities.getHasWwan(),
			HasWifi: Capabilities.getHasWifi(),
			Career: Capabilities.getCarrier(),
			Locale: Capabilities.getLocale(),
			AppReleaseVersion: Capabilities.getAppReleaseVersion(),
			SimCountryCode: Capabilities.getSimCountryCode(),
			NetworkCountryCode: Capabilities.getNetworkCountryCode(),
			UdpAvailable: Capabilities.getUdpAvailable(),
			TcpAvailable: Capabilities.getTcpAvailable(),
			SslAvailable: Capabilities.getSslAvailable()
		};

		return env;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 359,
	// Method create = -1
	// Method raise = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._raiseRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ErrorEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ErrorEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[359] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_raiseRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in ErrorEmitter.raise from command: " + cmd );
			return false;
		}
		
		obj[ "errorMessage" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "errorMessage" ] === undefined )
		{
			NgLogE("Could not parse errorMessage in ErrorEmitter.raise from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x167ffff, [ +__objectRegistryId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _raiseRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/DiagnosticEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/DiagnosticEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/DiagnosticEmitter'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/DiagnosticEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class DiagnosticEmitter
// Diagnostic emitter to decouple diagnostic generation from updating
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

////////////////////////////////////////////////////////////////////////////////

/*
 * Publish/subscribe to diagnostic information
 *
 * DiagnosticEmitter allows for the asynchronous publishing of module diagnostic
 * information in an efficient manner.  Producers of diagnostic info implement a
 * callback that will be polled when diagnostic information updates are required,
 * and subscribers to diagnostics do so through the standard emitter pattern.
 * Updates may also be pushed synchronously by the producers or updated outside
 * of the callback.  They may also be pushed from native code.
 *
 * For convenience and discoverability, you can use `{@link Core.DiagnosticRegistry#findEmitter}`
 * {@link Core.DiagnosticRegistry.createEmitter}, defined in the DiagnosticRegistry singleton
 * after the DiagnosticEmitter object below to obtain diagnostic emitters:
 *
 * var emitter = DiagnosticRegistry.findEmitter('Foo');
 * var emitter = DiagnosticRegistry.createEmitter('Bar');
 * etc.
 */

exports.DiagnosticEmitter = MessageEmitter.subclass(
/** @lends Core.DiagnosticEmitter.prototype */
{
    classname: 'DiagnosticEmitter',

////////////////////////////////////////////////////////////////////////////////
// public API

    /**
     * @class The <code>Core.DiagnosticEmitter</code> class allows for the asynchronous
     * publishing of module diagnostic information in an efficient manner.  Producers of
     * diagnostic information implement a callback that will be polled when diagnostic
     * information updates are required, and subscribers to diagnostics do so through the
     * standard emitter pattern. Updates may also be pushed synchronously by the producers
     * or updated outside of the callback.
     * <br /><br />
     * For convenience and discoverability, you can use <code>{@link Core.DiagnosticRegistry.findEmitter}</code>
     * or <code>{@link Core.DiagnosticRegistry.createEmitter}</code> to obtain diagnostic emitters.
     * <br /><br />
     * If you are using ngBuilder 2.1.5 or later to develop your app, you can also use this class to
     * profile a specific event in your app. Call
     * <code>{@link Core.DiagnosticEmitter.startEvent}</code> to start an event and
     * <code>{@link Core.DiagnosticEmitter.stopEvent}</code>. When you run your app from ngBuilder,
     * you will be able to view diagnostic information about the event.
     * @constructs The default constructor. Typically, you will not create diagnostic
     * emitters directly, but instead will use <code>{@link Core.DiagnosticRegistry.createEmitter}</code>.
     * @param {String} name The name of the emitter.
     * @augments Core.MessageEmitter
     * @since 1.7
     */
    initialize: function(name) 
    {
	this.name = name;
	this.reset();

	this.listeners = 0;
	this.native_listeners = 0;

	this.collectors = [];
	this.native_collector =false;
	this.dirty = false;

	ObjectRegistry.register(this);
	this._createSendGen(this.__objectRegistryId, name);
	// attempt registration.  May fail if someone is using the same name.
	exports.DiagnosticRegistry.registerEmitter(this.name, this);
    },


    /**
     * Destroys this DiagnosticEmitter. When using DiagnosticEmitters and other types with
     * a native counterpart, you must explicitly destroy them to avoid leaking memory.
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    destroy: function() 
    {
	exports.DiagnosticRegistry.deregisterEmitter(this.name, this);

	// destroy the emitter base class prior to the C++ class or there will
	// be some commands sent to the deregistered object when the message
	// emitter snuffs its listener array.
	MessageEmitter.prototype.destroy.apply(this);
	this._destroySendGen();
	ObjectRegistry.unregister(this);
    },
    

    /**
     * Set maximum data update rate for all listeners of this emitter.
     * Minimum interval is once per frame; however, producers may force data to be
     * emitted faster by calling <code>{@link Core.DiagnosticEmitter#push}</code>.
     * @param {Number} interval The number of frames to use as a publish interval.
     * @returns {Boolean} Set to <code>true</code> if the update was successful.
     * @since 1.7
     * @status iOS, Android, Flash
     */
    setInterval: function(interval) 
    {
	if(interval <= 0) 
	{
	    NgLogE('DiagnosticEmitter ' + this.name + ': attempt to set invalid interval ' + interval);
	    return false;
	}

	this._set_interval(interval);
	return true;
    },

    /**
     * Add a collector callback function to update data. This will be called once
     * per emission interval if there are listeners.
     * <br /><br />
     * The callback is expected to return a diagnostics object if there is an update, 
     * or <code>null</code> for no current update. The object may be of any type, but only local
     * properties are copied. The DiagnosticEmitter will not copy properties
     * from the prototype chain.
     * <br /><br />
     * Any properties returned by the collector callback are additive in that the 
     * DiagnosticEmitter maintains a copy of the diagnostics object and only updates
     * changed values. So if the collector callback returns an object with a subset of properties,
     * only those properties will be updated in the maintained diagnostics object while other 
     * properties will remain unchanged.
     * <br /><br />
     *
     * In order to clear all previous diagnostics, call <code>{@link Core.DiagnosticEmitter#reset}</code>
     * in the collector callback before returning a new diagnostics object.
     * <br /><br />
     * In addition, functions can also be returned in the diagnostics object and will be
     * emitted to listeners. Use this feature with care.
     * @param {Function} collector The function to be called to collect diagnostics. 
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    pushCollector: function(collector)
    {
	if(collector && !(collector instanceof Function))
	{
	    NgLogE('DiagnosticEmitter ' + this.name + ': attempt to set invalid collector');	    
	} 
	this.collectors.push(collector);
	// get initial values
	if(this.getListenerCount() > 0)
	{
	    this.update(collector(0));
	}
    },

    /**
     * Remove a previously added collector.
     *
     * @param {Function} collector The function to be removed.
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    removeCollector: function(collector)
    {
	for(var i=0;i<this.collectors.length; i++)
	{
	    if(this.collectors[i] == collector)
	    {
		this.collectors.splice(i, 1);
		return;
	    }
	}
    },

    /**
     * Clear this emitter's diagnostics. This will effectively remove all diagnostic
     * properties from the DiagnosticEmitter's diagnostics and replace
     * the contents with properties from the object passed in.
     * @param {Object} [obj] An object to reset the diagnostics to.
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    reset: function(obj) 
    {
	this.diags = {name: this.name};
	if(obj) 
	{
	    this.update(obj);
	}
    },

    /**
     * Manually make a diagnostics update outside of the callback mechanism.
     * Updates are merged into the existing diagnostics.
     * @param {Object} obj The object to update the diagnostics with.
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    update: function(obj) 
    {
	if(obj) 
	{
	    this.dirty = true;
	    for(var key in obj) 
	    {
		if(obj.hasOwnProperty(key)) 
		{
		    this.diags[key] = obj[key];
		}
	    }
	}
    }, 

    /**
     * Force an update to be emitted regardless of update interval.  
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    push: function()
    {
	this.emit(this.diags);
    },

    /**
     * Convenience function to update and force a push in one step.
     * @param {Object} obj the object to update the diagnostics with.
     * @returns {void}
     * @since 1.7
     * @status iOS, Android, Flash
     */
    pushUpdate: function(obj)
    {
	this.update(obj);
	this.push();
    },

    /**
     * Getter for the current diagnostics information.
     * @returns {Object} The current diagnostics object.
     * @since 1.7
     * @status iOS, Android, Flash
     */
    getDiags: function() 
    {
	return this.diags;
    },

    /**
     * Create a closure over a diagnostics producer function so that it will 
     * be called only if we have listeners. It should return a diagnostics 
     * update object.
     * @param {Object} obj
     * @param {Function} fn
     *
     * @returns {Function} A function to call that will update the diagnostics. 
     * @since 1.7
     * @status iOS, Android, Flash
     * @private
     */
    curryProducer: function(obj, fn)
    {
	var that = this;
	return function() {
	    if(that.listeners > 0)
	    {
		var upd = fn.apply(obj, arguments);
		that.update(upd);
	    } 
	};
    },

	/**
	 * Start an event that can be profiled in ngBuilder. Event profiling is supported in ngBuilder
	 * 2.1.5 and later.
	 * @name Core.DiagnosticEmitter.startEvent
	 * @function
	 * @static
	 * @param {String} eventName The event to profile.
	 * @returns {void}
	 * @since 1.8
	 * @status iOS, Android, Flash
	 */
	
	/** @ignore */
	$startEvent: function (eventName) {
		this._startEventSendGen(eventName, new Date().getTime());
	},

	/**
	 * Stop an event that can be profiled in ngBuilder. Event profiling is supported in ngBuilder
	 * 2.1.5 and later.
	 * @name Core.DiagnosticEmitter.stopEvent
	 * @function
	 * @static
	 * @param {String} eventName The event to profile.
	 * @returns {void}
	 * @since 1.8
	 * @status iOS, Android, Flash
	 */
	
	/** @ignore */
	$stopEvent: function (eventName) {
		this._stopEventSendGen(eventName, new Date().getTime());
	},


////////////////////////////////////////////////////////////////////////////////

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 362,
	// Method create = -1
	// Method destroy = 2
	// Method currentListeners = 3
	// Method updateDiagnostics = 4
	// Method nativeCollector = 5
	// Method collectNative = 6
	// Method _runTests = 7
	// Method nativeListeners = 8
	// Method setCurrentState = 9
	// Method tick = 10
	// Method startEvent = -11
	// Method stopEvent = -12
	// Method _set_interval = 13
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._updateDiagnosticsRecv( cmd );
					break;
				case 5:
					instance._nativeCollectorRecv( cmd );
					break;
				case 8:
					instance._nativeListenersRecv( cmd );
					break;
				case 10:
					instance._tickRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DiagnosticEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DiagnosticEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[362] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDiagnosticsRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in DiagnosticEmitter.updateDiagnostics from command: " + cmd );
			return false;
		}
		
		obj[ "jsonData" ] = Proc.parseObject( cmd[ 0 ] );
		if( obj[ "jsonData" ] === undefined )
		{
			NgLogE("Could not parse jsonData in DiagnosticEmitter.updateDiagnostics from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_nativeCollectorRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in DiagnosticEmitter.nativeCollector from command: " + cmd );
			return false;
		}
		
		obj[ "exists" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "exists" ] === undefined )
		{
			NgLogE("Could not parse exists in DiagnosticEmitter.nativeCollector from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_nativeListenersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in DiagnosticEmitter.nativeListeners from command: " + cmd );
			return false;
		}
		
		obj[ "num" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "num" ] === undefined )
		{
			NgLogE("Could not parse num in DiagnosticEmitter.nativeListeners from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_tickRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in DiagnosticEmitter.tick from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId, name )
	{
		Proc.appendToCommandString( 0x16affff, [ +__objectRegistryId, Proc.encodeString( name ) ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Proc.appendToCommandString( 0x16a0002, this );
	},
	
	/** @private */
	_currentListenersSendGen: function( num )
	{
		Proc.appendToCommandString( 0x16a0003, this, [ +num ] );
	},
	
	/** @private */
	_collectNativeSendGen: function( frame_interval )
	{
		Proc.appendToCommandString( 0x16a0006, this, [ +frame_interval ] );
	},
	
	/** @private */
	__runTestsSendGen: function( emitter_list )
	{
		Proc.appendToCommandString( 0x16a0007, this, [ Proc.encodeString( emitter_list ) ] );
	},
	
	/** @private */
	_setCurrentStateSendGen: function( jsonData )
	{
		Proc.appendToCommandString( 0x16a0009, this, [ Proc.encodeObject( jsonData ) ] );
	},
	
	/** @private */
	$_startEventSendGen: function( eventName, timeMs )
	{
		Proc.appendToCommandString( 0x16afff5, [ Proc.encodeString( eventName ), +timeMs ] );
	},
	
	/** @private */
	$_stopEventSendGen: function( eventName, timeMs )
	{
		Proc.appendToCommandString( 0x16afff4, [ Proc.encodeString( eventName ), +timeMs ] );
	},
	
	/** @private */
	__set_intervalSendGen: function( num )
	{
		Proc.appendToCommandString( 0x16a000d, this, [ +num ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId, name ) {}
	
	// destroy: function(  ) {}
	
	// currentListeners: function( num ) {}
	
	// _updateDiagnosticsRecv: function( cmd ) {}
	// _nativeCollectorRecv: function( cmd ) {}
	// collectNative: function( frame_interval ) {}
	
	// _runTests: function( emitter_list ) {}
	
	// _nativeListenersRecv: function( cmd ) {}
	// setCurrentState: function( jsonData ) {}
	
	// _tickRecv: function( cmd ) {}
	// $startEvent: function( eventName, timeMs ) {}
	
	// $stopEvent: function( eventName, timeMs ) {}
	
	// _set_interval: function( num ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


    ,
////////////////////////////////////////////////////////////////////////////////
// internal-only funcs and overrides
    _set_interval: function( num ) 
    {	
	this.__set_intervalSendGen(num);
    },

    // override for MessageEmitter
    addListener: function(listener, func, priority) 
    {
	MessageEmitter.prototype.addListener.apply(this, [listener, func, priority]);
	this.listeners = MessageEmitter.prototype.getListenerCount.apply(this);
	this.sendCurrentListeners(this.listeners);
    },
    // override for MessageEmitter
    removeListener: function(listener) 
    {
	MessageEmitter.prototype.removeListener.apply(this, [listener]);
	this.listeners = MessageEmitter.prototype.getListenerCount.apply(this);
	this.sendCurrentListeners(this.listeners);
    },

    // override for MessageEmitter
    getListenerCount: function() 
    {
	return this.listeners + this.native_listeners;
    },

    // send the current listeners to the C++ side 
    sendCurrentListeners: function(num) 
    {
	this._currentListenersSendGen(num);
    },
	
    // got diags from native code
    _updateDiagnosticsRecv: function(cmd) 
    {
	var diagblob = {};
	try {
	    if(this._updateDiagnosticsRecvGen(cmd, diagblob))
	    {
		var diagobj = diagblob.jsonData; 
		this.update(diagobj);
	    }
	}
	catch(e) {
	    NgLogE('DiagnosticEmitter: error parsing JSON received from C++, error is: ' + e);
	}
    },

    _nativeCollectorRecv: function(cmd) 
    {
	var obj = {};
	if(this._nativeCollectorRecvGen(cmd, obj))
	{
	    this.native_collector = obj.exists;
	}
    },
    
    collectNative: function(interval) 
    {
	this._collectNativeSendGen(interval);
    },
	
    _nativeListenersRecv: function( cmd ) 
    {
	var obj = {};
	if(this._nativeListenersRecvGen(cmd, obj))
	{
	    this.native_listeners = obj.num;
	}
    },
	
    setCurrentState: function( jsonData ) 
    {
	this._setCurrentStateSendGen(jsonData);
    },
	
    // Process update ticks.  If we have had a diag update collected or pushed 
    // and the update interval has expired, emit the update.
    _tickRecv: function(cmd) 
    {
	// if no listeners, do not collect or emit.
	if(this.getListenerCount() === 0) { return; }

	for(var c = 0; c < this.collectors.length; c++)
	{
	    var cfun = this.collectors[c];
	    this.update(cfun(this.last));
	}

	if(this.dirty)
	{
	    //NgLogD('DiagnosticEmitter ' + this.name + ' onTick emitting, delta=' + delta + ' last=' + this.last);
	    
	    this.dirty = false;
	    this.emit(this.diags);
	    this.setCurrentState(this.diags);
	}
    },
    
    // no-op unless conditionally compiled in on the C++ side.
    _runTests: function(emitter_list)
    {
	this.__runTestsSendGen(emitter_list);
    }
});

//
// Tools can use this to access all the registered emitters
//
exports.DiagnosticRegistry = Class.singleton({
    /** @lends Core.DiagnosticRegistry */

    classname: 'DiagnosticRegistry',
    /**
     * @class The <code>Core.DiagnosticRegistry</code> enables location and creation
     * of diagnostic emitters.<br/><br/>
     * 
     * You can define any number and type of diagnostic emitters that you would like to use
     * in your app. In order to create the emitter, call 
     * <code>{@link Core.DiagnosticRegistry.createEmitter}</code> with the name you want to use for
     * the emitter. The app can then add its collector callback and
     * set the reporting interval on the DiagnosticEmitter.
     *
     * @singleton
     * @constructs The default constructor.
     * @augments Core.Class
     * @since 1.7
     */
    initialize: function() 
    {
	ObjectRegistry.register(this);
	this.registry = {};
    },

    /** 
     * Returns the diagnostics emitter of the specified name.  
     * This method should be used by consumers of diagnostics.
     * @example
     * var myDiagEmitter = Core.DiagnosticRegistry.findEmitter("myEmitter");
     * 
     * if (myDiagEmitter) {
     *     myDiagEmitter.addListener (this, function (diagObj) {
     *         console.log("Diagnostics: ", JSON.stringify(diagObj));
     *     });
     * }
     * @param {String} name The name of the emitter you are looking for.
     * @returns {Core.DiagnosticEmitter} The emitter for that name, or undefined if it does not exist.
     * @since 1.7
     * @status iOS, Android, Flash
     */
    findEmitter: function(name)
    {
	return this.registry[name];
    },

    /** 
     * Returns the diagnostics emitter of the specified name, creating it if necessary.
     * This method should be used by diagnostic producers; it is idempotent and can be
     * called any number of times, returning the same emitter each time.
     * @example
     * function myDiagnosticsGatherer()
     * {
     *     // This assumes getDiagObject() returns an object of some type.
     *     var diagObject = getDiagObject();
     *     return diagObject;
     * }
     * var myDiagEmitter = Core.DiagnosticRegistry.createEmitter("myEmitter");
     *
     * myDiagEmitter.pushCollector(myDiagnosticsGatherer);
     *
     * myDiagEmitter.setInterval (100);
     *
     * @param {String} name The name of the emitter you are going to produce diagnostics for.
     * @returns {Core.DiagnosticEmitter} The emitter for that name
     * @since 1.7
     * @status iOS, Android, Flash
     */
    createEmitter: function(name)
    {
	var e = this.findEmitter(name);
	if(!e)
	{
	    e = new exports.DiagnosticEmitter(name);
	    // ctor registers, we done
	}
	return e;
    },

    /** 
     * Returns a list of all emitter names.
     *
     * This method should be used by consumers of diagnostics.
     * @example
     * var emitterList = Core.DiagnosticRegistry.listEmitters();
     *
     * for (e in emitterList) {
     *     console.log ("Emitter: ", emitterList[e]);
     * }
     *
     * @returns {Array} A list of the names of all of the registered DiagnosticEmitters.
     * @since 1.7
     * @status iOS, Android, Flash
     */
    listEmitters: function()
    {
	var rc = [];
	for(var key in this.registry) 
	{
	    rc.push(key);
	}
	return rc;
    },
    
    // internal functions follow
    registerEmitter: function(name, emitter)
    {
	if(this.registry[name])
	{
	    NgLogE('Duplicate registration of diagnostic emitter ' + name);
	    return false;
	}
	this.registry[name] = emitter;
	return true;
    }, 
    
    deregisterEmitter: function(name, emitter)
    {
	if(this.registry[name] != emitter)
	{
	    NgLogE('Non-registered deregistration attempt of diagnostic emitter ' + name);
	    return false;
	}
	this.registry[name] = undefined;
	return true;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// Core diagnostic emitter; collects info from Core subsystem and also collects 
// general info.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var DiagnosticEmitter = require('NGCore/Client/Core/DiagnosticEmitter').DiagnosticEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

////////////////////////////////////////////////////////////////////////////////
    
//
// Create and export a DiagnosticEmitter for Core.  Other modules should do this 
// this way too.
//

exports.Diagnostics = DiagnosticEmitter.singleton(
/** @lends Core.Diagnostics.prototype */
{
    classname: 'Core_Diagnostics',

    /**
     * @class The <code>Core.Diagnostics</code> class constructs a singleton object
     * to obtain overall frame tick diagnostic timing information and other diagnostics
     * generally applicable to the frame processing itself.  Other modules implement
     * module-specific detailed diagnostics.<br/><br/>
	 *
     * The emitter currently emits an object of the form:
     * <pre>
     *     {
     *         "name": "Core",             // The name of the emitter
     * 
     *         "frame": {Number},           // Frame number for which these Diagnostics apply.
     *         "fps": {Number},             // Instantaneous fps rate over the last sampling interval
     *         "skipped": {Number},         // Frames skipped in the last interval
     *         "skipped_fps": {Number},     // Instantaneous skipped fps rate over last interval
     * 
     *         "frame_total": {Timer},     // A Timer object reporting total time processing the frame:
     *                                     // See below for the object definition of Timer.
     *
     *         "tick_total": {Timer},      // Total time spent processing the current engine tick.
     *         "draw_total": {Timer},      // Total time spent drawing.
     *         "game_tick": {Timer},       // Total time spent executing the game JS.
     *         "priv_tick": {Timer},       // Total time spent executing the privileged JS.
     *         "app_tick": {Timer},        // Total time spent ticking the Application object.
     *         "physics_tick": {Timer},    // Total time spent in Physics.
     *         "audio_tick": {Timer},      // Total time spent in Audio.
     *         "motion_tick": {Timer},     // Total time spent processing motion input.
     *         "animations_tick": {Timer}  // Total time spent processing Animations.
     *     }
     * </pre>
     *
     * A Timer is an object of the form:
     * <pre>
     *      {
     *         "samples": {Number},        // number of timer executions captured this interval
     *         "average": {Number},        // average time spent in the timed block
     *         "min": {Number},            // minimum time spent in the timed block
     *         "max": {Number}             // maximum time spent in the timed block
     *      }
     * </pre>
     * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.DiagnosticEmitter
	 * @since 1.7
     */
    initialize: function($super) 
    {
	$super('Core');
    }
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Buffer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Buffer'] || {}; $MODULE_REGISTRY['NGCore/Shared/Buffer'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/Buffer.js';

var Class = require('NGCore/Shared/Class').Class;

exports.Buffer = Class.subclass(
/** @lends Core.Buffer.prototype */
{
  classname: 'Buffer',

  /**
   * @class The <code>Core.Buffer</code> class provides buffers for storing binary data. Use this
   * class in combination with <code>{@link Network.Socket}</code> to transmit data through a
   * socket.<br /><br />
   * In general, when you use this class' methods to read data from a buffer, the data is removed
   * from the buffer. If you need to retrieve data from a buffer without altering the buffer's
   * contents, do one of the following:
   * <ul>
   * <li>Retrieve the buffer's contents using <code>{@link Core.Buffer#toString}</code>.</li>
   * <li>Clone the buffer using <code>{@link Core.Buffer#clone}</code>, then read data from the
   * cloned buffer.</li>
   * </ul>
   * @example
   * // Create an empty data buffer.
   * var buffer = new Core.Buffer();
   * @example
   * // Create a data buffer that contains a string of text.
   * var buffer = new Core.Buffer("data");
   * @example
   * // Create a data buffer by copying data from an existing buffer.
   * var buffer1 = new Core.Buffer("data");
   * var buffer2 = new Core.Buffer(buffer1);
   * @constructs Create a data buffer.
   * @augments Core.Class
   * @param {Core.Buffer|String} [data] An existing data buffer whose contents will be copied to the
   *     new buffer, or a string that will be stored in the buffer.
   * @see Network.Socket
   * @since 1.6.5
   */
  initialize: function()
  {
    this._log2 = function(x) {
      return Math.floor(Math.log(x) / Math.LN2);
    };

    this._toIEEE754 = function(val, ctx, bitWidth) {
      var EBITS;  // num of bits in exponent field
      var FBITS;  // num of bits in significand field

      switch(bitWidth) {
        case 32:
          EBITS = 8;
          FBITS = 23;
          break;
        case 64:
          EBITS = 11;
          FBITS = 52;
          break;
        default:
          throw "Invalid bit width";
      }

      var BIAS = Math.pow(2, EBITS-1) - 1;

      ctx.neg = (val < 0)? 1:0;
      ctx.expo = 0;
      ctx.sigd = 0;

      val = Math.abs(val);

      if(isNaN(val)) {
        ctx.neg = 0;
        ctx.expo = 0;
        ctx.sigd = 1;
      } else if(!isFinite(val)) {
        ctx.expo = Math.pow(2, EBITS) - 1;
        ctx.sigd = 0;
      } else if(val === 0) {
        ctx.expo = 0;
        ctx.sigd = 0;
      } else {
        ctx.expo = this._log2(val);
        if(ctx.expo < (1-BIAS) || (ctx.expo == (1-BIAS) && val < Math.pow(2, (1-BIAS)))) {
          ctx.sigd = Math.round((val / Math.pow(2, (1-BIAS))) * Math.pow(2, FBITS));
          ctx.expo = 0;
        } else {
          ctx.sigd = Math.round((val / Math.pow(2, ctx.expo) - 1) * Math.pow(2, FBITS));
          ctx.expo += BIAS;
        }
      }
    };

    this._fromIEEE754 = function(ctx, bitWidth) {
      var EBITS;  // num of bits in exponent field
      var FBITS;  // num of bits in significand field

      switch(bitWidth) {
        case 32:
          EBITS = 8;
          FBITS = 23;
          break;
        case 64:
          EBITS = 11;
          FBITS = 52;
          break;
        default:
          throw "Invalid bit width";
      }

      var BIAS = Math.pow(2, EBITS-1) - 1;

      if(ctx.expo === 0) {
        if(ctx.sigd === 0) {
          return 0.0;
        }

        return ctx.neg * ctx.sigd * Math.pow(2, (1-BIAS) - FBITS);
      }

      if(ctx.expo == Math.pow(2, EBITS) - 1) {
        if(ctx.sigd === 0) {
          return ctx.neg * Number.POSITIVE_INFINITY;
        }

        return NaN;
      }

      return ctx.neg * (1 + ctx.sigd * Math.pow(2, -FBITS)) * Math.pow(2, ctx.expo - BIAS);
    };

    this._array2val = function(bytes, isLE) {
      var val = 0;
      if(isLE) bytes.reverse();
      for(var i = 0; i < bytes.length; ++i) {
        val += bytes[i] * Math.pow(2, (bytes.length - i - 1) * 8);
      }
      return val;
    };

    this._array2str = function(bytes, isLE) {
      if(isLE) bytes.reverse();
      return String.fromCharCode.apply(String, bytes);
    };

    this._isBinary = function(str) {
      for(var i = 0; i < str.length; ++i) {
        var c = str.charCodeAt(i);
        if(c < 0 && c >= 0x100) {
          return false;
        }
      }
      return true;
    };

    if(typeof(arguments[0]) == 'object') {
      this._bytes = arguments[0]._bytes;
    } else if(typeof(arguments[0]) == 'string') {
      this._bytes = arguments[0];
    } else {
      this._bytes = '';
    }

    if(!this._isBinary(this._bytes)) {
      this._bytes = '';
    }
  },

  /**
   * Retrieve the number of characters in the buffer.
   * @returns {Number} The number of characters in the buffer.
   * @since 1.6.5
   */
  getSize: function() {
    return this._bytes.length;
  },

  /**
   * Read an 8-bit unsigned integer value from the beginning of the buffer, and remove the character
   * at index 0 of the buffer.
   * @returns {Number} An 8-bit unsigned integer value, or <code>NaN</code> if the buffer is empty.
   * @since 1.6.5
   */
  readUint8: function() {
    if(this._bytes.length < 1) return NaN;
    var ret = this._bytes.charCodeAt(0);
    this._bytes = this._bytes.slice(1);
    return ret;
  },

  /**
   * Read a 16-bit unsigned integer value from the beginning of the buffer, and remove the 
   * characters at indexes 0 and 1 of the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to read data in little-endian format. By
   *     default, data is read in big-endian format.
   * @returns {Number} A 16-bit unsigned integer value, or <code>NaN</code> if the buffer contains
   *     fewer than 16 bits of data.
   * @since 1.6.5
   */
  readUint16: function(isLE) {
    if(this._bytes.length < 2) return NaN;
    var ret = this._array2val([
      this._bytes.charCodeAt(0),
      this._bytes.charCodeAt(1)
    ], isLE);
    this._bytes = this._bytes.slice(2);
    return ret;
  },

  /**
   * Read a 32-bit unsigned integer value from the beginning of the buffer, and remove the 
   * characters at indexes 0 through 3 of the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to read data in little-endian format. By
   *     default, data is read in big-endian format.
   * @returns {Number} A 32-bit unsigned integer value, or <code>NaN</code> if the buffer contains
   *     fewer than 32 bits of data.
   * @since 1.6.5
   */
  readUint32: function(isLE) {
    if(this._bytes.length < 4) return NaN;
    var ret = this._array2val([
      this._bytes.charCodeAt(0),
      this._bytes.charCodeAt(1),
      this._bytes.charCodeAt(2),
      this._bytes.charCodeAt(3)
    ], isLE);
    this._bytes = this._bytes.slice(4);
    return ret;
  },

  /**
   * Read an 8-bit signed integer value from the beginning of the buffer, and remove the character
   * at index 0 of the buffer.
   * @returns {Number} An 8-bit signed integer value, or <code>NaN</code> if the buffer is empty.
   * @since 1.6.5
   */
  readInt8: function() {
    var ret = this.readUint8();
    if(ret >>> 7) {
      return ret - 0x100;
    }
    return ret;
  },

  /**
   * Read a 16-bit signed integer value from the beginning of the buffer, and remove the characters
   * at indexes 0 and 1 of the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to read data in little-endian format. By
   *     default, data is read in big-endian format.
   * @returns {Number} A 16-bit signed integer value, or <code>NaN</code> if the buffer contains
   *     fewer than 16 bits of data.
   * @since 1.6.5
   */
  readInt16: function(isLE) {
    var ret = this.readUint16(isLE);
    if(ret >>> 15) {
      return ret - 0x10000;
    }
    return ret;
  },

  /**
   * Read a 32-bit signed integer value from the beginning of the buffer, and remove the characters
   * at indexes 0 through 3 of the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to read data in little-endian format. By
   *     default, data is read in big-endian format.
   * @returns {Number} A 32-bit signed integer value, or <code>NaN</code> if the buffer contains
   *     fewer than 32 bits of data.
   * @since 1.6.5
   */
  readInt32: function(isLE) {
    var ret = this.readUint32(isLE);
    if(ret >>> 31) {
      return ret - 0x100000000;
    }
    return ret;
  },

  /**
   * Read a 64-bit signed float value from the beginning of the buffer, and remove the characters at
   * indexes 0 through 7 of the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to read data in little-endian format. By
   *     default, data is read in big-endian format.
   * @returns {Number} A 64-bit float value, or <code>NaN</code> if the buffer contains fewer than
   *     64 bits of data.
   * @since 1.6.5
   */
  readFloat64: function(isLE) {
    if(this._bytes.length < 8) return NaN;
    var b = [
      this._bytes.charCodeAt(0),
      this._bytes.charCodeAt(1),
      this._bytes.charCodeAt(2),
      this._bytes.charCodeAt(3),
      this._bytes.charCodeAt(4),
      this._bytes.charCodeAt(5),
      this._bytes.charCodeAt(6),
      this._bytes.charCodeAt(7)
    ];

    if(isLE) b.reverse();
    this._bytes = this._bytes.slice(8);

    var ctx = {
      neg: 1 - (2 * (b[0] >> 7)), // 1 or -1
      expo: (((b[0] << 1) & 0xff) << 3) | (b[1] >> 4),
      sigd: ((b[1] & 0x0f) * 0x1000000000000) +
            (b[2] * 0x10000000000) +
            (b[3] * 0x100000000) +
            (b[4] * 0x1000000) +
            (b[5] * 0x10000) +
            (b[6] * 0x100) +
            b[7]
    };

    return this._fromIEEE754(ctx, 64);
  },

  /**
   * Read a 32-bit float value from the beginning of the buffer, and remove the characters at
   * indexes 0 through 3 of the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to read data in little-endian format. By
   *     default, data is read in big-endian format.
   * @returns {Number} A 32-bit float value, or <code>NaN</code> if the buffer contains fewer than
   *     32 bits of data.
   * @since 1.7
   */
  readFloat32: function(isLE) {
    if(this._bytes.length < 4) return NaN;
    var b = [
      this._bytes.charCodeAt(0),
      this._bytes.charCodeAt(1),
      this._bytes.charCodeAt(2),
      this._bytes.charCodeAt(3)
    ];

    if(isLE) b.reverse();
    this._bytes = this._bytes.slice(4);

    var ctx = {
      neg: 1 - (2 * (b[0] >> 7)),
      expo: (((b[0] << 1) & 0xff) | (b[1] >> 7)) & 0xffff,
      sigd: ((b[1] & 0x7f) * 0x10000) +
            (b[2] * 0x100) +
            b[3]
      };

    return this._fromIEEE754(ctx, 32);
  },

  /**
   * Read the specified number of characters from the buffer, and remove the characters from the
   * buffer.
   * @param {Number} len The number of characters to read.
   * @returns {String} The characters read from the buffer.
   * @since 1.6.5
   */
  readBytes: function(len) {
    if(len > this._bytes.length) {
      len = this._bytes.length;
    }
    var ret = this._bytes.slice(0, len);
    this._bytes = this._bytes.slice(len);
    return ret;
  },

  /**
   * Write a value to the end of the buffer as an 8-bit unsigned integer. One character will be
   * appended to the buffer.
   * @param {Number} val The value to write into the buffer.
   * @returns {void}
   * @since 1.6.5
   */
  writeUint8: function(val) {
    this._bytes += String.fromCharCode(val);
  },

  /**
   * Write a value to the end of the buffer as a 16-bit unsigned integer. Two characters will be
   * appended to the buffer.
   * @param {Number} val The value to write into the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to write data in little-endian format.
   *     By default, data is written in big-endian format.
   * @returns {void}
   * @since 1.6.5
   */
  writeUint16: function(val, isLE) {
    this._bytes += this._array2str([
      val>>>8,
      val & 0xff
    ], isLE);
  },

  /**
   * Write a value to the end of the buffer as a 32-bit unsigned integer. Four characters will be
   * appended to the buffer. The value is written in big-endian format.
   * @param {Number} val The value to write into the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to write data in little-endian format.
   *     By default, data is written in big-endian format.
   * @returns {void}
   * @since 1.6.5
   */
  writeUint32: function(val, isLE) {
    this._bytes += this._array2str([
      (val >>> 24) & 0xff,
      (val >>> 16) & 0xff,
      (val >>> 8) & 0xff,
      val & 0xff
    ], isLE);
  },

  /**
   * Write a value to the end of the buffer as an 8-bit signed integer. One character will be
   * appended to the buffer.
   * @param {Number} val The value to write into the buffer.
   * @returns {void}
   * @throws {Error} The specified value cannot be represented as an 8-bit signed integer.
   * @since 1.6.5
   */
  writeInt8: function(val) {
    if(val < -0x80 || val > 0x7f) throw new Error('Invalid argument');
    if(val < 0) {
      val = 0x100 + val;
    }
    this.writeUint8(val);
  },

  /**
   * Write a value to the end of the buffer as a 16-bit signed integer. Two characters will be
   * appended to the buffer.
   * @param {Number} val The value to write into the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to write data in little-endian format.
   *     By default, data is written in big-endian format.
   * @returns {void}
   * @throws {Error} The specified value cannot be represented as a 16-bit signed integer.
   * @since 1.6.5
   */
  writeInt16: function(val, isLE) {
    if(val < -0x8000 || val > 0x7fff) throw new Error('Invalid argument');
    if(val < 0) {
      val = 0x10000 + val;
    }
    this.writeUint16(val, isLE);
  },

  /**
   * Write a value to the end of the buffer as a 32-bit signed integer. Four characters will be
   * appended to the buffer.
   * @param {Number} val The value to write into the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to write data in little-endian format.
   *     By default, data is written in big-endian format.
   * @returns {void}
   * @throws {Error} The specified value cannot be represented as a 32-bit signed integer.
   * @since 1.6.5
   */
  writeInt32: function(val, isLE) {
    if(val < -0x80000000 || val > 0x7fffffff) throw new Error('Invalid argument');
    if(val < 0) {
      val = 0x100000000 + val;
    }
    this.writeUint32(val, isLE);
  },

  /**
   * Write a value to the end of the buffer as a 64-bit signed float. Eight characters will be 
   * appended to the buffer.
   * @param {Number} val The value to write into the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to write data in little-endian format.
   *     By default, data is written in big-endian format.
   * @returns {void}
   * @since 1.6.5
   */
  writeFloat64: function(val, isLE) {
    var ctx = {};
    this._toIEEE754(val, ctx, 64);

    var sigdu = Math.floor(ctx.sigd / 0x100000000);
    var sigdl = ctx.sigd % 0x100000000;

    this._bytes += this._array2str([
      (ctx.neg << 7) | (ctx.expo >> 4),
      (ctx.expo & 0x0f) << 4 | ((sigdu >> 16) & 0x0f),
      (sigdu >> 8) & 0xff,
      sigdu & 0xff,
      (sigdl >>> 24) & 0xff,
      (sigdl >>> 16) & 0xff,
      (sigdl >>> 8) & 0xff,
      sigdl & 0xff
    ], isLE);
  },

  /**
   * Write a value to the end of the buffer as a 32-bit float. Four characters will be appended to
   * the buffer.
   * @param {Number} val The value to write into the buffer.
   * @param {Boolean} [isLE=false] Set to <code>true</code> to write data in little-endian format.
   *     By default, data is written in big-endian format.
   * @returns {void}
   * @since 1.7
   */
  writeFloat32: function(val, isLE) {
    var ctx = {};
    this._toIEEE754(val, ctx, 32);

    this._bytes += this._array2str([
      (ctx.neg << 7) | (ctx.expo >>> 1),
      ((ctx.expo << 7) & 0xff) | ((ctx.sigd >> 16) & 0x7f),
      (ctx.sigd >> 8) & 0xff,
      ctx.sigd & 0xff
    ], isLE);
  },

  /**
   * Write characters to the end of the buffer.
   * @param {String} str The characters to write into the buffer.
   * @returns {void}
   * @since 1.6.5
   */
  writeBytes: function(str) {
    if(this._isBinary(this._bytes)) {
      this._bytes += str;
    }
  },

  /**
   * Retrieve the buffer's contents as a string.
   * @returns {String} The contents of the buffer.
   * @since 1.6.5
   */
  toString: function() {
      return this._bytes;
  },

  clear: function() {
    this._bytes = '';
  },

  /**
   * Create a copy of the <code>Core.Buffer</code> object.
   * @returns {Core.Buffer} A copy of the <code>Core.Buffer</code> object.
   * @since 1.6.5
   */
  clone: function() {
    return new exports.Buffer(this);
  },

  /**
   * Remove a portion of the buffer's data, and create a new buffer containing the data that was
   * removed.
   * @param {Number} begin The index of the first character to remove from the buffer.
   * @param {Number} [end] The index of the last character to remove from the buffer. If you omit
   *     omit this parameter, all of the data after the starting index will be removed.
   * @returns {Core.Buffer} A new <code>Core.Buffer</code> object containing the data that was
   *     removed from the original buffer.
   * @since 1.6.5
   */
  slice: function(begin, end) {
    return new exports.Buffer(this._bytes.slice(begin, end));
  }
});

// vim: ts=2:sw=2:expandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Buffer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Buffer'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Buffer'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Buffer.js';

exports.Buffer = require('NGCore/Shared/Buffer').Buffer;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/libutf8'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/libutf8'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/libutf8'] = exports; 
var __dirname = 'NGCore/Shared/Lib';
var __filename = 'NGCore/Shared/Lib/libutf8.js';

/*
 * A JavaScript implementation of UTF-8 encoder and decoder.
 */

var UTF8 = (function() {

  /**
   * Encode a string in UTF-8 format.
   * @name encode
   * @function
   * @memberOf Core.UTF8
   * @example
   * var str = "Test string";
   * var utf8 = Core.UTF8.encode(str);
   * @param {String} str The string to encode.
   * @returns {String} A UTF-8 encoded string.
   * @since 1.7
   */
  var _toUTF8 = function(str) {
    var utf8 = "";

    for (var n = 0; n < str.length; n++) {
      var c = str.charCodeAt(n);

      if(c < 128) {
        utf8 += String.fromCharCode(c);
      } else if((c > 127) && (c < 2048)) {
        utf8 += String.fromCharCode((c >> 6) | 192);
        utf8 += String.fromCharCode((c & 63) | 128);
      } else {
        utf8 += String.fromCharCode((c >> 12) | 224);
        utf8 += String.fromCharCode(((c >> 6) & 63) | 128);
        utf8 += String.fromCharCode((c & 63) | 128);
      }
    }

    return utf8;
  };

  /**
   * Decode a string in UTF-8 format.
   * @name decode
   * @function
   * @memberOf Core.UTF8
   * @example
   * var str = Core.UTF8.decode(utf8);
   * @param {String} utf8 A UTF-8 encoded string.
   * @returns {String} Decodeded string.
   * @since 1.7
   */
  var _fromUTF8 = function(utf8) {
    var str = "";
    var i = 0;
    var c = 0, c1 = 0, c2 = 0;

    while ( i < utf8.length ) {
      c = utf8.charCodeAt(i);

      if(c < 128) {
        str += String.fromCharCode(c);
        i++;
      } else if((c > 191) && (c < 224)) {
        c2 = utf8.charCodeAt(i+1);
        str += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
        i += 2;
      } else {
        c2 = utf8.charCodeAt(i+1);
        var c3 = utf8.charCodeAt(i+2);
        str += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
        i += 3;
      }
    }

    return str;
  };

  return { encode: _toUTF8, decode: _fromUTF8 };
})();

exports.UTF8 = UTF8;

// vim: ts=2:sw=2:expandtab
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UTF8'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UTF8'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UTF8'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/UTF8.js';

exports.UTF8 = require('NGCore/Shared/Lib/libutf8').UTF8;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/TypeCheck'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/TypeCheck'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/TypeCheck'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/TypeCheck.js';

// TypeCheck.js

// lowest level validate functions.
var isNumber = function (x) { return typeof x === 'number' && x === x; };  // NOTE: if x !== x it's a NaN
var isInteger = function (x) { return typeof x === 'number' && ((x % 1) === 0); }; 
var isString = function (x) { return typeof x === 'string'; };
var isFunction = function (x) { return typeof x === 'function'; };
var isBoolean = function (x) { return typeof x === 'boolean'; };
var isUndefined = function (x) { return typeof x === 'undefined'; };
var isAny = function (x) { return true; };
var isInstanceMaker = function (ctor) { return function (x) { return x instanceof ctor; }; };

// maps string to appropriate validate function
var typeToValidateFunctionMap = {
	'number': isNumber,
	'integer': isInteger,
	'string': isString,
	'function': isFunction,
	'boolean': isBoolean,
	'undefined': isUndefined,
	'any': isAny
};

// Pretty printing helper.
// Useful because it differentiates between the following:
//   * The number 10 = 10
//   * The string 10 = '10'
//   * An array with a single element which is the number 10 = [10]
//   * An array with a single element which is the string 10 = ['10']
// Also, it doesn't invoke toString on functions.
var pp = function(x) {
	if (x instanceof Array) {
		return '[' + x + ']';  // slap braces around x
	} else if (typeof x === 'string') {
		return "'" + x + "'";  // slap quotes around x
	} else if (typeof x === 'function') {
		return 'function';
	} else {
		return x;
	}
};

// Internal class used to hold Arg, OptionalArg, ArgArray, OptionalArgArray, NonEmptyArgArray, OptionalNonEmptyArgArray.
var TypeDef = function (type, check, verify) {
	this.type = type;
	this.check = check;
	this.verify = verify;
};
TypeDef.prototype.toString = function () {
	return '#TypeDef(' + pp(this.type) + ')';
};

// looks up validate function and returns it.
var lookupValidateFunc = function (typeOrFunc) {
	// validate just checks to see if a value is of a specific type.
	var validate;
	if (typeof typeOrFunc === 'string') {
		validate = typeToValidateFunctionMap[typeOrFunc];
		if (validate === undefined) {
			throw new TypeError("Unknown type '" + typeOrFunc + "'");
		}
	} else if (typeof typeOrFunc === 'function') {
		validate = isInstanceMaker(typeOrFunc);
	}
	return validate;
};

// User facing functions to construct new Args
var Arg = function (typeOrFunc, verifyFunc) {
	var validate = lookupValidateFunc(typeOrFunc);
	return new TypeDef(typeOrFunc, ifNotValidMaker(validate, false), verifyFunc);
};
var OptionalArg = function (typeOrFunc, verifyFunc) {
	var validate = lookupValidateFunc(typeOrFunc);
	return new TypeDef(typeOrFunc, ifNotValidMaker(validate, true), verifyFunc);
};
var ArgArray = function (typeOrFunc, verifyFunc) {
	var validate = lookupValidateFunc(typeOrFunc);
	return new TypeDef(typeOrFunc, ifNotValidArrayMaker(validate, 0, false), verifyFunc);
};
var OptionalArgArray = function (typeOrFunc, verifyFunc) {
	var validate = lookupValidateFunc(typeOrFunc);
	return new TypeDef(typeOrFunc, ifNotValidArrayMaker(validate, 0, true), verifyFunc);
};
var NonEmptyArgArray = function (typeOrFunc, verifyFunc) {
	var validate = lookupValidateFunc(typeOrFunc);
	return new TypeDef(typeOrFunc, ifNotValidArrayMaker(validate, 1, false), verifyFunc);
};
var OptionalNonEmptyArgArray = function (typeOrFunc, verifyFunc) {
	var validate = lookupValidateFunc(typeOrFunc);
	return new TypeDef(typeOrFunc, ifNotValidArrayMaker(validate, 1, true), verifyFunc);
};

// A union of primitive types, constructed by Or function.
var TypeUnion = function (typeDefs) {
	this.typeDefs = typeDefs;
	var last = typeDefs[typeDefs.length - 1];
	if (typeof last === 'function') {
		this.typeDefs = typeDefs.slice(0, -1);
		this.verify = last;
	} else {
		this.typeDefs = typeDefs;
	}
};
TypeUnion.prototype.toString = function () {
	return '#TypeUnion(' + this.typeDefs.join(', ') + ')';
};

// user facing function for creating type unions.
var Or = function () {
	var typeDefs = Array.prototype.slice.call(arguments);
	return new TypeUnion(typeDefs);
};

// An array of primitive types, constructed by the Array function.
var TypeArray = function (typeDefs) {
	var last = typeDefs[typeDefs.length - 1];
	if (typeof last === 'function') {
		this.typeDefs = typeDefs.slice(0, -1);
		this.verify = last;
	} else {
		this.typeDefs = typeDefs;
	}
};
TypeArray.prototype.toString = function () {
	return '#TypeArray(' + this.typeDefs.join(', ') + ')';
};

// User facing function for creating type arrays.  NOTE: Not named Array here so it won't shadow the built-in JavaScript Array class constructor.
// NOTE: if the last argument is a function, it will be used as a user supplied verification function.
var ArrayFunc = function () {
	var typeDefs = Array.prototype.slice.call(arguments);
	return new TypeArray(typeDefs);
};

// Object of primitive types, constructed by the Object function.
var TypeObject = function (obj, verify) {
	this.obj = obj;
	this.verify = verify;
};
TypeObject.prototype.toString = function () {
	return '#TypeObject()';
};

// User facing function for creating object args with optional verify functions.
var ObjectFunc = function (obj, verify) {
	if (typeof obj !== 'object') {
		throw TypeError('Object expected object parameter');
	}
	return new TypeObject(obj, verify);
};

// Helper higher-order function which wraps the isTypeFunc with error reporting.
var ifNotValidMaker = function (isTypeFunc, isOptional) {
	return function (schema, x, name) {
		if (!(isOptional && isUndefined(x)) && !isTypeFunc(x)) {
			if (typeof schema.type === 'function')
				return name + ' ' + pp(x) + ' is not a valid class instance';
			else
				return name + ' ' + pp(x) + ' is not a valid ' + schema.type;
		}
	};
};

// Helper higher-order function which wraps the isTypeFunc for arrays with iteration over the array and error reporting.
var ifNotValidArrayMaker = function (isTypeFunc, minLen, isOptional) {
	return function (schema, x, name) {
		var i;
		if (isOptional && isUndefined(x))
			return;
		if (!(x instanceof Array)) {
			return name + ' ' + pp(x) + ' is not an array';
		}
		if (x.length < minLen) {
			return name + ' ' + pp(x) + ' must have at least ' + minLen + ' element' + ((minLen !== 1) ? 's' : '');
		}
		for (i = 0; i < x.length; i++) {
			if (!isTypeFunc(x[i])) {
				return name + '[' + i + '] ' + x[i] + ' is not a valid ' + schema.type;
			}
		}
	};
};

// Assumes schema is an array of schemas.
// Iterates over x, and returns an error if any elements do not match the associated sub-schema.
// NOTE: if the last element of the schema is a function, that function is assumed to be a user supplied validation function, and is invoked on x.
var checkArray = function (schema, x, name) {
	//console.log('checkArray: x = ' + pp(x));
	if (!(x instanceof Array)) {
		return name + ' ' + x + ' is not an array';
	}

	// Check to see if the last element of the schema is a function, if so use it as the verify function.
	var last = schema[schema.length - 1];
	var len = schema.length;
	var verify;
	if (typeof last === 'function') {
		var length = schema.length - 1;
		verify = last;
	}

	// Iterate over each element of the array, stop at first error.
	var error;
	for (var i = 0; i < len; i++) {
		error = check(schema[i], x[i], name + '[' + i + ']');
		if (error)
			return error;
	}

	// Invoke user-supplied verify function.
	if (verify) {
		error = verify(x);
		if (error) {
			return name + ' ' + error;
		}
	}
};

// Assumes schema is an object with string keys, and schema values.
// Iterates over object, and returns error if any elements do not match the associated sub-schema.
// NOTE: there is no way a user can pass in a user-supplied verification function for this.
var checkObject = function (schema, x, name) {
	//console.log('checkObj: x = ' + pp(x));

	if (typeof x !== 'object') {
		return name + ' ' + x + ' is not an object';
	}

	var error;
	for (var key in schema) {
		error = check(schema[key], x[key], name + '.' + key);
		if (error)
			return error;
	}
};

// Assume schema is a TypeDef instance.
// Invoke the TypeDef.check function, followed by the TypeDef.verify function if present.
var checkTypeDef = function (schema, x, name) {
	//console.log('checkTypeDef: x = ' + pp(x) + ', schema = ' + schema);
	var error;
	var func = schema.check;
	if (!func) {
		throw new TypeError(schema.type + ' is not a valid TypeDef type!');
	}

	error = func(schema, x, name);
	if (error) {
		return error;
	}

	if (schema.verify) {
		error = schema.verify(x);
		if (error) {
			return name + ' ' + error;
		}
	}
};

// Assume schema is a TypeUnion instance.
// Try each sub-schema of the union, in order.  Only return an error if they ALL fail.
var checkTypeUnion = function (schema, x, name) {
	//console.log('checkTypeUnion: x = ' + pp(x) + ', schema = ' + schema);
	var i, error, errors = [];
	for (i = 0; i < schema.typeDefs.length; i++) {
		error = check(schema.typeDefs[i], x, name);
		if (!error)
			return;
		errors.push(error);
	}
	if (errors) {
		return errors.join(', ');
	}

	// Invoke user-supplied verify function.
	if (schema.verify) {
		error = schema.verify(x);
		if (error) {
			return name + ' ' + error;
		}
	}
};

// Assume schema is a TypeArray instance.
// check each element against it's sub-schema, return first error.
var checkTypeArray = function (schema, x, name) {
	//console.log('checkTypeArray: x = ' + pp(x) + ', schema = ' + schema);
	var i, error;
	for (i = 0; i < schema.typeDefs.length; i++) {
		error = check(schema.typeDefs[i], x[i], name);
		if (error)
			return error;
	}

	// Invoke user-supplied verify function.
	if (schema.verify) {
		error = schema.verify(x);
		if (error) {
			return name + ' ' + error;
		}
	}
};

// Assume schema is a TypeObject instance.
// check each object value against it's sub-schema, return first error.
var checkTypeObject = function (schema, x, name) {
	//console.log('checkTypeObject: x = ' + pp(x));

	if (typeof x !== 'object') {
		return name + ' ' + x + ' is not an object';
	}

	var error;
	for (var key in schema.obj) {
		error = check(schema.obj[key], x[key], name + '.' + key);
		if (error)
			return error;
	}

	// Invoke user-supplied verify function.
	if (schema.verify) {
		error = schema.verify(x);
		if (error) {
			return name + ' ' + error;
		}
	}
};

// Dispatch to specialized check function based on type of schema.
var check = function (schema, x, name) {
	//console.log('check: x = ' + pp(x));
	var func, error, i;
	if (schema instanceof Array) {
		return checkArray(schema, x, name);
	} else if (schema instanceof TypeDef) {
		return checkTypeDef(schema, x, name);
	} else if (schema instanceof TypeUnion) {
		return checkTypeUnion(schema, x, name);
	} else if (schema instanceof TypeArray) {
		return checkTypeArray(schema, x, name);
	} else if (schema instanceof TypeObject) {
		return checkTypeObject(schema, x, name);
	} else if (typeof schema === 'object') {
		return checkObject(schema, x, name);
	}
};

/** Function which checks arguments against the given type schema.
 *  The simplest case of type schema are basic types, constructed with the Arg() function.
 *  @example
 *    function add(a, b) {
 *      validate(arguments, [Arg('number'), Arg('number')]);
 *    }
 *
 *  There are several basic type strings that can be passed as parameters to the Arg function:
 *    * 'number'
 *    * 'integer'
 *    * 'string'
 *    * 'function'
 *    * 'undefined'
 *    * 'boolean'
 *    * constructor function - used to see if object is an instanceof the given constructor function.
 *
 *  Additionally there is the ability to specify optional and array argument types.
 *    * OptionalArg
 *    * ArgArray
 *    * NonEmptyArgArray
 *    * OptionalArgArray
 *    * OptionalNonEmptyArgArray
 *
 *  Compound types can be created by using arrays or maps of Arg's:
 *    * [Arg('string'), OptionalArg('number')] - an array with a string followed by an optional number
 *    * {name: Arg('string'), size: OptionalArg('number')} - a map where the name key must be a string, but the size key is an optional number.
 *
 *  Custom validation functions can be passed as a second argument to the Arg function.
 *  They are expected to return strings on error, and undefined otherwise.
 *
 *  @example
 *    function reciprocal(numerator) {
 *      validate(arguments, [Arg('number', function (x) {
 *        if (x === 0) {
 *           return 'divide by zero';
 *        }
 *      })]);
 *
 *  @throws TypeError if types within args do not match the schema.
 *  @param {array|Arguments} args parameters to check against the type schema.
 *  @param schema - descriptive structure of the types, names and additional verification functions for the args.
 */
var validateArgs = function () {
	var args = Array.prototype.slice.call(arguments);
	var first = args.shift();
	first = Array.prototype.slice.call(first);
	var rest = args;
	var schema = Or.apply(undefined, rest);
	var ex;
	var error = check(schema, first, 'arguments');
	if (error) {
		// output to log, because sometimes exeptions go down a hole.
		console.log('validateArgs: ' + error);
		ex = new TypeError(error);
		ex.stacklevel = 2;  // this will report exception occuring at the call made before the call to validateArgs
		throw ex;
	}
};

var validate = function (args, schema) {
	var error = check(schema, args, 'arguments');
	var ex;
	if (error) {
		ex = new TypeError(error);
		ex.stacklevel = 2;  // this will report exception occuring at the call made before the call to validateArgs
		throw ex;
	}
};

exports.TypeCheck = {
	validate: validate,
	validateArgs: validateArgs,
	Arg: Arg,
	OptionalArg: OptionalArg,
	ArgArray: ArgArray,
	OptionalArgArray: OptionalArgArray,
	NonEmptyArgArray: NonEmptyArgArray,
	OptionalNonEmptyArgArray: OptionalNonEmptyArgArray,
	Or: Or,
	Array: ArrayFunc,
	Object: ObjectFunc
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core'] || {}; $MODULE_REGISTRY['NGCore/Client/Core'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Core.js';

/**
 * <p>Classes and objects contained by the Core module.</p>
 * @name Core
 * @namespace Create an app's framework, and get information about a device's capabilities.
 * @description <p>The Core module is a collection of classes that provide apps with access to:</p>
 * <ul>
 * <li>Core components of a device.</li>
 * <li>APIs that define a class-based structure for development.</li>
 * <li>Objects that support app updates.</li>
 * </ul>
 * <p>Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Core.Analytics}</code>: Construct objects that keep track of game-specific items that require analysis and counting.</li>
 * <li><code>{@link Core.Base64}</code>: Provides methods to encode and decode Base64 data.</li>
 * <li><code>{@link Core.Buffer}</code>: Provides buffers for binary data that is used by network operations.</li>
 * <li><code>{@link Core.Capabilities}</code>: A singleton object that contains data about device hardware components.</li>
 * <li><code>{@link Core.Class}</code>: Provides an object-oriented programming (OOP) framework for ngCore apps.</li>
 * <li><code>{@link Core.Color}</code>: Control the RGB color components of a device.</li>
 * <li><code>{@link Core.DiagnosticEmitter}</code>: A base class object for constructing objects that emit diagnostic notifications.</li>
 * <li><code>{@link Core.Diagnostics}</code>: A singleton object that emits diagnostics pertaining to frame tick and timing information generally applicable to frame processing.</li>
 * <li><code>{@link Core.ErrorEmitter}</code>: A singleton object that emits errors resulting from unexpected situations, such as exceptions in the native OS or uncaught exceptions in JavaScript.</li>
 * <li><code>{@link Core.LocalGameList}</code>: Construct objects that manage a user's game list.</li>
 * <li><code>{@link Core.Localization}</code>: Provides apps with access to localized strings.</li>
 * <li><code>{@link Core.MessageEmitter}</code>: A base class object for constructing objects that emit app notifications.</li>
 * <li><code>{@link Core.MessageListener}</code>: A base class object for constructing objects that handle app notifications.</li>
 * <li><code>{@link Core.Point}</code>: Control the point values for <i>x</i> and <i>y</i> coordinates.</li>
 * <li><code>{@link Core.Rect}</code>: Construct rectangle objects.</li>
 * <li><code>{@link Core.Size}</code>: Control the values for <i>height</i> and <i>width</i> components.</li>
 * <li><code>{@link Core.Time}</code>: A singleton that contains data about device timing values.</li>
 * <li><code>{@link Core.UpdateEmitter}</code>: Control the app update time rate.</li>
 * <li><code>{@link Core.Vector}</code>: Control the vector values for <i>x</i> and <i>y</i> coordinates.</li>
 * </ul>
 * @this CoreLoader
 */
function CoreLoader(map) {
	this.add = function(key, toEval) {
		this.__defineGetter__(key, function() {
			delete this[key];
			return this[key] = toEval();
		});
	};
	for (var k in map) {
		if (map.hasOwnProperty(k)) this.add(k, map[k]);
	}
}

exports.Core = new CoreLoader({
	'Analytics': function() { return require('NGCore/Client/Core/Analytics').Analytics; },
	'Base64': function() { return require('NGCore/Client/Core/Base64').Base64; },
	'Capabilities': function() { return require('NGCore/Client/Core/Capabilities').Capabilities; },
	'Class': function() { return require('NGCore/Client/Core/Class').Class; },
	'Color': function() { return require('NGCore/Client/Core/Color').Color; },
	'Vector': function() { return require('NGCore/Client/Core/Vector').Vector; },
	'Point': function() { return require('NGCore/Client/Core/Point').Point; },
	'Size': function() { return require('NGCore/Client/Core/Size').Size; },
	'Rect': function() { return require('NGCore/Client/Core/Rect').Rect; },
	'MessageEmitter': function() { return require('NGCore/Client/Core/MessageEmitter').MessageEmitter; },
	'MessageListener': function() { return require('NGCore/Client/Core/MessageListener').MessageListener; },
	'ObjectRegistry': function() { return require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry; },
	'Time': function() { return require('NGCore/Client/Core/Time').Time; },
	'toMD5': function() { return require('NGCore/Client/Core/toMD5').toMD5; },
	'SHA1': function() { return require('NGCore/Client/Core/SHA1').SHA1; },
	'UpdateEmitter': function() { return require('NGCore/Client/Core/UpdateEmitter').UpdateEmitter; },
	'Proc': function() { return require('NGCore/Client/Core/Proc').Proc; },
	'Logger': function() { return require('NGCore/Client/Core/Logger').Logger; },
	'LocalGameList': function() { return require('NGCore/Client/Core/LocalGameList').LocalGameList; },
	'Localization': function() { return require('NGCore/Client/Core/Localization').Localization; },
	'_LocalGameList': function() { return require('NGCore/Client/Core/_LocalGameList')._LocalGameList; },
	'NativeAppLaunch': function() { return require('NGCore/Client/Core/NativeAppLaunch').NativeAppLaunch; },
	'ErrorEmitter': function() { return require('NGCore/Client/Core/ErrorEmitter').ErrorEmitter; },
	'Diagnostics': function() { return require('NGCore/Client/Core/Diagnostics').Diagnostics; },
	'DiagnosticEmitter': function() { return require('NGCore/Client/Core/DiagnosticEmitter').DiagnosticEmitter; },
	'DiagnosticRegistry': function() { return require('NGCore/Client/Core/DiagnosticEmitter').DiagnosticRegistry; },
	'Buffer': function() { return require('NGCore/Client/Core/Buffer').Buffer; },
	'UTF8': function() { return require('NGCore/Client/Core/UTF8').UTF8; },
	'TypeCheck': function() { return require('NGCore/Client/Core/TypeCheck').TypeCheck; }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// Network diagnostic emitter; collects info from Network subsystem.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

//
// Create and export a DiagnosticEmitter for Network.
//

exports.Diagnostics = Core.DiagnosticEmitter.singleton(
{
	classname: 'Network_Diagnostics',

	/**
	 * @class The <code>Network.Diagnostics</code> class provides detailed diagnostic information
	 * about classes in the <code>Network</code> module. You can use this information to debug your
	 * app's use of the <code>Network</code> module and learn more about the app's performance.
	 * <br /><br />
	 * The emitter emits an object of the form:
	 * <br /><br />
	 * <pre>
	 * {
	 *     name: "Network",         // The emitter's name
	 *     socket_fds: {Number},    // Number of file descriptors used by network sockets
	 *     bytes_in: {Number},      // Total amount of data read, in bytes (excluding headers)
	 *     bytes_out: {Number},     // Total amount of data sent, in bytes (excluding headers)
	 *     bps_in: {Number},        // Current instantaneous download rate, in bits per second
	 *     bps_out: {Number},       // Current instantaneous upload rate, in bits per second
	 *     downloads: {Requests},   // Information about file downloads
	 *     xhr: {Requests}          // Information about Network.XHR requests
	 * }
	 * </pre>
	 * The <code>Requests</code> type is an object of the form:
	 * <br /><br />
	 * <pre>
	 * {
	 *     complete: {Number},  // Number of completed requests
	 *     current: {Number},   // Number of requests in progress
	 *     failed: {Number}     // Number of failed downloads
	 * }
	 * </pre>
	 * @name Network.Diagnostics
	 * @constructs
	 * @augments Core.DiagnosticEmitter
	 * @singleton
	 * @since 1.8
	 */
	initialize: function($super)
	{
	$super('Network');
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network'] || {}; $MODULE_REGISTRY['NGCore/Client/Network'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Network.js';

////////////////////////////////////////////////////////////////////////////////
// Class Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
/**
 * @name Network
 * @namespace Connect to remote servers.
 * @description The Network module is a collection of classes that support manipulation of network flow.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:
 *
 * + `{@link Network.DNS}`: Obtain the IP address associated with a domain name.
 * + `{@link Network.Diagnostics}`: Provide diagnostic information about the app's use of the
 * `Network` module.
 * + `{@link Network.DownloadFile}`: Construct objects that conduct a file download.
 * + `{@link Network.DownloadManifest}`: Construct objects that keep manifests up-to-date.
 * + `{@link Network.Socket}`: Connect to a server using TCP or UDP sockets.
 * + `{@link Network.XHR}`: Construct XmlHttpRequest objects.
 */
function NetworkLoader(map) {
	this.add = function(key, toEval) {
		this.__defineGetter__(key, function() {
			delete this[key];
			return this[key] = toEval();
		});
	};
	for (var k in map) {
		if (map.hasOwnProperty(k)) this.add(k, map[k]);
	}
}

exports.Network = new NetworkLoader({
	'XHR': function() { return require("NGCore/Client/Network/XHR").XHR; },
	'DownloadFile': function() { return require("NGCore/Client/Network/DownloadFile").DownloadFile; },
	'DownloadManifest': function() { return require("NGCore/Client/Network/DownloadManifest").DownloadManifest; },
	'Util': function() { return require("NGCore/Client/Network/Util").Util; },
	'_int_Util': function() { return require("NGCore/Client/Network/_int_Util")._int_Util; },
	'Socket': function() { return require("NGCore/Client/Network/Socket").Socket; },
	'DNS': function() { return require("NGCore/Client/Network/DNS").DNS; },
	'Diagnostics': function() { return require("NGCore/Client/Network/Diagnostics").Diagnostics; }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipesRemote'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/NgPipesRemote.js';

var Network = require('NGCore/Client/Network').Network;

var ngPipesRequestNum = 0;

var NgPipesRemote = {
  listeners: [],
  debug: false,

  possibleStates: {
    unknown: {ngPipesRemote:"unknown"},
    finished: {ngPipesRemote:"finished"},
    error: {ngPipesRemote:"error"}
  }
};

NgPipesRemote.addListener = function(listner) {
  this.listeners.push(listner);
  return true;
};

NgPipesRemote.clearQueue = function(queue, callback) {

  if (!queue) {
    return false;
  }

  if (!this.getUrl()) {
    if (callback) {
      callback(NgPipesRemote.possibleStates.finished, []);
    }
    return false;
  }
	var copy_array = queue.slice(0, queue.length);

	var _j, _len2, data;
  while (copy_array && copy_array.length > 0) {
    var to_send = copy_array.slice(0, 10);
    copy_array = copy_array.slice(10);
    data = "";

    for (_j = 0, _len2 = to_send.length; _j < _len2; _j++) {
      data += JSON.stringify(to_send[_j]);
      if (_j+1 < _len2) {
         data += "\r\n";
      } //if len
    } //for

    if (data) {
      NgPipesRemote._makeRequest(data, to_send, callback);
    } //if data
  }//while

};

NgPipesRemote._makeRequest = function(json_data, objs, callback) {
    var request = new Network.XHR(), url = this.getUrl();
    if (this.debug) {
        NgPipesRemote._debugOutput(json_data);
    }

    ngPipesRequestNum++;
    var reqKey = 'pipe'+ngPipesRequestNum;

    var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
    LifecycleEmitter.requestEngineKeepAlive(reqKey);

    request.onreadystatechange = function() {
        var status = null;
        try {
            if (this.readyState === 4) {
                LifecycleEmitter.cancelEngineKeepAlive(reqKey);
                status = NgPipesRemote._handleResponse(request.responseText);
            } else {
                status = NgPipesRemote.possibleStates.unknown;
            }
        } catch (ex) {
            status = NgPipesRemote.possibleStates.error;
            NgLogException(ex);
        }

        if (callback) {
            callback(status, objs);
        }

        NgPipesRemote._notifyListeners(status);
        return true;
    };

    request.open("POST", url, true);

    request.setRequestHeader("X-Ngpipes-Api", "1.0");
    request.setRequestHeader("Content-Type", "application/json+batch");
    request.setRequestHeader("If-None-Match", "0");

    request.send(json_data);

    NgPipesRemote._notifyListeners('started');
    return true;
};

NgPipesRemote.setUrl = function(url) {
    this.url = url;
};
NgPipesRemote.getUrl = function() {
    if (this.url)
        return this.url;
    var Capabilities = require("NGCore/Client/Core/Capabilities").Capabilities;
    var url = null;
    
    if (Capabilities) {
      //Get the url from the configuration.json
      url = (Capabilities.getConfigs() || {} )["analyticsServer"] || null;
      if (url) {
        url = "https://"+url+"/pipes/r.2/bulk_record_stats";
        if (this.debug) {
          NgLogD("Pipes URL => " + url );
        }
      }
    }
    return url;
};


NgPipesRemote._handleResponse = function(respText) {
  var respObj, result;
  result = NgPipesRemote.possibleStates.unknown;
  if (respText && respText.length > 0) {
    try {
    respObj = JSON.parse(respText);
    } catch (e) {
      //Clean up after ourselves.
      respObj = null;
    }
	if (respObj  && (respObj.success !== null && respObj.success !== undefined ) && respObj.success) {
      if (this.debug) {
        NgLogD("[NgPipesRemote] Got Success" );
      }
      result = NgPipesRemote.possibleStates.finished;
    } else {
      result = NgPipesRemote.possibleStates.error;
    }
  } else {
      if (this.debug) {
        NgLogD('[NgPipesRemote] ERROR posting');
      }

    result = NgPipesRemote.possibleStates.error;
  }
  return result;
};

NgPipesRemote._debugOutput = function(str) {
  var _i, _len, _result, msg, msgs;
  msgs = str.split("\r\n");
  for (_i = 0, _len = msgs.length; _i < _len; _i++) {
    msg = msgs[_i];
    NgLogD("[NgPipesRemote] Message sent: " + msg);
  }
  return false;
};

NgPipesRemote._notifyListeners = function(state) {
  var _i, _len, _ref, l;
  for (_i = 0, _len = (_ref = this.listeners).length; _i < _len; _i++) {
    l = _ref[_i];
    l(state);
  }
  return true;
};

exports.NgPipesRemote = NgPipesRemote;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/_Internal/_RequireLoader'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/_Internal/_RequireLoader'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/_Internal/_RequireLoader'] = exports; 
var __dirname = 'NGCore/Client/Social/US/_Internal';
var __filename = 'NGCore/Client/Social/US/_Internal/_RequireLoader.js';

/** RequireLoader.js
	Include files lazily, using throwaway property getters.
*/

function _generateGetter(name, requireFn) {
	// Need this for scoping
	return function() {
		// Remove the getter on first access and replace it with the evaluated require_.
		delete this[name];
		return this[name] = requireFn(require); // Passes in require_ for some Interface Magic!
	};
}

exports.RequireLoader = function(map) {
	if (map instanceof Object) {
		for (var req in map) {
			this.__defineGetter__(req, _generateGetter(req, map[req]));
		}
	}
	return this;
};

exports.RequireLoader.prototype = {
	load: function(name) {
		// A little syntactic sugar if things need to be loaded.
		// require_s.load("Thing") explains what is happening pretty well.
		this[name];
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = exports; 
var __dirname = 'NGCore/Client/Social/_Internal';
var __filename = 'NGCore/Client/Social/_Internal/GSGlobals.js';

/**
 * Annoyingly necessary file to break circular dependencies.
 */
var theRouter = null;
exports.setRouterInstance = function(router){
	theRouter = router;
};
exports.getRouterInstance = function(){
	return theRouter;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Appdata.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class 
 * @name Social.Common.Appdata
 * @description
 * Mobage provides a common API for application data, which you can use for both Japan and the US. 
 * <code>Appdata</code> is consistent with the Open Social <code>osapi.appdata</code> interface 
 * and enables the application to store name/value pairs for arbitrary application data.
 * To add or update application data, call <code>updateEntries()</code>. To retrieve entries, call
 * <code>getEntries()</code>. To delete entries, call <code>deleteEntries()</code>.
 * <br /><br />
 * To use the <code>Appdata</code> API, you must indicate on the Mobage Developer Portal that your
 * application uses this API. To do this, follow these steps:
 * <ol>
 * <li>Log into the Developer Portal at
 * <a href="https://developer-sandbox.mobage.com/en/portal/dashboard">https://developer-sandbox.mobage.com/en/portal/dashboard</a>.</li>
 * <li>Click the Apps tab at the top of the page, then click the name of your application.</li>
 * <li>Scroll to the bottom of the page and click Edit Product Details, then scroll
 * to the bottom of the page and ensure that the "Use userdata api" box is selected.</li>
 * <li>Click Save to save your changes.</li>
 * </ol>
 * <br /><br />
 * <strong>Note</strong>: You can also use ngCore's <code>{@link Storage.KeyValue}</code> and
 * <code>{@link Storage.FileSystem}</code> classes to store application data on the user's device.
 * In addition, you can use the <code>{@link Social.US.AppData}</code> class to store application
 * data; however, if you use this class, you must rewrite portions of your application before
 * releasing it in Japan.
 * @see Social.US.AppData
 * @see Storage.KeyValue
 * @see Storage.FileSystem
 */
exports.Appdata = {
/** @lends Social.Common.Appdata.prototype */
		
	/**
	 * Retrieves a hash of one or more key/value pairs.
	 * If the <code>keys</code> parameter is <code>null</code>, <code>undefined</code> or an empty array, <code>getEntries()</code> 
	 * returns all key/value pairs to the callback function.
	 *
	 * @name Social.Common.Appdata.getEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Set as an array of key names. For example, <code>['key1', 'key2']</code>.
	 * @cb {Function} callback The function to call after retrieving the key-value pairs.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} keys The key/value pairs that were retrieved. The object's properties 
	 *		represent keys, and the value of each property represents the value of the 
	 *		corresponding key.
	 * @cb-returns {void}
	 * @see Social.Common.Appdata.updateEntries
	 * @example 
	 * Appdata.getEntries(['key1', 'key2'], callback );
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getEntries: function(keys, callback) {
		var cmd = {apiURL:"Common.Appdata.getEntries", keys:keys, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	},
	
	/**
	 * Inserts or updates the submitted key/value pairs. 
	 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
	 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
	 * To use key/value pairs without the foregoing constraints, use ngCore's
	 * <code>{@link Storage.KeyValue}</code> class.
	 *
	 * @name Social.Common.Appdata.updateEntries
	 * @function
	 * @public
	 * 
	 * @param {Object} entries The key/value pairs to insert or update. The object's properties 
	 *		represent keys, and the value of each property represents the value of the 
	 *		corresponding key.
	 * @cb {Function} callback The function to call after inserting or updating the key/value pairs.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} keys The key/value pairs that were inserted or updated. The object's 
	 *		properties represent keys, and the value of each property represents the value of the 
	 *		corresponding key.
	 * @cb-returns {void}
	 * @see Social.Common.Appdata.getEntries
	 * @example
	 * Appdata.updateEntries(
	 *              {   'favoriteMovie':'Pulp Fiction',    
	 *                  'petName':'Rover' }, 
	 *              callback );
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	updateEntries: function(entries, callback) {
		if(entries) {
			var cmd = {apiURL:"Common.Appdata.updateEntries", entries:entries, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Entries to update are a required parameter"
					}, null);
			}
		}
	},
	
	
	/**
	 * Deletes one or more key/value pairs.
	 *
	 * @name Social.Common.Appdata.deleteEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys An array of key names to delete. For example, <code>['petName']</code>.
	 * @cb {Function} callback The function to call after deleting the key/value pairs.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} keys The key/value pairs that were deleted. The object's properties 
	 *		represent keys, and the value of each property represents the value of the corresponding
	 *		key.
	 * @cb-returns {void}
	 * @example
	 * Appdata.deleteEntries(['petName'], callback );
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	deleteEntries: function(keys, callback) {
		if(keys && keys.length > 0) {
			var cmd = {apiURL:"Common.Appdata.deleteEntries", keys:keys, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Keys to delete are a required parameter"
					}, null);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Auth.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class
 * @name Social.Common.Auth
 * @description
 * Retrieves a verification code.
 * Games call <code>Auth.authorizeToken()</code> if the game server is using the Mobage REST API.
 * For more information, refer to the Mobage RESTful API documentation on the
 * <a href="https://developer.mobage.com/">Developer Portal</a>.
 */
exports.Auth = {
		
		
	/**
	 * Authorizes a temporary credential and returns a verification code.
	 *
	 * 
	 * @name Social.Common.Auth.authorizeToken
	 * @function
	 * @public
	 *
	 * @param {String} token The temporary credential identifier. 
	 * @cb {Function} callback The function to call after authorizing the temporary credential.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} verifier The verification code.
	 * @cb-returns {void}
	 * @example
	 * var token = "abcdefghi";
     * ...
	 * Social.Common.Auth.authorizeToken (token, callback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	authorizeToken: function(token, callback) {
		var cmd = {apiURL:"Common.Auth.authorizeToken", token:token, callbackFunc: callback };
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		//callback(error, verifier)
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Blacklist.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class 
 * @name Social.Common.Blacklist
 * @description
 * Provides an interface for checking the user's blacklist.
 */
exports.Blacklist = {

	/**
	 * Checks whether the specified user's blacklist contains a targeted user ID.
	 * If the target user ID parameter is <code>null</code>, this call retrieves the entire blacklist. The callback function also receives the total number of 
	 * target user IDs, the starting index, and the number of target IDs returned for paging the results.
	 *
	 * @name Social.Common.Blacklist.checkBlacklist
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID for the user who owns the blacklist. 
	 * @param {String} targetUserId The target user ID to check in the blacklist. <br/>If <code>null</code>, it checks the entire blacklist.
	 * @param {Object} opt The start index and count for pagination. <br/>E.g., <code>{'start': 1, 'count': 100}</code> 
     * Requires start index and count. The minimum start index is 1. 
     * If <code>null</code>, undefined or an empty array, the start index is 1 and the count is 50.
	 * @cb {Function} callback The function to call after checking the blacklist for the specified
	 *		user.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Array} listedUsers The users that appear on the blacklist.
	 * @cb-param {Object} result Information about the results that were returned.
	 * @cb-param {Number} result.total The total number of users on the blacklist.
	 * @cb-param {Number} result.start The starting index for this group of users within the user's 
	 *		entire blacklist.
	 * @cb-param {Number} result.count The number of users that were returned.
	 * @cb-returns {void}
  	 * @returns {void}
  	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	checkBlacklist: function(userId, targetUserId, opt, callback) {
		var cmd = {apiURL:"Common.Blacklist.checkBlacklist", userId:userId, targetUserId:targetUserId, opt:opt, callbackFunc: function(error, args) {
			callback(error, args.users, args.result);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/Cache.js';

var Class = require("NGCore/Client/Core/Class").Class;
var SocialR = require("NGCore/Client/Social");

/**
 * <code>Cache</code> provides caching for a user's objects residing in the local interpreter.
 * @class 
 * @name Social.US.Cache
 * @private
 */
var Cache = exports.Cache = Class.subclass({


	classname: "Cache",
	inMemoryObjects: {},
	caches: {},
	
	/**
	 * Initializes a cache object upon instantiation. 
	 * @name Social.US.Cache.initialize
	 * @constructs
	 * @private
	 */			
	initialize: function(){
	},

	
	/**
	* Takes a classname and a unique record ID and returns the object or <code>null</code> if it doesn't find the object.
	*
	* @name Social.US.Cache.getObjectWithRecordID
	* @function
	* @private
	*
	* @param {String} classname The name of the class.
	* @param {Number} recordID The object ID.
	*
	* @return Returns the object corresponding to the <code>recordID</code> parameter or <code>null</code> if it doesn't find the object.
	*/
	getObjectWithRecordID: function(classname, recordID){
		var category = this.inMemoryObjects[classname];
		if(category){
			return category[recordID] || null;
		}else{
			return null;
		}
	},
	
	/**
	* Takes an object and adds it to the cache.
	* <code>addObject()</code> takes an object, ensures that it is not already in the cache, and adds it to the cache.
	*
	* @name Social.US.Cache.addObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to add to the cache.
	* @return Returns the record ID of the object added to the cache.
	*/	
	addObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(!category){
			category = {};
			this.inMemoryObjects[classname] = category;
		}

		var object = category[obj.recordID];
		if(object){
			return object;
		}else{
			category[obj.recordID] = obj;
			return obj;
		}
	},
	
	/**
	* Takes an object reference and removes the object from the cache.
	* 
	* @name Social.US.Cache.removeObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to remove from the cache.
	*/	
	removeObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(category){
			delete category[obj.recordID]; // ZOMG THE DELETE OPERATOR
		}
	},
	
	/**
	* Takes an object reference and returns whether the object is in the cache.
	* 
	* @name Social.US.Cache.isObjectCached
	* @function
	* @private
	*	
	* @param {Object} obj The object to select in the cache.
	*
	* @return Returns <code>true</true> if the object is in the cache; otherwise, it returns <code>false</code>.
	*/		
	isObjectCached: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		return (category && (category[obj.recordID] == obj));
	},
	
	
	saveCache: function(){
		
	},
	
	
	loadCache: function(){
		
	},
	
	/**
	* Takes a JSON array of objects and loads them into the cache.
	*
	* @name Social.US.Cache.loadCacheFromJSONArray
	* @function
	* @private
	*
	* @param {JSON} jsonArray The JSON object array to load into the cache.
	* @param {function} cb <code>loadCacheFromJSONArray()</code> takes an optional callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
	*/			
	loadCacheFromJSONArray: function(jsonArray, cb){
		var objects = [];
        
		for(var idx = 0; idx < jsonArray.length; idx++){
			var hash = jsonArray[idx];
			if(hash && hash.hasOwnProperty("classname") && hash.hasOwnProperty("recordID")){
				var theClassname = hash.classname;
				var theClass = SocialR.Social.US[theClassname];
				var theRecordID = hash.recordID;
				if(theClass && theRecordID){
					var theInstance = this.getObjectWithRecordID(theClassname, theRecordID);
					if(!theInstance){
						theInstance = new theClass(theRecordID, {});
					}
        
					theInstance._deserializeFromHash(hash);
					this.addObject(theInstance);
				}
			}
		}
        
		cb(null, this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Data';
var __filename = 'NGCore/Client/Social/US/Data/Dispatcher.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

var Core = require("NGCore/Client/Core").Core;
var CacheR = require("NGCore/Client/Social/US/Models/Cache");

var SocialR = require('NGCore/Client/Social');
var SessionR = require('NGCore/Client/Social/US/Data/Session');

/**
 * <code>Dispatcher</code> objects know about <code>DataModel</code> objects and can "push" <code>DataModel</code> objects between interpreters.
 * <code>Dispatcher</code> objects can find classes and specific instances of objects, and may invoke their functions.
 * <code>Dispatcher</code> objects also provide a series of convenience functions to facilitate communication between interpreters.
 * @class 
 * @name Social.US.Dispatcher
 * @private
 */
var Dispatcher = exports.Dispatcher = {
				
	classname: "Dispatcher",
	callbackUIDCounter: 0,
	callbacks: {
		"-2": {},
		"-1": {}
	},
	
	/**
	 * Returns the data cache for the current session.
	 * @name Social.US.Dispatcher.cache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The data cache for the current session.
	 * @see Social.US.Cache
	 */		
	cache: function(){		
		try {		
			return SessionR.Session.getCurrentSession().dataCache();
		}
		catch (err) {
			NgLogD("Mobage/Dispatcher/cache-Warning: cannot get cache. NOTE: This may be expected behavior if early on in initialization. Err=" 
				+ err);

			return null;
		}
	},
	
	
	/**
	 * Gets the current session and loads session data.
	 * If there is no current session, <code>receiveSession()</code> creates a new session.
	 *	 
	 * @name Social.US.Dispatcher.receiveSession
	 * @function
	 * @private
	 *
	 * @param {Type} command Takes a command, which may include the platform version, server mode, application name and application version. 
	 */		
	receiveSession: function(command){		
		var session = SessionR.Session.getCurrentSession();
		if(!session){
			session = new SessionR.Session();
			SessionR.Session._currentSession = session;
		}
		
		var userData = command.data.userData;
		if(userData){
			// the User object will be cached implicitly, then loaded in _loadSessionData
			Dispatcher.receiveObject({data: userData});
		}
		
		session._loadSessionData(command.data);
		
		if(SessionR.Session._emitter){
			SessionR.Session._emitter.emit({session: session});
		}
	},
	
	// DataModel communication
	/**
	 * Finds a particular instance of an object in the local interpreter and calls a method on the object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnLocalObject
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, 
     * its record ID, the method name to call, and any parameters for the method.
	 * The command object takes an optional callback and <code>callMethodOnLocalObject()</code> returns returns the result 
     * and/or any error code and description to the callback function.
	 */		
	callMethodOnLocalObject: function(command){		
		var recordID = command.recordID;
		var classname = command.classname;
		
		var object = Dispatcher.cache().getObjectWithRecordID(classname, recordID);
		if(object){
			var methodName = command.methodName;

			var error = false;
			var args;
			var retVal;
			if(methodName instanceof Array) {
				var methodOwner = object;
				for(var idx = 0; idx < methodName.length; idx++) {
					if(typeof methodOwner[methodName[idx]] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
						retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
						methodOwner = retVal;						
					}
					else {
						error = true;
						break;
					}
				}
			}
			else {
				if(typeof object[methodName] == "function") {
					args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
					retVal = object[methodName].apply(object, args);
				}
				else {
					error = true;
				}
			}
			
			if(error) {
				NgLogD("ERROR: Invalid methods for calling on local object: " + command.recordID + " " + methodName);
			}
			else if(command.callback){
				var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
				if(callback){
					callback(retVal);
				}
			}
		}
	},
	
	
	/**
	 * Finds a particular instance of an object in a remote interpreter and calls a method on the remote object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnRemoteObject
 	 * @function
 	 * @private
 	 *
	 * @param {Number} object The object reference (i.e., typically the keyword 'this').
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method, including other <code>DataModel</code> objects or functions.
	 * @param {Function} cb Returns the result and/or any error code and description to the callback function.
	 *
	 * <b>Note:</b> If the target method wants a callback as one/more of its arguments, supply it as an element in the argument array, <b>NOT</b> as the fourth parameter.
	 */			
	callMethodOnRemoteObject: function(object, method, args, cb){		
		if(!object || !method){
			NgLogD("Public.Dispatcher.callMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callMethodOnLocalObject",
			recordID: object.recordID,
			classname: object._classname(),
			methodName: method,
			arguments: args,
			callback: Dispatcher.convertFunctionToJSON(cb)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Calls a static method on a class in the local interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnLocalObject	
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, the method name to call, and any parameters for the method.
	 * The command parameter takes an optional callback function and <code>callMethodOnLocalObject()</code> returns returns the result and/or any error code and description to the callback function.
	 */		
	callClassMethodOnLocalObject: function(command){		
		Dispatcher.beginBatching();
		
		var classname = command.classname;
		var methodName = command.methodName;
		if(classname && methodName){
			var theClass = SocialR.Social.US[classname];
			if(!theClass){
				theClass = SocialR.Social.US.Service[classname];
			}
			
			if(theClass){
				var error = false;
				var args;
				var retVal;
				if(methodName instanceof Array) {
					var methodOwner = theClass;
					for(var idx = 0; idx < methodName.length; idx++) {
						if(typeof methodOwner[methodName[idx]] == "function") {
							args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
							retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
							methodOwner = retVal;						
						}
						else {
							error = true;
							break;
						}
					}
				}
				else {
					if(typeof theClass[methodName] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
						retVal = theClass[methodName].apply(theClass, args);
					}
					else {
						error = true;
					}
				}
				
				if(error) {
					NgLogD("ERROR: Invalid methods for calling on local Class: " + classname + " " + methodName);
				}
				else if(command.callback){
					var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
					if(callback){
						callback(retVal);
					}
				}				
			}
		}
		
		Dispatcher.endBatching();
	},

	/**
	 * Calls a static method on a class in a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnRemoteObject
	 * @function
	 * @private
	 *
	 * @param {String} theClass The name of the class.
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method.
	 * @param {Function} cb <code>callClassMethodOnRemoteObject()</code> returns returns the result and/or any error code and description to the callback function.
	 * 
	 */			
	callClassMethodOnRemoteObject: function(theClass, methodName, args, cb){		
		if(!theClass || !methodName){
			NgLogD("Public.Dispatcher.callClassMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callClassMethodOnLocalObject",
			classname: (theClass.classname ? theClass.classname : theClass),
			methodName: methodName,
			arguments: args,
			callback: (cb ? Dispatcher.convertFunctionToJSON(cb) : null)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},


	// callback communication

	/**
  	 * Takes a callback and sends it to a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.sendCallbackToRemote
	 * @function
	 * @private
	 *
	 * @param {String} callbackUID The user ID of the user receiving the callback.
	 * @param {Array} args An array of parameters for the callback function.
	 */		
	sendCallbackToRemote: function(callbackUID, args){		
		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveCallbackFromRemote",
			callbackUID: callbackUID,
			arguments: args,
			zone: GSGlobals.getRouterInstance().zone
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Receives a callback from a remote interpreter and provides the arguments to the local callback function.
	 *	 
	 * @name Social.US.Dispatcher.receiveCallbackFromRemote
	 * @function
	 * @private
	 *
	 * @param {Type} command A JSON object containing the user ID of the user receiving the callback and the callback arguments array.
	 */			
	receiveCallbackFromRemote: function(command){
		var callback = Dispatcher.callbacks[GSGlobals.getRouterInstance().zone][command.callbackUID]; //Dispatcher.convertFunctionFromJSON(command);
		if(!callback){
			return;
		}

		var args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
		
		callback.apply(callback, args);
	},
	

	// convenience functions to facilitate communication of all objects
	
	/**
	 * Parses a JSON array of function parameters and returns an array of function parameters.
	 *	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayFromJSON
	 * @function
	 * @private
	 * 
	 * @param {Array} args An array of function parameters in JSON format.
	 * @return {Array} Returns an array of function parameters.
	 */	
	convertArgumentsArrayFromJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			
			if(arg && ((arg.recordID && arg.classname) || arg instanceof Array)){
				newArgs[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}else if(arg && arg.callbackUID){
				newArgs[idx] = Dispatcher.convertFunctionFromJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	/**
	 * Parses an array of function parameters and returns the array in JSON format.	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayToJSON
	 * @function
	 * @private
	 *
	 * @param {Array} args An array of function parameters.
	 * 
	 * @returns {JSON} An array of function parameters in JSON format.
	 */
	convertArgumentsArrayToJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			if(arg && (arg.recordID && arg._classname && typeof arg._classname == "function" && arg._classname())){
				Dispatcher.sendObjectImmediately(arg);

				arg = Dispatcher.convertModelObjectToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && arg instanceof Array){
				arg = Dispatcher.convertArgumentsArrayToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && typeof arg == "function"){
				newArgs[idx] = Dispatcher.convertFunctionToJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	// convenience functions to facilitate communication of DataModel objects
	
	/**
	 * Takes a <code>DataModel</code> object and returns the object in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectToJSON
	 * @function
	 * @private
	 * 
	 * @param {Social.Models.DataModel} object A reference to a <code>DataModel</code> object (i.e., typically a subclass of <code>Models.DataModel</code>).
	 *
	 * @return {JSON} A <code>DataModel</code> object in JSON format.
	 */		
	convertModelObjectToJSON: function(object){		
		if(object && object.recordID && object._classname()){
			object = {
				classname: object._classname(),
				recordID:  object.recordID
			};
		}
		return object;
	},


	/**
	 * Takes a <code>DataModel</code> object in JSON format and returns the object.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectFromJSON
 	 * @function
 	 * @private
 	 *
	 * @param {JSON} json A <code>DataModel</code> object in JSON format.
	 * 
	 * @return {Social.US.DataModel} A <code>DataModel</code> object.
	 */		
	convertModelObjectFromJSON: function(json){		
		var object = json;
		if(json.recordID && json.classname){
			var obj = Dispatcher.cache().getObjectWithRecordID(json.classname, json.recordID);
			if(obj){
				object = obj;
				if(json.data){
					object._deserializeFromHash(json.data);
				}
			}
		}else if(json instanceof Array){
			for(var idx=0; idx < json.length; idx++){
				var arg = json[idx];
				json[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}
		}
		return object;
	},

	// convenience functions to facilitate communication of functions
	
	/**
	 * Takes a function and returns the function in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertFunctionToJSON
	 * @function
	 * @private	 
	 * 
	 * @param {function} The function to conver to JSON format.
	 * 
	 * @return {JSON} Returns a function in JSON format.
	 */		
	convertFunctionToJSON: function(fn){		
		if(fn && typeof fn == "function"){
			
			var callbackUID = ++Dispatcher.callbackUIDCounter;
			var zone = GSGlobals.getRouterInstance().zone;
			Dispatcher.callbacks[zone][callbackUID] = fn;

			fn = {
				callbackUID: callbackUID,
				zone: zone
			};
		}
		return fn;
	},


	
	/**
 	 * Takes a function expressed in JSON format and returns the function.
	 * @name Social.US.Dispatcher.convertFunctionFromJSON
	 * @function
	 * @private
	 * 
	 * @param {JSON} A function in JSON format.
	 * 
	 * @return {Function} Returns a function.
	 */	
	convertFunctionFromJSON: function(json){		
		var fn = json;
		var callbackUID = fn.callbackUID;
		var zone = fn.zone;
		
		if(callbackUID){
			var callback = Dispatcher.callbacks[zone][callbackUID];
			if(callback){
				fn = callback;
				delete Dispatcher.callbacks[zone][callbackUID];
			}else{
				fn = Dispatcher.generateCallbackForUID(callbackUID);
			}
		}
		return fn;
	},


	
	/**
	 * Takes a user ID and sends the callback to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.generateCallbackForUID
	 * @function
	 * @private
	 *	 
	 * @param {Number} The user ID.
	 * @return {Function} Returns a callback to the remote interpreter.
	 */	
	generateCallbackForUID: function(uid){		
		if(uid.callbackUID){
			uid = uid.callbackUID;
		}
		
		return function(){
			Dispatcher.sendCallbackToRemote(uid, arguments);
		};
	},
	
	
	// object sending and batching
	_batchCount: 0,
	_queuedObjects: [],
	
	/**
	 * <code>beginBatching()</code> increments the batch count.
	 * 
	 * @name Social.US.Dispatcher.
	 * @function
	 * @private
	 */	
	beginBatching: function(){		
		++Dispatcher._batchCount;
	},

	/**
	 * Decrements the batch count.
	 * Decrements the batch count and sends any objects remaining in the queue immediately.
	 *
	 * @name Social.US.Dispatcher.endBatching
	 * @function
	 * @private
	 */	
	endBatching: function(){		
		if((--Dispatcher._batchCount) === 0){
			for(var objKey in Dispatcher._queuedObjects){
				var obj = Dispatcher._queuedObjects[objKey];
				Dispatcher._queuedObjects[objKey] = undefined;
				Dispatcher.sendObjectImmediately(obj);
			}
		}
	},

	/**
	 * Takes an object and adds it to a queue, which pushes the object to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.sendObject
	 * @function
	 * @private
	 */
	sendObject: function(obj){		
		if(Dispatcher._queuedObjects.indexOf(obj) == -1){
			Dispatcher.beginBatching();
			
			var key = "" + obj.classname + "---" + obj.recordID;
			Dispatcher._queuedObjects[key] = obj;
			
			Dispatcher.endBatching();
		}
	},

	/**
	 * Takes an object and pushes it to the remote interpreter immediately (i.e., bypassing the queue).
	 *
	 * @name Social.US.Dispatcher.sendObjectImmediately
	 * @function
	 * @private
	 */
	sendObjectImmediately: function(obj){		
		if(!obj){
			return;
		}
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveObject",
			data:   obj._serializedHash()
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Receives a serialized object from the remote interpreter, retrieves the local version of the same object from the cache, and deserializes the received object to the local object.
	 * If there is no local version of the received object, <code>receiveObject()</code> creates a local version and adds it to the cache; then, it deserializes the received object to the newly created local object.
	 *
	 * @name Social.US.Dispatcher.receiveObject
	 * @function
	 * @private
	 */
	receiveObject: function(command){		
		var data = command.data;
		var theRecordID  = data.recordID;
		var theClassname = data.classname;
		var theData      = data.data;
		
		if(theRecordID && theClassname && Dispatcher.cache()){
			var obj = Dispatcher.cache().getObjectWithRecordID(theClassname, theRecordID);
			if(!obj){
				var theClass = SocialR.Social.US[theClassname];
				obj = new theClass(theRecordID);
				
				Dispatcher.cache().addObject(obj);
			}

			// TODO disable emitting somehow
			if(theData){
				obj._deserializeFromHash(theData);
			}
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Data';
var __filename = 'NGCore/Client/Social/US/Data/Session.js';

var CoreReq = require('NGCore/Client/Core');
//var UserReq = require_('../Models/User');
var MessageEmitterReq = require("NGCore/Client/Core/MessageEmitter");
var CacheReq = require('NGCore/Client/Social/US/Models/Cache');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Session</code> manages a user's game sessions.
 * @class 
 * @name Social.US.Session
 */
var Session = exports.Session = MessageEmitterReq.MessageEmitter.subclass({
		
	classname: "Session",
	
	/**
	 * Constructs a session object.
	 * @name Social.US.Session.initialize
	 * @private
	 * @constructs 
	 */	
	initialize: function(gameData){
		if(gameData){
			this._loadSessionData(gameData);
		}
	},
	
	/**
	 * Loads the user's game data into the current session.
	 *
	 * @name Social.US.Session._loadSessionData
	 * @function
	 * @private
	 *
	 * @param {Type} gameData Takes game data and loads it into the current session.
	 */		
	_loadSessionData: function(gameData){
		this._appKey = gameData.appId || this._appKey || null;
		this._appVersion = gameData.appVersion || this._appVersion || null;
		this._platformVersion = gameData.platformVersion || this._platformVersion || "1.0";
		this._serverMode = gameData.serverMode || this._serverMode || null;

		this._user = (gameData.userID ? this.dataCache().getObjectWithRecordID("User", gameData.userID) : null);		
		this.emit({user: this._user});
	},
	
	/**
	 * Returns the cache for the current session. If a session cache does not exist, this call creates a new cache, loads it and returns it.
	 *
	 * @name Social.US.Session.dataCache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The cache for the current session.
	 */			
	dataCache: function(){
		if(!this._cache){
			this._cache = new CacheReq.Cache();
			this._cache.loadCache(function(err){
				NgLogD("Loaded cache: " + err);
			});
		}
		return this._cache;
	},
	
	
	/**
	 * Returns the user for this session.
	 *
	 * @name Social.US.Session.user
	 * @function
	 *
	 * @returns {Social.US.User} The user for the current session.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	user: function(){
		return this._user;
	},
	
	

	// data you probably don't need
	/**
	 * Returns the name of the game for this session.
	 *
	 * @name Social.US.Session.appKey
	 * @function
	 *
	 * @returns {String} The application name.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	appKey: function(){
		return this._appKey;
	},
	
	/**
	 * Returns the version of the game for this session.	 
	 *
	 * @name Social.US.Session.appVersion
	 * @function
	 *
	 * @returns {String} The application version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	appVersion: function(){
		return this._appVersion;
	},
	
	/**
	 * Returns the server mode of the game for this session.
	 *
	 * @name Social.US.Session.serverMode
	 * @function
	 *
	 * @returns {String} The server mode.
	 * <b>Note:</b> Valid settings for the server mode include:<br/>
	 * <ul>
	 * <li>staging</li>
	 * <li>integration</li>
	 * <li>sandbox</li>
	 * <li>production</li>
	 * <li>unknown</li>
	 * </ul>
	 * @see Social.US.Session.serverModes
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	serverMode: function(){
		return this._serverMode;
	},
	
	/**
	 * Returns the platform version of the game for this session.
	 *
	 * @name Social.US.Session.platformVersion
	 * @function
	 *
	 * @returns {String} The platform version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	platformVersion: function(){
		return this._platformVersion;
	},
	

	/**
	 * Takes a consumer key and retrieves the session tokens for the the consumer key.
	 *
	 * @name Social.US.Session.getSessionTokensForConsumerKey
	 * @function
	 * 
	 * @param {String} consumerKey The consumer key.
	 * @cb {Function} cb The function to call after retrieving the session tokens for the
	 *		consumer key.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} error.description A description of the error.
	 * @cb-param {String} error.errorCode A code identifying the error type.
	 * @cb-param {Object} tokens The session tokens for the consumer key.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getSessionTokensForConsumerKey: function(consumerKey, cb){
		Dispatcher.callClassMethodOnRemoteObject("Session", ["getCurrentSession", "getSessionTokensForConsumerKey"], [[], [consumerKey, cb]]);
	}
});


/**
 * The session modes for the server. Session modes include:
 * <ul>
 * <li><code>staging</code></li>
 * <li><code>integration</code></li>
 * <li><code>sandbox</code></li>
 * <li><code>production</code></li>
 * <li><code>unknown</code></li>
 * </ul>
 * @name Social.US.Session.serverModes
 * @field
 * @public
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.serverModes = {
	staging: "staging",
	integration: "integration",
	partner: "sandbox",
	sandbox: "sandbox",
	production: "production",
	unknown: "unknown"
};

/**
 * Returns the current session.  
 * @name Social.US.Session.getCurrentSession
 * @function
 * @static
 *
 * @returns {Social.US.Session} The current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
Session.getCurrentSession = function(){
	return Session._currentSession;
};



Session._emitter = null;

/**
 * Adds a listener to the current session.
 *
 * @name Social.US.Session.addCurrentSessionListener
 * @function
 * @static
 *  
 * @param {Core.MessageListener} listener The listener to add to the current session.
 * @cb {Function} callback The function to call when a session event occurs.
 * @cb-returns {void}
 * @param priority The priority for this <code>MessageListener</code>.
 *
 * @see Core.MessageListener
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.addCurrentSessionListener = function(listener, callback, priority){	
	if(!Session._emitter){
		Session._emitter = new MessageEmitterReq.MessageEmitter();
	}
	
	Session._emitter.addListener(listener, callback, priority);
};

/**
 * Removes the listener from the current session.
 *
 * @name Social.US.Session.removeCurrentSessionListener 
 * @function
 * @static
 *
 * @param {Core.MessageListener} listener The listener for the current session.
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.removeCurrentSessionListener = function(listener){
	if(Session._emitter){
		Session._emitter.removeListener(listener);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Config.js';

var Session = require("NGCore/Client/Social/US/Data/Session").Session;

/**
 * @class 
 * @name Social.Common.Config
 * @description
 * An API to determine whether the social server is a sandbox server or a production server. 
 */
exports.Config = {
/** @lends Social.Common.Config.prototype */

    /**
     * Determine whether the server is a sandbox server or a production server.
     * @name getServerEnvironment
     * @memberOf Social.Common.Config#
     * @public
     * @function
     * @returns {String} One of the following values:
     * <ul>
     *     <li><code>production</code>: Production server.</li>
     *     <li><code>sandbox</code>: Sandbox server.</li>
     *     <li><code>unknown</code>: The current session cannot be retrieved, or  the server mode is
     *     neither <code>sandbox</code> nor <code>production</code>.</li>
     * </ul>
     * @see Social.US.Session#serverMode
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getServerEnvironment: function(){
		var session = Session.getCurrentSession();
		if(!session){
			return "unknown";
		}
		
		var serverMode = Session.getCurrentSession().serverMode();
		if(serverMode == Session.serverModes.production){
			return "production";
		}else if(serverMode == Session.serverModes.sandbox){
			return "sandbox";
		}else{
			return "unknown";
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/People'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/People.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class 
 * @name Social.Common.People
 * @description
 * Provides access to information about users, including their personal information and their 
 * friends. A user's network of friends is sometimes referred to as the user's "social graph."
 * <br /><br />
 * The data that is available for each user varies between the Japan and US/worldwide platforms. On
 * both platforms, you can retrieve a user's ID and display name, as well as a URL for the user's
 * thumbnail image. You can also determine whether the user has installed the application that is
 * currently running. See the individual methods in this class for more details about which fields
 * are available on each platform.
 */
exports.People = {

	/**
	 * Retrieves information about the specified user. By default, only a limited amount of 
	 * information is retrieved. Use the <code>fields</code> parameter to retrieve additional 
	 * information.
	 *
	 * @name Social.Common.People.getUser
	 * @function 
	 * @public 
	 *
	 * @param {String} userId The user ID of the user to retrieve.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>user</code> parameter. The
	 *		required properties of the <code>user</code> parameter are retrieved by default.
	 * @cb {Function} callback The function to call after retrieving information about the specified
	 *		user.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} user Information about the user.
	 * @cb-param {String} [user.aboutMe] Brief introductory text for the user. Available only on the
	 *		Japan platform.
	 * @cb-param {String} [user.addresses] The prefecture where the user lives. Available only on 
	 *		the Japan platform.
	 * @cb-param {Number} [user.age] The user's age.
	 * @cb-param {Boolean} [user.ageRestricted] Set to <code>true</code> if the user has been 
	 *		restricted based on their age. Not available on the Japan platform.
	 * @cb-param {String} [user.birthday] The user's birthday. Uses the format
	 *		<code><em>YYYY</em>-<em>MM</em>-<em>DD</em></code>, where <code><em>YYYY</em></code> is
	 *		the four-digit year, <code><em>MM</em></code> is the two-digit month, and
	 *		<code><em>DD</em></code> is the two-digit day. Available only on the Japan platform.
	 * @cb-param {String} [user.bloodType] The user's blood type. Available only on the Japan 
	 *		platform.
	 * @cb-param {String} user.displayName The name displayed for the user.  Matches the user's 
	 *		nickname.
	 * @cb-param {String} [user.gender] The user's gender. Available only on the Japan platform.
	 * @cb-param {Boolean} user.hasApp Set to <code>true</code> if the user has installed the 
	 *		current application.
	 * @cb-param {String} user.id The user's ID.
	 * @cb-param {String} [user.interests] A list of the user's interests. Available only on the 
	 *		Japan platform.
	 * @cb-param {String} [user.jobType] The user's job type. Available only on the Japan platform.
	 * @cb-param {String} [user.nickname] The user's nickname.
	 * @cb-param {String} user.thumbnailUrl The URL for the user's thumbnail image.
	 * @cb-returns {void}
	 * @see Social.Common.People.getCurrentUser
	 * @example
	 * var recordID = 2;
	 *
	 * Social.Common.People.getUser(recordID, 
	 *                              ['id','nickname','thumbnailUrl'], 
	 *                              callback
	 *		});
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getUser: function(userId, fields, callback) {
		var cmd = {apiURL:"Common.People.getUser", userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves information about as many as 100 users. By default, only a limited amount of 
	 * information is retrieved. Use the <code>fields</code> parameter to retrieve additional
	 * information.
	 *	 
	 * @name Social.Common.People.getUsers
	 * @function 
	 * @public
	 * 
	 * @param {String[]} userIds The user IDs of the users to retrieve. The array must contain
	 *		between 1 and 100 user IDs.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available 
	 *		fields, see the properties of the callback function's <code>users</code> parameter. The
	 *		required properties of the <code>users</code> parameter are retrieved by default.
	 * @cb {Function} callback The function to call after retrieving information about the specified
	 *		users.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object[]} users Information about individual users.
	 * @cb-param {String} [users[].aboutMe] Brief introductory text for the user. Available only on 
	 *		the Japan platform.
	 * @cb-param {String} [users[].addresses] The prefecture where the user lives. Available only on
	 *		the Japan platform.
	 * @cb-param {Number} [users[].age] The user's age.
	 * @cb-param {Boolean} [users[].ageRestricted] Set to <code>true</code> if the user has been 
	 *		restricted based on their age. Not available on the Japan platform.
	 * @cb-param {String} [users[].birthday] The user's birthday. Uses the format
	 *		<code><em>YYYY</em>-<em>MM</em>-<em>DD</em></code>, where <code><em>YYYY</em></code> is
	 *		the four-digit year, <code><em>MM</em></code> is the two-digit month, and
	 *		<code><em>DD</em></code> is the two-digit day. Available only on the Japan platform.
	 * @cb-param {String} [users[].bloodType] The user's blood type. Available only on the Japan
	 *		platform.
	 * @cb-param {String} users[].displayName The name displayed for the user. Matches the user's 
	 *		nickname.
	 * @cb-param {String} [users[].gender] The user's gender. Available only on the Japan platform.
	 * @cb-param {Boolean} users[].hasApp Set to <code>true</code> if the user has installed the 
	 *		current application.
	 * @cb-param {String} users[].id The user's ID.
	 * @cb-param {String} [users[].interests] A list of the user's interests. Available only on the
	 *		Japan platform.
	 * @cb-param {String} [users[].jobType] The user's job type. Available only on the Japan 
	 *		platform.
	 * @cb-param {String} [users[].nickname] The user's nickname.
	 * @cb-param {String} users[].thumbnailUrl The URL for the user's thumbnail image.
	 * @cb-param {Object} result Information about the results that were returned.
	 * @cb-param {Number} result.total The total number of users.
	 * @cb-param {Number} result.start The starting index for this group of users within the entire
	 *		list of users.
	 * @cb-param {Number} result.count The number of users that were returned.
	 * @cb-returns {void}
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getUsers([1,2,3],null, callback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getUsers: function(userIds, fields, callback) {
		var cmd = {apiURL:"Common.People.getUsers", userIds:userIds, fields:fields, callbackFunc:function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves information about the current user. By default, only a limited amount of 
	 * information is retrieved. Use the <code>fields</code> parameter to retrieve additional
	 * information.
	 *
	 * @name Social.Common.People.getCurrentUser
	 * @function
	 * @public
	 *
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available 
	 *		fields, see the properties of the callback function's <code>user</code> parameter. The
	 *		required properties of the <code>user</code> parameter are retrieved by default.
	 * @cb {Function} callback The function to call after retrieving information about the current
	 *		user.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} user Information about the user.
	 * @cb-param {String} [user.aboutMe] Brief introductory text for the user. Available only on the
	 *		Japan platform.
	 * @cb-param {String} [user.addresses] The prefecture where the user lives. Available only on 
	 *		the Japan platform.
	 * @cb-param {Number} [user.age] The user's age.
	 * @cb-param {Boolean} [user.ageRestricted] Set to <code>true</code> if the user has been 
	 *		restricted based on their age. Not available on the Japan platform.
	 * @cb-param {String} [user.birthday] The user's birthday. Uses the format
	 *		<code><em>YYYY</em>-<em>MM</em>-<em>DD</em></code>, where <code><em>YYYY</em></code> is
	 *		the four-digit year, <code><em>MM</em></code> is the two-digit month, and
	 *		<code><em>DD</em></code> is the two-digit day. Available only on the Japan platform.
	 * @cb-param {String} [user.bloodType] The user's blood type. Available only on the Japan
	 *		platform.
	 * @cb-param {String} user.displayName The name displayed for the user. Matches the user's
	 *		nickname.
	 * @cb-param {String} [user.gender] The user's gender. Available only on the Japan platform.
	 * @cb-param {Boolean} user.hasApp Set to <code>true</code> if the user has installed the 
	 *		current application.
	 * @cb-param {String} user.id The user's ID.
	 * @cb-param {String} [user.interests] A list of the user's interests. Available only on the 
	 *		Japan platform.
	 * @cb-param {String} [user.jobType] The user's job type. Available only on the Japan platform.
	 * @cb-param {String} [user.nickname] The user's nickname.
	 * @cb-param {String} user.thumbnailUrl The URL for the user's thumbnail image.
	 * @cb-returns {void}
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getCurrentUser(null, callback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getCurrentUser: function(fields, callback) {
		var cmd = {apiURL:"Common.People.getCurrentUser", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves information about a user's friends. By default, only a limited amount of 
	 * information is retrieved. Use the <code>fields</code> parameter to retrieve additional
	 * information.
	 *
	 * @name Social.Common.People.getFriends
	 * @function
	 * @public
	 * 
	 * @param {String[]} userId The user ID of the user whose friends will be retrieved.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>users</code> parameter. The
	 *		required properties of the <code>users</code> parameter are retrieved by default.
	 * @param {Object} opt Options for the number of users to retrieve. Used to support
	 *                     pagination.
	 * @param {Number} [opt.start] The index of the first user to retrieve. For example, if the user
	 *		has 50 friends, and you have already retrieved 10 friends, set this parameter to
	 *		<code>11</code> to retrieve the next group of friends.
	 * @param {Number} [opt.count] The number of friends to retrieve. For example, if you want to
	 *		display 10 friends per page, set this parameter to <code>10</code>.
	 * @cb {Function} callback The function to call after retrieving information about the specified
	 *		user's friends.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object[]} users Information about individual users.
	 * @cb-param {String} [users[].aboutMe] Brief introductory text for the user. Available only on 
	 *		the Japan platform.
	 * @cb-param {String} [users[].addresses] The prefecture where the user lives. Available only on
	 *		the Japan platform.
	 * @cb-param {Number} [users[].age] The user's age.
	 * @cb-param {Boolean} [users[].ageRestricted] Set to <code>true</code> if the user has been 
	 *		restricted based on their age. Not available on the Japan platform.
	 * @cb-param {String} [users[].birthday] The user's birthday. Uses the format
	 *		<code><em>YYYY</em>-<em>MM</em>-<em>DD</em></code>,  where <code><em>YYYY</em></code> is
	 *		the four-digit year, <code><em>MM</em></code> is the two-digit month, and
	 *		<code><em>DD</em></code> is the two-digit day. Available only on the Japan platform.
	 * @cb-param {String} [users[].bloodType] The user's blood type. Available only on the Japan
	 *		platform.
	 * @cb-param {String} users[].displayName The name displayed for the user. Matches the user's 
	 *		nickname.
	 * @cb-param {String} [users[].gender] The user's gender. Available only on the Japan platform.
	 * @cb-param {Boolean} users[].hasApp Set to <code>true</code> if the user has installed the 
	 *		current application.
	 * @cb-param {String} users[].id The user's ID.
	 * @cb-param {String} [users[].interests] A list of the user's interests. Available only on the
	 *		Japan platform.
	 * @cb-param {String} [users[].jobType] The user's job type. Available only on the Japan
	 *		platform.
	 * @cb-param {String} [users[].nickname] The user's nickname.
	 * @cb-param {String} users[].thumbnailUrl The URL for the user's thumbnail image.
	 * @cb-param {Object} result Information about the results that were returned.
	 * @cb-param {Number} result.total The total number of this user's friends.
	 * @cb-param {Number} result.start The starting index for this group of users within the user's
	 *		entire list of friends.
	 * @cb-param {Number} result.count The number of users that were returned.
	 * @cb-returns {void}
	 * @see Social.Common.People.getFriendsWithGame
	 * @example
	 * People.getFriends(4, null, {'start': 2}, callback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	getFriends: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriends", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves a list of a user's friends who are playing the current game.
	 *
	 * @name Social.Common.People.getFriendsWithGame
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID of the user whose friends are playing the current game.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>users</code> parameter. The
	 *		required properties of the <code>users</code> parameter are retrieved by default.
	 * @param {Object} opt Options for the number of users to retrieve. Used to support pagination.
	 * @param {Number} [opt.start] The index of the first user to retrieve. For example, if the 
	 *		user has 50 friends, and you have already retrieved 10 friends, set this parameter to
	 *		<code>11</code> to retrieve the next group of friends.
	 * @param {Number} [opt.count] The number of friends to retrieve. For example, if you want to 
	 *		display 10 friends per page, set this parameter to <code>10</code>.
	 * @cb {Function} callback The function to call after retrieving a list of the user's friends 
	 *		who are playing the current game.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object[]} users Information about individual users.
	 * @cb-param {String} [users[].aboutMe] Brief introductory text for the user. Available only on
	 *		the Japan platform.
	 * @cb-param {String} [users[].addresses] The prefecture where the user lives. Available only on
	 *		the Japan platform.
	 * @cb-param {Number} [users[].age] The user's age.
	 * @cb-param {Boolean} [users[].ageRestricted] Set to <code>true</code> if the user has been
	 *		restricted based on their age. Not available on the Japan platform.
	 * @cb-param {String} [users[].birthday] The user's birthday. Uses the format
	 *		<code><em>YYYY</em>-<em>MM</em>-<em>DD</em></code>, where <code><em>YYYY</em></code> is
	 *		the four-digit year, <code><em>MM</em></code> is the two-digit month, and
	 *		<code><em>DD</em></code> is the two-digit day. Available only on the Japan platform.
	 * @cb-param {String} [users[].bloodType] The user's blood type. Available only on the Japan 
	 *		platform.
	 * @cb-param {String} users[].displayName The name displayed for the user. Matches the user's 
	 *		nickname.
	 * @cb-param {String} [users[].gender] The user's gender. Available only on the Japan platform.
	 * @cb-param {Boolean} users[].hasApp Set to <code>true</code> if the user has installed the
	 *		current application.
	 * @cb-param {String} users[].id The user's ID.
	 * @cb-param {String} [users[].interests] A list of the user's interests. Available only on the
	 *		Japan platform.
	 * @cb-param {String} [users[].jobType] The user's job type. Available only on the Japan
	 *		platform.
	 * @cb-param {String} [users[].nickname] The user's nickname.
	 * @cb-param {String} users[].thumbnailUrl The URL for the user's thumbnail image.
	 * @cb-param {Object} result Information about the results that were returned.
	 * @cb-param {Number} result.total The total number of users who are friends of the user and 
	 *		are playing the current game.
	 * @cb-param {Number} result.start The starting index for this group of users within the 
	 *		entire list of friends playing the current game.
	 * @cb-param {Number} result.count The number of users that were returned.
	 * @cb-returns {void}
	 * @see Social.Common.People.getFriends
	 * @example 
	 * People.getFriendsWithGame(4, null, null, callback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getFriendsWithGame: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriendsWithGame", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
	
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Profanity.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");	

/**
 * @class 
 * @name Social.Common.Profanity
 * @description
 * Provides an interface to check games for profanity.
 */
exports.Profanity = {
	
	/**
	 * Checks a text string to determine if it contains profanity.
	 * This call only conducts a check and does not attempt to cleanup the string.<br /><br />
	 * <b>Note:</b> The server handles locale and language automatically.
	 *
	 * @name Social.Common.Profanity.checkProfanity
	 * @function
	 * @public
	 * 
	 * @param {String} text The string to check for profanity.
	 * @cb {Function} callback The function to call after checking the string for profanity.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Boolean} valid Set to <code>false</code> if the string contains profanity.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	checkProfanity: function(text, callback) {
		var cmd = {apiURL:"Common.Profanity.checkProfanity", text:text, callbackFunc:function(error, args) {
			callback(error, args.profanity);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Request'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Request.js';

var Class = require('NGCore/Client/Core/Class').Class;


//Don't need to document
exports.Request = Class.subclass({
	execute: function(callback) {
		// [call US function here]	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/RemoteNotification'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/RemoteNotification'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/RemoteNotification'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/RemoteNotification.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class
 * @name Social.Common.RemoteNotification
 * @description
 * Mobage provides a Common API for the sending of remote notifications to others within the Mobage Service.
 * The messages are sent and received by games using ngCore's network-based notification capabilities.
 * The Mobage platform service acts an intermediary to enqueue and send remote messages, while local notification
 * support is provided elsewhere in the ngCore SDK.
 * <br />
 * <code>RemoteNotification</code> Sends a remote notification (push message) to a user's device.
 * This API can be used to send a message to a single user within a given application.  Broadcast notifications
 * can be sent via the server's HTTP REST endpoints, but only when game server's OAuth tokens.
 * @since 1.7
 */
exports.RemoteNotification = {

    /**
     * Sends a remote notification to another user who is also playing a Mobage-enabled game. This API covers only
     * the "user to user" remote notification. This API is not currently rate limited, but Mobage reserves the
     * right to throttle or suspend accounts sending excessive remote notifications.
     *
     * @name Social.Common.RemoteNotification.send
     * @function
     * @public
     *
     * @param {String} recipientId Recipient user's identifier.  This can be either a user's gamertag or user ID.
     * @param {Object} payload Additional parameters passed to the device.
     * @param {String} [payload.message] (required) UTF-8 message body
     * @param {Integer} [payload.badge] (optional) If the notification is sent to an iOS device, this number is used
     *      to badge the application icon.  If no badge is included, no numeric badge will be sent.  Including this
     *      field for target Android devices has no affect and does not count toward payload size constraints.
     * @param {String} [payload.sound] (reserved for future use) (optional) If the notification is sent to an iOS device,
     *      this is the name of the sound file in the application bundle.  If the sound file doesn't exist, or "default"
     *      is specified as the value, the default alert sound is played.  Including this field for target Android
     *      devices has no affect and does not count toward payload size constraints.
     * @param {String} [payload.collapseKey] (optional) If the notification is sent to an Android device, this is
     *      the collapse key to coalesce multiple messages into a single group, so that only the last received
     *      notification is visible.  If no key is specified, all notifications will use the same collapseKey.
     *      Including this field for target iOS devices has no affect and doesn't count toward payload size constraints.
     * @param {String} [payload.style] (optional) If the notification is sent to an Android device, this is a hint
     *      containing the preferred layout style for the system notification tray.  If no style is given, or the
     *      provided style is not available, the default Mobage style will be used.  Valid styles are "normal" and
     *      "largeIcon".  Including this field for target iOS devices has no affect and does not count toward payload
     *      size constraints.
     * @param {String} [payload.iconUrl] (optional) If the notification is sent to an Android device, and the
     *      notification payload includes a style attribute, this icon URL is used to determine the image shown in the
     *      Android notification bar.  If this field is not specified, the default Mobage icon image will be shown.
     *      Including this field for target iOS devices has no affect and doesn't count toward payload size constraints.
     * @param {Object} [payload.extras] (optional) Custom 1 level hash of key/value parameters defined by the developer.
     *      Note; the string key for each item in this section cannot contain any of the payload's defined key values.
     * @cb {Function} callback The function to call after sending the remote notification.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} remoteNotification Sent notification after successful enqueuing on the Mobage server.
     * @cb-param {String} [remoteNotification.id] Unique identifier for the remote notification.
	 * @cb-param {Object} [remoteNotification.payload] payload value specified in the send() method.
	 * @cb-param {String} [remoteNotification.published] ISO 8601 Timestamp when the Mobage API server received the request.
	 *
	 * @cb-returns {void}
	 * @see Device.NotificationEmitter
	 * @example
	 * var recipientId = 10028;
     * var payload     = {
     *   "message": "Simon! Come join my quest.",
     *   "extras": {
     *      "foo": 1,
     *      "bar": "twenty one!"
     *   }
     * };
     *
     * Social.Common.RemoteNotification.send(recipientId, payload, function(error, remoteNotification) {
     *   if (error) {
     *     // error handling code is here
     *   } else {
     *     // successful queueing of the remote notification
     *   }
     * });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.7
	 */
	send: function(recipientId, payload, callback) {
		var cmd = {apiURL:"Common.RemoteNotification.send", recipientId:recipientId, payload:payload, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },

    /**
     * Returns true if the current logged in user can receive remote notifications for the current running application.
     * This can be called from within each application to determine if the current user is capable of receiving remote
     * notifications.
     *
     * @name Social.Common.RemoteNotification.getRemoteNotificationsEnabled
     * @function
     * @public
     *
     * @param {Function} callback The function to call after determining if the current user can be notified.
     * @cb {Function} callback The function to call after determining if the current user can be notified.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Boolean} canBeNotified True if the current logged in user is capable of receiving remote notifications.
     *
	 * @cb-returns {void}
	 * @see Device.NotificationEmitter
	 * @example
	 * Social.Common.RemoteNotification.getRemoteNotificationsEnabled(function(error, canBeNotified) {
     *   if (error) {
     *     // error handling code is here
     *   }
     *   if (canBeNotified) {
     *     // User in the current application can receive remote notifications
     *   }
     * });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.7
	 */
    getRemoteNotificationsEnabled: function(callback) {
        var cmd = {apiURL:"Common.RemoteNotification.getRemoteNotificationsEnabled", callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
     * Boolean setter value for whether or not the current logged in user may receive remote notifications for the
     * current running application.  This can be called from within each application to set the remote notification
     * receipt capability.
     *
     * @name Social.Common.RemoteNotification.setRemoteNotificationsEnabled
     * @function
     * @public
     *
     * @param {Boolean} enabled The enabled or disabled state of the current user's remote notifications.
     * @param {Function} callback The function to call after setting if the current user can be notified.
     * @cb {Function} callback The function to call after setting if the current user can be notified.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Boolean} canBeNotified True if the current logged in user is capable of receiving remote notifications.
     *
	 * @cb-returns {void}
	 * @see Device.NotificationEmitter
	 * @example
	 * Social.Common.RemoteNotification.setRemoteNotificationsEnabled(true, function(error) {
     *   if (error) {
     *     // error handling code is here
     *   }
     *   // User is configured to receive remote notifications
     * });
	 * @returns {void}
     * @status iOS, Android, Test, iOSTested, AndroidTested
     * @since 1.7
     */
    setRemoteNotificationsEnabled: function(enabled, callback) {
        var cmd = {apiURL:"Common.RemoteNotification.setRemoteNotificationsEnabled", enabled:enabled, callbackFunc:callback};
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    }
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = exports; 
var __dirname = 'NGCore/Client/Social/_Internal';
var __filename = 'NGCore/Client/Social/_Internal/GSCommand.js';

/**
 * GSCommand.js
 * GameService Command Helper
 *
 * @summary Converts hashes for sending across the interpreter bounds, specifically:
 *		- Takes a hash with a callbackFunc
 * 			- Takes callbackFunc and converts to callbackId
 *		- Takes a hash with a callbackId
 *			- Takes the callbackId and looks up a callbackFunc from the local cache
 */
 
var GameServiceCommandCallbackStore = {};
GameServiceCommandCallbackStore.uidGenerator = 0;

/** @private */
var storeCallbackIdForFunc = function(callbackFunc) {
	var uid = GameServiceCommandCallbackStore.uidGenerator++;
	GameServiceCommandCallbackStore[uid] = callbackFunc;
	return uid;
};
/** @private */
var extractFuncForCallbackId = function(callbackId) {
	if(GameServiceCommandCallbackStore.hasOwnProperty(callbackId)){
		var callbackFunc = GameServiceCommandCallbackStore[callbackId];
		delete GameServiceCommandCallbackStore[callbackId];
		return callbackFunc;
	}
	return null;
};

var blindConvert = function(hash) {
	if ( typeof hash == "object" ) {
		// Case we have a hash
		if ( hash.hasOwnProperty("callbackFunc") ) {
			//	with a callback func to convert
			hash["callbackId"] = storeCallbackIdForFunc(hash["callbackFunc"]);
			
			delete hash["callbackFunc"];
		}
		else if (hash.hasOwnProperty("callbackId")) {
			hash["callbackFunc"] = extractFuncForCallbackId(hash["callbackId"]);
			delete hash["callbackId"];
		}
		return hash;
	}
	
	NgLogD("Error: invalid or non-object passed to gsCmdConvert.");
	return null;
};
exports.makeSafe = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackFunc"))
	{
		return blindConvert(hash);
	}
	return hash;
};
exports.makeExecutable = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackId"))
	{
		return blindConvert(hash);
	}
	return hash;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = exports; 
var __dirname = 'NGCore/Client/Social/_Internal';
var __filename = 'NGCore/Client/Social/_Internal/Privileged.js';

/**
 * Privileged API for GameService (Public Stub)
 * 
 * Access this file as NGCore/Client/Social.js
 */
exports.Social = {
	// stubbed out for the SDK
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = exports; 
var __dirname = 'NGCore/Client/Social/_Internal';
var __filename = 'NGCore/Client/Social/_Internal/_Router.js';

////////////////////////////////////////////////////////////////////////////////
// Class Router INTERNAL ROUTING CLASS
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Shared/Class').Class;
var Core = require('NGCore/Client/Core').Core;
var GSCommand = require("NGCore/Client/Social/_Internal/GSCommand");
var Public = require("NGCore/Client/Social").Social;

////////////////////////////////////////////////////////////////////////////////
var RouterVerbose = false;

exports.Router = Class.subclass(
/** @lends GameService.Router.prototype */
{
	classname: 'Router',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/** Member var to help shortcircuit uneccessary bounces out to native. */
	zone:-2,
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Zone for this Router Singleton (per-process)
			* @private */
	Zone:
	{ 
		/** Public Zone */
		Public: -2,
		/** GameService Zone */
		GameService: -1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 346,
	// Method create = -1
	// Method sendToOtherProcess = 2
	// Method onCreate = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._sendToOtherProcessRecv( cmd );
					break;
				case 3:
					instance._onCreateRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[346] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendToOtherProcessRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		obj[ "gsCommand" ] = Core.Proc.parseObject( cmd[ 0 ] );
		if( obj[ "gsCommand" ] === undefined )
		{
			NgLogE("Could not parse gsCommand in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onCreateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.onCreate from command: " + cmd );
			return false;
		}
		
		obj[ "zone" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "zone" ] === undefined )
		{
			NgLogE("Could not parse zone in Router.onCreate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x15affff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_sendToOtherProcessSendGen: function( gsCommand )
	{
		Core.Proc.appendToCommandString( 0x15a0002, this, [ Core.Proc.encodeObject( gsCommand ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _sendToOtherProcessRecv: function( cmd ) {}
	// sendToOtherProcess: function( gsCommand ) {}
	
	// _onCreateRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,
	_onCreateRecv:function(cmd) {
		if (!this._onCreateRecvGen(cmd,this)){
			return;
		}
		NgLogD("_Router/_onCreateRecv: "+this.zone);
		//We already stored the zone directly in ourselves (by passing in 'this').
	},
	_sendToOtherProcessRecv: function( cmd )
	{
		var decodedCommand = {};
		if(!this._sendToOtherProcessRecvGen(cmd,decodedCommand)){
			NgLogE("Decode of data for router, failed.");
			return;
		}
		
		var commandObject = decodedCommand["gsCommand"];
		
		//Incoming commands all get executed immediately.
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router/_sendToOtherProcessRecv - in public");
			}
			
			this.dispatchGameCommand(commandObject);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router/ _sendToOtherProcessRecv - not in public");
			}
			
			// Dispatch Immediately, because we are in the game interpreter
			this.dispatchGameServiceCommand(commandObject);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.dispatchGameCommand(commandObject);
		}
	},
 	sendToOtherProcess: function( gsCommand ) 
	{
		var jsonCommand = GSCommand.makeSafe(gsCommand);
		if(!jsonCommand) {
			NgLogD("Couldn't prep GSCommand message for sending!");
			return;
		}
		
		if(RouterVerbose) {
			NgLogD("_Router.js/sendToOtherProcess: " + JSON.stringify(jsonCommand));
		}
		
		this._sendToOtherProcessSendGen(jsonCommand);
	},
	sendCommandToGameService:function(gsCommand) 
	{		
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in public");
			}
			
			// In the Public Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - not in public");
			}
			
			// Dispatch Immediately, because we are in the game interpreter
			this.dispatchGameServiceCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.sendToOtherProcess(gsCommand);
		}
	},
	sendCommandToGame:function(gsCommand)
	{
		if(this.zone == this.Zone.GameService) {
			// In the GameService Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.Public) {
			// Dispatch Immediately, because we are in the game interpreter
			this.dispatchGameCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume this is not the game
			this.sendToOtherProcess(gsCommand);
		}
	},
	dispatchGameCommand:function(jsonCommand) 
	{
		var tCommand = GSCommand.makeExecutable(jsonCommand);
		//For the time being we expect this to almost always be callbacks
		if(tCommand && tCommand.hasOwnProperty("callbackFunc")) {	
			if( typeof tCommand["callbackFunc"] == "function" ) {
				var args = null;
				var error = null;
				if(tCommand.hasOwnProperty("error")) {
					error = tCommand["error"];
				}
				if(tCommand.hasOwnProperty("callbackData")) {
					args = tCommand["callbackData"];
				}

				//Time to execute the callback function!
				tCommand["callbackFunc"](error,args);
			}
		}
		else if(tCommand) {
			// Case there was no callbackFunc this is odd!!
			var apiURL = null;
			if(tCommand && tCommand.hasOwnProperty("apiURL") ) {
				apiURL = tCommand["apiURL"];

				var apiPieces = apiURL.split(".");
				var curPackage = Public;

				
				exports._dispatchHelper(curPackage, apiPieces, jsonCommand);
			}
		}
	},
	dispatchGameServiceCommand:function(jsonCommand) 
	{
		//Don't decode the callbackId into a func when on a different interpreter!
		var apiURL = null;
		if(jsonCommand && jsonCommand.hasOwnProperty("apiURL") ) {
			apiURL = jsonCommand["apiURL"];

			var apiPieces = apiURL.split(".");
			var curPackage = require("NGCore/Client/Social/_Internal/Privileged").Social;
			
			exports._dispatchHelper(curPackage, apiPieces, jsonCommand);
		}
		else {
			NgLogE("Someone called GameService without the proper parameters.\n");
		}
	},
	setVerboseLogging:function(useVerbose)
	{
		RouterVerbose = useVerbose;
	}
});
/** @protected */
exports._dispatchHelper = function(curPackage, apiPieces, jsonCommand){
	var nibble;
	var handedOwnership = false;
	
	while(apiPieces.length && !handedOwnership)
	{
		if (curPackage.dispatchCommand){
			curPackage.dispatchCommand(apiPieces, jsonCommand);
			handedOwnership = true;
		}
		else if (curPackage.hasOwnProperty((nibble = apiPieces.shift()))) {
			try {
				curPackage = curPackage[nibble];
			}
			catch (e){
				NgLogException(e);
			}
		}
		else {
			//Total Fail
			NgLogE("Cannot find namespace " + jsonCommand.apiURL + " in GameService");
			curPackage = null;
			break;
		}
	}

	if(!handedOwnership && curPackage && typeof curPackage == "function" ) {
		try {
			curPackage(jsonCommand);
		} catch(gsException) {
			NgLogException(gsException);
		}

		return; //done dispatching!
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = exports; 
var __dirname = 'NGCore/Client/Social/_Internal';
var __filename = 'NGCore/Client/Social/_Internal/RouterInit.js';

var Router = require('NGCore/Client/Social/_Internal/_Router').Router;
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

//Generate 1 instance of our router now and treat as the global instance!
GSGlobals.setRouterInstance(new Router());; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/DataModel.js';

var MessageEmitter = require("NGCore/Client/Core/MessageEmitter").MessageEmitter;
var SocialR = require("NGCore/Client/Social");
var SessionR        = require("NGCore/Client/Social/US/Data/Session");
var DispatcherR     = require("NGCore/Client/Social/US/Data/Dispatcher");

/**
 * <code>DataModel</code> constructs objects that emit messages when properties of an object change, and provides automatic caching,
 * serialization and deserialization between interpreters. 
 * <br/><br/>
 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>DataModel</code> for instantiation. These include:
 * <ul>
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.AppData}</li>
 * <li>{@link Social.US.Game}</li>
 * <li>{@link Social.US.Score}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </ul>
 * @class 
 * @name Social.US.DataModel
 */
var DataModel = exports.DataModel = MessageEmitter.subclass({
		
	/**
	 * The default constructor.
	 * @constructs
	 * @private
	 */		
	initialize: function(recordID){
		this.recordID = recordID;

		this._cache();
	},
	beginChanges: function(){
		DispatcherR.Dispatcher.beginBatching();
	},
	endChanges: function(){
		DispatcherR.Dispatcher.endBatching();
	},
	_classname: function(){
		var classname = this.classname;
		return classname;
	},
	_cache: function(){
		if(!this._dataCache){
			var session = SessionR.Session.getCurrentSession();
			if(session){
				var cache = session.dataCache();
				if(cache){
					cache.addObject(this);
					this._dataCache = cache;
				}
			}
		}
		return this._dataCache;
	},
	$_serializedDataModel: function(obj){
		if(obj instanceof(DataModel)){
			obj = {
				classname: obj.classname,
				recordID:  obj.recordID
			};
		}
		return obj;
	},
	$_deserializedDataModel: function(value, cache){
		if(value && value.hasOwnProperty && value.hasOwnProperty("classname") && value.hasOwnProperty("recordID")){
			var theClassname = value.classname;
			var theClass = SocialR.Social.US[theClassname];
			var theRecordID = value.recordID;
			if(theClass && theRecordID){
				var theInstance = cache.getObjectWithRecordID(theClassname, theRecordID);
				if(!theInstance){
					theInstance = new theClass(theRecordID);
				}
				
				theInstance._deserializeFromHash(value.data);
				cache.addObject(theInstance);
    
				value = theInstance;
			}
		}
		return value;
	},
	_serializedHash: function(full){
		var theClass = this.constructor;
		var hash = {classname: theClass.classname, recordID: this.recordID};
		if(full === false){
			return hash; // if it's undefined, assume we want all the data
		}
		
		hash.data = {};
		
		var properties = this.constructor.properties || [];
		for(var idx = 0; idx < properties.length; idx++){
			var propertyName = properties[idx];
			var propertyValue = this[propertyName];

			if(propertyValue instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < propertyValue.length; propertyIndex++){
					propertyValue[propertyIndex] = DataModel._serializedDataModel(propertyValue[propertyIndex]);
				}
			}else{
				propertyValue = DataModel._serializedDataModel(propertyValue);
			}
			
			hash.data[propertyName] = propertyValue;
		}
		
		return hash;
	},
	_deserializeFromHash: function(data){
		if(!data){
			NgLogD("No public hash data for " + this.classname + " " + this.recordID);
			return;
		}
		
		var cache = this._cache();
		for(var key in data){
			var value = data[key];
			if(value instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < value.length; propertyIndex++){
					value[propertyIndex] = DataModel._deserializedDataModel(value[propertyIndex], cache);
				}
			}else{
				value = DataModel._deserializedDataModel(value, cache);
			}
			this[key] = value;
		}
	}
});

DataModel._oldSubclass = DataModel.subclass;
DataModel.subclass = function(contents){
	var theClass = DataModel._oldSubclass(contents);
	var properties = contents.properties || [];
	for(var idx = 0; idx < properties.length; idx++){
		var propertyName = properties[idx];
		
		(function(name){
			theClass.prototype.__defineSetter__(name, function(value){
				this["___" + name] = value;
				
				var msg = {};
				msg[""+name] = value;
				
				this.emit(msg);
			});
			theClass.prototype.__defineGetter__(name, function(value){
				return this["___" + name];
			});
		})(propertyName);
	}
	return theClass;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/Friends.js';

var RouterInited = require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

var MessageEmitter = require("NGCore/Client/Core/MessageEmitter").MessageEmitter;

var DataModelR = require("NGCore/Client/Social/US/Models/DataModel");
var Dispatcher = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;

/**
 * @class 
 * @name Social.US.Service.Friends
 */
var Friends = exports.Friends = DataModelR.DataModel.subclass({
    classname: "Friends"
});

/**
 * Opens the "Find Friends" view.
 *
 * @name Social.US.Service.Friends.showFindFriends
 * @function
 * @static
 *
 * @param {String} [selectedTab] Takes an optional tab reference.
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFindFriends = function(selectedTab) {
		NgLogD("Public call showFindFriends");
	
		var cmd = {
			apiURL:"US.Service.Friends.showFindFriends"
		};
		
		if(selectedTab){
            cmd.data = {};
			cmd.data.tab = selectedTab;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
};

/**
 * Shows the "Friend Picker" view.
 * 
 * @name Social.US.Service.Friends.showFriendPicker
 * @function
 * @static
 * 
 * @param maxFriendsToPick The maximum number of friends to pick. <code>0</code> for unlimited.
 * @cb {Function} callback The function to call after opening the Friend Picker view.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} [error.description] A description of the error.
 * @cb-param {String} [error.errorCode] A code identifying the error type.
 * @cb-param {String[]} users The user IDs of the selected users. 
 * @cb-returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFriendPicker = function(maxFriendsToPick, callback) { 
    Dispatcher.callClassMethodOnRemoteObject(Friends, "showFriendPicker", [maxFriendsToPick, callback]);
};

/**
* <code>Social.US.Service.Friends</code> has an invited user message emitter. 
* To add a message listener to the message emitter, see the example below.
*
* @name Social.US.Service.Friends.invitedUserEmitter
* @field
* @example
* 
* Social.US.Service.Friends.invitedUserEmitter.addListener(
*				new Core.MessageListener(), 
*				function(user){ 
*				// do sth. w/ User object 
*				}
* Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
* @see Core.MessageListener
* @see Core.MessageEmitter
* @returns {void}
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Friends.invitedUserEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/Profile.js';

var RouterInited = require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class
 * @name Social.US.Service.Profile
 */

exports.Profile = {
	
	/**
	 * Shows the user profile of the user specified by the <code>userOrGamertag</code> parameter.
	 * 
	 * @name Social.US.Service.Profile.showUserProfile
	 * @function
	 * @public
	 * 
	 * @param userOrGamertag Identifies the user or gamertag corresponding to the user profile.
	 * @param tab Specifies the name of the tab to show when the UI opens. If <code>null</code>, it opens the default tab.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	showUserProfile:function(userOrUserGamertag,tab){		
		var cmd = {
			apiURL:"US.Service.Profile.showUserProfile", 
			data:{
				user:userOrUserGamertag
			}
		};
		if(tab){cmd.tab = tab;}
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/OrderedList.js';

var Dispatcher = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;

/**
 * @class 
 * @name Social.US.OrderedList
 * @description
 * Do not instantiate <code>OrderedList</code> objects directly. This description is for information purposes only. 
 * <code>DataModel</code> subclasses that return <code>OrderedList</code> interfaces include:<br/><br/>
 * <ul>
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </ul><br/>
 * Some <code>DataModel</code> subclasses can return an <code>OrderedList</code>,
 * which is an interface for iterating over a range of values. You determine the iteration range by
 * selecting one of three common functions: <br/><br/>
 * <ul>
 * <li><code>forAll(iterCb, doneCb):</code> Iterates over all values.</li>
 * <li><code>forRange(start, count, iterCb, doneCb):</code> Iterates from the starting index to the count.</li>
 * <li><code>forItem(index, iterCb, doneCb):</code> Iterates over a particular item given by its index.</li>
 * </ul>
 * Each of the functions calls an iteration callback (iterCb) for every available item. 
 * When the function iterates over all items or an error occurs, it calls the done callback (doneCb). You <b>MUST</b> provide both callbacks.
 * <br/><br/>
 * <b>Note:</b> The <code>OrderedList</code> interface invokes an iterator on the server. Do NOT assume it will execute your callback functions immediately.
 *
 * @example
 * //NOTE: You MUST provide both callback functions.
 * userBuddiesList.forAll( 
 *      function(error, details){//per item cb body}, 
 *      function(error, details){//done cb body}
 * );
 *
 * @example
 * //Callback examples
 * var done = false;
 * var err = null;
 *
 * currentUser.getFriendsList().forAll(
 *          function(continueCb, user, index){
 *				if(user == otherUser){
 *					foundBuddy = true;
 *					continueCb(false);
 *				}else{
 *					continueCb(true);
 *				}
 *			}, 
 *          function(error){
 *                  if (!error){
 *                      done = true;
 *                   } else {
 *                      err = error;
 *                   }
 *          }
 * );
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
var OrderedList = {

    /**
    * Returns a public interface for an object.
    * 
    * To expose a privelegee ordered list of a <code>DataModel</code> object in the public interface, 
    * add a function to the object of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getObjectPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },
    *
    * @name Social.US.OrderedList.getObjectPublicInterface
    * @function    
    * @private
    *
    * @param {Object} ownerObject The object that will "own" the public interface.
    * @param {Function} getListFn The function that returns a list of values to the <code>OrderedList</code>.
    * @param interfaceName The name of the interface.
    *
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getObjectPublicInterface: function(ownerObject, getListFn, interfaceName) {
		if(ownerObject[interfaceName]) {
			return ownerObject[interfaceName];
		}
		
		var args = Array.apply(null, arguments);
		if(args && args.length > 3){
			args.splice(0, 3);
		}else{
			args = [];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forAll"], [args,[perItemCb, doneCb]]);		
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forRange"], [args,[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forItem"], [args,[index, perItemCb, doneCb]]);
			}
		};
		
		ownerObject[interfaceName] = newInterface;
		
		return newInterface;
	},

    /**
    * Returns a public interface for a class.
    * To expose a priveleged ordered list of a <code>DataModel</code> subclass in the public interface, 
    * add a function to the subclass of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getClassPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },    
    *
    * @name Social.US.OrderedList.getClassPublicInterface
    * @function
    * @private
    *
    * @param {Object} owner The owner of the the public interface.
    * @param {Function} getListFn The function to call on each iteration.
    * @param interfaceName The name of the interface.
    * 
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getClassPublicInterface: function(owner, getListFn, interfaceName) {
		if(owner[interfaceName]) {
			return owner[interfaceName];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forAll"], [[],[perItemCb, doneCb]]);
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forRange"], [[],[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forItem"], [[],[index, perItemCb, doneCb]]);
			}
		};
		
		owner[interfaceName] = newInterface;
		
		return newInterface;
	}
};

exports.OrderedList = OrderedList;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/User'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/User.js';

var DataModelR  = require("NGCore/Client/Social/US/Models/DataModel");
var Dispatcher  = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;
var OrderedList = require("NGCore/Client/Social/US/Models/OrderedList").OrderedList;
var Social      = require("NGCore/Client/Social").Social;

/**
* <code>User</code> constructs objects that provide a service interface for the current user. 
* <code>User</code> objects enable the current user to retrieve:
* <ul>
* <li>user details</li>
* <li>a list of friends</li>
* <li>games</li>
* </ul>
* @class
* @name Social.US.User
* @augments Social.US.DataModel
*/
var User = exports.User = DataModelR.DataModel.subclass({
		
    /**
    * @constructs
    * @ignore
    */
	classname: "User",

	 /**
	 * The user's gamer tag. Read-only.
	 * @name Social.US.User.gamertag
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The user's avatar ID. Read-only.
	 * @name Social.US.User.avatarId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's motto. Read-only.
	 * @name Social.US.User.motto
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The relation to this user. Read-only.
	 * @name Social.US.User.relation
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Sparse limits attributes in search results. Read-only.
	 * @name Social.US.User.sparse
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's photo ID. Read-only.
	 * @name Social.US.User.photoId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's email address. Read-only.
	 * @name Social.US.User.emailAddress
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A hash of the user's email address. Read-only.
	 * @name Social.US.User.emailHash
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's phone number. Read-only.
	 * @name Social.US.User.phoneNumber
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's password. Read-only.
	 * @name Social.US.User.password
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's first name. Read-only.
	 * @name Social.US.User.firstName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's last name. Read-only.
	 * @name Social.US.User.lastName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether to hide the user's full name. Read-only.
	 * @name Social.US.User.hideFullName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user is age restricted. Read-only.
	 * @name Social.US.User.ageRestricted
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the relationship to the user is new. Read-only.
	 * @name Social.US.User.isNewRelationship
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user is a mutual friend. Read-only.
	 * @name Social.US.User.isMutualFriend
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user shows his/her presence. Read-only.
	 * @name Social.US.User.showsPresence
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user only shows friend notifications. Read-only.
	 * @name Social.US.User.setOnlyShowFriendNotifications
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's capabilities. Read-only.
	 * @name Social.US.User.capabilities
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's gamer score. Read-only.
	 * @name Social.US.User.gamerscore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level. Read-only.
	 * @name Social.US.User.gamerLevel
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level name. Read-only.
	 * @name Social.US.User.gamerLevelName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer level score. Read-only.
	 * @name Social.US.User.gamerLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer score for the next level. Read-only.
	 * @name Social.US.User.gamerNextLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's games. Read-only.
	 * @name Social.US.User.games
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	properties: [
		// public
		"gamertag",
		"avatarId",
		"motto",
		"relation",
		"sparse",
		"photoId",
		"emailHash",
		"ageRestricted",
		"isMutualFriend",
		
		// private
		"phoneNumber",
		"password",
		"firstName",
		"lastName",
		"hideFullName",
		"emailAddress",
		"isNewRelationship",
		"showsPresence",
		"onlyShowFriendNotifications",
        "allowFriendPostsOnly",
		"capabilities",
		"gamerscore",
		"gamerLevel",
		"gamerLevelName",
		"gamerLevelScore",
		"gamerNextLevelScore",
		"games"
	],
	
	/**
	 * @constructs The default constructor constructs <code>User</code> objects.
	 * @name Social.US.User.initialize 
	 * @private
	 */
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("User Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Adds a user to the buddies list and ensures the added user is not on the blocked users list.
	* @name Social.US.User.addBuddy
	* @function
	* @private
	*
	* @param {Social.US.User} buddy The user to add to the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @returns {void}
	*/	
	addBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "addBuddy", [buddy, cb]);
	},
	
	
	/**
	* Removes a user from the buddies list.
	* @name Social.US.User.removeBuddy
	* @function
	* @private
	*
	* @param {User} buddy The user to remove from the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @returns {void}
	*/		
	removeBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "deleteBuddy", [buddy, cb]);
	},
	ignoreBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "ignoreBuddy", [buddy, cb]);
	},
	/**
	 * Retrieves a user object with all of the user's details.
	 *
	 * @name Social.US.User.getUserDetails
	 * @function
	 * 
	 * @cb {Function} cb The function to call after retrieving the user's details.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
 	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Social.US.User} user Detailed information about the user.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	getUserDetails: function(cb){
		Dispatcher.callMethodOnRemoteObject(this, "getUserDetails", [cb]);		
	},
	
	/**
	* Retrieves an ordered list of the user's friend requests on Mobage.
	* @name Social.US.User.getMobageFriendRequestLists
	* @function
	*
	* @returns {Social.US.OrderedList} A list of the user's friend requests.
    * @example
    * var myMobageFriendRequests = userA.getMobageFriendRequestsList();
    * @see Social.US.OrderedList
	*/			
	getMobageFriendRequestsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getInvitesList", "_followersListInterface");
	},
	
	/**
	* Returns the user's friends list on Mobage.
	* @name Social.US.User.getMobageFriendsList
	* @function
	*
	* @returns {Social.US.OrderedList} The user's friend list on Mobage.
    * @example
    * var myMobageFriendsList = userA.getMobageFriendsList();
    * @see Social.US.OrderedList
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageFriendsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsList", "_friendsListInterface");
	},
	
	/**
	* Returns the user's blocked user list.
	* @name Social.US.User.getMobageBlockedUserList
	* @function
	*
	* @returns {Social.US.OrderedList} The user's blocked user list on Mobage.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageBlockedUserList: function(){
		return OrderedList.getObjectPublicInterface(this, "getBlockedUserList", "_enemyListInterface");
	},
	
	/**
	* Returns the user's games list.
	* @name Social.US.User.getOwnedGamesList
	* @function
	*
	* @returns {Social.US.OrderedList} The user's Mobage game list.
    * @example
    * var myGamesList = userA.getOwnedGamesList();
    * @see Social.US.OrderedList
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getOwnedGamesList: function(){
		return OrderedList.getObjectPublicInterface(this, "getOwnedGamesList", "_ownedGamesListInterface");
	},
	
	/**
	* MAX: TODO: DOCUMENT
	* returns achievements list for current game for this user
	*/			
	getAchievementsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getAchievementsList", "_achievementsListInterface");
	},

	/**
	* Returns the list of "featured" users.
	* @name Social.US.User.getFeaturedUsersList
	* @function
	*
	* @returns {Social.US.OrderedList} The list of "featured" users.
    * @example
    * var mobageFeaturedUsers = userA.getFeaturedUsersList();
    * @see Social.US.OrderedList
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	getFeaturedUsersList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFeaturedUsersList", "_featuredUsersListInterface");
	},

	/**
	* Invites the user to the current game.
	* @name Social.US.User.inviteToCurrentGame
	* @function
	* @cb {Function} cb The function to call after inviting the user to the current game.
	* @cb-param {Object} error Information about the error, if any.
 	* @cb-param {String} [error.description] A description of the error.
 	* @cb-param {String} [error.errorCode] A code identifying the error type.
	* @cb-returns {void}
 	* @returns {void}
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	inviteToCurrentGame: function(cb){
		var user = this;
		Dispatcher.callMethodOnRemoteObject(this, "inviteToCurrentGame", [function(err){
			if(!err){
				Social.Common.Service.invitedUserEmitter.emit({userId: user.recordID});
				Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
			}
			cb.apply(this, Array.apply(null, arguments));
		}]);		
	},
	
	/**
	 * Send a Push notification to this user through the GameService back end.
	 * @name Social.US.User.sendNotificationToUser
	 * @function
	 *
	 * @param {Alert Text} alertText The displayed message when the push is received.
	 * @param {Badge ID} badgeId Badge displayed on the push.
	 * @param {Sound} sound Sound played when push is received.
	 * @param {Extra Data} extraData Additional payload.
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	sendNotificationToUser: function(alertText, badgeId, sound, extraData) {
		Dispatcher.callMethodOnRemoteObject(this, "sendNotificationToUser", [alertText, badgeId, sound, extraData]);
	},

    /**
     * Adds a user to the current user's friend list for the current game. Implies a one-directional relationship or "follower" model.
     * Takes an optional group parameter to add the user to a particular group. Current user can only 
     * add the user to one group. If the current user adds the user to a second group in the friend list, 
     * the user is moved from the first group.
     *
     * A group is an arbitrary classification of friends. The <code>group</code> parameter is a string, which 
     * takes the name of the group. You may allow users to manage their own groups, create game-level groups, 
     * or omit groups altogether. A user may only reside in one group of another user's friend list.<br /><br />
     * <b>Note:</b> This is part of the Game Graph API. 
     *
     * @example
     * //Retrieve a user and set up a follower relationship.
     * var userA = Social.US.User; 
     * Social.US.User.getUserWithGamertag("chuck", function(error, user){
     *   if(!user) {
     *       var errorCode = error.errorCode;
     *       var errorDesc = error.description;
     *   } else {
     *        userA = user;
     *   }
     * });
     * var userB = Social.US.Session.getCurrentSession().user();
     * userB.addFriend(userA, callback);
     * //...
     * @example
     * //To make the relationship bi-directional, 
     * //you must make the same call for the other user.
     * userA.addFriend(userB, callback);
     *
     * @name Social.US.User.addFriend
     * @function
     *
     * @param {Social.US.User} user The user to add to the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
     * <code>Social.US.User</code> object, the callback error is "No user."
     * @param {String} [group] An optional parameter for adding the friend into a group within the friend list.
     * @cb {Function} cb The function to call after adding a user to the current user's friend list.
 	 * @cb-param {Object} error Information about the error, if any.
 	 * @cb-param {String} [error.description] A description of the error.
 	 * @cb-param {String} [error.errorCode] A code identifying the error type.
     * @cb-param {Object} data Information about the user.
     * @cb-returns {void}
     * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
	addFriend: function(user, group, cb){
		if(typeof arguments[1] == "function" && !arguments[2]){
			cb = arguments[1];
			group = undefined;
		}
		Dispatcher.callMethodOnRemoteObject(this, "addGameFriend", [user, group, cb]);
	},

    /**
     * Removes a user from the current user's friend list for the current game.<br /><br />
     * Does not require a group parameter, friends are only associated to one group in a friend list.
     * @name Social.US.User.removeFriend
     * @function
     *
     * @param {Social.US.User} user The user to remove from the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
     * <code>Social.US.User</code> object, the callback error is "No user."
     * @cb {Function} cb The function to call after removing a user from the current user's
     *                   friend list.
 	 * @cb-param {Object} error Information about the error, if any.
 	 * @cb-param {String} error.description A description of the error.
 	 * @cb-param {String} error.errorCode A code identifying the error type.
     * @cb-param {Object} data Information about the user.
     * @cb-returns {void}
     * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */		
	removeFriend: function(user, cb){
		Dispatcher.callMethodOnRemoteObject(this, "removeGameFriend", [user, cb]);
	},
	
	report: function(reason, cb){
		Dispatcher.callMethodOnRemoteObject(this, "report", [reason, cb]);
	},

    /**
	 * Returns the user's friend list for the current game. If you specify the <code>group</code>
	 * parameter, this call only returns friends within the group.<br /><br />
	 * <b>Note:</b> This is part of the Game Graph API.
	 * @name Social.US.User.getFriendsList
	 * @function
	 *
	 * @param {String} group If specified, returns only friends in the group.
	 * @returns {Social.US.OrderedList} The user's friend list for the current game.
	 * @example
	 * var myFriendsList = userA.getFriendsList ("Best Buddies");
	 * @see Social.US.OrderedList
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-friends-" + group ) : "_gameFriendsList-friends"), "friends", group);
	},


    /**
    * Returns the user's mutual friends.
    * Mutual friends result when two users add each other to their respective friend list.<br /><br />
    * <b>Note:</b> This is part of the game graph API.
    * @name Social.US.User.getMutualFriendsList
    * @function
    *
    * @param {String} group The group within the friend list. If specified, returns only mutual friends within the group.
    * @returns {Social.US.OrderedList} The user's mutual friend list.
    * @example
    * userA.addFriend(userB);
    * userB.addFriend(userA);
    * var myMutualFriends = userA.getMutualFriendsList();
    * //userA appears in userB's mutual friends list, 
    * //because they are in each other's friend lists.
    * @see Social.US.OrderedList
    * @status iOS, Android, Test, iOSTested, AndroidTested    
    */	
	getMutualFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-mutual-" + group) : "_gameFriendsList-mutual"), "mutual", group);
	},


    /**
    * Returns the user's friend requests list. If the <code>group</code> parameter is specified, returns
    * only friends within the group.
    * @name Social.US.User.getFriendRequestsList
    * @function
    *
    * @param {String} group The group within the friend request list.
    * @returns {Social.US.OrderedList} The user's friend requests list.
    * @example
    * var myFriendRequestsList = userA.getFriendRequestsList ();
    * @see Social.US.OrderedList
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendRequestsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-invitation-" + group) : "_gameFriendsList-invitation"), "invitation", group);
	},

	/**
	* Updates the email address for the current user.
	* @name Social.US.User.setEmailAddress
	* @function
	* @private
	*
	* @param {String} newAddress The email address for the current user.
	* @param {Function} cb The callback function if an error occurs (for example, invalid email address format).
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setEmailAddress:function(newAddress,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setEmailAddress", [newAddress, cb]);
	},
	
	/**
	* Sets whether the current user will receive notifications from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setOnlyShowFriendNotifications
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user will only receive notifications from Mobage users who are also Mobage friends. 
    * If set to <code>false</code>, the user receives notifications from all Mobage users. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setOnlyShowFriendNotifications:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOnlyShowFriendNotifications", [isFriendsOnly, cb]);
	},
	
	/**
	* Sets whether the current user will receive game news and updates from Mobage.
	* @name Social.US.User.setOptsIn
	* @function
	* @private
	*
	* @param {Boolean} optIn Set to <code>true</code> if the current user will receive news and updates from Mobage. 
    * If set to <code>false</code>, the user will not receive news or updates from Mobage. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setOptsIn:function(optIn,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOptsIn", [optIn, cb]);
	},

    /**
	* Sets whether the current user can receive wall post messages from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setAllowFriendPostsOnly
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user can only receive wall post messages from Mobage users who are also Mobage friends.
    * If set to <code>false</code>, the user can receive wall post messages from all Mobage users.
	* @param {Function} cb The callback function if an error occurs.
	* <br/>
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status ?
	*/
	setAllowFriendPostsOnly:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setAllowFriendPostsOnly", [isFriendsOnly, cb]);
	},

	/**
	* Sets a motto for the current user. In other words, the user's "about me" text string.
	* @name Social.US.User.setMotto
	* @function
	* @private
	*
	* @param {String} motto The motto for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setMotto:function(motto,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setMotto", [motto, cb]);
	},
	
	/**
	* Updates the first name for the current user.
	* @name Social.US.User.setFirstName
	* @function
	* @private
	*
	* @param {String} firstName The first name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setFirstName:function(firstName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setFirstName", [firstName, cb]);
	},
	
	/**
	* Updates the last name for the current user.
	* @name Social.US.User.setLastName
	* @function
	* @private
	*
	* @param {String} lastName The last name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setLastName:function(lastName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setLastName", [lastName, cb]);
	},
	

	/**
	* Sets a password for the current user.
	* @name Social.US.User.setPassword
	* @function
	* @private
	*
	* @param {String} password The password for the current user.
    * @param {String} confirmation The password confirmation for the current user.
	* @param {Function} cb The callback function if an error occurs. For example, password does not meet requirements; password and confirmation do not match, and so on.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setPassword:function(password,confirmation, cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setPassword", [password, confirmation, cb]);
	},

	/**
	* Sets whether the target user is in the logged-in user's blocked user list.
	* @name Social.US.User.setBlocked
	* @function
	* @private
	*
	* @param {Social.US.User} user The user that is the subject of blocking or unblocking.
    * @param {Boolean} blocked Whether the current user blocks the specified user. If <code>true</code>, the specified user is blocked.
    	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setBlocked:function(blocked, cb){
		Dispatcher.callMethodOnRemoteObject(this, "setBlocked", [blocked, cb]);
	},
	
	/**
	 * Gets the origin of the user's registration.
	 * Mobage records the origin of a user's registration. The "origin" may be the name of an alliance partner.
	 * The origin is typically used as a means of tracking revenue sharing events, such as the promotional activity 
	 * of an alliance partner that attracts new users to Mobage and thereby entitles the alliance partner 
	 * to share in revenue generated by the application.  
	 *
	 * @name Social.US.User.getOriginOfRegistration
	 * @private
	 * @static
	 * @function
	 *
	 * @param {Function} cb The callback function returns the origin of registration, or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, originOfRegistration){
	 *     if(!originOfRegistration) {
	 *          var errorCode = error.errorCode;
	 *          var errorDesc = error.description;
	 *     } else {
	 *          var origin = originOfRegistration;
	 *     }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getOriginOfRegistration: function(cb) {
		Dispatcher.callMethodOnRemoteObject(this, "getOriginOfRegistration", [cb]);
	}
});

User.GamertagKey = "gamertag";
User.AvatarKey = "badge_id";
User.MottoKey = "motto";
User.RelationKey = "relation";
User.FirstNameKey = "first_name";
User.LastNameKey = "last_name";
User.BirthdateKey = "birth_date";
User.GenderKey = "gender";
User.PrivacyKey = "fullname_privacy";
User.PhotoKey = "photo_url";
User.EmailAddressKey = "email";
User.EmailHashKey = "email_hash";
User.PhoneNumberKey = "phone_number";
User.AgeRangeKey = "age_restricted";
User.SpamKey = "opt_in";

User.PasswordKey = "password";
User.PasswordConfirmKey = "password_confirmation";
User.GamesKey = "games";
User.CapabilitiesKey = "capabilities";
User.NewBuddyKey = "new_buddy";
User.IsMutualFriendKey = "mutual_friends";
User.HidePresenceKey = "hide_presence";
User.OnlyShowFriendNotificationsKey = "friend_only_notification";
User.AllowFriendPostsOnly = "friend_only_wallpost";

User.GamerScoreKey = "gamerscore";
User.LevelNumberKey = "level_position";
User.LevelNameKey = "level_name";
User.CurrentLevelScoreKey = "level_points";
User.NextLevelScoreKey = "level_next_points";

// properties that are not returned in sparse search results
User.NonSparseKeys = [User.PhotoKey, User.EmailAddressKey,
User.EmailHashKey, User.PhoneNumberKey, User.PasswordKey,
User.FirstNameKey, User.LastNameKey, User.PrivacyKey,
User.NewBuddyKey, User.CapabilitiesKey, User.HidePresenceKey,
User.OnlyShowFriendNotificationsKey, User.AllowFriendPostsOnly, User.GamerScoreKey,
User.LevelNumberKey, User.LevelNameKey, User.CurrentLevelScoreKey,
User.NextLevelScoreKey, User.GamesKey];


/**
 * Retrieves the user corresponding to the <code>userID</code> parameter.
 * @name Social.US.User.getUserWithID
 * @static
 * @function
 * 
 * @param {String} userID The ID for the user.
 * @cb {Function} cb The function to call after retrieving the user.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} [error.description] A description of the error.
 * @cb-param {String} [error.errorCode] A code identifying the error type.
 * @cb-param {Social.US.User} user Detailed information about the user.
 * @cb-returns {void}
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
User.getUserWithID = function(userID, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithID", [userID, cb]);
};

/**
 * Retrieves the user corresponding to the <code>gamertag</code> parameter.
 * @name Social.US.User.getUserWithGamertag
 * @static
 * @function
 * 
 * @param {String} gamertag The user's gamertag.
 * @cb {Function} cb The function to call after retrieving the user.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} [error.description] A description of the error.
 * @cb-param {String} [error.errorCode] A code identifying the error type.
 * @cb-param {Social.US.User} user Detailed information about the user.
 * @cb-returns {void}
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
User.getUserWithGamertag = function(gamertag, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithGamertag", [gamertag, cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/ButtonOverlays.js';

var Rect = require("NGCore/Client/UI/ViewGeometry").Rect;

var RouterInited = require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

var MessageEmitter = require("NGCore/Client/Core/MessageEmitter").MessageEmitter;

var Friends = require("NGCore/Client/Social/US/Service/Friends").Friends;
var Profile = require("NGCore/Client/Social/US/Service/Profile").Profile;
var User    = require("NGCore/Client/Social/US/Models/User").User;

/**
 * @class 
 * @name Social.US.Service.ButtonOverlays
 */
exports.ButtonOverlays = {
	/**
	* Displays the "Mobage Community" button.
	*	
	* @name Social.US.Service.ButtonOverlays.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner.
	* @param {Function} callback The callback function if there is an error related to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/   
	showCommunityButton: function(gravity, callback) {
		NgLogD("Public - showCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showCommunityButton"
		};
		
		cmd.gravity = gravity = gravity || [0,0];
		if (( gravity[0] !== 0 && gravity[0] !== 1)
			|| ( gravity[1] !== 0 && gravity[1] !== 1) )
		{
			throw new Error("showCommunityButton: Illegal/Out-of-Bounds parameter: gravity "+JSON.stringify(gravity));
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	* Hides the "Mobage Community" button.
	*
	* @name Social.US.Service.ButtonOverlays.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	hideCommunityButton: function(callback) {
		NgLogD("Public - hideCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideCommunityButton"
		};
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Shows the balance button.
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
	 *
	 * @name Social.US.Service.ButtonOverlays.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
     * @param {String} sourcePage String for the Analytics class to event the originating transacting page.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback, sourcePage) {
		NgLogD("Public - showBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showBalanceButton"
		};
		
		if (rect != undefined) {
			cmd["rect"] = (new Rect(rect)).array(); //Rects Don't travel cleanly.
		} else {
			cmd["rect"] = undefined;
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		if(sourcePage != undefined) {
			cmd["sourcePage"] = sourcePage.toString();
		} else {
			cmd["sourcePage"] = "somewhere_game";
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.US.Service.ButtonOverlays.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		NgLogD("Public - hideBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideBalanceButton"
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Leaderboards'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Leaderboards'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Leaderboards'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/Leaderboards.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class
 * @name Social.US.Service.Leaderboards
 */

exports.Leaderboards = {
	
	/**
	 * Shows the leaderboards.
	 * 
	 * @name Social.US.Service.Leaderboards.showLeaderboards
	 * @function
	 * @public
	 * 
	 * @status un tested
	 */			
	showLeaderboards:function(){
		var cmd = {
			apiURL:"US.Service.Leaderboards.showLeaderboards"
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Service'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Service.js';

var RouterInited = require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

var MessageEmitter = require("NGCore/Client/Core/MessageEmitter").MessageEmitter;

var ButtonOverlays = require("NGCore/Client/Social/US/Service/ButtonOverlays").ButtonOverlays;
var Friends = require("NGCore/Client/Social/US/Service/Friends").Friends;
var Leaderboards = require("NGCore/Client/Social/US/Service/Leaderboards").Leaderboards;
var Profile = require("NGCore/Client/Social/US/Service/Profile").Profile;
var User    = require("NGCore/Client/Social/US/Models/User").User;

/**
 * This interface provides the following social game services:
 * <ul>
 * <li>Balance Button</li>
 * <li>Community Button</li>
 * <li>Friend Picker</li>
 * <li>User Finder</li>
 * <li>User Profile</li>
 * <li>Leaderboard</li>
 * </ul>
 * @class 
 * @name Social.Common.Service
 */
exports.Service = {

	/**
	* Opens the leaderboard screen.
	* Launches stand alone leaderboards over the game service with the games leaderboard data
	* @name Social.Common.Service.showLeaderboards
	* @function
	* @public
	* @returns {void}
	* @status not tested
    */
	showLeaderboards: function() {
		Leaderboards.showLeaderboards();
	},

	
	/**
	* Opens the user finder screen.
	* The user finder provides a way for users to find other users using the following filters:
	* <ul>
	* <li>Suggested Friends</li>
	* <li>Contacts</li> 
	* <li>Requests</li>
	* <li>Search</li>
	* </ul>
	*
	* @name Social.Common.Service.openUserFinder 
	* @function
	* @public
	* @returns {void}
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	openUserFinder: function() {
		Friends.showFindFriends(undefined);
	},

	
	/**
	 * Opens the friend picker.
	 *
	 * @name Social.Common.Service.openFriendPicker 
	 * @function
	 * @public 
	 * 
	 * @param {Number} maxFriendsToSelect The maximum number of friends the user may select.
	 * @cb {Function} callback The function to call after opening the friend picker.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String[]} friendUserIds The user IDs of the friends that were chosen.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	openFriendPicker: function(maxFriendsToSelect, callback) {
		Friends.showFriendPicker(maxFriendsToSelect, function(err, friends){
			var userIDs = [];
			friends = friends || [];
			for(var idx = 0; idx < friends.length; idx++){
				userIDs.push(friends[idx].recordID);
			}
			callback( userIDs );
		});
	},

	
	/**
	 * Opens the specified profile page.
	 *
	 * @name Social.Common.Service.openUserProfile 
	 * @function
	 * @public 
	 * 
	 * @param {String} userId The user ID or gamer name of the profile page to open.
	 * @cb {Function} callback The function to call after opening the profile page.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-returns {void}	 
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	openUserProfile: function(userId, callback) {
		if(typeof userId == "string"){
			// if the userId string contains no non-numeral characters:
			//   parse it into a number
			// else null it out, because it's not a valid userId
			if(userId.match(/[^0-9]/) === null){
				userId = parseInt(userId, 10);
			}else{
				userId = null;
			}
		}
		
		if( !userId ){
			callback({errorCode: 400, description: "userid is invalid"});
		}
		else{
			User.getUserWithID(userId, function(err, user){
				if(err){
					if( err==="Sorry, we can't find anyone with that name." ){
						callback({errorCode: 404, description: err});
					} else {
						callback({errorCode: 500, description: err});
					}
				}else if(!user){
					callback({errorCode: 404, description: "User not found"});
				}else{
					Profile.showUserProfile(user, undefined);
				}
			});
	}
	},


	/**
	 * Displays the <b>Mobage Community</b> button.
	 *	
	 * @name Social.Common.Service.showCommunityButton
	 * @function
	 * @public 
	 * 
	 * @param {UI.ViewGeometry.Gravity} gravity Displays the button in the specified corner. 
	 * <b>Note:</b> Only supported for the US. Japan uses the top-left corner only.
	 * @param {String} theme Displays the theme for the button (for example, "default", "dark", "light"). 
	 * <b>Note:</b> Only supported for Japan. You can specify <code>null</code> for the US region.
	 * @cb {Function} callback The function to call after displaying the Mobage Community button.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-returns {void}
	 * @see UI.ViewGeometry.Gravity
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */           
	showCommunityButton: function(gravity, theme, callback) {
		ButtonOverlays.showCommunityButton(gravity, callback);
	},

	/**
	 * Hides the <b>Mobage Community</b> button.
	 *
	 * @name Social.Common.Service.hideCommunityButton
	 * @function
	 * @public 
	 *	
	 * @cb {Function} callback The function to call after hiding the Mobage Community button.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideCommunityButton: function(callback) {
		ButtonOverlays.hideCommunityButton(callback);
	},

	
	/**
	* A message emitter object for adding a message emitter when inviting a user.
	*
	* @name Social.Common.Service.invitedUserEmitter
	* @field
	* @public
	* @example 
	* Social.Common.Service. ...
	* ... invitedUserEmitter.addListener(
	*			new Core.MessageListener(), 
	*			function(userId){
	*				NgLogD("New Emitter! " + userId);
	*			}
	*		);
	* @returns {void}
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	invitedUserEmitter : new MessageEmitter(),

	
	/**
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
     * The minimum size of the button is:<br/>
     * <ul>
     * <li>10% of height in Landscape, and the absolute minimum size is 150 x 50.</li>
     * <li>6% of height in Portrait, and the absolute minimum size is 150 x 50.</li>
	 * </ul>
	 *
	 * @name Social.Common.Service.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @cb {Function} callback The function to call after showing the balance button.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-returns {void}
	 * @param {String} sourcePage The originating page for the transaction. This value will be
	 *		displayed in your Analytics data.
	 * @see UI.ViewGeometry.Rect
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback, sourcePage) {		
		ButtonOverlays.showBalanceButton(rect, callback, sourcePage);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.Common.Service.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @cb {Function} callback The function to call after hiding the balance button.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		ButtonOverlays.hideBalanceButton(callback);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Analytics.js';

var SessionReq = require("NGCore/Client/Social/US/Data/Session");

/**
 * @private
 * @name Social.Common.Analytics
 * @description Private interface for analytics data
 *
 * TODO: These should be going into the priv interpreter. But need to check with Japan.
 */
exports.Analytics = {
  getUserId: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).recordID;
	}
	return cur_u;
  },
  getUsername: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).gamertag;
	}
	return cur_u;
  },
  getPlatformVersion: function() {
	var cur_sess =	this._getSession(), cur_pver = null;
	if (cur_sess) {
	  cur_pver = cur_sess.platformVersion();
	}
	return cur_pver;
  },
  getServiceId: function() { 
	return "US"; 
  },
  _getSession: function() {
	return SessionReq.Session.getCurrentSession();
  }
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Leaderboard'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Common';
var __filename = 'NGCore/Client/Social/US/Common/Leaderboard.js';

var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

/**
 * @class 
    * @name Social.Common.Leaderboard
 * @description
 * Mobage provides a Common API for updating and retrieving leaderboard information.
 * <br />
 * <code>Leaderboard</code> allows game to configure a collection of leaderboards through the
 * Developer Portal or via HTTP REST endpoints which are then subsequently accessed via this API.
 */
exports.Leaderboard = {

    /**
     * Retrieves information about the specified leaderboard. By default, only a limited amount of
     * information is retrieved. Use the <code>fields</code> parameter to retrieve additional
     * information.
     *
     * @name Social.Common.Leaderboard.getLeaderboard
     * @function
     * @public
     *
     * @param {String} leaderboardId The leaderboard ID of the leaderboard to retrieve.
     * @param {String[]} fields Additional fields to retrieve. For a complete list of available
     *		fields, see the properties of the callback function's <code>Leaderboard</code> parameter. The
     *		required properties of the <code>Leaderboard</code> parameter are retrieved by default.
     * @cb {Function} callback The function to call after retrieving information about the specified leaderboard.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} Leaderboard Information about the requested object.
	 * @cb-param {String} [leaderboard.id] Leaderboard identifier.
	 * @cb-param {String} [leaderboard.appId] The application ID associated with this Leaderboard.
	 * @cb-param {String} [leaderboard.title] The title of the leaderboard.
	 * @cb-param {String} [leaderboard.scoreFormat] The format of the <code>displayValue</code> in this leaderboard.
	 * @cb-param {Number} [leaderboard.scorePrecision] The decimal place value for the <code>displayValue</code> in this leaderboard.
	 * @cb-param {String} [leaderboard.iconUrl] The URL of the leaderboard icon.
	 * @cb-param {Boolean} [leaderboard.allowLowerScore] If true, the leaderboard will allow a user to post
     *      a lower score to this leaderboard.  If false, a user's preexisting higher score will NOT be replaced
     *      by an attempt to post a lower score.  This flag allows the developer to avoid "get and set if lower" logic.
	 * @cb-param {Boolean} [leaderboard.reverse] If true, lower scores are treated as more desirable.
     *      For example, in golf a lower score is more desirable.
	 * @cb-param {Boolean} [leaderboard.archived] Future enhancement field to archive a leaderboard.  Archived
     *      leaderboards will be readable but not writeable.  Currently this field always returns false.
	 * @cb-param {Number} [leaderboard.defaultScore] Default score value given to a user if no score attribute is
     *      specified in previous calls to <code>updateCurrentUserScore</code>.
	 * @cb-param {Date} [leaderboard.published] The date and time when this leaderboard was created.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 * @cb-param {Date} [leaderboard.updated] The date and time when this leaderboard was updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getLeaderboards
	 * @see Social.Common.Leaderboard.getAllLeaderboards
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.getLeaderboard("SanFranciscoGiants",
	 *                              ['id','title','scoreFormat', 'iconUrl'],
	 *                              function(error, leaderboard) {
     *                                  if (error) {
     *                                      // something went wrong
     *                                  }
     *                                  if (leaderboard) {
     *                                      console.log(leaderboard.title);
     *                                  }
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLeaderboard: function(leaderboardId, fields, callback) {
		var cmd = {apiURL:"Common.Leaderboard.getLeaderboard", leaderboardIds:leaderboardId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Retrieves information about the specified leaderboards. By default, only a limited amount of
	 * information is retrieved about each leaderboard. Use the <code>fields</code> parameter to retrieve additional
	 * information.
	 *
	 * @name Social.Common.Leaderboard.getLeaderboards
	 * @function
	 * @public
	 *
	 * @param {String[]} leaderboardIds The leaderboard IDs of the leaderboards to retrieve.  This is provided as an
     *      an array of leaderboard IDs.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>Leaderboard</code> parameter. The
	 *		required properties of the <code>Leaderboard</code> parameter are retrieved by default.
	 * @cb {Function} callback The function to call after retrieving information about the specified leaderboards.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} Leaderboards Information about the requested leaderboard object or array of objects.
	 * @cb-param {String} [leaderboard.id] Leaderboard identifier.
	 * @cb-param {String} [leaderboard.appId] The application ID associated with this Leaderboard.
	 * @cb-param {String} [leaderboard.title] The title of the leaderboard.
	 * @cb-param {String} [leaderboard.scoreFormat] The format of the <code>displayValue</code> in this leaderboard.
	 * @cb-param {Number} [leaderboard.scorePrecision] The decimal place value for the <code>displayValue</code> in this leaderboard.
	 * @cb-param {String} [leaderboard.iconUrl] The URL of the leaderboard icon.
	 * @cb-param {Boolean} [leaderboard.allowLowerScore] If true, the leaderboard will allow a user to post
     *      a lower score to this leaderboard.  If false, a user's preexisting higher score will NOT be replaced
     *      by an attempt to post a lower score.  This flag allows the developer to avoid "get and set if lower" logic.
	 * @cb-param {Boolean} [leaderboard.reverse] If true, lower scores are treated as more desirable.
     *      For example, in golf a lower score is more desirable.
	 * @cb-param {Boolean} [leaderboard.archived] Future enhancement field to archive a leaderboard.  Archived
     *      leaderboards will be readable but not writeable.  Currently this field always returns false.
	 * @cb-param {Number} [leaderboard.defaultScore] Default score value given to a user if no score attribute is
     *      specified in previous calls to <code>updateCurrentUserScore</code>.
	 * @cb-param {Date} [leaderboard.published] The date and time when this leaderboard was created.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 * @cb-param {Date} [leaderboard.updated] The date and time when this leaderboard was updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getLeaderboard
	 * @see Social.Common.Leaderboard.getAllLeaderboards
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.getLeaderboards(["SanFranciscoGiants","TopPlayers"],
	 *                              ['id','title','scoreFormat', 'scorePrecision', 'reverse'],
	 *                              function(error, leaderboards) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  }
     *                                  for (var i in leaderboards) with ({leaderboard: leaderboards[i]}) {
     *                                      // stuff each item into leaderboard local variable
     *                                  }
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    getLeaderboards: function(leaderboardIds, fields, callback) {
		var cmd = {apiURL:"Common.Leaderboard.getLeaderboards", leaderboardIds:leaderboardIds, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Retrieves information about all of the current user's game leaderboards. By default, only a limited amount of
	 * information about each leaderboard is retrieved. Use the <code>fields</code> parameter to retrieve additional
	 * information.
	 *
	 * @name Social.Common.Leaderboard.getAllLeaderboards
	 * @function
	 * @public
	 *
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>Leaderboard</code> parameter. The
	 *		required properties of the <code>Leaderboard</code> parameter are retrieved by default.
	 * @cb {Function} callback The function to call after retrieving information about the specified leaderboards.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} Leaderboards Information about the requested leaderboard object or array of objects.
	 * @cb-param {String} [leaderboard.id] Leaderboard identifier.
	 * @cb-param {String} [leaderboard.appId] The application ID associated with this Leaderboard.
	 * @cb-param {String} [leaderboard.title] The title of the leaderboard.
	 * @cb-param {String} [leaderboard.scoreFormat] The format of the <code>displayValue</code> in this leaderboard.
	 * @cb-param {Number} [leaderboard.scorePrecision] The decimal place value for the <code>displayValue</code> in this leaderboard.
	 * @cb-param {String} [leaderboard.iconUrl] The URL of the leaderboard icon.
	 * @cb-param {Boolean} [leaderboard.allowLowerScore] If true, the leaderboard will allow a user to post
     *      a lower score to this leaderboard.  If false, a user's preexisting higher score will NOT be replaced
     *      by an attempt to post a lower score.  This flag allows the developer to avoid "get and set if lower" logic.
	 * @cb-param {Boolean} [leaderboard.reverse] If true, lower scores are treated as more desirable.
     *      For example, in golf a lower score is more desirable.
	 * @cb-param {Boolean} [leaderboard.archived] Future enhancement field to archive a leaderboard.  Archived
     *      leaderboards will be readable but not writeable.  Currently this field always returns false.
	 * @cb-param {Number} [leaderboard.defaultScore] Default score value given to a user if no score attribute is
     *      specified in previous calls to <code>updateCurrentUserScore</code>.
	 * @cb-param {Date} [leaderboard.published] The date and time when this leaderboard was created.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 * @cb-param {Date} [leaderboard.updated] The date and time when this leaderboard was updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getLeaderboard
	 * @see Social.Common.Leaderboard.getLeaderboards
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.getAllLeaderboards(['id','title','appId', 'defaultScore'],
	 *                              function(error, leaderboards) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  }
     *                                  for (var i in leaderboards) with ({leaderboard: leaderboards[i]}) {
     *                                      // stuff each item into leaderboard local variable
     *                                  }
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    getAllLeaderboards: function(fields, callback) {
		var cmd = {apiURL:"Common.Leaderboard.getAllLeaderboards", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Retrieves information about the top users of a given leaderboard.  An array of <code>Score</code> objects
     * are returned. By default, only a limited amount of information about each user's <code>Score</code>
     * is retrieved. Use the <code>fields</code> parameter to retrieve additional information.
	 *
	 * @name Social.Common.Leaderboard.getTopScoresList
	 * @function
	 * @public
	 *
     * @param {String} leaderboardId The leaderboard ID to fetch top scores from.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>Score</code> parameter. The
	 *		required properties of the <code>Score</code> parameter are retrieved by default.
     * @param {Object} opts Additional request options for the scores to fetch.  Permitted options are:
     *      <code>count</code> The number of records to return.  If no count variable is provided, 50 scores will be fetched.
     *      <code>startIndex</code> The record offset when striding through the leaderboard's records.  Default value is 1
     *      and should be treated as an offset value.
	 * @cb {Function} callback The function to call after retrieving information about the specified scores.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} [Scores] Information about the requested leaderboard's user scores as an array of Score objects.
	 * @cb-param {String} [Score[].userId] User ID for this score record.
	 * @cb-param {Number} [Score[].value] Raw score value for this user.
	 * @cb-param {String} [Score[].displayValue] Formatted score value based upon the formatting rules for the
     *      requested leaderboard.
	 * @cb-param {Number} [Score[].rank] User's numerical rank for their placement in this leaderboard.
	 * @cb-param {Date} [Score[].updated] The date and time when this score was last updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getLeaderboard
	 * @see Social.Common.Leaderboard.getLeaderboards
	 * @see Social.Common.Leaderboard.getAllLeaderboards
	 * @see Social.Common.Leaderboard.getFriendsScoresList
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.getTopScoresList("Top Patriot Fans",
     *                              ['userId','value','displayValue', 'rank'],
     *                              { startIndex:1, count:50 },
	 *                              function(error, scores) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  }
     *                                  var userIds = [];
     *                                  var scoreMap = {};
     *                                  scores.forEach(function(i, score) {
     *                                      userIds.push(score.userId);
     *                                      scoreMap[score.userId] = score;
     *                                  });
     *
     *                                  Social.Common.People.getUsers(userIds, ["id", "nickname", "thumbnailUrl"], function(error, users) {
     *                                      users.forEach(function(i, user) {
     *                                          scoreMap[user.id]["nickname"] = user.nickname;
     *                                          scoreMap[user.id]["thumbnailUrl"] = user.thumbnailUrl;
     *                                      });
     *
     *                                      for (var i in scores) with ({score: scores[i]}) {
     *                                          // insert each score into a local variable
     *                                      }
     *                                  });
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTopScoresList: function(leaderboardId, fields, opts, callback) {
		var cmd = {apiURL:"Common.Leaderboard.getTopScoresList", leaderboardIds:leaderboardId, fields:fields, opts:opts, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Retrieves information about the top scores for the specified user's leaderboards.  Said in another way, this API
     * gets the scores for the given user's specified leaderboard.  An array of <code>Score</code> objects
     * are returned. By default, only a limited amount of information about each user's <code>Score</code>
     * is retrieved. Use the <code>fields</code> parameter to retrieve additional information.
	 *
	 * @name Social.Common.Leaderboard.getFriendsScoresList
	 * @function
	 * @public
	 *
     * @param {String} leaderboardId The leaderboard ID to fetch top scores from.
     * @param {String} userId The user whose leaderboards you're fetching.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>Score</code> parameter. The
	 *		required properties of the <code>Score</code> parameter are retrieved by default.
     * @param {Object} opts Additional request options for the scores to fetch.  Permitted options are:
     *      <code>count</code> The number of records to return.  If no count variable is provided, 50 scores will be fetched.
     *      <code>startIndex</code> The record offset when striding through the leaderboard's records.  Default value is 1
     *      and should be treated as an offset value.
	 * @cb {Function} callback The function to call after retrieving information about the specified scores.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} [Scores] Information about the requested leaderboard's user scores as an array of Score objects.
	 * @cb-param {String} [Score[].userId] User ID for this score record.
	 * @cb-param {Number} [Score[].value] Raw score value for this user.
	 * @cb-param {String} [Score[].displayValue] Formatted score value based upon the formatting rules for the
     *      requested leaderboard.
	 * @cb-param {Number} [Score[].rank] User's numerical rank for their placement in this leaderboard.
	 * @cb-param {Date} [Score[].updated] The date and time when this score was last updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getLeaderboard
	 * @see Social.Common.Leaderboard.getLeaderboards
	 * @see Social.Common.Leaderboard.getAllLeaderboards
	 * @see Social.Common.Leaderboard.getTopScoresList
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.getFriendsScoresList("Top Patriot Fans",
     *                              "coolGamerDude",
     *                              ['userId','value','displayValue', 'rank', 'updated'],
     *                              { startIndex:1, count:50 },
	 *                              function(error, scores) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  }
     *                                  var userIds = [];
     *                                  var scoreMap = {};
     *                                  scores.forEach(function(i, score) {
     *                                      userIds.push(score.userId);
     *                                      scoreMap[score.userId] = score;
     *                                  });
     *
     *                                  Social.Common.People.getUsers(userIds, ["id", "nickname", "thumbnailUrl"], function(error, users) {
     *                                      users.forEach(function(i, user) {
     *                                          scoreMap[user.id]["nickname"] = user.nickname;
     *                                          scoreMap[user.id]["thumbnailUrl"] = user.thumbnailUrl;
     *                                      });
     *
     *                                      for (var i in scores) with ({score: scores[i]}) {
     *                                          // insert each score into a local variable
     *                                      }
     *                                  });
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    getFriendsScoresList: function(leaderboardId, userId, fields, opts, callback) {
		var cmd = {apiURL:"Common.Leaderboard.getFriendsScoresList", leaderboardIds:leaderboardId, userId:userId, fields:fields, opts:opts, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Retrieves top score for the specified user's specified leaderboard.  A single <code>Score</code> object
     * is returned. By default, only a limited amount of information the user's <code>Score</code>
     * is retrieved. Use the <code>fields</code> parameter to retrieve additional information.
	 *
	 * @name Social.Common.Leaderboard.getScore
	 * @function
	 * @public
	 *
     * @param {String} leaderboardId The leaderboard ID to fetch the top score from.
     * @param {String} userId The user whose scores you're fetching.
	 * @param {String[]} fields Additional fields to retrieve. For a complete list of available
	 *		fields, see the properties of the callback function's <code>Score</code> parameter. The
	 *		required properties of the <code>Score</code> parameter are retrieved by default.
	 * @cb {Function} callback The function to call after retrieving information about the specified score.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Object} [Score] Information about the requested leaderboard's user score as a single JSON Object.
	 * @cb-param {String} [Score.userId] User ID for this score record.
	 * @cb-param {Number} [Score.value] Raw score value for this user.
	 * @cb-param {String} [Score.displayValue] Formatted score value based upon the formatting rules for the
     *      requested leaderboard.
	 * @cb-param {Number} [Score.rank] User's numerical rank for their placement in this leaderboard.
	 * @cb-param {Date} [Score.updated] The date and time when this score was last updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getLeaderboard
	 * @see Social.Common.Leaderboard.getLeaderboards
	 * @see Social.Common.Leaderboard.getAllLeaderboards
	 * @see Social.Common.Leaderboard.getTopScoresList
	 * @see Social.Common.Leaderboard.getFriendsScoresList
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.getScore("Boston Red Socks Top Fans",
     *                              "myFriend42",
     *                              ['userId','value','displayValue', 'updated'],
	 *                              function(error, score) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  }
     *                                  if (score) {
     *                                      console.log("user score is: "+score.value);
     *                                  }
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    getScore: function(leaderboardId, userId, fields, callback) {
		var cmd = {apiURL:"Common.Leaderboard.getScore", leaderboardIds:leaderboardId, userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Updates the current user's score in the specified leaderboard.  No additional information is returned.
	 *
	 * @name Social.Common.Leaderboard.updateCurrentUserScore
	 * @function
	 * @public
	 *
     * @param {String} leaderboardId The leaderboard ID in which to update the given user's score.
	 * @param {Number} value Numerical score value to assign to this user.
	 * @cb {Function} callback The function to call after updating information about the specified user.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
     * @cb-param {Object} [Score] The user's updated score object as a single JSON Object.
	 * @cb-param {String} [Score.userId] User ID for this score record.
	 * @cb-param {Number} [Score.value] Raw score value for this user.
	 * @cb-param {String} [Score.displayValue] Formatted score value based upon the formatting rules for the
     *      requested leaderboard.
	 * @cb-param {Number} [Score.rank] User's numerical rank for their placement in this leaderboard.
	 * @cb-param {Date} [Score.updated] The date and time when this score was last updated.
     *      Uses the date format YYYY-MM-DDThh:mm:ss.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.deleteCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.updateCurrentUserScore("BiggestFish", 42, function(error, score) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  } else {
     *                                      // score updated successfully
     *                                  }
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    updateCurrentUserScore: function(leaderboardId, value, callback) {
		var cmd = {apiURL:"Common.Leaderboard.updateCurrentUserScore", leaderboardId:leaderboardId, value:value, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

    /**
	 * Deletes the current user's score in the specified leaderboard.
	 *
	 * @name Social.Common.Leaderboard.deleteCurrentUserScore
	 * @function
	 * @public
	 *
     * @param {String} leaderboardId The leaderboard ID in which to delete the given user's score.
	 * @cb {Function} callback The function to call after updating information about the specified user.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 *
	 * @cb-returns {void}
	 * @see Social.Common.Leaderboard.getScore
	 * @see Social.Common.Leaderboard.updateCurrentUserScore
	 * @example
	 * Social.Common.Leaderboard.deleteCurrentUserScore("BiggestFish", function(error) {
     *                                  if (error) {
     *                                      // error handling code is here
     *                                  } else {
     *                                      // score deleted successfully
     *                                  }
     *                              });
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    deleteCurrentUserScore: function(leaderboardId, callback) {
		var cmd = {apiURL:"Common.Leaderboard.deleteCurrentUserScore", leaderboardIds:leaderboardId, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LocationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/LocationEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class LocationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LocationEmitter.prototype */
{
	classname: 'LocationEmitter',
	
	/**
	 * Enumeration for the desired accuracy of the location measurement.
	 * @fieldOf Device.LocationEmitter#
	 */
	Accuracy:
	{
		/**
		 * Low accuracy. The location that is reported will be within several miles of the actual 
		 * location. This setting minimizes the device's power consumption.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		LOW:    0, // equivalent to "3km"  in iOS
		
		/**
		 * Medium accuracy. The location that is reported will be within roughly 100 yards of the
		 * actual location.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		MEDIUM: 1, // equivalent to "100m" in iOS
		
		/**
		 * High accuracy. The location that is reported will be within a few yards of the actual
		 * location. This setting results in the highest power consumption.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		HIGH:   2  // equivalent to "Best" in iOS
	},
	
	/**
	 * Enumeration to choose which data about the device's location will be sent to the application.
	 * @fieldOf Device.LocationEmitter#
	 */
	Elements:
	{
		/**
		 * Receive latitude data.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		LATITUDE:  1,
		
		/**
		 * Receive longitude data.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		LONGITUDE: 2,
		
		/**
		 * Receive altitude data.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		ALTITUDE:  4,
		
		/**
		 * Receive heading data.
		 * @fieldOf Device.LocationEmitter#
		 * @constant
		 */
		HEADING:   8  // equivalent to "bearing" in Android
	},

	/**
	 * @class The <code>LocationEmitter</code> class constructs a singleton object that sends its
	 * listeners a <code>{@link Device.LocationEmitter.Location}</code> object when the device's
	 * location changes.
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @see Device.LocationEmitter.Location
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._lastLocation = undefined;
		this._forceListeners = [];
		this.elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
	},

	/**
	 * Set the desired accuracy for each update, as well as the information to include in each
	 * update.
	 * @param {LocationEmitter#Accuracy} accuracy Accuracy of updates. The default value is HIGH.
	 * @param {Number} elements OR-ed <code>LocationEmitter.Elements</code>. Example: LATITUDE | LONGITUDE. The default value is LATITUDE | LONGITUDE | ALTITUDE | HEADING (i.e. listens to all elements).
	 * @returns {void}
	 * @status
	 * @since 1.1.1.2
	 */
	setProperties: function(accuracy, elements)
	{
		if (typeof accuracy != 'number') accuracy = this.Accuracy.HIGH;
		if (! elements) elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
		this.accuracy = accuracy;
		this.elements = elements;
		this._setPropertiesSendGen(accuracy,elements);
	},

	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * <br /><br />
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br /><br />
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, false);
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, true, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @cb {Function} func The function to call when a location event occurs.
	 * @cb-param {Device.LocationEmitter.Location} location Information about the device's location.
	 * @cb-returns {void}
	 * @param {Boolean} forceStart Set to <code>true</code> if the application requires location services to function properly.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {Error} The specified listener is already listening to the emitter.
	 * @throws {Error} The specified listener is not an instance of <code>Core.MessageListener</code>.
	 * @see Device.LocationEmitter#removeListener
	 * @see Core.MessageEmitter#emit
	 * @see Core.MessageEmitter#chain
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	addListener: function($super, listener, func, forceStart, priority) {
		if(forceStart === undefined)
		{
			this._startUpdatingSendGen(true);
			this._forceListeners.push(listener);
		}
		else
		{
			this._startUpdatingSendGen(forceStart);
			if(forceStart === true)
				this._forceListeners.push(listener);
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br /><br /> 
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @see Device.LocationEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	removeListener: function($super, listener) {
		$super(listener);

		var index = this._forceListeners.indexOf(listener);
		if(index != -1)
		{
			this._forceListeners.splice(index,1);
			if(this._forceListeners.length === 0)
				this._stopUpdatingSendGen();
		}
	},
    
	/**
	 * Retrieve the last location returned by this <code>LocationEmitter</code>.
	 * @returns {Device.LocationEmitter.Location} The last location returned.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getLastLocation: function()
	{
		if(this._lastLocation === undefined || !this._lastLocation.getPosition()) return undefined;
		
		return this._lastLocation;
	},
	
    _locationUpdatedRecv: function( cmd ) {
		var msg = {};
		if (!this._locationUpdatedRecvGen(cmd, msg))
		    return;

		if (((this.elements & this.Elements.LATITUDE) === 0)  &&
			((this.elements & this.Elements.LONGITUDE) === 0) &&
			((this.Elements & this.Elements.ALTITUDE) === 0))
			return;

		this._lastLocation = new this.Location(
			new Core.Point(msg["latitude"], msg["longitude"]),
			msg["altitude"],
			this._lastLocation ? this._lastLocation.getHeading() : undefined,
			msg["accuracy"],
			msg["timestamp"]);

		this.emit(this._lastLocation);
    },
	
	_headingUpdatedRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._headingUpdatedRecvGen(cmd, msg))
			return;
			
		if ((this.elements & this.Elements.HEADING) === 0)
			return;

		this._lastLocation = new this.Location(
			this._lastLocation ? this._lastLocation.getPosition() : undefined,
			this._lastLocation ? this._lastLocation.getAltitude() : undefined,
			msg['magneticHeading'],
			this._lastLocation ? this._lastLocation.getAccuracy() : undefined,
			msg['timestamp']);
		
		if(msg['magneticHeading']) {
			this.emit(this._lastLocation);
		}
	},
	
	Location: Core.Class.subclass(
	/** @lends Device.LocationEmitter.Location.prototype */
	{
		classname: 'Location',
		
		/**
		 * @class <code>Location</code> constructs objects that encapsulate the location of a device.
		 * <code>Location</code> objects contain spatial components, like position and heading information, and a timestamp that indicates when a location is measured.
		 * 
		 * @constructs The default constructor. 
		 * @param {Core.Point} position The latitude / longitude of the device.
		 * @param {Number} altitude The altitude of the device.
		 * @param {Number} heading The heading of the device.
		 * @param {Number} accuracy The accuracy of the measurement.
		 * @param {Number} timestamp The timestamp when the location was measured.
		 * @augments Core.Class
		 * @since 1.0
		 */
		initialize: function(position, altitude, heading, accuracy, timestamp)
		{
			this._position = position;
			this._altitude = altitude;
			this._accuracy = accuracy;
			this._heading = heading;
			this._timestamp = timestamp;
		},
		
		/**
		 * Return the position of this <code>Location</code> as latitude / longitude.
		 * @returns {Core.Point} The current latitude / longitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Return the altitude of this <code>Location</code> in feet (ft).
		 * @returns {Number} The current altitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getAltitude: function()
		{
			return this._altitude;
		},
		
		/**
		 * Return the heading of this <code>Location</code> in degrees east of north.
		 * @returns {Number} The current heading.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getHeading: function()
		{
			return this._heading;
		},
		
		/**
		 * Return the accuracy of the measurement for this <code>Location</code>.
		 * @returns {Number} The current location accuracy.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getAccuracy: function()
		{
			return this._accuracy;
		},
		
		/**
		 * Return the timestamp when this measurement was taken.
		 * Expressed in milliseconds since Epoch (Unix time).
		 * @returns {Number} The timestamp of the measurement.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getTimestamp: function()
		{
			return this._timestamp;
		}
	}),
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 333,
	// Method create = -1
	// Method destroy = 2
	// Method startUpdatingLocation = 3
	// Method stopUpdatingLocation = 4
	// Method locationUpdated = 5
	// Method startUpdatingHeading = 6
	// Method stopUpdatingHeading = 7
	// Method headingUpdated = 8
	// Method setProperties = 9
	// Method startUpdating = 10
	// Method stopUpdating = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._locationUpdatedRecv( cmd );
					break;
				case 8:
					instance._headingUpdatedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[333] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_locationUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 5 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "latitude" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "latitude" ] === undefined )
		{
			NgLogE("Could not parse latitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "longitude" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "longitude" ] === undefined )
		{
			NgLogE("Could not parse longitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "altitude" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "altitude" ] === undefined )
		{
			NgLogE("Could not parse altitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_headingUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "magneticHeading" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "magneticHeading" ] === undefined )
		{
			NgLogE("Could not parse magneticHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "trueHeading" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "trueHeading" ] === undefined )
		{
			NgLogE("Could not parse trueHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x14dffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14d0002, this );
	},
	
	/** @private */
	_startUpdatingLocationSendGen: function( accuracy, distanceFilter )
	{
		Core.Proc.appendToCommandString( 0x14d0003, this, [ +accuracy, +distanceFilter ] );
	},
	
	/** @private */
	_stopUpdatingLocationSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14d0004, this );
	},
	
	/** @private */
	_locationUpdatedSendGen: function( timestamp, latitude, longitude, altitude, accuracy )
	{
		Core.Proc.appendToCommandString( 0x14d0005, this, [ +timestamp, +latitude, +longitude, +altitude, +accuracy ] );
	},
	
	/** @private */
	_startUpdatingHeadingSendGen: function( orientation, angularFilter )
	{
		Core.Proc.appendToCommandString( 0x14d0006, this, [ +orientation, +angularFilter ] );
	},
	
	/** @private */
	_stopUpdatingHeadingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14d0007, this );
	},
	
	/** @private */
	_headingUpdatedSendGen: function( timestamp, magneticHeading, trueHeading, accuracy )
	{
		Core.Proc.appendToCommandString( 0x14d0008, this, [ +timestamp, +magneticHeading, +trueHeading, +accuracy ] );
	},
	
	/** @private */
	_setPropertiesSendGen: function( accuracy, elements )
	{
		Core.Proc.appendToCommandString( 0x14d0009, this, [ +accuracy, +elements ] );
	},
	
	/** @private */
	_startUpdatingSendGen: function( force )
	{
		Core.Proc.appendToCommandString( 0x14d000a, this, [ ( force ? 1 : 0 ) ] );
	},
	
	/** @private */
	_stopUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14d000b, this );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// startUpdatingLocation: function( accuracy, distanceFilter ) {}
	
	// stopUpdatingLocation: function(  ) {}
	
	// _locationUpdatedRecv: function( cmd ) {}
	// locationUpdated: function( timestamp, latitude, longitude, altitude, accuracy ) {}
	
	// startUpdatingHeading: function( orientation, angularFilter ) {}
	
	// stopUpdatingHeading: function(  ) {}
	
	// _headingUpdatedRecv: function( cmd ) {}
	// headingUpdated: function( timestamp, magneticHeading, trueHeading, accuracy ) {}
	
	// setProperties: function( accuracy, elements ) {}
	
	// startUpdating: function( force ) {}
	
	// stopUpdating: function(  ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/MemoryEmitter.js';

var Core = require('NGCore/Client/Core').Core;

exports.MemoryEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MemoryEmitter.prototype */
{
	classname: 'MemoryEmitter',
		
	/**
	 * @class The <code>MemoryEmitter</code> class constructs a singleton object that notifies its
	 * listeners when a low memory warning is received from the system. The information that is
	 * sent to listeners is configurable and can vary by platform if desired. See
	 * <code>{@link Device.MemoryEmitter#addSummaryStatisticsListener}</code> for details about the
	 * information that can be sent to listeners.<br /><br />
	 * Applications can respond to these notifications by destroying unused objects, allowing the
	 * system to re-allocate free memory. Failure to respond to low memory warnings may cause the
	 * operating system to terminate the application.
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._summaryStatisticsEmitter = null;
		this._summaryStatisticsOption = this.StatisticsOption['common'];
		this._summaryStatisticsInterval = 1000;
	},
	
	_memoryEventRecv: function( cmd ) 
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._memoryEventSendGen();
	},
													  
	/**
	 * Enumeration values for use with {@link Device.MemoryEmitter#setSummaryStatisticsOption}.
	 * @fieldOf Device.MemoryEmitter.prototype
	 */
	StatisticsOption:
	{
		/**
		 * Map iOS and Android platform-specific information to platform-neutral information. See
		 * {@link Device.MemoryEmitter#addSummaryStatisticsListener} for more detail.
		 * @fieldOf Device.MemoryEmitter.prototype
		 * @constant
		 */
		common: 1,

		/**
		 * Provide platform-specific information for iOS and Android. See
		 * {@link Device.MemoryEmitter#addSummaryStatisticsListener} for more detail.
		 * @fieldOf Device.MemoryEmitter.prototype
		 * @constant
		 */
		raw: 2
	},

	/**
	 * Set whether the <code>MemoryEmitter</code> will provide platform-specific information,
	 * platform-neutral information, or both. The default option is 
	 * <code>{@link Device.MemoryEmitter#StatisticsOption.common}</code>.
	 * @example
	 * Device.MemoryEmitter.setSummaryStatisticsOption(Device.MemoryEmitter.
	 *   StatisticsOption.common | Device.MemoryEmitter.StatisticsOption.raw);
	 * @param {Device.MemoryEmitter#StatisticsOption} option The option to use for the
	 *		<code>MemoryEmitter</code>. To select multiple options, you can use the <code>|</code>
	 *		operator to combine multiple values. Use the value <code>0</code> to disable the
	 *		emitter.
	 * @returns {void}
	 * @since 1.4.1
	 */	
	setSummaryStatisticsOption: function( option )
	{
		this._summaryStatisticsOption = option;

		if( this._summaryStatisticsEmitter )
		{
			this._enableSummaryStatisticsSendGen( this._summaryStatisticsOption, this._summaryStatisticsInterval );
		}
	},

	/**
	 * Set the amount of time, in milliseconds, between calls to the callback function. The 
	 * default value is <code>1000</code>.
	 * @param {Number} interval The amount of time, in milliseconds, between calls to the callback
	 *		function.
	 * @returns {void}
	 * @since 1.4.1
	 */	
	setSummaryStatisticsInterval: function( interval )
	{
		this._summaryStatisticsInterval = interval;

		if( this._summaryStatisticsEmitter )
		{
			this._enableSummaryStatisticsSendGen( this._summaryStatisticsOption, this._summaryStatisticsInterval );
		}
	},

	/**
	 * Add a listener for memory statistics. 
	 * @example
	 * var MyListener = Core.MessageListener.subclass({
	 *     myCallback: function(statistics) {
	 *         if (statistics.rawValues.ActivityManager.getMemoryInfo) {
	 *             var info = JSON.stringify(statistics.rawValues.ActivityManager.
	 *               getMemoryInfo);
	 *             console.log("Android info about available memory: " + info);
	 *         }
	 *         if (statistics.totalFreeMemory) {
	 *             console.log("Platform-neutral info about available memory: " +
	 *               statistics.totalFreeMemory);
	 *         }
	 *     }
	 * });
	 * var listener = new MyListener();
	 * 
	 * Device.MemoryEmitter.addSummaryStatisticsListener(listener,
	 *   listener.myCallback);
	 * @param {Object} listener The listener that memory statistics will be sent to.
	 * @cb {Function} callback The function to call when the system sends a low memory warning.
	 * @cb-param {Object} statistics An object containing information about the amount of memory
	 *		that is available. The object's properties will vary depending on what value was
	 *		specified in <code>{@link Device.MemoryEmitter#setSummaryStatisticsOption}</code>. By
	 *		default, Android-only and iOS-only properties are not included.
	 * @cb-param {String} [statistics.rawValues./proc/pid/statm] The contents of 
	 *		<code>/proc/{application pid}/statm</code>. Android-only.
	 * @cb-param {Object} [statistics.rawValues.ActivityManager.getMemoryInfo] The value returned by
	 *		<a href="http://developer.android.com/reference/android/app/ActivityManager.html#getMemoryInfo(android.app.ActivityManager.MemoryInfo)">
	 *		ActivityManager.getMemoryInfo()</a>. Android only.
	 * @cb-param {Object} [statistics.rawValues.ActivityManager.getProcessMemoryInfo] The value
	 *		returned by
	 *		<a href="http://developer.android.com/reference/android/app/ActivityManager.html#getProcessMemoryInfo(int[])">
	 *		ActivityManager.getProcessMemoryInfo()</a>. Android only.
	 * @cb-param {Object} [statistics.rawValues.host_statistics] The value returned by 
	 *		<a href="http://web.mit.edu/darwin/src/modules/xnu/osfmk/man/host_statistics.html">
	 *		host_statistics()</a>. iOS only.
	 * @cb-param {Object} [statistics.rawValues.task_info] The value returned by
	 *		<a href="http://web.mit.edu/darwin/src/modules/xnu/osfmk/man/task_info.html">
	 *		task_info()</a>. iOS only.
	 * @cb-param {Number} [statistics.residentSize] The resident memory size of the process, in
	 *		bytes.
	 * @cb-param {Number} [statistics.totalFreeMemory] The amount of free memory on the device, in
	 *		bytes.
	 * @cb-param {Number} [statistics.virtualSize] The virtual memory size of the process, in bytes.
	 * @cb-returns {void}
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @returns {void}
	 * @see Device.MemoryEmitter#setSummaryStatisticsInterval
	 * @see Device.MemoryEmitter#setSummaryStatisticsOption
	 * @since 1.4.1
	 */	
	addSummaryStatisticsListener: function( listener, callback, priority )
	{
		if( !this._summaryStatisticsEmitter )
		{
			this._summaryStatisticsEmitter = new Core.MessageEmitter();
		}
		this._summaryStatisticsEmitter.addListener( listener, callback, priority );

		if( this._summaryStatisticsEmitter.getListenerCount() == 1 )
		{
			this._enableSummaryStatisticsSendGen( this._summaryStatisticsOption, this._summaryStatisticsInterval );
		}
	},

	/**
	 * Remove a listener for memory statistics.
	 * @param {Object} listener The memory statistics listener to remove.
	 * @returns {void}
	 * @since 1.4.1
	 */	
	removeSummaryStatisticsListener: function( listener )
	{
		if( this._summaryStatisticsEmitter )
		{
			this._summaryStatisticsEmitter.remove( listener );

			if( this._summaryStatisticsEmitter.getListenerCount() === 0 )
			{
				this._enableSummaryStatisticsSendGen( 0, 0 );
				this._summaryStatisticsEmitter = null;
			}
		}
		else
		{
			NgLogD("removeRealtimeSummaryStatisticsListener: memoryEmitter does not exist");
		}
	},

	_statisticsRecv: function( cmd )
	{
		var json, msg = {};
		if( !this._statisticsRecvGen( cmd, msg ))
			return;
	        
		try
		{
			json = JSON.parse( msg.data );
		}
		catch(e)
		{
			NgLogE("_statisticsRecv: error occured while parsing JSON");
			return;
		}		

		if(this._summaryStatisticsEmitter)
		{
			this._summaryStatisticsEmitter.emit( json );
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 331,
	// Method create = -1
	// Method memoryEvent = 2
	// Method enableSummaryStatistics = 3
	// Method statistics = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._memoryEventRecv( cmd );
					break;
				case 4:
					instance._statisticsRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[331] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_memoryEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.memoryEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_statisticsRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.statistics from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in MemoryEmitter.statistics from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x14bffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_memoryEventSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14b0002, this );
	},
	
	/** @private */
	_enableSummaryStatisticsSendGen: function( option, interval )
	{
		Core.Proc.appendToCommandString( 0x14b0003, this, [ +option, +interval ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _memoryEventRecv: function( cmd ) {}
	// memoryEvent: function(  ) {}
	
	// enableSummaryStatistics: function( option, interval ) {}
	
	// _statisticsRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MotionEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/MotionEmitter.js';

var Core = require('NGCore/Client/Core').Core;

exports.MotionEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MotionEmitter.prototype */
{
	classname: 'MotionEmitter',
	
	/**
	 * @class The <code>MotionEmitter</code> class constructs a singleton object that tracks a 
	 * device's movement through 3D space. When the device moves, the <code>MotionEmitter</code>
	 * sends its listeners a <code>{@link Device.MotionEmitter.Motion}</code> object that provides
	 * spatial information about the device.
	 * @singleton
	 * @constructs The default constructor.
	 * @see Device.MotionEmitter.Motion
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastAccel = null;
		this._lastGyro  = null;
		this._lastCompass = null;
	},

	Motion: Core.Class.subclass(
	/** @lends Device.MotionEmitter.Motion.prototype */
	{
		classname: 'Motion',
		
		/**
		 * @class <code>MotionEmitter</code> objects use <code>Motion</code> objects to provide
		 * spatial information about a device's movement. These objects report the information
		 * obtained from the device's accelerometer, gyroscope, and compass instruments during the
		 * most recent event.<br /><br />
		 * <strong>Important</strong>: By default, accelerometer data is returned using the
		 * right-hand rule on iOS and the left-hand rule on Android. To use the right-hand rule on
		 * both platforms, call <code>{@link Device.MotionEmitter#useCommonAccelerometerMode}</code>
		 * before you call <code>{@link Device.MotionEmitter.Motion#getAccelData}</code>.
		 * @constructs The default constructor. 
		 * @param {Object} accel accelerometer data for the device, indexed by "x", "y", and "z".
		 * @param {Object} gyro gyroscope accelerometer data for the device, indexed by "x", "y", and "z".
		 * @param {Object} compass compass data for the device, indexed by "x", "y", and "z".
		 * @see Device.MotionEmitter
		 * @augments Core.Class
		 * @since 1.0
		 */
		initialize: function(accel, gyro, compass)
		{
			this._accel = accel;
			this._gyro  = gyro;
			this._compass = compass;
		},
		
		/**
		 * Retrieve accelerometer data from the device. A call to <code>getAccelData()</code> on a device that contains an accelerometer
		 * returns an object that contains the accelerometer data. In all other cases, calling <code>getAccelData()</code> returns 
		 * <code>undefined</code>. The accelerometer value is based on the default orientation mode and is not affected by orientation
		 * changes.<br /><br />
		 * On iOS, the value is returned using the right-hand rule, and on Android, the value is returned using the left-hand rule.
		 * To make the value consistent across platforms, call <code>{@link Device.MotionEmitter#useCommonAccelerometerMode}</code>
		 * before you call <code>getAccelData()</code>.<br /><br />
		 * <b>Note:</b> Use <code>{@link Core.Capabilities#getHasAccel}</code> to programmatically check a 
		 * device for an accelerometer.
		 * @returns {Object} An object that contains the accelerometer data for the device, indexed by "x", "y", and "z".
		 * @see Core.Capabilities#getHasAccel
		 * @see Device.MotionEmitter#useCommonAccelerometerMode
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getAccelData: function()
		{
			return this._accel;
		},
		
		/**
		 * Retrieve gyroscope data from the device. A call to <code>getGyroData()</code> on a device that contains a gyroscope
		 * returns an object that contains the gyroscope data. In all other cases,
		 * this call returns <code>undefined</code>. <br /><br />
		 * <b>Note:</b> Use <code>{@link Core.Capabilities#getHasGyro}</code> to programmatically check a
		 * device for a gyroscope. 
		 * @returns {Object} An object that contains the gyroscope data for the device, indexed by "x", "y", and "z".
		 * @see Core.Capabilities#getHasGyro
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getGyroData: function()
		{
			return this._gyro;
		},
		
		/**
		 * Retrieve compass data from the device. A call to <code>getCompassData()</code> on a device that contains a magnetic compass
		 * returns an object that contains the compass data. In all other cases,
		 * this call returns <code>undefined</code>.<br /><br />
		 * <b>Note:</b> Use <code>{@link Core.Capabilities#getHasCompass}</code> to programmatically check a device for a compass. 
		 * @returns {Object} An object that contains the compass data for the device, indexed by "x", "y", and "z".
		 * @see Core.Capabilities#getHasCompass
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 * @since 1.0
		 */
		getCompassData: function()
		{
			return this._compass;
		}
	}),

	/**
	 * Register a <code>MessageListener</code> object with the <code>MotionEmitter</code>. If an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameter for the callback function is a <code>Motion</code> object.<br /><br />
	 * <b>Note:</b> Each listener can only listen to an emitter once.<br /><br />
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @cb {Function} func The function to call when a motion event occurs.
	 * @cb-param {Device.MotionEmitter.Motion} motion Information about the motion event.
	 * @cb-returns {void}
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @see Core.MessageEmitter#emit
	 * @see Core.MessageEmitter#chain
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() === 0) {
			// start the Accelerometer if this is the first listener
			this._startMotionSendGen();
		}

		$super(listener, func, priority);
	},

	/**
	 * Remove a <code>MessageListener</code> object from this <code>MotionEmitter</code> object. 
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.	 
	 * @returns {Boolean} Returns <code>true</code> when the registered listener was removed. Returns <code>false</code> in all other cases.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() === 0) {
			// stop the Accelerometer if this is the last listener
			this._stopMotionSendGen();
		}
	},

	_emitMotion: function()
	{
		var motion = new Device.MotionEmitter.Motion(this._lastAccel, this._lastGyro, this._lastCompass);
		this.emit(motion);
	},

	_accelChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._accelChangedRecvGen(cmd, msg))
			return;

		this._lastAccel = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._accelChangedSendGen(msg.x, msg.y, msg.z);
	},

	_gyroChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._gyroChangedRecvGen(cmd, msg))
			return;

		this._lastGyro = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._gyroChangedSendGen(msg.x, msg.y, msg.z);
	},
	
	_magneticChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._magneticChangedRecvGen(cmd, msg))
			return;
		
 		this._lastCompass = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._magneticChangedSendGen(msg.x, msg.y, msg.z);
	},

	/**
	 * Specify whether the <code>MotionEmitter</code> should use the right-hand rule to return 
	 * accelerometer data on both iOS and Android. By default, iOS uses the right-hand rule, and
	 * Android uses the left-hand rule.
	 * @param {Boolean} use Set to <code>true</code> to use the right-hand rule on both iOS and
	 *		Android. Set to <code>false</code> to use the right-hand rule on iOS and the left-hand
	 *		rule on Android.
	 * @returns {void}
	 * @see Device.MotionEmitter.Motion#getAccelData
	 * @since 1.6
	 */
	useCommonAccelerometerMode: function(use) {
		this._useCommonAccelerometerModeSendGen(use);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 330,
	// Method create = -1
	// Method accelChanged = 2
	// Method gyroChanged = 3
	// Method magneticChanged = 4
	// Method startMotion = 5
	// Method stopMotion = 6
	// Method useCommonAccelerometerMode = 7
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._accelChangedRecv( cmd );
					break;
				case 3:
					instance._gyroChangedRecv( cmd );
					break;
				case 4:
					instance._magneticChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[330] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_accelChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_gyroChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_magneticChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x14affff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_accelChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( 0x14a0002, this, [ +x, +y, +z ] );
	},
	
	/** @private */
	_gyroChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( 0x14a0003, this, [ +x, +y, +z ] );
	},
	
	/** @private */
	_magneticChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( 0x14a0004, this, [ +x, +y, +z ] );
	},
	
	/** @private */
	_startMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14a0005, this );
	},
	
	/** @private */
	_stopMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14a0006, this );
	},
	
	/** @private */
	_useCommonAccelerometerModeSendGen: function( use )
	{
		Core.Proc.appendToCommandString( 0x14a0007, this, [ ( use ? 1 : 0 ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _accelChangedRecv: function( cmd ) {}
	// accelChanged: function( x, y, z ) {}
	
	// _gyroChangedRecv: function( cmd ) {}
	// gyroChanged: function( x, y, z ) {}
	
	// _magneticChangedRecv: function( cmd ) {}
	// magneticChanged: function( x, y, z ) {}
	
	// startMotion: function(  ) {}
	
	// stopMotion: function(  ) {}
	
	// useCommonAccelerometerMode: function( use ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/NetworkEmitter.js';

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.NetworkEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NetworkEmitter.prototype */
{
	classname: 'NetworkEmitter',
	
	/**
	 * @class The <code>NetworkEmitter</code> class constructs a singleton object that sends its
	 * listeners a unique value when any of the following changes occur:
	 * <ul>
	 * <li>The device loses access to a network.</li>
	 * <li>The device gains access to a network.</li>
	 * <li>The device switches between cellular and wi-fi network access.</li>
	 * </ul>
	 * The unique value that the listeners receive corresponds to an enumerated value of 
	 * <code>{@link Device.NetworkEmitter#Status}</code>.<br /><br />
	 * In addition, the <code>NetworkEmitter</code> class provides listeners that receive updates on
	 * the number of active HTTP requests, the average data traffic, and the maximum time it is
	 * taking to set up a new HTTP connection.<br /><br />
	 * @singleton
	 * @constructs The default constructor. 
	 * @see Device.NetworkEmitter#Status
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

    this._lastStatus = null;
    this._perfEmitter = null;
    this._connEmitter = null;
    this._minRate = 5*1024;  // B/s
    this._duration = 5000;   // in msec
    this._samples = [];
    this._sum = 0;
    this._unconformFor = 0;
    this._lastSampleAt = 0;
    this._maxConnTime = 5000; // in msec
	},

	/**
	 * Retrieve the network status of the device.
	 * @returns {Device.NetworkEmitter#Status} The current device network status.
	 * @status iOS, Android, Test
	 * @since 1.0
	 */
	getLastStatus: function()
	{
		return this._lastStatus;
	},

	/** 
	 * Enumeration values for device network status.
	 * @fieldOf Device.NetworkEmitter.prototype
	 */
	Status:
	{
		/** 
		* No network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		None: 0,
		
		/** 
		* Cellular network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Cellular: 1,
		
		/** 
		* Wi-Fi network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Wifi: 2
	},

  /** private */
  _flags:
  {
    enable: 0x00000001
  },

  /**
   * Add a listener to monitor the device's network performance and execute a callback function if
   * performance is currently poor.
   * @example
   * Device.NetworkEmitter.addPerformanceListener(perfListener, function(perfStatus) {
   * 	// Set your own thresholds for acceptable performance for your application.
   *	if (perfStatus.actReqs > 10 &amp;&amp; perfStatus.aveRate < 10240) {  // 10 KB/second
   *		// Modify the application's behavior appropriately
   *    }
   * });
   * @param {Core.MessageListener} perfListener Performance listener.
   * @cb {Function} perfCb The function to call when network performance is poor.
   * @cb-param {Object} perfStatus An object containing information about network performance.
   * @cb-param {Number} perfStatus.actReqs The number of active HTTP requests.
   * @cb-param {Number} perfStatus.aveRate The average inbound and outbound data traffic in bytes
   *		per second.
   * @cb-returns {void}
   * @param {Number} [priority=0] The priority for this <code>NetworkListener</code>.
   * @returns {void}
   * @since 1.4
   */
  addPerformanceListener: function(perfListener, perfCb, priority)
  {
    if(!this._perfEmitter)
    {
      this._perfEmitter = new Core.MessageEmitter();
    }

    this._perfEmitter.addListener(perfListener, perfCb, priority);
    NgLogD("addPerformanceListener: count=" + this._perfEmitter.getListenerCount());

    if(this._perfEmitter.getListenerCount() == 1)
    {
      // Tell native to report stats.
      this._enablePerfEmitterSendGen( this._flags['enable'], this._minRate, this._duration );
    }
  },

  /**
   * Remove a listener that is monitoring the device's network performance.
   * @param {Core.MessageListener} perfListener Performance listener to remove.
   * @returns {void}
   * @since 1.4
   */
  removePerformanceListener: function(perfListener)
  {
    if(this._perfEmitter)
    {
      this._perfEmitter.removeListener(perfListener);
      NgLogD("removePerformanceListener: count=" + this._perfEmitter.getListenerCount());

      if(this._perfEmitter.getListenerCount() === 0)
      {
        // Tell native to stop reporting stats.
        this._enablePerfEmitterSendGen( 0, 0, 0 );
        this._perfEmitter = null;
      }
    }
    else
    {
      NgLogD("removePerformanceListener: perf-emitter does not exist");
    }
  },

  /**
   * Retrieve the number of <code>MessageListener</code> objects that have been registered with this
   * <code>NetworkEmitter</code> through <code>addPerformanceListener()</code>.
   * @returns {Number} The number of registered <code>MessageListener</code> objects.
   * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
   * @since 1.4.1
   */
  getPerformanceListenerCount: function() 
  {
    if(this._perfEmitter)
    {
      return this._perfEmitter.getListenerCount();
    }

    return 0;
  },

  /**
   * Add a listener to monitor the time it is taking to set up a new HTTP connection, and to execute
   * a callback function when it is taking an excessively long time to set up a new connection.
   * The listener will receive an event for every network frame until the lingering connection is 
   * established; the lingering connection has timed out; or the listener is removed.
   * @example Device.NetworkEmitter.addConnectionListener(connListener, function(connTime) {...});
   * @param {Core.MessageListener} connListener Connection listener.
   * @cb {Function} connCb The function to call when it is taking an excessively long time to set up
   *		a new HTTP connection.
   * @cb-param {Number} connTime The amount of time, in milliseconds, that it has taken so far to
   *		set up the most delayed network connection.
   * @cb-returns {void}
   * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
   * @returns {void}
   * @since 1.4
   */
  addConnectionListener: function(connListener, connCb, priority)
  {
    if(!this._connEmitter)
    {
      this._connEmitter = new Core.MessageEmitter();
    }

    this._connEmitter.addListener(connListener, connCb, priority);
    NgLogD("addConnectionListener: count=" + this._connEmitter.getListenerCount());

    if(this._connEmitter.getListenerCount() == 1)
    {
      // Tell native to report stats.
      this._enableConnEmitterSendGen( this._flags['enable'], this._maxConnTime );
    }
  },

  /**
   * Remove a connection listener that is monitoring the time it takes to set up a new HTTP 
   * connection.
   * @param {Core.MessageListener} connListener Connection listener to remove.
   * @returns {void}
   * @since 1.4
   */
  removeConnectionListener: function(connListener)
  {
    if(this._connEmitter)
    {
      this._connEmitter.removeListener(connListener);
      NgLogD("removeConnectionListener: count=" + this._connEmitter.getListenerCount());

      if(this._connEmitter.getListenerCount() === 0)
      {
        // Tell native to stop reporting stats.
        this._enableConnEmitterSendGen( 0, 0 );
        this._connEmitter = null;
      }
    }
    else
    {
      NgLogD("removeConnectionListener: already removed");
    }
  },

  /**
   * Retrieve the number of <code>MessageListener</code> objects that have been registered with this
   * <code>NetworkEmitter</code> through <code>addConnectionListener()</code>.
   * @returns {Number} The number of registered <code>MessageListener</code> objects.
   * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
   * @since 1.4.1
   */
  getConnectionListenerCount: function() 
  {
    if(this._connEmitter)
    {
      return this._connEmitter.getListenerCount();
    }

    return 0;
  },

  /**
   * @private
   * Set performance threshold parameters.
   * @param {Object} params Performance threshold parameters. Following parameters are available:
   * <pre>
   *  {
   *    minRate: {Number},  // minimum rate in B/s.
   *    duration: {Number}, // duration in msec for which it waits
   *                        // before emitting event.
   *  }
   * </pre>
   * For example, if minRate = 5*1024 (bytes) and duration = 5000 (msec), a message is emitted
   * in 5 seconds since the actual transmission rate became below the 'minRate'. If the 
   * transmission rate recovers (becomes more than minRate), the duration will be reset.
   * @returns {void}
   */
  setPerformanceThreshold: function(params)
  {
    if(params['minRate'])
    {
      this._minRate = params['minRate'];
    }
    if(params['duration'])
    {
      this._duration = params['duration'];
    }

    if(this._perfEmitter)
    {
      // Tell native that thresholds are updated.
      this._enablePerfEmitterSendGen( this._flags['enable'], this._minRate, this._duration );
    }
  },

  /**
   * @private
   * Set connection threshold parameters.
   * @param {Object} params Connection threshold parameters. Following parameters are available:
   * <pre>
   *  {
   *    maxConnTime: {Number},  // maximum connection setup time in milliseconds.
   *                            // Default is 5000, or 5 seconds.
   *  }
   * </pre>
   * @returns {void}
   */
  setConnectionThreshold: function(params)
  {
    if(params['maxConnTime'])
    {
      this._maxConnTime = params['maxConnTime'];
    }

    if(this._connEmitter)
    {
      // Tell native that thresholds are updated.
      this._enableConnEmitterSendGen( this._flags['enable'], this._maxConnTime );
    }
  },

	_statusChangedRecv: function( cmd )
	{
		var msg = {};
		if (!this._statusChangedRecvGen(cmd, msg))
		    return;

		this._lastStatus = msg['status'];
		this.emit(this._lastStatus);
	},

	_activityRecv: function( cmd )
 {
		var msg = {};
		if (!this._activityRecvGen(cmd, msg))
		    return;

    var actReqs = msg['numActiveReqs'];
    var actConns = msg['numActiveConns'];
    var opens = msg['numOpens'];
    var conns = msg['numConns'];
    var closes = msg['numCloses'];
    var sent = msg['bytesSent'];
    var rcvd = msg['bytesRcvd'];
    var connTime = msg['maxConnTime'];

    var now = Core.Time.getRealTime();

    //NgLogD('NetworkEmitter::_activityRecv: actReqs=' + actReqs + ' actConns=' + actConns + ' opens=' + opens + ' conns=' + conns + ' closes=' + closes + ' sent=' + sent + ' rcvd=' + rcvd + ' connTime=' + connTime);

    // Reset conditions
    // 1) actConns == conn: all new connections, and;
    // 2) !actConns: no connection, and;
    // 3) took more than the 'duration' since the last sampling.
    if(actConns == conns || !actConns)
    {
      if(now - this._lastSampleAt >= this._duration)
      {
        this._samples = [];
        this._sum = 0;
        this._unconformFor = 0;
      }
    }

    if(actConns > 0)
    {
      var latest = 0;
      if(this._samples.length == 150)
      {
        latest = this._samples.shift();
        if(this._sum >= latest)
        {
          this._sum -= latest;
        }
      }

      var dt = Core.Time.getFrameDelta();
      var rate = (sent + rcvd) / (dt / 1000);
      this._samples.push(rate);
      this._sum += rate;
      this._lastSampleAt = now;

      var ave = this._sum / this._samples.length;

      if(ave < this._minRate)
      {
        //NgLogD('NetworkEmitter::_activityRecv: aveRate=' + ave + ' sum=' + this._sum + ' numSamples=' + this._samples.length + ' since=' + this._unconformFor + ' now=' + now + ' deltaT=' + (now - this._unconformFor) + ' hasPerfEmitter=' + (this._perfEmitter? 'yes':'no'));
        this._unconformFor += dt;

        if(this._unconformFor >= this._duration)
        {
          if(this._perfEmitter)
          {
            //NgLogD('NetworkEmitter::_activityRecv: emitting performance event');
            this._unconformFor = 0;
            this._perfEmitter.emit({ actReqs: actReqs, actConns: actConns, aveRate: ave });
          }
        }
      }
      else
      {
        // Now it conforms to the min rate. Reset the timestamp.
        this._unconformFor = 0;
      }
    }

    if(connTime >= this._maxConnTime)
    {
      if(this._connEmitter)
      {
        //NgLogD('NetworkEmitter::_activityRecv: emitting connection event');
        this._connEmitter.emit(connTime);
      }
    }
 },

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 336,
	// Method create = -1
	// Method statusChanged = 2
	// Method activity = 3
	// Method enablePerfEmitter = 4
	// Method enableConnEmitter = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._statusChangedRecv( cmd );
					break;
				case 3:
					instance._activityRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[336] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_statusChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_activityRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 8 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "numActiveReqs" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "numActiveReqs" ] === undefined )
		{
			NgLogE("Could not parse numActiveReqs in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "numActiveConns" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "numActiveConns" ] === undefined )
		{
			NgLogE("Could not parse numActiveConns in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "numOpens" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "numOpens" ] === undefined )
		{
			NgLogE("Could not parse numOpens in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "numConns" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "numConns" ] === undefined )
		{
			NgLogE("Could not parse numConns in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "numCloses" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "numCloses" ] === undefined )
		{
			NgLogE("Could not parse numCloses in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "bytesSent" ] = Core.Proc.parseInt( cmd[ 5 ] );
		if( obj[ "bytesSent" ] === undefined )
		{
			NgLogE("Could not parse bytesSent in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "bytesRcvd" ] = Core.Proc.parseInt( cmd[ 6 ] );
		if( obj[ "bytesRcvd" ] === undefined )
		{
			NgLogE("Could not parse bytesRcvd in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		obj[ "maxConnTime" ] = Core.Proc.parseInt( cmd[ 7 ] );
		if( obj[ "maxConnTime" ] === undefined )
		{
			NgLogE("Could not parse maxConnTime in NetworkEmitter.activity from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x150ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_enablePerfEmitterSendGen: function( flags, minRate, duration )
	{
		Core.Proc.appendToCommandString( 0x1500004, this, [ +flags, +minRate, +duration ] );
	},
	
	/** @private */
	_enableConnEmitterSendGen: function( flags, maxConnTime )
	{
		Core.Proc.appendToCommandString( 0x1500005, this, [ +flags, +maxConnTime ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _statusChangedRecv: function( cmd ) {}
	// _activityRecv: function( cmd ) {}
	// enablePerfEmitter: function( flags, minRate, duration ) {}
	
	// enableConnEmitter: function( flags, maxConnTime ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/ShakeEmitter.js';

var Core = require('NGCore/Client/Core').Core;
var MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;

var ProxyListener = Core.MessageListener.subclass(
{
	onUpdate: function() {}
});

exports.ShakeEmitter = Core.MessageEmitter.singleton(
/** @lends Device.ShakeEmitter.prototype */
{
	classname: 'ShakeEmitter',
		
	/**
	 * @class The <code>ShakeEmitter</code> class constructs a singleton object that sends a message
	 * to its listeners when a user shakes the device.
	 * <br /><br />
	 * In addition, this class provides the method <code>{@link Device.ShakeEmitter#vibrate}</code>,
	 * which causes the device to vibrate briefly.
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._proxyListener = new ProxyListener();
		
	},
	
	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * <br /><br />
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br /><br />
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @cb {Function} func The function to call when the device is shaken.
	 * @cb-returns {void}
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {Error} The specified listener is already listening to the emitter.
	 * @throws {Error} The specified listener is not an instance of <code>Core.MessageListener</code>.
	 * @see Device.ShakeEmitter#removeListener
	 * @see Core.MessageEmitter#emit
	 * @see Core.MessageEmitter#chain
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() === 0) {
			MotionEmitter.addListener(this._proxyListener, function(){});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @see Device.ShakeEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() === 0) {
			MotionEmitter.removeListener(this._proxyListener);
		}
	},
	
	/**
	 * Turn on the device's vibrator briefly.
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.6
	 */
	vibrate: function ()
	{
		this._vibrateSendGen();
	},
    
	_shakeRecv: function( cmd )
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._shakeSendGen();
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 332,
	// Method create = -1
	// Method shake = 2
	// Method vibrate = -3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._shakeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[332] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_shakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ShakeEmitter.shake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x14cffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_shakeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14c0002, this );
	},
	
	/** @private */
	$_vibrateSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14cfffd );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _shakeRecv: function( cmd ) {}
	// shake: function(  ) {}
	
	// $vibrate: function(  ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/KeyEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/KeyEmitter.js';

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

// Private Class Statics
var keyCodeReverseMap = null;

exports.KeyEmitter = Core.MessageEmitter.singleton(
/** @lends Device.KeyEmitter.prototype */
{
	classname: 'KeyEmitter',

	/**
	 * @class The <code>KeyEmitter</code> class constructs a singleton object that sends its
	 * listeners a <code>{@link Device.KeyEmitter.KeyEvent}</code> object when the user presses or
	 * releases a device hardware key.
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @example
	 * var KeyListener = Core.MessageListener.subclass({
	 *   onUpdate: function(keyEvent) {
	 *     // back to the launcher when the back button is pressed
	 *     if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
	 *        this.destroy();
	 *        LGL.runUpdatedGame('/Samples/Launcher');
	 *        return;
	 *     }
	 *
	 *     var text = '';
	 *     switch (keyEvent.type) {
	 *        case Device.KeyEmitter.EventType.onDown:
	 *           text += 'onDown :';
	 *           break;
	 *        case Device.KeyEmitter.EventType.onUp:
	 *           text += 'onUp :';
	 *           break;
	 *     }
	 *
	 *     text += Device.KeyEmitter.keyCodeToSymbol(keyEvent.code);
	 *     console.log(text);
	 *   }
	 * });
	 *
	 * var keyListener = new KeyListener();
	 * Device.KeyEmitter.addListener(keyListener, keyListener.onUpdate);
	 * @status Android, Test, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Convert a keycode into the equivalent human-readable symbol. The keycode to convert is passed in as a parameter.
	 * The following code example illustrates how to convert a keycode into a human-readable symbol.
	 * @param {String} keyCode The keycode to convert.
	 * @example
	 *   var symbol = Device.KeyEmitter.keyCodeToSymbol(0x1d);
	 *   // symbol => 'a'
	 * @returns {String} The keycode as a human-readable symbol.
	 * @status
	 * @since 1.0
	 */
	keyCodeToSymbol: function(keyCode)
	{
		if (!keyCodeReverseMap) {
			keyCodeReverseMap = {};
			for (var codename in this.Keycode) {
				keyCodeReverseMap[this.Keycode[codename]] = codename;
			}
		}
		return keyCodeReverseMap[keyCode] || '';
	},

	KeyEvent: Core.Class.subclass(
	/** @lends Device.KeyEmitter.KeyEvent.prototype */
	{
		classname: 'KeyEvent',

		/**
		 * @class <code>KeyEvent</code> constructs objects that contain the parcel of a keyboard event. 
		 * The keycode of the key that triggered the event is passed in as a parameter.
		 * @constructs The default constructor. 
		 * @augments Core.Class
		 * @param {Device.KeyEmitter.EventType} type The type of the keyboard event.
		 * @param {Integer} modifiers the bit-and of {@link Device.KeyEmitter#Modifier} combination.
		 * @param {Device.KeyEmitter.Keycode} code The actual keycode.
		 * @since 1.0
		 */
		initialize: function(type, modifiers, code)
		{
			this.type      = type;
			this.modifiers = modifiers;
			this.code      = code;
		}
	}),

	_onKeyEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onKeyEventRecvGen(cmd, msg))
			return;

		var keyEvent = new Device.KeyEmitter.KeyEvent(msg.type, msg.modifiers, msg.code);
		
		if(!this.chain(keyEvent)) {
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onKeyEventSendGen(msg.type, msg.modifiers, msg.code);
		}
	},
	
	/** 
	 * Enumeration identifying whether the key was pressed or released.
	 * @name EventType
	 * @fieldOf Device.KeyEmitter#
	 */
	 
	/** 
	 * The key was released.
	 * @name EventType.onUp
	 * @fieldOf Device.KeyEmitter.prototype
	 * @constant
	 */
	
	/** 
	 * The key was pressed.
	 * @name EventType.onDown
	 * @fieldOf Device.KeyEmitter.prototype
	 * @constant
	 */
	
	
	/** 
	 * Enumeration identifying any modifier keys that are being pressed.
	 * @name Modifier
	 * @fieldOf Device.KeyEmitter#
	 * @example
	 * var keyEvent; // emitted from KeyEmitter
	 * if (keyEvent.modifiers &amp; Device.KeyEmitter.Modifier.ALT &amp;&amp; 
	 *     keyEvent.modifiers &amp; Device.KeyEmitter.Modifier.SHIFT) {
	 *     console.log("ALT+SHIFT");
	 * }
	 */
	
	/**
	 * No modifier key is pressed.
	 * @name Modifier.NONE
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	
	/**
	 * The SYMBOL modifier key is pressed.
	 * @name Modifier.SYMBOL
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	
	/**
	 * The ALT modifier key is pressed.
	 * @name Modifier.ALT
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	
	/**
	 * The left ALT modifier key is pressed.
	 * @name Modifier.ALT_LEFT
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	
	/**
	 * The right ALT modifier key is pressed.
	 * @name Modifier.ALT_RIGHT
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/**
	 * The SHIFT modifier key is pressed.
	 * @name Modifier.SHIFT
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/** 
	 * The left SHIFT modifier key is pressed.
	 * @name Modifier.SHIFT_LEFT
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/**
	 * The right SHIFT modifier key is pressed.
	 * @name Modifier.SHIFT_RIGHT
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */


	/** 
	 * Enumeration identifying the key that is pressed.
	 * @name Keycode
	 * @fieldOf Device.KeyEmitter#
	 */
	 
	/**
	 * The a key is pressed.
	 * @name Keycode.a
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	
	/**
	 * The b key is pressed.
	 * @name Keycode.b
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The c key is pressed.
	 * @name Keycode.c
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The d key is pressed.
	 * @name Keycode.d
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The e key is pressed.
	 * @name Keycode.e
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The f key is pressed.
	 * @name Keycode.f
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The g key is pressed.
	 * @name Keycode.g
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The h key is pressed.
	 * @name Keycode.h
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The i key is pressed.
	 * @name Keycode.i
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The j key is pressed.
	 * @name Keycode.j
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The k key is pressed.
	 * @name Keycode.k
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The l key is pressed.
	 * @name Keycode.l
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The m key is pressed.
	 * @name Keycode.m
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The n key is pressed.
	 * @name Keycode.n
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The o key is pressed.
	 * @name Keycode.o
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/**
	 * The p key is pressed.
	 * @name Keycode.p
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The q key is pressed.
	 * @name Keycode.q
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	
	/**
	 * The r key is pressed.
	 * @name Keycode.r
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/**
	 * The s key is pressed.
	 * @name Keycode.s
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/** 
	 * The t key is pressed.
	 * @name Keycode.t
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The u key is pressed.
	 * @name Keycode.u
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The v key is pressed.
	 * @name Keycode.v
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/**
	 * The w key is pressed.
	 * @name Keycode.w
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The x key is pressed.
	 * @name Keycode.x
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The y key is pressed.
	 * @name Keycode.y
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The z key is pressed.
	 * @name Keycode.z
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The Up key is pressed.
	 * @name Keycode.up
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The Down key is pressed.
	 * @name Keycode.down
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The Left key is pressed.
	 * @name Keycode.left
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */
	 
	/**
	 * The Right key is pressed.
	 * @name Keycode.right
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * The Enter key is pressed.
	 * @name Keycode.enter
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/** 
	 * The Backspace key is pressed.
	 * @name Keycode.backspace
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/** 
	 * The Back key is pressed.
	 * @name Keycode.back
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 */

	/**
	 * Special KeyCode to tell MobageService that the back was unhandled by the game, after the
	 * service declined first dibs. Stole MAX_KEYCODE (deprecated constant).
	 * @name Keycode.backunhandled
	 * @fieldOf Device.KeyEmitter#
	 * @constant
	 * @ignore
	 */
	
	/**
	 * The Menu key is pressed.
	 * @name Keycode.menu
	 * @fieldOf Device.KeyEmitter.prototype
	 * @constant
	 */
	

// {{?Wg Generated Code}}
	
	// Enums.
	EventType:
	{ 
		onUp: 0,
		onDown: 1
	},
	
	Modifier:
	{ 
		NONE: 0,
		SYMBOL: 1 << 0,
		ALT: 1 << 1,
		ALT_LEFT: 1 << 2,
		ALT_RIGHT: 1 << 3,
		SHIFT: 1 << 4,
		SHIFT_LEFT: 1 << 5,
		SHIFT_RIGHT: 1 << 6
	},
	
	Keycode:
	{ 
		a: 0x1d,
		b: 0x1e,
		c: 0x1f,
		d: 0x20,
		e: 0x21,
		f: 0x22,
		g: 0x23,
		h: 0x24,
		i: 0x25,
		j: 0x26,
		k: 0x27,
		l: 0x28,
		m: 0x29,
		n: 0x2a,
		o: 0x2b,
		p: 0x2c,
		q: 0x2d,
		r: 0x2e,
		s: 0x2f,
		t: 0x30,
		u: 0x31,
		v: 0x32,
		w: 0x33,
		x: 0x34,
		y: 0x35,
		z: 0x36,
		up: 0x13,
		down: 0x14,
		left: 0x15,
		right: 0x16,
		enter: 0x42,
		backspace: 0x43,
		back: 0x04,
		backunhandled: 0x54,
		menu: 0x52
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 343,
	// Method create = -1
	// Method onKeyEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onKeyEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[343] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onKeyEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "modifiers" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "modifiers" ] === undefined )
		{
			NgLogE("Could not parse modifiers in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x157ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_onKeyEventSendGen: function( type, modifiers, code )
	{
		Core.Proc.appendToCommandString( 0x1570002, this, [ +type, +modifiers, +code ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onKeyEventRecv: function( cmd ) {}
	// onKeyEvent: function( type, modifiers, code ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/_PushNotificationEmitter.js';

var Core = require('NGCore/Client/Core').Core;

/*
	NOTE: 	THIS IS FOR INTERNAL USE ONLY AND WILL BE DEPRECATED IN THE FUTURE.
			DO NOT USE IT IN ANY OF YOUR CODE.
*/

exports.PushNotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.PushNotificationEmitter.prototype */
{
	classname: 'PushNotificationEmitter',
		
	/**
	 * @class Emits when native code recieves a push notification
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPushNotificationRecv: function( cmd )
	{
		var msg = {};
		if (!this._onPushNotificationRecvGen(cmd, msg))
			return;
			
		this._lastMsgPayload = msg.msgPayload;
		
		if(!this.chain(msg.msgPayload))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPushNotificationSendGen(msg.msgPayload);
		}
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 345,
	// Method create = -1
	// Method onPushNotification = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPushNotificationRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[345] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPushNotificationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		obj[ "msgPayload" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "msgPayload" ] === undefined )
		{
			NgLogE("Could not parse msgPayload in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x159ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_onPushNotificationSendGen: function( msgPayload )
	{
		Core.Proc.appendToCommandString( 0x1590002, this, [ Core.Proc.encodeString( msgPayload ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPushNotificationRecv: function( cmd ) {}
	// onPushNotification: function( msgPayload ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/_InAppPurchaseEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchaseEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchaseEmitter = Core.MessageEmitter.singleton(
/** @lends Device.InAppPurchaseEmitter.prototype */
{
	classname: 'InAppPurchaseEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPurchaseEventRecv: function( cmd ) {
		var msg = {};
		if (!this._onPurchaseEventRecvGen(cmd, msg))
			return;
		if(!this.chain(msg.err, msg.data, msg.verificationToken))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPurchaseEventSendGen(msg.err, msg.data, msg.verificationToken);
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 347,
	// Method create = -1
	// Method onPurchaseEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPurchaseEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[347] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPurchaseEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "err" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "err" ] === undefined )
		{
			NgLogE("Could not parse err in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "verificationToken" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "verificationToken" ] === undefined )
		{
			NgLogE("Could not parse verificationToken in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x15bffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_onPurchaseEventSendGen: function( err, data, verificationToken )
	{
		Core.Proc.appendToCommandString( 0x15b0002, this, [ Core.Proc.encodeString( err ), Core.Proc.encodeString( data ), Core.Proc.encodeString( verificationToken ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPurchaseEventRecv: function( cmd ) {}
	// onPurchaseEvent: function( err, data, verificationToken ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/_InAppPurchase.js';

////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchase
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Analytics = require('NGCore/Client/Core/Analytics').Analytics;
var DeviceReq = require('NGCore/Client/Device');
var Localization = require('NGCore/Client/Core/Localization').Localization;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchase = Class.singleton(
/** @lends Device.InAppPurchase.prototype */
{
	classname: 'InAppPurchase',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	initService: function(ordercb, donecb, options) {
        NgLogD("initService called");
		if(this._iapInited) {
            NgLogD("initService has been called");
            return;
        }

		if ((!this._isIOS()) && (!this._isAndroid())) {
			NgLogE("ERROR: Neither Android nor iOS platform, IAP will not work");
			donecb();
			return;
		}

		this._initDonecb = donecb;
		this._initOrdercb = ordercb;

		if(options) {
			var options2 = JSON.parse(options);
			if(options2.service === "boku") {
				this._paymentProvider = "boku";
			}
		}
		if (!this._iapInited) {
			var IAPListener = Core.MessageListener.subclass({
				onPurchaseEvent: this._iapCallback.bind(this)
			});
			
			// Register for Android / iOS IAP callbacks the same way
			this.listener = new IAPListener();
	        DeviceReq.Device.InAppPurchaseEmitter.addListener(
				this.listener, this.listener.onPurchaseEvent);
	    	// listener will be called when purchase state changes
		}
		if (this._isAndroid()) {
			this._iapCallback('morenonces', '', '');
			/*
			 * Gets persisted unfulfilled orders, calls back ordercb for each
			 * unfulfilled order.
			 */
			var self = this;
			Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED, {},
			function(err, currorder) {
                    NgLogD("_iap getting orphaned order callback");
	   			if (currorder) {
					var order = JSON.parse(currorder);
   					// _restoreOrder eventually calls _initService when fully
					// done.
                    NgLogD("_iap restoring order");
					self._restoreOrder(order, options);
				} else {
                    NgLogD("_iap initService 0");
					self._initService(options);
				}
			});
		} else {
			// _isIOS - call _initService directly.  It will call back with
			// orphaned order if any.
                    NgLogD("_iap initService 1");
			this._initService(options);
		}
	},

	launchPurchaseView: function(productID, quantity, purchasecb, failcb, cancelcb, options) {
		if (!this._iapInited) {
            Analytics.reportGameEvent( "MobaIAPInitFailed" );
			NgLogE("ERROR: function initService must be called and its donecb " +
			"called back, before launchPurchaseView may be used.");
			failcb(false, "failed:initservice_not_done");
			return;
		}

		this._currentOrderProductID = productID;

		this._currentOrderCancelcb = cancelcb;
		this._currentOrderFailcb = failcb;
		this._currentOrderPurchasecb = purchasecb;

		// Android IAB currently only supports quantity of 1
		if (quantity !== 1 && this._isAndroid()) {
			failcb(false, "failed:unsupported_quantity");
            Analytics.reportGameEvent( "MobaIAPInvalidQuantity" );
			return;
		}

		if (this._isIOS() || this._isAndroid()) {
	        DeviceReq.Device.InAppPurchase._requestPurchase(productID, quantity, options);
			// Note that _iapCallback will call the *cb callback function(s)
			return;
		}
            
		var capabilities = Core.Capabilities;
        Analytics.reportGameEvent( "MobaIAPUnsupportPlatorm"+capabilities.getPlatformOS() );
		NgLogE('launchPurchaseView failed: only Android and iOS platforms are currently supported.');
		failcb(false, "failed:unsupported_platform");
		return;
	},

    // depreicated function
	pushSingleNonce: function(nonce){
		var noncePool = [];
		noncePool.push(nonce);
		this._fillIABNoncePool(JSON.stringify(noncePool));
	},

	/**
	 * get a product information specified by productId.
	 * @param {String} productId the product ID registered at iTunes connect.
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br /><br />
	 * <pre>function(productData, err)</pre><br />
	 * The <code>productData</code> is an product information like "JPY,115.000000".
	 * When something bad happenes, <code>err</code> is set to the error message. Otherwise, err will be null or undefined.
	 * @status iOS, iOSTested
	 */
	getProductInformation: function(productId, callback) {
		this._getProductInformationCB = callback;
		this._getProductInformationSendGen(productId);
	},

	/**
	 * get product information specified by set of product ids
	 * @param {String} productSet the set ofproduct ID registered at iTunes connect. JSON format: {"items":["sku1", "sku2"]}
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br><br>
	 * <pre>function(productData, err)</pre><br>
	 * The <code>productData</code> is product information like "{"currency":"US", "items":[{"sku":"webgame_test_D", "price":0.99},{"sku":"abc", "price":1.00}]}"
	 * @status iOS, iOSTested
	 */
	getProductSetInfo: function(productSet, callback) {
		this._getProductSetInfoCB = callback;
		this._getProductSetInfoSendGen(productSet);
	},

	/*
	 * For Google IAB, these constants come from
	 * Consts.java in IAB sample code
	 *
	 *	public enum PurchaseState {
     *   PURCHASED,   // User was charged for the order. -- 0
     *   CANCELED,    // The charge failed on the server. -- 1
	 *   REFUNDED;    // User received a refund for the order. -- 2
	 */
	_IAB_PURCHASED: 0,
	_IAB_CANCELED: 1,
	_IAB_REFUNDED: 2,
	_IAB_ORPHANED: "com.ngmoco.in_app_purchase.iab_orphaned_orders",

	_capIsAndroid: undefined,
	_capIsIOS: undefined,

	// at most one outstanding order is supported
	_currentOrderCancelcb : undefined,
	_currentOrderFailcb : undefined,
	_currentOrderProductID : undefined,
    // This flag is used by Google IAB only
	_currentOrderPurchasecb : undefined,

	_initDonecb : undefined,
	_initOrdercb : undefined,
	_iapInited: false,

	_generateIABNonce: function(){
		var timestamp = new Date().getTime();
		var random = Math.floor(Math.random() * 1000);
		var nonce = (timestamp * 1000) + random;
		NgLogD("Generated nonce: " + nonce);
		return nonce;
	},

    // For Android, this function will be called for the following scenarios:
    // 1. First initService after start the game
    // 2. After each IAB purchase
    // 
    // Looks like during restart, if there are un-ack orders, this _iapCallback
    // is being called twice.
    // First, it will be called after the service has been established
    // Second time, it will be alled if there are un-ack order with orders, receipt
    //
    //
    // For iOS
    // Only after IAP purchase
    //
	_iapCallback: function( err, data, verificationToken ) {
        NgLogD("8 _iapCallback with err: "+err + " data: "+data + " verficationToken: "+verificationToken);
		if (err == 'morenonces') {
			var count = 10;
			var noncePool = [];
			while(noncePool.length < count){
				noncePool.push(this._generateIABNonce());
			}
			this._fillIABNoncePool(JSON.stringify(noncePool));
			return true;
		}
		if ((err == 'initdone') || (err == 'initcheckdone')) {
			if (typeof this._initDonecb == 'function') {
				this._iapInited = true;
				this._initDonecb();
                NgLogD("_iap initService Done");
			} else {
				NgLogW("WARN: " + err + " callback with empty donecb");
			}
	        // at most one listener gets iap events
	        return true;
		}
		if (err == 'getProductInformationDone') {
			if (data && data.length > 0) {
				var datajsonp = JSON.parse(data);
				try {
					this._productInformationExtras = JSON.parse(verificationToken);
				} catch (e) {
					NgLogE("Error parsing Product Information");
				}
				
				this._getProductInformationCB(datajsonp.productId);
			} else {
				this._getProductInformationCB('', "no information on this product");
			}
			this._getProductInformationCB = undefined;
			delete this._productInformationExtras;
			return true;
		}
		if (err == 'getProductSetInfoDone') {
			this._getProductSetInfoCB(data);
			this._getProductSetInfoCB = undefined;
			return true;
		}

		var orderId;
		var prodId = "";
	        var datajson, receiptj;
        // There are two scenarios we will get the orders from Google
        // 1. during initService to the Googel market
        // 2. after the initService, user makes purchase.
        // before pop up the Google UI

		if (data && data.length > 0) {
		    datajson = JSON.parse(data);
		    if ((datajson.orders) && (datajson.orders.length > 0)) {
                this._dumpOrderIds(datajson.orders); // for debugging and troubleshooting

                // note: see the NGStoreObserver.m to understand how we contrust this JSON block

                orderId = datajson.orders[0].orderid;

 				if (this._isAndroid() && (!this._currentOrderPurchasecb)) {
					// this callback comes in 'out of band', when user did
					// not attempt a purchase.  This happens on Android
					// when async callbacks are not confirmed due to
					// connectivity issue.  This callback will come in
					// the time when we establish the connection to MarketService
                    // which is when the game restart
					//
                    // we only come to here when we first start the game
                    var order0 = datajson.orders[0];
			        receiptj = {
					    data: data,
					    signature: verificationToken
				    };
				    order0.receipt = JSON.stringify(receiptj);

                    // We overwrite the existing data if there is one
                    // Google will include all the previous un-ack orders in the latest
                    // signData
                     if(!order0.receipt) {
                        Analytics.reportGameEvent("NGNILRECEIPT2");
                     }
                     this._initOrdercb(order0.productId, order0.orderId, order0.receipt);
	                return true;
				}

            }
		}

		if (err && err.length > 0) {
			if (err == 'cancelled') {
				if ((typeof this._currentOrderCancelcb) == 'function') {
					this._currentOrderCancelcb();
					this._currentOrderCancelcb = undefined;
				} else {
                    Analytics.reportGameEvent("MobaIAPERR02");
                }
			} else {
				if (err) {
					NgLogD("DEBUG: iapCallback: got error: " + err);
				} else {
					// _IAB_CANCELED
					NgLogD("DEBUG: iapCallback: got canceled purchaseState.");
				}
				if ((typeof this._currentOrderFailcb) == 'function') {
					this._currentOrderFailcb(false, err);
					this._currentOrderFailcb = undefined;
				} else {
                    Analytics.reportGameEvent("MobaIAPERR01");
                }
			}

	        // at most one listener gets iap events
	        return true;
	    }

		if ((typeof this._currentOrderPurchasecb) == 'function') {
			var receipt = verificationToken;
			if (this._isAndroid()) {
				// on Android, both the data and signature are require_d
				// for verification
				receiptj = {
					data: data,
					signature: verificationToken
				};
				receipt = JSON.stringify(receiptj);
			}
            // prodId is undefined if it is Android.
            // We are OK for this since we never use this prodId on narwhal side anyway.
            // For iOS, we converted to uppercase. SKU is casesensitve. We are OK here. Again it is because
            // we don't use the prodId on the narwhal side.
            // Might be we should just fix the prodId logic
            if(!receipt) {
                Analytics.reportGameEvent("NGNILRECEIPT");
            }
		    this._currentOrderPurchasecb(prodId, orderId, receipt);
			this._currentOrderPurchasecb = undefined;
		} else if ((!this._iapInited) && ((typeof this._initOrdercb) ==
		 			'function')) {
            // KLO - I don't understand how we will get to this flow
			// part of initService flow
            // initOrdercb is pointing to the first function while calling
            // in the Purchase.js DeviceReq.Device.InAppPurchase.initService
		    this._initOrdercb(prodId, orderId, verificationToken);
		} else {
            Analytics.reportGameEvent("MobaIAPERR04");                    
        }
        // at most one listener gets iap events
        return true;
    },

	_isAndroid: function() {
		if (typeof this._capIsAndroid != 'undefined') {
			return this._capIsAndroid;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'android')) {
	        this._capIsAndroid = true;
	    } else {
	        this._capIsAndroid = false;
		}
		return this._capIsAndroid;
	},

	_isIOS: function() {
		if (typeof this._capIsIOS != 'undefined') {
			return this._capIsIOS;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'iphone os')) {
	        this._capIsIOS = true;
	    } else {
	        this._capIsIOS = false;
		}
		return this._capIsIOS;
	},

	_fillIABNoncePool: function(nonces) {
		this._fillIABNoncePoolSendGen(nonces);
	},

    _dumpOrderIds: function(orders) {
        for(var i=0; i < orders.length; i++) {
            var theOrder = orders[i];
            Analytics.reportGameEvent("NGIABRECEIVED", {orderId: theOrder.orderId});
        }
    },

    // deprecated
	_filterSuccessOrders: function(datajson, verificationToken, data) {
		var successOrders = [];
		for (var kdx in datajson.orders) {
			if (datajson.orders[kdx].purchaseState === this._IAB_PURCHASED) {
				var theorder = datajson.orders[kdx];
	            if(this._isAndroid()) {
			        var receiptj = {
					    data: data,
					    signature: verificationToken
				    };
				    theorder.receipt = JSON.stringify(receiptj);
                } else {
                    theorder.verificationToken = verificationToken;
                }
				successOrders.push(theorder);
			} else {
				//Send ACK for non-success orders
                // For success orders, we won't ACK until we get confirm from
                // Bank in the Mobage JS level
                // We don't need to this before because we ack everything 
                // right away in the old Google IAB example
				this._sendOrderProcessedAck(datajson.orders[kdx].notificationId);
				NgLogD("Sending ACK to google for filterorders");
			}
		}
        NgLogD("successOrders length = "+successOrders.length);
		return successOrders;
	},
    // deprecated
	_persistOrphanedOrders: function(successOrders) {
		// add orders to existing list of persisted orders
		Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED, {},
			(function(err, currorders){
				if (currorders && (currorders.length > 0)) {
					var orderlist = JSON.parse(currorders);
                    // append the new orders to the existing orders
					for (var idx in orderlist) {
						var o = orderlist[idx];
                        var foundOrder = false;
                        // If we don't ack the Google callback, it 
                        // will just keep coming back until we ack it.
                        // Therefore, don't add the older to the queue anymore
                        // This O(n^2) performance won't be a problem because
                        // we most likely have 2 - 3 orders in the callback.
                        for(var jdx in successOrders) {
                            var t = successOrders[jdx];
                            if(t.orderId === o.orderId) {
                                foundOrder = true;
                                break;
                            }
                        }
                        if(!foundOrder) {
                            successOrders.push(orderlist[idx]);
                        }
					}
				}
				var content = JSON.stringify(successOrders);
				Storage.KeyValueCache.local.setItem(this._IAB_ORPHANED, content, {},
				function(){
					NgLogD("Orphaned orders added to persistent store: " + content);
					NgLogD("Number of orders: " + successOrders.length);
			    });
			}).bind(this));
	},
	_initService: function(options) {
		if(options) {
            Analytics.reportGameEvent("MobaIAPERR06");
			this._initService2SendGen(options);
		} else {
            NgLogD("_iap calling initServiceSendGen");
			this._initServiceSendGen();
		}
	},

	_requestPurchase: function( sku, quantity, options ) {
		if(options){
			this._requestPurchase2SendGen(sku, quantity, options);
		} else {
			this._requestPurchaseSendGen(sku, quantity);
		}
	},
	
    // Send ACK to Google 
	_sendOrderProcessedAck: function( notificationId, orderId ) {
		NgLogD("sending ACK to Google with orderId: "+orderId);
        Analytics.reportGameEvent("MobaIABACK", {orderId: orderId});
		this._sendOrderProcessedAckSendGen( notificationId );
	},

	/* Deprecated
	 * Given unfulfilled orders, calls back ordercb for each unfulfilled order.
	 * Resets persisted store using removeItem when done, then call
	 * _initService to continue init process.
	 */
	_restoreOrder: function(order, options) {
		var self = this;

        // send the order back to Mobage application layer so it can forward
        // these order to bank
        // initOrdercb is pointing to the first function while calling
        // in the Purchase.js DeviceReq.Device.InAppPurchase.initService
        if(this._isAndroid()) {
		    this._initOrdercb(order.productId, order.orderId, order.receipt, order);
        } else {
		    this._initOrdercb(order.productId, order.orderId, order.verificationToken, order);
        }
		Storage.KeyValueCache.local.removeItem(this._IAB_ORPHANED, {},
			function() {
                NgLogD("_iap removeItem callback");
                    NgLogD("_iap initService 2");
				self._initService(options);
			});
	
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 348,
	// Method create = -1
	// Method initService = 2
	// Method requestPurchase = 3
	// Method fillIABNoncePool = 4
	// Method getProductInformation = 5
	// Method sendOrderProcessedAck = 6
	// Method getProductSetInfo = 7
	// Method initService2 = 8
	// Method requestPurchase2 = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[348] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x15cffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_initServiceSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x15c0002, this );
	},
	
	/** @private */
	_requestPurchaseSendGen: function( sku, quantity )
	{
		Core.Proc.appendToCommandString( 0x15c0003, this, [ Core.Proc.encodeString( sku ), +quantity ] );
	},
	
	/** @private */
	_fillIABNoncePoolSendGen: function( nonces )
	{
		Core.Proc.appendToCommandString( 0x15c0004, this, [ Core.Proc.encodeString( nonces ) ] );
	},
	
	/** @private */
	_getProductInformationSendGen: function( productId )
	{
		Core.Proc.appendToCommandString( 0x15c0005, this, [ Core.Proc.encodeString( productId ) ] );
	},
	
	/** @private */
	_sendOrderProcessedAckSendGen: function( orderId )
	{
		Core.Proc.appendToCommandString( 0x15c0006, this, [ Core.Proc.encodeString( orderId ) ] );
	},
	
	/** @private */
	_getProductSetInfoSendGen: function( skuIds )
	{
		Core.Proc.appendToCommandString( 0x15c0007, this, [ Core.Proc.encodeString( skuIds ) ] );
	},
	
	/** @private */
	_initService2SendGen: function( options )
	{
		Core.Proc.appendToCommandString( 0x15c0008, this, [ Core.Proc.encodeString( options ) ] );
	},
	
	/** @private */
	_requestPurchase2SendGen: function( sku, quantity, options )
	{
		Core.Proc.appendToCommandString( 0x15c0009, this, [ Core.Proc.encodeString( sku ), +quantity, Core.Proc.encodeString( options ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// initService: function(  ) {}
	
	// requestPurchase: function( sku, quantity ) {}
	
	// fillIABNoncePool: function( nonces ) {}
	
	// getProductInformation: function( productId ) {}
	
	// sendOrderProcessedAck: function( orderId ) {}
	
	// getProductSetInfo: function( skuIds ) {}
	
	// initService2: function( options ) {}
	
	// requestPurchase2: function( sku, quantity, options ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/IPCEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/IPCEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class IPCEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Class          = require('NGCore/Client/Core/Class').Class;
var Proc           = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Base64         = require('NGCore/Client/Core/Base64').Base64;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var DownloadFile   = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var Util           = require('NGCore/Client/Network/Util').Util;
var FileSystem     = require('NGCore/Client/Storage/FileSystem').FileSystem;

////////////////////////////////////////////////////////////////////////////////

exports.IPCEmitter = MessageEmitter.singleton(
/** @lends Device.IPCEmitter.prototype */
{

	classname: 'IPCEmitter',

	/**
	 * @class The IPCEmitter class is a singleton that enables an ngCore app to launch another
	 * app on the device, or to switch to that app if it is already running. For example, you can
	 * use this class to launch Google Play (on Android devices) or the App Store (on iOS devices).
	 * <br /><br />
	 * To launch another app, you pass a URL to <code>{@link Device.IPCEmitter#launch}</code>. The
	 * device examines the first part of the URL, then determines whether the device has an app that
	 * can handle the request. For example, on Android devices, a URL that begins with
	 * <code>market://</code> will be handled by the Google Play app. The remainder of the URL will
	 * be passed to the app that is being launched.
	 * <br /><br />
	 * In addition, you can use the method <code>{@link Device.IPCEmitter#canLaunch}</code> to check
	 * whether the device has an app that can handle a URL.
	 * @example
	 * // Require the user to download an updated copy of the app from Google Play.
	 * // NOTE: This example works only on Android. In addition, this example will
	 * // not work correctly in the sandbox environment, because ngCore apps have
	 * // different bundle IDs in the sandbox and production environments.
	 * 
	 * var bundleId = Core.Capabilities.getBundleIdentifier();
	 * var url = "market://details?id=" + bundleId;
	 *
	 * var Updater = Core.Class.singleton({
	 *     classname: "Updater",
	 *
	 *     showToast: function(message) {
	 *         var toast = new UI.Toast({
	 *             text: message
	 *         });
	 *         toast.setOnDisappear(function() {
	 *             toast.destroy();
	 *         });
	 *         toast.show();
	 *     },
	 *
	 *     launch: function() {
	 *         showToast("Update required. Opening Google Play...");
	 *
	 *         // Wait 3 seconds, then launch Google Play.
	 *         setTimeout(function() {
	 *             Device.IPCEmitter.launch(uri, function(error) {
	 *                 if (error) {
	 *                     showToast("Please open Google Play to download the update.");
	 *                 }
	 *             });
	 *         }, 3000);
	 *     }
	 * });
	 *
	 * Updater.update();
	 * @constructs
	 * @augments Core.MessageEmitter
	 * @singleton
	 */
	initialize: function()
	{
		console.log('IPCEmitter.initialize');
		this._callbackID = 0;
		this._callbacks = [];
		
		this._shouldEmitIntents = false;

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Check whether the device has an app that can handle a URL.
	 * @example
	 * var urlToLaunch = "mobagesample://example?test=test";
	 * Device.IPCEmitter.canLaunch(urlToLaunch, function(canLaunch) {
	 *     if (canLaunch) {
	 *         console.log("Launching URL: " + canLaunch);
	 *         Device.IPCEmitter.launch(urlToLaunch, function(error) {
	 *             console.log("An error occurred while launching " + urlToLaunch +
	 *               ": " + error);
	 *         });
	 *     } else {
	 *         console.log("Cannot launch the URL: " + urlToLaunch);
	 *     }
	 * });
	 * @param {String} url A URL to test.
	 * @cb {Function} callback The function to call after checking whether the URL can be launched.
	 * @cb-param {Boolean} canLaunch Set to <code>true</code> if the URL can be launched.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status
	 * @since 1.0
	 */
	canLaunch: function(url, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._canLaunchSendGen(url,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Launch an app that can handle the specified URL, or switch to the app if it is already
	 * running.
	 * @example
	 * var urlToLaunch = "mobagesample://example?test=test";
	 * Device.IPCEmitter.launch(urlToLaunch, function(error) {
	 *     console.log("An error occurred while launching " + urlToLaunch +
	 *       ": " + error);
	 * });
	 * @param {String} url A URL to launch.
	 * @cb {Function} callback The function to call after attempting to launch the URL.
	 * @cb-param {String} error Information about the error, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.0
	 */
	launch: function(url, callback)
	{
		 this._callbacks[this._callbackID] = callback;
		 this._launchSendGen(url,this._callbackID);
		 this._callbackID++;
	},

	launchIntent: function( intent, extras, packageName )
	{
		// Similar to launchService, stash the packageName in extras.
		if (typeof(packageName) == "string")
		{
			if (typeof(extras) == "string")
			{
				extras = JSON.parse(extras);
			}
			extras["packageName"] = packageName;
		}
		if (typeof extras == 'object') {
			extras = JSON.stringify(extras);
		}
		this._launchIntentSendGen(intent, extras);
	},
	
	launchService: function( intent, extras, packageName )
	{
		//This function originally did not take a "packageName" parameter, it was part of the extrasObj.
		//The separate parameter is added to make it a bit more clear that it is necessary to pass in a packageName.
		//Not sure it's going to help though, because we're trying to preserve backwards compatibility here.
		if (typeof(packageName) == "string")
		{
			var extrasObj;
			if (typeof(extras) == "string")
			{
				extrasObj = JSON.parse(extras);
			}
			else
			{
				extrasObj = {};
			}
			extrasObj["packageName"] = packageName;
			extras = JSON.stringify(extrasObj);
		}
		this._launchServiceSendGen(intent,extras);
	},

	/**
	 * Launch a Single Sign-on URL.
	 * @private
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&amp;className=xxx.xxx';
	 * Device.IPCEmitter.launchForSSO(appToLaunch, function(error) {
	 *     label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url The URL to launch. The URL must include the following as part of the query string: packageName=xxxx&amp;className=yyyy.
	 * @cb {Function} callback The function to call after launching the URL.
	 * @cb-param {String} error The error message, if any.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status
	 * @since 1.0
	 */
	launchForSSO: function(url, callback)
	{
		url += '&sso_auth';
		this.launch(url, callback);
	},

	/**
	 * Retrieve an array of signatures for the packageName.
	 * @private
	 * @param {String} packageName packageName is like "com.ngmoco.gamejs"
	 * @cb {Function} callback The function to call after retrieving the signatures.
	 * @cb-param {String[]} signatures An array of signatures.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status Android
	 * @since 1.0
	 */
	getAppSignatures: function(packageName, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getAppSignaturesSendGen(packageName,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Retrieve the package name that invokes this ngCore app.
	 * @private
	 * @cb {Function} callback The function to call after retrieving the package name.
	 * @cb-param {String} packageName The package name.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status Android
	 * @since 1.1.5
	 */
	getCallingPackage: function(callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getCallingPackageSendGen(this._callbackID);
		this._callbackID++;
	},
	
	/**
	 * Determine whether a service is running.
	 * @private
	 * @param {Device.IPCEmitter.Service} serviceEnum The service to query.
	 * @cb {Function} callback The function to call after determining whether the service is
	 *		running.
	 * @cb-param {Boolean} isServiceRunning Set to <code>true</code> if the service is running.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status Android
	 * @since 1.3.1b
	 */
	getIsServiceRunning: function(serviceEnum, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getIsServiceRunningSendGen(serviceEnum, this._callbackID);
		this._callbackID++;
	},


	app: function()
	{
		return this._app;
	},

	App: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'App',

		/**
		 * @class Information about the app.
		 * @ignore
		 */
		initialize: function(sourceAppID, intentURL)
		{
			this._sourceAppID   = sourceAppID;
			this._intentURL     = intentURL;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 * @ignore
		 */
		getID: function()
		{
			return this._sourceAppID;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 * @ignore
		 */
		getURL: function()
		{
			return this._intentURL;
		}
	}),

	Intent: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'Intent',

		/**
		 * @class Information about the app.
		 * @ignore
		 */
		initialize: function(action, extras)
		{
			this._action   = action;
			this._extras   = extras;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 * @ignore
		 */
		getAction: function()
		{
			return this._action;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 * @ignore
		 */
		getExtras: function()
		{
			return this._extras;
		}
	}),

	/**
	 * Create home screen shortcut icon.
	 * @private
	 * @param {String} name Displayed shortcut name
	 * @param {String} url Invoked url when icon clicked.
	 * @param {String} icon_path Local file path that stores icon file.
	 * @returns {void}
	 * @status Android
	 * @since 1.3.1b
	 */
	createShortcut: function( name, url, icon_path )
	{
		this._createShortcutSendGen(name, url, icon_path);
	},

	/**
	 * Create home screen shortcut icon with downloading its image.
	 * @private
	 * @param {String} name Displayed shortcut name.
	 * @param {String} url Invoked url when icon clicked.
	 * @param {String} icon_url Icon image url.
	 * @cb {Function} [callback] The function to call after creating the shortcut icon.
	 * @cb-param {Boolean} hasDownloadError Returns <code>true</code> if there was an error
	 *		downloading the icon.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status Android
	 * @since 1.3.1b
	 */
	createShortcutByIconUrl: function( name, url, icon_url, callback )
	{
                NgLogD("createShortcutByIconUrl called", name, url, icon_url);

                var df = new DownloadFile();
                var filename = 'shortcut_icon_image'+(new Date().getTime());
                var self = this;
                NgLogD("Icon download begin");
		Util.OperationWithRetries(function(failCb, abortCb) {
			df.start(filename, 'GET', icon_url, [], function( statusCode, fileSignature ) {
				NgLogD("Icon download finished status="+statusCode);
				if(statusCode == 200) {
					self.createShortcut( name, url, filename );
					FileSystem.deleteFile( filename, {}, function() {
						if(callback)
							callback(false);
					});
				}
				else if(statusCode == 404)
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					abortCb();
				}
				else
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					failCb();
				}
			});
		},
		function() {
			NgLogE("Unable download icon file");
			if(callback)
				callback(true);
		}, 
		true);
	},

	// ------------------------------------------------------------------
	// private
	//

	/**
	 * invoked from native when the app is resumed back from other app.
	 * @private
	 * @since 1.0
	 */
	_onResumedFromOthers: function (url, sourceAppID)
	{
		this._app = new Device.IPCEmitter.App(sourceAppID, url);
		this.emit(this._app);

		//Cascade the original message back out to native for forwarding
		this._onResumeFromOthersSendGen(url, sourceAppID);
	},
	
	// The game should not call this
	_setEmitIntents: function ( emit ) {
		this._shouldEmitIntents = Boolean(emit);
	},

	_onIntentReceived: function (action, extras)
	{
		console.log("On IntentReceived: " + action + " / " + JSON.stringify(extras));
		if (this._shouldEmitIntents) {
			this.emit( new exports.IPCEmitter.Intent(action, extras) );
		}
	},

	// private
	_canLaunchCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._canLaunchCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_onResumeFromOthersRecv: function(cmd)
	{
		var msg = {};
		if (! this._onResumeFromOthersRecvGen(cmd, msg))
			return;

		this._onResumedFromOthers(msg.url, msg.sourceAppID);
	},

	_launchFailedRecv: function( cmd )
	{
		var msg = {};
		if (! this._launchFailedRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_getAppSignaturesCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getAppSignaturesCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.signatures.split(','));
		}
	},

	_getCallingPackageCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getCallingPackageCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.packageName);
		}
	},
	
	
	_getIsServiceRunningCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getIsServiceRunningCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.running);
		}
	},
	
	_onIntentReceivedRecv: function( cmd )
	{
		var msg = {};
		if (! this._onIntentReceivedRecvGen(cmd, msg))
			return;
		
		this._onIntentReceived( msg.action, JSON.parse(msg.extras, 10) );
	},
	
	/**
	 * Enumeration for services whose status can be queried.
	 * @private
	 * @name Service
	 * @fieldOf Device.IPCEmitter#
	 */
	
	/**
	 * The download provider for the system.
	 * @private
	 * @name Service.SystemDownloadProvider
	 * @fieldOf Device.IPCEmitter#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	Service:
	{ 
		SystemDownloadProvider: 1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 349,
	// Method create = -1
	// Method canLaunch = 2
	// Method launch = 3
	// Method onResumeFromOthers = 4
	// Method launchFailed = 5
	// Method canLaunchCallback = 6
	// Method getAppSignatures = 7
	// Method getAppSignaturesCallback = 8
	// Method getCallingPackage = 9
	// Method getCallingPackageCallback = 10
	// Method launchIntent = 11
	// Method launchService = 12
	// Method onIntentReceived = 13
	// Method getIsServiceRunning = 14
	// Method getIsServiceRunningCallback = 15
	// Method createShortcut = 16
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onResumeFromOthersRecv( cmd );
					break;
				case 5:
					instance._launchFailedRecv( cmd );
					break;
				case 6:
					instance._canLaunchCallbackRecv( cmd );
					break;
				case 8:
					instance._getAppSignaturesCallbackRecv( cmd );
					break;
				case 10:
					instance._getCallingPackageCallbackRecv( cmd );
					break;
				case 13:
					instance._onIntentReceivedRecv( cmd );
					break;
				case 15:
					instance._getIsServiceRunningCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[349] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResumeFromOthersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "sourceAppID" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "sourceAppID" ] === undefined )
		{
			NgLogE("Could not parse sourceAppID in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_launchFailedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_canLaunchCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "canLaunch" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "canLaunch" ] === undefined )
		{
			NgLogE("Could not parse canLaunch in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppSignaturesCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signatures" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signatures" ] === undefined )
		{
			NgLogE("Could not parse signatures in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getCallingPackageCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "packageName" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "packageName" ] === undefined )
		{
			NgLogE("Could not parse packageName in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onIntentReceivedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "action" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "action" ] === undefined )
		{
			NgLogE("Could not parse action in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "extras" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "extras" ] === undefined )
		{
			NgLogE("Could not parse extras in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getIsServiceRunningCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "running" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "running" ] === undefined )
		{
			NgLogE("Could not parse running in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x15dffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_canLaunchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( 0x15d0002, this, [ Core.Proc.encodeString( url ), +callbackID ] );
	},
	
	/** @private */
	_launchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( 0x15d0003, this, [ Core.Proc.encodeString( url ), +callbackID ] );
	},
	
	/** @private */
	_onResumeFromOthersSendGen: function( url, sourceAppID )
	{
		Core.Proc.appendToCommandString( 0x15d0004, this, [ Core.Proc.encodeString( url ), Core.Proc.encodeString( sourceAppID ) ] );
	},
	
	/** @private */
	_getAppSignaturesSendGen: function( packageName, callbackID )
	{
		Core.Proc.appendToCommandString( 0x15d0007, this, [ Core.Proc.encodeString( packageName ), +callbackID ] );
	},
	
	/** @private */
	_getCallingPackageSendGen: function( callbackID )
	{
		Core.Proc.appendToCommandString( 0x15d0009, this, [ +callbackID ] );
	},
	
	/** @private */
	_launchIntentSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( 0x15d000b, this, [ Core.Proc.encodeString( intent ), Core.Proc.encodeString( extras ) ] );
	},
	
	/** @private */
	_launchServiceSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( 0x15d000c, this, [ Core.Proc.encodeString( intent ), Core.Proc.encodeString( extras ) ] );
	},
	
	/** @private */
	_getIsServiceRunningSendGen: function( serviceEnum, callbackID )
	{
		Core.Proc.appendToCommandString( 0x15d000e, this, [ +serviceEnum, +callbackID ] );
	},
	
	/** @private */
	_createShortcutSendGen: function( name, url, icon_path )
	{
		Core.Proc.appendToCommandString( 0x15d0010, this, [ Core.Proc.encodeString( name ), Core.Proc.encodeString( url ), Core.Proc.encodeString( icon_path ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// canLaunch: function( url, callbackID ) {}
	
	// launch: function( url, callbackID ) {}
	
	// _onResumeFromOthersRecv: function( cmd ) {}
	// onResumeFromOthers: function( url, sourceAppID ) {}
	
	// _launchFailedRecv: function( cmd ) {}
	// _canLaunchCallbackRecv: function( cmd ) {}
	// getAppSignatures: function( packageName, callbackID ) {}
	
	// _getAppSignaturesCallbackRecv: function( cmd ) {}
	// getCallingPackage: function( callbackID ) {}
	
	// _getCallingPackageCallbackRecv: function( cmd ) {}
	// launchIntent: function( intent, extras ) {}
	
	// launchService: function( intent, extras ) {}
	
	// _onIntentReceivedRecv: function( cmd ) {}
	// getIsServiceRunning: function( serviceEnum, callbackID ) {}
	
	// _getIsServiceRunningCallbackRecv: function( cmd ) {}
	// createShortcut: function( name, url, icon_path ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/LayoutEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class LayoutEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

var _window = null;

////////////////////////////////////////////////////////////////////////////////

exports.LayoutEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LayoutEmitter.prototype */
{
	classname: 'LayoutEmitter',
	
	/**
	 * @class The <code>LayoutEmitter</code> class constructs a singleton that sends an object to
	 * its listeners when the size of the display's usable portion is changing. The object has
	 * <code>width</code> and <code>height</code> properties representing the width and height, in
	 * logical units, of the display's usable portion. To determine how many pixels the device uses
	 * per logical unit, call <code>{@link Core.Capabilities#getScreenPixelUnits}</code>.
	 * @singleton
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @since 1.1.1.2
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_layoutChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._layoutChangedRecvGen(cmd, msg))
			return;

		this.setWidthAndHeight(msg.width, msg.height);
		
 		//NgLogD("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++JS received width as :"+ this._width + " and height as :" + this._height); 
		this.emit(msg);
		this._layoutChangedSendGen(msg.width, msg.height);
	},
	
	/**
	 * Retrieve the width of the usable portion of the display, in logical units, from the last 
	 * known event. To determine how many pixels the device uses per logical unit, call
	 * <code>{@link Core.Capabilities#getScreenPixelUnits}</code>.
	 * @name Device.LayoutEmitter.getWidth
	 * @function
	 * @static
	 * @returns {Number} The width of the usable portion of the display, in logical units.
	 * @since 1.4.1
	 */
	$getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Retrieve the height of the usable portion of the display, in logical units, from the last
	 * known event. To determine how many pixels the device uses per logical unit, call
	 * <code>{@link Core.Capabilities#getScreenPixelUnits}</code>.
	 * @name Device.LayoutEmitter.getHeight
	 * @function
	 * @static
	 * @returns {Number} The height of the usable portion of the display, in logical units.
	 * @since 1.4.1
	 */
	$getHeight: function()
	{
		return this._height;
	},
	
	$_setWindow: function(UIWindow) {
		_window = UIWindow;
	},
	
	/**
	 * @private
	 */
	setWidthAndHeight: function(width, height) {
		//NgLogD("---------------------------------Setting width and height for LayoutEmitter directly from native ......... width is " + width + " and height is " + height );
		this._width = width;
		this._height = height;
		if (_window) {
			_window._setWidthAndHeight(width, height);
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 352,
	// Method create = -1
	// Method layoutChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._layoutChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[352] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_layoutChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x160ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_layoutChangedSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( 0x1600002, this, [ +width, +height ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _layoutChangedRecv: function( cmd ) {}
	// layoutChanged: function( width, height ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_LocalNotification'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_LocalNotification'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_LocalNotification'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/_LocalNotification.js';

////////////////////////////////////////////////////////////////////////////////
// Class LocalNotification
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Core = require ('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocalNotification = Core.MessageEmitter.singleton(
/** @lends Device.LocalNotification.prototype */
{
	classname: 'LocalNotification',
	
	/**
	 * @class The Device.LocalNotification object is used to interact with the local notification system of the device.
	 * With this class you can schedule, cancel, listen for notifications, and know if the game was launched from a notification.
	 *  
	 * @constructs The default constructor.
	 * @arguments Core.Class
	 */
	initialize: function()
	{
		this._callbackIndexCounter = 1;
		this._callbacks = [];
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * showLocalNotification is called with JSON options.  Currently, these
	 * JSON options are supported: {
	 * openurl : "mobage-ww-mobageBoot://mobageBoot/1/ServiceUI/Catalog",
	 * aps : {
	 *    alert: "Text to show in notification area"
	 *  }
	 * // optional, Android-only, string tag to control how the notifications
	 * // are stacked in the tray
	 * tag : "tray_tag_1"
	 * }
	 *    
	 * The game cannot invoke this function.
	 *
	 * @param options - json options to describe how to show local notification
	 * @private
	 */
	showLocalNotification: function( options ) {
		this._showLocalNotificationSendGen(options);
	},
	
	/**
	 * Schedule a local notification with JSON options. Currently, these JSON options are supported:
	 * var options = {
	 *   aps : {
	 *    alert: "Text to show in notification area"
	 *   },
	 *   //notification will be scheduled for the next delayTime milliseconds
	 *   delayTime : 10000, 
	 *   // optional, Android-only, string tag to control how the notifications are stacked in the tray
	 *   tag : "tray_tag_1",
	 *   // optional, an id that belongs to the game logic. It can be used to identify the notification.
	 *   gameId: my_game_logic_id
	 * }
	 * @example:
	 * //a notification that will be fired in 15 minutes.
	 * 
	 * var options: {
	 *   aps: {
	 *     alert: "Your blue item is ready!"
	 *   },
	 *   delayTime: 1000*60*15,
	 *   tag: "my_game",
	 *   gameId: "blue_item_" + blueItem.id,
	 * }
	 * Device.LocalNotification.schedule(options,function(notifSysId){
	 *    this._notifications[options.gameId] = id;
	 * }.bind(this));
	 * 
	 * @argument options - json options to describe how to show local notification.
	 * @argument {Function} callback called when the notification is scheduled. The system id of the scheduled notification is passed as an argument. A negative value will be given if the notification couldn't be scheduled.
	 * @status iOS, Android
	 */
	schedule: function( options, callback )
	{
		if (!(callback instanceof Function)) {
			throw new Error('LocalNotification.schedule requires a callback function, given: ' + callback);
		}
		if (!options.delayTime) {
			throw new Error('LocalNotification.schedule requires a delayTime given in options');
		}
			
		if (!options.aps.alert) {
			throw new Error('LocalNotification.schedule requires an aps.alert given in options');
		}
			
		var id = 0;
		if (callback) {
			id = this._callbackIndexCounter++;
			this._callbacks[id] = callback;
		}
		
		this._scheduleSendGen(id, options);
	},
	
	_scheduleCommandCbRecv: function( cmd )
	{
		var msg = {};
		if (!this._scheduleCommandCbRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("_scheduleCommandCbRecv command : No registered callback found, id = " + id);
			return;
		}
		
		delete this._callbacks[id];
		cb(msg.id);
	},
	
	/**
	 * Cancel a previously scheduled notification.
	 * 
	 * @example:
	 * Device.LocalNotification.cancel(31);
	 * 
	 * @argument {Number} id - notification system id to be removed.
	 * @status iOS, Android
	 */
	cancel: function( id ) {
		this._cancelSendGen(id);
	},
	
	/**
	 * Cancel all the scheduled local notifications.
	 * @example: Device.LocalNotification.cancelAll();
	 * @status iOS, Android
	 */
	cancelAll: function() {
		this._cancelAllSendGen();
	},
	
	/**
	 * Returns an object with all the scheduled notifications.
	 * @example:
	 * Device.LocalNotification.getAllScheduled(function(notifications){
	 *   for (var notifId in notifications) {
	 *     console.log("notificationId: " + notifId + ", notificationGameId: " + notifications[notifId]);
	 *   }
	 * }.bind(this));
	 * @argument {Function} callback called with the notifications object as only argument. The object structure is: {sysId1: gameId1, sysId2: gameId2}. An empty object will be given if there is no scheduled notifications.
	 * @status iOS, Android
	 */
	getAllScheduled: function(callback) {
		if (!(callback instanceof Function)) {
			throw new Error('LocalNotification.getAllScheduled requires a callback function, given: ' + callback);
		}
		
		var callbackId = 0;
		if (callback) {
			callbackId = this._callbackIndexCounter++;
			this._callbacks[callbackId] = callback;
		}
		
		this._getAllScheduledSendGen(callbackId);
	},
	
	_getAllScheduledCommandCbRecv: function( cmd )
	{
		var msg = {};
		if (!this._getAllScheduledCommandCbRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("LocalNotificaton._getAllScheduledCommandCbRecv command : No registered callback found, id = " + id);
			return;
		}
		
		delete this._callbacks[id];		
		cb(msg.response);
	},
	
	/**
	 * Retrieves the last notification info that was used to launch or bring to front the game.
	 * @example:
	 * Device.LocalNotification.retrieveLauncherInfo(function(notification){
	 *   if (notification) {
	 *     console.log("Game was launched or brought to front with notification: notificationId: " + notification.id + ", notificationGameId: " + notification.gameId);
	 *   }
	 * }.bind(this));
	 * @argument {Function} callback called with the notification object or null. The object structure is: {id: sysId, gameId: gameId}.
	 */
	retrieveLauncherInfo: function( callback )
	{
		if (!(callback instanceof Function)) {
			throw new Error('LocalNotification.retrieveLauncherInfo requires a callback function, given: ' + callback);
		}
		
		var callbackId = 0;
		if (callback) {
			callbackId = this._callbackIndexCounter++;
			this._callbacks[callbackId] = callback;
		}
		
		this._retrieveLauncherInfoSendGen(callbackId);
	},
	
	_retrieveLauncherInfoCommandCbRecv: function( cmd )
	{
		var msg = {};
		if (!this._retrieveLauncherInfoCommandCbRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;

		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("LocalNotificaton._retrieveLauncherInfoCommandCbRecv command : No registered callback found, id = " + id);
			return;
		}

		delete this._callbacks[id];		
		cb(msg.response);
	},

    _onNotificationEventRecv: function( cmd )
    {
        var msg = {};
        if (!this._onNotificationEventRecvGen(cmd, msg)) {
            return;
        }

        this.emit(msg.info);
    },
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 354,
	// Method create = -1
	// Method destroy = 2
	// Method showLocalNotification = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalNotification._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalNotification._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[354] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x162ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1620002, this );
	},
	
	/** @private */
	_showLocalNotificationSendGen: function( options )
	{
		Core.Proc.appendToCommandString( 0x1620003, this, [ Core.Proc.encodeObject( options ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// showLocalNotification: function( options ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_UsageStats'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_UsageStats'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_UsageStats'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/_UsageStats.js';

////////////////////////////////////////////////////////////////////////////////
// Class UsageStats
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.UsageStats = Class.singleton(
/** @lends Device.UsageStats.prototype */
{
	classname: 'UsageStats',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.requests = {};
		this.cbIdCounter = 1;

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

	},
	
	getData: function( callback )
	{
		var cbId = this.cbIdCounter++;
		this.requests[cbId] = callback;
		this._getDataSendGen( cbId );
	},
	
	_getDataCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._getDataCbRecvGen( cmd, msg ))
			return;
		
		var cbId = msg.callbackId;
		var data = msg.data;

		if ( !cbId )
		{
			NgLogE ( "UsageStats.getData: No cbId" );
			return;
		}

		var cb = this.requests[ cbId ];

		if ( !cb )
		{
			NgLogE ( "UsageStats.getData:: No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.requests[ cbId ];
		try
		{
			cb ( JSON.parse(data) );
		}
		catch(e)
		{
			NgLogE( "UsageStats.getData: exception has occured while parsing JSON" );
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 356,
	// Method create = -1
	// Method getData = 2
	// Method getDataCb = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._getDataCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UsageStats._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UsageStats._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[356] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getDataCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in UsageStats.getDataCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in UsageStats.getDataCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in UsageStats.getDataCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x164ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_getDataSendGen: function( callbackId )
	{
		Core.Proc.appendToCommandString( 0x1640002, this, [ +callbackId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// getData: function( callbackId ) {}
	
	// _getDataCbRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NotificationEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/NotificationEmitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class NotificationEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////
var TAG = "Device.NotificationEmitter";
exports.NotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NotificationEmitter.prototype */
{
	classname: 'NotificationEmitter',
	
	/**
	 * Retrieve a notification that was received before the app started. For example, if the app is
	 * not running, and the user taps a remote notification for your app, the app will launch; your
	 * app must then call <code>getPendingNotification()</code> to retrieve the notification
	 * payload.
	 * <br /><br />
	 * If there is no pending notification, or if the app has already called this method, the method
	 * will return <code>undefined</code>.
	 * <br /><br />
	 * <strong>Important</strong>: Call this method during your app's startup process.
	 * @name Device.NotificationEmitter.getPendingNotification
	 * @function
	 * @static
	 * @returns {Object} The payload for the pending notification, with the same properties as the
	 *		<code>payload</code> parameter to
	 *		<code>{@link Device.NotificationEmitter#scheduleLocal}</code>, or <code>undefined</code>
	 *		if there is no pending notification.
	 * @since 1.7
	 */
	
	$getPendingNotification: function() {
		var notification = Core.Capabilities._getPendingNotification();
		if (notification) {
			notification = this._adjustFormat(notification);
		}
		return notification;
	},
	
	/**
	 * @class <code>Device.NotificationEmitter</code> uses the native notification mechanisms on 
     * Android and iOS to allow scheduling local notifications (ex: scheduling the notification,
     * "Your crops are now ready" for 6 hours in the future) 
     * or to receive application-specific notifications and payload data from local and remote 
     * sources (ex: "John moved Rook to Queen Bishop 4. It's your move!").
     * <br/><br/>
	 * When the app starts, it must call
	 * <code>{@link Device.NotificationEmitter.getPendingNotification}</code>, which retrieves a
	 * notification that was received before the app started. To receive notifications while the app
	 * is running, call <code>{@link Device.NotificationEmitter#addListener}</code> to add a 
	 * listener to the notification emitter.
	 * <br/><br/>
     * In addition, applications can use the method <code>{@link Device.NotificationEmitter#scheduleLocal}</code>
     * to schedule <em>local</em> notifications. For sending remote notifications, 
     * applications should use <code>{@link Social.Common.RemoteNotification.send}.</code><br/><br/>
     *
	 * As you develop your app, keep the following limitations in mind:
	 *
	 * <ul><li>Remote notifications may take a long time to arrive, and there is no guarantee that users
	 * will receive them.</li>
	 * <li>If a user dismisses the notification, rather than tapping on it, the payload will not
	 * be delivered to the app.</li>
	 * <li>If an app sends multiple remote notifications, the user may receive only the most recent
	 * notification.</li></ul>
	 * 
	 *
	 * <strong>Important</strong>: Do not use push notifications to provide features that require reliable
	 * messaging, such as delivery of a virtual item.<br/><br/>
	 *
	 * @constructs The default constructor
	 * @augments Core.MessageEmitter
	 * @singleton
	 * @since 1.7
	 */
	initialize: function()
	{
		this._callbackIndexCounter = 1;
		this._callbacks = {};
		this._payloadKeys = {"message":true,"badge":true,"sound":true,"collapseKey":true,"style":true,"iconUrl":true,"extras":true};
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

    /*
     * //Full Payload
	 * var payload = {
	 *   message: "Your blue item is ready!",
	 *   collapseKey: "my_game",	                // Only supported on Android
	 *   style: "normal",	                        // Only supported on Android
	 *   iconUrl: "internal/path/to/resource.png",	// Only supported on Android
	 *   badge: 3,	                                // Only supported on iOS
	 *   sound: "trumpets.caf",	                // Only supported on iOS
	 *   extras: {itemId: blueItem.id, itemType: "blue_item"}
	 * };    
    */
    	
	/**
	 * Schedule a local notification for some time in the future.<br/><br/>
	 *
	 * If you choose to pass a badge number in your payload, be sure to clear it appropriately
	 * by using {@link Device.NotificationEmitter#setAppBadgeCount}.
     *
	 * @example
	 * // A notification that will be fired in 15 minutes.
	 * 
	 * var payload = {
	 *   message: "Your blue item is ready!",
	 *   collapseKey: "my_game",	                        // Only supported on Android
	 *   style: "normal",	                                // Only supported on Android
	 *   iconUrl: "http://www.domain.com/notification.png",	// Only supported on Android
	 *   badge: 3,	                                        // Only supported on iOS
	 *   sound: "default",
	 *   extras: {itemId: blueItem.id, itemType: "blue_item"}
	 * };
	 * 
	 * var fireTime = (new Date().getTime() / 1000) + 15 * 60;
	 * 
	 * Device.NotificationEmitter.scheduleLocal(payload,fireTime,function(error,notification) {
	 *    if (error) {
	 *       console.log("Couldn't schedule the notification. Error: %s, code: %d", error.description, error.code);
	 *    } else {
	 *       console.log("Notification with message: %s, scheduled with systemId: %d", notification.payload.message, notification.id);
	 *    }
	 *    
	 * });
	 * 
	 * @param {Object} payload json options to describe how to show local notification.
	 * @param {String} payload.message The message that will be displayed to the user upon delivery of the notification. This is displayed by the native OS and delivered in the payload to the application.
	 * @param {String} payload.collapseKey This key is used by Android to group notifications. All notifications with the same collapseKey will be shown in the Notifications Window as one notification.
	 * @param {String} payload.style Determines the size of the icon in the Android Notifications Window. Options are <code>normal</code> and <code>largeIcon</code>.
	 * @param {String} payload.iconUrl A URL to an image file to use as an icon for this notification. This should be a network accessible URL.
	 * @param {Number} payload.badge iOS only. The number to display on the icon badge when viewing the application icon on the iOS home screen.
	 * @param {String} payload.sound Android only. Specifies whether to play a sound with the notification. 
	 * Possible values are <code>""</code> (no sound) or <code>"default"</code>.
	 * @param {Object} payload.extras A user-defined object that can be used to pass proprietary information.
	 * @param {Date or Number} time Time to fire the notification, as a Javascript Date or Unix Timestamp (seconds since the epoch).
	 * @cb {Function} callback called when the notification is scheduled.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {Object} notification Information about the notification that was scheduled.
	 * @cb-param {String} notification.id A unique ID for the notification.
	 * @cb-param {Object} notification.payload The payload for the notification, using the same
	 *		properties as the method's <code>payload</code> parameter.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.7
	 */
	scheduleLocal: function (payload,time,callback) {
		if (typeof callback != "function") {
			throw new Error(TAG + ".scheduleLocal: requires a callback function, given: " + callback);
		}
		if (!payload.message) {
			callback({code:-1,description:TAG + ".scheduleLocal: requires payload.message"});
			return;
		}
		
		if (time instanceof Date) {
			time = time.getTime() / 1000;
		}
			
		var cid = this._callbackIndexCounter++;
		this._callbacks[cid] = callback;
		
		this._scheduleSendGen(payload, ~~time ,cid);
	},
	
	_scheduleCbRecv: function( cmd )
	{
		var msg = {};
		if (!this._scheduleCbRecvGen(cmd, msg)) {
			return;
		}

		var cid = msg.callbackId;
		
		var cb = this._callbacks[cid];
		if (!cb) {
			NgLogE(TAG + "._scheduleCbRecv command : No registered callback found, id = " + cid);
			return;
		}
		
		delete this._callbacks[cid];
		cb(null,msg.notification);
	},
	
	/**
	 * Cancel a previously scheduled notification.
	 * 
	 * @example
	 * Device.NotificationEmitter.cancelScheduled(scheduledNotificationId);
	 * 
	 * @param {String} id An ID returned by a previous NotificationEmitter.schedule call.
	 * @returns {void}
	 * @since 1.7
	 */
	cancelScheduled: function( id ) {
		this._cancelScheduledSendGen(id);
	},
	
	/**
	 * Cancel all the scheduled local notifications.
	 * 
	 * @example
	 * Device.NotificationEmitter.cancelAllScheduled();
	 * @returns {void}
	 * @since 1.7
	 */
	cancelAllScheduled: function() {
		this._cancelAllScheduledSendGen();
	},
	
	/**
	 * Returns an array of all currently scheduled notifications.
	 * @example
	 * // Return format:
	 * {
	 *     "type":0,
	 *     "id":"notificationId", 
	 *     "payload":{ 
	 *         "message":"You did a thing! Claim your prize!"
	 *     }, 
	 *     "time":1332461937 
	 * }, 
	 * {
	 *     "type":0,
	 *     "id":"notificationId", 
	 *     ...
	 * }
	 * 
	 * @example
	 * Device.NotificationEmitter.getAllScheduled(function(notifications){
	 *   for (var i = 0; i < notifications.length; i++) {
	 *     var notification = notifications[i];
	 *     console.log("Notification %s will fire at time %s with payload %s", 
	 *                     notification.id, 
	 *                     notification.time, 
	 *                     JSON.stringify(notification.payload));
	 *   }
	 * });
	 * 
	 * @cb {Function} callback The function to call after retrieving the currently scheduled
	 *		notifications.
	 * @cb-param {Object[]} notifications An array of notifications. An empty array will be returned if no notifications are scheduled.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.7
	 */
	getAllScheduled: function(callback) {
		var cid = this._callbackIndexCounter++;
		this._callbacks[cid] = callback;
		
		this._getAllScheduledSendGen(cid);
	},
	
	_getAllScheduledCbRecv: function( cmd )
	{
		var msg = {};
		if (!this._getAllScheduledCbRecvGen(cmd, msg)) {
			return;
		}

		var cid = msg.callbackId;
		
		var cb = this._callbacks[cid];
		if (!cb) {
			NgLogE(TAG + "._getAllScheduledCbRecvGen command : No registered callback found, id = " + cid);
			return;
		}
		
		delete this._callbacks[cid];		
		cb(msg.notifications);
	},
	
	/**
	 * Adds a listener to receive notifications that arrive when the app is in the foreground. The
	 * listener will receive a <code>notification</code> object with the following properties:
	 * <ul>
	 * <li><code>notification.clicked</code>: Set to <code>true</code> if the user tapped the
	 * notification.</li>
	 * <li><code>notification.payload</code>: An object with the same properties that can be used
	 * in the <code>payload</code> parameter to
	 * <code>{@link Device.NotificationEmitter#scheduleLocal}</code>.</li>
	 * <li><code>notification.type</code>: The type of notification. Contains an enumerated value of
	 * <code>{@link Device.NotificationEmitter#Type}</code>.</li>
	 * </ul>
	 * @example
	 * Device.NotificationEmitter.addListener(new Core.MessageListener(), function(notification) {
	 *   if (notification.type == Device.NotificationEmitter.Type.Local) {
	 *      console.log("Local notification received. Notification message: " + notification.payload.message);
	 *   } else if (notification.type == Device.NotificationEmitter.Type.Remote) {
	 *      console.log("Remote notification received. Notification message: " + notification.payload.message);
	 *   } else {
	 *      console.log("Unknown type: " + notification.type);
	 *      return false;
	 *   }
	 *   return true;
	 * });
	 * @name Device.NotificationEmitter#addListener
	 * @function
	 * @param {Core.MessageListener} listener The <code>{@link Core.MessageListener}</code> object
	 *		that will listen to the emitter.
	 * @cb {Function} callback The function to call when the notification emitter is triggered. See
	 *		See the method description for details about the parameter that the callback will
	 *		receive.
	 * @cb-returns {Boolean} Set to <code>true</code> to halt propagation of the message to other
	 *		listeners or <code>false</code> to allow the message to propagate.
	 * @returns {void}
	 * @since 1.7
	 */

	 /*
	 * 	{notification} All keys defined by the notification spec in @link NotificationEmitter.schedule
	 * 	{notification.type} A Device.NotificationEmitter.Type enum, typically Local or Remote.
	 * 	{notification.clicked} Boolean. True if the system showed the user the notification, and the user decided to take action. If this bit is set, the application must perform the action described by the notification.
	 */
	addListener: function ($super, listener, callback){
		$super(listener,callback);
	},
	
    /**
     * Enumerated values for notification types.
     * @name Type
     * @fieldOf Device.NotificationEmitter#
     */
    
    /**
     * Local notification.
     * @name Type.Local
     * @fieldOf Device.NotificationEmitter#
     * @constant
     */
    
    /**
     * Remote notification.
     * @name Type.Remote
     * @fieldOf Device.NotificationEmitter#
     * @constant
     */


	/**
	 * Retrieves the current app badge count. 
	 * <br/><br/>
	 * This method is supported only on iOS. Calling this method on Android has no effect.
	 * 
	 * @example
	 * Device.NotificationEmitter.getAppBadgeCount( function(error, count) {} );
	 * 
	 * @cb {Function} callback The callback to be called with the current app badge.
	 * @cb-param {Object} error An error, if any.
	 * @cb-param {Number} badgeCount The current application icon badge count.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.7
	 */
	getAppBadgeCount: function(callback) {
		var cid = this._callbackIndexCounter++;
		this._callbacks[cid] = callback;
		
		this._getAppBadgeCountSendGen(cid);
	},
	
	_getAppBadgeCountCbRecv: function (cmd) {
		var msg = {};
		if (!this._getAppBadgeCountCbRecvGen(cmd, msg)) {
			return;
		}
		
		var cid = msg.callbackId;
		
		var cb = this._callbacks[cid];
		if (!cb) {
			NgLogE(TAG + "._getAppBadgeCountCbRecv command : No registered callback found, id = " + cid);
			return;
		}
		
		delete this._callbacks[cid];
		if (msg.error) {
			cb(JSON.parse(msg.error));
		} else {
			cb(null,msg.count);
		}
		
	},
	
	/**
	 * Set the badge count on the application's icon.
	 * <br/><br/>
	 * This method is supported only on iOS. Calling this method on Android has no effect.
	 * 
	 * @example
	 * Device.NotificationEmitter.setAppBadgeCount(1);
	 * 
	 * @param {Number} count The badge count.
	 * @returns {void}
	 * @since 1.7
	 */
	setAppBadgeCount: function(count) {
		this._setAppBadgeCountSendGen(count);
	},
	
	_notificationOccurredRecv: function( cmd )
	{
		var msg = {};
		if (!this._notificationOccurredRecvGen(cmd, msg))
			return;
		
		var notification = this._adjustFormat(JSON.parse(msg.notification));
		
		if(!this.chain(notification)) {
			//No one handled this event. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._notificationOccurredSendGen(msg.notification);
		}
		
	},
	
	_adjustFormat: function (notification) {
		//only remote require_s adjustment
		if (notification.type != Device.NotificationEmitter.Type.Remote) {
			return notification;
		}
		
		if (notification.message) {
			//Android
			return this._adjustC2DM(notification);
		} else if (notification.aps) {
			//iOS
			return this._adjustAPN(notification);
		} else {
			//Don't know, return it as it comes
			return notification;
		}
	},
	
	_adjustC2DM: function (notification) {
		//populate the payload
    	var payload = {};
		for (var key in notification) {
			var opaqueOvalue = notification[key];
			if (key in this._payloadKeys) {
				if (key == "extras" && typeof opaqueOvalue == "string") {
					var value = opaqueOvalue;
					if (value !== "") {
						payload[key] = JSON.parse(decodeURIComponent(value));
					} else {
						payload[key] = null;
					}
				} else {
					payload[key] = opaqueOvalue;
				}
			}
		}
		
		notification.payload = payload;
		return notification;
	},
	
	_adjustAPN: function (notification) {
		var payload = {};
		notification.payload = payload;
		var x = notification.x;
		
		notification.id = x[1];
		notification.senderId = x[2];
		if(typeof x[3] == "string" && x[3] !== "") {
			try {
				payload.extras =  JSON.parse(x[3]);
			} catch(e) {
				NgLogE("Unable to parse payload json: "+e);
				payload.extras = null;
			}
		} else {
			payload.extras = null;
		}
		notification.published = x[4];
		
		//populate the payload
		var aps = notification.aps;
		payload.message = aps.alert;
		payload.badge = aps.badge;
		payload.sound = aps.sound;

		return notification;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Type:
	{ 
		Local: 0,
		Remote: 1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 366,
	// Method create = -1
	// Method schedule = 2
	// Method scheduleCb = 3
	// Method getAllScheduled = 4
	// Method getAllScheduledCb = 5
	// Method cancelScheduled = 6
	// Method cancelAllScheduled = 7
	// Method getAppBadgeCount = 8
	// Method getAppBadgeCountCb = 9
	// Method setAppBadgeCount = 10
	// Method notificationOccurred = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._scheduleCbRecv( cmd );
					break;
				case 5:
					instance._getAllScheduledCbRecv( cmd );
					break;
				case 9:
					instance._getAppBadgeCountCbRecv( cmd );
					break;
				case 11:
					instance._notificationOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[366] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_scheduleCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in NotificationEmitter.scheduleCb from command: " + cmd );
			return false;
		}
		
		obj[ "notification" ] = Core.Proc.parseObject( cmd[ 0 ] );
		if( obj[ "notification" ] === undefined )
		{
			NgLogE("Could not parse notification in NotificationEmitter.scheduleCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in NotificationEmitter.scheduleCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAllScheduledCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in NotificationEmitter.getAllScheduledCb from command: " + cmd );
			return false;
		}
		
		obj[ "notifications" ] = Core.Proc.parseObject( cmd[ 0 ] );
		if( obj[ "notifications" ] === undefined )
		{
			NgLogE("Could not parse notifications in NotificationEmitter.getAllScheduledCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in NotificationEmitter.getAllScheduledCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppBadgeCountCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in NotificationEmitter.getAppBadgeCountCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in NotificationEmitter.getAppBadgeCountCb from command: " + cmd );
			return false;
		}
		
		obj[ "count" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "count" ] === undefined )
		{
			NgLogE("Could not parse count in NotificationEmitter.getAppBadgeCountCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in NotificationEmitter.getAppBadgeCountCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_notificationOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NotificationEmitter.notificationOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "notification" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "notification" ] === undefined )
		{
			NgLogE("Could not parse notification in NotificationEmitter.notificationOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x16effff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_scheduleSendGen: function( payload, time, callbackId )
	{
		Core.Proc.appendToCommandString( 0x16e0002, this, [ Core.Proc.encodeObject( payload ), +time, +callbackId ] );
	},
	
	/** @private */
	_getAllScheduledSendGen: function( callbackId )
	{
		Core.Proc.appendToCommandString( 0x16e0004, this, [ +callbackId ] );
	},
	
	/** @private */
	_cancelScheduledSendGen: function( id )
	{
		Core.Proc.appendToCommandString( 0x16e0006, this, [ Core.Proc.encodeString( id ) ] );
	},
	
	/** @private */
	_cancelAllScheduledSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x16e0007, this );
	},
	
	/** @private */
	_getAppBadgeCountSendGen: function( callbackId )
	{
		Core.Proc.appendToCommandString( 0x16e0008, this, [ +callbackId ] );
	},
	
	/** @private */
	_setAppBadgeCountSendGen: function( count )
	{
		Core.Proc.appendToCommandString( 0x16e000a, this, [ +count ] );
	},
	
	/** @private */
	_notificationOccurredSendGen: function( notification )
	{
		Core.Proc.appendToCommandString( 0x16e000b, this, [ Core.Proc.encodeString( notification ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// schedule: function( payload, time, callbackId ) {}
	
	// _scheduleCbRecv: function( cmd ) {}
	// getAllScheduled: function( callbackId ) {}
	
	// _getAllScheduledCbRecv: function( cmd ) {}
	// cancelScheduled: function( id ) {}
	
	// cancelAllScheduled: function(  ) {}
	
	// getAppBadgeCount: function( callbackId ) {}
	
	// _getAppBadgeCountCbRecv: function( cmd ) {}
	// setAppBadgeCount: function( count ) {}
	
	// _notificationOccurredRecv: function( cmd ) {}
	// notificationOccurred: function( notification ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// Device diagnostic emitter; collects info from Device subsystem.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

//
// Create and export a DiagnosticEmitter for Device.
//

exports.Diagnostics = Core.DiagnosticEmitter.singleton(
{
	classname: 'Device_Diagnostics',

	/**
	 * @class The <code>Device.Diagnostics</code> class provides detailed diagnostic information
	 * about the device's memory usage, orientation, and screen size. You can use this information
	 * to debug your app and learn more about the app's performance.
	 * <br /><br />
	 * The emitter emits an object of the form:
	 * <br /><br />
	 * <pre>
	 * {
	 *     name: "Device",                          // The emitter's name
	 *     mem_info: {
	 *         totalFreeMemory: {Number},           // Total free memory, in bytes
	 *         virtualSize: {Number},               // Virtual memory size of the process, in bytes
	 *         residentSize: {Number}               // Resident memory size of the process, in bytes
	 *     },
	 *     interface_orientation: {Orientation},    // Current interface orientation
	 *     device_orientation: {Orientation},       // Current device orientation
	 *     layout: {Number[]}                       // The usable screen width and height
	 * }
	 * </pre>
	 * The <code>Orientation</code> type contains one of the following strings:
	 * <br /><br />
	 * <ul>
	 * <li><code>FaceDown</code>: Oriented with the face of the device down. Used only on iOS.</li>
	 * <li><code>FaceUp</code>: Oriented with the face of the device up. Used only on iOS.</li>
	 * <li><code>LandscapeLeft</code>: Landscape orientation with the top of the device to the
	 * left.</li>
	 * <li><code>LandscapeRight</code>: Landscape orientation with the top of the device to the
	 * right. Used only on iOS and on Android 2.3 and later.</li>
	 * <li><code>Portrait</code>: Portrait orientation.</li>
	 * <li><code>PortraitUpsideDown</code>: Portrait orientation, but rotated 180 degrees. Used only
	 * on iOS and on Android 2.3 and later.</li>
	 * <li><code>Unknown</code>: Orientation could not be determined.</li>
	 * </ul>
	 * @name Device.Diagnostics
	 * @constructs
	 * @augments Core.DiagnosticEmitter
	 * @singleton
	 * @since 1.8
	 */
	initialize: function($super)
	{
	$super('Device');
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Device'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Device.js';

/**
 * <p>Classes and objects contained by the Device module.</p>
 * @name Device
 * @namespace Capture a device's location, movement, and user input.
 * @description <p>The Device module is a collection of classes that support the effect of physical movement on a device.
 * Each class instantiates a device singleton that emits when specific device conditions are met:</p>
 *<ul>
 *<li><code>{@link Device.Diagnostics}</code>: A singleton object that provides diagnostic information about the device.</li>
 *<li><code>{@link Device.KeyEmitter}</code>: A singleton object for emitting when the user presses or releases a device hardware key.</li>
 *<li><code>{@link Device.LayoutEmitter}</code>: A singleton object for emitting when the size of the display's usable portion is changing.</li>
 *<li><code>{@link Device.LifecycleEmitter}</code>: A singleton object for emitting when device lifecycle events occur.</li>
 *<li><code>{@link Device.LocationEmitter}</code>: A singleton object for emitting the geographic location of a device.</li>
 *<li><code>{@link Device.MemoryEmitter}</code>: A singleton object for emitting when low-memory states occur on a device.</li>
 *<li><code>{@link Device.MotionEmitter}</code>: A singleton object for emitting objects that collect spatial data from a device.</li>
 *<li><code>{@link Device.NetworkEmitter}</code>: A singleton object for emitting when a change in network status occurs for a device.</li>
 *<li><code>{@link Device.NotificationEmitter}</code>: A singleton object for retrieving notifications and scheduling local notifications.</li>
 *<li><code>{@link Device.OrientationEmitter}</code>: A singleton object for emitting when a change to the physical orientation of the device occurs.</li>
 *<li><code>{@link Device.ShakeEmitter}</code>: A singleton object for emitting when the device detects a shake gesture.</li>
 *</ul>
 */
function DeviceLoader(map) {
	this.add = function(key, toEval) {
		this.__defineGetter__(key, function() {
			delete this[key];
			return this[key] = toEval();
		});
	};
	for (var k in map) {
		if (map.hasOwnProperty(k)) this.add(k, map[k]);
	}
}

exports.Device = new DeviceLoader({
	'LifecycleEmitter': function() { return require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter; },
	'LocationEmitter': function() { return require('NGCore/Client/Device/LocationEmitter').LocationEmitter; },
	'MemoryEmitter': function() { return require('NGCore/Client/Device/MemoryEmitter').MemoryEmitter; },
	'MotionEmitter': function() { return require('NGCore/Client/Device/MotionEmitter').MotionEmitter; },
	'NetworkEmitter': function() { return require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter; },
	'OrientationEmitter': function() { return require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter; },
	'ShakeEmitter': function() { return require('NGCore/Client/Device/ShakeEmitter').ShakeEmitter; },
	'KeyEmitter': function() { return require('NGCore/Client/Device/KeyEmitter').KeyEmitter; },
	'PushNotificationEmitter': function() { return require('NGCore/Client/Device/_PushNotificationEmitter').PushNotificationEmitter; },
	'InAppPurchaseEmitter': function() { return require('NGCore/Client/Device/_InAppPurchaseEmitter').InAppPurchaseEmitter; },
	'InAppPurchase': function() { return require('NGCore/Client/Device/_InAppPurchase').InAppPurchase; },
	'IPCEmitter': function() { return require('NGCore/Client/Device/IPCEmitter').IPCEmitter; },
	'LayoutEmitter': function() { return require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter; },
	'LocalNotification': function() { return require('NGCore/Client/Device/_LocalNotification').LocalNotification; },
	'UsageStats': function() { return require('NGCore/Client/Device/_UsageStats').UsageStats; },
	'NotificationEmitter': function() { return require('NGCore/Client/Device/NotificationEmitter').NotificationEmitter; }
});
exports.Device.__defineGetter__("NotificationEmitter", function() {
	delete this.UsageStats;
	return this.UsageStats= require('NGCore/Client/Device/NotificationEmitter').NotificationEmitter;
});
exports.Device.__defineGetter__("Diagnostics", function() {
	delete this.Diagnostics;
	return this.Diagnostics = require('NGCore/Client/Device/Diagnostics').Diagnostics;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Game'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/Game.js';

var Core		= require("NGCore/Client/Core").Core;
var Device		= require("NGCore/Client/Device").Device;

var DataModelR	= require("NGCore/Client/Social/US/Models/DataModel");
var OrderedList	= require("NGCore/Client/Social/US/Models/OrderedList").OrderedList;
var Dispatcher	= require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;

/**
 * <code>Game</code> objects identify a game and its properties.
 * Game properties include: 
 * <ul>
 * <li><code>name</code></li>
 * <li><code>publisher</code></li>
 * <li><code>category</code></li>
 * <li><code>featured</code></li>
 * <li><code>numberOfLeaderboards</code></li> 
 * <li><code>numberOfAchievements</code></li>
 * <li><code>masterProductID</code></li>
 * <li><code>iconURL</code></li>
 * <li><code>AppStoreURL</code></li>
 * <li><code>feedURL</code></li>
 * <li><code>catalogURL</code></li>
 * </ul>
 * <code>Game</code> objects provide static functions to return all games in a catalog or games associated to a user profile.
 * 
 * @class 
 * @name Social.US.Game
 * @augments Social.US.DataModel
 */
var Game = exports.Game = DataModelR.DataModel.subclass({
	classname: "Game",
	
	
	 //Game is a subclass of data model, and the getter/setter methods are generated by defineSetterCallbacks. The following
	 //comments document the generated methods.
	 /**
	 * The game name. Read-only.
	 * @name Social.US.Game.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The publisher name. Read-only.
	 * @name Social.US.Game.publisher
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The game category name. Read-only.
	 * @name Social.US.Game.category
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether the game is featured. Read-only.
	 * @name Social.US.Game.featured
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The number of leaderboards for the game. Read-only.
	 * @name Social.US.Game.numberOfLeaderboards
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The number of achievements. Read-only.
	 * @name Social.US.Game.numberOfAchievements
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The master product ID. Read-only.
	 * @name Social.US.Game.masterProductID
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the icon for a game. Read-only.
	 * @name Social.US.Game.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the store or marketplace for a game. Read-only.
	 * @name Social.US.Game.appStoreURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the RSS feed for a game. Read-only.
	 * @name Social.US.Game.feedURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Sets a catalog URL for the catalog of game items. Read-only.
	 * @name Social.US.Game.catalogURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	properties: [
		// public
		"name",
		"publisher",
		"category",
		"numberOfLeaderboards",
		"iconURL",
		
		// private
		"numberOfAchievements",
		"featured",
		"masterProductID",
		"appStoreURL",
		"feedURL",
		"catalogURL",
		"description",
		"phone_screenshot_urls",
		"ngcore_url",
		"androidMarketIntentURL"
	],
	
	/**
	 * @public
	 * Sends the user to the app store for this Game
	 */
	goToAppStore: function() {
		if (Core.Capabilities.getPlatformOS().toLowerCase() === "iphone os") {
			Device.IPCEmitter.launch(this.appStoreURL);
		} else {
			Device.IPCEmitter.launchIntent(this.androidMarketIntentURL);
		}
	}
});

/**
 * Returns an ordered list interface to the Mobage game catalog.
 * 
 * @name Social.US.Game.getAllGamesList
 * @function
 * @private 
 * @static
 *
 * @returns {Social.US.OrderedList} An ordered list interface to the catalog of games.
 * @see Social.US.OrderedList
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getAllGamesList = function(){
		
	return OrderedList.getClassPublicInterface(Game, "getAllGamesList", "_allGamesInterface");
};

/**
 * Returns the current game. 
 *
 * @name Social.US.Game.getCurrentGame
 * @function
 * @static
 *
 * @cb {Function} cb The function to call after retrieving the current game.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} [error.description] A description of the error.
 * @cb-param {String} [error.errorCode] A code identifying the error type.
 * @cb-param {String} game An identifier for the game.
 * @cb-returns {void}
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getCurrentGame = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Game, "getCurrentGame", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/FullGamercard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/FullGamercard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/FullGamercard'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/FullGamercard.js';


var DataModelR  = require("NGCore/Client/Social/US/Models/DataModel");
var Dispatcher  = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;

/**
 * @class {FullGamercard} Full gamercard.
 */
var FullGamercard = exports.FullGamercard = DataModelR.DataModel.subclass({
	classname: "FullGamercard",
	 /**
	 * The show state of the gamercard. Read-only.
	 * @name visible
	 */
	properties: [
		// public
		"visible"
	],
	
	/**
	 * Show the gamercard.
	 * 
	 * An exception will be thrown if no valid user is set when attempting
	 * to show the gamercard.
	 */
	show: function() {
		Dispatcher.callMethodOnRemoteObject(this, "show");
	},
	
	/**
	 * Hide the gamercard.
	 */
	hide: function() {
		Dispatcher.callMethodOnRemoteObject(this, "hide");
	},
	
	/**
	 * Set gamercard data.
	 * 
	 * This may be called on-the-fly to update the gamercard after it has been
	 * displayed.
	 * 
	 * Set the <code>gameModule</code> entry to <code>null</code> to remove/disable it.
	 * 
	 * Up to two buttons can be set on the game module. Click events for these buttons
	 * will come into <code>actionCB</code> with <code>action.buttonClick</code>. The
	 * presence of the <code>buttonClick</code> block indicates the click occurred and
	 * its contents provides more context: the <code>id</code> of the button in question.
	 * (Note that if the button doesn't have an ID, the index into the button array is
	 * used instead.)
	 * 
	 * @example
	 *    card.set(
	 *       {
	 *          user: 'gahtje3',
	 *          gameModule: {
	 *             basic: {
	 *                text: 'blah blah blah',
	 *                icon: 'http://ngmoco.com/we-rule/wp-content/themes/werule/images/game/logo-small.png'
	 *             },
	 *             buttons: [
	 *                { id: 'foo', label: 'Foo' },
	 *                { id: 'bar', label: 'Bar' }
	 *             ]
	 *          }
	 *       },
	 *       function(err) {
	 *          if(err) {
	 *             NgLogD("Something went horribly, horribly wrong: " + err);
	 *          }
	 *          else {
	 *             card.show();			// show once complete, after user has been loaded
	 *          }
	 *       },
	 *       function(action) {
	 *          if(action.hasOwnProperty('buttonClick')) {
	 *             NgLogD("Clicked button with ID '" + action.buttonClick.id + "'");
	 *          }
	 *       }
	 *    );
	 * 
	 * @example
	 *    card.set(
	 *       {
	 *          user: 'gahtje7',
	 *          gameModule: {
	 *             dynamicImage: {
	 *                image: 'http://media.tumblr.com/tumblr_lok12fhmJi1qhmqze.jpg?size={width}x{height}',
	 *                placeholder: {
	 *                   width: "{width}",
	 *                   height: "{height}"
	 *                }
	 *             }
	 *          }
	 *       },
	 *       null, null
	 *    );
	 * 
	 * @param conf Data to configure.
	 * @config {String|User} [user] User object or gamertag.
	 * @config [gameModule] Game module data. Adding this will cause the game module
	 *                      to be added to the gamercard automatically.
	 * @param {Function} [completeCB] Completion callback, with <code>error</code> parameters (<code>null</code> if no error).
	 * @param {Function} [actionCB] Action callback, with <code>data</code> parameter.
	 */
	set: function(conf, completeCB, actionCB) {
		Dispatcher.callMethodOnRemoteObject(this, "set", [conf, completeCB, actionCB]);
	}
});

/**
 * Gets the full gamercard.
 * 
 * Only one full gamercard is maintained and its settings can be changed on-the-fly
 * with calls to {@link FullGamercard#set}.
 * 
 * @function
 * @static
 * @example
 *    Gamercard.getFullGamercard(function(card) {
 *       card.set({
 *          user: 'gahtje3'
 *       });
 *       card.show();
 *    });
 * 
 * @param {Function} cb Callback. This function will be passed the gamercard.
 */
FullGamercard.getFullGamercard = function(cb) {
	Dispatcher.callClassMethodOnRemoteObject(FullGamercard, "getFullGamercard", [cb]);
};

/**
 * Gets the full gamercard and sets the user.
 * 
 * @function
 * @static
 * @example
 *    Gamercard.getFullGamercardAndSetUser('gahtje3', function(err, card) {
 *       if(!err) {
 *          card.show();
 *       }
 *    });
 * 
 * @param {String|User} userOrGamertag User object or gamertag of user.
 * @param {Function} cb Callback. This function will be passed arguments: error string
 *                   (<code>null<</code> on success) and the gamercard (if no error).
 */
FullGamercard.getFullGamercardAndSetUser = function(userOrGamertag, cb) {
	Dispatcher.callClassMethodOnRemoteObject(FullGamercard, "getFullGamercardAndSetUser", [userOrGamertag, cb]);
};

/**
 * Gets the full gamercard and sets the user as the currently logged-in user.
 * 
 * @function
 * @static
 * @example
 *    Gamercard.getFullGamercardAndSetCurrentUser(function(err, card) {
 *       if(!err) {
 *          card.show();
 *       }
 *    });
 * 
 * @param {Function} cb Callback. This function will be passed arguments: error string
 *                   (<code>null</code> on success) and the gamercard (if no error).
 */
FullGamercard.getFullGamercardAndSetCurrentUser = function(cb) {
	Dispatcher.callClassMethodOnRemoteObject(FullGamercard, "getFullGamercardAndSetCurrentUser", [cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/Leaderboard.js';

var DataModelR = require("NGCore/Client/Social/US/Models/DataModel");
var Dispatcher = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;
var OrderedList = require("NGCore/Client/Social/US/Models/OrderedList").OrderedList;

/**
 * <code>Leaderboard</code> objects enable the current user to get friend scores, top scores, and submit a score.
 * To return a leaderboard, you must set up at least one leaderboard for your game in the Mobage Sandbox or Production environment.
 * @class 
 * @name Social.US.Leaderboard
 * @augments Social.US.DataModel
 */
var Leaderboard = exports.Leaderboard = DataModelR.DataModel.subclass({

	 
	classname: "Leaderboard",
	properties: [
	"level",
	"title",
	"game",
	"iconURL"
	],

	
	/** 
	 * @constructs Constructs a <code>Leaderboard</code> object identified by the record ID. 
	 * @private
	 *
	 * @param {Type} $super A reference to the DataModel superclass.
	 * @param {String} recordId The record ID of the object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("Leaderboard Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	 * Submits a score to the leaderboard.
	 *
	 * @name Social.US.Leaderboard.submitScore
	 * @function
	 *
	 * @param {Numeric} points The score points. If <code>null</code> or <code>undefined</code>, the callback error is "No score."
	 * @cb {Function} cb The function to call after submitting a score to the leaderboard.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Number} score The score.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	submitScore: function(points, cb){
		Dispatcher.callMethodOnRemoteObject(this, "submitScoreWithPoints", [points, cb]);
	},	
	
	/**
	 * Returns an <code>OrderedList</code> with the user's score and the highest scores.
	 * 
	 * @name Social.US.Leaderboard.getTopScoresList
	 * @function
	 *
	 * @returns {Social.US.OrderedList} The list of highest scores.
	 * @see Social.US.OrderedList
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	getTopScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getTopScoresList", "_leaderboardTopScoresInterface");
	},
	
	/**
	 * Returns an <code>OrderedList</code> of scores for the user's friends.
	 * 
	 * @name Social.US.Leaderboard.getFriendsScoresList
	 * @function
	 *
	 * @returns {Social.US.OrderedList} The list of scores for the user's friends.
	 * @see Social.US.OrderedList
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	getFriendsScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsScoresList", "_leaderboardFriendsScoresInterface");
	}

	 /**
	  * The user's level in the game. Read-only.
	  * @name Social.US.Leaderboard.level
	  * @field
	  * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	 
	 /**
	  * The leaderboard title. Read-only.
	  * @name Social.US.Leaderboard.title
	  * @field
	  * @status iOS, Android, Test, iOSTested, AndroidTested
	  */

	 /**
	  * The game name. Read-only.
	  * @name Social.US.Leaderboard.game
	  * @field
	  * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	 
	 /**
	  * A URL to the leaderboard icon. Read-only.
	  * @name Social.US.Leaderboard.iconURL
	  * @field
	  * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
		 
});

/**
 * Returns the leaderboard(s) for the current game.
 * To return a leaderboard, you must set up at least one leaderboard for your game in the Mobage Sandbox or Production environment.
 *
 * @name Social.US.Leaderboard.getLeaderboards
 * @function
 * @static
 *
 * @cb {Function} cb The function to call after retrieving the leaderboard(s) for the current game.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} error.description A description of the error.
 * @cb-param {String} error.errorCode A code identifying the error type.
 * @cb-param {Social.US.Leaderboard[]} leaderboards An array of leaderboards for the current game.
 * @cb-returns {void}
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Leaderboard.getLeaderboards = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Leaderboard, "getLeaderboards", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Achievement'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Achievement'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Achievement'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/Achievement.js';

var GSGlobals 	= require("NGCore/Client/Social/_Internal/GSGlobals");
var DataModelR  = require("NGCore/Client/Social/US/Models/DataModel");
var Dispatcher  = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;

/**
	// MAX: TODO: DOCUMENT 
 */

var Achievement = exports.Achievement = DataModelR.DataModel.subclass({
		
	classname: "Achievement",

	properties: [
		"description",
		"points",
		"category",
		"unlocked",
		"name",
		"index",
		"icon_url"
	],
	
	initialize: function($super, recordID){

		$super(recordID);
	},

	// cb signature: function(data, err), err is null if no error
	// data will have success: true, and points:___ with some # of points
	unlockAchievement: function(cb) {
		Dispatcher.callMethodOnRemoteObject(this, "unlockAchievement", [cb]);
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Score'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/Score.js';

var DataModel 	  = require("NGCore/Client/Social/US/Models/DataModel").DataModel;

/**
 * <code>Score</code> constructs objects that reflect a user's score for the current game.
 * @class 
 * @name Social.US.Score
 * @augments Social.US.DataModel
 */
var Score = exports.Score = DataModel.subclass({
	
    classname: "Score",
    	
	 /**
	 * A user's score. Read-only.
	 * @name Social.US.Score.score
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The score as formatted for display. Read-only.
	 * @name Social.US.Score.displayScore
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's rank. Read-only.
	 * @name Social.US.Score.rank
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's level in the current game. Read-only.
	 * @name Social.US.Score.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    
	 /**
	 * A <code>Social.US.User</code> reference to the user associated to the score. Read-only.
	 * @name Social.US.Score.user
	 * @field
	 * @public
     * @see Social.US.User
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
	 
    properties: [
	"points",
	"displayScore",
	"rank",
	"level",
	"user"
	]
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Models';
var __filename = 'NGCore/Client/Social/US/Models/AppData.js';

var DataModelReq = require("NGCore/Client/Social/US/Models/DataModel");
var Dispatcher = require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher;

/**
 * <code>AppData</code> constructs objects that get and set a user's properties, 
 * and provides permissions for sharing the user's properties with other users.
 * <br /><br />
 * To use the <code>AppData</code> API, you must indicate on the Mobage Developer Portal that your
 * application uses this API. To do this, follow these steps:
 * <ol>
 * <li>Log into the Developer Portal at
 * <a href="https://developer-sandbox.mobage.com/en/portal/dashboard">https://developer-sandbox.mobage.com/en/portal/dashboard</a>.</li>
 * <li>Click the Apps tab at the top of the page, then click the name of your application.</li>
 * <li>Scroll to the bottom of the page and click Edit Product Details, then scroll
 * to the bottom of the page and ensure that the "Use userdata api" box is selected.</li>
 * <li>Click Save to save your changes.</li>
 * </ol>
 * <br /><br />
 * <strong>Note</strong>: You can also use ngCore's <code>{@link Storage.KeyValue}</code> and
 * <code>{@link Storage.FileSystem}</code> classes to store application data on the user's device.
 * @class 
 * @name Social.US.AppData
 * @see Social.Common.Appdata
 * @see Storage.KeyValue
 * @see Storage.FileSystem
 */
var AppData = exports.AppData = DataModelReq.DataModel.subclass({
/** @lends Social.US.AppData.prototype */
		
	classname: "AppData",
	properties: [
		"data",
		"key",
		"user",
		"permissions"
	],
	
	/**
	 * The application data for the user. Limited to 1024 bytes.
	 * 
	 * @name data
	 * @fieldOf Social.US.AppData#
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The key describing the application data. Limited to 32 bytes.
	 * 
	 * @name key
	 * @fieldOf Social.US.AppData#
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The name of the user who owns the data.
	 * 
	 * @name name
	 * @fieldOf Social.US.AppData#
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	/**
	 * The permissions for the application data.
	 * 
	 * @name permissions
	 * @fieldOf Social.US.AppData#
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    /**
     * The default constructor.
     * @constructs 
     * @name Social.US.AppData.initialize
     * @private
     *
     * @param recordID A unique ID for the <code>AppData</code> object.
     *
     * @augments Social.US.DataModel
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
    initialize: function($super, recordID) {
        $super(recordID);
    }
});

/**
 * Takes a user reference and returns key/value pairs of the user for the current game.
 * @name Social.US.AppData.getKeysForUser
 * @function
 * @static
 *
 * @param {Social.US.User} user A reference to the user.
 * @cb {Function} cb The function to call after retrieving key/value pairs.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} error.description A description of the error.
 * @cb-param {String} error.errorCode A code identifying the error type.
 * @cb-param {Object} entries The key/value pairs for the user. The properties of the object
 *		represent keys. The value of each property represents the value of the corresponding key.
 * @cb-returns {void}
 * @example
 * var user = Social.US.Session.getCurrentSession().user();
 * var AppData = Social.US.AppData;
 * var retrievedEntries = null;
 * AppData.getKeysForUser(user, function(error, entries){
 *     retrievedEntries = entries;
 * });
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
AppData.getKeysForUser = function(user, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getKeysForUser", [user, cb]);
};

/**
 * Takes a user, a key (the name of the key for a name/value pair) and returns the key/value pair
 * for the user for the current game.
 * @name Social.US.AppData.getDataForUserWithKey
 * @function
 * @static
 *
 * @param {Social.US.User} user A reference to the user.
 * @param {String} key The name of the key.
 * @cb {Function} cb The function to call after retrieving the specified value.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} error.description A description of the error.
 * @cb-param {String} error.errorCode A code identifying the error type.
 * @cb-param {Object} response Information about the key.
 * @cb-param {String} response.data The value of the key.
 * @cb-returns {void}
 * @example
 * var user = Social.US.Session.getCurrentSession().user();
 * var AData = Social.US.AppData;
 * var errorCode = null;
 * var errorDesc = null;
 * var fetchedData = null;
 * AData.getDataForUserWithKey( user, 
 *                              key, 
 *                              function(error, response){
 *                                   errorCode = error.errorCode;
 *                                   errorDesc = error.description;
 *                                   fetchedData = response.data;
 *                              }
 *                            );
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
AppData.getDataForUserWithKey = function(user, key, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getDataForUserWithKey", [user, key, cb]);
};


/**
 * Takes data, a user, a key (the name of the key for a name/value pair) and permissions for the
 * data and sets the application data for the user.
 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
 * To use key/value pairs without the foregoing constraints, use ngCore's
 * <code>{@link Storage.KeyValue}</code> class.
 * @name Social.US.AppData.setDataForUserWithKeyAndPermissions
 * @function
 * @static 
 *
 * @param {String} data The data to set.
 * @param {Social.US.User} user A reference to the user.
 * @param {String} key The name of the key.
 * @param {Social.US.AppData.Permissions} permission The permissions for the data.
 * @cb {Function} cb The function to call after setting the value.
 * @cb-param {Object} error Information about the error, if any.
 * @cb-param {String} error.description A description of the error.
 * @cb-param {String} error.errorCode A code identifying the error type.
 * @cb-returns {void}
 * @example
 * var user = Social.US.Session.getCurrentSession().user();
 * var data = "some data";
 * var key = "some key";
 * var errorCode = null;
 * var errorDesc = null;
 * var result = null; 
 *
 * var AData = Social.US.AppData;
 * 
 * AData.setDataForUserWithKeyAndPermissions(data, 
 *                                           user, 
 *                                           key, 
 *                                           AppData.Permissions.Private, 
 *                                           function(error, response){
 *                                             errorCode = error.errorCode;
 *                                             errorDesc = error.description;
 *                                             result = response;
 *                                           }
 *                                         );
 * @returns {void}
 * @status iOS, Android, Test, iOSTested, AndroidTested
 * @see Social.US.AppData.Permissions
 * @see Social.Common.Appdata
 * @see Storage.KeyValue
 * @see Storage.FileSystem
 */
AppData.setDataForUserWithKeyAndPermissions = function(data, user, key, permissions, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "setDataForUserWithKeyAndPermissions", [data, user, key, permissions, cb]);
};



/**
 * Enumeration to define permissions for viewing user data.
 * @name Permissions
 * @fieldOf Social.US.AppData#
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */

/**
 * Only the user can read and write the user data.
 * @name Permissions.Private
 * @fieldOf Social.US.AppData#
 * @constant
 */

/**
 * Friends can read the user data but cannot write it.
 * @name Permissions.FriendsReadOnly
 * @fieldOf Social.US.AppData#
 * @constant
 */

/**
 * All users can read the user data but cannot write it.
 * @name Permissions.PublicReadOnly
 * @fieldOf Social.US.AppData#
 * @constant
 */

/** @ignore */
AppData.Permissions = {
	Private: 0,
	FriendsReadOnly: 1,
	PublicReadOnly: 2
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/GameLaunchPayload.js';

var RouterInited = require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

var MessageEmitter = require("NGCore/Client/Core/MessageEmitter").MessageEmitter;

/**
* Provides an interface for retrieving a game's last payload from the game service. The game
* payload is returned as a string.
* @name Social.US.Service.GameLaunchPayload
*/

var GameLaunchPayload = exports.GameLaunchPayload = {


	/**
	 * @name Social.US.Service.GameLaunchPayload.getLastPayload
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the last payload generated by the game client from the game service 
     * as a string (e.g., JSON) and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, payload){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var pl = payload;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getLastPayload:function(callback)
	{
        if(callback != undefined && typeof callback == "function")
		{
			var cmd = {
				apiURL:"US.Service.GameLaunchPayload.getLastPayload"
			};

            cmd["callbackFunc"] = callback;

			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		}
	},
	
	// MAX: NEEDS DOCUMENTATION!
	// use this to reference the emitter so that you can get push events as they are acted on by the user
	// Example usage code:
	
	//	listen for game push
	//	var GamePayloadListener = Core.MessageListener.subclass({
	//		_onNewGamePayload:function(payload) {
	//			TODO: act on game payload somehow :)
	//		},
	//
	//		destroy:function() {
	// 			Social.US.Service.GameLaunchPayload.getNewPayloadEmitter().removeListener(this);
	// 		}
	//	});
	//	var gamePayloadListenerInstance = new GamePayloadListener();
	//	Social.US.Service.GameLaunchPayload.getNewPayloadEmitter().addListener(gamePayloadListenerInstance,gamePayloadListenerInstance._onNewGamePayload);
	
	
	getNewPayloadEmitter:function() {
		if(!GameLaunchPayload.newGamePayloadEmitter) {
			NgLogD("Creating new payload emitter...");
			
			GameLaunchPayload.newGamePayloadEmitter = new MessageEmitter();
		}
		
		return GameLaunchPayload.newGamePayloadEmitter;
	},
	
	// private, automatically called when new payload arrives. Do not call.
	onGameLaunchPayload:function(event)
	{
		GameLaunchPayload.getNewPayloadEmitter().emit(event.data.payload);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Achievements'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Achievements'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Achievements'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/Achievements.js';

var RouterInited = require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals = require("NGCore/Client/Social/_Internal/GSGlobals");

exports.Achievements = {

	showAchievementsScreen: function() {
		NgLogD("Public - showAchievementsScreen");
		
		var cmd = {
			apiURL:"US.Service.Achievements.showAchievementsScreen"
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = exports; 
var __dirname = 'NGCore/Client/Social/US/Service';
var __filename = 'NGCore/Client/Social/US/Service/Bank.js';

// Bank Public Interface
var RouterInited 	= require("NGCore/Client/Social/_Internal/RouterInit");
var GSGlobals 		= require("NGCore/Client/Social/_Internal/GSGlobals");

/**
* @ignore
* @private
*/
exports.Bank = {
};


/**
 * @class
 * @name Bank.Debit
 * @description
 * Bank.Debit is an interface for in-game item purchasing. A transaction begins with a call to <code>createTransaction()</code>, which presents
 * a user interface to the user. If the user follows through with a purchase, the <code>transaction.state</code> property changes from 
 * <code>new</code> to <code>authorized</code>. Once <code>createTransaction()</code> executes its callback, the game may call 
 * <code>openTransaction()</code>, which changes the state from <code>authorized</code> to <code>open</code> and puts funds into escrow. 
 * At this point, the game/game server should deliver the purchased items. Once the items have been delivered, the game should call   
 * <code>closeTransaction()</code>. If there is a problem at any point in the transaction lifecycle, call <code>cancelTransaction()</code>,
 * which sets the <code>transactionState</code> property to <code>canceled</code> and restores funds from escrow back to the user.
 * <br /><br />
 * The value of a single transaction cannot exceed 100,000 MobaCoins.
 * <br /><br />
 * Please use <code>toLowerCase</code> when checking the state of the transaction to make sure the compatability across Japan and US platform.
 * <code>
 *   if(txnState.toLowerCase() == "open") {
 *    ...
 *   }
 * </code>
 */
exports.Bank.Debit = {
/** @lends Bank.Debit.prototype */
	
		
	/**
	 * Creates a transaction. Initially, it sets the <code>transaction.state</code> to <code>new</code>.
     * Mobage presents a dialog that prompts the user to confirm the transaction. 
	 * If the user decides not to proceed with the transaction, the callback error returns as "usercanceled."
	 * In the client-only flow, this call checks inventory and sets the state to <code>authorized</code>.
	 * <br /><br />
	 * The value of a single transaction cannot exceed 100,000 MobaCoins.
	 * 
	 * @name Bank.Debit.createTransaction
	 * @function
	 * 
	 * @param {Array} billingItems The billing items for the transaction. <br/><b>Note:</b> The array is limited to one item for this release.
	 * @param {String} comment A comment about the transaction.
	 * @cb {Function} callback The function to call after creating the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} transaction Information about the transaction.
	 * @cb-param {String} transaction.comment A comment about the transaction.
	 * @cb-param {String} transaction.id The transaction ID.
	 * @cb-param {String} transaction.state The current state of the transaction.
	 * @cb-returns {void}
	 * @example
     * var billingItems = [{
     *     "item": {
     *           "id": "iceCastle",
     *          },
     *     "quantity": 1
     *    }
     * ];
     * 
     * var createTxCallback = function (error, transaction) {
	 *     if (error === 'usercanceled') {
     *         var userCanceledDlg = new UI.AlertDialog();
     *         userCanceledDlg.setTitle("Transaction Cancelled");
     *         userCanceledDlg.setText("The transaction has been cancelled.");
     *         userCanceledDlg.setChoices([('OK')]);
     *         userCanceledDlg.show();
     *     } else if(error) {
     *         var errorCode = error.errorCode;
     *         var errorDesc = error.description;
     *         Bank.Debit.cancelTransaction(transaction.id);
     *     } else {
     *         txId = transaction.id;
     *         Bank.Debit.openTransaction(txId, openTxCallback)
     * };
     *
     * Bank.Debit.createTransaction(billingItems, "Sample transaction", createTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
    createTransaction: function(billingItems, comment, callback) {
		NgLogD("Public call createTransaction");
		
		
	var data = {
	    billingItems: billingItems,
	    comment: comment
	};
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.createTransaction",
			data: data
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}    
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Places funds into escrow and begins processing the transaction. 
	 * Indicates the game server needs to deliver the purchased item.
	 * The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>.
	 *
	 * @name Bank.Debit.openTransaction
	 * @function
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @cb {Function} callback The function to call after opening the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} transaction Information about the transaction.
	 * @cb-param {String} transaction.comment A comment about the transaction.
	 * @cb-param {String} transaction.id The transaction ID.
	 * @cb-param {String} transaction.state The current state of the transaction.
	 * @cb-returns {void}
	 * @example
	 * var openTxCallback = function (error, transaction) {
	 *      if (error) {
	 *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          Bank.Debit.cancelTransaction(transaction.id, cancelTxCallback );
     *      } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          // Deliver items to the client
     *          MyGameTxClass.deliverItems(transaction.items);
     *          // You must close the transaction in order to be paid
     *          Bank.Debit.closeTransaction(transaction.id, closeTxCallback );
     *      }	
     * };
     *
     * Bank.Debit.openTransaction(myTxId, openTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	openTransaction: function(transactionId, callback) {
		NgLogD("Public call openTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.openTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Continues processing a transaction.
	 * Checks the inventory to verify the item is valid, available, and so on. After verification, the <code>transaction.state</code> chranges from <code>new</code> to <code>authorized</code>,
	 * and funds are placed in escrow. The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>, which 
	 * indicates the game server needs to deliver the purchased item. 
	 * 	 
	 *
	 * @name Bank.Debit.continueTransaction
	 * @function
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @cb {Function} callback The function to call after continuing to process the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} transaction Information about the transaction.
	 * @cb-param {String} transaction.comment A comment about the transaction.
	 * @cb-param {String} transaction.id The transaction ID.
	 * @cb-param {String} transaction.state The current state of the transaction.
	 * @cb-returns {void}
	 * @example
	 * var continueTxCallback = function (error, transaction) {
     *      if (error) {
	 *           var errorCode = error.errorCode;
	 *           var errorDesc = error.description;
     *           Bank.Debit.cancelTransaction(transaction.id, cancelTxCallback );
     *      } else {
     *           var tx = transaction;
     *           Bank.Debit.openTransaction(transaction.id, openTxCallback );
     *      }
	 * };
	 * 
	 * Bank.Debit.continueTransaction(myTxId, continueTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    continueTransaction: function(transactionId, callback) {
		NgLogD("Public call continueTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.continueTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	

    /**
     * Cancels the transaction. The transaction was canceled or the purchased item was not delivered and the game
     * needs to return the user's funds. The <code>transaction.state</code> transitions to <code>canceled</code>.
     *
     * @name Bank.Debit.cancelTransaction
     * @function
     * 
     * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @cb {Function} callback The function to call after continuing to process the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} transaction Information about the transaction.
	 * @cb-param {String} transaction.comment A comment about the transaction.
	 * @cb-param {String} transaction.id The transaction ID.
	 * @cb-param {String} transaction.state The current state of the transaction.
	 * @cb-returns {void}
	 * @example
	 * var cancelTxCallback = function (error, transaction) {
     *     if (error) {
     *        var errorCode = error.errorCode;
     *        var errorDesc = error.errorDescription;
     *        console.log("An error occurred while canceling a transaction: " + error.errorCode +
     *            error.errorDescription);
     *     } else {
     *        var txId = transaction.id;
     *        var txState = transaction.state;
     *        var txComment = transaction.comment;
	 *     }	
     * };
     * 
     * Bank.Debit.cancelTransaction(myTxId, cancelTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
    cancelTransaction: function(transactionId, callback) {
		NgLogD("Public call cancelTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.cancelTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },


	/**
	 * Closes the transaction. The virtual item was delivered.
	 * The <code>transaction.state</code> transitions from <code>open</code> to <code>closed</code>.
	 *
	 * @name Bank.Debit.closeTransaction
	 * @function
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @cb {Function} callback The function to call after continuing to process the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} transaction Information about the transaction.
	 * @cb-param {String} transaction.comment A comment about the transaction.
	 * @cb-param {String} transaction.id The transaction ID.
	 * @cb-param {String} transaction.state The current state of the transaction.
	 * @cb-returns {void}
	 * @example
	 * var closeTxCallback = function (error, transaction) {
     *     if (error) {
     *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          Bank.Debit.cancelTransaction(transaction.id, cancelTxCallback);
	 *     } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *     }	
     * };
     *
     * Bank.Debit.closeTransaction(myTxId, closeTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	closeTransaction: function(transactionId, callback) {
		NgLogD("Public call closeTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.closeTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Retrieves the transaction corresponding to the given transaction ID parameter.
	 *
	 * @name Bank.Debit.getTransaction
	 * @function
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @cb {Function} callback The function to call after continuing to process the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} transaction Information about the transaction.
	 * @cb-param {String} transaction.comment A comment about the transaction.
	 * @cb-param {String} transaction.id The transaction ID.
	 * @cb-param {String} transaction.state The current state of the transaction.
	 * @cb-returns {void}
	 * @example
	 * var getTxCallback = function(error, transaction) {
     *      if (error) {
	 *            var errorCode = error.errorCode;
	 *            var errorDesc = error.description;
     *      } else {
     *            var tx = transaction;     
     *      }
	 * };
	 *
	 * Bank.Debit.getTransaction(myTxId, getTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTransaction: function(transactionId, callback) {
		NgLogD("Public call getTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves the user's transactions where the state is <code>new</code>, <code>authorized</code> or <code>open</code>.
     * See the <a href="https://developer.mobage.com/en/resources/bank_economy">Bank and Economy
     * section</a> of the <a href="https://developer.mobage.com/">Mobage Developer Portal</a> for
     * details.
     * <br /><br />
     * <strong>Note</strong>: This method is not available on the Japan platform.
	 *
	 * @name Bank.Debit.getPendingTransactions
	 * @function
	 * 
	 * @cb {Function} callback The function to call after continuing to process the transaction.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object[]} transactions Information about the transactions.
	 * @cb-param {String} transactions[] transaction ID
	 * @cb-returns {void}
	 * @example
	 * var getPendingTxCallback = function(error, transaction) {
     *      if (error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var tx = transaction;     
     *      }
	 * };
	 *
	 * Bank.Debit.getPendingTransactions(getPendingTxCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPendingTransactions: function(callback) {
		NgLogD("Public call getPendingTransactions");

		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getPendingTransactions",
			data:{}
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = function(err, data) {
				callback(err.error, data.openTransactions);
			};
		}

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	_getCallBackFunc : function(callback) {
			return function(err, data) {
				if(err) {
					callback(err, undefined);
				} else {
					callback(err, data.transaction);					
				}
			};
	}
};

/**
 * @class 
 * @name Bank.Inventory
 * @description
 * Provides an interface to retrieve items from inventory. The Mobage platform
 * server is responsible for managing item inventory in games.
 */
exports.Bank.Inventory = {


	/**
	 * Retrieves the item identified by its product ID from inventory on the Mobage platform server.
	 *
	 * @name Bank.Inventory.getItem
	 * @function
	 * 
	 * @param {Number} itemId The product ID for the item.
	 * @cb {Function} callback The function to call after retrieving the item.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} item Information about the item.
	 * @cb-param {String} item.description A description of the item.
	 * @cb-param {String} item.id The item ID.
	 * @cb-param {String} item.imageUrl The URL for an image of the item.
	 * @cb-param {String} item.name The name of the item.
	 * @cb-param {Number} item.price The price of the item.
	 * @cb-returns {void}
	 * @example
	 * var getItemCallback = function(error, item) {
     *      if (error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var itemData = item;
     *      }
	 * };
	 *
	 * Bank.Inventory.getItem(myItemId, getItemCallback);
	 * @returns {void}
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
    getItem: function(itemId,callback) {
	    NgLogD("Public call Inventory getItem");

	    var data = {
	        itemId: itemId
	    };

	    var cmd = {
	        apiURL:"US.Service.Banking.Purchase.getItem",
	        data:data
	    };

	    if (callback != undefined && typeof callback == "function") {
	        cmd["callbackFunc"] =  function(err, data) {
		        if(err) {
		            callback(err, undefined);
		        } else {
		            callback(err, data.item);					
		        }
	        };
	    }

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    },

	/**
	 * Retrieves the IAP items pricing information by IAP product IDs.
	 *
     * Note that the current implementation is not synchronized. If you do the following,
     * you will only get one callback:
     *
     * Bank.Inventory.getIAPItems(itemListA, cb);
     * Bank.Inventory.getIAPItems(itemListB, cb);
     * 
     * Here are the workarounds:
     * 1. Put all the item in one list and just call getIAPItems once.
     * 2. Chain the two call like :
     * Bank.Inventory.getIAPItems(itemListA, function(err, data){
     *     Bank.Inventory.getIAPItems(itemListB, function(err, data){
     *   });
     * });
     *
	 * @name Bank.Inventory.getIAPItems
	 * @function
	 * 
	 * @param {Array} items The product ID array.
	 * @cb {Function} callback The function to call after retrieving the items.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {String} [error.errorCode] A code identifying the error type.
	 * @cb-param {Object} data IAP product information
	 * @cb-returns {void}
     *
	 * @example
     * var items = new Array();
     * items.push("com_mobage_Dreamtopia_iOS_PLANET75");
     * items.push("com_mobage_Dreamtopia_iOS_SOLARSYSTEM165");
     * items.push("com_mobage_Dreamtopia_iOS_CONSTELLATION300");
     *     
     * Bank.Inventory.getIAPItems(items, function(err, data) {
     *     if(!err && data) {
     *          NgLogD("data = " + JSON.stringify(data));
     *     }
     * });
	 *
     * data = {"currency":"USD","items":[{"price":"29.990000","sku":"com_mobage_Dreamtopia_iOS_CONSTELLATION300","formatted":"$29.99"},{"price":"9.990000","sku":"com_mobage_Dreamtopia_iOS_PLANET75","formatted":"$9.99"},{"price":"19.990000","sku":"com_mobage_Dreamtopia_iOS_SOLARSYSTEM165","formatted":"$19.99"}]}
     *
     *
	 * Bank.Inventory.getIAPItems(items, cb);
	 * @returns {void}
	 * @status iOS
	 */    
    getIAPItems: function(items,callback) {
	    NgLogD("Public call Inventory getIAPItems");

	    var data = {
	        itemId: items
	    };

	    var cmd = {
	        apiURL:"US.Service.Banking.Purchase.getIAPItems",
	        data:data
	    };

	    if (callback != undefined && typeof callback == "function") {
	        cmd["callbackFunc"] =  function(err, data) {
		        if(err) {
		            callback(err, undefined);
		        } else {
		            callback(err, data.item);					
		        }
	        };
	    }

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    }


};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social'] || {}; $MODULE_REGISTRY['NGCore/Client/Social'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Social.js';

/**
 * Public API for GameService
 * 
 * Access this file as NGCore/Client/Social.js
 */

// Note the proper require_ path for our public interface files is: "./Social/US/[filename]"

/**
 * @namespace Manage user data, connect to friends, and more.
 * @name Social
 * @description
 * The <code>Social</code> namespace provides interfaces for the Mobage Social APIs.
 */
exports.Social = {
};

/**
 * @namespace
 * @name Social.Common
 * @description
 * The <code>Social.Common</code> namespace provides APIs for functionality that is shared by the
 * Japan (JP) and United States/worldwide (US) submodules. The features provided by this namespace
 * include Auth, People, Appdata, Blacklist, Profanity and Service.<br /><br />
 * <strong>Important</strong>: You are strongly encouraged to use the <code>Social.Common</code> 
 * APIs wherever possible. If your application uses the <code>Social.US</code> APIs, you must
 * rewrite portions of your application in order to release it in Japan. The same issue applies to
 * the <code>Social.JP<code> APIs.
 */
exports.Social.Common = new (require("NGCore/Client/Social/US/_Internal/_RequireLoader").RequireLoader)({
	"Appdata": function() { return require("NGCore/Client/Social/US/Common/Appdata").Appdata; },
	"Auth": function() { return require("NGCore/Client/Social/US/Common/Auth").Auth; },
	"Blacklist": function() { return require("NGCore/Client/Social/US/Common/Blacklist").Blacklist; },
	"Config": function() { return require("NGCore/Client/Social/US/Common/Config").Config; },
	"People": function() { return require("NGCore/Client/Social/US/Common/People").People; },
	"Profanity": function() { return require("NGCore/Client/Social/US/Common/Profanity").Profanity; },
	"Request": function() { return require("NGCore/Client/Social/US/Common/Request").Request; },
	"RemoteNotification": function() { return require("NGCore/Client/Social/US/Common/RemoteNotification").RemoteNotification; },
	"Service": function() { return require("NGCore/Client/Social/US/Common/Service").Service; },
	"Analytics": function() { return require("NGCore/Client/Social/US/Common/Analytics").Analytics; },
	"Leaderboard": function() { return require("NGCore/Client/Social/US/Common/Leaderboard").Leaderboard; }
});

/**
 * @namespace
 * @name Social.US
 * @description
 * The <code>Social.US</code> namespace provides APIs for the United States (US) submodule. The
 * features provided by this namespace include User, Game, Leaderboard, Score, Ordered List, and
 * AppData.<br /><br />
 * <strong>Important</strong>: You are strongly encouraged to use the <code>Social.Common</code>
 * APIs wherever possible. If your application uses the <code>Social.US</code> APIs, you must
 * rewrite portions of your application in order to release it in Japan.
 */
exports.Social.US = new (require("NGCore/Client/Social/US/_Internal/_RequireLoader").RequireLoader)({
	// Data Models
	"DataModel": function() { return require("NGCore/Client/Social/US/Models/DataModel").DataModel; },
	"User": function() { return require("NGCore/Client/Social/US/Models/User").User; },
	"Game": function() { return require("NGCore/Client/Social/US/Models/Game").Game; },
	"FullGamercard": function() { return require("NGCore/Client/Social/US/Models/FullGamercard").FullGamercard; },
	"Leaderboard": function() { return require("NGCore/Client/Social/US/Models/Leaderboard").Leaderboard; },
	"Achievement": function() { return require("NGCore/Client/Social/US/Models/Achievement").Achievement; },
	"Score": function() { return require("NGCore/Client/Social/US/Models/Score").Score; },
	
	"AppData": function() { return require("NGCore/Client/Social/US/Models/AppData").AppData; },
	
	// Data Cache
	"Cache": function() { return require("NGCore/Client/Social/US/Models/Cache").Cache; },

	// Data APIs
	"Session": function() { return require("NGCore/Client/Social/US/Data/Session").Session; },
	"Dispatcher": function() { return require("NGCore/Client/Social/US/Data/Dispatcher").Dispatcher; }
});

/**
 * @namespace
 * @name Social.US.Service
 * @description
 * Service APIs include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.US.Service = new (require("NGCore/Client/Social/US/_Internal/_RequireLoader").RequireLoader)({
	"Leaderboards": function() { return require("NGCore/Client/Social/US/Service/Leaderboards").Leaderboards; },
	"Friends": function() { return require("NGCore/Client/Social/US/Service/Friends").Friends; },
	"Profile": function() { return require("NGCore/Client/Social/US/Service/Profile").Profile; },
	"ButtonOverlays": function() { return require("NGCore/Client/Social/US/Service/ButtonOverlays").ButtonOverlays; },
	"GameLaunchPayload": function() { return require("NGCore/Client/Social/US/Service/GameLaunchPayload").GameLaunchPayload; },
	"Achievements": function() { return require("NGCore/Client/Social/US/Service/Achievements").Achievements; }
});

/**
 * @namespace Enable in-game purchasing using MobaCoin on Android or your own in-game currency on iOS.
 * @name Bank
 * @description
 * The <code>Bank</code> namespace provides interfaces for the Mobage Bank APIs.
 */
exports.Bank = require("NGCore/Client/Social/US/Service/Bank").Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipe'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipe'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipe'] = exports; 
var __dirname = 'NGCore/Shared';
var __filename = 'NGCore/Shared/NgPipe.js';

var Class = require("NGCore/Shared/Class").Class;
var NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;
var hex_sha1 = require('NGCore/Shared/Lib/sha1').hex_sha1;
var __hasProp = Object.prototype.hasOwnProperty;
var CapabilitiesReq = require('NGCore/Client/Core/Capabilities');
var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;

/*
The NgPipes object
*/

var NgPipe = Class.subclass({
    classname: "NgPipe",
    initialize: function(options) {
        options = options || {};
		var Capabilities = CapabilitiesReq.Capabilities;
		/*
		 * Note that this require statement cannot be put at the top level
		 * because it will cause code to fail to execute.  It's an intricacy
		 * in our require system.
		 */
		this._socAnalytics = require('NGCore/Client/Social').Social.Common.Analytics;
        this._meta = options.meta || {};
        this._queue = null;
        this._isSendQueued = false;
        this._sendDelay = options.sendDelay || 1000;
		this.UTCoffset = options.offset || 0;
		this.timeQueue = []; // Queue to hold items not yet ready for send. holds {msg:message,time:deviceTime} objects.
        this._meta = options.meta || {};
        this._seqStart = options.seqStart || new Date().getTime();
        this._playerState = options.playerState || null;
        this._seqNumber = options.seqNumber || 0;
        this._allowedLargeValue = {
            msg: 1024 * 5,
            err: 1024 * 5,
            sid: 64,
            udid: 64
        };

		this._waitForUTC = Capabilities.meetsBinaryVersion && Capabilities.meetsBinaryVersion("1.3.5.8");

        this._sendToRemote = true;
        this._globalKey = '__PipeKey';
        var self = this;
        var cb = function(error,value, key) {
            var new_queue = [];
            if (!error) {
                try {
                    new_queue = JSON.parse(value);
                } catch(e) {
                    new_queue = [];
                }
            }

            if (self._queue) {
                new_queue = self._queue.concat(new_queue);
            }

            self._setQueue(new_queue);
            if (self._queue.length > 0 ){
                self._drainQueue();
            }
        };
        this._locListener = null;
        this._location = null;
        KeyValueCache.global(this._globalKey).getItem(this._globalKey, {}, cb);
        var starting_queue = [].concat(options.queue || []);
        this._queue = starting_queue;
        this._sessionEnded = false;
        this._capAlphaNumStringKeys = ['afam', 'asku', 'srcty', 'evcl', 'evid', 'pltfmsku','carr','srv'];
        this.sessionStartEvent();
        this._tagQa();
        this._hookLifetime();
        this._hookGeo();
        return true;
    },

    close: function() {
        this._drainQueue();
        return true;
    },

    enable: function() {
        this._sendToRemote = true;
    },

    disable: function() {
        this._sendToRemote = false;
    },

    setRemoteUrl: function(url) {
        NgPipesRemote.setUrl(url);
    },

    playerEvent: function(eventId, evcl, change, playerState) {
        var e;
        evcl || (evcl = "PLST");
        e = {
            change: change,
            srcty: 'GC',
            evid: eventId,
            evcl: evcl,
            plst: this._getPlayerStateDiff(playerState || this._playerState)
        };
        this._queueMessage(e);
        this._setCurrentPlayerState(playerState);
        return e;
    },
    gameEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAME'
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
        }
        this._queueMessage(e);
        return e;
    },
    gameOpsEvent: function(eventId, payload) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAMEOPS'
        };
        this._queueMessage(e);
        return e;
    },
    revenueEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'REV',
            evid: eventId,
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    uiEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'UI',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    funnelEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evcl: 'FUNNEL',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
          this._setCurrentPlayerState(playerState);
        }
        this._queueMessage(e);
        return e;
    },
    plusEvent: function(eventId, payload, forThis)
	{
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e, forThis);
        return e;
    },
    plusUIEvent: function(eventId, payload) {
        var e = {
            evcl: 'PLUSUI',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    navigationEvent: function(fromScreen, toScreen, buttonID){
        var payload = {};
        payload.fro = fromScreen;
        payload.to  = toScreen;
        if(buttonID){
            payload.btnid = buttonID;
        }

        return this.plusUIEvent("NAV", payload);
    },
	_setUTC: function(time)
	{
		this.UTCoffset = time ? time - new Date().getTime() : 0;	// Default to phone time if we don't get something valid
		this.UTCready = true;
		var i = this.timeQueue.length;
		while (i--)
		{
			var x = this.timeQueue[i];
			x.msg.evts = x.time + this.UTCoffset;
			this._queueMessage(x.msg);
		}
	},
    sessionEndEvent: function() {
		if (!this.UTCready)
		{
			// Exiting before we got the right timestamp, we still need to send messages!
			this.UTCready = true;
			var i = this.timeQueue.length;
			while (i--)
			{
				var x = this.timeQueue[i];
				x.msg.evts = x.time;
				this._queueMessage(x.msg);
			}
		}
        if (!(this._sessionEnded)) {
            var e;
            var Capabilities = CapabilitiesReq.Capabilities;

            e = {
                evid:  'SFN',
                evcl:  'PLUS',
                srcty: 'PC',
                hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
                hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
                osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
                lang: Capabilities.getLanguage()
            };

            e = this._queueMessage(e);
            this._sessionEnded = true;
            return e;
        }
        return null;
    },
    sessionStartEvent: function() {
        var e;
        var Capabilities = CapabilitiesReq.Capabilities;

        e = {
            evid:  'SST',
            evcl:  'PLUS',
            srcty: 'PC',
            hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
            hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
            osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
            lang: Capabilities.getLanguage()
        };



        e = this._queueMessage(e);
        this._drainQueue();
        return e;
    },
    socialEvent: function(eventId, friendId,  payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'GC',
            frid: friendId,
            evid: eventId,
            evpl: payload
        };
        return this._queueMessage(e);
    },
    initPlayerState: function(inState) {
        this._setCurrentPlayerState(inState);
        return true;
    },

    updatePlayerState: function(newState) {
        this._setCurrentPlayerState(newState);
        return true;
    },

    //params for internal IAP events:

    //promo campaign unique identifier
    //promoid (String)

    //price of virtual good
    //price (Float)

    //currency used. Defaults to USD
    //cur (String)

    //user's moba balance after purchase
    //mobabalance (Integer)

    //unique identifier for purchase
    //orderid (String)

    //a string identifier for an item, e.g. "IceCastle"
    //sku (String)

    //the value of the item in moba
    //mobaprice (Float)

    //the quantity of item being purchased
    //itemamt (Float)

    //a text description of the item.
    //desc (String)

    //a message displayed to the user when the debit or credit occurs
    //dispmsg (String)

    //the name of the item, as displayed to the user
    //dispname (String)

    //the Mobage ID for the product.
    //productid (Integer)

    //dynamic data accepts a custom object with any params not included above
    //dynamicdata (Object)

    reportAdShow : function(adid) {
        return this.revenueEvent('ADSHOW',{'adid':adid});      
    },

    reportAdClick : function(adid) {
        return this.revenueEvent('ADCLCK',{'adid':adid});    
    },

    reportPromoShow : function(promoid) {
        return this.revenueEvent('PROMOSHOW',{'promoid':promoid});    
    },

    reportPromoClick : function(promoid) {
        return this.revenueEvent('PROMOCLCK',{'promoid':promoid});    
    },

    reportPromoRedeem : function(promoid) {
        return this.revenueEvent('PROMOREDM',{'promoid':promoid});    
    },

    //user clicks on money sku
    reportMoneyIAPIntent : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPINTENT', evpl);
    },

    //user cancels a money sku transaction
    reportMoneyIAPCancel : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPCANCEL', evpl);
    },

    //money sku transaction is successful; orderid require_d
    reportMoneyIAPSuccess : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            orderid : orderid,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPSUCCESS',evpl);
    },

    //money iap purchase fails after being authorized by user; orderid optional if available, pass in null otherwise
    reportMoneyIAPFail : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        orderid ? evpl.orderid = orderid : "";
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPFAIL', evpl);
    },

    //user opens money IAP store
    reportMoneyIAPShow : function() {
        return this.revenueEvent('IAPSHOW',{});
    },

    //user opens moba IAP store
    reportMobaIAPShow : function() {
        return this.revenueEvent('MOBAIAPSHOW',{});
    },

    //user clicks on a moba sku
    reportMobaIAPIntent : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPINTENT', evpl);
    },

    //user cancels moba sku transaction
    reportMobaIAPCancel : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPCANCEL', evpl);
    },

    //moba sku transaction is successful. orderid require_d. 
    reportMobaIAPSuccess : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            orderid : orderid,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPSUCCESS', evpl);
    },

    //moba sku purchase fails after being authorized by user. orderid optional if available, pass in null otherwise
    reportMobaIAPFail : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        orderid ? evpl.orderid = orderid : '';
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPFAIL', evpl);
    },

    /**
    * Report us scraping a facebook user's profile - ext_id is the user's facebook ID.
    *
    * @since 1.1.1.2
    */
    reportFacebookScrape : function(ext_id, dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            extid: ext_id,
            evid: 'FBSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report us scraping a user's contact list - ext_id is the user's facebook ID.
    *
    * @since 1.1.1.2
    */
    reportContactScrape : function(dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'CONTACTSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user posting to another user's wall.
    *
    * @since 1.1.1.2
    */
    reportWallPost : function(friendId, payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'PC',
            frid: friendId,
            evid: 'WALLPOST',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user downloading a game from a specific section in the store.
    * @param {String} game is the asku for the game being downloaded.
    * @param {String} section is the name of the section that the user downloaded from:
    *   AllGames, FeaturedGames, MyProfile, FriendsLastPlayedGame, FriendsPlayingGame
    * @param {String} slot is the order of the game in the section (if applicable)
    * @since 1.1.1.2
    */
    reportDownload : function(game, section, slot) {
        var payload = {};
        payload.game = game;
        payload.section = section;
        payload.slot = slot;
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'DOWNLOAD',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * add internal tag to a user.
    * @since 1.1.1.2
    */
    addTag : function(tagName) {
        var payload = {};
        payload.tag = tagName;
        var e;
        e = {
            evcl: 'PLUS',
            evid: 'TAG', 
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    getSeqNumber: function() {
        this._seqNumber += 1;
        return this._seqNumber;
    },

    getQueueCount: function() {
        return this._queue.length;
    },

    getSendDelay: function() {
        return this._sendDelay;
    },

    setSendDelay: function(val) {
        return (this._sendDelay = val);
    },

    setMeta: function(key, value) {
        if (!value) {
            value = key;
            return (this._meta = value);
        } else {
            return (this._meta[key] = value);
        }
    },

    getMeta: function(key) {
        if (key) {
            return this._meta[key];
        } else {
            return this._meta;
        }
    },

    _queueMessage: function(msg, forThis) {
        if (!msg) {
            return false;
        }

		if (this._waitForUTC && !this.UTCready)
		{
			this.timeQueue.unshift({msg:msg, time:new Date().getTime()});
			return true;
		}

        var self = this;

        //This sets metas that don't change often
        this._setUnsetMetaKeys();

		// evts = UTC time. Makes sense, no?
		msg.evts = msg.evts || this._getUTCTime();

        // The rest of these function set properties that 
        msg = this._mergeMeta(msg);
        msg = this._addSeqDetails(msg);
        msg = this._addGeo(msg);
        msg = this._addGameSku(msg, forThis);
        msg = this._addGameRel(msg);
        msg = this._addCarrier(msg);
        msg = this._addService(msg);
        msg = this._addPlatformVersion(msg);
        msg = this._addUserId(msg);
        msg = this._addUserName(msg);
        msg = this._normalizeValues(msg);
        var queue = this._getQueue();
        queue.push(msg);
        this._setQueue(queue);

        if (!this._isSendQueued) {
            setTimeout(function() {
                self._isSendQueued = false;
                return self._drainQueue();
            }, self._sendDelay);
        }
        return msg;
    },
    _tagQa: function() {
        var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
        var self = this;
        fs.readFile('QA', {}, function(err, data) {
            if (!err) {
                self.addTag("NGMOCOQA");
            }
        });
    },
    _hookGeo: function() {
        var Social = require('NGCore/Client/Social').Social;
        if(Social.US){
            var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
            var Device = require('NGCore/Client/Device').Device, self = this;
            var LocationListener = MessageListener.subclass({
                initialize: function() {
                    Device.LocationEmitter.addListener(this, this.onUpdate, false);
                },
                onUpdate: function(location) {
                    self._location = location;
                    Device.LocationEmitter.removeListener(this);
                    self._locListener = null;
                }
            });
            this._locListener = new LocationListener();
        }
    },
    _hookLifetime: function() {
        var self = this;
        var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
        var Device = require('NGCore/Client/Device').Device;
        var ListenerClass =  MessageListener.subclass({
            initialize: function() {
                Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
            },
            onLifecycleUpdate: function(event) {
                switch (event) {
                case Device.LifecycleEmitter.Event.Suspend:
                case Device.LifecycleEmitter.Event.Terminate:
                    self.sessionEndEvent();
					self._drainQueue();
                    break;
                }
            }
        });
        if (!this._listener) {
            this._listener = new ListenerClass();
        }
    },
    /**
    * Change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setSocialAnalytics: function(obj) {
		this._socAnalytics = obj;
	},
    _setUnsetMetaKeys: function() {
        var Capabilities = CapabilitiesReq.Capabilities, udid;
        if ((!this.getMeta('udid')) && (udid = Capabilities.getUniqueId() )) {
            this.setMeta('udid', udid);
        }

        if (!this.getMeta('sid')) {
            var sid = ''+ hex_sha1(this._seqStart+ (this.getMeta('udid')|| "UNKNOWN"));
            this.setMeta('sid', sid);
        }

        if (!this.getMeta('pltfmsku')) {
            var platRegex = /android/;

            var plat = Capabilities.getPlatformOS();
            if (plat) {
                plat = plat.toLowerCase();
                if (plat.match(platRegex) ) {
                    plat = "android";
                } else if ("flash" === plat ) {
                    plat = "flash";
                } else {
                    plat = "ios";
                }
                this.setMeta( 'pltfmsku', plat);
            }
        }

        if (!this.getMeta('apiver')) {
            this.setMeta('apiver', 5);
        }
        return true;
    },

    _getPlayerStateDiff: function(newState) {
        var delta_sign, delta_value, diff, key, value;
        diff = {};
        if (!this._playerState) {
            this._setCurrentPlayerState(newState);
        }
        for (key in newState) {
            if (!__hasProp.call(newState, key)) continue;
            value = newState[key];
            if (typeof value === 'number') {
                delta_value = (value - this._playerState[key]) || 0;
                if (delta_value < 0) {
                    delta_sign = '-';
                }
                if (delta_value >= 0) {
                    delta_sign = '+';
                }
                diff[key] = "" + delta_sign + "," + Math.abs(delta_value) + "," + (this._playerState[key]);
            } else if (typeof value === 'string') {
                diff[key] = value;
            }
        }
        return diff;
    },

    _setCurrentPlayerState: function(pst) {
        var key, value;
        this._playerState = {};
        for (key in pst) {
            if (!__hasProp.call(pst, key)) continue;
            value = pst[key];
            this._playerState[key] = value;
        }
        return true;
    },
	_getUTCTime: function()
	{
		return new Date().getTime() + this.UTCoffset;
	},
    _addGeo: function(msg) {
        var loc_point;

        if (this._location && (loc_point = this._location.getPosition())  && !isNaN(loc_point.getX()) && !isNaN(loc_point.getY())) {
            msg.geo = "" + loc_point.getX() + "," + loc_point.getY();
        }
        return msg;
    },
    _addCarrier: function(msg) {
        var Capabilities = CapabilitiesReq.Capabilities;
        var carr = Capabilities.getCarrier();
        if (carr) {
            msg.carr = carr;
        }
        return msg;
    },
    _addService: function(msg) {
        var Analytics = this._socAnalytics;
        msg.srvc = Analytics.getServiceId();
        return msg;
    },
    _addPlatformVersion: function(msg) {
        var Analytics = this._socAnalytics;
        msg.pver = Analytics.getPlatformVersion();
        return msg;

    },
    _addSeqDetails: function(msg) {
        this._seqNum += 1;
        msg.seq = this.getSeqNumber();
		// This is the length of the session. No need to offset on the real UTC, it's all relative.
        msg.seqdt = new Date().getTime() - this._seqStart;
        return msg;
    },
    _addUserId: function(msg) {
      var Analytics = this._socAnalytics;
      var uid = Analytics.getUserId();
      if (uid) {
        msg.uid = uid;
      }
      return msg;
    },
    _addUserName: function(msg) {
      var Analytics = this._socAnalytics;
      var un = Analytics.getUsername();
      if (un) {
        msg.plus = un;
      }
      return msg;
    },
    _addGameSku: function(msg, forThis) {
        var app_key = forThis || (Capabilities.getConfigs() || {} )["appId"];
        if ( app_key ) {
            msg.asku = app_key;
        }
        return msg;
    },
    _addGameRel: function(msg) {
        var arel = Capabilities.getAppReleaseVersion();
        if (arel) {
          msg.arel = arel;
        }
        return msg;
    },
    _normalizeValues: function(msg) {
        var key, value;
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            if (typeof value === 'string') {
                value = this._normalizeString(key, value);
            } else if (typeof value === 'object') {
                value = this._normalizeValues(value);
            }
            msg[key] = value;
        }
        return msg;
    },

    _normalizeString: function(key, value) {
        value = value.substring(0, this._allowedLargeValue[key] || 32);
        if (-1 !== this._capAlphaNumStringKeys.indexOf(key)) {
            value = value.toUpperCase().replace(/[^\w]+/g, "").replace("_", "");
        }
        return value;
    },

    _mergeMeta: function(msg) {
        var _ref, _ref2, key, new_msg, value;
        new_msg = {};
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            new_msg[key] = value;
        }
		ref = this._meta;
        for (key in _ref)
		{
            if (!__hasProp.call(_ref, key)) continue;
            value = _ref[key];
            (_ref2 = new_msg[key]) ? _ref2 : new_msg[key] = value;
        }
        return new_msg;
    },

    _drainQueue: function() {
        var cb, self, toDrain;
        toDrain = this._getQueue();
        this._setQueue([]);
        self = this;

        if (! this._sendToRemote)
            return true;

        cb = function(state, not_sent) {
            if (state === NgPipesRemote.possibleStates.error) {
                self._queueMany(not_sent);
				self._storeQueue();
                self._sendDelay = self._sendDelay * 2;
            } else if (state === NgPipesRemote.possibleStates.finished ) {
                self._sendDelay = 1000;
            }
            return true;
        };
        NgPipesRemote.clearQueue(toDrain, cb);
        toDrain = null; // explicit clear to keep memory down
        return true;
    },

	_exitingApp: function()
	{
		// called by LifecycleEmitter when we are about to exit the application
		this.sessionEndEvent();
		this._drainQueue();
	},

    _queueMany: function(msg_arr) {
        var _i, _len, msg, self = this;
        this._setQueue( (this._getQueue() || [] ).concat(msg_arr) );
        if (this._isSendQueued) {
          this._isSendQueued = true;
          setTimeout(function() {
              self._isSendQueued = false;
              return self._drainQueue();
          }, self._sendDelay);
        }

        return true;
    },
    _setQueue: function(new_queue) {
        this._queue = new_queue;
        return true;
    },
	_storeQueue: function()
	{
		KeyValueCache.global(this._globalKey).setItem(this._globalKey, {}, JSON.stringify(this._queue));
    },
    _getQueue: function() {
        return this._queue;

    }
});

exports.NgPipe = NgPipe;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Analytics.js';

var Class = require('NGCore/Client/Core/Class').Class,
NgPipe = require('NGCore/Shared/NgPipe').NgPipe,
NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;

var Analytics = Class.singleton(
/** @lends Core.Analytics.prototype */
{
    classname: 'Analytics',

    /**
     * @class The <code>Analytics</code> class serves as the custom messaging channel to the ngCore platform. 
     * The <code>Analytics</code> class provides developers with a way to keep track of game-specific items that require analysis and counting.
     * Use this class when you need your games to send custom elements that require in-game analytics support. 
     * @constructs The default constructor.
     * @augments Core.Class
     * @since 1.0
     */
    initialize: function() {
        if (!this._pipe) {
          this._pipe = new NgPipe();
        }
    },

	/** @private */
	updateGLEXT: function()
	{
		try
		{
			var caps = require("NGCore/Client/Core/Capabilities").Capabilities;
			var ext = caps.getOglExtensions();
			if (ext.length > 2)	// > 2 means we got some actual data, not our fake string
			{
				// We need to rip out just one of the four tex compressions we want.
				var list = [];
				var goodies =
				[
					"GL_IMG_texture_compression_pvrtc",
					"GL_AMD_compressed_ATC_texture",
					"GL_OES_compressed_ETC1_RGB8_texture",
					"GL_AMD_compressed_3DC_texture"
				];
				for (var i in goodies)
				{
					var item = goodies[i];
					for (var j in ext)
					{
						if (ext[j] ===  item)
						{
							var rep = {};
							rep[caps.getDeviceName()] = item;
							list.push(rep);
						}
					}
				}

				for (i in list)
				{
					Analytics.reportGameEvent("openglexts", list[i]);
				}
			}
		}
		catch (e)
		{
			NgLogException(e);
		}
	},

    /** @private */
    enable: function() {
        this._pipe.enable();
    },

    /** @private */
    disable: function() {
        this._pipe.disable();
    },

    /** @private */
    setUrl: function(url) {
        this._pipe.setRemoteUrl(url);
    },

    /**
    * Report a navigation event that occurs when users navigate between application pages. 
    * Calling this function will alert the analytics platform that a user has generated a navigation event.
    * This information is used to plot how users move through the game, how long they spend on a page, and what page they navigate to next.
    * @param {String} from The name of the page from which navigation originates. 
    * @param {String} to An analytics name for the destination page.
    * @param {String} btnid The ID of the button that triggered the navigation.
    * @returns {Boolean} Set to <code>false</code> if the <code>from</code> or <code>to</code>
    *		parameter is omitted. Set to <code>true</code> in all other cases.
    * @since 1.0
    */
    reportNavigation : function(from, to, btnid) {
        if (!(from && to)) {
            return false;
        }
        this._pipe.uiEvent('NAV', {to: to, fro: from, btnid: btnid} );
        return true;
    },
    /**
    * Report a custom game event. Call <code>reportGameEvent</code> to record events that do not alter a user's core game statistics.<br /><br />
    * <b>Note:</b> This function serves as a catch-all. Call <code>reportGameEvent</code> to count or analyze events that do not fit into any 
    * other category.
    * @param {String} eventId The ID for the custom event.
    * @param {Object} payload A hash of extra information.
    * @param {Object} playerState A hash of important player states.
    * @returns {Boolean} Set to <code>false</code> if the <code>eventId</code> parameter is omitted.
    *		Set to <code>true</code> in all other cases.
    * @since 1.0
    */
    reportGameEvent : function(eventId, payload, playerState ) {
        if (!eventId) {
            return false;
        }

        this._pipe.gameEvent(eventId, payload, playerState);

        return true;
    },
    /**
    * Report a change to a playerstate. A playerstate is the object representation of the player's core stats. 
    * For example, if a player purchased an in-game item, you would call this to let the analytics system know what happened and how much gold was spent.
    * Everything in the player state is counted and recorded. Make sure to only pass in things for which you want to see the change 
    * (gold, mojo, grow, level, xp, health, lives, and so on).<br /><br />
    * <b>Note:</b> This is only for game state and should not include information that is unique to a user. For example, the user game tag or the user ID.
    * @param {String} action The product ID of a purchased product. This essentially points out when an action is performed.
    * @param {Object} change A hash of currencies spent and/or gained. For example {mojo: 100, gold:-10}
    * @param {Object} playerState A hash of important player states after the purchase.
    * @returns {Boolean} Set to <code>false</code> if the <code>action</code> parameter is omitted.
    *		Set to <code>true</code> in all other cases.
    * @since 1.0
    */
    reportPlayerStateChange : function(action, change,  playerState) {
        if (action) {
            this._pipe.playerEvent(action, 'PLSTCHANGE', change, playerState);
            return true;
        } else {
            return false;
        }
    },

    /**
    * Report when a user reaches a new stage of a funnel. Funnel refers to a set of pages or requirements a user is required to engage in before proceeding. 
    * You can use this call to keep track of progress for all users. For example, keeping track of various stages users engage in for game registration.
    * Funnel stages are ordered by numeric ID. The funnel <code>stageName</code> is used for display. You do not need to define funnels ahead of time.
    * Funnel stages start at 0 and increase as the user proceeds further.<br /><br />
    * <b>Note:</b> Calling <code>reportFunnelStage()</code> multiple times for a single user generates an incorrect count.
    * @param {String} funnelName The name of the funnel that the user has progressed to.
    * @param {Number} funnelStage The integer value of the stage that the user reached.
    * @param {String} stageName The name of the stage that the user reached.
    * @param {Object} playerState A hash of important player states after a funnel stage.
    * @private
    */
    reportFunnelStage : function(funnelName, funnelStage, stageName, playerState) {
        var payload =  {};

        if (!(funnelName)) {
            return false;
        }
        if (funnelStage !== null && funnelStage !== undefined) {
            payload.stage = funnelStage;
        } else {
            return false;
        }

        if (stageName) {
            payload.stageName = stageName;
        }
        this._pipe.funnelEvent(funnelName, payload, playerState);

        return true;
    },
    /**
     * Report an interaction between two users.
     * @param {String} actionId The action that the user is performing to interact with the other user
     * @param {String} friendGamerTag The other user with whom the current user is interacting.
     * @param {Object} payload A hash of extra information.
     * @returns {Boolean} Set to <code>false</code> if the <code>actionId</code> or
     *		<code>friendGamerTag</code> parameter is omitted. Set to <code>true</code> in all other
     *		cases.
     * @since 1.0
     */
    reportSocialEvent: function(actionId, friendGamerTag, payload) {
        if (actionId && actionId.length && friendGamerTag && friendGamerTag.length ) {
            this._pipe.socialEvent(actionId, friendGamerTag, payload);
            return true;
        }
        return false;
    },
    /**
    * Report an error to analytics.
    * @param {String} error_msg The error message to log.
    * @returns {Boolean} Set to <code>false</code> if the <code>error_msg</code> parameter is
    *		omitted. Set to <code>true</code> in all other cases.
    * @since 1.0
    */
    reportError : function(error_msg) {
        if (!error_msg) {
            return false;
        }
        this._pipe.gameOpsEvent("ERR", {err: error_msg } );
        return true;
    },
    /**
     * @private
     */
    addTag: function(tag) {
        if (tag) {
            var evpl = {tag:tag};
            this._pipe.gameEvent('tag', evpl);
            return true;
        }
        return false;
    },
    /** @private */
    _getPipe: function() {
        return this._pipe;
    },
    /**
    * Change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setNgPipeSocialAnalytics: function(socialAnalyticObj) {
		if (this._pipe) {
			this._pipe._setSocialAnalytics(socialAnalyticObj);
		}
	}
});
exports.Analytics = Analytics;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = exports; 
var __dirname = 'NGCore/Client/Device';
var __filename = 'NGCore/Client/Device/LifecycleEmitter.js';

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

exports.LifecycleEmitter = MessageEmitter.singleton(
/** @lends Device.LifecycleEmitter.prototype */
{
	classname: 'LifecycleEmitter',
		
	/**
	 * @class The <code>LifecycleEmitter</code> class constructs a singleton object that sends its
	 * listeners a unique value when a lifecycle event occurs (for example, when the application is
	 * being suspended). The value corresponds to an enumerated value of
	 * <code>{@link Device.LifecycleEmitter#Event}</code>. Apps can respond to these events by
	 * notifying external sources, saving their current state, or taking another action. For
	 * example, an app can respond to a <code>Terminate</code> event by sending an analytics message
	 * using <code>{@link Core.Analytics}</code>.
	 * <br /><br />
	 * In addition, an app can exit immediately and shut down its process by calling the static
	 * method <code>{@link Device.LifecycleEmitter.exitProcess}</code>.
	 * @singleton
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		/** @private */
		this.identificationCache = {};
		this.numEngineRequests = 0;
	},
	
	_lifecycleEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._lifecycleEventRecvGen(cmd, msg))
			return;
			
		this.emit(msg.event);
		//Cascade the original message back out to native for forwarding
		//	to the next interpreter in the chain.
		this._lifecycleEventSendGen(msg.event);
	},

	/**
	 * Exit the app immediately, and shut down the app's process.
	 * @name Device.LifecycleEmitter.exitProcess
	 * @function
	 * @static
	 * @returns {void}
	 * @since 1.8
	 */
	
	$exitProcess: function()
	{
		// We need to notify analytics in case it wants to start sending events
		var pipe = require('NGCore/Client/Core/Analytics').Analytics._getPipe();
		pipe._exitingApp();

		this._exitProcessSendGen();
	},
	
	/** @private */
	$_bgMe: function()
	{
		this.__bgMeSendGen();
	},

	/** @private */
	$pauseGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Pausing Game");
		this._pauseGameSendGen();
		var _lgl = require("NGCore/Client/Core/_LocalGameList")._LocalGameList;
		_lgl._pausingGame();
	},

	/** @private */
	$resumeGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Resuming Game");
		this._resumeGameSendGen();
		var _lgl = require("NGCore/Client/Core/_LocalGameList")._LocalGameList;
		_lgl._resumingGame();
	},

	requestEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

			//Store identification key and increment request to engine
			this.identificationCache[key] = true;
			++this.numEngineRequests;
			this.incrementEngineAlive();
	},
	
	cancelEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

			if (this.identificationCache[key])
			{
				//Store identification key and increment request to engine
				delete this.identificationCache[key];
				--this.numEngineRequests;
				this.decrementEngineAlive();
			}else{
				NgLogW("LifecycleEmitter.cancelEngineKeepAlive() Identification Key not found");
			}
	},

	incrementEngineAlive: function()
	{
		this._incrementEngineAliveSendGen();
	},
	
	decrementEngineAlive: function()
	{
		this._decrementEngineAliveSendGen();
	},
	
	cancelAllEngineRequests: function()
	{
		this._cancelAllEngineRequestsSendGen();
	},

	_killGameProc: function( )
	{
		this.__killGameProcSendGen();
	},
	
	/** 
	 * Enumeration values for lifecycle events.
	 * @name Event
	 * @fieldOf Device.LifecycleEmitter#
	 */

	/**
	 * Application is being suspended.
	 * @name Event.Suspend
	 * @fieldOf Device.LifecycleEmitter#
	 * @constant
	 */

	/**
	 * Application is being resumed.
	 * @name Event.Resume
	 * @fieldOf Device.LifecycleEmitter#
	 * @constant
	 */
	 
	/**
	 * Application is being terminated.
	 * @name Event.Terminate
	 * @fieldOf Device.LifecycleEmitter#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	Event:
	{ 
		Suspend: 0,
		Resume: 1,
		Terminate: 2,
		KeepAliveWillTerminate: 3
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 334,
	// Method create = -1
	// Method lifecycleEvent = 2
	// Method exitProcess = -3
	// Method pauseGame = -4
	// Method resumeGame = -5
	// Method incrementEngineAlive = 6
	// Method decrementEngineAlive = 7
	// Method cancelAllEngineRequests = 8
	// Method _killGameProc = -9
	// Method _bgMe = -10
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._lifecycleEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[334] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_lifecycleEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		obj[ "event" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "event" ] === undefined )
		{
			NgLogE("Could not parse event in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x14effff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_lifecycleEventSendGen: function( event )
	{
		Core.Proc.appendToCommandString( 0x14e0002, this, [ +event ] );
	},
	
	/** @private */
	$_exitProcessSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14efffd );
	},
	
	/** @private */
	$_pauseGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14efffc );
	},
	
	/** @private */
	$_resumeGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14efffb );
	},
	
	/** @private */
	_incrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14e0006, this );
	},
	
	/** @private */
	_decrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14e0007, this );
	},
	
	/** @private */
	_cancelAllEngineRequestsSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14e0008, this );
	},
	
	/** @private */
	$__killGameProcSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14efff7 );
	},
	
	/** @private */
	$__bgMeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x14efff6 );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _lifecycleEventRecv: function( cmd ) {}
	// lifecycleEvent: function( event ) {}
	
	// $exitProcess: function(  ) {}
	
	// $pauseGame: function(  ) {}
	
	// $resumeGame: function(  ) {}
	
	// incrementEngineAlive: function(  ) {}
	
	// decrementEngineAlive: function(  ) {}
	
	// cancelAllEngineRequests: function(  ) {}
	
	// $_killGameProc: function(  ) {}
	
	// $_bgMe: function(  ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Time'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Time'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Time'] = exports; 
var __dirname = 'NGCore/Client/Core';
var __filename = 'NGCore/Client/Core/Time.js';

////////////////////////////////////////////////////////////////////////////////
// Class Time
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var callbacks = {};
var cbKey = 0;
callbacks.add = function(fn) {
	if (typeof fn != 'function') return undefined;
	this[++cbKey] = fn;
	return cbKey;
};

var Time = Class.singleton(
/** @lends Core.Time.prototype */
{
	classname: 'Time',
	mFrameTime: 0,
	mFrameDelta: 0,

	/**
	 * @class the <code>Time</code> class constructs objects that provide access to the system clock and system timings for a device.
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		
		var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
		var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
		var ListenerClass =  MessageListener.subclass({
			initialize: function(mainTime)
			{
				LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
				this.mTime = mainTime;
			},
			onLifecycleUpdate: function(event)
			{
				switch (event)
				{
//					case LifecycleEmitter.Event.Suspend: 	// If MOB-3366 is reopened, this may need to be uncommented
					case LifecycleEmitter.Event.Resume:		//MOB-3366 Reset frame time when we pause/resume. Suspend doesn't work, so use Resume
						this.mTime.mFrameTime = 0;
					break;
				}
			}
		});
		this.mLifeListener = new ListenerClass(this);
	},

	/**
	 * Return the timestamp for the current time frame (expressed in milliseconds).
	 * @returns {Number} The timestamp for the current time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getFrameTime: function()
	{
		return this.mFrameTime;
	},

	/**
	 * Return the delta time in milliseconds since the last time frame.
	 * @returns {Number} The delta time since the last time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getFrameDelta: function()
	{
		return this.mFrameDelta;
	},

	/**
	 * Return the real-time clock in milliseconds. 
	 * <b>Note:</b> This differs from the time frame timestamp, which is constant for the entire time frame.
	 * @returns {Number} The real-time clock.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getRealTime: function()
	{
		return (new Date()).getTime();
	},

	$_frameTimeRecv: function( cmd )
	{
		var o = {};
		this._frameTimeRecvGen(cmd, o);

		this.mFrameDelta = this.mFrameTime ? o.time - this.mFrameTime : 1;
		this.mFrameTime = o.time;
	},
	
	setTimeout: function( fn, delta ) {
		var cbId = callbacks.add(fn);
		if (cbId) {
			this._setTimeoutSendGen( cbId, delta );
		}
		return cbId;
	},
	
	setInterval: function( fn, interval ) {
		var cbId = callbacks.add(fn);
		if (cbId) {
			this._setIntervalSendGen( cbId, interval );
		}
		return cbId;
	},
	
	clearTimeout: function( token ) {
		delete callbacks[token];
		this._clearSendGen( token );
	},
	
	clearInterval: function( token ) {
		delete callbacks[token];
		this._clearSendGen( token );
	},
	
	_fireTimerRecv: function( cmd ) {
		var msg = {};
		if(!this._fireTimerRecvGen(cmd, msg))
			return;
		
		var fn = callbacks[msg.cbId];
		if (typeof fn == 'function') {
			fn();
		} else console.log("Could not find closure for " + msg.cbId);
		if (cmd.remove) delete callbacks[cmd.cbId];
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 351,
	// Method frameTime = -1
	// Method create = -2
	// Method setTimeout = 3
	// Method setInterval = 4
	// Method clear = 5
	// Method fireTimer = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._fireTimerRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -1:
					Time._frameTimeRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[351] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_frameTimeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.frameTime from command: " + cmd );
			return false;
		}
		
		obj[ "time" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "time" ] === undefined )
		{
			NgLogE("Could not parse time in Time.frameTime from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_fireTimerRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.fireTimer from command: " + cmd );
			return false;
		}
		
		obj[ "cbId" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "cbId" ] === undefined )
		{
			NgLogE("Could not parse cbId in Time.fireTimer from command: " + cmd );
			return false;
		}
		
		obj[ "remove" ] = Proc.parseBool( cmd[ 1 ] );
		if( obj[ "remove" ] === undefined )
		{
			NgLogE("Could not parse remove in Time.fireTimer from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( 0x15ffffe, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_setTimeoutSendGen: function( cbId, delta )
	{
		Proc.appendToCommandString( 0x15f0003, this, [ +cbId, +delta ] );
	},
	
	/** @private */
	_setIntervalSendGen: function( cbId, interval )
	{
		Proc.appendToCommandString( 0x15f0004, this, [ +cbId, +interval ] );
	},
	
	/** @private */
	_clearSendGen: function( cbId )
	{
		Proc.appendToCommandString( 0x15f0005, this, [ +cbId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $_frameTimeRecv: function( cmd ) {}
	// $create: function( __objectRegistryId ) {}
	
	// setTimeout: function( cbId, delta ) {}
	
	// setInterval: function( cbId, interval ) {}
	
	// clear: function( cbId ) {}
	
	// _fireTimerRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});

exports.Time = Time;

/** Timeout Support. Shameface. Intentionally leak to the global scope. */
var env = typeof $_GETENGINEENV !== "undefined" ? $_GETENGINEENV() : undefined;

if ( typeof env == 'object' && env.useCoreTimeout ) {
	
	setTimeout = function( fn, delay ) { return Time.setTimeout(fn, delay); };
	setInterval = function( fn, interval ) { return Time.setInterval(fn, interval); };
	clearTimeout = function( token ) { Time.clearTimeout(token); };
	clearInterval = function( token ) { Time.clearInterval(token); };
	
	exports.NGSetTimeoutRunTimers = function() {};
	
} else {
	exports.NGSetTimeoutRunTimers = require("NGCore/Client/UI/NGJSEnvironmentSupport").NGSetTimeoutRunTimers;
	
	Time.setTimeout = setTimeout;
	Time.setInterval = setInterval;
	Time.clearTimeout = clearTimeout;
	Time.clearInterval = clearInterval;
	
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Util'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/Util.js';

////////////////////////////////////////////////////////////////////////////////
// Utilities for Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Caps = require("NGCore/Client/Core/Capabilities").Capabilities;
var Time = require("NGCore/Client/Core/Time").Time;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
var AlertDialog = require("NGCore/Client/UI/AlertDialog").AlertDialog;

////////////////////////////////////////////////////////////////////////////////

var urlPathServerSplit = /^(https?:\/\/)?([^\/]*)(.*[^\/])?.?/i;

var Util = exports.Util =
{
    /*
     * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	NormalizeUrl: function(url, keepTrailingSlash)
	{
		url = Util.buildRelativeUrl(url);

		// Now split it into parts and make server bits lower case
		var parsed = url.match(urlPathServerSplit);
		if (parsed && parsed[1])
		{
			// absolute path!
			url = parsed[1].toLowerCase() + parsed[2].toLowerCase() + (parsed[3] ? parsed[3] : "");
		}
		else
		{
			// Direct server, no path
			url = url.toLowerCase();
		}
		return url;
	},

	/*
	 * For a given game url, this returns the directory of that url on the SD card.
	 */
	GetMD5HashDirectoryFromUrl: function(url)
	{
		var name;
		if (url === Capabilities._getBootServer() + "/" + Capabilities._getBoot())
			name = Capabilities.getBootDir();
		else
			name = require('NGCore/Shared/Lib/md5').toMD5(url);

		return name;
	},

	buildRelativeUrl: function(url)
	{
		if (!url.match(/^(https?:\/\/)/))
		{
			// If the path is relative, then we append our server to the beginning of it
			if (url.charAt(0) == '/' || !url.length)
			{
				url = Caps.getServer() + url;
			}
			else
			{
				url = Caps.getServer() + "/" + Caps.getGame() + "/" + url;
			}
		}

		return url;
	},

	RetrySchedule: function(initialRetry, maxDuration)
	{
		var count = Math.floor(Math.log(maxDuration / initialRetry));
		var schedule = [initialRetry];
		for(var i=0; i < count + 1; ++i)
		{
			initialRetry *= 2;
			schedule.push(initialRetry);
		}
		return schedule;
	},
	
	OperationWithRetries: function(operationCb, failureCb, failEarly)
	{
		var abortAttempts;
		var abortTime;
		var abortTimeAttempts;
		
		if(failEarly)
		{
			abortAttempts = 3;
			abortTime = 10000;
			abortTimeAttempts = 1;
		}
		else
		{
			abortAttempts = Infinity;
			abortTime = 30000;
			abortTimeAttempts = 6;
		}
		
		// console.log('retry config abortAttempts:', abortAttempts, 'abortTime', abortTime, 'abortTimeAttempts', abortTimeAttempts);
		
		abortTime = Core.Time.getRealTime() + abortTime;
		var timeout = 250;
		var attemptCount = 1;
		
		var failed = false;
		var armed = true;
		
		var failureParam = function()
		{
			if(failed) return;
			
			if(!armed)
			{
				console.log('OperationWithRetries: failureParam called when not armed');
				return;
			}
			armed = false;
			
			if(attemptCount >= abortAttempts)
			{
				console.log('OperationWithRetries: too many retry attempts');
				failed = true;
				failureCb();
				return;
			}
			
			if(Core.Time.getRealTime() >= abortTime && attemptCount >= abortTimeAttempts)
			{
				console.log('OperationWithRetries: retries took too long');
				console.log('OperationWithRetries: abortTime:', abortTime, 'realTime:', Core.Time.getRealTime());
				console.log('OperationWithRetries: attemptCount:', attemptCount, 'abortTimeAttempts:', abortTimeAttempts);
				failed = true;
				failureCb();
				return;
			}
			
			console.log('OperationWithRetries: Failure, will retry in ' + timeout + 'ms');
			setTimeout(function()
			{
				if(failed) return;
				armed = true;
				operationCb(failureParam, abortParam);
			}, timeout);
			
			attemptCount += 1;
			timeout *= 2;
		};
		
		var abortParam = function()
		{
			var failed = true;
			failureCb();
		};
		
		operationCb(failureParam, abortParam);
		
		return abortParam;
	},
	
	showFatalErrorDialog: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("Exit")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
			LifecycleEmitter.exitProcess();
		};
		
		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': "File location has changed (302)",
			'400': "Bad request to server (400)",
			'401': "Authorization failed (401)",
			'403': "Server permissions error (403)",
			'404': "Resource not found (404)",
			'408': "Request timed out (408)",
			'500': "Internal server error (500)",
			'501': "Cannot process request (501)",
			'502': "Bad Gateway (502)",
			'503': "Service overloaded / down for maintenance (503)",
			'504': "Timeout at intervening gateway (504)"
		};
		myAlert.setText( Core.Localization.getString( commonErrors[status] || "This application requires a working data connection." ) );
		myAlert.show();
	},

	showSimpleNetworkError: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("OK")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
		};

		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': " File location has changed (302)",
			'400': " Bad request to server (400)",
			'401': " Authorization failed (401)",
			'403': " Server permissions error (403)",
			'404': " Resource not found (404)",
			'408': " Request timed out (408)",
			'500': " Internal server error (500)",
			'501': " Cannot process request (501)",
			'502': " Bad Gateway (502)",
			'503': " Service overloaded / down for maintenance (503)",
			'504': " Timeout at intervening gateway (504)"
		};
		var message = "Cannot download game without network connection.";
		if (commonErrors[status])
		{
			message += commonErrors[status];
		}
		myAlert.setText( Core.Localization.getString( message ) );
		myAlert.show();
	},
	
	getCacheBustingString: function()
	{
		return '?t=' + (new Date()).getTime();
	},

	/*
	 * Ad
	 */
	Ad: {
		Tapjoy: {
			sendActionComplete: function(actionId) {
				var _int_Util = require('NGCore/Client/Network/_int_Util')._int_Util;
				_int_Util.adTapjoySendActionComplete(actionId);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/XHR'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/XHR'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/XHR'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/XHR.js';

////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Util = require('NGCore/Client/Network/Util').Util;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Header = function (item, content)
{
	this.item = item;
	this.content = content;
};
var headerEx = /(.*?): (.*)/;

// Constants
var State =
{
	UNSENT: 0,
	OPENED: 1,
	HEADERS_RECEIVED: 2,
	LOADING: 3,
	DONE: 4
};

// ///////////// Begin HTTP req'd methods of testing! //////
var methods =
[
	"OPTIONS",
	"GET",
	"HEAD",
	"POST",
	"PUT",
	"DELETE",
	"TRACE",
	"CONNECT"
];

var unsecureMethods = ["CONNECT", "TRACE", "TRACK"];

var checkMethod = function(method)
{
	if(!method) return "GET";

	method = method.toString();

	if (method in unsecureMethods)
	{
		throw "SECURITY_ERROR " + method + " not allowed.";
	}
	if (method.toUpperCase() in methods)
	{
		return method.toUpperCase();
	}
	return method;
};

// ////////////////////////// End! /////////////////////

////////////////////////////////////////////////////////////////////////////////

exports.XHR = Class.subclass(
/** @lends Network.XHR.prototype */
{
	classname: 'XHR',
	
	/**
	 * @class The `XHR` class constructs `XmlHttpRequest` objects. Applications can use these
	 * objects to send HTTP or HTTPS requests directly to a web server and load the server response
	 * data directly back into a script. For additional details, see the [W3C XmlHttpRequest
	 * specification](http://www.w3.org/TR/XMLHttpRequest/).
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		this.respHeaders = {};

		this.settings = {};
		this.headers = [];

		// State-associated flags
		this.sendFlag = false;
		this.errorFlag = false;
		
		// Status & response
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 340,
	// Method create = -1
	// Method destroy = 2
	// Method sendStatus = 3
	// Method sendHeaders = 4
	// Method sendData = 5
	// Method onFinish = 6
	// Method start = 7
	// Method header = 8
	// Method setComposition = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._sendStatusRecv( cmd );
					break;
				case 4:
					instance._sendHeadersRecv( cmd );
					break;
				case 5:
					instance._sendDataRecv( cmd );
					break;
				case 6:
					instance._onFinishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[340] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendStatusRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statNum" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "statNum" ] === undefined )
		{
			NgLogE("Could not parse statNum in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "statStr" ] === undefined )
		{
			NgLogE("Could not parse statStr in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendData from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in XHR.sendData from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onFinishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x154ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1540002, this );
	},
	
	/** @private */
	_startSendGen: function( method, url, data, headers )
	{
		Core.Proc.appendToCommandString( 0x1540007, this, [ Core.Proc.encodeString( method ), Core.Proc.encodeString( url ), Core.Proc.encodeString( data ), +headers ] );
	},
	
	/** @private */
	_headerSendGen: function( item, content )
	{
		Core.Proc.appendSubcommandToCommandString( [ Core.Proc.encodeString( item ), Core.Proc.encodeString( content ) ] );
	},
	
	/** @private */
	_setCompositionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1540009, this );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _sendStatusRecv: function( cmd ) {}
	// _sendHeadersRecv: function( cmd ) {}
	// _sendDataRecv: function( cmd ) {}
	// _onFinishRecv: function( cmd ) {}
	// start: function( method, url, data, headers ) {}
	
	// header: function( item, content ) {}
	
	// setComposition: function(  ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,
// API
	/**
	 * Initialize a request for this `XHR`.
	 *
	 * **Note**: Calling `open()` will wipe all request headers. You must set them after making this
	 * call.
	 * @param {String} method The request method (`GET`, `POST`, `OPTIONS`, `HEAD`, `PUT`, `DELETE`,
	 *		`TRACE`, `CONNECT`).
	 * @param {String} url The request URL.
	 * @param {Boolean} [async=true] Set to `true` if the request is synchronous. Set to `false` in
	 *		all other cases. **Note**: Currently not implemented.
	 * @param {String} [user] Username for basic authentication. **Note**: Currently not
	 *		implemented.
	 * @param {String} [password] Password for basic authentication.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	open: function(method, url, async, user, password)
	{
		url = url.split(' ').join('%20');
		this.settings =
		{
			"method": checkMethod(method),
			"url": Util.buildRelativeUrl(url),
			"async": async,
			"user": user,
			"password": password
		};

		this.reset();
		this.setState(State.OPENED);
	},

	/**
	 * @private
	 * Send a request initialized by the `open()` method. 
	 * @param {Array} [composition] Array of strings and file names to be composed into the body.
	 * **Note**: This parameter is ignored if `readyState` is set as `GET` or `HEAD`.
	 * @throws {INVALID_STATE_ERR} If `readyState` is set as anything other than `OPENED` or if the `send()` flag is true.
	 * @see Network.XHR#open
	 * @returns {void}
	 * @status iOS, Android, Flash
	 * @since 1.1.6
	 */
	sendComposition: function(comp)
	{
		// ex: [{"str":"string to send"},{"file":"path/to/file.bin"},{"str":"more goods"}]
		this.composing = true;
		this.send(JSON.stringify(comp));
	},

	/**
	 * Send a request initialized by the `open()` method.
	 * @param {String} [data] The request entity body. **Note**: This parameter is ignored if
	 *		`readyState` is set as `GET` or `HEAD`.
	 * @throws {INVALID_STATE_ERR} If `readyState` is set as anything other than `OPENED` or if the
	 *		`send()` flag is true.
	 * @see Network.XHR#open
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	send: function(data)
	{
		if (this.readyState != State.OPENED || this.sendFlag)
		{
			throw "INVALID_STATE_ERR: " + (this.sendFlag ? "Already sending" : "in state " + this.readyState);
		}
		this.sendFlag = true;

		/* Skip unused code.
		if (data && this.settings.method != "GET" && this.settings.method != "HEAD")
		{
			// TODO http://www.w3.org/TR/XMLHttpRequest/#the-send-method step 3
		}
		*/

		this.errorFlag = false;

	        var i;

		// Set content length header
		if (this.settings.method == "GET" || this.settings.method == "HEAD")
		{
			data = null;
		}
		else if (data)
		{
			var bFound = false;
			for (i in this.headers)
			{
				if (this.headers[i].item == "Content-Type")
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
			{
				this.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			}
		}

		this.responseText = "";

		// Send data to the server
		if (!data)
		{
			data = "";
		}

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		if (this.composing)
			this._setCompositionSendGen();

		this._startSendGen(this.settings.method, this.settings.url, data, this.headers.length);
		for (i in this.headers)
		{
			var obj = this.headers[i];
			this._headerSendGen(obj.item, obj.content);
		}
	}, // this.send() 

	/**
	 * Cancel any existing or pending network activity for this `XHR`. 
	 * This method is invoked using the
	 * [specification outlined by W3C for `abort()`](http://www.w3.org/TR/XMLHttpRequest/#the-abort-method).
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	abort: function()
	{
		this.responseText = null;
		this.errorFlag = true;
		this.headers = [];

		if (this.sendFlag)
		{
			if (this.readyState != State.DONE)
			{
				this.sendFlag = false;
				this.setState(State.DONE);
			}
		}
		this.readyState = State.UNSENT;
	},

	/**
	 * Retrieve a header from the server response.
	 * @param {String} header Name of header to retrieve.
	 * @returns {String} Text of the header or `null` if text does not exist.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getResponseHeader: function(header)
	{
		if (this.readyState > State.OPENED)
		{
			return this.respHeaders[header.toLowerCase()];
		}
		return null;
	},

	/**
	 * Nonstandard: Retrieve the key-value map of all response headers.
	 * @return {Object} A key-value map as an object.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getUnflattenedResponseHeaders: function()
	{
		return this.respHeaders;
	},

	/**
	 * Retrieve all the response headers from a request. This method is invoked using the
	 * [specification outlined by W3C for `getAllResponseHeaders()`](http://www.w3.org/TR/XMLHttpRequest/#the-getallresponseheaders-method).
	 * @return {String} All the response headers from a request.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAllResponseHeaders: function()
	{
		if (this.readyState < State.HEADERS_RECEIVED || this.errorFlag)
		{
			return "";
		}

		var result = "";
		for (var i in this.respHeaders)
		{
			result += i + ": " + this.respHeaders[i] + "\r\n";
		}
		return result.substr(0, result.length - 2);
	},

	/**
	 * Set a header for the request.
	 * @param {String} header The name of the header.
	 * @param {String} value The value of the header.
	 * @see Network.XHR#getRequestHeader
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setRequestHeader: function(header, value)
	{
		this.headers.push(new Header(header, value));
	},

	/**
	 * Retrieve a header from the request.
	 * @param {String} header The name of the header.
	 * @return {String} The value of the header.
	 * @see Network.XHR#setRequestHeader
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getRequestHeader: function(header)
	{
		var ret = null;
		for (var i in this.headers)
		{
			if (this.headers[i].item == header)
			{
				ret = this.headers[i].content;
				break;
			}
		}
		return ret;
	},

// Receivers
    /*
     * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	onStatus: function ( num, str)
	{
		this.status = num;
		this.statusText = str;
	},

	_sendStatusRecv: function( cmd )
	{
		var obj = {};
		this._sendStatusRecvGen(cmd, obj);
		this.onStatus(obj.statNum, obj.statStr);
	},
    /*
     * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	onHeaders: function(str)
	{
		var lines = str.split('\n');
		lines.pop();
		for (var i in lines)
		{
			var match = headerEx.exec(lines[i]);
			if (match)
				this.respHeaders[match[1].toLowerCase()] = match[2];
		}
		this.setState(State.HEADERS_RECEIVED);
	},

	_sendHeadersRecv: function( cmd )
	{
		var obj = {};
		this._sendHeadersRecvGen(cmd, obj);
		this.onHeaders(obj.headers);
	},
    /*
     * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	onData: function(data)
	{
		this.responseText += data;
		this.setState(State.LOADING);
	},

	_sendDataRecv: function( cmd )
	{
		var obj = {};
		this._sendDataRecvGen(cmd, obj);
		this.onData(obj.data);
	},
    /*
     * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	onFinish: function (err)
	{
		this.sendFlag = false;
		if (err)
		{
			this.responseText = null;
			this.error = "Network Error";
			this.errorFlag = true;
			this.status = 0;
		}
		this.setState(State.DONE);
	},

	_onFinishRecv: function( cmd )
	{
		var obj = {};
		this._onFinishRecvGen(cmd, obj);
		this.onFinish(obj.error);
	},

// Internal methods
	/**
	 * Reset all fields from a request. This call sets `readyState` to `UNSENT` and the response
	 * properties to `null`.
	 * @ignore
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	reset: function()
	{
		this.headers = [];
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.composing = false;
	},
	/**
	 * Change the value of `readyState` and call `onreadystatechange()`.
	 * @param {Number} state The new value for `readyState`
	 * @ignore
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 */
	setState: function(state)
	{
		this.readyState = state;
		if (state == State.DONE)
		{
			this._destroySendGen();
			ObjectRegistry.unregister(this);
		}
		if (typeof this.onreadystatechange != 'undefined')
		{
			try
			{
				this.onreadystatechange();
			}
			catch (e)
			{
				NgLogException(e);
			}
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadManifest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] = exports; 
var __dirname = 'NGCore/Client/Network';
var __filename = 'NGCore/Client/Network/DownloadManifest.js';

////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;

// JMarr temporary hack to supress archive downloads on flash.
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Manifest = Class.subclass(
/**
 * @private
 */
{
	classname: 'Manifest',

	/**
	 * @private
	 */
	initialize: function()
	{
    this.mNumAdded = 0;
    this.mNumRemoved = 0;
	},

	/**
	 * @private
	 */
	reset: function ()
	{
		this.mJson = null;
		this.mArchives = null;
	},

	/**
	 * @private
	 */
	initWithJsonText: function ( text, emptyOnFail)
	{
		try
		{
			this.mJson = JSON.parse ( text );
			if (!this.mJson)
			{
				this.mJson = {};
			}
		}
		catch (e)
		{
			this.mJson = {};
		}

		if('__archives' in this.mJson)
		{
			this.mArchives = this.mJson['__archives'].files;
			delete this.mJson['__archives'];
		}
		else
		{
			this.mArchives = [];
		}
	},

	//cb: function ( itemKey, dstList, srcList ), which is compareItems
	//cb returns ! null, then dst[ item ] = cb return value.
	//cb returns null, then delete dst[ item ].
	/**
	 * @private
	 */
	foreach: function ( other, cb )
	{
		var dst = this.mJson;
		var src = other.mJson;
	        var key;
		// Handle all things in src.
		for ( key in src )
		{
			this.handleItem ( key, dst, src, cb );
		}
		// Build up list of all things not in src.
		for ( key in dst )
		{
			// Handle all things not in src.
			if ( ! (key in src) )
			{
				this.handleItem ( key, dst, src, cb );
			}
		}
	},

	/**
	 * @private
	 */
	handleItem: function ( key, dst, src, cb )
	{
		var ret = cb ( key, dst, src );
		if(ret)
		{
      if(ret < 0) {
        this.mNumRemoved++;
        delete dst[ key ];
      } else {
        this.mNumAdded++;
      }
		}
	},

  isModified: function()
  {
    return (this.mNumAdded > 0 || this.mNumRemoved > 0);
  },

	/**
	 * @private
	 */
	write: function ( fname, callback )
	{
		var cb = function (err)
		{
			if (err)
			{
				console.log('Error writing manifest! ' + err);
			}
			if(callback)
			{
				callback();
			}
		};

		if (this.mJson)
		{
			var out = JSON.stringify(this.mJson);
			FileSystem.writeFile(fname, out, {}, cb);
		}
		else
		{
			callback();
		}
	}
});

////////////////////////////////////////////////////////////////////////////////

exports.DownloadManifest = MessageListener.subclass(
/** @lends Network.DownloadManifest.prototype */
{
	classname: 'DownloadManifest',

	/**
	 * @class The `DownloadManifest` class constructs objects that initiate the handling of a
	 * manifest file. This ensures a set of files are kept up-to-date in the specified directory
	 * from the specified URL.
	 * @constructs The default constructor. 
	 * @augments Core.MessageListener
	 * @since 1.0
	 */
	initialize: function()
	{
		this.reset();
	},

	_clearConnections: function()
	{
		for (var i in this.mConnections)
		{
			if(!this.mConnections.hasOwnProperty(i)) continue;
			
			this.mConnections[i].abort();
		}
		this.mConnections = [];
	},

	/**
	 * @private
	 */
	reset: function ()
	{
		this.mConcurrentRequests = 6;

		this.mManifest = null;

		this.mRemoteUrl = null;
		this.mLocalPath = null;
		this.mLocalRoot = null;

		this.mLocalText = null;
		this.mRemoteText = null;
		/** @inner */
		this.mProgressCb = function() {};
		/** @inner */
		this.mDoneCb = function() {};

		this.mPaused = false;
		this.mValid = false;

		this._clearConnections();
		this.mPendingItems = [];
		this.mCompleteBytes = 0;
		this.mTotalBytes = 0;
		
		this.mSpaceNeeded = 0;
		
		this.mNumRemoteManifestFiles = 0;
		this.mNumRemoteManifestBytes = 0;
		
		this.mDownloadArchives = true;
		this.mActiveRequests = [];

		this.mLocalGameList = LocalGameList;

		this.mNewJS = false;
		this.mAppObserver = null;

		this.mRetrySchedule = Util.RetrySchedule(50, 2000);
		this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

		if(this._statusListener)
		{
			this._statusListener.destroy();
			this._statusListener = null;
		}
		this.mCheckUpdateOnly = false;
		this.mCheckUpdateCallback = null;
		this.mDecompCtxId = 0;
	},

	_ensureTrailingSlashes: function(remoteUrl, localPath, secureContentUrl)
	{
		// Check for trailing slashes
		this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';
		// If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
		this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
		this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
	},

	_readLocalManifest: function()
	{
		FileSystem.readFile ( this.mLocalPath, {}, this._onReadLocalManifest.bind(this) );
	},

	_setRemotePath: function(manifestName)
	{
		if (this._secureContentUrl)
		{
			this.mRemotePath = this._secureContentUrl + manifestName;
		}
		else
		{
			this.mRemotePath = this.mRemoteUrl + manifestName;
		}
	},

	_parseManNames: function (man)
	{
		if (typeof man === 'string')
		{
			var obj = {};
			obj[man] = man;
			man = obj;
		}
		return man;
	},

	/**
	 * @private
	 */
	isUpdated: function(remoteUrl, localPath, manifest, doneCB, errorCB)
	{
		this.mCheckUpdateOnly = true;
		this.mCheckUpdateCallback = doneCB;

		this.mDoneCb = (typeof errorCB == 'function') ? errorCB : function() {};
		this.mProgressCb = function(done, left) {};
		var httpStatusCode = 0;
		var fullUrl = remoteUrl + "/configuration.json" + Util.getCacheBustingString();
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				/** @inner */
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						this.mManifest = new Manifest ();
						var manifestUrl = null;
						// Only parse if we got a good response back
						if (req.status == 200 && req.responseText)
						{
							var config = JSON.parse(req.responseText);
							manifestUrl = config.contentUrl;
							if (!manifest)
							{
								manifest =
								{
									"webgame.ngmanifest":
									require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config)
								};
							}

							// If config didn't have contentUrl or we never parsed(local testing), use the base URL
							if (!manifestUrl)
								manifestUrl = remoteUrl;

							manifest = this._parseManNames(manifest);
							var manifestSourceName;
							var manifestName;
							for (var key in manifest)
							{
								manifestSourceName = manifest[key];
								manifestName = key;
								break;
							}

							this._ensureTrailingSlashes(manifestUrl, localPath);
							this.mLocalPath = this.mLocalRoot + manifestName;
							this._setRemotePath(manifestSourceName);
							this._readLocalManifest();
						}
						else if (req.status == 404)
						{
							this._processError('404! Failed to download configuration at '+ fullUrl, false);
						}
						else
						{
							httpStatusCode = req.status;
							failCall();
						}
					}
				}).bind(this);

				req.open ( 'GET', fullUrl, true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ') at ' + fullUrl, false);
			}).bind(this),
			this.mFailEarly
		);

		this.mValid = true;
	},

	// progressCb: function ( completedRequests, totalRequests )
	// doneCb: function ( err, manifest )
	// throws if url/path arguments are null or empty.
	// TODO: Allow headers argument.  Currently null.
	// TODO: Allow HTTP method argument.  Currently GET.
    /**
	 * Start a download of a remote manifest file at `[remoteUrl + manifestName]` and read a local
	 * manifest at `[localPath + manifestName]`.
	 * 
	 * + If the local manifest does not exist, all files specified by the remote manifest are
	 * downloaded.
	 * + If the local manifest does exist, this method will update the file system at `[localPath]`
	 * to match the files specified in the remote manifest.
	 * 
	 * Each file download will trigger a callback function that returns the number of items
	 * downloaded and the total number of items to download. When all downloads are complete, a
	 * second callback function is triggered that returns an error (if any) and the contents of
	 * `[localPath + manifestName]`. If an error does not occur, this function returns `undefined`.
	 *
	 * **Note**: The contents of `[localPath + manifestName]` are saved whether an error occurs or
	 * not.
	 * 
	 * **Important**: It is currently not supported for multiple manifests to refer to the same 
	 * file.  If a file exists in several different manifests this may cause a race condition 
	 * when downloading multiple manifests that will lead to difficult to debug asset issues.
	 * 
	 * @param {String} remoteUrl The URL to a manifest file.
	 * @param {String} localPath The directory path to a manifest file.
	 * @param {String} manifestName The manifest filename. 
	 * @cb {Function} progressCb The function to call when a file has downloaded.
	 * @cb-param {Number} completedRequests The number of completed downloads.
	 * @cb-param {Number} totalRequests The total number of items being downloaded. Includes items 
	 *		that have already been downloaded.
	 * @cb-returns {void}
	 * @cb {Function} doneCb The function to call when all downloads are complete.
	 * @cb-param {String} err The error message, if any.
	 * @cb-param {String[]} manifest The contents of `[localPath + manifestName]`.
	 * @cb-returns {void}
	 * @param {Boolean} disableArchives Set to `true` to disable downloading files using archives.
	 * @param {Boolean} failEarly Set to `true` to reduce the number of times to attempt to download
	 *		files and the timeout length for each request.
	 * @throws {Error} The URL or directory path to the manifest file was empty or missing.
	 * @example
	 * Network.DownloadManifest.start(this._URL, './', this._manifestName,
	 *   progressCb, doneCallback);
	 * @function
	 * @returns {void}
     * @status iOS, Android
	 * @since 1.0
	 */
	start: function ( remoteUrl, localPath, manifest, progressCb, doneCb, disableArchives, failEarly )
	{
		this.mCheckUpdateOnly = false;
		
		// Allow manifestName to be a hash with {manifestDestName: manifestSourceName}
		manifest = this._parseManNames(manifest);
		var manifestSourceName;
		var manifestName;
		for (var key in manifest)
		{
			manifestSourceName = manifest[key];
			manifestName = key;
			break;
		}

		console.log('DownloadManifest.start(', remoteUrl, localPath, manifestSourceName, ')');
		if ( ! remoteUrl || ! localPath || remoteUrl === '' || localPath === '' )
		{
			throw new Error ( 'invalid arguments: ' + JSON.stringify ( arguments ) );
		}

		// Set up instance state for this request.
		this.mManifest = new Manifest ();
		if(disableArchives)
			this.mDownloadArchives = false;
		
		// JMarr temporary hack to disable archive downloads on flash.
		if(Capabilities.getPlatformOS() == 'flash')
		{
			console.log('Flash does not yet support archive downloads');
			this.mDownloadArchives = false;
		}

		this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
		this._setRemotePath(manifestSourceName);
		this.mLocalPath = this.mLocalRoot + manifestName;
		this.mFailEarly = failEarly;

		// try these to prevent a failed update due to bad code
		/** @inner */
		this.mProgressCb = function (done, left)
		{
			try
			{
				progressCb(done, left);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		var that = this;
		/** @inner */
		this.mDoneCb = function (err, man, hadCache)
		{
			try
			{
				// touch the .nomedia file (MOB-1355)
				FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '', {});

				/** @inner */
				this.mProgressCb = function() {};
				/** @inner */
				this.mDoneCb = function() {};
				this._setLifecycleListening(false);
				doneCb(err, man, hadCache);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		this._readLocalManifest();
		this._setLifecycleListening(true);
		this.mValid = true;
	},

	/**
	 * Reinitialize a `Network.DownloadManifest` object.
	 * @returns {void}
	 * @since 1.4.1
	 */
	abort: function()
	{
		this.reset();
	},

	/**
	 * Pause downloading of a download manifest.
	 * @returns {void}
	 * @since 1.4.1
	 */
	pause: function()
	{
		// Cancel downloads
		this._clearConnections();

		// move active requests back to pending
		this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
		this.mActiveRequests = [];

		// Invalidate current unzip operations.
		this.mDecompCtxId++;

		this.mPaused = true;
	},

	/**
	 * Resume downloading of a download manifest.
	 * @returns {void}
	 * @since 1.4.1
	 */
	resume: function()
	{
		if (this.mPaused)
		{
			this.mPaused = false;
			this._downloadPendingItems();
		}
	},

	_setLifecycleListening: function(toListen)
	{
		if (toListen && !this.lifeListening)
		{
			Device.LifecycleEmitter.addListener(this,
				function (event)
				{
					switch (event)
					{
						case Device.LifecycleEmitter.Event.Suspend:
						case Device.LifecycleEmitter.Event.Terminate:
							this._writeManifest();
						break;
					}
				}
			);
			this.lifeListening = true;
		}
		else if (this.lifeListening)
		{
			Device.LifecycleEmitter.removeListener(this);
			this.lifeListening = false;
		}
	},

	_theQuestion: function (toBe)
	{
		return toBe | !toBe;
	},

	_setConfig: function (cfg)
	{
		// For saving after completion
		this._Config = cfg;
		// for skipping JS download
		this._noJS = cfg.omitJsUpdate;
		// For using separate content URL
		this._secureContentUrl = cfg.secureContentUrl;
	},

	// Callback for read of local manifest file in start method.

	_onReadLocalManifest: function ( err, data )
	{
		if (this.mValid)
		{
			try	// always start try block in async callbacks
			{
				if ( ! err )
				{
					this.mLocalText = data;
				}
				else
				{
					this.mLocalText = '{}';	// Empty string is ! null.  It's ok for the read to fail.
				}
				this._downloadManifest();
			}
			catch ( ex )
			{
				NgLogException ( ex );
				this._processError ( 'Error reading local manifest err: ' + err , false );
			}
		}
	},

	// Called to start the manifest download.
	_downloadManifest: function()
	{
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				var id = this.mConnections.push(req) - 1;
				/** @inner */
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						delete this.mConnections[id];
						httpStatusCode = req.status;
						if ( httpStatusCode == 200 )
						{
							this.mRemoteText = req.responseText;
							this._checkItems();

							if (this.mCheckUpdateOnly)
								this._checkUpdate();
							else
								this._evalManifests ();
						}
						else
						{
							console.log( 'Download of manifest at ' + this.mRemotePath
								+Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
								+ req.responseText);
							if (httpStatusCode == 404)
							{
								abortCall();
							}
							else
							{
								failCall();
							}
						}
					}
				}).bind(this);

				req.open ( 'GET', this.mRemotePath + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);
	},

	// Can be called at any time.

	_processError: function ( message , writeManifest)
	{
		if (writeManifest && this.mManifest)
		{
			this._writeManifest();
		}

		// Don't call the doneCB without checking local text
		if (this.mValid)
		{
			this.mDoneCb ( message, null,  this.mLocalText ? this.mLocalText.length > 2 : false );
			this.reset ();
		}
	},

	_checkItems: function()
	{
		// Init source and destination manifests.
		this.mManifest.initWithJsonText ( this.mLocalText , true );
		var other = new Manifest ();
		other.initWithJsonText ( this.mRemoteText );

		// Build list of pending local items.
		this.mManifest.foreach ( other, this._compareItems.bind(this));
	},

	_checkUpdate: function()
	{
		this.mPendingItems = [];
		this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
	},

	_evalManifests: function ()
	{
		try
		{
			// JMarr always download with zips if they are available.
			// If we only need to download less than 33% of files and less than 33% of bytes, then don't use an archive.
			// Additinoally, we must be on wifi, or else carriers might tamper with our files.
			/*var NetworkEmitter = require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter;
			if(this.mPendingItems.length < this.mNumRemoteManifestFiles * 0.33
				&& this.mTotalBytes < this.mNumRemoteManifestBytes * 0.33
				&& NetworkEmitter.getLastStatus() == NetworkEmitter.Status.Wifi)
			{
				this.mDownloadArchives = false;
			}*/
			
			// Cache total bytes into separate variable. Archive download might increase
			// space needed, but not total bytes.
			this.mSpaceNeeded = this.mTotalBytes;

			var other = new Manifest ();
			other.initWithJsonText ( this.mRemoteText );
			// If there is no archive in the manifest, don't download an archive.
			if(!other.mArchives)
				this.mDownloadArchives = false;

			// Prepare for archive downloads. If mDownloadArchives is true,
			// then all files will be downloaded through an archive. Otherwise,
			// only files that are makred as force archive will be downloaded
			// through archive.
			this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);
			
			// Trigger progress callback.
			this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );

			this.mLocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
			{
				if (err)
				{
					this._processError(err, false);
					return;
				}
				var num = this.mPendingItems.length;
				if (num)
				{
					console.log("Going to download %d items.", num);
					if (num < 10)
					{
						console.log("Items: " + JSON.stringify(this.mPendingItems));
					}
				}
				// Download anything that got into pending list
				this._downloadPendingItems ();
			}).bind(this));
		}
		catch (e)
		{
			NgLogException ( e );
			this.mDoneCb ( 'Failed processing manifests!', null );
		}
	},
	
	// Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
	_prepareForArchiveDownload: function(archives, onlyForcedFiles)
	{
		console.log('DownloadManfiest._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
		// Iterate over files that need to be covered and make sure they are included.
		var neededFiles = [];
		var includedArcns = {};
		var includedExpSize = 0;
		var includedArcSize = 0;
		var filesToCover = this.mPendingItems;
		var nonForcedFiles = [];
	        var f;
		for(var i=0; i < filesToCover.length; ++i)
		{
			// If this file isn't an archive, just download the file.
			f = filesToCover[i];
			if(!f.arcn)
			{
				//console.log('NonForced: including arnc-less %s', f.name);
				neededFiles.push(f);
				includedExpSize += f.size;
				continue;
			}
			
			// Record that this archive provides this file.
			var arcn = f.arcn;
			var a = archives[arcn];
			if(!a.files)
				a.files = [f];
			else
				a.files.push(f);
			
			// Is this archive already incldued?
			if(includedArcns[arcn])
				continue;
			
			// If we are only including forced files, remember that this
			// is a non forced file that we need to download. If after evaluating
			// all of the forced files and these files are not included, they will
			// be explicitly included.
			if(onlyForcedFiles && !f.arcForce)
			{
				nonForcedFiles.push(f);
				//console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('Forced: including %s from arcn %d', f.name, f.arcn);
			
			// Include the archive associated with this arcn.
			neededFiles.push(a);
			includedArcns[arcn] = true;
			includedExpSize += a.expSize;
			includedArcSize += a.arcSize;
		}
		
		// If only downloading forced archives, examine all of the queued
		// files that are not forced. If their archive is not included, then 
		// directly include the file.
		for(i=0; i < nonForcedFiles.length; ++i)
		{
			// Is the archive for this file already incldued?
			// This will happen if a forced file (like a .js) 
			// forced the archive to be included.
			f = nonForcedFiles[i];
			if(includedArcns[f.arcn])
			{
				//console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('NonForced: including %s from arch %d', f.name, f.arcn);
			
			// Otherwise, include this file.
			neededFiles.push(f);
			includedExpSize += f.size;
		}
		
		// Tell the rest of the world about our choices.
		this.mPendingItems = neededFiles;
		this.mTotalBytes = includedExpSize;
		this.mSpaceNeeded = includedExpSize + includedArcSize;
	},

	// Callback from Manifest.foreach.

	_compareItems: function ( key, dst, src )
	{
		var ditem = dst[key];
		var sitem = src[key];

		// Early out for removed file.  Always delete.
		if ( ! sitem )
		{
			var fname = this.mLocalRoot + key;
			var cb = function(err)
			{
				if (err)
				{
					console.log('Error deleting ' + fname + ' error: ' + err);
				}
			};
			FileSystem.deleteFile(fname, {}, cb);

			// If the item was pending, delete the temporary file it was downloading
			if ('pending' in ditem )
			{
				fname = fname + '.tmp';
				FileSystem.deleteFile(fname, {}, cb);
			}
			return -1; // removed
		}

		var isJS = this._extensionMatch ( key, 'js' );

		// Don't download the html or the js with noJS.
		if (this._noJS && (isJS || key == "index.html"))
		{
			// Don't download JS!! keep it in the local manifest, but don't push it to download
			return 0; // no change
		}

		sitem.name = key;
		this.mNumRemoteManifestFiles += 1;
		this.mNumRemoteManifestBytes += sitem.size;

		// No local version or version mismatch, must download.
		if ( ! ditem || ditem.hash != sitem.hash)
		{
			if ( isJS )
			{
				this.mNewJS = true;
			}

			// Tally the space we need for downloading new items
			this.mTotalBytes += sitem.size;

			// Add to the pending queue.
			this.mPendingItems.push ( sitem );

      return 1; // added
		}
		
		return 0; // no chage
	},

	// Utility method to check for case-insensitive match for file extension.
	
	_extensionMatch: function ( fname, ext )
	{
		var pattern = new RegExp ( '^.*\\.(' + ext + ')$', 'i' );
		var ret = fname.match ( pattern );
		return ret;
	},

	// Once in download state, this method is called to start downloading 
	// assets from manifest.  When each asset successfully completes, this method
	// will also be called to start the next download.  This method institutes
	// the logic for having a limited number of concurrent downloads from
	// the mCurrentRequests and mConcurrentRequests members.

	_downloadPendingItems: function ()
	{
		if (this.mValid && !this.mPaused)
		{
			// Are we done?
			if ( this.mPendingItems.length === 0 && this.mActiveRequests.length === 0)
			{
				var cb = function()
				{
					this._writeConfig(function()
					{
						// Trigger done callback and reset.
						this.mDoneCb ( null, this.mManifest );
						this.reset ();
					}.bind(this));
				}.bind(this);

				//if (this.mTotalBytes > 0)
				if(this.mManifest && this.mManifest.isModified())
				{
					this._writeManifest ( cb );
				}
				else
				{
					FileSystem.registerManifest ( this.mLocalPath );
					cb();
				}
				return;
			}

			// Not done, pop more pending items and start their downloads.
			while ( this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests )
			{
				// Download the next pending file.
				var item = this.mPendingItems.pop ();
				item.retrySchedule = this.mRetrySchedule.slice(0);
				this._downloadItem(item);
			}
		}
	},
	
	_downloadItem: function(item)
	{
		this.mActiveRequests.push(item);
		var remoteUrl = this.mRemoteUrl + item.name;
		if(item.mangled)
		{
			var i = remoteUrl.lastIndexOf('.');
			remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i+1) + '.bin';
		}

		Util.OperationWithRetries((function(failCb)
		{
			// Start the download.
			var dlFile = new DownloadFile();
			var id = this.mConnections.push(dlFile) - 1;
			dlFile.start(this.mLocalRoot + item.name,
				'GET',
				remoteUrl + Util.getCacheBustingString(),
				[],
				this._onDownloadItemComplete.bind(this, item, failCb, id));
		}).bind(this), (function()
		{
			console.log('Manifest download failed. Too many failed download attempts for ' + item.name );
			this._processError ( 'Could not download file ' + item.name , true);
		}).bind(this), this.mFailEarly);
	},

	_removeActiveRequest: function (item)
	{
		for (var i in this.mActiveRequests)
		{
			if (item == this.mActiveRequests[i])
			{
				this.mActiveRequests.splice(i, 1);
			}
		}
	},

	// Callback for completion of download started in downloadItem method.
	// Will throw if item does not have pending member set.

	_onDownloadItemComplete: function ( item, failCb, id, status, hash )
	{
		var decompCtxId = this.mDecompCtxId;
		try
		{
			delete this.mConnections[id];
			// Was there an error or bad download?
			if(status != 200 || item.hash != hash)
			{
				// Try to download the item again.
				console.log('Download failed.  Retrying ' + item.name );
				console.log('Status: ' + status + ' manifest hash: ' + JSON.stringify(item.hash) + ' actual hash: ' + JSON.stringify(hash));
				failCb();
				return;
			}
			
			// Is this an archive?
			if(item.files)
			{
				// Temporarially increase the max number of connections while we decompress the archive.
				++this.mConcurrentRequests;
				this._downloadPendingItems();
				
				FileSystem.decompressFile(this.mLocalRoot + item.name, this.mLocalRoot, { returnFiles:false }, (function(err, files)
				{
					// Restore max connections to original value.
					--this.mConcurrentRequests;
					
					if(decompCtxId !== this.mDecompCtxId) {
						return;
					}

					// Delete the zip file.
					FileSystem.deleteFile(this.mLocalRoot + '/' + item.name, {});

					if(err)
					{
						// Try to download the item again.
						console.log('Decompress failed.  Retrying ' + item.name );
						failCb();
					}
					else
					{
						for(var i=0; i < item.files.length; ++i)
						{
							var f = item.files[i];
							this.mManifest.mJson[f.name] = {size: f.size, hash: f.hash};
							if (typeof f.encryption != "undefined")
								this.mManifest.mJson[f.name].encryption = f.encryption;
							if (typeof f.is_code != "undefined")
								this.mManifest.mJson[f.name].is_code = f.is_code;
						}

						this._removeActiveRequest(item);
						this.mCompleteBytes += Number(item.expSize);
						this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
						this._downloadPendingItems ();
					}
				}).bind(this));
			}
			else
			{
				// Update our working manifest.
				this.mManifest.mJson[item.name] = {size: item.size, hash: item.hash};
			    if (typeof item.encryption != "undefined")
					this.mManifest.mJson[item.name].encryption = item.encryption;
				if (typeof item.is_code != "undefined")
					this.mManifest.mJson[item.name].is_code = item.is_code;

				// Make callbacks (like a boss).
				this._removeActiveRequest(item);
				this.mCompleteBytes += Number(item.size);
				this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
				this._downloadPendingItems ();
			}
		}
		catch ( ex )
		{
			// Unlikely, but safety
			NgLogException ( ex );
			this._processError ( 'Error after finishing the download of item ' + item 
				+ '. status is ' + status , true );
		}
	},

	// Flush changes to locally cached manifest file.

	_writeManifest: function ( callback )
	{
		console.log("DM Complete!");
		try
		{
			if (this.mManifest) {
				var onComplete = function () {
					FileSystem.registerManifest ( this.mLocalPath );
					if (callback)
						callback.apply(this, arguments);
				};
				this.mManifest.write ( this.mLocalPath, onComplete.bind(this) );
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	},

	_writeConfig: function ( callback )
	{
		try
		{
			if (this._Config)
			{
				// console.log("writing |%s| to %s", JSON.stringify(this._Config), this.mLocalRoot + Capabilities._getConfigFile());
				FileSystem.writeFile(this.mLocalRoot + Capabilities._getConfigFile(),
					JSON.stringify(this._Config), {}, function(err) {
						console.log(err);
						if(callback)
						{
							callback();
						}
					} );
			}
			else
			{
				if(callback)
				{
					callback();
				}
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Node'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Node'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Node'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Node.js';

var Core = require('NGCore/Client/Core').Core;


var Node = exports.Node = Core.Class.subclass(
/** @lends GL2.Node.prototype */
{
	classname: 'Node',

	/**
	 * @class The `GL2.Node` class creates objects that can be used as containers to group,
	 * organize, and transform other components of a `GL2` scene. It also serves as a base class for
	 * the following classes:
	 *
	 * + `{@link GL2.Primitive}`
	 * + `{@link GL2.Sprite}`
	 * + `{@link GL2.Text}`
	 *
	 * The components of a `GL2` scene are organized into a tree of nodes, or a scene graph. The
	 * scene graph's organization affects how the scene's components are displayed. For example, if
	 * a sprite is assigned to a node that has been rotated, the sprite will also be rotated. The
	 * absolute position of a node is determined by the following properties of the node and its
	 * ancestors, which are applied in this order:
	 *
	 * 1. Scaling factors for width and height (see `{@link GL2.Node#setScale}`)
	 * 2. Rotation (see `{@link GL2.Node#setRotation}`)
	 * 3. Position (see `{@link GL2.Node#setPosition}`)
	 *
	 * To determine the final transform for a node, `GL2` takes the node's properties, then combines
	 * them with the properties of all of the node's ancestors. Although `GL2.Node` objects do not
	 * have a visual representation, all of their properties contribute to the combined transform.
	 *
	 * As a result, when you set or retrieve a node's properties, keep in mind that the properties
	 * are being defined relative to the node's ancestors. For example, if a parent node has its
	 * origin at the coordinate `(50, 50)` within the global scene, and you create a child node
	 * whose origin is set to `(25, 25)`, the child node will be drawn at the coordinate `(75, 75)`
	 * within the global scene; its position is relative to its ancestors' positions.
	 *
	 * Each node also has a depth property, which controls the order of drawing and touch events.
	 * When nodes are drawn, nodes with a lower depth are obscured by nodes with a higher depth. In
	 * contrast, touch events give priority to the top node in the stack; they propagate downward
	 * from the node with the highest depth to the node with the lowest depth. At any point, a touch
	 * target can capture the touch event and prevent it from propagating further. See
	 * `{@link GL2.TouchTarget#getTouchEmitter}` for more information about capturing touch events.
	 *
	 * **Note**: If a clipping rectangle has been applied to the node, it will affect both drawing
	 * and touch events. See `{@link GL2.Node#setClipRect}` for details.
	 *
	 * By default, nodes are grouped with their siblings, and they are sorted relative to their
	 * parent node as though the parent node had a depth of `0`. You can call
	 * `{@link GL2.Node#setChildrenDepthGrouped}` to modify this behavior.
	 *
	 * Nodes can exist independent of the scene graph. However, a node will not be displayed and
	 * cannot receive touch events unless it is attached to the root of the scene graph, either
	 * directly or through a parent node. See `{@link GL2.Root}` for details about the root of the
	 * scene graph.
	 *
	 * All nodes have a corresponding native object in ngCore's native layer. As a result, creating
	 * and destroying large numbers of nodes can affect an application's performance. If you are
	 * removing a node from the scene graph, but you will need to display the node again, you should
	 * normally avoid calling `{@link GL2.Node#destroy}` and then recreating the node. Instead,
	 * remove the node from the scene graph, or specify that the node is not visible or touchable,
	 * then display the node again later.
	 * @constructs Create a node.
	 * @augments Core.Class
	 * @since 1.0
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
        this._parent = null;
        this._position = new Core.Point();
        this._scale = new Core.Vector(1, 1);
        this._color = new Core.Color(1, 1, 1);
        this._alpha = 1;
        this._rotation = 0;
        this._depth = 0;
        this._visible = true;
        this._touchable = true;

        this._childrenDepthGrouped = true;
        this._children = [];

		this._clipRect = new Core.Rect(0, 0, -1, -1);
        this._clipRectEnabled = false;

		this._createSendGen(this.__objectRegistryId);

    },

	/**
	 * Remove the node's children (if any), detach the node from its parent (if any), and destroy
	 * the node, releasing the resources allocated by the node.
	 *
	 * **Important**: Destroying a node does not destroy the node's children.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		var children = this._children;
		while(children.length)
		{
			this.removeChild(children[0]);
		}

		if(this._parent)
		{
			this._parent.removeChild(this);
		}

		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the node's position, measured at its upper left corner.
	 * @returns {Core.Point} The node's current position, measured at its upper left corner.
	 * @see GL2.Node#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getPosition: function()
	{
		return this._position;
	},

	/**
	 * Retrieve the node's scaling factor, represented as a multiple of the node's width and height.
	 * @returns {Core.Vector} The current scaling factor for the node's width and height.
	 * @see GL2.Node#setScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getScale: function()
	{
		return this._scale;
	},

	/**
	 * Retrieve the node's RGB color. Although `GL2.Node` objects are not rendered to the screen,
	 * the color is used to transform the color of child nodes.
	 * @returns {Core.Color} The node's current RGB color.
	 * @see GL2.Node#setColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getColor: function()
	{
		return this._color;
	},

	/**
	 * Retrieve the node's opacity.
	 * @returns {Number} The node's current opacity, expressed as a float ranging from `0.0`, or
	 *		completely transparent, to `1.0`, or completely opaque.
	 * @see GL2.Node#setAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAlpha: function()
	{
		return this._alpha;
	},

	/**
	 * Retrieve the node's rotation, measured in degrees about the Z axis.
	 * @returns {Number} The node's current rotation, expressed as a float representing degrees.
	 * @see GL2.Node#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getRotation: function()
	{
		return this._rotation;
	},

	/**
	 * Retrieve the node's depth.
	 * @returns {Number} The node's current depth, expressed as a float.
	 * @see GL2.Node#setDepth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getDepth: function()
	{
		return this._depth;
	},

	/**
	 * Determine whether the node is visible.
	 * @returns {Boolean} Set to `true` if the node is visible.
	 * @see GL2.Node#setVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getVisible: function()
	{
		return this._visible;
	},

	/**
	 * Determine whether the node will receive touch events.
	 * @returns {Boolean} Set to `true` if the node will receive touch events.
	 * @see GL2.Node#setTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getTouchable: function()
	{
		return this._touchable;
	},

	/**
	 * Determine whether node trees and their children will be displayed based on the depth of their
	 * top-level nodes.
	 * @returns {Boolean} Set to `true` if node trees and their children will be displayed based on
	 *		the depth of their top-level nodes. Set to `false` if node trees that share the same
	 *		parent will be interleaved.
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getChildrenDepthGrouped: function()
	{
		return this._childrenDepthGrouped;
	},

	/**
	 * Retrieve the node's clipping rectangle, which is defined based on the global scene's
	 * coordinate system.
	 * @returns {Core.Rect} The current clipping rectangle, defined based on the global scene's
	 *		coordinate system.
	 * @see GL2.Node#setClipRect
	 * @status iOS, Android
	 * @since 1.4.1
	 */
	getClipRect: function()
	{
		return this._clipRect;
	},

	/**
	 * Determine whether the node's clipping rectangle is enabled.
	 * @returns {Boolean} Set to `true` if the node's clipping rectangle is enabled.
	 * @see GL2.Node#setClipRectEnabled
	 * @status iOS, Android
	 * @since 1.4.1
	 */
	getClipRectEnabled: function()
	{
		return this._clipRectEnabled;
	},

	/**
	 * Retrieve the node's parent node.
	 * @returns {GL2.Node} The current parent node, or `null` if the node does not have a parent
	 *		node.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getParent: function()
	{
		return this._parent;
	},

	/**
	 * Retrieve the node's children.
	 * @returns {Object[]} The node's current children.
	 * @status Flash, Test, FlashTested
	 * @since 1.1.6
	 */
	getChildren: function()
	{
		return this._children.slice();
	},


    /**
	 * Set the node's position, measured at its upper left corner. By default, the node's
	 * position is set to `(0, 0)`.
	 * @example
	 * var node = new GL2.Node();
	 * // Set the node's position using a Core.Point object.
	 * node.setPosition(new Core.Point(50, 100));
	 * // Set the node's position using two numbers.
	 * node.setPosition(25, 25);
	 * @param {Core.Point|Number} position The node's new position, measured at its upper left
	 *		corner. Specified as a `{@link Core.Point}` object or as two separate floats that
	 *		represent the X and Y coordinates of the origin, in that order.
	 * @returns {this}
	 * @see GL2.Node#getPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setPosition: function(x, y)
	{
		var p = this._position;
		switch (arguments.length) {
		case 1:
			p.setAll(x);
			break;
		case 2:
			p.setAll(x, y);
			break;
		default:
			p.setAll.apply(p, arguments);
			break;
		}
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},

    /**
	 * Set the node's scaling factor, represented as a multiple of the node's width and height. The
	 * node is scaled from its anchor point. By default, the node's scaling factor is set to
	 * `[1, 1]`, meaning that it is not scaled.
	 * @example
	 * var node = new GL2.Node();
	 * // Set the node's scale using a Core.Vector object.
	 * node.setScale(new Core.Vector(2, 0.5));
	 * // Set the node's scale using two numbers.
	 * node.setScale(3, 2);
	 * @param {Core.Vector|Number} scale The new scaling factor for the node's width and height.
	 *		Specified as a `{@link Core.Vector}` object or as two separate floats that represent
	 *		the X and Y scaling factors, or a single float which represents both X and Y scaling factors.
	 * @returns {this}
	 * @see GL2.Node#getScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setScale: function(scale)
	{
		var s = this._scale;
		if (typeof scale === 'number' && arguments.length === 1) {
			s.setAll(scale, scale);
		} else {
			s.setAll.apply(s, arguments);
		}
		this._setScaleSendGen(s.getX(), s.getY());
		return this;
	},
	/**
	 * Set the node's RGB color. The RGB values of each pixel in a child node are multiplied by the
	 * RGB values for the parent node. By default, the color is set to `[1, 1, 1]`, which does not
	 * affect the color of child nodes.
	 * @example
	 * // Draw an orange node using a Core.Color object.
	 * var node = new GL2.Node();
	 * node.setColor(new Core.Color(1.0, 0.5, 0));
	 * // Draw a purple text area by specifying the text area's RGB values
	 * // individually. GL2.Text objects inherit the setColor() method from
	 * // GL2.Node.
	 * var text = new GL2.Text();
	 * text.setColor(0.5, 0. 1.0);
	 * // Add the purple text area as a child of the orange node. The nodes' RGB
	 * // colors are multiplied by one another, and the resulting color is dark red:
	 * // ((1.0 * 0.5), (0.5 * 0), (0 * 1.0)) = (0.5, 0, 0). The text is displayed
	 * // in dark red.
	 * node.addChild(text);
	 * @param {Core.Color|Number} color The node's new RGB color. Specified as a
	 *		`{@link Core.Color}` object or as three separate floats that represent the red, green,
	 *		and blue values of the color, in that order; each float can range from `0` to `1`.
	 * @returns {this}
	 * @see GL2.Node#getColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setColor: function(color)
	{
		var c = this._color;
		c.setAll.apply(c, arguments);
		this._setColorSendGen(c.getRed(),c.getGreen(),c.getBlue());
		return this;
	},
    /**
	 * Set the node's opacity. The pixels in a parent node are individually blended with the pixels
	 * in a child node based on their opacity. By default, the node's opacity is `1`, or fully
	 * opaque.
	 * @example
	 * // Draw red text below a white node that has an opacity of 0.5, resulting in
	 * // pink text. Note that the GL2.Text object inherits the setColor() method
	 * // from GL2.Node.
	 * var node = new GL2.Node();  // defaults to a fully opaque white background
	 * node.setAlpha(0.5);
	 * var text = new GL2.Text();
	 * text.setColor(1.0, 0, 0);
	 * node.addChild(text);
	 * @param {Number} alpha The node's new opacity, expressed as a float ranging from `0.0`, or
	 *		completely transparent, to `1.0`, or completely opaque.
	 * @returns {this}
	 * @see GL2.Node#getAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setAlpha: function(alpha)
	{
		this._alpha = alpha;
		this._setAlphaSendGen(alpha);
		return this;
	},

    /**
	 * Set the node's rotation, measured in degrees about the Z axis. By default, the node's
	 * rotation is `0`.
	 * @example
	 * // Rotate a node by 45 degrees.
	 * var node = new GL2.Node();
	 * node.setRotation(45);
	 * @example
	 * // Rotate a node by 0.5 radians (approximately 28.65 degrees).
	 * function radiansToDegrees(radians) {
	 *     return radians * (180 / Math.PI);
	 * }
	 *
	 * var node = new GL2.Node();
	 * node.setRotation(radiansToDegrees(0.5));
	 * @param {Number} rotation The node's new rotation, expressed as a float representing degrees.
	 * @returns {this}
	 * @see GL2.Node#getRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},

    /**
	 * Set the node's depth. If two nodes have the same depth, nodes will be sorted based on
	 * their indexes; nodes with lower indexes will be treated as if they had a lower depth. By
	 * default, the node's depth is `0`.
	 *
	 * Nodes with lower depths will be drawn under nodes with higher depths. If a touch event falls
	 * within two nodes, the node with the higher depth will receive the touch event first; if that
	 * node does not capture the touch event, it propagates to the node with the lower depth.
	 *
	 * **Note**: To control how child nodes are interleaved, call
	 * `{@link GL2.Node#setChildrenDepthGrouped}`.
	 * @example
	 * // Create a parent node with two child nodes, each of which has a
	 * // different depth.
	 * var parentNode = new GL2.Node(),
	 *     childNodeLow = new GL2.Node(),
	 *     childNodeHigh = new GL2.Node();
	 * parentNode.addChild(childNodeLow).addChild(childNodeHigh);
	 * childNodeLow.setDepth(10);  // drawn below childNodeHigh; receives touch
	 *                             // events second
	 * childNodeHigh.setDepth(20); // drawn above childNodeLow; receives touch
	 *                             // events first
	 * @param {Number} depth The node's new depth, expressed as a float.
	 * @returns {this}
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @see GL2.Node#getDepth
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setDepth: function(depth)
	{
		if(this._depth != depth)
		{
			this._depth = depth;
			this._setDepthSendGen(depth);
		}
		return this;
	},

    /**
	 * Set whether the node is visible. By default, the node is visible.
	 * @param {Boolean} visible Set to `true` to make the node visible.
	 * @returns {this}
	 * @see GL2.Node#getVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setVisible: function(visible)
	{
		if(this._visible != visible)
		{
			this._visible = visible;
			this._setVisibleSendGen(visible);
		}
		return this;
	},

    /**
	 * Set whether the node will receive touch events. By default, the node receives touch
	 * events.
	 *
	 * **Important**: Nodes that do not receive touch events have better performance than nodes
	 * that receive touch events. If a node and its children do not need to support touch input,
	 * call this method and set the value of `touchable` to `false`.
	 * @param {Boolean} touchable Set to `true` to enable touch events for the node.
	 * @returns {this}
	 * @see GL2.Node#getTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setTouchable: function(touchable)
	{
		this._touchable = touchable;
		this._setTouchableSendGen(touchable);
		return this;
	},

	/**
	 * Set whether to display node trees and their children based on the depth of their top-level
	 * nodes. By default, this option is set to `true`.
	 *
	 * When `childrenDepthGrouped` is set to `true`, children are always grouped based on the depth
	 * of their parent node. For example, suppose that a scene graph includes two node trees, Y and
	 * Z, that share node X as their parent and have the same depth. However, node tree Z has a
	 * higher index:
	 *
	 *     Node X
	 *     +-- Node Y (depth = 0, index = 0)
	 *     |   +-- shadow sprite (depth = 10)
	 *     |   +-- character sprite (depth = 20)
	 *     |
	 *     +-- Node Z (depth = 0, index = 1)
	 *         +-- shadow sprite (depth = 10)
	 *         +-- character sprite (depth = 20)
	 *
	 * If `childrenDepthGrouped` is set to `true`, Z and its children will all be displayed on top 
	 * of Y and its children, regardless of the depth of Y and Z's child nodes. The drawing order
	 * for the entire scene graph will be as follows:
	 *
	 * 1. Node Z character sprite
	 * 2. Node Z shadow sprite
	 * 3. Node Z
	 * 4. Node Y character sprite
	 * 5. Node Y shadow sprite
	 * 6. Node Y
	 * 7. Node X
	 *
	 * When this option is set to `false`, two node trees that share the same parent will be
	 * interleaved with one another when they are drawn. With the scene graph shown above, nodes Y
	 * and Z, as well as their children, will be interleaved with one another based on their depth
	 * and indexes. Because the character sprites have a depth of `20`, they will be drawn on top of
	 * the shadow sprites, which have a depth of `10`. The drawing order for the entire scene graph
	 * will be as follows:
	 *
	 * 1. Node Z character sprite
	 * 2. Node Y character sprite
	 * 3. Node Z shadow sprite
	 * 4. Node Y shadow sprite
	 * 5. Node Z
	 * 6. Node Y
	 * 7. Node X
	 * @param {Boolean} childrenDepthGrouped Set to `true` to display node trees and their children
	 *		based on the depth of their top-level nodes. Set to `false` to interleave node trees
	 *		that share the same parent.
	 * @returns {this}
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setChildrenDepthGrouped: function(childrenDepthGrouped)
	{
		if(this._childrenDepthGrouped != childrenDepthGrouped)
		{
			this._childrenDepthGrouped = childrenDepthGrouped;
			this._setChildrenDepthGroupedSendGen(childrenDepthGrouped);
		}
		return this;
	},

	/**
	 * Add a child node.
	 * @example
	 * var parentNode = new GL2.Node(),
	 *     childNode = new GL2.Node();
	 * parentNode.addChild(childNode);
	 * @param {Object} child The child node to add. This parameter must contain an object instance
	 *		that inherits from `GL2.Node`.
	 * @returns {this}
	 * @see GL2.Node#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	addChild: function(child)
	{
		// Add to children list.
		this._children.push(child);

		// Tell child.
		child._didAddToParent(this);

		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));

		return this;
	},

	/**
	 * Remove a child node and its descendants from the node.
	 * @example
	 * var parentNode = new GL2.Node(),
	 *     childNode = new GL2.Node();
	 * parentNode.addChild(childNode);
	 * // To remove childNode from parentNode:
	 * parentNode.removeChild(childNode);
	 * @param {Object} child The child node to remove from the node. This parameter must contain an
	 *		object instance that is a child of the node and that inherits from `GL2.Node`.
	 * @throws {Error} The specified node is not a child node.
	 * @returns {this}
	 * @see GL2.Node#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	removeChild: function(child)
	{
		// Tell child.
		child._willRemoveFromParent();

		// Remove from children list.
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);

		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));

		return this;
	},

	/**
	 * Translate a location in the global scene's coordinate space to the node's local coordinate
	 * space.
	 * @param {Core.Point} location The location in the global scene to transform.
	 * @returns {Core.Point} The location's coordinate within the node's local coordinate space.
	 * @see GL2.Node#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	screenToLocal: function(location)
	{
		var parent = this._parent;
		if(!parent)
			return undefined;

		location = parent.screenToLocal(location);
		if(!location)
			return undefined;

		var x = location.getX();
		var y = location.getY();

		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();

		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;

		// Undo scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();

		return new Core.Point(x, y);
	},

	/**
	 * Translate a location in the node's local coordinate space to the global scene's coordinate
	 * coordinate space. Use this method to translate between two local coordinate spaces.
	 * @param {Core.Point} location The location in the node's local coordinate space to transform.
	 * @returns {Core.Point} The location's coordinate within the global scene's coordinate space.
	 * @see GL2.Node#screenToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	localToScreen: function(location)
	{
		var x = location.getX();
		var y = location.getY();

		// Undo scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();

		// Undo rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;

		// Undo translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();

		var parent = this._parent;
		if(!parent)
			return undefined;

		location = parent.localToScreen(new Core.Point(x, y));
		if(!location)
			return undefined;
		return location;
	},

    /**
	 * Set the node's clipping rectangle, which is defined based on the global scene's coordinate
	 * system. The clipping rectangle does not inherit scaling and rotation from its ancestor nodes.
	 * By default, the clipping rectangle is set to `(0, 0, -1, -1)`, which does not clip any
	 * portion of the node.
	 *
	 * When an application specifies a clipping rectangle, then enables it by calling
	 * `{@link GL2.Node#setClipRectEnabled}`, content outside of the clipping rectangle is not
	 * drawn, and touch targets outside of the clipping rectangle do not respond to touch inputs.
	 *
	 * If one or more ancestor nodes have a clipping rectangle enabled, the clipping rectangle used
	 * for rendering and touch input will be the intersection of the node's clipping rectangle and
	 * the ancestor nodes' clipping rectangles.
	 * @example
	 * var node = new GL2.Node();
	 * node.setClipRect(new Core.Rect(0, 28, 100, 32));
	 * @param {Core.Rect} rect The new clipping rectangle, defined based on the global scene's
	 *		coordinate system.
	 * @returns {this}
	 * @see GL2.Node#getClipRect
	 * @see GL2.Node#setClipRectEnabled
	 * @status iOS, Android
	 * @since 1.4.1
	 */
	setClipRect: function(rect)
	{
		var cr = this._clipRect;
		cr.setAll.apply(cr, arguments);

		var o = cr.getOrigin();
		var s = cr.getSize();
		this._setClipRectSendGen(o.getX(), o.getY(), s.getWidth(), s.getHeight());

		return this;
	},

    /**
	 * Set whether the node's clipping rectangle is enabled. By default, the clipping rectangle is
	 * not enabled.
	 * @param {Boolean} clipRectEnabled Set to `true` to enable the node's clipping rectangle.
	 * @returns {this}
	 * @see GL2.Node#getClipRectEnabled
	 * @see GL2.Node#setClipRect
	 * @status iOS, Android
	 * @since 1.4.1
	 */
	setClipRectEnabled: function(clipRectEnabled)
	{
		if(this._clipRectEnabled != clipRectEnabled)
		{
			this._clipRectEnabled = clipRectEnabled;
			this._setClipRectEnabledSendGen(clipRectEnabled);
		}
		return this;
	},

	_didAddToParent: function(parent)
	{
		if(this._parent)
			this._parent.removeChild(this);

		this._parent = parent;
	},

	_willRemoveFromParent: function()
	{
		this._parent = null;
	},

	_synchronizeNodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
		this._rotation = msg.rotation;
	},

	_synchronizeNodePosRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodePosRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
	},

	_synchronizeNodeRotRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRotRecvGen(cmd, msg))
			return;
		this._rotation = msg.rotation;
	},

	_synchronizeNodeScaleRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeScaleRecvGen(cmd, msg))
			return;
		this._scale.setAll(msg.sx, msg.sy);
	},

	_synchronizeNodeAlphaRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeAlphaRecvGen(cmd, msg))
			return;
		this._alpha = msg.alpha;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 307,
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setScale = 4
	// Method setColor = 5
	// Method setAlpha = 6
	// Method setRotation = 7
	// Method setDepth = 8
	// Method setVisible = 9
	// Method setTouchable = 10
	// Method setChildrenDepthGrouped = 11
	// Method addChild = 12
	// Method removeChild = 13
	// Method synchronizeNode = 14
	// Method setClipRect = 15
	// Method setClipRectEnabled = 16
	// Method synchronizeNodePos = 17
	// Method synchronizeNodeRot = 18
	// Method synchronizeNodeScale = 19
	// Method synchronizeNodeAlpha = 20
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 14:
					instance._synchronizeNodeRecv( cmd );
					break;
				case 17:
					instance._synchronizeNodePosRecv( cmd );
					break;
				case 18:
					instance._synchronizeNodeRotRecv( cmd );
					break;
				case 19:
					instance._synchronizeNodeScaleRecv( cmd );
					break;
				case 20:
					instance._synchronizeNodeAlphaRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[307] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_synchronizeNodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_synchronizeNodePosRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNodePos from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNodePos from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNodePos from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_synchronizeNodeRotRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNodeRot from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNodeRot from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_synchronizeNodeScaleRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNodeScale from command: " + cmd );
			return false;
		}
		
		obj[ "sx" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "sx" ] === undefined )
		{
			NgLogE("Could not parse sx in Node.synchronizeNodeScale from command: " + cmd );
			return false;
		}
		
		obj[ "sy" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "sy" ] === undefined )
		{
			NgLogE("Could not parse sy in Node.synchronizeNodeScale from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_synchronizeNodeAlphaRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNodeAlpha from command: " + cmd );
			return false;
		}
		
		obj[ "alpha" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "alpha" ] === undefined )
		{
			NgLogE("Could not parse alpha in Node.synchronizeNodeAlpha from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x133ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1330002, this );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1330003, this, [ +x, +y ] );
	},
	
	/** @private */
	_setScaleSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1330004, this, [ +x, +y ] );
	},
	
	/** @private */
	_setColorSendGen: function( red, green, blue )
	{
		Core.Proc.appendToCommandString( 0x1330005, this, [ +red, +green, +blue ] );
	},
	
	/** @private */
	_setAlphaSendGen: function( alpha )
	{
		Core.Proc.appendToCommandString( 0x1330006, this, [ +alpha ] );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( 0x1330007, this, [ +rotation ] );
	},
	
	/** @private */
	_setDepthSendGen: function( depth )
	{
		Core.Proc.appendToCommandString( 0x1330008, this, [ +depth ] );
	},
	
	/** @private */
	_setVisibleSendGen: function( visible )
	{
		Core.Proc.appendToCommandString( 0x1330009, this, [ ( visible ? 1 : 0 ) ] );
	},
	
	/** @private */
	_setTouchableSendGen: function( touchable )
	{
		Core.Proc.appendToCommandString( 0x133000a, this, [ ( touchable ? 1 : 0 ) ] );
	},
	
	/** @private */
	_setChildrenDepthGroupedSendGen: function( childrenDepthGrouped )
	{
		Core.Proc.appendToCommandString( 0x133000b, this, [ ( childrenDepthGrouped ? 1 : 0 ) ] );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( 0x133000c, this, [ +child ] );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( 0x133000d, this, [ +child ] );
	},
	
	/** @private */
	_setClipRectSendGen: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( 0x133000f, this, [ +x, +y, +w, +h ] );
	},
	
	/** @private */
	_setClipRectEnabledSendGen: function( clipRectEnabled )
	{
		Core.Proc.appendToCommandString( 0x1330010, this, [ ( clipRectEnabled ? 1 : 0 ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setScale: function( x, y ) {}
	
	// setColor: function( red, green, blue ) {}
	
	// setAlpha: function( alpha ) {}
	
	// setRotation: function( rotation ) {}
	
	// setDepth: function( depth ) {}
	
	// setVisible: function( visible ) {}
	
	// setTouchable: function( touchable ) {}
	
	// setChildrenDepthGrouped: function( childrenDepthGrouped ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _synchronizeNodeRecv: function( cmd ) {}
	// setClipRect: function( x, y, w, h ) {}
	
	// setClipRectEnabled: function( clipRectEnabled ) {}
	
	// _synchronizeNodePosRecv: function( cmd ) {}
	// _synchronizeNodeRotRecv: function( cmd ) {}
	// _synchronizeNodeScaleRecv: function( cmd ) {}
	// _synchronizeNodeAlphaRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/RenderTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/RenderTarget.js';

var Core = require('NGCore/Client/Core').Core;
var Node = require('NGCore/Client/GL2/Node').Node;


var RenderTarget = exports.RenderTarget = Core.Class.subclass(
	/** @lends GL2.RenderTarget.prototype */
{
	classname: 'RenderTarget',

	/**
	 * @class The `GL2.RenderTarget` class renders multiple `GL2` objects into a single render
	 * target. This target can be attached to a `{@link GL2.Animation.Frame}` object and displayed
	 * as part of an animation. The render target can also be saved to a file.
	 * @constructs Create a render target.
	 * @example
	 * // Create a square, opaque render target.
	 * var renderTarget = new GL2.RenderTarget(256, 256, true);
	 * @param {Number} width The width of the render target. Must be a power of two.
	 * @param {Number} height The height of the render target. Must be a power of two.
	 * @param {Boolean} [isOpaque=false] Set to `true` to omit the alpha channel from the render
	 *		target.
	 * @since 1.3.1b
	 */
	initialize: function (width, height, isOpaque) {
		Core.ObjectRegistry.register(this);
		this._children = [];
		this._width = width;
		this._height = height;
		this._isOpaque = isOpaque ? true : false;
		this._createSendGen(this.__objectRegistryId, width, height, this._isOpaque);
		this._callbackIndexCounter = 1;
		this._callbacks = [];
	},

	/**
	 * Destroy the render target, and release the resources allocated by the render target.
	 * @returns {void}
	 * @since 1.3.1b
	 */
	destroy: function () {
		var children = this._children;
		while (children.length) {
			this.removeChild(children[0]);
		}
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Add a child node to the render target.
	 *
	 * If the render target is being displayed in an animation, and the application has called
	 * `{@link GL2.RenderTarget#setAutoUpdate}` to enable automatic updates, the child node will be
	 * drawn in the next frame of the animation. In all other cases, the child node will not be
	 * drawn in the render target until the application calls `{@link GL2.RenderTarget#update}`.
	 * @example
	 * var renderTarget = new GL2.RenderTarget(1024, 256);
	 * var childNode = new GL2.Node();
	 * renderTarget.addChild(childNode);
	 * @param {Object} child The child node to add. The object must inherit from `{@link GL2.Node}`.
	 * @returns {this}
	 * @since 1.3.1b
	 */
	addChild: function (child) {
		this._children.push(child);
		child._didAddToParent(this);
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Remove a child node from the render target. When the render target is redrawn, the child node
	 * will not be drawn.
	 *
	 * If the render target is being displayed in an animation, and the application has called
	 * `{@link GL2.RenderTarget#setAutoUpdate}` to enable automatic updates, the child node will not
	 * be drawn in the next frame of the animation. In all other cases, the child node will continue
	 * to be shown in the render target until the application calls
	 * `{@link GL2.RenderTarget#update}`.
	 * @example
	 * var renderTarget = new GL2.RenderTarget(256, 512);
	 * var childNode = new GL2.Node();
	 * renderTarget.addChild(childNode);
	 * // When the application no longer needs to include the child node in the
	 * // render target:
	 * renderTarget.removeChild(childNode);
	 * @param {Object} child The child node to remove. The object must inherit from
	 *		`{@link GL2.Node}`.
	 * @returns {this}
	 * @since 1.3.1b
	 */
	removeChild: function (child) {
		child._willRemoveFromParent();
		var index = this._children.indexOf(child);
		if (index === -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Redraw the render target.
	 *
	 * Call this method after you make changes to the render target's child nodes. **Note**: If the
	 * render target is being displayed in an animation, and the application has called
	 * `{@link GL2.RenderTarget#setAutoUpdate}` to enable automatic updates, you do not need to call
	 * this method after changing the render target's child nodes.
	 *
	 * Also, call this method after the application has been suspended and resumed. **Note**: If the
	 * application has called `{@link GL2.RenderTarget#setBackingStoreEnable}` to enable the backing
	 * store, you do not need to call this method after the application resumes.
	 * @returns {this}
	 * @see GL2.RenderTarget#setAutoUpdate
	 * @since 1.3.1b
	 */
	update: function () {
		this._updateSendGen();
		return this;
	},

	/**
	 * Specify whether to automatically redraw the render target during every frame of an animation.
	 * Setting this option to `true` is equivalent to calling `{@link GL2.RenderTarget#update}`
	 * for every frame of an animation. If you set this option to `false`, or if the render target
	 * is not being displayed in an animation, you must call `{@link GL2.RenderTarget#update}` to
	 * redraw the render target.
	 * @param {Boolean} [autoUpdateEnable=true] Set to `true` to redraw the render target during
	 *		every frame of an animation.
	 * @returns {this}
	 * @see GL2.RenderTarget#update
	 * @since 1.3.1b
	 */
	setAutoUpdate: function (autoUpdateEnable) {
		var enable = (autoUpdateEnable || (autoUpdateEnable === undefined)) ? true : false;
		this._setAutoUpdateSendGen(enable);
		return this;
	},

	/**
	 * Specify whether the render target should be cleared before its child nodes are redrawn. By
	 * default, the render target is not cleared.
	 * @param {Boolean} [clearEnabled=true] Set to `true` to clear the render target before its
	 *		child nodes are redrawn.
	 * @returns {this}
	 * @since 1.3.1b
	 */
	setClearEnable : function (clearEnable) {
		var enable = (clearEnable || (clearEnable === undefined)) ? true : false;
		this._setClearEnableSendGen(enable);
		return this;
	},

	/**
	 * Set the render target's background color by using a `{@link Core.Color}` object. By default,
	 * the render target uses a white background. If the render target has an alpha channel, you can
	 * call `{@link GL2.RenderTarget#setClearColorAlpha}` to change the opacity of the background
	 * color.
	 * @example
	 * // Create a render target with a blue background.
	 * var renderTarget = new GL2.RenderTarget(64, 256);
	 * renderTarget.setClearColor(new Core.Color(0.3, 0.4, 0.5));
	 * @param {Core.Color} color The background color for the render target.
	 * @returns {this}
	 * @since 1.3.1b
	 */
	setClearColor : function () {
		var r, g, b, color;
		if (arguments.length === 1)
		{
			color = arguments[0];
			r = color.getRed();
			g = color.getGreen();
			b = color.getBlue();
		}
		else
		{
			r = arguments[0];
			g = arguments[1];
			b = arguments[2];
		}
		this._setClearColorSendGen(r, g, b);
		return this;
	},

	/**
	 * Set the render target's background color by specifying red, green, and blue values. By
	 * default, the render target uses a white background. If the render target has an alpha
	 * channel, you can call `{@link GL2.RenderTarget#setClearColorAlpha}` to set the opacity of the
	 * background color.
	 *
	 * Each parameter to this method is a float ranging from 0 to 1. To convert from an RGB color
	 * that is specified with values ranging from 0 to 255, simply divide each component's value by
	 * 255.
	 * @name GL2.RenderTarget#setClearColor^2
	 * @function
	 * @example
	 * // Create a render target with a blue background.
	 * var renderTarget = new GL2.RenderTarget(512, 256);
	 * renderTarget.setClearColor(0.3, 0.4, 0.5);
	 * @param {Number} red The red component of the background color, ranging from 0 to 1.
	 * @param {Number} green The green component of the background color, ranging from 0 to 1.
	 * @param {Number} blue Blue The blue component of the background color, ranging from 0 to 1.
	 * @returns {this}
	 * @since 1.3.1b
	 */

	/**
	 * Set the opacity of the render target's background color. By default, the render target is
	 * completely opaque.
	 * @param {Number} alpha The opacity of the render target's background color, ranging from 0
	 *		(fully transparent) to 1 (fully opaque).
	 * @returns {this}
	 * @since 1.3.1b
	 */
	setClearColorAlpha : function (alpha) {
		this._setClearColorAlphaSendGen(alpha);
		return this;
	},

	/**
	 * Save the render target's current visual state to the device's file system.
	 *
	 * To save the file in PNG format, specify a filename with the extension .png. To save the file
	 * in JPEG format, specify a filename with the extension .jpg.
	 * @example
	 * // Save a render target's current visual state to a PNG file. Clip the
	 * // image to a 128-pixel square that is centered on the render target.
	 * var renderTarget = new GL2.RenderTarget(256, 256);
	 * var rect = new Core.Rect(64, 64, 128, 128);
	 * renderTarget.save("render-target.png", rect, function(filename) {
	 *     console.log("Saved the render target as " + filename);
	 * });
	 * @param {String} filename The filename to use for the image. To save the file in PNG format,
	 * 		specify a filename with the extension .png. To save the file in JPEG format, specify a
	 *		filename with the extension .jpg.
	 * @param {Core.Rect} rect The rectangle that will be used to clip the render target. To output
	 *		the entire render target, set this parameter to `null`.
	 * @cb {Function} [callback] The function to call after saving the image.
	 * @cb-param {String} filename The filename that was used for the image.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.3.1b
	 */
	save : function (filename, rect, callback) {
		var id = 0;
		if (callback) {
			id = this._callbackIndexCounter++;
			this._callbacks[id] = callback;
		}
		var x = rect ? rect.getOrigin().getX() : -1;
		var y = rect ? rect.getOrigin().getY() : -1;
		var w = rect ? rect.getSize().getWidth() : -1;
		var h = rect ? rect.getSize().getHeight() : -1;
		this._saveSendGen(id, filename, x, y, w, h);
	},

	/**
	 * @private
	 */
	_invokeCallbackRecv: function (cmd)	{
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		var err = msg.error;
		if (!id) {
			NgLogE("invokeCallbackRecv command : bad id = " + id);
			return;
		}
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("invokeCallbackRecv command : No registered callback found, id = " + id);
			return;
		}
		delete this._callbacks[id];
		cb(err);
	},

	/**
	 * Specify whether to enable the render target's backing store. By default, the backing store is
	 * disabled.
	 *
	 * The backing store ensures that the render target will be drawn correctly after the
	 * application is suspended and resumed. If the backing store is not enabled, your application
	 * must call `{@link GL2.RenderTarget#update}` after the application resumes.
	 * @param {Boolean} [backingStoreEnable=true] Set to `true` to enable the backing store.
	 * @returns {this}
	 * @since 1.3.1b
	 */
	setBackingStoreEnable: function (backingStoreEnable) {
		var enable = (backingStoreEnable || (backingStoreEnable === undefined)) ? true : false;
		this._setBackingStoreEnableSendGen(enable);
		return this;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 353,
	// Method create = -1
	// Method destroy = 2
	// Method addChild = 3
	// Method removeChild = 4
	// Method update = 5
	// Method setAutoUpdate = 6
	// Method setClearEnable = 7
	// Method setClearColor = 8
	// Method setClearColorAlpha = 9
	// Method save = 10
	// Method invokeCallback = 11
	// Method setBackingStoreEnable = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 11:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[353] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( objectRegistryId, width, height, isOpaque )
	{
		Core.Proc.appendToCommandString( 0x161ffff, [ +objectRegistryId, +width, +height, ( isOpaque ? 1 : 0 ) ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1610002, this );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( 0x1610003, this, [ +child ] );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( 0x1610004, this, [ +child ] );
	},
	
	/** @private */
	_updateSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1610005, this );
	},
	
	/** @private */
	_setAutoUpdateSendGen: function( autoUpdateEnable )
	{
		Core.Proc.appendToCommandString( 0x1610006, this, [ ( autoUpdateEnable ? 1 : 0 ) ] );
	},
	
	/** @private */
	_setClearEnableSendGen: function( clearEnable )
	{
		Core.Proc.appendToCommandString( 0x1610007, this, [ ( clearEnable ? 1 : 0 ) ] );
	},
	
	/** @private */
	_setClearColorSendGen: function( r, g, b )
	{
		Core.Proc.appendToCommandString( 0x1610008, this, [ +r, +g, +b ] );
	},
	
	/** @private */
	_setClearColorAlphaSendGen: function( a )
	{
		Core.Proc.appendToCommandString( 0x1610009, this, [ +a ] );
	},
	
	/** @private */
	_saveSendGen: function( callbackId, filename, originX, originY, width, height )
	{
		Core.Proc.appendToCommandString( 0x161000a, this, [ +callbackId, Core.Proc.encodeString( filename ), +originX, +originY, +width, +height ] );
	},
	
	/** @private */
	_setBackingStoreEnableSendGen: function( backingStoreEnable )
	{
		Core.Proc.appendToCommandString( 0x161000c, this, [ ( backingStoreEnable ? 1 : 0 ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( objectRegistryId, width, height, isOpaque ) {}
	
	// destroy: function(  ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// update: function(  ) {}
	
	// setAutoUpdate: function( autoUpdateEnable ) {}
	
	// setClearEnable: function( clearEnable ) {}
	
	// setClearColor: function( r, g, b ) {}
	
	// setClearColorAlpha: function( a ) {}
	
	// save: function( callbackId, filename, originX, originY, width, height ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// setBackingStoreEnable: function( backingStoreEnable ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Animation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Animation.js';

var Core = require('NGCore/Client/Core').Core;
var RenderTarget = require('NGCore/Client/GL2/RenderTarget').RenderTarget;


var Animation = exports.Animation = Core.Class.subclass(
/** @lends GL2.Animation.prototype */
{
	classname: 'Animation',

	/**
	 * @class The `GL2.Animation` class creates animations that are composed of one or more
	 * `{@link GL2.Animation.Frame}` objects, which define the contents and duration of each
	 * animation frame. To play an animation, attach it to a `{@link GL2.Primitive}` or
	 * `{@link GL2.Sprite}` object.
	 *
	 * Most of the properties that control how an animation frame is displayed, such as the texture
	 * wrap mode and blending mode, are defined by the `GL2.Animation` object. All of the
	 * animation's frames will use the same setting for these properties.
	 * `{@link GL2.Animation.Frame}` objects define the properties that vary between individual
	 * frames in an animation, such as the frame's duration and the image that is displayed in a
	 * frame.
	 *
	 * Use the `{@link GL2.MotionController}` and `{@link GL2.MotionData}` classes for tween-based
	 * animations of a static texture using keyframes.
	 *
	 * **Note**: You can call `{@link GL2.Animation.setTextureColorDepth}` to control the bit depth
	 * of uncompressed, truecolor textures that are used in animations. The value you specify will
     * apply to all animations. You must call this method after the `{@link UI.GLView}` object has
     * been initialized and before any `GL2` textures have been created.
	 * @constructs Create an animation.
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);

        this._wrapMode = this.WrapMode.WrapNone;
        this._blendEnabled = true;
        this._blendMode = this.BlendMode.Alpha;
        this._filteringEnabled = true;
		this._loopingEnabled = true;
		this._totalDuration = 0;
		this._frames = [];

		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * Destroy the animation, and release the resources allocated by the animation.
	 *
	 * **Important**: Destroying an animation does not destroy the animation's frames.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the animation's texture wrap mode.
	 * @returns {GL2.Animation#WrapMode} The current texture wrap mode.
	 * @see GL2.Animation#setWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getWrapMode: function()
	{
		return this._wrapMode;
	},

	/**
	 * Determine whether alpha blending is enabled for the animation.
	 * @returns {Boolean} Set to `true` if alpha blending is enabled.
	 * @see GL2.Animation#setBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getBlendEnabled: function()
	{
		return this._blendEnabled;
	},

	/**
	 * Determine whether filtering is enabled for the animation.
	 * @returns {Boolean} Set to `true` if filtering is enabled.
	 * @see GL2.Animation#setFilteringEnabled
	 * @status Flash, Test, FlashTested
	 * @since 1.0
	 */
	getFilteringEnabled: function()
	{
		return this._filteringEnabled;
	},

	/**
	 * Determine whether looping is enabled for the animation.
	 * @returns {Boolean} Set to `true` if looping is enabled.
	 * @see GL2.Animation#setLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getLoopingEnabled: function()
	{
		return this._loopingEnabled;
	},

	/**
	 * Retrieve the animation's total duration, in milliseconds.
	 * @returns {Number} The animation's total duration, in milliseconds.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getTotalDuration: function()
	{
		return this._totalDuration;
	},

	/**
	 * Retrieve the total number of frames in the animation.
	 * @returns {Number} The total number of frames.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getFrameCount: function()
	{
		return this._frames.length;
	},

	/**
	 * Retrieve the animation frame at the specified index.
	 * @param {Number} index The index of the frame to retrieve.
	 * @returns {GL2.Animation.Frame} The animation frame at the specified index.
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getFrame: function(index)
	{
		return this._frames[index];
	},

    /**
	 * Set the animation's texture wrap mode. The texture wrap mode controls whether textures will
	 * be wrapped on the U and V dimensions of each animation frame. By default, the texture wrap
	 * mode is set to `{@link GL2.Animation#WrapMode.WrapNone}`, which clamps the texture on the U
	 * and V dimensions.
	 * @example
	 * var animation = new GL2.Animation();
	 * animation.setWrapMode(GL2.Animation.WrapMode.WrapUV);
	 * @param {GL2.Animation#WrapMode} wrapMode The new texture wrap mode for the animation.
	 * @returns {this}
	 * @see GL2.Animation#getWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setWrapMode: function(wrapMode)
	{
		this._wrapMode = wrapMode;

		this._setWrapModeSendGen(wrapMode);

		return this;
	},

    /**
	 * Set whether alpha blending is enabled for the animation. Alpha blending is enabled by
	 * default.
	 *
	 * **Note**: If all of an animation's frames are opaque, disabling alpha blending can improve
	 * performance.
	 * @example
	 * var animation = new GL2.Animation();
	 * animation.setBlendEnabled(false);
	 * @param {Boolean} blendEnabled Set to `true` to enable alpha blending.
	 * @returns {this}
	 * @see GL2.Animation#getBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setBlendEnabled: function(blendEnabled)
	{
		this._blendEnabled = blendEnabled;

		this._setBlendEnabledSendGen(blendEnabled);

		return this;
	},

	/**
	 * Set the animation's alpha blend mode. By default, the alpha blend mode is set to
	 * `{@link GL2.Animation#BlendMode.Alpha}`, which renders blended images differently based on
	 * the order in which they are drawn.
	 * @example
	 * var animation = new GL2.Animation();
	 * animation.setBlendMode(GL2.Animation.BlendMode.Add);
	 * @param {GL2.Animation#BlendMode} blendMode The new alpha blend mode for the animation.
	 * @see GL2.Animation#setBlendEnabled
	 * @returns {this}
	 * @status Android, Flash, AndroidTested
	 * @since 1.3.1b
	 */
	setBlendMode: function(blendMode)
	{
		this._blendMode = blendMode;

		this._setBlendModeSendGen(blendMode);

		return this;
	},

	getBlendMode: function()
	{
		return this._blendMode;
	},

    /**
	 * Set whether bilinear filtering is enabled for the animation, which improves the quality of
	 * each frame in the animation as the frame's image is scaled up or down. Bilinear filtering is
	 * enabled by default.
	 * @param {Boolean} filteringEnabled Set to `true` to enable bilinear filtering.
	 * @returns {this}
	 * @see GL2.Animation#getFilteringEnabled
	 * @status Flash
	 * @since 1.0
	 */
    setFilteringEnabled: function(filteringEnabled)
	{
		this._filteringEnabled = filteringEnabled;

		this._setFilteringEnabledSendGen(filteringEnabled);

		return this;
	},

    /**
	 * Set whether the animation will play in a loop. Looping is enabled by default.
	 * @param {Boolean} loopingEnabled Set as `true` to enable animation looping.
	 * @returns {this}
	 * @see GL2.Animation#getLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setLoopingEnabled: function(loopingEnabled)
	{
		this._loopingEnabled = loopingEnabled;

		this._setLoopingEnabledSendGen(loopingEnabled);

		return this;
	},

    /**
	 * Add a frame to the end of the animation. Calling this method is equivalent to calling
	 * `{@link GL2.Animation#spliceFrames}` in the following way:
	 *
	 *     animation.spliceFrames(animation.getFrameCount(), 0, frame);
	 * @example
	 * var animation = new GL2.Animation();
	 * var frame = new GL2.Animation.Frame("./Content/unicorn.png", 50,
	 *   new Core.Size(64, 64), new Core.Point(0.5, 0.5), new Core.Rect(0, 0, 0.5, 0.5));
	 * animation.pushFrame(frame);
	 * @param {GL2.Animation.Frame} frame The frame to add.
	 * @returns {this}
	 * @see GL2.Animation#setFrame
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    pushFrame: function(frame)
	{
		return this.spliceFrames(this._frames.length, 0, frame);
	},

    /**
	 * Replace the animation frame at a specified index. Calling this method is equivalent to
	 * calling `{@link GL2.Animation#spliceFrames}` in the following way:
	 *
	 *     animation.spliceFrames(i, 1, frame);
	 * @param {Number} i The index of the frame to replace.
	 * @param {GL2.Animation.Frame} frame The frame to insert.
	 * @returns {this}
	 * @see GL2.Animation#getFrame
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setFrame: function(i, frame)
	{
		return this.spliceFrames(i, 1, frame);
	},

    /**
	 * Remove a specified number of animation frames, and replace them with zero or more animation
	 * frames or render targets. You can pass any number of new frames and render targets to this
	 * method.
	 * @example
	 * // Create a new animation with four frames, then replace the third frame
	 * // with two new frames.
	 * var animation = new GL2.Animation();
	 *
	 * // The original images for the animation are contained in a sprite sheet
	 * // with four different sprites, arranged in a 2 x 2 grid.
	 * var frameSize = new Core.Size(64, 64);
	 * var anchor = new Core.Point(0.5, 0.5);
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/unicorn.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0, 0, 0.5, 0.5));
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/unicorn.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0.5, 0, 0.5, 0.5));
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/unicorn.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0, 0.5, 0.5, 0.5));
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/unicorn.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0.5, 0.5, 0.5, 0.5));
	 *
	 * // The new images are contained in a sprite sheet with two different sprites,
	 * // arranged horizontally.
	 * var newFrame1 = new GL2.Animation.Frame("./Content/shiny_unicorn.png", 50,
	 *   frameSize, anchor, new Core.Rect(0, 0, 0.5, 1));
	 * var newFrame2 = new GL2.Animation.Frame("./Content/shiny_unicorn.png", 50,
	 *   frameSize, anchor, new Core.Rect(0.5, 0, 0.5, 1));
	 *
	 * // Replace the third frame with the two new frames.
	 * animation.spliceFrames(2, 1, newFrame1, newFrame2);
	 * @example
	 * // Create a new animation with three frames, then remove the second frame.
	 * var animation = new GL2.Animation();
	 *
	 * // The images for the animation are contained in a sprite sheet with three
	 * // different sprites, arranged horizontally.
	 * var frameSize = new Core.Size(64, 64);
	 * var anchor = new Core.Point(0.5, 0.5);
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/monster.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0, 0, 0.333, 1));
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/monster.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0.333, 0, 0.333, 1));
	 * animation.pushFrame(new GL2.Animation.Frame("./Content/monster.png"), 50,
	 *   frameSize, anchor, new Core.Rect(0.666, 0, 0.333, 1));
	 *
	 * // Remove the second frame.
	 * animation.spliceFrames(1, 1);
	 * @param {Number} start The index of the first frame or render target to remove.
	 * @param {Number} len The total number of frames or render targets to remove.
	 * @param {GL2.Animation.Frame} [frames] The frame to insert.
	 *		To insert more than one frame, pass additional arguments to the method.
	 * @returns {this}
	 * @see GL2.Animation#pushFrame
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    spliceFrames: function(start, len, frames)
	{
		var i;
		var frameCount = arguments.length-2;
		var frame;

		// Determine if we should use the v2 version of the messsage, which supports renderTargets.
		// This is so that new javaScript that doesn't use renderTargets will still work with an old binary.
		var useV2 = false;
		for (i = 0; i < frameCount; ++i) {
			frame = arguments[i+2];
			if (frame && frame.getImage) {
				if (frame.getImage().classname === 'RenderTarget') {
					useV2 = true;
				}
			} else {
				return this;  // bad frame
			}
		}

		// Decrement from total duration.
		for (i=start; i < start + len; ++i) {
			this._totalDuration -= this._frames[i].getDuration();
		}

		this._frames.splice.apply(this._frames, arguments);

		if (useV2) {
			this._spliceFrames2SendGen(start, len, frameCount);
		} else {
			this._spliceFramesSendGen(start, len, frameCount);
		}

		for (i = 0; i < frameCount; ++i)
		{
			frame = arguments[i+2];
			var duration = frame.getDuration();
			var size = frame.getSize();
			var anchor = frame.getAnchor();
			var uvs = frame.getUVs();
			var uvOrigin = uvs.getOrigin();
			var uvSize = uvs.getSize();
			var image = frame.getImage();

			// if image is a renderTarget
			var renderTargetID = 0;
			if (image.classname === 'RenderTarget') {
				renderTargetID = image.__objectRegistryId;
				image = '';
			}

			if (useV2) {
				this._frame2SendGen(image,
									renderTargetID,
									duration,
									size.getWidth(),
									size.getHeight(),
									anchor.getX(),
									anchor.getY(),
									uvOrigin.getX(),
									uvOrigin.getY(),
									uvSize.getWidth(),
									uvSize.getHeight());
			} else {
				this._frameSendGen(image,
								   duration,
								   size.getWidth(),
								   size.getHeight(),
								   anchor.getX(),
								   anchor.getY(),
								   uvOrigin.getX(),
								   uvOrigin.getY(),
								   uvSize.getWidth(),
								   uvSize.getHeight());
			}
			this._totalDuration += duration;
		}

		return this;
	},

	/**
	 * Set the bit depth to use, in bits per pixel, for uncompressed, truecolor textures that are
	 * used in an animation. By default, each texture is drawn at its original bit depth.
	 *
	 * **Important**: You must call this static method after the `{@link UI.GLView}` object has been
	 * initialized and before any `GL2` textures have been created.
	 * @name GL2.Animation.setTextureColorDepth
	 * @function
	 * @static
	 * @example
	 * GL2.Animation.setTextureColorDepth(16);
	 * @param {Number} depth The bit depth to use, in bits per pixel, for uncompressed, truecolor
	 *		textures that are used in an animation. Use `16` to select 16bpp. Use `0` to draw the
	 *		texture at its original bit depth.
	 * @returns {void}
	 * @since 1.6
	 */

	$setTextureColorDepth: function(depth)
	{
		this._setTextureColorDepthSendGen(depth);
	},

	$Frame: Core.Class.subclass(
	/** @lends GL2.Animation.Frame.prototype */
	{
		classname: 'Frame',

		/**
		 * @class `GL2.Animation.Frame` objects define the properties of an individual frame in an
		 * animation, including the frame's source image, duration, size, and anchor point. You can
		 * also use sprite sheets by specifying that the animation frame should display only a
		 * portion of the source image.
		 * @constructs Create an animation frame.
		 * @example
		 * // Create an animation frame that contains the bottom right image in a
		 * // 3 x 3 sprite sheet.
		 * var frame = new GL2.Animation.Frame("./Content/unicorn.png"), 50,
		 *   new Core.Size(64, 64), new Core.Point(0.5, 0.5),
		 *   new Core.Rect(0.666, 0.666, 0.333, 0.333));
		 * @param {String|GL2.RenderTarget} image The directory path to an image, or an instance of
		 *		`{@link GL2.RenderTarget}`. If this parameter contains the path to an image, the
		 *		image must be in PNG (.png) or JPEG (.jpg) format; its dimensions must be a power of
		 *		two; it must be square; and it must be referenced in the `textures` or
		 *		`textures_encrypted` section of your application's manifest.
		 * @param {Number} duration The duration of the frame, in milliseconds.
		 * @param {Core.Size} size The size of the frame, in pixels. The frame will be scaled based
		 *		on its parent nodes' transformations.
		 * @param {Core.Point} [anchor=[0.5, 0.5]] The offset within the frame that defines the
		 *		anchor point for scaling and rotation. See `{@link GL2.Animation.Frame#getAnchor}`
		 *		for details. If you omit this parameter, you must also omit the `uvs` parameter.
		 * @param {Core.Rect} [uvs=[0, 0, 1, 1]] The image region to use for the frame. Specified in
		 *		UV coordinates ranging from 0 to 1, which represent a percentage of the original
		 *		image's width and height. The four coordinates represent the U origin, the V origin,
		 *		the U width, and the V height, in that order.
		 * @see GL2.Animation
		 * @augments Core.Class
		 * @since 1.0
		 */
		initialize: function(image, duration, size, anchor, uvs)
		{
			this._image     = image;
			this._duration  = duration || 0;
			this._size   = new Core.Size(size);

			if(anchor)
				this._anchor = new Core.Point(anchor);
			else
				this._anchor = new Core.Point(0.5, 0.5);

			if(uvs)
				this._uvs = new Core.Rect(uvs);
			else
				this._uvs = new Core.Rect(0, 0, 1, 1);
		},

		/**
		 * Retrieve the image contained in the animation frame. The returned value will be either
		 * the path to an image or a `{@link GL2.RenderTarget}` object.
		 * @returns {String|GL2.RenderTarget} The path to the animation frame's image, or a
		 *		`{@link GL2.RenderTarget}` object.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getImage:    function()
		{
			return this._image;
		},

		/**
		 * Retrieve the duration of the animation frame, in milliseconds.
		 * @returns {Number} The duration of the frame, in milliseconds.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getDuration:  function()
		{
			return this._duration;
		},

		/**
		 * Retrieve the size of the animation frame, in pixels.
		 * @returns {Core.Size} The size of the frame, in pixels.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getSize:    function()
		{
			return this._size;
		},

		/**
		 * Retrieve the offset of the animation frame's anchor point. The anchor point defines the
		 * origin of any scaling or rotation that is applied to the frame. Its offset is defined as
		 * a multiple of the frame's width and height. For example, the default anchor offset,
		 * `[0.5, 0.5]`, represents a point that is centered on the U and V axes.
		 *
		 * **Note**: The anchor point is calculated before transformations are applied to the
		 * animation frame.
		 * @returns {Core.Point} The offset of the frame's anchor point.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getAnchor:  function()
		{
			return this._anchor;
		},

		/**
		 * Retrieve the image region, in UV coordinates, to use for the animation frame.
		 * @returns {Core.Rect} The image region for the frame.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getUVs:    function()
		{
			return this._uvs;
		}
	}),

	/**
	 * Enumeration for UV wrapping modes.
	 * @name WrapMode
	 * @fieldOf GL2.Animation#
	 */

	/**
	 * Clamp in both U and V.
	 * @name WrapMode.WrapNone
	 * @fieldOf GL2.Animation#
	 * @constant
	 */

	/**
	 * Wrap in U, clamp in V.
	 * @name WrapMode.WrapU
	 * @fieldOf GL2.Animation#
	 * @constant
	 */

	/**
	 * Wrap in V, clamp in U.
	 * @name WrapMode.WrapV
	 * @fieldOf GL2.Animation#
	 * @constant
	 */

	/**
	 * Wrap in both U and V.
	 * @name WrapMode.WrapUV
	 * @fieldOf GL2.Animation#
	 * @constant
	 */


	/**
	 * Enumeration for alpha blend modes.
	 * @name BlendMode
	 * @fieldOf GL2.Animation#
	 */

	/**
	 * Use the blending function `(SourceColor * SourceAlpha) + (DestinationColor * (1 -
	 * SourceAlpha))`. For example, if the source color has an alpha of 0.6, it will contribute 60%
	 * of the blended color, and the destination color will contribute 40% of the blended color.
	 * Blended images will be rendered differently based on the order in which they are drawn.
	 * @name BlendMode.Alpha
	 * @fieldOf GL2.Animation#
	 * @constant
	 */

	/**
	 * Use the blending function `(SourceColor * SourceAlpha) + (DestinationColor * 1)`. The source
	 * color's red, green, and blue values are adjusted based on their alpha values, then added to
	 * the destination color's red, green, and blue values. Blended images will be rendered the same
	 * way regardless of the order in which they are drawn.
	 * @name BlendMode.Add
	 * @fieldOf GL2.Animation#
	 * @constant
	 */

	/**
	 * Use the blending function `(DestinationColor * 1) - (SourceColor * SourceAlpha)`. The source
	 * color's red, green, and blue values are adjusted based on their alpha values, then subtracted
	 * from the destination color's red, green, and blue values. Blended images will be rendered
	 * differently based on the order in which they are drawn.
	 * @name BlendMode.Subtract
	 * @fieldOf GL2.Animation#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	WrapMode:
	{ 
		WrapNone: 0,
		WrapU: 1,
		WrapV: 2,
		WrapUV: 3
	},
	
	BlendMode:
	{ 
		Alpha: 1,
		Add: 2,
		Subtract: 3
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 306,
	// Method create = -1
	// Method destroy = 2
	// Method setWrapMode = 3
	// Method setBlendEnabled = 4
	// Method setLoopingEnabled = 5
	// Method spliceFrames = 6
	// Method frame = 7
	// Method setFilteringEnabled = 8
	// Method spliceFrames2 = 9
	// Method frame2 = 10
	// Method setBlendMode = 11
	// Method setTextureColorDepth = -12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[306] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x132ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1320002, this );
	},
	
	/** @private */
	_setWrapModeSendGen: function( wrapMode )
	{
		Core.Proc.appendToCommandString( 0x1320003, this, [ +wrapMode ] );
	},
	
	/** @private */
	_setBlendEnabledSendGen: function( blendEnabled )
	{
		Core.Proc.appendToCommandString( 0x1320004, this, [ ( blendEnabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	_setLoopingEnabledSendGen: function( loopingEnabled )
	{
		Core.Proc.appendToCommandString( 0x1320005, this, [ ( loopingEnabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	_spliceFramesSendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( 0x1320006, this, [ +start, +len, +frameCount ] );
	},
	
	/** @private */
	_frameSendGen: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendSubcommandToCommandString( [ Core.Proc.encodeString( image ), +duration, +width, +height, +anchorX, +anchorY, +startU, +startV, +sizeU, +sizeV ] );
	},
	
	/** @private */
	_setFilteringEnabledSendGen: function( filteringEnabled )
	{
		Core.Proc.appendToCommandString( 0x1320008, this, [ ( filteringEnabled ? 1 : 0 ) ] );
	},
	
	/** @private */
	_spliceFrames2SendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( 0x1320009, this, [ +start, +len, +frameCount ] );
	},
	
	/** @private */
	_frame2SendGen: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendSubcommandToCommandString( [ Core.Proc.encodeString( image ), +renderTargetID, +duration, +width, +height, +anchorX, +anchorY, +startU, +startV, +sizeU, +sizeV ] );
	},
	
	/** @private */
	_setBlendModeSendGen: function( blendMode )
	{
		Core.Proc.appendToCommandString( 0x132000b, this, [ +blendMode ] );
	},
	
	/** @private */
	$_setTextureColorDepthSendGen: function( depth )
	{
		Core.Proc.appendToCommandString( 0x132fff4, [ +depth ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setWrapMode: function( wrapMode ) {}
	
	// setBlendEnabled: function( blendEnabled ) {}
	
	// setLoopingEnabled: function( loopingEnabled ) {}
	
	// spliceFrames: function( start, len, frameCount ) {}
	
	// frame: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setFilteringEnabled: function( filteringEnabled ) {}
	
	// spliceFrames2: function( start, len, frameCount ) {}
	
	// frame2: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setBlendMode: function( blendMode ) {}
	
	// $setTextureColorDepth: function( depth ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/EmitterData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/EmitterData'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/EmitterData'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/EmitterData.js';

////////////////////////////////////////////////////////////////////////////////
// Class EmitterData
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;


////////////////////////////////////////////////////////////////////////////////

var EmitterData = exports.EmitterData = Core.Class.subclass(
/** @lends GL2.EmitterData.prototype */
{
    classname: 'EmitterData',
    /**
     * @class The `EmitterData` class stores particle effect definition data that multiple `{@link GL2.Emitter}` objects can reference.
     *
     * Currently the only supported `EmitterData` format is `GravityEmitterData`.
     *
     *
     * ###GravityEmitterData JSON format for GL2.EmitterData###
     *
     * ####Overview####
     *
     * GL2.EmitterData uses a block of JSON to describe the behavior of a particle emitter system.
     * It is passed to a GL2.EmitterData object using the initFromData or initFromJSONFile.
     * Additionally, the mergeData call can be used to dynamically update data fields in real-time.
     *
     *
     * The GravityEmitterData form expects a valid JSON block of a single object with a 
     * set of key value pairs, wherein the keys must be strings.
     *
     *
     * The following caveats apply:
     *
     * 
     * + If a recognized key is not present, a default value is chosen for that key.</li>
     * + If an unknown key is present in the JSON, it is ignored.</li>
     * + If the value for a specific field is an unexpected type, an error is returned in the callback.</li>
     * + If there is a JSON parse error, an error is returned in the callback.</li>
     * 
     *
     * ####Recognized Keys####
     *
     * In general, keys that affect a particular attribute of the particle system will have the same prefix.
     * For example: all keys starting with "rotation_" will affect the rotation of each particle.
     *
     * ####Example JSON description of an explosion effect####
     *
     * <pre>
     * {
     *     "emitShape_type": "circle",
     *     "emitShape_circle_innerRadius": 0,
     *     "emitShape_circle_outerRadius": 20,
     *     "initVel_angle": 0,
     *     "initVel_angleDelta": 180,
     *     "initVel_speedMin": 30,
     *     "initVel_speedMax": 150,
     *     "physics_accel": [0, 200],
     *     "physics_radialAccel": 0,
     *     "physics_tangentialAccel": 0,
     *     "physics_dragCoeff": 2.0,
     *     "color_type": "randAnim",
     *     "color_randAnim_startMin": [0.5, 0.0, 0.0],
     *     "color_randAnim_startMax": [1.0, 1.0, 0.0],
     *     "color_randAnim_endMin": [0.5, 0.0, 0.0],
     *     "color_randAnim_endMax": [1.0, 0.0, 0.0],
     *     "alpha_type": "fade",
     *     "alpha_fade_in": 0.0,
     *     "alpha_fade_out": 0.5,
     *     "rotation_angle": 0,
     *     "rotation_spinRateMin": -2000,
     *     "rotation_spinRateMax": -1000,
     *     "rotation_alignToVelocity": false,
     *     "attractor_type": "none",
     *     "attractor_position": [0, 100],
     *     "attractor_falloff": "linear",
     *     "attractor_strength": 1,
     *     "size_type": "rand",
     *     "size_preserveAspectRatio": true,
     *     "size_aspectRatio": 1.0,
     *     "size_rand_min": [3, 3],
     *     "size_rand_max": [7, 7],
     *     "texture_type": "randPick",
     *     "texture_randPick": [{ "image": "Content/ballfx.png", "uvMin": [0.25, 0.5], "uvMax": [0.5, 0.75], "magFilter": "linear" },
     *                          { "image": "Content/ballfx.png", "uvMin": [0.75, 0.25], "uvMax": [1, 0.5], "magFilter": "linear" }],
     *     "emitter_position": [0, 0],
     *     "emitter_duration": 0,
     *     "emitter_lifetimeMin": 0.5,
     *     "emitter_lifetimeMax": 1.5,
     *     "emitter_rate": 70,
     *     "emitter_maxParticles": 70,
     *     "emitter_sortOrder": "none",
     *     "emitter_blendMode": "alpha",
     *     "emitter_freeParticles": true
     * }
     * </pre>
     *
     * ###Emitter###
     *
     * These values control the number and rate at which particles are emitted, as well as 
     * other properties which describe the lifetime of each particle, the sorting order, 
     * blend mode and coordinate frame.
     *
     * + `emitter_position` {[Number, Number]} - The origin of the emitter, in the local frame of the GL2.Emitter node. Default: [0, 0]
     * + `emitter_duration` {Number} - The amount of time particles will be emitted after `GL2.Emitter.play()` is called.
     *   0 indicates all particles are spawned at once. -1 indicates infinite spawning of particles. Default: 3.
     * + `emitter_lifetimeMin` {Number} - The minimum lifetime of a particle.  The lifetime of a specific particle is be randomly chosen, between the min and max. Default: 1
     * + `emitter_lifetimeMax` {Number} - The minimum lifetime of a particle.  The lifetime of a specific particle is be randomly chosen, between the min and max. Default: 2
     * + `emitter_rate` {Number} - When playing a GL2.Emitter will emit particles at this rate, in particles per second. Default: 20
     * + `emitter_maxParticles` {Number} - The total number of particles rendered and simulated is capped by this number.
     *   Increasing this number will increase both the memory used by the particle system and increase the CPU cost of playing it. Default: 50
     * + `emitter_freeParticles` {Boolean} - When a particle is spawned by the particle system on a moving GL2.Emitter it can either follow the motion of the emitter, or not.
     *   Setting this to false will cause all particles to follow changes in the GL2.Emitter transform. Default: false
     * + `emitter_sortOrder` {String} - When particles are drawn, some particles can be drawn on top of other particles from the same emitter.
     *   This parameter gives you the ability to set the sorting order. Default: "none"
     *     + "none" - no sorting
     *     + "oldestOnTop" - older particles will draw over of younger ones.
     *     + "newestOnTop" - new particles will draw over older ones.
     * + `emitter_blendMode` {String} - Used to control how each particle blends with the frame-buffer. Default: "alpha"
     *     + "opaque" - no blending at all.
     *     + "alpha" - alpha blending
     *     + "preMultipliedAlpha" - mix between alpha and additive blending.
     *     + "add" - additive blending.
     *     + "subtract" - subtractive blending.
     *
     * ###EmitShape###
     *
     * These values control where new particles are created.
     * Particles are created at a random position within the specified emitShape.
     * These values are in the GL2.Emitter coordinate frame; however, they can be offset 
     * using the `emitter_position` key.
     *
     * + `emitShape_type` {String} - type of volume. Default: "box"
     *     + "box" - Particles are spawned within an axis aligned box, the box size is specified by the `emitShape_box_max` and `emitShape_box_min` values.
     *     + "line" - Particles are spawned along the given line, the size of the line is specified by the `emitShape_line_length`, `emitShape_line_thickness` and `emitShape_line_angle` values.
     *     + "circle" - Particles are spawned within a circle, the size of the circle is specified by the `emitShape_circle_innerRadius` and `emitShape_circle_outerRadius` values.
     * + `emitShape_box_min` {[Number, Number]} - minimum values for the box, the first is in the x-dimension the second in the y-dimension. Default: [-50, -50]
     * + `emitShape_box_max` {[Number, Number]} - maximum values for the box, the first is in the x-dimension the second in the y-dimension. Default: [50, 50]
     * + `emitShape_line_length` {Number} - length of line.  Line is centered at `emitter_position`. Default: 100
     * + `emitShape_line_thickness` {Number} - thickness of line. Default: 10
     * + `emitShape_line_angle` {Number} - Angle of line in degrees.  0 indicates a horizontal line.
     *   Other angles will rotate it about its center at `emitter_position`. Default: 0
     *
     * ###InitVel###
     *
     * These values control the initial velocity of a particle when it is created.
     *
     * + `initVel_angle` {Number} - Angle in degrees, that specify the direction of travel. Default: 0
     * + `initVel_angleDelta` {Number} - Starting angle is randomized plus or minus this angle. Default: 10
     * + `initVel_speedMin` {Number} - Minimum speed of particle. Actual speed will be randomized between min and max. Default: 10
     * + `initVel_speedMax` {Number} - Maximum speed of particle. Actual speed will be randomized between min and max. Default: 20
     *
     * ###Physics###
     *
     * These values control how a particle accelerates or decelerates over time.
     *
     * + `physics_accel` {[Number, Number]} - Acceleration vector in GL2.Emitter local coordinate frame. Default: [0, 0]
     * + `physics_radialAccel` {Number} - Acceleration toward (negative values) or away from the origin, in GL2.Emitter local coordinate frame. Default: 0
     * + `physics_tangentialAccel` {Number} - Acceleration clockwise or counter-clockwise around the origin, in GL2.Emitter local coordinate frame. Default: 0
     * + `physics_dragCoeff` {Number} - Drag coefficient. Larger values will increase drag, smaller values will decrease it.  A value of 0 will disable drag.
     *   Drag is applied according to this equation: a = -k * v + g, where a is the acceleration applied to the particle, 
     *   k is the dragCoefficient, v is the velocity of the particle, and g is acceleration due to "gravity", which is the value from `physics_accel`.
     *   Note: enabling drag will increase CPU load when the effect is played. Default: 0
     *
     * ###Color###
     *
     *
     * These values control the color of a particle over time.
     *
     *
     * + `color_type` {String} Default: "constant"
     *     + "constant" - All particles will have the same color, specified by the `color_constant` key.
     *     + "rand" - A particle color will be randomly chosen between `color_rand_min` and `color_rand_max`.
     *     + "randAnim" - The particle start and end color will be randomly chosen. The color will change from the start color to the end color over the lifetime of the particle.
     *     + "keyframes" - The particle color is determines by a set of key frames.
     * + `color_constant` {[Number, Number, Number]} - Constant color of a particle.  Only active if `color_type` is "constant". Default: [1, 1, 1]
     * + `color_rand_min` {[Number, Number, Number]} - Minimum value for each color channel. Only active if `color_type` is "rand". Default: [1, 1, 1]
     * + `color_rand_max` {[Number, Number, Number]} - Maximum value for each color channel. Only active if `color_type` is "rand". Default: [1, 1, 1]
     * + `color_randAnim_startMin` {[Number, Number, Number]} - Minimum start value for each color channel. Only active if `color_type` is "randAnim". Default: [1, 1, 1]
     * + `color_randAnim_startMax` {[Number, Number, Number]} - Maximum start value for each color channel. Only active if `color_type` is "randAnim". Default: [1, 1, 1]
     * + `color_randAnim_endMin` {[Number, Number, Number]} - Minimum end value for each color channel. Only active if `color_type` is "randAnim". Default: [1, 1, 1]
     * + `color_randAnim_endMax` {[Number, Number, Number]} - Maximum end value for each color channel. Only active if `color_type` is "randAnim". Default: [1, 1, 1]
     * + `color_keyframes` {[{"key": Number, "value": [Number, Number, Number]}, ...]} - An array of keyframe objects.  Default: []
     *
     *   Each keyframe is an object with two keys:
     *
     *
     *   + "key" {Number} - a value from (0, 1) where 0 is the beginning of a particles lifetime and 1 is the end.
     *   + "value" - {[Number, Number, Number]} - the color desired at that time.
     *
     * ###Alpha###
     *
     * These values control the transparency of a particle over time.
     *
     * + `alpha_type` {String} Default: "fade"
     *     + "constant" - All particles will have a constant transparency value, specified by `alpha_constant`.
     *     + "fade" - Particles will fade in from transparent to opaque, then back to transparent.
     *     + "keyframe" - The particle transparency is determined by a set of key-frames.
     * + `alpha_constant` {Number} - Particle transparency (0 transparent, 1 opaque). Only active if `alpha_tpe` is "constant". Default: 1
     * + `alpha_fade_in` {Number} - Value specifying when particle will become opaque after being created.
     *   This value is from 0 to 1, where 0 is the beginning of a particle lifetime and 1 is the end.
     *   Only active if particle type is "fade".  Default: 0.1
     * + `alpha_fade_out` {Number} - Value specifying when particle will start becoming transparent before becoming fully transparent at the end of the particles lifetime.
     *   This value is from 0 to 1, where 0 is the beginning of a particle lifetime and 1 is the end.
     *   Only active if particle type is "fade".  Default: 0.9
     * + `alpha_keyframes` {[{"key": Number, "value": Number}, ...]} - An array of keyframe objects. Default: []
     *
     *   Each keyframe is an object with two keys:
     *     + "key" {Number} - a value from (0, 1) where 0 is the beginning of a particles lifetime and 1 is the end.
     *     + "value" - {Number} - the transparency value desired at that time.
     *
     * ###Rotation###
     *
     * These values control the rotation of a particle over time.
     *
     * + `rotation_angle` {Number} - Number in degrees, 0 indicates no rotation, positive numbers are clockwise rotations. Default: 0
     * + `rotation_spinRateMin` {Number} - Number in degrees per second. Actual particle spin rate will be chosen randomly between min and max. Default: 0
     * + `rotation_spinRateMax` {Number} - Number in degrees per second. Actual particle spin rate will be chosen randomly between min and max. Default: 0
     * + `rotation_alignToVelocity` {Boolean} - If true the rotation of the particle will be aligned with its velocity. Default: false
     *
     * ###Attractor###
     *
     * The particles within the particle system can be attracted to a specific position over time.
     *
     *
     * + `attractor_type` {String} Default: "none"
     *     + "none" - Attractor is disabled.
     *     + "local" - Attractor is specified in GL2.Emitter local coordinates.
     * + `attractor_position` {[Number, Number]} - position of GL2.Emitter. Default: [0, 0]
     * + `attractor_falloff` {String} - A particle is slowly attracted to the `attractor_position` over time.
     *   This parameter controls how fast or slow this attraction takes place. Default: "linear"
     *     + "linear" - particles move at a constant rate.
     *     + "easeIn" - particles start slowly and accelerate as they approach the destination
     *     + "easeOut" - particles start fast and decelerate as they approach the destination
     *     + "parabolic" - particles start fast, decelerate as they approach the midpoint, then accelerate as they approach the destination
     * + `attractor_strength` {Number} - Using this you can control the strength of the 
     *    attractor. When the value is 1 particles are guaranteed to end exactly on the 
     *    `attractor_position`. When the value is 0 there will be no attraction at all.
     *
     * ###Size###
     *
     * These values control the size of a particle over time.
     *
     * + `size_type` {String} Default: "constant"
     *     + "constant" - Particles will only have a single size specified by the `size_constant` value.
     *     + "rand" - Particle sizes will be randomly chosen between `size_rand_min` and `size_rand_max`.
     *     + "randAnim" - Particle sizes will be animated between a randomly determined start and end size.
     *     + "keyframes" - Particle size will specified by an array of keyframes.
     * + `size_preserveAspectRatio` {Boolean} - When true all particle sizes will have the aspect ratio. Default: false
     * + `size_aspectRatio` {Number} - The aspect ratio, (width / height) of each particle. Only takes effect if `size_preserveAspectRatio` is true. Default: 1
     * + `size_constant` {[Number, Number]} - The size of a particle. Only takes effect if `size_type` is "constant". Default: [10, 10]
     * + `size_rand_min` {[Number, Number]} - The minimum size of a particle. Only takes effect if `size_type` is "rand". Default: [10, 10]
     * + `size_rand_max` {[Number, Number]} - The maximum size of a particle. Only takes effect if `size_type` is "rand". Default: [10, 10]
     * + `size_randAnim_startMin` {[Number, Number]} - The minimum size of a particle's starting size. Only takes effect if `size_type` is "randAnim". Default: [10, 10]
     * + `size_randAnim_startMax` {[Number, Number]} - The maximum size of a particle's starting size. Only takes effect if `size_type` is "randAnim". Default: [10, 10]
     * + `size_randAnim_endMin` {[Number, Number]} - The minimum size of a particle's ending size. Only takes effect if `size_type` is "randAnim". Default: [10, 10]
     * + `size_randAnim_endMax` {[Number, Number]} - The maximum size of a particle's ending size. Only takes effect if `size_type` is "randAnim". Default: [10, 10]
     * + `size_keyframes` {[{"key": Number, "value": [Number, Number]}, ...]} - An array of keyframe objects. Default: []
     *   Each keyframe is an object with two keys:
     *     + "key" {Number} - a value from (0, 1) where 0 is the beginning of a particle's lifetime and 1 is the end.
     *     + "value" - {[Number, Number]} - the size value desired at that time.
     *
     * ###Texture###
     *
     * These values control textures used on a particle over time.
     * A texture object is a JSON block with the the following fields:
     *
     * + `image` {String} - filename of texture. Default: ""
     * + `uvMin` {[Number, Number]} - upper left hand corner of the particle texture in uv space.
     *   This can be used to select sub-rectangle within a sprite sheet. Default: [0, 0]
     * + `uvMax` {[Number, Number]} - lower right hand corner of the particle texture in uv space.
     *   This can be used to select sub-rectangle within a sprite sheet. Default: [1, 1]
     * + `uWrap` {String} - applies to x or u coordinate of the texture only. Default: "clampToEdge"
     *     + "clampToEdge" - any u value outside of the texture will be clamped to the color at the edge of the texture.
     *     + "wrap" - any u value outside of the texture will be wrapped.
     * + `vWrap` {String} - applies to y or v coordinate of the texture only. Default: "clampToEdge"
     *     + "clampToEdge" - any v value outside of the texture will be clamped to the color at the edge of the texture.
     *     + "wrap" - any v value outside of the texture will be wrapped.
     * + `minFilter` {String} - how filtering occurs when texture is minified, i.e. is smaller than the screen resolution. Default: "linear"
     *     + "nearest" - this nearest texel value is chosen.
     *     + "linear" - the texel value is computing by averaging the four nearest texels.
     * + `magFilter` {String} - how filtering occurs when texture is magnified, i.e. is larger than screen resolution. Default: "linear"
     *     + "nearest" - this nearest texel value is chosen.
     *     + "linear" - the texel value is computing by averaging the four nearest texels.
     *
     * These fields take a texture object as a parameter:
     *
     * + `texture_type` {String} Default: "none"
     *     + "constant" - Each particle has the same texture, specified by `texture_constant`.
     *     + "randPick" - Each particle has a single texture, chosen at random from a set of textures.
     *     + "keyframes" - Each particle animates through a series of textures.
     *     + "none" - particle is an untextured solid square
     * + `texture_constant` {Object} - Describes particle texture used for all particles.  Only used if `texture_type` is "constant".
     * + `texture_randPick` {[Object, ...]} - An array of objects that describe a texture.
     * + `texture_keyframes` {[{"key": Number, "value": Object}, ...]} - An array of keyframes.
     *   Each keyframe is an object with two keys:
     *     + "key" {Number} - a value from (0, 1) where 0 is the beginning of a particles lifetime and 1 is the end.
     *     + "value" - {Object} - the texture object desired at that time.
     *
     * @constructs The default constructor.
     * @augments Core.Class
     * @since 1.8
     */
    initialize: function ()
    {
        Core.ObjectRegistry.register(this);
        this._createSendGen(this.__objectRegistryId);
        this._callbackIndexCounter = 1;
        this._callbacks = [];
    },

    /**
     * Destroys this `EmitterData` object.
     * When you call `destroy` on a `EmitterData` object that is referred to by existing `{@link GL2.Emitter}`
     * objects, the `EmitterData` object is not destroyed until the last referring `{@link GL2.Emitter}` object is destroyed.
     * @returns {void}
     * @since 1.8
     * @status iOS, Android, Flash
     */
    destroy: function ()
    {
        this._destroySendGen();
        Core.ObjectRegistry.unregister(this);
    },

    /**
     * Verifies that `dataFormat` is a legal `EmitterData.DataFormat` enum.
     * @param {GL2.EmitterData.DataFormat} dataFormat The data format to check. Currently, only GL2.EmitterData.GravityEmitterData is supported.
     * @returns {Boolean}
     * @since 1.8
     * @status iOS, Android, Flash
     */
    isDataFormatSupported: function (dataFormat)
    {
        if (Core.Capabilities.meetsBinaryVersion && Core.Capabilities.meetsBinaryVersion([1,8,0,0,0])) {
            return dataFormat === EmitterData.DataFormat.GravityEmitterData;
        } else {
            return false;
        }
    },

    /**
     * Initialize this `EmitterData` object with particle system data in a given format.
     * This will completely erase and replace all existing data currently used by this `EmitterData`.
     * If you wish to only modify a subset of the existing data, not replace all of it, use the {@link GL2.EmitterData#mergeData} method instead.
     * The callback will be evoked when data parsing is complete or in the event of an error.
     * The callback is called with two arguments an error object with a code and description fields, as well as the `EmitterData` object itself.
     * @param {Object | String} dataOrJSONString A data object or a string in JSON format
     * @param {GL2.EmitterData.DataFormat} dataFormat The data format of the dataOrJSONString argument
     * @cb {Function} callback Called in the case of an error when reading the object or string
     * @cb-param {Object} error Error object detailing the parse error
     * @cb-param {GL2.EmitterData.ErrorCode} error.code 
     * @cb-param {String} error.description Description of the error
     * @cb-returns {void}
     * @returns {GL2.EmitterData}
     * @since 1.8
     * @status iOS, Android, Flash
     */
    initFromData: function (dataOrJSONString, dataFormat, callback)
    {
		var id;
		if (this.isDataFormatSupported(dataFormat))
		{
			if (typeof dataOrJSONString === 'string' || typeof dataOrJSONString === 'object') {
				// register callback
				id = this._callbackIndexCounter++;
				this._callbacks[id] = callback;
				if (typeof dataOrJSONString === 'string') {
					this._initFromDataSendGen(dataOrJSONString, dataFormat, id);
				} else {
					this._initFromDataSendGen(JSON.stringify(dataOrJSONString), dataFormat, id);
				}
			} else {
				if (callback && typeof callback === 'function') {
					callback({ code: EmitterData.ErrorCode.TypeError, description: "Expected Object or String" }, this);
				}
			}
		} else {
			if (callback && typeof callback === 'function') {
				callback({ code: EmitterData.ErrorCode.UnsupportedFormat, description: "Data Format Not Supported" }, this);
			}
		}
		return this;
	},

    /**
     * Change a subset of this `EmitterData` object properties. This will only change the data specified.
     * Any unspecified data will not be changed.  This can be used to apply delta updates.
     * @param {Object | String} dataOrJSONString A data object or a string in JSON format
     * @returns {this}
     * @since 1.8
     * @status iOS, Android, Flash
     */
    mergeData: function (dataOrJSONString)
    {
        if (typeof dataOrJSONString === 'string') {
            this._mergeDataSendGen(dataOrJSONString);
        } else {
            this._mergeDataSendGen(JSON.stringify(dataOrJSONString));
        }
        return this;
    },

    /**
     * Initialize this `EmitterData` object with particle system data in the given format from a JSON formatted file.
     * This will completely erase and replace all existing data currently used by this `EmitterData`.
     * The callback will be envoked when data parsing is complete or in the case of an error.
     * @example
     * ed.initFromJSONFile('Content/explosion.json', GL2.EmitterData.DataFormat.GravityEmitterData, function (error, ed) {
     *     if (error) {
     *         console.log("error.code = " + error.code + ", error.description = " + error.description);
     *         throw new Error(error.description);
     *     } else {
     *         console.log('success!');
     *     }
     * });
     * @param {String} filename The path to the file relative to the game root
     * @param {GL2.EmitterData.DataFormat} dataFormat The data format of the file argument
     * @cb {Function} callback Called in the case of an error when reading the object or string
     * @cb-param {Object} error Error object detailing the parse error
     * @cb-param {GL2.EmitterData.ErrorCode} error.code 
     * @cb-param {String} error.description Description of the error
     * @cb-returns {void}
     * @returns {GL2.EmitterData}
     * @since 1.8
     * @status iOS, Android, Flash
     */
    initFromJSONFile: function (filename, dataFormat, callback)
    {
		var id;
		if (this.isDataFormatSupported(dataFormat))
		{
			if (typeof filename === 'string') {
				// register callback
				id = this._callbackIndexCounter++;
				this._callbacks[id] = callback;
				this._initFromJSONFileSendGen(filename, dataFormat, id);
			} else {
				callback({ code: EmitterData.ErrorCode.InvalidFilename, description: "Invalid filename" }, this);
			}
		} else {
			if (callback && typeof callback === 'function') {
				callback({ code: EmitterData.ErrorCode.UnsupportedFormat, description: "Data Format Not Supported" }, this);
			}
		}
		return this;
	},

    /**
     * @private
     */
    _invokeCallbackRecv: function (cmd) {
        var msg = {};
        if (!this._invokeCallbackRecvGen(cmd, msg)) {
            return;
        }

        var id = msg.callbackId;
        if (!id) {
            NgLogE("GL2.EmitterData._invokeCallbackRecv command : bad id = " + id);
            return;
        }
        var cb = this._callbacks[id];
        if (!cb) {
            NgLogE("GL2.EmitterData._invokeCallbackRecv command : No registered callback found, id = " + id);
            return;
        }
        delete this._callbacks[id];
        if (msg.description) {
            // pass error to callback
            cb({ code: msg.code, description: msg.description }, this);
        } else {
            // no error, pass null to callback
            cb(null, this);
        }
    },

// {{?Wg Generated Code}}
	
	// Enums.
	DataFormat:
	{ 
		GravityEmitterData: 0
	},
	
	ErrorCode:
	{ 
		TypeError: 0,
		UnsupportedFormat: 1,
		InvalidFilename: 2,
		ParseError: 3,
		DataError: 4
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 367,
	// Method create = -1
	// Method destroy = 2
	// Method initFromData = 3
	// Method initFromJSONFile = 4
	// Method invokeCallback = 5
	// Method mergeData = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in EmitterData._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in EmitterData._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[367] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in EmitterData.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in EmitterData.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "description" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "description" ] === undefined )
		{
			NgLogE("Could not parse description in EmitterData.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in EmitterData.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( id )
	{
		Core.Proc.appendToCommandString( 0x16fffff, [ +id ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x16f0002, this );
	},
	
	/** @private */
	_initFromDataSendGen: function( emitterData, dataFormat, callbackId )
	{
		Core.Proc.appendToCommandString( 0x16f0003, this, [ Core.Proc.encodeString( emitterData ), +dataFormat, +callbackId ] );
	},
	
	/** @private */
	_initFromJSONFileSendGen: function( filename, dataFormat, callbackId )
	{
		Core.Proc.appendToCommandString( 0x16f0004, this, [ Core.Proc.encodeString( filename ), +dataFormat, +callbackId ] );
	},
	
	/** @private */
	_mergeDataSendGen: function( emitterData )
	{
		Core.Proc.appendToCommandString( 0x16f0006, this, [ Core.Proc.encodeString( emitterData ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( id ) {}
	
	// destroy: function(  ) {}
	
	// initFromData: function( emitterData, dataFormat, callbackId ) {}
	
	// initFromJSONFile: function( filename, dataFormat, callbackId ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// mergeData: function( emitterData ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Emitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Emitter'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Emitter'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Emitter.js';

////////////////////////////////////////////////////////////////////////////////
// Class Emitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Node = require('NGCore/Client/GL2/Node').Node;
var EmitterData = require('NGCore/Client/GL2/EmitterData').EmitterData;


////////////////////////////////////////////////////////////////////////////////

var Emitter = exports.Emitter = Node.subclass(
/** @lends GL2.Emitter.prototype */
{
	classname: 'Emitter',

	/**
	 * @class The `GL2.Emitter` class is a `{@link GL2.Node}` that can play a particle effect defined by a `{@link GL2.EmitterData}` object.
	 *
	 * `{@link GL2.EmitterData}` objects are associated with the `Emitter` using the 
	 * `setData` method. Once `EmitterData` is associated with the Emitter, the particle
	 * effect can be played by calling the `play` method or stopped by using the `stop` 
	 * method. The application can be notified when the particle system has stopped emitting 
	 * particles by registering a callback with the `onDoneCallback` method.
	 * Similarly, the application can be notified when all the particles in the system 
	 * have been killed (i.e. no longer visible) by using the `onDeadCallback` method.
	 *
	 * All particles in the system are relative to the `Emitter` object's position, scale, 
	 * and  rotation, which can be changed using the `setPosition`, `setScale`, and 
	 * `setRotation` methods inherited from the {@link GL2.Node} base class.
	 * @name GL2.Emitter
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 * @since 1.8
	 */
	initialize: function () {

	},

    /**
     * Destroys this GL2.Emitter. When using objects with
     * a native counterpart, you must explicitly destroy them to avoid leaking memory.
     * @returns {void}
     * @since 1.8
     * @status iOS, Android, Flash
     */
	destroy: function () {

	},

	/**
	 * Begins playback of the particle system.
     * @returns {void}
     * @since 1.8
     * @status iOS, Android, Flash
	 */
	play: function () {
		this._playSendGen();
	},

	/**
	 * Stops playback of the particle system.
	 * 
     * @returns {void}
     * @param {GL2.Emitter.StopMode} stopMode Determines whether to stop emitting particles 
     * _and_ stop playback or to stop emitting particles and allow individual particles to
     * complete their playback cycle.
     * @since 1.8
     * @status iOS, Android, Flash
     * @see GL2.Emitter#StopMode
	 */
	stop: function (stopMode) {
		var mode = (stopMode === undefined) ? Emitter.StopMode.Soft : stopMode;

		this._stopSendGen(mode);
	},

	/**
	 * Associates a `{@link GL2.EmitterData}` object with this `Emitter`.
	 * This is required for play and stop to function.
     * @returns {void}
     * @param {GL2.EmitterData} data An `EmitterData` object describing the behavior of the particle system.
     * @since 1.8
     * @status iOS, Android, Flash
	 */
	setData: function (data) {
		this._setDataSendGen(data.__objectRegistryId);
	},

	/**
	 * Registers a user defined callback function that will be called when this emitter 
	 * stops emitting particles.
     * @returns {void}
     * @cb {Function} doneCallback The function that will be called upon completion of the animation
     * @cb-param {GL2.Emitter} emitter The emitter which triggered the callback
     * @cb-returns {void}
     * @since 1.8
     * @status iOS, Android, Flash
	 */
	setDoneCallback: function (doneCallback)
	{
		this._doneCallback = doneCallback;
	},

	/**
	 * Registers a user defined callback function that will be called when all of this 
	 * emitter's particles have finished their playback cycle.
     * @returns {void}
     * @cb {Function} deadCallback
     * @cb-param {GL2.Emitter} emitter The emitter which triggered the callback
     * @cb-returns {void}
     * @since 1.8
     * @status iOS, Android, Flash
	 */
	setDeadCallback: function (deadCallback)
	{
		this._deadCallback = deadCallback;
	},

	/**
	 * @private
	 */
	_invokeDoneCallbackRecv: function () {
		if (this._doneCallback)
			this._doneCallback(this);
	},

	/**
	 * @private
	 */
	_invokeDeadCallbackRecv: function () {
		if (this._deadCallback)
			this._deadCallback(this);
	},
	
	/**
	 * Enumeration for stop modes.
	 * @name StopMode
	 * @fieldOf GL2.Emitter#
	 * @see GL2.Emitter#stop
	 */
	/**
	 * The system will stop emitting particles. Any existing particles will continue to play to
	 * completion.
	 * @name StopMode.Soft
	 * @fieldOf GL2.Emitter#
	 * @constant
	 */
	/**
	 * The system will stop emitting particles. All existing particles will immediately stop as
	 * well.
	 * @name StopMode.Hard
	 * @fieldOf GL2.Emitter#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	StopMode:
	{ 
		Soft: 0,
		Hard: 1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 368,
	// Method create = -1
	// Method destroy = 2
	// Method setData = 3
	// Method play = 4
	// Method stop = 5
	// Method invokeDoneCallback = 6
	// Method invokeDeadCallback = 7
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._invokeDoneCallbackRecv( cmd );
					break;
				case 7:
					instance._invokeDeadCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Emitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Emitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[368] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeDoneCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Emitter.invokeDoneCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_invokeDeadCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Emitter.invokeDeadCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( id )
	{
		Core.Proc.appendToCommandString( 0x170ffff, [ +id ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1700002, this );
	},
	
	/** @private */
	_setDataSendGen: function( emitterDataId )
	{
		Core.Proc.appendToCommandString( 0x1700003, this, [ +emitterDataId ] );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1700004, this );
	},
	
	/** @private */
	_stopSendGen: function( stopMode )
	{
		Core.Proc.appendToCommandString( 0x1700005, this, [ +stopMode ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( id ) {}
	
	// destroy: function(  ) {}
	
	// setData: function( emitterDataId ) {}
	
	// play: function(  ) {}
	
	// stop: function( stopMode ) {}
	
	// _invokeDoneCallbackRecv: function( cmd ) {}
	// _invokeDeadCallbackRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Font'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Font'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Font'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Font.js';

////////////////////////////////////////////////////////////////////////////////
// Class Font
// Font object implementation
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;


////////////////////////////////////////////////////////////////////////////////

var Font = exports.Font = Core.Class.subclass(
/** @lends GL2.Font.prototype */
{
	classname: 'Font',

	/**
	 * @class The `GL2.Font` class creates font objects that can be used by `{@link GL2.Text}`
	 * objects. When you create a new font object, you can specify that the font should be loaded
	 * asynchronously, so that the application is not blocked while it waits for the font to load.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @example
	 * var obj = new GL2.Font("Content/fontname.ttf",
	 *    {
	 *        location: GL2.Font.FontLocation.Manifest,
	 *        size: 16,
	 *        readFontAsync: true
	 *    },
	 *    function (error, object) {
	 *        if (error) {
	 *            console.log("Unable to read font family file: " + error.description);
	 *        } else {
	 *            console.log("The font family file was read: " + object.getFontFamily());
	 *        }
	 *    }
	 * );
	 * @param {String} fontFamily Name of the font family to load.
	 * @param {Object} [options] Options for loading the font.
	 * @param {Boolean} [options.readFontAsync=false] Set to `true` to load the font asynchronously.
	 * @param {GL2.Font.FontLocation} [options.location=GL2.Font.FontLocation.Default] Location of
	 *		the font family to load.
	 * @param {Number} [options.size=18] Size of the font, in pixels per em.
	 * @cb {Function} [createCallback] createCallback The function to call after the font has been
	 *		loaded.
	 * @cb-param {Object} error error Information about the error, if any.
	 * @cb-param {GL2.Font#ErrorCode} [error.code] [error.code] A code identifying the error type.
	 * @cb-param {String} [error.description] [error.description] A description of the error.
	 * @cb-param {GL2.Font} object object The `GL2.Font` object.
	 * @cb-returns {void}
	 * @returns {void}
	 * @status iOS, Android
	 * @since 1.8
	 */
	initialize: function( fontFamily, options, createCallback )
	{
		// default state
		this._isFontValid = false;
		this._fontFamily = '';
		this._options = Font.OptionFlags.DefaultOptions;
		this._location = Font.FontLocation.Default;
		this._size = 18;

		// parameters
		if ( fontFamily && typeof( fontFamily ) == 'string' ) {
			this._fontFamily = fontFamily;
		}

		if ( options && typeof( options ) == 'object' ) {
			if ( options['readFontAsync'] ) {
				this._options |= Font.OptionFlags.ReadFontAsync;
			}
			if ( options['location'] ) {
				this._location = options['location'];
			}
			if ( options['size'] ) {
				this._size = options['size'];
			}
		} else {
			createCallback = options;
		}

		// callback management
		this._nextCbId = 0;
		this._cb = {};
		this._storeCb = function( cb ) {
			var cbId = -1;
			if ( cb && typeof( cb ) == 'function' ) {
				cbId = this._nextCbId++;
				this._cb[cbId] = cb;
			}
			return cbId;
		};
		this._restoreCb = function( cbId ) {
			var cb = function () {};
			if ( cbId >= 0 ) {
				cb = this._cb[cbId];
				delete this._cb[cbId];
			}
			return cb;
		};

		// finish up
		Core.ObjectRegistry.register( this );

		this._createSendGen(    this.__objectRegistryId,
								this._storeCb( createCallback ),
								this._fontFamily,
								this._options,
								this._location,
								this._size );

	},

	/**
	 * Destroy the `GL2.Font` object, and release the resources allocated by the font.
	 *
	 * **Note**: If another `GL2` object is using the `GL2.Font` object, the font resources will not
	 * be released.
	 * @returns {void}
	 * @status iOS, Android
	 * @since 1.8
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister( this );
	},

	/** @private */
    _onCreateCbRecv: function( cmd ) {
		var obj = {};
		if ( this._onCreateCbRecvGen( cmd, obj ) ) {
			if ( obj['callbackId'] >= 0 ) {
				var cb = this._restoreCb( obj['callbackId'] );
				var err = obj['errCode'] ? { code:obj['errCode'], description:obj['errStr'] } : null;
                if ( !err ) {
                    this._isFontValid = true;
                }
				cb( err, this );
			}
		}
    },


// API

	/**
	 * Retrieve the name of the font family.
	 * @returns {String} The font family for this font object.
	 * @status iOS, Android
	 * @since 1.8
	 */
	getFontFamily: function()
	{
		return this._fontFamily;
	},

	/**
	 * Retrieve the location where the font family is stored.
	 * @returns {GL2.Font.FontLocation} The location where the font family is stored.
	 * @status iOS, Android
	 * @since 1.8
	 */
	getFontLocation: function()
	{
		return this._location;
	},

	/**
	 * Retrieve the font size.
	 * @returns {Number} The font size, in pixels per em.
	 * @status iOS, Android
	 * @since 1.8
	 */
	getFontSize: function()
	{
		return this._size;
	},
	
	/**
	 * Enumeration for font loading errors.
	 * @name ErrorCode
	 * @fieldOf GL2.Font#
	 */
	
	/**
	 * No error occurred.
	 * @name ErrorCode.NoError
	 * @fieldOf GL2.Font#
	 * @constant
	 */

	/**
	 * An unknown error occurred.
	 * @name ErrorCode.Unknown
	 * @fieldOf GL2.Font#
	 * @constant
	 */

	/**
	 * The requested font was not found.
	 * @name ErrorCode.NotFound
	 * @fieldOf GL2.Font#
	 * @constant
	 */

	/**
	 * The requested operation is not available.
	 * @name ErrorCode.Unsupported
	 * @fieldOf GL2.Font#
	 * @constant
	 */
	
	/**
	 * Enumeration for font loading options.
	 * @name OptionFlags
	 * @fieldOf GL2.Font#
	 * @private
	 */

	/**
	 * Use the default options.
	 * @name OptionFlags.DefaultOptions
	 * @fieldOf GL2.Font#
	 * @constant
	 * @private
	 */

	/**
	 * Load the font asynchronously.
	 * @name OptionFlags.ReadFontAsync
	 * @fieldOf GL2.Font#
	 * @constant
	 * @private
	 */

	/**
	 * Enumeration to choose the source of fonts for `GL2.Font`.
	 * @name FontLocation
	 * @fieldOf GL2.Font#
	 */

	/**
	 * Use the default fonts, which are the system fonts. Equivalent to
	 * `{@link GL2.Font#FontLocation.System}`.
	 * @name FontLocation.Default
	 * @fieldOf GL2.Font#
	 * @constant
	 */

	/**
	 * Use the system fonts.
	 * @name FontLocation.System
	 * @fieldOf GL2.Font#
	 * @constant
	 */

	/**
	 * Use the fonts that are bundled with ngCore. Not currently supported.
	 * @name FontLocation.Bundled
	 * @fieldOf GL2.Font#
	 * @constant
	 * @ignore
	 */

	/**
	 * Use custom fonts that are loaded through the application manifest.
	 * @name FontLocation.Manifest
	 * @fieldOf GL2.Font#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	ErrorCode:
	{ 
		NoError: 0,
		Unknown: -1,
		NotFound: -2,
		Unsupported: -3
	},
	
	FontLocation:
	{ 
		Default: 0,
		System: 1,
		Bundled: 2,
		Manifest: 3
	},
	
	OptionFlags:
	{ 
		DefaultOptions: 0,
		ReadFontAsync: 1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 369,
	// Method create = -1
	// Method destroy = 2
	// Method onCreateCb = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._onCreateCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Font._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Font._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[369] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onCreateCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Font.onCreateCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in Font.onCreateCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Font.onCreateCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Font.onCreateCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId, callbackId, fontFamily, options, fontLocation, fontSize )
	{
		Core.Proc.appendToCommandString( 0x171ffff, [ +__objectRegistryId, +callbackId, Core.Proc.encodeString( fontFamily ), +options, +fontLocation, +fontSize ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1710002, this );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId, callbackId, fontFamily, options, fontLocation, fontSize ) {}
	
	// destroy: function(  ) {}
	
	// _onCreateCbRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/MotionData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/MotionData'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/MotionData'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/MotionData.js';

var Core = require ('NGCore/Client/Core').Core;


var MotionData = exports.MotionData = Core.Class.subclass(
/** @lends GL2.MotionData.prototype */
{
	classname: 'MotionData',

    /**
     * @class
     * MotionData The `MotionData` class stores animation keyframe data that multiple `{@link GL2.MotionController}` objects can reference. A `MotionData` object
     * can store multiple animations. Each animation has a unique name, stored as a string.
     *
     * Animation keyframe data is stored as a JSON object with the following properties:
     *
     * + `motions`: This key is the root property of an animation. Each animation object has a unique name and contains the subsequent `Keyframe` and `source` elements.
     * + name: A unique string that identifies the animation.
     * + `Keyframe`: An array of keyframe definitions. Each keyframe has the following properties:
     *     + `x`: X position coordinate relative to the coordinates in the `source` field. The `source` field coordinates are generated by calling `{@link GL2.Node.setPosition}`.
     *     + `y`: Y position coordinate relative to the coordinates in the `source` field. The `source` field coordinates are generated by calling `{@link GL2.Node.setPosition}`.
     *     + `scaleX`: A positive horizontal scale multiplication factor.
     *     + `scaleY`: A positive vertical scale multiplication factor.
     *     + `index`: The frame this keyframe represents. An index of 0 represents the first frame of the animation.
     *     + `alpha`: A value from 0 to 1 indicating the opacity percentage of the alpha channel.
     *     + `rotation`: A rotation value from -180 degrees to 180 degrees.
     * + `source`: A source object defines properties of the animation and has the following properties:
     *     + `framerate`: An integer that specifies how many animation frames play per second. The value of `framerate` and the highest `index` value of any element in the `Keyframe`
     *        array define the duration of the animation. An animation with a `framerate` value of 30 and a `Keyframe` with the highest `index` value of 60 takes 2 seconds to play, for example.
     *     + `x`: X position coordinate generated by calling `{@link GL2.Node.setPosition}`.
     *     + `y`: Y position coordinate generated by calling `{@link GL2.Node.setPosition}`.
     *     + `scaleX`: A positive horizontal scale multiplication factor.
     *     + `scaleY`: A positive vertical scale multiplication factor.
     *     + `alpha`: A value from 0 to 1 indicating the opacity percentage of the alpha channel.
     *     + `rotation`: A rotation value from -180 degrees to 180 degrees.
     *
     * **Example animation JSON block**
     *
     * <pre>
     * {
     *     "motions": {
     *         "alphafade": {
     *             "Keyframe": [{
     *                 "x": 0,
     *                 "scaleX": 1,
     *                 "y": 0,
     *                 "scaleY": 1,
     *                 "index": 0,
     *                 "alpha": 1,
     *                 "rotation": 0
     *             }, {
     *                 "x": 0,
     *                 "scaleX": 1,
     *                 "y": 0,
     *                 "scaleY": 1,
     *                 "index": 15,
     *                 "alpha": 0,
     *                 "rotation": 0
     *             }, {
     *                 "x": 0,
     *                 "scaleX": 1,
     *                 "y": 0,
     *                 "scaleY": 1,
     *                 "index": 30,
     *                 "alpha": 1,
     *                 "rotation": 0
     *             }],
     *             "source": [{
     *                 "frameRate": 30,
     *                 "x": 100.84,
     *                 "scaleX": 1,
     *                 "y": -94.2,
     *                 "scaleY": 1,
     *                 "rotation": 0,
     *                 "alpha": 1
     *             }]
     *         }
     *     }
     * }
     * </pre>
     *
     * @example
     * md = new GL2.MotionData();
     * md.initFromJSONFile('Content/animations.json', GL2.MotionData.DataFormat.FlashClassicTween, function (error, md) {
     *     var mc;
     *     if (error) {
     *         console.log('error');
     *     } else {
     *         mc = new GL2.MotionController(md);
     *     }
     * });
     * @constructs Create a MotionData instance.
     * @since 1.7
     */
	initialize: function ()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._callbackIndexCounter = 1;
		this._callbacks = [];
	},

    /**
     * @function
     *
     * Destroy this `MotionData` object.
     * Destroy all `{@link GL2.MotionController}` instances that reference a `MotionData` object before calling this method.
     * When you call this method on a `MotionData` object that is referred to by existing `{@link GL2.MotionController}`
     * objects, the `MotionData` object is not destroyed until the last referring `{@link GL2.MotionController}` object is destroyed.
     *
     * @returns {void}
     * @since 1.7
     */
	destroy: function ()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

    /**
     * @function
     *
     * Verifies that a given `MotionData.DataFormat` enum has a legal value.
     * @example
     * md = new GL2.MotionData();
     * if (md.isDataFormatSupported(GL2.MotionData.DataFormat.FlashClassicTween)) {
     * 	console.log('Flash Classic Tween is supported!');
     * }
     * @param {GL2.MotionData.DataFormat} dataFormat The data format to test.
     * @returns {Boolean} true when the given dataFormat enum has a legal value. This method returns <code>false</code> in all other cases.
     * @since 1.7
     */
	isDataFormatSupported: function (dataFormat)
	{
		if (Core.Capabilities.meetsBinaryVersion && Core.Capabilities.meetsBinaryVersion([1,7,0,0,0])) {
			return dataFormat === MotionData.DataFormat.FlashClassicTween;
		} else {
			return false;
		}
	},

    /**
     * @function
     *
     * Initialize this `MotionData` object with keyframe data in the given format. This method loads the data in JavaScript.
     * @param {Object|String} dataOrJSONString Animation data. This parameter can be a raw JavaScript object or a JSON string.
     * @param {GL2.MotionData.DataFormat} dataFormat The format for the keyframe data.
     * @cb {Function} callback The function to call after creating the transaction.
     * @cb-param {String} error The error string. This parameter is undefined if there is no error.
     * @cb-param {MotionData} object This <code>MotionData</code> object.
     * @cb-returns {void}
     * @example
     * var data = {
     * 	motions: {
     * 		left_to_right: {
     * 			Kefyrame: [{x: 0, y: 120, scaleX: 1, scaleY: 1, rotation: 0, index: 0},
     * 					   {x: 320, y: 120, scaleX: 1, scaleY: 1, rotation: 0, index: 30}],
     * 			source: [{x: 0, y: 0, scaleX: 1, scaleY: 1, rotation: 0}]
     * 		}
     * 	}
     * };
     * md = new GL2.MotionData();
     * md.initFromData(data, GL2.MotionData.DataFormat.FlashClassicTween, function (error, md) {
     * 	if (error) {
     * 		console.log('error');
     * 	} else {
     * 		console.log('success');
     * 	}
     * });
     * @returns {this}
     * @since 1.7
     */
    initFromData: function (dataOrJSONString, dataFormat, callback)
	{
		var id;
		if (this.isDataFormatSupported(dataFormat))
		{
			if (typeof dataOrJSONString === 'string' || typeof dataOrJSONString === 'object') {
				// register callback
				id = this._callbackIndexCounter++;
				this._callbacks[id] = callback;
				if (typeof dataOrJSONString === 'string') {
					this._initFromDataSendGen(dataOrJSONString, dataFormat, id);
				} else {
					this._initFromDataSendGen(JSON.stringify(dataOrJSONString), dataFormat, id);
				}
			} else {
				if (callback && typeof callback === 'function') {
					callback("Expected Object or String");
				}
			}
		} else {
			if (callback && typeof callback === 'function') {
				callback("Data Format Not Supported");
			}
		}
		return this;
	},

    /**
     * @function
     *
     * Initialize this `MotionData` object with keyframe data from a JSON file. This method loads the data in native code.
     * @param {String} filename The file where the animation data is stored in JSON format.
     * @param {GL2.MotionData.DataFormat} dataFormat The format for the keyframe data.
     * @cb {Function} callback The function to call after creating the transaction.
     * @cb-param {String} error The error string. This parameter is undefined if there is no error.
     * @cb-param {GL2.MotionData} object This <code>MotionData</code> object.
     * @cb-returns {void}
     * @example
     * md = new GL2.MotionData();
     * md.initFromJSONFile('Content/animations.json', GL2.MotionData.DataFormat.FlashClassicTween, function (error, md) {
     * 	if (error) {
     * 		console.log('error');
     * 	} else {
     * 		console.log('success');
     * 	}
     * });
     * @returns {this}
     * @since 1.7
     */
	initFromJSONFile: function (filename, dataFormat, callback)
	{
		var id;
		if (this.isDataFormatSupported(dataFormat))
		{
			if (typeof filename === 'string') {
				// register callback
				id = this._callbackIndexCounter++;
				this._callbacks[id] = callback;
				this._initFromJSONFileSendGen(filename, dataFormat, id);
			} else {
				callback("Invalid filename");
			}
		} else {
			if (callback && typeof callback === 'function') {
				callback("Data Format Not Supported");
			}
		}
		return this;
	},

	/**
	 * @private
     */
	_invokeCallbackRecv: function (cmd) {
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		var err = msg.error;
		if (!id) {
			NgLogE("GL2.MotionData._invokeCallbackRecv command : bad id = " + id);
			return;
		}
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("GL2.MotionData._invokeCallbackRecv command : No registered callback found, id = " + id);
			return;
		}
		delete this._callbacks[id];
		cb(err, this);
	},

    /**
     * Enumerated values for `MotionData` objects.
     * @name DataFormat
     * @fieldOf GL2.MotionData#
     */

    /**
     * The Flash Classic Tween animation format
     * @name DataFormat.FlashClassicTween
     * @fieldOf GL2.MotionData#
     * @constant
     */

// {{?Wg Generated Code}}
	
	// Enums.
	DataFormat:
	{ 
		FlashClassicTween: 0
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 364,
	// Method create = -1
	// Method destroy = 2
	// Method initFromData = 3
	// Method initFromJSONFile = 4
	// Method invokeCallback = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionData._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionData._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[364] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionData.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in MotionData.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in MotionData.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( id )
	{
		Core.Proc.appendToCommandString( 0x16cffff, [ +id ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x16c0002, this );
	},
	
	/** @private */
	_initFromDataSendGen: function( animData, dataFormat, callbackId )
	{
		Core.Proc.appendToCommandString( 0x16c0003, this, [ Core.Proc.encodeString( animData ), +dataFormat, +callbackId ] );
	},
	
	/** @private */
	_initFromJSONFileSendGen: function( filename, dataFormat, callbackId )
	{
		Core.Proc.appendToCommandString( 0x16c0004, this, [ Core.Proc.encodeString( filename ), +dataFormat, +callbackId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( id ) {}
	
	// destroy: function(  ) {}
	
	// initFromData: function( animData, dataFormat, callbackId ) {}
	
	// initFromJSONFile: function( filename, dataFormat, callbackId ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/MotionController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/MotionController'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/MotionController'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/MotionController.js';

var Core = require ('NGCore/Client/Core').Core;
var Node = require('NGCore/Client/GL2/Node').Node;
var MotionData = require('NGCore/Client/GL2/MotionData').MotionData;


var MotionController = exports.MotionController = Core.Class.subclass(
/** @lends GL2.MotionController.prototype */
{
    classname: 'MotionController',

    /**
     * @class
     * The `MotionController` class animates the motion of several `{@link GL2.Node}` objects using keyframe data that is stored in a `{@link GL2.MotionData}` object. You can use
     * the methods in this class in parallel with `{@link GL2.Animation}` or independently. The `{@link GL2.Animation}` class provides functionality to support flip-book style animation
     * for sprite sheets, while `MotionController` enables apps to animate a static texture around the screen.
     * Multiple `MotionController` objects can share a single `{@link GL2.MotionData}` object. Sharing a `{@link GL2.MotionData}` object
     * reduces total memory footprint for your app.
     * A single `MotionController` object can animate multiple nodes at once. This capability enables your app to animate multi-sprite characters as
     * single unit.
     *
     * **Note**: The `position` and `rotation` fields of an animated `{@link GL2.Node}` object do not reflect to the
     * underlying JavaScript by default. Synchronizing these fields has a high performance cost. Use the `MotionController.syncContinuous` or `MotionController.syncFrames`
     * methods when you need to update these fields.
     *
     * @constructs Create a `MotionController` object to manage animations.
     * @param {GL2.MotionData} MotionData A `{@link GL2.MotionData}` object that holds keyframe animation data.
     * @augments Core.Class
     * @since 1.7
     */
	initialize: function (motionData)
	{
		Core.ObjectRegistry.register(this);
		this._motionData = motionData;
		this._syncCallbacks = {};
		this._timeScale = 1.0;

		this._createSendGen(this.__objectRegistryId, motionData.__objectRegistryId);
	},

    /**
     * Destroy this `MotionController` object.
     * Any `{@link GL2.Node}` objects bound to this controller become unbound and stop animating.
     * @since 1.7
     */
	destroy: function ()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

    /**
     * @function
     *
     * Bind a named animation to a `{@link GL2.Node}` object.
     * This function looks up the named animation in the `{@link GL2.MotionData}` object that is associated with this `MotionController` object.
     * This function animates the bound `{@link GL2.Node}` instance when this `MotionController` plays.
     * A specific named animation can be bound to a maximum of one `{@link GL2.Node}` object. You can call this method multiple times to
     * bind a single `{@link GL2.MotionController}` object to multiple named animations.
     * You can use a single `MotionController` object to animate a set of multiple `{@link GL2.Node}` objects.
     * You can use the optional `syncFlags` parameter to specify a set of fields to animate, such as `Position` and `Rotation` but not `Scale`. See the enums documentation for more
     * information about these fields.
     * The `syncFlags` parameter can be in two formats:
     *
     * + The result of a bitwise OR operation on several `syncFlags` values.
     * + An array of `syncFlags` values.
     *
     * This method has no effect when the animation is not found.
     * @example
     * md = new GL2.MotionData();
     * md.initFromJSONFile('Content/animations.json', GL2.MotionData.DataFormat.FlashClassicTween, function (error, md) {
     *  var mc, sprite, syncFlags;
     *  if (error) {
     *      console.log('error');
     *  } else {
     *      mc = new GL2.MotionController(md);
     *      sprite = new GL2.Sprite().setImage('Content/sprite.png', [100, 100], [0.5, 0.5]);
     *      // animate sprite position and scale ONLY.
     *      syncFlags = GL2.MotionController.SyncFlags.Position | GL2.MotionController.SyncFlags.Scale;
     *      mc.bind('sprite_anim_name', sprite, syncFlags);
     *      mc.play();
     *  }
     * });
     * @param {String} name The name of the animation to look up and bind.
     * @param {GL2.Node} node The <code>{@link GL2.Node}</code> object to bind to the named animation.
     * @param {Number | Array} [syncFlags=GL2.MotionController.SyncFlags.All] An array of <code>GL2.MotionController.syncFlags</code> values or the result of a
     * bitwise OR operation across several <code>GL2.MotionController.syncFlags</code> values.
     * @returns {this}
     * @since 1.7
     */
	bind: function (name, node, syncFlags)
	{
		var flags, i;
		if (syncFlags instanceof Array) {
			flags = 0;
			for (i = 0; i < syncFlags.length; i++) {
				flags = flags | syncFlags[i];
			}
		} else if (typeof syncFlags === 'number') {
			flags = syncFlags;
		} else {
			flags = MotionController.SyncFlags.All;
		}
		delete this._syncCallbacks[name];
		this._bindSendGen(name, node.__objectRegistryId, flags);
		return this;
	},

    /**
     * @function
     *
     * Unbind a named animation from a `{@link GL2.Node}` object. The `{@link GL2.Node}` object stops receiving updates.
     * The animation continues to play and any other `{@link GL2.Node}` objects that are bound to the named animation
     * continue to receive updates.
     * @param {String} name The name of the animation to unbind from the <code>{@link GL2.Node}</code> object.
     * @returns {this}
     * @since 1.7
     */
	unbind: function (name)
	{
		delete this._syncCallbacks[name];
		this._unbindSendGen(name);
		return this;
	},

    /**
     * @function
     *
     * Play all animations currently bound to any `{@link GL2.Node}` object.
     * Animations begin playing from frame 0. Each bound `{@link GL2.Node}` object updates to follow the animations bound to that object.
     * @example
     * md = new GL2.MotionData();
     * md.initFromJSONFile('Content/animations.json', GL2.MotionData.DataFormat.FlashClassicTween, function (error, md) {
     *  var mc, sprite, syncFlags;
     *  if (error) {
     *      console.log('error');
     *  } else {
     *      mc = new GL2.MotionController(md);
     *      sprite = new GL2.Sprite().setImage('Content/sprite.png', [100, 100], [0.5, 0.5]);
     *      // animate sprite position and scale ONLY.
     *      syncFlags = GL2.MotionController.SyncFlags.Position | GL2.MotionController.SyncFlags.Scale;
     *      mc.bind('sprite_anim_name', sprite, syncFlags);
     *      mc.play(GL2.MotionController.PlayMode.Loop);
     *  }
     * });
     * @param {GL2.MotionController.PlayMode} [playMode=GL2.MotionController.PlayMode.Normal] The play mode for the animations.
     * @returns {this}
     * @since 1.7
     */
	play: function (playMode)
	{
		var mode = playMode || MotionController.PlayMode.Normal;
		this._playSendGen(mode);
		return this;
	},

    /**
     * @function
     *
     * Stop updating all currently bound animations.
     * @returns {this}
     * @since 1.7
     */
	stop: function ()
	{
		this._stopSendGen();
		return this;
	},

    /**
     * @function
     *
     * Updates the `{@link GL2.Node}` object bound to the named animation when the animation plays.
     * This method updates the fields requested by the `syncFlags` parameter for every animation frame that this `MotionController` object plays.
     * To minimize the performance effect of these updates, minimize the number of animations and the number of fields to update.
     * Use `syncFrames` to synchronize on specific animation frames.
     * The optional `syncFlags` parameter can be used to specify a set of fields to animate, such as `Position` and `Rotation` but not `Scale`.
     * The `syncFlags` parameter can be in two formats:
     *
     * + The result of a bitwise OR operation on several `syncFlags` values.
     * + An array of `syncFlag` values.
     *
     * @example
     * mc.syncContinuous('sprite_anim_name', GL2.MotionController.SyncFlags.Position);
     * @param {String} name The name of the animation bound to the Node that you wish to update.
     * @param {Number | Array} [syncFlags=GL2.MotionController.syncFlags.All] An array of <code>syncFlags</code> values, or the result of a bitwise OR operation across several <code>syncFlags</code> values.
     * @returns {this}
     * @since 1.7
     */
	syncContinuous: function (name, syncFlags)
	{
		var flags, i;
		if (syncFlags instanceof Array) {
			flags = 0;
			for (i = 0; i < syncFlags.length; i++) {
				flags = flags | syncFlags[i];
			}
		} else if (typeof syncFlags === 'number') {
			flags = syncFlags;
		} else {
			flags = MotionController.SyncFlags.All;
		}
		delete this._syncCallbacks[name];
		this._syncContinuousSendGen(name, flags);
		return this;
	},

    /**
     * @function
     *
     * Updates the `{@link GL2.Node}` object bound to the named animation when the animation plays.
     * This method updates the fields requested by the `syncFlags` parameter for each frame number passed in the `frameArray` parameter.
     * To minimize the performance effect of these updates, minimize the number of animations and the number of fields to update.
     * @param {String} name The name of the animation bound to the <code>{@link GL2.Node}</code> object to update.
     * @param {Array} frameArray Array of frame numbers. Negative frame numbers are relative to last keyframe. The last keyframe's number is -1.
     * @param {Number | Array} [syncFlags=GL2.MotionController.syncFlags.All] An array of <code>syncFlags values</code>, or the result of a bitwise OR operation across several <code>syncFlags</code> values.
     * @cb {Function} callback The function to call after creating the transaction.
     * @cb-param {GL2.MotionController} object This <code>MotionController</code> object.
     * @cb-param {Number} frame The frame this callback function is associated with.
     * @cb-returns {void}
     * @example
     * var sprite = new GL2.Sprite().setImage('Content/sprite.png', [100, 100], [0.5, 0.5]);
     * mc.bind('sprite_anim_name', sprite);
     * mc.syncFrames('sprite_anim_name', [0, -1], GL2.MotionController.SyncFlags.Position, function (mc, frame) {
     *  var x = sprite.getPosition().getX();
     *  var y = sprite.getPosition().getY();
     *  if (frame === 0) {
     *      console.log('On first frame, pos = (' + x + ', ' + y + ')');
     *  } if (frame === -1) {
     *      console.log('On last frame, pos = (' + x + ', ' + y + ')');
     *  }
     * });
     * @returns {this}
     * @since 1.7
     */
	syncFrames: function (name, frameArray, syncFlags, callback)
	{
		if (!(frameArray instanceof Array)) {
			throw new Error("TypeError: Expected frameArray to be an Array");
		}

		var flags, i, hasCallback;
		if (syncFlags instanceof Array) {
			flags = 0;
			for (i = 0; i < syncFlags.length; i++) {
				flags = flags | syncFlags[i];
			}
		} else if (typeof syncFlags === 'number') {
			flags = syncFlags;
		} else {
			flags = MotionController.SyncFlags.All;
		}

		if (callback && typeof callback === 'function') {
			// register callback
			this._syncCallbacks[name] = callback;
			hasCallback = true;
		} else {
			delete this._syncCallbacks[name];
			hasCallback = false;
		}

		this._syncFramesSendGen(name, flags, hasCallback, frameArray.length);
		for (i = 0; i < frameArray.length; i++) {
			this._frameSendGen(frameArray[i]);
		}
		return this;
	},

    /**
     * @function
     *
     * Set the animation playback speed. If you call this method while an animation is playing, the speed of that animation changes.
     * @example
     * md = new GL2.MotionData();
     * md.initFromJSONFile('Content/animations.json', GL2.MotionData.DataFormat.FlashClassicTween, function (error, md) {
     *  var mc, sprite, syncFlags;
     *  if (error) {
     *      console.log('error');
     *  } else {
     *      mc = new GL2.MotionController(md);
     *      sprite = new GL2.Sprite().setImage('Content/sprite.png', [100, 100], [0.5, 0.5]);
     *      // animate sprite position and scale ONLY.
     *      syncFlags = GL2.MotionController.SyncFlags.Position | GL2.MotionController.SyncFlags.Scale;
     *      mc.bind('sprite_anim_name', sprite, syncFlags);
     *      mc.setTimeScale(0.5);
     *      mc.play(GL2.MotionController.PlayMode.Loop);
     *  }
     * });
     * @param {Number} timeScale The animation speed. Use a value of 1.0 to play the animation at normal speed. A value of 2.0 indicates double speed.
     * @returns {this}
     * @since 1.7
     */
	setTimeScale: function (timeScale)
	{
		this._setTimeScaleSendGen(timeScale);
		this._timeScale = timeScale;
		return this;
	},

    /**
     * @function
     *
     * Retrieve the current animation playback speed.
     * @returns {Number} timeScale The animation speed for the current animation.
     * @since 1.7
     */
	getTimeScale: function ()
	{
		return this._timeScale;
	},

	/**
	 * @private
	 */
	_invokeCallbackRecv: function(cmd)
	{
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var name = msg.name;
		if (!name) {
			NgLogE("GL2.MotionController._invokeCallbackRecv command : bad name = " + name);
			return;
		}
		var cb = this._syncCallbacks[name];
		if (!cb) {
			NgLogE("GL2.MotionController._invokeCallbackRecv command : No registered callback found, name = " + name);
			return;
		}
		cb(this, msg.frame);
	},

    /**
     * Enumerated values for `MotionController` objects.
     * @name SyncFlags
     * @fieldOf GL2.MotionController#
     */

    /**
     * No fields.
     * @name SyncFlags.None
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * Position field.
     * @name SyncFlags.Position
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * Rotation field.
     * @name SyncFlags.Rotation
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * Scale field.
     * @name SyncFlags.Scale
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * Alpha channel field.
     * @name SyncFlags.Alpha
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * All fields.
     * @name SyncFlags.All
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * Enumerated values for `MotionController` objects.
     * @name PlayMode
     * @fieldOf GL2.MotionController#
     */

    /**
     * Stop the animation at the end.
     * @name PlayMode.Normal
     * @fieldOf GL2.MotionController#
     * @constant
     */

    /**
     * Repeat the animation at the end.
     * @name PlayMode.Loop
     * @fieldOf GL2.MotionController#
     * @constant
     */

// {{?Wg Generated Code}}
	
	// Enums.
	SyncFlags:
	{ 
		None: 0,
		Position: 1,
		Rotation: 2,
		Scale: 4,
		Alpha: 8,
		All: 15
	},
	
	PlayMode:
	{ 
		Normal: 0,
		Loop: 1
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 363,
	// Method create = -1
	// Method destroy = 2
	// Method bind = 3
	// Method unbind = 4
	// Method syncContinuous = 5
	// Method syncFrames = 6
	// Method frame = 7
	// Method play = 8
	// Method stop = 9
	// Method invokeCallback = 10
	// Method setTimeScale = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 10:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionController._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionController._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[363] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionController.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "name" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "name" ] === undefined )
		{
			NgLogE("Could not parse name in MotionController.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "frame" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "frame" ] === undefined )
		{
			NgLogE("Could not parse frame in MotionController.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( id, motionDataId )
	{
		Core.Proc.appendToCommandString( 0x16bffff, [ +id, +motionDataId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x16b0002, this );
	},
	
	/** @private */
	_bindSendGen: function( name, nodeId, syncFlags )
	{
		Core.Proc.appendToCommandString( 0x16b0003, this, [ Core.Proc.encodeString( name ), +nodeId, +syncFlags ] );
	},
	
	/** @private */
	_unbindSendGen: function( name )
	{
		Core.Proc.appendToCommandString( 0x16b0004, this, [ Core.Proc.encodeString( name ) ] );
	},
	
	/** @private */
	_syncContinuousSendGen: function( name, syncFlags )
	{
		Core.Proc.appendToCommandString( 0x16b0005, this, [ Core.Proc.encodeString( name ), +syncFlags ] );
	},
	
	/** @private */
	_syncFramesSendGen: function( name, syncFlags, hasCallback, frameCount )
	{
		Core.Proc.appendToCommandString( 0x16b0006, this, [ Core.Proc.encodeString( name ), +syncFlags, ( hasCallback ? 1 : 0 ), +frameCount ] );
	},
	
	/** @private */
	_frameSendGen: function( frame )
	{
		Core.Proc.appendSubcommandToCommandString( [ +frame ] );
	},
	
	/** @private */
	_playSendGen: function( playMode )
	{
		Core.Proc.appendToCommandString( 0x16b0008, this, [ +playMode ] );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x16b0009, this );
	},
	
	/** @private */
	_setTimeScaleSendGen: function( timeScale )
	{
		Core.Proc.appendToCommandString( 0x16b000b, this, [ +timeScale ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( id, motionDataId ) {}
	
	// destroy: function(  ) {}
	
	// bind: function( name, nodeId, syncFlags ) {}
	
	// unbind: function( name ) {}
	
	// syncContinuous: function( name, syncFlags ) {}
	
	// syncFrames: function( name, syncFlags, hasCallback, frameCount ) {}
	
	// frame: function( frame ) {}
	
	// play: function( playMode ) {}
	
	// stop: function(  ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// setTimeScale: function( timeScale ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Texture'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Texture'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Texture'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Texture.js';

////////////////////////////////////////////////////////////////////////////////
// Class Texture
// Texture object implementation
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;


////////////////////////////////////////////////////////////////////////////////

var Texture = exports.Texture = Core.Class.subclass(
/** @lends GL2.Texture.prototype */
{
	classname: 'Texture',

	/**
	 * @class The `GL2.Texture` class creates texture objects synchronously or
	 * asynchronously. By specifying `readImageAsync` as `true` in the options object when
	 * creating the `GL2.Texture`, the application can continue processing without blocking
	 * execution while waiting for the texture file to load.
     *
     * `GL2.Texture` can be used in place of a literal image filename
     * string in calls to `{@link GL2.Sprite#setImage}` and `{@link GL2.Primitive#setImage}`.
     * The texture object's image is referenced and bound to the node.
     *
     * `{@link GL2.Texture#getFilename}` can be used in place of a literal image filename
     * string in calls to `{@link GL2.Sprite#setImage}`, `{@link GL2.Primitive#setImage}` and `{@link GL2.Animation.Frame}`.
     * The texture object's image is referenced and bound to the node or animation frame.
     *
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @param {String} filename Name of the image file to read.
	 * @param {Object} [options] Options for loading the texture.
	 * @param {Boolean} [options.readImageAsync] Read image asynchronously if true. `createCallback` is invoked when operation completes.
	 * @param {Boolean} [options.truecolorDepth16] Truecolor image depth is 16bpp after decoding if true.
	 * @cb {Function} [createCallback] createCallback Callback function for this texture's create operation.
	 * @cb-param {Object} error error Information about the error, if any.
	 * @cb-param {GL2.Texture#ErrorCode} [error.code] [error.code] A code identifying the error type.
	 * @cb-param {String} [error.description] [error.description] A description of the error.
	 * @cb-param {GL2.Texture} object object `this` object.
	 * @cb-returns {void}
     * @example
     * var obj = new GL2.Texture(
     *    "Content/ngmoco.pvr",
     *    {
     *        "truecolorDepth16" : false,
     *        "readImageAsync" : true
     *    },
     *    function (error, object) {
     *        if (error) {
     *            console.log("Unable to read image file: " + error.description);
     *        } else {
     *            console.log("The image file was read: " + object.getFilename());
     *        }
     *    }
     * );
	 * @status iOS, Android
	 * @since 1.7
	 */
	initialize: function( filename, options, createCallback )
	{
        // default state
        this._isImageValid = false;
		this._filename = '';
        this._options = Texture.OptionFlags.Default;
        this._minFilter = Texture.FilterMode.Linear;
        this._magFilter = Texture.FilterMode.Linear;
        this._wrapS = Texture.WrapMode.Clamp;
        this._wrapT = Texture.WrapMode.Clamp;

        // parameters
        if ( filename && typeof( filename ) == 'string' ) {
            this._filename = filename;
        }

        if ( options && typeof( options ) == 'object' ) {
            if ( options['readImageAsync'] ) {
                this._options |= Texture.OptionFlags.ReadImageAsync;
            }
            if ( options['truecolorDepth16'] ) {
                this._options |= Texture.OptionFlags.TruecolorDepth_BPP16;
            }
            if ( options['minFilter'] ) {
                this._minFilter = options['minFilter'];
            }
            if ( options['magFilter'] ) {
                this._magFilter = options['magFilter'];
            }
            if ( options['wrapS'] ) {
                this._wrapS = options['wrapS'];
            }
            if ( options['wrapT'] ) {
                this._wrapT = options['wrapT'];
            }
        } else {
            createCallback = options;
        }

        // callback management
		this._nextCbId = 0;
        this._cb = {};
		this._storeCb = function( cb ) {
			var cbId = -1;
			if ( cb && typeof( cb ) == 'function' ) {
				cbId = this._nextCbId++;
				this._cb[cbId] = cb;
			}
			return cbId;
		};
		this._restoreCb = function( cbId ) {
            var cb = function () {};
            if ( cbId >= 0 ) {
                cb = this._cb[cbId];
                delete this._cb[cbId];
			}
            return cb;
		};

        // finish up
		Core.ObjectRegistry.register( this );

		this._createSendGen(    this.__objectRegistryId,
                                this._storeCb( createCallback ),
                                this._filename,
                                this._options,
                                this._minFilter,
                                this._magFilter,
                                this._wrapS,
                                this._wrapT );
	},

	/**
	 * Destroy the `GL2.Texture` object, and release the resources allocated by the texture.
     *
     * **Note**: Image resources will be deallocated if there are no references held by `GL2.Node` objects.
     *
	 * @returns {void}
	 * @status iOS, Android
	 * @since 1.7
	 */
    destroy: function()
    {
        this._destroySendGen();
        Core.ObjectRegistry.unregister( this );
    },

// API

    /** @ignore initialize docs until 1.8
     *
     * and provides control over specific properties of the texture.
     *
     * **Note**: Calls to `{@link GL2.Texture#setFilterModes}` and `{@link GL2.Texture#setWrapModes}`
     * will affect all instances and usages of that texture object by sprites, primitives, and animations.
     *
	 * @param {GL2.Texture.FilterMode} [options.minFilter] Minification filter mode.
	 * @param {GL2.Texture.FilterMode} [options.magFilter] Magnification filter mode.
	 * @param {GL2.Texture.WrapMode} [options.wrapS] S-axis wrap mode.
	 * @param {GL2.Texture.WrapMode} [options.wrapT] T-axis wrap mode.
     */

	/**
	 * Get `GL2.Texture` filename.
	 * @returns {String} The name of the image file associated with this texture object.
	 * @status iOS, Android
	 * @since 1.7
	 */
    getFilename: function() {
        return this._filename;
    },
	
	/**
	 * Set `GL2.Texture` filter modes.
	 * @param {GL2.Texture.FilterMode} minFilter Minification filter mode for this texture.
	 * @param {GL2.Texture.FilterMode} magFilter Magnification filter mode for this texture.
	 * @returns `this` to support method invocation chaining.
	 * @status iOS, Android
     * @private
	 */
    setFilterModes: function( minFilter, magFilter ) {
        this._minFilter = minFilter;
        this._magFilter = magFilter;
        this._setFilterModesSendGen( minFilter, magFilter );
        return this;
    },

	/**
	 * Get `GL2.Texture` filter modes.
	 * @returns {Object} Texture filter modes in the form of { minFilter:value, magFilter:value }
	 * @status iOS, Android
     * @private
	 */
    getFilterModes: function() {
        return { minFilter:this._minFilter, magFilter:this._magFilter };
    },

	/**
	 * Set `GL2.Texture` wrap modes.
	 * @param {GL2.Texture.WrapMode} wrapS S-axis wrap mode for this texture.
	 * @param {GL2.Texture.WrapMode} wrapT T-axis wrap mode for this texture.
	 * @returns `this` to support method invocation chaining.
	 * @status iOS, Android
     * @private
	 */
    setWrapModes: function( wrapS, wrapT ) {
        this._wrapS = wrapS;
        this._wrapT = wrapT;
        this._setWrapModesSendGen( wrapS, wrapT );
        return this;
    },

	/**
	 * Get `GL2.Texture` wrap modes.
	 * @returns {Object} Texture wrap modes in the form of { wrapS:value, wrapT:value }
	 * @status iOS, Android
     * @private
	 */
    getWrapModes: function() {
        return { wrapS:this._wrapS, wrapT:this._wrapT };
    },

	/**
     * Read meta data information about an image file.
     * @name GL2.Texture.readImageInfo
     * @function
     * @static
     *
     * @param {String} filename Name of image file to open and read meta data information.
     * @cb {Function} readCallback Callback function for image read operation.
	 * @cb-param {Object} error Information about the error, if any.
	 * @cb-param {GL2.Texture#ErrorCode} [error.code] A code identifying the error type.
	 * @cb-param {String} [error.description] A description of the error.
	 * @cb-param {Number} width The width in pixels of the image file.
	 * @cb-param {Number} height The height in pixels of the image file.
	 * @cb-param {Boolean} hasAlpha Flag is `true` if the image file contains alpha transparency.
	 * @cb-returns {void}
     * @example
     * GL2.Texture.readImageInfo("Content/ngmoco.pvr", function (error, width, height, hasAlpha) {
     *      if (error) {
     *          console.log("Unable to read image file info: " + error.description);
     *      } else {
     *          console.log("The image file info: " + width + ", " + height + ", " + hasAlpha);
     *      }
     * });
	 * @status iOS, Android
	 * @since 1.7
     */

	$readImageInfo: function( filename, readCallback ) {
        if ( !this._readCallbacks ) {
            this._readCallbacks = { uidGenerator:1 };
        }
        this._readCallbacks[++this._readCallbacks.uidGenerator] = readCallback;
        this._readImageInfoSendGen( this._readCallbacks.uidGenerator, filename );
    },

	/** @private */
    _onCreateCbRecv: function( cmd ) {
		var obj = {};
		if ( this._onCreateCbRecvGen( cmd, obj ) ) {
			if ( obj['callbackId'] >= 0 ) {
				var cb = this._restoreCb( obj['callbackId'] );
				var err = obj['errCode'] ? { code:obj['errCode'], description:obj['errStr'] } : null;
                if ( !err ) {
                    this._isImageValid = true;
                }
				cb( err, this );
			}
		}
    },

	/** @private */
	$_readImageInfoCbRecv: function( cmd ) {
        var obj = {};
        this._readImageInfoCbRecvGen( cmd, obj );

        if ( this._readCallbacks.hasOwnProperty( obj.callbackId ) ) {
            var err = obj['errCode'] ? { code:obj['errCode'], description:obj['errStr'] } : null;
            this._readCallbacks[obj.callbackId]( err, obj['width'], obj['height'], obj['hasAlpha'] );
            delete this._readCallbacks[obj.callbackId];
        }
    },

	/**
	 * No error occurred.
	 * @name ErrorCode.NoError
	 * @fieldOf GL2.Texture#
	 * @constant
	 */

	/**
	 * An unknown error occurred.
	 * @name ErrorCode.Unknown
	 * @fieldOf GL2.Texture#
	 * @constant
	 */

	/**
	 * The file was not found.
	 * @name ErrorCode.NotFound
	 * @fieldOf GL2.Texture#
	 * @constant
	 */

	/**
	 * The requested operation is not available.
	 * @name ErrorCode.Unsupported
	 * @fieldOf GL2.Texture#
	 * @constant
	 */

	/**
	 * Filter texture using nearest texel sampling.
	 * @name FilterMode.Nearest
	 * @fieldOf GL2.Texture#
	 * @constant
     * @private
	 */

	/**
	 * Filter texture using linear interpolation sampling.
	 * @name FilterMode.Linear
	 * @fieldOf GL2.Texture#
	 * @constant
     * @private
	 */

	/**
	 * Create texture without special options.
	 * @name OptionFlags.Default
	 * @fieldOf GL2.Texture#
	 * @constant
	 */

	/**
	 * Create texture using asynchronous processing if `true`.
	 * @name OptionFlags.ReadImageAsync
	 * @fieldOf GL2.Texture#
	 * @constant
	 */

	/**
	 * Create texture with a bit depth of 16 bits per pixel if `true`. This option applies to uncompressed, truecolor formats.
	 * @name OptionFlags.TruecolorDepth_BPP16
	 * @fieldOf GL2.Texture#
	 * @constant
     * @see GL2.Animation.setTextureColorDepth
	 */

	/**
	 * Clamp texture coordinates to the edge of the image along the indicated axis.
	 * @name WrapMode.Clamp
	 * @fieldOf GL2.Texture#
	 * @constant
     * @private
	 */

	/**
	 * Repeat texture coordinates using the fractional part along the indicated axis.
	 * @name WrapMode.Repeat
	 * @fieldOf GL2.Texture#
	 * @constant
     * @private
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	/** Texture Callback errors */
	ErrorCode:
	{ 
		NoError: 0,
		Unknown: -1,
		NotFound: -2,
		Unsupported: -3
	},
	
	/** @private Texture Filtering */
	FilterMode:
	{ 
		Nearest: 1,
		Linear: 2
	},
	
	/** Texture creation options */
	OptionFlags:
	{ 
		Default: 0,
		ReadImageAsync: 1,
		TruecolorDepth_BPP16: 2
	},
	
	/** @private Texture Wrapping */
	WrapMode:
	{ 
		Clamp: 1,
		Repeat: 2
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 365,
	// Method create = -1
	// Method destroy = 2
	// Method setFilterModes = 3
	// Method setWrapModes = 4
	// Method onCreateCb = 5
	// Method readImageInfoCb = -6
	// Method readImageInfo = -7
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._onCreateCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Texture._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -6:
					Texture._readImageInfoCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Texture._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[365] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onCreateCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Texture.onCreateCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in Texture.onCreateCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Texture.onCreateCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Texture.onCreateCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	$_readImageInfoCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 6 )
		{
			NgLogE("Could not parse due to wrong argument count in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		obj[ "errCode" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "errCode" ] === undefined )
		{
			NgLogE("Could not parse errCode in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		obj[ "errStr" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "errStr" ] === undefined )
		{
			NgLogE("Could not parse errStr in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 3 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		obj[ "hasAlpha" ] = Core.Proc.parseBool( cmd[ 5 ] );
		if( obj[ "hasAlpha" ] === undefined )
		{
			NgLogE("Could not parse hasAlpha in Texture.readImageInfoCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId, callbackId, filename, options, minFilter, magFilter, wrapS, wrapT )
	{
		Core.Proc.appendToCommandString( 0x16dffff, [ +__objectRegistryId, +callbackId, Core.Proc.encodeString( filename ), +options, +minFilter, +magFilter, +wrapS, +wrapT ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x16d0002, this );
	},
	
	/** @private */
	_setFilterModesSendGen: function( minFilter, magFilter )
	{
		Core.Proc.appendToCommandString( 0x16d0003, this, [ +minFilter, +magFilter ] );
	},
	
	/** @private */
	_setWrapModesSendGen: function( wrapS, wrapT )
	{
		Core.Proc.appendToCommandString( 0x16d0004, this, [ +wrapS, +wrapT ] );
	},
	
	/** @private */
	$_readImageInfoSendGen: function( callbackId, filename )
	{
		Core.Proc.appendToCommandString( 0x16dfff9, [ +callbackId, Core.Proc.encodeString( filename ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId, callbackId, filename, options, minFilter, magFilter, wrapS, wrapT ) {}
	
	// destroy: function(  ) {}
	
	// setFilterModes: function( minFilter, magFilter ) {}
	
	// setWrapModes: function( wrapS, wrapT ) {}
	
	// _onCreateCbRecv: function( cmd ) {}
	// $_readImageInfoCbRecv: function( cmd ) {}
	// $readImageInfo: function( callbackId, filename ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Primitive'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Primitive.js';

var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Texture = require('NGCore/Client/GL2/Texture').Texture;
var Core = require('NGCore/Client/Core').Core;


var Primitive = exports.Primitive = Node.subclass(
/** @lends GL2.Primitive.prototype */
{
	classname: 'Primitive',

	/**
	 * @class The `GL2.Primitive` class provides the ability to draw arbitrary vertex-based polygons
	 * in two dimensions. Its APIs are similar to the `{@link GL2.Sprite}` class, which is used to
	 * display images and animations that are not warped or skewed.
	 *
	 * A primitive's vertexes are specified with `{@link GL2.Primitive.Vertex}` objects. Primitives
	 * can display solid colors, static images, or animations. Images and animations can be pinned
	 * to the primitive's vertexes. You can warp or skew an image by creating a primitive that
	 * represents the desired shape of the image, then pinning the image to the primitive's
	 * vertexes.
	 *
	 * By default, the primitive uses its vertexes to draw individual triangles; every group of
	 * three vertexes in the primitive represents a triangle. You can change this behavior by
	 * calling `{@link GL2.Primitive#setType}`.
	 *
	 * **Note**: Call `{@link Core.UpdateEmitter#setTickRate}` to set the frame rate for all
	 * animations that are attached to primitives.
	 * @constructs Create a primitive.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
        this._animation = null;
		this._ownsAnimation = false;

		this._animationCompleteEmitter = new Core.MessageEmitter();
        this._type = this.Type.Triangles;
        this._vertexes = [];
    },

	/**
	 * Destroy the primitive, and release the resources allocated by the primitive.
	 *
	 * If the primitive is displaying a single image that was set by calling
	 * `{@link GL2.Primitive#setImage}`, calling `destroy()` will also destroy the reference to the
	 * image. If the primitive is displaying an animation that was set by calling
	 * `{@link GL2.Primitive#setAnimation}`, you must also call `{@link GL2.Animation#destroy}` to
	 * destroy the animation.
	 *
	 * **Important**: Destroying a primitive does not destroy the primitive's vertexes.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		var ownedAnim = this._unhookOwnedAnimation();
		if (ownedAnim)
			ownedAnim.destroy();
		this._animationCompleteEmitter.destroy();
	},

	/**
	 * Retrieve the number of vertexes in the primitive.
	 * @returns {Number} The current number of vertexes.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},

	/**
	 * Retrieve a single vertex from the primitive's vertexes.
	 * @param {Number} index The index of the vertex to retrieve.
	 * @returns {GL2.Primitive.Vertex} The current vertex at the specified index.
	 * @see GL2.Primitive#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},

	/**
	 * Determine the type of geometry that the primitive will render.
	 * @returns {GL2.Primitive#Type} The type of geometry that the primitive will render.
	 * @see GL2.Primitive#setType
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getType: function()
	{
		return this._type;
	},

	/**
	 * Retrieve the primitive's current animation. If the primitive is displaying a single image
	 * that was set by calling `{@link GL2.Primitive#setImage}`, or if no animation has been
	 * assigned to the primitive, this method will return `null`.
	 * @returns {GL2.Animation} The primitive's current animation, or `null` if no animation is
	 *		assigned to the primitive.
	 * @see GL2.Primitive#setAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;

		return this._animation;
	},

	/**
	 * Retrieve the primitive's "animation complete" emitter. This emitter fires when the primitive
	 * has finished playing the last frame of a non-looping animation. If a listener is attached to
	 * the emitter, the primitive will be passed to the listener's callback function.
	 *
	 * **Note**: If the animation is interrupted before it finishes playing, the "animation
	 * complete" emitter will not fire.
	 * @example
	 * var Listener = Core.MessageListener.subclass({
	 *     initialize: function() {
	 *         this.animation = new GL2.Animation();
	 *         this.primitive = new GL2.Primitive();
	 *         this.primitive.setAnimation(animation);
	 *         this.primitive.getAnimationCompleteEmitter().
	 *           addListener(this, this.onComplete.bind(this));
	 *     },
	 *
	 *     onComplete: function(primitive) {
	 *         console.log("Animation complete.");
	 *     }
	 * });
	 *
	 * // Instantiate the object.
	 * var listener = new Listener();
	 * @returns {Core.MessageEmitter} The "animation complete" emitter.
	 * @see Core.MessageEmitter
	 * @see Core.MessageListener
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},

	/**
	 * Set the animation to display in the primitive. The animation will start playing immediately,
	 * replacing any image or animation that was previously assigned to the primitive.
	 * @example
	 * var animation = new GL2.Animation();
	 * var primitive = new GL2.Primitive();
	 * primitive.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to display.
	 * @param {Number} [startTime=0] The time offset, in milliseconds, at which to start playing the
	 *		animation. For example, if an animation has ten frames, each of which is displayed for
	 *		50 milliseconds, and you specify the value `250`, playback will begin halfway through
	 *		the animation.
	 * @returns {void}
	 * @see GL2.Primitive#getAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setAnimation: function(animation, startTime)
	{
		var ownedAnim = this._unhookOwnedAnimation();
		this._animation = animation;
		this._setAnimationSendGen( Core.ObjectRegistry.objectToId(animation), startTime || 0 );
		if (ownedAnim)
			ownedAnim.destroy();
	},

    /**
	 * Set a single image to display in the primitive. The image will be displayed immediately,
	 * replacing any image or animation that was previously assigned to the primitive. If the image
	 * is not square, or if its width and height are not a power of two, the image will be stretched
	 * into a square with power-of-two dimensions.
	 * // Create a primitive that displays a single image, which is taken from the
	 * // top right corner of a 4 x 4 sprite sheet.
	 * var primitive = new GL2.Primitive();
	 * primitive.setImage("./Content/unicorn.png"), new Core.Size(64, 64),
	 *   new Core.Point(0.5, 0.5), new Core.Rect(0, 0, 0.5, 0.5));
	 * @param {String|GL2.Texture} image The directory path to an image or a `GL2.Texture` object.
	 * @param {Core.Size} size The size, in pixels, of the image to display,
	 * @param {Core.Point} [anchor=[0.5, 0.5]] The offset within the node that defines the
	 *		anchor point for scaling and rotation. The anchor point defines the origin of any
	 *		scaling or rotation that is applied to the node. Its offset is defined as a multiple of
	 *		the node's width and height. For example, the default anchor offset, `[0.5, 0.5]`,
	 *		represents a point that is centered on the U and V axes. If you omit this parameter, you
	 *		must also omit the `uvs` parameter.
	 * @param {Core.Rect} [uvs=[0, 0, 1, 1]] The region within the image to display. Specified in UV
	 *		coordinates ranging from 0 to 1, which represent a percentage of the original image's
	 *		width and height. The four coordinates represent the U origin, the V origin, the U
	 *		width, and the V height, in that order. By default, the entire image is displayed.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setImage: function(image, size, anchor, uvs)
	{
		var prevOwnedAnim = this._unhookOwnedAnimation();

		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
        // replace Texture with filename
        if (image.classname === "Texture")
        {
            args[0] = image.getFilename();
        }
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame(args[0], args[1], args[2], args[3], args[4]);
		var animation = new Animation();
		animation.pushFrame(frame);

		this._animation = animation;
		this._ownsAnimation = true;

		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);

		if (prevOwnedAnim)
			prevOwnedAnim.destroy();

		return this;
	},

    /**
	 * Set the type of geometry that the primitive will render. See `{@link GL2.Primitive#Type}`
	 * for information about the types of geometry that are supported.
	 * @example
	 * var primitive = new GL2.Primitive();
	 * primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * @param {GL2.Primitive#Type} type The type of geometry that the primitive will render.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setType: function(type)
	{
		this._type = type;

		this._setTypeSendGen(type);

		return this;
	},

    /**
	 * Add a vertex to the end of the primitive's list of vertexes. Calling this method is
	 * equivalent to calling `{@link GL2.Primitive#spliceVertexes}` in the following way:
	 *
	 *     primitive.spliceVertexes(primitive.getVertexCount(), 0, vertex);
	 * @example
	 * var primitive = new GL2.Primitive();
	 * primitive.pushVertex(new GL2.Primitive.Vertex([0, 0], [0, 0], [0.3, 0.4, 0.5]));
     * @param {GL2.Primitive.Vertex} vertex The vertex to add.
     * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
     */
    pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},

    /**
	 * Replace the vertex at a specified index. Calling this method is equivalent to
	 * calling `{@link GL2.Primitive#spliceVertexes}` in the following way:
	 *
	 *     primitive.spliceVertexes(i, 1, vertex);
	 * @param {Number} i The index of the vertex to replace.
	 * @param {GL2.Primitive.Vertex} vertex The vertex to insert.
	 * @returns {this}
	 * @see GL2.Primitive#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},

    /**
	 * Remove a specified number of vertexes, and replace them with zero or more vertexes. You can
	 * pass any number of new vertexes to this method.
	 * @example
	 * // Create a square primitive with four vertexes, then turn the square into
	 * // an irregularly shaped polygon by replacing the third vertex.
	 * var widthHeight = 100;
	 * var color = [0.3, 0.4, 0.5];
	 * var primitive = new GL2.Primitive();
	 * primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * primitive.pushVertex(new GL2.Primitive.Vertex([0, 0], [0, 0], color));
	 * primitive.pushVertex(new GL2.Primitive.Vertex([widthHeight, 0], [0, 0], color));
	 * primitive.pushVertex(new GL2.Primitive.Vertex([widthHeight, widthHeight],
	 *   [0, 0], color));
	 * primitive.pushVertex(new GL2.Primitive.Vertex([0, widthHeight], [0, 0], color));
	 *
	 * // Replace the third vertex.
	 * primitive.spliceVertexes(2, 1, new GL2.Primitive.Vertex([widthHeight + 10, -10],
	 *   [0, 0], color));
	 * @example
	 * // Create a square primitive with four vertexes, then turn the square into
	 * // a triangle by removing the second vertex.
	 * var widthHeight = 100;
	 * var color = [0.3, 0.4, 0.5];
	 * var primitive = new GL2.Primitive();
	 * primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * primitive.pushVertex(new GL2.Primitive.Vertex([0, 0], [0, 0], color));
	 * primitive.pushVertex(new GL2.Primitive.Vertex([widthHeight, 0], [0, 0], color));
	 * primitive.pushVertex(new GL2.Primitive.Vertex([widthHeight, widthHeight],
	 *   [0, 0], color));
	 * primitive.pushVertex(new GL2.Primitive.Vertex([0, widthHeight], [0, 0], color));
	 *
	 * // Remove the second vertex.
	 * primitive.spliceVertexes(1, 1);
	 * @param {Number} start The index of the first vertex to remove.
	 * @param {Number} len The total number of vertexes to remove.
	 * @param {GL2.Primitive.Vertex} [vertex] The vertex to insert. To insert more than one vertex,
	 *		pass additional arguments to the method.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    spliceVertexes: function(start, len, vertexes)
	{

		this._vertexes.splice.apply(this._vertexes, arguments);

		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);

		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			var position = vertex.getPosition();
			var uv = vertex.getUV();
			var color = vertex.getColor();
			this._vertexSendGen(
				position.getX(),
				position.getY(),
				uv.getX(),
				uv.getY(),
				color.getRed(),
				color.getGreen(),
				color.getBlue()
			);
		}

		return this;
	},

	$Vertex: Core.Class.subclass(
	/** @lends GL2.Primitive.Vertex.prototype */
	{
		classname: 'Vertex',

		/**
		 * @class `GL2.Primitive.Vertex` objects specify the location, texture coordinates, and
		 * color of a vertex in a primitive.
		 *
		 * + The vertex's location is in pixel coordinates and is relative to its ancestors'
		 * position, scale, and rotation.
		 * + The texture coordinate indicates the UV coordinate in the primitive's image or
		 * animation that will be pinned to the vertex.
		 * + The color represents a fill color that will radiate out from the vertex into the
		 * primitive. If two vertexes have different colors, the fill colors will be faded into one
		 * another.
		 * @constructs Create a vertex for a primitive.
		 * @augments Core.Class
		 * @example
		 * // Create a vertex that contributes an orange fill to the primitive and
		 * // pins images and animations at their top left corner.
		 * var vertex = new GL2.Primitive.Vertex([200, 100], [0, 0], [1.0, 0.5, 0]);
		 * @param {Core.Point|Number[]} position The vertex's location, in pixel coordinates
		 *		relative to its ancestors' position, scale, and totation. Specified as a
		 *		`{@link Core.Point}` object or as two separate floats that represent the U and V
		 *		coordinates, in that order.
		 * @param {Core.Point|Number[]} uv The UV coordinates in the primitive's image or animation
		 *		that will be pinned to the vertex. Specified as a `{@link Core.Point}` object or as
		 *		two separate floats that represent the U and V coordinates, in that order; each
		 *		float can range from `0` to `1`.
		 * @param {Core.Color|Number[]} color The vertex's RGB color. Specified as a
		 *		`{@link Core.Color}` object or as three separate floats that represent the red,
		 *		green, and blue values of the color, in that order; each float can range from `0` to
		 *		`1`.
		 * @see GL2.Primitive
		 * @since 1.0
		 */
		initialize: function(position, uv, color)
		{
			this._position = new Core.Point(position);
			this._uv = new Core.Point(uv);
			this._color = new Core.Color(color);
		},

		/**
		 * Retrieve the vertex's current location, measured in pixel coordinates that are relative
		 * to its ancestors' position, scale, and rotation.
		 * @returns {Core.Point} The vertex's current location, in pixel coordinates relative to its
		 *		ancestors' position, scale, and totation.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getPosition: function()
		{
			return this._position;
		},

		/**
		 * Retrieve the UV coordinates in the primitive's image or animation that will be pinned to
		 * the vertex.
		 * @returns {Core.Point} The current UV coordinates in the primitive's image or animation
		 *		that will be pinned to the vertex.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getUV: function()
		{
			return this._uv;
		},

		/**
		 * Retrieve the fill color that will radiate out from the vertex into the primitive.
		 * @returns {Core.Color} The current RGB color.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
		 * @since 1.0
		 */
		getColor: function()
		{
			return this._color;
		}
	}),

	_unhookOwnedAnimation: function()
	{
		var retVal = undefined;
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
			retVal = this._animation;
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		this._image = null;
		return retVal;
	},

	/**
	 * Enumeration for the types of geometry that a primitive can render.
	 * @name Type
	 * @fieldOf GL2.Primitive#
	 */

	/**
	 * Every group of three vertexes defines a separate triangle. The number of vertexes must be
	 * divisible by three.
	 *
	 * For example, if a primitive includes vertexes `[A, B, C, D, E, F]`, the following triangles
	 * will be drawn:
	 *
	 * + `ABC`
	 * + `DEF`
	 * @name Type.Triangles
	 * @fieldOf GL2.Primitive#
	 * @constant
	 */

	/**
	 * Every vertex defines a triangle that includes the previous two vertexes. Use this option to
	 * create a series of connected triangles. The primitive must have at least three vertexes.
	 *
	 * For example, if a primitive includes vertexes `[A, B, C, D, E, F]`, the following triangles
	 * will be drawn:
	 *
	 * + `ABC`
	 * + `BCD`
	 * + `CDE`
	 * + `DEF`
	 * @name Type.TriangleStrip
	 * @fieldOf GL2.Primitive#
	 * @constant
	 */

	/**
	 * Every vertex defines a triangle that includes the first vertex and the previous vertex. Use
	 * this option to create several triangles that form a polygon. The primitive must have at least
	 * three vertexes.
	 *
	 * For example, if a primitive includes vertexes `[A, B, C, D, E, F]`, the following triangles
	 * will be drawn:
	 *
	 * + `ABC`
	 * + `ACD`
	 * + `ADE`
	 * + `AEF`
	 * @name Type.TriangleFan
	 * @fieldOf GL2.Primitive#
	 * @constant
	 */

	/**
	 * Every pair of two vertexes defines a line segment. Each line segment is drawn with a width of
	 * one pixel. The number of vertexes must be divisible by two.
	 *
	 * For example, if a primitive includes vertexes `[A, B, C, D, E, F]`, the following line
	 * segments will be drawn:
	 *
	 * + `AB`
	 * + `CD`
	 * + `EF`
	 * @name Type.LineList
	 * @fieldOf GL2.Primitive#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	Type:
	{ 
		Triangles: 0,
		TriangleStrip: 1,
		TriangleFan: 2,
		LineList: 3
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 308,
	// Method create = -1
	// Method spliceVertexes = 2
	// Method vertex = 3
	// Method setType = 4
	// Method setAnimation = 5
	// Method animationComplete = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[308] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Primitive.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x134ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( 0x1340002, this, [ +start, +len, +vertexCount ] );
	},
	
	/** @private */
	_vertexSendGen: function( x, y, u, v, red, green, blue )
	{
		Core.Proc.appendSubcommandToCommandString( [ +x, +y, +u, +v, +red, +green, +blue ] );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( 0x1340004, this, [ +type ] );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( 0x1340005, this, [ +animation, +startTime ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y, u, v, red, green, blue ) {}
	
	// setType: function( type ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Touch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Touch.js';

var Core = require('NGCore/Client/Core').Core;

var Touch = exports.Touch = Core.Class.subclass(
/** @lends GL2.Touch.prototype */
{
	classname: 'Touch',

	/**
	 * @class The `GL2.Touch` class provides objects that identify touch events and track a finger's
	 * movement across the device's screen. `GL2.Touch` objects are created by a
	 * `{@link GL2.TouchTarget}` object's touch emitter, then passed to the emitter's message
	 * listener. See `{@link GL2.TouchTarget#getTouchEmitter}` for details about creating a message
	 * listener for a touch emitter.
	 *
	 * **Note**: Do not instantiate this class directly.
	 * @constructs
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		this._id = 0;
		this._action = {};
		this._position = new Core.Point();
		this._targetIds = null;
		this._targetIdMap = {};
	},

	/**
	 * Retrieve a list of touch targets that are tracking the touch object's events.
	 * @returns {GL2.TouchTarget[]} An array of touch targets that are tracking the touch object's
	 *		events.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getTouchTargets: function()
	{
		var ids = this._targetIds;
		var result = [];
		if (ids) {
			for(var i = 0; i < ids.length; i++)
			{
				var t = Core.ObjectRegistry.idToObject(ids[i]);
				if(t) result.push(t);
			}
		}
		return result;
	},

	/**
	 * Determine whether the user's initial touch fell within the specified touch target.
	 * @param {GL2.TouchTarget} touchTarget The touch target to evaluate.
	 * @returns {Boolean} Set to `true` if the user's initial touch fell within the touch target.
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	getIsInside: function(touchTarget)
	{
		// Check if the object's id is in the touchtargets map
		return ( Core.ObjectRegistry.objectToId(touchTarget) in this._targetIdMap);
	},

	/**
	 * Retrieve the touch object's current position within the global scene's coordinate space.
	 * @returns {Core.Point} The position of the touch object within the global scene's coordinate
	 *		space.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getPosition: function()
	{
		return this._position;
	},

	/**
	 * Retrieve the touch object's unique ID.
	 *
	 * **Note**: Do not use this ID as an index to an array. The ID is often a very large number,
	 * and using it as an array index can cause JavaScript to allocate a much larger array than
	 * necessary.
	 * @returns {Number} The touch object's unique id.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getId: function()
	{
		return this._id;
	},

	/**
	 * Retrieve the current phase of the touch event that the touch object is tracking. Call this
	 * method from the touch emitter's listener. See `{@link GL2.TouchTarget#getTouchEmitter}` for
	 * an example of how to use this method.
	 *
	 * If this method returns the value `{@link GL2.Touch#Action.Start}`, the touch emitter's
	 * listener can capture the event by returning `true` from the event handler. If the event
	 * handler returns `true`, the emitter continues to fire throughout the touch event. If the
	 * event handler does not return `true`, the event propagates downwards to other touch targets.
	 * @returns {GL2.Touch#Action} The current phase of the touch event that the touch object is
	 *		tracking.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAction: function()
	{
		return this._action;
	},

	_setId: function(id)
	{
		this._id = id;
	},

	_setAction: function(action)
	{
		this._action = action;
	},

	_setPosition: function(position)
	{
		this._position.setAll(arguments);
	},

	_setTargetIds: function(targetIds)
	{
		// We transfer the array of numeric target IDs into a
		// map so we can support getIsInside call which uses 'in'.
		this._targetIds = targetIds.slice();
		this._targetIdMap = {};
		for (var i = 0; i < targetIds.length; i++)
			this._targetIdMap[targetIds[i]] = null;
	},

	/**
	 * Enumeration for the phases of a touch event.
	 * @name Action
	 * @fieldOf GL2.Touch#
	 */

	/**
	 * The user's finger started touching the screen.
	 * @name Action.Start
	 * @fieldOf GL2.Touch#
	 * @constant
	 */

	/**
	 * The user's finger stopped touching the screen.
	 * @name Action.End
	 * @fieldOf GL2.Touch#
	 * @constant
	 */

	/**
	 * The user's finger moved to a new location on the screen.
	 * @name Action.Move
	 * @fieldOf GL2.Touch#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	Action:
	{ 
		Start: 0,
		End: 1,
		Move: 2
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 312,
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[312] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Sprite'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Sprite.js';

var Core = require('NGCore/Client/Core').Core;
var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Texture = require('NGCore/Client/GL2/Texture').Texture;


var Sprite = exports.Sprite = Node.subclass(
/** @lends GL2.Sprite.prototype */
{
	classname: 'Sprite',

	/**
	 * @class The `GL2.Sprite` class is used to display a sprite that contains a single image or an
	 * animation. Its APIs are similar to the `{@link GL2.Primitive}` class, which is used to draw
	 * vertex-based polygons.
	 *
	 * Sprites cannot warp or skew their images and animations. Use the `{@link GL2.Primitive}`
	 * class if you need to warp or skew an image or animation.
	 *
	 * **Note**: Call `{@link Core.UpdateEmitter#setTickRate}` to set the frame rate for all
	 * animations that are attached to sprites.
	 * @constructs Create a sprite.
	 * @augments GL2.Node
	 * @since 1.0
	 */
    initialize: function()
    {
		this._clubObject = null;
        this._animation = null;
		this._ownsAnimation = false;

		this._animationCompleteEmitter = new Core.MessageEmitter();
    },

	/**
	 * Destroy the sprite, and release the resources allocated by the sprite.
	 *
	 * If the sprite is displaying a single image that was set by calling
	 * `{@link GL2.Sprite#setImage}`, calling `destroy()` will also destroy the reference to the
	 * image. If the sprite is displaying an animation that was set by calling
	 * `{@link GL2.Sprite#setAnimation}`, you must also call `{@link GL2.Animation#destroy}` to
	 * destroy the animation.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		var ownedAnim = this._unhookOwnedAnimation();
		if (ownedAnim)
			ownedAnim.destroy();
		this._animationCompleteEmitter.destroy();
	},

	/**
	 * Retrieve the sprite's current animation. If the sprite is displaying a single image that was
	 * set by calling `{@link GL2.Sprite#setImage}`, or if no animation has been assigned to the
	 * sprite, this method will return `null`.
	 * @returns {GL2.Animation} The sprite's current animation, or `null` if no animation is
	 *		assigned to the sprite.
	 * @see GL2.Sprite#setAnimation
	 * @see GL2.Sprite#setImage
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;

		return this._animation;
	},

    /**
	 * Retrieve the sprite's "animation complete" emitter. This emitter fires when the sprite
	 * has finished playing the last frame of a non-looping animation. If a listener is attached to
	 * the emitter, the sprite will be passed to the listener's callback function.
	 *
	 * **Note**: If the animation is interrupted before it finishes playing, the "animation
	 * complete" emitter will not fire.
	 * @example
	 * var Listener = Core.MessageListener.subclass({
	 *     initialize: function() {
	 *         this.animation = new GL2.Animation();
	 *         this.sprite = new GL2.Sprite();
	 *         this.sprite.setAnimation(animation);
	 *         this.sprite.getAnimationCompleteEmitter().
	 *           addListener(this, this.onComplete.bind(this));
	 *     },
	 *
	 *     onComplete: function(sprite) {
	 *         console.log("Animation complete.");
	 *     }
	 * });
	 *
	 * // Instantiate the object.
	 * var listener = new Listener();
	 * @returns {Core.MessageEmitter} The "animation complete" emitter.
	 * @see Core.MessageEmitter
	 * @see Core.MessageListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},

    /**
	 * Set the animation to display in the sprite. The animation will start playing immediately,
	 * replacing any image or animation that was previously assigned to the sprite.
	 * @example
	 * var animation = new GL2.Animation();
	 * var sprite = new GL2.Sprite();
	 * sprite.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to display.
	 * @param {Number} [startTime=0] The time offset, in milliseconds, at which to start playing the
	 *		animation. For example, if an animation has ten frames, each of which is displayed for
	 *		50 milliseconds, and you specify the value `250`, playback will begin halfway through
	 *		the animation.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setAnimation: function(animation, startTime)
	{
		var ownedAnim = this._unhookOwnedAnimation();
		this._animation = animation;
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation), startTime || 0);
		if (ownedAnim)
			ownedAnim.destroy();
		return this;
	},

    /**
	 * Set a single image to display in the sprite. The image will be displayed immediately,
	 * replacing any image or animation that was previously assigned to the sprite. If the image is
	 * not square, or if its width and height are not a power of two, the image will be stretched
	 * into a square with power-of-two dimensions.
	 * @example
	 * // Create a sprite that displays a single image, which is taken from the
	 * // top right corner of a 4 x 4 sprite sheet.
	 * var sprite = new GL2.Sprite();
	 * sprite.setImage("./Content/unicorn.png"), new Core.Size(64, 64),
	 *   new Core.Point(0.5, 0.5), new Core.Rect(0, 0, 0.5, 0.5));
	 * @param {String|GL2.Texture} image The directory path to an image or a `GL2.Texture` object.
	 * @param {Core.Size} size The size, in pixels, of the image to display,
	 * @param {Core.Point} [anchor=[0.5, 0.5]] 	The offset within the node that defines the
	 *		anchor point for scaling and rotation. 	The anchor point defines the origin of any
	 *		scaling or rotation that is applied to the node. Its offset is defined as a multiple of
	 *		the node's width and height. For example, the default anchor offset, `[0.5, 0.5]`,
	 *		represents a point that is centered on the U and V axes. If you omit this parameter, you
	 *		must also omit the `uvs` parameter.
	 * @param {Core.Rect} [uvs=[0, 0, 1, 1]] The region within the image to display. Specified in UV
	 *		coordinates ranging from 0 to 1, which represent a percentage of the original image's
	 *		width and height. The four coordinates represent the U origin, the V origin, the U
	 *		width, and the V height, in that order. By default, the entire image is displayed.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setImage: function(image, size, anchor, uvs)
	{
		var prevOwnedAnim = this._unhookOwnedAnimation();

		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
        // replace Texture with filename
        if (image.classname === "Texture")
        {
            args[0] = image.getFilename();
        }
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame(args[0], args[1], args[2], args[3], args[4]);
		var animation = new Animation();
		animation.pushFrame(frame);

		this._animation = animation;
		this._ownsAnimation = true;

		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);

		if (prevOwnedAnim)
			prevOwnedAnim.destroy();

		return this;
	},

	_unhookOwnedAnimation: function()
	{
		var retVal = undefined;
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destroy the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
			retVal = this._animation;
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		return retVal;
	},

	_animationCompleteRecv: function(cmd)
	{
		var msg = {};
		if(!this._animationCompleteRecvGen(cmd, msg))
			return;

		this._animationCompleteEmitter.emit(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 310,
	// Method create = -1
	// Method setAnimation = 2
	// Method animationComplete = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[310] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Sprite.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x136ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( 0x1360002, this, [ +animation, +startTime ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/TouchTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/TouchTarget.js';

var Node = require('NGCore/Client/GL2/Node').Node;
var Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
var Core = require('NGCore/Client/Core').Core;


var TouchTarget = exports.TouchTarget = Node.subclass(
/** @lends GL2.TouchTarget.prototype */
{
	classname: 'TouchTarget',

	/**
	 * @class The `GL2.TouchTarget` class provides applications with access to touch events.
	 *
	 * **Note**: Do not use `GL2.TouchTarget` to monitor touch events for `{@link UI}` objects.
	 * Instead, use the events that are provided by each class in the `{@link UI}` module.
	 *
	 * A touch target is a rectangular area that is defined based on its size and its offset from
	 * the X and Y origin. If the user touches an area of the screen that is covered by the touch
	 * target, the touch target fires a `touch` event, which your application can receive by
	 * attaching a message listener to the touch emitter. To attach a listener, call
	 * `{@link GL2.TouchTarget#getTouchEmitter}`.
	 *
	 * A touch target will activate even if its parent or ancestor nodes are not visible. You can
	 * call the `setTouchable()` method, inherited from `{@link GL2.Node}`, to disable a touch
	 * target.
	 *
	 * **Note**: If a clipping rectangle is active, and the touch target is outside of the clipping
	 * rectangle, the touch target will not be touchable. See `{@link GL2.Node#setClipRect}` and
	 * `{@link GL2.Node#setClipRectEnabled}` for additional details about clipping rectangles.
	 *
	 * When you instantiate a touch target, it is created with a size of `0` and an anchor point of
	 * `[0, 0]`. Call `{@link GL2.TouchTarget#setSize}` and `{@link GL2.TouchTarget#setAnchor}` to
	 * change these properties so they define an area that can receive touch events. In most cases,
	 * you will set these properties so they are identical to the corresponding properties of a
	 * `{@link GL2.Primitive}`, `{@link GL2.Sprite}`, or `{@link GL2.Text}` object. You can then add
	 * the touch target as a child of the visible node and call the `setPosition()` method,
	 * inherited from `{@link GL2.Node}`, to indicate that the touch target has an offset of 0 from
	 * its parent node. The touch target will inherit transformations from its parent node.
	 * @constructs Create a touch target.
	 * @augments GL2.Node
	 * @since 1.0
	 */
    initialize: function()
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0, 0);
		this._touchEmitter = new Core.MessageEmitter();
    },

	/**
	 * Destroy the touch target, and release the resources allocated by the touch target.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
	},

	/**
	 * Retrieve the size of the touch target. The size is relative to the scale that has been
	 * applied to the parent node.
	 * @example
	 * // Create a parent node that scales up its child nodes.
	 * var node = new GL2.Node();
	 * node.setScale(50, 25);
	 * // Add a touch target to the parent node.
	 * var touchTarget = new GL2.TouchTarget();
	 * node.addChild(touchTarget);
	 * // Because the touch target's parent node has been scaled, the following call
	 * // to setSize() will result in a touch target that covers a 50 pixel by 25 pixel
	 * // rectangle on the device's screen.
	 * touchTarget.setSize(new Core.Size(1, 1));
	 * // The value returned by getSize() does not reflect any scaling that has been
	 * // applied to the parent node.
	 * var targetSize = touchTarget.getSize();
	 * console.log(targetSize.getWidth());  // prints "1"
	 * console.log(targetSize.getHeight()); // prints "1"
	 * @returns {Core.Size} The current size of the touch target.
	 * @see GL2.TouchTarget#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getSize: function()
	{
		return this._size;
	},

	/**
	 * Retrieve the offset of the touch target's anchor point. The anchor point defines the
	 * origin of any scaling or rotation that is applied to the touch target.
	 * @returns {Core.Point} The current offset of the touch target's anchor point.
	 * @see GL2.TouchTarget#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getAnchor: function()
	{
		return this._anchor;
	},

	/**
	 * Retrieve the touch emitter for the touch target. By adding a listener to the touch emitter,
	 * you can monitor touch events as the user touches the target, moves a finger across the
	 * screen, and stops touching the screen. The touch emitter calls the listener's callback
	 * function, passing in a `{@link GL2.Touch}` object.
	 *
	 * The emitter fires its first event when the user touches the touch target. If the handler for
	 * this initial event returns the value `true`, the emitter captures the touch event and
	 * continues to fire as long as the user continues to touch the screen, regardless of whether
	 * the user's finger is within the touch target. The emitter stops firing when the user's finger
	 * is no longer touching the screen.
	 *
	 * If the handler for the initial touch event does not return `true`, the touch event will
	 * continue to propagate to touch targets that have a lower depth.
	 * @example
	 * // Create a subclass of Core.MessageListener that covers the entire screen
	 * // with a touch target and handles touch events.
	 * var Target = Core.MessageListener.subclass({
	 *     initialize: function() {
	 *         this.node = new GL2.Node();
	 *         this.target = new GL2.TouchTarget();
	 *
	 *         var anchor = new Core.Point(0.5, 0.5);
	 *         var size = new Core.Size(Device.LayoutEmitter.getWidth(),
	 *           Device.LayoutEmitter.getHeight());
	 *         this.target.setAnchor(anchor);
	 *         this.target.setSize(size);
	 *
	 *         this.target.getTouchEmitter().addListener(this, this.onTouch.
	 *           bind(this));
	 *
	 *         node.addChild(this.target);
	 *         GL2.Root.addChild(this.node);
	 *     },
	 *
	 *     onTouch: function(touch) {
	 *         switch(touch.getAction()) {
	 *             case touch.Action.Start:
	 *                 // Start tracking the touch event.
	 *                 this.trackingId = touch.getId();
	 *                 this.trackingPosition = touch.getPosition();
	 *
	 *                 // Identify the touch event's offset from the global
	 *                 // scene coordinates.
	 *                 var local = this.screenToLocal(this.trackingPosition);
	 *                 var current = this.getPosition();
	 *                 this.trackingOffset = new Core.Vector(current.getX() - local.getX(),
	 *                   current.getY() - local.getY());
	 *
	 *                 // Return true so that we continue to get touch events.
	 *                 return true;
	 *
	 *             case touch.Action.Move:
	 *                 // Make sure this is the same touch that we are
	 *                 // currently tracking.
	 *                 if (this.trackingId != touch.getId()) {
	 *                     return;
	 *                 }
	 *                 // Update the touch position.
	 *                 this.trackingPosition = touch.getPosition();
	 *                 break;
	 *
	 *             case touch.Action.End:
	 *                 // Make sure this is the same touch that we are
	 *                 // currently tracking.
	 *                 if (this.trackingId != touch.getId()) {
	 *                     return;
	 *                 }
	 *                 // Clear the ID and position.
	 *                 this.trackingId = this.trackingPosition = null;
	 *                 break;
	 *         }
	 *     }
	 * });
	 *
	 * // Instantiate the object.
	 * var myTouchTarget = new Target();
	 * @returns {Core.MessageEmitter} The touch emitter for this touch area.
	 * @see Core.MessageEmitter
	 * @see Core.MessageListener
	 * @see GL2.Touch#getAction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getTouchEmitter: function()
	{
		return this._touchEmitter;
	},

    /**
	 * Set the touch target's width and height. The size is relative to the scale that has been
	 * applied to the parent node.
	 * @example
	 * // Create a parent node that scales up its child nodes.
	 * var node = new GL2.Node();
	 * node.setScale(50, 25);
	 * // Add a touch target to the parent node.
	 * var touchTarget = new GL2.TouchTarget();
	 * node.addChild(touchTarget);
	 * // Because the touch target's parent node has been scaled, the following call
	 * // to setSize() will result in a touch target that covers a 50 pixel by 25 pixel
	 * // rectangle on the device's screen.
	 * touchTarget.setSize(new Core.Size(1, 1));
	 * @param {Core.Size} size The touch target's new width and height.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());

		return this;
	},

	/**
	 * Set the offset of the touch target's anchor point. The anchor point defines the origin of
	 * any scaling or rotation that is applied to the touch target. Its offset is defined as a
	 * multiple of the touch target's width and height. For example, the anchor point offset
	 * `[0.5, 0.5]` represents a point that is centered on the X and Y axes.
	 *
	 * **Note**: The anchor point is calculated before transformations are applied to the touch
	 * target.
 	 * @example
	 * var touchTarget = new GL2.TouchTarget();
	 * touchTarget.setAnchor(new Core.Point(0.25, 0.25));
	 * @param {Core.Point} anchor The new offset of the touch target's anchor point.
	 * @returns {this}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);

		this._setAnchorSendGen(a.getX(),a.getY());

		return this;
	},

	/**
	 * Translate a location in the global scene's coordinate space to the touch target's local
	 * coordinate space. Use this method to determine a touch event's offset from the touch target.
	 *
	 * For an example of how to use this method, see the example for
	 * `{@link GL2.TouchTarget#getTouchEmitter}`.
	 * @name GL2.TouchTarget#screenToLocal
	 * @function
	 * @param {Core.Point} location The location to transform.
	 * @returns {Core.Point} The location's coordinates within the touch target's local coordinate
	 *		space.
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */

	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;

		var a = this._anchor;
		var s = this._size;

		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},

	/**
	 * Translate a location in the touch target's local coordinate space to the global scene's
	 * coordinate space. Use this method to translate between two local coordinate spaces.
	 * @name GL2.TouchTarget#localToScreen
	 * @function
	 * @param {Core.Point} location The location in the touch target's local coordinate space to
	 *		transform.
	 * @returns {Core.Point} The location's coordinate within the global scene's coordinate space.
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */

	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;

		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());

		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 313,
	// Method create = -1
	// Method setSize = 2
	// Method setAnchor = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[313] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x139ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( 0x1390002, this, [ +width, +height ] );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1390003, this, [ +x, +y ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// GL2 diagnostic emitter; collects info from GL2 subsystem.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

//
// Create and export a DiagnosticEmitter for GL2.
//

var Diagnostics = exports.Diagnostics = Core.DiagnosticEmitter.singleton(
    /** @lends GL2.Diagnostics.prototype */
{
    classname: 'GL2_Diagnostics',

    /**
     * @class the <code>GL2.Diagnostics</code> class constructs a singleton object
     * that emits detailed GL2 diagnostic information to its listeners.
     *
     * The emitter currently emits an object of the form:
     * <pre>
     *  {
     *      "name":"GL2",                  // Emitter name, 'GL2'
     *
     *      "graph_nodes": {Number},       // Number of nodes in the scene graph
     *
     *      "gl2_scene_time":{             // A Timer object reporting total time traversing the scene:
     *           "samples": {Number},      // Number of timer executions captured this interval
     *           "average": {Number},      // Average time spent in the timed block
     *           "min": {Number},          // Minimum time spent in the timed block
     *           "max": {Number}           // Maximum time spent in the timed block
     *      },                             // Other {Timer} below are identical.
     *
     *      "gl2_touch_time":{Timer},      // Time spent processing Touch events
     *
     *      "ngfx_last_frame":{                // Object containing ngfx statistics from the last frame:
     *          "total_vertices": {Number},    // Total vertices drawn
     *          "total_primitives": {Number},  // Total number of GL2.Primitives drawn
     *          "total_indices": {Number},     // Total number of indices processed over all primitives
     *          "total_draw_calls": {Number}   // Total number of times draw calls were made into GL.
     *      },
     *
     *      "ngfx_texture_info":{              // Object containing info on currently loaded textures:
     *          "total_bytes": {Number},       // Total size of all loaded textures
     *          "num_textures_total":{Number}, // Number of textures loaded
     *          "num_textures_by_size":{       // Object containing a breakdown of how many of each size:
     *              {String} : {Number},       // Entries of the form "'nnnn bytes': m, ..."
     *              ...
     *          }
     *      },
     *
     *      "gl2_animations": {                // Object containing information about loaded Animations:
     *          "motion_controllers": {        // Object containing GL2.MotionController info:
     *              "num_total": {Number}      // Total number of motion controllers
     *              "num_playing": {Number},   // Number of motion controllers currently playing
     *          },
     *
     *          "motion_data": {               // Object containing GL2.MotionData info:
     *              "num_total": {Number},     // Total number of MotionData objects created
     *              "total_size": {Number}     // Total heap bytes consumed by MotionData objects
     *          }
     *      }
     *  }
     * </pre>
     * @name GL2.Diagnostics
     * @augments Core.DiagnosticEmitter
     * @constructs
     * @singleton
     * @since 1.7
     */

    initialize: function($super)
    {
	$super('GL2');
    }

});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Root'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Root'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Root'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Root.js';

var Core = require('NGCore/Client/Core').Core;
var Touch = require('NGCore/Client/GL2/Touch').Touch;
var Diagnostics = require('NGCore/Client/GL2/Diagnostics').Diagnostics;
var Node = require('NGCore/Client/GL2/Node').Node;


var Root = exports.Root = Core.Class.singleton(
/** @lends GL2.Root.prototype */
{
	classname: 'Root',

	/**
	 * @class The `GL2.Root` class is a singleton that acts as a container for the `GL2` objects
	 * that comprise the scene graph. `GL2` node trees must be added to the `GL2.Root` singleton so
	 * that their individual nodes can be displayed and can receive touch events.
	 * @name GL2.Root
	 * @augments Core.Class
	 * @constructs
	 * @singleton
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
	    Diagnostics.pushCollector(this.nodesInGraph.bind(this));

		this._children = [];

		this._createSendGen(this.__objectRegistryId);

		this._touchTracking = {};
	},

	/**
	 * Add a node tree to the root of the scene graph.
	 * @example
	 * var mainNode = new GL2.Node(),
	 *     sprite = new GL2.Sprite(),
	 *     text = new GL2.Text();
	 * mainNode.addChild(sprite).addChild(text);
	 * GL2.Root.addChild(mainNode);
	 * @param {Object} child The node tree to add. This parameter must contain an object instance
	 *		that inherits from `{@link GL2.Node}`.
	 * @returns {void}
	 * @see GL2.Root#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	addChild: function(child)
	{
		this._children.push(child);
		child._didAddToParent(this);

		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
	},

	/**
	 * Remove a node tree from the root of the scene graph.
	 *
	 * **Note**: Removing a node tree from the scene graph does not destroy the node tree. You must
	 * explicitly call `destroy()` on the parent node and its children when you no longer need to
	 * use the node tree.
	 * @example
	 * var sprite = new GL2.Sprite();
	 * GL2.Root.addChild(sprite);
	 * // Additional code here.
	 * // Later, when the application is no longer using the sprite:
	 * GL2.Root.removeChild(sprite);
	 * @param {Object} child The node tree to remove. This parameter must contain an object instance
	 *		that inherits from `{@link GL2.Node}`.
	 * @throws {Error} The specified node tree is not a child of `GL2.Root`.
	 * @returns {void}
	 * @see GL2.Root#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	removeChild: function(child)
	{
		child._willRemoveFromParent();

		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);

		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
	},

	/**
	 * Translate a location in the global scene's coordinate space to the coordinate space of the
	 * scene graph's root. These two coordinate spaces are identical; therefore, you will not
	 * normally need to call this method.
	 * @param {Core.Point} location The location to transform.
	 * @returns {Core.Point} The location's coordinates within the local coordinate space of the
	 *		scene graph's root.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	screenToLocal: function(location)
	{
		return location;
	},

	/**
	 * Translate a location in the coordinate space of the scene graph's root to the global scene's
	 * coordinate space. These two coordinate spaces are identical; therefore, you will not
	 * normally need to call this method.
	 * @param {Core.Point} location The location to transform.
	 * @returns {Core.Point} The location's coordinates within the global scene's coordinate space.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	localToScreen: function(location)
	{
		return location;
	},

	_onTouchEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onTouchEventRecvGen(cmd, msg))
			return;

		// Build touch object.
		var touchId = msg.touchId;
		var touchAction = msg.touchAction;
		var touch = new Touch();
	        var i, o, track;
		touch._setId(touchId);
		touch._setAction(touchAction);
		touch._setPosition(msg.x, msg.y);

		// Extract all touch targets.
		var ids = [];
		for(i=0; i < msg.touchTargetCount; ++i)
		{
			var t = {};
			if(!this._touchTargetRecvGen(cmd, t))
				return;
			// Add an array entry for every touch event that we have gotten from native.
			ids.push(t.nodeId);
		}

		touch._setTargetIds(ids);

		switch(touchAction)
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var key in ids)
				{
					var id=ids[key];
					o = Core.ObjectRegistry.idToObject(id);
					if(o && o.getTouchEmitter().chain(touch))
					{
						this._touchTracking[touchId] = id;
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				track = this._touchTracking[touchId];
				if(track)
				{
					o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				track = this._touchTracking[touchId];
				if(track)
				{
					o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 309,
	// Method create = -1
	// Method addChild = 2
	// Method removeChild = 3
	// Method onTouchEvent = 4
	// Method touchTarget = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onTouchEventRecv( cmd );
					break;
				case 5:
					instance._touchTargetRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[309] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onTouchEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "touchId" ] === undefined )
		{
			NgLogE("Could not parse touchId in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchAction" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "touchAction" ] === undefined )
		{
			NgLogE("Could not parse touchAction in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchTargetCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "touchTargetCount" ] === undefined )
		{
			NgLogE("Could not parse touchTargetCount in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_touchTargetRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		obj[ "nodeId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "nodeId" ] === undefined )
		{
			NgLogE("Could not parse nodeId in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 1);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x135ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( 0x1350002, this, [ +child ] );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( 0x1350003, this, [ +child ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _onTouchEventRecv: function( cmd ) {}
	// _touchTargetRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

	,
    // Diagnostics collector
    nodesInGraph: function(interval) 
    {
	var diag = {graph_nodes: 0};

	// Do BFS, don't recurse; SG may be deep
	var nodes = this._children.slice();
	while(nodes.length > 0)
	{
	    var node = nodes.shift();
	    nodes = nodes.concat(node._children);
	    diag.graph_nodes++;
	}

	return diag;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Text'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Text'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Text'] = exports; 
var __dirname = 'NGCore/Client/GL2';
var __filename = 'NGCore/Client/GL2/Text.js';

var Core = require('NGCore/Client/Core').Core;
var Node = require('NGCore/Client/GL2/Node').Node;
var Font = require('NGCore/Client/GL2/Font').Font;


var Text = exports.Text = Node.subclass(
/** @lends GL2.Text.prototype */
{
	classname: 'Text',

	/**
	 * @class The `GL2.Text` class enables applications to display text areas. The methods in this
	 * class control the text area's font, alignment, and placement.
	 *
	 * By default, text areas are styled as follows:
	 *
	 * 1. Text is rendered in Arial, using 18 pixels per em.
	 * 2. Text is horizontally and vertically centered with the text area.
	 * 3. The text area's size is not constrained. If a width constraint is added, the text area's
	 * text string will wrap onto multiple lines.
	 * 4. The text area's anchor point is centered within the text area.
	 *
	 * **Important**: Text areas may have rendering problems when they are scaled. Do not apply a
	 * scale to text areas unless absolutely necessary. In addition, minimize the number of font
	 * sizes that your application uses; each new font size uses additional memory on the device.
	 * @constructs Create a text area.
	 * @augments GL2.Node
	 * @param {String} [text] The text to display.
	 * @since 1.0
	 */
    initialize: function(text)
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
        this._horizontalAlign = this.HorizontalAlign.Center;
        this._verticalAlign = this.VerticalAlign.Middle;
        this._text = '';
		if (text)
			 this.setText(text);

        this._fontFamily = '';
        this._fontSize = 18;
		this._overflowMode = this.OverflowMode.Multiline;
		this._fontLocation = this.FontLocation.Default;

		this._font = null;

		this._callbackIdCounter = 1;
		this._callbacks = {};
    },

	/**
	 * Destroy the text area, and release the resources allocated by the text area.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
	},

	/**
	 * Retrieve the width and height of the text area. If one of these dimensions is set to 0, the
	 * rendering engine will allow that dimension to expand if necessary to fit the text.
	 * @returns {Core.Size} The current size of the text area, in pixels.
	 * @see GL2.Text#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getSize: function()
	{
		return this._size;
	},

	/**
	 * Retrieve the offset of the text area's anchor point. The anchor point defines the origin of
	 * any scaling or rotation that is applied to the text area.
	 * @returns {Core.Point} The current offset of the text area's anchor point.
	 * @see GL2.Text#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getAnchor: function()
	{
		return this._anchor;
	},

	/**
	 * Retrieve the text area's horizontal alignment.
	 * @returns {GL2.Text#HorizontalAlign} The current horizontal alignment of the text area.
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getHorizontalAlign: function()
	{
		return this._horizontalAlign;
	},

	/**
	 * Retrieve the text area's vertical alignment.
	 * @returns {GL2.Text#VerticalAlign} The current vertical alignment of the text area.
	 * @see GL2.Text#setVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getVerticalAlign: function()
	{
		return this._verticalAlign;
	},

	/**
	 * Retrieve the text string to render in the text area.
	 * @returns {String} The current text string to render in the text area.
	 * @see GL2.Text#setText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getText: function()
	{
		return this._text;
	},

	/**
	 * Retrieve the text area's font family.
	 * @returns {String|GL2.Font} The current font family for the text area.
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getFontFamily: function()
	{

		return this._fontFamily;
	},

	/**
	 * Retrieve the text area's font size, in pixels per em.
	 * @returns {Number} The current font size for the text area.
	 * @see GL2.Text#setFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getFontSize: function()
	{

		return this._fontSize;
	},

	/**
	 * Retrieve the text area's overflow mode, which defines the text area's behavior when the text
	 * area is not large enough to fit the text string.
	 * @returns {GL2.Text#OverflowMode} The current overflow mode for the text area.
	 * @see GL2.Text#OverflowMode
	 * @see GL2.Text#setOverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getOverflowMode: function()
	{
		return this._overflowMode;
	},

    /**
	 * Set the text area's width and height. The size is relative to the scale that has been applied
	 * to the parent node.
	 *
	 * **Important**: Text areas may have rendering problems when they are scaled. Do not apply a
	 * scale to text areas unless absolutely necessary.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setSize(200, 100);
	 * @param {Core.Size} size The text area's new width and height, in pixels.
	 * @returns {this}
	 * @see GL2.Text#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());

		return this;
	},

    /**
	 * Set the offset of the text area's anchor point. The anchor point defines the origin of any
	 * scaling or rotation that is applied to the text area. Its offset is defined as a multiple of
	 * the text area's width and height. For example, the default anchor offset, `[0.5, 0.5]`,
	 * represents a point that is centered on the U and V axes.
	 *
	 * If the text area's width or height is set to 0, the anchor point's offset is measured based
	 * on the rendered size of the text string.
	 *
	 * **Note**: The anchor point is calculated before transformations are applied to the text area.
	 * @example
	 * // Create a text area with horizontally and vertically centered text.
	 * var textArea = new GL2.Text("Next Level");
	 * textArea.setHorizontalAlign(GL2.Text.HorizontalAlign.Center).
	 *   setVerticalAlign(GL2.Text.VerticalAlign.Middle).
	 *   setAnchor(new Core.Point(0.5, 0.5));
	 * @param {Core.Point} location The new offset of the text area's anchor point.
	 * @returns {this}
	 * @see GL2.Text#getAnchor
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setAnchor: function(location)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);

		this._setAnchorSendGen(a.getX(),a.getY());

		return this;
	},

    /**
	 * Set the text area's horizontal alignment.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
	 * @param {GL2.Text#HorizontalAlign} horizontalAlign The new horizontal alignment for the text
	 *		area.
	 * @returns {this}
	 * @see GL2.Text#getHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setHorizontalAlign: function(horizontalAlign)
	{
		this._horizontalAlign = horizontalAlign;

		this._setHorizontalAlignSendGen(horizontalAlign);

		return this;
	},

    /**
	 * Set the text area's vertical alignment.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setVerticalAlign(GL2.Text.VerticalAlign.Bottom);
	 * @param {GL2.Text#VerticalAlign} verticalAlign The new vertical alignment for the text area.
	 * @returns {this}
	 * @see GL2.Text#getVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setVerticalAlign: function(verticalAlign)
	{
		this._verticalAlign = verticalAlign;

		this._setVerticalAlignSendGen(verticalAlign);

		return this;
	},

    /**
	 * Set the text string to display in the text area.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setText("Choose an Item");
	 * @param {String} text The new text string to display in the text area.
	 * @returns {this}
	 * @see GL2.Text#getText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setText: function(text)
	{
		this._text = text;

		this._setTextSendGen(text);

		return this;
	},

    /**
	 * Set the font family to use for the text area. By default, you can use the font families that
	 * are provided by the device. You can also use the font families that are bundled with ngCore
	 * or include your own font family in the application bundle.
	 *
	 * To retrieve a list of font families that are provided by the device, call
	 * `{@link Core.Capabilities#getAvailableFonts}`.
	 *
	 * To use a font family that is bundled with your application, do the following:
	 *
	 * 1. Include the necessary font files in your application's `manifest.json` file, or in a
	 * secondary manifest. The font files must be in TrueType (.ttf) or OpenType (.otf) format. You
	 * can include the font files in the `other` or `other_encrypted` section of `manifest.json`.
	 * 2.  Call `{@link GL2.Text#setFontLocation}` to indicate that the text area will use a font
	 * family from the application bundle.
	 * 3. Call `setFontFamily()`, and pass in the path to the font file.
	 *
	 * In addition, you can use the `{@link GL2.Font}` class to load a font, then pass the
	 * `GL2.Font` object to this method. The `GL2.Font` class enables you to load a font
	 * asynchronously, so the application is not blocked while it waits for the font to load.
	 * @example
	 * // Use a random system-provided font.
	 * var textArea = new GL2.Text();
	 * var systemFonts = Core.Capabilities.getAvailableFonts();
	 * textArea.setFontFamily(systemFonts[Math.floor(Math.random() * systemFonts.length)]);
	 * @example
	 * // Use a font family from the application bundle.
	 * var textArea = new GL2.Text();
	 * textArea.setFontLocation(GL2.Text.FontLocation.Manifest);
	 * textArea.setFontFamily("./Content/fontName.otf");
	 * @param {String|GL2.Font} fontFamily The name of the font family to use in the text area; the
	 *		path to a font file in the application bundle; or a `{@link GL2.Font}` object that
	 *		contains a font resource.
	 * @returns {this}
	 * @see Core.Capabilities#getAvailableFonts
	 * @see GL2.Text#FontLocation
	 * @see GL2.Text#getFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
    setFontFamily: function(fontFamily)
	{


		this._fontFamily = fontFamily;

		this._setFontFamilySendGen(fontFamily);

		this._font = null;

		return this;
	},

    /**
	 * Set the text area's font size, in pixels per em.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setFontSize(24);
	 * @param {Number} fontSize The text area's new font size, in pixels per em.
	 * @returns {this}
	 * @see GL2.Text#getFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setFontSize: function(fontSize)
	{


		this._fontSize = fontSize;

		this._setFontSizeSendGen(fontSize);

		this._font = null;

		return this;
	},

	/**
	 * Retrieve the text area's overflow mode, which defines the text area's behavior when the text
	 * area is not large enough to fit the text string.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
	 * @param {GL2.Text#OverflowMode} overflowMode The new overflow mode for the text area.
	 * @returns {this}
	 * @see GL2.Text#getOverflowMode
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	setOverflowMode: function(overflowMode)
	{
		this._overflowMode = overflowMode;

		this._setOverflowModeSendGen(overflowMode);

		return this;
	},

	/**
	 * Set the location of font families that can be used by the text area. By default, the text
	 * area can use font families that are provided by the device.
	 * @example
	 * var textArea = new GL2.Text();
	 * textArea.setFontLocation(GL2.Text.FontLocation.Manifest);
	 * @param {GL2.Text#FontLocation} fontLocation The location of font families that can be used by
	 *		the text area.
	 * @returns {this}
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	setFontLocation: function(fontLocation)
	{


		this._fontLocation = fontLocation;

		this._setFontLocationSendGen(fontLocation);

		this._font = null;

		return this;
	},

	/**
	 * Translate a location in the global scene's coordinate space to the text area's local
	 * coordinate space.
	 * @name GL2.Text#screenToLocal
	 * @function
	 * @param {Core.Point} location The location in the global scene to transform.
	 * @returns {Core.Point} The location's coordinate within the text area's local coordinate
	 *		space.
	 * @see GL2.Text#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */

	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;

		var a = this._anchor;
		var s = this._size;

		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},

	/**
	 * Translate a location in the text area's local coordinate space to the global scene's
	 * coordinate space. Use this method to translate between two local coordinate spaces.
	 * @name GL2.Text#localToScreen
	 * @function
	 * @param {Core.Point} location The location in the text area's local coordinate space to
	 *		transform.
	 * @returns {Core.Point} The location's coordinate within the global scene's coordinate space.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */

	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;

		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());

		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},


	/**
	 * Measure the text area's total width and height, as well as the width of each line of text.
	 *
	 * **Note**: Before you call this method, you must add text to the text area or set the text
	 * area's size.
     * @example
	 * var textArea = new GL2.Text("Play Game");
	 * var size = new Core.Size();
	 * var lineWidths = [];
	 * var totalWidth = 0;
	 * textArea.measureArea(function(result) {
	 *     size.setAll(result.width, result.height);
	 *     lineWidths = result.lineWidths;
	 *     totalWidth = result.totalWidth;
	 * });
     * @cb {Function} callback The function to call after measuring the text.
     * @cb-param {Object} result Information about the text area's size.
     * @cb-param {Number} result.width The width, in pixels, of the block of text.
     * @cb-param {Number} result.height The height, in pixels, of the block of text.
     * @cb-param {Number[]} result.lineWidths The widths, in pixels, of each line in the block of
	 *		text.
     * @cb-param {Number} result.totalWidth The combined width, in pixels, of all of the lines in
	 *		the text block.
	 * @cb-returns {void}
     * @returns {void}
	 * @since 1.6
	 */
	measureArea: function(callback)
	{
		var callbackId = this._callbackIdCounter++;
		this._callbacks[callbackId] = callback;
		this._measureAreaSendGen(callbackId);
 	},

	_measureAreaCbRecv: function(cmd)
	{
		var msg = {};
		if (! this._measureAreaCbRecvGen(cmd, msg))
			return;

		var callbackId = msg["callbackId"];
		var result = msg["result"];

		var callback = this._callbacks[callbackId];
		delete this._callbacks[callbackId];

		callback(result);
	},

	/**
	 * Set the text area's font family by providing a `{@link GL2.Font}` object. The `GL2.Font`
	 * object's settings will override the existing font family, font location, and font size.
	 * @example
	 * var font = new GL2.Font("Default"),
	 * var text = new GL2.Text();
	 * text.setFont(font);
	 * @param {GL2.Font} font The font to use for this text area.
	 * @returns {this}
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android
	 * @since 1.8
	 */
	setFont: function( font )
	{

		this._font = font;

		this._setFontSendGen(Core.ObjectRegistry.objectToId(font));

		return this;
	},

	/**
	 * Enumeration for horizontal alignment modes.
	 * @name HorizontalAlign
	 * @fieldOf GL2.Text#
	 */

	/**
	 * Align text to the left.
	 * @name HorizontalAlign.Left
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Align text in the center.
	 * @name HorizontalAlign.Center
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Align text to the right.
	 * @name HorizontalAlign.Right
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Enumeration for vertical alignment modes.
	 * @name VerticalAlign
	 * @fieldOf GL2.Text#
	 */

	/**
	 * Align text at the top.
	 * @name VerticalAlign.Top
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Align text in the middle.
	 * @name VerticalAlign.Middle
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Align text at the bottom.
	 * @name VerticalAlign.Bottom
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Enumeration for the behavior when there is too much text to fit on one line.
	 * @name OverflowMode
	 * @fieldOf GL2.Text#
	 */

	/**
	 * Reduce the font size until the text fits.
	 * @name OverflowMode.ReduceFontSize
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Split the text into multiple lines.
	 * @name OverflowMode.Multiline
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Enumeration to choose the source of fonts for the application.
	 * @name FontLocation
	 * @fieldOf GL2.Text#
	 */

	/**
	 * Use the default fonts, which are the system fonts. Equivalent to
	 * `{@link GL2.Text#FontLocation.System}`.
	 * @name FontLocation.Default
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Use the system fonts.
	 * @name FontLocation.System
	 * @fieldOf GL2.Text#
	 * @constant
	 */

	/**
	 * Use the fonts that are bundled with ngCore. Not currently supported.
	 * @name FontLocation.Bundled
	 * @fieldOf GL2.Text#
	 * @constant
	 * @ignore
	 */

	/**
	 * Use custom fonts that are loaded through the application manifest.
	 * @name FontLocation.Manifest
	 * @fieldOf GL2.Text#
	 * @constant
	 */

// {{?Wg Generated Code}}
	
	// Enums.
	HorizontalAlign:
	{ 
		Left: 0,
		Center: 1,
		Right: 2
	},
	
	VerticalAlign:
	{ 
		Top: 0,
		Middle: 1,
		Bottom: 2
	},
	
	OverflowMode:
	{ 
		ReduceFontSize: 0,
		Multiline: 1
	},
	
	FontLocation:
	{ 
		Default: 0,
		System: 1,
		Bundled: 2,
		Manifest: 3
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 311,
	// Method create = -1
	// Method destroy = 2
	// Method setSize = 3
	// Method setAnchor = 4
	// Method setHorizontalAlign = 5
	// Method setVerticalAlign = 6
	// Method setText = 7
	// Method setFontFamily = 8
	// Method setFontSize = 9
	// Method setOverflowMode = 10
	// Method setFontLocation = 11
	// Method measureArea = 12
	// Method measureAreaCb = 13
	// Method setFont = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 13:
					instance._measureAreaCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[311] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_measureAreaCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 2 )
		{
			NgLogE("Could not parse due to wrong argument count in Text.measureAreaCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in Text.measureAreaCb from command: " + cmd );
			return false;
		}
		
		obj[ "result" ] = Core.Proc.parseObject( cmd[ 1 ] );
		if( obj[ "result" ] === undefined )
		{
			NgLogE("Could not parse result in Text.measureAreaCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x137ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1370002, this );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( 0x1370003, this, [ +width, +height ] );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( 0x1370004, this, [ +x, +y ] );
	},
	
	/** @private */
	_setHorizontalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( 0x1370005, this, [ +align ] );
	},
	
	/** @private */
	_setVerticalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( 0x1370006, this, [ +align ] );
	},
	
	/** @private */
	_setTextSendGen: function( text )
	{
		Core.Proc.appendToCommandString( 0x1370007, this, [ Core.Proc.encodeString( text ) ] );
	},
	
	/** @private */
	_setFontFamilySendGen: function( fontFamily )
	{
		Core.Proc.appendToCommandString( 0x1370008, this, [ Core.Proc.encodeString( fontFamily ) ] );
	},
	
	/** @private */
	_setFontSizeSendGen: function( fontSize )
	{
		Core.Proc.appendToCommandString( 0x1370009, this, [ +fontSize ] );
	},
	
	/** @private */
	_setOverflowModeSendGen: function( overflowMode )
	{
		Core.Proc.appendToCommandString( 0x137000a, this, [ +overflowMode ] );
	},
	
	/** @private */
	_setFontLocationSendGen: function( fontLocation )
	{
		Core.Proc.appendToCommandString( 0x137000b, this, [ +fontLocation ] );
	},
	
	/** @private */
	_measureAreaSendGen: function( callbackId )
	{
		Core.Proc.appendToCommandString( 0x137000c, this, [ +callbackId ] );
	},
	
	/** @private */
	_setFontSendGen: function( font )
	{
		Core.Proc.appendToCommandString( 0x137000e, this, [ +font ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setHorizontalAlign: function( align ) {}
	
	// setVerticalAlign: function( align ) {}
	
	// setText: function( text ) {}
	
	// setFontFamily: function( fontFamily ) {}
	
	// setFontSize: function( fontSize ) {}
	
	// setOverflowMode: function( overflowMode ) {}
	
	// setFontLocation: function( fontLocation ) {}
	
	// measureArea: function( callbackId ) {}
	
	// _measureAreaCbRecv: function( cmd ) {}
	// setFont: function( font ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/GL2.js';

/**
 * @name GL2
 * @namespace Draw sprites and animations, and handle touch events.
 * @description
 * The `GL2` module renders an application's sprites and animations, leveraging the device's support
 * for the OpenGL standard. `GL2` also provides monitoring of touch events within the context of an
 * OpenGL view, which is provided by the `{@link UI.GLView}` class.
 *
 * You can use the `GL2` module's classes to do all of the following:
 *
 * + Organize and group `GL2` nodes (`{@link GL2.Node}`, `{@link GL2.Root}`)
 * + Display static images, which can be warped and stretched arbitrarily (`{@link GL2.Sprite}`,
 * `{@link GL2.Primitive}`)
 * + Display flipbook-style animations (`{@link GL2.Animation}`, `{@link GL2.Animation.Frame}`)
 * + Move images around the screen (`{@link GL2.MotionController}`, `{@link GL2.MotionData}`)
 * + Create particle effects (`{@link GL2.Emitter}`, `{@link GL2.EmitterData}`)
 * + Draw arbitrary vertex-based polygons (`{@link GL2.Primitive}`, `{@link GL2.Primitive.Vertex}`)
 * + Display text (`{@link GL2.Text}`)
 * + Track touch events (`{@link GL2.TouchTarget}`, `{@link GL2.Touch}`)
 * + Render multiple images into a single texture, which can be displayed or saved to a file
 * (`{@link GL2.RenderTarget}`)
 * + Load texture images and fonts, either synchronously or asynchronously (`{@link GL2.Texture}`,
 * `{@link GL2.Font}`)
 *
 * You can also capture a screenshot from the device by calling `{@link UI.takeScreenshot}`.
 *
 * The components of a `GL2` scene are organized into a tree of nodes, commonly referred to as a
 * scene graph. The `{@link GL2.Root}` singleton is at the top of the scene graph, and all of the
 * scene graph's nodes are children or descendants of `{@link GL2.Root}`. A node can also exist
 * independently of the scene graph, but it will not be displayed, and its touch targets will not be
 * touchable.
 *
 * Each node can have parents and ancestors, as well as children and descendants. Nodes inherit many
 * of the properties of their parents and ancestors; for example, if node X has an ancestor that is
 * rotated by 45 degrees, node X will also be rotated by 45 degrees. See `{@link GL2.Node}` for
 * additional details.
 *
 * You can use clipping rectangles to hide portions of the scene graph. See
 * `{@link GL2.Node#setClipRect}` for details. When a clipping rectangle is enabled, content outside
 * of the clipping rectangle is not drawn, and touch targets outside of the clipping rectangle do
 * not respond to touch inputs.
 *
 * The `GL2` module is supported by the `{@link UI.GLView}` class. Before an application
 * instantiates objects in the `GL2` module, it must do the following:
 *
 * 1. Instantiate a `{@link UI.GLView}` object.
 * 2. Call the object's `setFrame()` method, inherited from `{@link UI.AbstractView}`, to set the
 * view's frame. You will normally set the frame so that it encompasses the device's entire screen.
 * 3. Call the object's `setOnLoad()` method, inherited from `{@link UI.Element}`, to define a
 * callback function that will run after the `{@link UI.GLView}` object has loaded. **Important**:
 * You must wait for the callback to run before you call any method in the `GL2` module.
 * 4. Set the `active` property of the `{@link UI.GLView}` object to `true`.
 *
 * Applications should not attempt to display `{@link UI}` and `GL2` objects at the same time, with
 * the sole exception of `{@link UI.GLView}` objects. Displaying other `{@link UI}` objects at the
 * same time as `GL2` objects can result in poor performance.
 *
 * If your application needs to combine UI components and other graphics on the same screen,
 * consider using the ngGo toolkit. Its `GLUI` module reimplements the `{@link UI}` module in
 * OpenGL, enabling you to combine UI components with other graphics. Although `GLUI` does not
 * support all of the `{@link UI}` module's styling options, it offers enough flexibility for many
 * applications.  You can download ngGo from the Downloads section on the
 * [Mobage Developer Portal](https://developer.mobage.com/).
 */
function GL2Loader(map) {
	this.add = function(key, toEval) {
		this.__defineGetter__(key, function() {
			delete this[key];
			return this[key] = toEval();
		});
	};
	for (var k in map) {
		if (map.hasOwnProperty(k)) this.add(k, map[k]);
	}
}

exports.GL2 = new GL2Loader({
	'Animation': function() { return require('NGCore/Client/GL2/Animation').Animation; },
	'EmitterData': function() { return require('NGCore/Client/GL2/EmitterData').EmitterData; },
	'Emitter': function() { return require('NGCore/Client/GL2/Emitter').Emitter; },
	'Font': function() { return require('NGCore/Client/GL2/Font').Font; },
	'MotionController': function() { return require('NGCore/Client/GL2/MotionController').MotionController; },
	'MotionData': function() { return require('NGCore/Client/GL2/MotionData').MotionData; },
	'Node': function() { return require('NGCore/Client/GL2/Node').Node; },
	'Primitive': function() { return require('NGCore/Client/GL2/Primitive').Primitive; },
	'Touch': function() { return require('NGCore/Client/GL2/Touch').Touch; },
	'TouchTarget': function() { return require('NGCore/Client/GL2/TouchTarget').TouchTarget; },
	'Root': function() { return require('NGCore/Client/GL2/Root').Root; },
	'Sprite': function() { return require('NGCore/Client/GL2/Sprite').Sprite; },
	'Text': function() { return require('NGCore/Client/GL2/Text').Text; },
	'Texture': function() { return require('NGCore/Client/GL2/Texture').Texture; },
	'RenderTarget': function() { return require('NGCore/Client/GL2/RenderTarget').RenderTarget; },
	'Diagnostics': function() { return require('NGCore/Client/GL2/Diagnostics').Diagnostics; }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/View'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/View'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/View'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/View.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Window = require('NGCore/Client/UI/Window').Window;

var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;

var View = exports.View = AbstractView.subclass(
/** @lends UI.View.prototype */
{
	'type':'view',

	/**	 
	 * @class The `UI.View` class constructs objects that represent a view in a user interface.
	 * A view can encompass an entire screen in the user interface or a smaller component of a
	 * screen. This enables you to organize UI components into groups, then show and hide them as
	 * needed.
	 * 
	 * This class also serves as a base class for the following derived classes:
	 *
	 * + `{@link UI.ScrollView}`
	 * + `{@link UI.Toast}`
	 *
	 * A `UI.View` object's appearance can change automatically when its view state changes. For
	 * example, the view's image border can change automatically when the view gains focus or is
	 * selected. To implement this feature, your application can call a `UI.View` setter method more
	 * than once, passing a different value in the `flags` parameter each time. In addition, your 
	 * application can include properties for multiple view states in the constructor. See the 
	 * `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.View#setImageFit}` to specify how images
	 * will be resized to fit within the view, the fit mode you specify will apply in all view
	 * states.
	 * @name UI.View
	 * @constructs Create a view.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a UI.View object without setting any of its properties.
	 * var view = new UI.View();
	 * @example
	 * // Create a UI.View object, and set images that are specified in the
	 * // "image" property to use a dark gray border.
	 * var border = {
	 *     outerLine: "FF5F5F5F 1.0"
	 * };
	 * var View = new UI.View({
	 *     imageBorder: border
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new `UI.View`
	 *		object.
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (View._init) View._init();
		ViewParent.initialize.call(this);
		return $super(properties);
	},
	/**
	 * Add a child node to the view at the specified index. The child node must be an object
	 * created by a class that is derived from `{@link UI.AbstractView}`. Objects with a higher
	 * index are drawn on top of objects with a lower index.
	 * 
	 * If a child node already exists at the specified index, the existing child node is not
	 * removed. Instead, the index is incremented for all existing child nodes that have a higher
	 * index than the new child node.
	 * @function
	 * @example
	 * // Create a new view, then add a button to the view.
	 * var mainView = new UI.View();
	 * var button = new UI.Button();
	 * mainView.addChild(button);
	 * @param {Object} childNode The child node to add.
	 * @param {Number} [index] The index at which to add the child node. If the index is not
	 *		provided, the child node will be added as the last child node in the view.
	 * @returns {this}
	 * @see UI.View#removeChild
	 * @status iOS, Android, Flash, Test
	 */
	addChild: ViewParent.addChild,
	
	/**
	 * Remove the specified child node from the view.
	 *
	 * **Note**: Removing a child node from a view does not destroy the child node. You must 
	 * explicitly call `destroy()` when you no longer need to use the child node.
	 * @function
	 * @example
	 * // Create a new view, then add a button to the view.
	 * var mainView = new UI.View();
	 * var button = new UI.Button();
	 * mainView.addChild(button);
	 * // Remove the button when necessary.
	 * mainView.removeChild(button);
	 * @param {Object} childNode The child node to remove.
	 * @returns {Object} The child node that was removed.
	 * @see UI.View#addChild
	 * @status iOS, Android, Flash, Test
 	 */    
	removeChild: ViewParent.removeChild,


	/**
	 * Retrieve the number of child nodes attached to the view.
	 * @function
	 * @returns {Number} The current number of child nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildCount: ViewParent.getChildCount,

	/**
	 * Retrieve the child nodes that are attached to the view.
	 * @function
	 * @returns {Object[]} An array of child nodes that are attached to the view.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildren: ViewParent.getChildren,

	/**
	 * Provide custom layout code that runs before the view is displayed. For example, an
	 * application could programmatically adjust the positioning of the view's child nodes based on
	 * the dimensions of the view's frame.
	 *
	 * To use this method, create a custom subclass of `UI.View` that overrides this method, then
	 * specify your own layout code in the subclass' version of the method. 
	 * @function
	 * @returns {void}
	 * @since 1.0
	 */
	layoutSubviews: function() {
		//Override this for custom view subclass layout code
	},
	
	/**
	 * @protected
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	_setVisible: function($super, makeVisible) {
		var wasVisible = this._visible;
		$super(makeVisible);
		if (this._visible != wasVisible) {
			var l = this._children.length;
			for (var i = 0; i < l; i++) {
				this._children[i]._setVisible(makeVisible);
			}
		}
	}
});

// Properties
View._init = function() {
	delete View._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * Set the `image` property, which links to an image that the view will display in a specified
	 * view state.
	 * @name UI.View#setImage
	 * @function 
	 * @example
	 * var view = new UI.View();
	 * view.setImage("./Content/background.png");
	 * @param {String} image The path to the new image.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this image. To specify an image for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
 	 * @see UI.View#getImage
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `image` property, which links to an image that the view will
	 * display in a specified view state.
	 * @name UI.View#getImage
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The path to the current image for the specified view state.
	 * @see UI.View#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * Set the `imageBorder` property, which defines a border for the image in a specified view 
	 * state. See `{@link UI.Style#setGradient}` for information about this property.
	 * @name UI.View#setImageBorder
	 * @function
	 * @example
	 * var view = new UI.View();
	 * var border = {
	 *     outerLine: "FF5F5F5F 1.0"
	 * };
	 * view.setImageBorder(border);
	 * @param {Object} imageBorder The new image border.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this image border. To specify an image border for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.View#getImageBorder
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageBorder` property, which defines a border for the image in a
	 * specified view state.
	 * @name UI.View#getImageBorder
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The current image border.
	 * @see UI.View#setImageBorder
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * Set the `imageGravity` property, which defines how the image is positioned within the
	 * viewable area. The default image gravity is `[0.5, 0.5]`, which horizontally and vertically
	 * centers the image within the view.
	 * 
	 * See `{@link UI.Style#setImageGravity}` for more information about this property.
	 * @name UI.View#setImageGravity
	 * @function
	 * @example
	 * // Set the image gravity so that the image is horizontally centered and
	 * // vertically adjacent to the view's top edge.
	 * var view = new UI.View();
	 * view.setImageGravity([0.5, 0.0]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} imageGravity The new image gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
 	 * @returns {void}
	 * @see UI.View#getImageGravity
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageGravity` property, which defines how the image is positioned
	 * within the viewable area.
	 * @name UI.View#getImageGravity
	 * @function
	 * @returns {Number[]} The current image gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.View#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * Set the `imageFit` property, which defines how images will be scaled relative to the view.
	 * @name UI.View#setImageFit
	 * @function
	 * @example
	 * var view = new UI.View();
	 * view.setImageFit(UI.Commands.FitMode.None);
	 * @param {UI.Commands#FitMode} imageFit The scaling option that will be used to scale images 
	 * 		relative to the view.
	 * @status Flash
	 * @returns {void}
	 * @see UI.View#getImageFit
	 */
	/**
	 * Retrieve the value of the `imageFit` property, which defines how images will be scaled
	 * relative to the view.
	 * @name UI.View#getImageFit
	 * @function
	 * @example
	 * var view = new UI.View();
	 * view.setImageFit(UI.Commands.FitMode.AspectWidth);
	 * // More code here.
	 * // Later, the application takes different actions based on the
	 * // image's fit mode:
	 * var imageFitMode = view.getImageFit();
	 * switch (imageFitMode) {
	 *     case UI.Commands.FitMode.AspectHeight:
	 *         // Your code here
	 *         break;
	 *     case UI.Commands.FitMode.AspectWidth:
	 *         // Your code here
	 *         break;
	 *     // Continue through each enumerated value that you want to test
	 *     default:
	 *         // Your code here
	 *         break;
	 * }
	 * @returns {Number} The current scaling option that will be used to scale images relative to 
	 * 		the view. The returned value corresponds to an enumerated value of
	 *		`{@link UI.Commands#FitMode}`.
	 * @see UI.View#setImageFit
 	 * @status Flash
	 */
	View.synthesizeProperty('imageFit', Commands.setImageFitMode);

	View.synthesizeProperty('visibleInOrientations', Commands.setVisibleInOrientations);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Label'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Label'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Label'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Label.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Label = exports.Label = AbstractView.subclass(
/** @lends UI.Label.prototype */
{
	'type':'label',
	/**
	 * @class The `UI.Label` class creates text labels in a user interface.
	 * 
	 * A `UI.Label` object's appearance can change automatically when its view state changes. For
	 * example, the label's text shadow can change automatically when the label is disabled. To
	 * implement this feature, your application can call a `UI.Label` setter method more than once,
	 * passing a different value in the `flags` parameter each time. In addition, your application
	 * can include properties for multiple view states in the constructor. See the `{@link UI}`
	 * module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.Label#setTextGravity}` to control a label's
	 * position within its view, the text gravity you specify will apply in all view states.
	 * @name UI.Label
	 * @constructs Create a new label.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.Label object without setting any of its properties.
	 * var label = new UI.Label();
	 * @example
	 * // Create a new UI.Label object, setting its text and text color.
	 * var labelText = "First Name";
	 * var labelTextColor = "5A7F95";
	 * var label = new UI.Label({
	 *     text: labelText,
	 *     textColor: labelTextColor
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new `UI.Label`
	 *		object.
	 * @see UI.Commands#State
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (Label._init) Label._init();
		$super(properties);
	}
});

Label._init = function() {
	delete Label._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * Set the `text` property, which defines text for the label in a specified view state.
	 * @name UI.Label#setText
	 * @function
	 * @example
	 * var label = new UI.Label();
	 * label.setText("First Name");
	 * @param {String} text The new text for the label.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Label#getText
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `text` property, which defines text for the label in a specified
	 * view state.
	 * @name UI.Label#getText
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current label text for the specified view state.
	 * @see UI.Label#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizePropertyWithState('text', Commands.setText);	
	/**
	 * Set the `textFont` property, which defines the font that is used for the label text in a
	 * specified view state.
	 * @name UI.Label#setTextFont
	 * @function
	 * @example
	 * var label = new UI.Label();
	 * label.setTextFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this font. To specify a font for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Label#getTextFont
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textFont` property, which defines the font that is used for the
	 * label text in a specified view state.
	 * @name UI.Label#getTextFont
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The name of the current font for the specified view state.
	 * @see UI.Label#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * Set the `textColor` property, which defines the text color for the label in a specified view
	 * state.
	 * @name UI.Label#setTextColor
	 * @function
	 * @example
	 * var label = new UI.Label();
	 * label.setTextColor("5A7F95");
	 * @param {String} textColor The new text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can 
	 * 		use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Label#getTextColor
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textColor` property, which defines the text color for the label in
	 * a specified view state.
	 * @name UI.Label#getTextColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text color for the specified view state, in hexidecimal RGB
	 *		format.
	 * @see UI.Label#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * Set the `textShadow` property, which defines the color and size of shadows on the label text
	 * in a specified view state. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0, -1.0}"`)
	 * that contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.Label#setTextShadow
	 * @function
	 * @example
	 * // Use a white text shadow with a two-pixel blur, shifted up one pixel.
	 * var label = new UI.Label();
	 * label.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} textShadow The new text shadow, in the format specified above.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @see UI.Label#getTextShadow
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textShadow` property, which defines the color and size of shadows
	 * on the label text in a specified view state.
	 * @name UI.Label#getTextShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text shadow.
	 * @see UI.Label#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * Set the `textGravity` property, which defines how the label text is positioned within the
	 * viewable area. The text gravity is defined as two floats, one for the X (horizontal) axis and
	 * one for the Y (vertical) axis. Each float represents a percentage of the whitespace 
	 * surrounding the text.
	 * 
	 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
	 * text, with the remainder placed to the right of the text. For the Y axis, the specified 
	 * percentage of whitespace will be placed above the text, with the remainder placed below the
	 * text.
	 * 
	 * By default, the text gravity is set to `[0.5, 0.5]`, which centers the text within the
	 * label's area.
	 * @name UI.Label#setTextGravity
	 * @function
	 * @example
	 * // Set the text to be near the left side of the label and
	 * // vertically centered
	 * var label = new UI.Label();
	 * label.setTextGravity([0.1, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @see UI.Label#getTextGravity
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textGravity` property, which defines how the label text is
	 * positioned within the viewable area.
	 * @name UI.Label#getTextGravity
	 * @function
	 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.Label#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * Set the `textSize` property, which specifies the size, in pixels, of the label text.
	 * @name UI.Label#setTextSize
	 * @function
	 * @example
	 * var label = new UI.Label();
	 * var textSize = 24;
	 * label.setTextSize(textSize);
	 * @param {Number} textSize The new size, in pixels, of the label text.
	 * @see UI.Label#getTextSize
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of the
	 * label text.
	 * @name UI.Label#getTextSize
	 * @function
	 * @returns {Number} The current size, in pixels, of the label text.
	 * @see UI.Label#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizeProperty('textSize', Commands.setTextSize);

	/**
	 * Set the `textInsets` property, which contains insets that are used to clip the edges of the
	 * label text. The inset is specified as an array of floats, starting with the top inset and
	 * going clockwise around the button.
	 * @name UI.Label#setTextInsets
	 * @function
	 * @example
	 * var label = new UI.Label();
	 * var insetLeft = 10;
	 * label.setTextInsets([0, 0, 0, insetLeft]);
	 * @param {Number[]} textInsets The new text insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the label.
	 * @returns {void}
	 * @see UI.Label#getTextInsets
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textInsets` property, which contains insets that are used to clip
	 * the edges of the label text.
	 * @name UI.Label#getTextInsets
	 * @function
	 * @returns {Number[]} The current text insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the label.
	 * @see UI.Label#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Label.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);

	/**
	 * Set the `lineHeight` property, which specifies the line height, in pixels, for the label
	 * text. The line height will affect the label's layout if the text wraps onto multiple lines.
	 * @name UI.Label#setLineHeight
	 * @function
	 * @example
	 * var label = new UI.Label();
	 * label.setLineHeight(24);
	 * @param {Number} lineHeight The new line height, in pixels, for the label.
	 * @returns {void}
	 * @see UI.Label#getLineHeight
	 * @status iOS, Android, Test
	 * @since 1.6
	 */
	/**
	 * Retrieve the value of the `lineHeight` property, which specifies the line height, in pixels, 
	 * for the label text.
	 * @name UI.Label#getLineHeight
	 * @function
	 * @returns {Number} The current line height, in pixels, for the label.
	 * @see UI.Label#setLineHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.6
	 */
	Label.synthesizeProperty('lineHeight', Commands.setLineHeight);

};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Image'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Image'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Image'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Image.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Image = exports.Image = AbstractView.subclass(
/** @lends UI.Image.prototype */
{
	/**
	 * @class The `UI.Image` class creates images in a user interface. The methods in this class
	 * control how images are displayed and positioned.
	 * 
	 * A `UI.Image` object's appearance can change automatically when its view state changes. For
	 * example, the border around an image can change automatically when the image gains focus or is
	 * selected. To implement this feature, your application can call a `UI.Image` setter method
	 * more than once, passing a different value in the `flags` parameter each time. In addition,
	 * your application can include properties for multiple view states in the constructor. See the
	 * `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.Image#setImageGravity}` to control an
	 * image's position within its view, the image gravity you specify will apply in all view
	 * states.
	 * @name UI.Image
	 * @constructs Create a new image.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.Image object without setting any of its properties.
	 * var splashGraphic = new UI.Image();
	 * @example
	 * // Create a new UI.Image object, setting its image gravity.
	 * var splashGraphic = new UI.Image({
	 *     imageGravity: [0.25, 0.5]
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.Image` object.
	 * @see UI.Commands#State
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (Image._init) Image._init();
		$super(properties);
	},
	
	'type':'image'
});


// Properties
Image._init = function() {
	delete Image._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * Set the `image` property, which contains the path to an image that will be displayed for a 
	 * specified view state.
	 * @name UI.Image#setImage
	 * @function 
	 * @example
	 * var splashGraphic = new UI.Image();
	 * splashGraphic.setImage("./Content/splash.png");
	 * @param {String} imageURL The new image URL.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this image. To specify an image for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Image#getImage
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve a path to the image for a specified view state.
	 * @name UI.Image#getImage
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The path to the image for the specified view state.
	 * @see UI.Image#setImage
	 * @status iOS, Android, Flash, Test
	 */
	Image.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * Set the `imageBorder` property, which defines a border for images in a specified view state.
	 * See `{@link UI.Style#setGradient}` for information about this property.
	 * @name UI.Image#setImageBorder
	 * @function
	 * @example
	 * // Specify a one-pixel dark gray border.
	 * var image = new UI.Image();
	 * image.setImageBorder({
	 *     outerLine: "FF5F5F5F 1.0"
	 * });
	 * @param {Object} imageBorder The new image border.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this border. To specify a border for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Style#setGradient
	 * @see UI.Image#getImageBorder
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the `imageBorder` property, which defines a border for images in a specified view
	 * state.
	 * @name UI.Image#getImageBorder
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The current image border.
	 * @see UI.Image#setImageBorder
	 * @status iOS, Android, Flash, Test
	 */
	Image.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * Set the `imageGravity` property, which defines how the image is positioned within the
	 * viewable area. The image gravity is defined as two floats, one for the X (horizontal)
	 * axis and one for the Y (vertical) axis. Each float represents a percentage of the
	 * whitespace surrounding the button image.
	 * 
	 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
	 * image, with the remainder placed to the right of the image. For the Y axis, the specified 
	 * percentage of whitespace will be placed above the image, with the remainder placed below the
	 * image.
	 * 
	 * By default, the image gravity is set to `[0.5, 0.5]`, which centers the image within the
	 * viewable area.
	 * @name UI.Image#setImageGravity
	 * @function
	 * @example
	 * // Set the image gravity so that images are vertically centered
	 * // and horizontally placed near the left edge.
	 * var splashGraphic = new UI.Image();
	 * splashGraphic.setImageGravity([0.25, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} imageGravity The new image gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @returns {void}
	 * @see UI.Image#getImageGravity
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageGravity` property, which defines how the image is positioned
	 * within the viewable area.
	 * @name UI.Image#getImageGravity
	 * @function
	 * @returns {Number[]} The current image gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.Image#setImageGravity
	 * @status iOS, Android, Flash, Test
	 */
	Image.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	  * Set the `imageTransform` property, which defines an affine transformation of the image. An
	  * affine transformation makes it possible to move, scale, or skew an image while ensuring that
	  * straight lines remain straight and parallel lines remain parallel. You can also use an
	  * affine transformation to rotate an image.
	  * 
	  * The parameters to this method represent a 2 x 3 matrix that contains the following values:
	  * 
	  *     --      --    a = X scale    tx = X reposition
	  *     | a    b |    b = Y skew     ty = Y reposition
	  *     | c    d |    c = X skew
	  *     | tx  ty |    d = Y scale
	  *     --      --
	  * @name UI.Image#setImageTransform
	  * @function
	  * @example
	  * // Increase an image's size by 20 units along the X axis, and move it
	  * // down 5 units along the Y axis.
	  * var splashGraphic = new UI.Image();
	  * var scaleX = 20;
	  * var moveY = 5;
	  * splashGraphic.setImageTransform([scaleX, 0, 0, 0, 0, moveY]);
	  * @example
	  * // Rotate an image 30 degrees to the left.
	  * function degreesToRadians(degrees) {
	  *     return degrees * (Math.PI / 180);
	  * }
	  *
	  * var splashGraphic = new UI.Image();
	  * var angle = degreesToRadians(30);
	  * splashGraphic.setImageTransform([Math.cos(angle), Math.sin(angle),
	  *     -Math.sin(angle), Math.cos(angle), 0, 0]);
	  * @example
	  * // Skew the bottom of an image to the right by 10 units along the x axis.
	  * var splashGraphic = new UI.Image();
	  * var skewX = 10;
	  * splashGraphic.setImageTransform([0, 0, skewX, 0, 0, 0]);
	  * @param {Number[]} imageTransform The new affine transformation to use. Specified as an array 
	  *		of six floats: `[a, b, c, d, tx, ty]`.
	  * @returns {void}
	  * @see UI.Image#getImageTransform
	  */
	 /**
	  * Retrieve the value of the `imageTransform` property, which defines an affine transformation
	  * of the image.
	  * @name UI.Image#getImageTransform
	  * @function
	  * @returns {Number[]} The current affine transformation. Specified as an array of six floats:
	  *		 `[a, b, c, d, tx, ty]`.
	  * @see UI.Image#setImageTransform
	  */
	 Image.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * Set the `imageFit` property, which defines how images will be scaled relative to the view.
	 * @name UI.Image#setImageFit
	 * @function
	 * @example
	 * var splashGraphic = new UI.Image();
	 * splashGraphic.setImageFit(UI.Commands.FitMode.None);
	 * @param {UI.Commands#FitMode} imageFit The scaling option that will be used to scale images 
	 * 		relative to the button.
	 * @returns {void}
	 * @see UI.Image#getImageFit
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageFit` property, which defines how images will be scaled
	 * relative to the view.
	 * @name UI.Image#getImageFit
	 * @function
	 * @example
	 * var splashGraphic = new UI.Image();
	 * splashGraphic.setImageFit(UI.Commands.FitMode.AspectWidth);
	 * // More code here.
	 * // Later, the application takes an action based on the image's
	 * // fit mode:
	 * var imageFitMode = splashGraphic.getImageFit();
	 * switch (imageFitMode) {
	 *     case UI.Commands.FitMode.AspectHeight:
	 *         // Your code here
	 *         break;
	 *     case UI.Commands.FitMode.AspectWidth:
	 *         // Your code here
	 *         break;
	 *     // Continue through each enumerated value that you want to test
	 *     default:
	 *         // Your code here
	 *         break;
	 * }
	 * @returns {Number} The current scaling option that will be used to scale images relative to 
	 * 		the view. The returned value corresponds to an enumerated value of
	 *		`{@link UI.Commands#FitMode}`.
	 * @see UI.Image#setImageFit
 	 * @status iOS, Android, Flash, Test
	 */
	Image.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
	/**
	 * Set a function to call when an `imageLoaded` event occurs. This event occurs when the
	 * image specified by the `image` property finishes loading.
	 * @name UI.Image#setOnImageLoaded
	 * @event
	 * @example
	 * var image = new UI.Image();
	 * image.setOnImageLoaded(function(event) {
	 *     if (event.error) {
	 *         console.log("Unable to load image: " + event.error + ": " +
	 *             event.message);
	 *     } else {
	 *         console.log("Loaded an image with width=" + event.width + 
	 *         " and height=" + event.height);
	 *     }
	 * });
	 * @cb {Function} imageLoadedCallback The function to call when an `imageLoaded` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} [event.error] A code identifying the error, if any.
	 * @cb-param {Number} [event.height] The height of the image that was loaded.
	 * @cb-param {String} [event.message] A message describing the error, if any.
	 * @cb-param {Number} [event.width] The width of the image that was loaded.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.Image#event:getOnImageLoaded
	 * @since 1.6
	 * @status Flash
	 */
	/**
	 * Retrieve the function to call when an `imageLoaded` event occurs.
	 * @name UI.Image#getOnImageLoaded
	 * @event
	 * @returns {Function} The current function to call when an `imageLoaded` event occurs.
	 * @see UI.Image#event:setOnImageLoaded
	 * @since 1.6
	 * @status Flash
	 */
	Image.registerEventType('imageLoaded');
	
	/**
	 * Set a function to call when an `imageLoadFailed` event occurs. This event occurs when the
	 * image specified by the `image` property cannot be loaded.
	 * @name UI.Image#setOnImageLoadFailed
	 * @event
	 * @example
	 * var image = new UI.Image();
	 * image.setOnImageLoadFailed(function(event) {
	 *     console.log("An error occurred when loading " + event.url + 
	 *         ": " + event.error + ": " + event.message);
	 * });
	 * @cb {Function} imageLoadFailedCallback The function to call when an `imageLoadFailed` event
	 *		occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} event.error A code identifying the error.
	 * @cb-param {String} event.url The URL for the image.
	 * @cb-param {String} event.message A message describing the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.Image#event:getOnImageLoadFailed
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoadFailed` event occurs.
	 * @name UI.Image#getOnImageLoadFailed
	 * @event
	 * @returns {Function} The current function to call when an `imageLoadFailed` event occurs.
	 * @see UI.Image#event:setOnImageLoadFailed
	 * @since 1.6
	 */
	Image.registerEventType('imageLoadFailed');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Button'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Button'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Button'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Button.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Button = exports.Button = AbstractView.subclass(
/** @lends UI.Button.prototype */
{
	/**
	 * @class The `UI.Button` class provides buttons in a user interface. The methods in this class
	 * control how buttons are displayed and positioned.
	 * 
	 * A `UI.Button` object's appearance can change automatically when the button's view state 
	 * changes. For example, the button's fill color can change automatically when the button gains 
	 * focus or is selected. To implement this feature, your application can call a `UI.Button`
	 * setter method more than once, passing a different value in the `flags` parameter each time.
	 * In addition, your application can include properties for multiple view states in the
	 * constructor. See the `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.Button#setImageGravity}` to control an
	 * image's position within the button, the image gravity you specify will apply in all view
	 * states.
	 * @name UI.Button
	 * @constructs Create a button.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.Button object without setting any of its properties.
	 * var button = new UI.Button();
	 * @example
	 * // Create a new UI.Button object, setting its text gravity.
	 * var button = new UI.Button({
	 *     textGravity: [0.25, 0.5]
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new `UI.Button`
	 *		object.
	 */
	'type':'button',

	'Layout':Commands.ButtonLayout,
	
	/** @ignore */
	initialize: function($super, properties) {
		if (Button._init) Button._init();
		$super(properties);
	}
});

// Properties
Button._init = function() {
	delete Button._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * Set the `image` property, which links to an image that represents the button for a
	 * specified view state.
	 * @name UI.Button#setImage
	 * @function 
	 * @example
	 * var backButton = new UI.Button();        
	 * backButton.setImage("./Content/backButton.png", UI.Commands.State.Normal |
	 *     UI.Commands.State.Focused);
	 * @param {String} image The path to the new image.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this image. To specify an image for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Button#getImage
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `image` property, which defines a path to the button image for a
	 * specified view state.
	 * @name UI.Button#getImage
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The path to the button image for the specified view state.
	 * @see UI.Button#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizePropertyWithState('image', Commands.setImage);
	
	/**
	 * Set a function to call when an `imageLoaded` event occurs. This event occurs when an image
	 * finishes loading.
	 * @name UI.Button#setOnImageLoaded
	 * @event
	 * @example
	 * // Create an array of objects representing images to load, and update an
	 * // image's state when it has been loaded.
	 * var infoButton = new UI.Button();
	 * var images = [
	 *     {
	 *         url: "http://www.example.com/image1.png",
	 *         loaded: false,
	 *         width: 0,
	 *         height: 0
	 *     },
	 *     {
	 *         url: "http://www.example.com/image2.png",
	 *         loaded: false,
	 *         width: 0,
	 *         height: 0
	 *     }
	 * ];
	 * infoButton.setOnImageLoaded(function(event) {
	 *     if (event.error) {
	 *         console.log("An error occurred when loading " + event.imageURL + 
	 *             ": " + event.error + ": " + event.message);
	 *     } else {
	 *         for (var i = 0, l = images.length; i < l; i++) {
	 *             if (images[i].url == event.imageUrl) {
	 *                 images[i].loaded = true;
	 *                 images[i].height = event.height;
	 *                 images[i].width = event.width;
	 *             }
	 *         }
	 *     }
	 * });
	 * @cb {Function} imageLoadedCallback The function to call when an `imageLoaded` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} [event.error] A code identifying the error, if any.
	 * @cb-param {Number} [event.height] The height of the image, in pixels.
	 * @cb-param {String} event.imageUrl The URL for the image.
	 * @cb-param {String} [event.message] A message describing the error, if any.
	 * @cb-param {Number} [event.width] The width of the image, in pixels.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.Button#event:getOnImageLoaded
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoaded` event occurs.
	 * @name UI.Button#getOnImageLoaded
	 * @event
	 * @returns {Function} The function to call when an `imageLoaded` event occurs.
	 * @see UI.Button#event:setOnImageLoaded
	 * @since 1.6
	 */
	Button.registerEventType('imageLoaded');
	
	/**
	 * Set a function to call when an `imageLoadFailed` event occurs. This event occurs when an
	 * image cannot be loaded.
	 * @name UI.Button#setOnImageLoadFailed
	 * @event
	 * @example
	 * var infoButton = new UI.Button();
	 * infoButton.setOnImageLoadFailed(function(event) {
	 *     console.log("An error occurred when loading " + event.url + 
	 *         ": " + event.error + ": " + event.message);
	 * });
	 * @cb {Function} imageLoadFailedCallback The function to call when an `imageLoadFailed` event
	 *		occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} event.error A code identifying the error.
	 * @cb-param {String} event.url The URL for the image.
	 * @cb-param {String} event.message A message describing the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.Button#event:getOnImageLoadFailed
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoadFailed` event occurs.
	 * @name UI.Button#getOnImageLoadFailed
	 * @event
	 * @returns {Function} The function to call when an `imageLoadFailed` event occurs.
	 * @see UI.Button#event:setOnImageLoadFailed
	 * @since 1.6
	 */
	Button.registerEventType('imageLoadFailed');
		
	/**
	 * Set the `imageInsets` property, which contains insets that are used to clip the edges of the
	 * button image. The inset is specified as an array of floats, starting with the top inset and
	 * going clockwise around the button.
	 * @name UI.Button#setImageInsets
	 * @function
	 * @example
	 * var backButton = new UI.Button();
	 * // Use a top inset of 10, a right inset of 20, a bottom inset of 15, and
	 * // a left inset of 5.
	 * backButton.setImageInsets([10, 20, 15, 5]);
	 * @param {Number[]} imageInsets The new image insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the button.
	 * @returns {void}
	 * @see UI.Button#getImageInsets
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `imageInsets` property, which contains insets that are used to clip
	 * the edges of the button image.
	 * @name UI.Button#getImageInsets
	 * @function
	 * @returns {Number[]} The current image insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the button.
	 * @see UI.Button#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * Set the `imageFit` property, which defines how images will be scaled relative to the button.
	 * @name UI.Button#setImageFit
	 * @function
	 * @example
	 * var backButton = new UI.Button();
	 * backButton.setImageFit(UI.Commands.FitMode.None);
	 * @param {UI.Commands#FitMode} imageFit The scaling option that will be used to scale images 
	 * 		relative to the button.
	 * @returns {void}
	 * @see UI.Button#getImageFit
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `imageFit` property, which defines how images will be scaled
	 * relative to the button.
	 * @name UI.Button#getImageFit
	 * @function
	 * @example
	 * var backButton = new UI.Button();
	 * backButton.setImageFit(UI.Commands.FitMode.AspectWidth);
	 * // More code here.
	 * // Later, the application takes different actions based on the
	 * // image's fit mode:
	 * var imageFitMode = backButton.getImageFit();
	 * switch (imageFitMode) {
	 *     case UI.Commands.FitMode.AspectHeight:
	 *         // Your code here
	 *         break;
	 *     case UI.Commands.FitMode.AspectWidth:
	 *         // Your code here
	 *         break;
	 *     // Continue through each enumerated value that you want to test
	 *     default:
	 *         // Your code here
	 *         break;
	 * }
	 * @returns {Number} The current scaling option that will be used to scale images relative to 
	 * 		the button. The returned value corresponds to an enumerated value of
	 *		`{@link UI.Commands#FitMode}`.
	 * @see UI.Button#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * Set the `imageGravity` property, which defines how the button image is positioned within the
	 * viewable area. By default, the image gravity is set to `[0.5, 0.5]`, which centers the image
	 * within the viewable area.
	 * 
	 * See `{@link UI.Image#setImageGravity}` for more information about this property.
	 * @name UI.Button#setImageGravity
	 * @function
	 * @example
	 * // Position the image horizontally towards the left edge of the button and
	 * // vertically centered.
	 * var backButton = new UI.Button();
	 * backButton.setImageGravity([0.25, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} imageGravity The new image gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @returns {void}
	 * @see UI.Button#getImageGravity
	 * @see UI.Image#setImageGravity
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `imageGravity` property, which defines how the button image is
	 * positioned within the viewable area.
	 * @name UI.Button#getImageGravity
	 * @function
	 * @returns {Number[]} The current image gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.Button#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * Set the `imageTransform` property, which defines an affine transformation of the button
	 * image. See `{@link UI.Image#setImageTransform}` for more information about affine
	 * transformations.
	 * @name UI.Button#setImageTransform
	 * @function
	 * @example
	 * // Increase an image's size by 20 units along the X axis, and move it
	 * // down 5 units along the Y axis.
	 * var button = new UI.Button();
	 * var scaleX = 20;
	 * var moveY = 5;
	 * button.setImageTransform([scaleX, 0, 0, 0, 0, moveY]);
	 * @example
	 * // Rotate an image 30 degrees to the left.
	 * function degreesToRadians(degrees) {
	 *     return degrees * (Math.PI / 180);
	 * }
	 *
	 * var button = new UI.Button();
	 * var angle = degreesToRadians(30);
	 * button.setImageTransform([Math.cos(angle), Math.sin(angle),
	 *     -Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @example
	 * // Skew the bottom of an image to the right by 10 units along the x axis.
	 * var button = new UI.Button();
	 * var skewX = 10;
	 * button.setImageTransform([0, 0, skewX, 0, 0, 0]);
	 * @param {Number[]} imageTransform The new affine transformation. Specified as an array
	 *		of six floats: `[a, b, c, d, tx, ty]`.
	 * @returns {void}
	 * @see UI.Button#getImageTransform
	 * @see UI.Image#setImageTransform
 	 * @status iOS, Android
	 */
	/**
	 * Retrieve the value of the `imageTransform` property, which defines an affine transformation
	 * of the button image.
	 * @name UI.Button#getImageTransform
	 * @function
	 * @returns {Number[]} The current affine transformation. Specified as an array of six floats:
	 *		 `[a, b, c, d, tx, ty]`.
	 * @see UI.Button#setImageTransform
 	 * @status Javascript, iOS, Android, Flash
	 */
	Button.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * Set the `imageBorder` property, which defines a border for images in a specified view state.
	 * See `{@link UI.Style#setGradient}` for information about this property.
	 * @name UI.Button#setImageBorder
	 * @function
	 * @example
	 * // Use a dark gray border for the image.
	 * var infoButton = new UI.Button();
	 * var border = {
	 *     outerLine: "FF5F5F5F 1.0"
	 * }; 
	 * infoButton.setImageBorder(border);
	 * @param {Object} imageBorder The new image border.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this border. To specify a border for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Style#setGradient
	 * @see UI.Button#getImageBorder
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageBorder` property, which defines a border for images in a
	 * specified view state.
	 * @name UI.Button#getImageBorder
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The current image border for the specified view state.
	 * @see UI.Button#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	
	/**
	 * Set the `text` property, which defines text for the button in a specified view state.
	 * @name UI.Button#setText
	 * @function
	 * @example
	 * var infoButton = new UI.Button();
	 * infoButton.setText("More information");
	 * @param {String} text The new text for the button.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Button#getText
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `text` property, which defines text for the button in a specified
	 * view state.
	 * @name UI.Button#getText
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current button text for the specified view state.
	 * @see UI.Button#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * Set the `textColor` property, which defines the text color for the button in a specified view
	 * state.
	 * @name UI.Button#setTextColor
	 * @function 
	 * @example
	 * var infoButton = new UI.Button();
	 * infoButton.setTextColor("FFFFFF");
	 * @param {String} textColor The new text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can 
	 * 		use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Button#getTextColor
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `textColor` property, which defines the text color for the button
	 * in a specified view state.
	 * @name UI.Button#getTextColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text color for the specified view state, in hexidecimal RGB
	 *		format.
	 * @see UI.Button#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * Set the `textFont` property, which defines the font that is used for the button text in a
	 * specified view state.
	 * @name UI.Button#setTextFont
	 * @function
	 * @example
	 * var infoButton = new UI.Button();
	 * infoButton.setTextFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this font. To specify a font for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Button#getTextFont
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `textFont` property, which defines the font that is used for the
	 * button text in a specified view state.
	 * @name UI.Button#getTextFont
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The name of the current font for the specified view state.
	 * @see UI.Button#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * Set the `textShadow` property, which defines the color and size of shadows on the button text
	 * in a specified view state. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0, -1.0}"`)
	 * that contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.Button#setTextShadow
	 * @function
	 * @example
	 * // Specify a white text shadow with a two-pixel blur, shifted up one pixel
	 * // along the Y axis.
	 * var infoButton = new UI.Button();
	 * infoButton.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} textShadow The new text shadow, in the format specified above.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Button#getTextShadow
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `textShadow` property, which defines the color and size of shadows
	 * on the button text in a specified view state.
	 * @name UI.Button#getTextShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text shadow.
	 * @see UI.Button#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * Set the `textGravity` property, which defines how the button text is positioned within the
	 * viewable area. The text gravity is defined as two floats, one for the X (horizontal) axis and
	 * one for the Y (vertical) axis. Each float represents a percentage of the whitespace 
	 * surrounding the text.
	 * 
	 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
	 * text, with the remainder placed to the right of the text. For the Y axis, the specified 
	 * percentage of whitespace will be placed above the text, with the remainder placed below the
	 * text.
	 * 
	 * By default, the text gravity is set to `[0.5, 0.5]`, which centers the text horizontally and
	 * vertically within the viewable area.
	 * @name UI.Button#setTextGravity
	 * @function
	 * @example
	 * // Position the text horizontally towards the left side of the button and
	 * // vertically centered.
	 * var infoButton = new UI.Button();
	 * infoButton.setTextGravity([0.1, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @returns {void}
	 * @see UI.Button#getTextGravity
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `textGravity` property, which defines how the button text is
	 * positioned within the viewable area.
	 * @name UI.Button#getTextGravity
	 * @function
	 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.Button#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * Set the `textSize` property, which specifies the size, in pixels, of the button text.
	 * @name UI.Button#setTextSize
	 * @function
	 * @example
	 * var infoButton = new UI.Button();
	 * var textSize = 24;
	 * infoButton.setTextSize(textSize);
	 * @param {Number} textSize The new size, in pixels, of the button text.
	 * @returns {void}
	 * @see UI.Button#getTextSize
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of the
	 * button text.
	 * @name UI.Button#getTextSize
	 * @function
	 * @returns {Number} The current size, in pixels, of the button text.
	 * @see UI.Button#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * Set the `textInsets` property, which contains insets that are used to clip the edges of the
	 * button text. The inset is specified as an array of floats, starting with the top inset and
	 * going clockwise around the button.
	 * @name UI.Button#setTextInsets
	 * @function
	 * @example
	 * var infoButton = new UI.Button();
	 * var insetLeft = 10;
	 * infoButton.setTextInsets([0, 0, 0, insetLeft]);
	 * @param {Number[]} textInsets The new text insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the button.
	 * @returns {void}
	 * @see UI.Button#getTextInsets
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `textInsets` property, which contains insets that are used to clip
	 * the edges of the button text.
	 * @name UI.Button#getTextInsets
	 * @function
	 * @returns {Number[]} The current text insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the button.
	 * @see UI.Button#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/GLView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/GLView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/GLView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/GLView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var GLView = exports.GLView = AbstractView.subclass(
/** @lends UI.GLView.prototype */
{
	'type':'glview',
	/**
	 * @class The `UI.GLView` class provides applications with access to OpenGL. Before an
	 * application instantiates objects in the `{@link GL2}` module, it must do the following:
	 *
	 * 1. Instantiate a `UI.GLView` object.
	 * 2. Call the `setFrame()` method, inherited from `{@link UI.AbstractView}`, to set the view's
	 * frame. You will normally set the frame so that it encompasses the device's entire screen.
	 * **Note**: When calling `{@link UI.AbstractView#setFrame}` on a `UI.GLView` object, you must
	 * set the `x` and `y` parameters to `0`. Using other values will result in undefined behavior.
	 * 3. Call the `setOnLoad()` method, inherited from `{@link UI.Element}`, to define a callback
	 * function that will run after the `UI.GLView` object has loaded. **Important**: You must wait
	 * for the callback to run before you add `GL2` objects to the OpenGL view.
	 * 4. Set the `active` property of the `UI.GLView` object to `true`.
	 * @name UI.GLView
	 * @augments UI.AbstractView	
 	 * @example
	 * // Create a new UI.GLView object without setting any of its properties,
	 * // then prepare the object for use.
	 * var glView = new UI.GLView();
     * glView.setFrame(0, 0, Device.LayoutEmitter.getWidth(),
	 *   Device.LayoutEmitter.getHeight());
	 * glView.setOnLoad(function() {
	 *     // Add code to create GL2 objects and add them as children of the
	 *     // GL2.Root singleton.
	 * });
	 * glView.setActive(true);
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.GLView` object.
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (GLView._init) GLView._init();
		$super(properties);
	}
});

GLView._init = function() {
	delete GLView._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * Set the value of the `active` property, which indicates whether the `UI.GLView` will be
	 * displayed.
	 * @name UI.GLView#setActive
	 * @function
	 * @example
	 * var glView = new UI.GLView();
     * glView.setFrame(0, 0, Device.LayoutEmitter.getWidth(),
	 *   Device.LayoutEmitter.getHeight());
 	 * glView.setOnLoad(function() {
	 *     // Add code to create GL2 objects and add them as children of the
	 *     // GL2.Root singleton.
	 * });
	 * glView.setActive(true);
	 * @param {Boolean} active Set to `true` if the `UI.GLView` object is active.
	 * @returns {void}
	 * @see UI.GLView#getActive
	 * @status iOS, Flash, Test
	 */
	/**
	 * Retrieve the value of the `active` property, which indicates whether the `UI.GLView` will be
	 * displayed.
	 * @name UI.GLView#getActive
	 * @function
	 * @returns {Boolean} Set to `true` if the `UI.GLView` object is active.
	 * @see UI.GLView#setActive
	 * @status iOS, Android, Flash, Test
	 */
	GLView.synthesizeProperty('active', Commands.setActive);
	
	/**
	 * Retrieve an array that lists all of the OpenGL extensions that are supported in the current
	 * view. You can use this information to control how your application displays content. For
	 * example, some Android devices do not include hardware extensions for certain texture-mapping
	 * effects. This can result in low frame rates when an application requires these effects. On
	 * devices that lack the extensions, you could improve the application's frame rate by turning
	 * off the effect and displaying a different set of textures that simulates the effect. 
	 * 
	 * For more information about OpenGL extensions, see the
	 * [OpenGL website](http://www.opengl.org/resources/features/OGLextensions/).
	 * 
	 * **Note**: The return value of this method may be incorrect if the view is not active.
	 * @name UI.GLView#getOGLExtensions
	 * @returns {String[]} An array of OpenGL extensions that the device supports.
	 * @status Android
	 * @function
	 */
	GLView.registerAccessors('OGLExtensions', function() {return this['_OGLExtensions'];}, function() {} );
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NavController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NavController'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NavController'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/NavController.js';

var MessageListener = require("NGCore/Client/Core/MessageListener").MessageListener;
var KeyEmitter = require("NGCore/Client/Device/KeyEmitter").KeyEmitter;
var Window = require("NGCore/Client/UI/Window").Window;
var Capabilities = require("NGCore/Client/Core/Capabilities").Capabilities;
var Element = require("NGCore/Client/UI/Element").Element;
var View = require("NGCore/Client/UI/View").View;
var Commands = require("NGCore/Client/UI/Commands").Commands;

var NavKeyListener = MessageListener.subclass({
	classname: "UI_NavController_KeyListener"
});

var NavController = exports.NavController = View.subclass(
/** @lends UI.NavController.prototype */
{
	/**
	 * @class The `UI.NavController` class enables your application to navigate between multiple
	 * views in a navigation stack.
	 * @name UI.NavController
	 * @constructs Create a navigation controller.
	 * @augments UI.View
	 * @example
	 * // Create a new UI.NavController object without setting any of its properties.
	 * var navController = new UI.NavController();
	 * @example
	 * // Create a new UI.NavController object, setting its view frame to the entire screen.
	 * var navController = new UI.NavController({
	 *     frame: UI.Window.getFrame()
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new 
	 *		`UI.NavController` object. See `{@link UI.AbstractView}` for information about the
	 *		properties that are supported.
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (NavController._init) NavController._init();
		
	    this.navStack = [];
		var onAndroid = Capabilities.getPlatformOS() == 'Android';
	    this._useBackButton = !onAndroid;
	
		this.keyListener = new NavKeyListener();
		KeyEmitter.addListener(this.keyListener, this.onKeyPressed.bind(this));
		$super(properties);
	},
	
	/**
	 * Display a Back button on the screen. Applications that will run on iOS should always provide
	 * an on-screen Back button and call `{@link UI.NavController#back}` when it is pressed. On
	 * Android devices, which have a hardware Back button, this method has no effect.
	 * @function
	 * @example
	 * var navController = new UI.NavController();
	 * navController.setUseBackButton(true);
	 * @param {Boolean} toUse Set to `true` to enable the on-screen Back button.
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	setUseBackButton: function(toUse) {
		this._useBackButton = toUse;
		if (toUse) {
			this._createBackButton();
		} else if (this.backButton) {
			this.backButton.removeFromParent();
		}
	},
    
	// don't document the unused fromButton parameter, per jyopp
	/**
	 * Reset the navigation stack, removing all views from the stack.
	 * @name UI.NavController#clear
	 * @function
	 * @example
	 * var navController = new UI.NavController();
	 * var page = new UI.View();
	 * navController.forwardToView(page);
	 * // When the application is finished with the navigation stack:
	 * navController.clear();
	 * @returns {Object[]} The views that were removed, or an empty array if no views were removed.
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	
	clear: function(fromButton) {
		return this.backToView(undefined);
	},
	
	/**
	 * Retrieve the top view from the navigation stack.
	 * @returns {Object} The top view in the navigation stack, or `undefined` if the navigation
	 *		stack does not contain any views.
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 * @since 1.0
	 */
	getTopView: function() {
		return (this.navStack.length > 0) ? this.navStack[ (this.navStack.length - 1) ] : undefined;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	navStackDepth: function() {
		return this.navStack.length;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	depthOfView: function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){return -1;}
		
		return this.navStack.length - targetIndex - 1;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	viewAtDepth: function(targetDepth) {
		if(targetDepth >= this.navStack.length){
			return null;
		}
		return this.navStack[this.navStack.length - targetDepth - 1];
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	removeDeepView:function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){
			NgLogE("NavController: trying to remove a nonexistent view from the nav stack!");
			return;
		}
		this.navStack.splice(targetIndex,1);
	},
    
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 * @since 1.0
	 */
	_viewTransition: function(fromView, toView, back) {
		//The views transition within the container (which is 'this')
		var myFrame = this.getFrame();
		var w = myFrame[2];
		var h = myFrame[3];
		
		//TODO: animate this (below) transition.
		if (toView) {
			toView.setFrame( (back ? -w : w), 0, w, h);
			this.addChild(toView);
		}
		
		Commands.animate(function() {
			if (fromView) fromView.setFrame( (back ? w : -w), 0, w, h);
			if (toView) toView.setFrame(0, 0, w, h);
		}, 400, function() {
			if (fromView) fromView.removeFromParent();
		});
		
		this._createBackButton();
	},

	// don't document the unused fromButton parameter
	/**
	 * Add the specified view to the navigation stack, and move forward to the view.
	 * @name UI.NavController#forwardToView
	 * @function
	 * @example
	 * var navController = new UI.NavController();
	 * var page = new UI.View();
	 * navController.forwardToView(page);
	 * @param {Object} destView The view to display.
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#backToView
	 * @since 1.0
	 */
	
	forwardToView: function(destView, fromButton) {
		var currentView = this.getTopView();
		if (destView && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPush == "function" 
					&& this._delegate.navControllerShouldPush(this,destView))
			)) {
			
			destView.performEventCallback({eventType:"push",navController:this});
			
			this.navStack.push(destView);
			this._viewTransition(currentView, destView, false, fromButton);
		}
	},
    
	/**
	 * Go back to the previous view.
	 * @returns {Object} The view that was removed, or `null` if no view was removed.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forward	
	 * @since 1.0
	 */
	back: function() {
		var removed = this.navStack.pop();
		
		if (removed && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPop == "function" 
					&& this._delegate.navControllerShouldPop(this,removed))
			)) {
			removed.performEventCallback({eventType:"pop",navController:this});
		} else {
			return null;
		}
		this._viewTransition(removed, this.getTopView(), true);
		return removed;
	},

	// don't document the unused fromButton parameter
	/**
	 * Navigate back to the specified view, returning any views that were removed from the
	 * navigation stack in the order they were removed.
	 * @name UI.NavController#backToView
	 * @function
	 * @example
	 * var navController = new UI.NavController();
	 * var page1 = new UI.View(),
	 *     page2 = new UI.View(),
	 *     page3 = new UI.View();
	 * navController.forwardToView(page1);
	 * navController.forwardToView(page2);
	 * navController.forwardToView(page3);
	 * // removedViews will contain page3, followed by page2
	 * var removedViews = navController.backToView(page1);
	 * @param {Object} destView The view to display.
	 * @returns {Object[]} The views that were removed, or an empty array if no views were removed.
	 * @see UI.NavController#forwardToView
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */

	backToView: function(destView, fromButton) {
		var removedSet = [];
		var removed = this.navStack.pop();
		var originalView = removed;
		if (removed) {
			do {
				if (removed && 
					(!this._delegate 
						|| (this._delegate 
							&& typeof this._delegate.navControllerShouldPop == "function" 
							&& this._delegate.navControllerShouldPop(this,removed))
					)) {
					removedSet.push(removed);
					removed.performEventCallback({eventType:"pop",navController:this});
				}
				else {
					//There was nothing to remove, or the this._delegate said "don't remove".
					break;
				}
				
				if (this.getTopView() == destView){break;}
			} while ((removed = this.navStack.pop()));
		}
		if(removedSet.length > 0) {
			this._viewTransition(originalView, this.getTopView(), true, fromButton);
		}
		return removedSet;
	},

	/**
	 * Set the navigation controller to launch the application when activated.
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */    
	loadApp: function() {		
	},
    
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */    
	onBackPressed: function() {
		if (this.navStack.length > 1) {
		//	NgLogD("Handle back on nav stack. Number of views on stack=" + this.navStack.length);
			this.back();
			return true;
		}
		return false;
	},
	
	onKeyPressed: function(event) {
		if ((event.code === KeyEmitter.Keycode.back) && (this.navStack.length > 1)) {
			this.back();
			return true;
		}
		return false;
	},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 */
	_delegate:null,
	/**
	 * @description Set subscribers to the `NavController` behavior. Subscribers can modify what happens. 
	 * NavControllerDelegateProtocol:
	 *	@optional - (BOOL)navControllerShouldPop(NavController,View)
	 *	@optional - (BOOL)navControllerShouldPush(NavController,View)
	 * @param {String} navDelegate A `NavController` subscriber.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setDelegate:function( /*NavControllerDelegate*/ navDelegate){
		this._delegate = navDelegate;
	},
	
	delegate:function(){return this._delegate;},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 * @since 1.0
	 */
	_createBackButton: function() {
		// Do nothing if this device does not require_ an onscreen button.
		if (!this._useBackButton) return;
		
		if (!this.backButton) {
			this.backButton = new UI.Button({
				normalText: 'Back',
				textSize: 13.0,
				normalTextColor: "FF",
				normalTextShadow: "00 1.5 {0,-1}",
				frame: [-2, 20, Window.outerWidth / 5, Window.outerHeight / 12],
				normalGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerShadow: "99FF 2.0 {0,-1}",
					gradient: [
						"FFCC 0.0",
						"FF80 1.0"
					]
				},
				highlightedGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerLine: "FF00 15 {0,-1}",
					gradient: [
						"FF50 0.0",
						"FF80 1.0"
					]
				}
			});
			this.backButton.onclick = this.bind(this.onBackPressed);
		}
		
		if (this.navStack.length > 1) {
			if (!this.backButton.getParent()) Window.document.addChild(this.backButton);
		} else if ( this.backButton.getParent() ) {
			this.backButton.removeFromParent();
		}
	}
});

NavController._init = function() {
	delete NavController._init;
	if (View._init) View._init();
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WebView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/WebView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var WebView = exports.WebView = AbstractView.subclass(
/** @lends UI.WebView.prototype */
{
	'type':'webview',

	/**
	 * @class The `UI.WebView` class provides web views for loading HTML documents, either from
	 * local files or from remote servers. It also provides methods for navigating back and forward
	 * in the web view's history.
	 * 
	 * On Android devices, email addresses and telephone numbers in a web view are automatically
	 * turned into active links. Web addresses in a web view are not autodetected.
	 * 
	 * On iOS devices, by default, web addresses in a web view are automatically turned into active 
	 * links. You can use the `{@link UI.WebView#setAutodetection}` method to control this behavior. 
	 * Email addresses and phone numbers are not autodetected.
	 *
	 * **Note**: If your app uses the `UI.WebView` class to display a web-based game, avoid adding
	 * listeners to the `{@link Core.UpdateEmitter}` class when possible. Attaching a listener to
	 * `Core.UpdateEmitter` can limit the performance of web-based games.
	 * @name UI.WebView
	 * @constructs Create a web view.
	 * @augments UI.AbstractView
	 * @param {Object} [properties] An object whose properties will be added to the new `UI.WebView`
	 *		object.
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (WebView._init) WebView._init();
		this._canGoBack = false;
		this._canGoForward = false;
		return $super(properties);
	},
	
	/** @private */
	_onShouldLoad: function(event) {
		NgLogD("Should Load " + event.url + " ???????");
		var fn = this.getOnShouldload();
		if (typeof fn == 'function') {
			// If we SHOULDN'T load the url, bail.
			if (!Boolean(fn.call(this, event))) return;
		}
		// The default (if the function was missing or not a function) is to load the url.
		this.loadUrl(event.url);
	},
	
	/** @private */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'shouldload') {
				// We need to call the onShouldLoad function in a way that captures the return value.
				this._onShouldLoad(event);
				return;
			}
			if (event.eventType == 'pageload') {
				// Do not touch this parsing code. Everything else is wrong, extensive testing was done.
				this._canGoBack = event.canGoBack = Boolean(JSON.parse(event.canGoBack));
				this._canGoForward = event.canGoForward = Boolean(JSON.parse(event.canGoForward));
			}
			$super(event);
		} catch(e) {
			NgHandleException(e);
		}
	},
	// invoke doesn't return a value. to get response, use onpageevent
	/**
	 * Execute the JavaScript code specified in the `script` parameter. To return a value, your code
	 * must do the following:
	 *
	 * 1. Convert the return value to a string.
	 * 2. Turn the string into a URL by adding `ngcore://` to the beginning of the string.
	 * 3. Attempt to load the `ngcore://` URL. This fires a `pageevent` event, and the return value
	 * is passed to the callback function that was set through
	 * `{@link UI.WebView#event:setOnPageevent}`.
	 * @function
	 * @example
	 * // Log the text "Hello World" to the console.
	 * var js = "var message = 'Hello World'; " + 
	 *     "window.location.href = 'ngcore://' + message;";
	 * var webView = new UI.WebView();
	 * webView.setOnPageevent(function(event) {
	 *     console.log(event.eventStream);
	 * });
	 * webView.invoke(js);
	 * @param {String} script The JavaScript code to execute.
	 * @returns {void}
 	 * @see UI.WebView#event:setOnPageevent
	 * @status iOS, Android, Flash
	 */
	invoke: Commands.invoke,
	/**
	 * Request a file from the specified URL using the HTTP `GET` method. You can specify an
	 * `http://` or `https://` URL.
	 * @example
	 * // Load a webpage from a remote server.
	 * var webView = new UI.WebView();
	 * webView.loadUrl("http://www.example.com/testpage/");
	 * @param {String} url The URL to request.
	 * @param {String} [headers] A JSON object containing key-value pairs to include in the HTTP 
	 *		request headers. Supported only on iOS.
	 * @param {Number} [timeout] The timeout length for the request, in seconds.
	 * @returns {void}
 	 * @see UI.WebView#loadDocument
	 * @see UI.WebView#postUrl
	 * @status iOS, Android, Flash, Test, FlashTested
	 * @since 1.0
	 */
	loadUrl: function(url, headers, timeout) {
		Commands.loadURL.call(this, url, headers || null, +(timeout || 0));
	},
	/**
	 * Load a document from the specified local path.
	 * @example
	 * // Load a local file.
	 * var webView = new UI.WebView();
	 * webView.loadDocument("./html/page.html");
	 * @param {String} relativePath The local path from which to load a document.
	 * @returns {void}
	 * @see UI.WebView#loadUrl
	 * @see UI.WebView#postUrl
	 * @status iOS, Android, Flash, Test, FlashTested
	 * @since 1.0
	 */
	loadDocument: Commands.setSourceDocument,
	/**
	 * Post data to the specified URL using the HTTP `POST` method.
	 * @example
	 * // Post data using a string that contains the raw body of the `POST` request.
	 * var webView = new UI.WebView();
	 * var postData = "catalog=Fall;retrieve=titles";
	 * webView.postUrl("http://www.example.com/getCatalogInfo", postData);
	 * @example
	 * // Post data using an object that contains key-value pairs.
	 * var webView = new UI.WebView();
	 * var postData = {
	 *     catalog: "Fall",
	 *     retrieve: "titles"
	 * };
	 * webView.postUrl("http://www.example.com/getCatalogInfo", postData);
	 * @param {String} url The URL that will be used to post data.
	 * @param {String|Object} data A string that contains the raw body of the `POST` request, or an
	 *		object whose properties will be converted into key-value pairs for the request, using
	 *		`www/form-data` encoding.
	 * @see UI.WebView#loadUrl
	 * @see UI.WebView#loadDocument
	 * @returns {void}
	 * @status iOS, Android
	 * @since 1.0
	 */
	postUrl: function(url, data){
		var dataStr;
		if(typeof data == "object"){
			var params = [];
			for(var key in data){
				params.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
			}
			dataStr = params.join('&');
		}else{
			dataStr = data;
		}
		Commands.postURL.call(this, url, dataStr);
	},
	/**
     * Stop loading a document. 
	 * @function
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	stopLoading: Commands.stopLoading,
	/**
	 * Reload a document that was requested with `{@link UI.WebView#loadDocument}` or
	 * `{@link UI.WebView#loadUrl}`.
	 * @function
	 * @returns {void}
	 * @see UI.WebView#loadDocument
	 * @see UI.WebView#loadUrl
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	reload: Commands.reload,
	/**
	 * Go back one page in the web view's history.
	 * @function
	 * @returns {void}
	 * @see UI.WebView#goForward
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	goBack: Commands.goBack,
	/**
	 * Go forward one page in the web view's history.
	 * @function
	 * @returns {void}
	 * @see UI.WebView#goBack
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	goForward: Commands.goForward,
	/**
	 * Determine whether the web view can go back a page in the web view's history.
	 * @returns {Boolean} Set to `true` if the web view can go back a page in the web view's
	 *		history.
	 * @see UI.WebView#canGoForward
	 * @status iOS, Flash, Test, FlashTested
	 * @since 1.0
	 */
	canGoBack: function(){
		return this._canGoBack;
	},
	/**
	 * Determine whether the web view can go forward a page in the web view's history.
	 * @returns {Boolean} Set to `true` if the web view can go forward a page in the web view's
	 *		history.
	 * @see UI.WebView#canGoBack
	 * @status iOS, Flash, Test, FlashTested
	 * @since 1.0
	 */
	canGoForward: function(){
		return this._canGoForward;
	},
	/**
	 * Set the authentication credentials for this web view, including the username, the password,
	 * the authentication host, and the security realm. This method supports HTTP Basic Access
	 * Authentication.
	 *
	 * For more information about using the `host` and `realm` parameters, see
	 * [RFC 2617](http://www.ietf.org/rfc/rfc2617.txt), which provides the specification for Basic
	 * Access Authentication.
	 * @param {String} host The authentication host.
	 * @param {String} realm The security realm.
	 * @param {String} username The username for the session.
	 * @param {String} password The password for the session.
	 * @returns {void}
	 * @status iOS, Android
	 * @since 1.0
	 */
	setBasicAuthCredential: function(host, realm, username, password){
		Commands.setBasicAuthCredentials.call(this, {'host':host, 'realm':realm, 'username':username, 'password':password});
	},
    /**
     * Set whether the web view should honor an HTML document's `viewport` meta tags. These meta
 	 * tags are honored by default.
	 *
	 * For example, if this property is set to `true`, the following meta tags would cause the page
	 * content to be scaled to fill the viewport:
	 *
     *     <meta name="viewport" content="initial-scale=1.0" />
     *     <meta name="viewport" content="user-scalable=false" />
     * @param {Boolean} enabled Set to `true` if the web view should honor the page's `viewport`
	 *		meta tags.
     * @returns {void}
     * @since 1.4.1
     */
	setViewportEnabled: Commands.setViewportEnabled,

	/**
	 * Set whether to autodetect phone numbers in this web view. By default, phone numbers are not
	 * autodetected. Call this method before calling `{@link UI.WebView#loadDocument}` or
	 * `{@link UI.WebView#loadUrl}`. Supported only on iOS.
	 * @param {UI.Commands#Autodetect} type Set to `UI.Commands.Autodetect.Phone` to enable
	 *		autodetection of phone numbers.
	 * @returns {void}
	 * @see UI.WebView#loadDocument
	 * @see UI.WebView#loadUrl
	 * @status iOS
	 * @since 1.4.1
	 */
	setAutodetection: function(type) {
		Commands.setAutodetection.call(this, type);
	}
});

WebView._init = function() {
	delete WebView._init;
	if (AbstractView._init) AbstractView._init();
	
	WebView.synthesizeProperty('scrollable', Commands.setScrollable);
	WebView.synthesizeProperty('pluginsEnabled', Commands.setPluginsEnabled);
	
	/**
	 * Set a function to call when a `startload` event occurs. This event occurs when a document
	 * starts loading.
	 * @name UI.WebView#setOnStartload
	 * @event
	 * @example
	 * var webView = new UI.WebView();
	 * webView.setOnStartload(function(event) {
	 *     console.log("Started loading the following URL: " + event.url);
	 * });
	 * @cb {Function} startloadCallback The function to call when a `startload` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.url The URL of the page being loaded.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.WebView#event:getOnStartload
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the function to call when a `startload` event occurs.
	 * @name UI.WebView#getOnStartload
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnStartload
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	WebView.registerEventType('startload');
	/**
	 * Set a function to call when a `pageload` event occurs. This event occurs when a document
	 * finishes loading.
	 * @name UI.WebView#setOnPageload
	 * @event
	 * @example
	 * var backOK = false;
	 * var forwardOK = false;
	 * var webView = new UI.WebView();
	 * webView.setOnPageload(function(event) {
	 *     console.log("Finished loading the following URL: " + event.url);
	 *     backOK = event.canGoBack;
	 *     forwardOK = event.canGoForward;
	 * });
	 * @cb {Function} pageloadCallback The function to call when a `pageload` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {Boolean} event.canGoBack Set to `true` if the web view can go back a page in the
	 *		web view's history.
	 * @cb-param {Boolean} event.canGoForward Set to `true` if the web view can go forward a page in
	 *		the web view's history.
	 * @cb-param {String} event.url The URL of the page that loaded.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.WebView#event:getOnPageload
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the function to call when a `pageload` event occurs.
	 * @name UI.WebView#getOnPageload
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageload
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	WebView.registerEventType('pageload');
	/**
	 * Set a function to call when an `error` event occurs. This event occurs when a document cannot
	 * be loaded.
	 * @name UI.WebView#setOnError
	 * @event
	 * @example
	 * var webView = new UI.WebView();
	 * webView.setOnError(function(error) {
	 *     console.log("The document could not be loaded: " + event.code + ": " +
	 *         event.description);
	 * });
	 * @cb {Function} errorCallback The function to call when an `error` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {Number} event.code The HTTP error code for the error.
	 * @cb-param {String} [event.description] A description of the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.WebView#event:getOnError
	 * @status iOS, Android
	 */
	/**
	 * Retrieve the function to call when an `error` event occurs.
	 * @name UI.WebView#getOnError
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnError
	 * @status iOS, Android
	 */
	WebView.registerEventType('error');
	/**
	 * Set a function to call when a `pageevent` event occurs. This event occurs when the
	 * application executes JavaScript code by calling `{@link UI.WebView#invoke}`, and the
	 * JavaScript code attempts to load a URL that begins with `ngcore://`. The text of the URL,
	 * excluding the `ngcore://` prefix, is passed to the callback function.
	 * @name UI.WebView#setOnPageevent
	 * @event
	 * @cb {Function} pageeventCallback The function to call when a `pageevent` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.eventStream The text of the URL, excluding the `ngcore://` prefix.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.WebView#event:getOnPageevent
	 * @status iOS, Android, Flash
	 */
	/**
	 * Retrieve the function to call when a `pageevent` event occurs.
	 * @name UI.WebView#getOnPageevent
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageevent
	 * @status iOS, Android, Flash
	 */
	WebView.registerEventType('pageevent');	
	/**
	 * Set a function to call when a `shouldload` event occurs. When a callback function is
	 * specified, a `shouldload` event occurs each time a document is requested via the HTTP `GET`
	 * method. The callback function returns a boolean to indicate whether the URL should be loaded.
	 * @name UI.WebView#setOnShouldload
	 * @event
	 * @example
	 * // Only load http:// and https:// links. Ignore other types of links, such
	 * // as links that will open external applications.
	 * var webView = new UI.WebView();
	 * webView.setOnShouldload(function(event) {
	 *     if (event.url.match(/^http[s?]:\/\//)) {
	 *         return true;
	 *     } else {
	 *         console.log("Attempted to load the external link " + event.url);
	 *         return false;
	 *     }
	 * });
	 * @cb {function} shouldloadCallback The function to call when a `shouldload` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.navigation The type of navigation event that occurred. Contains one
	 *		of the following values:
	 * 
	 * + `click`: The user clicked a link.
	 * + `other`: The user performed an unspecified action.
	 * + `reload`: The user reloaded the page.
	 * + `resubmit`: The user resubmitted a form.
	 * + `submit`: The user submitted a form.
	 * @cb-param {String} event.url The URL to be loaded.
	 * @cb-returns {Boolean} Set to `true` if the document should be loaded.
	 * @see UI.WebView#event:getOnShouldload
	 * @returns {void}
	 */
	/**
	 * Retrieve the function to call when a `shouldload` event occurs.
	 * @name UI.WebView#getOnShouldload
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnShouldload
	 * @event
	 */
	WebView.registerEventType('shouldload');
	
	/**
	 * Set a function to call when an `externalLink` event occurs, indicating that a link will be
	 * opened in an external application.
	 * @name UI.WebView#setOnExternalLink
	 * @event
	 * @example
	 * var webView = new UI.WebView();
	 * webView.setOnExternalLink(function(event) {
	 *     console.log("Opened the external link " + event.url);
	 * });
	 * @cb {function} externalLinkCallback The function to call when an `externalLink` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.url The URL to be loaded.
	 * @cb-returns {Boolean} Set to `true` if the URL should be opened.
	 * @returns {void}
	 * @see UI.WebView#event:getOnExternalLink
	 */
	/**
	 * Retrieve the function to call when an `externalLink` event occurs.
	 * @name UI.WebView#getOnExternalLink
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnExternalLink
	 */
	WebView.registerEventType('externalLink');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ScrollView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ScrollView.js';

var View = require('NGCore/Client/UI/View').View;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ScrollView = exports.ScrollView = View.subclass(
/** @lends UI.ScrollView.prototype */
{
	'type':'scrollview',
	/**
	 * @class The `UI.ScrollView` class constructs objects that handle views in a small scroll area.
	 * A scroll area can be scrolled horizontally, vertically, or in both directions. Android
	 * devices can scroll in only one direction at a time.
	 *
	 * If you need to create a scrolling list that uses a table-like layout, or that contains a
	 * large number of very similar views, consider using the `{@link UI.ListView}` class instead of
	 * `UI.ScrollView`.
	 * @name UI.ScrollView
	 * @constructs Create a scroll area.
	 * @augments UI.View
	 * @example
	 * // Create a new UI.ScrollView object without setting any of its properties.
	 * var scrollArea = new UI.ScrollView();
	 * @example
	 * // Create a new UI.ScrollView object, and hide its scrollbars.
	 * var scrollArea = new UI.ScrollView({
	 *     scrollIndicatorsVisible: false
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.ScrollView` object.
	 * @see UI.ListView
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (ScrollView._init) ScrollView._init();
		this._scrollPosition = [0, 0];
		return $super(properties);
	},
	
	/**
	 * @private
	 */    
	updateScrollPosition: function(newVal) {
		this._scrollPosition = newVal;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'scroll') this.updateScrollPosition(e.scrollPosition);
		$super(e);
	},

	getFrameOffset: function() {
		var frame = this._frame;
		if (frame) {
			return [-this._scrollPosition[0], -this._scrollPosition[1]];
		} else {
			return undefined;
		}
	}
});

// Properties
ScrollView._init = function() {
	delete ScrollView._init;
	if (View._init) View._init();

	/**
	 * Set the `contentSize` property, which defines the scroll area's width and height in pixels.
	 * @name UI.ScrollView#setContentSize
	 * @function
	 * @example
	 * var width = Device.LayoutEmitter.getWidth();
	 * var scrollArea = new UI.ScrollView();
	 * scrollArea.setContentSize([width / 2, 200]);
	 * @param {Number[]|Number} w An array of two integers, where the first item contains the scroll
	 *		area's width in pixels and the second item contains the scroll area's height in pixels;
	 *		or a number representing the width, in pixels, of the scroll area.
	 * @param {Number} [h] A number representing the height, in pixels, of the scroll area. If
	 *		the `w` parameter contains an array, do not use the `h` parameter.
	 * @returns {void}
 	 * @see UI.ScrollView#getContentSize
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `contentSize` property, which defines the scroll area's width and
	 * height in pixels.
	 * @name UI.ScrollView#getContentSize
	 * @function
	 * @returns {Number[]} An array of two integers, where the first item contains the scroll area's
	 *		width in pixels and the second item contains the scroll area's height in pixels.
	 * @see UI.ScrollView#setContentSize
	 * @status iOS, Android, Flash, Test
	 */
	ScrollView.synthesizeCompoundProperty('contentSize', Commands.setScrollableSize);
	/**
	 * Set the `scrollPosition` property, which indicates where the scrollbar should be positioned
	 * and, as a result, what part of the scroll area should be displayed. This property contains
	 * two integers, which indicate the positions, in pixels, of the horizontal and vertical
	 * scrollbars.
	 * @name UI.ScrollView#setScrollPosition
	 * @function
	 * @example
	 * // Scroll to the origin of the scroll area.
	 * var scrollArea = new UI.ScrollView();
	 * scrollArea.setScrollPosition([0, 0]);
	 * @param {Number[]|Number} x An array of two integers, where the first item contains the 
	 *		position of the horizontal scrollbar, in pixels, and the second item contains the 
	 *		position of the vertical scrollbar, in pixels; or a single integer representing the 
	 *		position of the horizontal scrollbar, in pixels.
	 * @param {Number} [y] An integer representing the position of the vertical scrollbar, in
	 *		pixels. If the `x` parameter contains an array, do not use the `y` parameter.
	 * @see UI.ScrollView#getScrollPosition
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `scrollPosition` property, which indicates where the scrollbar
	 * should be positioned and, as a result, what part of the scroll area should be displayed.
	 *
	 * **Note**: The `scrollPosition` property is not updated when the user scrolls the view. See
	 * `{@link UI.ScrollView#event:setOnScroll}` for information about how to monitor the current
	 * position of the scroll area. If the application has not called
	 * `{@link UI.ScrollView#setScrollPosition}`, this method will return the value `[0, 0]`,
	 * regardless of whether the view has been scrolled.
	 * @name UI.ScrollView#getScrollPosition
	 * @function
	 * @returns {Number[]} An array of two integers, where the first item contains the position of the
	 *		horizontal scrollbar, in pixels, and the second item contains the position of the
	 *		vertical scrollbar, in pixels.
	 * @see UI.ScrollView#setScrollPosition
	 * @status iOS, Android, Flash, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollPosition', Commands.setScrollPosition);
	
	/**
	 * Set the `scrollIndicatorsVisible` property, which indicates whether the scroll area's 
	 * scrollbars should be visible.
	 * @name UI.ScrollView#setScrollIndicatorsVisible
	 * @function
	 * @example
	 * // Hide the scroll area's scrollbars.
	 * var scrollArea = new UI.ScrollView();
	 * scrollArea.setScrollIndicatorsVisible(false);
	 * @param {Boolean} enabled Set to `true` if the scroll area's scrollbars should be visible.
	 * @returns {void}
	 * @see UI.ScrollView#getScrollIndicatorsVisible
	 * @status iOS, Android, Test
	 */
	/**
	 * Retrieve the value of the `scrollIndicatorsVisible` property, which indicates whether the
	 * scroll area's scrollbars should be visible.
	 * @name UI.ScrollView#getScrollIndicatorsVisible
	 * @function
	 * @returns {Boolean} Set to `true` if the scroll area's scrollbars should be visible.
	 * @see UI.ScrollView#setScrollIndicatorsVisible
	 * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollIndicatorsVisible', Commands.setScrollIndicatorsVisible);
	
	View.synthesizeProperty('visibleInOrientations', Commands.setVisibleInOrientations);

	/**
	 * Set a function to call when a `scroll` event occurs. This event occurs when the user scrolls
	 * the scroll area.
	 * @name UI.ScrollView#setOnScroll
	 * @event
	 * @example
	 * var scrollArea = new UI.ScrollView();
	 * scrollArea.setOnScroll(function(event) {
	 *     console.log("X position: " + event.scrollPosition[0] +
	 *         ", Y position:" + event.scrollPosition[1]);
	 * });
	 * @cb {Function} scrollCallback The function to call when a `scroll` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {Number[]} event.scrollPosition An array of two integers, where the first item
	 *		represents the number of pixels by which the scroll area has been scrolled along the X
	 *		axis and the second item represents the number of pixels by which the scroll area has
	 *		been scrolled along the Y axis.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.ScrollView#event:getOnScroll
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the function to call when a `scroll` event occurs.
	 * @name UI.ScrollView#getOnScroll
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.ScrollView#event:setOnScroll
	 * @status iOS, Android, Flash, Test
	 */
	ScrollView.registerEventType('scroll');
	
	ScrollView.registerEventType('scrollEnded');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ListView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ListView = exports.ListView = ScrollView.subclass(
/** @lends UI.ListView.prototype */
{
	'type':'listview',
	/**
	 * @class The `UI.ListView` class creates scrolling lists in an application. A `UI.ListView`
	 * object can contain one or more sections, which are represented by `UI.ListViewSection` 
	 * objects. In turn, each section can contain one or more items, which are represented by
	 * `UI.ListViewItem` objects.
	 *
	 * To improve performance for long lists, `UI.ListView` objects use a pool of reusable views.
	 * When a list item scrolls off the top or bottom of the screen, its view is added to the view
	 * pool. See `{@link UI.ListViewItem}` for more information about managing view pools.
	 *
	 * In a typical list, most or all of the list items' views are displayed with the same general 
	 * appearance. When a list item's view is given a unique appearance--for example, if it is
	 * highlighted with a unique background color--its appearance must be reset when it scrolls off
	 * screen. If the appearance is not reset, the view's unique appearance will persist when the
	 * view is recycled. See `{@link UI.ListViewItem}` for more information.
	 * 
	 * Use this class for scrolling lists that use a table-like layout, or that contain a large
	 * number of very similar views.  For other types of scrolling lists, use the
	 * `{@link UI.ScrollView}` class instead.
	 *
	 * **Note**: Destroying a `UI.ListView` object also destroys all of the
	 * `{@link UI.ListViewItem}` objects that are associated with the scrolling list.
	 * @name UI.ListView
	 * @constructs Create a list view.
	 * @augments UI.ScrollView
	 * @example
	 * // Create a new UI.ListView object without setting any of its properties.
	 * var listView = new UI.ListView();
	 * @example
	 * // Create a new UI.ListView object, setting its header.
	 * var listHeader = "Latest News";
	 * var listView = new UI.ListView({
	 *     header: listHeader
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.ListView` object.
	 * @see UI.ListViewItem
	 * @see UI.ListViewSection
	 * @see UI.ScrollView
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize:function($super, properties) {
		if (ListView._init) ListView._init();
		$super(properties);
		
		this._sections = [];
		this._scrollPosition = [0,0];
		this.enableEvent('scroll', true);
		
		this._ownedViews = [];
		this._queuedViews = {};
		
		this._cellDivider = 0;
		
		return this;
	},
	
	destroy: function($super) {
		var l = this._ownedViews.length;
		for (var i = 0; i < l; i++) {
			this._ownedViews[i].release();
		}
		this._ownedViews = null;
		$super();
	},
	
	addChild: function($super, child, index) {
		if (index == "cell") {
			index = this._cellDivider++;
		} else if ((index || -1) >= 0) {
			index += this._cellDivider;
		}
		$super(child, index);
	},
	
	_viewForItem: function(lvItem) {
		if (lvItem._currentView instanceof AbstractView) return lvItem._currentView;
		
		var rID = lvItem._reuseId;
		var queue = this._queuedViews[rID];
		
		var view = null;
		while (queue && queue.length > 0) {
			if ((view = queue.pop()) instanceof AbstractView) break;
		}
		
		if (!(view instanceof AbstractView)) {
			view = lvItem._onCreateView(lvItem);
			if (view instanceof AbstractView) {
				this._ownedViews.push(view.retain());
				this.addChild(view, "cell");
			} else {
				console.log("Error creating view for list item with reuse id " + rID);
			}
		}
	//	console.log("_viewForItem: " + lvItem + " = " + view);
		return view;
	},
	
	_queueViewForItem: function(lvItem) {
		if(!lvItem){
			NgLogE("ListView::_queueViewForItem called with undefined item");
			return;
		}
		var viewToQueue = lvItem._currentView;
		if (viewToQueue instanceof AbstractView) {
			var rId = lvItem._reuseId;
			var queue = this._queuedViews[rId] || (this._queuedViews[rId] = []);
			queue.push(viewToQueue);
		}
		lvItem._setCurrentView();
	},
	
	_removeQueuedViews: function() {
		for (var q in this._queuedViews) {
			if (!this._queuedViews.hasOwnProperty(q)) continue;
			
			q = this._queuedViews[q];
			for (var i = 0, l = q.length; i < l; i++) {
				q[i].removeFromParent();
			}
		}
		this._cellDivider = 0;
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	flushSections: function() {
		for (var i in this._sections) {
			if(!this._sections.hasOwnProperty(i)) { continue; }
				
			var section = this._sections[i];
			// Cause every section to completely queue out its item views.
			section.flush();
			section.calculateItemPositions();
		}
		this._removeQueuedViews();
	},
	
	/**
	 * Reload all of the list's sections, and update the layout of each list item's view. Calling
	 * this method ensures that the list reflects any changes to its list items.
	 * 
	 * You do not normally need to call this method. In most cases, the list is automatically 
	 * redrawn as necessary when its list items change.
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	reloadData: function() {
		this.flushSections();
		this.calculateSectionPositions();
		this.updateScrollPosition(this._scrollPosition);
	},
	
	/**
	 * Retrieve the sections that the list contains.
	 * @returns {UI.ListViewSection[]} An array of sections that the list contains.
	 * @see UI.ListView#setSections
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	getSections: function() {
		return this._sections;
	},
	
	/**
	 * Remove all sections from the list, and set a new list of sections that the list contains.
	 * @example
	 * var sections = [];
	 * var sectionHeaders = ["News", "Updates", "Announcements"];
	 * for (var i = 0, l = sectionHeaders.length; i < l; i++) {
	 *     var section = new UI.ListViewSection({
	 *         titleView: sectionHeaders[i]
	 *     });
	 *     // Additional code to populate the section with items.
	 *     // Then add the section to the list:
	 *     sections.push(section);
	 * }
	 * var listView = new UI.ListView();
	 * listView.setFrame([0, 0, Device.LayoutEmitter.getWidth(),
	 *   Device.LayoutEmitter.getHeight()]);
	 * listView.setSections(sections);
	 * @param {UI.ListViewSection[]} newSections An array of sections to add to the list.
	 * @see UI.ListView#getSections
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	setSections: function(newSections) {
		this.flushSections();
	        var i;
		for (i in this._sections) {
			if(this._sections.hasOwnProperty(i)) {
				this._sections[i].setListView(null);
			}
		}
		this._sections = newSections;
		var idArray = [];
		for (i in newSections) {
			if(newSections.hasOwnProperty(i)) {
				idArray.push(0+(newSections[i].__objectRegistryId || 0));
			}
		}
		Commands.setSections.call(this, idArray);
		this.reloadData();
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	calculateSectionPositions: function() {
		if(!this.getFrame()){
			console.log("UI.ListView Warning: You probably called setSections before you actually set a frame.");
			return;
		}
		this._stackedSections = {};
		var topY = 0;
		// Should account for header here.
		var l = this._sections.length;
		for (var i = 0; i < l; i++) {
		//	NgLogD("Calculating height for Section " + i + " / " + l + " from yPos " + topY);
			var section = this._sections[i];
			this._stackedSections[topY] = section;
			section.setListView(this);
			section.setYPosition(topY);
			var relTopY = this._scrollPosition[1/*y*/] - topY;
			section.updateVisibleRange(relTopY, relTopY + this._frame[3/*h*/]);
			var h = section._measureHeight();
			// Set the section's frame...
			section._setFrame(0, topY, this._frame[2], h);
			topY += h;
		}
		// Should account for footer here.
		this.setContentSize([this._frame[2], topY]);
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	updateScrollPosition:function(newVal) {
		if (this._scrollPosition[1] === newVal[1]) return;
		this._scrollPosition = newVal;
		
		var myHeight = this._frame[3];
		for (var yPos in this._stackedSections) {
			if(this._stackedSections.hasOwnProperty(yPos)) {
				var section = this._stackedSections[yPos];
				var relTopY = newVal[1] - yPos;
				section.updateVisibleRange(relTopY, relTopY + myHeight);
			}
		}
	},
	
	/**
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	'_onScroll': function() {},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	enableEvent: function($super, eventName, enable) {
		// Don't allow scrolling events to be turned off!
		if ( (eventName == 'scroll') && !enable ) return;
		$super(eventName, enable);
	}
});

ListView._init = function() {
	delete ListView._init;
	if (ScrollView._init) ScrollView._init();

	/**
	 * Set the `header` property, which contains header text for the list.
	 * @name UI.ListView#setHeader
	 * @function
	 * @example 
	 * var listView = new UI.ListView();
	 * listView.setHeader("Friends");
	 * @param {String} header The new header text for the list.
	 * @see UI.ListView#getHeader
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `header` property, which contains header text for the list.
	 * @name UI.ListView#getHeader
	 * @function
	 * @returns {String} The current header text for the list.
	 * @see UI.ListView#setHeader
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('header');
	/**
	 * Set the `footer` property, which contains footer text for the list.
	 * @name UI.ListView#setFooter
	 * @function
	 * @example
	 * var listView = new UI.ListView();
	 * listView.setFooter("Powered by Mobage");
	 * @param {String} footer The new footer text for the list.
	 * @returns {void}
	 * @see UI.ListView#getFooter
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `footer` property, which contains footer text for the list.
	 * @name UI.ListView#getFooter
	 * @function
	 * @returns {String} The current footer text for the list.
	 * @see UI.ListView#setFooter
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('footer');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewItem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ListViewItem.js';

/* This class does not have a physical view representation, and is just a holder for closures / a bag for data...
	We still fully map and register it so that sections can be persisted independently of tables. */
var Class = require("NGCore/Client/Core/Class").Class;

var ListViewItem = exports.ListViewItem = Class.subclass(
/** @lends UI.ListViewItem.prototype */
{	
	/**
	 * @class The `UI.ListViewItem` class creates individual items in a scrolling list. When a list
	 * item is about to be displayed, it is assigned a view, such as a `{@link UI.CellView}` object,
	 * that represents the list item's contents. The view is taken from a pool of reusable views,
	 * which are managed by the `UI.ListView` object. When a list item scrolls off the top or bottom
	 * of the screen, its view is added to the view pool.
	 *
	 * **Note**: Your application can also create more than one view pool, which is useful if your 
	 * list items will use different types of views. For example, some of your list's items might 
	 * use a cell view created by `{@link UI.CellView}`, while others might use a text label created 
	 * by `{@link UI.Label}`. To specify the view pool for a list item, include a name for the view
	 * pool in the constructor's `reuseId` parameter. You can use this view pool for any list item
	 * that uses the same type of view.
	 *
	 * When an application creates a `UI.ListViewItem` object, the application does not immediately
	 * populate the object with a view. Instead, the application assigns callback functions to the
	 * object, which are triggered as follows:
	 *
	 * +   **When the list's view pool is not full**: The `createView` event fires, telling the 
	 * application that it must create a new view for the view pool. This event triggers the 
	 * callback function specified by `{@link UI.ListViewItem#event:setOnCreateView}`. The callback 
	 * function returns a new view, such as a `{@link UI.CellView}` object, which is added to the 
	 * list's view pool. The callback function also sets the view's default appearance. For example,
	 * the function could call the view's `setGradient()` method to specify the fill color.
	 *
	 * +   **When a view is assigned to a list item**: The `setView` event fires, telling the 
	 * application that it needs to set up the view's unique attributes, such as the text and images
	 * that it displays. This event triggers the callback function specified by
	 * `{@link UI.ListViewItem#event:setOnSetView}`. The callback function assigns text and images
	 * to the view and changes its default appearance as necessary.
	 *
	 *     In some cases, the callback function will _always_ set a certain attribute, such as the
	 * view's text. The application does not need to clean up these attributes when the view is
	 * released.
	 *
	 *     In other cases, the callback function will _only sometimes_ set a certain attribute. For
	 * example, the callback function might use a unique fill color for certain views based on the
	 * views' content. **When the view is released, the application must restore these attributes to
	 * their default settings.**
	 *
	 * +   **When a view is released from a list item**: The `releaseView` event fires, telling the
	 * application that it needs to clean up the view's unique attributes as necessary. This event
	 * triggers the callback function specified by `{@link UI.ListViewItem#event:setOnReleaseView}`. 
	 * 
	 *     As described above, the callback function does not need to clean up attributes that are 
	 * _always_ set when the `setView` event fires. For attributes that are _only sometimes_ set, 
	 * **the callback function must restore these attributes to their default settings**. If the 
	 * callback function does not do this, the unique attributes will persist when the view is
	 * reused, and the view will not have the appropriate appearance.
	 * @name UI.ListViewItem
	 * @constructs Create a new list item.
	 * @augments Core.Class
	 * @example
	 * var listItem = new UI.ListViewItem();
	 * var defaultGradient = ["FFCBCBCB 1.0"];
	 *
	 * listItem.setOnCreateView(function() {
	 *     // Return a UI.CellView object that can be added to the view pool.
	 *     // Set the view to have a light gray background.
	 *     var cell = new UI.CellView({
	 *         gradient: {
	 *             gradient: defaultGradient
	 *         }
	 *     });
	 *
	 *     return cell;
	 * });
	 *
	 * listItem.setOnSetView(function(newView) {
	 *     // Set the text for the UI.CellView object to display. In this
	 *     // example, the text is chosen at random from an array.
	 *     var textOptions = ["Choose an Item", "Update Settings", "View High
	 *         Scores"];
	 *     newView.setText(textOptions[Math.floor(Math.random() * 
	 *         textOptions.length)];
	 *
	 *     // If the text contains a specific string, change the view's
	 *     // background color. Because the callback function only updates
	 *     // the background color in some cases, the application must restore
	 *     // the default background color when the releaseView event fires.
	 *     var cellText = newView.getText();
	 *     if (cellText.match(/Settings/)) {
	 *         newView.setGradient({
	 *             gradient: ["FF91CBC6 1.0"]
	 *         });
	 *     }
	 * });
	 * 
	 * listItem.setOnReleaseView(function(oldView) {
	 *     // Restore the view's background color to the default. The view's
	 *     // text does not need to be restored to a default setting, because
	 *     // the setView event's callback function will always set the correct
	 *     // text for the view.
	 *     oldView.setGradient({
	 *         gradient: defaultGradient
	 *     });
	 * });
	 * @param {String} [reuseId] The name of the view pool that this list item should use. Use this
	 *		parameter if your list items do not all display the same type of view. If you do not
	 *		include this parameter, the list item will use the default view pool. See the [overview 
	 *		of this class](#) for additional details.
	 * @see UI.ListView
	 * @see UI.ListViewSection
	 */
	
	'type':'listview-item',
	
	_reuseId: "__default__",
	/** @protected */
	_currentView: null,
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	_onCreateView: function() {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	_onReleaseView: function(oldView) {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	_onSetView: function(newView) {},
	
	/**
	 * Set a function to call when a `createView` event occurs. This event occurs when the
	 * `{@link UI.ListView}` object needs an additional view that can be assigned to list items
	 * when they are displayed. The callback function returns a new view, such as a
	 * `{@link UI.CellView}` object, which will be added to the view pool. The callback function
	 * also sets the view's default appearance.
	 *
	 * For additional details, see the [overview of this class](#).
	 * @event
	 * @cb {Function} newFn The function to call when a `createView` event occurs.
	 * @cb-returns {Object} A view that can be assigned to a list item.
	 * @returns {void}
	 * @since 1.0
	 */
	setOnCreateView: function(newFn)	{this._onCreateView = newFn},
	/**
	 * Set a function to call when a `releaseView` event occurs. This event occurs when a view is
	 * released from a list item.
	 * 
	 * **Important**: The function must clean up any unique attributes of the view, such as a unique
	 * background color, that are not automatically reset by the `setView` event's callback
	 * function. If the function does not do this, the unique attributes will persist when the view
	 * is reused, and the view will not have the appropriate appearance.
	 *
	 * For additional details, see the [overview of this class](#).
	 * @event
	 * @cb {Function} newFn The function to call when a `releaseView` event occurs.
	 * @cb-param {Object} oldView The view that is being released from the list item.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.0
	 */
	setOnReleaseView: function(newFn)	{this._onReleaseView = newFn},
	/**
	 * Set a function to call when a `setView` event occurs. This event occurs when a view is being
	 * added to a list item. The function assigns text and images to the view and changes its
	 * default appearance as necessary. In some cases, it is necessary to clean up the view after it
	 * is released from the list item, so that the view has the correct appearance when it is
	 * reused.
	 *
	 * For additional details, see the [overview of this class](#).
	 * @event
	 * @cb {Function} newFn The function to call when a `setView` event occurs.
	 * @cb-param {Object} newView The view that is being added to a list item.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.0
	 */
	setOnSetView: function(newFn)		{this._onSetView = newFn},
	
	/**
	 * Set the height, in pixels, of the list item. This value is used only when the list item is in
	 * a list section that uses variable row heights. Call this method before the list item is
	 * visible to the user (for example, when a `setView` event occurs).
	 * @param {Number} h The height, in pixels, of the list item.
	 * @returns {void}
	 * @see UI.ListViewSection#setRowHeight
	 * @since 1.1.1.2
	 */
	setHeight: function(h) {
		this._height = h;
	},
	
	/**
	 * Get the height, in pixels, of the list item.
	 * @returns {Number} The height, in pixels, of the list item.
	 * @since 1.1.1.2
	 */
	getHeight: function() {
		return this._height;
	},
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	_setCurrentView: function(newView) {
		if (newView instanceof Class) {
			this._onSetView(newView);
		} else {
			this._onReleaseView(this._currentView);
		}
		this._currentView = newView;
		return this;
	},
	
	/**
 	 * Retrieve the view that is currently attached to the list item.
	 * @returns {Object} The list item's current view, or `null` if no view is assigned.
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
 	 */
	getCurrentView: function(){
		return this._currentView;
	},
		
	initialize: function(reuseId) {
		if (reuseId) this._reuseId = reuseId;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewSection'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ListViewSection.js';

var Element = require('NGCore/Client/UI/Element').Element;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Core = require('NGCore/Client/Core').Core;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;

var _padTopRows = 5;
var _padBottomRows = 5;

if ( Core.Capabilities.getPlatformOS() === "iPhone OS" ) {
	// iOS's UI refresh mechanisms are much more tightly coupled. Save some memory...
	_padTopRows = 1;
	_padBottomRows = 2;
}

/* This class does not have a physical view representation.
	We still fully map and register it so that sections can be persisted independently of tables. */

var ListViewSection = exports.ListViewSection = Element.subclass(
/** @lends UI.ListViewSection.prototype */
{
	'type':'listview-section',
	/**
	 * @class The `UI.ListViewSection` class creates sections of a scrolling list. Each section 
	 * contains one or more `{@link UI.ListViewItem}` objects, which represent the list's individual
	 * items.
	 *
	 * A `UI.ListViewSection` object's appearance can change automatically when its view state 
	 * changes. For example, the section's title can change automatically when the section gains 
	 * focus or is selected. To implement this feature, your application can call a
	 * `UI.ListViewSection` setter method more than once, passing a different value in the `flags`
	 * parameter each time. In addition, your application can include properties for multiple view
	 * states in the constructor. See the `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.ListViewSection#setRowHeight}` to control
	 * the fheight of the section's rows, the height you specify will apply in all view states.
	 * @name UI.ListViewSection
	 * @constructs Create a list section.
	 * @augments UI.Element
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.ListViewSection object without setting any of its properties.
	 * var listSection = new UI.ListViewSection();
	 * @example
	 * // Create a new UI.ListViewSection object, setting its title.
	 * var sectionTitle = "Latest Updates";
	 * var listSection = new UI.ListViewSection({
	 *     titleView: sectionTitle
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.ListViewSection` object.
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize:function($super, properties) {
		if (ListViewSection._init) ListViewSection._init();
		
		this._visibleRange = [0,0];
		this._headerHeight = 0;
		this._titleHeight = 0;
		
		delete this._measuredHeight;
		this._needsLayout = false;
		
		$super(properties);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	addItemToVisible: function(lvItem, index) {
		if (!(lvItem instanceof ListViewItem)) return;
		if (lvItem._currentView instanceof Element) return;
		
		var useView = this._listView._viewForItem(lvItem);
		var w = this._listView.getFrame()[2];
		
		if (this._rowHeight > 0) {
			useView.setFrame(0, this._yPosition + this._titleHeight + index * this._rowHeight, w, this._rowHeight);
		} else {
			useView.setFrame(0, this._yPosition + this._cellPositions[index], w, lvItem._height);
		}
		
		lvItem._setCurrentView(useView);
		if (!useView.getParent()) this._listView.addChild(useView, "cell");
	},
	
	_setFrame: function(l, t, w, h) {
		Commands.setFrame.call(this, l, t, w, h);
		if (this._titleView) {
			var f = this._titleView.getFrame();
			this._titleView.setFrame(l, t, w, f[3]);
		}
	},
	
	/**
	 * Reset the indices of the first and last visible list items within the section. Call this
	 * method when you change the list items in a way that the `{@link UI.ListView}` object cannot
	 * automatically detect. For example, if you pass an array to
	 * `{@link UI.ListViewSection#setItems}`, then modify the array, calling `flush()` will redraw
	 * the list based on the current items in the array.
	 * @function
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash
	 * @since 1.0
	 */
	flush: function() {
		for (var i = this._visibleRange[0], l = this._visibleRange[1]; i < l && i < this._items.length; i++) {
            this._listView._queueViewForItem(this._items[i]);
		}
		this._visibleRange = [0,0];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	updateVisibleRange: function(topY, bottomY) {
		var totalH = this._getMeasuredHeight();
		
		// Expand the view window. This is really only necessary for Android...
		var l = this._items.length;
		var rowH = this._rowHeight > 0 ? this._rowHeight : totalH / l;
		topY -= rowH * _padTopRows;
		bottomY += rowH * _padBottomRows;
		
		var oldStartIndex = this._visibleRange[0];
		var oldEndIndex = this._visibleRange[1];
		var startIndex = l > 0 ? Math.max(0, Math.floor(topY / rowH)) : 0;
		var endIndex = l > 0 ? Math.min(l, startIndex + Math.floor((bottomY - topY) / rowH)) : 0;
		
		if (this._cellPositions) {
			// We should have a good guess into the array from the above code,
			// so now it just needs to be adjusted until accurate.
			while (startIndex < l && this._cellPositions[startIndex] < topY) startIndex++;
			while (startIndex > 0 && this._cellPositions[startIndex] > topY) startIndex--;
			if (startIndex >= l) startIndex = Math.max(0, l - 1);
			
			while (endIndex < l && this._cellPositions[endIndex] < bottomY) endIndex++;
			while (endIndex > startIndex && this._cellPositions[endIndex] > bottomY) endIndex--;
		
			topY = this._cellPositions[startIndex];
			// EndIndex is one past the last element...
			bottomY = endIndex === 0 ? topY : (this._cellPositions[endIndex-1] + this._items[endIndex-1]._height );
		}
		if (bottomY < 0 || topY > totalH) {
			for (var i = this._visibleRange[0]; i < this._visibleRange[1] && i < this._items.length; i++) {
				this._listView._queueViewForItem(this._items[i]);
			}
			this._visibleRange = [0,0];
			return;
		}
		
		if (oldStartIndex == startIndex && oldEndIndex == endIndex) return;
		
//		NgLogD("(" + oldStartIndex + "," + oldEndIndex + ") -> (" + startIndex + "," + endIndex + ")");
		
		if (oldStartIndex == oldEndIndex) {
			for (i = startIndex; i < endIndex; i++) {
				this.addItemToVisible(this._items[i], i);
			}
		} else {
			// Dequeue and requeue from both ends.
			if (oldStartIndex < startIndex) {
				do {
					this._listView._queueViewForItem(this._items[oldStartIndex]);
				} while (++oldStartIndex < startIndex);
			}
			if (oldEndIndex > endIndex) {
				while (oldEndIndex-- > endIndex) {
					this._listView._queueViewForItem(this._items[oldEndIndex]);
				}
				oldEndIndex = endIndex;	// Keep later codepath from triggering
			}
		
			if (oldStartIndex > startIndex) {
				while (oldStartIndex-- > startIndex) {
					this.addItemToVisible(this._items[oldStartIndex], oldStartIndex);
				}
				oldStartIndex = startIndex;
			} 
			if (oldEndIndex < endIndex) {
				do {
					this.addItemToVisible(this._items[oldEndIndex], oldEndIndex);
				} while (++oldEndIndex < endIndex);
			}
		
		}
		this._visibleRange = [startIndex, endIndex];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setListView : function(listView) {
		this._listView = listView;
		delete this._measuredHeight;
		return this;
	},
	
	_getMeasuredHeight : function() {
		return this._measuredHeight || this._measureHeight();
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	_measureHeight : function() {
		// Sum the heights of the rows.  No variable-heights yet!!!
		if (this._rowHeight < 0) {
			// Variable Height Trigger
			var totalHeight = this._titleHeight + this._headerHeight;
			var runningHeights = [];
			var l = this._items.length;
			for (var i = 0; i < l; i++) {
				runningHeights.push(totalHeight);
				totalHeight += this._items[i]._height;
			}
			this._cellPositions = runningHeights;
			return this._measuredHeight = totalHeight;
		}
		
		delete this._cellPositions;
		return this._measuredHeight = this._titleHeight + this._headerHeight + this._rowHeight * this._items.length;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	calculateItemPositions: function() {
		// Not used?.
	}
});

ListViewSection._init = function() {
	delete ListViewSection._init;
	if (Element._init) Element._init();

	// We don't have a set pattern for sending the id of a view we want to assign by reference...
	var boundTitleFunction = function() {
		if (this.listViewMonitor) this.listViewMonitor.setTitleView(this);
		boundTitleFunction._superfunc.apply(this, Array.prototype.slice.call(arguments));
	};
	var setTitleView = function(titleView) {
		if (this._titleView && this._titleView.listViewMonitor == this) {
			delete this._titleView.listViewMonitor;
		}
		this._titleView = titleView;
		
		if (titleView.listViewMonitor != this) {
			titleView.listViewMonitor = this;
			if (!boundTitleFunction._superfunc) {
				boundTitleFunction._superfunc = titleView.setFrame;
			}
			if (titleView.setFrame != boundTitleFunction) {
				titleView.registerAccessors('frame', null, boundTitleFunction);
			}
		}
		
		this._titleHeight = titleView.getFrame()[3];
		delete this._measuredHeight;
		Commands.setTitleView.call(this, ObjectRegistry.objectToId(titleView));
		return this;
	};
	var getTitleView = function() {
		return this._titleView;
	};
	/**
	 * Set the `titleView` property, which contains the list section's title.
	 * @name UI.ListViewSection#setTitleView
	 * @function
	 * @example
	 * var listSection = new UI.ListViewSection();
	 * listSection.setTitleView("Latest Updates");
	 * @param {String} title The new section title.
	 * @returns {void}
	 * @see UI.ListViewSection#getTitleView
	 */
	/**
	 * Retrieve the value of the `titleView` property, which contains the list section's title.
	 * @name UI.ListViewSection#getTitleView
	 * @function
	 * @returns {String} The current section title.
	 * @see UI.ListViewSection#setTitleView
	 */
	ListViewSection.registerAccessors('titleView', getTitleView, setTitleView);
	
	// Other properties
	/**
	 * Set the `rowHeight` property, which contains the height, in pixels, of each row in the list
	 * section. If the section's rows will have variable heights, set the value of `rowHeight` to
	 * `-1`, and call the `{@link UI.ListViewItem#setHeight}` method to set the height of each list
	 * item in the section.
	 * @name UI.ListViewSection#setRowHeight
	 * @function
	 * @example
	 * // Set a fixed row height.
	 * var listSection = new UI.ListViewSection();
	 * listSection.setRowHeight(80);
	 * @param {Number} rowHeight The height, in pixels, of each row in the list section. To use
	 *		variable row heights, set the value to `-1`.
	 * @returns {void}
	 * @see UI.ListViewItem#setHeight
	 * @see UI.ListViewSection#getRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `rowHeight` property, which contains the height, in pixels, of each
	 * row in the list section.
	 * @name UI.ListViewSection#getRowHeight
	 * @function
	 * @returns {Number} The height, in pixels, of each row in the list section. Set to `-1` if the
	 *		row uses variable heights.
	 * @see UI.ListViewSection#setRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListViewSection.synthesizeProperty('rowHeight');
	/**
	 * Set the `items` property, which specifies a list of the `{@link UI.ListViewItem}` objects
	 * that the section contains. The new list of items will completely replace the existing list of
	 * items. If the section is visible, it will be redrawn to show the new items.
	 * @name UI.ListViewSection#setItems
	 * @function
	 * @example
	 * var listItem1 = new UI.ListViewItem(),
	 *     listItem2 = new UI.ListViewItem(),
	 *     listItem3 = new UI.ListViewItem();
	 * var listSection = new UI.ListViewSection();
	 * listSection.setItems[listItem1, listItem2, listItem3];
	 * @param {UI.ListViewItem|UI.ListViewItem[]} newItems A single `{@link UI.ListViewItem}`
	 *		object, or an array of objects, that the list section will contain.
	 * @returns {void}
	 * @see UI.ListViewSection#getItems
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	var setItems = function(newItems) {
		newItems = (newItems instanceof Array) ? newItems : Array.prototype.slice.call(arguments);
		
		this.flush();
		this._items = newItems;
		
		delete this._measuredHeight;
		if (!this._listView) return;
		this._listView.reloadData();
	};
	/**
	 * Retrieve the value of the `items` property, which specifies a list of the
	 * `{@link UI.ListViewItem}` objects that the section contains.
	 * @name UI.ListViewSection#getItems
	 * @function
	 * @returns {UI.ListViewItem[]} An array of objects that the list section currently contains.
	 * @see UI.ListViewSection#setItems
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	var getItems = function() {
		return this._items;
	};
	ListViewSection.registerAccessors('items', getItems, setItems);

	// private
	ListViewSection.synthesizeProperty('yPosition');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CellView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CellView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CellView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/CellView.js';

var View = require('NGCore/Client/UI/View').View;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CellView = exports.CellView = View.subclass(
/** @lends UI.CellView.prototype */
{
	'type':'cell',
	/**
	 * @class The `UI.CellView` class provides cell views in an application, such as cells in a
	 * scrolling list. A `UI.CellView` object can display an image, such as an arrow, on the right
	 * side. The object also provides two vertically stacked areas that can contain a title and
	 * other text.
	 * 
	 * A `UI.CellView` object's appearance can change automatically when the cell's view state 
	 * changes. For example, the cell's fill color can change automatically when the cell is
	 * selected. To implement this feature, your application can call a `UI.CellView` setter method 
	 * more than once, passing a different value in the `flags` parameter each time. In addition, 
	 * your application can include properties for multiple view states in the constructor. See the
	 * `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.CellView#setImageGravity}` to control an
	 * image's position within the cell, the image gravity you specify will apply in all view
	 * states.
	 * @name UI.CellView
	 * @constructs Create a cell view.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.CellView object without setting any of its properties.
	 * var cell = new UI.CellView();
	 * @example
	 * // Create a new UI.CellView object, setting its title and text.
	 * var cellTitle = "Options";
	 * var cellText = "Configure the application."
	 * var cell = new UI.CellView({
	 *     title: cellTitle,
	 *     text: cellText
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.CellView` object.
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (CellView._init) CellView._init();
		$super(properties);
	}
});

// Properties
CellView._init = function() {
	delete CellView._init;
	if (View._init) View._init();
	
	/**
	 * Set the `image` property, which links to an image that is displayed in the cell for a
	 * specified view state.
	 * @name UI.CellView#setImage
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setImage("./Content/cell-bg.png", UI.Commands.State.Normal |
	 *     UI.Commands.State.Focused);
	 * @param {String} image The path to the new image.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this image. To specify an image for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getImage
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `image` property for a specified view state.
	 * @name UI.CellView#getImage
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The path to the image for the specified view state.
	 * @see UI.CellView#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * Set the value of the `imageBorder` property, which defines a border for images in a
	 * specified view state. See `{@link UI.Style#setGradient}` for information about this
	 * property.
	 * @name UI.CellView#setImageBorder
	 * @function
	 * @example
	 * // Use a dark gray border for the image.
	 * var cell = new UI.CellView();
	 * var border = {
	 *     outerLine: "FF5F5F5F 1.0"
	 * };
	 * cell.setImageBorder(border);
	 * @param {Object} imageBorder The new image border.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this border. To specify a border for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getImageBorder
	 * @see UI.Style#setGradient
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageBorder` property, which defines a border for images in a
	 * specified view state.
	 * @name UI.CellView#getImageBorder
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The current image border.
	 * @see UI.CellView#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * Set the `imageInsets` property, which contains insets that are used to clip the edges of the
	 * image.
	 * @name UI.CellView#setImageInsets
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * // Use a top inset of 10, a right inset of 20, a bottom inset of 15, and
	 * // a left inset of 5.
	 * cell.setImageInsets([10, 20, 15, 5]);
	 * @param {Number[]} imageInsets The new image insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the button.
	 * @returns {void}
	 * @see UI.CellView#getImageInsets
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageInsets` property, which contains insets that are used to clip
	 * the edges of the image.
	 * @name UI.CellView#getImageInsets
	 * @function
	 * @returns {Number[]} The current image insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the button.
	 * @see UI.CellView#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * Set the `imageFit` property, which defines how images will be scaled relative to the cell.
	 * @name UI.CellView#setImageFit
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setImageFit(UI.Commands.FitMode.None);
	 * @param {UI.Commands#FitMode} imageFit The method that will be used to scale images relative
	 * 		to the cell.
	 * @returns {void}
	 * @see UI.CellView#getImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `imageFit` property, which defines how images will be scaled
	 * relative to the cell.
	 * @name UI.CellView#getImageFit
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setImageFit(UI.Commands.FitMode.AspectWidth);
	 * // More code here.
	 * // Later, the application takes different actions based on the
	 * // image's fit mode:
	 * var imageFitMode = cell.getImageFit();
	 * switch (imageFitMode) {
	 *     case UI.Commands.FitMode.AspectHeight:
	 *         // Your code here
	 *         break;
	 *     case UI.Commands.FitMode.AspectWidth:
	 *         // Your code here
	 *         break;
	 *     // Continue through each enumerated value that you want to test
	 *     default:
	 *         // Your code here
	 *         break;
	 * }
	 * @returns {Number} The current scaling option that will be used to scale images relative to 
	 * 		the cell. The returned value corresponds to an enumerated value of
	 *		`{@link UI.Commands#FitMode}`.
	 * @see UI.CellView#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * Set the `imageGravity` property, which defines how the image is positioned within the
	 * viewable area. By default, the image gravity is set to `[0.5, 0.5]`, which centers the image
	 * within the viewable area.
	 * 
	 * See `{@link UI.Image#setImageGravity}` for more information about this property.
	 * @name UI.CellView#setImageGravity
	 * @function
	 * @example
	 * // Position the image towards the left side of the cell and vertically centered.
	 * var cell = new UI.CellView();
	 * cell.setImageGravity([0.25, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} imageGravity The new image gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @returns {void}
	 * @see UI.CellView#getImageGravity
	 * @see UI.Image#setImageGravity
 	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#getImageGravity
	 * @function
	 * @description Retrieve the value of the `imageGravity` property.
	 * @returns {Number[]} The current image gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.CellView#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * Set the `imageTransform` property, which defines an affine transformation of the image. See
	 * `{@link UI.Image#setImageTransform}` for more information about affine transformations.
	 * @name UI.CellView#setImageTransform
	 * @function
	 * @example
	 * // Increase an image's size by 20 units along the X axis, and move it
	 * // down 5 units along the Y axis.
	 * var cell = new UI.CellView();
	 * var scaleX = 20;
	 * var moveY = 5;
	 * cell.setImageTransform([scaleX, 0, 0, 0, 0, moveY]);
	 * @example
	 * // Rotate an image 30 degrees to the left.
	 * function degreesToRadians(degrees) {
	 *     return degrees * (Math.PI / 180);
	 * }
	 *
	 * var cell = new UI.CellView();
	 * var angle = degreesToRadians(30);
	 * cell.setImageTransform([Math.cos(angle), Math.sin(angle),
	 *     -Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @example
	 * // Skew the bottom of an image to the right by 10 units along the x axis.
	 * var cell = new UI.CellView();
	 * var skewX = 10;
	 * cell.setImageTransform([0, 0, skewX, 0, 0, 0]);
	 * @param {Number[]} imageTransform The new affine transformation. Specified as an array of
	 *		four floats: `[a, b, c, d, tx, ty]`.
	 * @returns {void}
	 * @see UI.CellView#getImageTransform
	 * @see UI.Image#setImageTransform
 	 * @status iOS, Android, Test
	 */
	/**
	 * Retrieve the value of the `imageTransform` property, which defines an affine transformation
	 * of the image.
	 * @name UI.CellView#getImageTransform
	 * @function
	 * @returns {Number[]} The current affine transformation. Specified as an array of six floats:
	 *		 `[a, b, c, d, tx, ty]`.
	 * @see UI.CellView#setImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	 CellView.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * Retrieve the value of the `rightImage` property, which defines a path to an image to display
	 * on the right side of the cell for a specified view state.
	 * @name UI.CellView#getRightImage
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current path to the image that will be displayed on the right side of
	 *		the cell.
	 * @see UI.CellView#setRightImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `rightImage` property, which defines a path to an image to display on the right side
	 * of the cell for a specified view state. For example, your application could display a right
	 * arrow, indicating that the user will proceed to a new view by touching the cell.
	 * @name UI.CellView#setRightImage
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setRightImage("./Content/right-arrow.png",
	 *     UI.Commands.State.Focused);
	 * @param {String} rightImage The path to the new image.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this right image. To specify a right image for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getRightImage
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('rightImage', Commands.setRightImage);
	/**
	 * Retrieve the value of the `rightImageBorder` property, which defines a border for the image
	 * that is specified by the `rightImage` property for a specified view state.
	 * @name UI.CellView#getRightImageBorder
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The current image border for the right image.
	 * @see UI.CellView#setRightImage
	 * @see UI.CellView#setRightImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `rightImageBorder` property, which defines a border for the image that is specified 
	 * by the `rightImage` property for a specified view state. See `{@link UI.Style#setGradient}`
	 * for information about the `rightImageBorder` property.
	 * @name UI.CellView#setRightImageBorder
	 * @function
	 * @example
	 * // Use a dark gray border for the right image.
	 * var cell = new UI.CellView();
	 * var border = {
	 *     outerLine: "FF5F5F5F 1.0"
	 * };
	 * cell.setRightImageBorder(border);
	 * @param {Object} rightImageBorder The new image border for the right image.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this right image border. To specify a right image for a view that is in multiple states,
	 * 		you can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#setRightImage
	 * @see UI.CellView#getRightImageBorder
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
	/**
	 * Retrieve the value of the `rightImageInsets` property, which contains insets that are used to
	 * clip the edges of the right image.
	 * @name UI.CellView#getRightImageInsets
	 * @function
	 * @returns {Number[]} The current image insets. Specified as an array of four floats, starting 
	 *		with the top inset and going clockwise around the cell.
	 * @see UI.CellView#setRightImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `rightImageInsets` property, which contains insets that are used to clip the edges of
	 * the right image. The inset is specified as an array of floats, starting with the top inset
	 * and going clockwise around the cell.
	 * @name UI.CellView#setRightImageInsets
	 * @function
	 * @example
	 * // Use a top inset of 10, a right inset of 20, a bottom inset of 15, and
	 * // a left inset of 5.
	 * var cell = new UI.CellView();
	 * cell.setRightImageInsets([10, 20, 15, 5]);
	 * @param {Number[]} imageInsets The new image insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the cell.
	 * @returns {void}
	 * @see UI.CellView#getRightImageInsets
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('rightImageInsets', Commands.setRightImageInsets);
	/**
	 * Retrieve the value of the `rightImageFit` property, which defines how the right image will be
	 * scaled relative to the view.
	 * @name UI.CellView#getRightImageFit
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setRightImageFit(UI.Commands.FitMode.AspectWidth);
	 * // More code here.
	 * // Later, the application takes an action based on the image's
	 * // fit mode:
	 * var imageFitMode = cell.getImageFit();
	 * switch (imageFitMode) {
	 *     case UI.Commands.FitMode.AspectHeight:
	 *         // Your code here
	 *         break;
	 *     case UI.Commands.FitMode.AspectWidth:
	 *         // Your code here
	 *         break;
	 *     // Continue through each enumerated value that you want to test
	 *     default:
	 *         // Your code here
	 *         break;
	 * }
	 * @returns {Number} The current scaling option that will be used to scale the right image 
	 * 		relative to the view. The returned value corresponds to an enumerated value of
	 *		`{@link UI.Commands#FitMode}`.
	 * @see UI.CellView#setRightImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `rightImageFit` property, which defines how the right image will be scaled relative
	 * to the view.
	 * @name UI.CellView#setRightImageFit
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setRightImageFit(UI.Commands.FitMode.None);
	 * @param {UI.Commands#FitMode} rightImageFit The scaling option that will be used to scale 
	 * 		the right image relative to the cell.
	 * @returns {void}
	 * @see UI.CellView#getRightImageFit
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
	/**
	 * Retrieve the value of the `rightImageGravity` property, which defines how the right image is
	 * positioned within the viewable area.
	 * @name UI.CellView#getRightImageGravity
	 * @function
	 * @returns {Number[]} The current image gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.CellView#setRightImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `rightImageGravity` property, which defines how the right image is positioned within 
	 * the viewable area. See `{@link UI.Image#setImageGravity}` for information about this
	 * property.
	 * @name UI.CellView#setRightImageGravity
	 * @function
	 * @example
	 * // Position the right image so that it is horizontally centered and vertically
	 * // adjacent to the top edge of the cell.
	 * var cell = new UI.CellView();
	 * cell.setRightImageGravity([0.5, 0.0]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} rightImageGravity The new image gravity. Specified
	 *		as an array of two floats, where the first represents the X axis and the second
	 *		represents the Y axis. You can also specify an enumerated value of
	 *		`{@link UI.ViewGeometry#Gravity}` in place of the array.
	 * @returns {void}
	 * @see UI.CellView#getRightImageGravity
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('rightImageGravity', Commands.setRightImageGravity);
	/**
	 * Retrieve the current value of the `rightImageTransform` property, which defines an affine
	 * transformation of the right image.
	 * @name UI.CellView#getRightImageTransform
	 * @function
	 * @returns {Number[]} The current affine transformation. Specified as an array of six floats:
	 *		`[a, b, c, d, tx, ty]`.
	 * @see UI.CellView#setRightImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `rightImageTransform` property, which defines an affine transformation of the right 
	 * image. See `{@link UI.Image#setImageTransform}` for information about this property.
	 * @name UI.CellView#setRightImageTransform
	 * @function
	 * @example 
	 * // Increase the right image's size by 20 units along the X axis, and 
	 * // move it down 5 units along the Y axis.
	 * var cell = new UI.CellView();
	 * var scaleX = 20;
	 * var moveY = 5;
	 * cell.setRightImageTransform([scaleX, 0, 0, 0, 0, moveY]);
	 * @param {Number[]} imageTransform The new affine transformation. Specified as an array of six
	 *		floats: `[a, b, c, d, tx, ty]`.
	 * @returns {void}
	 * @see UI.CellView#getRightImageTransform
	 * @see UI.Image#setImageTransform
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
	
	/**
	 * Set the function to call when an `imageLoaded` event occurs. This event occurs when an image
	 * that is specified for a `UI.CellView` finishes loading.
	 * @name UI.CellView#setOnImageLoaded
	 * @event
	 * @example
	 * var cellView = new UI.CellView();
	 * cellView.setOnImageLoaded(function(event) {
	 *     if (event.error) {
	 *         console.log("Unable to load image: " + e.error + " " + e.message);
	 *     } else {
	 *         console.log("Loaded the image " + event.imageUrl);
	 *         console.log("Width: " + event.width + ", height: " + event.height);
	 *     }
	 * });
	 * @cb {Function} imageLoadedCallback The function to call when an `imageLoaded` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} [event.error] A code identifying the error, if any.
	 * @cb-param {Number} [event.height] The height of the image that was loaded.
	 * @cb-param {String} event.imageUrl The URL of the image that was loaded, or that failed to
	 *		load.
	 * @cb-param {String} [event.message] A description of the error, if any.
	 * @cb-param {Number} [event.width] The width of the image that was loaded.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.CellView#event:getOnImageLoaded
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoaded` event occurs.
	 * @name UI.CellView#getOnImageLoaded
	 * @event
	 * @returns {Function} The function to call when an `imageLoad` event occurs.
	 * @see UI.CellView#event:setOnImageLoaded
	 * @since 1.6
	 */
	 CellView.registerEventType('imageLoaded'); 
		
	/**
	 * Set a function to call when an `imageLoadFailed` event occurs. This event occurs when an
	 * image that is specified for a `UI.CellView` cannot be loaded.
	 * @name UI.CellView#setOnImageLoadFailed
	 * @event
	 * @example
	 * var cellView = new UI.CellView();
	 * cellView.setOnImageLoadFailed(function(event) {
	 *     console.log("An error occurred when loading " + event.url + 
	 *         ": " + event.error + ": " + event.message);
	 * });
	 * @cb {Function} imageLoadFailedCallback The function to call when an `imageLoadFailed` event
	 *		occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} event.error A code identifying the error.
	 * @cb-param {String} event.url The URL for the image.
	 * @cb-param {String} event.message A message describing the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.CellView#event:getOnImageLoadFailed
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoadFailed` event occurs.
	 * @name UI.CellView#getOnImageLoadFailed
	 * @event
	 * @returns {Function} The current function to call when an `imageLoadFailed` event occurs.
	 * @see UI.CellView#event:setOnImageLoadFailed
	 * @since 1.6
	 */
	CellView.registerEventType('imageLoadFailed');
	
	/**
	 * Retrieve the current value of the `title` property, which defines a title for the cell in a
	 * specified view state.
	 * @name UI.CellView#getTitle
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current cell title.
	 * @see UI.CellView#setTitle
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `title` property, which defines a title for the cell in a specified view state.
	 * @name UI.CellView#setTitle
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * var cellTitle = "Configure Application";
	 * cell.setTitle(cellTitle);
	 * @param {String} title The new cell title.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this title. To specify a title for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTitle
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * Retrieve the value of the `titleColor` property, which defines the text color for the title
	 * in a specified view state.
	 * @name UI.CellView#getTitleColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current title text color, in hexidecimal RGB format.
	 * @see UI.CellView#setTitleColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `titleColor` property, which defines the text color for the title in a specified view
	 * state.
	 * @name UI.CellView#setTitleColor
	 * @function 
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setTitleColor("FFFFFF");
	 * @param {String} titleColor The new title text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can 
	 * 		use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTitleColor
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
	/**
	 * Retrieve the value of the `titleFont` property, which defines the font that is used for the 
	 * title text in a specified view state.
	 * @name UI.CellView#getTitleFont	 
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current title text font.
	 * @see UI.CellView#setTitleFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `titleFont` property, which defines the font that is used for the title text in a
	 * specified view state.
	 * @name UI.CellView#setTitleFont
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setTitleFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this font. To specify a font for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTitleFont
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
	/**
	 * Retrieve the value of the `titleShadow` property, which defines the color and size of shadows
	 * on the title text in a specified view state.
	 * @name UI.CellView#getTitleShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current title text shadow.
	 * @see UI.CellView#setTitleShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `titleShadow` property, which defines the color and size of shadows on the title text
	 * in a specified view state. See `{@link UI.Style#setTextShadow}` for information about this
	 * property.
	 * @name UI.CellView#setTitleShadow
	 * @function
	 * @example
	 * // Set a light gray text shadow with a two-pixel blur, shifted up by one
	 * // pixel along the Y axis.
	 * var cell = new UI.CellView();
	 * cell.setTitleShadow("FFCCCCFF 2.0 {0.0, -1.0}");
	 * @param {String} titleShadow The new title text shadow, in the format specified by 
	 *		`{@link UI.Button#setTextShadow}`.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you 
	 * 		can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTitleShadow
	 * @see UI.Style#setTextShadow
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);

	/**
	 * Retrieve the value of the `titleGravity` property, which defines how the title text is
	 * positioned within the viewable area.
	 * @name UI.CellView#getTitleGravity
	 * @function
	 * @returns {Number[]} The current title text gravity. Specified as an array of two floats,
	 *		where the first represents the X axis and the second represents the Y axis.
	 * @see UI.CellView#setTitleGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `titleGravity` property, which defines how the title text is positioned within the
	 * viewable area. See `{@link UI.Style#setTextGravity}` for information about this property.
	 * @name UI.CellView#setTitleGravity
	 * @function
	 * @example
	 * // Position the title text so that it is horizontally centered and vertically
	 * // adjacent to the top of the cell.
	 * var cell = new UI.CellView();
	 * cell.setTitleGravity([0.5, 0.0]);	 
	 * @param {Number[]|UI.ViewGeometry#Gravity} titleGravity The new title text gravity. Specified
	 *		as an array of two floats, where the first represents the X axis and the second
	 *		represents the Y axis. You can also specify an enumerated value of
	 *		`{@link UI.ViewGeometry#Gravity}` in place of the array.
	 * @returns {void}
	 * @see UI.CellView#getTitleGravity
	 * @see UI.Style#setTextGravity
	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);

	/**
	 * Retrieve the value of the `titleSize` property, which specifies the size, in pixels, of the
	 * title text.
	 * @name UI.CellView#getTitleSize
	 * @function
	 * @returns {Number} The current size, in pixels, of the title text.
	 * @see UI.CellView#setTitleSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `titleSize` property, which specifies the size, in pixels, of the title text.
	 * @name UI.CellView#setTitleSize
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * var textSize = 24;
	 * cell.setTitleSize(textSize);
	 * @param {Number} titleSize The new size, in pixels, of the title text.
	 * @returns {void}
	 * @see UI.CellView#getTitleSize
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeProperty('titleSize', Commands.setTitleSize);
	/**
	 * Retrieve the value of the `titleInsets` property, which contains insets that are used to clip
	 * the edges of the title text.
	 * @name UI.CellView#getTitleInsets
	 * @function
	 * @returns {Number[]} The current title text insets. Specified as an array of four floats, 
	 *		representing pixels, starting with the top inset and going clockwise around the text.
	 * @see UI.CellView#setTitleInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `titleInsets` property, which contains insets that are used to clip the edges of the
	 * title text. The inset is specified as an array of floats, representing pixels, starting with 
	 * the top inset and going clockwise around the text.
	 * @name UI.CellView#setTitleInsets
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * var insetLeft = 10;
	 * cell.setTitleInsets([0, 0, 0, insetLeft]);
	 * @param {Number[]} titleInsets The new title text insets. Specified as an array of four 
	 *		floats, representing pixels, starting with the top inset and going clockwise around the 
	 *		text.
	 * @returns {void}
	 * @see UI.CellView#getTitleInsets
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('titleInsets', Commands.setTitleInsets);
	
	/**
	 * Retrieve the value of the `text` property, which defines text for the cell in a specified
	 * view state.
	 * @name UI.CellView#getText
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text for the cell.
	 * @see UI.CellView#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `text` property, which defines text for the cell in a specified view state.
	 * @name UI.CellView#setText
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * var cellText = "Change your configuration settings.";
	 * cell.setText(cellText);
	 * @param {String} text The new text for the cell.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getText
 	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	CellView.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * Retrieve the value of the `textColor` property, which defines the text color for the cell in
	 * a specified view state.
	 * @name UI.CellView#getTextColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text color, in hexidecimal RGB format.
	 * @see UI.CellView#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textColor` property, which defines the text color for the cell in a specified view
	 * state.
	 * @name UI.CellView#setTextColor
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setTextColor("FFFFFF");
	 * @param {String} textColor The new text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can
	 * 		use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTextColor
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * Retrieve the value of the `textShadow` property, which defines the color and size of shadows
	 * on the button text in a specified view state.
	 * @name UI.CellView#getTextShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text shadow.
	 * @see UI.CellView#setTextShadow	
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textShadow` property, which defines the color and size of shadows on the cell text
	 * in a specified view state. See `{@link UI.Style#setTextShadow}` for information about this
	 * property.
	 * @name UI.CellView#setTextShadow
	 * @function
	 * @example
	 * // Set a white text shadow with a two-pixel blur, shifted up one pixel
	 * // along the Y axis.
	 * var cell = new UI.CellView();
	 * cell.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} textShadow The new text shadow, in the format specified by
	 *		`{@link UI.Button#setTextShadow}`.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you 
	 * 		can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTextShadow
	 * @see UI.Style#setTextShadow
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * Retrieve the value of the `textFont` property, which defines the font that is used for the
	 * cell text in a specified view state.
	 * @name UI.CellView#getTextFont
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The name of the current font.
	 * @see UI.CellView#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textFont` property, which defines the font that is used for the cell text in a
	 * specified view state.
	 * @name UI.CellView#setTextFont
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * cell.setTextFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this font. To specify a font for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CellView#getTextFont
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	/**
	 * Retrieve the value of the `textGravity` property, which defines how the cell text is
	 * positioned within the viewable area.
	 * @name UI.CellView#getTextGravity
	 * @function
	 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.CellView#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textGravity` property, which defines how the cell text is positioned within the
	 * viewable area. See `{@link UI.Style#setTextGravity}` for information about this property.
	 * @name UI.CellView#setTextGravity	 
	 * @function
	 * @example
	 * // Position the cell text so it is horizontally pushed towards the left edge
	 * // of the cell and vertically centered.
	 * var cell = new UI.CellView();
	 * cell.setTextGravity([0.1, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @returns {void}
	 * @see UI.CellView#getTextGravity
	 * @see UI.Style#setTextGravity
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of the
	 * cell text.
	 * @name UI.CellView#getTextSize
	 * @function
	 * @returns {Number} The current size, in pixels, of the cell text.
	 * @see UI.CellView#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textSize` property, which specifies the size, in pixels, of the cell text.
	 * @name UI.CellView#setTextSize
	 * @function
	 * @example
	 * var cell = new UI.CellView();
	 * var textSize = 24;
	 * cell.setTextSize(textSize);
	 * @param {Number} textSize The new size, in pixels, of the cell text.
	 * @returns {void}
	 * @see UI.CellView#getTextSize
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * Retrieve the value of the `textInsets` property, which contains insets that are used to clip
	 * the edges of the cell text.
	 * @name UI.CellView#getTextInsets
	 * @function
	 * @returns {Number[]} The current text insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the button.
	 * @see UI.CellView#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textInsets` property, which contains insets that are used to clip the edges of the
	 * cell text. The inset is specified as an array of floats, starting with the top inset and
	 * going clockwise around the text.
	 * @name UI.CellView#setTextInsets
	 * @function
	 * @example
	 * // Add a two-pixel inset to the left and right sides of the text.
	 * var cell = new UI.CellView();
	 * cell.setTextInsets([0.0, 2.0, 0.0, 2.0]);
	 * @param {Number[]} textInsets The new text insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the button.
	 * @returns {void}
	 * @see UI.CellView#getTextInsets
 	 * @status iOS, Android, Flash, Test
	 */
	CellView.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckBox'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/CheckBox.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var gradients = {
	'normal': {
		"gradient": ["FFED 0.000", "FFA4 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'pressed': {
		"innerShadow": "FF00 6.0 {0.0,-1.0}",
		"gradient": ["FF80 0.000", "FF80 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'checked': {"innerLine":"FF27A227 2.0","corners":"3.0 3.0 3.0 3.0","insets":"{4.0,4.0,4.0,4.0}","gradient":["FF2CFF2B 0.000","FF179117 1.000"],"outerShadow":"0000 0.0 {0.0,0.0}","outerLine":"FF51 3.0","innerShadow":"FF97FE97 1.0 {0.0,0.0}"},
	'checkedpressed': {"innerShadow":"FF0F610F 5.0 {0.0,-1.0}","gradient":["FF179117 0.000","FF179117 1.000"],"insets":"{4.0,4.0,4.0,4.0}","outerLine":"FF2B512B 3.0","outerShadow":"0000 0.0 {0.0,0.0}","corners":"3.0 3.0 3.0 3.0"},
	'disabled': {
		"innerShadow": "0000 0.0 {0.0,0.0}",
		"gradient": ["66B6 0.000", "66CA 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "7FE0 3.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	}
};

var CheckBox = exports.CheckBox = AbstractView.subclass(
/** @lends UI.CheckBox.prototype */
{
	'type':'checkbox',

	/**
	 * @class The `UI.CheckBox` class provides checkboxes in a user interface. The methods in this
	 * class control how checkboxes are displayed and positioned, and they provide access to the
	 * checkbox's current state.
	 * 
	 * A `UI.CheckBox` object's appearance can change automatically when the cell's view state 
	 * changes. For example, the border around a checkbox can change automatically when the checkbox
	 * gains focus or is selected. To implement this feature, your application can call a
	 * `UI.CheckBox` setter method more than once, passing a different value in the `flags`
	 * parameter each time. In addition, your application can include properties for multiple view
	 * states in the constructor. See the `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.Checkbox#setImageInsets}` to control an
	 * image's insets within the checkbox, the insets you specify will apply in all view states.
	 * @name UI.CheckBox
	 * @constructs Create a checkbox.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.CheckBox object without setting any of its properties.
	 * var checkBox = new UI.CheckBox();
	 * @example
	 * // Create a new UI.CheckBox object, setting its label text.
	 * var checkBox = new UI.CheckBox({
	 *     text: "Expert Mode"
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.CheckBox` object.
	 * @since 1.0
	 */

	/** @ignore */
	initialize: function($super, properties) {
		if (CheckBox._init) CheckBox._init();
        this._checked = false;
        $super();
		this.setGradient(gradients['normal'], Commands.State.Normal);
		this.setGradient(gradients['pressed'], Commands.State.Pressed);
		this.setGradient(gradients['checked'], Commands.State.Checked);
		this.setGradient(gradients['checkedpressed'], Commands.State.Checked | Commands.State.Pressed);
		this.setGradient(gradients['disabled'], Commands.State.Disabled);
		this.setImageInsets([4,4,4,4]);
		this.setAttributes(properties);
    },
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
    performEventCallback: function($super, event) {
		if (event.eventType == 'click') {
        	this._checked = event.checked;
			if (this._checked) {
				this._state = this._state | Commands.State.Checked;
			} else {
				this._state = this._state & ~Commands.State.Checked;
			}
		}
		$super(event);
    }
});

CheckBox._init = function() {
	delete CheckBox._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * Retrieve the value of the `image` property, which links to an image that represents the 
	 * checkbox for a specified view state.
	 * @name UI.CheckBox#getImage
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The path to the checkbox image for the specified view state.
	 * @see UI.CheckBox#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `image` property, which links to an image that represents the checkbox for a
	 * specified view state.
	 * @name UI.CheckBox#setImage
	 * @example
	 * var checkBox = new UI.CheckBox();        
	 * checkBox.setImage("./Content/checkBox.png");
	 * @see UI.CheckBox#getImage
	 * @param {String} imageURL The path to the new image.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this image. To specify an image for a view that is in multiple states, you can use the 
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('image', Commands.setImage);
	CheckBox.bindPropertyState('image', 'checked', Commands.State.Checked);
	/**
	 * Retrieve the value of the `imageInsets` property, which contains insets that are used to clip
	 * the edges of the checkbox image.
	 * @name UI.CheckBox#getImageInsets
	 * @function
	 * @returns {Number[]} The current image insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the checkbox.
	 * @see UI.CheckBox#setImageInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `imageInsets` property, which contains insets that are used to clip the edges of the
	 * checkbox image. The inset is specified as an array of floats, starting with the top inset and
	 * going clockwise around the checkbox.
	 * @name UI.CheckBox#setImageInsets
	 * @function
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * // Use a top inset of 10, a right inset of 20, a bottom inset of 15, and
	 * // a left inset of 5.
	 * checkBox.setImageInsets([10, 20, 15, 5]);
	 * @param {Number[]} imageInsets The new image insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the checkbox.
	 * @returns {void}
	 * @see UI.CheckBox#getImageInsets
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);

	/**
	 * Set the function to call when an `imageLoaded` event occurs. This event occurs when an image
	 * that is specified for a `UI.CheckBox` finishes loading.
	 * @name UI.CheckBox#setOnImageLoaded
	 * @event
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setOnImageLoaded(function(event) {
	 *     if (event.error) {
	 *         console.log("Unable to load image: " + event.error + ": " +
	 *             event.message);
	 *     } else {
	 *         console.log("Loaded an image with width=" + event.width + 
	 *         " and height=" + event.height);
	 *     }
	 * });
	 * @cb {Function} imageLoadedCallback The function to call when an `imageLoaded` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} [event.error] A code identifying the error, if any.
	 * @cb-param {Number} [event.height] The height of the image that was loaded.
	 * @cb-param {String} [event.message] A message describing the error, if any.
	 * @cb-param {Number} [event.width] The width of the image that was loaded.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.CheckBox#event:getOnImageLoaded
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoaded` event occurs.
	 * @name UI.CheckBox#getOnImageLoaded
	 * @event
	 * @returns {Function} The current function to call when an `imageLoaded` event occurs.
	 * @see UI.CheckBox#event:setOnImageLoaded
	 * @since 1.6
	 */
	CheckBox.registerEventType('imageLoaded');
	
	/**
	 * Set a function to call when an `imageLoadFailed` event occurs. This event occurs when an
	 * image that is specified for a `UI.CheckBox` cannot be loaded.
	 * @name UI.CheckBox#setOnImageLoadFailed
	 * @event
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setOnImageLoadFailed(function(event) {
	 *     console.log("An error occurred when loading " + event.url + 
	 *         ": " + event.error + ": " + event.message);
	 * });
	 * @cb {Function} imageLoadFailedCallback The function to call when an `imageLoadFailed` event
	 *		occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {UI.Commands#ResourceError} event.error A code identifying the error.
	 * @cb-param {String} event.url The URL for the image.
	 * @cb-param {String} event.message A message describing the error.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.CheckBox#event:getOnImageLoadFailed
	 * @since 1.6
	 */
	/**
	 * Retrieve the function to call when an `imageLoadFailed` event occurs.
	 * @name UI.CheckBox#getOnImageLoadFailed
	 * @event
	 * @returns {Function} The current function to call when an `imageLoadFailed` event occurs.
	 * @see UI.CheckBox#event:setOnImageLoadFailed
	 * @since 1.6
	 */
	CheckBox.registerEventType('imageLoadFailed');
	
	
	/**
	 * Retrieve the value of the `text` property, which defines text for the checkbox's label in a 
	 * specified view state.
	 * @name UI.CheckBox#getText
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text for the checkbox's label for the specified view state.
	 * @see UI.CheckBox#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `text` property, which defines text for the checkbox's label in a specified view 
	 * state.
	 * @name UI.CheckBox#setText
	 * @function
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setText("Flip screen");
	 * @param {String} text The new text for the checkbox's label.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @see UI.CheckBox#getText
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizePropertyWithState('text', Commands.setText);
	CheckBox.bindPropertyState('text', 'checked', Commands.State.Checked);
	/**
	 * Retrieve the value of the `textColor` property, which defines the text color for the 
	 * checkbox's label in a specified view state.
	 * @name UI.CheckBox#getTextColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text color for the specified view state, in hexidecimal RGB
	 *		format.
	 * @see UI.CheckBox#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textColor` property, which defines the text color for the checkbox's label in a 
	 * specified view state.
	 * @name UI.CheckBox#setTextColor
	 * @function 
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setTextColor("FFFFFF");
	 * @param {String} textColor The new text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can 
	 * 		use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CheckBox#getTextColor
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizePropertyWithState('textColor', Commands.setTextColor);
	CheckBox.bindPropertyState('textColor', 'checked', Commands.State.Checked);
	/**
	 * Retrieve the value of the `textShadow` property, which defines the color and size of shadows
	 * on the checkbox's label in a specified view state.
	 * @name UI.CheckBox#getTextShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text shadow.
	 * @see UI.CheckBox#setTextShadow	
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textShadow` property, which defines the color and size of shadows on the checkbox's 
	 * label in a specified view state. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0, 
	 * -1.0}"`) that contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.CheckBox#setTextShadow
	 * @function
	 * @example
	 * // Use a white text shadow with a two-pixel blur, shifted up one pixel
	 * // along the Y axis.
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} textShadow The new text shadow, in the format specified above.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.CheckBox#getTextShadow
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	CheckBox.bindPropertyState('textShadow', 'checked', Commands.State.Checked);
	/**
	 * Retrieve the value of the `textGravity` property, which defines how the checkbox's label is
	 * positioned within the viewable area.
	 * @name UI.CheckBox#getTextGravity
	 * @function
	 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.CheckBox#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textGravity` property, which defines how the checkbox label is positioned within the
	 * viewable area. The text gravity is defined as two floats, one for the X (horizontal) axis and
	 * one for the Y (vertical) axis. Each float represents a percentage of the whitespace 
	 * surrounding the text.
	 * 
	 * By default, the image gravity is set to `[0.5, 0.5]`, which centers the text within the
	 * viewable area.
	 * @name UI.CheckBox#setTextGravity
	 * @function
	 * @example
	 * // Position the checkbox label so it is horizontally pushed towards the
	 * // left side of the viewable area and vertically centered.
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setTextGravity([0.1, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @see UI.CheckBox#getTextGravity
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of the
	 * checkbox label.
	 * @name UI.CheckBox#getTextSize
	 * @returns {Number} The current size, in pixels, of the checkbox label.
	 * @see UI.CheckBox#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * Set the `textSize` property, which specifies the size, in pixels, of the checkbox label.
	 * @name UI.CheckBox#setTextSize
	 * @function
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * var textSize = 12;
	 * checkBox.setTextSize(textSize);
	 * @param {Number} textSize The new size, in pixels, of the checkbox label.
	 * @see UI.CheckBox#getTextSize
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * Retrieve the value of the `textFont` property, which defines the font that is used for the
	 * checkbox label in a specified view state.
	 * @name UI.CheckBox#getTextFont
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The name of the current font for the specified view state.
	 * @see UI.CheckBox#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textFont` property, which defines the font that is used for the checkbox label in a
	 * specified view state.
	 * @name UI.CheckBox#setTextFont
	 * @function
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setTextFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this font. To specify a font for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @see UI.CheckBox#getTextFont
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizePropertyWithState('textFont', Commands.setTextFont);
	CheckBox.bindPropertyState('textFont', 'checked', Commands.State.Checked);
	/**
	 * Retrieve the value of the `textInsets` property, which contains insets that are used to clip
	 * the edges of the checkbox label.
	 * @name UI.CheckBox#getTextInsets
	 * @function
	 * @returns {Number[]} The current text insets. Specified as an array of four floats, starting
	 *		with the top inset and going clockwise around the checkbox label.
	 * @see UI.CheckBox#setTextInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textInsets` property, which contains insets that are used to clip the edges of the
	 * checkbox label. The inset is specified as an array of floats, starting with the top inset and
	 * going clockwise around the checkbox label.
	 * @name UI.CheckBox#setTextInsets
	 * @function
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * var insetLeft = 10;
	 * checkBox.setTextInsets([0, 0, 0, insetLeft]);
	 * @param {Number[]} textInsets The new text insets. Specified as an array of four floats, 
	 *		starting with the top inset and going clockwise around the button.
	 * @see UI.CheckBox#getTextInsets
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */
	CheckBox.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// Corresponding event is onClick
	/**
	 * Retrieve the value of the `checked` property, which indicates whether the checkbox is
	 * currently checked.
	 * @name UI.CheckBox#getChecked
	 * @function
	 * @returns {Boolean} Set to `true` if the checkbox is currently checked.
	 * @see UI.CheckBox#setChecked
	 * @status Javascript, iOS, Android, Flash
	 */
	/**
	 * Set the `checked` property, which indicates whether the checkbox is currently checked.
	 * @name UI.CheckBox#setChecked
	 * @function 
	 * @example
	 * var checkBox = new UI.CheckBox();
	 * checkBox.setChecked(true);
	 * @param {Boolean} checked Set to `true` if the checkbox is currently checked.
	 * @returns {void}
	 * @see UI.CheckBox#getChecked
	 * @status iOS, Android, Flash
	 */
	CheckBox.synthesizeProperty('checked', Commands.setChecked);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditText'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditText'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditText'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/EditText.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditText = exports.EditText = AbstractView.subclass(
/** @lends UI.EditText.prototype */
{
	'type':'edittext',
	/**
	 * @class The `UI.EditText` class creates single-line text fields in a user interface. The 
	 * methods in this class control how text fields are displayed and positioned, and they provide
	 * access to the user's input.
	 *
	 * A `UI.EditText` object's appearance can change automatically when its view state changes. For
	 * example, the field's text color can change automatically when the field gains focus or is
	 * selected. To implement this feature, your application can call a `UI.EditText` setter method 
	 * more than once, passing a different value in the `flags` parameter each time. In addition, 
	 * your application can include properties for multiple view states in the constructor. See the
	 * `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.EditText#setPlaceholder}` to control a
	 * field's placeholder text, the placeholder text you specify will apply in all view states.
	 *
	 * **Note**: As of version 1.6, `UI.EditText` objects no longer fire `click` events, and calling
	 * `UI.EditText.setOnClick()` will have no effect.
	 * @name UI.EditText
	 * @constructs Create a text field.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.EditText object without setting any of its properties.
	 * var textField = new UI.EditText();
	 * @example
	 * // Create a new UI.EditText object, setting its placeholder text.
	 * var placeholderText = "Email address";
	 * var textField = new UI.EditText({
	 *     placeholder: placeholderText
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.EditText` object.
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (EditText._init) EditText._init();
		$super(properties);
		this.setOnClick = this.setOnClickCancel = function() {
			NgLogE("WARNING: Click and ClickCancel events do not work on EditText objects.");
		};
	},
	
	
	'InputTypes': Commands.InputType,
	'EnterKeyTypes': Commands.EnterKeyType,
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					/* falls through */
				default: $super(event);
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the `text` property, which contains the user's text input.
	 * @function
	 * @returns {String} The current text input.
	 * @see UI.EditText#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the `text` property, which contains the user's text input. You can use this method to
	 * fill in fields whose value is already known, such as a user's name.
	 * @function
	 * @example
	 * var textField = new UI.EditText();
	 * var firstName = "John";
	 * textField.setText(firstName);
	 * @param {String} text The text that the user can edit.
	 * @returns {void}
	 * @see UI.EditText#getText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	focus: function() {
		Commands.setFocus.call(this, true);
	},

	blur: function() {
		Commands.setFocus.call(this, false);
	},
	
	setFocus: function(focus) {
		try {
			throw new Error("EditText.setFocus is deprecated and should not be used. Please use .focus() and .blur().");
		} catch (e) {
			NgHandleException(e);
		}
		Commands.setFocus.call(this, focus);
	}
});

EditText._init = function() {
	delete EditText._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditText.registerAccessors('text', EditText.prototype.getText, EditText.prototype.setText);
	
	/**
	 * Retrieve the value of the `placeholder` property, which defines text that will be displayed
	 * as a placeholder before the user types in the text field.
	 * @name UI.EditText#getPlaceholder
	 * @function
	 * @returns {String} The current placeholder text.
	 * @see UI.EditText#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `placeholder` property, which defines text that will be displayed as a placeholder
	 * before the user types in the text field.
	 * @name UI.EditText#setPlaceholder
	 * @function
	 * @example
	 * var textField = new UI.EditText();
	 * var placeholderText = "Email address";
	 * textField.setPlaceholder(placeholderText);
	 * @param {String} placeholder The new placeholder text.
	 * @returns {void}
	 * @see UI.EditText#getPlaceholder
	 */
	EditText.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * Retrieve the value of the `placeholderColor` property, which defines the text color for the
	 * placeholder text.
	 * @name UI.EditText#getPlaceholderColor
	 * @function
	 * @returns {String} The current placeholder text color, in hexidecimal RGB format.
	 * @see UI.EditText#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 */	
	/**
	 * Set the `placeholderColor` property, which defines the text color for the placeholder text.
	 * @name UI.EditText#setPlaceholderColor
	 * @function
	 * @example
	 * var textField = new UI.EditText();
	 * textField.setPlaceholderColor("666666");
	 * @param {String} placeholderColor The new placeholder text color, in hexidecimal RGB format.
	 * @see UI.EditText#getPlaceholderColor
	 * @returns {void}
	 */
	EditText.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * Retrieve the value of the `placeholderShadow` property, which defines the color and size of
	 * shadows on the placeholder text.
	 * @name UI.EditText#getPlaceholderShadow
	 * @function
	 * @returns {String} The current placeholder text shadow.
	 * @see UI.EditText#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `placeholderShadow` property, which defines the color and size of shadows on the
	 * placeholder text. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0, -1.0}"`) that
	 * contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.EditText#setPlaceholderShadow
	 * @function
	 * @example
	 * // Use a white text shadow with a two-pixel blur, shifted up one pixel.
	 * var textField = new UI.EditText();
	 * textField.setPlaceholderShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} placeholderShadow The new placeholder text shadow.
	 * @see UI.EditText#getPlaceholderShadow
	 * @returns {void}
	 */
	 EditText.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	// ==== Behavior
	/**
	 * Retrieve the value of the `inputType` property, which defines the type of text input that
	 * the field will contain.
	 * @name UI.EditText#getInputType
	 * @function
	 * @returns {UI.Commands#InputType} The current input type.
	 * @see UI.EditText#setInputType
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `inputType` property, which defines the type of text input that the field will
	 * contain. For devices that have soft keyboards, the device uses this value and the value of
	 * the `enterKeyType` property to control which keyboard is displayed to the user.
	 * @name UI.EditText#setInputType
	 * @param {UI.Commands#InputType} inputType The new input type.
	 * @see UI.Commands#InputType
	 * @see UI.EditText#getInputType
	 * @function
	 * @returns {void}
	 */	
	 EditText.synthesizeProperty('inputType', Commands.setInputType);
	/**
	 * Retrieve the value of the `enterKeyType` property, which defines the Enter key's behavior for
	 * the field.
	 * @name UI.EditText#getEnterKeyType
	 * @function
	 * @returns {UI.Commands#EnterKeyType} The current behavior of the Enter key.
	 * @see UI.EditText#setEnterKeyType
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `enterKeyType` property, which defines the Enter key's behavior for the field. For 
	 * devices that have soft keyboards, the device uses this value and the value of the 
	 * `inputType` property to control which keyboard is displayed to the user.
	 * @name UI.EditText#setEnterKeyType
	 * @function
	 * @param {UI.Commands#EnterKeyType} enterKeyType The new behavior of the Enter key.
	 * @see UI.Commands#EnterKeyType
	 * @see UI.EditText#getEnterKeyType
	 * @returns {void}
	 */
	EditText.synthesizeProperty('enterKeyType', Commands.setEnterKeyType);
	
	// ==== Appearance
	/**
	 * Retrieve the value of the `textColor` property, which defines the text color for the field
	 * in a specified view state.
	 * @name UI.EditText#getTextColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text color for the specified view state, in hexidecimal RGB
	 *		format.
	 * @see UI.EditText#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textColor` property, which defines the text color for the button in a specified view
	 * state.
	 * @name UI.EditText#setTextColor
	 * @function
	 * @example
	 * var textField = new UI.EditText();
	 * textField.setTextColor("FFFFFF");
	 * @param {String} textColor The new text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can 
	 * 		use the `|` operator to combine multiple flags.
	 * @see UI.EditText#getTextColor
	 * @returns {void}
	 * @status iOS, Flash, Test
	 */
	EditText.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * Retrieve the value of the `textShadow` property, which defines the color and size of shadows
	 * on the user's text input in a specified view state.
	 * @name UI.EditText#getTextShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text shadow.
	 * @see UI.EditText#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textShadow` property, which defines the color and size of shadows on the user's text
	 * input in a specified view state. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0,
	 * -1.0}"`) that contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.EditText#setTextShadow
	 * @example
	 * // Use a white text shadow with a two-pixel blur, shifted up one pixel.
	 * var textField = new UI.EditText();
	 * textField.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} textShadow The new text shadow, in the format specified above.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @see UI.EditText#getTextShadow
	 * @returns {void}
	 * @status iOS, Flash, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * Retrieve the value of the `textGravity` property, which defines how text is positioned within
	 * the field.
	 * @name UI.EditText#getTextGravity
	 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.EditText#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * Set the `textGravity` property, which defines how text is positioned within the field. The
	 * text gravity is defined as two floats, one for the X (horizontal) axis and one for the Y
	 * (vertical) axis. Each float represents a percentage of the whitespace surrounding the text.
	 * 
	 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
	 * text, with the remainder placed to the right of the text. For the Y axis, the specified 
	 * percentage of whitespace will be placed above the text, with the remainder placed below the
	 * text.
	 * 
	 * By default, the text gravity is set to `[0.0, 0.5]`, which positions the text adjacent to
	 * the left side of the field and vertically centers the text.
	 * @name UI.EditText#setTextGravity
	 * @example
	 * // Set the text to be horizontally and vertically centered
	 * var textField = new UI.EditText();
	 * textField.setTextGravity([0.5, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @see UI.EditText#getTextGravity
     * @status Flash
	 * @function
	 * @returns {void}
	 */
	EditText.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of the
	 * field's text.
	 * @name UI.EditText#getTextSize
	 * @function
	 * @returns {Number} The current size, in pixels, of the field's text.
	 * @see UI.EditText#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textSize` property, which specifies the size, in pixels, of the field's text.
	 * @name UI.EditText#setTextSize
	 * @function
	 * @example
	 * var textField = new UI.EditText();
	 * var textSize = 12;
	 * textField.setTextSize(textSize);
	 * @param {Number} textSize The new size, in pixels, of the field's text.
	 * @returns {void}
	 * @see UI.EditText#getTextSize
	 * @status iOS, Flash, Test
	 */
	EditText.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * Retrieve the value of the `textFont` property, which defines the font that is used for the
	 * field's text.
	 * @name UI.EditText#getTextFont
	 * @function
	 * @returns {String} The name of the current font.
	 * @see UI.EditText#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textFont` property, which defines the font that is used for the field's text.
	 * @name UI.EditText#setTextFont
	 * @function
	 * @example
	 * var textField = new UI.EditText();
	 * textField.setTextFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @see UI.EditText#getTextFont
	 * @returns {void}
	 * @status iOS, Flash, Test
	 */
	EditText.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * Retrieve the function to call when a `change` event occurs. This event occurs when the user
	 * changes the value of the text field.
	 * @name UI.EditText#getOnChange
	 * @event
	 * @returns {Function} The current function to call when a `change` event occurs.
	 * @see UI.EditText#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set a function to call when a `change` event occurs. This event occurs when the user changes
	 * the value of the text field.
	 * @name UI.EditText#setOnChange
	 * @event
	 * @example
	 * var textField = new UI.EditText();
	 * var text = "";
	 * textField.setOnChange(function(event) { 
	 *     text = event.text;
	 * });
	 * @cb {Function} changeCallback The function to call when a `change` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.text The new value of the text field.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.EditText#event:getOnChange
	 * @status iOS, Flash
	 */
	EditText.registerEventType('change');
	/**
	 * Retrieve the function to call when a `focus` event occurs. This event occurs when the text
	 * field gains focus.
	 * @name UI.EditText#getOnFocus 
	 * @event	 
	 * @returns {Function} The current function to call when a `focus` event occurs.
	 * @see UI.EditText#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the function to call when a `focus` event occurs. This event occurs when the text
	 * field gains focus.
	 * @name UI.EditText#setOnFocus
	 * @event
	 * @example
	 * var textField = new UI.EditText();
	 * textField.setOnFocus(function() {
	 *     textField.addState(UI.Commands.State.Focused);
	 * });
	 * @cb {Function} focusCallback The function to call when a `focus` event occurs.
	 * @cb-returns {void}
	 * @see UI.EditText#event:getOnFocus
	 * @status Flash
	 * @returns {void}
	 */
	EditText.registerEventType('focus');
	/**
	 * Retrieve the function to call when a `blur` event occurs. This event occurs when the text
	 * field loses focus.
	 *
	 * **Note**: This event is not guaranteed to occur on Android devices.
	 * @name UI.EditText#getOnBlur
	 * @event
	 * @returns {Function} The current function to call when a `blur` event occurs.
	 * @see UI.EditText#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the function to call when a `blur` event occurs. This event occurs when the text field
	 * loses focus.
	 *
	 * **Note**: This event is not guaranteed to occur on Android devices.
	 * @name UI.EditText#setOnBlur
	 * @event
	 * @example
	 * var textField = new UI.EditText();
	 * textField.setOnBlur(function() {
	 *     textField.clearState(UI.Commands.State.Focused);
	 * });
	 * @cb {Function} blurCallback The current function to call when a `blur` event occurs.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.EditText#event:getOnBlur
	 */
	EditText.registerEventType('blur');

	/**
	 * Retrieve the function to call when an `action` event occurs. This event occurs when the user
	 * presses the Return or Enter key.
	 * 
	 * **Note**: This event is not guaranteed to occur on Android devices.
	 * @name UI.EditText#getOnAction
	 * @event
	 * @returns {Function} The current function to call when an `action` event occurs.
	 * @see UI.EditText#event:setOnAction
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the function to call when an `action` event occurs. This event occurs when the user
	 * presses the Return or Enter key.
	 * 
	 * **Note**: This event is not guaranteed to occur on Android devices.
	 * @name UI.EditText#setOnAction
	 * @event
	 * @example
	 * var textField = new UI.EditText();
	 * textField.setOnAction(function() {
	 *     console.log("The user pressed the Return key.");
	 * });
	 * @cb {Function} actionCallback The function to call when an `action` event occurs.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.EditText#event:getOnAction
	 * @since 1.1.6
	 */
	EditText.registerEventType('action');
	
	

};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditTextArea'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/EditTextArea.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditTextArea = exports.EditTextArea = AbstractView.subclass(
/** @lends UI.EditTextArea.prototype */
{
	'type':'edittextarea',
	/**
	 * @class The `UI.EditTextArea` class provides multi-line text areas in a user interface. The 
	 * methods in this class control how text areas are displayed and positioned, and they provide
	 * access to the user's input.
	 * 
	 * A `UI.EditTextArea` object's appearance can change automatically when its view state changes. 
	 * For example, the border around a text area can change automatically when the text area gains 
	 * focus or is selected. To implement this feature, your application can call a
	 * `UI.EditTextArea` setter method more than once, passing a different value in the `flags`
	 * parameter each time. In addition, your application can include properties for multiple view
	 * states in the constructor. See the `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.EditTextArea#setPlaceholder}` to set the
	 * text area's placeholder text, the placeholder text you specify will apply in all view states.
	 * @name UI.EditTextArea
	 * @constructs Create a text area.
	 * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.EditTextArea object without setting any of its properties.
	 * var textArea = new UI.EditTextArea();
	 * @example
	 * // Create a new UI.EditTextArea object, setting its placeholder text.
	 * var placeholderText = "Write your message here";
	 * var textArea = new UI.EditTextArea({
	 *     placeholder: placeholderText
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.EditTextArea` object.
	 * @since 1.1.1.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (EditTextArea._init) EditTextArea._init();
		$super(properties);
	},
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					$super(event);
					break;
				case 'focus':
				case 'blur':
					$super(event);
					break;
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the `text` property, which contains the user's text input.
	 * @function
	 * @returns {String} The current text input.
	 * @see UI.EditTextArea#setText
	 * @status Javascript, iOS, Flash
	 * @since 1.1.1.2
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the `text` property, which contains the user's text input. You can use this method to
	 * fill in a text area when its value is already known. For example, you can call this method
	 * when a user is updating previously entered text.
	 * @function
	 * @example
	 * var previousText = "This game is my favorite!";
	 * var textArea = new UI.EditTextArea();
	 * textArea.setText(previousText);
	 * @param {String} text The text that the user can edit.
	 * @returns {void}
	 * @see UI.EditTextArea#getText
	 * @status Javascript, iOS, Flash
	 * @since 1.1.1.2
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	focus: function() {
		Commands.setFocus.call(this, true);
	},

	blur: function() {
		Commands.setFocus.call(this, false);
	}
});

EditTextArea._init = function() {
	delete EditTextArea._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditTextArea.registerAccessors('text', EditTextArea.prototype.getText, EditTextArea.prototype.setText);
	
	/**
	 * Retrieve the value of the `placeholder` property, which defines text that will be displayed
	 * as a placeholder before the user types in the text area.
	 * @name UI.EditTextArea#getPlaceholder
	 * @function
	 * @returns {String} The current placeholder text.
	 * @see UI.EditTextArea#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `placeholder` property, which defines text that will be displayed as a placeholder
	 * before the user types in the text area.
	 * @name UI.EditTextArea#setPlaceholder
	 * @function
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * textArea.setPlaceholder("Write your message here");
	 * @param {String} placeholder The new placeholder text.
	 * @see UI.EditTextArea#getPlaceholder
	 * @returns {void}
	 */
	EditTextArea.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * Retrieve the value of the `placeholderColor` property, which defines the text color for the
	 * placeholder text.
	 * @name UI.EditTextArea#getPlaceholderColor
	 * @function
	 * @returns {String} The current placeholder text color, in hexidecimal RGB format.
	 * @see UI.EditTextArea#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 */	
	/**
	 * Set the `placeholderColor` property, which defines the text color for the placeholder text.
	 * @name UI.EditTextArea#setPlaceholderColor
	 * @function
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * textArea.setPlaceholderColor("666666");
	 * @param {String} placeholderColor The new placeholder text color, in hexidecimal RGB format.
	 * @see UI.EditTextArea#getPlaceholderColor
	 * @returns {void}
	 */
	EditTextArea.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * Retrieve the value of the `placeholderShadow` property, which defines the color and size of
	 * shadows on the placeholder text.
	 * @name UI.EditTextArea#getPlaceholderShadow
	 * @function
	 * @returns {String} The current placeholder text shadow.
	 * @see UI.EditTextArea#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `placeholderShadow` property, which defines the color and size of shadows on the
	 * placeholder text. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0, -1.0}"`) that
	 * contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.EditTextArea#setPlaceholderShadow
	 * @function
	 * @example
	 * // Use a white text shadow with a two-pixel blur, shifted up one pixel.
	 * var textArea = new UI.EditTextArea();
	 * textArea.setPlaceholderShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} placeholderShadow The new placeholder text shadow.
	 * @see UI.EditTextArea#getPlaceholderShadow
	 * @returns {void}
	 */
	 EditTextArea.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	
	// ==== Appearance
	/**
	 * Retrieve the value of the `textColor` property, which defines the text color for the text
	 * area in a specified view state.
	 * @name UI.EditTextArea#getTextColor
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text color for the specified view state, in hexidecimal RGB
	 *		format.
	 * @see UI.EditTextArea#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textColor` property, which defines the text color for the text area in a specified
	 * view state.
	 * @name UI.EditTextArea#setTextColor
	 * @function
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * textArea.setTextColor("FFFFFF");
	 * @param {String} textColor The new text color, in hexidecimal RGB format.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text color. To specify a text color for a view that is in multiple states, you can 
	 * 		use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.EditTextArea#getTextColor
	 * @status iOS, Flash, Test
	 */
	EditTextArea.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * Retrieve the value of the `textShadow` property, which defines the color and size of shadows
	 * on the user's text input in a specified view state.
	 * @name UI.EditTextArea#getTextShadow
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text shadow.
	 * @see UI.EditTextArea#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textShadow` property, which defines the color and size of shadows on the user's text
	 * input in a specified view state. Specified as a string (for example, `"FFFFFFFF 2.0 {0.0,
	 * -1.0}"`) that contains three values separated by spaces:
	 * 
	 * 1. A color in hexidecimal ARGB format (the alpha value followed by the RGB color).
	 * 2. The width, in pixels, to blur the edges of the shadow.
	 * 3. Two comma-separated floats enclosed in brackets:
	 *     1. The shadow's X offset from the left, in pixels.
	 *     2. The shadow's Y offset from the top, in pixels.
	 * @name UI.EditTextArea#setTextShadow
	 * @function
	 * @example
	 * // Use a white text shadow with a two-pixel blur, shifted up one pixel.
	 * var textArea = new UI.EditTextArea();
	 * textArea.setTextShadow("FFFFFFFF 2.0 {0.0, -1.0}");
	 * @param {String} textShadow The new text shadow, in the format specified above.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text shadow. To specify a text shadow for a view that is in multiple states, you  
	 * 		can use the `|` operator to combine multiple flags.
	 * @see UI.EditTextArea#getTextShadow
	 * @status iOS, Flash, Test
	 */
	EditTextArea.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * Retrieve the value of the `textGravity` property, which defines how text is positioned within
	 * the text area.
	 * @name UI.EditTextArea#getTextGravity
	 * @function
	 * @returns {Number[]} The current text gravity. Specified as an array of two floats, where the
	 *		first represents the X axis and the second represents the Y axis.
	 * @see UI.EditTextArea#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textGravity` property, which defines how text is positioned within the text area. 
	 * The text gravity is defined as two floats, one for the X (horizontal) axis and one for the Y
	 * (vertical) axis. Each float represents a percentage of the whitespace surrounding the text.
	 * 
	 * For the X axis, the specified percentage of whitespace will be placed to the left of the 
	 * text, with the remainder placed to the right of the text. For the Y axis, the specified 
	 * percentage of whitespace will be placed above the text, with the remainder placed below the
	 * text.
	 * 
	 * By default, the text gravity is set to `[0.0, 0.0]`, which positions the text at the top
	 * left corner of the text area.
	 * @name UI.EditTextArea#setTextGravity
	 * @function
	 * @example
	 * // Set the text to be centered within the text area.
	 * var textArea = new UI.EditTextArea();
	 * textArea.setTextGravity([0.5, 0.5]);
	 * @param {Number[]|UI.ViewGeometry#Gravity} textGravity The new text gravity. Specified as an 
	 *		array of two floats, where the first represents the X axis and the second represents the
	 *		Y axis. You can also specify an enumerated value of `{@link UI.ViewGeometry#Gravity}` in
	 *		place of the array.
	 * @see UI.EditTextArea#getTextGravity
	 * @returns {void}
     * @status Flash
	 */
	EditTextArea.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * Retrieve the value of the `textSize` property, which specifies the size, in pixels, of the
	 * text area's text.
	 * @name UI.EditTextArea#getTextSize
	 * @function
	 * @returns {Number} The current size, in pixels, of the text area's text.
	 * @see UI.EditTextArea#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textSize` property, which specifies the size, in pixels, of the field's text.
	 * @name UI.EditTextArea#setTextSize
	 * @function
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * var textSize = 12;
	 * textArea.setTextSize(textSize);
	 * @param {Number} textSize The new size, in pixels, of the text area's text.
	 * @returns {void}
	 * @see UI.EditTextArea#getTextSize
	 * @status iOS, Flash, Test
	 */
	EditTextArea.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * Retrieve the value of the `textFont` property, which defines the font that is used for the
	 * text area's text.
	 * @name UI.EditTextArea#getTextFont
	 * @function
	 * @returns {String} The name of the current font.
	 * @see UI.EditTextArea#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the `textFont` property, which defines the font that is used for the text area's text.
	 * @name UI.EditTextArea#setTextFont
	 * @function
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * textArea.setTextFont("DroidSans");
	 * @param {String} textFont The name of the new font.
	 * @returns {void}
	 * @see UI.EditTextArea#getTextFont
	 * @status iOS, Flash, Test
	 */
	EditTextArea.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * Retrieve the function to call when a `change` event occurs. This event occurs when the user
	 * changes the value of the text area.
	 * @name UI.EditTextArea#getOnChange
	 * @event
	 * @returns {Function} The current function to call when a `change` event occurs.
	 * @see UI.EditTextArea#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set a function to call when a `change` event occurs. This event occurs when the user changes
	 * the value of the text area.
	 * @name UI.EditTextArea#setOnChange
	 * @event
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * textArea.setOnChange(function(event) { 
	 *     console.log(event.text);
	 * });
	 * @cb {Function} changeCallback The function to call when a `change` event occurs.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {String} event.text The new value of the text area.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.EditTextArea#event:getOnChange
	 * @status iOS, Flash
	 */
	EditTextArea.registerEventType('change');
	/**
	 * Retrieve the function to call when a `focus` event occurs. This event occurs when the text
	 * area gains focus.
	 * @name UI.EditTextArea#getOnFocus 
	 * @event	 
	 * @returns {Function} The current function to call when a `focus` event occurs.
	 * @see UI.EditTextArea#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the function to call when a `focus` event occurs. This event occurs when the text
	 * area gains focus.
	 * @name UI.EditTextArea#setOnFocus
	 * @event
	 * @example
	 * var textArea = new UI.EditText();
	 * textArea.setOnFocus(function() {
	 *     textArea.addState(UI.Commands.State.Focused);
	 * });
	 * @cb {Function} focusCallback The function to call when a `focus` event occurs.
	 * @cb-returns {void}
	 * @status Flash
	 * @returns {void}
	 * @see UI.EditTextArea#event:getOnFocus
	 */
	EditTextArea.registerEventType('focus');
	/**
	 * Retrieve the function to call when a `blur` event occurs. This event occurs when the text
	 * area loses focus.
	 * @name UI.EditTextArea#getOnBlur
	 * @event
	 * @returns {Function} The current function to call when a `blur` event occurs.
	 * @see UI.EditTextArea#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Set the function to call when a `blur` event occurs. This event occurs when the text area
	 * loses focus.
	 * @name UI.EditTextArea#setOnBlur
	 * @event
	 * @example
	 * var textArea = new UI.EditTextArea();
	 * textArea.setOnBlur(function() {
	 *     textArea.clearState(UI.Commands.State.Focused);
	 * });
	 * @cb {Function} blurCallback The current function to call when a `blur` event occurs.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.EditTextArea#event:getOnBlur
	 */
	EditTextArea.registerEventType('blur');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DateField'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DateField'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DateField'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/DateField.js';

var EditText = require('NGCore/Client/UI/EditText').EditText;

function isValidDate(d) {
	if ( !d || !d.getTime )
		return false; 
		
	return !isNaN(d.getTime());
}

/*
 Date Parser code to handle WebKit's lack of following the implementation.
 http://stackoverflow.com/questions/3085937/safari-js-cannot-parse-yyyy-mm-dd-date-format/3085993#3085993
 */
function parseDate(input, format) {
  format = format || 'yyyy-mm-dd'; // default format
  var parts = input.match(/(\d+)/g), 
      i = 0, fmt = {};
  if (parts === null) { //Don't throw exceptions if the input isn't parsable
	return null;
  }
  // extract date-part indexes from the format
  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++;});
  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
}
/*
 * Our Code is not actually passing its format to parseDate (already had all the code to rejigger the date pieces to yyyy-mm-dd before I realized the problems with webkit's date constructor / date string parser). -fbartho 2010-11-30
 */

exports.DateField = EditText.subclass(
/** @lends UI.DateField.prototype */
{
	classname: "DateField",
	/**
	 * @class The `UI.DateField` class creates text entry fields for dates. The user's input is 
	 * normalized to a format specified by the application. By default, the date is normalized to
	 * the format `yyyy-mm-dd`, where `yyyy` is the four-digit year, `mm` is the two-digit month, 
	 * and `dd` is the two-digit day. 
	 * @name UI.DateField
	 * @augments UI.EditText
	 * @constructs Create a date field.
	 * @example
	 * // Create a new UI.DateField object without setting any of its properties.
	 * var dateField = new UI.DateField();
	 * @example
	 * // Create a new UI.DateField object, setting the date format and text color.
	 * var dateField = new UI.DateField({
	 *     dateFormat: "mm-dd-yyyy",
	 *     textColor: "CCCCCC"
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.DateField` object. See `{@link UI.EditText}` for information about properties that
	 *		are supported.
	 * @since 1.0
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		var constructorRVal = $super(properties);
		this.setDateFormat("yyyy-mm-dd");
		this.ondatechange = function(newDate){};
		
		this.setInputType(EditText.InputTypes.Date);
		return constructorRVal;
	},
    
	/**
	 * Trigger an event callback for this `DateField`.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} event The event that triggers a callback function.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'change') {
				// Make Sure the Text is changed (call $super), before we call our listeners!
				var oldText = this.getText();
				$super(event);
				this.ondatechange(this.getDate());
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	_filterAndInsertDashes:function(oldText,newText) {
		var t = newText;
		if((oldText.length == t.length + 1) && oldText[oldText.length-1] == "-") {
			//This lets the user backspace through - marks as if they weren't there.
			// fbartho: Currently not in use! 2010-12-10
			//this.setText(t.substring(0,t.length-1));
			return t.substring(0,t.length-1);
		}
		
		var nt = "";
		var j = 0;
		for(var i = 0; i < t.length && nt.length < this.formatStr.length; i++,j++) {
			if(j < this.formatStr.length && this.formatStr[j] == "-" && i < t.length){
				if(t[i] == "-"|| t[i] == "/"){
					nt+="-";
					continue;
				}
				else {
					nt+="-";
					nt+=t[i];
					continue;
				}
			}
			if ( i < t.length && (t[i] == "-" || t[i] == "/") ) {
				--j; 
				continue;
			}
			nt+=t[i];
		}
		
		if(this.formatStr.length > j && (this.formatStr[j] == "-" || this.formatStr[j] == "/") ) {
			nt+="-";
		}
		
		return nt;
	},
	/**
	 * Normalize the format of the user's text input, converting forward slashes to dashes.
	 * @returns {void}
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */    
	normalizeDateLayout:function() {
		var ot = this.getText();
		var nt = this._filterAndInsertDashes(this.getText(),this.getText());
		if(ot!=nt)this.setText(nt);
	},
	/**
	 * Retrieve the current date format that will be used to normalize the user's input.
	 * @returns {String} The current date format that will be used to normalize the user's input.
	 * @see UI.DateField#setDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	getDateFormat:function() {
		return this.formatStr;
	},
	/**
	 * Set the date format that will be used to normalize the user's input. Valid values include
	 * the following, where `mm` is the two-digit month, `dd` is the two-digit day, and `yyyy` is
	 * the four-digit year:
	 * 
	 * + `yyyy-mm-dd`
	 * + `mm-yyyy`
	 * + `yyyy-mm`
	 * + `mm-dd-yyyy`
	 * + `dd-mm-yyyy`
	 * @param {String} dateFormat The new date format that will be used to normalize the user's
	 *		input.
	 * @returns {void}
	 * @see UI.DateField#getDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 * @since 1.0
	 */
	setDateFormat:function(fStr) 
	{
		if (   fStr != "yyyy-mm-dd"
			&& fStr != "mm-yyyy"
			&& fStr != "yyyy-mm"
			&& fStr != "mm-dd-yyyy"
			&& fStr != "dd-mm-yyyy" ) {
			// Invalid Format String Error Case
			NgLogD("Error: Invalid Format String set for Birthdate Field!!\n");
			
			return;
		}
		
		this.formatStr = fStr;
		this.setPlaceholder(this.formatStr);
		return;
	},
	/**
	 * Retrieve the user's input, normalized to the date field's current date format.
	 * @returns {String} The user's text input, normalized to the current date format for this
	 *		text field.
	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.DateField#setDateFormat
	 * @since 1.0
	 */
	getDate:function() {
		return this._dateFromText(this._filterAndInsertDashes(this.getText(),this.getText()));
	}, 
	_dateFromText:function(text) 
	{
		var tmp = null;
		var t = text;
		var bits = null;
		var b2 = null;
		if ( this.formatStr == "dd-mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push(bits.pop());
			tmp = parseDate(b2.join("-"));
		} else if ( this.formatStr == "mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[1].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push("01");
			var tStr = b2.join("-");
			
			tmp = parseDate(tStr);
		} else if ( this.formatStr == "yyyy-mm" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[0].length != 4)
				return null;
			
			tmp = parseDate(t+"-01");
		} else if ( this.formatStr == "mm-dd-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.shift());
			b2.push(bits.shift());
			tmp = parseDate(b2.join("-"));
		} else {
			tmp = parseDate(t);
		}
		
		if(!isValidDate(tmp)) {
			NgLogD("Failed to parse date: "+text+"   -  "+tmp+"\n");
			return null;
		}
		return tmp;
	}
});

//TODO: make a proper DatePicker?
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ProgressDialog.js';

var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ProgressDialog = exports.ProgressDialog = Element.subclass(
/** @lends UI.ProgressDialog.prototype */
{
	'type':'progressdialog',

    /**
	 * @name UI.ProgressDialog
     * @class The `UI.ProgressDialog` class displays progress updates from an application. This
	 * class is typically used in combination with `{@link UI.ProgressBar}`.
	 *
 	 * A `UI.ProgressDialog` object's appearance can change automatically when its view state 
	 * changes. For example, the text in the dialog can change when the dialog is disabled. To 
	 * implement this feature, your application can call a `UI.ProgressDialog` setter method more 
	 * than once, passing a different value in the `flags` parameter each time. In addition, your 
	 * application can include properties for multiple view states in the constructor. See the 
	 * `{@link UI}` module overview for more information.
     * @constructs Create a progress dialog.
     * @augments UI.Element
	 * @example
	 * // Create a new UI.ProgressDialog object without setting any of its properties.
	 * var dialog = new UI.ProgressDialog();
	 * @example
	 * // Create a new UI.ProgressDialog object, setting its title and text.
	 * var dialogTitle = "Please Wait";
	 * var dialogText = "Loading images...";
	 * var dialog = new UI.ProgressDialog({
	 *     title: dialogTitle,
	 *     text: dialogText
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new 
	 *		`UI.ProgressDialog` object.
     * @since 1.0
     */

	/** @ignore */
    initialize: function($super, properties) {
		if (ProgressDialog._init) ProgressDialog._init();
        return $super(properties);
    },
	/**
	 * Show the progress dialog.
	 * @function
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */    
    show: Commands.show,
	/**
	 * Hide the progress dialog.
	 * @function
	 * @returns {void}
	 * @status iOS, Android, Flash, Test
	 */    
    hide: Commands.hide
});

ProgressDialog._init = function() {
	delete ProgressDialog._init;
	if (Element._init) Element._init();
	
	/**
	 * Set the `title` property, which defines the progress dialog's title for a specified view
	 * state.
	 * @name UI.ProgressDialog#setTitle
	 * @function
	 * @example
	 * var dialog = new UI.ProgressDialog();
	 * dialog.setTitle("Please Wait");
	 * @param {String} title The title for the progress dialog.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this title. To specify a title for a view that is in multiple states, you can use the
	 * 		`|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.ProgressDialog#getTitle
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `title` property, which defines the progress dialog's title for a
	 * specified view state.
	 * @name UI.ProgressDialog#getTitle
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current title.
	 * @see UI.ProgressDialog#setTitle
	 * @status iOS, Android, Flash, Test
	 */
	ProgressDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * Set the `text` property, which defines the progress dialog's text for a specified view state.
	 * @name UI.ProgressDialog#setText
	 * @function
	 * @example
	 * var dialog = new UI.ProgressDialog();
	 * var text = "Loading images...";
	 * dialog.setText(text);
	 * @param {String} text The text for the progress dialog.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.ProgressDialog#getText
	 * @status iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `text` property, which defines the progress dialog's text for a
	 * specified view state.
	 * @name UI.ProgressDialog#getText
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text for the progress dialog.
	 * @see UI.ProgressDialog#setText
	 * @status iOS, Android, Flash, Test
	 */
	ProgressDialog.synthesizePropertyWithState('text', Commands.setText);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Toast'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Toast'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Toast'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Toast.js';

var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Toast = exports.Toast = Element.subclass(
/** @lends UI.Toast.prototype */
{	
    'type': 'toast',
    /**
	 * @class The `UI.Toast` class creates temporary messages on the device's screen. On Android
	 * devices, these messages slide up from the bottom of the screen. On iOS devices, these 
	 * messages slide down from the top of the screen.
	 *
	 * A `UI.Toast` object's appearance can change automatically when its view state changes. For
	 * example, the toast's text can change automatically when the temporary message gains focus or
	 * is selected. To implement this feature, your application can call a single `UI.Toast` method
	 * more than once, passing a different value in the `flags` parameter each time. In addition,
	 * your application can include properties for multiple view states in the constructor. See the
	 * `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.Toast#event:setOnDisappear}` to provide a 
	 * callback function for the `disappear` event, the callback function you specify will apply in 
	 * all view states.
	 * @name UI.Toast
	 * @constructs Create a temporary message.
	 * @augments UI.View
	 * @example
	 * // Create a temporary message without specifying any properties.
	 * var toast = new UI.Toast();
	 * @example
	 * // Create a temporary message, setting the text that will appear in the
	 * // message.
	 * var toast = new UI.Toast({
	 *     text: "Update complete";
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new `UI.Toast`
	 *		object.
	 * @since 1.0.2
	 */

	/** @ignore */
	initialize: function($super, properties) {
		if (Toast._init) Toast._init();
		$super(properties);
	},
	
	/** 
	 * Show the temporary message.
	 * @function
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
    show: Commands.show
});

Toast._init = function() {
	delete Toast._init;
	if (Element._init) Element._init();

	/**
	 * Set the `text` property, which defines the temporary message's text for a specified view
	 * state.
	 * @name UI.Toast#setText
	 * @function
	 * @example
	 * var toast = new UI.Toast();
	 * toast.setText("Update complete");
	 * @param {String} text The new text for the temporary message.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this text. To specify text for a view that is in multiple states, you can use the `|`
	 * 		operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.Toast#getText
	 * @status iOS, Android, Flash, Test, FlashTested
	 */
	/**
	 * Retrieve the value of the `text` property, which defines the temporary message's text for a
	 * specified view state.
	 * @name UI.Toast#getText
	 * @function	 
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {String} The current text for the temporary message.
	 * @see UI.Toast#setText
	 * @status iOS, Android, Flash, Test
	 */
	Toast.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * Set a function to call when a `disappear` event occurs. This event occurs when a temporary
	 * message is removed from the screen.
	 * @name UI.Toast#setOnDisappear
	 * @event
	 * @example
	 * // Destroy the temporary message after it disappears.
	 * var toast = new UI.Toast();
	 * toast.setOnDisappear(function() {
	 *     toast.destroy();
	 * });
	 * @cb {Function} disappearCallback The function to call when a `disappear` event occurs.
	 * @cb-returns {void}
	 * @returns {void}
	 * @see UI.Toast#event:getOnDisappear
	 */
	/**
	 * Retrieve the function to call when a `disappear` event occurs.
	 * @name UI.Toast#getOnDisappear
	 * @event
	 * @returns {Function} The current callback function.
	 * @see UI.Toast#event:setOnDisappear
	 * @status Flash, Test, FlashTested
	 */
	Toast.registerEventType('disappear');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Spinner'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Spinner.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Spinner = exports.Spinner = AbstractView.subclass(
/** @lends UI.Spinner.prototype */
{
	'type':'spinner',
	
	/**
	 * @class The `UI.Spinner` class creates spinning activity indicators in a user interface.
	 * @name UI.Spinner
	 * @constructs Create a spinning activity indicator.
	 * @augments UI.AbstractView
	 * @since 1.0.6
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (Spinner._init) Spinner._init();
		return $super(properties);
	}
});

Spinner._init = function() {
	delete Spinner._init;
	if (AbstractView._init) AbstractView._init();
	
	Spinner.synthesizeProperty('darkStyle', Commands.setDarkStyle);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/ProgressBar.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var ProgressBar = exports.ProgressBar = AbstractView.subclass(
/** @lends UI.ProgressBar.prototype */
{
	'type':'progressbar',

    /**
     * @class The `UI.ProgressBar` class creates horizontal progress bars. To update the progress
	 * bar, your application must call the `{@link UI.ProgressBar#setProgress}` method.
	 *
	 * A progress bar has a primary gradient and a secondary gradient. This enables you to create a
	 * progress bar that shows two progress states at once. For example, you could create a progress
	 * bar that shows a user's current position in a game level as well as the position of the next
	 * save point.
	 *
	 * A `UI.ProgressBar` object's appearance can change automatically when its view state changes. 
	 * For example, the progress bar's outline or fill can change automatically when the progress
	 * bar gains focus or is selected. To implement this feature, your application can call a
	 * `UI.ProgressBar` setter method more than once, passing a different value in the `flags`
	 * parameter each time. In addition, your application can include properties for multiple view
	 * states in the constructor. See the `{@link UI}` module overview for more information.
	 * 
	 * **Note**: Some of this class' methods do not allow you to set different properties for each
	 * view state. For example, when you use `{@link UI.ProgressBar#setProgress}` to control the
	 * amount of progress that is shown, this amount of progress will apply in all view states.
	 * @name UI.ProgressBar
     * @constructs Create a progress bar.
     * @augments UI.AbstractView
	 * @example
	 * // Create a new UI.ProgressBar object without setting any of its properties.
	 * var progressBar = new UI.ProgressBar();
	 * @example
	 * // Create a new UI.ProgressBar object, setting its progress amount.
	 * var progressAmount = 0.1;
	 * var progressBar = new UI.ProgressBar({
	 *     progress: progressAmount
	 * });
	 * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.ProgressBar` object.
     * @since 1.0
     */

	/** @ignore */
    initialize: function($super, properties) {
		if (ProgressBar._init) ProgressBar._init();
        return $super(properties);
    },

	useForUpdateProgress: Commands.useForUpdateProgress
});

ProgressBar._init = function() {
	delete ProgressBar._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * Retrieve the value of the `progressGradient` property, which defines the outlines, shadows,
	 * rounded corners, and gradient fills that are currently applied to the progress indicator for
	 * the specified view state.
	 * @name UI.ProgressBar#getProgressGradient
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The progress bar's appearance for the specified view state.
	 * @see UI.ProgressBar#setProgressGradient
	 * @status Javascript, Android
	 */
	/**
	 * Set the `progressGradient` property, which defines the outlines, shadows, rounded corners, 
	 * and gradient fills that are applied to the progress indicator for the specified view state. 
	 * See `{@link UI.Style#setGradient}` for information about this property.
	 * @name UI.ProgressBar#setProgressGradient
	 * @function
	 * @example
	 * // Set a gradient that has rounded corners with an eight-pixel radius; a
	 * // black outer border; and a gradient fill that fades from gray to 
	 * // light gray.
	 * var progressBar = new UI.ProgressBar();
	 * progressBar.setProgressGradient({
	 *     corners: "8 8 8 8",
	 *     outerLine: "FF000000 1.5",
	 *     gradient: ["FF888888 0.0", "FFE4E4E4 1.0"]
	 * });
	 * @param {Object} gradient The new appearance for the progress bar.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this appearance. To specify the appearance for a view that is in multiple states, you
	 * 		can use the `|` operator to combine multiple flags.
	 * @see UI.ProgressBar#getProgressGradient
	 * @returns {void}
	 * @status Android
	 */
	ProgressBar.synthesizePropertyWithState('progressGradient', Commands.setProgressGradient);
	/**
	 * Retrieve the value of the `secondaryGradient` property, which defines the outlines, shadows, 
	 * rounded corners, and gradient fills that are currently applied to the secondary progress 
	 * indicator for the specified view state. See `{@link UI.Style#setGradient}` for information
	 * about this property.
	 * @name UI.ProgressBar#getSecondaryGradient
	 * @function
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The specified view state.
	 * @returns {Object} The progress bar's secondary gradient for the specified view state.
	 * @see UI.SecondaryBar#setSecondaryGradient
	 * @status Javascript, Android
	 */
	/**
	 * Set the `secondaryGradient` property, which defines the outlines, shadows, rounded corners,
	 * and gradient fills that are applied to the secondary progress indicator for the specified 
	 * view state. See `{@link UI.Style#setGradient}` for information about this property.
	 * @name UI.ProgressBar#setSecondaryGradient
	 * @function 
	 * @example
	 * // Set a gradient that has rounded corners with an eight-pixel radius; a
	 * // black outer border; and a gradient fill that fades from gray to 
	 * // light gray.
	 * var progressBar = new UI.ProgressBar();
	 * progressBar.setSecondaryGradient({
	 *     corners: "8 8 8 8",
	 *     outerLine: "FF000000 1.5",
	 *     gradient: ["FF888888 0.0", "FFE4E4E4 1.0"]
	 * });
	 * @param {Object} gradient The new secondary gradient for the progress bar.
	 * @param {UI.Commands#State} [flags=UI.Commands.State.Normal] The view state in which to use
	 *		this secondary gradient. To specify the secondary gradient for a view that is in 
	 * 		multiple states, you can use the `|` operator to combine multiple flags.
	 * @returns {void}
	 * @see UI.SecondaryBar#getSecondaryGradient
	 * @see UI.Style#setGradient
	 * @status Android
	 */
	ProgressBar.synthesizePropertyWithState('secondaryGradient', Commands.setSecondaryGradient);
	
	var setProgressGuarded = function(arg0) {
		var args = (arg0 instanceof Array) ? arg0 : Array.prototype.slice.call(arguments);
		while (args.length < 2) args.push(0);
		Commands.setProgress.apply(this, args);
	};
	/**
	 * Retrieve the value of the `progress` and `secondaryProgress` properties, which indicate the
	 * amount of progress that is displayed on the primary and secondary progress bars.
	 * @name UI.ProgressBar#getProgress
	 * @function
	 * @returns {Number[]} The current progress and secondary progress amounts. Specified as an
	 *		array of two floats, where the first represents the progress amount and the second
	 *		represents the secondary progress amount.
	 * @see UI.ProgressBar#setProgress
	 * @status Javascript, Android
	 */
	/**
	 * Set the `progress` and `secondaryProgress` properties, which indicate the amount of progress
	 * that is displayed on the primary and secondary progress bars. Each property is specified as 
	 * a float ranging from 0.0, which represents 0% complete, to 1.0, which represents 100%
	 * complete.
	 * @name UI.ProgressBar#setProgress
	 * @function
	 * @param {Number[]|Number} arg0 An array of two floats, where the first represents the progress
	 *		amount and the second represents the secondary progress amount. Both floats can range
	 *		from 0.0 to 1.0. You can also pass these values in as separate parameters. If you omit
	 *		the secondary progress amount, it will default to 0.
	 * @returns {void}
	 * @see UI.ProgressBar#getProgress
	 * @status Javascript, Android
	 */
	ProgressBar.synthesizeCompoundProperty('progress', setProgressGuarded);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// UI diagnostic emitter; collects info from UI subsystem.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////
    
//
// Create and export a DiagnosticEmitter for UI.  
//

exports.Diagnostics = Core.DiagnosticEmitter.singleton(
{
    classname: 'UI_Diagnostics',

    /**
     * @class the <code>UI.Diagnostics</code> class constructs a singleton object
     * to obtain detailed UI diagnostic information from.
     *
     * The emitter currently emits an object of the form:
     * 
     <code>
        {
	    "name":"UI",                      // Emitter name, 'UI'				          
	}  
     </code>
     * @since 1.7.5
     */
    initialize: function($super) 
    {
	$super('UI');
    }

});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AdView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/AdView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private */
var AdView = exports.AdView = AbstractView.subclass(
{
	'type':'adview',

	/**
	 * @class The <code>AdView</code> class constructs objects that handle event callback functions and ad event metadata.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.AbstractView
	 * @deprecated As of version 1.6, this class is no longer supported. It will be removed in a
	 *		future version.
	 * @since 1.0
	 */
	initialize: function($super, properties) {
		if (AdView._init) AdView._init();
		$super(properties);
		
		this.onappear = this.bind(this._onappear);
		this.ondisappear = this.bind(this._ondisappear);
		this.onclick = this.bind(this._onclick);
	},
	
	/**
	 * An event for signaling when an <code>AdView</code> is on display.
	 * @event
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 * @since 1.0
	 */
	onappear: function() {
	 },
	
	/**
	 * An event for signaling when an <code>AdView</code> has been closed.
	 * @event
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 * @since 1.0
	 */
	ondisappear: function() { 
	},
	
	/**
	 * @protected
	 * @since 1.0
	 */
	_onappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADSHOW",  this.getAdEventMetadata());
	},
	
	/**
	 * @protected
	 * @since 1.0
	 */
	_ondisappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADCLOSE", this.getAdEventMetadata());
	},
	
	performEventCallback: function($super, event) {
		if (event.eventType == 'click')
		{
//			Core.Analytics._getPipe().revenueEvent("ADCLCK", this.getAdEventMetadata());
			NgLogD("AD WAS CLICKED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
		if (event.eventType == 'load')
		{
//			Core.Analytics._getPipe().revenueEvent("ADLOAD", this.getAdEventMetadata());
			NgLogD("AD WAS LOADED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
	},
	/**
	* Pause this <code>AdView</code>.<br /><br />
	* <b>Note:</b> If an <code>AdView</code> is already paused, this call does nothing.
	* @see UI.AdView#resumeAds
	* @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	* @status Android
	* @since 1.0
	*/
	pauseAds: function() {
		Commands.pauseAds.call(this);
	},
	/**
	* Resume this <code>AdView</code> from a paused state. Setting this will resume the <code>AdView</code> from the current position.
	* @see UI.AdView#resumeAds
	* @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	* @status Android
	* @since 1.0
	*/
	resumeAds: function() {
		Commands.resumeAds.call(this);
	},
	/**
	* Set the refresh rate for this <code>AdView</code>. 
	* @param {Number} refreshRate The amount of time each ad is on display (in milliseconds).
	* @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	* @status Android
	* @since 1.0
	*/
	setRefreshRate: function(refreshRate) {
		Commands.setAdRefreshRate.call(this, refreshRate);
	},
	/**
	* Set this <code>AdView</code> to automatically play.
	* @status Android
	* @param {Boolean} autoplay Set as <code>true</code> if autoplay is enabled.
	* @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	* @since 1.0
	*/
	setAutoplay: function(autoplay) {
		Commands.setAdRefreshRate.call(this, autoplay);
	},
	
	/**
	 * Retrieve event metadata from this <code>AdView</code>. 
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 * @since 1.0
	 */
	getAdEventMetadata: function(){
		NgLogD("AD EventMetetData was requested!");
		var AdMeteData = "DefaultAdEventMetaData";
		return AdMeteData;
	}
});

// Event Handlers
AdView._init = function() {
	delete AdView._init;
	if (AbstractView._init) AbstractView._init();

    /**
	 * @name UI.AdView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>AdView</code> object is set to active.
	 * @see UI.AdView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 */
	AdView.synthesizeProperty('active', Commands.setActive);
    
	/**
	 * @name UI.AdView#setOnClick
	 * @description Set a function to call on <code>click</code> events.	 
	 * @param {Function} clickCallback The new <code>click</code> callback function. <br /><br />
	 * <b>Note:</b> The <code>click</code> event is disabled if the value for this parameter is not a function.<br />
	 * @see UI.AdView#event:setOnClick
 	 * @status Android, Test
	 * @event
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 */
	/**
	 * @name UI.AdView#getOnClick
	 * @description Retrieve the function to call on <code>click</code> events.<br />
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>click</code> callback function.<br />
 	 * @status Android, Test
	 * @event
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 */
	AdView.registerEventType('click');
	/**
	 * @name UI.AdView#setOnLoad
	 * @description Set a function to call on <code>load</code> events.	 
	 * @param {Function} loadCallback The new <code>load</code> callback function. <br /><br />
	 * <b>Note:</b> The <code>load</code> event is disabled if the value for this parameter is not a function.<br />
	 * @see UI.AdView#event:getOnClick
 	 * @status Android, Test
	 * @event
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 */
	/**
	 * @name UI.AdView#getOnLoad
	 * @description Retrieve the function to call on <code>load</code> events.<br />
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>load</code> callback function.<br />
 	 * @status Android, Test
	 * @event
	 * @deprecated Since version 1.6. The UI.AdView class will be removed in a future version.
	 */
	AdView.registerEventType('load');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DocumentView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/DocumentView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var DocumentView = exports.DocumentView = AbstractView.subclass(
/** @lends UI.DocumentView.prototype */
{
	'type':'documentview',
	/**
	 * @class The `UI.DocumentView` class is used to display local HTML files.
	 * @name UI.DocumentView
	 * @constructs Create a document view.
	 * @augments UI.AbstractView
	 * @deprecated As of version 1.6, this class is no longer supported. It will be removed in a
	 *		future version.
     * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.DocumentView` object.
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (DocumentView._init) DocumentView._init();
		$super(properties);
	}
});

// Properties
DocumentView._init = function() {
	delete DocumentView._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * Set the `documentURL` property, which specifies the URL to load.
	 * @name UI.DocumentView#setDocumentURL
	 * @function
	 * @deprecated Since version 1.6. The UI.DocumentView class will be removed in a future
	 *		version.
	 * @param {String} documentURL The new document URL.
	 * @returns {void}
	 * @see UI.DocumentView#getDocumentURL
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * Retrieve the value of the `documentURL` property, which specifies the URL to load.
	 * @name UI.DocumentView#getDocumentURL
	 * @function
	 * @deprecated Since version 1.6. The UI.DocumentView class will be removed in a future
	 *		version.
	 * @returns {String} The current document URL.
	 * @see UI.DocumentView#setDocumentURL
	 * @status iOS, Android, Flash, Test
	 */
	DocumentView.synthesizeProperty('documentURL', Commands.setSourceDocument);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckoutView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/CheckoutView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CheckoutView = exports.CheckoutView = AbstractView.subclass(
/** @lends UI.CheckoutView.prototype */
{
	'type':'checkoutview',
	/**
	 * @class The `UI.CheckoutView` class is used to support in-app payments.
	 * @name UI.CheckoutView
     * @constructs Create a checkout view.
	 * @augments UI.AbstractView
	 * @deprecated As of version 1.6, this class is no longer supported. It will be removed in a
	 *		future version.
     * @param {Object} [properties] An object whose properties will be added to the new
	 *		`UI.CheckoutView` object.
	 * @since 1.0.2
	 */
	
	/** @ignore */
	initialize: function($super, properties) {
		if (CheckoutView._init) CheckoutView._init();
		$super(properties);
	}
});

// Properties
CheckoutView._init = function() {
	delete CheckoutView._init;
	if (AbstractView._init) AbstractView._init();
	
	// THESE ARE METHODS NOT PROPERTIES... THIS SHOULD BE FIXED.
	// We define ONLY setters, and no getters (write-only props, no local copies)
	/**
	 * Set the post data for the checkout view.
	 * @name UI.CheckoutView#setPostData
	 * @function
	 * @deprecated Since version 1.6. The UI.CheckoutView class will be removed in a future
	 *		version.
	 * @param {String} postData The new post data for the checkout view.
	 * @returns {void}
	 * @status Android
	 */
	CheckoutView.registerAccessors('postData', null, Commands.setPostData);
	/**
	 * Set the URL to use for an HTTP `POST` request.
	 * @name UI.CheckoutView#setPostURL
	 * @function
	 * @deprecated Since version 1.6. The UI.CheckoutView class will be removed in a future
	 *		version.
	 * @param {String} postURL The URL to use.
	 * @returns {void}
	 * @status Android
	 */
	CheckoutView.registerAccessors('postURL', null, Commands.loadPostURL);
	/**
	 * Set the URL to use for an HTTP `GET` request.
	 * @name UI.CheckoutView#setGetURL
	 * @function
	 * @deprecated Since version 1.6. The UI.CheckoutView class will be removed in a future
	 *		version.
	 * @param {String} getURL The URL to load.
	 * @returns {void}
	 * @status Android
	 */
	CheckoutView.registerAccessors('getURL', null, Commands.loadGetURL);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapAnnotation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/MapAnnotation.js';

var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var MapAnnotation = exports.MapAnnotation = Element.subclass(
/** @lends UI.MapAnnotation.prototype */
{
	'type':'mapannotation',
	/**
	* @class <code>MapAnnotation</code>
	* @name UI.MapAnnotation
	* @augments Core.Class
	* @since 1.1.1.2
	*/
	initialize: function($super, properties) {
		return $super(properties);
	},

	setCalloutLeftView: function(view)
	{
		this._calloutLeftView = view;
		Commands.setCalloutLeftView.call(this, view.__objectRegistryId);
	},

	getCalloutLeftView: function()
	{
		return this._calloutLeftView;
	},

	setCalloutRightView: function(view)
	{
		this._calloutRightView = view;
		Commands.setCalloutRightView.call(this, view.__objectRegistryId);
	},

	getCalloutRightView: function()
	{
		return this._calloutRightView;
	},

	setView: function(view)
	{
		this._view = view;
		Commands.setView.call(this, view.__objectRegistryId);
	},

	getView: function()
	{
		return this._view;
	},

	setImage: function(image)
	{
		console.log("WARNING : MapAnnotation.setImage has been deprecated. Use MapAnnotation.setView instead.");
		var iV = new UI.Image();
		iV.setImage(image);
		iV.setFrame([0, 0, 40, 40]);
		this.setView(iV);
	},

	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		$super(e);
	}
});

// Properties
(function() {

	MapAnnotation.synthesizeCompoundProperty('coordinate', Commands.setCoordinate);
	
	MapAnnotation.synthesizeCompoundProperty('centerOffset', Commands.setCenterOffset);
	
	MapAnnotation.synthesizeProperty('calloutTitle', Commands.setCalloutTitle);

	MapAnnotation.synthesizeProperty('calloutSubtitle', Commands.setCalloutSubtitle);
	
	MapAnnotation.synthesizeProperty('calloutEnabled', Commands.setCalloutEnabled);

	MapAnnotation.registerEventType('select');
	MapAnnotation.registerEventType('deselect');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/MapView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;

var MapView = exports.MapView = AbstractView.subclass(
/** @lends UI.MapView.prototype */
{
	'type':'mapview',
	/**
	* @class <code>MapView</code>
	* @name UI.MapView
	* @augments UI.View
	* @since 1.1.1.2
	*/
	initialize: function($super, properties) {
		this._annotations = [];
		this._region = [];
		return $super(properties);
	},
	
	getCenterCoordinate: function()
	{
		return [this._region[0], this._region[1]];
	},
    
    setCenterCoordinate: function(lat, lon, animated)
    {
        this._region[0] = lat;
        this._region[1] = lon;
        if (!this._region[2])
            this._region[2] = 0.05;
        if (!this._region[3])
            this._region[3] = 0.05;            
        this.setRegion(this._region[0], this._region[1], this._region[2], this._region[3], animated);
    },
	
	getCoordinateSpan: function()
	{
		return [this._region[2], this._region[3]];
	},	
	
	selectAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				Commands.selectAnnotation.call(this, annotation.__objectRegistryId);
				return;
			}
		}
		Commands.selectAnnotation.call(this, -1);
	},
	
	addAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			this._annotations.push(annotation);
			
			Commands.addAnnotation.call(this, annotation.__objectRegistryId);
			
		} else throw {message: this.type + ".addAnnotation: " + annotation + " is not a MapAnnotation!"};
		return this;
	},
	
	removeAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			// Remove this node from parent's child list
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				this._annotations.splice(index, 1);
			}
			
			// Remove from the parent at the system level
			Commands.removeAnnotation.call(this, annotation.__objectRegistryId);
		} else throw {message: this.type + ".removeAnnotation: " + annotation + " is not a MapAnnotation!"};
		return annotation;
	},
	
	/**
	 * @private
	 */    
	updateRegionFits: function(lat, lon ,latD , lonD) {
		//console.log(lat + " " + lon + " " + latD + " " + lonD);
		//console.log(this._region[0] + " " + this._region[1] + " " + this._region[2] + " " + this._region[3]);
		this._region[0] = lat;
		this._region[1] = lon;
		this._region[2] = latD;
		this._region[3] = lonD;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'regionchange') this.updateRegionFits(e.latitude, e.longitude , e.latitudeDelta , e.longitudeDelta);
		$super(e);
	}
});

// Properties
(function() {
	MapView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	MapView.synthesizeProperty('zoomable', Commands.setZoomable);
	
	MapView.synthesizeCompoundProperty('region', Commands.setRegion);
	
	MapView.registerEventType('regionchange');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/_CutSceneView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/_CutSceneView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/_CutSceneView'] = exports; 
var __dirname = 'NGCore/Client/UI';
var __filename = 'NGCore/Client/UI/_CutSceneView.js';

var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CutSceneView = exports.CutSceneView = AbstractView.subclass(
/** @lends UI.CutSceneView.prototype */
{
	'type':'_cutsceneview',
	
	/**
	* @class The <code>CutSceneView</code> class constructs objects that handle menu CutSceneViews in a user interface. 
	* @name UI.CutSceneView
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (CutSceneView._init) CutSceneView._init();
		return $super(properties);
	},
	
	play: function(url, callbackFn) {
		var cbId = (typeof callbackFn == 'function')
			? Commands.registerTemporaryCallback(callbackFn.bind(this))
			: "";
		Commands.playVideo.call(this, url, cbId);
	}
});

CutSceneView._init = function() {
	delete CutSceneView._init;
	if (AbstractView._init) AbstractView._init();
	
	// No init for this class
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI'] || {}; $MODULE_REGISTRY['NGCore/Client/UI'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/UI.js';

var UILoader = function(map) {
	// Internal function to define isolated-scope getters.
	var loadFn = function(object, key, fn) {
		return function() {
			delete object[key];
			return object[key] = fn.call(this);
		};
	};

	for (var key in map) {
		if (typeof map[key] == 'function') {
			this.__defineGetter__(key, loadFn(this, key, map[key]));
		} else {
			this[key] = map[key];
		}
	}
};

/**
 * @name UI
 * @namespace Provide user interface components such as buttons, text fields, and web views.
 * @description
 * The `UI` module provides access to user interface (UI) components. You can use the `UI` module's
 * classes to create all of the following types of UI components:
 *
 * + Alert dialogs (`{@link UI.AlertDialog}`)
 * + Checkboxes (`{@link UI.CheckBox}`)
 * + Date fields (`{@link UI.DateField}`)
 * + Images (`{@link UI.Image}`)
 * + Progress bars (`{@link UI.ProgressBar}`)
 * + Progress dialogs (`{@link UI.ProgressDialog}`)
 * + Progress indicators (`{@link UI.Spinner}`)
 * + Rectangles that help to position UI components (`{@link UI.ViewGeometry}`,
 * `{@link UI.ViewGeometry.Rect}`, `{@link UI.ViewGeometry.Scale}`)
 * + Scrolling lists (`{@link UI.ListView}`, `{@link UI.ListViewItem}`,
 * `{@link UI.ListViewSection}`, `{@link UI.ScrollView}`)
 * + Table cells (`{@link UI.CellView}`)
 * + Temporary messages (`{@link UI.Toast}`)
 * + Text fields, single-line and multi-line (`{@link UI.EditText}`, `{@link UI.EditTextArea}`)
 * + Text labels (`{@link UI.Label}`)
 * + Web views (`{@link UI.WebView}`)
 *
 * The `UI` module also provides the `{@link UI.View}` class, which enables you to group UI
 * components into views. You can then use the `{@link UI.NavController}` class to navigate between
 * views based on user input. In addition, you can use the `{@link UI.Style}` class to create a set
 * of style properties that can be reused by multiple UI components.
 *
 * Finally, the `UI` module provides several static functions that enable you to:
 *
 * + Animate changes to a `UI` object's properties (`{@link UI.animate}`)
 * + Capture a screenshot from the device (`{@link UI.takeScreenshot}`)
 * + Choose a photo from the user's camera roll, or take a new photo using the device's camera
 * (`{@link UI.choosePhoto}`, `{@link UI.choosePhotoCamera}`)
 * + Combine multiple images into a single file (`{@link UI.compositeImages}`)
 * + Measure the dimensions of a text string (`{@link UI.measureText}`)
 *
 * ## UI and GL2 Modules ##
 * The `UI` module includes the `{@link UI.GLView}` class, which provides applications with access
 * to OpenGL. Applications should not attempt to display `UI` and `GL2` objects at the same time,
 * with the sole exception of `{@link UI.GLView}` objects. Displaying other `UI` objects at the same
 * time as `GL2` objects can result in poor performance.
 * 
 * If your application needs to combine UI components and other graphics on the same screen, 
 * consider using the ngGo toolkit. Its `GLUI` module reimplements the `UI` module in OpenGL, 
 * enabling you to combine UI components with other graphics. Although `GLUI` does not support all
 * of the `UI` module's styling options, it offers enough flexibility for many applications.  You
 * can download ngGo from the Downloads section on the
 * [Mobage Developer Portal](https://developer.mobage.com/).
 *
 * ## Handling Events ##
 * Classes in the `UI` module are event-driven. For example, each instance of a `UI` class can fire
 * events when the user makes a selection, or when the UI component appears or disappears. Your
 * application processes these events by defining a callback function for each one. The callback
 * function can then take an action such as processing the user's input, destroying the UI
 * component, or moving to a different view.
 *
 * To determine which events a component supports, review the Events section of the class'
 * documentation. The documentation also explains which parameters are passed to the callback
 * function for each type of event.
 *
 * **Note**: An event will not fire unless you define a callback function to handle the event.
 *
 * ## Styling UI Components ##
 * Each UI component supports a variety of style properties that manage the component's contents and
 * appearance. For example, you can use these style properties to add fills, borders, and rounded 
 * corners to a UI component, or to add images and text to a component.
 * 
 * To determine which style properties a component supports, review the getter and setter methods 
 * the component's class. For example, the `{@link UI.Toast}` class provides one setter method,
 * `{@link UI.Toast#setText}`, which provides access to the style property `text`.
 *
 * **Note**: If you need to access a large number of style properties at once, you can streamline
 * your code by using the component's `setAttributes()` and `getAttributes()` methods, which are
 * inherited from `{@link UI.AbstractView}`. In addition, you can set an object's style properties
 * when you instantiate the object, avoiding the need for separate method calls.
 *
 * ## Managing View States ##
 * The `UI` module defines a collection of view states, which you can use to manage the appearance
 * of UI components based on their state. For example, you can define different styles for a
 * `{@link UI.CheckBox}` object based on whether it is disabled, checked, or pressed. You can also
 * define styles for a component that is in multiple states at once, such as a `{@link UI.CheckBox}`
 * object that is both pressed and checked. In addition, you can define custom view states for your
 * application. See `{@link UI.Commands#State}` for details about the view states that are
 * supported.
 * 
 * There are several ways to specify unique style properties for a specific view state:
 * 
 * 1. Call the setter method for each property, and include the `flags` parameter to define which
 * view states will use the specified style.
 * 2. Define style properties for multiple view states when you instantiate the UI component.
 * To define a style property for a view state, add the name of the view state to the beginning of 
 * the property name, and capitalize the property name. For example, to specify an image border for
 * a UI component that has focus, pass the `focusedImageBorder` property to the constructor. This 
 * approach is supported only for the `normal`, `focused`, `selected`, `pressed`, and `disabled` 
 * view states. To specify a style property for a custom view state, or for a component that is in
 * multiple states, you must use the component's setter methods.
 * 3. Define style properties for multiple view states when you create a `{@link UI.Style}` object.
 * You can define a style property for a view state as described above.
 * 
 * ## Reusing Style Properties for Multiple Objects ##
 * If your application will use the same appearance for multiple objects, create a
 * `{@link UI.Style}` object that defines the style properties for those objects. You can then call
 * the objects' `setStyle()` and `getStyle()` methods to manage the objects' styles, or you can pass
 * the `UI.Style` object in the `style` property of the object's constructor. By using `UI.Style`
 * objects, you reduce the amount of communication between JavaScript and native code, which can 
 * significantly improve your application's performance.
 *
 * In some cases, your application may include two UI components whose style differs only slightly.
 * You can assign a single `UI.Style` object to both of these components, then override the
 * `UI.Style` object's style properties by applying style properties directly to the UI component.
 */

UILoader.prototype = {
/** @lends UI.prototype */

	/**
	 * Animate changes to the `alpha`, `frame`, and `scrollPosition` properties of one or more UI
	 * components. This method also animates the addition and removal of child views.
	 *
	 * To animate a set of changes, you must define a function that actually changes the properties.
	 * You then pass this function to `UI.animate()` in the `action` parameter.
	 *
	 * **Note**: If a UI component is currently being animated, do not animate additional changes to
	 * the component's properties.
	 * @name UI.animate
	 * @function
	 * @static
	 * @example
	 * // Fade in a string of text.
	 * var textProperties = {
	 *     alpha: 0.0,
	 *     text: "Sample text",
	 *     textSize: 24,
	 *     textColor: "000000",
	 *     textFont: "Arial"
	 * };
	 * var label = new UI.Label(textProperties);
	 * var windowSize = [Device.LayoutEmitter.getWidth(),
	 *   Device.LayoutEmitter.getHeight()];
	 * var textDimensions = UI.measureText(textProperties.text, windowSize[0],
	 *   windowSize[1], textProperties.textFont, textProperties.textSize, 
	 *   function(dimensions) {
	 *     // Center the label within the window.
	 *     var xOrigin = (windowSize[0] / 2) - (dimensions.width / 2);
	 *     var yOrigin = (windowSize[1] / 2) - (dimensions.height / 2);
	 *     label.setFrame([xOrigin, yOrigin, dimensions.width, dimensions.height]);
	 *     // Add the label to UI.Window.document.
	 *     UI.Window.document.addChild(label);
	 *     // Animate the change to the label's alpha property, fading the label in
	 *     // over 2 seconds.
	 *     UI.animate(function() {
	 *         label.setAlpha(1.0);
	 *     }, 2000, function(event) {
	 *         console.log("It is " + event.canceled + " that the animation was " +
	 *           "canceled.");
	 *     });
	 * });
	 * @param {Function} action A function that sets the property or properties to be animated.
	 *		This function can change the properties of any number of UI components.
	 * @param {Number} duration The time over which to animate the changes, in milliseconds.
	 * @cb {Function} onCompletion The function to call after the animation ends.
	 * @cb-param {Object} event Information about the event.
	 * @cb-param {Boolean} event.canceled Set to `true` if the animation was canceled.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.0
	 */
    animate: function() { return this.Commands.animate.apply(this,Array.prototype.slice.call(arguments)); },

    /**
	 * Combine multiple images into a single image, and write the single image to the device's
	 * file system.
	 * 
	 * By default, the image is saved in PNG format. To use JPEG format, specify a filename with the
	 * extension .jpg.
	 * @name UI.compositeImages
	 * @function
	 * @static
	 * @example
	 * // Replace the right side of an existing 200 x 200 pixel image, and save
	 * // the new image file to the device's storage.
	 * var filename = "example.png";
	 * var images = [
	 *     {
	 *         image: "./Content/background.png",
	 *         rect: [0, 0, 200, 200]
	 *     },
	 *     {
	 *         image: "./Content/new-right-side.png",
	 *         rect: [100, 0, 100, 100]
	 *     }
	 * ];
	 * UI.compositeImages(200, 200, filename, images, function(data) {
	 *     if (data.error) {
	 *         console.log("Unable to create composite image: " + data.error);
	 *     } else {
	 *         // Update the filename.
	 *         filename = data.filename;
	 *     }
	 * });
	 * @param {Number} w The width, in pixels, of the new image.
	 * @param {Number} h The height, in pixels, of the new image.
	 * @param {String} filename The preferred filename for the new image. Use the extension .jpg to
	 *		save the file in JPEG format. By default, the file is saved in PNG format. **Note**: The
	 *		file may be saved using a different name. Use the callback function to identify the 
	 *		file's actual name.
	 * @param {Object[]} infoArray An array of objects that identify the images to be composited.
	 * @param {UI.Commands#FitMode} [infoArray[].fit=UI.Commands.FitMode.Inside] The image fit mode
	 *		to use when scaling the existing image.
	 * @param {Number[]|UI.ViewGeometry#Gravity} [infoArray[].gravity=[0.5, 0.5]] The image gravity
	 *		to use when placing the existing image within the new image. See
	 *		`{@link UI.Image#setImageGravity}` for more details about this property.
	 * @param {String} infoArray[].image A filename for an existing image to include in the
	 *		composite image.
	 * @param {Number[]} [infoArray[].insets=[0, 0, 0, 0]] The insets that will be used to clip the
	 *		edges of the image. Specified as an array of four floats, starting with the top inset
	 *		and going clockwise around the image.
	 * @param {Number[]} [infoArray[].rect] An array of integers that specify a rectangle where the 
	 *		existing image will be placed in the composite image. (By default, this method uses a
	 *		rectangle that is the same size as the new image.) The array contains the following four
	 *		values, in this order:
	 *
	 * 1. The X origin at which to place the top left corner of the existing image.
	 * 2. The Y origin at which to place the top left corner of the existing image.
	 * 3. The width, in pixels, of the image rectangle.
	 * 4. The height, in pixels, of the image rectangle.
	 * @param {Number[]} [infoArray[].transform] The affine transformation to apply to the existing
	 *		image. See `{@link UI.Image#setImageTransform}` for more information about affine
	 *		transformations. Specified as an array of six floats: `[a, b, c, d, tx, ty]`.
	 * @cb {Function} callback The function to call after creating the composite image.
	 * @cb-param {Object} data Information about the composite image.
	 * @cb-param {String} [data.error] A description of the error, if any.
	 * @cb-param {String} [data.filename] The filename for the composite image. **Note**: This value
	 *		may differ from the value that was sent in the `filename` parameter.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.1.1.2
	 */
    compositeImages: function(w, h, filename, infoArray, callback) {
        var cb = this.Commands.registerTemporaryCallback(callback);
        if (cb) {
			this.Commands.doCompositeImages(w, h, filename, infoArray, cb);
		}
    },

    /**
     * Display a full-screen interface for selecting an existing image from the device's camera
	 * roll, and write the selected image to the device's file system. You can retrieve the image
	 * at its original size, or you can rescale the image to fit within a width and height you
	 * specify.
	 *
	 * By default, the image is saved in PNG format. To use JPEG format, specify a filename with the
	 * extension .jpg.
	 * @name UI.choosePhoto
	 * @function
	 * @static
	 * @example
	 * // Retrieve an image that has been scaled to fit within a 100 x 200 rectangle.
	 * var filename = "example.png";
	 * var view = new UI.View();
	 * UI.choosePhoto(100, 200, filename, {}, function(data) {
	 *     if (data.error) {
	 *         // The user probably canceled instead of choosing an image.
	 *         console.log("Unable to select an image: " + data.error);
	 *     } else {
	 *         // Update the filename.
	 *         filename = data.filename;
	 *     }
	 * }, view);
	 * @param {Number} targetWide The width, in pixels, to use for scaling the image. Use 0 to
	 *		retrieve an unscaled image.
	 * @param {Number} targetHigh The height, in pixels, to use for scaling the image. Use 0 to
	 *		retrieve an unscaled image.
	 * @param {String} filename The preferred filename for the new image. Use the extension .jpg to
	 *		save the file in JPEG format. By default, the file is saved in PNG format. **Note**: The
	 *		file may be saved using a different name. Use the callback function to identify the 
	 *		file's actual name.
	 * @param {Object} options Options for retrieving the image.
	 * @param {UI.Commands#FitMode} [options.fit=UI.Commands.FitMode.Inside] The image fit mode to
	 *		use when scaling the existing image.
	 * @param {Number[]|UI.ViewGeometry#Gravity} [options.gravity=[0.5, 0.5]] The image gravity to
	 *		use when placing the existing image within the retrieved image. See
	 *		`{@link UI.Image#setImageGravity}` for more details about this property.
	 * @param {Number[]} [options.insets=[0, 0, 0, 0]] The insets that will be used to clip the
	 *		edges of the image. Specified as an array of four floats, starting with the top inset
	 *		and going clockwise around the image.
	 * @param {Number[]} [options.rect] An array of integers that specify a rectangle where the 
	 *		existing image will be placed in the new image. (By default, this method uses a
	 *		rectangle that is the same size as the new image.) The array contains the following four
	 *		values, in this order:
	 *
	 * 1. The X origin at which to place the top left corner of the existing image.
	 * 2. The Y origin at which to place the top left corner of the existing image.
	 * 3. The width, in pixels, of the image rectangle.
	 * 4. The height, in pixels, of the image rectangle.
	 * @param {Number[]} [options.transform] The affine transformation to apply to the existing
	 *		image. See `{@link UI.Image#setImageTransform}` for more information about affine
	 *		transformations. Specified as an array of six floats: `[a, b, c, d, tx, ty]`.
	 * @cb {Function} callback The function to call after choosing an image.
	 * @cb-param {Object} data Information about the image.
	 * @cb-param {String} [data.error] A description of the error, if any.
	 * @cb-param {String} [data.filename] The filename for the image. **Note**: This value may
	 *		differ from the value that was sent in the `filename` parameter.
	 * @cb-returns {void}
	 * @param {Object} invokingView The view that is invoking the image picker.
	 * @returns {void}
	 * @since 1.3.1b
	 */
    choosePhoto: function(targetWide, targetHigh, filename, options, callback, invokingView) {
       if (!invokingView || !invokingView.__objectRegistryId) {
            new exports.UI.Toast({
                'text': "Photo picker requires an invoking view.",
                'onDisappear': function() {
                    this.destroy();
                }
            }).show();
            return;
        }

        var cb = this.Commands.registerTemporaryCallback(callback);
		if (cb) {
        	this.Commands.doChoosePhoto(targetWide, targetHigh, filename, options || {}, cb, invokingView.__objectRegistryId);
		}
    },

    /**
     * Display a full-screen interface for taking a new photo with the device's camera, and write
	 * the photo to the device's file system. You can retrieve the photo at its original size, or 
	 * you can rescale the photo to fit within a width and height you specify.
	 *
	 * By default, the image is saved in PNG format. To use JPEG format, specify a filename with the
	 * extension .jpg.
	 * @name UI.choosePhotoCamera
	 * @function
	 * @static
	 * @example
	 * // Take a photo, and scale it to fit within a 100 x 200 rectangle.
	 * var filename = "example.png";
	 * UI.choosePhotoCamera(100, 200, filename, {}, function(data) {
	 *     if (data.error) {
	 *         // The user probably canceled instead of taking a photo.
	 *         console.log("Unable to retrieve a photo: " + data.error);
	 *     } else {
	 *         // Update the filename.
	 *         filename = data.filename;
	 *     }
	 * });
	 * @param {Number} targetWide The width, in pixels, to use for scaling the photo. Use 0 to
	 *		retrieve an unscaled photo.
	 * @param {Number} targetHigh The height, in pixels, to use for scaling the photo. Use 0 to
	 *		retrieve an unscaled photo.
	 * @param {String} filename The preferred filename for the new photo. Use the extension .jpg to
	 *		save the file in JPEG format. By default, the file is saved in PNG format. **Note**: The
	 *		file may be saved using a different name. Use the callback function to identify the 
	 *		file's actual name.
	 * @param {Object} options Options for retrieving the image.
	 * @param {UI.Commands#FitMode} [options.fit=UI.Commands.FitMode.Inside] The image fit mode to
	 *		use when scaling the existing image.
	 * @param {Number[]|UI.ViewGeometry#Gravity} [options.gravity=[0.5, 0.5]] The image gravity to
	 *		use when placing the existing image within the retrieved image. See
	 *		`{@link UI.Image#setImageGravity}` for more details about this property.
	 * @param {Number[]} [options.insets=[0, 0, 0, 0]] The insets that will be used to clip the
	 *		edges of the image. Specified as an array of four floats, starting with the top inset
	 *		and going clockwise around the image.
	 * @param {Number[]} [options.rect] An array of integers that specify a rectangle where the 
	 *		existing image will be placed in the new image. (By default, this method uses a
	 *		rectangle that is the same size as the new image.) The array contains the following four
	 *		values, in this order:
	 *
	 * 1. The X origin at which to place the top left corner of the existing image.
	 * 2. The Y origin at which to place the top left corner of the existing image.
	 * 3. The width, in pixels, of the image rectangle.
	 * 4. The height, in pixels, of the image rectangle.
	 * @param {Number[]} [options.transform] The affine transformation to apply to the existing
	 *		image. See `{@link UI.Image#setImageTransform}` for more information about affine
	 *		transformations. Specified as an array of six floats: `[a, b, c, d, tx, ty]`.
	 * @cb {Function} callback The function to call after taking a photo.
	 * @cb-param {Object} data Information about the photo.
	 * @cb-param {String} [data.error] A description of the error, if any.
	 * @cb-param {String} [data.filename] The filename for the photo. **Note**: This value may
	 *		differ from the value that was sent in the `filename` parameter.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.3.1b
	 */
    choosePhotoCamera: function(width, height, filename, options, callback) {
        var cb = this.Commands.registerTemporaryCallback(callback);
		if (cb) {
        	this.Commands.doChooseCamera(width, height, filename, options || {}, cb);
		}
    },


    /**
	 * Capture a static image of the screen. You can retrieve the screenshot at its original size, 
	 * or you can rescale the image to fit within a width and height you specify.
	 *
	 * By default, screenshots include graphics that were drawn by classes in the `UI` and
	 * `{@link GL2}` modules. Use the `options.screenshotType` parameter to exclude either type of
	 * graphics from the screenshot.
	 *
	 * By default, the image is saved in PNG format. To use JPEG format, specify a filename with the
	 * extension .jpg.
	 * @name UI.takeScreenshot
	 * @function
	 * @static
	 * @example
	 * // Take a screenshot, and scale it to fit within a 100 x 200 rectangle.
	 * var filename = "example.png";
	 * UI.takeScreenshot(100, 200, filename, {}, function(data) {
	 *     if (data.error) {
	 *         console.log("Unable to retrieve a screenshot: " + data.error);
	 *     } else {
	 *         // Update the filename.
	 *         filename = data.filename;
	 *     }
	 * });
	 * @param {Number} targetWide The width, in pixels, to use for scaling the photo. Use 0 to
	 *		retrieve an unscaled image.
	 * @param {Number} targetHigh The height, in pixels, to use for scaling the photo. Use 0 to
	 *		retrieve an unscaled image.
	 * @param {String} filename The preferred filename for the new image. Use the extension .jpg to
	 *		save the file in JPEG format. By default, the file is saved in PNG format. **Note**: The
	 *		file may be saved using a different name. Use the callback function to identify the 
	 *		file's actual name.
	 * @param {Object} options Options for retrieving the screenshot.
	 * @param {UI.Commands#FitMode} [options.fit=UI.Commands.FitMode.Inside] The image fit mode to
	 *		use when scaling the screenshot.
	 * @param {Number[]|UI.ViewGeometry#Gravity} [options.gravity=[0.5, 0.5]] The image gravity to
	 *		use when placing the screenshot within the retrieved image. See
	 *		`{@link UI.Image#setImageGravity}` for more details about this property.
	 * @param {Number[]} [options.insets=[0, 0, 0, 0]] The insets that will be used to clip the
	 *		edges of the image. Specified as an array of four floats, starting with the top inset
	 *		and going clockwise around the image.
	 * @param {Number[]} [options.rect] An array of integers that specify a rectangle where the 
	 *		screenshot will be placed in the new image. (By default, this method uses a rectangle
	 *		that is the same size as the new image.) The array contains the following four values,
	 *		in this order:
	 *
	 * 1. The X origin at which to place the top left corner of the screenshot.
	 * 2. The Y origin at which to place the top left corner of the screenshot.
	 * 3. The width, in pixels, of the image rectangle.
	 * 4. The height, in pixels, of the image rectangle.
	 * @param {Number[]} [options.transform] The affine transformation to apply to the screenshot.
	 *		See `{@link UI.Image#setImageTransform}` for more information about affine
	 *		transformations. Specified as an array of six floats: `[a, b, c, d, tx, ty]`.
	 * @param {UI.Commands.ScreenshotType} [options.screenshotType] Indicates whether to include
	 *		graphics drawn with the `UI` module, the `{@link GL2}` module, or both modules. By
	 *		default, screenshots include graphics from both modules.
	 * @cb {Function} callback The function to call after taking a screenshot.
	 * @cb-param {Object} data Information about the screenshot.
	 * @cb-param {String} [data.error] A description of the error, if any.
	 * @cb-param {String} [data.filename] The filename for the screenshot. **Note**: This value may
	 *		differ from the value that was sent in the `filename` parameter.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.6.5
	 */
	takeScreenshot: function(width, height, filename, options, callback) {
		var cb = this.Commands.registerTemporaryCallback(callback);
		if (cb) {
			this.Commands.takeScreenshot(width, height, filename, options || {}, cb);
		}
	},

	/**
	 * Retrieve the width and height, in pixels, of a text block. The dimensions are measured by
	 * attempting to lay the text out inside of a rectangle whose width and height you specify,
	 * using a font and font size that you specify. If the text overflows the rectangle's height,
	 * only the text that fits within the rectangle is measured.
	 *
	 * You can also measure the dimensions of a text block without width and/or height constraints,
	 * which enables you to determine how much space would be required to display the text block.
	 * @name UI.measureText
	 * @function
	 * @static
	 * @example
	 * // Measure the dimensions of a text block that is allowed to take up the
	 * // entire screen.
	 * var string = "You have to learn the rules of the game. And then you have to " +
	 *   "play better than anyone else.";
	 * var blockSize = [];
	 * var lineWidths = [];
	 * var totalWidth = 0;
	 * UI.measureText(string, Device.LayoutEmitter.getWidth(),
	 *   Device.LayoutEmitter.getHeight(), "DroidSans", 24, function(dimensions) {
	 *     blockSize = [dimensions.width, dimensions.height];
	 *     lineWidths = dimensions.lineWidths;
	 *     totalWidth = dimensions.totalWidth;
	 * });
	 * @param {String} text The string of text to measure.
	 * @param {Number} w The width, in pixels, of the rectangle that will be used to lay out the
	 *		text. Specify an empty string to measure the text without a width constraint.
	 * @param {Number} h The height, in pixels, of the rectangle that will be used to lay out the
	 *		text. Specify an empty string to measure the text without a height constraint.
	 * @param {String} font The name of the font to use for measuring the text.
	 * @param {Number} size The font size, in pixels, to use for measuring the text.
	 * @cb {Function} callback The function to call after measuring the text.
	 * @cb-param {Object} dimensions Information about the text dimensions.
	 * @cb-param {Number} dimensions.height The height, in pixels, of the block of text.
	 * @cb-param {Number[]} dimensions.lineWidths The widths, in pixels, of each line in the block
	 *		of text.
	 * @cb-param {Number} dimensions.totalWidth The combined width, in pixels, of all of the lines
	 *		in the text block.
	 * @cb-param {Number} dimensions.width The width, in pixels, of the block of text.
	 * @cb-returns {void}
	 * @returns {void}
	 * @since 1.4.2
	 */
	measureText: function( text, w, h, font, size, callback) {
		var cb = this.Commands.registerTemporaryCallback(callback);
		if (cb !== '') {
			this.Commands.measureText(text, w || -1, h || -1, font, size, cb);
		}
	},
	/**
	 * Hide the on-screen keyboard if it is showing, regardless of which text field or text area is 
	 * selected.
	 * @name UI.hideKeyboard
	 * @function
	 * @static
	 * @returns {void}
	 * @since 1.6.5
	 */
	hideKeyboard: function() {
		this.Commands.hideKeyboard();
	}
};

exports.UI = new UILoader({
	"Commands": function() { return require("NGCore/Client/UI/Commands").Commands; },
	"FontStyle": function() { return this.Commands.FontStyle; },
	"State": function() { return this.Commands.State; },
	"FitMode": function() { return this.Commands.FitMode; },
	
	"Window": function() { return require("NGCore/Client/UI/Window").Window; },
	"Element": function() { return require("NGCore/Client/UI/Element").Element; },
	"ViewGeometry": function() { return require("NGCore/Client/UI/ViewGeometry").ViewGeometry; },
	"Scale": function() { return exports.UI.ViewGeometry.Scale; },
	"View": function() { return require("NGCore/Client/UI/View").View; },
	"Label": function() { return require("NGCore/Client/UI/Label").Label; },
	"Image": function() { return require("NGCore/Client/UI/Image").Image; },
	"Button": function() { return require("NGCore/Client/UI/Button").Button; },
	"GLView": function() { return require("NGCore/Client/UI/GLView").GLView; },
	"NavController": function() { return require("NGCore/Client/UI/NavController").NavController; },
	"WebView": function() { return require("NGCore/Client/UI/WebView").WebView; },
	"ScrollView": function() { return require("NGCore/Client/UI/ScrollView").ScrollView; },
	"ListView": function() { return require("NGCore/Client/UI/ListView").ListView; },
	"ListViewSection": function() { return require("NGCore/Client/UI/ListViewSection").ListViewSection; },
	"ListViewItem": function() { return require("NGCore/Client/UI/ListViewItem").ListViewItem; },
	"CellView": function() { return require("NGCore/Client/UI/CellView").CellView; },
	"CheckBox": function() { return require("NGCore/Client/UI/CheckBox").CheckBox; },
	"EditText": function() { return require("NGCore/Client/UI/EditText").EditText; },
	"EditTextArea": function() { return require("NGCore/Client/UI/EditTextArea").EditTextArea; },
	"DateField": function() { return require("NGCore/Client/UI/DateField").DateField; },
	"AlertDialog": function() { return require("NGCore/Client/UI/AlertDialog").AlertDialog; },
	"ProgressDialog": function() { return require("NGCore/Client/UI/ProgressDialog").ProgressDialog; },
	"Toast": function() { return require("NGCore/Client/UI/Toast").Toast; },
	"Style": function() { return require("NGCore/Client/UI/Style").Style; },
	"Spinner": function() { return require("NGCore/Client/UI/Spinner").Spinner; },
	"ProgressBar": function() { return require("NGCore/Client/UI/ProgressBar").ProgressBar; },
	"Diagnostics": function() { return require("NGCore/Client/UI/Diagnostics").Diagnostics; },
/** @private */
	"AdView": function() { return require("NGCore/Client/UI/AdView").AdView; },
	"DocumentView": function() { return require("NGCore/Client/UI/DocumentView").DocumentView; },
	"CheckoutView": function() { return require("NGCore/Client/UI/CheckoutView").CheckoutView; },
	"MapView": function() { return require("NGCore/Client/UI/MapView").MapView; },
	"MapAnnotation": function() { return require("NGCore/Client/UI/MapAnnotation").MapAnnotation; },
	"_CutSceneView": function() { return require("NGCore/Client/UI/_CutSceneView").CutSceneView; }
});

; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/ngCrunch'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/ngCrunch'] || {}; $MODULE_REGISTRY['ngCrunch/ngCrunch'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/ngCrunch.js';

/*
 *  ngCrunch.js
 *  BigClaw
 *
 *  Created by Dennis on 10/17/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 *  This was core.js, but it was realized there were namespacing issues. Core.js now includes this.
 *  Note that global functions are defined with name = function name()...
 *  This forces the function declared as a global (instead of the default: local to this file).
 *
 */

var Core  = require('NGCore/Client/Core').Core;

// are we on flash?
_FLASH = typeof(_NG_TARGET_FLASH) != 'undefined';

// are we in node.js hosted mode? true/false.
// Should *always* be committed in SVN as 'false'.
_NODEJS = false;

// are we in debug mode? true/false.  
// Should *always* be committed in SVN as 'false'.
_DEBUG = false;

/**
	Synonym for undefined.
	@example
	if ( thing == NULL )
		log("thing doesn't exist");
	@static
*/
NULL = undefined;	// intentially undefined!


// simple way to determine the described features.
isDroid = function()	/**bool*/
{
	if ( _FLASH )
		return false;
	return Core.Capabilities.getPlatformOS() && 
		Core.Capabilities.getPlatformOS().toLowerCase() == 'android';	
}

isApple = function()	/**bool*/ 
{
	if ( _FLASH )
		return false;
	return !isDroid();
}

isFlash = function()	/**bool*/
{
	return _FLASH;
}

/**
	@function
	Synonym to dump a log message to the console.
	@example
	log("thing doesn't exist");
	@static
*/
log = function log(msg)
{
	if(!_DEBUG)
		return;
	
	// in ngCore SDK 1.1.5 era, logging was completely disabled on iOS for some reason.
	// This was the hack to get around it.
//	if(Core.Capabilities.getPlatformOS() == "iPhone OS")
//		Core.Logger._logSendGen( { msg: msg } );
	if ( 0 ) {}
	
	else if (isDroid())
	{
		// break multilines down and log separately
		var	tree = msg.split("\n");
		for ( var i=0; i<tree.length; i++ )
			NgLogD( tree[i] );
	}
	else
		NgLogD(msg);
}

/** 
	call this to automatically suspend the app.  only works in the browser version.
	@static
*/
suspend = function suspend()
{
	if ( _FLASH )
		simulateSuspendResume();
}

/**
	adds a 'clone' method to a basic Array.  This is a shallow copy!
*/
Array.prototype.clone = function() 
{ 
	return this.slice(0); 
};

/**
	synonym for 'length'.
*/
Array.prototype.size = function() /**int*/ 
{ 
	return this.length; 
};

/**
	'push' an object, but only if that object isn't already in the array.
*/
Array.prototype.add = function( it ) 
{ 
	if ( this.contains(it) )
		return this.length;
	return this.push( it ); 
}

/**
	remove a specific element from an array, searching for it.
	Returns if the item was found.
*/
Array.prototype.remove = function( it ) /**bool*/
{
	var index = this.indexOf(it);
	if ( index < 0 )
		return false;
	
	this.splice(index, 1);
	return true;
}

/**
	return the index of a given object in this array or -1 if not found.
*/
Array.prototype.indexOf = function( it ) /**int*/
{
	var	l = this.length;
	for ( var i=0; i<l; i++ )
	{
		if ( this[i] == it )
			return i;
	}
	return -1;
}

/**
	return the index of a given object in this array or -1 if not found.
	Uses === comparison instead of standard ==.
*/
Array.prototype.strictIndexOf = function( it ) /**int*/
{
	var	l = this.length;
	for ( var i=0; i<l; i++ )
	{
		if ( this[i] === it )
			return i;
	}
	return -1;
}

/**
	synonym for indexOf
*/
Array.prototype.contains = function( it ) /**bool*/
{
	return this.indexOf(it) >= 0? true:false;
}

/**
	“smart” empty array check
	Checks and reports the array as empty if and only if either the array:
	* is zero-length
	* only contains undefined elements (such as when all the elements have been removed with delete, or when an array has been expanded by setting the length property)
*/
Array.prototype.isEmpty = function isEmpty() /**bool*/
{
	// first, do a quick check: if the length is 0, we know it's empty
	if (this.length == 0)
	{
		return true;
	}
	else
	{
		// next, try checking each element for undefined; if any are not, we know it's not empty
		for (var elementI = 0, length = this.length; elementI < length; ++elementI)
		{
			if (typeof this[elementI] != "undefined")
				return false;
		}
		
		return true;
	}
}

/**
	Does this string start with the passed string?
*/
String.prototype.startsWith = function( /**string*/ str )	/**bool*/
{
	var	start = this.length-str.length;
	if ( this.length < str.length )
		return false;
	var test = this.substr( 0, str.length );
	return test == str;
}

/**
	Does this string end with the passed string?
*/
String.prototype.endsWith = function( /**string*/ str )	/**bool*/
{
	var	start = this.length-str.length;
	if ( start < 0 )
		return false;
	var test = this.substr( start );
	return test == str;
}

/**
	For each 'key' value in the passed object, return a string that searches and 
	replaces each instance with the value for that key.  
*/
String.prototype.substitute = function( /**Object*/ keyValues ) /**string*/
{
	var ret = this;
	for ( var i in keyValues )
		ret = ret.replace( "+"+i+"+", keyValues[i] );
	return ret;
}

// add a reasonable toString for Point.
Core.Point.prototype.toString = function()
{
	return "{"+this.getX().toString()+", "+this.getY().toString()+"}";
}

// add a reasonable toString for Size.
Core.Size.prototype.toString = function()
{
	return "{"+this.getWidth().toString()+", "+this.getHeight().toString()+"}";
}

// add a reasonable toString for Vector.
Core.Vector.prototype.toString = function()
{
	return "{"+this.getX().toString()+", "+this.getY().toString()+"}";
}

// add a reasonable toString for Rect.
Core.Rect.prototype.toString = function()
{
	return "{"+this.getOrigin().toString()+", "+this.getSize().toString()+"}";
}

// add a reasonable toString for Color.
Core.Color.prototype.toString = function()
{
	return "{"+this.getRed().toString()+", "+this.getGreen().toString()+", "+this.getBlue().toString()+"}";
}

// adds a 'clone' method to Color
Core.Color.prototype.clone = function()
{
	return new this.constructor(this);
}

/**
	Get the centerpoint of this rectangle.
*/
Core.Rect.prototype.getCenter = function() /**Core.Point*/
{
	return new Core.Point( this.getMidX(), this.getMidY() );
}

/**
	Return a new Point containing this plus passed vector.
*/
Core.Point.prototype.add = function( /**Core.Point*/ b ) /**Core.Point*/
{
	return new Core.Point( this.getX()+b.getX(), this.getY()+b.getY() );
}

/**
	Return a new Point containing this minus passed vector.
*/
Core.Point.prototype.sub = function( /**Core.Point*/ b ) /**Core.Point*/
{
	return new Core.Point( this.getX()-b.getX(), this.getY()-b.getY() );
}

/**
	Return a new Point containing this scaled by a vector.
*/
Core.Point.prototype.scale = function( /**float*/ b ) /**Core.Point*/
{
	return new Core.Point( this.getX()*b, this.getY()*b );
}

/**
	Return the 'quick length', x*x+y*y, but does *not* do the square root.
*/
Core.Point.prototype.qlen = function() /**float*/
{
	return this.getX()*this.getX() + this.getY()*this.getY();
}


// overrides the standard exception handler to more clearly explain "what went wrong".
// Over time we should add additional cases for other common errors.
// @private
NgLogException_xxx = function NgLogException( ex )
{
    var str = "\n>>>\n>>> EXCEPTION "+ex.toString()+"\n>>>\n";

	var	curr = arguments.callee.caller;	// remove this from trace
	while (curr) {
		str += curr.toString() + "\n================================\n";
		curr = curr.caller;
	}
	str += "\n";
	
    for( var prop in ex )
		str += "\t"+prop+": ["+ ex[prop]+ "]\n";

	NgLogD( str );
}


// overrides the standard exception handler to more clearly explain "what went wrong".
// Over time we should add additional cases for other common errors.
// @private
NgLogException_ngCrunch = function NgLogException( ex, /**bool*/inAllowContinue )
{
	var	preamble = "\n>>>\n>>> EXCEPTION: ";
	var	postable = "\n>>>";
	
	// do special stuff depending on the type of error
	switch ( ex.name )
	{
		case 'ReferenceError':
			log(preamble+ex.message+" from line "+ex.line+". Might also be looking for a function with that name."+postable);
			break;
		
		// Message:
		// Result of expression 'this._children' [undefined] is not an object.
		// Not gonna do anything more with this until i start regexp'ing these.
	//	case 'TypeError':
	//		break;
		
		default:
			var str = preamble+ex.message+" at line "+ex.line+"."+postable+"\n";
			for( var prop in ex )
			{
				var	allow = true;
				switch ( prop )
				{
					case 'message':
					case 'line':
					case 'name':
						allow = false;
				}
				if ( !allow )
					continue;
				str += "    "+ prop+ ":"+ ex[prop]+ "\n";
			}
			log(str);
			break;
	}
	
	// and pause things right here.
	if ( !inAllowContinue )
		suspend();
		
	// can we re-throw the exception to make the browser stop?
//	throw ex;	// doesn't do much, nevermind.
}

if ( _DEBUG ) // do simple exception logging
{
	NgLogException = NgLogException_ngCrunch;
	NgHandleException = NgLogException;
}

/**
 * Given arguments array as a String, subsituting type names for non-string types.
 *
 * @param {Arguments} object
 * @return {Array} of Strings with stringified arguments
 *
 * Borrowed from stacktrace.js at 
 * https://github.com/eriwen/javascript-stacktrace/blob/master/stacktrace.js
 */
function _stringifyArguments(args) 
{
	var slice = Array.prototype.slice;
	for (var i = 0; i < args.length; ++i) {
		var arg = args[i];
		if (arg === undefined) {
			args[i] = 'undefined';
		} else if (arg === null) {
			args[i] = 'null';
		} else if (arg.constructor) {
			if (arg.constructor === Array) {
				if (arg.length < 3) {
					args[i] = '[' + _stringifyArguments(arg) + ']';
				} else {
					args[i] = '[' + _stringifyArguments(slice.call(arg, 0, 1)) + '...' + _stringifyArguments(slice.call(arg, -1)) + ']';
				}
			} else if (arg.constructor === Object) {
				args[i] = '#object';
			} else if (arg.constructor === Function) {
				args[i] = '#function';
			} else if (arg.constructor === String) {
				args[i] = '"' + arg + '"';
			}
		}
	}
	return args.join(',');
}

// in _DEBUG, dump a stacktrace to console for working out who called me, without
// stopping the app.
// Note: all methods in the stack need to have the pattern of "function foo( args )".
// By default class methods don't, they need to be done like:
// classMethod:	function classMethod( args )	
// to be seen properly
NgLogStacktrace = function NgLogStacktrace( message )
{
	if ( _DEBUG )	// enable NgLogStacktrace in _DEBUG
		{} else return;
		
	if ( isApple() )
	{
		// this is the Safari version.
		var	str = message+"\n";
		var ANON = '{anonymous}', fnRE = /function\s*([\w\-\_$]+)?\s*\(/i;
		var	curr = arguments.callee.caller;	// remove this from trace
		while (curr) 
		{
			fn = fnRE.test(curr.toString()) ? RegExp.$1 || ANON : ANON;
			args = Array.prototype.slice.call(curr['arguments'] || []);
            str += "\t"+ fn + "(" + _stringifyArguments(args) + ")\n";
			curr = curr.caller;
		}
		str += "\n";
		log(str);
		return;
	}

	{
		// this is the v8/Droid version
		try {
			throw new Error(message);
		} catch ( err ) {
			NgLogException( err, true );
		}
		return;
	}
}


// replace stringify so we can catch exceptions and display immediately.
if ( _DEBUG && 0 )
{
	var oldStringify = JSON.stringify;
	JSON.stringify = function() 
	{
		try {
		//	log("using modded JSON.stringify");
			return oldStringify.apply(JSON, arguments);
		} catch(e) {
			NgLogException(e);
			throw e;
		}
	}
}

/**
	//Record of a scheduled callback
	@private
*/
var Timer = Core.MessageListener.subclass(
{
	initialize: function(time, callback)
	{
		this.target = callback;
		this.targetTime = time*1000.0;			//game ticks are in ms, 
		this.counter = 0;
		
		Core.UpdateEmitter.addListener(this, this.tick);
	},
	
	destroy: function()
	{
		this.target = NULL;	// make certain it is never called.
		Core.UpdateEmitter.removeListener(this);
	},
	
	tick: function(delta)
	{
		// deal with bug in SDK 1.0 on flash where delta is always 0.
		if ( delta <= 0 )
			delta = 1000/60;
			
		this.counter += delta;
		
		if(this.counter >= this.targetTime)
		{
			if ( this.target )
				this.target();
			
			this.destroy();
		}
	}

});


/**
	Asynchronously call a function after a delay
*/

invokeAfterDelay = function invokeAfterDelay(/**float*/seconds, /**function*/target)
{
	return new Timer(seconds, target);
}

/**
	synonym for Core.Localization.getString
*/
localString = function localString( /**string*/ inKey ) /**string*/
{
	// if it doesn't start with "$", it's a literal string.
	if ( inKey.startsWith("$") )
		return Core.Localization.getString(inKey.replace("$",""));
	return inKey;
}


/**

    Choose the level of graphics appropriate for the current device

*/

graphicsLevelPath = function graphicsLevelPath()
{
    var device = Core.Capabilities.getDeviceName();
    
    //TODO: compare to list of devices to select high or low graphics. In this case we will always 
    //be selecting high.
    
    return "lowres";
}

assetPrefix = function assetPrefix()
{
    var res = graphicsLevelPath();
    
    return "./Content/"+res+"/";

}

initialAssetPrefix = function initialAssetPrefix()
{
    return "./Content/initial/";
}

localizedAssetPrefix = function localizedAssetPrefix()
{    
    var prefix = assetPrefix();
    
    var language = Core.Capabilities.getLanguage();
    
    return prefix+"_"+language+"/";
}

localizedInitialAssetPrefix = function localizedInitialAssetPrefix()
{
    //TODO: there is probably a better way to do this

    return "./Content/initial/_"+Core.Capabilities.getLanguage()+"/";
}

/**
	@private
*/
exports.baseInit = function () {}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = exports; 
var __dirname = 'NGCore/Client/Audio';
var __filename = 'NGCore/Client/Audio/ActiveEffect.js';

var Core = require('NGCore/Client/Core').Core;

exports.ActiveEffect = Core.Class.subclass(
/** @lends Audio.ActiveEffect.prototype */
{
	/**
	 * @class The <code>ActiveEffect</code> class constructs objects that control 
	 * the reproduction of an audio effect. Audio effects in Mobage applications are captured as 
	 * <code>{@link Audio.Effect}</code> objects, which load data for an audio effect into memory. 
	 * This separation allows applications to manage effect data independently of effect 
	 * reproduction.
	 * <br /><br />
	 * You must specify the <code>{@link Audio.Effect}</code> object to reproduce when you
	 * instantiate the <code>ActiveEffect</code> object. After instantiation, you cannot change
	 * which <code>{@link Audio.Effect}</code> object is associated with the
	 * <code>ActiveEffect</code> object.
	 * <br /><br />
	 * <strong>Important</strong>: See <code>{@link Audio.Effect}</code> for information about the
	 * maximum size of audio resources.
	 * @example
	 * var effect = new Audio.Effect('some_effect.wav');
	 * var activeEffect = new Audio.ActiveEffect(effect);
	 * activeEffect.play();
	 * @constructs The default constructor. 	 
	 * @augments Core.Class
	 * @param {Audio.Effect} effect The <code>{@link Audio.Effect}</code> that this <code>ActiveEffect</code> object plays.
	 * @see Audio.Effect
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	initialize: function(effect)
	{
		this._volume  = 1.0;
		this._loops   = false;
		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter = new Core.MessageEmitter();

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setEffect(effect);
	},
	
	/**
	 * Destroy this instance and releases resources on the backend.
	 * <b>Note:</b> This call does not automatically destroy the associated <code>{@link Audio.Effect}</code>.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		this.stop();
		this._effect = null;
		this._playCompleteEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Return the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Number} The current volume level.
	 * @see Audio.ActiveEffect#setVolume
	 * @status iOS, Android, Flash, Test
	 * @since 1.0
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * Calling this changes the volume even if an application is in the middle of reproducing an <code>{@link Audio.Effect}</code> object.
	 * The new volume level applies to any subsequent reproductions of the <code>{@link Audio.Effect}</code> object.
	 * @example Audio.ActiveEffect.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume level. Supported values range between <code>(0-1)</code>. 
	 * @returns {this}
	 * @see Audio.ActiveEffect#getVolume
	 * @status iOS, Android, Flash
	 * @since 1.0
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the loop status for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled.
	 * @see Audio.ActiveEffect#setLoops
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getLoops: function()
	{
		return this._loops;
	},
	
	/**
	 * Set the loop state for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * A looped effect wraps seamlessly from begining to end.
	 * @example Audio.ActiveEffect.setLoops(true);
	 * @param {Boolean} loops Set as <code>true</code> to enable looping.
	 * @returns {this}
	 * @see Audio.ActiveEffect#getLoops
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setLoops: function(loops)
	{
		this._loops = loops;
		this._setLoopsSendGen(loops);
		return this;
	},
	
	/**
	 * Retrieve the <code>PlayComplete</code> emitter for the <code>{@link Audio.Effect}</code> this
	 * <code>ActiveEffect</code> is reproducing. The <code>PlayComplete</code> emitter notifies
	 * its listeners when reproduction of an <code>{@link Audio.Effect}</code> is complete, passing
	 * the <code>ActiveEffect</code> object to the listener.
	 * <br /><br />
	 * <strong>Note</strong>: An <code>{@link Audio.Effect}</code> that loops will not trigger the
	 * <code>PlayComplete</code> emitter.
	 * @example
	 * var AudioSample = Core.MessageListener.subclass({
	 *     initialize: function() {
	 *         this._effect = new Audio.Effect("path/to/effect");
	 *         this._activeEffect = new Audio.ActiveEffect(this._effect);
	 *     },
	 *     
	 *     addListener: function() {
	 *         this._activeEffect.getPlayCompleteEmitter().
	 *           addListener(this, this.onComplete.bind(this));
	 *     },
	 *
	 *     onComplete: function(activeEffect) {
	 *         activeEffect.getPlayCompleteEmitter().removeListener(this);
	 *         activeEffect.destroy();
	 *         this._activeEffect = null;
	 *         console.log("Play completed");
	 *     }
	 * });
	 * @returns {Core.MessageEmitter} The current state of the <code>PlayComplete</code> emitter.
	 * @status iOS, Flash, Test, FlashTested
	 * @since 1.0
	 */
	getPlayCompleteEmitter: function()
	{
		return this._playCompleteEmitter;
	},
	
	/**
	 * Return the play status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>ActiveEffect</code> is reproducing an <code>{@link Audio.Effect}</code>.
	 * @see Audio.ActiveEffect#play
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>{@link Audio.Effect}</code> is in a paused state.
	 * @see Audio.ActiveEffect#pause
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproducing an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>{@link Audio.Effect}</code> is new or in a stopped state,
	 * reproduction starts at the beginning.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is in a paused state, reproduction resumes from the previous position.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.ActiveEffect#getIsPlaying
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is in the process of reproducing an <code>{@link Audio.Effect}</code>, this call pauses reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped or paused state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling this does not trigger the <code>Play Complete</code> emitter.
	 * @see Audio.ActiveEffect#getIsPaused
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reprodution of an <code>{@link Audio.Effect}</code> object.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is currently reproducing an <code>{@link Audio.Effect}</code> or the <code>{@link Audio.Effect}</code> is in a paused state, this call stops reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling <code>stop()</code> does not trigger the <code>Play Complete</code> emitter.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 328,
	// Method create = -1
	// Method destroy = 2
	// Method setVolume = 3
	// Method setLoops = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method setEffect = 8
	// Method playComplete = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 9:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[328] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ActiveEffect.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x148ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1480002, this );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( 0x1480003, this, [ +volume ] );
	},
	
	/** @private */
	_setLoopsSendGen: function( loops )
	{
		Core.Proc.appendToCommandString( 0x1480004, this, [ ( loops ? 1 : 0 ) ] );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1480005, this );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1480006, this );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1480007, this );
	},
	
	/** @private */
	_setEffectSendGen: function( effectId )
	{
		Core.Proc.appendToCommandString( 0x1480008, this, [ +effectId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setVolume: function( volume ) {}
	
	// setLoops: function( loops ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// setEffect: function( effectId ) {}
	
	// _playCompleteRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


	,
	_setEffect: function(effect)
	{
		this._effect  = effect;
		this._setEffectSendGen(this._effect.__objectRegistryId);
		return this;
	},

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter.emit(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Diagnostics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Diagnostics'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Diagnostics'] = exports; 
var __dirname = 'NGCore/Client/Audio';
var __filename = 'NGCore/Client/Audio/Diagnostics.js';

////////////////////////////////////////////////////////////////////////////////
// Class Diagnostics
// Audio diagnostic emitter; collects info from Audio subsystem.
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////
    
//
// Create and export a DiagnosticEmitter for Audio.
//

exports.Diagnostics = Core.DiagnosticEmitter.singleton(
{
	classname: 'Audio_Diagnostics',

	/**
	 * @class The <code>Audio.Diagnostics</code> class provides detailed diagnostic information
	 * about classes in the <code>Audio</code> module. You can use this information to debug your
	 * app's use of the <code>Audio</code> module and learn more about the app's performance.
	 * <br /><br />
	 * The emitter emits an object of the form:
	 * <br /><br />
	 * <pre>
	 * {
	 *     name: "Audio",                       // The emitter's name
	 *     effects: {
	 *         count: {Number},                 // Total number of effects
	 *         effectPaths: {String[]}          // Paths to the effects
	 *     },
	 *     volume: {Number},                    // Audio volume, from 0 (muted) to 1 (full volume)
	 *     audio_update_time: {Timer}           // Time spent processing effects
	 *     audio_update_detached_time: {Timer}, // Time spent processing detached sounds
	 *     audio_update_music_time: {Timer},    // Time spent processing music
	 *     activeEffects: {
	 *         count: {Number}                  // Number of ActiveEffect objects
	 *     },
	 *     detachedSounds: {                    // Number of detached sounds
	 *         count: {Number}
	 *     },
	 *     music: {
	 *         filename: {String},              // Path to the background music file
	 *         isPlaying: {Boolean},            // Set to true if the background music is playing
	 *         volume: {Number},                // Background music volume, from 0 (muted) to 1 (full volume)
	 *         currentTime: {Number}            // Elapsed playback time, in milliseconds
	 *     },
	 *     totalMemory: {Number}                // Total memory, in bytes, used for music and effects
	 * }
	 * </pre>
	 * The <code>Timer</code> type is an object of the form:
	 * <br /><br />
	 * <pre>
	 * {
	 *     samples: {Number},   // Number of samples that were captured
	 *     average: {Number},   // Average time spent in the timed block
	 *     min: {Number},       // Minimum time spent in the timed block
	 *     max: {Number}        // Maximum time spent in the timed block
	 * }
	 * </pre>
	 * @name Audio.Diagnostics
	 * @constructs
	 * @augments Core.DiagnosticEmitter
	 * @singleton
	 * @since 1.8
	 */
	
	initialize: function($super)
	{
	$super('Audio');
	this._includeDetails = false;
	},

	/**
	 * @this Diagnostics
	 * @private
	 */
	includeDetails: function()
	{
		return this._includeDetails;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Device'] = exports; 
var __dirname = 'NGCore/Client/Audio';
var __filename = 'NGCore/Client/Audio/Device.js';

var Core = require('NGCore/Client/Core').Core;
var Diagnostics = require('NGCore/Client/Audio/Diagnostics').Diagnostics;

exports.Device = Core.Class.singleton(
/** @lends Audio.Device.prototype */
{
	classname: 'Device',

	/**
	 * @class The <code>Device</code> class constructs a singleton object that contains audio device properties.
	 * Applications can use <code>Device</code> objects to control global audio effects volume 
	 * and reproduce detached audio effects.
	 * @singleton
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @since 1.0
	 */
	 
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._volume = (Core.Capabilities.getPlatformOS().toLowerCase() == 'flash') ? 1.0 : undefined; // default value

		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var initialValues = KeyValueCache.global("Audio.Device.InitialValues");

		var self = this;
		initialValues.getItem("effectsVolume", {}, function(error, value) {
			if (error) {
				NgLogW('Audio.Device: failed in getting device volume: ' + error);
				self._volume = 1.0; // fallback to 1.0
			} else
				self._volume = parseFloat(value);
		});

		/** @private */
		this.resetEffectsRequests = {};
		/** @private */
		this.cbIdCounter = 1;

		/** @private */
		this.effectCount = 0;
		this.effectList = [];
		Diagnostics.pushCollector(this.collectDeviceInfo.bind(this));
	},
	
	/**
	 * Return the global sound effects volume for this <code>Device</code> object.
	 * @returns {Number} The current global sound effects volume.
	 * @see Audio.Device#setEffectsVolume	 
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	getEffectsVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the global sound effects volume for this <code>Device</code> object.
	 * Volume for each active effect multiplies
	 * by this value to produce a new volume level. 
	 * For example, if the global sound effects volume is set to 0.5, each active effect will play at half the volume set on the effect.
	 * @param {Number} [effectsVolume=1] The new volume for global sound effects. 
	 * Supported values range between <code>(0-1)</code>. 
	 * @example Audio.Device.setEffectsVolume(0.5);
	 * @returns {this}
	 * @see Audio.Device#getEffectsVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @since 1.0
	 */
	setEffectsVolume: function(effectsVolume)
	{
		if (effectsVolume < 0.0) effectsVolume = 0.0;
		if (effectsVolume > 1.0) effectsVolume = 1.0;

		this._volume = effectsVolume;
		this._setEffectsVolumeSendGen(effectsVolume);
		return this;
	},
	
	/**
	 * Play an audio effect in a way that is completely detached from upstream or downstream processing.
	 * Using this call is a simple, high-level way to reproduce an audio effect.<br /><br />
	 * The specified audio effect is only reproduced once.
	 * There is no control over the effect volume or effect playback.
	 * Resource allocation automatically occurs on the backend when playback begins. Resources are automatically released when playback ends.	 
	 * The following code is an example of a <code>playDetached()</code> call.
	 * @example
	 * Audio.Device.playDetached('Content/explosion.wav');
	 * @param {String} path A relative directory path to the audio file.
	 * @returns {this}
	 * @deprecated Since version 1.7. This method will be removed in a future version of ngCore.
	 *		Calling this method can lead to poor performance on some Android devices.  Use the
	 *		{@link Audio.ActiveEffect} and {@link Audio.Effect} classes rather than this method.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	playDetached: function(path)
	{
		this._playDetachedSendGen( path );
		return this;
	},

	/**
	 * Reset all audio effects on a device running Android 2.3 or earlier. These versions of
	 * Android can load only 255 simultaneous effects. You must recreate all of the application's
	 * <code>ActiveEffect</code> objects after calling this method.
	 * <br /><br />
	 * On iOS, and on devices running later versions of Android, this method has no effect.
	 * <br /><br />
	 * <strong>Important</strong>: This method is synchronous, and calling this method can result in
	 * a noticeable delay in your application. Be sure to call the method at a time when the user
	 * will not notice the delay (for example, during a transition between levels).
	 * @name Audio.Device#resetEffects
	 * @function
	 * @returns {void}
	 * @status Android, Test, AndroidTested
	 * @since 1.7
	 */
	
	resetEffects: function( cb )
	{
		var cbId = 0;

		if (Core.Capabilities.getPlatformOS().toLowerCase() == 'android')
		{
			if (cb)
			{
				cbId = this.cbIdCounter++;
				this.resetEffectsRequests[ cbId ] = cb;
			}

			this._resetEffectsSendGen(cbId);
		}
		else if(typeof(cb) == 'function')
		{
			cb();
		}
		return this;
	},
	
	/**
	 * @private
	 */
	_resetEffectsCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._resetEffectsCbRecvGen(cmd, msg))
			return;

		var cbId = msg[ "callbackId" ];

		if ( !cbId )
		{
			//NgLogE ( "Audio Device command : No cbId" );
			return;
		}

		var cb = this.resetEffectsRequests[ cbId ];

		if ( !cb )
		{
			NgLogE ( "Audio Device command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.resetEffectsRequests[ cbId ];

		cb ( );
	},

	effectCreated: function(path)
	{
		this.effectCount++;
		this.effectList.push( path  );
	},

	effectDestroyed: function()
	{
		var index = this.effectList.indexOf(this._path);
		if(index >=0)
		{
			this.effectList.splice(index, 1);
		}
		this.effectCount--;
	},

	//Diagnostics collector
	collectDeviceInfo: function(type, interval)
	{
		var collectedInfo = { volume: this._volume };
		if(Diagnostics.includeDetails())
		{
			collectedInfo['effects'] = { count: this.effectCount, effectPaths: this.effectList };
		}
		else
		{
			collectedInfo['effects'] = { count: this.effectCount };
		}

		return collectedInfo;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 327,
	// Method create = -1
	// Method setEffectsVolume = 2
	// Method playDetached = 3
	// Method resetEffects = 4
	// Method resetEffectsCb = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._resetEffectsCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[327] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_resetEffectsCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Device.resetEffectsCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in Device.resetEffectsCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x147ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_setEffectsVolumeSendGen: function( effectsVolume )
	{
		Core.Proc.appendToCommandString( 0x1470002, this, [ +effectsVolume ] );
	},
	
	/** @private */
	_playDetachedSendGen: function( path )
	{
		Core.Proc.appendToCommandString( 0x1470003, this, [ Core.Proc.encodeString( path ) ] );
	},
	
	/** @private */
	_resetEffectsSendGen: function( callbackId )
	{
		Core.Proc.appendToCommandString( 0x1470004, this, [ +callbackId ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setEffectsVolume: function( effectsVolume ) {}
	
	// playDetached: function( path ) {}
	
	// resetEffects: function( callbackId ) {}
	
	// _resetEffectsCbRecv: function( cmd ) {}
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Effect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] = exports; 
var __dirname = 'NGCore/Client/Audio';
var __filename = 'NGCore/Client/Audio/Effect.js';

var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Audio/Device').Device;

exports.Effect = Core.Class.subclass(
/** @lends Audio.Effect.prototype */
{
	/**
	 * @class The <code>Effect</code> class constructs objects for handling audio resources that comprise an audio effect.
	 * Instantiating these objects allocates resources on the backend.
	 * After creating an <code>Effect</code> object, applications can control reproduction through an <code>{@link Audio.ActiveEffect}</code> object.
	 * <br /><br />
	 * No more than 255 <code>Effect</code> objects can be played simultaneously. Additional <code>Effect</code> objects can be created, but they will not be played.
	 * <br /><br />
	 * <strong>Important</strong>: The audio resource for the <code>Effect</code> object must be
	 * no larger than 1 MB. If your application attempts to play a larger file, it will result in an
	 * error during playback. Take the following steps to minimize the size of your application's
	 * audio resources:
	 * <ul>
	 * <li>Limit the bit rate of your audio resources.</li>
	 * <li>Where possible, use mono audio resources rather than stereo.</li>
	 * <li>Where possible, limit the duration of your audio resources.</li>
	 * </ul>
	 * @example
	 * var effect = new Audio.Effect('Content/explosion.wav');
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @param {String} path A directory path that points to the audio file to load.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	initialize: function(path)
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setPath(path);

		Device.effectCreated(path);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);

		Device.effectDestroyed();
	},
	
	/**
	 * Set a directory path to the audio file resource for this <code>Effect</code> object.
	 * @param {String} path The new directory path.
	 * @returns {this}
	 * @since 1.0
	 */
	_setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	_classId: 326,
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[326] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x146ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1460002, this );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( 0x1460003, this, [ Core.Proc.encodeString( path ) ] );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}



});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Music'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Music'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Music'] = exports; 
var __dirname = 'NGCore/Client/Audio';
var __filename = 'NGCore/Client/Audio/Music.js';

var Core = require('NGCore/Client/Core').Core;

exports.Music = Core.Class.singleton(
/** @lends Audio.Music.prototype */
{
	classname: 'Music',

	/**
	 * @class The <code>Music</code> class constructs a singleton object that provides control over reproduction
	 * of application background music.
	 * This object is constructed independently of <code>Device</code> objects because many devices
	 * already provide hardware-accelerated streaming and decode
	 * for a single background music track. Some
	 * devices gracefully mute a background music track
	 * if the user is playing a music track from their own library.
	 * @singleton
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @since 1.0
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._path    = null;
		this._playing = false;
		this._paused  = false;
		this._volume  = 1.0;
		this._currentTimeCode = 0;
		this._stateChangeEmitter = new Core.MessageEmitter();
		this._timeCodeEmitter    = new this._TimeCodeEmitter();
		this._updateListener     = new this._TimeCodeListener(this._timeCodeEmitter);
		Core.UpdateEmitter.addListener(this._updateListener, this._updateListener.onUpdate);
	},

	destroy: function()
	{
		Core.UpdateEmitter.removeListener(this._updateListener);
		this._stateChangeEmitter.destroy();
		this._timeCodeEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Return the directory path to the background music track that the application is using.
	 * @returns {String} The directory path to a music track.
	 * @see Audio.Music#setPath
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getPath: function()
	{
		return this._path;
	},
	
	/**
	 * Set the directory path for the background music track that the application is using.<br /><br />
	 * <b>Note:</b> If the application is reproducing music when this is called, reproduction will stop.
	 * The application must call <code>play()</code> again to start reproduction of the new resource.<br /><br />
	 * The code in the following example sets a directory path to a music resource and plays that resource.
	 * @example
	 * Audio.Music.setPath('Content/music.mp3');
	 * Audio.Music.play();
	 * @param {string} path The new directory path to a music track.
	 * @see Audio.Music#getPath
	 * @see Audio.Music#play
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setPath: function(path)
	{
		if(path == null)
		{
			throw new Error('Audio.Music setPath(): no path was provided');
		}

		this._path = path;
		this._setPathSendGen(path);
	},
	
	/**
	 * Return the volume level used for reproduction of the application's background music track.
	 * @returns {Number} The current volume level.
	 * @see Audio.Music#setVolume
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level used for reproduction of the application's background music track.
	 * This call instantly modifies the background music volume level.
	 * Any subsequent reproductions of background music will play at the specified volume.
	 * @example Audio.Music.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume. Supported values range between <code>(0-1)</code>.
	 * @returns {this}
	 * @see Audio.Music#getVolume
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the playback state of the background music track.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#play
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause state of the background music track.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#pause
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin playback of the background music track.
	 * <ul>	
	 * <li>If the background music track has not yet been played, or the application has stopped the background music track, 
	 * this call begins reproduction from the beginning.</li>
	 * <li>If the background music track is in a paused state, this call resumes reproduction from the previous position.</li>
	 * <li>If the background music track is currently playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPlaying
	 * @see Audio.Music#pause
	 * @see Audio.Music#stop
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause playback of the background music track.
	 * <ul>
	 * <li>If an application is currently playing the background music track, this call pauses playback.</li>
	 * <li>If the background music track is in a paused or stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPaused
	 * @see Audio.Music#play
	 * @see Audio.Music#stop
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop playback of the background music track.
	 * <ul>
	 * <li>If the background music track is playing or in a paused state, this call stops playback.</li>
	 * <li>If the background music track is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#play
	 * @see Audio.Music#pause
	 * @returns {void}
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested, FlashTested
	 * @since 1.0
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
	/**
	 * Indicate whether the background music track should be reproduced in a loop. By default,
	 * the background music track will loop until the application calls
	 * <code>{@link Audio.Music#pause}</code> or <code>{@link Audio.Music#stop}</code>.
	 * @param {Boolean} toLoop Set to <code>false</code> if the background music track should not be reproduced in a
	 *		loop.
	 * @returns {void}
	 * @see Audio.Music#pause
	 * @see Audio.Music#stop
	 * @since 1.6
	 */
	setLoop: function( toLoop )
	{
		this._setLoopSendGen(toLoop);
	},
	
	/**
	 * Retrieve the state change emitter for the background music track. The emitter's listeners
	 * will receive an enumerated value of <code>{@link Audio.Music#PlayState}</code> when the
	 * playback state changes.
	 * @returns {Core.MessageEmitter} The state change emitter for the background music track.
	 * @since 1.6
	 */
	getStateChangeEmitter: function()
	{
		return this._stateChangeEmitter;
	},

	/**
	 * Retrieve the time code emitter for the background music track. The emitter's listeners will
	 * receive the time code, in milliseconds, of the background music track.
	 * @returns {Core.MessageEmitter} The time code emitter for the background music track.
	 * @since 1.6
	 */
	getTimeCodeEmitter: function()
	{
		return this._timeCodeEmitter;
	},

	/**
	 * Retrieve the current time code (playback position) of the background music track.
	 * @returns {Number} The background music track's current time code, in milliseconds.
	 * @since 1.6
	 */
	getCurrentTimeCode: function()
	{
		return this._currentTimeCode;
	},
	
	
	/**
	 * Enumeration for the background music track's current playback state.
	 * @name PlayState
	 * @fieldOf Audio.Music#
	 * @since 1.6
	 */
	
	/**
	 * The music track is stopped.
	 * @name PlayState.Stop
	 * @fieldOf Audio.Music#
	 * @constant
	 * @since 1.6
	 */
	
	/**
	 * The music track is playing.
	 * @name PlayState.Play
	 * @fieldOf Audio.Music#
	 * @constant
	 * @since 1.6
	 */
	
	/**
	 * The music track is paused.
	 * @name PlayState.Pause
	 * @fieldOf Audio.Music#
	 * @constant
	 * @since 1.6
	 */
	

// {{?Wg Generated Code}}
	
	// Enums.
	PlayState:
	{ 
		Stop: 0,
		Play: 1,
		Pause: 2
	},
	
	///////
	// Class constants (for internal use only):
	_classId: 329,
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	// Method setVolume = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method playComplete = 8
	// Method updatePlayState = 9
	// Method updateTimeCode = 10
	// Method setLoop = 11
	// Method _startTimeCodeUpdating = 12
	// Method _stopTimeCodeUpdating = 13
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._playCompleteRecv( cmd );
					break;
				case 9:
					instance._updatePlayStateRecv( cmd );
					break;
				case 10:
					instance._updateTimeCodeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) === 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[329] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updatePlayStateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.updatePlayState from command: " + cmd );
			return false;
		}
		
		obj[ "state" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "state" ] === undefined )
		{
			NgLogE("Could not parse state in Music.updatePlayState from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateTimeCodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length !== 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.updateTimeCode from command: " + cmd );
			return false;
		}
		
		obj[ "elapsedMilliSecond" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "elapsedMilliSecond" ] === undefined )
		{
			NgLogE("Could not parse elapsedMilliSecond in Music.updateTimeCode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( 0x149ffff, [ +__objectRegistryId ] );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1490002, this );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( 0x1490003, this, [ Core.Proc.encodeString( path ) ] );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( 0x1490004, this, [ +volume ] );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1490005, this );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1490006, this );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x1490007, this );
	},
	
	/** @private */
	_setLoopSendGen: function( toLoop )
	{
		Core.Proc.appendToCommandString( 0x149000b, this, [ ( toLoop ? 1 : 0 ) ] );
	},
	
	/** @private */
	__startTimeCodeUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x149000c, this );
	},
	
	/** @private */
	__stopTimeCodeUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( 0x149000d, this );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	// setVolume: function( volume ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// _playCompleteRecv: function( cmd ) {}
	// _updatePlayStateRecv: function( cmd ) {}
	// _updateTimeCodeRecv: function( cmd ) {}
	// setLoop: function( toLoop ) {}
	
	// _startTimeCodeUpdating: function(  ) {}
	
	// _stopTimeCodeUpdating: function(  ) {}
	
	
	0:0 // tame jslint/Closure Compiler for trailing comma.
// {{/Wg Generated Code}}


	,
	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;
	},

	_updatePlayStateRecv: function( cmd )
	{
		if (this._stateChangeEmitter.getListenerCount() === 0)
			return;

		var msg = {};
		if(!this._updatePlayStateRecvGen(cmd, msg))
			return;

		this._stateChangeEmitter.emit(msg.state);
	},

	_updateTimeCodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._updateTimeCodeRecvGen(cmd, msg))
			return;

		this._currentTimeCode = msg.elapsedMilliSecond;
	},

	_TimeCodeListener: Core.MessageListener.subclass({
		classname: '_TimeCodeListener',

        /**
         * @this _TimeCodeListener
         * @private
         */
		initialize: function(emitter)
		{
			this._emitter = emitter;
		},

        /**
         * @this _TimeCodeListener
         * @private
         */
		onUpdate: function()
		{
			var timeCode = exports.Music.getCurrentTimeCode();
			this._emitter.emit(timeCode);
		}
	}),

	_TimeCodeEmitter: Core.MessageEmitter.subclass({
		classname: '_timeCodeEmitter',

        /**
         * @this _timeCodeEmitter
         * @private
         */
		addListener: function($super, listener, func, priority) {
			if (this.getListenerCount() === 0)
				exports.Music.__startTimeCodeUpdatingSendGen();
			$super(listener, func, priority);
		},
        /**
         * @this _timeCodeEmitter
         * @private
         */
		removeListener: function($super, listener) {
			$super(listener);
			if (this.getListenerCount() === 0)
				exports.Music.__stopTimeCodeUpdatingSendGen();
		}
	})
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Audio.js';

/**
 * <p>Classes and objects contained by the Audio module.</p>
 * @name Audio
 * @namespace Play music and sound effects.
 * @description <p>The Audio module is a collection of classes that support manipulation of audio effects in an application.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Audio.ActiveEffect}</code>: Construct objects for controlling the reproduction of <code>Effect</code> objects.</li>
 *<li><code>{@link Audio.Device}</code>: A singleton object that controls device sound effects volume.</li>
 *<li><code>{@link Audio.Diagnostics}</code>: A singleton object that provides diagnostic information about the app's use of the <code>Audio</code> module.</li>
 *<li><code>{@link Audio.Effect}</code>: Construct objects that load sound resources into memory.</li>
 *<li><code>{@link Audio.Music}</code>: A singleton object that controls the reproduction of application background music.</li>
 *</ul>
 */
exports.Audio = {};

exports.Audio.__defineGetter__("ActiveEffect", function() {
	delete this.ActiveEffect;
	return this.ActiveEffect = require('NGCore/Client/Audio/ActiveEffect').ActiveEffect;
});
exports.Audio.__defineGetter__("Effect", function() {
	delete this.Effect;
	return this.Effect = require('NGCore/Client/Audio/Effect').Effect;
});
exports.Audio.__defineGetter__("Device", function() {
	delete this.Device;
	return this.Device = require('NGCore/Client/Audio/Device').Device;
});
exports.Audio.__defineGetter__("Music", function() {
	delete this.Music;
	return this.Music = require('NGCore/Client/Audio/Music').Music;
});
exports.Audio.__defineGetter__("Diagnostics", function() {
	delete this.Diagnostics;
	return this.Diagnostics = require('NGCore/Client/Audio/Diagnostics').Diagnostics;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Bank'] = exports; 
var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Bank.js';



exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/sha1'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/sha1'] = exports; 
var __dirname = 'NGCore/Client/Plus';
var __filename = 'NGCore/Client/Plus/sha1.js';

// THIS FILE EXISTS ONLY FOR COMPATIBILITY: Use req("./NGCore/Client/Core").SHA1 instead. Full word require_ omitted to avoid parsing

var SHA1 = require('NGCore/Client/Core/SHA1').SHA1;
exports.b64_hmac_sha1 = SHA1.b64_hmac_sha1;
exports.hex_sha1 = SHA1.hex_sha1;
exports.b64_sha1 = SHA1.b64_sha1;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/oauth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/oauth'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/oauth'] = exports; 
var __dirname = 'NGCore/Client/Plus';
var __filename = 'NGCore/Client/Plus/oauth.js';

/*
 * Copyright 2008 Netflix, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* Here's some JavaScript software for implementing OAuth.

   This isn't as useful as you might hope.  OAuth is based around
   allowing tools and websites to talk to each other.  However,
   JavaScript running in web browsers is hampered by security
   restrictions that prevent code running on one website from
   accessing data stored or served on another.

   Before you start hacking, make sure you understand the limitations
   posed by cross-domain XMLHttpRequest.

   On the bright side, some platforms use JavaScript as their
   language, but enable the programmer to access other web sites.
   Examples include Google Gadgets, and Microsoft Vista Sidebar.
   For those platforms, this library should come in handy.
*/

// The HMAC-SHA1 signature method calls b64_hmac_sha1, defined by
// http://pajhome.org.uk/crypt/md5/sha1.js

/* An OAuth message is represented as an object like this:
   {method: "GET", action: "http://server.com/path", parameters: ...}

   The parameters may be either a map {name: value, name2: value2}
   or an Array of name-value pairs [[name, value], [name2, value2]].
   The latter representation is more powerful: it supports parameters
   in a specific sequence, or several parameters with the same name;
   for example [["a", 1], ["b", 2], ["a", 3]].

   Parameter names and values are NOT percent-encoded in an object.
   They must be encoded before transmission and decoded after reception.
   For example, this message object:
   {method: "GET", action: "http://server/path", parameters: {p: "x y"}}
   ... can be transmitted as an HTTP request that begins:
   GET /path?p=x%20y HTTP/1.0
   (This isn't a valid OAuth request, since it lacks a signature etc.)
   Note that the object "x y" is transmitted as x%20y.  To encode
   parameters, you can call OAuth.addToURL, OAuth.formEncode or
   OAuth.getAuthorization.

   This message object model harmonizes with the browser object model for
   input elements of an form, whose value property isn't percent encoded.
   The browser encodes each value before transmitting it. For example,
   see consumer.setInputs in example/consumer.js.
 */

/* This script needs to know what time it is. By default, it uses the local
   clock (new Date), which is apt to be inaccurate in browsers. To do
   better, you can load this script from a URL whose query string contains
   an oauth_timestamp parameter, whose value is a current Unix timestamp.
   For example, when generating the enclosing document using PHP:

    script src="OAuth.js?oauth_timestamp=<?=time()?>" ...

   Another option is to call OAuth.correctTimestamp with a Unix timestamp.
 */

var b64_hmac_sha1_req = require("NGCore/Client/Plus/sha1");

var OAuth;
if ((typeof OAuth == "undefined") || (OAuth === null)) { OAuth = {}; }

OAuth.setProperties = function setProperties(into, from) {
    if (into !== null && from !== null) {
        for (var key in from) {
			if (from.hasOwnProperty(key)) {
				into[key] = from[key];
			}
		}
    }
    return into;
};

OAuth.setProperties(OAuth, // utility functions
{
    percentEncode: function percentEncode(s) {
        if ((typeof s == "undefined") || (s === null)) {
            return "";
        }
        if (s instanceof Array) {
            var e = "";
            for (var i = 0; i < s.length; ++s) {
                if (e !== "") {
					e += '&';
				}
                e += OAuth.percentEncode(s[i]);
            }
            return e;
        }
        s = encodeURIComponent(s);
        // Now replace the values which encodeURIComponent doesn't do
        // encodeURIComponent ignores: - _ . ! ~ * ' ( )
        // OAuth dictates the only ones you can ignore are: - _ . ~
        // Source: http://developer.mozilla.org/en/docs/Core_JavaScript_1.5_Reference:Global_Functions:encodeURIComponent
        s = s.replace(/\!/g, "%21");
        s = s.replace(/\*/g, "%2A");
        s = s.replace(/\'/g, "%27");
        s = s.replace(/\(/g, "%28");
        s = s.replace(/\)/g, "%29");
        return s;
    },
    decodePercent: function decodePercent(s) {
        if (s !== null) {
            // Handle application/x-www-form-urlencoded, which is defined by
            // http://www.w3.org/TR/html4/interact/forms.html#h-17.13.4.1
            s = s.replace(/\+/g, " ");
        }
        return decodeURIComponent(s);
    },
    /** Convert the given parameters to an Array of name-value pairs. */
    getParameterList: function getParameterList(parameters) {
        if ((typeof parameters == "undefined") || (parameters === null)) {
            return [];
        }
        if (typeof parameters != "object") {
            return OAuth.decodeForm(parameters + "");
        }
        if (parameters instanceof Array) {
            return parameters;
        }
        var list = [];
        for (var p in parameters) {
			if (parameters.hasOwnProperty(p)){
				list.push([p, parameters[p]]);
			}
        }
        return list;
    },
    /** Convert the given parameters to a map from name to value. */
    getParameterMap: function getParameterMap(parameters) {
        if ((typeof parameters == "undefined") || (parameters === null)) {
            return {};
        }
        if (typeof parameters != "object") {
            return OAuth.getParameterMap(OAuth.decodeForm(parameters + ""));
        }
        if (parameters instanceof Array) {
            var map = {};
            for (var p = 0; p < parameters.length; ++p) {
                var key = parameters[p][0];
                if (map[key] === undefined) { // first value wins
                    map[key] = parameters[p][1];
                }
            }
            return map;
        }
        return parameters;
    },
    getParameter: function getParameter(parameters, name) {
        if (parameters instanceof Array) {
            for (var p = 0; p < parameters.length; ++p) {
                if (parameters[p][0] == name) {
                    return parameters[p][1]; // first value wins
                }
            }
        } else {
            return OAuth.getParameterMap(parameters)[name];
        }
        return null;
    },
    formEncode: function formEncode(parameters) {
        var form = "";
        var list = OAuth.getParameterList(parameters);
        for (var p = 0; p < list.length; ++p) {
            var value = list[p][1];
            if ((typeof value == "undefined") || value === null) { value = ""; }
            if (form !== "") { form += '&'; }
            form += OAuth.percentEncode(list[p][0]) +
              '='+ OAuth.percentEncode(value);
        }
        return form;
    },
    decodeForm: function decodeForm(form) {
        var list = [];
        var nvps = form.split('&');
        for (var n = 0; n < nvps.length; ++n) {
            var nvp = nvps[n];
            if (nvp === "") {
                continue;
            }
            var equals = nvp.indexOf('=');
            var name;
            var value;
            if (equals < 0) {
                name = OAuth.decodePercent(nvp);
                value = null;
            } else {
                name = OAuth.decodePercent(nvp.substring(0, equals));
                value = OAuth.decodePercent(nvp.substring(equals + 1));
            }
            list.push([name, value]);
        }
        return list;
    },
    setParameter: function setParameter(message, name, value) {
        var parameters = message.parameters;
        if (parameters instanceof Array) {
            for (var p = 0; p < parameters.length; ++p) {
                if (parameters[p][0] == name) {
                    if (value === undefined) {
                        parameters.splice(p, 1);
                    } else {
                        parameters[p][1] = value;
                        value = undefined;
                    }
                }
            }
            if (value !== undefined) {
                parameters.push([name, value]);
            }
        } else {
            parameters = OAuth.getParameterMap(parameters);
            parameters[name] = value;
            message.parameters = parameters;
        }
    },
    setParameters: function setParameters(message, parameters) {
        var list = OAuth.getParameterList(parameters);
        for (var i = 0; i < list.length; ++i) {
            OAuth.setParameter(message, list[i][0], list[i][1]);
        }
    },
    /** Fill in parameters to help construct a request message.
        This function doesn't fill in every parameter.
        The accessor object should be like:
        {consumerKey:'foo', consumerSecret:'bar', accessorSecret:'nurn', token:'krelm', tokenSecret:'blah'}
        The accessorSecret property is optional.
     */
    completeRequest: function completeRequest(message, accessor) {
        if ((typeof message.method == "undefined") || message.method === null) {
            message.method = "GET";
        }
        var map = OAuth.getParameterMap(message.parameters);
        if ((typeof map.oauth_consumer_key == "undefined") || map.oauth_consumer_key === null) {
            OAuth.setParameter(message, "oauth_consumer_key", accessor.consumerKey || "");
        }
        if ((typeof map.oauth_token == "undefined") || map.oauth_token === null && accessor.token !== null) {
            OAuth.setParameter(message, "oauth_token", accessor.token);
        }
        if ((typeof map.oauth_version == "undefined") || map.oauth_version === null) {
            OAuth.setParameter(message, "oauth_version", "1.0");
        }
        if ((typeof map.oauth_timestamp == "undefined") || map.oauth_timestamp === null) {
            OAuth.setParameter(message, "oauth_timestamp", OAuth.timestamp());
        }
        if ((typeof map.oauth_nonce == "undefined") || map.oauth_nonce === null) {
            OAuth.setParameter(message, "oauth_nonce", OAuth.nonce(6));
        }
        OAuth.SignatureMethod.sign(message, accessor);
    },
    setTimestampAndNonce: function setTimestampAndNonce(message) {
        OAuth.setParameter(message, "oauth_timestamp", OAuth.timestamp());
        OAuth.setParameter(message, "oauth_nonce", OAuth.nonce(6));
    },
    addToURL: function addToURL(url, parameters) {
        var newURL = url;
        if ((typeof parameters != 'undefined') && parameters !== null) {
            var toAdd = OAuth.formEncode(parameters);
            if (toAdd.length > 0) {
                var q = url.indexOf('?');
                if (q < 0) { newURL += '?'; }
                else       { newURL += '&'; }
                newURL += toAdd;
            }
        }
        return newURL;
    },
    /** Construct the value of the Authorization header for an HTTP request. */
    getAuthorizationHeader: function getAuthorizationHeader(realm, parameters) {
        var header = 'OAuth ';
		if(realm){
			parameters = parameters.slice();
			parameters.realm = realm;
		}
		var added = 0;
        var list = OAuth.getParameterList(parameters);
        for (var p = 0; p < list.length; ++p) {
            var parameter = list[p];
            var name = parameter[0];
            if (name.indexOf("oauth_") === 0 || name.indexOf("realm") === 0) {
                header += (added++ === 0 ? '' : ',') + OAuth.percentEncode(name) + '="' + OAuth.percentEncode(parameter[1]) + '"';
            }
        }
        return header;
    },
    /** Correct the time using a parameter from the URL from which the last script was loaded. */
    correctTimestampFromSrc: function correctTimestampFromSrc(parameterName) {
        parameterName = parameterName || "oauth_timestamp";
		return;
		/*
		 * 2010-10: gerald@ngmoco
		 *   This code will always return because there is no document
		 *   object in NGCore environment
		 *
        var scripts = document.getElementsByTagName('script');
        if (scripts === null || !scripts.length) { return; }
        var src = scripts[scripts.length-1].src;
        if (!src) { return; }
        var q = src.indexOf("?");
        if (q < 0) { return; }
        var parameters = OAuth.getParameterMap(OAuth.decodeForm(src.substring(q+1)));
        var t = parameters[parameterName];
        if (t === null) { return; }
        OAuth.correctTimestamp(t);
		*/
    },
    /** Generate timestamps starting with the given value. */
    correctTimestamp: function correctTimestamp(timestamp) {
        OAuth.timeCorrectionMsec = (timestamp * 1000) - (new Date()).getTime();
    },
    /** The difference between the correct time and my clock. */
    timeCorrectionMsec: 0,
    timestamp: function timestamp() {
        var t = (new Date()).getTime() + OAuth.timeCorrectionMsec;
        return Math.floor(t / 1000);
    },
    nonce: function nonce(length) {
        var chars = OAuth.nonce.CHARS;
        var result = "";
        for (var i = 0; i < length; ++i) {
            var rnum = Math.floor(Math.random() * chars.length);
            result += chars.substring(rnum, rnum+1);
        }
        return result;
    }
});

OAuth.nonce.CHARS = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";

/** Define a constructor function,
    without causing trouble to anyone who was using it as a namespace.
    That is, if parent[name] already existed and had properties,
    copy those properties into the new constructor.
 */
OAuth.declareClass = function declareClass(parent, name, newConstructor) {
    var previous = parent[name];
    parent[name] = newConstructor;
    if (newConstructor !== null && previous !== null) {
        for (var key in previous) {
            if (key != "prototype") {
                newConstructor[key] = previous[key];
            }
        }
    }
    return newConstructor;
};

/** An abstract algorithm for signing messages. */
OAuth.declareClass(OAuth, "SignatureMethod", function OAuthSignatureMethod(){});

OAuth.setProperties(OAuth.SignatureMethod.prototype, // instance members
{
    /** Add a signature to the message. */
    sign: function sign(message) {
        var baseString = OAuth.SignatureMethod.getBaseString(message);
        var signature = this.getSignature(baseString);
        OAuth.setParameter(message, "oauth_signature", signature);
        return signature; // just in case someone's interested
    },
    /** Set the key string for signing. */
    initialize: function initialize(name, accessor) {
        var consumerSecret;
        if ((typeof accessor.accessorSecret != 'undefined') &&
	        accessor.accessorSecret !== null &&
            name.length > 9 &&
            name.substring(name.length-9) == "-Accessor")
        {
            consumerSecret = accessor.accessorSecret;
        } else {
            consumerSecret = accessor.consumerSecret;
        }
        this.key = OAuth.percentEncode(consumerSecret) +
             "&"+ OAuth.percentEncode(accessor.tokenSecret);
    }
});

/* SignatureMethod expects an accessor object to be like this:
   {tokenSecret: "lakjsdflkj...", consumerSecret: "QOUEWRI..", accessorSecret: "xcmvzc..."}
   The accessorSecret property is optional.
 */
// Class members:
OAuth.setProperties(OAuth.SignatureMethod, // class members
{
    sign: function sign(message, accessor) {
        var name = OAuth.getParameterMap(message.parameters).oauth_signature_method;
        if ((typeof name == "undefined") || name === null || name === "") {
            name = "HMAC-SHA1";
            OAuth.setParameter(message, "oauth_signature_method", name);
        }
        OAuth.SignatureMethod.newMethod(name, accessor).sign(message);
    },
    /** Instantiate a SignatureMethod for the given method name. */
    newMethod: function newMethod(name, accessor) {
        var impl = OAuth.SignatureMethod.REGISTERED[name];
        if ((typeof impl != "undefined") && (impl !== null)) {
            var method = new impl();
            method.initialize(name, accessor);
            return method;
        }
        var err = new Error("signature_method_rejected");
        var acceptable = "";
        for (var r in OAuth.SignatureMethod.REGISTERED) {
			if ( OAuth.SignatureMethod.REGISTERED.hasOwnProperty(r)) {
				if (acceptable !== "") {
					acceptable += '&';
				}
				acceptable += OAuth.percentEncode(r);
			}
        }
        err.oauth_acceptable_signature_methods = acceptable;
        throw err;
    },
    /** A map from signature method name to constructor. */
    REGISTERED : {},
    /** Subsequently, the given constructor will be used for the named methods.
        The constructor will be called with no parameters.
        The resulting object should usually implement getSignature(baseString).
        You can easily define such a constructor by calling makeSubclass, below.
     */
    registerMethodClass: function registerMethodClass(names, classConstructor) {
        for (var n = 0; n < names.length; ++n) {
            OAuth.SignatureMethod.REGISTERED[names[n]] = classConstructor;
        }
    },
    /** Create a subclass of OAuth.SignatureMethod, with the given getSignature function. */
    makeSubclass: function makeSubclass(getSignatureFunction) {
        var superClass = OAuth.SignatureMethod;
        var subClass = function() {
            superClass.call(this);
        };
        subClass.prototype = new superClass();
        // Delete instance variables from prototype:
        // delete subclass.prototype... There aren't any.
        subClass.prototype.getSignature = getSignatureFunction;
        subClass.prototype.constructor = subClass;
        return subClass;
    },
    getBaseString: function getBaseString(message) {
        var URL = message.action;
        var q = URL.indexOf('?');
        var parameters;
        if (q < 0) {
            parameters = message.parameters;
        } else {
            // Combine the URL query string with the other parameters:
            parameters = OAuth.decodeForm(URL.substring(q + 1));
            var toAdd = OAuth.getParameterList(message.parameters);
            for (var a = 0; a < toAdd.length; ++a) {
                parameters.push(toAdd[a]);
            }
        }
        return OAuth.percentEncode(message.method.toUpperCase()) +
         '&'+ OAuth.percentEncode(OAuth.SignatureMethod.normalizeUrl(URL)) +
         '&'+ OAuth.percentEncode(OAuth.SignatureMethod.normalizeParameters(parameters));
    },
    normalizeUrl: function normalizeUrl(url) {
        var uri = OAuth.SignatureMethod.parseUri(url);
        var scheme = uri.protocol.toLowerCase();
        var authority = uri.authority.toLowerCase();
        var dropPort = (scheme == "http" && uri.port == 80) ||
                       (scheme == "https" && uri.port == 443);
        if (dropPort) {
            // find the last : in the authority
            var index = authority.lastIndexOf(":");
            if (index >= 0) {
                authority = authority.substring(0, index);
            }
        }
        var path = uri.path;
        if (!path) {
            path = "/"; // conforms to RFC 2616 section 3.2.2
        }
        // we know that there is no query and no fragment here.
        return scheme + "://" + authority + path;
    },
    parseUri: function parseUri (str) {
        /* This function was adapted from parseUri 1.2.1
           http://stevenlevithan.com/demo/parseuri/js/assets/parseuri.js
         */
        var o = {key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
                 parser: {strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@\/]*):?([^:@\/]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/ }};
        var m = o.parser.strict.exec(str);
        var uri = {};
        var i = 14;
        while (i--) { uri[o.key[i]] = m[i] || ""; }
        return uri;
    },
    normalizeParameters: function normalizeParameters(parameters) {
        if ((typeof parameters == 'undefined') || parameters === null) {
            return "";
        }
        var list = OAuth.getParameterList(parameters);
        var sortable = [];
        for (var p = 0; p < list.length; ++p) {
            var nvp = list[p];
            if (nvp[0] != "oauth_signature") {
                sortable.push([ OAuth.percentEncode(nvp[0]) +
                                " " + // because it comes before any character that can appear in a percentEncoded string.
                                OAuth.percentEncode(nvp[1]), nvp]);
            }
        }
        sortable.sort(function(a,b) {
                          if (a[0] < b[0]) { return  -1; }
                          if (a[0] > b[0]) { return 1; }
                          return 0;
                      });
        var sorted = [];
        for (var s = 0; s < sortable.length; ++s) {
            sorted.push(sortable[s][1]);
        }
        return OAuth.formEncode(sorted);
    }
});

OAuth.SignatureMethod.registerMethodClass(["PLAINTEXT", "PLAINTEXT-Accessor"],
    OAuth.SignatureMethod.makeSubclass(
        function getSignature(baseString) {
            return this.key;
        }
    ));

OAuth.SignatureMethod.registerMethodClass(["HMAC-SHA1", "HMAC-SHA1-Accessor"],
    OAuth.SignatureMethod.makeSubclass(
        function getSignature(baseString) {
			/*
			 * 2010-10: gerald@ngmoco:
			 *    Bad idea to set global of sha1.js like this, this bug
			 *    took a few hours to find!
            b64pad = '=';
			 */
            var signature = b64_hmac_sha1_req.b64_hmac_sha1(this.key, baseString, '=');
            return signature;
        }
    ));

try {
    OAuth.correctTimestampFromSrc();
} catch(e) {
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.OAuth = OAuth;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/BaseClass'] = function(){var exports = $MODULE_REGISTRY['Code/Util/BaseClass'] || {}; $MODULE_REGISTRY['Code/Util/BaseClass'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/BaseClass.js';

/**
 * Base Class
 * v:2.0
 * Date:17/Feb/2012
 * +addChild(node) Method.
 */
exports.BaseClass = Core.Class.subclass({
    classname : 'BaseClass',
    
    initialize : function(width, height)
    {
        this._node = new GL2.Node();
        this._node._AL_owner = this;
        this.__updateListener = new Core.MessageListener();
        Core.UpdateEmitter.addListener(this.__updateListener, this.__onUpdate.bind(this));
        
        if (!width || !height)
        {
        	//al_trace("no se ingresan las medidas !!!!! ");
            return;
        }
        this._size = [ width, height ];
        //this.__size = new Core.Size(MainGame._workingArea.screenWidth, MainGame._workingArea.screenHeight);
        //touch target
        this.__touchTarget = new GL2.TouchTarget();
        this.__touchTarget.setAnchor(0.5, 0.5);
        this.__touchTarget.setPosition(this._size[0] / 2, this._size[1] / 2);
        this.__touchTarget.setSize(this._size);
        this.__touchListener = new Core.MessageListener();
        this.__touchTarget.getTouchEmitter().addListener(this.__touchListener, this.__onTouch.bind(this));
        this._node.addChild(this.__touchTarget);
    },
    
    setTouchTargetToScreenSize : function()
    {
        this.__touchTarget.setSize(this.__size);
    },
    
    _replaceRootNode : function(/*GL2.Node*/newNode)
    {
        this._node.destroy();
        this._node = null;
        this._node = newNode;
        this._node.addChild(this.__touchTarget);
    },
    
    addChild: function(node)
    {
    	this._node.addChild(node);
    },
    
    getNode : function()
    {
        return this._node;
    },
    
    getSize : function()
    {
        return this.__size;
    },
    
    /**
     * Override to give a different BoundingBox. This implementation uses the
     * this._node if its a Sprite, else use this._node.position and this.__size
     * give in the constructor.
     * 
     * @return the bounding box of this class.
     */
    getBB : function()
    {
        if (this._node.classname == 'Sprite')
        {
            return createBB(this._node);
        }
        else
        {
            return createBBBase(this._node.getPosition(), this.__size);
        }
    },
    
    __onUpdate : function(delta)
    {
        if (this._destroying || this.__destroying)
        {
            return;
        }
        
        if (!this._drawError && this._node.getParent() != null && this._node.getVisible() && this._node.getAlpha() > 0)
        {
            try
            {
                this._draw(delta);
            }
            catch (ex)
            {
                this._drawError = true;
                NgLogException(ex);
            }
        }
    },
    
    /**
     * override this function to do work on every frame
     * 
     * @param delta -
     *            time between frames.
     */
    _draw : function(delta)
    {
    },
    
    __onTouch : function(/*GL2.Touch*/touchEvent)
    {
        switch (touchEvent.getAction())
        {
            case GL2.Touch.Action.Start:
                return this._ccTouchesBegan(touchEvent);
            case GL2.Touch.Action.Move:
                this._ccTouchesMoved(touchEvent);
                break;
            case GL2.Touch.Action.End:
                this._ccTouchesEnded(touchEvent);
                break;
        }
    },
    
    /**
     * Override to react on touch began.
     * @return true if the event is going to be captured by this node, false to
     *         leave others receive this event.
     */
    _ccTouchesBegan : function(/*GL2.Touch*/touchEvent)
    {
        return false;
    },
    
    /**
     * Override to react on touch moved.
     */
    _ccTouchesMoved : function(/*GL2.Touch*/touchEvent)
    {
    },
    
    /**
     * Override to react on touch ended.
     */
    _ccTouchesEnded : function(/*GL2.Touch*/touchEvent)
    {
    },
    
    /**
     * Destroy this instance by removing the listeners and calling destroy on the rootNode.
     */
    destroy : function()
    {
        al_trace(this.classname + ": (Destroy) Destroying");
        
        if (this.__updateListener)
        {
            this.__updateListener.destroy();
            this.__updateListener = null;
        }
        
        if (this.__touchListener)
        {
            this.__touchListener.destroy();
            this.__touchListener = null;
        }
        
        if (this.__touchTarget)
        {
            this.__touchTarget.destroy();
            this.__touchTarget = null;
        }
        
        if(this._node && this._node._AL_owner){
        	this._node._AL_owner = null;
        }
        this.__destroyNodeAndChildren(this._node);
        this._node = null;
    },
    
    $__destroyNodeAndChildren : function(/*GL2.Node*/node)
    {
        if (!node)
        {
            return;
        }
        
        while (node._children.length > 0)
        {
            var childNode = node._children[node._children.length - 1];
            if (childNode)
            {
                if (childNode._AL_owner)
                {
                    childNode._AL_owner.destroy();
                }
                else
                {
                    this.__destroyNodeAndChildren(childNode);
                }
            }
        }
        
        node.stopAllActions();
        if (this != node)
        {
            node.destroy();
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/Prototypes'] = function(){var exports = $MODULE_REGISTRY['Code/Util/Prototypes'] || {}; $MODULE_REGISTRY['Code/Util/Prototypes'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/Prototypes.js';

// Trick to force the inclusion of this class
exports.Prototypes = Core.Class.subclass(
{

    $setupXibPrototypes: function()
    {
        Xib.ViewController.prototype.viewWillAppear_ = function( /** bool */
        inWillBeAnimated )
        {
            if( !this._isLoadingXib )
            {
                // normal. just passthrough
                this.viewWillAppear( inWillBeAnimated );
                Core.UpdateEmitter.removeListener( this );
                Core.UpdateEmitter.addListener( this, this._updateFrame, 0 );
                return;
            }

            // 'store' the request for processing when loading is done.
            if( this._pendingNotifications == NULL )
            {
                this._pendingNotifications = new Array;
            }

            this._pendingNotifications.push(
            {
                proc: this.viewWillAppear_,
                param: inWillBeAnimated
            } );
        };

        Xib.Navigation.resetScreenStackTo = function( newView, useAnimation, forced )
        {
            info( "Prototypes.Navigation.resetScreenStackTo called. forced=" + forced );
            if( this._modalView && this._modalView._viewOwner == "PopUp" && !forced )
            {
                info( "Prototypes.Navigation.resetScreenStackTo returning. this._modalView._viewOwner == 'PopUp' && !forced" );
                return;
            }

            this.popToRootViewController( useAnimation );
            this.pushViewController( newView, useAnimation );
        };

        Xib.Navigation._popToViewController = function( targetView, useAnimation, forced )
        {
            info( "Prototypes.Navigation._popToViewController called. forced=" + forced );

            var index;

            if( this.overlayView == NULL )
            {
                index = 0;
            }
            else
            {
                index = 1;
            }

            // TODO: search stack by class name
            var passedOpaqueView = false;

            // is the view even in our lists?
            var inList = false;
            for( var i = 0; i < this.stack.length; i++ )
            {
                if( typeof targetView == 'string' )
                {
                    if( this.stack[i].__proto__.classname == targetView )
                    {
                        inList = true;
                        break;
                    }
                }
                else
                {
                    if( this.stack[i] == targetView )
                    {
                        inList = true;
                        break;
                    }
                }
            }

            if( !inList )
            {
                return this.startNextCommand();
            }

            if( this.stack.size() == 1 && this.overlayView != NULL ) // We only have the overlay on
            {
                return this.startNextCommand();
            }

            this._waitingOn = 0;

            // warn the current topmost.
            this.stack[index].viewWillDisappear( useAnimation );

            // if we passed an opaque view, everything below it was not being rendered
            if( this.stack[0].isFullscreenOpaque() )
                passedOpaqueView = true;

            // Remove all the views we passed over from the middle of the stack immediately.
            // We do *not* remove the topmost, as that will animate away normally.
            while( this.stack.length > 2 )
            {
                var oldView = this.stack[1];

                // is this the one we were waiting on?
                if( oldView == targetView )
                    break;

                // nope. Cut it DEEP.
                this.stack.splice( 1, 1 );

                if( !passedOpaqueView )
                {
                    GL2.Root.removeChild( oldView.getView() );
                    oldView._visible = false;
                    oldView._isRendering = false;
                }

                // if we passed an opaque view, everything below it was not being rendered
                if( oldView.isFullscreenOpaque() )
                    passedOpaqueView = true;

                oldView._destroyForNavigation();
            }

            if( this.stack[1] != undefined )

                // then show the target view
                this.stack[1].viewWillAppear_( useAnimation );

            // if we passed an opaque view, we need to restore the stack contents to render
            this._waitingOn++; // make sure we don't trigger earlier than desired.
            if( passedOpaqueView )
            {
                for( var i = 1; i < this.stack.size(); i++ )
                {
                    GL2.Root.addChild( this.stack[i].getView() );
                    this.stack[i]._visible = true;
                    this.stack[i]._isRendering = true;
                    this._waitingOn++;
                    this.stack[i].addLoadedCallback( this.finishPopViewController.bind( this ) );

                    if( this.stack[i].isFullscreenOpaque() )
                        break; // stop here, don't show below this.
                }
            }

            this.updatePriorities();

            // there may be other animations going on already. Add us to the list
            if( useAnimation )
            {
                this._waitingOn++;
                invokeAfterDelay( this.defaultTransitionTimer, this.finishPopViewController.bind( this ) );
            }

            // balance the ealier _waitingOn++
            this.finishPopViewController();
        };

        Xib.Navigation.popViewController = function( /** Boolean */
        useAnimation, forced )
        {
            info( "Prototypes.Navigation.popViewController called. forced=%s", JSON.stringify( forced ) );

            if( this._modalView && this._modalView._viewOwner == "PopUp" && !forced )
            {
                info( "Prototypes.Navigation.popViewController returning. this._modalView._viewOwner == 'PopUp' && !forced" );
                return;
            }

            this.addCommand( function( useAnimation )
            {
                var index = ( this.overlayView == NULL ) ? 0 : 1;

                if( this.stack.length <= 1 )
                {
                    warn( "Cannot pop root view" );
                    return this.startNextCommand();
                }

                this._waitingOn = 0;

                // warn them they will go away.
                this.stack[index].viewWillDisappear( useAnimation );

                // if the view was opaque, add the earlier views to the world. if not, they were already there anyway
                this._waitingOn++; // make sure we don't trigger earlier than desired.
                if( this.stack[index].isFullscreenOpaque() )
                {
                    for( var i = index + 1; i < this.stack.size(); i++ )
                    {
                        GL2.Root.addChild( this.stack[i].getView() );
                        this.stack[i]._visible = true;
                        this.stack[i]._isRendering = true;
                        this._waitingOn++;
                        this.stack[i].addLoadedCallback( this.finishPopViewController.bind( this ) );

                        info( "popViewController adding " + this.stack[i].classname + " to render" );
                        if( this.stack[i].isFullscreenOpaque() )
                            break; // stop here, don't show below this.
                    }
                }

                // warn next one down that they will appear.
                // Done *after* the load has been triggered by GL2.Root.addChild() above.
                if( this.stack.size() > 1 )
                {
                    this.stack[index].viewWillAppear_( /** Boolean */
                    useAnimation ); // if we got down here the stack is at least 2 deep
                }

                // there may be other animations going on already. Add us to the list
                if( useAnimation )
                {
                    this._waitingOn++;
                    invokeAfterDelay( this.defaultTransitionTimer, this.finishPopViewController.bind( this ) );
                }

                // balance the ealier _waitingOn++
                this.finishPopViewController();

            }.bind( this, useAnimation ) );
        };

        /**
         * Finish popping a view controller
         * 
         * @private
         */

        Xib.Navigation.finishPopViewController = function()
        {
            info( "Prototypes.Navigation.finishPopViewController called." );

            var index = ( this.overlayView == NULL ) ? 0 : 1;

            this._waitingOn--;
            if( this._waitingOn > 0 )
                return;
            this._waitingOn = 0;

            var didAnimate = this.usedTransitionTimer;

            // drop the topmost view controller, tell the remaining one that it finished animating
            GL2.Root.removeChild( this.stack[index].getView() );
            this.stack[index]._visible = false;
            this.stack[index]._isRendering = false;
            info( "Prototypes.Navigation.finishPopViewController Removing %s from render", this.stack[index].classname );

            // alter the stack before making the viewDidDisappear callback.
            // Just in case the caller wants to reentrant us.
            var oldView = this.stack[index];
            this.stack.splice( index, 1 );

            this.updatePriorities();

            // send notificaitons. Note how they are explicitly last.
            oldView.viewDidDisappear_( didAnimate );
            info( "Prototypes.Navigation.finishPopViewController Navigation will destroy " + oldView.classname );
            oldView._destroyForNavigation();

            if( this.stack.size() > 1 )
            {
                // Let's check were not using overlays to do this
                this.stack[index].viewDidAppear_( didAnimate );
            }
            this.startNextCommand();

            if( this.logRenderTree )
            {
                info( "Prototypes.Navigation.finishPopViewController render hierarchy after pop:\n" + GL2.Root.toString() );
            }

        };

        Xib.Navigation.swapViewController = function( /** Xib.ViewController or string */
        newView, /** Boolean */
        useAnimation )
        {
            info( "Prototypes.Navigation.swapViewController called." );

            if( !newView )
            {
                info( "Prototypes.Navigation.swapViewController Get a NULL view. returning." );
                return;
            }
            info( "Prototypes.Navigation.swapViewController called. newView.classname=%s", newView.classname );

            info( "Prototypes.Navigation.swapViewController (queue new): " + newView.classname ? newView.classname : newView );
            this.addCommand( function( newView, useAnimation )
            {
                //
                // only difference between this and pushViewController is that when we're done,
                // the view currenty topmost wants to be destroyed.
                //
                if( this.stack.length )
                {
                    // don't have a modal view, so we can swap the first view controller.
                    if( this.modalView == NULL && this.overlayView == NULL )
                    {
                        this._destroyList.push( this.stack[0] );
                    }
                    // if there's a modal AND an overlay, we need to swap the third in the list, since we don't want to remove the popup.
                    else if( this.modalView && this.overlayView )
                    {
                        this._destroyList.push( this.stack[2] );
                    }
                    // If there's either a modal OR an overlay, we must remove the second one
                    else
                    {
                        this._destroyList.push( this.stack[1] );

                    }
                }
                var realNewView = this._readyPushViewController( newView );
                if( !realNewView )
                    return;

                this._pushViewController( realNewView, useAnimation );

            }.bind( this, newView, useAnimation ) );
        };

        Xib.Navigation.presentOverlayView = function( view, useAnimation, autoDismiss )
        {
            info( "Prototypes.Navigation.presentOverlayView called." );

            if( !view )
            {
                log( this.classname + ".presentOverlaylView was passed NULL view" );
                return;
            }

            var realNewView;
            if( typeof view == 'string' )
                eval( "realNewView = new " + view );
            else
                realNewView = view;

            // push to top of stack.
            this.pushViewController( realNewView, useAnimation );

            // if we don't have an overlay view, flag this one as special.
            // Note we cannot actually set this.modalView here, it would mess with pushViewController.
            if( this.OverlayView == NULL )
                realNewView._isOverlayView = true;
        };

        Xib.Navigation.removeOverlayView = function( /** Boolean */
        useAnimation )
        {
            if( this.overlayView == NULL )
            {
                log( "No overlay view to remove!" );
                return;
            }

            // the modal view should be top of stack at all times
            // This demotes it to a normal view to be removed.
            this.overlayView.destroy();
            this.overlayView = NULL;

            // now a standard pop will remove it properly.
            this.popViewController( useAnimation );
        };

        Xib.Navigation.getOverlayView = function()
        {
            return this.overlayView;
        };

        var initialize = Xib.Navigation.initialize;
        Xib.Navigation.initialize = function()
        {
            info( "Prototypes.Navigation.initialize called." );
            this.overlayView = NULL; // current overlay interface
            this._modalView = NULL; // new modal to work with overlay
            initialize.apply( this, arguments );
        };

        Xib.Navigation.setShields = function( /* number */depth )
        {
            this.inputShield.setDepth( depth );
        },

        Xib.Navigation.setModalOverlay = function( view )
        {
            if( this._modalView != undefined )
            {
                return;
            }
            var depth = 0;
            if( this.overlayView != undefined )
            {
                depth = this.overlayView.getView().getDepth() + 100;
            }
            else
            {
                depth = this.stack.size() * 1000;
            }

            if( this.stack.length > 1 )
            {
                this.stack[1].viewWillDisappear();
            }

            this._modalView = view.getView();

            this.fillScreenWithView( this._modalView );
            this._modalView._viewOwner = view.classname;
            this._modalView._viewController = view;
            this._modalView.setDepth( depth );
            this.setShields( depth );
            GL2.Root.addChild( this._modalView );
        },

        Xib.Navigation.removeModalOverlay = function( forced )
        {
            info( "Prototypes.Navigation.removeModalOverlay called. forced=" + forced );

            if( this._modalView == NULL )
                return;

            info( "Prototypes.Navigation.removeModalOverlay this._modalView._viewOwner=" + this._modalView._viewOwner );

            if( this._modalView && this._modalView._viewOwner == "PopUp" && !forced )
            {
                info( "Prototypes.Navigation.removeModalOverlay returning. this._modalView._viewOwner == 'PopUp' && !forced" );
                return;
            }

            if( this.stack.length > 1 )
            {
                this.stack[1].viewWillAppear();
            }
            // GL2.Root.removeChild( this._modalView );
            this._modalView._viewController.destroy();
            this.lowerShields();
            this._modalView = NULL;
        },

        Xib.Navigation.lowerShields = function()
        {
            // -if there is a modal view, place the input shield directly beneath it
            // -if not, place the input shield below the highest view to return that it does not allow interface passthrough
            if( this.modalView != NULL )
            {
                // place the input shield under the modal view and atop everyone else

                this.inputShield.setDepth( this.modalView.getViewDepth() - 100 );
                log( "Navigation.lowerShields() under modal moved to: " + this.inputShield.getDepth() );
            }
            else
            {
                if( !this.stack || this.stack.size() == 0 )
                    return; // Do nothing if there's no stack
                // locate the first view that replies that it blocks taps, and put the input shield behind it
                var iterator = 0;

                while( this.stack[iterator].getAllowTapPassthrough() && ( iterator < ( this.stack.length - 1 ) ) )
                    iterator++;

                this.inputShield.setDepth( this.stack[iterator].getView().getDepth() - 100 );
                log( "Navigation.lowerShields() moved to: " + this.inputShield.getDepth() );
            }

            try
            {
                // throw new Error("lowerSheilds called by...?");
            }
            catch( error )
            {
                NgLogException( error, true );
            }
        },

        Xib.Navigation._pushViewController = function( realNewView, useAnimation )
        {
            info( "pushViewController (now new): " + realNewView.classname );

            var realNewViewIndex = ( this.modalView == NULL ) ? 0 : 1; // the index of this new view controller depends on if we have a modal dialog box.
            realNewViewIndex += ( this.overlayView == NULL ) ? 0 : 1; // another one if it's an overlay

            // If this view is in the "to be destroyed" list, remove it. They changed their mind.
            for( var i = 0; i < this._destroyList.length; i++ )
            {
                if( this._destroyList[i] != realNewView )
                    continue;
                this._destroyList.splice( i, 1 );
                i--; // recheck this entry.
            }

            //
            // get the new view started loading, if it needs it.
            //

            // warn the old view it's going away.
            if( this.stack.length > realNewViewIndex )
                this.stack[realNewViewIndex].viewWillDisappear( useAnimation );

            info( "Setting screen in index: " + realNewViewIndex );

            // put the new view on the stack
            this.stack.splice( realNewViewIndex, 0, realNewView ); // insert at the index we have determined.

            // deal with this being the root view
            if( this.stack.length == 0 )
            {
                realNewView.setIsFullscreenOpaque( true ); // the root fullscreen is always opaque
                realNewView.setAllowTapPassthrough( false );
            }

            // wait on the view to load (if necessary.)
            this._waitingOn = 1; // so it doesn't trigger early.
            this._waitingOn++;
            realNewView.addLoadedCallback( this._loadedPushViewController.bind( this, realNewView, useAnimation ) );

            /*
             * is an animation going on right now? If there is, and we want an additional animation... Wait for the last animation to complete before allowing the user to start input. We also need to
             * wait for the view to actually load.
             */
            this.usedTransitionTimer = useAnimation;
            if( useAnimation )
            {
                this._waitingOn++;
                invokeAfterDelay( this.defaultTransitionTimer, this._finishPushViewController.bind( this ) );
            }

            info( "Done pushing with index " + realNewViewIndex );
            info( "stack size is: " + this.stack.length );

            // balance initial waitingOn
            this._finishPushViewController();
        };

        Xib.Navigation._readyPushViewController = function( newView )
        {
            if( !newView )
            {
                log( this.classname + ".pushViewController was passed NULL view" );
                return;
            }

            var realNewView;
            if( typeof newView == 'string' )
                eval( "realNewView = new " + newView );
            else
                realNewView = newView;
            if( realNewView == NULL )
                return NULL;

            // Start the loading of the new screen;
            // tag the view with the owner's name.
            realNewView.getView()._viewOwner = realNewView.classname;
            realNewView.getView()._viewController = realNewView;

            // resize the temporary view to the full screen so that viewDidLoad() gets the full size.
            this.fillScreenWithView( realNewView.getView() );

            // put the view in the view tree but not visible
            realNewView._isRendering = true;
            realNewView.getView().setVisible( false );
            realNewView.getView().setDepth( -111111 );
            GL2.Root.addChild( realNewView.getView() );
            return realNewView;
        },

        Xib.Navigation._finishPushViewController = function()
        {
            this._waitingOn--;
            if( this._waitingOn > 0 )
                return;
            this._waitingOn = 0;

            var didAnimate = this.usedTransitionTimer;

            // if the new top is opaque, remove the lower one(s) completely from render tree
            var realNewViewIndex = ( this.modalView == NULL ) ? 0 : 1; // the index of this new view controller depends on if we have a modal dialog box.
            realNewViewIndex += ( this.overlayView == NULL ) ? 0 : 1; // we move it another index if there's an overlay
            var controller = this.stack[realNewViewIndex];

            if( controller.isFullscreenOpaque() && this.stack.size() > 1 )
            {
                // remove views until we remove an opaque view, then stop
                // (We stop after opaque because we know nothing else was visible before it.)
                for( var i = realNewViewIndex + 1; i < this.stack.size(); i++ )
                {
                    GL2.Root.removeChild( this.stack[i].getView() );
                    this.stack[i]._visible = false;
                    this.stack[i]._isRendering = false;
                    info( "_finishPushViewController removing " + this.stack[i].classname + " from render" );
                    if( this.stack[i].isFullscreenOpaque() )
                        break;
                }
            }
            controller.getView().setVisible( true );
            // send notificaitons. Note how they are explicitly last.
            // was there another view below the one we just added?
            var nextViewIndex = realNewViewIndex + 1;
            if( this.stack.length > nextViewIndex )
                this.stack[nextViewIndex].viewDidDisappear_( didAnimate ); // the view is invisible anyway...

            // destroy anyone who is requesting it.
            for( var stackIndex = 0; stackIndex < this.stack.length; stackIndex++ )
            {
                var willRemove = this.stack[stackIndex];
                var wantsRemove = false;
                for( var i = 0; i < this._destroyList.length; i++ )
                {
                    if( this._destroyList[i] != willRemove )
                        continue;

                    // pull from list
                    this._destroyList.splice( i, 1 );
                    i--; // recheck this entry.
                    wantsRemove = true;
                }

                if( wantsRemove )
                {
                    // do actual destroy
                    info( "Navigation will destroy " + willRemove.classname );
                    this.stack.splice( stackIndex, 1 ); // pull from list
                    if( willRemove._visible )
                    {
                        willRemove._visible = false;
                        willRemove._isRendering = false;
                        GL2.Root.removeChild( willRemove.view );
                    }
                    willRemove._destroyForNavigation();
                }
            }

            // if this is the new modal view, handle it appropriately.
            if( controller._isModalView && !this.modalView )
                this.modalView = controller;

            // if it's an overlay, the same
            if( controller._isOverlayView && !this.overlayView )
            {
                this.overlayView = controller;

            }

            // flag new one is ready.
            controller.viewDidAppear_( didAnimate ); // If the time elapsed was zero, we clearly did not animate

            if( this.logRenderTree )
                info( "Navigaton.finishPushViewController: render hierarchy after push:\n" + GL2.Root.toString() );

            this.startNextCommand();
        };

        Xib.Scroller.prototype.setUpdateFunction = function( /** function */
        updateFunction )
        {
            this.updateFunction = updateFunction;
        };

        var __updateScroll = Xib.Scroller.prototype.updateScroll;
        Xib.Scroller.prototype.updateScroll = function()
        {
            __updateScroll.apply( this, arguments );
            if( typeof ( this.updateFunction ) == "function" )
            {
                if( !this._destroyed )
                {
                    this.updateFunction();
                }
            }
        };

        var __destroyButton = Xib.Button.prototype.destroy;
        Xib.Button.prototype.destroy = function()
        {
            __destroyButton.apply( this, arguments );
            this._destroyed = true;
            if( this._pic != undefined && !this._pic._destroyed )
            {
                this._pic.destroy();
                this._pic = null;
            }
            if( this._alternatePic != undefined && !this._alternatePic._destroyed )
            {
                this._alternatePic.destroy();
                this._alternatePic = null;
            }
        };

        Xib.Button.prototype.setAlpha = function( /** Number */
        newAlpha )
        {
            if( this._pic != NULL )
                this._pic.setAlpha( newAlpha );
            if( this._text != NULL )
                this._text.setAlpha( newAlpha );
        };

        Xib.Button.prototype.setStateData = function( data, text )
        {
            this._stateData = data;
            if( text != undefined )
            {
                this._text = text;
            }
        };

        var __button_stateChanged = Xib.Button.prototype.stateChanged;
        Xib.Button.prototype.stateChanged = function()
        {
            if( this._stateData != undefined )
            {
                state = this._enabled ? this._stateData.unselected : this._stateData.selected;
                if( state.color != undefined )
                {
                    this.setColor( state.color );
                }
                if( state.image != undefined )
                {
                    this.setImage( state.image );
                }
                if( state.alpha != undefined )
                {
                    this.setAlpha( state.alpha );
                }
                if( state.textColor != undefined )
                {
                    this._text.setColor( state.textColor );
                }
                if( state.textAlpha != undefined )
                {
                    this._text.setAlpha( state.textAlpha );
                }
                if( state.text != undefined )
                {
                    this.setText( state.text );
                }
            }

            else
            {
                __button_stateChanged.apply( this );
            }

        };

        Xib.Button.prototype.doAction = function()
        {
            if( !this._target )
            {
                return;
            }

            // blocking butons for tutorial
            if( TutorialManager.isButtonBlocked( this ) )
            {
                // Display message pop up
                this.setEnabled( false );
                return;
            }

            // create and call: this._target._selector( this );
            var call = sprintf( "this._target.%s( this );", this._selector );
            eval( call );
        };

        var __button_initialize = Xib.Button.prototype.initialize;
        Xib.Button.prototype.initialize = function()
        {
            __button_initialize.apply( this );

            if( TutorialManager.isButtonBlocked( this ) )
            {
                this.setEnabled( false );
                this._enabled = false;
                return;
            }
        };

        var __button_setEnabled = Xib.Button.prototype.setEnabled;
        Xib.Button.prototype.setEnabled = function( enabled )
        {
            if( enabled == false )
            {
                __button_setEnabled.apply( this, [ false ] );
            }
            else
            {
                if( TutorialManager.isButtonBlocked( this ) )
                {
                    __button_setEnabled.apply( this, [ false ] );
                }
                else
                {
                    __button_setEnabled.apply( this, [ true ] );
                }
            }
        };
    },

    $setupPrototypes: function()
    {

        // var __GL2NodeDestroy = GL2.Node.prototype.destroy;
        // GL2.Node.prototype.destroy = function()
        // {
        // if( !this._destroying )
        // {
        // this._destroying = true;
        // BaseClass.__destroyNodeAndChildren( this );
        // }
        // else
        // {
        // __GL2NodeDestroy.apply( this, arguments );
        // }
        // };
        //
        // var __GL2SpriteDestroy = GL2.Sprite.prototype.destroy;
        // GL2.Sprite.prototype.destroy = function()
        // {
        // if( !this._destroying )
        // {
        // this._destroying = true;
        // BaseClass.__destroyNodeAndChildren( this );
        // }
        // else
        // {
        // __GL2SpriteDestroy.apply( this, arguments );
        // }
        // };
        //
        // var __GL2TextDestroy = GL2.Text.prototype.destroy;
        // GL2.Text.prototype.destroy = function()
        // {
        // if( !this._destroying )
        // {
        // this._destroying = true;
        // BaseClass.__destroyNodeAndChildren( this );
        // }
        // else
        // {
        // __GL2TextDestroy.apply( this, arguments );
        // }
        // };

        GL2.Node.prototype.setClipRect2 = function( rect )
        {
            this._clipRect2 = rect;
            var nodePosInScreenPos = this.localToScreen( new Core.Vector( rect._origin.getX(), rect._origin.getY() ) );
            var nodeSizeInScreenPos = this.localToScreen( new Core.Vector( rect._origin.getX() + rect._size.getWidth(), rect._origin.getY() + rect._size.getHeight() ) );

            rect = new Core.Rect( nodePosInScreenPos._x, nodePosInScreenPos._y, nodeSizeInScreenPos._x, nodeSizeInScreenPos._y );
            this.setClipRect( rect );
        };

        GL2.Node.prototype.getClipRect2 = function()
        {
            if( this._clipRect2 != undefined )
            {
                return this._clipRect2;
            }
            return this._clipRect;
        };

        Array.prototype.swap = function( a, b )
        {
            var tmp = this[a];
            this[a] = this[b];
            this[b] = tmp;
        };

        GL2.Sprite.prototype.Sprite_setImage = GL2.Sprite.prototype.setImage; // prepare for inheritance
        GL2.Sprite.prototype.setImage = function( image )
        {
            if( image == undefined )
                return this; // umm... what?

            if( this._destroyed )
                return this; // can happen with callbacks

            if( arguments.length != 1 || !this._frame )
            {
                arguments[0] = ResourceManager.getPathFor( arguments[0], true );
                return this.Sprite_setImage.apply( this, arguments ); // call super instead
            }

            if( ( !this._cachedImage ) || this._cachedImage.getFrame( 0 ).getImage() != image )
            {
                if( this._cachedImage )
                    this._cachedImage.destroy();

                var frame = new GL2.Animation.Frame( ResourceManager.getPathFor( image, true ), 0, this.getFrame().getSize(), [ .5, .5 ], ResourceManager.getUVSFor( image ) );
                this._cachedImage = new GL2.Animation();
                this._cachedImage.pushFrame( frame );
                // log("GL2.Sprite caching image "+image);
            }

            // set it with all appropriate values.
            return this.Sprite_setImage( ResourceManager.getPathFor( image, true ), this.getFrame().getSize(), [ .5, .5 ], ResourceManager.getUVSFor( image ) );
        };

        GL2.Node.prototype.spinnerOn = function()
        {
            if( this.m_wSprite != undefined )
            {
                this.m_wSprite.destroy();
                this.m_wSprite = null;
            }
            this.m_wSprite = new WaitingSprite( this );
        };

        GL2.Node.prototype.spinnerOff = function( image )
        {
            if( this.m_wSprite != undefined && !this.m_wSprite._destroyed )
            {
                this.m_wSprite.destroy();
                this.m_wSprite = null;
            }
        };

        GL2.Text.prototype.Text_destroy = GL2.Text.prototype.destroy; // prepare for inheritance
        GL2.Text.prototype.destroy = function()
        {
            this._destroyed = true;
            this.removeAnimator();
            this.Text_destroy(); // super
        };

        GL2.Sprite.prototype.Sprite_destroy = GL2.Sprite.prototype.destroy; // prepare for inheritance
        GL2.Sprite.prototype.destroy = function()
        {
            this._destroyed = true;
            this.removeAnimator();
            this.Sprite_destroy(); // super
        };

        /*
         * GL2.Text.prototype.setColor = function( ) { var c = new Core.Color(1,1,1); this._color = c; this._setColorSendGen(c.getRed(),c.getGreen(),c.getBlue()); return this; };
         */

        // var __GL2TextsetFontFamily = GL2.Text.prototype.setFontFamily;
        GL2.Text.prototype.setFontFamily = function( fontFamily )
        {
            if( this.m_needBold == true )
            {
                return this;// this.setBold( true );
            }

            fontFamily = "./Content/font/eurostile.ttf";
            this._fontFamily = fontFamily;

            this._setFontFamilySendGen( fontFamily );

            return this;
        };

        GL2.Text.prototype.setBold = function( bold )
        {
            var fontFamily = "./Content/font/eurostile.ttf";

            if( bold )
            {
                fontFamily = "./Content/font/Eurostib.ttf";
            }
            if( this._fontFamily == fontFamily )
            {
                return this;
            }
            this._fontFamily = fontFamily;
            this._setFontFamilySendGen( this._fontFamily );

            return this;
        };

        GL2.Text.prototype.setText = function( text )
        {
            this.setTextWithStyle( text );
            if( this.m_needBold == true )
            {
                this.setBold( true );
            }
            return this;
        };

        GL2.Text.prototype.__setText = function( text )
        {
            this.setTextWithStyle( text );
            if( this.m_needBold == true )
            {
                this.setBold( true );
            }
            return this;
        };

        /**
         * 
         * @param text: "
         *            <b> Hello"
         */
        GL2.Text.prototype.setTextWithStyle = function( text )
        {
            if( text != undefined )
            {
                /*
                 * // Final indexes of tags var boldLastIndex = -1; var sizeLastIndex = -1; // Looking for "<b>" var boldIndex = text.search( /< *b *>/g ); // If we found "<b>" if( boldIndex != -1 ) { //
                 * Set the bold property this.m_needBold = true; // Save the final index of the bold tag boldLastIndex = text.indexOf( ">", boldIndex ); } // Get the real text var textValue; // Get
                 * the last tag index var lastTagIndex = sizeLastIndex; if( boldLastIndex > lastTagIndex ) { lastTagIndex = boldLastIndex; } // If there are tags, get the real text value if(
                 * lastTagIndex != -1 ) { // textValue = " Hello" textValue = text.substring( lastTagIndex + 1 ); } else { // The text does not have tags textValue = text; }
                 */
                var textValue = text;
                // Removing more "<b>"s
                // if( this.m_needBold )
                // {
                while( true )
                {
                    var initialTextIndex = textValue.search( /< *b *>/g );

                    if( initialTextIndex == -1 )
                    {
                        break;
                    }
                    this.m_needBold = true;
                    var initialText = textValue.substring( 0, initialTextIndex );
                    var finalText = textValue.substring( initialTextIndex );

                    finalTextIndex = finalText.indexOf( ">" );
                    finalText = finalText.substring( finalTextIndex + 1, finalText.length );

                    textValue = initialText + finalText;
                }
                // }
                this._text = textValue;
                this._setTextSendGen( textValue );
            }
        };
    }
} );
exports.Prototypes.setupPrototypes();
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Network/Manifest'] = function(){var exports = $MODULE_REGISTRY['Code/Network/Manifest'] || {}; $MODULE_REGISTRY['Code/Network/Manifest'] = exports; 
var __dirname = 'Code/Network';
var __filename = 'Code/Network/Manifest.js';

var Core = require('NGCore/Client/Core').Core;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

exports.Manifest = Core.Class.subclass(
{
    classname : 'Manifest',

    initialize : function ()
    {
        this.mNumAdded = 0;
        this.mNumRemoved = 0;
    },

    /* Unused
    reset : function ()
    {
        this.mJson = null;
        this.mArchives = null;
    },*/

    initWithJsonText : function (text)
    {
        try
        {
            this.mJson = JSON.parse(text);
            if (!this.mJson)
            {
                this.mJson = {};
            }
        }
        catch (e)
        {
            this.mJson = {};
        }

        if ('__archives' in this.mJson)
        {
            this.mArchives = this.mJson['__archives'].files;
            delete this.mJson['__archives'];
        }
        else
        {
            this.mArchives = [];
        }
    },

    write : function (fileName, callback)
    {
        if (this.mJson)
        {
            var out = JSON.stringify(this.mJson);
            FileSystem.writeFile(fileName, out, {}, function (err)
            {
                if (err)
                {
                    console.log('Error writing manifest: ' + err);
                }

                if (callback)
                {
                    callback();
                }
            });
        }
        else
        {
            callback();
        }
    },

    isModified : function ()
    {
        return (this.mNumAdded > 0 || this.mNumRemoved > 0);
    },

    foreach : function (other, callback)
    {
        // callback: function ( itemKey, dstList, srcList ), which is compareItems
        // callback returns ! null, then dst[ item ] = callback return value.
        // callback returns null, then delete dst[ item ].

        var dst = this.mJson;
        var src = other.mJson;

        // Handle all things in src.
        var key;
        for (key in src)
        {
            this._handleItem(key, dst, src, callback);
        }

        // Build up list of all things not in src.
        for (key in dst)
        {
            // Handle all things not in src.
            if (!(key in src))
            {
                this._handleItem(key, dst, src, callback);
            }
        }
    },

    _handleItem : function (key, dst, src, callback)
    {
        var ret = callback(key, dst, src);
        if (ret)
        {
            if (ret < 0)
            {
                this.mNumRemoved++;
                delete dst[ key ];
            }
            else
            {
                this.mNumAdded++;
            }
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Network/DownloadFileSet'] = function(){var exports = $MODULE_REGISTRY['Code/Network/DownloadFileSet'] || {}; $MODULE_REGISTRY['Code/Network/DownloadFileSet'] = exports; 
var __dirname = 'Code/Network';
var __filename = 'Code/Network/DownloadFileSet.js';

////////////////////////////////////////////////////////////////////////////////
// DownloadFileSet.js
//
// Copyright (C) 2012 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

// NOTE: You are require_d to change these to suit your project structure
var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var Manifest = require('Code/Network/Manifest').Manifest;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFileSet = Core.MessageListener.subclass(
{
    classname : 'DownloadFileSet',

    WRITE_COOLDOWN : 3000 /* 3 seconds */,
    MAX_CONCURRENT_REQUESTS : 6,

    /**
     * @class The `DownloadFileSet` class constructs objects that initiate the handling of a
     * manifest file. This ensures a set of files are kept up-to-date in the specified directory
     * from the specified URL.
     * @constructs The default constructor.
     */
    initialize : function ()
    {
        this.mCompletedPaths = {};
        this.mCompletionCallbacks = {};

        this.mConnections = [];
        this.mPendingItems = [];
        this.mActiveRequests = [];

        this._reset();
    },

    /**
     * Sorts pending items by priority. The priority for a file is proportional
     * to the number of completion callbacks related to it.
     * @private
     */
    _sortPendingItems : function ()
    {
        var priorityA;
        var priorityB;
        this.mPendingItems.sort(function (itemA, itemB)
        {
            priorityA = (itemA.priority !== undefined) ? itemA.priority : 0;
            priorityB = (itemB.priority !== undefined) ? itemB.priority : 0;

            return priorityB - priorityA;
        });
    },

    /**
     * @private
     */
    _clearConnections : function ()
    {
        for (var i in this.mConnections)
        {
            if (!this.mConnections.hasOwnProperty(i))
            {
                continue;
            }

            this.mConnections[i].abort();
        }

        this.mConnections.length = 0;
    },

    /**
     * @private
     */
    _reset : function ()
    {
        this.mConcurrentRequests = this.MAX_CONCURRENT_REQUESTS;

        this.mManifest = null;

        this.mRemoteUrl = null;
        this.mLocalPath = null;
        this.mLocalRoot = null;

        this.mLocalText = null;
        this.mRemoteText = null;
        this.mProgressCb = function () {};
        this.mDoneCb = function () {};

        this.mPaused = false;
        this.mValid = false;

        this._clearConnections();
        this.mPendingItems.length = 0;
        this.mCompleteBytes = 0;
        this.mTotalBytes = 0;

        this.mSpaceNeeded = 0;

        // Unused
        //this.mNumRemoteManifestFiles = 0;
        //this.mNumRemoteManifestBytes = 0;
        //this.mNewJS = false;
        //this.mAppObserver = null;

        this.mDownloadArchives = true;
        this.mActiveRequests.length = 0;

        this.mRetrySchedule = Util.RetrySchedule(50, 2000);
        this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

        if (this._statusListener)
        {
            this._statusListener.destroy();
            this._statusListener = null;
        }

        this.mLastManifestWrite = 0;

        this.mCheckUpdateOnly = false;
        this.mCheckUpdateCallback = null;
    },

    _ensureTrailingSlashes : function (remoteUrl, localPath, secureContentUrl)
    {
        // Check for trailing slashes
        this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';

        // If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
        this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
        this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
    },

    _readLocalManifest : function ()
    {
        FileSystem.readFile(this.mLocalPath, {}, this._onReadLocalManifest.bind(this));
    },

    _setRemotePath : function (manifestName)
    {
        if (this._secureContentUrl)
        {
            this.mRemotePath = this._secureContentUrl + manifestName;
        }
        else
        {
            this.mRemotePath = this.mRemoteUrl + manifestName;
        }
    },

    _parseManifestNames : function (manifest)
    {
        if (typeof manifest === 'string')
        {
            var obj = {};
            obj[manifest] = manifest;
            manifest = obj;
        }

        return manifest;
    },

    /**
     * @private
     */
    _notifyFileReady : function (path)
    {
        if (this.mCompletedPaths[path] === undefined)
        {
            this.mCompletedPaths[path] = true;
        }

        var callbackArray = this.mCompletionCallbacks[path];
        if (callbackArray)
        {
            for (var i = 0; i < callbackArray.length; i++)
            {
                callbackArray[i]();
            }

            callbackArray.length = 0;
            delete this.mCompletionCallbacks[path];
        }

        this._writeManifest(null, false);
    },

    /**
     * Allows to be notified when an individual file within a manifest has finished downloading.
     * **Note**: This method will not validate that the file belongs to the manifest. In that case, no
     * callback will be called.
     * @param path {String} File path
     * @cb callback {Function} Callback with no parameters
     * @example
     * DownloadFileSet.onNotifyFileReady(path, callback);
     * @function
     * @returns {void}
     * @status iOS, Android
     */
    onNotifyFileReady : function (path, callback)
    {
        if (typeof callback != "function")
        {
            return;
        }

        if (this.mCompletedPaths[path] !== undefined)
        {
            // Calling immediately (file is already on disk)
            callback();
        }
        else
        {
            if (this.mCompletionCallbacks[path] === undefined)
            {
                this.mCompletionCallbacks[path] = [];
            }

            this.mCompletionCallbacks[path].push(callback);

            // Updates mPendingItems priority
            for (var i = 0; i < this.mPendingItems.length; i++)
            {
                var item = this.mPendingItems[i];
                if (item.name == path)
                {
                    item.priority = this.mCompletionCallbacks[path].length;
                    this._sortPendingItems();
                    break;
                }
            }
        }
    },

    /**
     * Start a download of a remote manifest file at `[remoteUrl + manifestName]` and read a local
     * manifest at `[localPath + manifestName]`.
     *
     * + If the local manifest does not exist, all files specified by the remote manifest are
     * downloaded.
     * + If the local manifest does exist, this method will update the file system at `[localPath]`
     * to match the files specified in the remote manifest.
     *
     * Each file download will trigger a callback function that returns the number of items
     * downloaded and the total number of items to download. When all downloads are complete, a
     * second callback function is triggered that returns an error (if any) and the contents of
     * `[localPath + manifestName]`. If an error does not occur, this function returns `undefined`.
     *
     * **Note**: The contents of `[localPath + manifestName]` are saved whether an error occurs or
     * not.
     * @param {String} remoteUrl The URL to a manifest file.
     * @param {String} localPath The directory path to a manifest file.
     * @param {String} manifest The manifest filename.
     * @cb {Function} progressCb The function to call when a file has downloaded.
     * @cb-param {Number} completedRequests The number of completed downloads.
     * @cb-param {Number} totalRequests The total number of items being downloaded. Includes items
     *      that have already been downloaded.
     * @cb-returns {void}
     * @cb {Function} doneCb The function to call when all downloads are complete.
     * @cb-param {String} err The error message, if any.
     * @cb-param {String[]} manifest The contents of `[localPath + manifestName]`.
     * @cb-returns {void}
     * @param {Boolean} disableArchives Set to `true` to disable downloading files using archives.
     * @param {Boolean} failEarly Set to `true` to reduce the number of times to attempt to download
     *      files and the timeout length for each request.
     * @throws {Error} The URL or directory path to the manifest file was empty or missing.
     * @example
     * DownloadFileSet.start(this._URL, './', this._manifestName, progressCb, doneCallback);
     * @function
     * @returns {void}
     * @status iOS, Android
     */
    start : function (remoteUrl, localPath, manifest, progressCb, doneCb, disableArchives, failEarly)
    {
        // progressCb: function ( completedRequests, totalRequests )
        // doneCb: function ( err, manifest )
        // throws if url/path arguments are null or empty.
        // TODO: Allow headers argument.  Currently null.
        // TODO: Allow HTTP method argument.  Currently GET.

        this.mCheckUpdateOnly = false;

        // Allow manifestName to be a hash with {manifestDestName: manifestSourceName}
        manifest = this._parseManifestNames(manifest);

        var manifestName = Object.keys(manifest)[0];
        var manifestSourceName = manifest[manifestName];

        console.log('DownloadFileSet.start(', remoteUrl, localPath, manifestSourceName, ')');
        if (!remoteUrl || !localPath || remoteUrl == '' || localPath == '')
        {
            throw new Error('invalid arguments: ' + JSON.stringify(arguments));
        }

        // Set up instance state for this request.
        this.mManifest = new Manifest();

        var isFlash = Core.Capabilities.getPlatformOS() == 'flash';
        if (disableArchives || isFlash)
        {
            this.mDownloadArchives = false;

            if (isFlash)
            {
                console.log('Flash does not yet support archive downloads');    
            }
        }

        this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
        this._setRemotePath(manifestSourceName);
        this.mLocalPath = this.mLocalRoot + manifestName;
        this.mFailEarly = failEarly;

        // try these to prevent a failed update due to bad code
        /** @inner */
        this.mProgressCb = function (done, left)
        {
            try
            {
                progressCb(done, left);
            }
            catch (ex)
            {
                NgLogException(ex);
            }
        };

        var that = this;
        /** @inner */
        this.mDoneCb = function (err, man, hadCache)
        {
            try
            {
                // touch the .nomedia file (MOB-1355)
                FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '', {});

                /** @inner */
                this.mProgressCb = function ()
                {
                };
                /** @inner */
                this.mDoneCb = function ()
                {
                };
                this._setLifecycleListening(false);
                doneCb(err, man, hadCache);
            }
            catch (ex)
            {
                NgLogException(ex);
            }
        };

        this._readLocalManifest();
        this._setLifecycleListening(true);
        this.mValid = true;
    },

    /**
     * Reinitialize a `DownloadFileSet` object.
     * @returns {void}
     */
    abort : function ()
    {
        this.mCompletedPaths = {};
        this.mCompletionCallbacks = {};

        this._reset();
    },

    /**
     * Pause downloading of a download manifest.
     * @returns {void}
     */
    pause : function ()
    {
        // Cancel downloads
        this._clearConnections();

        // move active requests back to pending
        this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
        this.mActiveRequests.length = 0;

        this.mPaused = true;
    },

    /**
     * Resume downloading of a download manifest.
     * @returns {void}
     */
    resume : function ()
    {
        if (this.mPaused)
        {
            this.mPaused = false;
            this._downloadPendingItems();
        }
    },

    _setLifecycleListening : function (toListen)
    {
        if (toListen && !this.lifeListening)
        {
            Device.LifecycleEmitter.addListener(this,
                function (event)
                {
                    switch (event)
                    {
                        case Device.LifecycleEmitter.Event.Suspend:
                        case Device.LifecycleEmitter.Event.Terminate:
                            this._writeManifest(null, true);
                            break;
                    }
                }
            );
            this.lifeListening = true;
        }
        else if (this.lifeListening)
        {
            Device.LifecycleEmitter.removeListener(this);
            this.lifeListening = false;
        }
    },

    _setConfig : function (cfg)
    {
        // For saving after completion
        this._Config = cfg;

        // For skipping JS download
        this._noJS = cfg.omitJsUpdate;

        // For using separate content URL
        this._secureContentUrl = cfg.secureContentUrl;
    },

    /**
     * Callback for read of local manifest file in start method.
     * @private
     */
    _onReadLocalManifest : function (err, data)
    {
        if (this.mValid)
        {
            try // always start try block in asynchronous callbacks
            {
                if (!err)
                {
                    this.mLocalText = data;
                }
                else
                {
                    this.mLocalText = '{}'; // Empty string is ! null.  It's ok for the read to fail.
                }
                this._DownloadFileSet();
            }
            catch (ex)
            {
                NgLogException(ex);
                this._processError('Error reading local manifest err: ' + err, false);
            }
        }
    },

    /**
     * Called to start the manifest download.
     * @private
     */
    _DownloadFileSet : function ()
    {
        var httpStatusCode = 0;

        Util.OperationWithRetries(
            /*operationCb*/ (function (failCall, abortCall)
            {
                // Start remote manifest download.
                var req = new XHR();
                var id = this.mConnections.push(req) - 1;

                /** @inner */
                req.onreadystatechange = (function ()
                {
                    if (req.readyState == 4 && this.mValid)    // done && not cancelled
                    {
                        delete this.mConnections[id];
                        httpStatusCode = req.status;
                        if (httpStatusCode == 200)
                        {
                            this.mRemoteText = req.responseText;
                            this._checkItems();

                            if (this.mCheckUpdateOnly)
                            {
                                this._checkUpdate();
                            }
                            else
                            {
                                this._evalManifests();
                            }
                        }
                        else
                        {
                            console.log('Download of manifest at ' + this.mRemotePath
                                + Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
                                + req.responseText);
                            if (httpStatusCode == 404)
                            {
                                abortCall();
                            }
                            else
                            {
                                failCall();
                            }
                        }
                    }
                }).bind(this);

                req.open('GET', this.mRemotePath + Util.getCacheBustingString(), true);
                req.send();
            }).bind(this),
            /*failureCallback*/ (function ()
            {
                this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
            }).bind(this),
            /*failEarly*/ this.mFailEarly
        );
    },

    /**
     * Processed errors
     * @param message {String}
     * @param writeManifest {Boolean}
     * @private
     */
    _processError : function (message, writeManifest)
    {
        if (writeManifest && this.mManifest)
        {
            this._writeManifest(null, true);
        }

        // Don't call the doneCB without checking local text
        if (this.mValid)
        {
            this.mDoneCb(message, null, this.mLocalText ? this.mLocalText.length > 2 : false);
            this._reset();
        }
    },

    _checkItems : function ()
    {
        // Initialize source and destination manifests
        this.mManifest.initWithJsonText(this.mLocalText, true);
        var other = new Manifest();
        other.initWithJsonText(this.mRemoteText);

        // Build list of pending local items
        this.mManifest.foreach(other, this._compareItems.bind(this));
        this._sortPendingItems();
    },

    _checkUpdate : function ()
    {
        this.mPendingItems.length = 0;
        this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
    },

    _evalManifests : function ()
    {
        try
        {
            // Cache total bytes into separate variable. Archive download might increase
            // space needed, but not total bytes.
            this.mSpaceNeeded = this.mTotalBytes;

            var other = new Manifest();
            other.initWithJsonText(this.mRemoteText);
            // If there is no archive in the manifest, don't download an archive.
            if (!other.mArchives)
            {
                this.mDownloadArchives = false;
            }

            // Prepare for archive downloads. If mDownloadArchives is true,
            // then all files will be downloaded through an archive. Otherwise,
            // only files that are marked as force archive will be downloaded
            // through archive.
            this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);

            // Trigger progress callback.
            this.mProgressCb(this.mCompleteBytes, this.mTotalBytes);

            LocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
            {
                if (err)
                {
                    this._processError(err, false);
                    return;
                }

                var num = this.mPendingItems.length;
                if (num)
                {
                    console.log("Going to download %d items.", num);
                    if (num < 10)
                    {
                        console.log("Items: " + JSON.stringify(this.mPendingItems));
                    }
                }
                // Download anything that got into pending list
                this._downloadPendingItems();
            }.bind(this)));
        }
        catch (e)
        {
            NgLogException(e);
            this.mDoneCb('Failed processing manifests!', null);
        }
    },

    /**
     * Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
     * @private
     */
    _prepareForArchiveDownload : function (archives, onlyForcedFiles)
    {
        console.log('DownloadFileSet._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
        // Iterate over files that need to be covered and make sure they are included.
        var neededFiles = [];
        var includedArcns = {};
        var includedExpSize = 0;
        var includedArcSize = 0;
        var filesToCover = this.mPendingItems;
        var nonForcedFiles = [];

        var reSort = false;

        var f;
        for (var i = 0; i < filesToCover.length; ++i)
        {
            // If this file isn't an archive, just download the file.
            f = filesToCover[i];
            if (!f.arcn)
            {
                //console.log('NonForced: including arcn-less %s', f.name);
                neededFiles.push(f);
                includedExpSize += f.size;
                continue;
            }

            // Record that this archive provides this file.
            var arcn = f.arcn;
            var a = archives[arcn];
            if (!a.files)
            {
                a.files = [f];
            }
            else
            {
                a.files.push(f);
            }

            // Is this archive already included?
            if (includedArcns[arcn])
            {
                continue;
            }

            // If we are only including forced files, remember that this
            // is a non forced file that we need to download. If after evaluating
            // all of the forced files and these files are not included, they will
            // be explicitly included.
            if (onlyForcedFiles && !f.arcForce)
            {
                nonForcedFiles.push(f);
                //console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
                continue;
            }
            
            //console.log('Forced: including %s from arcn %d', f.name, f.arcn);
            
            // Repriorize the file associated with this arcn.
            if (this.mCompletionCallbacks[f.name] && this.mCompletionCallbacks[f.name].length > 0)
            {
                if (!a.priority)
                {
                    a.priority = 0;
                }

                a.priority += this.mCompletionCallbacks[f.name].length;
                reSort = true;
            }
            
            // Include the archive associated with this arcn.
            neededFiles.push(a);
            includedArcns[arcn] = true;
            includedExpSize += a.expSize;
            includedArcSize += a.arcSize;
        }

        // If only downloading forced archives, examine all of the queued
        // files that are not forced. If their archive is not included, then
        // directly include the file.
        for (i = 0; i < nonForcedFiles.length; ++i)
        {
            // Is the archive for this file already included?
            // This will happen if a forced file (like a .js)
            // forced the archive to be included.
            f = nonForcedFiles[i];
            if (includedArcns[f.arcn])
            {
                //console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
                continue;
            }

            //console.log('NonForced: including %s from arch %d', f.name, f.arcn);

            // Otherwise, include this file.
            neededFiles.push(f);
            includedExpSize += f.size;
        }

        // Tell the rest of the world about our choices.
        this.mPendingItems = neededFiles;
        this.mTotalBytes = includedExpSize;
        this.mSpaceNeeded = includedExpSize + includedArcSize;

        if (reSort)
        {
            // NOTE: Make it more efficient if necessary
            this._sortPendingItems();
        }
    },

    /**
     * Callback from Manifest.foreach
     * @param key
     * @param dst
     * @param src
     * @return {Number} 0 = unchanged. -1 = removed. 1 = added
     * @private
     */
    _compareItems : function (key, dst, src)
    {
        var ditem = dst[key];
        var sitem = src[key];

        // Early out for removed file.  Always delete.
        if (!sitem)
        {
            var fname = this.mLocalRoot + key;
            var cb = function (err)
            {
                if (err)
                {
                    console.log('Error deleting ' + fname + ' error: ' + err);
                }
            };
            FileSystem.deleteFile(fname, {}, cb);

            // If the item was pending, delete the temporary file it was downloading
            if ('pending' in ditem)
            {
                fname = fname + '.tmp';
                FileSystem.deleteFile(fname, {}, cb);
            }

            return -1; // removed
        }

        var isJS = this._extensionMatch(key, 'js');

        // Don't download the html or the js with noJS.
        if (this._noJS && (isJS || key == "index.html"))
        {
            // Don't download JS!! keep it in the local manifest, but don't push it to download
            return 0; // no change
        }

        sitem.name = key;
        //this.mNumRemoteManifestFiles += 1;
        //this.mNumRemoteManifestBytes += sitem.size;

        // No local version or version mismatch, must download.
        if (!ditem || ditem.hash != sitem.hash)
        {
            /*
            if (isJS)
            {
                this.mNewJS = true;
            }*/

            // Tally the space we need for downloading new items
            this.mTotalBytes += sitem.size;

            // Add to the pending queue.
            var completionCallbacks = this.mCompletionCallbacks[sitem.name];
            if (completionCallbacks && completionCallbacks.length > 0)
            {
                sitem.priority = completionCallbacks.length;
            }

            this.mPendingItems.push(sitem);
            return 1; // added
        }

        this._notifyFileReady(sitem.name);
        return 0; // no change
    },

    /**
     * Utility method to check for case-insensitive match for file extension.
     * @private
     */
    _extensionMatch : function (fileName, extension)
    {
        var patternRE = new RegExp('^.*\.(' + extension + ')$', 'i');
        return fileName.match(patternRE);
    },

    /**
     * Once in download state, this method is called to start downloading assets
     * from manifest.  When each asset successfully completes, this method will
     * also be called to start the next download.  This method institutes the logic
     * for having a limited number of concurrent downloads from the mCurrentRequests
     * and mConcurrentRequests members.
     * @private
     */
    _downloadPendingItems : function ()
    {
        if (this.mValid && !this.mPaused)
        {
            // Are we done?
            if (this.mPendingItems.length == 0 && this.mActiveRequests.length == 0)
            {
                var cb = function ()
                {
                    this._writeConfig(function ()
                    {
                        // Trigger done callback and reset.
                        this.mDoneCb(null, this.mManifest);
                        this._reset();
                    }.bind(this));
                }.bind(this);

                //if (this.mTotalBytes > 0)
                if (this.mManifest && this.mManifest.isModified())
                {
                    this._writeManifest(cb, true);
                }
                else
                {
                    FileSystem.registerManifest(this.mLocalPath);
                    cb();
                }
                return;
            }

            // Not done, pop more pending items and start their downloads.
            while (this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests)
            {
                // Download the next pending file.
                var item = this.mPendingItems.shift();

                item.retrySchedule = this.mRetrySchedule.slice(0);
                this._downloadItem(item);
            }
        }
    },

    _downloadItem : function (item)
    {
        this.mActiveRequests.push(item);
        var remoteUrl = this.mRemoteUrl + item.name;
        if (item.mangled)
        {
            var i = remoteUrl.lastIndexOf('.');
            remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i + 1) + '.bin';
        }

        Util.OperationWithRetries(
            /*operationCb*/(function (failCb)
            {
                // Start the download.
                var dlFile = new DownloadFile();
                var id = this.mConnections.push(dlFile) - 1;

                dlFile.start(this.mLocalRoot + item.name,
                    'GET',
                    remoteUrl + Util.getCacheBustingString(),
                    [],
                    this._onDownloadItemComplete.bind(this, item, failCb, id));
            }).bind(this),
            /*failureCb*/(function ()
            {
                console.log('Manifest download failed. Too many failed download attempts for ' + item.name);
                this._processError('Could not download file ' + item.name, true);
            }).bind(this),
            /*failEarly*/this.mFailEarly);
    },

    _removeActiveRequest : function (item)
    {
        for (var i in this.mActiveRequests)
        {
            if (item == this.mActiveRequests[i])
            {
                this.mActiveRequests.splice(i, 1);
                break;
            }
        }
    },

    /**
     * Callback for completion of download started in downloadItem method.
     * Will an exception throw if item does not have pending member set.
     * @private
     */
    _onDownloadItemComplete : function (item, failCb, id, status, hash)
    {
        try
        {
            delete this.mConnections[id];

            // Was there an error or bad download?
            if (status != 200 || item.hash != hash)
            {
                // Try to download the item again.
                console.log('Download failed.  Retrying ' + item.name);
                console.log('Status: ' + status + ' manifest hash: ' + JSON.stringify(item.hash) + ' actual hash: ' + JSON.stringify(hash));
                failCb();
                return;
            }

            // Is this an archive?
            if (item.files)
            {
                // Temporarily increase the max number of connections while we decompress the archive.
                ++this.mConcurrentRequests;
                this._downloadPendingItems();

                FileSystem.decompressFile(
                    /* filename */this.mLocalRoot + item.name,
                    /* destination */ this.mLocalRoot,
                    /* options */ { returnFiles : false },
                    /* callback */ (function (err, files)
                    {
                        // Restore max connections to original value.
                        --this.mConcurrentRequests;

                        // Delete the zip file.
                        FileSystem.deleteFile(this.mLocalRoot + '/' + item.name, {});

                        if (err)
                        {
                            // Try to download the item again.
                            console.log('Decompress failed.  Retrying ' + item.name);
                            failCb();
                        }
                        else
                        {
                            for (var i = 0; i < item.files.length; ++i)
                            {
                                var f = item.files[i];
                                this.mManifest.mJson[f.name] = {size : f.size, hash : f.hash};
                                if (typeof f.encryption != "undefined")
                                {
                                    this.mManifest.mJson[f.name].encryption = f.encryption;
                                }
                                if (typeof f.is_code != "undefined")
                                {
                                    this.mManifest.mJson[f.name].is_code = f.is_code;
                                }

                                this._notifyFileReady(f.name);
                            }

                            this._removeActiveRequest(item);
                            this.mCompleteBytes += Number(item.expSize);
                            this.mProgressCb(this.mCompleteBytes, this.mTotalBytes);
                            this._downloadPendingItems();
                        }
                    }).bind(this));
            }
            else
            {
                // Update our working manifest.
                this.mManifest.mJson[item.name] = {size : item.size, hash : item.hash};
                if (typeof item.encryption != "undefined")
                {
                    this.mManifest.mJson[item.name].encryption = item.encryption;
                }

                if (typeof item.is_code != "undefined")
                {
                    this.mManifest.mJson[item.name].is_code = item.is_code;
                }

                // Make callbacks (like a boss).
                this._removeActiveRequest(item);
                this.mCompleteBytes += Number(item.size);
                this.mProgressCb(this.mCompleteBytes, this.mTotalBytes);
                this._downloadPendingItems();

                this._notifyFileReady(item.name);
            }
        }
        catch (ex)
        {
            // Unlikely, but safety
            NgLogException(ex);
            this._processError('Error after finishing the download of item ' + item + '. status is ' + status, true);
        }
    },

    _writeManifest : function (callback, force)
    {
        var coolDownActive = Math.abs(Core.Time.getRealTime() - this.mLastManifestWrite) < this.WRITE_COOLDOWN;
        if (!coolDownActive || force)
        {
            try
            {
                if (this.mManifest)
                {
                    var onComplete = function ()
                    {
                        FileSystem.registerManifest(this.mLocalPath);
                        if (callback)
                        {
                            callback.apply(this, arguments);
                        }
                    };

                    this.mManifest.write(this.mLocalPath, onComplete.bind(this));
                    this.mLastManifestWrite = Core.Time.getRealTime();
                }
            }
            catch (ex)
            {
                NgLogException(ex);
            }
        }
    },

    _writeConfig : function (callback)
    {
        try
        {
            if (this._Config)
            {
                FileSystem.writeFile(this.mLocalRoot + Core.Capabilities._getConfigFile(),
                    JSON.stringify(this._Config), {}, function (stringifyError)
                    {
                        console.log(stringifyError);
                        if (callback)
                        {
                            callback();
                        }
                    });
            }
            else
            {
                if (callback)
                {
                    callback();
                }
            }
        }
        catch (ex)
        {
            NgLogException(ex);
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Network/NetworkManager'] = function(){var exports = $MODULE_REGISTRY['Code/Network/NetworkManager'] || {}; $MODULE_REGISTRY['Code/Network/NetworkManager'] = exports; 
var __dirname = 'Code/Network';
var __filename = 'Code/Network/NetworkManager.js';

exports.NetworkManager = Core.Class.singleton(
    {
        classname : "NetworkManager",

        initialize : function()
        {
            info( "NetworkManager.initialize called." );

            this.m_networkStatusListener = new Core.MessageListener();
            this.m_currentStatus = Device.NetworkEmitter.Status.Wifi;
            this.m_ngCrunchReady = false;
            this.m_popUp = null;

            Device.NetworkEmitter.addListener( this.m_networkStatusListener, this._newNetworkStatus.bind( this ) );
        },

        ngCrunchReady : function()
        {
            info( "NetworkManager.ngCrunchReady called. this.m_ngCrunchReady=%s", this.m_ngCrunchReady );
            this.m_ngCrunchReady = true;
        },

        _newNetworkStatus : function( newStatus )
        {
            info( "NetworkManager.setupNetworkStatus called. newStatus=%s", newStatus );
            this.m_currentStatus = newStatus;

//            switch( newStatus )
//            {
//                case Device.NetworkEmitter.Status.None:
//                    break;
//
//                case Device.NetworkEmitter.Status.Wifi:
//                case Device.NetworkEmitter.Status.Cellular:
//                default:
//                    break;
//            }
        },

        networkAvailable : function()
        {
            info( "NetworkManager.networkAvailable called. this.m_currentStatus=%s", this.m_currentStatus );

            if( this.m_currentStatus == Device.NetworkEmitter.Status.Wifi || this.m_currentStatus == Device.NetworkEmitter.Status.Cellular )
            {
                return true;
            }

            return false;
        },

        isCurrentlyDisplayingError : function()
        {
            if( this.m_popUp != undefined )
            {
                return true;
            }

            return false;
        },

        showServerErrorDialog : function()
        {
            err( "NetworkManager.showServerErrorDialog called. this.m_ngCrunchReady=%s", this.m_ngCrunchReady );

            if( !this.m_ngCrunchReady )
            {
                err( "NetworkManager.showServerErrorDialog returning this.m_ngCrunchReady=%s", this.m_ngCrunchReady );
                return;
            }

            // Check if the dialog is already been displayed
            if( this.isCurrentlyDisplayingError() )
            {
                err( "NetworkManager.showServerErrorDialog returning, PopUp already displayed" );
                return;
            }

            this.m_popUp = new PopUp(
                2,                                       // numberOfButtons
                PopUp.ERROR,                             // popUpType
                _loc( "server_error_dlg_title" ),        // title
                _loc( "server_error_dlg_description" ),  // description

                function()                               // button1 callback
                {
                    // Close game
                    Device.LifecycleEmitter.exitProcess();
                }.bind( this ),
                _loc( "server_error_dlg_exit_button" ), // button1 label

                function()                              // button2 callback
                {
                    info( "NetworkManager.showServerErrorDialog.PopUp_button called." );

                    if( this.m_popUp != undefined && this.m_popUp.closePopUp )
                    {
                        this.m_popUp.closePopUp();
                        this.m_popUp = null;

                        if( TutorialManager.getActiveStateId() == undefined )
                        {
                            Xib.Navigation.resetScreenStackTo( new ControlRoom(), false, true );
                            GameController.getMainScreen().showButtons();
                            GameController.getMainScreen().showPlayerInfo();
                        }
                    }
                }.bind( this ),
                _loc( "server_error_dlg_try_again_button" ),  // button2 label
                false                                         // autoDismiss
            );
            this.m_popUp.setAutoDismiss( false );

            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( this.m_popUp );
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/IntroCutScene'] = function(){var exports = $MODULE_REGISTRY['Code/IntroCutScene'] || {}; $MODULE_REGISTRY['Code/IntroCutScene'] = exports; 
var __dirname = 'Code';
var __filename = 'Code/IntroCutScene.js';

var IntroCutScene = exports.IntroCutScene = Core.Class.subclass(
{
    initialize: function( url, cb )
    {

        this.m_url = url;
        this._cb = cb;
        this._bgView = new UI.View(
        {
            frame: UI.Window.getFrame().array(),
            backgroundColor: "000000"
        } );

        UI.Window.document.addChild( this._bgView );

        var screenWidth = UI.Window._width;
        var screenHeight = UI.Window._height;

        info( "IntroCutScene.initialize: " + screenWidth + ", " + screenHeight );

        // Video size is 848, 480, making it fit.
        var videoW = 480;
        var videoH = 848;

        var videoRatio = videoW / videoH;
        var screenRatio = screenWidth / screenHeight;

        if( screenRatio < videoRatio )
        {
            videoW = screenWidth;
            videoH = videoW / videoRatio;
        }
        else
        {
            videoH = screenHeight;
            videoW = videoH * videoRatio;
        }
        
        var f = [ ( screenWidth - videoW ) / 2, ( screenHeight - videoH ) / 2, videoW, videoH ];

        this._cutScene = new UI._CutSceneView(
        {
            frame: f
        } );

        this._cutScene.setOnClick( function( event )
        {
            console.log( "Video Clicked" );
            this.cleanup();
        }.bind( this ) );

        UI.Window.document.addChild( this._cutScene );

        this._listener = new Core.MessageListener();
        Device.LifecycleEmitter.addListener( this._listener, this.lifecycleUpdate.bind( this ) );
    },

    lifecycleUpdate: function( lifecycleEvent )
    {
        switch( lifecycleEvent )
        {
            case Device.LifecycleEmitter.Event.Suspend:
                this.cleanup();
                break;
        }
    },

    play: function()
    {
        this._cutScene.play( this.m_url, this.videoCallback.bind( this ) );
    },

    cleanup: function()
    {
        if( this._cleaned )
            return;
        this._cleaned = true;

        this._bgView.removeFromParent();
        this._bgView.destroy();
        this._cutScene.removeFromParent();
        this._cutScene.destroy();
        this._listener.destroy();

        this._cb();
    },

    videoCallback: function( event )
    {
        this.cleanup();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/ActionManager'] = function(){var exports = $MODULE_REGISTRY['Code/Action/ActionManager'] || {}; $MODULE_REGISTRY['Code/Action/ActionManager'] = exports; 
var __dirname = 'Code/Action';
var __filename = 'Code/Action/ActionManager.js';

var ActionManager = Core.Class.singleton({
    classname : "ActionManager",
    
    initialize : function()
    {
        this._targetsActions = [];
        this._targetsIndex = [];
        
        Core.UpdateEmitter.addListener(new Core.MessageListener(), function(dt)
        {
            this._step(dt / 1000);
        }.bind(this));
    },
    
    numberOfRunningActions : function(/*GL2.Node */target)
    {
        var result = 0;
        var index = this._targetsIndex.indexOf(target);
        if (index != -1)
        {
            var actions = this._targetsActions[index];
            if (actions)
            {
                actLength = actions.length;
                for ( var i = 0; i < actLength; i++)
                {
                    if (actions[i])
                    {
                        result++;
                    }
                }
            }
        }
        
        return result;
    },
    
    addAction : function(/*Action.Action*/action,/*GL2.Node*/target, /*Boolean*/paused)
    {    	
        action.startWithTarget(target);
        
        var index = this._targetsIndex.indexOf(target);
        if (index == -1)
        {
            this._targetsIndex.push(target);
            this._targetsActions.push([ action ]);
        }
        else
        {
            this._targetsActions[index].push(action);
        }        
    },
    
    removeAllActionsFromTarget : function(/*GL2.Node*/target)
    {
        var index = this._targetsIndex.indexOf(target);
        if (index != -1)
        {
            // delete the element data from both arrays
            this._targetsIndex.splice(index, 1);
            var actions = this._targetsActions.splice(index, 1)[0];
            //destroy the actions
            actLength = actions.length;
            for ( var i = 0; i < actLength; i++)
            {
                //console.log("removeAllActionsFromTarget.destroyingAction: " + actions[i]);
                this._destroyAction(actions[i]);
                actions[i] = null;
            }
        }
    },
    
    _step : function(/*Number*/dt)
    {
        tarLength = this._targetsActions.length;
        for ( var i = 0; i < tarLength; i++)
        {
            var actions = this._targetsActions[i];
            if (actions)
            {
                actLength = actions.length;
                for ( var j = 0; j < actLength; j++)
                {
                    var action = actions[j];
//                    try
//                    {
                        if (action)
                        {
                            if (!action.isDone())
                            {
                                action.step(dt);
                            }
                            else
                            {
                                //console.log("Destroying finished action: " + action);
                                this._destroyAction(action);
                                actions[j] = null;
                            }
                        }
//                    }
//                    catch (e)
//                    {
//                        console.log("Exception while calling action.step. Exception: " + e.message);
//                        this._destroyAction(action);
//                        actions[j] = null;
//                    }
                    
                }
            }
            
        }
    },
    
    _destroyAction : function(action)
    {
        try
        {
            action && action.destroy();
        }
        catch (e)
        {
            console.log('Exception while destroying action. Ignored Exception: ' + e);
            throw e;
        }
    }
});

exports.ActionManager = ActionManager;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/Action'] = function(){var exports = $MODULE_REGISTRY['Code/Action/Action'] || {}; $MODULE_REGISTRY['Code/Action/Action'] = exports; 
var __dirname = 'Code/Action';
var __filename = 'Code/Action/Action.js';

var kCCActionTagInvalid = -1;

/**
 * Base class for Action objects.
 */
var Action = Core.Class.subclass({
    classname : 'Action',
    
    initialize : function()
    {
        
        /**
         * The original target, since target can be nil. Is the target that were
         * used to run the action. Unless you are doing something complex, like
         * ActionManager, you should NOT call this method.
         */
        this.originalTarget = null;
        
        /**
         * The "target". The action will modify the target properties. The
         * target will be set with the 'startWithTarget' method. When the 'stop'
         * method is called, target will be set to nil. The target is
         * 'assigned', it is not 'retained'.
         */
        this.target = null;
        
        /** The action tag. An identifier of the action */
        this.tag = 0;
        
    },
    
    /** static builder */
    $action : function()
    {
        return new this();
    },
    
    initialize : function()
    {
        this.originalTarget = this.target = null;
        this.tag = kCCActionTagInvalid;
        return this;
    },
    
    //! return YES if the action has finished
    isDone : function()
    {
        return true;
    },
    
    //! called before the action start. It will also set the target.
    startWithTarget : function(/*GL2.Node*/aTarget)
    {
        this.originalTarget = this.target = aTarget;
    },
    
    //! called after the action has finished. It will set the 'target' to null.
    //! IMPORTANT: You should never call "action.stop()" manually. Instead, use: "target.stopAction(action);"
    stop : function()
    {
        this.target = null;
    },
    
    //! called every frame with it's delta time. DON'T override unless you know what you are doing. dt in seconds
    step : function(/*Number*/dt)
    {
    },
    
    //! called once per frame. time a value between 0 and 1
    //! For example: 
    //! * 0 means that the action just started
    //! * 0.5 means that the action is in the middle
    //! * 1 means that the action is over
    update : function(/*Number*/time)
    {
    },
    
    destroy : function()
    {
    }
});

exports.Action = Action;

/**
 * Base class actions that do have a finite time duration. Possible actions: -
 * An action with a duration of 0 seconds - An action with a duration of 35.5
 * seconds Infinite time actions are valid
 */
var FiniteTimeAction = Action.subclass({
    classname : 'FiniteTimeAction',
    
    initialize : function()
    {
        
        //! duration in seconds of the action
        this.duration = 0;
    },
    
    /** returns a reversed action */
    reverse : function()
    {
        return null;
    }
});

exports.FiniteTimeAction = FiniteTimeAction;

/**
 * Repeats an action for ever. To repeat the an action for a limited number of
 * times use the Repeat action.
 * 
 * @warning This action can't be Sequenceable because it is not an
 *          IntervalAction
 */
var RepeatForever = Action.subclass({
    classname : 'RepeatForever',
    
    initialize : function()
    {
        // the action to repeate
        this.other = null;
    },
    
    /** creates the action */
    $actionWithAction : function(/*IntervalAction*/action)
    {
        return new RepeatForever().initWithAction(action);
    },
    
    /** initializes the action */
    initWithAction : function(/*IntervalAction*/action)
    {
        this.other = action;
        return this;
    },
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.other.startWithTarget(aTarget);
    },
    
    step : function(/*Number*/dt)
    {
        this._ddt = this._ddt ? this._ddt + dt : dt;
        //adjust oneOverFPS to slow down the amount of fps for debuging purpose.
        var oneOverFPS = 0;//Example: 1/2 to get 2 fps. Zero to allow the system FPS.
        if (this._ddt > oneOverFPS)
        {
            this.other.step(this._ddt);
            this._ddt = 0;
            
            if (this.other.isDone())
            {
                var diff = this._ddt + this.other.duration - this.other.elapsed;
                this.other.startWithTarget(this.target);
                
                // to prevent jerk. issue #390
                this.other.step(diff);
            }
        }
    },
    
    isDone : function()
    {
        return false;
    },
    
    reverse : function()
    {
        return RepeatForever.actionWithAction(this.other.reverse());
    },
    
    destroy : function()
    {
        this.other.destroy();
    }
});

exports.RepeatForever = RepeatForever;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/IntervalAction'] = function(){var exports = $MODULE_REGISTRY['Code/Action/IntervalAction'] || {}; $MODULE_REGISTRY['Code/Action/IntervalAction'] = exports; 
var __dirname = 'Code/Action';
var __filename = 'Code/Action/IntervalAction.js';

var FiniteTimeAction = require( 'Code/Action/Action' ).FiniteTimeAction;

var FLT_EPSILON = 1e-15;
var ccpSub = function( /* Core.Point */a, /* Core.Point */b )
{
    return new Core.Point( a.getX() - b.getX(), a.getY() - b.getY() );
};

var IntervalAction = FiniteTimeAction.subclass(
{
    classname: 'IntervalAction',

    initialize: function()
    {
        /** how many seconds had elapsed since the actions started to run. */
        this.elapsed = null;
        this.firstTick = false;
    },

    /** creates the action */
    $actionWithDuration: function( /* Number */duration )
    {
        return new this().initWithDuration( duration );
    },

    /** initializes the action */
    initWithDuration: function( /* Number */duration )
    {
        this.duration = duration;

        // prevent division by 0
        // This comparison could be in step:, but it might decrease the performance
        // by 3% in heavy based action games.
        if( this.duration == 0 )
            this.duration = FLT_EPSILON;
        this.elapsed = 0;
        this.firstTick = true;
        return this;
    },

    /** returns true if the action has finished */
    isDone: function()
    {
        return( this.elapsed >= this.duration );
    },

    step: function( /* Number */dt )
    {
        if( this.firstTick )
        {
            this.firstTick = false;
            this.elapsed = 0;
        }
        else
            this.elapsed += dt;

        this.update( Math.min( 1, this.elapsed / this.duration ) );
    },

    startWithTarget: function( $super,/* Node */aTarget )
    {
        $super( aTarget );
        this.elapsed = 0.0;
        this.firstTick = true;
    },

    /** returns a reversed action */
    reverse: function()
    {
        throw new Error( 'ReverseActionNotImplemented' );
    }

} );

exports.IntervalAction = IntervalAction;

/**
 * Runs actions sequentially, one after another
 */
var Sequence = IntervalAction.subclass(
{
    classname: 'Sequence',

    initialize: function()
    {
        this.actions = [];
        this.split = null;
        this.last = 0;
    },

    /** helper constructor to create an array of sequenceable actions */
    $actions: function()
    {
        var now;
        var prev = arguments[0];

        for( var i = 1; i < arguments.length; i++ )
        {
            now = arguments[i];
            if( now )
                prev = this.actionOne( prev, now );
            else
                break;
        }
        return prev;
    },

    /** creates the action */
    $actionOne: function( /* FiniteTimeAction */actionOne,/* FiniteTimeAction */actionTwo )
    {
        return new Sequence().initOne( actionOne, actionTwo );
    },

    /** initializes the action */
    initOne: function( /* FiniteTimeAction */actionOne,/* FiniteTimeAction */actionTwo )
    {

        var d = actionOne.duration + actionTwo.duration;
        this.initWithDuration( d );

        this.actions[0] = actionOne;
        this.actions[1] = actionTwo;

        return this;
    },

    startWithTarget: function( $super,/* Node */aTarget )
    {
        $super( aTarget );
        this.split = this.actions[0].duration / this.duration;
        this.last = -1;
    },

    stop: function( $super )
    {
        this.actions[0].stop();
        this.actions[1].stop();
        $super();
    },

    update: function( /* Number */t )
    {
        var found = 0;
        var new_t = 0.0;

        if( t >= this.split )
        {
            found = 1;
            if( this.split == 1 )
                new_t = 1;
            else
                new_t = ( t - this.split ) / ( 1 - this.split );
        }
        else
        {
            found = 0;
            if( this.split != 0 )
                new_t = t / this.split;
            else
                new_t = 1;
        }

        if( this.last == -1 && found == 1 )
        {
            this.actions[0].startWithTarget( this.target );
            this.actions[0].update( 1.0 );
            this.actions[0].stop();
        }

        if( this.last != found )
        {
            if( this.last != -1 )
            {
                this.actions[this.last].update( 1.0 );
                this.actions[this.last].stop();
            }
            this.actions[found].startWithTarget( this.target );
        }
        this.actions[found].update( new_t );
        this.last = found;
    },

    reverse: function()
    {
        return this.actionOne( this.actions[1].reverse(), this.actions[0].reverse() );
    },

    destroy: function()
    {
        this.actions[0].destroy();
        this.actions[1].destroy();
    }

} );

exports.Sequence = Sequence;

var DelayTime = IntervalAction.subclass(
{
    classname: 'DelayTime',

    update: function( t )
    {
        return;
    },

    reverse: function()
    {
        return this.actionWithDuration( this.duration );
    }
} );

exports.DelayTime = DelayTime;

/**
 * Moves a GL2.Node object to the position x,y. x and y are absolute coordinates by modifying it's position attribute.
 */
var MoveTo = IntervalAction.subclass(
{
    classname: 'MoveTo',

    initialize: function()
    {
        this.endPosition = null;
        this.startPosition = null;
        this.delta = null;
    },

    /** creates the action */
    $actionWithDuration: function( /* Number */duration,/* Core.Point */position )
    {
        return new this().initWithDuration( duration, position );
    },

    /** initializes the action */
    initWithDuration: function( $super,/* Number */duration,/* Core.Point */position )
    {
        $super( duration );
        this.endPosition = position;
        return this;
    },

    startWithTarget: function( $super,/* Node */aTarget )
    {
        $super( aTarget );
        this.startPosition = this.target.getPosition().clone();
        this.delta = ccpSub( this.endPosition, this.startPosition );
    },

    update: function( /* Number */t )
    {
        // console.log(this.classname + ".update("+t+")");
        var newPosition = new Core.Point( ( this.startPosition.getX() + this.delta.getX() * t ), ( this.startPosition.getY() + this.delta.getY() * t ) );
        this.target.setPosition( newPosition );
    }

} );

exports.MoveTo = MoveTo;

/**
 * Moves a GL2.Node object x,y pixels by modifying it's position attribute. x and y are relative to the position of the object. Duration is is seconds.
 */
var MoveBy = MoveTo.subclass(
{
    classname: 'MoveBy',

    /** creates the action */
    $actionWithDuration: function( /* Number */duration,/* Core.Point */deltaPosition )
    {
        return new MoveBy().initWithDuration( duration, deltaPosition );
    },

    /** initializes the action */
    initWithDuration: function( $super,/* Number */duration,/* Core.Point */deltaPosition )
    {
        $super( duration, deltaPosition );
        this.delta = deltaPosition;
        return this;
    },

    startWithTarget: function( $super,/* Node */aTarget )
    {
        var dTmp = this.delta;
        $super( aTarget );
        this.delta = dTmp;
    },

    reverse: function()
    {
        return this.actionWithDuration( this.duration, new Core.Point( -this.delta.getX(), -this.delta.getY() ) );
    }

} );

exports.MoveBy = MoveBy;

var ScaleTo = IntervalAction.subclass(
{
    classname: 'ScaleTo',

    initialize: function()
    {
        this.scaleX = 0;
        this.scaleY = 0;
        this.startScaleX = 0;
        this.startScaleY = 0;
        this.endScaleX = 0;
        this.endScaleY = 0;
        this.deltaX = 0;
        this.deltaY = 0;
    },

    /**
     * Creates the action
     */
    $actionWithDuration: function( /* Number */t,/* Number */a,/* Number */b )
    {
        return new this().initWithDuration( t, a, b );
    },

    /**
     * Creates the action
     */
    initWithDuration: function( $super,/* Number */t,/* Number */a,/* Number */b )
    {
        // As JavaScript doesn't support method overloading, we have to check if the arguments are defined.
        $super( t );
        if( typeof ( b ) == 'undefined' )
        {
            if( a.hasOwnProperty( "length" ) )
            {
                this.endScaleX = a[0];
                this.endScaleY = a[1];
            }
            else if( a instanceof Core.Point )
            {
                this.endScaleX = a._x;
                this.endScaleY = a._y;
            }
            else
            {
                /** initializes the action with the same scale factor for X and Y */
                this.endScaleX = a;
                this.endScaleY = a;
            }
        }
        else
        {
            /** creates the action with and X factor and a Y factor */
            this.endScaleX = a;
            this.endScaleY = b;
        }

        return this;
    },

    startWithTarget: function( $super,/* GL2.Node */aTarget )
    {
        $super( aTarget );
        this.startScaleX = this.target.getScale().getX();
        this.startScaleY = this.target.getScale().getY();
        this.deltaX = this.endScaleX - this.startScaleX;
        this.deltaY = this.endScaleY - this.startScaleY;
    },

    update: function( /* Number */t )
    {
        this.target.setScale( ( this.startScaleX + this.deltaX * t ), ( this.startScaleY + this.deltaY * t ) );
    }
} );

exports.ScaleTo = ScaleTo;

/**
 * Scales a GL2.Node object a zoom factor by modifying it's scale attribute.
 */
var ScaleBy = ScaleTo.subclass(
{
    classname: 'ScaleBy',

    startWithTarget: function( $super,/* GL2.Node */aTarget )
    {
        $super( aTarget );
        this.deltaX = this.startScaleX * this.endScaleX - this.startScaleX;
        this.deltaY = this.startScaleY * this.endScaleY - this.startScaleY;
    },

    reverse: function()
    {
        return this.actionWithDuration( this.duration, 1 / this.endScaleX, 1 / this.endScaleY );
    }
} );

exports.ScaleBy = ScaleBy;

/**
 * Rotates a Node object to a certain angle by modifying it's rotation attribute. The direction will be decided by the shortest angle.
 */
var RotateTo = IntervalAction.subclass(
{
    classname: 'RotateTo',

    initialize: function()
    {
        this.dstAngle = 0;
        this.startAngle = 0;
        this.diffAngle = 0;
    },

    /** creates the action */
    $actionWithDuration: function( /* Number */duration, /* Number */angle )
    {
        return new this().initWithDuration( duration, angle );
    },

    /** initializes the action */
    initWithDuration: function( $super,/* Number */duration, /* Number */angle )
    {
        $super( duration );
        this.dstAngle = angle;
        return this;
    },

    startWithTarget: function( $super,/* GL2.Node */aTarget )
    {
        $super( aTarget );

        this.startAngle = this.target.getRotation();
        if( this.startAngle > 0 )
            this.startAngle = this.startAngle % 360;
        else
            this.startAngle = this.startAngle % -360;

        this.diffAngle = this.dstAngle - this.startAngle;
        if( this.diffAngle > 180 )
            this.diffAngle -= 360;
        if( this.diffAngle < -180 )
            this.diffAngle += 360;
    },

    update: function( /* Number */t )
    {
        this.target.setRotation( this.startAngle + this.diffAngle * t );
    }
} );

exports.RotateTo = RotateTo;

/**
 * Fades Out an object that implements the RGBAProtocol protocol. It modifies the opacity from 1 to 0. The "reverse" of this action is FadeIn.
 */
var FadeOut = IntervalAction.subclass(
{
    classname: 'FadeOut',

    update: function( /* Number */t )
    {
        this.target.setAlpha( 1 - t );
    },

    reverse: function()
    {
        return FadeIn.actionWithDuration( this.duration );
    }

} );

exports.FadeOut = FadeOut;

/**
 * Fades In an object that implements the RGBAProtocol protocol. It modifies the opacity from 0 to 1. The "reverse" of this action is FadeOut.
 */
var FadeIn = IntervalAction.subclass(
{
    classname: 'FadeIn',

    update: function( /* Number */t )
    {
        this.target.setAlpha( t );
    },

    reverse: function()
    {
        return FadeOut.actionWithDuration( this.duration );
    }

} );

exports.FadeIn = FadeIn;

var ClipTo = IntervalAction.subclass(
{
    classname: 'ClipTo',

    initialize: function()
    {
        this.clipX = 0;
        this.clipY = 0;
        this.startClipX = 0;
        this.startClipY = 0;
        this.endClipX = 0;
        this.endClipY = 0;
        this.deltaX = 0;
        this.deltaY = 0;
    },

    /**
     * Creates the action
     */
    $actionWithDuration: function( /* Number */t, /* Number */x, /* Number */y, /* Number */w, /* Number */h )
    {
        return new this().initWithDuration( t, x, y, w, h );
    },

    /**
     * Creates the action
     */
    initWithDuration: function( $super, /* Number */t, /* Number */x, /* Number */y, /* Number */w, /* Number */h )
    {
        // As JavaScript doesn't support method overloading, we have to check if the arguments are defined.
        $super( t );
        if( typeof ( y ) == 'undefined' )
        {
            if( x.hasOwnProperty( "length" ) )
            {
                this.endClipX = x[0];
                this.endClipY = x[1];
                this.endClipW = x[2];
                this.endClipH = x[3];
            }
            else
            {
                this.endClipX = x._origin._x;
                this.endClipY = x._origin._y;
                this.endClipW = x._size._width;
                this.endClipH = x._size._height;
            }
        }
        else
        {
            /** creates the action with X, Y, W and H */
            this.endClipX = x;
            this.endClipY = y;
            this.endClipW = w;
            this.endClipH = h;
        }

        return this;
    },

    startWithTarget: function( $super, /* GL2.Node */aTarget )
    {
        $super( aTarget );
        var rect = this.target.getClipRect2();
        this.startClipX = rect._origin.getX();
        this.startClipY = rect._origin.getY();
        this.deltaX = this.endClipX - this.startClipX;
        this.deltaY = this.endClipY - this.startClipY;

        this.startClipH = rect._size.getHeight();
        this.startClipW = rect._size.getWidth();
        this.deltaH = this.endClipH - this.startClipH;
        this.deltaW = this.endClipW - this.startClipW;
    },

    update: function( /* Number */t )
    {
        var newRect = new Core.Rect( ( this.startClipX + this.deltaX * t ), ( this.startClipY + this.deltaY * t ), ( this.startClipW + this.deltaW * t ), ( this.startClipH + this.deltaH * t ) );
        this.target.setClipRect2( newRect );
    }
} );
exports.ClipTo = ClipTo;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/InstantAction'] = function(){var exports = $MODULE_REGISTRY['Code/Action/InstantAction'] || {}; $MODULE_REGISTRY['Code/Action/InstantAction'] = exports; 
var __dirname = 'Code/Action';
var __filename = 'Code/Action/InstantAction.js';

var FiniteTimeAction = require('Code/Action/Action').FiniteTimeAction;

var InstantAction = FiniteTimeAction.subclass({
    classname : 'InstantAction',
    
    initialize : function()
    {
        /** how many seconds had elapsed since the actions started to run. */
        this.duration = 0;
    },
    
    /** returns true if the action has finished */
    isDone : function()
    {
        return true;
    },
    
    step : function(/*Number*/dt)
    {
        this.update(1);
    },
    
    /** returns a reversed action */
    reverse : function()
    {
        this;
    }

});

exports.InstantAction = InstantAction;

/**
 * Hide the node
 */
var Hide = InstantAction.subclass({
    classname : 'Hide',
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.target.setVisible(false);
    },
    
    reverse : function()
    {
        return Show.action();
    }

});

exports.Hide = Hide;

/**
 * Show the node
 */
var Show = InstantAction.subclass({
    classname : 'Show',
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.target.setVisible(true);
    },
    
    reverse : function()
    {
        return Hide.action();
    }

});

exports.Show = Show;

var CallFunc = InstantAction.subclass({
    classname : 'CallFunc',
    
    $actionWithTarget : function(t, s)
    {
        return new this().initWithTarget(t, s);
    },
    
    initWithTarget : function(t, s)
    {
        this.targetCallback = t;
        this.selector = s;
        
        return this;
    },
    
    startWithTarget : function($super, /* GL2.Node */aTarget)
    {
        $super(aTarget);
        this.execute();
    },
    
    execute : function()
    {
        this.selector.call(this.targetCallback);
    }
});

exports.CallFunc = CallFunc;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action/EaseAction'] = function(){var exports = $MODULE_REGISTRY['Code/Action/EaseAction'] || {}; $MODULE_REGISTRY['Code/Action/EaseAction'] = exports; 
var __dirname = 'Code/Action';
var __filename = 'Code/Action/EaseAction.js';

var IntervalAction = require('Code/Action/IntervalAction').IntervalAction;

var EaseAction = IntervalAction.subclass({
    classname : 'EaseAction',
    
    other : null,
    
    /** creates the action */
    $actionWithAction : function(/*IntervalAction*/action)
    {
        return new this().initWithAction(action);
    },
    
    /** initializes the action */
    initWithAction : function(/*IntervalAction*/action)
    {
        this.initWithDuration(action.duration);
        this.other = action;
        return this;
    },
    
    startWithTarget : function($super,/*GL2.Node*/aTarget)
    {
        $super(aTarget);
        this.other.startWithTarget(aTarget);
    },
    
    stop : function($super)
    {
        this.other.stop();
        $super();
    },
    
    update : function(/*Number*/t)
    {
        this.other.update(t);
    },
    
    reverse : function()
    {
        return this.actionWithAction(this.other.reverse());
    },
    
    destroy : function()
    {
        this.other.destroy();
    }
});

exports.EaseAction = EaseAction;

exports.EaseInQuad = EaseAction.subclass({
	classname: 'EaseInQuad',
	
	update: function(/*Number*/ t)
	{
		this.other.update(EasingFunctions.easeInQuad(t,0,1,1));
	}
});

exports.EaseOutQuad = EaseAction.subclass({
	classname : 'EaseOutQuad',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutQuad(t, 0, 1, 1));
	}
});

exports.EaseInOutQuad = EaseAction.subclass({
	classname : 'EaseInOutQuad',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutQuad(t, 0, 1, 1));
	}
});

exports.EaseInCubic = EaseAction.subclass({
	classname : 'EaseInCubic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInCubic(t, 0, 1, 1));
	}
});

exports.EaseOutCubic = EaseAction.subclass({
	classname : 'EaseOutCubic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutCubic(t, 0, 1, 1));
	}
});

exports.EaseInOutCubic = EaseAction.subclass({
	classname : 'EaseInOutCubic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutCubic(t, 0, 1, 1));
	}
});

exports.EaseOutInCubic = EaseAction.subclass({
	classname : 'EaseOutInCubic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInCubic(t, 0, 1, 1));
	}
});

exports.EaseInQuart = EaseAction.subclass({
	classname : 'EaseInQuart',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInQuart(t, 0, 1, 1));
	}
});

exports.EaseOutQuart = EaseAction.subclass({
	classname : 'EaseOutQuart',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutQuart(t, 0, 1, 1));
	}
});

exports.EaseInOutQuart = EaseAction.subclass({
	classname : 'EaseInOutQuart',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutQuart(t, 0, 1, 1));
	}
});

exports.EaseOutInQuart = EaseAction.subclass({
	classname : 'EaseOutInQuart',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInQuart(t, 0, 1, 1));
	}
});

exports.EaseInQuint = EaseAction.subclass({
	classname : 'EaseInQuint',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInQuint(t, 0, 1, 1));
	}
});

exports.EaseOutQuint = EaseAction.subclass({
	classname : 'EaseOutQuint',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutQuint(t, 0, 1, 1));
	}
});

exports.EaseInOutQuint = EaseAction.subclass({
	classname : 'EaseInOutQuint',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutQuint(t, 0, 1, 1));
	}
});

exports.EaseOutInQuint = EaseAction.subclass({
	classname : 'EaseOutInQuint',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInQuint(t, 0, 1, 1));
	}
});

exports.EaseInSine = EaseAction.subclass({
	classname : 'EaseInSine',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInSine(t, 0, 1, 1));
	}
});

exports.EaseOutSine = EaseAction.subclass({
	classname : 'EaseOutSine',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutSine(t, 0, 1, 1));
	}
});

exports.EaseInOutSine = EaseAction.subclass({
	classname : 'EaseInOutSine',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutSine(t, 0, 1, 1));
	}
});

exports.EaseOutInSine = EaseAction.subclass({
	classname : 'EaseOutInSine',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInSine(t, 0, 1, 1));
	}
});

exports.EaseInExpo = EaseAction.subclass({
	classname : 'EaseInExpo',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInExpo(t, 0, 1, 1));
	}
});

exports.EaseOutExpo = EaseAction.subclass({
	classname : 'EaseOutExpo',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutExpo(t, 0, 1, 1));
	}
});

exports.EaseInOutExpo = EaseAction.subclass({
	classname : 'EaseInOutExpo',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutExpo(t, 0, 1, 1));
	}
});

exports.EaseOutInExpo = EaseAction.subclass({
	classname : 'EaseOutInExpo',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInExpo(t, 0, 1, 1));
	}
});

exports.EaseInCirc = EaseAction.subclass({
	classname : 'EaseInCirc',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInCirc(t, 0, 1, 1));
	}
});

exports.EaseOutCirc = EaseAction.subclass({
	classname : 'EaseOutCirc',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutCirc(t, 0, 1, 1));
	}
});

exports.EaseInOutCirc = EaseAction.subclass({
	classname : 'EaseInOutCirc',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutCirc(t, 0, 1, 1));
	}
});

exports.EaseOutInCirc = EaseAction.subclass({
	classname : 'EaseOutInCirc',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInCirc(t, 0, 1, 1));
	}
});

exports.EaseInElastic = EaseAction.subclass({
	classname : 'EaseInElastic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInElastic(t, 0, 1, 1));
	}
});

exports.EaseOutElastic = EaseAction.subclass({
	classname : 'EaseOutElastic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutElastic(t, 0, 1, 1));
	}
});

exports.EaseInOutElastic = EaseAction.subclass({
	classname : 'EaseInOutElastic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutElastic(t, 0, 1, 1));
	}
});

exports.EaseOutInElastic = EaseAction.subclass({
	classname : 'EaseOutInElastic',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInElastic(t, 0, 1, 1));
	}
});

exports.EaseInBack = EaseAction.subclass({
	classname : 'EaseInBack',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInBack(t, 0, 1, 1));
	}
});

exports.EaseOutBack = EaseAction.subclass({
	classname : 'EaseOutBack',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutBack(t, 0, 1, 1));
	}
});

exports.EaseInOutBack = EaseAction.subclass({
	classname : 'EaseInOutBack',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutBack(t, 0, 1, 1));
	}
});

exports.EaseOutInBack = EaseAction.subclass({
	classname : 'EaseOutInBack',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInBack(t, 0, 1, 1));
	}
});

exports.EaseInBounce = EaseAction.subclass({
	classname : 'EaseInBounce',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInBounce(t, 0, 1, 1));
	}
});

exports.EaseOutBounce = EaseAction.subclass({
	classname : 'EaseOutBounce',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutBounce(t, 0, 1, 1));
	}
});

exports.EaseInOutBounce = EaseAction.subclass({
	classname : 'EaseInOutBounce',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeInOutBounce(t, 0, 1, 1));
	}
});

exports.EaseOutInBounce = EaseAction.subclass({
	classname : 'EaseOutInBounce',

	update : function(/*Number*/t) {
		this.other.update(EasingFunctions.easeOutInBounce(t, 0, 1, 1));
	}
});

var EasingFunctions = {
		easeNone: function(t, b, c, d) {
			return c*t/d + b;
		},
		easeInQuad: function(t, b, c, d) {
			return c*(t/=d)*t + b;
		},
		easeOutQuad: function(t, b, c, d) {
			return -c *(t/=d)*(t-2) + b;
		},
		easeInOutQuad: function(t, b, c, d) {
			if((t/=d/2) < 1) return c/2*t*t + b;
				return -c/2 *((--t)*(t-2) - 1) + b;
		},
		easeInCubic: function(t, b, c, d) {
			return c*(t/=d)*t*t + b;
		},	
		easeOutCubic: function(t, b, c, d) {
			return c*((t=t/d-1)*t*t + 1) + b;
		},	
		easeInOutCubic: function(t, b, c, d) {
			if((t/=d/2) < 1) return c/2*t*t*t + b;
			return c/2*((t-=2)*t*t + 2) + b;
		},	
		easeOutInCubic: function(t, b, c, d) {
			if(t < d/2) return this.easeOutCubic(t*2, b, c/2, d);
			return this.easeInCubic((t*2)-d, b+c/2, c/2, d);
		},	
		easeInQuart: function(t, b, c, d) {
			return c*(t/=d)*t*t*t + b;
		},	
		easeOutQuart: function(t, b, c, d) {
			return -c *((t=t/d-1)*t*t*t - 1) + b;
		},	
		easeInOutQuart: function(t, b, c, d) {
			if((t/=d/2) < 1) return c/2*t*t*t*t + b;
			return -c/2 *((t-=2)*t*t*t - 2) + b;
		},	
		easeOutInQuart: function(t, b, c, d) {
			if(t < d/2) return this.easeOutQuart(t*2, b, c/2, d);
			return this.easeInQuart((t*2)-d, b+c/2, c/2, d);
		},	
		easeInQuint: function(t, b, c, d) {
			return c*(t/=d)*t*t*t*t + b;
		},	
		easeOutQuint: function(t, b, c, d) {
			return c*((t=t/d-1)*t*t*t*t + 1) + b;
		},	
		easeInOutQuint: function(t, b, c, d) {
			if((t/=d/2) < 1) return c/2*t*t*t*t*t + b;
			return c/2*((t-=2)*t*t*t*t + 2) + b;
		},	
		easeOutInQuint: function(t, b, c, d) {
			if(t < d/2) return this.easeOutQuint(t*2, b, c/2, d);
			return this.easeInQuint((t*2)-d, b+c/2, c/2, d);
		},	
		easeInSine: function(t, b, c, d) {
			return -c * Math.cos(t/d *(Math.PI/2)) + c + b;
		},	
		easeOutSine: function(t, b, c, d) {
			return c * Math.sin(t/d *(Math.PI/2)) + b;
		},	
		easeInOutSine: function(t, b, c, d) {
			return -c/2 *(Math.cos(Math.PI*t/d) - 1) + b;
		},	
		easeOutInSine: function(t, b, c, d) {
			if(t < d/2) return this.easeOutSine(t*2, b, c/2, d);
			return this.easeInSine((t*2)-d, b+c/2, c/2, d);
		},	
		easeInExpo: function(t, b, c, d) {
			return(t==0) ? b : c * Math.pow(2, 10 *(t/d - 1)) + b - c * 0.001;
		},	
		easeOutExpo: function(t, b, c, d) {
			return(t==d) ? b+c : c * 1.001 *(-Math.pow(2, -10 * t/d) + 1) + b;
		},	
		easeInOutExpo: function(t, b, c, d) {
			if(t==0) return b;
			if(t==d) return b+c;
			if((t/=d/2) < 1) return c/2 * Math.pow(2, 10 *(t - 1)) + b - c * 0.0005;
			return c/2 * 1.0005 *(-Math.pow(2, -10 * --t) + 2) + b;
		},	
		easeOutInExpo: function(t, b, c, d) {
			if(t < d/2) return this.easeOutExpo(t*2, b, c/2, d);
			return this.easeInExpo((t*2)-d, b+c/2, c/2, d);
		},	
		easeInCirc: function(t, b, c, d) {
			return -c *(Math.sqrt(1 -(t/=d)*t) - 1) + b;
		},	
		easeOutCirc: function(t, b, c, d) {
			return c * Math.sqrt(1 -(t=t/d-1)*t) + b;
		},	
		easeInOutCirc: function(t, b, c, d) {
			if((t/=d/2) < 1) return -c/2 *(Math.sqrt(1 - t*t) - 1) + b;
			return c/2 *(Math.sqrt(1 -(t-=2)*t) + 1) + b;
		},	
		easeOutInCirc: function(t, b, c, d) {
			if(t < d/2) return this.easeOutCirc(t*2, b, c/2, d);
			return this.easeInCirc((t*2)-d, b+c/2, c/2, d);
		},	
		easeInElastic: function(t, b, c, d, a, p) {
			var s;
			if(t==0) return b;  if((t/=d)==1) return b+c;  if(!p) p=d*.3;
			if(!a || a < Math.abs(c)) { a=c; s=p/4; } else s = p/(2*Math.PI) * Math.asin(c/a);
			return -(a*Math.pow(2,10*(t-=1)) * Math.sin((t*d-s)*(2*Math.PI)/p )) + b;
		},	
		easeOutElastic: function(t, b, c, d, a, p) {
			var s;
			if(t==0) return b;  if((t/=d)==1) return b+c;  if(!p) p=d*.3;
			if(!a || a < Math.abs(c)) { a=c; s=p/4; } else s = p/(2*Math.PI) * Math.asin(c/a);
			return(a*Math.pow(2,-10*t) * Math.sin((t*d-s)*(2*Math.PI)/p ) + c + b);
		},	
		easeInOutElastic: function(t, b, c, d, a, p) {
			var s;
			if(t==0) return b;  if((t/=d/2)==2) return b+c;  if(!p) p=d*(.3*1.5);
			if(!a || a < Math.abs(c)) { a=c; s=p/4; }	   else s = p/(2*Math.PI) * Math.asin(c/a);
			if(t < 1) return -.5*(a*Math.pow(2,10*(t-=1)) * Math.sin((t*d-s)*(2*Math.PI)/p )) + b;
			return a*Math.pow(2,-10*(t-=1)) * Math.sin((t*d-s)*(2*Math.PI)/p )*.5 + c + b;
		},	
		easeOutInElastic: function(t, b, c, d, a, p) {
			if(t < d/2) return this.easeOutElastic(t*2, b, c/2, d, a, p);
			return this.easeInElastic((t*2)-d, b+c/2, c/2, d, a, p);
		},	
		easeInBack: function(t, b, c, d, s) {
			if(s == undefined) s = 1.70158;
			return c*(t/=d)*t*((s+1)*t - s) + b;
		},	
		easeOutBack: function(t, b, c, d, s) {
			if(s == undefined) s = 1.70158;
			return c*((t=t/d-1)*t*((s+1)*t + s) + 1) + b;
		},	
		easeInOutBack: function(t, b, c, d, s) {
			if(s == undefined) s = 1.70158;
			if((t/=d/2) < 1) return c/2*(t*t*(((s*=(1.525))+1)*t - s)) + b;
			return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
		},	
		easeOutInBack: function(t, b, c, d, s) {
			if(t < d/2) return this.easeOutBack(t*2, b, c/2, d, s);
			return this.easeInBack((t*2)-d, b+c/2, c/2, d, s);
		},	
		easeInBounce: function(t, b, c, d) {
			return c - this.easeOutBounce(d-t, 0, c, d) + b;
		},	
		easeOutBounce: function(t, b, c, d) {
			if((t/=d) <(1/2.75)) {
				return c*(7.5625*t*t) + b;
			} else if(t <(2/2.75)) {
				return c*(7.5625*(t-=(1.5/2.75))*t + .75) + b;
			} else if(t <(2.5/2.75)) {
				return c*(7.5625*(t-=(2.25/2.75))*t + .9375) + b;
			} else {
				return c*(7.5625*(t-=(2.625/2.75))*t + .984375) + b;
			}
		},	
		easeInOutBounce: function(t, b, c, d) {
			if(t < d/2) return this.easeInBounce(t*2, 0, c, d) * .5 + b;
			else return this.easeOutBounce(t*2-d, 0, c, d) * .5 + c*.5 + b;
		},	
		easeOutInBounce: function(t, b, c, d) {
			if(t < d/2) return this.easeOutBounce(t*2, b, c/2, d);
			return this.easeInBounce((t*2)-d, b+c/2, c/2, d);
		}
};
exports.EasingFunctions = EasingFunctions;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Action'] = function(){var exports = $MODULE_REGISTRY['Code/Action'] || {}; $MODULE_REGISTRY['Code/Action'] = exports; 
var __dirname = 'Code';
var __filename = 'Code/Action.js';

exports.Action =
{
    ActionManager: require( 'Code/Action/ActionManager' ).ActionManager,
    RepeatForever: require( 'Code/Action/Action' ).RepeatForever,
    Sequence: require( 'Code/Action/IntervalAction' ).Sequence,
    MoveTo: require( 'Code/Action/IntervalAction' ).MoveTo,
    MoveBy: require( 'Code/Action/IntervalAction' ).MoveBy,
    ScaleTo: require( 'Code/Action/IntervalAction' ).ScaleTo,
    ScaleBy: require( 'Code/Action/IntervalAction' ).ScaleBy,
    RotateTo: require( 'Code/Action/IntervalAction' ).RotateTo,
    FadeIn: require( 'Code/Action/IntervalAction' ).FadeIn,
    FadeOut: require( 'Code/Action/IntervalAction' ).FadeOut,
    ClipTo: require( 'Code/Action/IntervalAction' ).ClipTo,
    DelayTime: require( 'Code/Action/IntervalAction' ).DelayTime,
    Show: require( 'Code/Action/InstantAction' ).Show,
    Hide: require( 'Code/Action/InstantAction' ).Hide,
    CallFunc: require( 'Code/Action/InstantAction' ).CallFunc,

    EasingFunctions: require( 'Code/Action/EaseAction' ).EasingFunctions,

    EaseInQuad: require( 'Code/Action/EaseAction' ).EaseInQuad,
    EaseOutQuad: require( 'Code/Action/EaseAction' ).EaseOutQuad,
    EaseInOutQuad: require( 'Code/Action/EaseAction' ).EaseInOutQuad,
    EaseInCubic: require( 'Code/Action/EaseAction' ).EaseInCubic,
    EaseOutCubic: require( 'Code/Action/EaseAction' ).EaseOutCubic,
    EaseInOutCubic: require( 'Code/Action/EaseAction' ).EaseInOutCubic,
    EaseOutInCubic: require( 'Code/Action/EaseAction' ).EaseOutInCubic,
    EaseInQuart: require( 'Code/Action/EaseAction' ).EaseInQuart,
    EaseOutQuart: require( 'Code/Action/EaseAction' ).EaseOutQuart,
    EaseInOutQuart: require( 'Code/Action/EaseAction' ).EaseInOutQuart,
    EaseOutInQuart: require( 'Code/Action/EaseAction' ).EaseOutInQuart,
    EaseInQuint: require( 'Code/Action/EaseAction' ).EaseInQuint,
    EaseOutQuint: require( 'Code/Action/EaseAction' ).EaseOutQuint,
    EaseInOutQuint: require( 'Code/Action/EaseAction' ).EaseInOutQuint,
    EaseOutInQuint: require( 'Code/Action/EaseAction' ).EaseOutInQuint,
    EaseInSine: require( 'Code/Action/EaseAction' ).EaseInSine,
    EaseOutSine: require( 'Code/Action/EaseAction' ).EaseOutSine,
    EaseInOutSine: require( 'Code/Action/EaseAction' ).EaseInOutSine,
    EaseOutInSine: require( 'Code/Action/EaseAction' ).EaseOutInSine,
    EaseInExpo: require( 'Code/Action/EaseAction' ).EaseInExpo,
    EaseOutExpo: require( 'Code/Action/EaseAction' ).EaseOutExpo,
    EaseInOutExpo: require( 'Code/Action/EaseAction' ).EaseInOutExpo,
    EaseOutInExpo: require( 'Code/Action/EaseAction' ).EaseOutInExpo,
    EaseOutCirc: require( 'Code/Action/EaseAction' ).EaseOutCirc,
    EaseInOutCirc: require( 'Code/Action/EaseAction' ).EaseInOutCirc,
    EaseOutInCirc: require( 'Code/Action/EaseAction' ).EaseOutInCirc,
    EaseInElastic: require( 'Code/Action/EaseAction' ).EaseInElastic,
    EaseOutElastic: require( 'Code/Action/EaseAction' ).EaseOutElastic,
    EaseInOutElastic: require( 'Code/Action/EaseAction' ).EaseInOutElastic,
    EaseOutInElastic: require( 'Code/Action/EaseAction' ).EaseOutInElastic,
    EaseInBack: require( 'Code/Action/EaseAction' ).EaseInBack,
    EaseOutBack: require( 'Code/Action/EaseAction' ).EaseOutBack,
    EaseInOutBack: require( 'Code/Action/EaseAction' ).EaseInOutBack,
    EaseOutInBack: require( 'Code/Action/EaseAction' ).EaseOutInBack,
    EaseInBounce: require( 'Code/Action/EaseAction' ).EaseInBounce,
    EaseOutBounce: require( 'Code/Action/EaseAction' ).EaseOutBounce,
    EaseInOutBounce: require( 'Code/Action/EaseAction' ).EaseInOutBounce,
    EaseOutInBounce: require( 'Code/Action/EaseAction' ).EaseOutInBounce,
};

/** Node+Action function prototypes */
GL2.Node.prototype.runAction = function( /* Action.Action */action )
{
    Action.ActionManager.addAction( action, this );
};

GL2.Node.prototype.stopAllActions = function()
{
    Action.ActionManager.removeAllActionsFromTarget( this );
};

GL2.Node.prototype.numberOfRunningActions = function()
{
    return Action.ActionManager.numberOfRunningActions( this );
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Animation/FightAnimation'] = function(){var exports = $MODULE_REGISTRY['Code/Animation/FightAnimation'] || {}; $MODULE_REGISTRY['Code/Animation/FightAnimation'] = exports; 
var __dirname = 'Code/Animation';
var __filename = 'Code/Animation/FightAnimation.js';

exports.FightAnimation      = Core.Class.subclass
({
    classname               : "FightAnimation",
    
    FIGHT                   : 0,
    SHOOT                   : 1,
    MANEUVER                : 2,
    ABILITY_ENEMY           : 3,
    ABILITY_PLAYER          : 4,
    DEAD                    : 5,
    BONUS_X2_ENEMY          : 6,
    BONUS_X3_ENEMY          : 7,
    BONUS_X2_PLAYER         : 8,
    BONUS_X3_PLAYER         : 9,
    MAX_LEVEL_ENEMY         : 10,
    MAX_LEVEL_PLAYER        : 11,
    DELAY                   : 12,
    
    COALLITION              : 1,
    SWARM                   : 2,
    ELDERS                  : 3,
    
    
    initialize              : function()
    {
        this.m_animationQueue       = [];
        this.m_nextAnim             = 0;
        
        this.m_animExecIndex        = 0;
        
        this.m_callback             = null;
        
        this.m_animationDidFinish   = false;
    },
    
    addAnimationFor         : function( type, raceType, originCard, destinationUnit, destinationCards, destinationHPBars, damagePercent, withSkill)
    {
        info("FightAnimation.addAnimationFor > type : "+type);
        
        if( type == FightAnimation.DELAY )
        {
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.DelayTime.actionWithDuration(1),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
        
        if( type == FightAnimation.BONUS_X2_PLAYER )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "bonus_x2_blue.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
        
        if( type == FightAnimation.BONUS_X3_PLAYER )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "bonus_x3_blue.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
        
        if( type == FightAnimation.BONUS_X2_ENEMY )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "bonus_x2_red.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
        
        if( type == FightAnimation.BONUS_X3_ENEMY )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "bonus_x3_red.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
        
        if( type == FightAnimation.MAX_LEVEL_ENEMY )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "bonus_maxlvl.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }

        if( type == FightAnimation.MAX_LEVEL_PLAYER )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "bonus_maxlvl.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }

        
        if( type == FightAnimation.FIGHT || type == FightAnimation.MANEUVER )
        {
            var originFrame             = originCard.getFrame().clone();
            var destinationFrame        = destinationUnit.getFrame().clone();
            
            var parentFrame             = originCard.getParent().getFrame().clone();
                        
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : originCard,
                    "animation"     : Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration(0.05),
                            Action.EaseInCubic.actionWithAction(
                                    Action.MoveTo.actionWithDuration(0.13, new Core.Point( destinationFrame._origin._x + destinationFrame._size._width/2 - parentFrame._size._width/2, destinationFrame._origin._y + destinationFrame._size._height/2 - parentFrame._size._height/2))
                            ),
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                    )
            };
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : destinationCards[0],
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                            Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "hit_melee.png", destinationFrame, originCard.getParent())),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(10,10)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(-10,-10))
                    )
            };
            
            if( destinationCards[1] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationCards[1],
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(10,10)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-10,-10))
                        )
                };
            }
            
            if( destinationCards[2] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationCards[2],
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.CallFunc.actionWithTarget(this, function(){SoundManager.playSound(SoundManager.MELEE_HIT1);}),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(10,10)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),  
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-10,-10))
                        )
                };
            }
                        
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : destinationHPBars[0].foreground,
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                            Action.ScaleTo.actionWithDuration(  0.05, 
                                                                1-damagePercent[0],
                                                                destinationHPBars[0].foreground._scale._y 
                                                            )
                    )
            };
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : destinationHPBars[0].foreground2,
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                            Action.ScaleTo.actionWithDuration(  0.5, 
                                                                1-damagePercent[0],
                                                                destinationHPBars[0].foreground2._scale._y 
                                                            )
                    )
            };
            
            if( destinationHPBars[1] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[1].foreground,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.05, 
                                                                    1-damagePercent[1],
                                                                    destinationHPBars[1].foreground._scale._y 
                                                                )
                        )   
                };
                        
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[1].foreground2,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.5, 
                                                                    1-damagePercent[1],
                                                                    destinationHPBars[1].foreground2._scale._y 
                                                                )
                        )
                };
            }
            
            if( destinationHPBars[2] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[2].foreground,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.05, 
                                                                    1-damagePercent[2],
                                                                    destinationHPBars[2].foreground._scale._y 
                                                                )
                        )
                };
            
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[2].foreground2,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.5, 
                                                                    1-damagePercent[2],
                                                                    destinationHPBars[2].foreground2._scale._y 
                                                                )
                        )
                };
            }
            
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : originCard,
                    "animation"     : Action.Sequence.actions(
                            Action.EaseOutCubic.actionWithAction(
                                    Action.MoveTo.actionWithDuration(0.13, new Core.Point( originFrame._origin._x + originFrame._size._width/2 - parentFrame._size._width/2, originFrame._origin._y + originFrame._size._height/2 - parentFrame._size._height/2))
                            ),
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                    )
            };
        }
        
        if(type == FightAnimation.SHOOT)
        {
            var originFrame             = originCard.getFrame().clone();
            var destinationFrame        = destinationUnit.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            var radAngle                = Math.atan2(destinationUnit._position._y - originCard._position._y, destinationUnit._position._x - originCard._position._x);
            
            var angle                   = radAngle*180/Math.PI + 90;
            
            
            var beamName                = "";
            var shootName               = "";
            var hitName                 = "";
            var hitSound                = null;
            
            if( raceType == FightAnimation.COALLITION )
            {
                beamName                = "coallition_bullet.png";
                shootName               = "coallition_shoot.png";
                hitName                 = "coallition_hit.png";
                hitSound                = SoundManager.HUMAN_SHOT1;
            }
            else if( raceType == FightAnimation.SWARM )
            {
                beamName                = "swarm_bullet.png";
                shootName               = "swarm_shoot.png";
                hitName                 = "swarm_hit.png";
                hitSound                = Math.floor( Math.random() * 2 ) >= 1 ? SoundManager.ELDER_SHOT1 : SoundManager.ELDER_SHOT2;
            }
            else if( raceType == FightAnimation.ELDERS )
            {
                beamName                = "elder_bullet.png";
                shootName               = "elder_shoot.png";
                hitName                 = "elder_hit.png";
                hitSound                = Math.floor( Math.random() * 2 ) >= 1 ? SoundManager.SWARM_SHOT1 : SoundManager.SWARM_SHOT2;
            }
                        
            var beamSprite              = this.startAnimation(beamName, new Core.Rect(0,0,100,112), originCard.getParent(), true, angle);
            beamSprite.setPosition(originCard.getPosition());
            beamSprite.setAlpha(0);
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : beamSprite,
                    "animation"     : Action.Sequence.actions(
                        Action.DelayTime.actionWithDuration(0.1),
                        Action.FadeIn.actionWithDuration(0.02),
                        Action.CallFunc.actionWithTarget(this, function(){SoundManager.playSound( hitSound );}),
                        Action.CallFunc.actionWithTarget(this, this.makeShootingAnim.bind(this, shootName, angle, originCard)),
                        Action.MoveTo.actionWithDuration(0.15, new Core.Point( destinationFrame._origin._x + destinationFrame._size._width/2 - parentFrame._size._width/2, destinationFrame._origin._y + destinationFrame._size._height/2 - parentFrame._size._height/2)),
                        Action.CallFunc.actionWithTarget(this, this.destroySprite.bind(this, beamSprite)),
                        Action.CallFunc.actionWithTarget(this, function(){SoundManager.playSound( SoundManager.CANNON_HIT );}),
                        Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                    )
            };
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : destinationCards[0],
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                            Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, hitName, destinationFrame, originCard.getParent())),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(10,10)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                            Action.MoveBy.actionWithDuration(0.05, new Core.Point(-10,-10))
                    )
            };
            
            if( destinationCards[1] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationCards[1],
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(10,10)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-10,-10))
                        )
                };
            }
            
            if( destinationCards[2] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationCards[2],
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(10,10)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-20,-20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(20,20)),
                                Action.MoveBy.actionWithDuration(0.05, new Core.Point(-10,-10))                        )
                };
            }
                       
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : destinationHPBars[0].foreground,
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                            Action.ScaleTo.actionWithDuration(  0.05, 
                                                                1-damagePercent[0],
                                                                destinationHPBars[0].foreground._scale._y 
                                                            )
                    )
            };
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : destinationHPBars[0].foreground2,
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                            Action.ScaleTo.actionWithDuration(  0.5, 
                                                                1-damagePercent[0],
                                                                destinationHPBars[0].foreground2._scale._y 
                                                            )
                    )
            };
            
            if( destinationHPBars[1] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[1].foreground,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.05, 
                                                                    1-damagePercent[1],
                                                                    destinationHPBars[1].foreground._scale._y 
                                                                )
                        )
                };
            
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[1].foreground2,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.5, 
                                                                    1-damagePercent[1],
                                                                    destinationHPBars[1].foreground2._scale._y 
                                                                )
                        )
                };
            }
            
            if( destinationHPBars[2] )
            {
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[2].foreground,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.05, 
                                                                    1-damagePercent[2],
                                                                    destinationHPBars[2].foreground._scale._y 
                                                                )
                        )
                };
            
            
                this.m_animationQueue[this.m_nextAnim++]    = {
                        "actor"         : destinationHPBars[2].foreground2,
                        "animation"     : Action.Sequence.actions(
                                Action.CallFunc.actionWithTarget(this, this.executeFightAnimation),
                                Action.ScaleTo.actionWithDuration(  0.5, 
                                                                    1-damagePercent[2],
                                                                    destinationHPBars[2].foreground2._scale._y 
                                                                )
                        )
                };
            }
            
            
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : originCard,
                    "animation"     : Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration( 0.15 ),
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                    )
            };

        }

        if( type == FightAnimation.DEAD )
        {
            this.m_animationQueue[this.m_nextAnim++]    = {
                    "actor"         : originCard,
                    "animation"     : Action.Sequence.actions(
                            Action.CallFunc.actionWithTarget(this, this.fadeKOCard.bind(this, originCard)),
                            Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                    )
            };

        }
    },
    
    addAbilityAnim                  : function( type, originCard, abilityFrame, abilityLabel, abilityDescription)
    {
        if( type == FightAnimation.ABILITY_PLAYER )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "ability_blue.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.DelayTime.actionWithDuration(0.3),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : abilityFrame,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.changeAbilityDescription.bind( this, abilityLabel, abilityDescription )),
                    Action.FadeIn.actionWithDuration( 0.10 ),
                    Action.DelayTime.actionWithDuration( 1 ),
                    Action.FadeOut.actionWithDuration( 0.10 ),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
        
        if( type == FightAnimation.ABILITY_ENEMY )
        {
            var originFrame             = originCard.getFrame().clone();
            var parentFrame             = originCard.getParent().getFrame().clone();
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : originCard,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.startAnimation.bind(this, "ability_red.png", new Core.Rect(
                                            0,
                                            0,
                                            100,112), originCard.getParent(), false, null, originCard._position )),
                    Action.DelayTime.actionWithDuration(0.3),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
            
            this.m_animationQueue[ this.m_nextAnim++ ]  = {
                "actor"             : abilityFrame,
                "animation"         : Action.Sequence.actions(
                    Action.CallFunc.actionWithTarget(this, this.changeAbilityDescription.bind( this, abilityLabel, abilityDescription )),
                    Action.FadeIn.actionWithDuration( 0.10 ),
                    Action.DelayTime.actionWithDuration( 1 ),
                    Action.FadeOut.actionWithDuration( 0.10 ),
                    Action.CallFunc.actionWithTarget(this, this.executeFightAnimation)
                )
            }
        }
    },
    
    changeAbilityDescription        : function( abilityLabel , abilityDescription)
    {
        abilityLabel.setText( abilityDescription );
    },
    
    makeShootingAnim                : function(shootName, angle, originCard)
    {
        if(originCard)
        {
            var shootingSprite          = this.startAnimation(shootName, new Core.Rect(0, 0 ,100,112), originCard.getParent(), false, angle );
            
            if( shootingSprite )
            {
                shootingSprite.setPosition(originCard.getPosition());
            }
        }
    },
    
    fadeKOCard                      : function(sprite)
    {
        sprite.setAlpha(0.4);
    },
    
    destroySprite                   : function(sprite)
    {
        if( sprite && sprite.__objectRegistryId )
        {
            sprite.destroy();
        }
    },
    
    setFinishedAnimationCallback    : function(cb)
    {
        this.m_callback             = cb;
    },
    
    executeFightAnimation           : function()
    {
        if( this.m_animationDidFinish )
        {
            warn("FightAnimation.executeAnimation animation finished, not following next animation in queue");
            return;
        }
        
        if(!this.m_animationQueue[this.m_animExecIndex])
        {
            info("FightAnimation.executeFightAnimation > Battle animation finished");
            if(this.m_callback)
            {
                this.m_callback();
            }
            return;
        }
        var animation               = this.m_animationQueue[this.m_animExecIndex].animation;
        var actor                   = this.m_animationQueue[this.m_animExecIndex].actor;
        
        this.m_animExecIndex++;
        
        actor.runAction(animation);
    },
    
    startAnimation           : function(animation ,frame, parent, loopEnabled, angle, position)
    {
        if(!parent)
        {
            //FIGHT NO LONGER RUNNING, STOPING
            return;
        }
        
        var anim            = new GL2.Sprite();
        parent.addChild(anim);
        
        var animAnimation   = ResourceManager.getAnimationFor(animation);
        if(loopEnabled)
            animAnimation.setLoopingEnabled(loopEnabled);
        else
            animAnimation.setLoopingEnabled(false);
        
        if(frame)
            anim.setFrame(frame);
        
        anim.setAnimation(animAnimation);
        
        anim.getAnimationCompleteEmitter().addListener(new Core.MessageListener(), this.destroySprite.bind(this, anim));
        
        if(angle)
            anim.setRotation(angle);
            
        if(position)
            anim.setPosition( position );
            
        anim.setDepth(FightScene.EFFECT);
                
        return anim;
    },
    
    cutFightAnimation       : function()
    {
        this.m_animationDidFinish   = true;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Bank/PaymentController'] = function(){var exports = $MODULE_REGISTRY['Code/Bank/PaymentController'] || {}; $MODULE_REGISTRY['Code/Bank/PaymentController'] = exports; 
var __dirname = 'Code/Bank';
var __filename = 'Code/Bank/PaymentController.js';

/**
 * Mobage payment controller class. Allows to perform payments using the Mobage
 * banking API. Allows up to 1 concurrent payment.
 */
exports.PaymentController = Core.Class.subclass( {

    classname : "PaymentController",

    onClose : null,
    onProcess : null,
    onError : null,

    initialize : function( onClose, onProcess, onError )
    {
        info( "PaymentController.initialize called." );

        var genericCb = function(){};
        this.transactionId = "";
        if( onClose )
        {
            this.onClose = onClose;
        }
        else
        {
            this.onClose = genericCb;
        }

        if( onProcess )
        {
            this.onProcess = onProcess;
        }
        else
        {
            this.onProcess = genericCb;
        }

        if( onError )
        {
            this.onError = onError;
        }
        else
        {
            this.onError = genericCb;
        }
    },

    /**
     * Attemps to buy 1 item, given its Stock-keeping Unit code
     *
     * @param sku
     *            Stock-keeping Unit (item Id)
     * @param comment
     *            Comment used by the transaction log
     */
    createSimpleTransaction : function( sku, comment, packId, cb, amount )
    {
        info( "PaymentController.createSimpleTransaction called. sku=%s, packId=%s, amount=%s, comment=%s",
            sku, packId, amount, comment );

        if( !amount )
        {
            warn( "PaymentController.createSimpleTransaction Amount not specified! Setting it to amount=1" );
            amount = 1;
        }

        this.createTransaction( [
            {
                'item' : {
                    'id' : sku
                },
                'quantity' : amount
            }
        ], comment );


        this.transactionCreatedCallback = cb;
        this.packId = packId;
    },

    /**
     * Attemps to buy one or more items in any given quantity.
     *
     * @param billingItems
     *            Items array (see Bank.Debit.createTransaction for details)
     * @param comment
     *            Comment used by the transaction log
     */
    createTransaction : function( billingItems, comment )
    {
        info( "PaymentController.createTransaction called. billingItems=%s, comment=%s", JSON.stringify( billingItems ), comment );

        // Creation response handler
        var onCreateResponse = function( error, transaction )
        {
            info( "PaymentController.createTransaction.onCreateResponse called." );

            if( error || !transaction )
            {
                warn( "PaymentController.createTransaction.onResponse: Error creating transaction. Error: " + JSON.stringify( error ) );
                Xib.Navigation.removeModalOverlay();
                this.onError( error, transaction );
            }
            else
            {
                // Opening response handler
                var onOpenResponse = function( _error, _transaction )
                {
                    info( "PaymentController.createTransaction.onCreateResponse.onOpenResponse called." );

                    if( _error || !_transaction )
                    {
                        err( "PaymentController.createTransaction.onOpenResponse: Error opening transaction. _error=%s", JSON.stringify( _error ) );
                        Bank.Debit.cancelTransaction( this.transactionId, this.onError );
                    }
                    else
                    {
                        if( this.onProcess )
                        {
                            this.onProcess( _transaction );
                        }
                        else
                        {
                            warn( "PaymentController.createTransaction.onOpenResponse: No processing callback found." );
                        }
                    }
                };

                // Call
                this.transactionId = transaction.id;
                info( "PaymentController.createTransaction.onOpenResponse transaction=%s", JSON.stringify( transaction ) );
                info( "PaymentController.createTransaction.onOpenResponse transactionId=%s", this.transactionId );

                //console.log("PaymentController. calling Callback");
                //Bank.Debit.openTransaction(this.transactionId, onOpenResponse.bind(this));

                if( this.transactionCreatedCallback )
                {
                    this.transactionCreatedCallback( this.packId, this.transactionId );
                }
            }
        };

        try
        {
            Bank.Debit.createTransaction( billingItems, comment, onCreateResponse.bind( this ) );
        }
        catch( exception )
        {
            err( "PaymentController.createTransaction Error while creating transaction. exception=%s", JSON.stringify( exception ) );
        }
    },

    /**
     * Attemps to close a transaction
     *
     * @param transaction
     *            The transaction to close
     */
    closeTransaction : function( transaction )
    {
        info( "PaymentController.closeTransaction transaction=%s", JSON.stringify( transaction ) );

        // Response handler
        var onResponse = function( error, transaction )
        {
            info( "PaymentController.closeTransaction.onResponse called. transaction=%s", JSON.stringify( transaction ) );

            if( !error )
            {
                if( transaction )
                {
                    // Transaction successful
                    this.onClose( transaction );
                }
                else
                {
                    this.onError( null, transaction );
                }
            }
            else
            {
                err( "PaymentController.closeTransaction.onResponse Error closing transaction. error=%s", JSON.stringify( error ) );
                Bank.Debit.cancelTransaction( this.transactionId, this.onError );
            }
        };

        // Call
        if( transaction )
        {
            Bank.Debit.closeTransaction( transaction.id, onResponse.bind( this ) );
        }
        else
        {
            warn( "PaymentController.closeTransaction Warning, no transaction found." );
        }
    },

    /**
     * Cancels existing transactions
     */
    $cancelPendingTransactions : function()
    {
        info( "PaymentController.cancelPendingTransactions called." );
        var onResponse = function( error, transactions )
        {
            info( "PaymentController.cancelPendingTransactions.onResponse called." );
            var transaction, i;
            for( i in transactions )
            {
                transaction = transactions[i];
                info( "PaymentController.cancelPendingTransactions.onResponse Cancelling transaction i=%s, transaction=%s", i, JSON.stringify( transaction ) );

                Bank.Debit.cancelTransaction( transaction,
                    function( error, transaction )
                    {
                        info( "PaymentController.cancelPendingTransactions.onResponse._onResponse called." );
                    }.bind( this )
                );
            }
        };

        Bank.Debit.getPendingTransactions( onResponse.bind( this ) );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Bank/ProductHandler'] = function(){var exports = $MODULE_REGISTRY['Code/Bank/ProductHandler'] || {}; $MODULE_REGISTRY['Code/Bank/ProductHandler'] = exports; 
var __dirname = 'Code/Bank';
var __filename = 'Code/Bank/ProductHandler.js';

exports.ProductHandler      = Core.Class.singleton({
    classname               : "ProductHandler",
    
    initialize              : function()
    {
        this.m_storeProductList     = [
                                           "itemstore_test_product1",
                                           "itemstore_test_product2",
                                           "itemstore_test_product1",
                                           "itemstore_test_product2"
                                       ];
    },
    
    getStoreProductList     : function()
    {
        return this.m_storeProductList;
    },
    
    getItem                 : function(item, cb)
    {
        Bank.Inventory.getItem(item, cb);
    },
    
    buyItem                 : function(item, quantity)
    {
        var billingItems = [{
            "item": {
                  "id": item
                 },
            "quantity": quantity
           }
        ];
        
        var paymentController       = new PaymentController(this._onCloseCallback.bind(this), this._onProcessCallback.bind(this, item, quantity), this._onErrorCallback.bind(this));
        paymentController.createTransaction(billingItems, "Buying item > "+item);
    },
    
    _onErrorCallback        : function(error, transaction)
    {
        err("ProductHandler._onErrorCallback > error : "+error+"  transaction : "+transaction);
    },
    
    _onCloseCallback        : function(transaction)
    {
        info("ProductHandler._onCloseCallback > Closing transaction : "+transaction);
    },
    
    _onProcessCallback      : function(item, quantity, transaction)
    {
        warn("ProductHandler._onProcessCallback > Processing transaction : "+transaction+" for item : "+item+" quantity : "+quantity);
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/ScreenManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/ScreenManager'] || {}; $MODULE_REGISTRY['Code/Game/ScreenManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/ScreenManager.js';

exports.ScreenManager = Core.Class.singleton(
{
    classname: "ScreenManager",
    m_callback: null,

    initialize: function()
    {
        info( "ScreenManager.initialize called." );
    },

    setBackInfo: function( callback )
    {
        this.m_callback = callback;
    },

    getCallback: function()
    {
        return this.m_callback;
    },

    resetCallBack: function()
    {
        this.m_callback = null;
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GameController'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GameController'] || {}; $MODULE_REGISTRY['Code/Game/GameController'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/GameController.js';

exports.GameController = Core.Class.singleton(
{
    classname: "GameController",

    initialize: function()
    {
        info( "GameController initializing" );

        this.m_emitter          = new Core.MessageListener();
        this.m_background       = new Background();
        this.m_loadingScreen    = new LoadingScreen();
        this.m_tutorialScreen   = null;

        Core.UpdateEmitter.addListener( this.m_emitter, this.updateLoadingScreen.bind( this ) );

        Xib.Navigation.setModalOverlay( this.m_loadingScreen, false );

        // Cancel Pending transactions
        // PaymentController.cancelPendingTransactions();

        // Start Resource manager and Manifest manager
        ResourceManager.instantiate();

        /**
         * Initialize the card manager
         */
        CardsManager.instantiate();

        this.preloadXib();
    },

    getLoadingScreen: function()
    {
        return this.m_loadingScreen;
    },

    removeLoadingScreen: function()
    {
        info( "GameController.removeLoadingScreen called." );
//        Core.UpdateEmitter.removeListener( this.m_emitter );
//        this.m_loadingScreen = null;
//        Xib.Navigation.removeModalOverlay();
//        GL2.Root.addChild( background );
    },


    playBgMusic: function()
    {
        SoundManager.setMusicEnabled( true, SoundManager.BG_MUSIC_NORMAL );
    },

    updateLoadingScreen: function()
    {
        if( ResourceManager.m_currentManifest )
        {
            if( ResourceManager.m_manifestProgress[ResourceManager.m_currentManifest] >= 0 && ResourceManager.m_manifestProgress[ResourceManager.m_currentManifest] <= 100 )
            {
                this.m_loadingScreen.updateActualProgressBar( ResourceManager.m_manifestProgress[ResourceManager.m_currentManifest] );
            }
        }
    },

    LoadInitialScreen: function()
    {
        info( "GameController.LoadInitialScreen called." );

        this.m_mainScreen = new MainScreen();
       
        Xib.Navigation.removeModalOverlay();
        this.m_background.setBackgrounds();
        
        Xib.Navigation.presentOverlayView( this.m_mainScreen, false, false );
    },

    setTutorialScreen: function( tutorialScreen )
    {
        this.m_tutorialScreen = tutorialScreen;
    },

    getTutorialScreen: function()
    {
        return this.m_tutorialScreen; 
    },

    getMainScreen: function()
    {
        return this.m_mainScreen;
    },

    preloadXib: function()
    {
        Loader.addXibToCache( "./Content/Xib/TutorialLayerUI.xib" );
        Loader.addXibToCache( "./Content/Xib/MainScreen.xib" );
        Loader.addXibToCache( "./Content/Xib/CardFusionBaseSelection.xib" );
        Loader.addXibToCache( "./Content/Xib/CardFusionMaterialSelection.xib" );
        Loader.addXibToCache( "./Content/Xib/CardFusionMenu.xib" );
        Loader.addXibToCache( "./Content/Xib/CardFusionAnimation.xib" );
        Loader.addXibToCache( "./Content/Xib/ComboBoxCell.xib" );
        Loader.addXibToCache( "./Content/Xib/ComboBoxTable.xib" );
        Loader.addXibToCache( "./Content/Xib/ComboBox.xib" );

        Loader.addXibToCache( "./Content/Xib/CardCollectionUI.xib" );
        Loader.addXibToCache( "./Content/Xib/CardScreen.xib" );
        Loader.addXibToCache( "./Content/Xib/DeckCategoryInfo.xib" );
        Loader.addXibToCache( "./Content/Xib/DeckManagerUI.xib" );
        Loader.addXibToCache( "./Content/Xib/ExplorationProgressBar.xib" );
        Loader.addXibToCache( "./Content/Xib/ExplorationScreenAnimated.xib" );
        Loader.addXibToCache( "./Content/Xib/ExplorationScreenProgressBar.xib" );
        Loader.addXibToCache( "./Content/Xib/ExplorationSelection.xib" );
        Loader.addXibToCache( "./Content/Xib/ItemDeckCategoryEdit.xib" );
        Loader.addXibToCache( "./Content/Xib/ItemStore.xib" );
        Loader.addXibToCache( "./Content/Xib/ItemStoreElement.xib" );
        Loader.addXibToCache( "./Content/Xib/MissionSelectionScreen.xib" );
        Loader.addXibToCache( "./Content/Xib/MissionSelectionScreenNoBoss.xib" );
        Loader.addXibToCache( "./Content/Xib/VersusBattleFight.xib" );
        Loader.addXibToCache( "./Content/Xib/VersusBattleMain.xib" );
        Loader.addXibToCache( "./Content/Xib/GiftStorage.xib" );
        Loader.addXibToCache( "./Content/Xib/RewardList.xib" );
        // Loader.addXibToCache( "./Content/Xib/RewardStage.xib" );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/User'] = function(){var exports = $MODULE_REGISTRY['Code/Game/User'] || {}; $MODULE_REGISTRY['Code/Game/User'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/User.js';

exports.User = Core.Class.singleton(
{
    classname: "User",

    m_dummyUserQuestsData:
    {
        "missionsState": [
        {
            "missionId": 40010101,
            "progress": 1,
            "rewards": [
            {
                "type": "card",
                "value": 11000212
            },
            {
                "type": "card",
                "value": 11000211
            } ],
            "roundNumber": 4,
            "worldId": 1
        },
        {
            "missionId": 40010102,
            "progress": 1,
            "rewards": [
            {
                "type": "card",
                "value": 12000091
            },
            {
                "type": "card",
                "value": 11000031
            } ],
            "roundNumber": 4,
            "worldId": 1
        },
        {
            "missionId": 40010103,
            "progress": 1,
            "rewards": [
            {
                "type": "card",
                "value": 12000012
            },
            {
                "type": "card",
                "value": 12000011
            } ],
            "roundNumber": 4,
            "worldId": 1
        },
        {
            "missionId": 40010104,
            "progress": 1,
            "rewards": [
            {
                "type": "card",
                "value": 12000112
            },
            {
                "type": "card",
                "value": 11000031
            } ],
            "roundNumber": 4,
            "worldId": 1
        },
        {
            "missionId": 40010105,
            "progress": 1,
            "rewards": [
            {
                "type": "card",
                "value": 11000013
            },
            {
                "type": "card",
                "value": 11000051
            } ],
            "roundNumber": 4,
            "worldId": 1
        } ]
    },

    updateMainStats : function()
    {
        var callback = function( error, data )
        {
            if( error )
            {
                err( "User.updateMainStats._innerCallback Error. error=%s", JSON.stringify( error ) );
                return;
            }

            if( data )
            {
                info( "User.updateMainStats._innerCallback data=%s", data );
                var _data = JSON.parse( data );
                this.setCurrency( _data.currency );
                this.setExploreEnergy( _data.exploreEnergy );
                this.setBattleEnergy( _data.battleEnergy );
                this.setXP( _data.xp );
            }
        };
        Server.getMainStats( callback.bind( this ) );
    },

    setGashaPoints: function( value )
    {
        this.m_gashaPoints = value;
    },

    // TODO FIXME: This has the device hardcoded for Android
    getAnalyticsPlayerState: function()
    {
        var data = {
            dv_t        : 2,   // Device Type (1: FP, 2: Android, 3: iOS)
            reg_at      : 0,   // Game Registration Time (unix time)
            aff_code    : 0,   // Registration Path
            sid         : 0,   // Session ID
            level       : 0,   // Level
            rank        : 0,   // Rank (Grade)
            xp          : 0,   // XP
            al_num      : 0,   // # of Friends
            en          : 0,   // remained Energy
            sta         : 0,   // remained Battle Energy
            gold        : 0,   // Gold
            dp          : 0    // Gacha Pt
        };

        data.reg_at     = "";                       // TODO
        data.aff_code   = "";                       // TODO
        data.sid        = "";                       // TODO
        data.level      = this.m_userLevel;
        data.rank       = -1;
        data.xp         = this.m_userXP;
        data.al_num     = -1;
        data.en         = this.m_exploreEnergy;
        data.sta        = this.m_battleEnergy;
        data.gold       = this.m_currency;
        data.dp         = this.m_gashaPoints;

        return data;
    },

    initialize: function( callback )
    {
        info( "User.initialize called." );

        this.m_gamerTag = null;
        this.m_userId = null;
        this.m_user = null;
        this.m_userData = null;
        this.m_userXP = 0;
        this.m_userLevel = 1;
        this.m_userProgressLevel = 0;
        this.m_levelData = null;
        this.m_currency = null;
        this.m_maxExploreEnergy = null;
        this.m_exploreEnergy = null;
        this.m_maxBattleEnergy = null;
        this.m_battleEnergy = null;
        this.m_NextFreeGashaTime = 0;
        this.m_maxGearCards = 0;
        this.m_maxPilotCards = 0;
        this.m_fellows = null;
        this.m_maxFellows;
        this.m_firstTimePremiumGasha = false;
        this.m_gashaPoints = 0;

        this.m_currentStage = null;

        this.m_currentStage =
        {
            "worldId": -1,
            "stageId": -1
        };
        this.m_medals = {};

        Social.Common.People.getCurrentUser( null, this._getCurrentUserCallback.bind( this, callback ) );
    },

    getCurrentStage: function()
    {
        return this.m_currentStage;
    },

    // info: {"worldId": this.m_currentWorld, "stageId": this.m_currentStage}
    setCurrentStage: function( currentStageInfo )
    {
        this.m_currentStage = currentStageInfo;
        if( TutorialManager.getActiveStateId() == undefined )
        {
            Server.setCurrentStage( this.m_currentStage,
                function()
                {
                }
            );
        }
    },

    mapMedals: function( data )
    {
        info( "User.mapMedals called. data=%s", JSON.stringify( data ) );
        var retValue =
        {};
        for( var i = 0; i < data.length; i++ )
        {
            retValue[data[i].id] = data[i];
        }
        return retValue;
    },

    updateMedalAmount: function( data )
    {
        info("User.updateMedalAmount called. data=%s", JSON.stringify(data));
        this.m_medals = this.mapMedals( data );
    },

    // TODO have actual medals list and get the amount from there
    getGashaCurrencyAmount: function( currencyId )
    {
        return 0;
    },

    getMedalAmount: function( medalId )
    {
        if( this.m_medals[medalId] != undefined )
        {
            return this.m_medals[medalId].amount;
        }
        return 0;
    },

    hasMedals: function()
    {
        var keys = Object.keys( this.m_medals );
        for( var i = 0; i < keys.length; ++i )
        {
            var key = keys[i];
            if( this.m_medals[key] != undefined && this.m_medals[key].amount > 0 )
            {
                return true;
            }
        }
        
        return false;
    },

    getMedals: function()
    {
        return this.m_medals;
    },

    addMedals: function( medalId, amount )
    {
        if( this.m_medals[medalId] == undefined )
        {
            this.m_medals[medalId] = {"id" : medalId, "amount": amount};
        }
        else
        {
            this.m_medals[medalId].amount += amount;
        }
    },

    updatePremiumsBought : function( value )
    {
        info( "User.updatePremiumsBought called. value=%s", value );
        this.m_firstTimePremiumGasha = value;
    },

    _getCurrentUserCallback: function( callback, error, user )
    {
        info( "User._getCurrentUserCallback called." );

        if( error || !user )
        {
            err( "User._getCurrentUserCallback Error, cannot retrieve user data! error=%s", JSON.stringify( error ) );
            callback && callback( false );
        }
        else
        {
            info( "User._getCurrentUserCallback User obtained. user=%s", JSON.stringify( user ) );
            this.m_user = user;
            this.m_userId = user.id;
            this.m_gamerTag = user.nickname;
            Server.instantiate();
        }
    },

    loadLevelListDetails: function( data )
    {
        this.m_levelData = data;
        info( "User.loadLevelListDetails called with data: " + JSON.stringify( data ) );
    },

    getLevel: function()
    {
        info( "User.getLevel called." );

        this.calculateLevel();
        return this.m_userLevel;
    },

    getProgressLevel: function()
    {
        info( "User.getProgressLevel called." );

        this.calculateLevel();
        this.calculateProgressLevel();
        return this.m_userProgressLevel;
    },

    calculateLevel: function()
    {
        info( "User.calculateLevel called." );

        var exp = this.getXP();
        var currentLevel = 2;
        if( this.m_levelData )
        {
            while( this.m_levelData[currentLevel + ""] )
            {
                result = currentLevel;
                if( exp < this.m_levelData[currentLevel + ""].xpRequired )
                {
                    this.m_userLevel = currentLevel - 1;
                    break;
                }
                currentLevel++;
            }
        }

        info( "User.getLevel called, the level of the user is " + this.m_userLevel );
    },

    calculateProgressLevel: function()
    {
        info( "User.calculateProgressLevel called." );

        var level = this.m_userLevel;
        var exp = this.getXP();
        var actualLevelXP;
        if( level == 1 )
        {
            actualLevelXP = 0;
        }
        else
        {
            actualLevelXP = this.m_levelData[level + ""].xpRequired;
        }
        var nextLevel = this.m_levelData[( level + 1 ) + ""];
        if( !nextLevel )
        {
            info( "User.calculateProgressLevel user is in the maximum level" );
            this.m_userProgressLevel = 1;
        }
        var nextLevelXP = nextLevel.xpRequired - actualLevelXP;
        this.m_userProgressLevel = ( exp - actualLevelXP ) / nextLevelXP;
        info( "User.calculateProgressLevel this.m_userProgressLevel=%s, actualLevelXP=%s, nextLevel.xpRequired=%s", this.m_userProgressLevel, actualLevelXP, nextLevel.xpRequired );
    },

    getXPNeededForLevel: function( level )
    {
        if( level == 1 )
        {
            return  0;
        }
        var levelData = this.m_levelData[ level + "" ];
        if( levelData != null )
        {
            return levelData.xpRequired;
        }
        else
        {
            //In case the next level doesn't exists
            return -1;
        }
    },

    setUpManagers: function()
    {
        info( "User.setUpManagers userData: " + JSON.stringify( this.m_userData ) );

        CardsManager.initWithData( this.m_userData.cards, this.m_userData.cardsHistory, this.m_userData.cardsLimbo );
        ItemManager.initWithData( this.m_userData.items );
        DeckManager.initWithData( this.m_userData.decks );
        GiftManager.initWithData( this.m_userData.gifts );
        RewardManager.initWithData( this.m_userData.rewards, this.m_userData.lastRewardsByType );
        QuestManager.initWithData( this.m_userData.missionsState );
        QuestManager.setUpBosses( this.m_userData.completedStages );
        this.m_userXP = this.m_userData.xp;
        this.m_currency = this.m_userData.currency;
        this.m_maxExploreEnergy = this.m_userData.maxExploreEnergy;
        this.m_exploreEnergy = this.m_userData.exploreEnergy;
        this.m_maxBattleEnergy = this.m_userData.maxBattleEnergy;
        this.m_battleEnergy = this.m_userData.battleEnergy;
        this.m_maxGearCards = this.m_userData.maxGearCards;
        this.m_maxPilotCards = this.m_userData.maxPilotCards;
        this.m_currentStage = this.m_userData.currentStage;
        this.m_gashaPoints = this.m_userData.gashaPoints;
        this.m_medals = this.mapMedals( this.m_userData.medals );
        this.m_fellows = this.m_userData.fellows;
        this.m_maxFellows = this.m_userData.maxFellows;
        this.m_firstTimePremiumGasha = this.m_userData.firstTimePremiumGasha;
        this.updateHud();
    },

    updateMissionsState: function( missionsData )
    {
        QuestManager.initWithData( missionsData.missionsState );
        QuestManager.setUpBosses( missionsData.completedStages );
    },

    updateMissionState: function(missionId, data)
    {
        QuestManager.updateMission(data.missionsState);
        QuestManager.setUpBosses(data.completedStages);
    },

    getMaxFellows: function()
    {
        return this.m_maxFellows;
    },

    setMaxFellows: function( val )
    {
        this.m_maxFellows = val;
    },
    
    getMaxPilotCards: function()
    {
        return this.m_maxPilotCards;
    },

    setMaxPilotCards: function( val )
    {
        this.m_maxPilotCards = val;
        this.updateHud();
    },

    getMaxGearCards: function()
    {
        return this.m_maxGearCards;
    },

    setMaxGearCards: function( val )
    {
        this.m_maxGearCards = val;
        this.updateHud();
    },

    getCurrency: function()
    {
        info("User.getCurrency called. this.m_currency=%s", this.m_currency );
        if (this.m_currency < 0)
        {
            this.m_currency = 0;
        }
        return this.m_currency;
    },
    setCurrency: function( value )
    {
        if( value < 0 )
        {
            value = 0;
        }
        this.m_currency = value;
        this.updateHud();
    },
    increaseCurrency: function( value )
    {
        this.m_currency = this.m_currency + value;
        if( this.m_currency < 0 )
        {
            this.m_currency = 0;
        }
        this.updateHud();
    },
    getMaxExplorationEnergy: function()
    {
        return this.m_maxExploreEnergy;
    },
    setMaxExplorationEnergy: function( value )
    {
        this.m_maxExploreEnergy = value;
    },
    increaseMaxExplorationEnergy: function( value )
    {
        this.m_maxExploreEnergy = this.m_maxExploreEnergy + value;
        if( this.m_maxExploreEnergy < 0 )
        {
            this.m_maxExploreEnergy = 0;
        }
        this.updateHud();
    },
    getExploreEnergy: function()
    {
        return this.m_exploreEnergy;
    },
    setExploreEnergy: function( value )
    {
        info( "User.setExploreEnergy called. this.m_exploreEnergy=%s, value=%s", this.m_exploreEnergy, value );

        if( value < 0 )
        {
            warn( "User.setExploreEnergy Warning, trying to set a negative energy value! this.m_exploreEnergy=%s, value=%s", this.m_exploreEnergy, value );
            this.m_exploreEnergy = 0;
        }
        else
        {
            this.m_exploreEnergy = value;

            if( this.m_exploreEnergy > this.m_maxExploreEnergy )
            {
                this.m_exploreEnergy = this.m_maxExploreEnergy;
            }
        }

        this.updateHud();
    },

    increaseExploreEnergy: function( value )
    {
        var newEnergy = this.getExploreEnergy() + value;
        this.setExploreEnergy( newEnergy );
    },

    getMaxBattleEnergy: function()
    {
        return this.m_maxBattleEnergy;
    },

    setMaxBattleEnergy: function( value )
    {
        this.m_maxBattleEnergy = value;
    },

    increaseMaxBattleEnergy: function( value )
    {
        this.m_maxBattleEnergy = this.m_maxBattleEnergy + value;
        if( this.m_maxBattleEnergy < 0 )
        {
            this.m_maxBattleEnergy = 0;
        }
        this.updateHud();
    },

    getBattleEnergy: function()
    {
        return this.m_battleEnergy;
    },

    setBattleEnergy: function( value )
    {
        this.m_battleEnergy = value;
    },

    increaseBattleEnergy: function( value )
    {
        if( this.m_battleEnergy + value > this.m_maxBattleEnergy )
        {
            this.m_battleEnergy = this.m_maxBattleEnergy;
            this.updateHud();
            return;
        }

        this.m_battleEnergy = this.m_battleEnergy + value;

        if( this.m_battleEnergy < 0 )
        {
            this.m_battleEnergy = 0;
            return false;
        }

        return true;
    },

    getXP: function()
    {
        return this.m_userXP;
    },

    setXP: function( value )
    {
        info( "User.setXP called. this.m_userXP=%s, value=%s", this.m_userXP, value );
        if( value < 0 )
        {
            warn( "User.setXP Warning, trying to set a negative experience value! this.m_userXP=%s, value=%s", this.m_userXP, value );
            this.m_userXP = 0;
        }
        else
        {
            this.m_userXP = value;
        }

        this.updateHud();
    },

    increaseXP: function( value )
    {
        var newXP = this.getXP() + value;
        this.setXP( newXP );
    },

    setDisplayFlag: function( value )
    {
        this.m_displayHud = value;
    },

    getUserData: function()
    {
        if( !this.m_userData )
        {
            warn( "User.getUserData The userData is not defined!" );
        }
        return this.m_userData;
    },

    getUser: function()
    {
        if( !this.m_user )
        {
            warn( "User.getUser The user is not defined!" );
        }
        return this.m_user;
    },

    getGamerTag: function()
    {
        var gamerTag = "unknown"; // HACK: this should be necessary for Flash

        if( this.m_user && this.m_gamerTag )
        {
            gamerTag = this.m_gamerTag;
        }

        info( "User.getGamerTag return. gamerTag=" + gamerTag );
        return gamerTag;
    },

    getUserId: function()
    {
        var userId = 12345; // HACK: this should be necessary for Flash

        if( this.m_user && this.m_userId )
        {
            userId = this.m_userId;
        }

        info( "User.getUserId return. userId=" + userId );
        return userId;
    },

    updateHud: function()
    {
        info( "User.updateHud called." );

        var overlayView = Xib.Navigation.getOverlayView();
        if( overlayView && overlayView.fillPlayerData )
        {
            overlayView.fillPlayerData();
        }
        else
        {
            warn( "User.updateHud Warning, cannot get overlayView!" );
        }
    },

    updateGashaDates: function()
    {
        info( "User.updateGashaDates. called..." );
        this.m_NextFreeGashaTime = Number.POSITIVE_INFINITY;
        Server.getLastAndNextFreeGashaDates( function( error, _data )
        {
            info( "User.updateGashaDates._internalCallback called..." );
            if( error )
            {
                return;
            }
            var dataObject = JSON.parse( _data );
            info( "User.updateGashaDates._internalCallback lastFreeGashaDate... " + dataObject.lastFreeGashaDate );
            info( "User.updateGashaDates._internalCallback nextFreeGashaDate... " + dataObject.nextFreeGashaDate );

            // var lastFreeGashaDate = new Date( dataObject.lastFreeGashaDate );
            // this.m_LastFreeGashaTime = lastFreeGashaDate.getTime();

            var nextFreeGashaDate = new Date( dataObject.nextFreeGashaDate );
            this.m_NextFreeGashaTime = nextFreeGashaDate.getTime();

        }.bind( this ) );
    },

    getGashaPoints: function()
    {
        return this.m_gashaPoints;
    },

    setGashaPoints: function( value )
    {
        this.m_gashaPoints = value;
    },

    isGashaAvailable: function()
    {
        info( "User.isGashaAvailable. called..." );
        if( Server.getServerTime() > this.m_NextFreeGashaTime )
        {
            return true;
        }
        return false;
    },

    resetUser: function( cb )
    {
        info( "User.resetUser. called..." );
        Server.resetUser( cb );
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/CardsManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/CardsManager'] || {}; $MODULE_REGISTRY['Code/Game/CardsManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/CardsManager.js';

exports.CardsManager = Core.Class.singleton(
{
    classname: "CardsManager",

    m_cardsDetailList: null,
    m_dictionaryDetailList: null,

    /**
     * Fusion variables
     */
    m_fusionBaseCard: null,
    m_fusionMaterialCards: [],
    m_maxMaterialCardsNumber: 10,
    m_fusionItem: null,
    m_fusionItemNumber: 0,
    m_fusionItemMaxNumber: 0,

    m_sortOptions: [
    {
        "text": "fusion_sort_filter_overall_high",
        "id": "overall",
        "invert": true
    },
    {
        "text": "fusion_sort_filter_overall_low",
        "id": "overall",
        "selected": true
    },

    {
        "text": "fusion_sort_filter_rarity_high",
        "id": "rarity",
        "invert": true
    },
    {
        "text": "fusion_sort_filter_rarity_low",
        "id": "rarity"
    },

    {
        "text": "fusion_sort_filter_status1_high",
        "id": "status1",
        "invert": true
    },
    {
        "text": "fusion_sort_filter_status1_low",
        "id": "status1"
    },

    {
        "text": "fusion_sort_filter_status2_high",
        "id": "status2",
        "invert": true
    },
    {
        "text": "fusion_sort_filter_status2_low",
        "id": "status2"
    },

    {
        "text": "fusion_sort_filter_status3_high",
        "id": "status3",
        "invert": true
    },
    {
        "text": "fusion_sort_filter_status3_low",
        "id": "status3"
    },
    {
        "text": "fusion_sort_filter_newest",
        "id": "instanceId",
        "invert": true
    },
    {
        "text": "fusion_sort_filter_oldest",
        "id": "instanceId"
    }

    ],

    m_rarityOptions: [
    {
        "text": "sort_default",
        "id": "",
        "value": -1,
        "selected": true
    },
    {
        "text": RARITY_TEXT[RARITY.common],
        "id": "rarity",
        "value": RARITY.common,
    },
    {
        "text": RARITY_TEXT[RARITY.uncommon],
        "id": "rarity",
        "value": RARITY.uncommon
    },
    {
        "text": RARITY_TEXT[RARITY.rare],
        "id": "rarity",
        "value": RARITY.rare
    },
    {
        "text": RARITY_TEXT[RARITY.superRare],
        "id": "rarity",
        "value": RARITY.superRare
    } ],

    DEFAULT_SORT_VALUE: 1,

    m_playerCardList: null,
    m_playerCardHistory: null,
    m_playerLimboCardList: null,

    m_gearLevel: null,
    m_pilotLevel: null,

    initialize: function()
    {
        info( "CardsManager.initialize called." );
    },

    // Load the list of all cards details in m_cardsDetailList, and a dictionary
    // in m_dictionaryDetailList with key "id"
    loadCardListDetails: function( list )
    {
        info( this.classname + ".loadCardListDetails: " + JSON.stringify( list ) );
        this.m_cardsDetailList = list;

        this.m_dictionaryDetailList =
        {};
        var i;
        var cardsDetailListLength = this.m_cardsDetailList.length;

        for( i = 0; i < cardsDetailListLength; i++ )
        {
            var cardsDetailList = this.m_cardsDetailList[i];
            this.m_dictionaryDetailList[cardsDetailList.id] = cardsDetailList;
        }

    },

    /**
     * Get the details for the card with "definitionId" id
     * 
     * @param id
     * @return JSON: { "id": 1, "name": "loc_name", "shortName": "loc_shortName", "description": "loc_description", "collectionType": 1, "unitType": 34, "unitGroup": FACTIONS.coalition, "eventId":
     *         1254, "rarity": 2, "sellingPrice": 568, "maxLevel": 10, "hp": 100, "status": {"status1": 95, "status2": 90, "status3": 93}, "skillId": [95, 90, 93, 1025], "abilities": {"allAttack": 95,
     *         "fastAttack": 90, "crossFire": 93, "fightingPreemptive": 93, "doubleAttack": 93}, "comment": "this is an internal comment" }
     */
    getCardDefinition: function( definitionId )
    {

        if( this.m_dictionaryDetailList != undefined )
        {
            return this.m_dictionaryDetailList[definitionId];
        }
        return null;
    },

    addLimboCard: function( card )
    {
        this.m_playerLimboCardList.push( card );
    },

    getCardDefinitionsArray: function()
    {
        return this.m_cardsDetailList.clone();
    },

    getCardDefinitionDictionary: function()
    {
        return dictionaryClone( this.m_dictionaryDetailList );
    },

    /**
     * Get the list of the cards that user has seen
     * 
     * @return {Array}: [ { id: info }, ... ]
     */
    getPlayerHistoryCardList: function( callback )
    {
        return dictionaryClone( this.m_playerCardHistory );
    },

    _syncPlayerCardListCallback: function( cb, error, data )
    {
        info( "CardsManager._syncPlayerCardListCallback called. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

        if( error )
        {
            err( "CardsManager._syncPlayerCardListCallback Error: %s", JSON.stringify( error ) );
            cb && cb( false, null );
            return;
        }

        if( !data )
        {
            err( "CardsManager._syncPlayerCardListCallback Error. No data received! data=%s", JSON.stringify( data ) );
            cb && cb( false, null );
            return;
        }

        data = JSON.parse( data );
        this.m_playerCardList = ( data.cards ).clone();
        this.m_playerLimboCardList = ( data.cardsLimbo ).clone();
        this.setUpLimboCards();
        cb && cb( true, this.m_playerCardList.cards );
    },

    syncPlayerCardList: function( cb )
    {
        info( "CardsManager.syncPlayerCardList called." );
        Server.getAllUserCards( this._syncPlayerCardListCallback.bind( this, cb ) );
    },

    setUpLimboCards: function()
    {
        var length = this.m_playerLimboCardList.length;
        info( "CardsManager.setUpLimboCards called: " + length );
        for( var i = 0; i < length; i++ )
        {
            this.m_playerLimboCardList[i].inLimbo = true;
        }
    },

    initWithData: function( cardList, cardHistory, cardsLimbo )
    {
        info( "CardsManager.initWithData called. cardList=%s", JSON.stringify( cardList ) );
        info( "CardsManager.initWithData called. cardHistoryLength=%s -> cardHistory=%s", cardHistory.length, JSON.stringify( cardHistory ) );
        info( "CardsManager.initWithData called. cardLimbo=%s ", JSON.stringify( cardsLimbo ) );

        this.m_playerCardList = ( cardList != undefined ) ? cardList.clone() : [];
        this.m_playerLimboCardList = ( cardsLimbo != undefined ) ? cardsLimbo.clone() : [];

        this.setUpLimboCards();
        this.m_playerCardHistory =
        {};

        if( cardHistory != undefined )
        {
            // ///////////////////////////////////////////////////////////
            // TODO FIXME HACK fix the server please !
            // ///////////////////////////////////////////////////////////
            // Cleanup data until the server get fixed.
            var i, key;
            for( i = 0; i < cardHistory.length; i++ )
            {
                key = Object.keys( cardHistory[i] )[0];
                this.m_playerCardHistory[key] = cardHistory[i][key];
            }
            // ///////////////////////////////////////////////////////////
        }

    },

    /**
     * Get the list of the card that the user has
     * 
     * @param sortBy:
     *            Can be any field of this.m_cardsDetailList ("name", "type", ...)
     * 
     */
    getPlayerCardList: function( sortBy, playerCardsList )
    {
        info( "CardsManager.getPlayerCardList called. sortBy=%s", JSON.stringify( sortBy ) );

        if( playerCardsList == undefined )
        {
            playerCardsList = this.m_playerCardList.clone();
        }

        else
        {
            playerCardsList = playerCardsList.clone();
        }

        info( "CardsManager.getPlayerCardList called. playerCardList=%s", JSON.stringify( playerCardsList ) );

        if( sortBy != undefined && playerCardsList && playerCardsList.length > 1 )
        {
            // Sort Data
            playerCardsList.compareValue = function( card )
            {

                var sortByValue = sortBy.value;

                switch( sortByValue )
                {
                    case "instanceId":
                        return card.id;
                    case "sellingPrice":
                        return this.getCardSellingPrice( card );
                    case "overall":
                        var cardStatus = CardsManager.getCardStatus( card );
                        var value = 0;
                        for( var key in cardStatus )
                        {
                            value = value + cardStatus[key];
                        }
                        return value;
                    case "status1":
                    case "status2":
                    case "status3":
                        var cardStatus = CardsManager.getCardStatus( card );
                        return cardStatus[sortByValue];
                    default:
                        var cardInfo = CardsManager.getCardDefinition( card.definitionId );
                        if( cardInfo )
                        {
                            return _loc( cardInfo[sortByValue] );
                        }
                }

            }.bind( this );

            playerCardsList.inverted = sortBy.invert;
            quickSort( playerCardsList );
        }

        return playerCardsList;
    },

    getPlayerCardSellList: function()
    {
        var cardsAvailableToSell = [];

        for( var i = 0; i < this.m_playerCardList.length; i++ )
        {
            if( this.m_playerCardList[i].locked == false )
            {
                cardsAvailableToSell.push( this.m_playerCardList[i] );
            }
        }

        for( i = 0; i < this.m_playerLimboCardList.length; i++ )
        {
            cardsAvailableToSell.push( this.m_playerLimboCardList[i] );
        }

        return cardsAvailableToSell;
    },

    getPlayerCardById: function( instanceId )
    {
        info( "CardsManager.getPlayerCardById called. id=%d", instanceId );
        var i, card;
        card = null;

        for( i = 0; i < this.m_playerCardList.length; i++ )
        {
            card = this.m_playerCardList[i];
            if( card.id == instanceId )
            {
                break;
            }
        }
        return card;
    },

    /**
     * 
     * @param dictionaryKey:
     *            Can be any field of the PlayerList ("id", "definitionId", "xp")
     * @param sortBy:
     *            {"value": "name", "invert": true} value: Can be any field of this.m_cardsDetailList ("name", "type", ...) return in callback: JSON: { "list": playerList, "dictionary":
     *            playerDictionary }; invert: Can be true or false.
     */
    getPlayerCardDictionary: function( dictionaryKey, sortBy, list )
    {
        var playerList = this.getPlayerCardList( sortBy, list );

        if( playerList )
        {
            var dictionary, length, i, val;
            dictionary =
            {};
            length = playerList.length;

            for( i = 0; i < length; i++ )
            {
                val = playerList[i];
                dictionary[val[dictionaryKey]] = val;
            }

            var playerCards =
            {
                "list": playerList,
                "dictionary": dictionary
            };

            return playerCards;
        }

        return null;
    },

    getSortOptions: function()
    {
        var ret = [];
        var i;
        var length = this.m_sortOptions.length;

        for( i = 0; i < length; i++ )
        {
            var dict = dictionaryClone( this.m_sortOptions[i] );
            ret.push( dict );
        }
        return ret;
    },

    getRarityOptions: function()
    {
        var ret = [];
        var i;
        var length = this.m_rarityOptions.length;

        for( i = 0; i < length; i++ )
        {
            var dict = dictionaryClone( this.m_rarityOptions[i] );
            ret.push( dict );
        }
        return ret;
    },

    /**
     * Experience and level Methods *********************************
     */

    loadGearLevel: function( data )
    {
        this.m_gearLevel = data;
    },

    loadPilotLevel: function( data )
    {
        this.m_pilotLevel = data;
    },
    /**
     * @param cardDictionary: {
     *            "id": 363, "definitionId": 14, "xp": 300 }
     * 
     * @return cardXpPercentage: Between 0 and 1
     */
    getXpPercentage: function( cardInstance )
    {
        var cardDefinition = this.getCardDefinition( cardInstance.definitionId );
        var level = this.getCardLevel( cardInstance );

        if( level == cardDefinition.maxLevel )
        {
            return 1;
        }

        var xpLevel = this._getXPForLevel( level, cardDefinition.type );
        var xpToNextLevel = this._getXPForLevel( ( level + 1 ), cardDefinition.type );
        var xp = cardInstance.xp - xpLevel;

        var result = xp / ( xpToNextLevel - xpLevel );

        return result;
    },

    _getXPForLevel: function( level, type )
    {
        var key = "" + level;

        if( type == PILOT && ( this.m_pilotLevel[key] != undefined ) )
        {
            return this.m_pilotLevel[key];
        }
        else if( type == GEAR && ( this.m_gearLevel[key] != undefined ) )
        {
            return this.m_gearLevel[key];
        }

        return -1;
    },

    /**
     * @param cardInstance: {
     *            "id": 363, "definitionId": 14, "xp": 300 }
     * 
     * @return cardLevel: Related with the cardXP and the maxLevel
     */
    getCardLevel: function( cardInstance )
    {
        var cardDefinition = this.getCardDefinition( cardInstance.definitionId );
        var xp = cardInstance.xp;

        var level = 0;

        if( cardDefinition.type == PILOT )
        {
            level = parseInt( binaryRangeSearch( this.m_pilotLevel, xp ) );
        }
        else if( cardDefinition.type == GEAR )
        {
            level = parseInt( binaryRangeSearch( this.m_gearLevel, xp ) );
        }

        if( isNaN( level ) || level == undefined || level == 0 )
        {
            level = 1;
        }

        if( level > cardDefinition.maxLevel || level == -1 )
        {
            level = cardDefinition.maxLevel;
        }
        else if( level == -2 )
        {
            level = 1;
        }

        return level;
    },

    getMaxCardLevel: function( cardInstance )
    {
        var cardDefinition = this.getCardDefinition( cardInstance.definitionId );
        return cardDefinition.maxLevel;
    },

    getAllPlayerCards: function()
    {
        return this.m_playerCardList;
    },

    // Loads an image from a card with the specified size
    loadCardImage: function( /* int */cardDefinitionId, /* string */size, /* function */cb )
    {
        var cardDefinition = this.getCardDefinition( cardDefinitionId );
        var imageURL = cardDefinition.id + "_" + size + ".jpg";

        info( "CardsManager.loadCardImage imageURL=%s.", imageURL );

        var wrap = function( imageURL )
        {
            cb( imageURL );
        }.bind( this, imageURL );
        ResourceManager.preLoadResource( imageURL, wrap );
    },

    loadSpecialCardImages: function( /* int */cardDefinitionId, /* string */size, /* function */cb )
    {
        var pendingImages = 3;
        var images = [ "", "", "" ];
        var onImageLoaded = function( imageURL, position )
        {
            info( "CardsManager.loadSpecialCardImages.onImageLoaded called: " + imageURL + ", pos: " + position );
            pendingImages--;
            images[position] = imageURL;
            if( pendingImages > 0 )
            {
                return;
            }
            info( "CardsManager.loadSpecialCardImages.onImageLoaded ready" );
            for( var i = 0; i < images.length; ++i )
            {
                // in case of a missing asset, we return null
                if( images[i] == null )
                {
                    cb( null );
                    return;
                }
            }
            cb( images );
        };

        var cardDefinition = this.getCardDefinition( cardDefinitionId );
        if( cardDefinition.rarity != RARITY.superRare )
        {
            cb( images );
            return;
        }

        var wrap = function( imageURL, position )
        {
            onImageLoaded( imageURL, position );
        };

        var imageURL1 = cardDefinition.id + "_" + size + ".jpg";
        var imageURL2 = cardDefinition.id + "_1_" + size + ".jpg";
        var imageURL3 = cardDefinition.id + "_2_" + size + ".jpg";

        info( "CardsManager.loadSpecialCardImages imageURL1=%s.", imageURL1 );
        info( "CardsManager.loadSpecialCardImages imageURL2=%s.", imageURL2 );
        info( "CardsManager.loadSpecialCardImages imageURL3=%s.", imageURL3 );

        ResourceManager.preLoadResource( imageURL1, wrap.bind( this, imageURL1, 0 ), wrap.bind( this, null, 0 ) );
        ResourceManager.preLoadResource( imageURL2, wrap.bind( this, imageURL2, 1 ), wrap.bind( this, null, 1 ) );
        ResourceManager.preLoadResource( imageURL3, wrap.bind( this, imageURL3, 2 ), wrap.bind( this, null, 2 ) );
    },

    getAreaOfInterestSquare: function( cardDefinitionId )
    {
        var cardDefinition = this.getCardDefinition( cardDefinitionId );
        var offsets = cardDefinition.offsets.square;
        // var result = {"_x": ( cardSize.x / BIGGEST_CARD_SIZE._x ), "_y": (
        // cardSize.y / BIGGEST_CARD_SIZE._y )};
        var result =
        {
            "_x": offsets.x,// 0.29,
            "_y": offsets.y,// 0.205,
            "_width": offsets.width,// 0.46,
            "_height": offsets.height
        // 0.8
        };
        return result;
    },

    getAreaOfInterestWide: function( cardDefinitionId )
    {
        var cardDefinition = this.getCardDefinition( cardDefinitionId );
        var offsets = cardDefinition.offsets.wide;
        // var cardSize = cardDefinition.offset;
        var result =
        {
            "_x": offsets.x,// 0.04,
            "_y": offsets.y,// 0.27,
            "_width": offsets.width,// 0.9,
            "_height": offsets.height
        // 0.5
        // cardSize.y / BIGGEST_CARD_SIZE._y )
        };
        return result;
    },

    lockCard: function( /* int */cardId, /* boolean */lock, /* string */status )
    {
        var cards = this.m_playerCardList;
        for( var i = cards.length - 1; i >= 0; --i )
        {
            if( cards[i].id == cardId )
            {
                cards[i].locked = lock;
                if( lock )
                {
                    cards[i].lockedStatus = status;
                }
                else
                {
                    cards[i].lockedStatus = "";
                }
            }
        }
    },

    /**
     * 
     * @param cardId:
     *            the instance id of the card to be modified
     * @param newCardDatas:
     *            dictionary with the new fields (example: {"xp": 10, "lock": false})
     */
    updatePlayerCard: function( cardId, newCardData )
    {
        info( "CardsManager.updatePlayerCard: " + cardId );
        for( var i = this.m_playerCardList.length - 1; i >= 0; --i )
        {
            if( this.m_playerCardList[i].id == cardId )
            {
                for( var key in newCardData )
                {
                    this.m_playerCardList[i][key] = newCardData[key];
                }
            }
        }
    },

    /**
     * @param card:
     *            card instance IMPORTANT: when using this method, the cards has been already added in the server, so there's no need to send a request to the server. Only use this function in this
     *            case.
     */
    addPlayerCard: function( card )
    {
        if( card.inLimbo && card.inLimbo == true )
        {
            this.addLimboCard( card );
            this.validateCardHistory( card.definitionId );
            return;
        }
        this.m_playerCardList.push( card );
        var adquisitedCardDefinitionId = card.definitionId;
        this.validateCardHistory( adquisitedCardDefinitionId );
        User.updateHud();
    },

    /**
     * 
     * @param cardsIds:
     *            Array of the cards instanceIds to remove
     */
    removePlayerCards: function( cardsIds )
    {
        info( "CardsManager.removePlayerCards: " + JSON.stringify( cardsIds ) );
        for( var i = this.m_playerCardList.length - 1; i >= 0; --i )
        {
            if( cardsIds.indexOf( this.m_playerCardList[i].id ) != -1 )
            {
                this.m_playerCardList.splice( i, 1 );
            }
        }

        for( var i = this.m_playerLimboCardList.length - 1; i >= 0; --i )
        {
            if( cardsIds.indexOf( this.m_playerLimboCardList[i].id ) != -1 )
            {
                this.m_playerLimboCardList.splice( i, 1 );
            }
        }

        User.updateHud();
    },

    getFilteredPlayerCardsWithLimbo: function( filters )
    {
        var allCards_noLimbo = this.m_playerCardList.clone();
        var allCards_limbo = this.m_playerLimboCardList.clone();

        var allCards = [];

        allCards = allCards.concat( allCards_limbo, allCards_noLimbo );

        return this._getFilteredPlayerCards( filters, allCards );
    },

    getFilteredPlayerCards: function( filters )
    {
        var allCards = this.m_playerCardList.clone();
        return this._getFilteredPlayerCards( filters, allCards );
    },

    getAllFilteredPlayerCards: function( filters )
    {
        /*
         * var allCards = this.m_playerCardList.clone(); var tempCards = this.m_playerCardLimbo.clone(); for (var i=0; i<tempCards.length; i++ ) { allCards.push(tempCards[i ]); }
         */
        return this._getFilteredPlayerCards( filters, this.getPlayerCardSellList() );
    },

    // This will check playerCard and the respective definitionCard fields. The
    // filter will be applied in that order.
    // DO NOT USE the 'id' field. If you need to filter using cards definition
    // id use 'definitionId' as the filter.
    // Example: CardsManager.getFilteredPlayerCards( { "definitionId":"12000010"
    // } );
    _getFilteredPlayerCards: function( filters, allCards )
    {
        info( "CardsManager.getFilteredPlayerCards called. filters=%s", JSON.stringify( filters ) );
        var filteredCards, i, playerCard, definitionCard, passedFilters;

        filteredCards = [];

        if( !filters || Object.keys( filters ) == 0 )
        {
            return allCards;
        }

        info( "CardsManager.getFilteredPlayerCards allCards.length=%s", allCards.length );

        for( i = 0; i < allCards.length; i++ )
        {
            playerCard = allCards[i];
            passedFilters = 0;

            for( var filterId in filters )
            {
                if( playerCard[filterId] != undefined )
                {
                    if( playerCard[filterId] == filters[filterId] )
                    {
                        // info( "PLAYER CARD > "+ playerCard.id + " FILTER > "+filters[filterId]);
                        passedFilters++;
                        continue;
                    }
                }
                else
                {
                    definitionCard = this.getCardDefinition( playerCard.definitionId );
                    if( definitionCard && definitionCard[filterId] != undefined )
                    {
                        if( definitionCard[filterId] == filters[filterId] )
                        {
                            // info( "#PLAYER CARD > "+ definitionCard.id + " FILTER > "+filters[filterId]);
                            passedFilters++;
                        }
                    }
                }
            }

            if( passedFilters == Object.keys( filters ).length )
            {
                filteredCards.push( playerCard );
            }
        }

        return filteredCards;
    },

    getFilteredDefinitionsCards: function( filters )
    {
        info( "CardsManager.getFilteredDefinitionsCards called. filters=%s", JSON.stringify( filters ) );
        var allCards, filteredCards, i, playerCard, passedFilters;

        allCards = this.m_cardsDetailList.clone();
        filteredCards = [];

        if( !filters || Object.keys( filters ) == 0 )
        {
            return allCards;
        }

        for( i = 0; i < allCards.length; i++ )
        {
            playerCard = allCards[i];
            passedFilters = 0;

            for( var filterId in filters )
            {
                if( playerCard[filterId] != undefined )
                {
                    if( playerCard[filterId] == filters[filterId] )
                    {
                        passedFilters++;
                    }
                }
            }

            if( passedFilters == Object.keys( filters ).length )
            {
                filteredCards.push( playerCard );
            }
        }

        return filteredCards;
    },

    // Returns a COPY of the filtered cards
    // { "cardParameter1": value, "cardParameter2": value }
    getFilteredCards: function( filters, allCards )
    {
        info( "CardsManager.getFilteredCards called. filters=%s", JSON.stringify( filters ) );
        var result, cardId, i;

        if( allCards )
        {
            result = this.getCardDefinitionsArray();
        }
        else
        {
            // User cards
            result = this.m_playerCardList.clone();
        }

        if( !filters || Object.keys( filters ) == 0 )
        {
            return result;
        }

        // //FIXME: Only for testing
        // this.m_playerCardList[ 0].locked = true;
        // this.m_playerCardList[ 0].lockedStatus = "DECK";
        // this.m_playerCardList[ 1].locked = true;
        // this.m_playerCardList[ 1].lockedStatus = "DECK";
        //
        //
        for( var filterId in filters )
        {
            for( i = result.length - 1; i >= 0; --i )
            {
                if( allCards )
                {
                    cardId = result[i].id;
                }
                else
                {
                    cardId = result[i].definitionId;
                }

                cardInfo = this.getCardDefinition( cardId );
                if( !cardInfo )
                {
                    err( "CardsManager.getFilteredCards: couldn't find cardInfo with id: " + cardId );
                    // result.splice( i, 1 );
                    // continue;
                }
                if( cardInfo[filterId] != undefined )
                {
                    if( !( cardInfo[filterId] == filters[filterId] ) )
                    {
                        result.splice( i, 1 );
                    }
                }
                else if( result[i][filterId] != undefined )
                {
                    if( !( result[i][filterId] == filters[filterId] ) )
                    {
                        result.splice( i, 1 );
                    }
                }
                else
                {
                    result.splice( i, 1 );
                }
            }
        }

        info( "CardsManager.getFilteredCards result.length=%d, result=%s", result.length, JSON.stringify( result ) );
        return result;
    },

    // Returns a COPY of the filtered cards
    // [{ "parameter": parameter1, "value": value, "operator": "</=/>" }, {
    // "parameter": parameter2, "value": value, "operator": "</=/>" }]
    getFilteredCards_Advanced: function( filters )
    {
        var result, i, filterId, j, cardId, operator;
        result = this.m_playerCardList.clone();

        for( i = 0; i < filters.length; ++i )
        {
            filterId = filters[i].parameter;
            operator = filters[i].operator;
            for( j = result.length - 1; j >= 0; --j )
            {
                cardId = result[j].id;

                cardInfo = this.getCardDefinition( cardId );
                switch( operator )
                {
                    case "<":
                        if( cardInfo[filterId] != undefined )
                        {
                            if( !( cardInfo[filterId] < filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else if( result[i][filterId] != undefined )
                        {
                            if( !( result[i][filterId] < filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else
                        {
                            result.splice( i, 1 );
                        }
                        break;
                    case "<=":
                        if( cardInfo[filterId] != undefined )
                        {
                            if( !( cardInfo[filterId] <= filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else if( result[i][filterId] != undefined )
                        {
                            if( !( result[i][filterId] <= filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else
                        {
                            result.splice( i, 1 );
                        }
                        break;
                    case "==":
                        if( cardInfo[filterId] != undefined )
                        {
                            if( !( cardInfo[filterId] == filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else if( result[i][filterId] != undefined )
                        {
                            if( !( result[i][filterId] == filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else
                        {
                            result.splice( i, 1 );
                        }
                        break;
                    case ">=":
                        if( cardInfo[filterId] != undefined )
                        {
                            if( !( cardInfo[filterId] >= filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else if( result[i][filterId] != undefined )
                        {
                            if( !( result[i][filterId] >= filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else
                        {
                            result.splice( i, 1 );
                        }
                        break;
                    case ">":
                        if( cardInfo[filterId] != undefined )
                        {
                            if( !( cardInfo[filterId] > filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else if( result[i][filterId] != undefined )
                        {
                            if( !( result[i][filterId] > filters[filterId] ) )
                            {
                                result.splice( i, 1 );
                            }
                        }
                        else
                        {
                            result.splice( i, 1 );
                        }
                        break;
                }

            }
        }

        return result;
    },

    /**
     * Fusion Methods *********************************
     */
    // TODO: Hardcoded
    getCardTypes: function()
    {
        return [ GEAR, PILOT ];
    },

    // TODO This data should came from server.....
    getFusionRecommendedCard: function( cardType )
    {
        // TODO:FIXME: Implement a setter
        if( cardType == undefined )
        {
            return this.m_recommended;
        }

        var max = -1;

        var i;
        var length = this.m_playerCardList.length;
        for( i = 0; i < length; i++ )
        {
            var cardDict = this.m_playerCardList[i];
            var infoDict = this.getCardDefinition( cardDict.definitionId );
            if( infoDict.type == cardType )
            {
                var cardStatus = CardsManager.getCardStatus( cardDict );
                var value = 0;
                for( var key in cardStatus )
                {
                    value = value + cardStatus[key];
                }
                if( value > max )
                {
                    max = value;
                    // TODO:FIXME: Implement a setter
                    this.m_recommended = cardDict.id;
                }
            }

        }

        return this.m_recommended;
    },

    /**
     * @return {Boolean}: If the card was added return true, else, return false
     */
    setFusionBaseCard: function( id )
    {
        var i, length;

        length = this.m_maxMaterialCardsNumber;

        for( i = 0; i < length; i++ )
        {
            if( id == this.m_fusionMaterialCards[i] )
            {
                return false;
            }
        }
        this.m_fusionBaseCard = id;
        return true;
    },

    /**
     * 
     * @param id:
     *            instance definitionId to be added
     * @return {Boolean}: If the card was added return true, else, return false
     */
    setFusionMaterialCard: function( id )
    {
        if( id == this.m_fusionBaseCard )
        {
            return false;
        }
        var i, length;

        length = this.m_maxMaterialCardsNumber;

        for( i = 0; i < length; i++ )
        {
            if( this.m_fusionMaterialCards[i] == undefined )
            {
                this.m_fusionMaterialCards[i] = id;
                return true;
            }
        }
        return false;
    },

    /**
     * 
     * @param cards:
     *            Array with the material cards instanceIds
     * @return {Boolean}: If the array was added return true, else, return false
     */
    setFusionMaterialCards: function( cards )
    {
        if( cards.length <= this.m_maxMaterialCardsNumber )
        {
            var baseCardIndex = cards.indexOf( this.m_fusionBaseCard );
            if( baseCardIndex != -1 )
            {
                cards.splice( baseCardIndex, 1 );
            }

            this.m_fusionMaterialCards.length = 0;
            this.m_fusionMaterialCards = null;

            this.m_fusionMaterialCards = cards;
            return true;
        }

        return false;
    },

    setFusionItemNumber: function( number )
    {
        if( this.m_fusionItemNumber <= this.m_fusionItemMaxNumber && this.m_fusionItemNumber >= 0 )
        {
            this.m_fusionItemNumber = number;
            return true;
        }

        return false;
    },

    /**
     * 
     * @param id:
     *            instance definitionId to be removed
     * @return {Boolean}: If the card was removed return true, else, return false
     */
    removeFusionMaterialCard: function( id )
    {
        var index = this.m_fusionMaterialCards.indexOf( id );
        if( index != -1 )
        {
            this.m_fusionMaterialCards.splice( index, 1 );
            return true;
        }

        return false;
    },

    getFusionBaseCard: function()
    {
        return this.m_fusionBaseCard;
    },

    getFusionMaterialCards: function()
    {
        return this.m_fusionMaterialCards.clone();
    },

    getMaxMaterialCardsNumber: function()
    {
        return this.m_maxMaterialCardsNumber;
    },

    getFusionItemNumber: function()
    {
        return this.m_fusionItemNumber;
    },

    getFusionItemMaxNumber: function()
    {
        return this.m_fusionItemMaxNumber;
    },

    getFusionItem: function()
    {
        return this.m_fusionItem;
    },

    setFusionItemType: function( type )
    {
        var itemList = ItemManager.getItemDefinitionArray();

        var length = itemList.length;
        var i;
        for( i = 0; i < length; i++ )
        {
            var item = itemList[i];
            if( item.type == type )
            {
                this.m_fusionItem = item;
                itemInstance = ItemManager.getPlayerItem( this.m_fusionItem.id );
                this.m_fusionItemMaxNumber = ( itemInstance != undefined ) ? itemInstance.amount : 0;
                break;
            }
        }
    },
    // Reset the Fusion
    clearFusion: function()
    {
        info( "CardsManager.clearFusion called." );
        this.m_fusionMaterialCards.length = 0;
        this.m_fusionMaterialCards = [];
        this.m_fusionBaseCard = null;
        this.m_fusionItemNumber = 0;
    },

    // TODO: Implement this method
    getFusionCostByCard: function( cardInstance )
    {
        var cardDefinition = this.getCardDefinition( cardInstance.definitionId );
        var maxStatusSum = 0;
        var fusionCost = 0;

        if( cardDefinition.type == GEAR )
        {
            maxStatusSum = cardDefinition.statusMax.status1 + cardDefinition.statusMax.status2 + cardDefinition.statusMax.status3;
            fusionCost = maxStatusSum * 0.15;
            fusionCost = 10 * Math.floor(fusionCost / 10);
        }
        else if( cardDefinition.type == PILOT )
        {
            var bases = [ 480, 720, 960, 1440, 1920 ];
            var level = this.getCardLevel( cardInstance );
            fusionCost = level * bases[cardDefinition.rarity - 1];
        }
        return fusionCost;
    },

    getFusionCost: function( withItems )
    {
        var cost = 0;

        if( !withItems )
        {
            if( this.m_fusionMaterialCards != undefined )
            {
                var cardBaseInstance = this.getPlayerCardById( this.m_fusionBaseCard );
                var cardBaseDefinition = this.getCardDefinition( cardBaseInstance.definitionId );

                var i;
                var length = this.m_fusionMaterialCards.length;
                var materialCardInstance = null;
                if( cardBaseDefinition.type == GEAR )
                {
                    for( i = 0; i < length; i++ )
                    {
                        materialCardInstance = this.getPlayerCardById( this.m_fusionMaterialCards[i] );
                        cost = cost + this.getFusionCostByCard( materialCardInstance );
                    }
                }
                else if( cardBaseDefinition.type == PILOT )
                {
                    for( i = 0; i < length; i++ )
                    {
                        materialCardInstance = this.getPlayerCardById( this.m_fusionMaterialCards[i] );
                        cost = cost + this.getFusionCostByCard( materialCardInstance );
                    }
                }
                cost = Math.floor( cost / 10 );
                cost = cost * 10;
            }
        }
        else
        {
            cost = this.m_fusionItem.evolveCost * this.m_fusionItemNumber;
        }

        return cost;
    },

    endFusion: function()
    {
        this.m_fusioning = false;
    },
    
    fusioning: function()
    {
        return this.m_fusioning;
    },
    
    /**
     * @return {Boolean}: If the cards were fusiond return true, else, return false.
     */
    fusion: function( cb, fusionWithItems )
    {
        if( this.m_fusioning )
        {
            cb(false);
            return;
        }
        
        this.m_fusioning = true;
        
        info( "CardsManager.fusion called. this.m_fusionBaseCard=%s, this.m_fusionMaterialCards=%s, this.m_fusionItemNumber=%s", JSON.stringify( this.m_fusionBaseCard ), JSON.stringify( this.m_fusionMaterialCards ), JSON
                .stringify( this.m_fusionItemNumber ) );
        if( typeof ( cb ) != "function" )
        {
            err( "CardsManager.fusion Error, no callback specified!" );
            this.m_fusioning = false;
            return false;
            // THROW ERROR
        }

        if( this.m_fusionBaseCard == undefined )
        {
            info( "CardsManager.fusion: No cards to fusion" );
            cb( false );
            return false;
        }

        if( !fusionWithItems && ( this.m_fusionMaterialCards == undefined || this.m_fusionMaterialCards.length == 0 ) )
        {
            info( "CardsManager.fusion: Wrong material cards number" );
            cb( false );
            return false;
        }

        if( fusionWithItems == true && ( this.m_fusionItemNumber > this.m_fusionItemMaxNumber || this.m_fusionItemNumber == 0 ) )
        {
            info( "CardsManager.fusion: Wrong items number" );
            cb( false );
            return false;
        }
        else
        {
            var itemsArray = [];

            if( fusionWithItems == true )
            {
                itemsArray.push(
                {
                    "id": this.m_fusionItem.id,
                    "amount": this.m_fusionItemNumber
                } );

                this.m_fusionMaterialCards.length = 0;
                this.m_fusionMaterialCards = [];
            }

            Server.fusionCard( this.m_fusionBaseCard, this.m_fusionMaterialCards, itemsArray, false /* remake */, function( error, data )
            {
                info("CardsManager.fusion: ServerCb: error: " + JSON.stringify(error) + ", data: " + JSON.stringify(data));
                if( error != undefined )
                {
                    cb( false );
                }
                else
                {
                    data = JSON.parse( data );
                    // Modify the local cardList
                    var newCardData =
                    {
                        "xp": data.xp
                    };

                    // Modify user gold.
                    var cost = CardsManager.getFusionCost( fusionWithItems );
                    User.increaseCurrency( -cost );

                    this.updatePlayerCard( data.baseCardId, newCardData );

                    if( fusionWithItems == true )
                    {
                        ItemManager.modifyItemAmount( this.m_fusionItem.id, -this.m_fusionItemNumber );
                        this.clearFusion();
                        cb( true, data );
                    }
                    else
                    {
                        var func = function()
                        {           
                            CardsManager.clearFusion();
                            User.updateHud();
                            cb( true, data );
                        };
                        this.syncPlayerCardList( func );
                    }
                }
            }.bind( this ) );
        }
    },

    // Overload of getCardStatus
    getCardStatus_with_Definition_XP: function( definitionId, xp )
    {
        var auxStruct =
        {
            "definitionId": definitionId,
            "xp": xp
        };
        return this.getCardStatus( auxStruct );
    },

    getCardStatus: function( cardInstance )
    {
        var cardDefinition = this.getCardDefinition( cardInstance.definitionId );
        var level = this.getCardLevel( cardInstance );

        var result = null;

        if( cardDefinition.type == GEAR )
        {
            // FIXME: Hardcoded
            result =
            {
                "status1": Math.floor( this._getStatusByLevel( cardDefinition, level, "status1", "sublinear" ) ),
                "status2": Math.floor( this._getStatusByLevel( cardDefinition, level, "status2", "linear" ) ),
                "status3": Math.floor( this._getStatusByLevel( cardDefinition, level, "status3", "supralinear" ) ),
            };
        }
        else if( cardDefinition.type == PILOT )
        {
            result =
            {
                "status1": this._getStatusByLevel( cardDefinition, level, "status1", "linear" ),
                "status2": this._getStatusByLevel( cardDefinition, level, "status2", "linear" ),
                "status3": this._getStatusByLevel( cardDefinition, level, "status3", "linear" ),
            };
        }

        return result;
    },

    _getStatusByLevel: function( cardDefinition, level, status, type )
    {
        var statusMax = cardDefinition.statusMax;
        var statusMin = cardDefinition.statusInit;

        level = level - 1;

        var sqLevel = level * level;

        var result = null;
        switch( type )
        {
            case "sublinear":
                result = ( ( statusMax[status] - statusMin[status] ) / ( cardDefinition.maxLevel - 1 ) * ( ( GROWTH_FACTOR.late / ( cardDefinition.maxLevel - 1 ) ) * sqLevel + ( 1 - GROWTH_FACTOR.late ) * level ) + statusMin[status] );
                break;
            case "supralinear":
                result = ( ( statusMax[status] - statusMin[status] ) / ( cardDefinition.maxLevel - 1 ) * ( ( GROWTH_FACTOR.early / ( cardDefinition.maxLevel - 1 ) ) * sqLevel + ( 1 - GROWTH_FACTOR.early ) * level ) + statusMin[status] );
                break;
            case "linear":
                result = ( ( ( statusMax[status] - statusMin[status] ) / ( cardDefinition.maxLevel - 1 ) ) * level + statusMin[status] );
                break;
        }

        return result;
    },

    getSkillsFromUnit: function( pilotCardDefinitionId, gearCardDefinitionId )
    {
        var pilotCardDefinition = this.getCardDefinition( pilotCardDefinitionId );
        var gearCardDefinition = this.getCardDefinition( gearCardDefinitionId );

        var result = [];

        for( var i = 0; i < pilotCardDefinition.skillId.length; ++i )
        {
            if( pilotCardDefinition.skillId[i] < 0 )
            {
                continue;
            }

            var skill = SkillsManager.getSkillById( pilotCardDefinition.skillId[i] );

            for( var j = 0; j < gearCardDefinition.groups.length; ++j )
            {
                if( skill.groupId == gearCardDefinition.groups[j] )
                {
                    result.push( skill );
                    break;
                }
            }
        }

        return result;
    },

    // Overload of getUnitStatus
    getUnitStatus_with_Definition_XP: function( pilotCardDefinitionId, gearCardDefinitionId, pilotXP, gearXP )
    {
        var pilotStatus = this.getCardStatus_with_Definition_XP( pilotCardDefinitionId, pilotXP );
        var gearStatus = this.getCardStatus_with_Definition_XP( gearCardDefinitionId, gearXP );

        var result = this._calculateUnitStatus( pilotStatus, gearStatus );

        return result;
    },

    getUnitStatus: function( pilotCardInstance, gearCardInstance )
    {
        var pilotStatus = this.getCardStatus( pilotCardInstance );
        var gearStatus = this.getCardStatus( gearCardInstance );

        var result = this._calculateUnitStatus( pilotStatus, gearStatus );

        return result;
    },

    _calculateUnitStatus: function( pilotStatus, gearStatus )
    {
        var result =
        {
            "status1": ( pilotStatus.status1 * gearStatus.status1 ),
            "status2": ( pilotStatus.status2 * gearStatus.status2 ),
            "status3": ( pilotStatus.status3 * gearStatus.status3 )
        };

        return result;
    },

    getUnitStatusWithSkill_with_Definition_XP: function( pilotCardDefinitionId, gearCardDefinitionId, pilotXP, gearXP )
    {
        var pilotStatus = this.getCardStatus_with_Definition_XP( pilotCardDefinitionId, pilotXP );
        var gearStatus = this.getCardStatus_with_Definition_XP( gearCardDefinitionId, gearXP );

        return this._calculateUnitStatusWithSkill( pilotCardDefinitionId, gearCardDefinitionId, pilotStatus, gearStatus );
    },

    getUnitStatusWithSkill: function( pilotCardInstance, gearCardInstance )
    {
        var pilotStatus = this.getCardStatus( pilotCardInstance );
        var gearStatus = this.getCardStatus( gearCardInstance );
        var result = this._calculateUnitStatusWithSkill( pilotCardInstance.definitionId, gearCardInstance.definitionId, pilotStatus, gearStatus );

        return result;
    },

    _calculateUnitStatusWithSkill: function( pilotDefinitionId, gearDefinitionId, pilotStatus, gearStatus )
    {
        var skills = this.getSkillsFromUnit( pilotDefinitionId, gearDefinitionId );
        var skillStatus1 = pilotStatus.status1, skillStatus2 = pilotStatus.status2, skillStatus3 = pilotStatus.status3;
        for( var i = 0; i < skills.length; ++i )
        {
            skillStatus1 += skills[i].status["status1"];
            skillStatus2 += skills[i].status["status2"];
            skillStatus3 += skills[i].status["status3"];
        }

        var result =
        {
            "status1": Math.floor( ( skillStatus1 / 100 + 1 ) * gearStatus.status1 ),
            "status2": Math.floor( ( skillStatus2 / 100 + 1 ) * gearStatus.status2 ),
            "status3": Math.floor( ( skillStatus3 / 100 + 1 ) * gearStatus.status3 )
        };

        return result;
    },

    getUnitPower: function( pilotCardInstance, gearCardInstance, status, position )
    {
        var unitStatus = this.getUnitStatusWithSkill( pilotCardInstance, gearCardInstance );

        var statusMultiplier =
        {
            "status1": 1,
            "status2": 1,
            "status3": 1
        };
        statusMultiplier[status] = DECK_POSITION_MULTIPLIER[position];

        var maxLevelBonus = 1.0;
        var gearLevel = this.getCardLevel( gearCardInstance );
        var gearMaxLevel = this.getCardDefinition( gearCardInstance.definitionId );

        if( gearLevel >= gearMaxLevel )
        {
            maxLevelBonus = 1.3;
        }

        var unitPower =
        {
            "attack": ( ( unitStatus.status1 * statusMultiplier["status1"] ) + ( unitStatus.status2 * statusMultiplier["status2"] ) + ( unitStatus.status3 * statusMultiplier["status3"] ) ) * maxLevelBonus,
            "hp": ( unitStatus.status1 + unitStatus.status2 + unitStatus.status3 )
        };
        return unitPower;
    },

    getUnitPowerWithId: function( pilotCardInstanceId, gearCardInstanceId, status, position )
    {
        var pilotCardInstance = this.getPlayerCardById( pilotCardInstanceId );
        var gearCardInstance = this.getPlayerCardById( gearCardInstanceId );
        var unitStatus = this.getUnitStatusWithSkill( pilotCardInstance, gearCardInstance );

        var statusMultiplier =
        {
            "status1": 1,
            "status2": 1,
            "status3": 1
        };
        statusMultiplier[status] = DECK_POSITION_MULTIPLIER[position];

        var unitPower =
        {
            "attack": ( ( unitStatus.status1 * statusMultiplier["status1"] ) + ( unitStatus.status2 * statusMultiplier["status2"] ) + ( unitStatus.status3 * statusMultiplier["status3"] ) ),
            "hp": ( unitStatus.status1 + unitStatus.status2 + unitStatus.status3 )
        };
        return unitPower;
    },

    getAttackAndHPWithStatus: function( unitStatus, position, status )
    {
        var statusMultiplier =
        {
            "status1": 1,
            "status2": 1,
            "status3": 1
        };
        statusMultiplier[status] = DECK_POSITION_MULTIPLIER[position];

        var unitPower =
        {
            "attack": ( ( unitStatus.status1 * statusMultiplier["status1"] ) + ( unitStatus.status2 * statusMultiplier["status2"] ) + ( unitStatus.status3 * statusMultiplier["status3"] ) ),
            "hp": ( unitStatus.status1 + unitStatus.status2 + unitStatus.status3 )
        };
        return unitPower;
    },

    getCardSellingPrice: function( cardInstance )
    {
        var cardDefinition = this.getCardDefinition( cardInstance.definitionId );
        return cardDefinition.initialSellingPrice;
    },

    getCardMaxSellingPrice: function( cardDefinition )
    {
        return cardDefinition.initialSellingPrice;
    },

    // FIXME: Localization mission
    getCardName: function( definitionId )
    {
        if( this.m_dictionaryDetailList != undefined )
        {
            return _loc( this.m_dictionaryDetailList[definitionId].name );
        }
        return null;
    },

    // FIXME: Maybe the time should come with the card
    isCardNew: function( cardDefId )
    {
        var keys = Object.keys( this.m_playerCardHistory );
        var isNew = true;
        for( var i = 0; i < keys.length; i++ )
        {
            if( cardDefId == keys[i] )
            {
                isNew = false;
                break;
            }
        }

        return isNew;
    },

    validateCardHistory: function( cardDefId )
    {
        if( this.isCardNew( cardDefId ) == true )
        {
            this.m_playerCardHistory[cardDefId] = Server.getServerTime();
        }
    },

    getCollectionNumber: function()
    {
        var counter =
        {
            "GEAR": 0,
            "PILOT": 0
        };

        var keys = Object.keys( this.m_playerCardHistory );

        for( var i = 0; i < keys.length; i++ )
        {
            var cardDefinition = this.getCardDefinition( parseInt( keys[i] ) );
            if( cardDefinition.type == GEAR )
            {
                counter.GEAR = counter.GEAR + 1;
            }
            if( cardDefinition.type == PILOT )
            {
                counter.PILOT = counter.PILOT + 1;
            }
        }

        return counter;
    },

    getCardsNumber: function()
    {
        var counter =
        {
            "GEAR": 0,
            "PILOT": 0
        };

        var i;
        var length = this.m_cardsDetailList.length;
        for( i = 0; i < length; i++ )
        {
            var cardDefinition = this.m_cardsDetailList[i];
            if( cardDefinition.type == GEAR )
            {
                counter.GEAR = counter.GEAR + 1;
            }
            if( cardDefinition.type == PILOT )
            {
                counter.PILOT = counter.PILOT + 1;
            }
        }

        return counter;
    },

    // Returns the definition id of a random card the player has
    getRandomPlayerCard: function( type )
    {
        var cards = CardsManager.getFilteredPlayerCards(
        {
            "type": type
        } );
        var cardIndex = Math.floor( Math.random() * cards.length );
        var result = cards[cardIndex].definitionId;

        info( "GashaManager.getRandomPlayerCard result: " + result );

        return result;
    },

    getRandomDeckTuple: function()
    {
        var randomPos = ( Math.floor( ( Math.random() * 2 ) ) > 0 ? 0 : Math.floor( ( Math.random() * 2 ) ) + 1 ) + Math.floor( ( Math.random() * 3 ) ) * 3;

        return DeckManager.getPair(
        {
            "status": randomPos / 3 + 1,
            "priority": randomPos % 3 + 1
        } );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/SkillsManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/SkillsManager'] || {}; $MODULE_REGISTRY['Code/Game/SkillsManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/SkillsManager.js';

exports.SkillsManager = Core.Class.singleton(
{
    classname: "SkillsManager",

    m_skills: null,
    m_skillGroups: null,

    initialize: function()
    {
        info( "SkillsManager.initialize called." );
    },

    // Load the list of all cards details in m_cardsDetailList, and a dictionary in m_dictionaryDetailList with key "id"
    loadSkillsListDetails: function( data )
    {
        this.m_skillArray = data;
        this.m_skills = {};
        
        for( var i = 0; i < this.m_skillArray.length; ++i )
        {
            var skill = this.m_skillArray[i];
            this.m_skills[skill.id] = skill;
        }
        info( "User.loadSkillsListDetails called with data: " + JSON.stringify( this.m_skills ) );
           
    },

    getSkillById: function( skillId )
    {
        info( "User.loadSkillsListDetails skillId: " + skillId );
        var skill = this.m_skills[skillId];
        
        var clonedSkill = {
            "name"          : skill.name,
            "description"   : skill.description,
            "groupId"       : skill.groupId,
            "type"          : skill.type,
            "img"           : skill.img,
            "status"        : {"status1": skill.status["status1"], "status2": skill.status["status2"], "status3": skill.status["status3"]}
        };

        return clonedSkill;
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/DeckManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/DeckManager'] || {}; $MODULE_REGISTRY['Code/Game/DeckManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/DeckManager.js';

exports.DeckManager = Core.Class.singleton(
{
    classname       : "DeckManager",

    FIGHTER         : "status1",
    SHOOTER         : "status2",
    MANEUVER        : "status3",

    GEAR            : "gear",
    PILOT           : "pilot",
    
    MAX_TOP_CARDS   : 20,

    initialize: function()
    {
        info( "DeckManager.initialize called." );
        
        this.m_deck     = [];
    },

    initWithData: function( deckData )
    {
        info( "DeckManager intialized with data: " + JSON.stringify( deckData ) );
        var decks = deckData.clone();
        this.m_deck = decks[0];
    },

    _syncWithServerCallback: function( callback, error, data )
    {
        info( "DeckManager._syncWithServerCallback called. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

        this.m_deck = JSON.parse( data ).deck;

        info( "DeckManager._syncWithServerCallback this.m_deck=%s", JSON.stringify( this.m_deck ) );

        this._updateNewDeckLocks();

        callback && callback( true, this.m_deck );
    },

    _updateNewDeckLocks: function()
    {
        var cards = CardsManager.getPlayerCardList();
        for( var i = 0; i < cards.length; ++i )
        {
            if( this._isInDeck( cards[i].id ) )
            {
                CardsManager.lockCard( cards[i].id, true, LOCK_STATUS_DECK );
            }
            else if( cards[i].lockedStatus == LOCK_STATUS_DECK )
            {
                CardsManager.lockCard( cards[i].id, false );
            }
        }
    },

    _isInDeck: function( instanceId )
    {
        var status = this.m_deck.status1;
        for( var i = 0; i < status.length; ++i )
        {
            if( status[i].pilot == instanceId || status[i].gear == instanceId )
            {
                return true;
            }
        }

        status = this.m_deck.status2;
        for( var i = 0; i < status.length; ++i )
        {
            if( status[i].pilot == instanceId || status[i].gear == instanceId )
            {
                return true;
            }
        }

        status = this.m_deck.status3;
        for( var i = 0; i < status.length; ++i )
        {
            if( status[i].pilot == instanceId || status[i].gear == instanceId )
            {
                return true;
            }
        }

        return false;
    },

    syncWithServer: function( callback )
    {
        info( "DeckManager.syncWithServer called." );

        Server.instantiate();
        Server.getDeck( 0, false, this._syncWithServerCallback.bind( this, callback ) );
        // Server.getDeck( 0, true, this.callb );
    },

    getDeck: function()
    {
        return this.m_deck;
    },

    setDeck: function( deck, cb )
    {
        if( TutorialManager.getActiveStateId() != undefined )
        {
            this.m_deck = deck;
            return;
        }

        Server.setDeck( 0, deck, false, function( error, data )
        {
            info( "DeckManager.setDeck._innerCallback called. " );
            if( !error )
            {
                this.m_deck = deck;
            }
            this._updateNewDeckLocks();
            cb && cb( this.m_deck );
        }.bind( this ) );
    },

    addCardInSlot: function( id, type, slot, slotType )
    {
        if( slot < 0 || slot > 2 )
        {
            err( "DeckManager.addCardInSlot slot out of range" );
            return;
        }

        if( type != DeckManager.FIGHTER && type != DeckManager.SHOOTER && type != DeckManager.MANEUVER )
        {
            err( "DeckManager.addCardInSlot type not recognized" );
            return;
        }

        if( slotType != DeckManager.GEAR && slotType != DeckManager.PILOT )
        {
            err( "DeckManager.addCardInSlot slotType not recognized" );
            return;
        }

        this.m_deck[type][slot][slotType] = id;
    },

    _getSortedCardsByStatus: function( cards )
    {
        var cardsS      = [];

        for( var i = 0; i < cards.length; ++i )
        {
            var status = CardsManager.getCardStatus( cards[i] );

            var cardS =
            {
                "id": cards[i].id,
                "value": status.status1 + status.status2 + status.status3
            };
            cardsS.push( cardS );

            cardsS.compareValue     = "value";
        }

        quickSort( cardsS );

        cardsS.reverse();

        return cardsS;
    },

    _getTopCards: function( sortedCards )
    {
        var topCards = [];

        for( var i = 0; i < Math.min(sortedCards.length , DeckManager.MAX_TOP_CARDS); ++i )
        {
            topCards.push(sortedCards[i]);
        }
        
        
        return topCards;
    },
    
    _joinBestMatchesForStatus       : function( sortedPilots, sortedGear, status )
    {
        var bestUnits       = [];
        
        // PAIRS REPRESENTATION
        /*
         *  {
         *      pilot   : {id:XX, value:STATUS_SUM},
         *      gear    : {id:XX, value:STATUS_SUM},
         *      power   : UNITPOWER
         *  }
         */
        
        for(var f = 0; f < sortedPilots.length; f++)
        {
            var bestGear        = null;
            
            for(var g = 0; g < sortedGear.length; g++)
            {
                var unitPower   = CardsManager.getUnitPowerWithId(sortedPilots[f].id, sortedGear[g].id, status, 1);
                
                var added       = false;
                
                for( var h = 0; h < Math.min( bestUnits.length, sortedGear.length * 9 ); ++h )
                {
                    if( bestUnits[h].power.attack < unitPower.attack )
                    {
                        bestUnits.splice( h, 0, { pilot : sortedPilots[f].id, gear : sortedGear[g].id, power : unitPower } );
                        added   = true;
                        break;
                    }
                }
                
                if( !added  && bestUnits.length <= sortedGear.length * 9 )
                {
                    bestUnits.push( { pilot : sortedPilots[f].id, gear : sortedGear[g].id, power : unitPower } );
                }
            }
        }
        
        return bestUnits;
    },
    
    _makeDeckFromBestMatches        : function( status1Pairs, status2Pairs, status3Pairs )
    {
        var usedCards       = [];
        
        var deck            = {
            "status1"       : [],
            "status2"       : [],
            "status3"       : []
        }
        
        var status1Used     = false;
        var status2Used     = false;
        var status3Used     = false;
        
        for( var i = 0; i < 3 ; ++i )
        {
            //STATUS 1
            for( var j = 0; j < status1Pairs.length; j++)
            {
                if( usedCards.indexOf( status1Pairs[j].pilot ) < 0 && usedCards.indexOf( status1Pairs[j].gear ) < 0)
                {
                    usedCards.push( status1Pairs[j].pilot );
                    usedCards.push( status1Pairs[j].gear );
                
                    deck.status1.push(
                        {
                            "pilot"     : status1Pairs[j].pilot,
                            "gear"      : status1Pairs[j].gear
                        }
                    );
                    break;
                }
            }
            
            //STATUS2
            for( var j = 0; j < status2Pairs.length; j++)
            {
                if( usedCards.indexOf( status2Pairs[j].pilot ) < 0 && usedCards.indexOf( status2Pairs[j].gear ) < 0)
                {
                    usedCards.push( status2Pairs[j].pilot );
                    usedCards.push( status2Pairs[j].gear );
                
                    deck.status2.push(
                        {
                            "pilot"     : status2Pairs[j].pilot,
                            "gear"      : status2Pairs[j].gear
                        }
                    );
                    break;
                }
            }
            
            //STATUS3
            for( var j = 0; j < status3Pairs.length; j++)
            {
                if( usedCards.indexOf( status3Pairs[j].pilot ) < 0 && usedCards.indexOf( status3Pairs[j].gear ) < 0)
                {
                    usedCards.push( status3Pairs[j].pilot );
                    usedCards.push( status3Pairs[j].gear );
                
                    deck.status3.push(
                        {
                            "pilot"     : status3Pairs[j].pilot,
                            "gear"      : status3Pairs[j].gear
                        }
                    );
                    break;
                }
            }
        }
        
        return deck;
    },

    getRecommendedDeck: function()
    {
        info( "DeckManager.getRecomendedDeck called." );

        var pilotCards = CardsManager.getFilteredPlayerCards(
        {
            "type": PILOT
        } );
        var gearCards = CardsManager.getFilteredPlayerCards(
        {
            "type": GEAR
        } );

        info( "DeckManager.getRecomendedDeck pilotCards: " + JSON.stringify( pilotCards ) );
        info( "DeckManager.getRecomendedDeck gearCards: " + JSON.stringify( gearCards ) );

        var sortedPilots = this._getSortedCardsByStatus( pilotCards );
        var sortedGear = this._getSortedCardsByStatus( gearCards );

        info( "DeckManager.getRecomendedDeck sortedPilots: " + JSON.stringify( sortedPilots ) );
        info( "DeckManager.getRecomendedDeck sortedGear: " + JSON.stringify( sortedGear ) );

        var topPilots = this._getTopCards( sortedPilots );
        var topGear = this._getTopCards( sortedGear );

        info( "DeckManager.getRecomendedDeck topPilots: " + JSON.stringify( topPilots ) );
        info( "DeckManager.getRecomendedDeck topGear: " + JSON.stringify( topGear ) );


        var bestMatchesStatus1      = this._joinBestMatchesForStatus( topPilots, topGear, "status1" );
        var bestMatchesStatus2      = this._joinBestMatchesForStatus( topPilots, topGear, "status2" );
        var bestMatchesStatus3      = this._joinBestMatchesForStatus( topPilots, topGear, "status3" );

        info( "DeckManager.getRecommendedDeck bestMatchesStatus1 > "+JSON.stringify( bestMatchesStatus1 ) );
        info( "DeckManager.getRecommendedDeck bestMatchesStatus2 > "+JSON.stringify( bestMatchesStatus2 ) );
        info( "DeckManager.getRecommendedDeck bestMatchesStatus3 > "+JSON.stringify( bestMatchesStatus3 ) );

        var recommendedDeck = this._makeDeckFromBestMatches( bestMatchesStatus1, bestMatchesStatus2, bestMatchesStatus3 );
        
        info( "DeckManager.getRecommendedDeck recommendedDeck > "+JSON.stringify( recommendedDeck ) );

        return recommendedDeck;
    },

    getRandomPair: function()
    {
        var position =
        {
            "status": ( Math.floor( Math.random() * 3 ) + 1 ),
            "priority": ( Math.floor( Math.random() * 3 ) + 1 )
        };

        return this.getPair( position );
    },

    // Receives {"status": 1/3, "priority": 1/3}
    getPair: function( position )
    {
        switch( position.status )
        {
            case 1:
                return this.m_deck.status1[position.priority - 1];
            case 2:
                return this.m_deck.status2[position.priority - 1];
            case 3:
                return this.m_deck.status3[position.priority - 1];
            default:
                return this.m_deck.status1[0];
        }
    },

    setInitialDeck: function( deckIndex, cb )
    {
        //Setting the initial deck
        info("DeckManager.setInitialDeck called");
        Server.setInitialDeck( 0, deckIndex, true, function( error, data )
        {
            info("DeckManager.setInitialDeck inner callback... error" + JSON.stringify( error) + "  data: " + JSON.stringify(data) );
            if( error != undefined )
            {
                cb( false );
            }
            else
            {
                //Getting the user information
                var func = function( _error, data)
                {
                    info("DeckManager.setInitialDeck inner func... error" + JSON.stringify( _error) + "  data: " + JSON.stringify(data) );
                    var dataObject  = JSON.parse( data );
                    User.m_userData = dataObject;
                    Server.setUpServerTime( dataObject.serverTime );

                    User.setUpManagers();
                    User.updateGashaDates();
                    cb( true );
                };

                info("DeckManager.setInitialDeck ");
                Server.getUserFromServer( func );
            }
        } );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/SpecialCard'] = function(){var exports = $MODULE_REGISTRY['Code/Game/SpecialCard'] || {}; $MODULE_REGISTRY['Code/Game/SpecialCard'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/SpecialCard.js';

exports.SpecialCard     = GL2.Node.subclass
({
    classname : "SpecialCard",

    NUM_FRAMES : 3,

    initialize : function( frameInfo )
    {
        info("SpecialCard.initialize called " + JSON.stringify( frameInfo) );

        this.m_Frames = [];
        this.m_MotionListener = null;
        this.m_FrameSize  = frameInfo._size;

        //this.m_background = new GL2.Sprite();
        //this.m_background.setImage("1pxorange.png", [this.m_FrameSize._width, this.m_FrameSize._height], [0.5,0.5]);
        //this.addChild( this.m_background );

        for(var i = 0; i < this.NUM_FRAMES; i++)
        {
            var sprite = new GL2.Sprite();
            sprite.setAlpha( 0 );
            sprite.setImage( "1pxalpha0.png", [this.m_FrameSize._width, this.m_FrameSize._height], [0.5,0.5] );
            this.m_Frames.push( sprite );
            this.addChild( sprite );
        }


    },

    refresh : function( cardDefinition, cb )
    {
        info("SpecialCard.refresh called. cardDefinition=%s", JSON.stringify( cardDefinition ) );

        if ( cardDefinition.rarity != RARITY.superRare )
        {
            info("SpecialCard.refresh cardDefinition.rarity != 4, hidding images.. cardDefinition.rarity=%s", cardDefinition.rarity );
            if( this.m_MotionListener )
            {
                this.m_MotionListener.destroy();
                this.m_MotionListener = null;
            }

            for(var i = 0; i < this.NUM_FRAMES; i++)
            {
                this.m_Frames[i].setImage( "1pxalpha0.png", [this.m_FrameSize._width, this.m_FrameSize._height], [0.5,0.5] );
            }
            cb();
            return;
        }

        //this.m_background.setImage("1pxorange.png", [this.m_FrameSize._width, this.m_FrameSize._height], [0.5,0.5]);

        CardsManager.loadSpecialCardImages( cardDefinition.id, IMAGE_SIZE.BIGGEST, function( images )
            {
                if (images == null )
                {
                    cb( "Missing Asset" );
                    return;
                }
                info("SpecialCard.refresh._internalCallback called. images=%s", JSON.stringify( images ) );
                for(var i = 0; i < this.NUM_FRAMES; i++)
                {
                    this.m_Frames[i].setImage( images[i], [this.m_FrameSize._width, this.m_FrameSize._height], [0.5,0.5] );
                    this.m_Frames[i].setAlpha(0);
                }

                if( this.m_MotionListener == null )
                {
                     this.m_MotionListener = new Core.MessageListener();
                     Device.MotionEmitter.addListener( this.m_MotionListener, this.motionUpdate.bind(this), 200 );
                }
                cb();
            }.bind( this )
        );
    },

    motionUpdate : function(motion)
    {
        var motionYAxis     = 0;

        //actually the axis are backwards...so accel X is actually accel X
        if(Core.Capabilities.getHasAccel())
        {
            motionYAxis     = motion._accel.x;
        }
        else if(Core.Capabilities.getHasGyro())
        {
            motionYAxis     = motion._gyro.x;
        }

        var totalFrames = this.m_Frames.length;
        var angleFactor = ( ( totalFrames / 10 ) * 1.3 );
        var adjustedAngle = Math.abs( motionYAxis * angleFactor );
        var backFrame = Math.floor( adjustedAngle % totalFrames );
        var alpha = ( adjustedAngle % 1 );
        var frontFrame = ( backFrame == ( totalFrames - 1 ) ) ?  0 : ( backFrame + 1);

        for(var i = 0; i < totalFrames; ++i)
        {

            if( i == backFrame )
            {
                this.m_Frames[i].setDepth(101);
                this.m_Frames[i].setAlpha(1);
            }
            else if ( i == frontFrame )
            {
                this.m_Frames[i].setDepth(102);
                this.m_Frames[i].setAlpha( alpha );
            }
            else
            {
                this.m_Frames[i].setDepth(100);
            }
        }
    },

    destroy: function( $super )
    {
        info( "SpecialCard.destroy, called." );
        //ToDo: apparently the sprites are removed from somewhere else
        if( this.m_MotionListener )
        {
            this.m_MotionListener.destroy();
            this.m_MotionListener = null;
        }

        for(var i = 0; i < this.NUM_FRAMES; i++ )
        {
            var sprite = this.m_Frames[i];
            var parent = sprite.getParent();
            if( parent )
            {
                sprite.destroy();
            }
        }
        $super();
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/Background'] = function(){var exports = $MODULE_REGISTRY['Code/Game/Background'] || {}; $MODULE_REGISTRY['Code/Game/Background'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/Background.js';

exports.Background = Core.Class.subclass( {
    classname : "Background",

    initialize : function()
    {
        Core.UpdateEmitter.addListener( new Core.MessageListener(), this.onUpdate.bind( this ) );

        this.m_background = background;
        this.m_f = true;
    },

    onUpdate : function()
    {
        if( this.m_f )
        {
            if( this.m_background._position._x + SCREEN_WIDTH <= this.m_background.getFrame()._size._width / 2 )
            {
                this.m_f = false;
            }
            this.m_background.setPosition( this.m_background._position._x - 0.1, this.m_background._position._y );
        }
        else
        {
            if( this.m_background._position._x >= this.m_background.getFrame()._size._width / 2 )
            {
                this.m_f = true;
            }
            this.m_background.setPosition( this.m_background._position._x + 0.1, this.m_background._position._y );
        }
    },

    setBackgrounds : function()
    {
        var realSize = ResourceManager.getRealSizeFor( "ui_bg.jpg" );
        var scale = SCREEN_HEIGHT / realSize.h;

        background.setFrame( 0, 0, realSize.w * scale, SCREEN_HEIGHT );
        background.setImage( "ui_bg.jpg" );

        background.setPosition( realSize.w * scale * 0.5, background._position._y );

    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/QuestManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/QuestManager'] || {}; $MODULE_REGISTRY['Code/Game/QuestManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/QuestManager.js';

exports.QuestManager = Core.Class.singleton(
{
    classname: "QuestManager",

    m_questData: null,
    m_playerQuestData: null,
    m_luckyChanceData: null,

    m_worldsDictionary:
    {},
    m_stagesDictionary:
    {},
    m_missionsDictionary:
    {},

    m_luckyChanceDictionary:
    {},

    m_playerWorldsDictionary:
    {},
    m_playerStagesDictionary:
    {},
    m_playerMissionsDictionary:
    {},
    m_bossesPassed:
    {},

    PLAYER: 1,
    WORLD: 2,

    loadBanner: function( worldId, stageId, cb )
    {
        var imageURL;

        if (cb != undefined)
        {

            if (worldId < 10) worldId = "0" + worldId;
            if (stageId < 10) stageId = "0" + stageId;

            imageURL = sprintf("world_%s_stage_%s.jpg", worldId, stageId);
        }

        else
        {
            cb = stageId;
            if (worldId < 10) worldId = "0" + worldId;
            imageURL = sprintf("world_%s.jpg", worldId);
        }


        info( "QuestManager.loadBanner imageURL=%s.", imageURL );

        var wrap = function()
        {
            cb( imageURL );
        };
        ResourceManager.preLoadResource( imageURL, wrap );
    },

    getNextStage: function(worldId, stageId)
    {
        info( "QuestManager.getNextStage called... worldId: " + worldId + ", stageId: " + stageId );
        var worldData ;
        var retVal = {};
        var stageData;

        retVal.stageId = null;
        retVal.worldId = null;

        var keys = Object.keys( this.m_worldsDictionary );
        for (var j = 0; j < keys.length; j++)
        {
            worldData = this.m_worldsDictionary[ keys[j] ];
            if( worldData  == null )
            {
                continue;
            }
            if ( worldData.id == worldId )
            {
                for (var i = 0; i < worldData.stages.length; i++)
                {
                    if (worldData.stages[i].id !== stageId)
                    {
                        continue;
                    }

                    stageData = worldData.stages[i];

                    if (worldData.stages[ i + 1 ] !== undefined && worldData.stages[i + 1] !== null)
                    {
                        retVal.stageId = worldData.stages[i + 1].id;
                        retVal.worldId = worldData.id;

                        return retVal;
                    }

                    if( keys[j + 1] !== undefined && keys[j + 1] !== null &&
                        this.m_worldsDictionary[ keys[j + 1] ] !== null && this.m_worldsDictionary[ keys[j + 1] ] !== undefined )
                    {
                        var nextWorldData = this.m_worldsDictionary[ keys[j + 1] ];
                        retVal.stageId = null;
                        retVal.worldId = nextWorldData.id;

                        return retVal;
                    }
                    return retVal;
                }
            }
        }

        return retVal;
    },

    getFakeStageId : function( worldId, stageId )
    {
        info( "QuestManager.getFakeStageId called" );
        var rtval, counter, world, stage;

        world = this.m_worldsDictionary[ worldId ];
        counter = 0;

        if( world === undefined || world === null )
        {
            return 0;
        }

        for (var i = 0; i < world.stages.length; i++)
        {
            counter ++;
            stage = world.stages[i];
            if (stage.id == stageId)
            {
                return counter;
            }

        }

       return 0;
    },

    initialize: function()
    {
        info( "QuestManager.initialize called" );
        this.syncWithServer( function()
        {
            info( "QuestManager.initialize._innerCallback called" );
        }.bind( this ) );
    },

    initWithData: function( data )
    {
        info( "QuestManager.initWithData called. data=%s", JSON.stringify( data ) );

        if( !data )
        {
            data = [];
        }
        this.m_playerQuestData = data;
        
        this.setUpPlayerDictionaries( this.m_playerQuestData, this.m_playerMissionsDictionary );
        // this.initialize();
        // this.m_playerMissionsDictionary = data;
    },

    updateMission: function(data)
    {
        this.m_playerMissionsDictionary[data.missionId] = data;
    },

    setUpPlayerDictionaries: function( data, dict )
    {
        for( var i = 0; i < data.length; i++ )
        {
            dict[data[i].missionId] = data[i];
        }
    },

    setUpBosses: function( data )
    {
        info( "QuestManager.setUpBosses called. data=%s", JSON.stringify( data ) );
        for( var i = 0; i < data.length; i++ )
        {
            this.m_bossesPassed[data[i]] = true;
        }
    },

    isBossPassed: function(stageId)
    {
        return this.m_bossesPassed[stageId];
    },

    loadMissionsListDetails: function( data )
    {
        info( "QuestManager.loadMissionsListDetails called. data=%s", JSON.stringify( data ) );
        this.m_questData = data;
        this.setUpDictionaries( this.m_questData.worlds, this.m_worldsDictionary, this.WORLD );
    },

    loadEnemyChance : function( data )
    {
        info( "QuestManager.loadEnemyChance called. data=%s", JSON.stringify( data ) );
        var i, enemy;

        this.m_enemyChanceData = {};
        for( i = 0; i < data.length; i++ )
        {
            enemy = data[i];
            this.m_enemyChanceData[ enemy.id ] = enemy;
        }

        info( "QuestManager.loadEnemyChance this.m_enemyChanceData=%s", JSON.stringify( this.m_enemyChanceData ) );
    },

    loadLuckyChanceListDetails: function( data )
    {
        info( "QuestManager.loadLuckyChanceListDetails called. data=%s", JSON.stringify( data ) );
        this.m_luckyChanceData = data;
        this.setUpLuckyChanceDictionaries( this.m_luckyChanceData, this.m_luckyChanceDictionary );
    },

    setUpLuckyChanceDictionaries: function( data, dictionary )
    {
        // TODO: Implement this function
        this.m_luckyChanceDictionary = data; // ??????? Change this to adapt the require_d structure!!
    },

    getLuckyChanceDictionaries: function()
    {
        return this.m_luckyChanceDictionary;
    },

    setUpDictionaries: function( data, dictionary, type )
    {
        if( !data )
        {
            return null;
        }

        for( var i = 0; i < data.length; i++ )
        {
            if( data[i].stages )
            {
                if( type == this.WORLD )
                {
                    this.setUpDictionaries( data[i].stages, this.m_stagesDictionary, type );
                }
                else
                {
                    this.setUpDictionaries( data[i].stages, this.m_playerStagesDictionary, type );
                }
            }
            else if( data[i].missions )
            {
                if( type == this.WORLD )
                {
                    this.setUpDictionaries( data[i].missions, this.m_missionsDictionary, type );
                }
                else
                {
                    this.setUpDictionaries( data[i].missions, this.m_playerMissionsDictionary, type );
                }
            }
            dictionary[data[i].id] = data[i];
        }
    },

    syncWithServer: function( cb )
    {
        /* Should connect with the server here */
        this.m_questData =
        {
            "version": 1,
            "worlds": [
            {
                "id": 1,
                "worldName": "First World",
                "minLevelRequired": 0,
                "preReqWorldId": 0,
                "stages": [
                {
                    "id": 1,
                    "stageName": "Starter Mission",
                    "preReqStageId": 0,
                    "minLevelRequired": 0,
                    "missions": [
                    {
                        "id": 1,
                        "missionName": "Round 1: Noobs Die Here",
                        "xpReward": 5,
                        "numberOfRounds": 10,
                        "energyPerRound": 2,
                        "cards": [
                        {
                            "id": 12000091,
                            "probability": 50
                        },
                        {
                            "id": 12000091,
                            "probability": 50
                        } ],
                        "enabled": "true",
                        "preReqMissionId": 0,
                        "minLevelRequired": 0
                    },
                    {
                        "id": 2,
                        "missionName": "Round 2: Revenge of the Noobs",
                        "xpReward": 10,
                        "numberOfRounds": 10,
                        "energyPerRound": 4,
                        "cards": [
                        {
                            "id": 12000091,
                            "probability": 95
                        },
                        {
                            "id": 12000091,
                            "probability": 5
                        } ],
                        "enabled": "true",
                        "preReqMissionId": 1,
                        "minLevelRequired": 0
                    } ]
                } ]
            } ]
        };
        if( cb && typeof ( cb ) == "function" )
        {
            cb();
        }
    },

    hasPlayerUnlockedCard: function( worldId, stageId, missionId, cardId )
    {
        var mission;

        mission = this.getPlayerMission( missionId );

        if( !mission )
        {
            return false;
        }

        for( var j = 0; j < mission.cardRewards.length; j++ )
        {
            if( mission.cardRewards[j] == cardId )
            {
                return true;
            }
        }
        return false;

    },

    getPlayerMission: function( missionId )
    {
        return this.m_playerMissionsDictionary[missionId];
    },

    areStageRequirementsPassed: function( worldId, stageId )
    {
        if( this.m_stagesDictionary[stageId] )
        {
            var stage = this.m_stagesDictionary[stageId];

            if( stage.preReqStageId == 0 )
            {
                return true;
            }

            if( this.m_stagesDictionary[stage.preReqStageId] )
            {

                var preReqStage = this.m_stagesDictionary[stage.preReqStageId];
                var progress = this.getPlayerProgressForStage( worldId, preReqStage.id );

                if( progress.numberOfRounds == progress.completedRounds && this.m_bossesPassed[stage.preReqStageId] )
                {
                    return true;
                }
            }
        }
        return false;
    },

    areMissionRequirementsPassed: function( missionId )
    {
        if( this.m_missionsDictionary[missionId] )
        {
            var mission = this.m_missionsDictionary[missionId];

            if( mission.preReqMissionId == 0 )
            {
                return true;
            }

            // TODO Prepare if there's a use for type 2. Right now it's useless, as the ids are unique.
            else if( mission.preReqType == 1 || mission.preReqType == 2 )
            {
                if( this.m_missionsDictionary[mission.preReqMissionId] )
                {
                    var preReq = this.m_missionsDictionary[mission.preReqMissionId];
                    var missionRounds = preReq.numberOfRounds;
                    if( this.m_playerMissionsDictionary[mission.preReqMissionId] )
                    {
                        if( this.m_playerMissionsDictionary[mission.preReqMissionId].roundNumber >= missionRounds )
                        {
                            return true;
                        }
                    }
                    else
                    {
                        return false;
                    }

                }
            }
        }
        return false;
    },

    getFullUserQuestData: function()
    {
        return this.m_playerQuestData;
    },


    isMissionComplete: function( worldId, stageId, missionId)
    {
        var progress = this.getPlayerProgressForMission( worldId, stageId, missionId );

        if( progress.numberOfRounds == progress.completedRounds )
        {
            return true;
        }

        return false;
    },

    getPlayerProgressForMission: function( worldId, stageId, missionId )
    {
        if( this.m_questData == null )
        {
            warn( "QuestManager.getPlayerProgressForMission -> no worlds data loaded!" );
            return -1;
        }

        var numberOfRounds = 0;
        var totalCards = 0;
        var collectedCards = 0;

        numberOfRounds = this.m_missionsDictionary[missionId].numberOfRounds;
        totalCards = this.m_missionsDictionary[missionId].cards.length;

        if( !this.m_playerMissionsDictionary[missionId] )
        {
            var returnValue =
            {
                "totalCards": totalCards,
                "collectedCards": 0,
                "numberOfRounds": numberOfRounds,
                "completedRounds": 0
            };

            return returnValue;
        }
        roundsNumber = this.m_playerMissionsDictionary[missionId].roundNumber;
        for( var i = 0; i < this.m_playerMissionsDictionary[missionId].cardRewards.length; i++ )
        {
            if( this.m_playerMissionsDictionary[missionId].cardRewards[i] )
            {
                collectedCards++;
            }
        }

        var returnValue =
        {
            "totalCards": totalCards,
            "collectedCards": collectedCards,
            "numberOfRounds": numberOfRounds,
            "completedRounds": roundsNumber
        };

        return returnValue;
    },

    getPlayerProgressForStage: function( worldId, stageId )
    {
        if( this.m_questData == null )
        {
            warn( "QuestManager.getPlayerProgressForStage -> no worlds data loaded!" );
            return -1;
        }

        var worldData = this.getMissionsForStage( worldId, stageId );

        var cardsCollected = 0;
        var cardsTotal = 0;
        var roundsCompleted = 0;
        var roundsTotal = 0;

        var i, progress;
        for( i = 0; i < worldData.length; i++ )
        {
            progress = this.getPlayerProgressForMission( worldId, stageId, worldData[i].id );
            cardsCollected += progress.collectedCards;
            cardsTotal += progress.totalCards;
            roundsCompleted += progress.completedRounds;
            roundsTotal += progress.numberOfRounds;
        }

        var result =
        {
            "totalCards": cardsTotal,
            "collectedCards": cardsCollected,
            "numberOfRounds": roundsTotal,
            "completedRounds": roundsCompleted
        };

        info( "QuestManager.getPlayerProgressForStage returning. worldId=%s, stageId=%s, result=%s", worldId, stageId, JSON.stringify( result ) );

        return result;
    },

    getPlayerProgressForWorld: function( worldId )
    {
        if( this.m_questData == null )
        {
            warn( "QuestManager.getPlayerProgressForWorld -> no worlds data loaded!" );
            return -1;
        }

        var worldData = this.getStagesForWorld( worldId );
        var cardsCollected = 0;
        var cardsTotal = 0;
        var roundsCompleted = 0;
        var roundsTotal = 0;

        for( var i = 0; i < worldData.length; i++ )
        {
            var progress = this.getPlayerProgressForStage( worldId, worldData[i].id );
            cardsCollected += progress.collectedCards;
            cardsTotal += progress.totalCards;
            roundsCompleted += progress.completedRounds;
            roundsTotal += progress.numberOfRounds;
        }

        var result =
        {
            "totalCards": cardsTotal,
            "collectedCards": cardsCollected,
            "numberOfRounds": roundsTotal,
            "completedRounds": roundsCompleted
        };
        info( "QuestManager.getPlayerProgressForWorld returning. result=%s", JSON.stringify( result ) );

        return result;
    },

    getPlayerMissionsForStage: function( worldId, stageId )
    {
        if( this.m_playerStagesDictionary[stageId] )
        {
            return this.m_playerStagesDictionary[stageId].mission;
        }
        else
        {
            return null;
        }
    },

    getPlayerStagesForWorld: function( worldId )
    {
        if( this.m_playerWorldsDictionary[worldId] )
        {
            return this.m_playerWorldsDictionary[worldId].stages;
        }
        return null;
    },

    getFullQuestData: function()
    {
        return this.m_questData;
    },

    getWorlds: function()
    {
        var keys, ids, i;

        keys = Object.keys( this.m_questData.worlds );
        ids = [];

        for( i = 0; i < keys.length; i++ )
        {
            if( this.m_questData.worlds[keys[i]].id == 0 )
            {
                continue;
            }
            world = this.m_questData.worlds[keys[i]];
            ids.push( world.id );
        }
        info( "QuestManager.getWorlds returning. keys=%s", JSON.stringify( ids ) );
        return ids;
    },

    getWorldData: function( worldId )
    {
        info( "QuestManager.getWorldData called. worldId=%s", JSON.stringify( worldId ) );

        if( this.m_questData == null )
        {
            warn( "QuestManager.getWorldData Warning, this.m_questData==null" );
        }

        return this.m_worldsDictionary[worldId];
    },

    getStagesForWorld: function( worldId )
    {
        if( this.m_questData == null )
        {
            warn( "QuestManager.getStagesForWorld called without quests data" );
        }

        if( this.m_worldsDictionary[worldId] )
        {
            return this.m_worldsDictionary[worldId].stages;
        }
        else
        {
            return null;
        }
    },

    getAvailableStagesForWorld: function( worldId )
    {
        var avStages = [];
        var stages = this.getStagesForWorld( worldId );

        for( var key in stages )
        {
            if( this.areStageRequirementsPassed( worldId, stages[key].id ) )
            {
                avStages.push( stages[key] );
            }
        }
        return avStages;

    },

    getMissionsForStage: function( worldId, stageId )
    {
        if( this.m_questData == null )
        {
            warn( "QuestManager.getMissionsForStage called without quests data" );
        }

        if( this.m_stagesDictionary[stageId] )
        {
            return this.m_stagesDictionary[stageId].missions;
        }

        return null;
    },

    getMission: function( missionId )
    {
        if( this.m_missionsDictionary[missionId] )
        {
            return this.m_missionsDictionary[missionId];
        }
        return null;
    },

    getStageOfWorld: function( worldId, stageId )
    {
        if( this.m_questData == null )
        {
            warn( "QuestManager.getMissionsForStage called without quests data" );
        }

        return this.m_stagesDictionary[stageId];
    },

    completeRound: function( missionId, cb )
    {
        info( "QuestManager.completeRound called. missionId=%s", missionId );

        if( TutorialManager.getActiveStateId() != null )
        {
            if( this.m_tutorialRound == undefined )
            {
                this.m_tutorialRound = 0;
            }
            this.m_tutorialRound++;

            var genericServerResponse;

            genericServerResponse = {
                "xp" : 0,
                "energy" : 20,
                "missionState" : {
                    "cardRewards" : [],
                    "missionId" : -1,
                    "progress" : 0,
                    "roundNumber" : this.m_tutorialRound,
                    "worldId" : 0
                },
                "newReward":
                {
                    "type": -1,
                    "value": -1
                }
            };

            info( "QuestManager.completeRound m_tutorialRound=%s, User.getXP=%s, User.getLevel=%s, User.getXPNeededForLevel(%s)=%s",
                this.m_tutorialRound, User.getXP(), User.getLevel(), User.getLevel() + 1, User.getXPNeededForLevel( User.getLevel() + 1 ) );

            var deltaXP = ( User.getXPNeededForLevel( 2 ) / 6 );
            if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION )
            {
                genericServerResponse.missionId = 40000001;
                if( this.m_tutorialRound == 1 )
                {
                    genericServerResponse.energy                = 90;
                    genericServerResponse.xp                    = User.getXP() + deltaXP;
                    genericServerResponse.missionState.progress = 0.3;
                    genericServerResponse.newReward.type        = MISSION_REWARDS.GOLD;
                    genericServerResponse.newReward.value       = 222 + User.m_currency;

                }
                else if( this.m_tutorialRound == 2 )
                {
                    var cardInstance = CardsManager.getPlayerCardById( 20 ); // TODO This data is duplicated in TutorialManager

                    genericServerResponse.energy                = 80;
                    genericServerResponse.xp                    = User.getXP() + deltaXP;
                    genericServerResponse.missionState.progress = 0.6;
                    genericServerResponse.newReward.type        = MISSION_REWARDS.CARD;
                    genericServerResponse.newReward.value       = cardInstance;
                }
                else if( this.m_tutorialRound == 3 )
                {
                    genericServerResponse.energy                = 65;
                    genericServerResponse.xp                    = User.getXP() + deltaXP;
                    genericServerResponse.missionState.progress = 1;
                    genericServerResponse.newReward.type        = MISSION_REWARDS.GOLD;
                    genericServerResponse.newReward.value       = 220 + User.m_currency;
                }
                else
                {
                    err( "QuestManager.completeRound Error, unknown m_tutorialRound. m_tutorialRound=%s", this.m_tutorialRound );
                }
            }
            else if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION2 )
            {
                genericServerResponse.missionId = 40000002;
                if( this.m_tutorialRound == 1 )
                {
                    genericServerResponse.energy                = 50;
                    genericServerResponse.xp                    = User.getXP() + deltaXP;
                    genericServerResponse.missionState.progress = 0.33;
                    genericServerResponse.newReward.type        = MISSION_REWARDS.GOLD;
                    genericServerResponse.newReward.value       = 198 + User.m_currency;
                }
                else if( this.m_tutorialRound == 2 )
                {
                    var cardInstance = CardsManager.getPlayerCardById( 21 ); // TODO This data is duplicated in TutorialManager

                    genericServerResponse.energy                = 35;
                    genericServerResponse.xp                    = User.getXP() + deltaXP;
                    genericServerResponse.missionState.progress = 0.66;
                    genericServerResponse.newReward.type        = MISSION_REWARDS.CARD;
                    genericServerResponse.newReward.value       = cardInstance;
                }
                else if( this.m_tutorialRound == 3 )
                {
                    genericServerResponse.energy                = 25;
                    genericServerResponse.xp                    = User.getXPNeededForLevel( 2 );
                    genericServerResponse.missionState.progress = 1;
                    genericServerResponse.newReward.type        = MISSION_REWARDS.GOLD;
                    genericServerResponse.newReward.value       = 200 + User.m_currency;
                }
                else
                {
                    err( "QuestManager.completeRound Error, unknown m_tutorialRound. m_tutorialRound=%s", this.m_tutorialRound );
                }
            }

            var genericServerResponseStr = JSON.stringify( genericServerResponse );
            info( "QuestManager.completeRound [TUTORIAL] returning. genericServerResponseStr=%s", genericServerResponseStr );

            if( typeof ( cb ) == "function" )
            {
                cb( false, genericServerResponseStr );
            }
        }
        else
        {
            Server.completeRound( missionId, cb );
        }
    },

    getMissionData: function( data, cb )
    {
        info( "QustManager.getMissionData called...data: " + JSON.stringify( data ) );
        if( TutorialManager.getActiveStateId() != null )
        {
            var serverResponse =
            {
                "missionState":
                {
                    "cardRewards": [],
                    "missionId": 40000001,
                    "progress": 0,
                    "roundNumber": 2,
                    "worldId": 0
                }
            };

            if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION )
            {
                // serverResponse.missionState.progress = 0.5;
                serverResponse.missionState.roundNumber = 3;
            }
            else if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION2 )
            {
                // serverResponse.missionState.progress = 1;
                serverResponse.missionState.roundNumber = 3;
            }

            var serverResponseStr = JSON.stringify( serverResponse );
            info( "QuestManager.getMissionData [TUTORIAL] returning. serverResponseStr=%s", serverResponseStr );

            if( typeof ( cb ) == "function" )
            {
                cb( true, serverResponse );
            }
        }
        else
        {
            Server.getMissionData( data, function( error, data )
            {
                if( error )
                {
                    err( "QuestManager.getMissionData Error: %s", JSON.stringify( error ) );
                    cb && cb( false, null );
                    return;
                }

                if( !data )
                {
                    err( "QuestManager.getMissionData Error. No data received! data=%s", JSON.stringify( data ) );
                    cb && cb( false, null );
                    return;
                }

                data = JSON.parse( data );

                if( typeof ( cb ) == "function" )
                {
                    cb( true, data );
                }
            } );
        }
    },

    getRewards: function()
    {
        a =
        {
            "0":
            {
                "id": 0,
                "stageName": "stage_name_0",
                "preReqStageId": 0,
                "minLevelRequired": 0,
                "boss":
                {
                    "id": 0,
                    "pilotId": 11000251,
                    "gearId": 12000151,
                    "hp": 1500,
                    "attack": 100,
                    "dialog": "boss_dialog_0"
                },
                "missions": [
                {
                    "id": 40000001,
                    "missionName": "mission_name_40000001",
                    "xpReward": 10,
                    "numberOfRounds": 3,
                    "energyPerRound": 10,
                    "enabled": true,
                    "preReqMissionId": 0,
                    "preReqType": 1,
                    "minLevelRequired": 0,
                    "rewards": [
                    {
                        "type": 1,
                        "rate": 50,
                        "value": 180
                    },
                    {
                        "type": 2,
                        "rate": 50,
                        "value": 12000141
                    } ],
                    "cards": [ 12000141 ]
                },
                {
                    "id": 40000002,
                    "missionName": "mission_name_40000002",
                    "xpReward": 10,
                    "numberOfRounds": 3,
                    "energyPerRound": 10,
                    "enabled": true,
                    "preReqMissionId": 40000001,
                    "preReqType": 1,
                    "minLevelRequired": 0,
                    "rewards": [
                    {
                        "type": 1,
                        "rate": 50,
                        "value": 180
                    },
                    {
                        "type": 2,
                        "rate": 50,
                        "value": 12000141
                    } ],
                    "cards": [ 12000141 ]
                } ]
            }
        }

        return a;
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/BattleManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/BattleManager'] || {}; $MODULE_REGISTRY['Code/Game/BattleManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/BattleManager.js';

exports.BattleManager = Core.Class.singleton(
{
    classname : "BattleManager",
    m_lastBattleData: null,

    initialize : function()
    {
        info( "BattleManager.initialize called." );
    },

    retrieveBattle: function( level, cb )
    {
        info( "BattleManager.retrieveBattle called." );
        
        Server.getBattleEnemies( level, false /* remake */,
            function( error, data )
            {
                if( error || data == undefined )
                {
                    err( "BattleManager.retrieveBattle._innerCallback Error: error=%s, data=%s", error, data );
                    this.m_lastBattleData = null;
                    cb( error, null );
                }
                else
                {
                    this.m_lastBattleData = JSON.parse( data );
                    cb( null, this.m_lastBattleData );
                }
            }.bind( this )
        );
        return;
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/ItemManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/ItemManager'] || {}; $MODULE_REGISTRY['Code/Game/ItemManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/ItemManager.js';

exports.ItemManager = Core.Class.singleton(
{
    classname: "ItemManager",

    m_itemDetailList: null,
    m_dictionaryDetailList: null,
    DEFAULT_SORT_VALUE: 1,

    m_playerItemList: null,

    initialize: function()
    {
        info( "CardsManager.initialize called." );
    },

    // Load the list of all items details in m_itemsDetailList, and a dictionary in m_dictionaryDetailList with key "id"
    // This have to be called in DataLoader. See CardsManager.loadCardListDetails.
    loadItemListDetails: function( list )
    {
        info( this.classname + ".loadItemListDetails: " + JSON.stringify( list ) );
        this.m_itemsDetailList = list;

        this.m_dictionaryDetailList =
        {};
        var i;
        var itemsDetailListLength = this.m_itemsDetailList.length;

        for( i = 0; i < itemsDetailListLength; i++ )
        {
            var itemsDetailList = this.m_itemsDetailList[i];
            this.m_dictionaryDetailList[itemsDetailList.id] = itemsDetailList;
        }

    },

    /**
     * Get the details for the item with "id" id
     * 
     * @param id
     * @return JSON: { "id": 1, "name": "loc_name" ..}
     */
    getItemDefinition: function( id )
    {
        if( this.m_dictionaryDetailList != undefined )
        {
            return this.m_dictionaryDetailList[id];
        }
        return null;
    },

    getUserExploreEnergyItems: function()
    {
        var retArray = [];
        var tempItem = null;
        for (var i = 0; i < this.m_playerItemList.length; i++)
        {
            tempItem = this.getItemDefinition(this.m_playerItemList[i].id);
            if (tempItem.category == "stat" && tempItem.stat == ITEM_STATS.EXPLORE_ENERGY)
                retArray.push(tempItem);
        }
        return retArray;
    },

    getItemDefinitionArray: function()
    {
        return this.m_itemsDetailList.clone();
    },

    getItemDefinitionDictionary: function()
    {
        return dictionaryClone( this.m_dictionaryDetailList );
    },

    _syncPlayerItemListCallback: function( cb, error, data )
    {
        info( "ItemsManager._syncPlayerItemListCallback called. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

        if( error )
        {
            err( "ItemsManager._syncPlayerItemListCallback Error: %s", JSON.stringify( error ) );
            cb && cb( false, null );
            return;
        }

        if( !data )
        {
            err( "ItemsManager._syncPlayerItemListCallback Error. No data received! data=%s", JSON.stringify( data ) );
            cb && cb( false, null );
            return;
        }

        this.m_playerItemList = ( JSON.parse( data ) ).items;
        cb && cb( true, this.m_playerItemList.items );
    },

    syncPlayerItemList: function( cb )
    {
        info( "ItemsManager.syncPlayerItemList called." );
        Server.getAllUserItems( this._syncPlayerItemListCallback.bind( this, cb ) );
    },

    // This have to be called in User.js. See CardsManager.initWithData.
    initWithData: function( itemList )
    {
        info( "ItemsManager.initWithData called. itemList=%s", JSON.stringify( itemList ) );
        this.m_playerItemList = ( itemList != undefined ) ? itemList.clone() :
        {};
    },

    /**
     * Get the list of the the user items
     * 
     * @param sortBy:
     *            Can be any field of this.m_itemsDetailList ("name", "type", ...)
     * 
     */
    getPlayerItemList: function()
    {
        info( "ItemsManager.getPlayerItemList called." );
        playerItemsList = this.m_playerItemList.clone();
        return playerItemsList;
    },

    // For the size
    loadItemImage: function( /* int */itemDefinitionId, /* string */size, /* function */cb )
    {
        var itemDefinition = this.getItemDefinition( itemDefinitionId );
        var imageURL = itemDefinition.img + "_" + size + ".jpg";
        var wrap = function()
        {
            cb( imageURL );
        };
        ResourceManager.preLoadResource( imageURL, wrap );
    },

    /**
     * 
     * @param itemId:
     *            the instance id of the item to be modified
     * @param delta:
     *            delta amount to be changed. It could be positive or negative.
     */
    modifyItemAmount: function( itemId, delta )
    {
        info( "ItemsManager.updatePlayerItem: " + itemId );

        info( "Player item list : " + JSON.stringify( this.m_playerItemList ) );

        var itemAmount = null;

        if( this.m_playerItemList )
        {
            var index = this.getIndexForPlayerItem( itemId );
            if( this.m_playerItemList[index] )
            {
                itemAmount = this.m_playerItemList[index].amount;
            }

            // If we have the item, change the amount
            if( itemAmount != null )
            {
                itemAmount += delta;
                if( itemAmount <= 0 )
                {
                    this.m_playerItemList.splice( index, 1 );
                }
                else
                {
                    this.m_playerItemList[index].amount = itemAmount;
                }
            }
            // If we don't have it, and delta is positive, add the item.
            else
            {
                if( delta > 0 )
                {
                    this.m_playerItemList.push(
                    {
                        "id": itemId,
                        "amount": delta
                    } );
                }
            }
        }
    },

    /**
     * 
     * @param itemId:
     *            Id of the item to be removed
     */
    removePlayerItem: function( itemId )
    {
        info( "ItemsManager.removePlayerItem: " + JSON.stringify( itemId ) );
        var index = this.getIndexForPlayerItem( itemId );
        if( this.m_playerItemList && this.m_playerItemList[index] != undefined )
        {
            this.m_playerItemList.splice( index, 1 );
        }
    },

    addPlayerItem: function( itemId, amount )
    {
        info( "ItemsManager.addPlayerItem: " + JSON.stringify( itemId ) );
        if( amount <= 0 )
        {
            err( "ItemsManager.addPlayerItem: Wrong amount " + amount );
            return;
        }
        var index = this.getIndexForPlayerItem( itemId );
        if( index != -1 )
        {
            this.m_playerItemList.splice( index, 1 );
        }

        if( this.m_playerItemList )
        {
            var newItem =
            {
                "id": itemId,
                "amount": ( amount != undefined ) ? amount : 1
            };
            this.m_playerItemList.push( newItem );
        }
    },

    // Amount only for misc Items.
    useItem: function( itemId, amount, cb )
    {
        info( "ItemsManager.useItem: " + JSON.stringify( itemId ) );

        var index = this.getIndexForPlayerItem( itemId );
        var playerItem = this.m_playerItemList[index];
        if( playerItem == undefined || ( playerItem == undefined && playerItem.amount <= 0 ) )
        {
            err( "ItemsManager.useItem: The inventory doesn't have this item: " + JSON.stringify( itemId ) );
            return;
        }

        var item = this.m_dictionaryDetailList[itemId];

        if( item == undefined )
        {
            err( "ItemsManager.useItem: No information for item " + JSON.stringify( itemId ) );
            return;
        }

        if( cb == undefined )
        {
            cb = amount;
            amount = 1;
        }

        var useItemCallback = function( error, data )
        {
            if( error )
                err( "ItemManager.useItem useItemCallback error" );
            if( data )
            {
                var _data = JSON.parse( data );
                info( "ItemManager.useItemCallback data: " + JSON.stringify( _data ) );

                if( item.category == ITEM_TYPE.STAT )
                {
                    var increaseType = item.increaseType;
                    var statIncrease = item.statIncrease;

                    switch( item.stat )
                    {
                        case ITEM_STATS.EXPLORE_ENERGY:
                            this._modifyExploreEnergy( statIncrease, increaseType );
                            break;
                        case ITEM_STATS.BATTLE_ENERGY:
                            this._modifyBattleEnergy( statIncrease, increaseType );
                            break;
                        case ITEM_STATS.TOTAL_RECOVERY:
                            this._modifyExploreEnergy( statIncrease, increaseType );
                            this._modifyBattleEnergy( statIncrease, increaseType );
                            break;
                        case ITEM_STATS.COINS:
                            this._modifyCoins( statIncrease, increaseType );
                            break;
                    }

                    this.modifyItemAmount( itemId, -1 );
                    cb();
                }

                else if( item.category == ITEM_TYPE.MISC )
                {
                    if( amount != undefined && ( amount <= 0 || amount > playerItem.amount ) )
                    {
                        err( "ItemsManager.useItem: Wrong amount for Misc Item : " + JSON.stringify( itemId ) );
                        cb();
                        return;
                    }
                    // Stats Modified in CardsManager
                    this.modifyItemAmount( itemId, -1 * amount );
                }

                User.updateMainStats();
            }
        }.bind( this );

        Server.useItem( itemId, useItemCallback );
    },

    verifyItem: function( itemId )
    {
        var item = this.m_dictionaryDetailList[itemId];
        
        var retValue = "";
        if( item.category == ITEM_TYPE.STAT )
        {

            switch( item.stat )
            {
                case ITEM_STATS.EXPLORE_ENERGY:
                    if( User.getExploreEnergy() == User.getMaxExplorationEnergy() )
                    {
                        retValue = "item_explore_energy_full";
                    }
                    break;
                case ITEM_STATS.BATTLE_ENERGY:
                    if( User.getBattleEnergy() == User.getMaxBattleEnergy() )
                    {
                        retValue = "item_battle_energy_full";
                    }
                    break;
                case ITEM_STATS.TOTAL_RECOVERY:
                    if( User.getBattleEnergy() == User.getMaxBattleEnergy() && User.getExploreEnergy() == User.getMaxExplorationEnergy() )
                    {
                        retValue = "item_explore_energy_full";
                    }
                    break;
            }
        }

        return retValue;
    },

    _modifyExploreEnergy: function( statIncrease, increaseType )
    {
        var oldAmount = User.getExploreEnergy();
        var maxAmount = User.getMaxExplorationEnergy();
        deltaAmount = Math.floor( this._getIncreaseAmount( maxAmount, statIncrease, increaseType ) );
        User.setExploreEnergy( oldAmount + deltaAmount );
    },

    _modifyBattleEnergy: function( statIncrease, increaseType )
    {
        var oldAmount = User.getBattleEnergy();
        deltaAmount = this._getIncreaseAmount( oldAmount, statIncrease, increaseType );
        User.setBattleEnergy( oldAmount + deltaAmount );
    },

    _modifyCoins: function( statIncrease, increaseType )
    {
        var oldAmount = User.getCurrency();
        deltaAmount = this._getIncreaseAmount( oldAmount, statIncrease, increaseType );
        User.setCurrency( oldAmount + deltaAmount );
    },

    _getIncreaseAmount: function( amount, delta, type )
    {
        var newDelta = 0;
        switch( type )
        {
            case ITEM_INCREASE_TYPE.PERCENTAGE:
                newDelta = amount * ( delta / 100 );
                break;
            case ITEM_INCREASE_TYPE.QUANTITY:
                newDelta = delta;
                break;
        }

        return newDelta;
    },

    getIndexForPlayerItem: function( id )
    {
        for( var k = 0; k < this.m_playerItemList.length; ++k )
        {
            if( this.m_playerItemList[k].id == id )
            {
                return k;
            }
        }

        return -1;
    },

    getPlayerItem: function( itemId )
    {
        var index = this.getIndexForPlayerItem( itemId );
        if( index != -1 )
        {
            return this.m_playerItemList[index];
        }
        else
        {
            return null;
        }
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GiftManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GiftManager'] || {}; $MODULE_REGISTRY['Code/Game/GiftManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/GiftManager.js';

exports.GiftManager = Core.Class.singleton(
{
    classname: "GiftManager",

    initialize: function()
    {
        info( "GiftManager.initialize called." );

        this.m_playerGiftList = null;
    },

    _syncPlayerGiftListCallback: function( cb, error, data )
    {
        info( "GiftManager._syncPlayerGiftListCallback called. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

        if( error )
        {
            err( "GiftManager._syncPlayerGiftListCallback Error: %s", JSON.stringify( error ) );
            cb && cb( false, null );
            return;
        }

        if( !data )
        {
            err( "GiftManager._syncPlayerGiftListCallback Error. No data received! data=%s", JSON.stringify( data ) );
            cb && cb( false, null );
            return;
        }

        this.m_playerGiftList = ( JSON.parse( data ) ).gifts;
        cb && cb( true, this.m_playerGiftList.gifts );
    },
    // FIXME
    syncPlayerGiftList: function( cb )
    {
        info( "GiftManager.syncPlayerGiftList called." );
        Server.getAllUserGifts( this._syncPlayerGiftListCallback.bind( this, cb ) );
    },

    // This have to be called in User.js. See CardsManager.initWithData.
    initWithData: function( giftList )
    {
        info( "GiftManager.initWithData called. giftList=%s", JSON.stringify( giftList ) );
        this.m_playerGiftList = ( giftList != undefined ) ? giftList.clone() : [];

        /*
         * this.m_playerGiftList = []; for( var i = 0; i < 22; i++ ) { this.m_playerGiftList.push( { "id": ( i + 1 ), "origin": "tutorial", "date": 0, "type": 10, "value": "", "amount": 100000,
         * "timestamp": 1341853361068 } ); }
         */
        
        this._sortList();
    },

    _sortList: function()
    {
        this.m_playerGiftList.compareValue = function( gift )
        {
            return gift.timestamp;
        };
        this.m_playerGiftList.inverted = true;
        quickSort( this.m_playerGiftList );
    },

    getPlayerGiftList: function()
    {
        info( "GiftManager.getPlayerGiftList called." );
        return this.m_playerGiftList.clone();
    },

    getGiftInstanceById: function( giftInstanceId )
    {
        var i;
        var length = this.m_playerGiftList.length;

        for( i = length - 1; i >= 0; i-- )
        {
            var giftInstance = this.m_playerGiftList[i];
            if( giftInstance.id == giftInstanceId )
            {
                return giftInstance;
            }
        }

        return null;
    },

    getGiftInformation: function( giftInstance, imageSize, cb )
    {
        info( "GiftManager.getGiftInformation: " + JSON.stringify( giftInstance ) );
        var title = "";
        if( imageSize == null )
        {
            imageSize = "200";
        }

        if( typeof ( giftInstance ) != "object" )
        {
            var giftInstanceId = giftInstance;
            giftInstance = this.getGiftInstanceById( giftInstanceId );
        }

        switch( giftInstance.type )
        {
            case GIFT_TYPE.COINS:
                title = _loc( "gift_storage_coins_title" );
                cb( "GOLD_" + imageSize + ".jpg" );
                break;
            case GIFT_TYPE.GASHA:
                title = _loc( "gift_storage_gasha_title" );
                cb( "gasha_card_" + imageSize + ".jpg" );
                break;
            case GIFT_TYPE.ITEM:
                var item = ItemManager.getItemDefinition( giftInstance.value );
                title = item.name;
                // title = item.description;
                ItemManager.loadItemImage( item.id, imageSize, cb );
                break;
            case GIFT_TYPE.INVENTORY_SPACE:
                if( giftInstance.value == PILOT )
                {
                    title = _loc( "gift_storage_fighter_inventory_space_title" );
                    cb( "extra_memory_fg_" + imageSize + ".jpg" );
                }
                if( giftInstance.value == GEAR )
                {
                    title = _loc( "gift_storage_equipment_inventory_space_title" );
                    cb( "extra_memory_eq_" + imageSize + ".jpg" );
                }
                break;
            case GIFT_TYPE.MEDALS:
                title = _loc( "gift_" + giftInstance.value ); // medalData[0].description ); //"gift_storage_medals_title" );
                GashaManager.loadMedalImage( giftInstance.value, cb );
                break;
            case GIFT_TYPE.FELLOWS_SPACE:
                title = _loc( "gift_storage_fellows_space_title" );
                cb( "" );
                break;
            case GIFT_TYPE.CARD:
                var cardDef = CardsManager.getCardDefinition( giftInstance.value );
                title = _loc( cardDef.name );
                CardsManager.loadCardImage( giftInstance.value, imageSize, cb );
                break;
            default:
                cb( "" );
        }

        var retValue =
        {
            "title": title,
            "amount": giftInstance.amount,
            "value": giftInstance.value,
            "id": giftInstance.id,
            "type": giftInstance.type,
            "timestamp": giftInstance.expirationDate,
            "origin": giftInstance.origin,
        };

        return retValue;
    },

    claimGift: function( giftId, cb )
    {
        log( "GiftManager.claimGift: giftid = " + giftId + ", this.m_playerGiftList = " + JSON.stringify( this.m_playerGiftList ) );

        /*
         * this.m_playerGiftList.splice( 0, 1 ); cb( true ); return;
         */

        var callback = function( giftInstance, index, error, data )
        {
            info( "GiftManager.claimGift: error: " + JSON.stringify( error ) + ", data: " + JSON.stringify( data ) );
            if( error == undefined )
            {
                this.m_playerGiftList.splice( index, 1 );
                this._useGift( giftInstance );
                // Refresh cards
                if( giftInstance.type == GIFT_TYPE.INVENTORY_SPACE || giftInstance.type == GIFT_TYPE.CARD )
                {
                    CardsManager.syncPlayerCardList( function()
                    {
                        cb( true );
                        User.updateHud();
                    } );
                }
                else
                {
                    cb( true );
                }
            }
            else
            {
                cb( false );
            }
        };

        var i;
        var length = this.m_playerGiftList.length;
        var itemUsed = false;
        for( i = length - 1; i >= 0; i-- )
        {
            var giftInstance = this.m_playerGiftList[i];

            if( giftId == giftInstance.id )
            {
                // FIXME: implement fellowsSpace
                if( giftInstance.type == GIFT_TYPE.FELLOWS_SPACE )
                {
                    cb( false );
                    return;
                }

                var giftList = [ giftId ];
                Server.claimGift( giftList, true, callback.bind( this, giftInstance, i ) );
                itemUsed = true;
                break;
            }
        }

        if( !itemUsed )
        {
            cb( false );
        }
    },

    _useGift: function( giftInstance )
    {
        info( "GiftManager._useGift: giftInstance = " + JSON.stringify( giftInstance ) );
        switch( giftInstance.type )
        {
            case GIFT_TYPE.COINS:
                User.increaseCurrency( giftInstance.amount );
                break;
            case GIFT_TYPE.GASHA:
                User.setGashaPoints( User.getGashaPoints() + giftInstance.amount );
                break;
            case GIFT_TYPE.ITEM:
                ItemManager.modifyItemAmount( giftInstance.value, giftInstance.amount );
                break;
            case GIFT_TYPE.INVENTORY_SPACE:
                if( giftInstance.value == PILOT )
                {
                    User.setMaxPilotCards( User.getMaxPilotCards() + giftInstance.amount );
                }
                if( giftInstance.value == GEAR )
                {
                    User.setMaxGearCards( User.getMaxGearCards() + giftInstance.amount );
                }
                break;
            case GIFT_TYPE.MEDALS:
                User.addMedals( giftInstance.value, giftInstance.amount );
                break;
            case GIFT_TYPE.FELLOWS_SPACE:
                User.setMaxFellows( User.getMaxFellows() + giftInstance.amount );
                break;
            case GIFT_TYPE.CARD:
                break;
        }

        User.updateHud();
    },

    claimAllGifts: function( cb )
    {
        info( "GiftManager.claimAllGifts: " + JSON.stringify( this.m_playerGiftList ) );

        /*
         * this.m_playerGiftList = []; cb(true); return;
         */

        this.m_haveToRefreshCards = false;
        var i;
        var length = this.m_playerGiftList.length;
        var giftList = [];

        var self = this;
        var callback = function( error, data )
        {
            info( "GiftManager.claimAllGifts: error: " + JSON.stringify( error ) + ", data: " + JSON.stringify( data ) );

            if( error == undefined )
            {
                for( i = length - 1; i >= 0; i-- )
                {
                    var giftInstance = self.m_playerGiftList[i];
                    self.m_playerGiftList.splice( i, 1 );

                    // Set the flag to refresh cards
                    if( giftInstance.type == GIFT_TYPE.INVENTORY_SPACE || giftInstance.type == GIFT_TYPE.CARD )
                    {
                        self.m_haveToRefreshCards = true;
                    }
                    self._useGift( giftInstance );
                }
                // Refresh cards
                if( self.m_haveToRefreshCards == true )
                {
                    CardsManager.syncPlayerCardList( function()
                    {
                        cb( true );
                        User.updateHud();
                    } );
                }
                else
                {
                    cb( true );
                }
            }
            else
            {
                cb( false );
            }
        };

        for( i = length - 1; i >= 0; i-- )
        {
            var giftInstance = this.m_playerGiftList[i];

            // FIXME: implement fellowsSpace
            if( giftInstance.type == GIFT_TYPE.FELLOWS_SPACE )
            {
                continue;
            }

            giftList.push( giftInstance.id );
        }

        Server.claimGift( giftList, true, callback );
    },

    addGift: function( giftList )
    {
        info("GiftManager.addGift: " + JSON.stringify(giftList));
        var i;
        var length = giftList.length;
        for( i = 0; i < length; i++ )
        {
            this.m_playerGiftList.push( giftList[i] );
        }
        this._sortList();
    },

    getAllGiftsNumber: function()
    {
        return this.m_playerGiftList.length;
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/RewardManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/RewardManager'] || {}; $MODULE_REGISTRY['Code/Game/RewardManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/RewardManager.js';

exports.RewardManager = Core.Class.singleton(
{
    classname: "RewardManager",

    initialize: function()
    {
        info( "RewardManager.initialize called." );

        this.m_playerRewardList = null;
        this.m_dictionaryDetailList = [];
        this.m_rewardsDetailList = [];
        this.m_nextRewardDifinition = null;
    },

    // Load the list of all rewards details in m_rewardsDetailList, and a dictionary in m_dictionaryDetailList with key "id"
    // This have to be called in DataLoader. See CardsManager.loadCardListDetails.
    loadRewardListDetails: function( list, type )
    {
        this.m_rewardsDetailList[type] = list;

        this.m_dictionaryDetailList[type] =
        {};
        var i;
        var rewardsDetailListLength = list.length;

        for( i = 0; i < rewardsDetailListLength; i++ )
        {
            var rewardsDetailList = ( this.m_rewardsDetailList[type] )[i];
            if( type == PILOT || type == GEAR )
            {
                ( this.m_dictionaryDetailList[type] )["" + rewardsDetailList.cards] = rewardsDetailList;
            }
            else
            {
                ( this.m_dictionaryDetailList[type] )["" + rewardsDetailList.stageId] = rewardsDetailList;
            }
        }

    },

    loadPilotRewardDefinition: function( list )
    {
        info( this.classname + ".loadPilotRewardDefinition: " + JSON.stringify( list ) );
        this.loadRewardListDetails( list, PILOT );
    },

    loadGearRewardDefinition: function( list )
    {
        info( this.classname + ".loadGearRewardDefinition: " + JSON.stringify( list ) );
        this.loadRewardListDetails( list, GEAR );
    },

    loadStageRewardDefinition: function( list )
    {
        info( this.classname + ".loadStageRewardDefinition: " + JSON.stringify( list ) );
        this.loadRewardListDetails( list, STAGE_REWARDS );
    },
    /**
     * Get the details for the reward with "id" id
     * 
     * @param id
     * @return JSON: { "id": 1, "name": "loc_name" ..}
     */
    getRewardDefinition: function( id, type )
    {
        if( this.m_dictionaryDetailList != undefined )
        {
            return ( this.m_dictionaryDetailList[type] )[id];
        }
        return null;
    },

    getRewardDefinitionArray: function( type )
    {
        return ( this.m_rewardsDetailList[type] ).clone();
    },

    getRewardDefinitionDictionary: function( type )
    {
        return dictionaryClone( this.m_dictionaryDetailList[type] );
    },

    _syncPlayerRewardListCallback: function( cb, error, data )
    {
        info( "RewardManager._syncPlayerRewardListCallback called. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

        if( error )
        {
            err( "RewardManager._syncPlayerRewardListCallback Error: %s", JSON.stringify( error ) );
            cb && cb( false, null );
            return;
        }

        if( !data )
        {
            err( "RewardManager._syncPlayerRewardListCallback Error. No data received! data=%s", JSON.stringify( data ) );
            cb && cb( false, null );
            return;
        }

        this.m_playerRewardList = ( JSON.parse( data ) ).rewards;
        cb && cb( true, this.m_playerRewardList.rewards );
    },

    syncPlayerRewardList: function( cb )
    {
        info( "RewardManager.syncPlayerRewardList called." );
        Server.getAllUserRewards( this._syncPlayerRewardListCallback.bind( this, cb ) );
    },

    // This have to be called in User.js. See CardsManager.initWithData.
    initWithData: function( rewardList, nextRewards )
    {
        info( "RewardManager.initWithData called. rewardList=%s", JSON.stringify( rewardList ) );
        info( "RewardManager.initWithData called. nextRewards=%s", JSON.stringify( nextRewards ) );

        this.m_playerRewardList = ( rewardList != undefined ) ? rewardList.clone() : [];
        this._sortList();

        this.m_nextRewardDifinition = ( nextRewards != undefined ) ? dictionaryClone( nextRewards ) :
        {};
    },

    _sortList: function()
    {
        this.m_playerRewardList.compareValue = function( reward )
        {
            return reward.value;
        };
        this.m_playerRewardList.inverted = true;
        quickSort( this.m_playerRewardList );
    },

    getNextReward: function( type )
    {

        var key = "" + type;
        var id = this.m_nextRewardDifinition[key];

        if( id == undefined )
        {
            return null;
        }

        var answer =
        {};

        if( type == PILOT || type == GEAR )
        {
            var rewardList = this.m_rewardsDetailList[type];

            var i;
            var length = rewardList.length;
            for( i = 0; i < length; i++ )
            {
                var rewardDef = rewardList[i];
                var rewardId = parseInt( rewardDef.cards );
                if( id < rewardId )
                {
                    answer.rewards = rewardDef.rewards;
                    answer.value = rewardId;
                    break;
                }
            }
        }

        return answer;
    },

    getFilteredPlayerRewardList: function( type )
    {
        var filteredList = [];

        var i;
        var length = this.m_playerRewardList.length;

        for( i = 0; i < length; i++ )
        {
            if( this.m_playerRewardList[i].type == type )
            {
                var reward = dictionaryClone( this.m_playerRewardList[i] );
                // Add this variable to claim the rewards using the method claimRewards.
                reward.index = i;
                filteredList.push( reward );
            }

        }

        return filteredList;
    },

    getPlayerRewardLength: function()
    {
        var lengthDict = {};
        lengthDict[PILOT] = 0;
        lengthDict[GEAR] = 0;
        lengthDict[STAGE_REWARDS] = 0;
        
        var i;
        var length = this.m_playerRewardList.length;

        for( i = 0; i < length; i++ )
        {
            var reward = this.m_playerRewardList[i];
            lengthDict[reward.type] = lengthDict[reward.type] + 1; 
        }

        return lengthDict;
        
    },
    getPlayerRewardList: function()
    {
        info( "RewardManager.getPlayerRewardList called." );
        return this.m_playerRewardList.clone();
    },

    claimRewards: function( indexes, cb )
    {
        info( "RewardManager.claimRewards: " + JSON.stringify( indexes ) );
        this.m_haveToRefreshCards = false;
        var i;
        var length = indexes.length;
        var rewardList = [];

        var self = this;
        var callback = function( error, data )
        {
            info( "RewardManager.claimRewards: callback: error: " + JSON.stringify( error ) + ", data: " + JSON.stringify( data ) );
            if( error == undefined )
            {
                for( i = length - 1; i >= 0; i-- )
                {
                    var rewardInstance = self.m_playerRewardList[indexes[i]];

                    self.m_playerRewardList.splice( indexes[i], 1 );

                    var rewards = rewardInstance.rewards;
                    var rewardLength = rewards.length;
                    for( var j = 0; j < rewardLength; j++ )
                    {
                        //Set the flag to refresh cards
                        if( rewards[j].type == GIFT_TYPE.INVENTORY_SPACE )
                        {
                            self.m_haveToRefreshCards = true;
                        }
                        GiftManager._useGift( rewards[j] );
                    }

                    rewardList.push( rewardInstance.id );
                }
                
                //Refresh cards
                if( self.m_haveToRefreshCards == true )
                {
                    CardsManager.syncPlayerCardList( function()
                    {
                        cb( true );
                        User.updateHud();
                    } );
                }
                else
                {
                    cb( true );
                }
            }
            else
            {
                cb( false );
            }
        };

        for( i = length - 1; i >= 0; i-- )
        {
            var rewardInstance = this.m_playerRewardList[indexes[i]];
            rewardList.push( rewardInstance.id );
        }

        // callback( null, true );
        Server.claimReward( rewardList, true, callback );
    },

    addReward: function( data )
    {
        info( "RewardManager.addReward called" + JSON.stringify( data ) );
        if( data == null )
        {
            return;
        }
        if( data.rewards == null )
        {
            return;
        }
        var rewards = data.rewards;
        var nextReward = data.lastRewardsByType;

        var i;
        var length = rewards.length;
        for( i = 0; i < length; i++ )
        {
            this.m_playerRewardList.push( rewards[i] );
        }
        this.m_nextRewardDifinition = nextReward;

        this._sortList();
    },

    getStageRewardsInformation: function()
    {
        var list = this.m_rewardsDetailList[STAGE_REWARDS];
        return list[0].rewards;
    },

    getAllRewardsNumber: function()
    {
        return this.m_playerRewardList.length;
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/GashaManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/GashaManager'] || {}; $MODULE_REGISTRY['Code/Game/GashaManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/GashaManager.js';

exports.GashaManager = Core.Class.singleton(
{
    classname: 'GashaManager',

    GASHA_TYPES:
    {
        "NORMAL": "1",
        "PREMIUM": "2",
        "MEDALS": "3"
    },

    initialize: function()
    {
        this.m_medalGashaData =
        {};
        this.m_premiumGashaData = [];
        this.m_normalGashaData = [];
        this.m_freeGashaData = [];
        this.m_premiumPromoGashaData = [];
        this.m_promoReady = false
    },

    initWithData: function( data )
    {
        this.m_userMedals = data;
    },

    loadGashaListDetails: function( data )
    {
        info( "GashaManger.loadGashaListDetails called with: " + JSON.stringify( data ) );
        this.mapData( data[this.GASHA_TYPES.PREMIUM], this.GASHA_TYPES.PREMIUM );
        this.mapData( data[this.GASHA_TYPES.MEDALS], this.GASHA_TYPES.MEDALS );
        this.mapData( data[this.GASHA_TYPES.NORMAL], this.GASHA_TYPES.NORMAL );
    },

    mapData: function( data, type )
    {
        switch( type )
        {
            case this.GASHA_TYPES.NORMAL:
                for( var i = 0; i < data.length; i++ )
                {
                    if( data[i].currency == 'free' )
                        this.m_freeGashaData = data[i];
                    else
                        this.m_normalGashaData.push( data[i] );
                }
                break;

            case this.GASHA_TYPES.PREMIUM:
                var remData = 0;
                for( var i = 0; i < data.length; i++ )
                {
                    Bank.Inventory.getItem( data[i].sku, function( _i, error, item )
                    {
                        if( item )
                            data[_i].cost = item.price;
                        if (data[_i].saleId)
                            this.m_premiumPromoGashaData.push(data[_i]);
                        else
                            this.m_premiumGashaData.push( data[_i] );

                        remData ++;

                        if (remData == data.length)
                            //this.applyPromoPacks(this.m_premiumGashaData, promoData);
                            this.m_promoReady = true;
                    }.bind( this, i ) )
                }
                break;

            case this.GASHA_TYPES.MEDALS:

                for( var i = 0; i < data.length; i++ )
                {
                    var key = data[i].currency;
                    if( this.m_medalGashaData[key] == undefined )
                    {
                        this.m_medalGashaData[key] = [];
                    }
                    this.m_medalGashaData[key].push( data[i] );
                }
                break;
        }
    },

    applyPromoPacks: function(baseArray, promoArray)
    {
        if (!User.m_firstTimePremiumGasha) return baseArray;

        var normalArray = baseArray.clone();

        for (var i = 0; i < normalArray.length; i++)
        {
            for (var j = 0; j < promoArray.length; j++)
            {
                if (normalArray[i].id == promoArray[j].saleId)
                    normalArray[i] = promoArray[j];
            }
        }
        return normalArray;
    },

    getDataForMedal: function( currency )
    {
        var medalsForCurrency = this.m_medalGashaData[currency];
        return medalsForCurrency;
    },

    loadMedalImage: function( medalId, cb )
    {
        info( "GashaManager.loadMedalImage medalId=%s.", medalId );

        var imageURL = MEDAL_ASSETS[medalId];
        if( imageURL === null || imageURL === undefined )
        {
            cb( "1pxalpha0.png", medalId );
            return;
        }

        var wrap = function( imageURL )
        {
            cb( imageURL, medalId );
        }.bind( this, imageURL );
        ResourceManager.preLoadResource( imageURL, wrap );
    },

    getUserAvailableMedals: function()
    {
        var retArray = [];
        var userMedals = User.getMedals();

        for( var i in userMedals )
        {
            var medals = this.getDataForMedal( userMedals[i].id );

            if( medals != undefined )
            {
                for( var j = 0; j < medals.length; j++ )
                {
                    if( medals[j].value <= userMedals[i].amount )
                    {
                        retArray.push( medals[j] );
                    }
                }
            }
        }
        return retArray;
    },

    getFreeGashaId: function()
    {
        return this.m_freeGashaData.defId;
    },

    getFreeGashaData: function()
    {
        return this.m_freeGashaData;
    },

    getNormalGashaData: function()
    {
        return this.m_normalGashaData;
    },

    getPremiumGashaData: function()
    {
        return this.applyPromoPacks(this.m_premiumGashaData, this.m_premiumPromoGashaData);
    },

    getMedalsGasha: function()
    {
        return this.m_medalGashaData;
    },

    getGashaPackById: function( id )
    {
        if( this.m_freeGashaData.id == id )
        {
            return this.m_freeGashaData;
        }

        for( var i = 0; i < this.m_normalGashaData.length; i++ )
        {
            if( this.m_normalGashaData[i].id == id )
            {
                return this.m_normalGashaData[i];
            }
        }
        keys = Object.keys( this.m_medalGashaData );

        for( var i = 0; i < keys.length; i++ )
        {
            var container = this.m_medalGashaData[keys[i]];
            for( var j = 0; j < container.length; j++ )
            {
                if( container[j].id == id )
                {
                    return container[j];
                }
            }
        }
        for( var i = 0; i < this.m_premiumGashaData.length; i++ )
        {
            if( this.m_premiumGashaData[i].id == id )
            {
                return this.m_premiumGashaData[i];
            }
        }
        for( var i = 0; i < this.m_premiumPromoGashaData.length; i++ )
        {
            if( this.m_premiumPromoGashaData[i].id == id )
            {
                return this.m_premiumPromoGashaData[i];
            }
        }
        return null;
    },

    runGasha: function( packId, amount, transactionId )
    {
        info( "GashaManager.runGasha called. packId=%s", packId );
        var pendingImages = 0;
        var onImageLoaded = function( cards, isNew )
        {
            pendingImages--;
            if( pendingImages > 0 )
            {
                return;
            }
            var func = function()
            {
                var screen = new GashaResults( cards, packId );
                Xib.Navigation.resetScreenStackTo( screen, false );
                info( "GashaStore.runGasha Screen Pushed: classname=" + screen.classname );
            };

            func();
        };

        var gashaCallback = function( error, data )
        {
            User.updateGashaDates();
            if( error )
            {
                Xib.Navigation.removeModalOverlay();

                // Manage Error
                err( "GashaManager.runGasha... error: " + JSON.stringify( error ) );
                return;
            }

            data = JSON.parse( data ); // Remove this line
            info( "RewardManager.runGasha... gasha results: " + JSON.stringify( data ) );
            if( data && data.cards && data.cards.length )
            {
                // To assure that all the cards images are loaded before the animation
                var length = data.cards.length;
                pendingImages = length;
                User.setGashaPoints( data.gashaPoints );
                User.updateMedalAmount( data.medals );
                User.updatePremiumsBought( data.firstTimePremiumGasha );
                for( var i = 0; i < length; ++i )
                {
                    var card = data.cards[i];
                    if( !card || !card.definitionId )
                    {
                        pendingImages--;
                        continue;
                    }

                    var isNew = CardsManager.isCardNew(card.definitionId);
                    data.cards[i].isNew = isNew;

                    CardsManager.addPlayerCard( card );
                    CardsManager.loadCardImage( card.definitionId, IMAGE_SIZE.BIGGEST, function( imageURL )
                    {

                        info( "GashaManager.runGasha...image loaded: " + imageURL );
                        onImageLoaded( data.cards, isNew );
                    }.bind( this ) );
                }

                if( data.collectionRewards )
                {
                    if( data.collectionRewards.rewards && data.collectionRewards.lastRewardsByType )
                    {
                        RewardManager.addReward( data.collectionRewards );
                    }
                }
                
                User.updateHud();
            }
            else if (data && data.gift)
            {
                if( data.collectionRewards )
                {
                    if( data.collectionRewards.rewards && data.collectionRewards.lastRewardsByType )
                    {
                        RewardManager.addReward( data.collectionRewards );
                    }
                }

                User.setGashaPoints( data.gashaPoints );
                User.updateMedalAmount( data.medals );
                User.updatePremiumsBought( data.firstTimePremiumGasha );

                var cardDef = data.gift[0].value;
                var cardIns = {"definitionId": cardDef};

                var cardArray = [];
                cardArray.push(cardIns);

                var isNew = CardsManager.isCardNew(cardDef);

                GiftManager.addGift(data.gift);

                cardIns.isNew = isNew;

                CardsManager.loadCardImage( cardDef, IMAGE_SIZE.BIGGEST, function( imageURL )
                    {

                        info( "GashaManager.runGasha...image loaded: " + imageURL );
                        onImageLoaded( cardArray, isNew );
                    }.bind( this ) );
            }

            else
            {
                Xib.Navigation.removeModalOverlay();
                // Manage Error
                return;
            }

        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( function()
        {
        } ) );
        Server.runGasha( gashaCallback, packId, amount, transactionId, false ); // The 0 is for non Mobage bank transactions
    }
} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/TimersController'] = function(){var exports = $MODULE_REGISTRY['Code/Game/TimersController'] || {}; $MODULE_REGISTRY['Code/Game/TimersController'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/TimersController.js';

exports.TimersController        = Core.Class.singleton({


    /* TIMER DEFINITION, if you want to use this class follow this description
     *
     * {
     *      "interval"  : [millis between each function execution,
     *      "func"      : [function to execute after *interval* milliseconds],
     *      "timeout"   : [javascript object generated by setTimeout]
     * }
     */

    
    classname                   : "TimersController",
    
    initialize                  : function(  )
    {
        this.m_configData       = null;
        
        this.m_timers           = [];
    },
    
    //PUT config.json HERE
    initWithData                : function( data )
    {
        info( "TimersController.initWithData called. Data : "+JSON.stringify( data ) );
        this.syncTimeWithServer();
        
        this.m_configData       = data;
        
        Server.getLastBattleDate( this.syncBattleTime.bind( this ) );
        Server.getLastExploreDate( this.syncExplorationTime.bind( this ) );
        
    },
    
    syncBattleTime              : function( _err, data )
    {        
        var battleTimeOffset    = Date.parse( JSON.parse(data).lastBattleEnergyUpdate );
        battleTimeOffset        = ( this.m_serverTime - battleTimeOffset ) % ( this.m_configData.battleEnergyPeriod*60*1000 );
                
        var func                = function(  )
        {
            User.increaseBattleEnergy( this.m_configData.battleEnergyRate );
        }.bind(this);
        
        this.setNewTimer( this.m_configData.battleEnergyPeriod*60*1000, func,  battleTimeOffset );
    },
    
    syncExplorationTime         : function( _err, data )
    {
        var explorationTimeOffset       = Date.parse( JSON.parse(data).lastExploreEnergyUpdate );
        explorationTimeOffset           = ( this.m_serverTime - explorationTimeOffset ) % ( this.m_configData.exploreEnergyPeriod*60*1000 );
                    
        var func                = function(  )
        {
            User.increaseExploreEnergy( this.m_configData.exploreEnergyRate );
        }.bind(this);
        
        this.setNewTimer( this.m_configData.exploreEnergyPeriod*60*1000, func, explorationTimeOffset );
    },
    
    syncTimeWithServer          : function()
    {
        this.m_serverTime       = Server.getServerTime();
        info( "TimersController.syncTimerWithServer, ServerTime : "+JSON.stringify(this.m_serverTime) );
    },
    
    setNewTimer                 : function( interval, func, offset )
    {
        if( !offset )
        {
            offset  = 0;
        }
        
        info( "TIME OFFSET >>> "+JSON.stringify( offset ) );
        info( "TIME OFFSET >>> "+JSON.stringify( new Date(offset) ) );
        
        this.m_timers.push(
            {
                "interval"      : interval,
                "func"          : func,
                "timeout"       : null
            }
        );
        
        var timer               = this.m_timers[ this.m_timers.length-1 ];
        timer.timeout           = setTimeout( this.executeFunction.bind( this, timer ), interval - offset );
    },
    
    removeTimer                 : function( timerIndex )
    {
        this.m_timers.splice(timerIndex, 1);
    },
    
    cancelAllTimeouts           : function(  )
    {
        for( var i = 0; i < this.m_timers.length ; ++i )
        {
            var timer           = this.m_timers[i];
            clearTimeout(timer.timeout);
        }
    },
    
    restartAllTimeouts          : function(  )
    {
        this.cancelAllTimeouts();
        
        for( var i = 0; i < this.m_timers.length ; ++i )
        {
            var timer           = this.m_timers[i];
            timer.timeout       = setTimeout(this.executeFunction.bind(this, timer) , timer.interval);
        }
    },
    
    executeFunction             : function( timer)
    {
        timer.func();
        setTimeout(this.executeFunction.bind(this, timer), timer.interval);
    }
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Game/ItemPackManager'] = function(){var exports = $MODULE_REGISTRY['Code/Game/ItemPackManager'] || {}; $MODULE_REGISTRY['Code/Game/ItemPackManager'] = exports; 
var __dirname = 'Code/Game';
var __filename = 'Code/Game/ItemPackManager.js';

exports.ItemPackManager         = Core.Class.singleton({
    
    classname                   : "ItemPackManager",
    
    initialize                  : function(  )
    {
        this.m_itemPacksData    = null;
    },
    
    //PUT ItemPacks.json HERE
    initWithData                : function( data )
    {
        info( "ItemPackManager.initWithData called. Data : "+JSON.stringify( data ) );
        
        this.m_itemPacksData       = data;
    },
    
    getAllItemPacks             : function(  )
    {
        var orderedList         = [];
        
        for(var i = 0; i < this.m_itemPacksData.length; ++i)
        {
            var k = 0;
            var newItem         = this.m_itemPacksData[i];
            for( k = 0; k < orderedList.length; ++k )
            {
                if( orderedList[k].sort > newItem.sort )
                {
                    break;
                }
            }
            orderedList.splice(k, 0, newItem);
        }
        
        return orderedList;
    },
    
    getAllSellableItemPacks     : function(  )
    {
        var orderedList         = [];
        
        for(var i = 0; i < this.m_itemPacksData.length; ++i)
        {
            var k = 0;
            var newItem         = this.m_itemPacksData[i];
            
            if( this.m_itemPacksData[i].show == "FALSE" )
            {
                continue;
            }
            
            for( k = 0; k < orderedList.length; ++k )
            {
                if( orderedList[k].sort > newItem.sort )
                {
                    break;
                }
            }
            orderedList.splice(k, 0, newItem);
        }
        
        return orderedList;
    },
    
    getPackWithId               : function( id )
    {
        for( var i = 0; i < this.m_itemPacksData.length; ++i)
        {
            if( this.m_itemPacksData[i].id == id )
            {
                return this.m_itemPacksData[i];
            } 
        }
        
        return null;
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Tutorial/TutorialManager'] = function(){var exports = $MODULE_REGISTRY['Code/Tutorial/TutorialManager'] || {}; $MODULE_REGISTRY['Code/Tutorial/TutorialManager'] = exports; 
var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialManager.js';

exports.TutorialManager = Core.Class.singleton( {
    classname: "TutorialManager",

    //Tutorial States
    STATE_START: "tutorial_start",
    STATE_CARDS_EXPLANATION: "tutorial_cards_explanation",
    STATE_FUSION_EXPLANATION: "tutorial_fusion_explanation",
    STATE_BATTLE_EXPLANATION: "tutorial_battle_explanation",
    STATE_START_TRAINING: "tutorial_start_training",
    STATE_FIRST_GASHA: "tutorial_first_gasha",
    STATE_GASHA_ACQUIRED: "tutorial_gasha_acquired",
    STATE_MISSION_SELECTION: "tutorial_mission_selection",
    STATE_GOTO_FUSION: "tutorial_goto_fusion",

    STATE_FUSION_SELECTION: "tutorial_fusion_selection",
    STATE_FUSION_MATERIAL: "tutorial_fusion_material",
    STATE_MATERIAL_SELECTION: "tutorial_material_selection",
    STATE_FUSE: "tutorial_fuse",
    STATE_FUSION_ANIMATION: "tutorial_fusion_animation",
    STATE_FUSION_RESULTS: "tutorial_fusion_results",
    STATE_FUSION_CARD: "tutorial_fusion_card",

    STATE_DECK_MANAGER: "tutorial_deck_manager",
    STATE_DECK_MANAGER2: "tutorial_deck_manager2",
    STATE_MISSION_SELECTION2 : "tutorial_mission_selection2",
    STATE_MISSION_SELECTION3 : "tutorial_mission_selection3",
    STATE_FIGHT_WON : "tutorial_fight_won",
    STATE_STARTER_DECK: "tutorial_starter_deck",
    STATE_TUTORIAL_END: "end",


    initialize: function( activeStateId )
    {
        info( "TutorialManager.initialize called. activeStateId=%s", activeStateId );

        this.m_activeState = null;
        this.m_states = [];
        this.m_unblockedButtons = [];
        this.m_areButtonBlocked = false;

        this._initializeStates();
    },

    _initializeStates: function()
    {
        info( "TutorialManager._initializeStates called" );

        var stateId, state, action;

        //ToDo: don't create the states that have been completed (?) (or we dont need to do the tutorial...)

        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Welcome Commander"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // start tutorial image
        // Tutorial Step: SC00
        stateId = this.STATE_START;
        action = new TutorialPictureAction( null, _loc( "tutorial_start_tutorial_button" ), "tutorial_start.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Equipment & Fighter"
        // Next Button  ">"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // card explanation...initial state
        // Tutorial Step: SC03
        stateId = this.STATE_CARDS_EXPLANATION;
        action = new TutorialExplanationAction( _loc( "tutorial_explanation_unit_title" ), _loc( "tutorial_explanation_unit" ), _loc( "tutorial_continue_button" ), "tutorial_unit.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Card Fusion"
        // Next Button  ">"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // fusion explanation
        // Tutorial Step: SC04
        stateId = this.STATE_FUSION_EXPLANATION;
        action = new TutorialExplanationAction( _loc( "tutorial_explanation_fusion_title" ), _loc( "tutorial_explanation_fusion" ), _loc( "tutorial_continue_button" ),"tutorial_fusion.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Battle"
        // Next Button  ">"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // battle explanation
        // Tutorial Step: SC05
        stateId = this.STATE_BATTLE_EXPLANATION;
        action = new TutorialExplanationAction( _loc( "tutorial_explanation_battle_title" ), _loc( "tutorial_explanation_battle" ), _loc( "tutorial_continue_button" ),"tutorial_battle.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        ""
        // Next Button  "Start Training"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // welcome // ""
        // Tutorial Step: SC06
        stateId = this.STATE_START_TRAINING;
        action = new TutorialPictureAction( _loc( "tutorial_start_training" ), _loc( "tutorial_start_button" ), "tutorial_starterpack.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        ""
        // Next Button  "Open Card Pod"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // gasha picture
        // Tutorial Step: SC07
        var dummyCard = CardsManager.getPlayerCardById( 19 );

        stateId = this.STATE_FIRST_GASHA;
        action = new TutorialPictureAction( _loc( "tutorial_first_gasha" ), _loc( "tutorial_open_pack" ), "tutorial_gasha.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();

            GameController.getTutorialScreen().setVisibleTopFrame( false );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

            CardsManager.addPlayerCard( dummyCard );
            var screen = new GashaResults( [ dummyCard ] );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Gasha Animation -"
        // Next Button  "Touch"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Card Display -"
        // Next Button  "Touch"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "New Card Acquired"
        // Next Button  "Go To Exploration"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // gasha acquired
        // Tutorial Step: SC08
        // Tutorial Step: SC09
        stateId = this.STATE_GASHA_ACQUIRED;
        var onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( true );

            this.blockAllButtons();
            this.setButtonAsUnblocked( GameController.getTutorialScreen().xib_continueButton );

            Xib.Navigation.setModalOverlay(
                new WaitingScreen(
                    function()
                    {
                        var screen = new SingleGasha( dummyCard, 1 );
                        Xib.Navigation.resetScreenStackTo( screen, false );
                    }.bind( this )
                )
            );

        }.bind( this );
        var onContinue = function()
        {
            info( "TutorialManager._initializeStates.onContinue... activeStateId=%s", this.getActiveStateId() );
            this.unblockAllButtons();
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this );
        action = new TutorialOpenScreenAction( _loc( "tutorial_gasha_acquired" ), _loc( "tutorial_goto_exploration" ), "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "KORALES (Stage name)"
        // Next Button  "Explore Area"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Credits"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - New Card Found"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Credits"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Area Clear"
        // Next Button  "Touch"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // mission selection
        // Tutorial Step: SC10
        // Tutorial Step: SC11
        // Tutorial Step: SC12
        // Tutorial Step: SC13
        stateId = this.STATE_MISSION_SELECTION;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

            var worldId = 0;
            var stageId= 0;
            var screen = new MissionSelectionScreen( worldId, stageId );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        onContinue = null;
        action = new TutorialOpenScreenAction( _loc( "tutorial_mission_selection" ), null, "1pxorange.png", onExecuted, null );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        ""
        // Next Button  "Go To Fusion"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // goto fusion
        // Tutorial Step: SC15
        stateId = this.STATE_GOTO_FUSION;
        action = new TutorialPictureAction( _loc( "tutorial_goto_fusion" ), _loc( "tutorial_goto_fusion_button" ), "tutorial_fusion2.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }

            this.blockAllButtons();
            this.setButtonAsUnblocked( GameController.getTutorialScreen().xib_continueButton );

            // TODO This data is duplicated in QuestManager
            var missionData = {
                        "roundNumber" : 3,
                        "cardRewards" : [ CardsManager.getPlayerCardById( 20 ).definitionId ]
                    };
            QuestManager.m_playerMissionsDictionary[40000001] = missionData;
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Fusion"
        // Next Button  "Use Recommended Card"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //tutorial fusion selection",
        // Tutorial Step: SC16
        stateId = this.STATE_FUSION_SELECTION;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

            this.blockAllButtons();

            Xib.Navigation.setModalOverlay(
                new WaitingScreen(
                    function()
                    {
                        var screen = new CardFusionBaseSelection( PILOT );
                        screen._getUserCards();
                        Xib.Navigation.resetScreenStackTo( screen, false );
                    }.bind( this )
                )
            );
        }.bind( this );
        onContinue = function()
        {
//            this.unblockAllButtons();
        }.bind( this );
        action = new TutorialOpenScreenAction( _loc( "tutorial_fusion_selection" ), null, "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Fusion"
        // Next Button  "Use Recommended Card"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //tutorial fusion selection,
        // Tutorial Step: SC17
        stateId = this.STATE_FUSION_MATERIAL;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );
            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

        }.bind( this );
        onContinue = null;
        action = new TutorialOpenScreenAction( _loc( "tutorial_fusion_material" ), null, "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Fusion"
        // Next Button  "??"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //tutorial material selection,
        // Tutorial Step: SC18
        stateId = this.STATE_MATERIAL_SELECTION;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );
            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

        }.bind( this );
        onContinue = null;
        action = new TutorialOpenScreenAction( _loc( "tutorial_material_selection" ), null, "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Fusion"
        // Next Button  "Fusion!"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //tutorial fuse,
        // Tutorial Step: SC19
        stateId = this.STATE_FUSE;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );
            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

        }.bind( this );
        onContinue = null;
        action = new TutorialOpenScreenAction( _loc( "tutorial_fuse" ), null, "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Fusion Screen Animation -"
        // Next Button  "Start!"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //tutorial fuse,
        // Tutorial Step: after SC19, before SC20
        stateId = this.STATE_FUSION_ANIMATION;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );
            GameController.getTutorialScreen().setVisibleTopFrame( false );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );
            this.unblockAllButtons();
        }.bind( this );
        onContinue = null;
        action = new TutorialOpenScreenAction( _loc( "tutorial_fusion_card" ), null, "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Fusion Complete"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // fusion results
        // Tutorial Step: SC20
        stateId = this.STATE_FUSION_RESULTS;
        var onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( true );

            this.blockAllButtons();
            this.setButtonAsUnblocked( GameController.getTutorialScreen().xib_continueButton );

        }.bind( this );
        var onContinue = function()
        {
            info( "TutorialManager._initializeStates.onContinue... activeStateId=%s", this.getActiveStateId() );

            this.unblockAllButtons();
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
            }
        }.bind( this );
        action = new TutorialOpenScreenAction( _loc( "tutorial_fusion_results" ), _loc( "tutorial_continue_button" ), "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        ""
        // Next Button  "Go To Deck"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Tutorial Step: SC21
        stateId = this.STATE_FUSION_CARD;
        action = new TutorialPictureAction( _loc( "tutorial_fusion_card" ), _loc( "tutorial_goto_deck" ), "tutorial_deck.jpg", function()
        {
            info( "TutorialManager._initializeStates.internalCallback... activeStateId=%s", this.getActiveStateId() );
            this.completeActiveState();
            if( this.getActiveStateId() )
            {
                this.executeActiveStateAction();
                //go to "use recomendation"
            }
        }.bind( this ) );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


       //////////////////////////////////////////////////////////////////////////////////////////////////////////////
       // Title        "Deck"
       // Next Button  "Use Recommended Deck"
       //////////////////////////////////////////////////////////////////////////////////////////////////////////////
       // Tutorial Step: SC22
       stateId = this.STATE_DECK_MANAGER;
       onExecuted = function()
       {
           info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

           GameController.getTutorialScreen().setVisibleTopFrame( true );
           GameController.getTutorialScreen().setVisibleBottomFrame( false );

           this.blockAllButtons();

           var screen = new DeckManagerUI();
           Xib.Navigation.resetScreenStackTo( screen, false );
       }.bind( this );
       onContinue = null;
       action = new TutorialOpenScreenAction( _loc( "tutorial_deck_manager" ), null, "1pxorange.png", onExecuted, onContinue );
       state = new TutorialState( stateId, action, false );
       this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


       //////////////////////////////////////////////////////////////////////////////////////////////////////////////
       // Title        "Deck"
       // Next Button  "Confirm"
       //////////////////////////////////////////////////////////////////////////////////////////////////////////////
       //tutorial fusion selection",
       // Tutorial Step: SC23
       stateId = this.STATE_DECK_MANAGER2;
       onExecuted = function()
       {
           info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

       }.bind( this );
       onContinue = null;
       action = new TutorialOpenScreenAction( _loc( "tutorial_deck_manager2" ), null, "1pxorange.png", onExecuted, onContinue );
       state = new TutorialState( stateId, action, false );
       this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Korales (stage name)"
        // Next Button  "Explore Area"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Credits"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - New Card Found"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Credits"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Area Clear"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "- Exploration - Level Up"
        // Next Button  "Continue"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // mission selection
        // Tutorial Step: SC24
        // Tutorial Step: SC25
        // Tutorial Step: SC26
        // Tutorial Step: SC27
        // Tutorial Step: SC28
        stateId = this.STATE_MISSION_SELECTION2;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            this.unblockAllButtons();

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

            var worldId = 0;
            var stageId= 0;
            var screen = new MissionSelectionScreen( worldId, stageId );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        onContinue = null;
        action = new TutorialOpenScreenAction( _loc( "tutorial_mission_selection2" ), null, "1pxorange.png", onExecuted, onContinue );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Korales (stage name)"
        // Next Button  "Fight"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // mission selection (to boss fight)
        // Tutorial Step: SC29
        stateId = this.STATE_MISSION_SELECTION3;
        onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

            // TODO This data is duplicated in QuestManager
            var missionData = {
                        "roundNumber" : 3,
                        "cardRewards" : [ CardsManager.getPlayerCardById( 21 ).definitionId ]
                    };
            QuestManager.m_playerMissionsDictionary[40000002] = missionData;

            var worldId = 0;
            var stageId= 0;
            var screen = new MissionSelectionScreen( worldId, stageId );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        action = new TutorialOpenScreenAction( _loc( "tutorial_boss_incoming" ), null, "1pxorange.png", onExecuted, null );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Starter Deck Selection"
        // Next Button  "- Select a Deck -"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Starter Deck Confirmation"
        // Next Button  "Confirm"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // starter deck
        stateId = this.STATE_STARTER_DECK;
        var onExecuted = function()
        {
            info( "TutorialManager._initializeStates.onExecuted... activeStateId=%s", this.getActiveStateId() );

            GameController.getTutorialScreen().setVisibleTopFrame( true );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );

            //this.blockAllButtons();
            //this.setButtonAsUnblocked( GameController.getTutorialScreen().xib_continueButton );

            Xib.Navigation.setModalOverlay(
                new WaitingScreen(
                    function()
                    {
                        var screen = new StarterPackSelection();
                        Xib.Navigation.resetScreenStackTo( screen, false );
                    }.bind( this )
                )
            );
        }.bind( this );
        action = new TutorialOpenScreenAction( _loc( "tutorial_select_pack" ), null, "1pxorange.png", onExecuted, null );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////


        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // Title        "Congratulations Commander!!!"
        // Next Button  "Accept"
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
        // end tutorial image
        // Tutorial Step: ??
        stateId = this.STATE_TUTORIAL_END;
        action = new TutorialPictureAction( null, _loc( "tutorial_end_button" ), "tutorial_end.jpg",
            function()
            {
                info( "TutorialManager._initializeStates.innerCallback [TUTORIAL] [STATE_TUTORIAL_END] activeStateId=%s", this.getActiveStateId() );
                TutorialManager.completeActiveState();
                TutorialManager.executeActiveStateAction();
                TutorialManager.finishTutorial();
            }.bind( this )
        );
        state = new TutorialState( stateId, action, false );
        this.m_states.push( state );
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////
    },

    finishTutorial: function ()
    {
        info("TutorialManager.finishTutorial");

        var mainScreen = GameController.getMainScreen();
        var mainView   = mainScreen.getView();
        var tutorialScreen = GameController.getTutorialScreen();
        var tutorialView   = tutorialScreen.getView();

        TutorialManager.setActiveState( null );

        mainView.removeChild( tutorialView );

        mainScreen.showButtons();
        mainScreen.showPlayerInfo();

        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        mainScreen._setClipping();
        mainScreen.moveToS1();
    },

    setActiveState: function( stateId )
    {
        info( "TutorialManager.setActiveState called. stateId=%s", stateId );
        this.m_activeState = null;
        for( var i = 0; i < this.m_states.length; ++i )
        {
            var state = this.m_states[i];
            if( state.getId() == stateId )
            {
                this.m_activeState = state;
            }
        }
        if( this.m_activeState )
        {
            info( "TutorialManager.setActiveState this.m_activeState=%s", this.m_activeState.getId() );
        }
        else
        {
            info( "TutorialManager.setActiveState No state active" );
        }
    },

    getActiveStateId: function()
    {
        if( this.m_activeState )
        {
            return this.m_activeState.getId();
        }
        return null;
    },

    executeActiveStateAction: function()
    {
        info( "TutorialManager.executeActiveStateAction called. activeStateId=%s", this.getActiveStateId() );
        if( this.m_activeState )
        {
            return this.m_activeState.executeAction();
        }
    },

    completeActiveState: function()
    {
        info( "TutorialManager.completeState called. activeStateId=%s", this.getActiveStateId() );
//        this.m_activeState.onStateCompleted();
        var lastActiveState, lastActiveStateId, i, state, currentProgress, totalProgress, progressRatio;


        if( !this.m_activeState || !this.m_activeState.getId )
        {
            warn( "TutorialManager.completeState Warning, there is no active state." );
            return;
        }

        lastActiveState = this.m_activeState;
        lastActiveStateId = this.m_activeState.getId();
        this.m_activeState = null;
        for( i = 0; i < this.m_states.length; ++i )
        {
            state = this.m_states[i];
            if( state.getId() == lastActiveStateId )
            {
                currentProgress = i;
                lastActiveState.onStateCompleted();
                this.m_activeState = this.m_states[ i + 1 ];
                break;
            }
        }

        totalProgress = this.m_states.length;
        if( totalProgress == 0 || currentProgress == undefined )
        {
            progressRatio = 1;
        }
        else
        {
            progressRatio = currentProgress / totalProgress;
        }

        GameController.getTutorialScreen().setProgress( progressRatio );
    },

    setButtonAsUnblocked: function( button )
    {
        this.m_unblockedButtons.push( button );
        button.setEnabled( true );
    },

    blockAllButtons: function()
    {
        this.m_areButtonBlocked = true;
    },

    unblockAllButtons: function()
    {
        this.m_areButtonBlocked = false;
        this.m_unblockedButtons = [];
    },

    isButtonBlocked: function( button )
    {
        if( this.m_areButtonBlocked == false )
        {
            return false;
        }

        for( var i = 0; i < this.m_unblockedButtons.length; ++i )
        {
            if( this.m_unblockedButtons[i] == button )
            {
                return false;
            }
        }

        return true;
    },

    loadStarterPacksListDetails: function( dict )
    {
        info( this.classname + ".loadStarterPacksListDetails: " + JSON.stringify( dict ) );
        this.m_starterPacks = dict;
    },

    getStarterPacks: function()
    {
        return this.m_starterPacks;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Tutorial/TutorialState'] = function(){var exports = $MODULE_REGISTRY['Code/Tutorial/TutorialState'] || {}; $MODULE_REGISTRY['Code/Tutorial/TutorialState'] = exports; 
var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialState.js';

exports.TutorialState = Core.Class.subclass(
{
    classname : "TutorialState",

    initialize: function( stateId, tutorialAction, isPersistable )
    {
        info( "TutorialState.initialize called" );
        this.m_isPersistable = isPersistable;
        this.m_stateId = stateId;
        this.m_tutorialAction = tutorialAction;
    },

    executeAction: function()
    {
        info( "TutorialState.executeAction called" );
        if( !this.m_tutorialAction )
        {
            return;
        }
//        GameController.getMainScreen().setTutorialTopLabel( "this.m_stateId=" + this.m_stateId );
//        GameController.getMainScreen().setVisibleBottomFrame( true );

        this.m_tutorialAction.execute();
    },

    getId: function()
    {
        return this.m_stateId;
    },

    onStateCompleted: function()
    {
        info( "TutorialState.onStateCompleted called. m_stateId=%s", this.m_stateId );

        Server.updateTutorialState( this.m_stateId,
            function( error, data )
            {
                info( "TutorialState.onStateCompleted._innerCallback called. m_stateId=%s, data=%s",
                    this.m_stateId, data );
            }.bind( this )
        );

//        if( this.m_isPersistable )
//        {
//            Server.updateTutorialState(this.m_stateId, this.onServerUpdatedState.bind( this ));
//        }
    }
    
//    onServerUpdatedState    : function( _err, data )
//    {
//        if(_err)
//        {
//            err("TutorialState.onServerUpdatedState ERROR when updating tutorial state : "+JSON.stringify( _err ));
//        }
//
//        info( "TutorialState.onServerUpdatedState > Data received : "+JSON.stringify( data ) );
//    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Tutorial/TutorialAction'] = function(){var exports = $MODULE_REGISTRY['Code/Tutorial/TutorialAction'] || {}; $MODULE_REGISTRY['Code/Tutorial/TutorialAction'] = exports; 
var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialAction.js';

exports.TutorialAction = Core.Class.subclass(
{
    classname : "TutorialAction",

    initialize: function()
    {
        info( "TutorialAction.initialize called" );
    },

    // override as necessary
    execute: function()
    {
        info( "TutorialAction.execute called" );
        // Do nothing
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Tutorial/TutorialExplanationAction'] = function(){var exports = $MODULE_REGISTRY['Code/Tutorial/TutorialExplanationAction'] || {}; $MODULE_REGISTRY['Code/Tutorial/TutorialExplanationAction'] = exports; 
var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialExplanationAction.js';

exports.TutorialExplanationAction = Core.Class.subclass(
{
    classname : "TutorialExplanationAction",
    s_ExplanationScreen: null,


    initialize: function( titleText, descriptionText, buttonText, backgroundImageUrl, cb )
    {
        info( "TutorialExplanationAction.initialize called" );

        this.m_titleText            = titleText;
        this.m_descriptionText      = descriptionText;
        this.m_buttonText           = buttonText;
        this.m_backgroundImageUrl   = backgroundImageUrl;
        this.m_cb                   = cb;
    },

    // override
    execute: function()
    {
        info( "TutorialExplanationAction.execute called" );
        if( TutorialExplanationAction.s_ExplanationScreen )
        {
            info( "TutorialExplanationAction.execute Recycling s_ExplanationScreen" );
            TutorialExplanationAction.s_ExplanationScreen.refresh( this.m_titleText, this.m_descriptionText, this.m_buttonText, this.m_backgroundImageUrl, this.m_cb );
        }
        else
        {
            Xib.Navigation.setModalOverlay(
                new WaitingScreen(
                    function()
                    {
                        var screen = new TutorialExplanationScreen( this.m_titleText, this.m_descriptionText, this.m_buttonText, this.m_backgroundImageUrl, this.m_cb );
                        TutorialExplanationAction.s_ExplanationScreen = screen;
                        Xib.Navigation.resetScreenStackTo( screen, false );
                    }.bind( this )
                )
            );
        }
    },

    $clearExplanationScreen: function()
    {
        info( "TutorialExplanationAction.$clearPictureScreen called. this.m_titleText=%s, this.m_backgroundImageUrl=%s", this.m_titleText, this.m_backgroundImageUrl );
        TutorialExplanationAction.s_ExplanationScreen = null;
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Tutorial/TutorialPictureAction'] = function(){var exports = $MODULE_REGISTRY['Code/Tutorial/TutorialPictureAction'] || {}; $MODULE_REGISTRY['Code/Tutorial/TutorialPictureAction'] = exports; 
var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialPictureAction.js';

exports.TutorialPictureAction = Core.Class.subclass(
{
    classname : "TutorialPictureAction",
    s_PictureScreen: null,

    initialize: function( topText, buttonText, imageUrl, cb )
    {
        info( "TutorialPictureAction.initialize called. topText=%s, imageUrl=%s, buttonText=%s",
            JSON.stringify( topText ), imageUrl, buttonText );

        this.m_topText = topText;
        this.m_buttonText = buttonText;
        this.m_imageUrl = imageUrl;
        this.m_cb = cb;
    },

    // override
    execute: function()
    {
        info( "TutorialPictureAction.execute called. this.m_imageUrl=%s", this.m_imageUrl );
        // TODO FIXME This shouldn't be disabled! fbarriga fix
        if( TutorialPictureAction.s_PictureScreen )
        {
            TutorialPictureAction.s_PictureScreen.refresh( this.m_buttonText, this.m_imageUrl, this.m_cb );
        }
        else
        {
            Xib.Navigation.setModalOverlay(
                new WaitingScreen(
                    function()
                    {
                        var screen = new TutorialPictureScreen( this.m_buttonText, this.m_imageUrl, this.m_cb );
                        TutorialPictureAction.s_PictureScreen = screen;
                        Xib.Navigation.resetScreenStackTo( screen, false );
                    }.bind( this )
                )
            );

            if( this.m_topText )
            {
                GameController.getTutorialScreen().setVisibleTopFrame( true );
                GameController.getTutorialScreen().setTutorialText( this.m_topText );
            }
            else
            {
                GameController.getTutorialScreen().setVisibleTopFrame( false );
            }
        }
    },

    $clearPictureScreen: function()
    {
        info( "TutorialPictureAction.$clearPictureScreen called. this.m_imageUrl=%s", this.m_imageUrl );
        TutorialPictureAction.s_PictureScreen = null;
//        TutorialExplanationAction.s_PictureScreen = null;
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Tutorial/TutorialOpenScreenAction'] = function(){var exports = $MODULE_REGISTRY['Code/Tutorial/TutorialOpenScreenAction'] || {}; $MODULE_REGISTRY['Code/Tutorial/TutorialOpenScreenAction'] = exports; 
var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialOpenScreenAction.js';

exports.TutorialOpenScreenAction = Core.Class.subclass(
{
    classname : "TutorialOpenScreenAction",
    s_ExplanationScreen: null,


    initialize: function( topLayerText, bottomLayerText, imageURL, openScreenFunction, onContinueButton )
    {
        info( "TutorialOpenScreenAction.initialize called" );

        this.m_imageURL = imageURL;
        this.m_topLayerText = topLayerText;
        this.m_bottomLayerText = bottomLayerText;
        this.m_openScreenFunction = openScreenFunction;
        this.m_onContinueButton = onContinueButton;
    },

    // override
    execute: function()
    {
        info( "TutorialOpenScreenAction.execute called" );

        var tutorialScreen = GameController.getTutorialScreen();

        tutorialScreen.setContinueAction( this.m_onContinueButton );
        if( this.m_topLayerText )
        {
            tutorialScreen.setVisibleTopFrame( true );
            tutorialScreen.setTutorialText( this.m_topLayerText );
        }
        else
        {
            tutorialScreen.setVisibleTopFrame( false );
        }

        if( this.m_bottomLayerText )
        {
            tutorialScreen.setVisibleBottomFrame( true );
            tutorialScreen.setTutorialBottomLabel( this.m_bottomLayerText );
        }
        else
        {
            tutorialScreen.setVisibleBottomFrame( false );
        }

        if( this.m_imageURL )
        {
            tutorialScreen.setCardImage( this.m_imageURL );
        }

        if( this.m_openScreenFunction )
        {
            this.m_openScreenFunction();
        }
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Sound/SoundManager'] = function(){var exports = $MODULE_REGISTRY['Code/Sound/SoundManager'] || {}; $MODULE_REGISTRY['Code/Sound/SoundManager'] = exports; 
var __dirname = 'Code/Sound';
var __filename = 'Code/Sound/SoundManager.js';

exports.SoundManager	= Core.Class.singleton({
	
	classname : "SoundManager",
	
    ATTACK_1        : 0,
    ATTACK_2        : 1,
    ATTACK_3        : 2,
    CLICK           : 3,
    OPEN            : 5,
    POD             : 4,
    ENEMY_ATTACK_1  : 6,
    ENEMY_ATTACK_2  : 7,
    ATTACK_4        : 8,
    CANNON_HIT      : 9,
    ELDER_SHOT1     : 10,
    ELDER_SHOT2     : 11,
    HUMAN_SHOT1     : 12,
    MELEE_HIT1      : 13,
    SWARM_SHOT1     : 14,
    SWARM_SHOT2     : 15,
    
    /* MUSIC */

    BG_MUSIC_NORMAL         : "music_galaxy_assault_v2.ogg",
    BG_MUSIC_BATTLE         : "music_battle.ogg",
    BG_MUSIC_FUSION         : "sting_fusion.ogg",
    BG_MUSIC_GASHA          : "sting_dailybonus.ogg",
    BG_MUSIC_EXPLORATION    : "music_odyssey.ogg",
    
    
	initialize : function(){
		this.soundEnabled       = true;
		this.musicEnabled       = true;
        
        this.m_lastMusicStat    = "";
		
		this._listener          = new Core.MessageListener();
		
		// Add your sounds in this array
		// Example :  new Audio.Effect('./Content/Sounds/mySound')
		this.sounds             = [
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_attack1.wav")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_attack2.wav")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_attack3.wav")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_click.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_cardpack_hover.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_cardpack_press.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_enemy_attack1.wav")),
                                    new Audio.Effect(ResourceManager.getPathFor("sfx_enemy_attack2.wav")),
                                    new Audio.Effect(ResourceManager.getPathFor("battle_hit.wav")),
                                    new Audio.Effect(ResourceManager.getPathFor("cannonhit1.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("elder_shot1.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("elder_shot2.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("human_shot1.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("meleehit1.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("swarm_shot1.ogg")),
                                    new Audio.Effect(ResourceManager.getPathFor("swarm_shot2.ogg"))
                                ];		
	},
	
	$playSound : function(soundId){
		if(!this.soundEnabled) return; 
		var audioEffect	= new Audio.ActiveEffect(this.sounds[soundId]);
		audioEffect.play();
		audioEffect.getPlayCompleteEmitter().addListener(this._listener , this._cleanAudioFX.bind(this));
        return audioEffect;
	},
	
	_cleanAudioFX : function(ae){
		ae.destroy();
	},
	
	$setMusicEnabled : function(enable, musicPath){
		this.musicEnabled		= enable;
		
		if (this.musicEnabled){
			if(Audio.Music.getIsPlaying() && musicPath == this.m_lastMusicStat){
				return;
			}
			Audio.Music.setPath( ResourceManager.getPathFor( musicPath ) );
			Audio.Music.play();
			Audio.Music.setVolume( 1 );
		}else{
			Audio.Music.stop();
		}
        
         this.m_lastMusicStat    = musicPath;
	},
	
	$setSoundsEnabled : function(enable){
		this.soundEnabled	= enable;
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Sprite/SpriteFactoryCache'] = function(){var exports = $MODULE_REGISTRY['Code/Sprite/SpriteFactoryCache'] || {}; $MODULE_REGISTRY['Code/Sprite/SpriteFactoryCache'] = exports; 
var __dirname = 'Code/Sprite';
var __filename = 'Code/Sprite/SpriteFactoryCache.js';

exports.SpriteFactoryCache = Core.Class.singleton( {

    classname: 'SpriteFactoryCache',

    initialize: function()
    {
        this._animationCache = {};
    },

    /**
     * @param framePath - the path to the texture to use. Example: ./Content/textures/my_texture.png
     * @param size - the size of the texture. Example: new Core.Size(128,256) or [128,256]
     * @param anchor - the anchor to use. Example: new Core.Point(0.5,1) or [0.5,1]
     * @param uvs - the uvs mapping to use. Example: new Core.Rect(0,0,1,1) or [0,0,1,1]
     * @param filter - boolean flag to filter the texture, by default false.
     * @returns a GL2.Animation instance, could be a new one or a cached one if already exist.
     */
    getAnimation: function( /*String*/ resName, /*Core.Size*/ size, /*Core.Point*/ anchor, /*Core.Rect*/ uvs, /*Boolean*/ filter )
    {
        var framePath       = ResourceManager.getPathFor(resName); 
        
        info("SpriteFactoryCache.getAnimation > framePath : "+framePath+" resName : "+resName);
        
        size = ( size instanceof Core.Size) ? size : new Core.Size( size );
        anchor = ( anchor instanceof Core.Point) ? anchor : new Core.Point( anchor || [0, 0] );
        uvs = ( uvs instanceof Core.Rect) ? uvs : new Core.Rect( uvs || [0, 0, 1, 1] );

        var animation = this.__animationInCache( framePath, 0, size, anchor, uvs );
        if( !animation )
        {
            animation = new GL2.Animation();
            animation.setFilteringEnabled( true && filter );
            animation.pushFrame( new GL2.Animation.Frame( framePath, 0, size, anchor, uvs ) );
            animation._refCounter = 0;
            this.__addToAnimationCache( animation );
        }
        animation._refCounter++;
        return animation;
    },

    /**
     * @param framePath - the path to the texture to use. Example: ./Content/textures/my_texture.png
     * @param size - the size of the texture. Example: new Core.Size(128,256) or [128,256]
     * @param anchor - the anchor to use. Example: new Core.Point(0.5,1) or [0.5,1]
     * @param uvs - the uvs mapping to use. Example: new Core.Rect(0,0,1,1) or [0,0,1,1]
     * @param filter - boolean flag to filter the texture, by default false.
     * @returns a new GL2.Sprite instance with a cached GL2.Animation instance.
     */
    createSpriteWithCachedAnimation: function( /*String*/ framePath, /*Core.Size*/ size, /*Core.Point*/ anchor, /*Core.Rect*/ uvs, /*Boolean*/ filter )
    {
        var sprite = new GL2.Sprite();
        var animation = this.getAnimation( framePath, size, anchor, uvs, filter );
        sprite.setAnimation( animation );
        sprite.__size = ( size instanceof Core.Size) ? size : new Core.Size( size );
        return sprite;
    },

    clearAnimationCache: function()
    {
        var cacheRefCopy = this._animationCache;
        this._animationCache = {};
        var cleared = 0;
        var keeped = 0;
        for( var key in cacheRefCopy )
        {
            var animation = cacheRefCopy[key];
            cacheRefCopy[key] = null;
            if( animation._refCounter == 0 )
            {
                animation.destroy();
                cleared++;
            }
            else
            {
                this._animationCache[key] = animation;
                keeped++;
            }
        }
        console.log( 'SpriteConfigurer.clearAnimationCache: Animation cache cleared: %d, keeped: %d', cleared, keeped );
    },

    __animationInCache: function( image, duration, size, anchor, uvs )
    {
        var key = this.__createCacheKey( image, duration, size, anchor, uvs );
        return this._animationCache[key];
    },

    __addToAnimationCache: function( /*GL2.Animation*/animation )
    {
        var key = this.__createCacheKey(
            animation.getFrame( 0 ).getImage(),
            animation.getFrame( 0 ).getDuration(),
            animation.getFrame( 0 ).getSize(),
            animation.getFrame( 0 ).getAnchor(),
            animation.getFrame( 0 ).getUVs()
        );
        this._animationCache[key] = animation;
    },

    __createCacheKey: function( image, duration, size, anchor, uvs )
    {
        var key = "";
        key += image;
        key += duration;
        key += size.getWidth() + "" + size.getHeight();
        key += anchor.getX() + "" + anchor.getY();
        key += uvs.getOrigin().getX() + "" + uvs.getOrigin().getY() + "" + uvs.getSize().getWidth() + "" + uvs.getSize().getHeight();

        return key;
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Storage/LocalStorage'] = function(){var exports = $MODULE_REGISTRY['Code/Storage/LocalStorage'] || {}; $MODULE_REGISTRY['Code/Storage/LocalStorage'] = exports; 
var __dirname = 'Code/Storage';
var __filename = 'Code/Storage/LocalStorage.js';

exports.LocalStorage = Core.Class.singleton( {
    classname: "LocalStorage",

    initialize: function()
    {
        this._defaultKey = "defaultKey";
        this._storage = Storage.KeyValueCache.local;
    },

    /**
     * Write data to the local app storage.
     * The data parameter can be a string, an array or an object for use like a key/value storage. All the given data will be serialized using JSON.stringify.
     * @param {Object} data to save.
     * @param {Function} [callback] if you want to know the save was successful or not. If it fails, is because a mayor problem is happening, like no space available. The callback receives an object with key/error pairs.
     *
     * Example:
     * 1) LocalStorage.write("my data to save");  //will save string with the default key
     * 2) LocalStorage.write(["data1","data2","data3"]); //will save array with the default key
     * 3) LocalStorage.write({globalData: {xp: 12, gold: 100}, achievements: [1,0,1,0,0,0,0]});
     * 4) LocalStorage.write({globalData: {xp: 12, gold: 100}, achievements: [1,0,1,0,0,0,0]}, function (errors){console.log(JSON.stringify(errors))});
     */
    write: function( data, callback )
    {
        if( data == null )
        {
            throw new Error( "LocalStorage.write: Data I/O: data can't be null" );
        }

        var jsonData = {};
        var dataType = typeof(
            data);
        switch( dataType )
        {
            case "string":
            {
                jsonData[this._defaultKey] = JSON.stringify( data );
                break;
            }
            case "object":
            {
                if( data.hasOwnProperty( "length" ) )
                {
                    jsonData[this._defaultKey] = JSON.stringify( data );
                }
                else
                {
                    for( var key in data )
                    {
                        jsonData[key] = JSON.stringify( data[key] );
                    }
                }
                break;
            }
            default:
            {
                throw new Error( "LocalStorage.write: Data I/O: data type not supported. Type: " + dataType );
            }
        }

        var errors = {};
        var wereErrors = false;
        var counter = 0;
        for( var key in jsonData )
        {
            counter++;
            this._storage.setItem( key, jsonData[key], {}, function( error, ckey )
            {
                if( !error )
                {
                    console.log( "LocalStorage.write: Data I/O: Key: " + ckey + ", data written to disk: " + jsonData[ckey] );
                }
                else
                {
                    wereErrors = true;
                    errors[ckey] = error;
                    console.log( "LocalStorage.write: Data I/O: Key: " + ckey + ". Can't write to disk. Error: " + error );
                }
                counter--;
            } );
        }

        var checkReady = function()
        {
            if( counter > 0 )
            {
                setTimeout( checkReady, 100 );
            }
            else
            {
                if( wereErrors )
                {
                    callback( errors );
                }
                else
                {
                    callback();
                }
            }
        };

        if( callback )
        {
            setTimeout( checkReady, 100 );
        }
    },

    /**
     * Read data from the local storage.
     * The key parameter specified the keys to be read, if null/undefined, then the default key will be used. The data parameter will be passed as it was received, it responsibility of the client to parse it.
     * In case of error, an error object will be given with a
     * @param {Array} callback(error,data) to give the read data
     * @param {Array} [keys] to read
     *
     * Example:
     * 1) LocalStorage.read(function(error,data) {// //will read the default key
     *      console.log("LocalStorage: Read: " + data);
     *    });
     *
     * 2) LocalStorage.read(function(errors,datas) {
     *        for (var key in datas) {
     *            if (errors[key]) {
     *                console.log("LocalStorage: Read errors["+key+"]: " + errors[key]);
     *            } else {
     *                console.log("LocalStorage: Read datas["+key+"]: " + datas[key]);
     *            }
     *        }

     *        if (data) {
     *            LocalStorage.remove(["key1","key2"]);
     *        }
     *    },["key1","key2"]);
     */
    read: function( callback, keys )
    {
        if( typeof callback != "function" )
        {
            throw new Error( "LocalStorage.read: callback should be a function" );
        }

        if( keys == null )
        {
            keys = [this._defaultKey];
        }

        if( keys.length == 0 )
        {
            console.log( "LocalStorage.read: Data I/O: empty array of keys to read, aborting." );
            return;
        }

        var datas = {};
        var errors = {};
        var counter = 0;
        var key = null;
        for( var index in keys )
        {
            key = keys[index];
            counter++;
            this._storage.getItem( key, {}, function( ckey, error, value )
            {
                counter--;
                datas[ckey] = null;
                errors[ckey] = null;
                if( value )
                {
                    console.log( "LocalStorage.read: Data I/O: Key " + ckey + ", read from disk. " + value );
                    datas[ckey] = JSON.parse( value );
                }
                else
                {
                    if( error.indexOf( 'Could not find key' ) == 0 || error.indexOf( 'No Results' ) != -1 ||
                        error.indexOf( 'Lookup query returned no result' ) != -1 )
                    {
                        console.log( "LocalStorage.read: Data I/O: Key " + ckey + " not found on disk." );
                    }
                    else
                    {
                        console.log( "LocalStorage.read: Data I/O: Key " + ckey + ". Can't read from disk. Error: " + error );
                        errors[ckey] = error;
                    }
                }
            }.bind( this, key ) );
        }

        var checkReady = function()
        {
            if( counter > 0 )
            {
                setTimeout( checkReady, 100 );
            }
            else
            {
                if( keys.length == 1 && keys[0] == this._defaultKey )
                {
                    if( errors[this._defaultKey] )
                    {
                        callback( errors[this._defaultKey], null );
                    }
                    else
                    {
                        callback( null, datas[this._defaultKey] );
                    }
                }
                else
                {
                    callback( errors, datas );
                }
            }
        }.bind( this );

        setTimeout( checkReady, 100 );
    },

    /**
     * Erase the keys.
     * @param {Array} [keys] to erase. If null/undefined is given, then the default key will be used.
     *
     * Example:
     * 1) LocalStorage.remove(); //will remove the default key
     *
     * 2) LocalStorage.remove(["key1","key2"]);
     */
    remove: function( keys )
    {
        if( keys == null )
        {
            keys = [this._defaultKey];
        }

        if( keys.length == 0 )
        {
            console.log( "LocalStorage.remove: Data I/O: empty array of keys to remove, aborting." );
            return;
        }

        var key = null;
        for( var index in keys )
        {
            key = keys[index];
            this._storage.removeItem( key, function( ckey, error )
            {
                if( !error )
                {
                    console.log( "LocalStorage.remove: Data I/O: Key " + ckey + " removed." );
                }
                else
                {
                    console.log( "LocalStorage.remove: Data I/O: Key " + ckey + " couldn't be removed. Error: " + error );
                }
            }.bind( this, key ) );
        }
    }
} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Storage/RemoteStorage'] = function(){var exports = $MODULE_REGISTRY['Code/Storage/RemoteStorage'] || {}; $MODULE_REGISTRY['Code/Storage/RemoteStorage'] = exports; 
var __dirname = 'Code/Storage';
var __filename = 'Code/Storage/RemoteStorage.js';

exports.RemoteStorage = Core.Class.singleton( {
    classname: "RemoteStorage",

    initialize: function()
    {
        this._defaultKey = "defaultKey";
        this._maxRetry = 3;
        this._retrySleep = 500;
    },

    /**
     * Write data to the remote storage.
     * The data parameter can be a string, an array or an object for use like a key/value storage. All the given data will be serialized using JSON.stringify.
     * @param {Object} data to save.
     * @param {Function} [callback] if you want to know the save was successful or not. If it fails, is because a mayor problem is happening, like no space available. The callback receives an object with key/error pairs.
     *
     * Example:
     * 1) RemoteStorage.write("my data to save");  //will save string with the default key
     * 2) RemoteStorage.write(["data1","data2","data3"]); //will save array with the default key
     * 3) RemoteStorage.write({globalData: {xp: 12, gold: 100}, achievements: [1,0,1,0,0,0,0]});
     * 4) RemoteStorage.write({globalData: {xp: 12, gold: 100}, achievements: [1,0,1,0,0,0,0]}, function (errors){console.log(JSON.stringify(errors))});
     */
    write: function( data, callback )
    {
        if( data == null )
        {
            throw new Error( "RemoteStorage.write: Data I/O: data can't be null" );
        }

        var jsonData = {};
        var dataType = typeof(
            data);
        switch( dataType )
        {
            case "string":
            {
                jsonData[this._defaultKey] = data;
                break;
            }
            case "object":
            {
                if( data.hasOwnProperty( "length" ) )
                {
                    jsonData[this._defaultKey] = JSON.stringify( data );
                }
                else
                {
                    for( var key in data )
                    {
                        jsonData[key] = JSON.stringify( data[key] );
                    }
                }
                break;
            }
            default:
            {
                throw new Error( "RemoteStorage.write: Data I/O: data type not supported. Type: " + dataType );
            }
        }

        this._write( this._maxRetry, jsonData, callback );
    },

    _write: function( retries, jsonData, callback )
    {
        Social.Common.Appdata.updateEntries( jsonData, function( error )
        {
            if( !error )
            {
                console.log( "RemoteStorage.write: Data I/O: data written to storage: " + JSON.stringify( jsonData ) );
            }
            else
            {
                if( retries-- > 0 )
                {
                    console.log( "RemoteStorage.write: Data I/O: Error on connection, retrying " + (
                        retries + 1) + " more times." );
                    setTimeout( this._write.bind( this, retries, jsonData, callback ), this._retrySleep );
                    return;
                }
                console.log( "RemoteStorage.write: Data I/O: Can't write to storage. Error: " + JSON.stringify( error ) );
            }
            callback && callback( error );
        } );
    },

    /**
     * Read data from the remote storage.
     * The key parameter specified the keys to be read, if null/undefined, then the default key will be used. The data parameter will be passed as it was received, it responsibility of the client to parse it.
     * In case of error, an error object will be given with a
     * @param {Array} callback(error,data) to give the read data
     * @param {Array} [keys] to read
     *
     * Example:
     * 1) RemoteStorage.read(function(error,data) {// //will read the default key
     *      console.log("RemoteStorage: Read: " + data);
     *    });
     *
     * 2) RemoteStorage.read(function(errors,datas) {
     *        for (var key in datas) {
     *            if (errors[key]) {
     *                console.log("RemoteStorage: Read errors["+key+"]: " + errors[key]);
     *            } else {
     *                console.log("RemoteStorage: Read datas["+key+"]: " + datas[key]);
     *            }
     *        }

     *        if (data) {
     *            RemoteStorage.remove(["key1","key2"]);
     *        }
     *    },["key1","key2"]);
     */
    read: function( callback, keys )
    {
        if( typeof callback != "function" )
        {
            throw new Error( "RemoteStorage.read: callback should be a function" );
        }

        if( keys == null )
        {
            keys = [this._defaultKey];
        }

        if( keys.length == 0 )
        {
            console.log( "RemoteStorage.read: Data I/O: empty array of keys to read, aborting." );
            return;
        }

        this._read( this._maxRetry, callback, keys );
    },

    _read: function( retries, callback, keys )
    {
        var datas = {};
        var errors = {};
        var key = null;
        Social.Common.Appdata.getEntries( keys, function( error, entries )
        {
            if( !error )
            {
                for( var index in keys )
                {
                    datas[keys[index]] = entries[keys[index]];
                }

            }
            else
            {
                if( retries-- > 0 )
                {
                    console.log( "RemoteStorage.read: Data I/O: Keys " + keys + ", error on connection, retrying " + (
                        retries + 1) + " more times." );
                    setTimeout( this._read.bind( this, retries, callback, keys ), this._retrySleep );
                    return;
                }
                console.log( "RemoteStorage.read: Data I/O: Keys " + keys + " couldn't be read from remote. Error: " + JSON.stringify( error ) );
                //convert to key/value objects to have the same API than when returning from Social.US.AppData.getDataForUserWithKey
                for( var index in keys )
                {
                    key = keys[index];
                    datas[key] = null;
                    errors[key] = error;
                }
            }
            if( keys.length == 1 && keys[0] == this._defaultKey )
            {
                if( errors[this._defaultKey] )
                {
                    callback( errors[this._defaultKey], null );
                }
                else
                {
                    callback( null, datas[this._defaultKey] );
                }
            }
            else
            {
                callback( errors, datas );
            }
        }.bind( this ) );
    },

    /**
     * Erase the keys from the remote storage.
     * @param {Array} [keys] to erase. If null/undefined is given, then the default key will be used.
     *
     * Example:
     * 1) RemoteStorage.remove(); //will remove the default key
     *
     * 2) RemoteStorage.remove(["key1","key2"]);
     */
    remove: function( keys )
    {
        if( keys == null )
        {
            keys = [this._defaultKey];
        }

        if( keys.length == 0 )
        {
            console.log( "RemoteStorage.remove: Data I/O: empty array of keys to remove, aborting." );
            return;
        }
        this._remove( this._maxRetry, keys );
    },

    _remove: function( retries, keys )
    {
        Social.Common.Appdata.deleteEntries( keys, function( error, ckeys )
        {
            if( !error )
            {
                console.log( "RemoteStorage.remove: Data I/O: Keys " + ckeys + " removed." );
            }
            else
            {
                if( retries-- > 0 )
                {
                    console.log( "RemoteStorage.remove: Data I/O: Error on connection, retrying " + (
                        retries + 1) + " more times." );
                    setTimeout( this._remove.bind( this, retries, keys ), this._retrySleep );
                    return;
                }
                console.log( "RemoteStorage.remove: Data I/O: Keys " + keys + " couldn't be removed from remote. Error: " + JSON.stringify( error ) );
            }
        } );
    }
} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Storage/USRemoteStorage'] = function(){var exports = $MODULE_REGISTRY['Code/Storage/USRemoteStorage'] || {}; $MODULE_REGISTRY['Code/Storage/USRemoteStorage'] = exports; 
var __dirname = 'Code/Storage';
var __filename = 'Code/Storage/USRemoteStorage.js';

var RemoteStorage = require( 'Code/Storage/RemoteStorage' ).RemoteStorage;

exports.USRemoteStorage = Core.Class.singleton( {
    classname: "USRemoteStorage",

    initialize: function()
    {
        this._defaultKey = "defaultKey";
        this._maxRetry = 3;
        this._retrySleep = 500;
    },

    /**
     * Write data to the US storage.
     * The data parameter can be a string, an array or an object for use like a key/value storage. All the given data will be serialized using JSON.stringify.
     * @param {Object} data to save.
     * @param {Social.US.AppData.Permissions} [permission] to store all the data with. If null/undefined is given, then will use Social.US.AppData.Permissions.Private as default.
     * @param {Function} [callback] if you want to know the save was successful or not. If it fails, it may be because network issues. The callback receives an object with key/error pairs.
     *
     * Example:
     * 1) USRemoteStorage.write("my data to save");  //will save string with the default key
     * 2) USRemoteStorage.write(["data1","data2","data3"], Social.US.AppData.Permissions.PublicReadOnly); //will save array with the default key and public permission
     * 3) USRemoteStorage.write({globalData: {xp: 12, gold: 100}, achievements: [1,0,1,0,0,0,0]});
     * 4) USRemoteStorage.write({globalData: {xp: 12, gold: 100}, achievements: [1,0,1,0,0,0,0]},  Social.US.AppData.Permissions.PublicReadOnly, function (errors){console.log(JSON.stringify(errors))});
     */
    write: function( data, permissions, callback )
    {
        if( data == null )
        {
            throw new Error( "USRemoteStorage.write: Data I/O: data can't be null" );
        }

        if( permissions == null )
        {
            permissions = Social.US.AppData.Permissions.Private;
        }

        //FIXME: using Common.Appdata mixed with US.AppData on production is not working as of 2011/12/21
        if( false && permissions == Social.US.AppData.Permissions.Private )
        {
            RemoteStorage.write( data, callback );
        }
        else
        {
            var jsonData = {};
            var dataType = typeof(
                data);
            switch( dataType )
            {
                case "string":
                {
                    jsonData[this._defaultKey] = data;
                    break;
                }
                case "object":
                {
                    if( data.hasOwnProperty( "length" ) )
                    {
                        jsonData[this._defaultKey] = JSON.stringify( data );
                    }
                    else
                    {
                        for( var key in data )
                        {
                            jsonData[key] = JSON.stringify( data[key] );
                        }
                    }
                    break;
                }
                default:
                {
                    throw new Error( "USRemoteStorage.write: Data I/O: data type not supported. Type: " + dataType );
                }
            }
            this._write( this._maxRetry, jsonData, permissions, callback );
        }
    },

    _write: function( retries, jsonData, permissions, callback )
    {
        var session = Social.US.Session.getCurrentSession();
        if( session )
        {
            user = session.user();
        }
        else
        {
            throw new Error( "USRemoteStorage.write: Data I/O: couldn't get a valid session to get the user. Check your connection configuration" );
        }
        var counter = 0;
        var errors = {};
        var onResponse = function( ckey, cdata, cretries, error, response )
        {
            if( error )
            {
                if( cretries-- > 0 )
                {
                    console.log( "USRemoteStorage.write: Data I/O: Error writing key: %s, will retry %d more time", key, cretries + 1 );
                    setTimeout( function()
                    {
                        Social.US.AppData.setDataForUserWithKeyAndPermissions( cdata, user, ckey, permissions, onResponse.bind( this, ckey, cdata, cretries ) );
                    }.bind( this ), this._retrySleep );
                }
                else
                {
                    counter--;
                    errors[ckey] = error;
                    console.log( "USRemoteStorage.write: Data I/O: Too many errors writing key: %s, will not retry again, error: %s", ckey, error );
                }
            }
            else
            {
                counter--;
                errors[ckey] = null;
                console.log( "USRemoteStorage.write: Data I/O: Key " + ckey + " written to US storage, value: " + cdata );
            }
        };

        for( var key in jsonData )
        {
            counter++;
            Social.US.AppData.setDataForUserWithKeyAndPermissions( jsonData[key], user, key, permissions, onResponse.bind( this, key, jsonData[key], retries ) );
        }

        if( callback )
        {
            var checkReady = function()
            {
                if( counter > 0 )
                {
                    setTimeout( checkReady, 300 );
                }
                else
                {
                    if( jsonData.length == 1 && jsonData.hasOwnProperty( this._defaultKey ) )
                    {
                        callback( errors[this._defaultKey] );
                    }
                    else
                    {
                        callback( errors );
                    }
                }
            }.bind( this );
            setTimeout( checkReady, 300 );
        }
    },

    /**
     * Read data from the US storage.
     * The key parameter specified the keys to be read, if null/undefined, then the default key will be used. The data parameter will be passed as it was received, is responsibility of the client to parse it.
     * In case of error, an error object will be given with a
     * @param {Social.US.User} user to read data from, if null, then the Social.US.Session.getCurrentSession().user() user will be used.
     * @param {Array} callback(error,data) to give the read data
     * @param {Array} [keys] to read
     *
     * Example:
     * 1) USRemoteStorage.read(null,function(error,data) {//will read the default key from the current user.
     *      console.log("USRemoteStorage: Read: " + data);
     *    });
     *
     * 2) var onResponse = function(errors,datas) {
     *        for (var key in datas) {
     *            if (errors[key]) {
     *                console.log("USRemoteStorage: Read errors["+key+"]: " + errors[key]);
     *            } else {
     *                console.log("USRemoteStorage: Read datas["+key+"]: " + datas[key]);
     *            }
     *        }

     *        if (data) {
     *            USRemoteStorage.remove(["key1","key2"]);
     *        }
     *  };
     *
     *  USRemoteStorage.read(null, onResponse,["key1","key2"]);//will read keys ["key1", "key2"] from the current user.
     *
     *  USRemoteStorage.read(anotherUser, onResponse,["key1","key2"]);//will read keys ["key1", "key2"] from anotherUser user. anotherUser can be retrieved with a call to: Social.US.User.getUserWithGamertag
     */
    read: function( user, callback, keys )
    {
        var isSessionUser = false;
        if( user == null )
        {
            var session = Social.US.Session.getCurrentSession();
            if( session )
            {
                user = session.user();
                isSessionUser = true;
            }
            else
            {
                throw new Error( "USRemoteStorage.read: Data I/O: couldn't get a valid session to get the user. Check your connection configuration" );
            }
        }

        //FIXME: using Common.Appdata mixed with US.AppData on production is not working as of 2011/12/21
        if( false && isSessionUser )
        {
            RemoteStorage.read( callback, keys );
        }
        else
        {
            if( typeof callback != "function" )
            {
                throw new Error( "USRemoteStorage.read: Data I/O: callback should be a function" );
            }

            if( keys == null )
            {
                keys = [this._defaultKey];
            }

            if( keys.length == 0 )
            {
                console.log( "USRemoteStorage.read: Data I/O: empty array of keys to read, aborting." );
                return;
            }

            this._read( this._maxRetry, user, callback, keys );
        }
    },

    _read: function( retries, user, callback, keys )
    {
        var datas = {};
        var errors = {};
        var counter = 0;
        var key = null;

        var onResponse = function( cretries, ckey, error, response )
        {
            datas[ckey] = null;
            errors[ckey] = null;

            if( !error && response && response.data )
            {
                var value = response.data;
                console.log( "USRemoteStorage.read: Data I/O: Key " + ckey + ", read from remote: " + value );
                datas[ckey] = value;
                counter--;
            }
            else
            {
                if( cretries-- > 0 )
                {
                    console.log( "USRemoteStorage.read: Data I/O: Key " + ckey + ", error on connection, retrying " + (
                        cretries + 1) + " more times." );
                    setTimeout( function()
                    {
                        Social.US.AppData.getDataForUserWithKey( user, ckey, onResponse.bind( this, cretries, ckey ) );
                    }.bind( this ), this._retrySleep );
                    return;
                }
                counter--;
                console.log( "USRemoteStorage.read: Data I/O: Key " + ckey + " couldn't be read from remote. Error: " + JSON.stringify( error ) );
                errors[ckey] = JSON.stringify( error );
            }
        };

        for( var index in keys )
        {
            key = keys[index];
            counter++;
            Social.US.AppData.getDataForUserWithKey( user, key, onResponse.bind( this, retries, key ) );
        }

        var checkReady = function()
        {
            if( counter > 0 )
            {
                setTimeout( checkReady, 100 );
            }
            else
            {
                if( keys.length == 1 && keys[0] == this._defaultKey )
                {
                    if( errors[this._defaultKey] )
                    {
                        callback( errors[this._defaultKey], null );
                    }
                    else
                    {
                        callback( null, datas[this._defaultKey] );
                    }
                }
                else
                {
                    callback( errors, datas );
                }
            }
        }.bind( this );

        setTimeout( checkReady, 100 );
    },

    /**
     * Erase the keys from the remote storage.
     * @param {Array} [keys] to erase. If null/undefined is given, then the default key will be used.
     *
     * Example:
     * 1) RemoteStorage.remove(); //will remove the default key
     *
     * 2) RemoteStorage.remove(["key1","key2"]);
     */
    remove: function( keys )
    {
        RemoteStorage.remove( keys );
    }
} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Network/SXHR'] = function(){var exports = $MODULE_REGISTRY['Code/Network/SXHR'] || {}; $MODULE_REGISTRY['Code/Network/SXHR'] = exports; 
var __dirname = 'Code/Network';
var __filename = 'Code/Network/SXHR.js';

var XHR = Network.XHR;
/**
 * Simple XHR.
 */
exports.SXHR = Core.Class.subclass(
{
    classname: "SXHR",
    initialize: function()
    {

    },

    /**
     * Simple get method. If the returned data comes with a header "Content-Type :
     * application/json", then the data will be parsed before returning it.
     * 
     * @param url
     *            to retrieve
     * @param [callbackOrData]
     *            the callback or data to send. If this is data to send, then
     *            should be a string or an object to be serialized.
     * @param callback
     *            to call when done. should be in the form: callback (error,
     *            data)
     * 
     * Example of a service returning json data: var callback = function
     * (error,data) { if (error) { console.log("Error: code: " + error.code + ",
     * message: " + error.message); } else { console.log(data.status); if
     * (data.status == "OK") { console.log(data.results[0].formatted_address); } } }
     * SXHR.get("http://maps.googleapis.com/maps/api/geocode/json",{address:"1600
     * Amphitheatre Parkway, Mountain View, CA", sensor:"false"},callback);
     * 
     * Example of a simple get:
     * SXHR.get("http://www.google.com",function(error,data){console.log(data)});
     */
    $get: function( url, callbackOrData, callback )
    {
        var dataObject = null;
        if( typeof ( callbackOrData ) == "function" )
        {
            callback = callbackOrData;
        }
        else if( callback )
        {
            dataObject = callbackOrData;
        }
        console.log( "SXHR.get: Network status: " + Device.NetworkEmitter.getLastStatus() );

        if( Device.NetworkEmitter.getLastStatus() == Device.NetworkEmitter.Status.None )
        {
            callback(
            {
                code: -2,
                message: "No network available"
            } );
            return;
        }

        var dataStr = this._buildDataString( dataObject );
        if( dataStr )
        {
            var questionIndex = url.indexOf( '?' );
            if( questionIndex != -1 )
            {
                if( questionIndex == url.length - 1 || url.indexOf( '&' ) == url.length - 1 )
                {
                    url += dataStr;
                }
                else
                {
                    url += '&' + dataStr;
                }
            }
            else
            {
                url += '?' + dataStr;
            }
        }

        var req = this._xhr( 'GET', url, callback );
        req.send();
    },

    /**
     * Simple post method. If the returned data comes with a header
     * "Content-Type : application/json", then the data will be parsed before
     * returning it.
     * 
     * @param url
     *            to send to
     * @param [callbackOrData]
     *            the callback or data to send. If this is data to send, then
     *            should be a string or an object to be serialized.
     * @param callback
     *            to call when done. should be in the form: callback (error,
     *            data)
     * 
     * Example of a service returning json data:
     * SXHR.post("http://php.opensourcecms.com/scripts/show.php",{catid:"all","category":"All
     * CMS Demos"},function(error,data) { if (!error) { console.log("Right
     * page?: " + (data.indexOf("All Open Source PHP Demos") != -1)); } else {
     * console.log("Error: code: " + error.code + ", message: " +
     * error.message); } });
     */
    $post: function( url, callbackOrData, callback )
    {
        var dataObject = null;
        if( typeof ( callbackOrData ) == "function" )
        {
            callback = callbackOrData;
        }
        else if( callback )
        {
            dataObject = callbackOrData;
        }

        if( Device.NetworkEmitter.getLastStatus() == Device.NetworkEmitter.Status.None )
        {
            callback(
            {
                code: -2,
                message: "No network available"
            } );
            return;
        }

        var req = this._xhr( 'POST', url, callback );
        req.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
        req.__data = this._buildDataString( dataObject );
        req.send( req.__data );
    },

    $_buildDataString: function( dataObject )
    {
        var dataStr = null;
        if( dataObject )
        {
            if( typeof ( dataObject ) == "string" )
            {
                dataStr = dataObject;
            }
            else
            {
                var dataArr = new Array();
                for( var key in dataObject )
                {
                    dataArr.push( escape( key ) + "=" + escape( dataObject[key] ) );
                }
                dataStr = dataArr.join( "&" );
            }
        }

        return dataStr;
    },

    $_xhr: function( method, url, callback )
    {
        var req = new XHR();
        req.onreadystatechange = function()
        {
            if( req.readyState == 4 )
            {
                var httpStatus = req.status;
                var statusText = req.statusText;
                if( httpStatus == 200 )
                {
                    // Success.
                    this._handleResponse( req, callback );
                }
                else
                {
                    // follow redirect
                    if( httpStatus == 301 || httpStatus == 302 || httpStatus == 303 || httpStatus == 307 )
                    {
                        // following redirect
                        var newUrl = req.getResponseHeader( "Location" );
                        if( !newUrl )
                        {
                            callback(
                            {
                                code: httpStatus,
                                message: statusText
                            } );
                        }
                        else
                        {
                            // check if it is relative
                            if( newUrl.charAt( 0 ) == "/" )
                            {
                                var matches = url.match( /(https?:\/\/.+?)(\/|\?|\#|$)/i );
                                url = matches[1] + newUrl;
                            }
                            else
                            {
                                url = newUrl;
                            }
                            if( httpStatus <= 303 && method != "GET" )
                            {
                                this.get( url, req.__data, callback );
                            }
                            else
                            {
                                var newReq = this._xhr( method, url, callback );
                                newReq.__data = req.__data;
                                if( method == "POST" )
                                {
                                    newReq.send( newReq.__data );
                                }
                                else
                                {
                                    newReq.send();
                                }
                            }
                        }
                    }
                    else
                    {
                        callback(
                        {
                            code: httpStatus,
                            message: statusText
                        } );
                    }
                }
            }
        }.bind( this );

        req.open( method, url );
        return req;
    },

    $_handleResponse: function( req, callback )
    {
        var data = req.responseText;
        var type = req.getResponseHeader( "Content-Type" );
        if( data && type && data.length && type.indexOf( "application/json" ) != -1 )
        {
            var jsonData = null;
            var parsed = false;
            try
            {
                jsonData = JSON.parse( data );
                parsed = true;
            }
            catch( e )
            {
                callback(
                {
                    code: -1,
                    message: "Couldn't parse response as JSON. Data: " + data
                } );
            }
            if( parsed )
            {
                callback( null, jsonData );
            }
        }
        else
        {
            callback( null, data );
        }
    }

} );; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/MoreMath'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/MoreMath'] || {}; $MODULE_REGISTRY['ngCrunch/MoreMath'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/MoreMath.js';

var Core  = require('NGCore/Client/Core').Core;

/**
 * @name MoreMath
 * @class
 * Utilities for interpolating float values for animation
 */


exports.MoreMath = Core.Class.subclass(
/** @lends MoreMath.prototype */
{
    classname: 'MoreMath',
	
	/** 
	 * Animation curve types
	 * @namespace
	 */
	BlendCurve:	{
		/** Flat slope curve */
		Linear:			"LERP",
		/** Ease in and out */
		EaseInOut:		"XLERP",
		/** Along a sine wave */
		Sherical:		"SLERP",
		// DDP I'd be happy to add the rest, just don't really know what they mean.
		
		/** Penner Easing sine-wave curve, “in” variant */
		SineIn:			"SINEIN",
		/** Penner Easing sine-wave curve, “out” variant */
		SineOut:		"SINEOUT",
		/** Penner Easing sine-wave curve, “in/out” variant */
		SineInOut:		"SINEINOUT",
		
		/** Penner Easing 2nd-order algebraic curve, “in” variant */
		QuadIn:			"QUADIN",
		/** Penner Easing 2nd-order algebraic curve, “out” variant */
		QuadOut:		"QUADOUT",
		/** Penner Easing 2nd-order algebraic curve, “in/out” variant */
		QuadInOut:		"QUADINOUT",
		
		/** Penner Easing 3rd-order algebraic curve, “in” variant */
		CubicIn:		"CUBICIN",
		/** Penner Easing 3rd-order algebraic curve, “out” variant */
		CubicOut:		"CUBICOUT",
		/** Penner Easing 3rd-order algebraic curve, “in/out” variant */
		CubicInOut:		"CUBICINOUT",
		
		/** Penner Easing 4th-order algebraic curve, “in” variant */
		QuartIn:		"QUARTIN",
		/** Penner Easing 4th-order algebraic curve, “out” variant */
		QuartOut:		"QUARTOUT",
		/** Penner Easing 4th-order algebraic curve, “in/out” variant */
		QuartInOut:		"QUARTINOUT",
		
		/** Penner Easing 5th-order algebraic curve, “in” variant */
		QuintIn:		"QUINTIN",
		/** Penner Easing 5th-order algebraic curve, “out” variant */
		QuintOut:		"QUINTOUT",
		/** Penner Easing 5th-order algebraic curve, “in/out” variant */
		QuintInOut:		"QUINTINOUT",
		
		/** Penner Easing exponential curve, “in” variant */
		ExpoIn:			"EXPOIN",
		/** Penner Easing exponential curve, “out” variant */
		ExpoOut:		"EXPOOUT",
		/** Penner Easing exponential curve, “in/out” variant */
		ExpoInOut:		"EXPOINOUT",
		
		/** Penner Easing circular/spherical curve, “in” variant */
		CircIn:			"CIRCIN",
		/** Penner Easing circular/spherical curve, “out” variant */
		CircOut:		"CIRCOUT",
		/** Penner Easing circular/spherical curve, “in/out” variant */
		CircInOut:		"CIRCINOUT",
		
		/** Penner Easing elastic “curve”, “in” variant */
		ElasticIn:		"ELASTICIN",
		/** Penner Easing elastic “curve”, “out” variant */
		ElasticOut:		"ELASTICOUT",
		/** Penner Easing elastic “curve”, “in/out” variant */
		ElasticInOut:	"ELASTICINOUT",
		
		/** Penner Easing back-up “curve”, “in” variant */
		BackIn:			"BACKIN",
		/** Penner Easing back-up “curve”, “out” variant */
		BackOut:		"BACKOUT",
		/** Penner Easing back-up “curve”, “in/out” variant */
		BackInOut:		"BACKINOUT",
		
		/** Penner Easing bouncing “curve”, “in” variant */
		BounceIn:		"BOUNCEIN",
		/** Penner Easing bouncing “curve”, “out” variant */
		BounceOut:		"BOUNCEOUT",
		/** Penner Easing bouncing “curve”, “in/out” variant */
		BounceInOut:	"BOUNCEINOUT",
	},
	
	/**
		interpolate between values a and b at time t (range 0 to 1), using the given blend curve style.
		Understands floats, Core.Point, Core.Vector, Core.Size, Core.Color and Core.Rect for a and b.
		@static
	*/
	$interpolate: function(/**MoreMath.BlendCurve*/func, /**float*/a, /**float*/b, /**float*/t)
	{
		if((a instanceof Core.Point) || (a instanceof Core.Vector))
		{
			return new Core.Vector(this.interpolate(func, a.getX(), b.getX(), t), 
									this.interpolate(func, a.getY(), b.getY(), t));
		}
		else if(a instanceof Core.Size)
		{
			return new Core.Size(this.interpolate(func, a.getWidth(), b.getWidth(), t), 
									this.interpolate(func, a.getHeight(), b.getHeight(), t));
		}
		else if(a instanceof Core.Color)
		{
			return new Core.Color(this.interpolate(func, a.getRed(), b.getRed(), t), 
									this.interpolate(func, a.getGreen(), b.getGreen(), t), 
									this.interpolate(func, a.getBlue(), b.getBlue(), t));
		}
		else if(a instanceof Core.Rect)
		{
			return new Core.Rect(this.interpolate(func, a.getOrigin().getX(), b.getOrigin().getX(), t),
								this.interpolate(func, a.getOrigin().getY(), b.getOrigin().getY(), t),
								this.interpolate(func, a.getSize().getWidth(), b.getSize().getWidth(), t),
								this.interpolate(func, a.getSize().getHeight(), b.getSize().getHeight(), t));
		}
		else
		{
			switch(func)
			{
				case "LERP":
					return this.lerp(a,b,t);
				case "XLERP":
					return this.xLerp(a,b,t);
				case "XLERPINV":
					return this.xLerpInv(a,b,t);
				case "XLERPBOTH":
					return this.xLerpBoth(a,b,t);
				case "SLERP":
					return this.slerp(a,b,t);
				
				case "SINEIN":
					return this.Easing.sineIn(a,b,t);
				case "SINEOUT":
					return this.Easing.sineOut(a,b,t);
				case "SINEINOUT":
					return this.Easing.sineInOut(a,b,t);
				
				case "QUADIN":
					return this.Easing.quadIn(a,b,t);
				case "QUADOUT":
					return this.Easing.quadOut(a,b,t);
				case "QUADINOUT":
					return this.Easing.quadInOut(a,b,t);
				
				case "CUBICIN":
					return this.Easing.cubicIn(a,b,t);
				case "CUBICOUT":
					return this.Easing.cubicOut(a,b,t);
				case "CUBICINOUT":
					return this.Easing.cubicInOut(a,b,t);
				
				case "QUARTIN":
					return this.Easing.quartIn(a,b,t);
				case "QUARTOUT":
					return this.Easing.quartOut(a,b,t);
				case "QUARTINOUT":
					return this.Easing.quartInOut(a,b,t);
				
				case "QUINTIN":
					return this.Easing.quintIn(a,b,t);
				case "QUINTOUT":
					return this.Easing.quintOut(a,b,t);
				case "QUINTINOUT":
					return this.Easing.quintInOut(a,b,t);
				
				case "EXPOIN":
					return this.Easing.expoIn(a,b,t);
				case "EXPOOUT":
					return this.Easing.expoOut(a,b,t);
				case "EXPOINOUT":
					return this.Easing.expoInOut(a,b,t);
				
				case "CIRCIN":
					return this.Easing.circIn(a,b,t);
				case "CIRCOUT":
					return this.Easing.circOut(a,b,t);
				case "CIRCINOUT":
					return this.Easing.circInOut(a,b,t);
				
				case "ELASTICIN":
					return this.Easing.elasticIn(a,b,t);
				case "ELASTICOUT":
					return this.Easing.elasticOut(a,b,t);
				case "ELASTICINOUT":
					return this.Easing.elasticInOut(a,b,t);
				
				case "BACKIN":
					return this.Easing.backIn(a,b,t);
				case "BACKOUT":
					return this.Easing.backOut(a,b,t);
				case "BACKINOUT":
					return this.Easing.backInOut(a,b,t);
				
				case "BOUNCEIN":
					return this.Easing.bounceIn(a,b,t);
				case "BOUNCEOUT":
					return this.Easing.bounceOut(a,b,t);
				case "BOUNCEINOUT":
					return this.Easing.bounceInOut(a,b,t);
			}
		}
	},
	
	$lerp: function(a, b, t)
	{
		return a + t * (b - a);
	},
	
	$xLerp: function(a, b, t)
	{
		t = t * t;
		return this.lerp(a, b, t);
	},
	
	$xLerpInv: function(a, b, t)
	{
		t = -(t * t) + 2*t;
		return this.lerp(a, b, t);
	},
	
	$xLerpBoth: function(a, b, t)
	{
		if ((t*=2) < 1)
		{
			return (b-a)/2*t*t+a;
		}
		return (a-b)/2*((--t)*(t-2)-1)+a;
	},
	
	$slerp: function(a, b, t)
	{
		if(t >= 1)
		{
			return a;
		}
		t = Math.sin(Math.PI * t);
		return this.lerp(a, b, t);
	},
	
	
	$clamp: function(value, min, max)
	{
		if (value < min)
			return min;
		else if (value > max)
			return max;
		else
			return value;
	},
	
	$clamp01: function(value)
	{
		return this.clamp(value, 0, 1);
	},
	
	/**
	 * The Classic Penner Easing Equations
	 * Originally by Robert Penner
	 * Adapted by Slipp Douglas
	 * 
	 * TERMS OF USE - EASING EQUATIONS
	 * 
	 * Open source under the BSD License. 
	 * 
	 * Copyright © 2001 Robert Penner
	 * All rights reserved.
	 * http://www.robertpenner.com/easing/
	 * http://www.robertpenner.com/easing/easing_demo.html
	 * 
	 * Redistribution and use in source and binary forms, with or without modification, 
	 * are permitted provided that the following conditions are met:
	 * 
	 * Redistributions of source code must retain the above copyright notice, this list of 
	 * conditions and the following disclaimer.
	 * Redistributions in binary form must reproduce the above copyright notice, this list 
	 * of conditions and the following disclaimer in the documentation and/or other materials 
	 * provided with the distribution.
	 * 
	 * Neither the name of the author nor the names of contributors may be used to endorse 
	 * or promote products derived from this software without specific prior written permission.
	 * 
	 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
	 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
	 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
	 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
	 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
	 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
	 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
	 * OF THE POSSIBILITY OF SUCH DAMAGE. 
	*/
	$Easing: Core.Class.subclass(
	{
		/*
			@group Sine-Wave Curve
		*/
		
		$sineIn: function sineIn(initial, target, ratio)
		{
			var HALF_PI = Math.PI / 2;
			var delta = target - initial;
			
			return -delta * Math.cos(ratio * HALF_PI) + target;
		},
		
		$sineOut: function sineOut(initial, target, ratio)
		{
			var HALF_PI = Math.PI / 2;
			var delta = target - initial;
			
			return delta * Math.sin(ratio * HALF_PI) + initial;
		},
		
		$sineInOut: function sineInOut(initial, target, ratio)
		{
			var HALF_PI = Math.PI / 2;
			var delta = target - initial;
			
			return (-delta / 2) * (Math.cos(ratio * HALF_PI) - 1) + initial;
		},
		
		/* @end */
		
		
		/*
			@group Quadratic Curve (2nd-order algebraic curve)
		*/
		
		$quadIn: function quadIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			return delta * (ratio * ratio) + initial;
		},
		
		$quadOut: function quadOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			return -delta * (ratio * (ratio - 2)) + initial;
		},
		
		$quadInOut: function quadInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio * 2;
			if (adjustedRatio < 1)
			{
				return (delta / 2) * (adjustedRatio * adjustedRatio) + initial;
			}
			else
			{
				adjustedRatio -= 1;
				return (-delta / 2) * ((adjustedRatio - 2) * adjustedRatio - 1) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Cubic Curve (3rd-order algebraic curve)
		*/
		
		$cubicIn: function cubicIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			return delta * (ratio * ratio) * ratio + initial;
		},
		
		$cubicOut: function cubicOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio - 1;
			
			return delta * ((adjustedRatio * adjustedRatio) * adjustedRatio + 1) + initial;
		},
		
		$cubicInOut: function cubicInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio * 2;
			
			if (adjustedRatio < 1)
			{
				return (delta / 2) * (adjustedRatio * adjustedRatio) * adjustedRatio + initial;
			}
			else
			{
				adjustedRatio -= 2;
				return (delta / 2) * ((adjustedRatio * adjustedRatio) * adjustedRatio + 2) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Quartic Curve (4th-order algebraic curve)
		*/
		
		$quartIn: function quartIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			return delta * (ratio * ratio) * (ratio * ratio) + initial;
		},
		
		$quartOut: function quartOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio - 1;
			
			return -delta * ((adjustedRatio * adjustedRatio) * (adjustedRatio * adjustedRatio) - 1) + initial;
		},
		
		$quartInOut: function quartInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio * 2;
			
			if (adjustedRatio < 1)
			{
				return (delta / 2) * (adjustedRatio * adjustedRatio) * (adjustedRatio * adjustedRatio) + initial;
			}
			else
			{
				adjustedRatio -= 2;
				return (-delta / 2) * ((adjustedRatio * adjustedRatio) * (adjustedRatio * adjustedRatio) - 2) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Quintic Curve (5th-order algebraic curve)
		*/
		
		$quintIn: function quintIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			return delta * (ratio * ratio) * (ratio * ratio) * ratio + initial;
		},
		
		$quintOut: function quintOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio - 1;
			
			return delta * ((adjustedRatio * adjustedRatio) * (adjustedRatio * adjustedRatio) * adjustedRatio + 1) + initial;
		},
		
		$quintInOut: function quintInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio * 2;
			
			if (adjustedRatio < 1)
			{
				return (delta / 2) * (adjustedRatio * adjustedRatio) * (adjustedRatio * adjustedRatio) * adjustedRatio + initial;
			}
			else
			{
				adjustedRatio -= 2;
				return (delta / 2) * ((adjustedRatio * adjustedRatio) * (adjustedRatio * adjustedRatio) * adjustedRatio + 2) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Exponential Curve
			@note: These are less efficient than the other types of easing.
		*/
		
		$expoIn: function expoIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			if (ratio == 0)
				return initial;
			else
				return delta * Math.pow(2, 10 * (ratio - 1)) + initial;
		},
		
		$expoOut: function expoOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			if (ratio == 1.0)
				return initial + delta;
			else
				return delta * ( -Math.pow(2, -10 * ratio) + 1) + initial;
		},
		
		$expoInOut: function expoInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			if (ratio == 0)
				return initial;
			
			if (ratio == 1)
				return initial + delta;
			
			var adjustedRatio = ratio * 2;
			
			if (adjustedRatio < 1)
			{
				return (delta / 2) * Math.pow(2, 10 * (adjustedRatio - 1)) + initial;
			}
			else
			{
				adjustedRatio -= 1;
				return (delta / 2) * ( -Math.pow(2, -10 * adjustedRatio) + 2) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Circular Curve (AKA “Spherical”)
		*/
		
		$circIn: function circIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			return -delta * (Math.sqrt(1 - ratio * ratio) - 1) + initial;
		},
		
		$circOut: function circOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio - 1;
			return delta * Math.sqrt(1 - adjustedRatio * adjustedRatio) + initial;
		},
		
		$circInOut: function circInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			var adjustedRatio = ratio * 2;
			
			if (adjustedRatio < 1)
			{
				return (-delta / 2) * (Math.sqrt(1 - adjustedRatio * adjustedRatio) - 1) + initial;
			}
			else
			{
				adjustedRatio -= 2;
				return (delta / 2) * (Math.sqrt(1 - adjustedRatio * adjustedRatio) + 1) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Elastic “Curve”
				Overshoots slightly and quickly, producing a snapping effect.
			@note: These are less efficient than the other types of easing.
		*/
		
		$elasticIn: function elasticIn(initial, target, ratio, /**Number*/ amplitude, /**Number*/ period)
		{
			var DOUBLE_PI = 2 * Math.PI;
			var delta = target - initial;
			
			if (ratio == 0)
				return initial;
			if (ratio == 1)
				return initial + delta;
			
			if (period == undefined)
				period = delta * 0.3;
			
			var overshoot;
			if (amplitude == undefined || amplitude < Math.abs(delta))
			{
				amplitude = delta;
				overshoot = period >> 2;
			}
			else
			{
				overshoot = period / DOUBLE_PI * Math.asin(delta / amplitude);
			}
			
			var adjustedRatio = ratio - 1;
			var fixedRatio = amplitude * Math.pow(2, 10 * adjustedRatio); // this is a fix, again, with pos -increment operators
			return -(fixedRatio * Math.sin((adjustedRatio - overshoot) * DOUBLE_PI / period)) + initial;
		},
		
		$elasticOut: function elasticOut(initial, target, ratio, /**Number*/ amplitude, /**Number*/ period)
		{
			var DOUBLE_PI = 2 * Math.PI;
			var delta = target - initial;
			
			if (ratio == 0)
				return initial;
			if (ratio == 1)
				return initial + delta;
			
			if (period == undefined)
				period = delta * 0.3;
			
			var overshoot;
			if (amplitude == undefined || amplitude < Math.abs(delta))
			{
				amplitude = delta;
				overshoot = period >> 2;
			}
			else
			{
				overshoot = period / DOUBLE_PI * Math.asin(delta / amplitude);
			}
			
			
			return amplitude * Math.pow(2, -10 * ratio) * Math.sin((ratio - overshoot) * DOUBLE_PI / period) + delta + initial;
		},
		
		$elasticInOut: function elasticInOut(initial, target, ratio, /**Number*/ amplitude, /**Number*/ period)
		{
			var DOUBLE_PI = 2 * Math.PI;
			var delta = target - initial;
			
			if (ratio == 0)
				return initial;
			if (ratio == 1)
				return initial + delta;
			
			var adjustedRatio = ratio * 2;
			
			if (period == undefined)
				period = delta * (0.3 * 1.5);
			
			var overshoot;
			if (amplitude == undefined || amplitude < Math.abs(delta))
			{
				amplitude = delta;
				overshoot = period >> 2;
			}
			else
			{
				overshoot = period / DOUBLE_PI * Math.asin(delta / amplitude);
			}
			
			if (adjustedRatio < 1)
			{
				adjustedRatio -= 1;
				var fixedRatio = amplitude * Math.pow(2, 10 * adjustedRatio);
				return -0.5 * (fixedRatio * Math.sin((adjustedRatio - overshoot) * DOUBLE_PI / period)) + initial;
			}
			else
			{
				adjustedRatio -= 1;
				var fixedRatio = amplitude * Math.pow(2, -10 * adjustedRatio);
				return (fixedRatio * Math.sin((adjustedRatio - overshoot) * DOUBLE_PI / period) / 2) + delta + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Back-Up “Curve”
				Overshoots greatly, then returns gently to rest at the final value.
		*/
		
		$backIn: function backIn(initial, target, ratio, /**Number*/ overshoot)
		{
			var delta = target - initial;
			
			if (overshoot == undefined)
				overshoot = 1.70158;
			
			return delta * ratio * ratio * ((overshoot + 1) * ratio - overshoot) + initial;
		},
		
		$backOut: function backOut(initial, target, ratio, /**Number*/ overshoot)
		{
			var delta = target - initial;
			
			if (overshoot == undefined)
				overshoot = 1.70158;
			
			var adjustedRatio = ratio - 1;
			return delta * (adjustedRatio * adjustedRatio * ((overshoot + 1) * adjustedRatio + overshoot) + 1) + initial;
		},
		
		$backInOut: function backInOut(initial, target, ratio, /**Number*/ overshoot)
		{
			var delta = target - initial;
			
			if (overshoot == undefined)
				overshoot = 1.70158;
			
			overshoot = overshoot * 1.525;
			var adjustedRatio = ratio * 2;
			
			if (adjustedRatio < 1)
			{
				return (delta / 2) * (adjustedRatio * adjustedRatio * ((overshoot + 1) * adjustedRatio - overshoot)) + initial;
			}
			else
			{
				adjustedRatio -= 2;
				return (delta / 2) * (adjustedRatio * adjustedRatio * ((overshoot + 1) * adjustedRatio + overshoot) + 2) + initial;
			}
		},
		
		/* @end */
		
		
		/*
			@group Bouncing “Curve”
		*/
		
		$bounceIn: function bounceIn(initial, target, ratio)
		{
			var delta = target - initial;
			
			return delta - this.bounceOut(1.0 - ratio, 0, delta) + initial;
		},
		
		$bounceOut: function bounceOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			if (ratio < (1.0 / 2.75))
			{
				return delta * (7.5625 * ratio * ratio) + initial;
			}
			else if (ratio < (2.0 / 2.75))
			{
				var adjustedRatio = ratio - (1.5 / 2.75);
				return delta * (7.5625 * adjustedRatio * adjustedRatio + 0.75) + initial;
			}
			else if (ratio < (2.5 / 2.75))
			{
				var adjustedRatio = ratio - (2.25 / 2.75);
				return delta * (7.5625 * adjustedRatio * adjustedRatio + 0.9375) + initial;
			}
			else
			{
				var adjustedRatio = ratio - (2.625 / 2.75);
				return delta * (7.5625 * adjustedRatio * adjustedRatio + 0.984375) + initial;
			}
		},
		
		$bounceInOut: function bounceInOut(initial, target, ratio)
		{
			var delta = target - initial;
			
			if (ratio < 0.5)
				return (this.bounceIn(ratio * 2, 0, delta) / 2) + initial;
			else
				return (this.bounceOut(ratio * 2 - 1.0, 0, delta) / 2) + (delta / 2) + initial;
		},
		
		/* @end */
	}),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/internal/UIElement'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/internal/UIElement'] || {}; $MODULE_REGISTRY['ngCrunch/internal/UIElement'] = exports; 
var __dirname = 'ngCrunch/internal';
var __filename = 'ngCrunch/internal/UIElement.js';

var Core  = require('NGCore/Client/Core').Core;
var Xib	= require('ngCrunch/Xib').Xib;
var MoreMath = require('ngCrunch/MoreMath').MoreMath;

exports.UIElement = Core.Class.subclass(
{
    classname: 'UIElement',

	/**
		Convenience function for people like me who get confused when they see ‘new UIElement(…)’ floating on a line, with the result of the new appearing to be lost.
		Also provides a safety wrapper; if the given ‘uiElement’ object already has an animator, a new one won't be created.
		@return The newly-created UIElement, or if the given ‘uiElement’ object already has an animator then ‘null’.
	*/
	$createOn: function(/**Object*/ uiElement)
	{
		var constructorF = this;
		
		if (uiElement.animator != undefined)
			return null;
		
		return (new constructorF(uiElement));
	},

	initialize: function(/**Object*/ uiElement)
    {
		// KJB For easier access
		uiElement.animator = this;
		
		// KJB Save UIElement that we'll be updating
		this._mUIElement = uiElement;
		
		// Option: delete self when anim is done?
		this._deleteOnComplete = false;
		
		// Option: call method when anim is done
		this._doneProc = NULL;
		
		// KJB See if frame has been initialized yet
		if(!this._mUIElement._frame)
		{
			if(this._mUIElement.init)
				this._mUIElement.init();
			else
				throw new Error("UIElement error - Object passed in does not have init() function");
		}
		// KJB Variables of UI element
		this._mOrigPosition = this.getPosition().clone();
		this._mPosition = this.getPosition();
		this._mOrigColor = this.getColor();
		this._mColor = this.getColor();
		this._mOrigRotation = this.getRotation();
		this._mRotation = this.getRotation();
		this._mOrigSize = this.getSize().clone();
		this._mSize = this.getSize();
		this._mOrigScale = this.getScale().clone();
		this._mScale = this.getScale();
		this._mOrigTex = this.getTexCoords().clone();
		this._mTex = this.getTexCoords();
		
		// KJB Variables for animating position
		this._mStartPos = new Core.Vector(0, 0);
		this._mEndPos = new Core.Vector(0, 0);
		this._mPosAnimTime = 0;
		this._mPosTimer = 0;
		this._mPosCurve = "XLERP";
		this._mPosLoopCurve = "XLERPINV";
		this._mPosAnimLoop = false;
		this._mPosAnimDelay = 0;
		this._mPosAnimLoopDelay = 0;
		this._mPosAnimLoopSwitch = false;
		this._mPosAnimLoopTimer = 0;
		
		// KJB Variables for animating color
		this._mStartColor = new Core.Rect(1, 1, 1, 1);
		this._mEndColor = new Core.Rect(1, 1, 1, 1);
		this._mColorAnimTime = 0;
		this._mColorTimer = 0;
		this._mColorCurve = "XLERP";
		this._mColorLoopCurve = "XLERPINV";
		this._mColorAnimLoop = false;
		this._mColorAnimDelay = 0;
		this._mColorAnimLoopDelay = 0;
		this._mColorAnimLoopSwitch = false;
		this._mColorAnimLoopTimer = 0;
		
		// KJB Variables for animating rotation
		this._mStartRot = 0;
		this._mEndRot = 0;
		this._mRotAnimTime = 0;
		this._mRotTimer = 0;
		this._mRotCurve = "XLERP";
		this._mRotLoopCurve = "XLERPINV";
		this._mRotAnimLoop = false;
		this._mRotAnimDelay = 0;
		this._mRotAnimLoopDelay = 0;
		this._mRotAnimLoopSwitch = false;
		this._mRotAnimLoopTimer = 0;
		
		// KJB Variables for animating size
		this._mStartSize = new Core.Size(0, 0);
		this._mEndSize = new Core.Size(0, 0);
		this._mSizeAnimTime = 0;
		this._mSizeTimer = 0;
		this._mSizeCurve = "XLERP";
		this._mSizeLoopCurve = "XLERPINV";
		this._mSizeAnimLoop = false;
		this._mSizeAnimDelay = 0;
		this._mSizeAnimLoopDelay = 0;
		this._mSizeAnimLoopSwitch = false;
		this._mSizeAnimLoopTimer = 0;
		
		// KJB Variables for animating UV texture coordinates
		this._mStartTex = new Core.Rect(0, 0, 0, 0);
		this._mEndTex = new Core.Rect(0, 0, 0, 0);
		this._mTexAnimTime = 0;
		this._mTexTimer = 0;
		this._mTexCurve = "XLERP";
		this._mTexLoopCurve = "XLERPINV";
		this._mTexAnimLoop = false;
		this._mTexAnimDelay = 0;
		this._mTexAnimLoopDelay = 0;
		this._mTexAnimLoopSwitch = false;
		this._mTexAnimLoopTimer = 0;
		
		// KJB Variables for animating scale
		this._mStartScale = new Core.Vector(1, 1);
		this._mEndScale = new Core.Vector(1, 1);
		this._mScaleAnimTime = 0;
		this._mScaleTimer = 0;
		this._mScaleCurve = "XLERP";
		this._mScaleLoopCurve = "XLERPINV";
		this._mScaleAnimLoop = false;
		this._mScaleAnimDelay = 0;
		this._mScaleAnimLoopDelay = 0;
		this._mScaleAnimLoopSwitch = false;
		this._mScaleAnimLoopTimer = 0;
		
		// KJB Variables for animating text
		this._mEndText = "";
		this._mTextDelay = 0;
		
		// KJB Variables for animating a number within text
		this._mStartTextNum = 0;
		this._mEndTextNum = 0;
		this._mTextNumAnimTime = 0;
		this._mTextNumTimer = 0;
		this._mTextNumCurve = "XLERP";
		this._mTextNumLoopCurve = "XLERPINV";
		this._mTextNumAnimLoop = false;
		this._mTextNumAnimDelay = 0;
	},
	
	update: function(/**Number*/ delta)
	{
		//////////////////////////////////////////////////// Position
		
		if(this._mPosTimer > 0 || this._mPosAnimDelay > 0 || this._mPosAnimLoopTimer > 0)
		{
			// KJB Update the delay
			if(this._mPosAnimDelay > 0)
			{
				this._mPosAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mPosAnimDelay <= 0 && this._mPosTimer <= 0)
				{
					// KJB Set position to endPos
					this._mPosition = this._mEndPos;
				}
				
				if(this._mPosAnimDelay < 0)
					this._mPosTimer += (this._mPosAnimDelay%1);
			}
			else if(this._mPosTimer > 0)
			{
				// KJB Update the position timer
				this._mPosTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mPosAnimTime - this._mPosTimer) / this._mPosAnimTime);
				// KJB Update our position by interpolating
				this._mPosition = MoreMath.interpolate(this._mPosCurve, this._mStartPos, this._mEndPos, posT);
				
				if(this._mPosTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mPosAnimLoop)
					{
						if(this._mPosAnimLoopSwitch && this._mPosAnimLoopDelay != 0)
							this._mPosAnimLoopTimer = (this._mPosAnimLoopDelay + (this._mPosTimer %= this._mPosAnimTime));
						else
							this.loopPosition();
					}
					// KJB Otherwise set our position to the endPos
					else
					{
						this._mPosition = this._mEndPos;
					}
				}
			}
			else
			{
				this._mPosAnimLoopTimer -= delta;
				
				if(this._mPosAnimLoopTimer <= 0)
					this.loopPosition();
			}
			// KJB Update the UI element's position only if the delay is over
			if(this.debugging)
				log("POSITION: " + this._mPosition.toString());
			if(this._mPosAnimDelay <= 0)
				this.setPosition(this._mPosition);
		}
		
		//////////////////////////////////////////////////// Color
		
		if(this._mColorTimer > 0 || this._mColorAnimDelay > 0 || this._mColorAnimLoopTimer > 0)
		{
			// KJB Update the delay
			if(this._mColorAnimDelay > 0)
			{
				this._mColorAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mColorAnimDelay <= 0 && this._mColorTimer <= 0)
				{
					// KJB Set color to endColor
					this._mColor = this._mEndColor;
				}
				
				if(this._mColorAnimDelay < 0)
					this._mColorTimer += (this._mColorAnimDelay%1);
			}
			else if(this._mColorTimer > 0)
			{
				// KJB Update the color timer
				this._mColorTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mColorAnimTime - this._mColorTimer) / this._mColorAnimTime);
				// KJB Update our color by interpolating
				this._mColor = MoreMath.interpolate(this._mColorCurve, this._mStartColor, this._mEndColor, posT);
				
				if(this._mColorTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mColorAnimLoop)
					{
						if(this._mColorAnimLoopSwitch && this._mColorAnimLoopDelay != 0)
							this._mColorAnimLoopTimer = (this._mColorAnimLoopDelay + (this._mColorTimer %= this._mColorAnimTime));
						else
							this.loopColor();
					}
					// KJB Otherwise set our color to the endColor
					else
					{
						this._mColor = this._mEndColor;
					}
				}
			}
			else
			{
				this._mColorAnimLoopTimer -= delta;
				
				if(this._mColorAnimLoopTimer <= 0)
					this.loopColor();
			}
			
			// KJB Update the UI element's color only if the delay is over.
			if(this._mColorAnimDelay <= 0)
				this.setColor(this._mColor);
		}
		
		//////////////////////////////////////////////////// Rotation
		
		if(this._mRotTimer > 0 || this._mRotAnimDelay > 0 || this._mRotAnimLoopTimer > 0)
		{
			// KJB Update the delay
			if(this._mRotAnimDelay > 0)
			{
				this._mRotAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mRotAnimDelay <= 0 && this._mRotTimer <= 0)
				{
					// KJB Set rotation to endRot
					this._mRotation = this._mEndRot;
				}
				
				if(this._mRotAnimDelay < 0)
					this._mRotTimer += (this._mRotAnimDelay%1);
			}
			else if(this._mRotTimer > 0)
			{
				// KJB Update the rotation timer
				this._mRotTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mRotAnimTime - this._mRotTimer) / this._mRotAnimTime);
				// KJB Update our rotation by interpolating
				this._mRotation = MoreMath.interpolate(this._mRotCurve, this._mStartRot, this._mEndRot, posT);
				
				if(this._mRotTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mRotAnimLoop)
					{
						if(this._mRotAnimLoopSwitch && this._mRotAnimLoopDelay != 0)
							this._mRotAnimLoopTimer = (this._mRotAnimLoopDelay + (this._mRotTimer %= this._mRotAnimTime));
						else
							this.loopRotation();
					}
					// KJB Otherwise set our rotation to the endRot
					else
					{
						this._mRotation = this._mEndRot;
					}
				}
			}
			else
			{
				this._mRotAnimLoopTimer -= delta;
				
				if(this._mRotAnimLoopTimer <= 0)
					this.loopRotation();
			}
				
			// KJB Update the UI element's rotation only if the delay is over
			if(this._mRotAnimDelay <= 0)
				this.setRotation(this._mRotation);
		}
		
		//////////////////////////////////////////////////// Size
		
		if(this._mSizeTimer > 0 || this._mSizeAnimDelay > 0 || this._mSizeAnimLoopTimer > 0)
		{
			// KJB Update the delay
			if(this._mSizeAnimDelay > 0)
			{
				this._mSizeAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mSizeAnimDelay <= 0 && this._mSizeTimer <= 0)
				{
					// KJB Set size to endSize
					this._mSize = this._mEndSize;
				}
				
				if(this._mSizeAnimDelay < 0)
					this._mSizeTimer += (this._mSizeAnimDelay%1);
			}
			else if(this._mSizeTimer > 0)
			{
				// KJB Update the size timer
				this._mSizeTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mSizeAnimTime - this._mSizeTimer) / this._mSizeAnimTime);
				// KJB Update our size by interpolating
				this._mSize = MoreMath.interpolate(this._mSizeCurve, this._mStartSize, this._mEndSize, posT);
				
				if(this._mSizeTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mSizeAnimLoop)
					{
						if(this._mSizeAnimLoopSwitch && this._mSizeAnimLoopDelay != 0)
							this._mSizeAnimLoopTimer = (this._mSizeAnimLoopDelay + (this._mSizeTimer %= this._mSizeAnimTime));
						else
							this.loopSize();
					}
					// KJB Otherwise set our size to the endSize
					else
					{
						this._mSize = this._mEndSize;
					}
				}
			}
			else
			{
				this._mSizeAnimLoopTimer -= delta;
				
				if(this._mSizeAnimLoopTimer <= 0)
					this.loopSize();
			}
		
			// KJB Update the UI element's size
			if(this._mSizeAnimDelay <= 0)
				this.setSize(this._mSize);
		}
		
		//////////////////////////////////////////////////// Texture Coordinates
		
		if(this._mTexTimer > 0 || this._mTexAnimDelay > 0 || this._mTexAnimLoopTimer > 0)
		{
			// KJB Update the delay
			if(this._mTexAnimDelay > 0)
			{
				this._mTexAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mTexAnimDelay <= 0 && this._mTexTimer <= 0)
				{
					// KJB Set tex coords to endTex
					this._mTex = this._mEndTex;
				}
				
				if(this._mTexAnimDelay < 0)
					this._mTexTimer += (this._mTexAnimDelay%1);
			}
			else if(this._mTexTimer > 0)
			{
				// KJB Update the tex timer
				this._mTexTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mTexAnimTime - this._mTexTimer) / this._mTexAnimTime);
				// KJB Update our tex coords by interpolating
				this._mTex = MoreMath.interpolate(this._mTexCurve, this._mStartTex, this._mEndTex, posT);
				
				if(this._mTexTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mTexAnimLoop)
					{
						if(this._mTexAnimLoopSwitch && this._mTexAnimLoopDelay != 0)
							this._mTexAnimLoopTimer = (this._mTexAnimLoopDelay + (this._mTexTimer %= this._mTexAnimTime));
						else
							this.loopTexCoords();
					}
					// KJB Otherwise set our tex coords to the endTex
					else
					{
						this._mTex = this._mEndTex;
					}
				}
			}
			else
			{
				this._mTexAnimLoopTimer -= delta;
				
				if(this._mTexAnimLoopTimer <= 0)
					this.loopTexCoords();
			}
		
			// KJB Update the UI element's tex coords only if the delay is over
			if(this._mTexAnimDelay <= 0)
				this.setTexCoords(this._mTex);
		}
		
		//////////////////////////////////////////////////// Scale
		
		if(this._mScaleTimer > 0 || this._mScaleAnimDelay > 0 || this._mScaleAnimLoopTimer > 0)
		{
			// KJB Update the delay
			if(this._mScaleAnimDelay > 0)
			{
				this._mScaleAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mScaleAnimDelay <= 0 && this._mScaleTimer <= 0)
				{
					// KJB Set scale to endScale
					this._mScale = this._mEndScale;
				}
				
				if(this._mScaleAnimDelay < 0)
					this._mScaleTimer += (this._mScaleAnimDelay%1);
			}
			else if(this._mScaleTimer > 0)
			{
				// KJB Update the scale timer
				this._mScaleTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mScaleAnimTime - this._mScaleTimer) / this._mScaleAnimTime);
				// KJB Update our scale by interpolating
				this._mScale = MoreMath.interpolate(this._mScaleCurve, this._mStartScale, this._mEndScale, posT);
				if(this._mScaleTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mScaleAnimLoop)
					{
						if(this._mScaleAnimLoopSwitch && this._mScaleAnimLoopDelay != 0)
							this._mScaleAnimLoopTimer = (this._mScaleAnimLoopDelay + (this._mScaleTimer %= this._mScaleAnimTime));
						else
							this.loopScale();
					}
					// KJB Otherwise set our scale to the endScale
					else
					{
						this._mScale = this._mEndScale;
					}
				}
			}
			else
			{
				// KJB Update the scale loop timer
				this._mScaleAnimLoopTimer -= delta;
				
				// KJB If it's up, loop!
				if(this._mScaleAnimLoopTimer <= 0)
					this.loopScale();
			}
			
			// KJB Update the UI element's scale only if the delay is over
			if(this._mScaleAnimDelay <= 0)
				this.setScale(this._mScale);
		}
		
		//////////////////////////////////////////////////// Text
		
		if(this._mTextDelay > 0)
		{
			// KJB Update the delay
			this._mTextDelay -= delta;
			
			// KJB If the delay is up, set the text
			if(this._mTextDelay <= 0)
				this._mUIElement.setText(this._mEndText);
		}
		
		//////////////////////////////////////////////////// Number in text
		
		if(this._mTextNumTimer > 0 || this._mTextNumAnimDelay > 0)
		{
			// KJB Update the delay
			if(this._mTextNumAnimDelay > 0)
			{
				this._mTextNumAnimDelay -= delta;
				
				// KJB If the delay is up and there's no timer
				if(this._mTextNumAnimDelay <= 0 && this._mTextNumTimer <= 0)
				{
					// KJB Set text to endNum
					this._mTextNum = this._mEndTextNum;
				}
			}
			else
			{
				// KJB Update the text num timer
				this._mTextNumTimer -= delta;
				
				// KJB Get the percentage of the animation we're done with
				var posT = Math.max(0, (this._mTextNumAnimTime - this._mTextNumTimer) / this._mTextNumAnimTime);
				// KJB Update our rotation by interpolating
				this._mTextNum = Math.floor(MoreMath.interpolate(this._mTextNumCurve, this._mStartTextNum, this._mEndTextNum, posT));
				
				if(this._mTextNumTimer <= 0)
				{
					// KJB If we're looping, reset the time
					if(this._mTextNumAnimLoop)
					{
						if (this._mTextNumTimer <= -(this._mTextNumAnimTime))
							this._mTextNumTimer %= this._mTextNumAnimTime;
						
						this._mTextNumTimer += this._mTextNumAnimTime;
						
						// KJB Swap start and end values
						var tempValue = this._mStartTextNum;
						this._mStartTextNum = this._mEndTextNum;
						this._mEndTextNum = tempValue;
						
						// KJB Swap curves for smooth animation
						tempValue = this._mTextNumCurve;
						this._mTextNumCurve = this._mTextNumLoopCurve;
						this._mTextNumLoopCurve = tempValue;
					}
					// KJB Otherwise set our textNum to the endNum
					else
					{
						this._mTextNum = this._mEndTextNum;
					}
				}
			}
				
			// KJB Update the UI element's text
			if(this._mTextNum != "" && this._mTextNumAnimDelay <= 0)
				this.setText(this._mTextNumText.replace("%i", this._mTextNum));
		}
		
		// done?
		if ( !this.isBusy() )
		{
			// done proc?
			if ( this._doneProc )
			{
				var	proc = this._doneProc;
				this._doneProc = NULL;
				proc( this._mUIElement );
			}
			
			// should we clear out?
			if ( this._deleteOnComplete )
			{
				// toast self.
				var	wasNode = this._mUIElement;
				this._mUIElement = NULL;	// drop ref to the target object
				if ( wasNode )
					wasNode.removeAnimator();
			}
		}
	},
	
	error:	function( message )
	{
		if ( _DEBUG )	// throw errors instead of just logging them
			throw new Error( message );
		
		log( message );
	},
	
	setDoneProc:	function( /**function()*/ doneProc )
	{
		this._doneProc = doneProc;
	},
	
	loopPosition: function loopPosition()
	{
		this._mPosAnimLoopSwitch = !this._mPosAnimLoopSwitch;
		
		if (this._mPosTimer <= -(this._mPosAnimTime))
			this._mPosTimer %= this._mPosAnimTime;
		
		this._mPosTimer += this._mPosAnimTime;
		
		// KJB Swap start and end values
		var tempValue = new Core.Vector(this._mStartPos);
		this._mStartPos.setAll(this._mEndPos.getX(), this._mEndPos.getY());
		this._mEndPos.setAll(tempValue.getX(), tempValue.getY());
		
		// KJB Swap curves for smooth animation
		tempValue = this._mPosCurve;
		this._mPosCurve = this._mPosLoopCurve;
		this._mPosLoopCurve = tempValue;
	},
    
    animatePos: function(/**Core.Vector*/ newPos, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = "XLERPINV";
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		if(loopDelay == null)
			loopDelay = 0;
		
		// KJB Set variables for animating the UI element's position
		this._mStartPos = this.getPosition();
		this._mPosition = this._mStartPos;
		this._mEndPos = newPos;
		this._mPosAnimTime = time;
		this._mPosTimer = time;
		this._mPosCurve = curve;
		this._mPosLoopCurve = loopCurve;
		this._mPosAnimLoop = loop;
		this._mPosAnimDelay = delay;
		this._mPosAnimLoopDelay = loopDelay;
		
		// KJB If time and delay are 0 just place it at the newPos
		if(time == 0 && delay == 0)
		{
			this._mPosition = this._mEndPos;
			this.setPosition(this._mPosition);
		}
	},
	
	animateX: function(/**Number*/ newX, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		this.animatePos(new Core.Vector(newX, this.getPosition().getY()), time, curve, loop, delay, loopCurve, loopDelay);
	},
	
	animateY: function(/**Number*/ newY, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		this.animatePos(new Core.Vector(this.getPosition().getX(), newY), time, curve, loop, delay, loopCurve, loopDelay);
	},
	
	setPosition: function(/**Core.Vector*/ newPos)
	{
		var frame = this._mUIElement.getFrame();
		this._mUIElement.animator = NULL;
		this._mUIElement.setFrame(new Core.Rect(newPos.getX(), newPos.getY(), frame.getSize().getWidth(), frame.getSize().getHeight()));
		this._mUIElement.animator = this;
	},
	
	setX: function(/**Number*/ newX)
	{
		this.setPosition(new Core.Vector(newX, this.getPosition().getY()));
	},
	
	setY: function(/**Number*/ newY)
	{
		this.setPosition(new Core.Vector(this.getPosition().getX(), newY));
	},
	
	getPosition: function()
	{
		return this._mUIElement.getFrame().getOrigin();
	},
	
	getOrigPosition: function()
	{
		return this._mOrigPosition;
	},
	
	loopColor: function loopColor()
	{
		this._mColorAnimLoopSwitch = !this._mColorAnimLoopSwitch;
		
		if (this._mColorTimer <= -(this._mColorAnimTime))
			this._mColorTimer %= this._mColorAnimTime;
		
		this._mColorTimer += this._mColorAnimTime;
		
		// KJB Swap start and end values
		var tempValue = new Core.Rect(this._mStartColor);
		this._mStartColor.setAll(this._mEndColor.getOrigin().getX(), this._mEndColor.getOrigin().getY(), this._mEndColor.getSize().getWidth(), this._mEndColor.getSize().getHeight());
		this._mEndColor.setAll(tempValue.getOrigin().getX(), tempValue.getOrigin().getY(), tempValue.getSize().getWidth(), tempValue.getSize().getHeight());
		
		// KJB Swap curves for smooth animation
		tempValue = this._mColorCurve;
		this._mColorCurve = this._mColorLoopCurve;
		this._mColorLoopCurve = tempValue;
	},
	
	animateColor: function(/**Core.Rect*/ newColor, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = curve;
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		if(loopDelay == null)
			loopDelay = 0;
		
		// KJB Set variables for animating the UI element's color
		var curColor = this.getColor();
		this._mStartColor = new Core.Rect(curColor.getOrigin().getX(), curColor.getOrigin().getY(), curColor.getSize().getWidth(), curColor.getSize().getHeight());
		this._mEndColor = newColor;
		this._mColor = this._mStartColor;
		this._mColorAnimTime = time;
		this._mColorTimer = time;
		this._mColorCurve = curve;
		this._mColorLoopCurve = loopCurve;
		this._mColorAnimLoop = loop;
		this._mColorAnimDelay = delay;
		this._mColorAnimLoopDelay = loopDelay;
		
		// KJB If time and delay are 0 just set the new color
		if(time == 0 && delay == 0)
		{
			this._mColor = this._mEndColor;
			this.setColor(this._mColor);
		}
	},
	
	animateRed: function(/**Number*/ newRed, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		var color = this.getColor();
		this.animateColor(new Core.Rect(newRed, color.getOrigin().getY(), color.getSize().getWidth(), color.getSize().getHeight()), time, curve, loop, delay, loopCurve, loopDelay);
	},
	
	animateGreen: function(/**Number*/ newGreen, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		var color = this.getColor();
		this.animateColor(new Core.Rect(color.getOrigin().getX(), newGreen, color.getSize().getWidth(), color.getSize().getHeight()), time, curve, loop, delay, loopCurve, loopDelay);
	},
	
	animateBlue: function(/**Number*/ newBlue, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		var color = this.getColor();
		this.animateColor(new Core.Rect(color.getOrigin().getX(), color.getOrigin().getY(), newBlue, color.getSize().getHeight()), time, curve, loop, delay, loopCurve, loopDelay);
	},
	
	animateAlpha: function(/**Number*/ newAlpha, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		var color = this.getColor();
		this.animateColor(new Core.Rect(color.getOrigin().getX(), color.getOrigin().getY(), color.getSize().getWidth(), newAlpha), time, curve, loop, delay, loopCurve, loopDelay);
	},
	
	setAlpha: function(/**Number*/ newAlpha)
	{
		this._mUIElement.setAlpha(newAlpha);
	},
	
	getAlpha: function()
	{
		return this._mUIElement.getAlpha();
	},
	
	setColorObj: function(/**Core.Rect*/ newColor)
	{
		this._mUIElement.setColor( newColor );
	},
	
	getColorObj: function()
	{
		return this._mUIElement.getColor();
	},
	
	setColor: function(/**Core.Rect*/ newColor)
	{
		this._mUIElement.setColor(new Core.Color(newColor.getOrigin().getX(), newColor.getOrigin().getY(), newColor.getSize().getWidth()));
		this._mUIElement.setAlpha(newColor.getSize().getHeight());
	},
	
	getColor: function()
	{
		if(this._mUIElement.getColor)
		{
			var color = this._mUIElement.getColor();
			return new Core.Rect(color.getRed(), color.getGreen(), color.getBlue(), this.getAlpha());
		}
		else
			return new Core.Rect(1, 1, 1, 1);
	},
	
	getOrigColor: function()
	{
		return this._mOrigColor;
	},
	
	loopRotation: function loopRotation()
	{
		this._mRotAnimLoopSwitch = !this._mRotAnimLoopSwitch;
		
		if (this._mRotTimer <= -(this._mRotAnimTime))
			this._mRotTimer %= this._mRotAnimTime;
		
		this._mRotTimer += this._mRotAnimTime;
		
		// KJB Swap start and end values
		var tempValue = this._mStartRot;
		this._mStartRot = this._mEndRot;
		this._mEndRot = tempValue;
		
		// KJB Swap curves for smooth animation
		tempValue = this._mRotCurve;
		this._mRotCurve = this._mRotLoopCurve;
		this._mRotLoopCurve = tempValue;
	},
	
	animateRotation: function(/**Number*/ newRot, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = curve;
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		if(loopDelay == null)
			loopDelay = 0;
		
		// KJB Set variables for animating the UI element's rotation
		this._mStartRot = this.getRotation();
		this._mEndRot = newRot;
		this._mRotation = this._mStartRot;
		this._mRotAnimTime = time;
		this._mRotTimer = time;
		this._mRotCurve = curve;
		this._mRotLoopCurve = loopCurve;
		this._mRotAnimLoop = loop;
		this._mRotAnimDelay = delay;
		this._mRotAnimLoopDelay = loopDelay;
		
		// KJB If time and delay are 0 set it to the endRot
		if(time == 0 && delay == 0)
		{
			this._mRotation = this._mEndRot;
			this.setRotation(this._mRotation);
		}
	},
	
	getRotation: function()
	{
		return this._mUIElement.getRotation();
	},
	
	getOrigRotation: function()
	{
		return this._mOrigRotation;
	},
	
	setRotation: function(/**Number*/ newRot)
	{
		this._mUIElement.setRotation(newRot);
	},
	
	loopTexCoords: function loopTexCoords()
	{
		this._mTexAnimLoopSwitch = !this._mTexAnimLoopSwitch;
		
		if (this._mTexTimer <= -(this._mTexAnimTime))
			this._mTexTimer %= this._mTexAnimTime;
		
		this._mTexTimer += this._mTexAnimTime;
		
		// KJB Swap start and end values
		var tempValue = new Core.Rect(this._mStartTex);
		this._mStartTex.setAll(this._mEndTex.getOrigin().getX(), this._mEndTex.getOrigin().getY(), this._mEndTex.getSize().getWidth(), this._mEndTex.getSize().getHeight());
		this._mEndTex.setAll(tempValue.getOrigin().getX(), tempValue.getOrigin().getY(), tempValue.getSize().getWidth(), tempValue.getSize().getHeight());
		
		// KJB Swap curves for smooth animation
		tempValue = this._mTexCurve;
		this._mTexCurve = this._mTexLoopCurve;
		this._mTexLoopCurve = tempValue;
	},
	
	animateTexCoords: function(/**Core.Rect*/ newCoords, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = curve;
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		if(loopDelay == null)
			loopDelay = 0;
		
		if(this._mUIElement.getAnimation)
		{
			// KJB Set variables for animating the UI element's UV coords
			this._mStartTex = this.getTexCoords();
			this._mEndTex = newCoords;
			this._mTex = this._mStartTex;
			this._mTexAnimTime = time;
			this._mTexTimer = time;
			this._mTexCurve = curve;
			this._mTexLoopCurve = loopCurve;
			this._mTexAnimLoop = loop;
			this._mTexAnimDelay = delay;
			this._mTexAnimLoopDelay = loopDelay;
			
			// KJB If time and delay are 0 set it to the endTex
			if(time == 0 && delay == 0)
			{
				this._mTex = this._mEndTex;
				this.setTexCoords(this._mTex);
			}
		}
	},
	
	getSpriteAnimObject:	function()
	{
		// this._mUIElement.getAnimation() lies, if it's an internally created animation.
		// We have to get the information we want more directly.
	//	return this._mUIElement.getAnimation();
		return this._mUIElement._animation;
	},
	
	getTexCoords: function()
	{
		if(this._mUIElement.getAnimation)
		{
			// this._mUIElement.getAnimation() lies, if it's an internally created animation.
			// We have to get the information we want more directly.
			var animation = this.getSpriteAnimObject();
			if(animation && animation.getFrame)
			{
				var frame = animation.getFrame(0);
				if(frame && frame.getUVs)
				{
					var uvs = frame.getUVs();
					if(uvs)
					{
						return uvs;
					}
					else
					{
						this.error("UIElement error - no UVs found for object " + this._mUIElement);
					}
				}
				else
				{
					this.error("UIElement error - no frame found for object " + this._mUIElement);
				}
			}
			else
			{
				this.error("UIElement error - no animation found for object " + this._mUIElement);
			}
		}
		else
		{
			// DDP this is not an error, because not all target objects will be subclassed from Sprite.
		//	this.error("UIElement error - object doesn't have getAnimation function " + this._mUIElement);
		}
		return new Core.Rect(0,0,1,1);
	},
	
	getOrigTexCoords: function()
	{
		return this._mOrigTex;
	},
	
	setTexCoords: function(/**Core.Rect*/ newCoords)
	{
		if(this._mUIElement.getAnimation)
		{
			var animation = this.getSpriteAnimObject();
			if(animation)
			{
				var frame = animation.getFrame(0);
				if(frame)
				{
					this._mUIElement.setImage(this._mUIElement.getImage(), frame.getSize(), frame.getAnchor(), newCoords);
				}
				else
				{
					this.error("UIElement error - no frame found for object " + this._mUIElement);
				}
			}
			else
			{
				this.error("UIElement error - no animation found for object " + this._mUIElement);
			}
		}
		else
		{
			this.error("UIElement error - object doesn't support getAnimation " + this._mUIElement);
		}
	},
	
	loopSize: function loopSize()
	{
		this._mSizeAnimLoopSwitch = !this._mSizeAnimLoopSwitch;
		
		if (this._mSizeTimer <= -(this._mSizeAnimTime))
			this._mSizeTimer %= this._mSizeAnimTime;
		
		this._mSizeTimer += this._mSizeAnimTime;
		
		// KJB Swap start and end values
		var tempValue = new Core.Size(this._mStartSize);
		this._mStartSize.setAll(this._mEndSize.getWidth(), this._mEndSize.getHeight());
		this._mEndSize.setAll(tempValue.getWidth(), tempValue.getHeight());
		
		// KJB Swap curves for smooth animation
		tempValue = this._mSizeCurve;
		this._mSizeCurve = this._mSizeLoopCurve;
		this._mSizeLoopCurve = tempValue;
	},
	
	animateSize: function(/**Core.Size*/ newSize, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = curve;
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		if(loopDelay == null)
			loopDelay = 0;
		
		// KJB Set variables for animating the UI element's size
		this._mStartSize = this.getSize();
		this._mEndSize = newSize;
		this._mSize = this._mStartSize;
		this._mSizeAnimTime = time;
		this._mSizeTimer = time;
		this._mSizeCurve = curve;
		this._mSizeLoopCurve = loopCurve;
		this._mSizeAnimLoop = loop;
		this._mSizeAnimDelay = delay;
		this._mSizeAnimLoopDelay = loopDelay;
		
		// KJB If time and delay are 0 set it to endSize
		if(time == 0 && delay == 0)
		{
			this._mSize = this._mEndSize;
			this.setSize(this._mSize);
		}
	},
	
	setSize: function(/**Core.Size*/ newSize)
	{
		var frame = this._mUIElement.getFrame();
		this._mUIElement.animator = NULL;
		this._mUIElement.setFrame(new Core.Rect(frame.getOrigin().getX(), frame.getOrigin().getY(), newSize.getWidth(), newSize.getHeight()));
		this._mUIElement.animator = this;
	},
	
	getSize: function()
	{
		return this._mUIElement.getFrame().getSize();
	},
	
	setOrigSize: function(/**Core.Size*/ newSize)
	{
		this._mOrigSize = newSize;
	},
	
	getOrigSize: function()
	{
		return this._mOrigSize;
	},
	
	loopScale: function loopScale()
	{
		this._mScaleAnimLoopSwitch = !this._mScaleAnimLoopSwitch;
		
		if (this._mScaleTimer <= -(this._mScaleAnimTime))
			this._mScaleTimer %= this._mScaleAnimTime;
		
		this._mScaleTimer += this._mScaleAnimTime;
		
		// KJB Swap start and end values
		var tempValue = new Core.Vector(this._mStartScale);
		this._mStartScale.setAll(this._mEndScale.getX(), this._mEndScale.getY());
		this._mEndScale.setAll(tempValue.getX(), tempValue.getY());
		
		// KJB Swap curves for smooth animation
		tempValue = this._mScaleCurve;
		this._mScaleCurve = this._mScaleLoopCurve;
		this._mScaleLoopCurve = tempValue;
	},
	
	animateScale: function(/**Core.Vector*/ newScale, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve, /**Number*/ loopDelay)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = curve;
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		if(loopDelay == null)
			loopDelay = 0;
		
		// KJB Set variables for animating the object's scale
		this._mStartScale = this.getScale().clone();
		this._mEndScale = newScale;
		this._mScale = this._mStartScale;
		this._mScaleAnimTime = time;
		this._mScaleTimer = time;
		this._mScaleCurve = curve;
		this._mScaleLoopCurve = loopCurve;
		this._mScaleAnimLoop = loop;
		this._mScaleAnimDelay = delay;
		this._mScaleAnimLoopDelay = loopDelay;
		
		// KJB If time and delay are 0 set it to endScale
		if(time == 0 && delay == 0)
		{
			this._mScale = this._mEndScale;
			this.setScale(this._mScale);
		}
	},
	
	setScale: function(/**Core.Vector*/ newScale)
	{
		this._mUIElement.setScale(newScale);
	},
	
	getScale: function()
	{
		return this._mUIElement.getScale();
	},
	
	getOrigScale: function()
	{
		return this._mOrigScale;
	},
	
	setText: function setText(/**String*/ newText, /**Number*/ delay)
	{
		// KJB Set defaults
		if(delay == null)
			delay = 0;
		
		// KJB Set variables for setting the object's text
		this._mEndText = newText;
		this._mTextDelay = delay;
		
		// KJB If delay is 0, set it immediately
		if(delay == 0)
			this._mUIElement.setText(newText);
	},
	
	animateNumberInText: function animateNumberInText(/**String*/ text, /**Number*/ from, /**Number*/ to, /**Number*/ time, /**String*/ curve, /**Boolean*/ loop, /**Number*/ delay, /**String*/ loopCurve)
	{
		// KJB Set defaults
		if(time == null)
			time = 0.5;
		if(curve == null)
			curve = "XLERP";
		if(loopCurve == null)
			loopCurve = curve;
		if(loop == null)
			loop = false;
		if(delay == null)
			delay = 0;
		
		// KJB Set variables
		this._mTextNumText = text;
		this._mStartTextNum = from;
		this._mText = this._mStartTextNum;
		this._mTextNum = "";
		this._mEndTextNum = to;
		this._mTextNumAnimTime = time;
		this._mTextNumTimer = time;
		this._mTextNumCurve = curve;
		this._mTextNumLoopCurve = loopCurve;
		this._mTextNumAnimLoop = loop;
		this._mTextNumAnimDelay = delay;
		
		// KJB If delay and time are 0, set immediately
		if(time == 0 && delay == 0)
		{
			this._mText = text.replace("%i", to);
			this.setText(this._mText);
		}
	},
	
	getUIElement: function()
	{
		return this._mUIElement;
	},
	
	stopAnimating: function()
	{
		this._mPosTimer = 0;
		this._mColorTimer = 0;
		this._mRotTimer = 0;
		this._mTexTimer = 0;
		this._mSizeTimer = 0;
		this._mScaleTimer = 0;
	},
	
	isBusy: function()
	{
		return (this._mPosTimer > 0 || this._mColorTimer > 0 || this._mRotTimer > 0 || this._mTexTimer > 0 || this._mSizeTimer > 0 || this._mScaleTimer > 0);
	},
	
	isAnimatingPosition: function isAnimatingPosition()
	{
		return (this._mPosTimer > 0);
	},
	
	isAnimatingColor: function isAnimatingColor()
	{
		return (this._mColorTimer > 0);
	},
	
	isAnimatingRotation: function isAnimatingRotation()
	{
		return (this._mRotTimer > 0);
	},
	
	isAnimatingTexCoords: function isAnimatingTexCoords()
	{
		return (this._mTexTimer > 0);
	},
	
	isAnimatingSize: function isAnimatingSize()
	{
		return (this._mSizeTimer > 0);
	},
	
	isAnimatingScale: function isAnimatingScale()
	{
		return (this._mScaleTimer > 0);
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/GL2Extensions'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/GL2Extensions'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/GL2Extensions'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/GL2Extensions.js';

/*
 *  GL2Extensions.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/18/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var UI = require('NGCore/Client/UI').UI;
var GL2 = require('NGCore/Client/GL2').GL2;
var Network = require('NGCore/Client/Network').Network;
var Core = require('NGCore/Client/Core').Core;
var UIElement = require('ngCrunch/internal/UIElement').UIElement;

// had to pull this in directly since UI namespace alone doesn't actually pull this.
var AbstractView = UI.AbstractView;
if ( !AbstractView )
	AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

//
// graft additional methods onto core classes so that they act as users expect
//

/* Autoresizing masks.  OR these bits together to describe desired autoresizing.
From Apple's docs:

Where more than one option along an axis is set, the default behavior is to distribute
the size difference as evenly as possible among the flexible portions.
For example, if frame and autoresizingMask are set and the superview�s width has
increased by 10.0 units, the receiver�s frame and right margin are each
widened by 5.0 units.
*/
DViewAutoresizingNone                 = 0;
DViewAutoresizingFlexibleLeftMargin   = 1 << 0;
DViewAutoresizingFlexibleWidth        = 1 << 1;
DViewAutoresizingFlexibleRightMargin  = 1 << 2;
DViewAutoresizingFlexibleTopMargin    = 1 << 3;
DViewAutoresizingFlexibleHeight       = 1 << 4;
DViewAutoresizingFlexibleBottomMargin = 1 << 5;

// string to prepend to all image resource names so they can be found in the data folder.
SpriteFolder = "Content/";

// string to prepend to all font resource names so they can be found in the data folder.
FontFolder = "Content/";

// Should we show debug frames on objects?
SHOW_TEXT_FRAMES	= _DEBUG && false;

loggedTheFonts = false;

// KJB Table containing downloaded images.
var downloadedImages = [];

// list of images currently downloading.  Key: image name, value: object
var	waitingImages = {};

// cache folder for downloaded images.
var	imageCacheFolder = "./ngCrunch/XibSupport/Cache/";

// active animation block. if this exists, then any supported Node changes should be animated.
activeAnimBlock = NULL;

/**
	Default initialization.
	@task construction
*/
GL2.Node.prototype.init = function() /**GL2.Node*/
{
	//
	// set require_d options
	//
//	this.setChildrenDepthGrouped(true);
	this._frame = new Core.Rect;
	this._AutoresizingMask = DViewAutoresizingFlexibleRightMargin|DViewAutoresizingFlexibleBottomMargin;

	return this;
}

// override destroy() so we clear our animation object (if any)
GL2.Node.prototype.Node_destroy = GL2.Node.prototype.destroy;	// prepare for inheritance
GL2.Node.prototype.destroy = function()
{
	this._destroyed = true;
	this.removeAnimator();
	this.Node_destroy();	// super
}


/**
	Get current user reference value.
	@task tags
*/
GL2.Node.prototype.getTag = function() /**int*/
{
	return this._ID || 0;
}

/**
	Set current user reference value.
	@task tags
*/
GL2.Node.prototype.setTag = function( /**int*/ val )
{
	this._ID = val;
}

/**
	Find a child node with the given tag
	@task tags
*/
GL2.Node.prototype.nodeWithTag = function( /**int*/ val )
{
	var	list = this.getChildren();
	for ( var i=0; i<list.length; i++ )
	{
		if ( list[i].getTag() == val )
			return list[i];
	}
	return NULL;
}

/**
	Set the position and size of this object, realtive to it's parent node.
	Supports animation blocks (see GL2.Node#beginAnimation).
	@task Dimensions
*/
GL2.Node.prototype.setFrame = function( /**Core.Rect*/ inFrame )
{
	if ( !this._frame )
		this.init();

	// new feature - convert argument list ( x,y, w,h ) to Core.Rect for us.
	if ( arguments.length == 4 )
		inFrame = new Core.Rect( arguments[0], arguments[1], arguments[2], arguments[3] );

	// new feature - convert array [ x,y, w,h ] to Core.Rect for us.
	if ( inFrame.length == 4 )
		inFrame = new Core.Rect( inFrame[0], inFrame[1], inFrame[2], inFrame[3] );

	if ( this._setupAnimation() )
	{
		// is size change requested?
		var	myVal = this._frame.getSize();
		var	newVal = inFrame.getSize();
		if ( myVal.getWidth() != newVal.getWidth() ||
			myVal.getHeight() != newVal.getHeight())
		{
		//	log("anim: animate size ("+myVal+" to "+newVal+")");
			this.animator.animateSize(
				newVal,
				activeAnimBlock.time,
				activeAnimBlock.curve,
				activeAnimBlock.loop,
				activeAnimBlock.delay );
			if ( activeAnimBlock.doneProc )
				this.animator.setDoneProc( activeAnimBlock.doneProc );
			activeAnimBlock.numUses ++;
		}

		// position?
		var	myVal = this._frame.getOrigin();
		var	newVal = inFrame.getOrigin();
		if ( myVal.getX() != newVal.getX() ||
			myVal.getY() != newVal.getY())
		{
		//	log("anim: animate pos ("+myVal+" to "+newVal+")");
			this.animator.animatePos(
				newVal,
				activeAnimBlock.time,
				activeAnimBlock.curve,
				activeAnimBlock.loop,
				activeAnimBlock.delay );
			if ( activeAnimBlock.doneProc )
				this.animator.setDoneProc( activeAnimBlock.doneProc );
			activeAnimBlock.numUses ++;
		}

		return;
	}

	// store for resize
	var	wasTheSize = this._frame.getSize();

	// save new position.
	this._frame = inFrame;

	// update all positions
	this.transformChanged();

	// if our size changed, update children
	var	diff = new Core.Point(
		this._frame.getSize().getWidth() - wasTheSize.getWidth(),
		this._frame.getSize().getHeight() - wasTheSize.getHeight() );
	if ( diff.getX() == 0 && diff.getY() == 0 )
		return;	// all done

	// update sizes of subviews
	var	list = this.getChildren();
	for ( var i=0; i<list.size(); i++ )
	{
		var	it = list[i];
		if ( it._AutoresizingMask == NULL || it._AutoresizingMask == DViewAutoresizingNone )
			continue;

		var	mask = it._AutoresizingMask;
		var	margin = { origin:{x:0,y:0}, size:{x:0,y:0} };
		var	f = {
			origin:{
				x:it.getFrame().getOrigin().getX(),
				y:it.getFrame().getOrigin().getY()},
			size:{
				x:it.getFrame().getSize().getWidth(),
				y:it.getFrame().getSize().getHeight()} }
		var	wasSize = { x:wasTheSize.getWidth(), y:wasTheSize.getHeight() };
		var	nowSize = { x:inFrame.getSize().getWidth(), y:inFrame.getSize().getHeight() };

		//
		// horizontal
		//

		// pull out parts that are 'locked'
		if (!( mask & DViewAutoresizingFlexibleLeftMargin ))
			margin.origin.x += f.origin.x;
		if (!( mask & DViewAutoresizingFlexibleRightMargin ))
			margin.size.x += wasSize.x - (f.origin.x+f.size.x);

		f.origin.x	-= margin.origin.x;	// pull it out...
		nowSize.x	-= margin.origin.x + margin.size.x;
		wasSize.x	-= margin.origin.x + margin.size.x;

		// mode is based on whether size is flexible
		if ( mask & DViewAutoresizingFlexibleWidth )
		{
			f.origin.x = f.origin.x * nowSize.x / wasSize.x;
			f.size.x = f.size.x * nowSize.x / wasSize.x;

		} else {

			// we only modify the position of the object in question.
			// If any margin is locked, maintain that margin.
			if (!( mask & DViewAutoresizingFlexibleLeftMargin ))
			{
				// do nothing, the origin stuff takes care of itself.
			}
			else if (!( mask & DViewAutoresizingFlexibleRightMargin ))
			{
				// muck so it sticks to edge
				f.origin.x = this._frame.getSize().getWidth() - margin.size.x - f.size.x;
				margin.origin.x = 0;	// just in case.
			}
			else {
				f.origin.x += f.size.x/2;
				f.origin.x = f.origin.x * nowSize.x / wasSize.x;
				f.origin.x -= f.size.x/2;
			}
		}

		f.origin.x += margin.origin.x;	// re-add it back in.


		//
		// vertical
		//

		// pull out parts that are 'locked'
		if (!( mask & DViewAutoresizingFlexibleTopMargin ))
			margin.origin.y += f.origin.y;
		if (!( mask & DViewAutoresizingFlexibleBottomMargin ))
			margin.size.y += wasSize.y - (f.origin.y+f.size.y);

		f.origin.y	-= margin.origin.y;	// pull it out...
		nowSize.y	-= margin.origin.y + margin.size.y;
		wasSize.y	-= margin.origin.y + margin.size.y;

		// mode is based on whether size is flexible
		if ( mask & DViewAutoresizingFlexibleHeight )
		{
			f.origin.y = f.origin.y * nowSize.y / wasSize.y;
			f.size.y = f.size.y * nowSize.y / wasSize.y;

		} else {

			// we only modify the position of the object in question.
			// If any margin is locked, maintain that margin.
			if (!( mask & DViewAutoresizingFlexibleTopMargin ))
			{
				// do nothing, the origin stuff takes care of itself.
			}
			else if (!( mask & DViewAutoresizingFlexibleBottomMargin ))
			{
				// muck so it sticks to edge
				f.origin.y = this._frame.getSize().getHeight() - margin.size.y - f.size.y;
				margin.origin.y = 0;	// just in case.
			}
			else {
				f.origin.y += f.size.y/2;
				f.origin.y = f.origin.y * nowSize.y / wasSize.y;
				f.origin.y -= f.size.y/2;
			}
		}

		f.origin.y += margin.origin.y;	// re-add it back in.

		// save it.
		var	frame = new Core.Rect( f.origin.x, f.origin.y, f.size.x, f.size.y );
		it.setFrame( frame );
	}
}

/**
	Get the position and size of this object, realtive to it's parent node.
	@task Dimensions
*/
GL2.Node.prototype.getFrame = function()	/**Core.Rect*/
{
	if ( !this._frame )
		this.init();

	return this._frame.clone();
}

/**
	Get the position and size of this object, realtive to this node.
	A subnode that 'fills' this object would have this for it's frame.
	@task Dimensions
*/
GL2.Node.prototype.getBounds = function()	/**Core.Rect*/
{
	if ( !this._frame )
		this.init();

	return new Core.Rect( [0,0], this._frame.getSize() );
}


/**
	Get the position of the center of this object, relative to its parent node.
	@task Dimensions
*/
GL2.Node.prototype.getCenter = function()	/**Core.Point*/
{
	return this.getFrame().getCenter();
}

/**
	Set the position of the center of this object, relative to its parent node.
	Supports animation blocks (see GL2.Node#beginAnimation).
	@task Dimensions
*/
GL2.Node.prototype.setCenter = function( /**Core.Point*/ at )
{
	return this.setFrame( this.getFrame().setOriginCentered(at) );
}

/**
	Get the size to be passed to the base GL2 setSize() calls.
	Typically only needed internally.
	@task Dimensions
*/
GL2.Node.prototype.getScaledSize = function() /**Core.Size*/
{
	if ( !this._scaleSize )
		return this._frame.getSize();

	var	size = this._frame.getSize().clone();
	var	scale = this.getScale();
	size.setAll( size.getWidth() / scale.getX(), size.getHeight() / scale.getY() );

	return size;
}


GL2.Node.prototype.Node_setRotation = GL2.Node.prototype.setRotation;	// prepare for inheritance
GL2.Node.prototype.setRotation = function( /**float*/ inRot )
{
	if ( this._setupAnimation() )
	{
		if ( inRot != this.getRotation() )
		{
		//	log("anim: animate rotation ("+this.getRotation()+" to "+inRot+")");
			this.animator.animateRotation(
				inRot,
				activeAnimBlock.time,
				activeAnimBlock.curve,
				activeAnimBlock.loop,
				activeAnimBlock.delay );
			if ( activeAnimBlock.doneProc )
				this.animator.setDoneProc( activeAnimBlock.doneProc );
			activeAnimBlock.numUses ++;
		}

		return;
	}

	this.Node_setRotation( inRot );
}


GL2.Node.prototype.Node_setAlpha = GL2.Node.prototype.setAlpha;	// prepare for inheritance
GL2.Node.prototype.setAlpha = function( /**float*/ inValue )
{
	if ( this._setupAnimation() )
	{
		if ( inValue != this.getAlpha() )
		{
		//	log("anim: animate rotation ("+this.getRotation()+" to "+inRot+")");
			this.animator.animateAlpha(
				inValue,
				activeAnimBlock.time,
				activeAnimBlock.curve,
				activeAnimBlock.loop,
				activeAnimBlock.delay );
			if ( activeAnimBlock.doneProc )
				this.animator.setDoneProc( activeAnimBlock.doneProc );
			activeAnimBlock.numUses ++;
		}

		return;
	}

	this.Node_setAlpha( inValue );
}

GL2.Node.prototype.Node_setScale = GL2.Node.prototype.setScale;	// prepare for inheritance
GL2.Node.prototype.setScale = function( inVal )
{
	// make sure inVal is a Vector.
	var	s = this.getScale().clone();
	s.setAll.apply(s, arguments);

	if ( this._setupAnimation() )
	{
	//	log("anim: animate scale ("+this.getScale()+" to "+s+")");
		this.animator.animateScale(
			s,
			activeAnimBlock.time,
			activeAnimBlock.curve,
			activeAnimBlock.loop,
			activeAnimBlock.delay );
		if ( activeAnimBlock.doneProc )
			this.animator.setDoneProc( activeAnimBlock.doneProc );
		activeAnimBlock.numUses ++;

		return;
	}

	this.Node_setScale( s );
}


/**
	Called when size or center of the frame changes.
	@task Dimensions
*/
GL2.Node.prototype.transformChanged = function()
{
	if ( this._frame == NULL )
		return;	// not setup yet.

	// update the transform to match.
	// In order for transforms to build on each other properly,
	// having a parent means our center is offset by the parent's.
	var	pos;
	if ( this.getParent() && this.getParent()._frame )
	{
		var	parSize = this.getParent()._frame.getSize();
		/*	DDP ok, this isn't working as well as i hoped.
		parSize = parSize.clone();
		var	parScale = this.getParent().getScale();
		parSize.setWidth( parSize.getWidth() / parScale.getX() );
		parSize.setHeight( parSize.getHeight() / parScale.getY() );
		*/
		pos = new Core.Point(
			this._frame.getMidX() - parSize.getWidth()/2,
			this._frame.getMidY() - parSize.getHeight()/2
		);
	} else {

		// at the root level, we have to take into account the scale value.
		var	scale = this.getScale();
		pos = new Core.Point( this._frame.getMidX()*scale.getX(), this._frame.getMidY()*scale.getY() );
	}
	this.Node_setPosition( pos );
}

GL2.Node.prototype.forceAllTransformChanged = function()
{
	this.transformChanged();

	var	list = this.getChildren();
	for ( var i=0; i<list.length; i++ )
		list[i].forceAllTransformChanged();
}

/**
	Get a copy of the children list.  Safe to change the returned list, it won't affect
	the original Node.
*/
GL2.Node.prototype.getChildren = function() /**Array[GL2.Node]*/
{
	return this._children.clone();
}

// override addChild so that it calls transformChanged() on new child nodes.
// This way the order of operations doesn't matter.
GL2.Node.prototype.Node_addChild = GL2.Node.prototype.addChild;	// prepare for inheritance
GL2.Node.prototype.addChild = function(child)
{
	this.Node_addChild( child );	// super
	child.transformChanged();
}

// override setPosition so that any object using the init/setFrame/ngCrunch style API
// doesn't allow for direct position sets accidentally.
GL2.Node.prototype.Node_setPosition = GL2.Node.prototype.setPosition;	// prepare for inheritance
GL2.Node.prototype.setPosition = function()
{
//	if ( this._frame )
//		throw new Error("setPosition is not supported on an ngCrunch/init/setFrame style Node");

	this.Node_setPosition.apply( this, arguments );
}

/**
	Find the child node with the given tag number.
	Only first found is returned.
*/
GL2.Node.prototype.viewWithTag = function( /**int*/ tag ) /**GL2.Node*/
{
	var	list = this.getChildren();
	for ( var i=0; i<list.length; i++ )
	{
		if ( list[i].getTag() == tag )
			return list[i];
	}
	return NULL;
}


/**
	Get the autoresizing (a.k.a. springs & struts) mask.
	@task Dimensions
*/
GL2.Node.prototype.getAutoresizingMask = function()	/**DViewAutoresizing constant*/
{
	return this._AutoresizingMask;
}

/**
	Set the autoresizing (a.k.a. springs & struts) mask.
	@task Dimensions
*/
GL2.Node.prototype.setAutoresizingMask = function( /**DViewAutoresizing constant*/ val )
{
	this._AutoresizingMask = val;
}

/**
	Initialize this object with information from a xib file.
	Subclasses typically override this.  Be sure to either a) call $super, or b) call
	setupSelfFromXib and setupSubviewsFromXib.
	In Interface Builder we support:
	<li>Tag
	<li>Autoresizes Subviews is always On
	<li>Autoresize Springs and Struts
	@task construction
*/
GL2.Node.prototype.initWithXib = function( /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
{
	this.setupSelfFromXib( groupElem, inLoader );
	this.setupSubviewsFromXib( groupElem, inLoader );
	return this;
}

/**
	Extract an object's frame from a xib definition.
	@task construction
	@private
*/
GL2.Node.prototype.frameFromXib = function( /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader ) /**Core.Rect*/
{
	var	str = inLoader.stringForKey( groupElem, "NSFrame" );
	if ( str )
	{
		var	match = /\{\{(.*?),\s*(.*?)\},\s*\{(.*?),\s*(.*?)\}\}/.exec(str);
		return new Core.Rect(
			[parseFloat(match[1]), parseFloat(match[2])], [parseFloat(match[3]), parseFloat(match[4])] );
	}

	// try frameSize instead
	str = inLoader.stringForKey( groupElem, "NSFrameSize" );
	if ( str )
	{
		var	match = /\{(.*?),\s*(.*?)\}/.exec(str);
		return new Core.Rect( [0,0], [parseFloat(match[1]), parseFloat(match[2])] );
	}

	return NULL;
}

/**
	Initialize this object from a xib definition file.  This is all the base class informtion,
	all except for subviews.
	@task construction
	@private
*/
GL2.Node.prototype.setupSelfFromXib = function( /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
{
	// base initialize
	this.init();

	//
	// work out the frame
	//

	var	newFrame = this.frameFromXib( groupElem, inLoader );
	if ( newFrame == NULL )
		newFrame = this._frame;

//	log("got frame "+newFrame.toString());

	// but wait.  if we're using a Mac XIB, we have to *reverse* the frame.
	// It's in botleft coordinates, and our engine uses topRight.  Fun, huh?
	if ( inLoader.isMacXib() )
	{
		// get the superview.  we then reverse based on it's size.
		var	parent = inLoader.objectElementForKey( groupElem, "NSSuperview" );
		if ( parent )
		{
			var	parentFrame = this.frameFromXib( parent, inLoader );
			if ( parentFrame )
			{
				newFrame.setOrigin( [newFrame.getOrigin().getX(),
					parentFrame.getSize().getHeight() - newFrame.getOrigin().getY() - newFrame.getSize().getHeight()] );
			//	log("reversed frame "+newFrame.toString());
			}
		}
	}

	// set the new frame
	this.setFrame( newFrame );

	//
	// get additional information
	//

	// the ID is in here too
	if ( this._ID == NULL )
		this._ID = 0;	// just so it's defined.
	this._ID = inLoader.intForKey( groupElem, "IBUITag", this._ID );
	this._ID = inLoader.intForKey( groupElem, "NSTag", this._ID );

	// the flex bits are all here, verbatim. (not tested for iPhone)
	this._AutoresizingMask = inLoader.intForKey( groupElem, "NSvFlags" ) & 0x03f;
	// reverse the vertical flags for a mac xib.
	if ( inLoader.isMacXib() )
	{
		var	t = this._AutoresizingMask;
		this._AutoresizingMask &= ~(DViewAutoresizingFlexibleTopMargin|DViewAutoresizingFlexibleBottomMargin);
		this._AutoresizingMask |= (t&DViewAutoresizingFlexibleTopMargin)? DViewAutoresizingFlexibleBottomMargin:0;
		this._AutoresizingMask |= (t&DViewAutoresizingFlexibleBottomMargin)? DViewAutoresizingFlexibleTopMargin:0;
	}

	// get initial visibility flag
	if ( inLoader.intForKey( groupElem, "NSvFlags" ) & 0x80000000 )
	{
		this.setVisible(false);
	}

	// is there a background color tag?
	var	col = inLoader.colorForKey( groupElem, "IBUIBackgroundColor", undefined );
	var	alpha = 1;
	if ( col )
	{
		this.setColor( new Core.Color(col.r,col.g,col.b) );
		alpha = col.a;
	}

	// alpha?  If the background color defines an alpha, mux them.
	col = 1;
	col = inLoader.realForKey( groupElem, "IBUIAlpha", col );
	col = inLoader.realForKey( groupElem, "NSViewAlphaValue", col );
	this.setAlpha( alpha * col );
}


/**
	Initialize this object from a xib definition file.  This only handles subviews of this object.
	@task construction
	@private
*/
GL2.Node.prototype.setupSubviewsFromXib = function( /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
{
	// look for objects to load
	var	element = inLoader.arrayElementForKey(groupElem, "NSSubviews");
	if ( element == NULL )
		return;

	// Done in two steps because mac xibs need to be added to us in reverse order.
	var	list = [];
	var	tasks = element.length;
	for(var i=0;i<element.length;i++)
	{
		var child = element[i];

		// create it.
		inLoader.objectFrom( child, inLoader.owner, function( what )
		{
			tasks --;
			if ( what )
		list.add( what );

			if ( tasks > 0 )
				return;

	// add them.
	var	d = 1;
	if ( inLoader.isMacXib() )
	{
		// REVERSE order
		for ( var i=list.size()-1; i>=0; i--,d++ )
		{
			this.addChild( list[i] );
			list[i].changeDepthDeep( d );
			list[i].transformChanged();
		}

	} else {

		// UIKit, normal order.
		for ( var i=0; i<list.size(); i++,d++ )
		{
			this.addChild( list[i] );
			list[i].changeDepthDeep( d );
			list[i].transformChanged();
		}
	}
		}.bind(this));
}
}


/**
	 * Convert the relative location of a scene to the local coordinate space for this <code>Node</code>.
	 * Do not use GL2.Node#screenToLocal, as that has overrides in some node types which makes
	 * the result invalid.
	 * @example var p = Game.getRoot().globalToLocal(touch.getPosition());
	 * @param {Core.Point} location The relative location for a scene.
	 * @see GL2.Node#localToGlobal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	GL2.Node.prototype.globalToLocal = function (location)
	{
		var parent = this._parent;
		if(!parent)
			return location;

		location = parent.globalToLocal(location);
		if(!location)
			return undefined;

		var x = location.getX();
		var y = location.getY();

		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();

		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;

		// Undo scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();

		return new Core.Point(x, y);
	}

	/**
	 * Convert a location within the local coordinate space for this <code>Node</code> to a location within the screen coordinate
	 * space. Note: {0,0} is the *center* of this object, I haven't fixed it for getBounds() yet.
	 * Do not use GL2.Node#localToScreen, as that has overrides in some node types which makes
	 * the result invalid.
	 * @param {Core.Point} location A location in the local transform for this <code>Node</code>.
	 * @see GL2.Node#globalToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	GL2.Node.prototype.localToGlobal = function(location)
	{
		// break out
		var x = location.getX();
		var y = location.getY();

		// Undo scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();

		// Undo rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;

		// Undo translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();
		location = new Core.Point(x, y);

		var parent = this.getParent();
		if(!parent)
			return location;

		location = parent.localToGlobal(location);
		if(!location)
			return undefined;
		return location;
	}

	/**
	 * Translate screen coordinates into node coordinates.
	 * Do not use GL2.Root#screenToLocal, as that has overrides in some node types which makes
	 * the result invalid.
	 * @example var p = Game.getRoot().globalToLocal(touch.getPosition());
	 * @param {Core.Point} location The screen coordinates to translate.
	 * @returns The location as node coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	GL2.Root.globalToLocal = function(location)
	{
		return location;
	}

	/**
	 * Translate node coordinates into screen coordinates.
	 * Do not use GL2.Root#localToScreen, as that has overrides in some node types which makes
	 * the result invalid.
	 * @param {Core.Point} location The node coordinates to translate.
	 * @returns The location as screen coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	GL2.Root.localToGlobal = function(location)
	{
		return location;
	}

/**
	Show the current rendering tree (including children) as a flat string.
	Subclasses should override _toString() to provide additional class-specific information.
	@task debugging
*/
GL2.Node.prototype.treeToString = function()	/**string*/
{
	var	indent = arguments[0];
	if ( indent == NULL )
		indent = "";

	var ret = indent + this.classname;

	// native ID
	ret += "-"+this.__objectRegistryId;

	// view owner
	if ( this._viewOwner )
		ret += " \towner:"+this._viewOwner;

	// position and/or frame
	if ( this._frame )
		ret += " \tframe:"+this._frame;
//	else
//		ret += " \tposition:"+this.getPosition();
	ret += " \tpriority:"+this.getDepth();
//	ret += " \tpriorityGrouped:"+(this.getChildrenDepthGrouped()?"on":"off");

	// give subclasses a chance
	if ( typeof this._toString == 'function' )
		ret += " \t"+this._toString();

	// recursive
	if ( this._children.size() )
	{
		ret += "\n";
		ret += indent+"{\n";
		var	subIndent = indent+"    ";
		for ( var i=0; i<this._children.size(); i++ )
		{
			ret += this._children[i].treeToString( subIndent );
			// make sure line ends in newline
			if ( !ret.endsWith("\n") )
				ret += "\n";
		}
		ret += indent+"}\n";
	}

	return ret;
}

/**
	Create an object that mirrors this node's setup, including all children.
	Subclasses should override _showTree() to provide additional class-specific information.
	@task debugging
*/
GL2.Node.prototype.showTree = function( parent )
{
	var	ret = {};
	var	key = this.classname+"-"+this.__objectRegistryId;
	if ( this._viewOwner )
		key = this._viewOwner+"-"+key;
	if ( parent )
		parent[key] = ret;

	if ( this._viewOwner )
		ret.owner = this._viewOwner;

	// position and/or frame
	if ( this._frame )
		ret.frame = this._frame.toString();
	else
		ret.position = this.getPosition().toString();

	ret.priority = this.getDepth();
	ret.priorityGrouped = (this.getChildrenDepthGrouped()?"on":"off");

	if ( this.getRotation() )
		ret.rotation = this.getRotation();
	if ( this.getScale().getX() != 1 || this.getScale().getY() != 1 )
		ret.scale = this.getScale();

	// give subclasses a chance
	if ( typeof this._showTree == 'function' )
		this._showTree( ret );

	// recursive
	if ( this._children.size() )
	{
		for ( var i=0; i<this._children.size(); i++ )
			this._children[i].showTree( ret );
	}

	return ret;
}

/**
	Get a short name for this Node that matches up with the output of showTree or treeToString.
	@task debugging
*/
GL2.Node.prototype.toString = function()
{
	if ( this._viewOwner )
		return this.classname+"-"+this._viewOwner+"-"+this.__objectRegistryId;
	return this.classname+"-"+this.__objectRegistryId;
}

// only added here so subclasses don't have to guess if $super uses this.
GL2.Node.prototype.connectFromXib = function(/**Object*/thing, /**string*/connectionName)
{
	return false;
}

GL2.Node.prototype._setupAnimation = function()
{
	if ( !activeAnimBlock )
		return false;

	if ( this.animator )
		return true;	// already have one.

	// track down our view controller.  without one, we can't do anything
	var	owner = this._viewController;
	var	parent = this;
	while ( parent )
	{
		owner = parent._viewController;
		if ( owner )
			break;

		parent = parent.getParent();
	}
	if ( !owner )
	{
	//	log("anim: no view controller");
		return false;
	}

	// create an animator, with default values.
	new UIElement( this );
	this.animator._deleteOnComplete = true;
	owner._animators.push( this.animator );

	return true;
}

/**
	Request that a new animation block should be started.
	Any Node calls that support this will be animated.
	Be sure to end the setup with commitAnimations (to prevent accidental animation of other objects).
	Only one animation block may be defined at a time - but you may create successive animation
	blocks to run their animations at the same time.
	<br><br>
	Caller may adjust settings of the animation (speed, delay, etc) with the setAnimation* calls.
	Each call is done in order, so...
	@example
// after this, node1 will animate for the default time (.3 seconds).
// node2 will start animating immediately as well, but for 2 seconds.
GL2.Node.beginAnimation();
node1.setAlpha(0);
GL2.Node.setAnimationLength( 2 );
node2.setAlpha(0);
GL2.Node.commitAnimation();
	@static
	@task Animation
*/
GL2.Node.beginAnimation = function()
{
	// is an animation already running?
	if ( activeAnimBlock )
		return true;

	// create an anim block, setting defaults
	activeAnimBlock = {
		numUses:	0,
		time:	.3,
		curve:	"XLERP",
		delay:	0,
		loop:	false,
		doneProc:	NULL
	};

	return true;
}
GL2.Node.prototype.beginAnimation = GL2.Node.beginAnimation;	// make instance method too.


/**
	Close an existing animation block, balancing beginAnimation().
	@static
	@task Animation
*/
GL2.Node.commitAnimation = function()
{
	activeAnimBlock = undefined;
}
GL2.Node.prototype.commitAnimation = GL2.Node.commitAnimation;	// make instance method too.

/**
	Remove and cancel any animations set for this Node.  Useful if you want to cancel an animation early.
	Does *not* commit the final frame of the animation.
	@task Animation
*/
GL2.Node.prototype.removeAnimator = function()
{
	if ( !this.animator )
		return;

	var	wasAnimator = this.animator;
	this.animator = NULL;	// drop the reference.

	// track down our view controller.  without one, we can't do anything
	var	owner = this._viewController;
	var	parent = this;
	while ( parent )
	{
		owner = parent._viewController;
		if ( owner )
		{
			owner._animators.remove( wasAnimator );
			break;
		}
		parent = parent.getParent();
	}
}


/**
	Set the length of any following animated values.
	@static
	@task Animation
*/
GL2.Node.prototype.setAnimationLength = function( /**float*/ secs )
{
	if ( secs <= 0 )
	{
		if ( _DEBUG )	// warning of bad anim length
			throw new Error("Node.setAnimationLength given bad length <= 0: "+secs);
		return;	// prevent really bad things from happening.
	}
	if ( !activeAnimBlock )
		return;
	activeAnimBlock.time = secs;
}

/**
	Set the delay of any following animated values.
	@static
	@task Animation
*/
GL2.Node.prototype.setAnimationDelay = function( /**float*/ secs )
{
	if ( !activeAnimBlock )
		return;
	activeAnimBlock.delay = secs;
}

/**
	Set the style of animation curve for any following animated values.
	@static
	@task Animation
*/
GL2.Node.prototype.setAnimationCurve = function( /**MoreMath.BlendCurve*/ type )
{
	if ( !activeAnimBlock )
		return;
	activeAnimBlock.curve = type;
}

/**
	Set whether this animation should loop indefinitely.
	Cancel the loop by calling target.removeAnimator();
	@static
	@task Animation
*/
GL2.Node.prototype.setAnimationLoop = function( /**bool*/ loop )
{
	if ( !activeAnimBlock )
		return;
	activeAnimBlock.loop = loop;
}

/**
	Set a callback for when the animation completes.
	@static
	@task Animation
*/
GL2.Node.prototype.setAnimationDoneProc = function( /**function()*/ doneProc )
{
	if ( !activeAnimBlock )
		return;
	activeAnimBlock.doneProc = doneProc;
}

/**
	Recursively change the depth of a node and every one of its children

	@private
*/

GL2.Node.prototype.changeDepthDeep = function(/**float*/deltaDepth)
	{
		//change the depth of the target node
/*		if(targetRoot==NULL)
			targetRoot = this.view;
*/
		this.setDepth(this.getDepth()+deltaDepth);

		var children = this.getChildren();

		for(var i=0;i<children.length;i++)
			children[i].changeDepthDeep(deltaDepth);

		//TODO: take advantage of depth grouping
	},

/**
	Calculate the position within a node of a set of coordinates in the global screen space.
	Prefer localToGlobal and globalToLocal instead of this.
	@private
*/

GL2.Node.prototype.screenCoordinatesToLocal = function(/**Core.Point*/pos, /**bool*/ ignoreAnchor)
{

	//TODO: handle rotation, scaling. also there is probably something terribly wrong with this

	var localPos = pos.clone();
	var ourPos = this.getPosition().clone();

	if(typeof this._parent.screenCoordinatesToLocal=='function')
	{
		localPos = this._parent.screenCoordinatesToLocal(localPos, true);
	}

	if(this._anchor && (ignoreAnchor==undefined))
	{
		ourPos.setX(ourPos.getX() - (this._anchor.getX()*this.getSize().getWidth()));
		ourPos.setY(ourPos.getY() - (this._anchor.getY()*this.getSize().getHeight()));
	}

	localPos.setX((localPos.getX() - ourPos.getX()));
	localPos.setY((localPos.getY() - ourPos.getY()));

	return localPos;
}

/**
	Set a UI view's frame by converting a Xib-style Node's frame to the global space.
	This assumes the AbstractView is a child of UI.Window.document.
*/
AbstractView.prototype.setFrameFromXib = function( /**GL2.Node*/ inTemplateXibNode )
{
	var sendFrame = inTemplateXibNode.getFrame();
	var w = sendFrame.getSize().getWidth();
	var h = sendFrame.getSize().getHeight();
	var chatFieldTopLeft = inTemplateXibNode.localToGlobal(new Core.Point(-w/2,-h/2));
	var chatFieldBottomRight = inTemplateXibNode.localToGlobal(new Core.Point(w/2,h/2));
	var fieldX = Math.round(chatFieldTopLeft.getX());
	var fieldY = Math.round(chatFieldTopLeft.getY());
	var fieldWidth = Math.round(chatFieldBottomRight.getX()-chatFieldTopLeft.getX());
	var fieldHeight = Math.round(chatFieldBottomRight.getY()-chatFieldTopLeft.getY());
	this.setFrame(fieldX, fieldY, fieldWidth, fieldHeight);
}

/**
	Shallow duplicate this Touch so that the same touch can be handed to sub-code with a different
	action code.
*/
GL2.Touch.prototype.clone = function()
{
	var	ret = new GL2.Touch;
	for ( var k in this )
	{
		if ( typeof(this[k]) == 'function' )
			continue;
		ret[k] = this[k];
	}
	return ret;
}


GL2.Touch.prototype.ng_setTargetIds = GL2.Touch.prototype._setTargetIds;	// prepare for inheritance
GL2.Touch.prototype._setTargetIds = function( targetIds )
{
	// Call super
	this.ng_setTargetIds( targetIds );

	// keep this around for later.
	this._orderedTargets = targetIds.clone();
}

/**
 * Retrieve a list of every <code>TouchTarget</code> object in which this <code>Touch</code> object resides and is marked as touchable.
 * @returns {GL2.TouchTarget} A prioritized list of every <code>TouchTarget</code> for this <code>Touch</code>.
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
GL2.Touch.prototype.getTouchTargets = function()
{
	var ids = this._orderedTargets.clone();	// DDP the big difference between ng's and ours.
	var result = [];
	for(var i = 0; i < ids.length; i++ )
	{
		var t = Core.ObjectRegistry.idToObject(ids[i]);
		if(t) result.push(t);
	}
	return result;
}



GL2.Sprite.prototype.Node_initWithXib = GL2.Sprite.prototype.initWithXib;	// prepare for inheritance
/**
	Initialize this object with information from a xib file.
	In Interface Builder we support everything of GL2.Node.initWithXib, as well as:
	<li>Scaling of "Axes Independantly" only
	<li>Border: None only
	@task construction
*/
GL2.Sprite.prototype.initWithXib = function( /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
{
	// Call super
	this.Node_initWithXib( groupElem, inLoader );

	//
	// get the image name
	//

	var	group;
	var	name;

	// uikit
	group = inLoader.objectElementForKey( groupElem, "IBUIImage" );
	if ( group )
		name = inLoader.stringForKey( group, "NSResourceName" );

	// Cocoa
	group = inLoader.objectElementForKey( groupElem, "NSCell" );
	if ( group )
		group = inLoader.objectElementForKey( group, "NSContents" );
	if ( group )
	{
		// have to add the extension manually for a Cocoa one.
		name = inLoader.stringForKey( group, "NSResourceName" );
	}

	if ( name )
	{
		var unmodifiedName = name;
		var locate = unmodifiedName.match(".png$");
		var checkJPG = unmodifiedName.match(".jpg$");

		if(locate==NULL && checkJPG==NULL)
			name = SpriteFolder+name+".png";	// have to add this manually for now
		else
			name= SpriteFolder+name;

		this.setImage( name );
	}
}


var	imageLookupDelegate = undefined;

/**
	inImageLookupDelegate, takes 3 parameters. The first parameter is a GL2.Sprite object.
	The second parameter is the name of the image exactly as specified in IB. The third parameter
	is the expected frame of the sprite when displayed.
	The method should return
*/
GL2.Sprite.setImageLookupDelegate = function( inImageLookupDelegate )
{
	imageLookupDelegate = inImageLookupDelegate;
}
GL2.Sprite.prototype.setImageLookupDelegate = GL2.Sprite.setImageLookupDelegate;	// synonym


// called when image is done being processed by compositeImages
function processedImageCallback( data )
{
	// because of how it was called, "this" is the name of the image in the cache.
	var	imageName = this;

	// get the filename - it may be different!
	var	filename = data.filename;

//	log("GL2.Sprite: processed image "+imageName+" at "+filename);

	// complete the image setup process.
	downloadedImages.push( imageName );	// so we know it's available now.
	var	list = waitingImages[imageName].list;
	for ( var i=0; i<list.length; i++ )
	{
		// is this target object?  Or has something else overridden this Sprite already?
		var	entry = list[i];
		if ( entry._waitingForDownload == imageName )
		{
			entry.setImage( filename );
		//	log("GL2.Sprite: "+entry+" download image "+entry._waitingForDownload+" complete");
			delete entry._waitingForDownload;
		}
		// else log("GL2.Sprite: "+entry+" download image was overidden by "+entry._waitingForDownload+" instead of "+imageName);
	}
	waitingImages[imageName].list = [];	// just in case next line isn't right...
	delete waitingImages[imageName];
}


// called when image is done downloading.
function downloadImageCallback(statusCode, md5)
{
	// because of how it was called, "this" is the name of the image in the cache.
	var	imageName = this;

	// has the caller let us know that we don't need to scale it?
	if ( waitingImages[imageName].options && waitingImages[imageName].options.disableComposite )
	{
	//	log("GL2.Sprite: skipping compositeImages for "+imageName);
		return processedImageCallback.call( imageName, { filename: imageCacheFolder+imageName } );
	}

	// round up to power of two for android
	var	x = Math.pow( 2, Math.ceil( Math.log( waitingImages[imageName].size.getWidth() ) / Math.log(2) ) );
	var	y = Math.pow( 2, Math.ceil( Math.log( waitingImages[imageName].size.getHeight() ) / Math.log(2) ) );

//	log("GL2.Sprite: download status "+statusCode+" for "+imageName+" will want size "+x+","+y);

	// have compositeImages break it down
	UI.compositeImages( x,y, imageCacheFolder+imageName, [{
		image:imageCacheFolder+imageName,
		rect:[0,0,x,y],
		fit: UI.FitMode.Stretch
	}], processedImageCallback.bind(imageName) );
}

function makeImageKeyFromURL( image )
{
	// remove the leading http:// part
	var	imageName = image.substr( 7 /*"http://".length*/ );

	// Disregard anything after the last ? mark
	var questionLoc = imageName.lastIndexOf("?");
	if ( questionLoc >= 0 )
		imageName = imageName.substring(0, questionLoc);

	// convert slashes to underscores
	imageName = imageName.replace( /\/+/g, "_" );
	imageName = imageName.replace( /\:/g, "_" );

	return imageName;
}

GL2.Sprite.removeDownloadedImage = function( image )
{
	var	imageName = makeImageKeyFromURL( image );
	var numDownloadedImages = downloadedImages.length;
	// check to see if the file is actually cached and if so remove it from our records
	for(var i = 0;i < numDownloadedImages;i++)
		if(downloadedImages[i] == imageName)
		{
			// remove the file from our records and return
			downloadedImages.splice(i,1);
			return;
		}
}
GL2.Sprite.prototype.removeDownloadedImage = GL2.Sprite.removeDownloadedImag;

GL2.Sprite.setDownloadImageOptions = function( image, options )
{
	var	imageName = makeImageKeyFromURL( image );

	// check to see if we already downloaded this file
	if ( downloadedImages.contains(imageName) )
		return;	// too late, already loaded.

	if ( !waitingImages[imageName] )
		waitingImages[imageName] = {};
	waitingImages[imageName].options = options;
}
GL2.Sprite.prototype.setDownloadImageOptions = GL2.Sprite.setDownloadImageOptions;


//GL2.Sprite.prototype.Sprite_setImage = GL2.Sprite.prototype.setImage;	// prepare for inheritance
//GL2.Sprite.prototype.setImage = function(image)
//{
//	if ( image == undefined )
//		return this;	// umm... what?
//
//	if ( this._destroyed )
//		return this;	// can happen with callbacks
//
//	if ( arguments.length != 1 || !this._frame )
//		return this.Sprite_setImage.apply(this, arguments);	// call super instead
//
//	// check with the sprite manager before doing anything.
//	if ( imageLookupDelegate )
//	{
//		if ( imageLookupDelegate( this, image, this.getFrame() ) )
//			return this;	// handled.
//	}
//
//	// KJB Check to see if we're trying to use an image from the internets
//	if(image.indexOf("http://") == 0 && (!_FLASH))
//	{
//		var	imageName = makeImageKeyFromURL( image );
//
//		// KJB Next check to see if we already downloaded this file
//		if ( downloadedImages.contains(imageName) )
//		{
//			// KJB Use it!
//			image = imageCacheFolder + imageName;
//			// fall through to standard image setting
//		}
//		else
//		{
//			var	waitingEntry = waitingImages[imageName];
//			if ( !waitingEntry )
//				waitingEntry = waitingImages[imageName] = {};
//
//			// check if there is a default image to use
//			if ( waitingEntry.options && waitingEntry.options.defaultPic )
//			{
//				// note that we do *not* use the normal cache stuff below.
//				this.Sprite_setImage( waitingEntry.options.defaultPic, this.getFrame().getSize(), [.5, .5] );
//			}
//
//			// update this UI element to refer to this image.
//			this._waitingForDownload = imageName;
//
//			// if it currently being downloaded?
//			if ( waitingEntry.list )
//			{
//				// add us to the notification list
//				waitingEntry.list.push( this );
//				return;
//			}
//
//			// we are going to want an idea of how big to make the image.
//			// We may be scaled up to screen resolution right now.  If so, take that into account
//			// when calculating our size.
//			var	totalScale = this.getFrame().getSize().clone();
//			var	whom = this;
//			while ( whom && whom.getScale )	// check that it has a getScale method too
//			{
//				totalScale.setWidth( whom.getScale().getX() * totalScale.getWidth() );
//				totalScale.setHeight( whom.getScale().getY() * totalScale.getHeight() );
//				whom = whom.getParent();
//			}
//
//			// mark up the global table so it's found immediately by next caller
//			waitingEntry.list = [ this ];
//			waitingEntry.size = totalScale;
//
//			// KJB Download the image
//		//	log("GL2.Sprite: starting image download for "+imageName+" from "+image);
//			new Network.DownloadFile().start(
//				imageCacheFolder + imageName, "GET", image, [], downloadImageCallback.bind(imageName));
//			return;
//		}
//	}
//
//	// maximize the native cache by removing any leading "./" from paths.  We don't need them,
//	// and it breaks the cache.
////	image.replace( /^\.\//, "");
//
//
//	// The ngCore image system recreates the texture on the backend, unless we cache the texture ourselves.
//	// This is where we do it.
//	if ( (!this._cachedImage) || this._cachedImage.getFrame(0).getImage() != image )
//	{
//		if ( this._cachedImage )
//			this._cachedImage.destroy();
//
//		var	frame = new GL2.Animation.Frame( image, 0, this.getFrame().getSize(), [.5,.5] );
//		this._cachedImage = new GL2.Animation();
//		this._cachedImage.pushFrame( frame );
//	//	log("GL2.Sprite caching image "+image);
//	}
//
//	// set it with all appropriate values.
//	return this.Sprite_setImage( image, this.getFrame().getSize(), [.5, .5] );
//}

// override destroy() so we clear our animation object (if any)
GL2.Sprite.prototype.Node2_destroy = GL2.Sprite.prototype.destroy;	// prepare for inheritance
GL2.Sprite.prototype.destroy = function()
{
	if ( this._cachedImage )
	{
	//	log("GL2.Sprite done with image cache "+this._cachedImage.getFrame(0).getImage());

		this._cachedImage.destroy();
		this._cachedImage = NULL;
	}
	this.Node2_destroy();	// super
}



/**
	Determine whether given image is downloaded or not
*/
GL2.Sprite.prototype.isImageDownloaded = function(imageName)
{
	// remove the leading http:// part
	imageName = imageName.substr( 7 /*"http://".length*/ );

	// Disregard anything after the last ? mark
	var questionLoc = imageName.lastIndexOf("?");
	if ( questionLoc >= 0 )
		imageName = imageName.substring(0, questionLoc);

	// convert slashes to underscores
	imageName = imageName.replace( /\/+/g, "_" );
	imageName = imageName.replace( /\:/g, "_" );

	// KJB Next check to see if we already downloaded this file
	if ( downloadedImages.contains(imageName) )
		return true;
	return false;
}

/**
	Flip the UVs of the image horizontally
*/
GL2.Sprite.prototype.flipHorizontally = function()
{
	var animation = this.getAnimation();
	if(!animation)
		animation = this._animation;
	if(animation)
	{
		var frame = animation.getFrame(0);
		if(frame)
		{
			var uvs = frame.getUVs();
			if(uvs)
			{
				var newX = uvs.getOrigin().getX() + uvs.getSize().getWidth();
				var newWidth = uvs.getSize().getWidth() * -1;
				uvs.setOrigin(new Core.Point(newX, uvs.getOrigin().getY()));
				uvs.setSize(new Core.Size(newWidth, uvs.getSize().getHeight()));

				this.setImage(this.getImage(), frame.getSize(), frame.getAnchor(), uvs);
			}
		}
	}
}

/**
	Flip the UVs of the image vertically
*/
GL2.Sprite.prototype.flipVertically = function()
{
	var animation = this.getAnimation();
	if(!animation)
		animation = this._animation;
	if(animation)
	{
		var frame = animation.getFrame(0);
		if(frame)
		{
			var uvs = frame.getUVs();
			if(uvs)
			{
				var newY = uvs.getOrigin().getY() + uvs.getSize().getHeight();
				var newHeight = uvs.getSize().getHeight() * -1;
				uvs.setOrigin(new Core.Point(uvs.getOrigin().getX(), newY));
				uvs.setSize(new Core.Size(uvs.getSize().getWidth(), newHeight));

				this.setImage(this.getImage(), frame.getSize(), frame.getAnchor(), uvs);
			}
		}
	}
}

GL2.Sprite.prototype.Node_transformChanged = GL2.Sprite.prototype.transformChanged;	// prepare for inheritance
GL2.Sprite.prototype.transformChanged = function()
{
	// call super...
	this.Node_transformChanged();

	if ( !this._frame )
		return;

	// update our animation's size to match
	var anim = this.getAnimation();
	if ( !anim )
		anim = this._animation;
	if ( !anim )
		return;

	// Create a duplicate animation.
	var	copy = new GL2.Animation;
	for( var i=0;i<anim.getFrameCount();i++)
	{
			var oldFrame = anim.getFrame(i);
		var newFrame = new GL2.Animation.Frame(
			oldFrame.getImage(), oldFrame.getDuration(),
			this._frame.getSize(), oldFrame.getAnchor(), oldFrame.getUVs());
		copy.pushFrame(newFrame);
		}
	this.setAnimation(copy);
	this._ownsAnimation = true;	// because we really did add it to ourselves.
	}

/**
	Get the last image name set on this sprite.  This is only accurate for non-animated sprites.
*/
GL2.Sprite.prototype.getImage = function() /**string*/
{
	if ( this._animation == NULL )
		return NULL;

	// assume it only has one frame
	return this._animation.getFrame(0).getImage();
}

GL2.Sprite.prototype._toString = function()
{
	return "image:"+this.getImage();
}

GL2.Sprite.prototype._showTree = function( ret )
{
	ret.image = this.getImage();
}

var	validFonts;
/**
	Set the available font list for the project.
	Any font used during runtime that is not in this list will be reworked to match.
	Each entry's key is the name of the allowed font, and the value is an array of sizes
	to allow.

	This example fontlist object would define one font to use.  A requested size of
	6-12 will use 12; 13-18 will use 18; anything larger will use the larger requested size.
	@example
	  {
		"BlockT-Regu" : [
		  12, 18
		],
		"default" : "Content/BlockT-Regu.ttf"
	  }
*/
GL2.Text.setFontList = function( /**Object*/ info )
{
	validFonts = info;

	// make sure list of sizes is smallest to largest
	for ( var k in validFonts )
	{
		if ( k == "default" )
			continue;

		validFonts[k].sort(function(a,b){
			a-b
		});
	}
//	log("validFonts: "+JSON.stringify(validFonts));
}

GL2.Text.prototype.Node_init = GL2.Text.prototype.init;	// prepare for inheritance
GL2.Text.prototype.init = function()
{
	// set require_d settings
	this.setAnchor(.5,.5);
	return this.Node_init();
}



GL2.Text.prototype.Node_initWithXib = GL2.Text.prototype.initWithXib;	// prepare for inheritance
/**
	Initialize this object with information from a xib file.
	In Interface Builder we support everything of GL2.Node.initWithXib, as well as:
	<li>Alignment of Left, Center, or Right
	<li>Border: None only
	<li>Line Breaks: Clip or Word Wrap
	<li>Text Color
	@task construction
*/
GL2.Text.prototype.initWithXib = function( /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
{
	// Call super
	this.Node_initWithXib( groupElem, inLoader );

	// set require_d settings
	this.setAnchor(.5,.5);

	// which kind of xib is this?
	if ( inLoader.isMacXib() )
	{
		//
		// Cocoa
		//

		// swap the group element for the Cell, which holds the *real* information.
		groupElem = inLoader.objectElementForKey( groupElem, "NSCell" );

		// get content
		this.setText( inLoader.stringForKey( groupElem, "NSContents" ) );

		// get color definition
		this.setColor( inLoader.colorObjForKey( groupElem, "NSTextColor", this.getColor() ) );

		// line break mode
		// bit 9, for 3 bits, from enum NSLineBreakMode <NSParagraphStyle.h>
		var	overflow = GL2.Text.OverflowMode.Multiline;
		switch ( (inLoader.intForKey( groupElem, "NSCellFlags2" ) >> 9 ) & 0x07 )
		{
			case 0:	overflow = GL2.Text.OverflowMode.Multiline;			break; // word wrap
			case 1:	overflow = GL2.Text.OverflowMode.Multiline;			break; // character wrap

			case 2:	// Clip mode
			case 3: overflow = GL2.Text.OverflowMode.ReduceFontSize;	break; // truncate start
			case 4: overflow = GL2.Text.OverflowMode.ReduceFontSize;	break; // truncate end
			case 5: overflow = GL2.Text.OverflowMode.ReduceFontSize;	break; // truncate middle

			default:
				 // unspecified: Multiline mode
			//	mWordWrap = false;	mSingleLine = true;	break;
		}
		this.setOverflowMode( overflow );

		// alignment
		// bit 26, for 3 bits, from enum NSTextAlignment <NSText.h>
		var	justifyH = GL2.Text.HorizontalAlign.Left;
		switch ( (inLoader.intForKey( groupElem, "NSCellFlags2" ) >> 26 ) & 0x07 )
		{
			// DDP this way because when it was written vertical justification wasn't working.
			case 0:	justifyH = GL2.Text.HorizontalAlign.Left;	break;
			case 1:	justifyH = GL2.Text.HorizontalAlign.Right;	break;
			case 2:	justifyH = GL2.Text.HorizontalAlign.Center;	break;
			// 3: justified
			// 4: "natural" - default for font.
		}
		this.setHorizontalAlign( justifyH );
	//	this.setVerticalAlign( GL2.Text.Top );

		// the "support" object contains font definition.
		var	group = inLoader.objectElementForKey( groupElem, "NSSupport" );
		if ( group )
		{
			// font and size
			var	name = inLoader.stringForKey( group, "NSName" );
			var	size = inLoader.realForKey( group, "NSSize" );

			this.setFontFamily(name);
			this.setFontSize(size);

		//	log("wanting font "+name+" at size "+size);
		}
	} else {
		//
		// UIKit
		//

		// get content
		this.setText( _loc( inLoader.stringForKey( groupElem, "IBUIText" ) ) );

		// get color definition
		// Default is Black, if it's not spelled out in the xib.
		this.setColor( [0,0,0] );
		this.setColor( inLoader.colorObjForKey( groupElem, "IBUITextColor", this.getColor() ) );

		// line break mode
		var	overflow = GL2.Text.OverflowMode.Multiline;
		switch ( inLoader.intForKey( groupElem, "IBUILineBreakMode" ) )
		{
			case 0:	overflow = GL2.Text.OverflowMode.Multiline;		break; // word wrap
			case 1:	overflow = GL2.Text.OverflowMode.Multiline;		break; // character wrap

			case 2:	// Clip mode
			case 3: // truncate start
			case 4: // truncate end
			case 5: // truncate middle
				overflow = GL2.Text.OverflowMode.ReduceFontSize;	break;

			default:
				// unspecified: truncate end
			//	mWordWrap = false;	mSingleLine = true;	break;
		}
		this.setOverflowMode( overflow );

		// alignment
		var	justifyH = GL2.Text.HorizontalAlign.Left;
		switch ( inLoader.intForKey( groupElem, "IBUITextAlignment" ) )
		{
			// DDP this way because when it was written vertical justification wasn't working.
			case 0:	justifyH = GL2.Text.HorizontalAlign.Left;	break;
			case 1:	justifyH = GL2.Text.HorizontalAlign.Center;	break;
			case 2:	justifyH = GL2.Text.HorizontalAlign.Right;	break;
		}
		this.setHorizontalAlign( justifyH );
//		this.setVerticalAlign( GL2.Text.Top );

		// the "support" object contains font definition.
		var	group = inLoader.objectElementForKey( groupElem, "IBUIFont" );
		if ( group )
		{
			// font and size
			var	name = inLoader.stringForKey( group, "NSName" );
			var	size = inLoader.realForKey( group, "NSSize" );

			this.setFontFamily(name);
			this.setFontSize(size);

		//	log("wanting font "+name+" at size "+size);
		}
	}
}

// deprecated.
GL2.Text.prototype.getFontSubstituteFor = function(fontFamily)
{
	return fontFamily;
}

/**
	Normalizes font names or paths to a directory-less, extension-less version
		* Safe to pass an already-normalized path in (you'll just get it back).
	Useful for comparing if a given font family is functionally the same.
	More-or-less the opposite of GL2.Text.normalizeFontName.
*/
GL2.Text.normalizeFontPath = function normalizeFontPath(/**String*/ originalFontNameOrPath)
{
	var fontPath = originalFontNameOrPath;

	if ( fontPath.indexOf(FontFolder) < 0 )
		fontPath = "./" + FontFolder + fontPath;
	var	extPos = fontPath.lastIndexOf('.');
	if ( extPos < 0 || extPos < (fontPath.length-5) || extPos < fontPath.indexOf('/') )
		fontPath += ".ttf";

//	if ( fontPath != originalFontNameOrPath )	log("made "+fontPath+" from "+originalFontNameOrPath);

	return fontPath;
};
GL2.Text.prototype.normalizeFontPath = GL2.Text.normalizeFontPath; // instance method, too

/**
	Normalizes font names or paths to a directory-less, extension-less version.
		* Safe to pass an already-normalized name in (you'll just get it back).
	Useful for comparing if a given font family is functionally the same.
	More-or-less the opposite of GL2.Text.normalizeFontPath.
*/
GL2.Text.normalizeFontName = function normalizeFontName(/**String*/ originalFontPathOrName)
{
	var fontName = originalFontPathOrName;

	// there should be no slashes in a non-path; grab everything after the last one
	var lastSlashPos = fontName.lastIndexOf('/');
	if (lastSlashPos >= 0)
		fontName = fontName.substr(lastSlashPos + 1); // after the slash, to the end

	// dots can exist in the file name and extensions can vary in length (and technically have multiple dots), so we'll just check for known font extensions

	var ttfExtension = ".ttf";
	if (fontName.match(new RegExp(ttfExtension+"$")))
		fontName = fontName.substr(0, fontName.length - ttfExtension.length); // from the beginning, up to (not including) the extension

	//if (fontName != originalFontPathOrName)	log("made "+fontName+" from "+originalFontPathOrName);

	return fontName;
},
GL2.Text.prototype.normalizeFontName = GL2.Text.normalizeFontName; // instance method, too

GL2.Text.prototype.Text_setFontFamily = GL2.Text.prototype.setFontFamily;	// prepare for inheritance
GL2.Text.prototype.setFontFamily = function GL2Extensions_setFontFamily(fontFamily)
{
	// assume all fonts from from Manifest.
	// WARNING: on iOS, this might be Bundled!  If you crash, that's why.
	this.setFontLocation(GL2.Text.FontLocation.Manifest);

	// is this a full path? if not, add require_d parts.
	var	was = fontFamily;
	fontFamily = this.normalizeFontPath(fontFamily);

	if ( !validFonts )
	{
		// just have super handle it.
		return this.Text_setFontFamily( fontFamily );
	}

	// look for the font in our list. if it isn't, use the first one.
	for ( var k in validFonts )
	{
		if ( k == "default" )
			continue;

		if ( fontFamily.indexOf(k) >= 0 )
		{
			// valid, let it pass.
			return this.Text_setFontFamily( fontFamily );
		}
	}

	// did not pass. take first font we find and use it as a substitute.
//	log("used default font");
	return this.Text_setFontFamily( validFonts["default"] );
}

GL2.Text.prototype.Text_setFontSize = GL2.Text.prototype.setFontSize;	// prepare for inheritance
GL2.Text.prototype.setFontSize = function(wantSize)
{
	if ( !validFonts )
	{
		// just have super handle it.
		return this.Text_setFontSize( wantSize );
	}

	// find this font's entry in the font table
	fontFamily = this.getFontFamily();
	var	info;
	for ( var k in validFonts )
	{
		if ( k == "default" )
			continue;

		if ( fontFamily.indexOf(k) >= 0 )
		{
			info = validFonts[k];
			break;
		}
	}

	var	baseSize = wantSize;
	if ( info )
	{
		// what's the nearest font size larger than desired?
		// Anything larger than the biggest size will use the requested value directly.
		for ( var i=0; i<info.length; i++ )
		{
			if ( info[i] >= wantSize )
			{
				baseSize = info[i];
				break;
			}
		}
	}
	// else how did we get a font not in the list?!?!

	if ( baseSize != wantSize )
	{
	//	log("baseSize:"+baseSize+" wantSize:"+wantSize);

		// scale the object so it works out the same visual size.
		var	scale = wantSize / baseSize;
		this.setScale( scale, scale );
		this._scaleSize = true;
	}

	return this.Text_setFontSize( wantSize );
},



GL2.Text.prototype.Text_transformChanged = GL2.Text.prototype.transformChanged;	// prepare for inheritance
GL2.Text.prototype.transformChanged = function()
{
	// call super...
	this.Text_transformChanged();

	if ( !this._frame )
		return;

	// update our size to match.
	this.setSize( this.getScaledSize() );

	// update our debug frame, if any.
	if ( SHOW_TEXT_FRAMES )
	{
		if ( this._debugFrame == NULL )
		{
			this._debugFrame = (new GL2.Sprite).init();
			this._debugFrame.setImage( "ngCrunch/XibSupport/standin.png", this._frame.getSize(), [.5,.5] );
			this.addChild( this._debugFrame );
		}
		this._debugFrame.setFrame( this.getBounds() );
	}
}

GL2.Text.prototype._toString = function()
{
	var	text = this.getText();
	if ( text && text.length > 40 )
		text = text.substr( 0, 40 ) + "...";
	return "text:"+text;
}

GL2.Text.prototype._showTree = function( ret )
{
	var	text = this.getText();
	if ( text && text.length > 40 )
		text = text.substr( 0, 40 ) + "...";
	ret.text = text;
}


// make it so that someone passing a number/integer will be converted to a string for display.
// Otherwise setText(0) results in an empty string instead of "0" onscreen.
GL2.Text.prototype.Text_setText = GL2.Text.prototype.setText;	// prepare for inheritance
GL2.Text.prototype.setText = function( text )
{
	// is it a number?
	if ( text != undefined && typeof( text.toPrecision ) == 'function' )
		text = text.toString();

	// call it.
	this.Text_setText( text );
}


/**
	Calculate how many pixels wide the current string/font/size will take onscreen.
	Does not take into account any Node scaling (of this node or parent).
	Right now this is more of a guess, since the native side does not have this ability.
*/
GL2.Text.prototype.calculateWidth = function() /**int*/
{
	// we're gonna flub this right now.  In near future, we can switch based on font family
	// and scale based on size for a more accurate calculation.
	// Ideally we'll get ngCore to do this natively.

	// Right now this is being used on a Futura Medium 18, for a bunch of numbers only
	return this.getText().length * 9;
}



GL2.TouchTarget.prototype.Node_init = GL2.TouchTarget.prototype.init;	// prepare for inheritance
GL2.TouchTarget.prototype.init = function()
{
	this.Node_init();

	// set require_d settings
	this.setAnchor(.5,.5);

	return this;
}

GL2.TouchTarget.prototype.Node_transformChanged = GL2.TouchTarget.prototype.transformChanged;	// prepare for inheritance
GL2.TouchTarget.prototype.transformChanged = function()
{
	// call super...
	this.Node_transformChanged();

	if ( !this._frame )
		return;

	// update our size to match.
	this.setSize( this.getScaledSize() );
}

; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/nodeExtensions'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/nodeExtensions'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/nodeExtensions'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/nodeExtensions.js';

/*
 *  nodeExtensions.js
 *  poker
 *
 *  Created by Dennis on 11/17/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;



/**
	Move nodes "out of the way" of a given rectangle area.
	It will shift all the node frames so that the rectangular area is 'empty'.
*/
moveNodesToExposeArea = function( 
	/**Core.Rect*/ areaToClear,
	/**Array[GL2.Node]*/ nodesToMove )
{
	for ( var i=0; i<nodesToMove.length; i++ )
	{
		var	node = nodesToMove[i];
		var	frame = node._frame;
		if ( !frame )
			continue;	// not a ngCrunch node.
			
		// intersect at all?
		if ( frame.getMaxX() <= areaToClear.getMinX() )
			continue;
		if ( frame.getMinX() >= areaToClear.getMaxX() )
			continue;
		if ( frame.getMaxY() <= areaToClear.getMinY() )
			continue;
		if ( frame.getMinY() >= areaToClear.getMaxY() )
			continue;
		
		// what are the overlaps?
		var	top=0, left=0, right=0, bottom=0;
		if ( frame.getMaxX() > areaToClear.getMaxX() && frame.getMinX() > areaToClear.getMinX() )
			right = areaToClear.getMaxX() - frame.getMinX();
		if ( frame.getMinX() < areaToClear.getMinX() && frame.getMaxX() < areaToClear.getMaxX() )
			left = frame.getMaxX() - areaToClear.getMinX();
		if ( frame.getMaxY() > areaToClear.getMaxY() && frame.getMinY() > areaToClear.getMinY() )
			bottom = areaToClear.getMaxY() - frame.getMinY();
		if ( frame.getMinY() < areaToClear.getMinY() && frame.getMaxY() < areaToClear.getMaxY() )
			top = frame.getMaxY() - areaToClear.getMinY();
		
	//	log(left+", "+right+"  "+top+", "+bottom+" for "+node);
		
		// less than 0 on each means no overlap.
		top = Math.max( top, 0 );
		left = Math.max( left, 0 );
		right = Math.max( right, 0 );
		bottom = Math.max( bottom, 0 );
		
		// if there is an overlap of *both* sides, do nothing on that side
		if ( right && left )
			right = left = 0;
		if ( top && bottom )
			top = bottom = 0;
		
		// get shift values.
		var	off = new Core.Point( right? right:-left, bottom? bottom:-top );
		
		// move it.
		node.setFrame( new Core.Rect( frame.getOrigin().add(off), frame.getSize() ) );
	}
}
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/TEXT'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/TEXT'] || {}; $MODULE_REGISTRY['ngCrunch/TEXT'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/TEXT.js';

/*
 *  TEXT.js
 *  Blackjack
 *
 *  Created by Dennis on 4/5/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core  = require('NGCore/Client/Core').Core;

var	readOptions = NULL;

/** 
	@name TEXT
	@class
*/
exports.TEXT = Core.Class.singleton(
{
	classname: 'TEXT',
	
	/**
		Load a file from the local Contents directory into a buffer.
		This is an async operation, so you must pass a closure to call when loading is done.
		If there was an error, 'data' will be undefined.
		This is a static method, you don't need to allocate a Loader object.
		@example
// this is if you're calling from a method of a class
TEXT.loadFile( "Contents/thing.txt", (function(data){ processData(data); }).bind(this));
		@function
		@name loadFile
		@memberOf TEXT
	*/
	loadFile:	function( /**string*/ inPath, /**function*/inClosure )
	{
		if ( _FLASH )
		{
			// DDP network request is necessary right now because Storage.FileSystem.readFile 
			// does not yet work in flash.
			var xhttp=new XMLHttpRequest();
			xhttp.onload = function(){
				inClosure( xhttp.responseText );
			};
			xhttp.onerror = function(){
				inClosure( NULL );
			};
			xhttp.open("GET",inPath,true);
			xhttp.send();
			return;
		}
		
		// in ngCore 1.3.5+, there is now an options block that we can set to 
		// nonblocking mode.  But we have to check which SDK we're on first.
		if ( readOptions == NULL )
		{
			var	useNew = false;
			var	rev = Core.Capabilities.getBinaryVersion();
			var	orgRev = rev;
			if ( parseFloat(rev) > 1.3 )
				useNew = true;
			else {
				// require_ 1.3.5.
				rev = rev.replace(/.*?1\.3\./,"");
				NgLogD("trimmed rev:"+rev);
				if ( parseFloat(rev) >= 5 )
					useNew = true;
			}
			
			NgLogD("TEXT.loadFile using "+(useNew?"current":"legacy")+" readFile support for ngCore "+orgRev);
			if ( useNew )
				readOptions = { blocking:false, binary:false };
			else
				readOptions = false;
		}
		
		// the 'normal' way it should be done.
		Storage.FileSystem.readFile( inPath, readOptions, function(err,data)
		{
			if ( err || data == NULL )
				inClosure( NULL );
			else
				inClosure( data );
		});
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/XML'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/XML'] || {}; $MODULE_REGISTRY['ngCrunch/XML'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/XML.js';

/*
 *  XML.js
 *  Blackjack
 *
 *  Created by Dennis on 4/5/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core  = require('NGCore/Client/Core').Core;
var TEXT  = require('ngCrunch/TEXT').TEXT;

/** 
	@name XML
	@class
*/
exports.XML = Core.Class.singleton(
{
	classname: 'XML',
	
	/**
		Load a file from the local Contents directory into a buffer.
		This is an async operation, so you must pass a closure to call when loading is done.
		If there was an error, 'data' will be undefined.
		This is a static method, you don't need to allocate a Loader object.
		@example
// this is if you're calling from a method of a class
XML.loadFile( "Contents/thing.xml", (function(data){ processData(data); }).bind(this));
		@function
		@name loadFile
		@memberOf XML
	*/
	loadFile:	function( /**string*/ inPath, /**function*/inClosure )
	{
/*		if ( _FLASH )
		{
			// DDP network request is necessary right now because Storage.FileSystem.readFile 
			// does not yet work in flash.
			var xhttp=new XMLHttpRequest();
			xhttp.onload = function(){
				inClosure( xhttp.responseXML );
			};
			xhttp.onerror = function(){
				inClosure( NULL );
			};
			xhttp.open("GET",inPath,true);
			xhttp.send();
			return;
		}
*/		
		// we can use the plain loadFile for this, since it has to be xml parsed anyway.
		TEXT.loadFile( inPath, function(data)
		{
			// deal with error
			if ( !data )
			{
				inClosure(NULL);
				return;
			}
			
			inClosure( exports.XML.parseText( data ) );
		});
	},
	
	/**
		Parse a block of text as an XML object set, return the root (or NULL on error)
	*/
	parseText:	function( /**string*/ data ) /**Object*/
	{
		//Drop-in JS parser replacement
		var xmlDoc = new REXML(data);
		
		exports.XML.preprocessElements(xmlDoc.rootElement);
		
		return xmlDoc.rootElement;
	},
	
	/**
		Postpass to establish convenience accessors expected by loader
		@private
	*/
	preprocessElements: function(/**REXML*/node)
	{
//		node.nodeName = node.name;
//		node.nodeValue = node.text;
		//parse all attributes for this node, apply them as properties
		if(node)
		{
			if(node.attributeString)
			{
				//use JSXML to extract all attributes as key/value arrays
				// Call the following method with "node" as "this".
				JSXMLBuilder_XMLElement_parseAttributes.call( node );
				
				//dump them into node properties like we expect
				var attributeArray = node.attributes;
				if(attributeArray)
				{
					// convert the array-based list to a property-based list.
					if ( attributeArray.length )
						node.attributes = {};
					for(var i=0;i<attributeArray.length;i++)
					{
						if(attributeArray[i][0] && attributeArray[i][1] && 
							attributeArray[i][0] != undefined && attributeArray[i][1] != undefined &&
							attributeArray[i][0] != "undefined" && attributeArray[i][1] != "undefined" )
						{
							node.attributes[attributeArray[i][0]] = { 
								text:attributeArray[i][1]
							}; 
						}
					}
				}
				delete node.attributeString;	// remove extra data from tree, save RAM
			}
			
			if(node.childElements)
			{
				if(node.childElements.length==0)
				{
		//			node.firstElementChild = NULL;
		//			node.childNodes = new Array();				//must be present!
				}
				else
				{
		//			node.firstElementChild = node.childElements[0];
		//			node.childNodes = node.childElements;
					
					for(var i=0;i<(node.childElements.length-1);i++)
					{
		//				node.childElements[i].nextElementSibling=node.childElements[i+1];
						exports.XML.preprocessElements(node.childElements[i]);
					}
					exports.XML.preprocessElements(node.childElements[node.childElements.length-1]);
				}
			}
		}
	},
	
	
	// DDP this really doesn't belong here. Is someone using this?
	parse: function(parseMe)
	{
		return new REXML(parseMe);
	},
	
	
	_serializeNodeToJSON:	function( inNode, outNode )
	{
		// serialize self. leave out functions.
		for ( var k in inNode )
		{
			if ( typeof(inNode[k]) == 'function' )
				continue;
			
			// special case.  prevent cyclic references
			if ( k == "parentElement" )
				continue;
			
			// copy across
			outNode[k] = inNode[k];
		}
		
		// search children.
		if ( inNode.childElements )
		{
			outNode.childElements = [];
			for ( var i=0; i<inNode.childElements.length; i++ )
			{
				var	out = {};
				exports.XML._serializeNodeToJSON( inNode.childElements[i], out );
				outNode.childElements.push(out);
			}
		}
	},
	
	/**
		convert an xml doc to json format.
		pass the root node, it'll return json string.
		
		There are some limitations with this method:
		<li> no per-node functions, like getText(), childElement(), or getAttributes().
		<li> node.parentElement is not supported. Doesn't allow going back up the tree.
	*/
	serializeToJSON:	function( rootNode )
	{
		var	out = {};
		exports.XML._serializeNodeToJSON( rootNode, out );
		return JSON.stringify(out);
	},
	
	// take a deserialized json object and add any methods we had to strip for json serialization
	deserializeJSON:	function( rootNode )
	{
		// DDP should put back parentNode, but nobody's using it right now.
	},
});


//////     JSXML XML Tools - REXML                /////////////
//////     Regular Expression-based XML parser    /////////////
//////     Ver 1.2 Jun 18 2001                    /////////////
//////     Copyright 2000 Peter Tracey            /////////////
//////     http://jsxml.homestead.com/            /////////////

function REXML(XML) {
	this.XML = XML;

	this.rootElement = null;

	this.parse = REXML_parse;
	if (this.XML && this.XML != "") this.parse();
}

	function REXML_parse() {
		var reTag = new RegExp("<([^>/ ]*)([^>]*)>","g"); // matches that tag name $1 and attribute string $2
		var reTagText = new RegExp("<([^>/ ]*)([^>]*)>([^<]*)","g"); // matches tag name $1, attribute string $2, and text $3
		var strType = "";
		var strTag = "";
		var strText = "";
		var strAttributes = "";
		var strOpen = "";
		var strClose = "";
		var iElements = 0;
		var xmleLastElement = null;
		if (this.XML.length == 0) return;
		var arrElementsUnparsed = this.XML.match(reTag);
		var arrElementsUnparsedText = this.XML.match(reTagText);
		var i=0;
		if (!arrElementsUnparsed ) return;
		if(arrElementsUnparsed[0])
		{
			if (arrElementsUnparsed[0].replace(reTag, "$1") == "?xml") i++;
		}

		for (; i<arrElementsUnparsed.length; i++) {
			if(arrElementsUnparsed[i])
				strTag = arrElementsUnparsed[i].replace(reTag,"$1");
			if(arrElementsUnparsed[i])
				strAttributes = arrElementsUnparsed[i].replace(reTag,"$2");
			if(arrElementsUnparsedText[i])
			{
				if(arrElementsUnparsedText[i].replace(reTagText,"$3"))
				{
					strText = arrElementsUnparsedText[i].replace(reTagText,"$3").replace(/[\r\n\t ]+/g, " "); // remove white space
				}
			}
			strClose = "";
			if (strTag.indexOf("![CDATA[") == 0) {
				strOpen = "<![CDATA[";
				strClose = "]]>";
				strType = "cdata";
			} else if (strTag.indexOf("!--") == 0) {
				strOpen = "<!--";
				strClose = "-->";
				strType = "comment";
			} else if (strTag.indexOf("?") == 0) {
				strOpen = "<?";
				strClose = "?>";
				strType = "pi";
			} else strType = "element";
			if (strClose != "") {
				strText = "";
				if (arrElementsUnparsedText[i].indexOf(strClose) > -1) strText = arrElementsUnparsedText[i];
				else {
					for (; i<arrElementsUnparsed.length && arrElementsUnparsedText[i].indexOf(strClose) == -1; i++) {
						strText += arrElementsUnparsedText[i];
					}
					strText += arrElementsUnparsedText[i];
				}
				if (strText.substring(strOpen.length, strText.indexOf(strClose)) != "")	{
					xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement(strType, "","",xmleLastElement,strText.substring(strOpen.length, strText.indexOf(strClose)));
										
					if (strType == "cdata") xmleLastElement.text += strText.substring(strOpen.length, strText.indexOf(strClose));
				}
				if (strText.indexOf(strClose)+ strClose.length < strText.length) {
					xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement("text", "","",xmleLastElement,strText.substring(strText.indexOf(strClose)+ strClose.length, strText.length));
					
					if (strType == "cdata") xmleLastElement.text += strText.substring(strText.indexOf(strClose)+ strClose.length, strText.length);
				}
				continue;
			}
			if (strText.replace(/ */, "") == "") strText = "";
			if(arrElementsUnparsed[i])
			{
				if (arrElementsUnparsed[i].substring(1,2) != "/") {
					if (iElements == 0) {
						xmleLastElement = this.rootElement = new REXML_XMLElement(strType, strTag,strAttributes,null,strText);
						iElements++;
						if (strText != "")
						{
							xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement("text", "","",xmleLastElement,strText);
						}
						
					} else if (arrElementsUnparsed[i].substring(arrElementsUnparsed[i].length-2,arrElementsUnparsed[i].length-1) != "/") {
						xmleLastElement = xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement(strType, strTag,strAttributes,xmleLastElement,strText);
						iElements++;
						if (strText != "")
						{
							xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement("text", "","",xmleLastElement,strText);
						}
					} else {
						xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement(strType, strTag,strAttributes,xmleLastElement,strText);
						if (strText != "")
						{
							xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement("text", "","",xmleLastElement,strText);
						}
					}
				} else {
					if(xmleLastElement.parentElement)
					{
						xmleLastElement = xmleLastElement.parentElement;
						iElements--;
						if (xmleLastElement && strText != "") {
							xmleLastElement.text += strText;
							//xmleLastElement.childElements[xmleLastElement.childElements.length] = new REXML_XMLElement("text", "","",xmleLastElement,strText);
						}
					}
				}
			}
		}
	}

	function REXML_XMLElement(strType, strName, strAttributes, xmlParent, strText) {
		this.type = strType;
		//log("--- XMLELEMENT: " + strType + " --- " + strName + " --- " + strAttributes + " --- " + xmlParent + " --- " + strText);
		// KJB Check for namespace
		var namespaceCheck = strName.split(":");
		this.name = strName;
		if(namespaceCheck.length > 1)
		{
			this.namespace = namespaceCheck[0];
			this.actualName = namespaceCheck[1];
		}
		else
		{
			this.namespace = null;
			this.actualName = namespaceCheck[0];
		}
		
		this.attributeString = strAttributes;
		this.attributes = null;
		this.childElements = new Array();
		this.parentElement = xmlParent;
		this.text = strText; // text of element

		this.getText = REXML_XMLElement_getText; // text of element and child elements
		this.childElement = REXML_XMLElement_childElement;
		this.getChildren = REXML_XMLElement_getChildren;
		this.attribute = REXML_XMLElement_attribute;
		this.getAttributes = REXML_XMLElement_getAttributes;
		this.getAllChildren = REXML_XMLElement_getAllChildren;
	}

		function REXML_XMLElement_getText() {
			if (this.type == "text" || this.type == "cdata") {
				return this.text;
			} else if (this.childElements.length) {
				var L = "";
				for (var i=0; i<this.childElements.length; i++) {
					L += this.childElements[i].getText();
				}
				return L;
			} else return "";
		}
		
		function REXML_XMLElement_childElement(strElementName) {
			for (var i=0; i<this.childElements.length; i++) if (this.childElements[i].name == strElementName) return this.childElements[i];
			return null;
		}
		
		function REXML_XMLElement_getAllChildren()
		{
			return this.childElements;
		}
		
		function REXML_XMLElement_getChildren(strElementName)
		{
			var children = new Array();
			// KJB First check our own children
			for(var i=0;i<this.childElements.length;i++)
			{
				if(this.childElements[i].name == strElementName)
				{
					children.push(this.childElements[i]);
				}
			}
			// KJB Then recursively check our children's children
			for(var i=0;i<this.childElements.length;i++)
			{
				children = children.concat(this.childElements[i].getChildren(strElementName));
			}
			return children;
		}

		function REXML_XMLElement_attribute(strAttributeName) {
			if (!this.attributes) {
				var reAttributes = new RegExp(" ([^= ]*)=","g"); // matches attributes
				if (this.attributeString.match(reAttributes) && this.attributeString.match(reAttributes).length) {
					var arrAttributes = this.attributeString.match(reAttributes);
					if (!arrAttributes.length) arrAttributes = null;
					else for (var j=0; j<arrAttributes.length; j++) {
						arrAttributes[j] = new Array(
							(arrAttributes[j]+"").replace(/[= ]/g,""),
							ParseAttribute(this.attributeString, (arrAttributes[j]+"").replace(/[= ]/g,""))
										);
					}
					this.attributes = arrAttributes;
				}
			}
			if (this.attributes) for (var i=0; i<this.attributes.length; i++) if (this.attributes[i][0] == strAttributeName) return this.attributes[i][1];
			return "";
		}
		
		function REXML_XMLElement_getAttributes(strAttributeName)
		{
			var attrs = new Array();
			// KJB First loop through our own attributes
			for(var i=0;i<this.attributes.length;i++)
			{
				if(this.attributes[i][0] == strAttributeName)
					attrs.push(this.attributes[i][1]);
			}
			// KJB Then check the children
			for(var i=0;i<this.childElements.length;i++)
			{
				attrs.concat(this.childElements[i].attributes(strAttributeName));
			}
			return attrs;
		}

function ParseAttribute(str,Attribute) {
	var str = str +  ">";
	if (str.indexOf(Attribute + "='")>-1) var Attr = new RegExp(".*" + Attribute + "='([^']*)'.*>");
	else if (str.indexOf(Attribute + '="')>-1) var Attr = new RegExp(".*" + Attribute + '="([^"]*)".*>');
	return str.replace(Attr, "$1");
}

function JSXMLBuilder_XMLElement_parseAttributes() {
	if (!this.attributes) {
		var reAttributes = new RegExp(" ([^= ]*)=","g"); // matches attributes
		if (this.attributeString.match(reAttributes) && this.attributeString.match(reAttributes).length) {
			var arrAttributes = this.attributeString.match(reAttributes);
			if (!arrAttributes.length) arrAttributes = null;
			else for (var j=0; j<arrAttributes.length; j++) {
				arrAttributes[j] = new Array(
					(arrAttributes[j]+"").replace(/[= ]/g,""),
					ParseAttribute(this.attributeString, (arrAttributes[j]+"").replace(/[= ]/g,""))
								);
			}
			this.attributes = arrAttributes;
		}
	}
}

/**
 * XMLWriter - XML generator for Javascript, based on .NET's XMLTextWriter.
 * Copyright (c) 2008 Ariel Flesler - aflesler(at)gmail(dot)com | http://flesler.blogspot.com
 * Licensed under BSD (http://www.opensource.org/licenses/bsd-license.php)
 * Date: 3/12/2008
 * @version 1.0.0
 * @author Ariel Flesler
 * http://flesler.blogspot.com/2008/03/xmlwriter-for-javascript.html
 */

exports.XMLWriter = Core.Class.subclass(
{
	encoding:'ISO-8859-1',// what is the encoding
	version:'1.0', //what xml version to use
	formatting: 'none', //how to format the output (indented/none)  ?
	indentChar:'\t', //char to use for indent
	indentation: 1, //how many indentChar to add per level
	newLine: '\n', //character to separate nodes when formatting
	
	initialize: function(encoding, version)
	{
		if( encoding )
			this.encoding = encoding;
		if( version )
			this.version = version;
	},
	writeStartDocument:function( standalone ){
		this.close();//cleanup
		this.stack = [ ];
		this.standalone = standalone;
	},
	//get back to the root
	writeEndDocument:function(){
		this.active = this.root;
		this.stack = [ ];
	},
	//set the text of the doctype
	writeDocType:function( dt ){
		this.doctype = dt;
	},
	//start a new node with this name, and an optional namespace
	writeStartElement:function( name, ns ){
		if( ns )//namespace
			name = ns + ':' + name;
		
		var node = { n:name, a:{ }, c: [ ] };//(n)ame, (a)ttributes, (c)hildren
		
		if( this.active ){
			this.active.c.push(node);
			this.stack.push(this.active);
		}else
			this.root = node;
		this.active = node;
	},
	//go up one node, if we are in the root, ignore it
	writeEndElement:function(){
		this.active = this.stack.pop() || this.root;
	},
	//add an attribute to the active node
	writeAttributeString:function( name, value ){
		if( this.active )
			this.active.a[name] = value;
	},
	//add a text node to the active node
	writeString:function( text ){
		if( this.active )
			this.active.c.push(text);
	},
	//shortcut, open an element, write the text and close
	writeElementString:function( name, text, ns ){
		this.writeStartElement( name, ns );
		this.writeString( text );
		this.writeEndElement();
	},
	//add a text node wrapped with CDATA
	writeCDATA:function( text ){
		this.writeString( '<![CDATA[' + text + ']]>' );
	},
	//add a text node wrapped in a comment
	writeComment:function( text ){
		this.writeString('<!-- ' + text + ' -->');
	},
	//generate the xml string, you can skip closing the last nodes
	flush:function(){		
		if( this.stack && this.stack[0] )//ensure it's closed
			this.writeEndDocument();
		
		var 
			chr = '', indent = '', num = this.indentation,
			formatting = this.formatting.toLowerCase() == 'indented',
			buffer = '<?xml version="'+this.version+'" encoding="'+this.encoding+'"';
			
		if( this.standalone !== undefined )
			buffer += ' standalone="'+!!this.standalone+'"';
		buffer += ' ?>';
		
		buffer = [];
		
		if( this.doctype && this.root )
			buffer.push('<!DOCTYPE '+ this.root.n + ' ' + this.doctype+'>'); 
		
		if( formatting ){
			while( num-- )
				chr += this.indentChar;
		}
		
		if( this.root )//skip if no element was added
			format( this.root, indent, chr, buffer );
		
		return buffer.join( formatting ? this.newLine : '' );
	},
	//cleanup, don't use again without calling startDocument
	close:function(){
		if( this.root )
			clean( this.root );
		this.active = this.root = this.stack = null;
	},
});

//utility, you don't need it
function clean( node ){
	var l = node.c.length;
	while( l-- ){
		if( typeof node.c[l] == 'object' )
			clean( node.c[l] );
	}
	node.n = node.a = node.c = null;	
}

//utility, you don't need it
function format( node, indent, chr, buffer ){
	var 
		xml = indent + '<' + node.n,
		nc = node.c.length,
		attr, child, i = 0;
		
	for( attr in node.a )
		xml += ' ' + attr + '="' + node.a[attr] + '"';
	
	xml += nc ? '>' : '/>';

	buffer.push( xml );
		
	if( nc ){
		do{
			child = node.c[i++];
			if( typeof child == 'string' ){
				if( nc == 1 )//single text node
					return buffer.push( buffer.pop() + child + '</'+node.n+'>' );					
				else //regular text node
					buffer.push( indent+chr+child );
			}else if( typeof child == 'object' ) //element node
				format(child, indent+chr, chr, buffer);
		}while( i < nc );
		buffer.push( indent + '</'+node.n+'>' );
	}
}; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/JSON'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/JSON'] || {}; $MODULE_REGISTRY['ngCrunch/JSON'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/JSON.js';

/*
 *  JSON.js
 *  Blackjack
 *
 *  Created by Dennis on 4/5/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
var Core	= require('NGCore/Client/Core').Core;
var TEXT	= require('ngCrunch/TEXT').TEXT;
var XHR		= require('NGCore/Client/Network').Network.XHR;

// Doesn't actually define a new object, because JSON is a builtin.
exports.JSON = JSON;
if ( exports.JSON == undefined )
	exports.JSON = {};	// resolves something with pre.js

/** 
	@name JSON
	@class
*/

/**
	Load a file from the local Contents directory into a buffer.
	This is an async operation, so you must pass a closure to call when loading is done.
	If there was an error, 'data' will be undefined.
	This is a static method, you don't need to allocate a Loader object.
	@example
// this is if you're calling from a method of a class
JSON.loadFile( "Contents/thing.json", (function(data){ processData(data); }).bind(this));
	@function
	@name loadFile
	@memberOf JSON
*/
exports.JSON.loadFile = function( /**string*/ inPath, /**function*/inClosure )
{
	// we can use the plain loadFile for this, since it has to be parsed anyway.
	TEXT.loadFile( inPath, function(data)
	{
		// deal with error
		if ( !data )
		{
			inClosure(NULL);
			return;
		}
		
		// parse it.
		try {
			data = JSON.parse(data);
		} catch (err) {
			NgLogE("ngCrunch JSON parser: error parsing: " + err);
			data = NULL;	// to return an error.
		}
		
		// parse it.
		inClosure( data );
	});
}

/**	
*/
exports.JSON.httpRequest = function( 
	/**string*/ inUrl, 
	/**string*/ serializedData, 
	/**function(isOK, responseData)*/ callback )
{
	XHR.prototype.DONE = 4;
	XHR.prototype.OK = 200;
	
	var	req = new XHR;
	
	req.onreadystatechange = (function()
	{
		// this is the callback after the request is complete
		if ( req.readyState != req.DONE )
			return;	// don't care about anything till it's done.
		
		try {
			// all good?
			if ( req.status != req.OK )
				throw "status not OK: "+req.status;
			
			// parse the content out
			var	ret = JSON.parse( req.responseText );
			if ( typeof(ret) != 'object' )
				throw "ret isn't an object? "+typeof(ret);
			
		} catch ( err ) {
			log("error server response: "+err+" for "+inUrl);
			return callback( false, NULL );
		}
		
		return callback( true, ret );
		
	}).bind(this);
	
	log("POST to \""+inUrl+"\" with "+serializedData);
	
	// this is the rest of the callback creation.
	req.open("POST", inUrl, true );
	req.setRequestHeader("Content-Type","application/json");
	req.send( serializedData );
	return req;
}

; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/TouchListener'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/TouchListener'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/TouchListener'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/TouchListener.js';

/*
 *  TouchListener.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/25/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core  = require('NGCore/Client/Core').Core;


exports.TouchListener = Core.MessageListener.subclass(
/** @lends Xib.TouchListener.prototype */
{
	/**
		@class Mixin class to allow easy touch callbacks from within a non-MessageListener subclass.
		Assumes inOwner has a touch emitter and an 'onTouch' method which will be called.  
		Remember to destroy() this when your class is destroy()d!
		
		@constructs The default constructor.
		@augments Core.MessageListener
		@task creation
	*/
	initialize:	function( inListener, inWhoToWatch )
	{
		if ( !inWhoToWatch )
			inWhoToWatch = inListener;
			
		this._owner = inListener;
		inWhoToWatch.getTouchEmitter().addListener(this, this.onTouch, 0);
	},
	
	/**
		Forwards touch to real owner but also calls any callbacks previously set up
		for the TouchCallbackManager so that additional independent effects can
		be processed for touch events, such as visual effects.
		@private
	*/
	onTouch:	function( /**GL2.Touch*/ touch )
	{
		// MSA Send the touch event to the touch callback manager if there
		// are additional effects to process based on touch events:
		if (touch)
		{
			Xib.TouchCallbackManager.callCallbacks(touch);
		}
		
		// forward the touch back to the real owner.
		return this._owner.onTouch( touch );
	},
});

; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/Button'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/Button'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/Button'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/Button.js';

/*
 *  Button.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/21/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var GL2 = require('NGCore/Client/GL2').GL2;
var TouchListener = require('ngCrunch/Xib/TouchListener').TouchListener;

var	kDebounceTime = 500;	// (1000 = 1 second)

exports.Button = GL2.TouchTarget.subclass(
/** @lends Xib.Button.prototype */
{
	classname: 'Button',

	/**
		@class A basic button implementation
		@constructs The default constructor.
		@augments GL2.TouchTarget
		@task creation
	*/
	initialize: function()
	{
		// be prepared to handle stuff.
		this._listener = new TouchListener( this );

		// defaults
		this._enabled = true;
		this._highlighted = false;

		// keep ready
		this._lastTap = NULL;
	},

	/**
		Initialize this object with information from a xib file.
		In Interface Builder we support everything of GL2.Node.initWithXib, as well as:
		<li>Title
		<li>Image
		<li>Alt. Image
		<li>Alignment of Left, Center, or Right
		<li>Border: None only
		<li>Line Breaks: Clip or Word Wrap
		<li>Text Color
		<li>Scaling of "Axes Independantly" only

		Connections made to this button in Interface Builder as action targets will be used by doAction
		@task construction
	*/
	initWithXib:	function( $super, /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
	{
		// Call super
		$super( groupElem, inLoader );

		// set require_d settings
		this.setAnchor(.5,.5);

		this._pic = (new GL2.Sprite).init();
		this._alternatePic = (new GL2.Sprite).init();
		this._alternatePic.setDepth( 1 );
		this._pic.setDepth( 1 );
		//this.addChild( this._pic );

		//
		// iPhone version
		//

		var	group;

		group = inLoader.objectElementForKey( groupElem, "IBUINormalImage" );
		if ( group == NULL )
			group = inLoader.objectElementForKey( groupElem, "IBUINormalBackgroundImage" );
		if ( group )
			this.normalImage = inLoader.stringForKey( group, "NSResourceName" );


		group = inLoader.objectElementForKey( groupElem, "IBUISelectedImage" );
		if ( group == NULL )
			group = inLoader.objectElementForKey( groupElem, "IBUISelectedBackgroundImage" );
		if ( group )
			this.altImage = inLoader.stringForKey( group, "NSResourceName" );

		if ( inLoader.stringForKey( groupElem, "IBUINormalTitle" ) )
		{
			this._text = (new GL2.Text).init();
			this._text.initWithXib( groupElem, inLoader );
			this._text.setDepth( 2 );
			this._text.setVerticalAlign( this._text.VerticalAlign.Middle );
			this._text.setHorizontalAlign( this._text.HorizontalAlign.Center );
			this.addChild( this._text );
			this.setText( _loc( inLoader.stringForKey( groupElem, "IBUINormalTitle" ) ) );

			// if there's a color, pull it.
			var	color = inLoader.colorObjForKey( groupElem, "IBUINormalTitleColor", NULL );
			if ( color )
				this._text.setColor( color );
		}

		//
		// Cocoa version
		//

		var	cell = inLoader.objectElementForKey( groupElem, "NSCell" );
		if ( cell )
		{
			group = inLoader.objectElementForKey( cell, "NSNormalImage" );
			if ( group )
			{
				this.normalImage = inLoader.stringForKey( group, "NSResourceName" );
				if ( this.normalImage )
					this.normalImage += ".png";
			}

			group = inLoader.objectElementForKey( cell, "NSAlternateImage" );
			if ( group )
			{
				this.altImage = inLoader.stringForKey( group, "NSResourceName" );
				if ( this.altImage )
					this.altImage += ".png";
			}

			// text?
			if ( inLoader.stringForKey( cell, "NSContents" ) )
			{
				this._text = (new GL2.Text).init();
				this._text.initWithXib( groupElem, inLoader );
				this._text.setDepth( 2 );
				this.addChild( this._text );
				this._text.setColor(0,0,0);
			}
		}

		//
		// enact it
		//

		// add necessary preface strings
		if ( this.normalImage )
			this.normalImage = SpriteFolder + this.normalImage;
		if ( this.altImage )
			this.altImage = SpriteFolder + this.altImage;


		// start with normal image.
		if ( this.normalImage )
		{
			this.addChild( this._pic );
			this._pic.setVisible(true);
//			this._pic._lastImage = this.normalImage;
			this._pic.setImage( this.normalImage );
		}

		if(this.altImage)
		{
			this.addChild(this._alternatePic);
			this._alternatePic.setVisible(false);
			this._alternatePic.setImage( this.altImage );
		}

		//hide the nodes if we are hidden by default
		var flags = inLoader.intForKey(groupElem, "NSvFlags");
		if(flags & (1<<31))
		{
			this.setVisible(false);
//			this.setTouchable(false);
		}

		// update all positions.
		this.transformChanged();

		return this;
	},

	_toString:	function()
	{
		return (this.getEnabled()?"enabled ":"disabled ")+
			(this.getHighlighted()?"highlighted ":"normal ")+
			this.getText();
	},

	//setVisible override

	setVisible: function($super, /**bool*/inVisible)
	{
		$super(inVisible);
		this.setTouchable(inVisible);
	},

	/**
		enabled state
	*/
	setEnabled:	function( /**bool*/ isEnabled )
	{
		if ( this._enabled == isEnabled )
			return;

		this._enabled = isEnabled;
		this.stateChanged();
	},

	/**
		enabled state
	*/
	getEnabled:	function()	/**bool*/
	{
		return this._enabled;
	},


	/**
		highlight state
	*/
	setHighlighted:	function( /**bool*/ inHighlighted )
	{
		if ( this._highlighted == inHighlighted )
			return;
		this._highlighted = inHighlighted;
		this.stateChanged();
	},

	/**
		highlight state
	*/
	getHighlighted:	function()	/**bool*/
	{
		return this._highlighted;
	},

	/**
		subclasses can override this to use different handling of state changes
	*/
	stateChanged:	function()
	{
		if ( !this._enabled )
		{
			if ( this._pic )
			{
				this._pic.setColor( .5, .5, .5 );
				this._pic.setAlpha( .8 );
			}
			return;
		}

		if ( this.altImage )
		{
			this.setColor( 1,1,1 );
			this.setAlpha( 1 );

			if ( this._highlighted )
			{
//				this._pic._lastImage = this.altImage;
//				this._pic.setImage( this.altImage );
//				this.removeChild(this._pic);
//				this.addChild(this._alternatePic);
				this._pic.setVisible(false);
				this._alternatePic.setVisible(true);
			} else {
//				this._pic._lastImage = this.normalImage;
//				this._pic.setImage( this.normalImage );
//				this.removeChild(this._alternatePic);
//				this.addChild(this._pic);

				// no alternate image, use image darkening.
				if ( this._pic )
				{
					this._pic.setAlpha( 1 );
					if ( this._highlighted )
						this._pic.setColor( .5, .5, .5 );
					else
						this._pic.setColor( 1,1,1 );
				}

				this._pic.setVisible(true);
				this._alternatePic.setVisible(false);
			}
			return;
		}

		// no alternate image, use image darkening.
		if ( this._pic )
		{
			this._pic.setAlpha( 1 );
			if ( this._highlighted )
				this._pic.setColor( .5, .5, .5 );
			else
				this._pic.setColor( 1,1,1 );
		}
	},

	// override transformChanged to keep our subobjects maintained.
	transformChanged:	function( $super )
	{
		$super();

		// update our size to match.
		this.setSize( this._frame.getSize() );

		// update positions of our subobjects.  doing it in initFromXib() is not enough.
		var	bounds = this.getBounds();
		if ( this._pic )
			this._pic.setFrame( bounds );
		if ( this._alternatePic )
			this._alternatePic.setFrame( bounds );
		if ( this._text )
			this._text.setFrame( bounds );
	},

	// a touch was found on us.  what now?
	onTouch:	function( /**GL2.Touch*/ touch )
	{
		if ( !this._enabled )
			return false;
		if ( !this.getVisible() )
			return false;

//		log("root:"+GL2.Root.toString());
//		var localPos = this.screenCoordinatesToLocal(touch.getPosition());

//		log("touched inside button: "+localPos.toString());

		switch ( touch.getAction() )
		{
			case GL2.Touch.Action.Start:
				this.setHighlighted(true);
                SoundManager.playSound(SoundManager.CLICK);
				this._trackingId = touch.getId();
				break;

			case GL2.Touch.Action.Move:
				if(this._trackingId != touch.getId())
					return;

				this.setHighlighted( touch.getIsInside(this) );
				break;

			case GL2.Touch.Action.End:
				if(this._trackingId != touch.getId())
					return;

				this._trackingId = undefined;
				this.setHighlighted(false);
				if ( touch.getIsInside(this) )
					this.doActionWithDebounce();
				break;

			default:
				return false;	// we don't know this event. ignore it.
		}

		return true;			//ML: Claim this event so we are the target of subsequent move and end messages
	},

	// internal: do action, with debounce
	doActionWithDebounce:	function()
	{
		// debounce the action.  If it's been tapped within x time, don't re-hit it.
		var	was = this._lastTap;
		this._lastTap = new Date;	// update automatically.
		if ( was )
		{
			if (( this._lastTap - was ) < kDebounceTime )
				return;
		}

		this.doAction();
	},

	/**
		do our selector.
	*/
	doAction:	function()
	{
		if ( !this._target )
			return;

		// create and call: this._target._selector( this );
		var	call = "this._target."+this._selector+"( this );";
		eval(call);
	},

	/**
		Set the target and action.
		The target object should have a method named same as the string action passed in.
		Expect one parameter - the calling button.
	*/
	setTargetAction:	function( target, actionProcName )
	{
		this._target = target;
		this._selector = actionProcName;
	},

	getTarget:	function()
	{
		return this._target;
	},

	getAction:	function()
	{
		return this._selector;
	},

	connectFromXib:	function( /**Object*/ inThing, /**string*/ inConnectionName )	/**bool*/
	{
		this._target = inThing;
		this._selector = inConnectionName.replace(":","");	// remove trailing colon
		return true;
	},

	/**
		Change the name of the button.
		@task Configuration
	*/
	setText: function(/**String*/newText)
	{
		if(!this._text)
		{
			this._text = (new GL2.Text).init();
			this._text.init();
			this._text.setFrame(this.getBounds())
			this._text.setDepth( 2 );
			this.addChild( this._text );
			this._text.setColor(0,0,0);
		}

		this._text.setText(newText);
	},

	/**
		Get the name of the button.
		@task Configuration
	*/
	getText: function()
	{
		if(this._text!=NULL)
			return this._text.getText();
		else
			return "";
	},

	/**
		Changes the alpha of the button's image, if there is one
		@task Configuration
	*/
	setAlpha: function(/**Number*/newAlpha)
	{
		if(this._pic != NULL)
			this._pic.setAlpha(newAlpha);
	},

	/**
		Get the alpha of the button's image, if there is one
	*/
	getAlpha: function()
	{
		if(this._pic != NULL)
			return this._pic.getAlpha();
		return 0;
	},

	/**
		Change the image of the button.
		@task Configuration
	*/

	setImage: function(/**String*/newImage)
	{
		if(!this.normalImage)
			this.addChild( this._pic );		//if we did not have a defined normalImage before then the sprite was not shown
		this.normalImage = newImage;
		this._pic.setImage(newImage);
	},

	/**
		Retrieve the image of the button.
		@task Configuration
	*/
	getImage: function()
	{
		return this._pic.getImage();
	},

	/**
		Change the alt/highlighted image of the button.
		@task Configuration
	*/

	setAltImage: function(/**String*/newImage)
	{
		this.altImage = newImage;
	},

	/**
		Retrieve the alt/highlighted image of the button.
		@task Configuration
	*/
	getAltImage: function()
	{
		return this.altImage;
	},

	/**
		Retrieve the name of the function we invoke
		User code should probably not mess with this
		@private
	*/
	getSelector: function()
	{
		return this._selector;
	},

	/**
		Retrieve the sprite used to display the button's normal state.
		@task Configuration
	*/

	getSprite: function()
	{
		return this._pic;
	},


	/**
		Retrieve the sprite used to display the button's depressed state
		@task Configuration
	*/

	getAltSprite: function()
	{
		return this._alternatePic;
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/ViewController'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/ViewController'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/ViewController'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/ViewController.js';

/*
 *  ViewController.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/23/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core		= require('NGCore/Client/Core').Core;
var GL2			= require('NGCore/Client/GL2').GL2;
var Loader		= require('ngCrunch/Xib/Loader').Loader;
var Navigation	= require('ngCrunch/Xib/Navigation').Navigation;

exports.ViewController = Core.MessageListener.subclass(
/** @lends Xib.ViewController.prototype */
{
	classname: 'ViewController',

	/**
		@class Manages a single game screen.
		@constructs The default constructor.
		@task creation
	*/
	initialize: function()
	{
		this._wantDestroyForNavigation = true;
		this.view = NULL;
		this._isOpaque = false;
		this.allowPassthrough = false;
		this._animators = [];
		this._delayDisplay = false;
		this._autoExposeMobageButton = false;
		
		// being visible is *not* the same as being attached to GL2.Root.
		// When first being created, the views are added to GL2.Root but the priority
		// is set far below the root view to make it invisible.
		// Only when it's loaded and ready do we move it into view.
		this._visible = false;
		
		// this indicates it is in the GL2.Root tree.
		this._isRendering = false;
	},
	
	/**
		standard setup, if you will be managing the view yourself.
		@task creation
	*/
	initWith:	function( /**bool*/inFullscreenOpaque )
	{
		this._isOpaque = inFullscreenOpaque;
		this.allowPassthrough = false;
		return this;
	},
	
	/**
		standard setup, if you want automatic view management.
		@task creation
	*/
	initWithXib:	function( /**string*/inXibPath, /**bool*/inFullscreenOpaque)
	{
		this._xibPath = inXibPath;
		this._isOpaque = inFullscreenOpaque;
		this.allowPassthrough = false;
		return this;
	},
	
	/**
		destroy a complete view/Node tree
		@private
	*/
	destroyNodeTree:	function(root)
	{
		// the base GL2.Node.destroy() only handles self.  Children are ignored.
		// This version recurses the whole thing.
		var	list = root.getChildren().slice(0);	// be sure to duplicate the list
		for ( var i=0; i<list.length; i++ )
			this.destroyNodeTree(list[i]);
		
		// finally, dump root.
	//	log("destroying... "+root.classname);
		root.destroy();
	},
	
	/**
		The default destructor. 
		@task creation
	*/
	destroy:	function()
	{
		// and destroy our view.	
		this.setView(NULL);			
	},
	
	/**
		Called when Navigation is done with this controller.
		@private
	*/
	_destroyForNavigation:	function()
	{
		if ( this._wantDestroyForNavigation )
			this.destroy();
	},
	
	/**
		Set whether this controller should be destroyed when Navigation is done with it.
		Default is true.
		@task creation
	*/
	setDestroyByNavigation:	function( /**bool*/ value )
	{
		this._wantDestroyForNavigation = value;		
	},

	/**
		Set whether this controller should be destroyed when Navigation is done with it.
		Default is true.
		@task creation
	*/
	getDestroyByNavigation:	function() /**bool*/
	{
		return this._wantDestroyForNavigation;
	},
	
	/**
		Is this view expected to cover the entire screen so that views behind it cannot be seen?
		@task Memory management
	*/
	isFullscreenOpaque:	function()	/**bool*/
	{
		return this._isOpaque;
	},
	
	/**
		Is this view expected to cover the entire screen so that views behind it cannot be seen?
		@task Memory management
	*/
	setIsFullscreenOpaque:	function( /**bool*/ value )
	{
		this._isOpaque = value;
	},
	
	/**
		Gets the current view.  Loads it if not there.
		@task Managing the View
	*/
	getView:	function() /**GL2.Node*/
	{
		if ( this.view == NULL )
			this.loadView();
		return this.view;
	},
	
	/**
		Sets the current view.  Should only be called within loadView().
		@task Managing the View
	*/
	setView:	function( /**GL2.Node*/ inView ) 
	{
		// deal with special case of a xib load happening async.
		if ( this._isLoadingXib )
		{
			if ( inView == NULL )
				return;	// um, what?
			
			//
			// the view we have right now is the one we keep.  the incoming view's data
			// needs to be transferred to our existing view.
			//
			
			// transfer view information.
			this.view.setTag( inView.getTag() );
			
			// We change the incoming view, to properly let child views deal with
			// changes to size.  Well, if the view's frame was set properly...
			if ( this.view.getFrame().getSize().getWidth() > 0 )
				inView.setFrame( this.view.getFrame() );
			else
				this.view.setFrame( inView.getFrame() );				
			
			// transfer child nodes across
			var	list = inView.getChildren();
			for ( var i=0; i<list.size(); i++ )
			{
				var	v = list[i];
				inView.removeChild( v );
				this.view.addChild( v );
			}
			
			// delete the incoming view, we don't need it anymore.
			inView.destroy();
			
			// send notifications.
			// No!  We do *not* send notification, because the entire view is not yet loaded.
			// Waits for parseXib closure for that.
		//	this.viewDidLoad();	
			
			// heroic task complete!
			return;	
		}
		
		//
		// normal changing of the views.
		//
		if ( this.view )
		{
			this.destroyNodeTree( this.view );
			this.viewDidUnload();
		}
		
		this.view = inView;
		if ( this.view )
			this.viewDidLoad();		
	},

	/**
		Is our view loaded?  Does not load it if not there.
		@task Managing the View
	*/
	isViewLoaded:	function()	/**bool*/
	{
		return this.view != NULL && (!this._isLoadingXib);
	},
	
	/**
		Loads our view.  If you initWithXib, will load it.
		Otherwise subclasses must override this to provide the view.
		@task Managing the View
	*/
	loadView:	function()
	{
		// clear previous if any. which shouldn't really be possible, but just in case.
		if ( this.view )
		{
			this.view.destroy();
			this.viewDidUnload();
		}
		this.view = NULL;
		this._delayDisplay = false;
		
		// default implementation
		if ( this._xibPath )
		{
			// create a default node object that we can immediately return, while
			// we wait for the loader to finish it's job.
			this.view = new GL2.Node;
			this.view.init();
			this._isLoadingXib = true;
			
			// start the loader
			var	loader = new Loader();
			loader.parseXib( this._xibPath, this, this, function(isOk){ 
				
				//If we failed to load the xib, barf
				if(!isOk)
					throw new Error("Failed to load xib "+this._xibPath);
				
				//enable depth grouping
				this.view.setChildrenDepthGrouped(true);
				
				// turn off hack flag
				this._isLoadingXib = false;
				
				// notify caller we're good
				this.viewDidLoad();
				
				// fix mobage button
				if ( this._autoExposeMobageButton )
					this.exposeMobageButton();
				
				// did the caller delay loading?
				if ( !this._delayDisplay )
					this.readyToDisplay();
				
			}.bind(this));
		}
	},
	
	// Add a callback that will be called when our view is ready for display.
	// If we already have a view, will be called next frame.
	// @private
	addLoadedCallback:	function( /**function*/ callback )
	{
		if ( this.isViewLoaded() )
		{
			invokeAfterDelay( 0, callback );
			return;
		}
		
		// 'store' the request for processing when loading is done.
		if ( this._pendingNotifications == NULL )
			this._pendingNotifications = new Array;
		this._pendingNotifications.push( {
			proc:this._someoneElsesCallback,
			param:callback
		});		
	},
	
	_someoneElsesCallback:	function( callback )
	{
		callback();
	},
	
	// Make sure the view is actually loaded before sending the notification.
	// private method for Navigation.
	// @private
	viewWillAppear_:	function(/**bool*/ inWillBeAnimated )
	{
		if ( !this._isLoadingXib )
		{
			// normal. just passthrough
			this.viewWillAppear( inWillBeAnimated );
			Core.UpdateEmitter.addListener(this, this._updateFrame, 0);
			return;
		}
		
		// 'store' the request for processing when loading is done.
		if ( this._pendingNotifications == NULL )
			this._pendingNotifications = new Array;
		this._pendingNotifications.push( {
			proc:this.viewWillAppear_,
			param:inWillBeAnimated
		});
	},
	
	Center_: function Center_()
	{
		if(!this._isLoadingXib)
		{
			this.Center();
			return;
		}
		else
		{
			if(this._pendingNotifications==NULL)
				this._pendingNotifications = new Array;
			
			this._pendingNotifications.push( {
				proc:this.Center,
				param: NULL,
			});
		}
	
	},
	
	Center: function Center()
	{
		//Resize the new view to completely cover the screen
		var width = Core.Capabilities.getScreenWidth();
		var height = Core.Capabilities.getScreenHeight();
		
		var internalWidth = this.getView().getFrame().getSize().getWidth();
		var internalHeight = this.getView().getFrame().getSize().getHeight();
		this.getView().setFrame(new Core.Rect([(width/2) - (internalWidth/2), (height/2)-(internalHeight/2)], [internalWidth, internalHeight]));	
	},
	
	// Make sure the view is actually loaded before sending the notification.
	// private method for Navigation.
	// @private
	viewDidAppear_:	function(/**bool*/ inWasAnimated )
	{
		if ( !this._isLoadingXib )
		{
			// normal. just passthrough
			this.viewDidAppear( inWasAnimated );
			return;
		}
		
		// 'store' the request for processing when loading is done.
		if ( this._pendingNotifications == NULL )
			this._pendingNotifications = new Array;
		this._pendingNotifications.push( {
			proc:this.viewDidAppear,
			param:inWasAnimated
		});
	},
	
	// private method for Navigation.
	// @private
	viewDidDisappear_:	function()
	{
		Core.UpdateEmitter.removeListener(this);
		this.viewDidDisappear();
	},
	
	/**
		Notification that subclasses can override to know when the view is loaded.
		Useful for doing post-load setup.
		@task Managing the View
	*/
	viewDidLoad:	function()
	{
	},

	/**
		Notification that subclasses can override to know when the view will be destroyed.
		Called in low memory situations for a view that is currently hidden.
		A good place to clear references to objects loaded along with the view.
		<br><br>
		If you have added references to singleton nodes to your node tree, they must be removed
		*before* this point.  It is recommended in viewDidDisappear, rather than here.
		@task Managing the View
	*/
	viewDidUnload:	function()
	{
	},
	
	/**
		Notification that subclasses can override to know when we will be presented onscreen.
		This is where you should update your view from the current backing data.
		@task Responding to View Events
	*/
	viewWillAppear:	function(/**bool*/ inWillBeAnimated )
	{
	},
	
	/**
		Notification that subclasses can override to know when we will be presented onscreen.
		This is where you should prepare for user input.
		@task Responding to View Events
	*/
	viewDidAppear:	function(/**bool*/ inWasAnimated )
	{
	},
	
	/**
		Notification that subclasses can override to know when we will be hidden from view.
		This will be called even if the new view above it is not fully opaque!
		This is where you should stop accepting user input, and save your view content to the 
		stored backing data.
		@task Responding to View Events
	*/
	viewWillDisappear:	function(/**bool*/ inWillBeAnimated )
	{
	},
	
	/**
		Notification that subclasses can override to know when we will be hidden from view.
		This will be called even if the new view above it is not fully opaque!
		Typically unnecessary, but here for completeness.
		@task Responding to View Events
	*/
	viewDidDisappear:	function(/**bool*/ inWasAnimated )
	{
	},
	
	
	/**
		Call this during viewDidLoad() to delay the display of this view onscreen 
		until all sub-components are loaded.  This is an optional call.
		Call readyToDislay() when fully prepared.
		
		This exists for situations where additional subviews need to be loaded after the main
		one completes and you don't want to watch the loading happen onscreen.
		@task Managing the View
	*/
	waitToDisplay:	function()
	{
		this._delayDisplay = true;
	},
	
	/**
		Flag that all loading is complete and the view may now be presented onscreen.
	*/
	readyToDisplay:	function()
	{
		this._delayDisplay = false;
		
		// any pending notifications?
		if ( this._pendingNotifications )
		{
			for ( var i=0; i<this._pendingNotifications.size(); i++ )
				this._pendingNotifications[i].proc.call( this, this._pendingNotifications[i].param );
			this._pendingNotifications = [];	// clear out
			
			if ( Navigation.logRenderTree )
				log( "render hierarchy after xib load completed:\n"+GL2.Root.toString() );
		}
	},
	
	/**
		Returns the overall depth of the loaded view 
		@task Managing the View
		@private
	*/
	getViewDepth: function()
	{
		if(this.view!=NULL)
			return this.view.getDepth();
		else
			return 0;
	},
		
	/**
		Sets whether this view is opaque to taps or allows them to fall through to lower views on the stack
		This is automatically implied by setting isFullscreenOpaque to true
		@task Memory management
	*/
	setAllowTapPassthrough: function(/**bool*/value)
	{
		this.allowPassthrough = value;
	},

	/**
		Get whether this view is opaque to taps.
		@task Memory management
	*/
	getAllowTapPassthrough: function()
	{
		return this.allowPassthrough && (!this._isOpaque);
	},
	
	inputCallbackPassthrough: function(foo)
	{
	},
	
	/**
		A low-level callback from the Xib.Loader when the view has been loaded from disk 
		and all contained objects were called with awakeFromXib.
		It is preferred for subclasses to override Xib.ViewController#viewDidLoad instead,
		as all ViewController processing is complete by then.
		@task creation
	*/
	awakeFromXib: function()
	{
	},
	
	/**
		A proc called every frame that subclasses may override to animate or run state machines.
		This will only be active when this ViewController is going to be frontmost onscreen.
		@task Frame updates
	*/
	updateFrame:	function( /**float*/ secondsPassed )
	{
	},
	
	/**
		The real frame update proc.
		@private
	*/
	_updateFrame:	function( ticks )
	{
		// DDP deal with SDK 1.0 for flash sending 0 deltas all the time.
		if ( ticks <= 0 )
			ticks = 1000 / 60;
		
		// The conversion of ticks to seconds.
		ticks = ticks / 1000.0;
		
		// update any contained animations.
		for ( var i=0; i<this._animators.length; i++ )
		{
			this._animators[i].update( ticks );
		}
		
		// call the overridden one
		this.updateFrame( ticks );
	},
	
	/**
		Is this view currently visible onscreen?
		If not, we are currently hidden behind an opaque ViewController.
		Useful from viewDidDisappear to allow unloading of this controller's View.
	*/
	isViewVisible:	function()	/**bool*/
	{
		return this._visible;
	},
	
	/**
		Calculate the expected bounds of the Mobage button in terms of device coordinates
		Right now it assumes the button is in the topLeft.
	*/
	$getMobageButtonFrame_Device:	function()	/**Core.Rect*/
	{
		// how big is the button? 
		// From Mobage Global Game Service Developer's Guide...
		// The Mobage Community button size is: 11.875% of the narrow side length.
		var	realSize = { x:54, y:54 };
		var screenWide = Core.Capabilities.getScreenWidth();
		var screenHigh = Core.Capabilities.getScreenHeight();
		var	screenSize = screenWide > screenHigh? screenHigh:screenWide;
		realSize.x = realSize.y = 11.875 * screenSize / 100;
		return new Core.Rect(0,0,realSize.x, realSize.y);
	},
	
	/**
		Calculate the expected bounds of the Mobage button as though it was one of our child views.
		Right now it assumes the button is in the topLeft.
	*/
	getMobageButtonFrame:	function()	/**Core.Rect*/
	{
		var	src = this.getMobageButtonFrame_Device();
		var	realSize = { x:src.getSize().getWidth(), y:src.getSize().getHeight() };
		
		// based on our scale, calculate the rect the button will take onscreen.
		realSize.x /= this.view.getScale().getX();
		realSize.y /= this.view.getScale().getY();
		log("mobage button taking "+realSize.x+","+realSize.y+" pels in coordinates of our view.");
		
		return new Core.Rect(0,0,realSize.x, realSize.y);
	},
	
	/**
		Move all child views out of the way of the Mobage button.
		Right now it assumes the button is in the topLeft.
	*/
	exposeMobageButton:	function()
	{
		// Shift everything out of the way.
		moveNodesToExposeArea( this.getMobageButtonFrame(), this.view.getChildren() );
	},
});


exports.AnimatorMixin = Core.MessageListener.subclass(
/** @lends Xib.AnimatorMixin.prototype */
{
	classname: 'AnimatorMixin',

	/**
		@class Mixin class to allow easy animation callbacks from within a non-MessageListener subclass.
		@constructs The default constructor.
		@augments Core.MessageListener
		@task creation
		@example
var view1 = Xib.ViewController.subclass(
{
	viewDidAppear:	function()
	{
		// start animating
		this._animator = new Xib.AnimatorMixin( this.animate.bind(this) );
	},

	viewWillDisappear:	function()
	{
		// cancel the animation
		this._animator.destroy();
		this._animator = NULL;
	},

	// actual animation proc
	animate:	function( inSecsPassed )
	{
		// animate my views
	},
}
	*/
	initialize:	function( /**function*/ inProc )
	{
		this._Proc = inProc;
		Core.UpdateEmitter.addListener(this, this.onUpdate, 0);
	},
	
	/**
		Cleanup
	*/
	destroy:	function()
	{
		Core.UpdateEmitter.removeListener(this);
	},
	
	onUpdate:	function( /**float*/ ticks )
	{
		// DDP deal with SDK 1.0 for flash sending 0 deltas all the time.
		if ( ticks <= 0 )
			ticks = 1000 / 60;
		
		// forward the touch back to the real owner.
		// Note the conversion of ticks to seconds.
		this._Proc( ticks / 1000.0 );
	},
});

; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/Navigation'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/Navigation'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/Navigation'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/Navigation.js';

/*
 *  Navigation.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/23/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core		= require('NGCore/Client/Core').Core;
var GL2			= require('NGCore/Client/GL2').GL2;
var OrientSrc	= require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;

// turn on the touch target visualizer.
// Turning it off means commend *and add* require_DISABLED
//require_DISABLED("../TouchTargetVisualizer").TouchTargetVisualizer.show();
//require_DISABLED("../TouchTargetVisualizer").TouchTargetVisualizer.show();

var	TouchCallbackManager = NULL;
// TESTING TESTING TESTING
//TouchCallbackManager	= require_DISABLED('./TouchCallbackManager').TouchCallbackManager;
// TESTING TESTING TESTING

function NavigationCatcher_() {};	// for xCode function popup

/**
	Private class to catch input events
	@private
*/
var NavigationCatcher = Core.MessageListener.subclass(
{
	classname: 'NavigationCatcher',
	
	initialize: function()
	{
		
	},

	touchBegan: function(touch)
	{
		if ( _DEBUG )
		{
			log("Touch fell through to input shield");
			
			if ( touch.getAction() == GL2.Touch.Action.Start )
			{
			//	log("view tree: "+GL2.Root.toString());
			}
			
			// MSA Send the touch event to the touch callback manager if there
			// are additional effects to process based on touch events:
			if (touch && TouchCallbackManager)
				TouchCallbackManager.callCallbacks(touch);
		}
		return true;
	}
});


function Navigation_() {};	// for xCode function popup

exports._Navigation = Core.Class.subclass(
/** @lends Xib.Navigation.prototype */
{
	classname: 'Navigation',
	
	// items that can be turned on (set 'true') to log lots of debug information to console.
	logRenderTree:		true,
	
	/**
		@class Manages game screens
		@constructs The default constructor.
		rootView must be a ViewController or a string which is the name of a subclass of ViewController.
		@task creation
	*/
	initialize: function()
	{
		this.stack = new Array();
		this.modalView = NULL;						//current modal interface
		this.defaultTransitionTimer = 1;
		this.usedTransitionTimer = false;
		this.expectedScreenSize = new Core.Size( 320,480 );
		this._waitingOn = 0;
		
		// this is a list of ViewControllers that asked to be destroyed after all anims are done.
		this._destroyList = [];
		
		// list of commands we're doing.
		this._commands = [];
		
		//Create the backstop to prevent input events during transitions
		this.inputShield = new GL2.TouchTarget();
		this.inputShield.setSize(10000,10000);				//TODO: set to fullscreen, keep updated throughout orientation changes
		this.navCatcher = new NavigationCatcher()
		this.inputShield.getTouchEmitter().addListener(this.navCatcher, this.navCatcher.touchBegan);
		this.inputShield.setDepth(100000);
		this.inputShield.setVisible(false);
		this.inputShield._viewOwner = this;
		GL2.Root.addChild(this.inputShield);
		
		/** 
			for debugging, show the current rendering tree as a flat string.
		*/
		GL2.Root.toString = function(/**string*/ indent )	/**string*/ 
		{
			// DDP I added this here in Navigation because Navigation will be used on startup,
			// preparing this little override chunk.  It didn't work to do this 
			// to the prototype like normal classes.
			
			if ( indent == NULL )
				indent = "";
			
			var ret = indent + this.classname;
				
			// recursive
			if ( this._children.size() )
			{
				ret += "\n";
				ret += indent+"{\n";
				var	subIndent = indent+"    ";
				for ( var i=0; i<this._children.size(); i++ )
				{
					ret += this._children[i].treeToString( subIndent );
					// make sure line ends in newline
					if ( !ret.endsWith("\n") )
						ret += "\n";
				}
				ret += indent+"}\n";
			}
			
			return ret;
		}
		/** 
			for debugging, show the current rendering tree as a flat string.
			@function
		*/
		GL2.Root.treeToString = GL2.Root.toString;
		
		/** 
			for debugging, build a mirror object list describing the current rendering tree. 
			This object list can be revealed for detail in Console.
		*/
		GL2.Root.showTree = function()
		{
			// DDP I added this here in Navigation because Navigation will be used on startup,
			// preparing this little override chunk.  It didn't work to do this to the 
			// prototype like normal classes.
			
			var ret = {};
			
			// recursive
			if ( this._children.size() )
			{
				for ( var i=0; i<this._children.size(); i++ )
					this._children[i].showTree( ret );
			}
			
			return ret;
		}
		
		GL2.Root.forceAllTransformChanged = function()
		{
			var	list = this._children;
			for ( var i=0; i<list.length; i++ )
				list[i].forceAllTransformChanged();
		}
	},
	
	/**
		Destructor
		@task destruction
	*/
	destroy: function()
	{
		while(this.stack.length>1)
			this.popViewController();
	
		//popViewController will refuse to remove the root view so do that manually
		var rootView = this.stack[0];
		
		rootView._destroyForNavigation();
		
		delete this.stack;
		
		this.inputShield.destroy();
	},
	
	toString:	function()
	{
		return this.classname;
	},
	
	log:	function( message )
	{
		if ( debugSettings.Navigation )
			log(this.classname+" "+message);
	},
	
	/**
		Get the input sheild node, for knowing when we've hit the end of the potential touchTarget list.
		@private
	*/
	getInputSheild:	function()
	{
		return this.inputShield;
	},
	
	/**
		When pushing a view, we expand the view to 'fill' the entire display, first by 
		proportionally scaling it, then expanding the frame of the top level view.  
		If the view has an 'empty' size (as they do while being loaded from a xib for example), 
		we will use this default size in our expansion calculations.
		The default size is 320x480.
	*/
	setExpectedScreenSize:	function( /**Core.Size*/ size )
	{
		this.expectedScreenSize.setAll(size);
	},
	
	/**
		Set the time allowed for the views to animate transitions on or off the screen. Argument is in seconds.
		Default is 1 second.
		@task Configuration
	*/
	
	setTransitionTime: function(/**float*/time)
	{
		this.defaultTransitionTimer = time;
	},
	
	/**
		Get the time allowed for the views to animate transitions on or off the screen. Argument is in seconds.
		@task Configuration
	*/
	
	getTransitionTime: function() /**float*/
	{
		return this.defaultTransitionTimer;
	},
	
	/**
		Force the input shield forward to prevent clicks on even the frontmost view.
		Will be reset normally after any transitions are done, or lowerShields() called.
		@task input shield control
	*/
	raiseShields:	function()
	{
		//-if we are in a transition put the input shield on top
		this.inputShield.setDepth(10000);
		log("Navigation.raiseShields()");

		try {
		//	throw new Error("raiseShields called by...?");
		} catch ( err ) {
			NgLogException(err,true);
		}
	},
	
	/**
		Lower the input shield to allow clicks/taps on the frontmost view.
		Will be reset normally after any transitions are done.
		@task input shield control
	*/
	lowerShields:	function()
	{
		//-if there is a modal view, place the input shield directly beneath it
		//-if not, place the input shield below the highest view to return that it does not allow interface passthrough
		if(this.modalView!=NULL)
		{
			//place the input shield under the modal view and atop everyone else
			
			this.inputShield.setDepth(this.modalView.getViewDepth()-100);
			log("Navigation.lowerShields() under modal moved to: "+this.inputShield.getDepth());
		}
		else
		{
			//locate the first view that replies that it blocks taps, and put the input shield behind it
			var iterator = 0;
			
			while(this.stack[iterator].getAllowTapPassthrough() && (iterator < (this.stack.length-1)))
				iterator++;
				
			this.inputShield.setDepth(this.stack[iterator].getView().getDepth()-100);
			log("Navigation.lowerShields() moved to: "+this.inputShield.getDepth());
		}
		
		try {
		//	throw new Error("lowerSheilds called by...?");
		} catch ( err ) {
			NgLogException(err,true);
		}

		// if in debug mode, setup a FPS counter
		if ( debugSettings.showFPS && (!this.fps) )
		{
			/*	
				Simple "on" can be done with this in debugging.json:
				"showFPS":true,
				
				On the other hand, optional keys for controlling this in debugging.json:
				"showFPS":
				{
					"pos":[xPos, yPos],
					"color":[red, green, blue],
					
					// set the font size
					"size":24,
					
					// set the number of frames to remember timings for
					"queueLen":30,
					
					// when on, tapping fps counter dumps GL2.Root.treeToString() to console log
					"showTree":true	
				},
			*/
			
			this.fps = new GL2.Text();
			this.fps.setDepth(100000);
			this.fps._viewOwner = this;
			this.fps.setText("fps:-0-");
			this.fps.setSize( 100,40 );
			this.fps.setPosition( 90, 10 );
			if ( debugSettings.showFPS.pos )
				this.fps.setPosition( debugSettings.showFPS.pos );
			this.fps.setAnchor(0,0);
			this.fps.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
			this.fps.setVerticalAlign(GL2.Text.VerticalAlign.Top);
			// DDP don't use the defaults system, might not be ready.
			this.fps.Text_setFontFamily( "DroidSansFallback" );	
		//	this.fps.setFontFamily( "junkFont.ttf" );
			this.fps.setFontSize( 12 );
			if ( debugSettings.showFPS.size )
				this.fps.setFontSize( debugSettings.showFPS.size );
			if ( debugSettings.showFPS.color )
				this.fps.setColor( debugSettings.showFPS.color );
			GL2.Root.addChild(this.fps);
			
			this._secsList = [];
			this._fpsQueueLen = 30;
			if ( debugSettings.showFPS.queueLen )
				this._fpsQueueLen = debugSettings.showFPS.queueLen;
			
			var AnimatorMixin = require('ngCrunch/Xib/ViewController').AnimatorMixin;
			new AnimatorMixin( function(secs)
			{
				this._secsList.push(secs);
				while ( this._secsList.length > this._fpsQueueLen )	// queue length
					this._secsList.shift();
				var	i,count=this._secsList.length,total=0;
				for ( i=0; i<count; i++ )
					total+=this._secsList[i];
				total = count / total;	// divide out
				total = Math.round(total*10)/10;	// limit decimal places
				this.fps.setText("fps:"+total);
				
			}.bind(this));
			
			if ( debugSettings.showFPS.showTree )
			{
				var	btn = new GL2.TouchTarget();
				btn.setSize(this.fps.getSize());
				btn.setAnchor(0,0);
				btn.setPosition(0,0);
				this.fps.addChild(btn);
				
				var	listenerType = Core.MessageListener.subclass(
				{
					onTouch:	function( /**GL2.Touch*/ touch )
					{
						if ( touch.getAction() != touch.Action.Start )
							return false;
						log(GL2.Root.treeToString());
						return true;	// capture the tap, just in case.
					},
				});
				var	listener = new listenerType;
				btn.getTouchEmitter().addListener(listener, listener.onTouch, 0);
			}
		}
	},
	
	/**
		Are the shields currently raised?  Useful to know if we're in a transition state.
	*/
	areShieldsUp:	function()	/**bool*/
	{
		return this.inputShield.getDepth() >= 10000;
	},
	
	// hack for setting the app to a whole app to a given orientation
	setInterfaceOrientation:	function( /**Device.OrientationEmitter.Orientation*/ orient )
	{
		OrientSrc.setInterfaceOrientation( orient, false);
		this.forcedOrientation = orient;
		log("Navigation.setInterfaceOrientation("+orient+")");
	},
	
	/**
		set the frame and scale on the passed view so that it fills the screen.
		@private
	*/
	fillScreenWithView:	function(/**GL2.Node*/ view)
	{
		//
		//Resize the new view to completely cover the screen, first by scaling, then by altering frame.
		//
		var screenWide = Core.Capabilities.getScreenWidth();
		var screenHigh = Core.Capabilities.getScreenHeight();
		var	wide,high,scale;
		
		// fix the screen dimensions if our interface is in landscape mode.
		var	orient = OrientSrc.getInterfaceOrientation();
		if ( this.forcedOrientation != NULL )
			orient = this.forcedOrientation;
		switch ( orient )
		{
			case OrientSrc.Orientation.LandscapeLeft:
			case OrientSrc.Orientation.LandscapeRight:
				wide = screenWide;
				screenWide = screenHigh;
				screenHigh = wide;
				break;
		}
		
		// what's the original view size?  This is what the designer expected.
		// Unfortunately at this point the actual loading hasn't happened yet, so we have 
		// to get the information from an app global.
		var	orgSize = view.getFrame().getSize();
		if ( orgSize.getWidth() <= 0 || orgSize.getHeight() <= 0 )
			orgSize = this.expectedScreenSize;
		
		// Scale mode?
	//	if ( orgSize.getWidth() > orgSize.getHeight() )	// fails iPad, works on Nexus one.
		if ( ( orgSize.getWidth() * screenHigh / screenWide ) < orgSize.getHeight() )	// works iPad and Nexus one
		{
			// make the aspect ratio match
			high = orgSize.getHeight();
			wide = Math.ceil(high * screenWide / screenHigh);
			
			// now set a proportional scale to fill the screen
			scale = screenHigh / high;
		} else {
			// make the aspect ratio match
			wide = orgSize.getWidth();
			high = Math.ceil(wide * screenHigh / screenWide);
			
			// now set a proportional scale to fill the screen
			scale = screenWide / wide;
		}
		
		var	name = view._viewOwner || view;
		log(name+" orgSize:"+orgSize+" screen:"+screenWide+"x"+screenHigh+" result frame: "+wide+"x"+high+" scale:"+scale);
		
		view.setScale( scale, scale );	// be sure to do this *before* setFrame()
		view.setFrame(new Core.Rect([0, 0], [wide, high]));		
	},
	
	/**
		Add a command to the list of things the caller requested.
		Done this way so a string of commands are all done sequentially, 
		to prevent bugs in client code.
		@private
	*/
	addCommand:	function( proc )
	{
		// add it for later.
		this._commands.push( proc );
		
		// do we have any other commands pending?
		// If not, just do it.
		if ( this._commands.length == 1 )
		{
			// prevent user input.
			this.raiseShields();
			
			// start it.
			proc();
		}
	},
	
	/**
		A command is done.  Are there any waiting?
		If not, re-allow access by users.
	*/
	startNextCommand:	function()
	{
		// remove last completed command
		if ( this._commands.length )
			this._commands.splice(0,1);
		
		// any remaining commands?
		if ( this._commands.length )
		{
			// do it.
			this._commands[0]();
			return;
		}
		
		// all done with commands. allow user input.
		this.lowerShields();
	},
	
	/**
		Begin displaying a new ViewController.
		If newView is a ViewController it is pushed onto the stack and made visible.
		If newView is a string, an instance of the class by that name, which must be a subclass of ViewController, is created. It is then
		pushed onto the stack and made visible.
		@task Navigation
	*/
	pushViewController: function(/**Xib.ViewController or string*/newView, /**Boolean */useAnimation)
	{
		var	realNewView = this._readyPushViewController( newView );
		if ( !realNewView )
			return;
		
		// push the command
		this.log("pushViewController (queue): "+realNewView.classname);
		this.addCommand( this._pushViewController.bind(this, realNewView, useAnimation));
	},
	
	_readyPushViewController:	function( newView )
	{
		if ( !newView )
		{
			log(this.classname+".pushViewController was passed NULL view");
			return;
		}
		
		var realNewView;
		if(typeof newView == 'string')
			eval("realNewView = new "+newView);
		else
			realNewView = newView;
		if ( realNewView == NULL )
			return NULL;
		
		// Start the loading of the new screen; 
		// tag the view with the owner's name.
		realNewView.getView()._viewOwner = realNewView.classname;
		realNewView.getView()._viewController = realNewView;
		
		// resize the temporary view to the full screen so that viewDidLoad() gets the full size.
		this.fillScreenWithView( realNewView.getView() );
		
		// put the view in the view tree but not visible
		realNewView._isRendering = true;
		realNewView.getView().setDepth(-111111);
		GL2.Root.addChild(realNewView.getView());
		return realNewView;
	},
	
	_pushViewController:	function( realNewView, useAnimation )
	{
		this.log("pushViewController (now): "+realNewView.classname);
		
		var realNewViewIndex = (this.modalView == NULL) ? 0 : 1; // the index of this new view controller depends on if we have a modal dialog box.
		
		// If this view is in the "to be destroyed" list, remove it. They changed their mind.
		for ( var i=0; i<this._destroyList.length; i++ )
		{
			if ( this._destroyList[i] != realNewView )
				continue;
			this._destroyList.splice( i, 1 );
			i --;	// recheck this entry.
		}
		
		//
		// get the new view started loading, if it needs it.
		//
		
		// warn the old view it's going away.
		if(this.stack.length > realNewViewIndex)
			this.stack[realNewViewIndex].viewWillDisappear(useAnimation);
		
		// put the new view on the stack
		this.stack.splice(realNewViewIndex, 0, realNewView);	// insert at the index we have determined.
		
		// deal with this being the root view
		if(this.stack.length==0)
		{
			realNewView.setIsFullscreenOpaque(true);			//the root fullscreen is always opaque
			realNewView.setAllowTapPassthrough(false);
		}
		
		// wait on the view to load (if necessary.)
		this._waitingOn = 1;	// so it doesn't trigger early.
		this._waitingOn ++;
		realNewView.addLoadedCallback( this._loadedPushViewController.bind(this, realNewView, useAnimation));
		
		/* is an animation going on right now?
		If there is, and we want an additional animation... Wait for the last animation
		to complete before allowing the user to start input. 
		We also need to wait for the view to actually load.
		*/
		this.usedTransitionTimer = useAnimation;
		if ( useAnimation )
		{
			this._waitingOn ++;
			invokeAfterDelay( this.defaultTransitionTimer, this._finishPushViewController.bind(this));
		}
		
		// balance initial waitingOn
		this._finishPushViewController();
	},
		
	_loadedPushViewController:	function( realNewView, useAnimation )
	{
		this.log("pushViewController adding "+realNewView.classname+" to render");
		
		realNewView.viewWillAppear_(useAnimation);
		
		// now that caller had a chance to fix things up, show it to user.
		realNewView._visible = true;
		this.updatePriorities();
		
		// fall through to finish
		this._finishPushViewController();
	},
	
	/**
		Finalize a push as the view animation completes
		@private
	*/
	
	_finishPushViewController: function()
	{
		this._waitingOn --;
		if ( this._waitingOn > 0 )
			return;
		this._waitingOn = 0;
		
		var	didAnimate = this.usedTransitionTimer;
		
		// if the new top is opaque, remove the lower one(s) completely from render tree
		var realNewViewIndex = (this.modalView == NULL) ? 0 : 1; // the index of this new view controller depends on if we have a modal dialog box.
		var	controller = this.stack[realNewViewIndex];
		if(controller.isFullscreenOpaque())
		{
			// remove views until we remove an opaque view, then stop
			// (We stop after opaque because we know nothing else was visible before it.)
			for ( var i=1; i<this.stack.size(); i++ )
			{
				GL2.Root.removeChild(this.stack[i].getView());
				this.stack[i]._visible = false;
				this.stack[i]._isRendering = false;
				this.log("_finishPushViewController removing "+this.stack[i].classname+" from render");
				if ( this.stack[i].isFullscreenOpaque() )
					break;
			}
		}
		
		// send notificaitons.  Note how they are explicitly last.
		// was there another view below the one we just added?
		var	nextViewIndex = realNewViewIndex+1;
		if ( this.stack.length > nextViewIndex )
			this.stack[nextViewIndex].viewDidDisappear_(didAnimate); // the view is invisible anyway...
		
		// destroy anyone who is requesting it.
		for( var stackIndex = 0; stackIndex < this.stack.length; stackIndex++ )
		{
			var willRemove = this.stack[stackIndex];
			var	wantsRemove = false;
			for ( var i=0; i<this._destroyList.length; i++ )
			{
				if ( this._destroyList[i] != willRemove )
					continue;
				
				// pull from list
				this._destroyList.splice( i, 1 );
				i --;	// recheck this entry.
				wantsRemove = true;
			}
			
			if ( wantsRemove )
			{
				// do actual destroy
				log("Navigation will destroy "+willRemove.classname);
				this.stack.splice(1,1);	// pull from list
				if ( willRemove._visible )
				{
					willRemove._visible = false;
					willRemove._isRendering = false;
					GL2.Root.removeChild(willRemove.view);
				}
				willRemove._destroyForNavigation();
			}
		}
		
		// if this is the new modal view, handle it appropriately.
		if ( controller._isModalView && !this.modalView )
			this.modalView = controller;
		
		// flag new one is ready.
		controller.viewDidAppear_(didAnimate);			//If the time elapsed was zero, we clearly did not animate
			
		if ( this.logRenderTree )
			console.log( "render hierarchy after push:\n"+GL2.Root.toString() );
		
		this.startNextCommand();
	},
	
	/**
		Replace the current ViewController with a new one.
		If newView is a ViewController, the current ViewController is removed from the stack and newView pushed on in its place. newView is then made visible.
		If newView is a string, an instance of the class by that name, which must be a subclass of ViewController, is created. The current ViewController
		is then removed from the stack and the new one pushed on in its place, then made visible.
		This convenience function will skip the momentary presentation of the second highest view on the stack.
		@task Navigation
	*/
	swapViewController: function(/**Xib.ViewController or string*/newView, /**Boolean*/ useAnimation)
	{
		if ( !newView )
		{
			log(this.classname+".swapViewController was passed NULL view");
			return;
		}
		
		this.log("swapViewController (queue): "+newView.classname?newView.classname:newView);
		this.addCommand(function( newView, useAnimation )
		{
			//
			// only difference between this and pushViewController is that when we're done,
			// the view currenty topmost wants to be destroyed.
			//
			if ( this.stack.length )
			{
				// don't have a modal view, so we can swap the first view controller.
				if( this.modalView == NULL)
				{
					this._destroyList.push( this.stack[0] );
				}
				// otherwise, we need to swap the second in the list, since we don't want to remove the popup.
				else
				{
					this._destroyList.push( this.stack[1] );
				}
			}
			var	realNewView = this._readyPushViewController( newView );
			if ( !realNewView )
				return;
			
			this._pushViewController( realNewView, useAnimation );
		
		}.bind( this, newView, useAnimation ));
	},
	
	/**
		Remove the most recently added ViewController.
		The current ViewController is hidden and destroyed. The next ViewController is made visible.
		The last ViewController on the stack may not be removed; if this function would empty the stack entirely it instead has no effect.
		@task Navigation
	*/
	popViewController: function(/**Boolean */useAnimation)
	{
		this.addCommand(function( useAnimation ){
		
		if(this.stack.length<=1)
		{
			log("Cannot pop root view");
			return this.startNextCommand();
		}
		
		this._waitingOn = 0;
		
		this.log("popViewController "+this.stack[0].classname);
		
		// warn them they will go away.
		this.stack[0].viewWillDisappear(useAnimation);
		
		//if the view was opaque, add the earlier views to the world. if not, they were already there anyway
		this._waitingOn ++;	// make sure we don't trigger earlier than desired.
		if(this.stack[0].isFullscreenOpaque())
		{
			for ( var i=1; i<this.stack.size(); i++ )
			{
				GL2.Root.addChild(this.stack[i].getView());
				this.stack[i]._visible = true;
				this.stack[i]._isRendering = true;
				this._waitingOn ++;
				this.stack[i].addLoadedCallback( this.finishPopViewController.bind(this));

				this.log("popViewController adding "+this.stack[i].classname+" to render");
				if ( this.stack[i].isFullscreenOpaque() )
					break;	// stop here, don't show below this.
			}
		}
		
		// warn next one down that they will appear.
		// Done *after* the load has been triggered by GL2.Root.addChild() above.
		this.stack[1].viewWillAppear_(/**Boolean */useAnimation);			//if we got down here the stack is at least 2 deep
		
		// there may be other animations going on already. Add us to the list
		if ( useAnimation )
		{
			this._waitingOn ++;
			invokeAfterDelay( this.defaultTransitionTimer, this.finishPopViewController.bind(this));
		}

		// balance the ealier _waitingOn++
		this.finishPopViewController();
		
		}.bind(this,useAnimation));
	},
	
	/**
		Finish popping a view controller
		@private
	*/
	
	finishPopViewController: function()
	{
		this._waitingOn --;
		if ( this._waitingOn > 0 )
			return;
		this._waitingOn = 0;
		
		var	didAnimate = this.usedTransitionTimer;
		
		//drop the topmost view controller, tell the remaining one that it finished animating
		GL2.Root.removeChild(this.stack[0].getView());
		this.stack[0]._visible = false;
		this.stack[0]._isRendering = false;
		this.log("finishPopViewController: removing "+this.stack[0].classname+" from render");
		
		// alter the stack before making the viewDidDisappear callback.
		// Just in case the caller wants to reentrant us.
		var oldView = this.stack[0];
		this.stack.splice(0, 1);
		
		this.updatePriorities();
		if ( this.logRenderTree )
			console.log( "render hierarchy after pop:\n"+GL2.Root.toString() );
		
		// send notificaitons.  Note how they are explicitly last.
		oldView.viewDidDisappear_(didAnimate);
		log("Navigation will destroy "+oldView.classname);
		oldView._destroyForNavigation();
		
		this.stack[0].viewDidAppear_(didAnimate);
		
		this.startNextCommand();
	},
	
	/**
		Hide ViewControllers and remove them from the stack until the specified ViewController is revealed. If targetView is a ViewController
		the stack is unwound until that instance is revealed. If targetView is a string the stack is unwound until an instance of a ViewController subclass
		with that name is revealed.
		All removed ViewControllers are destroyed.
		If the specified ViewController is not on the stack this function has no effect.
		@task Navigation
	*/
	
	popToViewController: function(/**Xib.ViewController*/targetView, /**Boolean*/useAnimation)
	{
		if ( !targetView )
		{
			log(this.classname+".popToViewController was passed NULL view");
			return;
		}
		
		this.addCommand( this._popToViewController.bind( this, targetView, useAnimation ) );
	},
		
	_popToViewController:	function( targetView, useAnimation )
	{
		//TODO: search stack by class name
		var passedOpaqueView = false;
		
		// is the view even in our lists?
		var	inList = false;
		for(var i=0; i < this.stack.length; i++)
		{
			if(typeof targetView == 'string')
			{
				if(this.stack[i].__proto__.classname==targetView)
				{
					inList = true;
					break;
				}
			}
			else
			{
				if(this.stack[i]==targetView)
				{
					inList = true;
					break;
				}
			}
		}
		
		if(!inList)
		{
			log("popToViewController: view "+targetView+" not found in stack");
			return this.startNextCommand();
		}
		
		this.log("popToViewController start: "+targetView);
		
		this._waitingOn = 0;
		
		// warn the current topmost.
		this.stack[0].viewWillDisappear(useAnimation);

		//if we passed an opaque view, everything below it was not being rendered
		if(this.stack[0].isFullscreenOpaque())
			passedOpaqueView = true;
			
		//Remove all the views we passed over from the middle of the stack immediately.
		//We do *not* remove the topmost, as that will animate away normally.
		while(this.stack.length > 2)
		{
			var oldView = this.stack[1];
			
			// is this the one we were waiting on?
			if( oldView == targetView )
				break;
			
			// nope. Cut it DEEP.
			this.stack.splice(1, 1);
			
			this.log("popToViewController: "+oldView.classname);
			
			if ( !passedOpaqueView )
			{
				GL2.Root.removeChild(oldView.getView());
				oldView._visible = false;
				oldView._isRendering = false;
				this.log("popToViewController: removing "+oldView.classname+" from render");
			}
			
			//if we passed an opaque view, everything below it was not being rendered
			if(oldView.isFullscreenOpaque())
				passedOpaqueView = true;
			
			log("Navigation will destroy "+oldView.classname);
			oldView._destroyForNavigation();
		}
		
		if (this.stack[1] != undefined)
			this.log("popToViewController stop at: "+this.stack[1].classname);
			
		//then show the target view
		this.stack[1].viewWillAppear_(useAnimation);
		
		//if we passed an opaque view, we need to restore the stack contents to render
		this._waitingOn ++;	// make sure we don't trigger earlier than desired.
		if(passedOpaqueView)
		{
			for ( var i=1; i<this.stack.size(); i++ )
			{
				GL2.Root.addChild(this.stack[i].getView());
				this.stack[i]._visible = true;
				this.stack[i]._isRendering = true;
				this._waitingOn ++;
				this.stack[i].addLoadedCallback( this.finishPopViewController.bind(this));
				
				this.log("popToViewController: adding "+this.stack[i].classname+" to render");
				if ( this.stack[i].isFullscreenOpaque() )
					break;	// stop here, don't show below this.
			}
		}

		this.updatePriorities();
		
		// there may be other animations going on already. Add us to the list
		if ( useAnimation )
		{
			this._waitingOn ++;
			invokeAfterDelay( this.defaultTransitionTimer, this.finishPopViewController.bind(this));
		}

		// balance the ealier _waitingOn++
		this.finishPopViewController();
	},
		
	/**
		Hide all ViewControllers except the root view and remove them from the stack.
		All removed ViewControllers are destroyed.
		@task Navigation
	*/
	
	popToRootViewController: function(/**Boolean*/useAnimation)
	{
		this.addCommand( function( useAnimation )
		{
			this._popToViewController(this.stack[this.stack.length-1], useAnimation);
			
		}.bind( this, useAnimation ));
	},
	
	/**
		Return the currently displayed ViewController.
		@task Navigation
	*/
	
	getCurrentViewController: function()
	{
		return this.stack[0];
	},
	
	/**
		Return a list of all visible view controllers.
		Topmost is at index 0.
	*/
	getViewControllers:	function()
	{
		return this.stack.clone();
	},
	
	
	/**
		Update the priorities of the views of the stack so they match the expected order.
		@private
	*/
	updatePriorities:	function()
	{
		for ( var i=0; i<this.stack.length; i++ )
		{
			var	v = this.stack[i].view;
			if ( v == undefined )
				continue;	// happens if an offscreen view has been temporarily released
			
			v.setDepth( (this.stack.length-i-1) * 1000 );
		}
		
		// put this on top no matter what.
		if(this.modalView!=NULL)
		{
			var v = this.modalView.view;
			if ( v )
				v.setDepth((this.stack.length)*1000);
		}
	},
	
	/**
		Present a ViewController modally
		The viewcontroller will be placed over the view stack and no input will be passed to the view stack (whether the modal view allows tap passthrough is ignored).
		The second parameter selects whether the modal view is automatically dismissed if the user taps outside its active controls.
		
		Only one modal view is allowed, calls to this method without balancing calls to removeModalView will be ignored.
		@task Modal Views
	*/
	
	presentModalView: function(/**Xib.ViewController or string*/view, /**Bool*/ useAnimation, /**Bool*/autoDismiss)
	{
		if ( !view )
		{
			log(this.classname+".presentModalView was passed NULL view");
			return;
		}
		
		var realNewView;
		if(typeof view == 'string')
			eval("realNewView = new "+view);
		else
			realNewView = view;
		
		// push to top of stack.
		this.pushViewController( realNewView, useAnimation );
		
		// if we don't have a modal view, flag this one as special.
		// Note we cannot actually set this.modalView here, it would mess with pushViewController.
		if ( this.modalView == NULL )
			realNewView._isModalView = true;
	},
	
	/**
		Get the modal view, which can then be used by calling code for customization, or for a stew, or for mixing into a nice potpourri.  
		@task Modal Views
	*/
	
	getModalView: function() 
	{
		return this.modalView;
	},
	
	/**
		Remove a modally presented ViewController.
		The view controllers on the stack will resume responding to events.
		@task Modal Views
	*/
	
	removeModalView: function(/**Boolean*/useAnimation)
	{
		if(this.modalView==NULL)
		{
			log("No modal view to remove!");
			return;
		}
		
		// the modal view should be top of stack at all times
		// This demotes it to a normal view to be removed.
		this.modalView = NULL;
		
		// now a standard pop will remove it properly.
		this.popViewController(useAnimation);
	},
	
});

exports.Navigation = exports._Navigation.singleton({});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/Scroller'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/Scroller'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/Scroller'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/Scroller.js';

/*
 *  Scroller.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/25/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var	Touch = GL2.Touch;
var TouchListener = require('ngCrunch/Xib/TouchListener').TouchListener;
var Navigation = require('ngCrunch/Xib/Navigation').Navigation;

function logList( msg, list )
{
	var	l = [];
	for ( var i=0; i<list.length; i++ )
		l.push( list[i].classname );
	log(msg+l.join("; "));
}

// hack for dealing with Cocoa's "Clip view"
exports.NSClipView = GL2.Node.subclass(
{
	classname: 'NSClipView',
});

exports.Scroller = GL2.Node.subclass(
/** @lends Xib.Scroller.prototype */
{
	classname: 'Scroller',

	/**
		@class A basic scroller implementation.  Does *not* support clipping of contents.
		This class shifts around all child nodes.  Subclasses can also override updateScroll()
		to control any number of possible unrelated things, like an animation.
		@constructs The default constructor.
		@augments GL2.Node
		@task creation
	*/
	initialize: function()
	{
		// constant settings
		this.mOffsetScale = 1;
		this.mMinVelocity = 1;
		this.mDirtyPicker = false;
		this.mPagingEnabled = false;
		this.customPageSize = false;
		this.mPageSize = new Core.Point( 50, 50 );
		this.mWrapEnabled = false;
		this.mContentSize = new Core.Size( 1000, 1000 );
		this.SA_SmoothingFactor = 0.3;
		this.SA_Friction = 0.9 * (480 / Core.Capabilities.getScreenHeight());
		
		// starting values
		this.mOffset = new Core.Point( 0, 0 );	// will be reset to 0 shortly.
		this._state = this.kIdle;
		this._momentum = { x:0, y:0 };
		this.mLastVel = new Core.Point( 0,0 );
		this.roundedOffset = this.mOffset;
		this.pagingTarget = NULL;
		
		// for handleSubviewEvent
		this._touchTracking = {};
		
		// this touchTarget is special in that it floats above
		// all the contained Node's touchTargets. It has to capture events first!
		this._touchTargetNode = new GL2.TouchTarget;
		this._touchTargetNode.init();
		this._touchTargetNode.setDepth( 100 );
		this._touchTargetNode._viewOwner = this;
		this.addChild( this._touchTargetNode );

		// be prepared to handle stuff.
		this._listener = new TouchListener( this, this._touchTargetNode );
	},

	initWithXib:	function( $super, /**xmlElement*/ groupElem, /**Xib.Loader*/inLoader )
	{
		// Call super
		$super( groupElem, inLoader );
		
		this.mPagingEnabled = inLoader.boolForKey( groupElem, "IBUIPagingEnabled", this.mPagingEnabled );
	},
	
	// override transformChanged to keep our subobjects maintained.
	// @private
	transformChanged:	function( $super )
	{
		$super();
		this._touchTargetNode.setFrame( this.getBounds() );
		
		// subclasses may want to override this in future.
		if ( !this.customPageSize )
			this.mPageSize = this.getBounds().getSize();
	},
	
	// @private
	awakeFromXib:	function()
	{
		// see if we contain the infamous NSClipView, and remove it if so.
		var	list = this.getChildren();
		for ( var i=0; i<list.length; i++ )
		{
			var	clipView = list[i];
			if ( clipView.classname != "NSClipView" )
				continue;
			this.removeChild( clipView );
			
			// transfer all contents of the clip view to be directly our descendants.
			var	list = clipView.getChildren();
			for ( var i=0; i<list.size(); i++ )
			{
				var	it = list[i];
				clipView.removeChild(it);
				this.addChild(it);
			}
			
			// remove and destroy clipview.
			clipView.destroy();
			
			// recheck from start.
			i = 0;
		}
		
		// automatically set our content size to the max size of our subviews.
		// as a convenience.
		var	size = { x:0, y:0 };
		for ( var i=0; i<list.size(); i++ )
		{
			var	it = list[i].getFrame().getSize();
			if ( size.x < it.getWidth() )
				size.x = it.getWidth();
			if ( size.y < it.getHeight() )
				size.y = it.getHeight();
		}
		
		this.setContentSize( new Core.Size(size.x,size.y) );
		
		// use the first subobject as current position.
		if ( list.size() )
			this.setContentOffset( list[0].getFrame().getOrigin() );
	},
	
	/*	DISABLED (Incomplete)
		Set whether to enable Wrap mode (where it loops the scroll content indefinitely).
		Default is false.
		@task Wrap Mode
	*/
	setWrapEnabled:	function( /**bool*/val )
	{
		this.mWrapEnabled = val;
	},
	
	/*	DISABLED (Incomplete)
		Get whether to enable Wrap mode (where it loops the scroll content indefinitely).
		Default is false.
		@task Wrap Mode
	*/
	getWrapEnabled:	function()	/**bool*/
	{
		return this.mWrapEnabled;
	},
	
	/**
		Set whether to enable Page mode (where it snaps to a page after user releases).
		Default is false.
		@task Paging Mode
	*/
	setPagingEnabled:	function( /**bool*/val )
	{
		this.mPagingEnabled = val;
	},
	
	/**
		Get whether to enable Page mode (where it snaps to a page after user releases).
		Default is false.
		@task Paging Mode
	*/
	getPagingEnabled:	function()	/**bool*/
	{
		return this.mPagingEnabled;
	},
	
	/**
		Set the size of a "page" that is snapped.
		Pass NULL to reset to default, which is the size of the viewable area of the scroller.
		@task Paging Mode
	*/
	setPagingSize:	function( /**Core.Size*/ val )
	{
		if ( val )
		{
			this.mPageSize = val;
			this.customPageSize = true;
		} else {
			this.customPageSize = false;
			this.transformChanged();
		}
	},
	
	/**
		Get the size of a "page" that is snapped.
		@task Paging Mode
	*/
	getPagingSize:	function() /**Core.Size*/
	{
		return this.mPageSize;
	},
	
	/**
		The size of the content view.
		Does not change or clip the current offset!
		@task Managing Content
	*/
	setContentSize:	function( /**Core.Size*/ inSize )
	{
		this.mContentSize = inSize;
	},
	
	/**
		The size of the content view.
		@task Managing Content
	*/
	getContentSize:	function() /**Core.Size*/
	{
		return this.mContentSize;
	},
	
	/**
		The point at which the origin of the content view is offset from the origin of the scroll view.
		Value is clipped to current scroll limits before updating.
		@task Managing Content
	*/
	setContentOffset:	function( /**Core.Point*/ inAt, /**bool*/ inAnimated )
	{
		// only allow scrolling if user isn't touching.
		switch ( this.getState() )
		{
			case this.kIdle:
			case this.kReleased:
				break;
			
			default:
				return;
		}
		
		var newOffset = this.clipPotentialScrollPos(inAt);
		if ( !inAnimated )
		{
			this.updateScroll(newOffset,false);
			this.mOffset = newOffset;
		} else {
			this.gotoState( this.kReleased );
			this.pagingTarget = newOffset;	// redirect the paging target (if this is a paging scroller)
			this.startAnimating();
		}
	},
	
	/**
		The point at which the origin of the content view is offset from the origin of the scroll view.
		@task Managing Content
	*/
	getContentOffset:	function() /**Core.Point*/
	{
		return this.mOffset;
	},
	
	//
	// state manager.
	//
	
	// @private
	setState:	function( /**int*/ newState )
	{
		if ( newState == this._state )
			return;
		
		var wasState = this._state;
		this._state = newState;
	//	log("state change from "+wasState+" to "+newState);
		
		switch ( this._state )
		{
			case this.kScroll:
				// warn whoever wants to know that we're scrolling.
				this.scrollingWillStart();
				
				// start our animation runner
				this.startAnimating();
				break;
			
			case this.kSubview:
			//	log("timeout, pass to subview now\n");
				
				// we are no longer the event hog.
			//	mDisplay->setEventHog(NULL);
				
				// send mStart as a "new" event.
				this.handleSubviewEvent( this.mStart );
				
				// from here, any moves/touchup events are processed as normal.
				break;
			
				
			case this.kReleased:
				this.scrollingDidReleaseTouch();
				if ( this.mPagingEnabled )
				{
					// calculate the expected target.  Use the current momentum to guess 
					// where the user intended to stop.
					// pos = Vel*t + (Acc/2)*t^2
					// Need to work out time, which will be how long Acc takes to reach 0.
					// Vel + Acc * t = 0; Acc * t = -Vel; t = -Vel/Acc
					
					// which is largest momentum?
					var	vel = Math.max( Math.abs(this._momentum.x), Math.abs(this._momentum.y) );
					var	acc = this.SA_Friction * 30;	// positive, take into account expected FPS
					
					var	t = vel / acc;	// positive (in "future")
					var	acc = acc / 2 * t * t;
					
					var	newOffset = new Core.Point(
						this.mOffset.getX() + this._momentum.x * t + acc,
						this.mOffset.getY() + this._momentum.y * t + acc);
					
					// DDP I think i'm off somewhere in that calculation.
				//	newOffset = this.mOffset;
					
					// Round the potential position to a page boundary
					newOffset = new Core.Point(
						Math.round( newOffset.getX() / this.mPageSize.getWidth()) * this.mPageSize.getWidth(),
						Math.round( newOffset.getY() / this.mPageSize.getHeight()) * this.mPageSize.getHeight());
					this.pagingTarget = this.clipPotentialScrollPos( newOffset );
					
				//	log("pagingTarget:"+this.pagingTarget);
					
					if ( 0 )
					{
					// jump there for test.
					this.updateScroll( this.pagingTarget,false );
					this.mOffset = this.pagingTarget;
					this.pagingTarget = NULL;
					this._momentum.x = this._momentum.y = 0;
					}
				}
				break;
				
			case this.kIdle:
				if ( this._anim )
				{
					this._anim.destroy();
					this._anim = NULL;
				}
				
				switch ( wasState )
				{
					case this.kScroll:
					case this.kReleased:
						// warn whoever wants to know that we're done scrolling.
						this.scrollingDidStop();
						break;
				}
				break;
		}
	},
	
	// @private
	getState:	function() /**int*/
	{
		return this._state;
	},
	
	// @private
	gotoState:	function( /**int*/ newState )
	{
		this.setState(newState);
	},
	
	// @private
	gotoStateAfter:	function( /**int*/ newState, /**float*/ delay )
	{
		invokeAfterDelay(delay, function()
		{ 
			this.setState(newState); 
			
		}.bind(this));
	},
	
	//
	// end of state manager
	//
	
	// start our animation runner
	startAnimating:	function()
	{
		if ( !this._anim )
		{
			var AnimatorMixin = require('ngCrunch/Xib/ViewController').AnimatorMixin;
			this._anim = new AnimatorMixin( this.animate.bind(this) );
		}
	},
	
	// states
	kIdle:"idle",
	kStart:"start",			// user has finger down, just starting. if user moves a lot before timeout, it's a scroll
	kScroll:"scroll",			// user has finger down for scroll (post-timeout)
	kSubview:"subview",			// user has finger down for a subview (post-timeout)
	kReleased:"released",		// user has released, but we still animate. (setup)
//	kPagingScroll:"paging",	// user released, we are animating until next page.
	
	//
	// constants
	// 
	
	// num seconds to delay before considering scrolling
	kTicksBeforeScroll:0.3,
	
	// squared because it's a qlen compare. in pels.
	kScrollVsSubviewThreshold:5*5,	
	
	kPageVelocityFactor:.02,
	
	// a touch was found on us.  what now?
	// @private
	onTouch:	function( /**GL2.Touch*/ touch )
	{
		switch ( touch.getAction() )
		{
			case GL2.Touch.Action.Start:
				this.mLast = this.mStart = touch;
				this.setState( this.kStart );
				this._momentum = { x:0, y:0 };	// reset momentum immediately, user touched us.
				
				// check the touchtarget list.  is there any that can properly respond to this tap?
				// if now, go direct to scrolling.
				var	found = false;
				var	list = touch.getTouchTargets();
				for ( i=0; i<list.length; i++ )
				{
					if ( list[i] == this._touchTargetNode )
						continue;
					
					// stop at the navigation eating target.
					// Have to do a non-method access because subclassed Navigation objects
					// messes with the singleton system.
					if ( list[i] == Navigation.inputShield )
						break;
					
					// if the target responds to it, ask if it *require_s* first shot at
					// this event.
					if ( list[i].overridesScroller )
					{
					//	log("overridesScroller!");
						// totally different situation.  Forward immediately.
						this.setState(this.kSubview); 
						return this.handleSubviewEvent( touch );
					}
					
					// assume it's valid.
					found = true;
					break;
				}
				
				if ( found )
				{
					// a responder was found.
					// after a short delay, if we're still at starting place, forward to subview.
					invokeAfterDelay(this.kTicksBeforeScroll, function()
					{ 
						if ( this.getState() != this.kStart )
							return;
						this.setState(this.kSubview); 
						
					}.bind(this));
				} else {
				//	log("no responder, going right to scroll");
					// no responder.  
					// switch to true scrolling
					this.gotoState( this.kScroll );					
				}
				break;
				
			case GL2.Touch.Action.Move:
				// check for a 'moved' without a 'began'.
				switch ( this.getState() )
				{
					case this.kStart:
					{	
						// have we moved far enough away from initial spot?
						var	d = touch.getPosition().sub(this.mLast.getPosition());
						if ( d.qlen() >= this.kScrollVsSubviewThreshold )
						{
							// switch to true scrolling
							this.gotoState( this.kScroll );
							break;	// allows 'scrolling' to happen.
						}
						
						// otherwise, ignore the input (for moment)
					}	return true;
					
					// normal scrolling happening.
					case this.kScroll:
						break;
					
					// we need to pass this to the subview.
					case this.kSubview:
						return this.handleSubviewEvent( touch );
						
					default:	// either we're idle or released or ?  Force a new 'begin'.
						var	dup = touch.clone();
						dup._action = GL2.Touch.Action.Start;
						return this.onTouch( dup );
				}
				
				// if we aren't the event hog, someone dragged their finger across the button but 
				// didn't start here, so ignore it.
			//	if ( mDisplay->eventHog() != this )
			//		return false;
				
				// delta?
				var	d = touch.getPosition().sub(this.mLast.getPosition());
				d = d.scale( this.mOffsetScale );
				this.mLastVel = d;
				this.mLast = touch;
				
				// update position.
				var newOffset = this.clipPotentialScrollPos(this.mOffset.add( d ));
				this.updateScroll( newOffset,false );
				this.mOffset = newOffset;
				break;
				
			case GL2.Touch.Action.End:
				// check for being in subview mode
				switch ( this.getState() )
				{
					case this.kStart:
						// still waiting for initial trigger, so assume user wants to tap subview.
						// send the initial event (like kSubView would)
						this.setState( this.kSubview );
					//	break;	// fall through to pass the touchDone.
					
					case this.kSubview:
						this.setState( this.kIdle );
						return this.handleSubviewEvent( touch );
				}
				
				// if we aren't the event hog, someone dragged their finger across the button but 
				// didn't start here, so ignore it.
			//	if ( mDisplay->eventHog() != this )
			//		return false;
					
				// clear the event hog, don't need it any longer.
			//	mDisplay->setEventHog(NULL);
				
				this.gotoState( this.kReleased );
				break;
			
			default:
				return false;
		}
		
		// claim the event as our own
		return true;
	},
	
	animate:	function( /**float*/ secsPassed )
	{
	//	log("animate "+this.getState());
		switch ( this.getState() )
		{
			case this.kScroll:
				// add to the stored momentum value.
				this._momentum.x = this.SA_SmoothingFactor * this.mLastVel.getX() + 
					(1-this.SA_SmoothingFactor) * this._momentum.x;
				this._momentum.y = this.SA_SmoothingFactor * this.mLastVel.getY() + 
					(1-this.SA_SmoothingFactor) * this._momentum.y;
				break;
			
			case this.kReleased:
				// add to our position.
				var	newOffset = new Core.Point(
					this.mOffset.getX() + this._momentum.x,
					this.mOffset.getY() + this._momentum.y );
				var newOffset = this.clipPotentialScrollPos( newOffset );
				this.updateScroll( newOffset,false );
				this.mOffset = newOffset;
				
				// are we in paging scroll mode?
				if ( !this.pagingTarget )
				{
					// degrade the stored momentum value
					this._momentum.x *= this.SA_Friction;
					this._momentum.y *= this.SA_Friction;
					
					// have we dropped below minimum movement?
					if ( Math.abs(this._momentum.x) >= this.mMinVelocity ||
						Math.abs(this._momentum.y) >= this.mMinVelocity)
						break;
					
					this.gotoState( this.kIdle );
					
				} else {
					
					// paging enabled.  
					var	d = {
						x:	this.pagingTarget.getX() - this.mOffset.getX(),
						y:	this.pagingTarget.getY() - this.mOffset.getY(),
					};
					
					// if we're in wrap mode, see if going the other direction gets you there faster.
					if ( this.mWrapEnabled )
					{
						// try both ways
						var	d2 = {
							x:	this.pagingTarget.getX() + this.mContentSize.getWidth() - this.mOffset.getX(),
							y:	this.pagingTarget.getY() + this.mContentSize.getHeight() - this.mOffset.getY(),
						};
						if ( Math.abs(d2.x) < Math.abs(d.x) )
							d.x = d2.x;
						if ( Math.abs(d2.y) < Math.abs(d.y) )
							d.y = d2.y;
						
						var	d2 = {
							x:	this.pagingTarget.getX() - this.mContentSize.getWidth() - this.mOffset.getX(),
							y:	this.pagingTarget.getY() - this.mContentSize.getHeight() - this.mOffset.getY(),
						};
						if ( Math.abs(d2.x) < Math.abs(d.x) )
							d.x = d2.x;
						if ( Math.abs(d2.y) < Math.abs(d.y) )
							d.y = d2.y;
					}
					
					// blend current momentum with directed momentum
					this._momentum.x = /*(this._momentum.x * .9)*/ + (d.x * .1);
					this._momentum.y = /*(this._momentum.y * .9)*/ + (d.y * .1);
					
					// have we reached target?
					if ( (Math.abs(d.x)+Math.abs(d.y)) > .1 )
						break;
					
					this.pagingTarget = NULL;	// done with it.
					this.gotoState( this.kIdle );
				}
				break;
		}
	},
	
	handleSubviewEvent:	function( /**Touch*/ touch )
	{
		//
		// WARNING: this require_s knowledge of GL2.Root internals!
		// This could be invalidated by a later ngCore build.
		//
		
		var	list = touch.getTouchTargets();
		// find us in this list - we need to ignore all possibles up to and including.
		var	i;
		for ( i=0; i<list.length; i++ )
		{
			if ( list[i] == this._touchTargetNode )
			{
				i ++;
				break;
			}
		}
		if ( i >= list.length )
		{
		//	log("odd, should have found self.");
			return;
		}
		
		// remove all including this from list.
		list.splice( 0, i );
		
		//
		// duplicate code from Root.js
		// Modified to not need idToObject conversion
		//
		var		touchId = touch.getId();
		var		ids = list;
		switch(touch.getAction())
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var i=0; i < ids.length; ++i)
				{
					var o = ids[i];
					if(o.getTouchEmitter().chain(touch))
					{
					//	log(o.classname+"-"+Core.ObjectRegistry.objectToId( o )+" said yes to touch");
						this._touchTracking[touchId] = Core.ObjectRegistry.objectToId( o );
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
				//	log(o.classname+"-"+Core.ObjectRegistry.objectToId( o )+" end touch");
					o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
					o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},
	
	clipPotentialScrollPos:	function( /**Core.Point*/ inAt ) /**Core.Point*/
	{
		var	at = { x:inAt.getX(), y:inAt.getY() };
		var	size = { x:this.mContentSize.getWidth(), y:this.mContentSize.getHeight() };
		
		// take into account our size too.
		size.x -= this.getFrame().getSize().getWidth();
		size.y -= this.getFrame().getSize().getHeight();
		if ( size.x < 0 )
			size.x = 0;
		if ( size.y < 0 )
			size.y = 0;
		
		if ( !this.mWrapEnabled )
		{
			// note how this expects the offset to be negative
			if ( at.x > 0 )
				at.x = 0;
			if ( at.y > 0 )
				at.y = 0;
			if ( at.x < -size.x )
				at.x = -size.x;
			if ( at.y < -size.y )
				at.y = -size.y;

		} else {
			// note how this expects the offset to be between -size and 0,
			// not 0 to size like you might expect.
			if ( size.x )
			{
				while ( at.x <= -size.x )
					at.x += size.x;
				while ( at.x > 0 )
					at.x -= size.x;
			} else
				at.x = 0;
				
			if ( size.y )
			{
				while ( at.y <= -size.y )
					at.y += size.y;
				while ( at.y > 0 )
					at.y -= size.y;
			} else
				at.y = 0;
		}
		
		if ( _DEBUG && 0 )	// show scroller clipping in console
			log("scroll src:"+inAt.getX()+","+inAt.getY()+" range:"+size.x+","+size.y+" result:"+at.x+","+at.y);
		return new Core.Point( at.x, at.y );
	},
	
	/**
		for subclasses to override.  Not well tested yet.
		@task Notifications
	*/
	scrollingWillStart:	function()
	{
	//	log("scrollingWillStart");
	},
	
	/**
		for subclasses to override.  Not well tested yet.
		@task Notifications
	*/
	scrollingDidStop:	function()
	{
	//	log("scrollingDidStop");
	},
	
	/**
		for subclasses to override.  Not well tested yet.
		@task Notifications
	*/
    scrollingDidReleaseTouch:	function()
	{
	//	log("scrollingDidStop");
	},

	/**
		for subclasses to override.
		Default is to shift all children to have their frames start at current scroll pos.
		@task Notifications
	*/
	updateScroll:		function(/**Core.Point*/ inNewPos, /**bool*/ inForce )
	{
		// round the new position so it lies on a pixel boundary.
		var	newPos = new Core.Point( Math.round(inNewPos.getX()), Math.round(inNewPos.getY()) );
		
		// shift all children by the amount by which we are moving
		var delta = new Core.Point(
			newPos.getX() - this.roundedOffset.getX(), 
			newPos.getY() - this.roundedOffset.getY());
		
		// store the rounded value for next update.
		this.roundedOffset = newPos;
		
//		log("scroll delta "+delta);
		//delta = new Core.Point(1,1);
//		var	origin = inNewPos;
		var	list = this.getChildren();
		for ( var i=0; i<list.size(); i++ )
		{
			var	it = list[i];
			
			if ( it == this._touchTargetNode )
				continue;
			
			var	frame = new Core.Rect( new Core.Point(it.getFrame().getOrigin().getX() + delta.getX(), it.getFrame().getOrigin().getY() + delta.getY()), it.getFrame().getSize() );
			it.setFrame( frame );
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/ListView'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/ListView'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/ListView'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/ListView.js';

/*
 *  ListView.js
 *
 *  Created by Mark on 3/18/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
 
var Core  = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Scroller = require('ngCrunch/Xib/Scroller').Scroller;


function padStringLeft( s, len )
{
	s = s.toString();
	while ( s.length < len )
		s = " "+s;
	return s;
}

function _ListView() {}	// for the xCode function popup

exports.ListView = Scroller.subclass(
/** @lends Xib.ListView.prototype */
{
	classname: 'ListView',
	
	/**
		@class 	A class which manages a dynamically generated collection of rows provided by the user by calling methods of a datasource object
		@constructs The default constructor.
		@augments Xib.Scroller
		@task creation
	*/
	initialize: function()
	{
		this.dataDelegate = NULL;
		this.defaultCellHeight = 20;
		this.cells = [];
		this.sizeView = NULL;	// usually this.cells[0], but might be one of the others.
		this.horzOrient = false;
		this.cellXibName = '';
		this.allowCellReUse = true;
		this.lastPos = -1;	// forces initial update
		this._activeLoads = 0;
	},
	
	destroy:	function( $super )
	{
		log("ListView.destroy");
		for ( var i=0; i<this.cells.length; i++ )
			this.cells[i].destroy();
		this.cells = [];
		$super();
	},
	
	log:	function( s )
	{
		if ( _DEBUG && 0 )	// enable logging
			log(this.classname+"-"+this.__objectRegistryId+" "+s);
	},
	
	/**
		Set the expected scrolling orientation.  False (default) scrolls vertically,
		true scrolls horizontally.  Setup early (typically along with setCellXib).
		@task Setup
	*/
	setIsHorizontalOrientation:	function( /**bool*/ val )
	{
		this.horzOrient = val;
	},
	
	/**
		Get the expected scrolling orientation.  False (default) scrolls vertically,
		true scrolls horizontally.
		@task Setup
	*/
	getIsHorizontalOrientation:	function()	/**bool*/
	{
		return this.horzOrient;
	},	
	
	/**
		Set the xib file to be used when replicating cells. 
		There is no IB flag for this so it must be set programmatically.
		Alternately this can be specified using the delegate method 'cellXibName'.
		@task Setup
	*/
	setCellXib: function(/** String */xibName)
	{
		this.cellXibName = xibName;
		this.log("new cell xib: "+xibName);	
	},
	
	/**
		Activate cell re-use.  When on, a minimal number of cells are created onscreen to 
		reduce loading and rendering time. Default is true.
		There is no IB flag for this so it must be set programmatically.
		Alternately this can be specified using the delegate method 'allowCellReUse'.
		@task Setup
	*/
	setAllowCellReUse:	function( /**bool*/ allow )
	{
		this.allowCellReUse = allow;
	},
	
	/**
		Set the datasource for this listview.
		@task Setup
	*/
	setDataSource:	function( /**Xib.ListViewDelegate*/ obj )
	{
		this.dataDelegate = obj;	
		this.log("new dataSource: "+(obj.classname?obj.classname:obj));
		console.log("DELEGATE >>>>>>>>>>> OBJ : "+obj);
	},
	
	/**
		Initialize this object from a xib.
		The only part of the xib we use for now is the datasource connection, the delegate is ignored.
		@task construction
	*/
	initWithXib: function($super, /**xmlElement*/ group, /**Xib.Loader*/loader)
	{
		$super(group, loader);
		
		this.owner = loader.owner;
		return this;
	},
		
	awakeFromXib:	function($super)
	{
		// watch for the Cocoa xib setup:
		// Parent is NSClipView (unused) and parent of that is NSScrollView.
		// Is the NSScrollView's awakeFromXib called first, then our immediate parent is the
		// NSScrollView.  In any event, take the place of that topmost view.
		var	parent = this.getParent();
		if ( parent && parent.classname == "NSClipView" )
			parent = parent.getParent();
		if ( parent && parent.classname == "Scroller" && parent.getParent() )
		{
		//	log("swapping out scroller for ListView");
			
			// We need to take the place of that parent view
			// Copy it's settings to us.
			this.setFrame( parent.getFrame() );
			this._AutoresizingMask = parent._AutoresizingMask;
			this.setDepth( parent.getDepth() );
			
			// remove the unused objects
			var	newParent = parent.getParent();
			newParent.removeChild( parent );
			
			// add us in it's place
			this.getParent().removeChild( this );
			newParent.addChild( this );
			
			// fix any lingering stuffs
			this.transformChanged();
		}
		
		// call scroller's stuff
		$super();
		
		this.refresh();
	},
	
	/**
		Causes the table to reload its contents from the data delegate. 
		@task Updates
	*/
	refresh: function()
	{
		if(this.dataDelegate==NULL)
		{
			log("ListView has no data delegate!");
			return;
		}
		if(!this.dataDelegate.numberOfListItems)
			return;	// extroardanary circumstances
		
		// allow cell re-use?
		if ( typeof(this.dataDelegate.allowCellReUse) == 'function' )
			this.allowCellReUse = this.dataDelegate.allowCellReUse(this);
		if ( typeof(this.dataDelegate.isHorizontal) == 'function' )
			this.horzOrient = this.dataDelegate.isHorizontal(this);
		
		// re-use?
		var	numberOfRows = 0;
		var	maxRows = Math.max(0,this.dataDelegate.numberOfListItems(this));
		if ( this.allowCellReUse )
		{
			// do we know cell size?
			if ( this.cells.length <= 0 || !this.sizeView )
				numberOfRows = 1;	// we need at least one
			else {
				// have cell size. how many rows?
				var	cellSize = this.sizeView.getFrame().getSize();
				if (this.horzOrient)
				{
					numberOfRows = Math.ceil( 
						(this.getFrame().getSize().getWidth()+cellSize.getWidth()-1) / cellSize.getWidth() );
				} else {
					numberOfRows = Math.ceil( 
						(this.getFrame().getSize().getHeight()+cellSize.getHeight()-1) / cellSize.getHeight() );						
				}
				
				if ( numberOfRows > maxRows )
					numberOfRows = maxRows;
			}
		} else {
			// cannot reuse cells. create as specified.
			numberOfRows = maxRows;
		}
		
		// empty dataset?
		if ( numberOfRows <= 0 )
		{
			// hide anything we have.
			this.setContentSize( new Core.Size(0,0) );
			for ( var i=0; i<this.cells.length; i++ )
			{
				var	view = this.cells[i].getView();
				if ( !view )
					continue;
				
				view.setFrame( new Core.Rect( [ -10000,-10000 ], view.getFrame().getSize()) );
				this.cells[i].index = -1;
			}
			return;
		}
		
		this.log("refresh. max:"+maxRows+" visible:"+numberOfRows+
			" reUse:"+(this.allowCellReUse?"yes":"no"));
		
		// how many cells do we have?
		if ( this.cells.length < numberOfRows )
		{
			// see if the data delegate sets the cell xib name
			var	cellXib;
			if ( typeof(this.dataDelegate.cellXibName) == 'function' )
				cellXib = this.dataDelegate.cellXibName(this);
			if ( !cellXib )
				cellXib = this.cellXibName;
			
			if ( !cellXib )
			{
				log("ListView has no cell xib specified!");
				return;
			}
			
			for(var i=this.cells.length; i<numberOfRows; i++)
			{
				this.log("Requesting item "+i+"...");
				
				//begin loading a new cell asynchronously
				var newCell = new exports.ListViewElement();
				newCell.index = -1;
				newCell.setOwner(this);
				
				this._activeLoads ++;
				newCell.loadXibNamed(cellXib, this.owner);
				this.cells.push(newCell);
				
				//now we wait for a callback
			}
		}
		
		//
		// Calculate the estimated full table size.
		//
		
		if ( !this.sizeView )
			return;
		
		var	cellSize = this.sizeView.getFrame().getSize();
		if (this.horzOrient)
		{
			this.setContentSize(new Core.Size(
				maxRows * cellSize.getWidth(), cellSize.getHeight() ));			
		} else {
			this.setContentSize(new Core.Size(
				cellSize.getWidth(), maxRows * cellSize.getHeight() ));			
		}
		this.log("content size:"+this.getContentSize());
		
		////////
		// We have enough cells to display the content at hand.  
		////////
		
		//
		// refresh any cells that are already prepared.
		//
		
		for ( var i=0; i<this.cells.length; i++ )
		{
			var	entry = this.cells[i];
			if ( entry.index < 0 )
				continue;
			if ( !entry.getView() )
				continue;
			
			this.dataDelegate.createListEntryAtIndex(this, entry.index, entry);
		}
		
		
		//
		// Have the main handler take over.
		//
		
		this.updateScroll( this.mOffset, true );
	},
	
	/** 
		get the data delegate
		@task Setup
	*/
	getDelegate:	function()	/**Object*/
	{
		return this.dataDelegate;
	},
	
	/** 
		get the controlling Element for the given row.
		@task Working with Elements
	*/
	getElementForRow:	function( /**int*/ row )	/**ListViewElement*/ 
	{
		for ( var i=0; i<this.cells.length; i++ )
		{
			if ( this.cells[i].index == row )
				return this.cells[i];
		}
		return NULL;
	},
	
	/**
		get the controlling Element for the given view.
		Assumes the view is the top level one (doesn't do deep search)
		@task Working with Elements
	*/
	getElementForView:	function( /**GL2.Node*/ view )	/**ListViewElement*/ 
	{
		for ( var i=0; i<this.cells.length; i++ )
		{
			if ( this.cells[i].getView() == view )
				return this.cells[i];
		}
		return NULL;
	},
	
	// @private
	transformChanged:	function( $super )
	{
		$super();
		
		// make sure any loaded cells are the correct dimensions
		for ( var i=0; i<this.cells.length; i++ )
			this.updateCellSize( this.cells[i].getView() );
		
		this.updateScroll( this.mOffset, true );
	},
	
	updateCellSize:	function( cellView )
	{
		if ( !cellView )
			return;
			
		var	cellFrame = cellView.getFrame();
		var	myFrame = this.getFrame();
		if (this.horzOrient)
		{
			cellView.setFrame( new Core.Rect( cellFrame.getOrigin(), 
				[ cellFrame.getSize().getWidth(), myFrame.getSize().getHeight() ] ));
				
		} else {
		
			cellView.setFrame( new Core.Rect( cellFrame.getOrigin(), 
				[ myFrame.getSize().getWidth(), cellFrame.getSize().getHeight() ] ));
		}
		this.log(this+".updateCellSize() "+cellView.getFrame());
	},
	
	/**
		Causes the table to reload one specific row from the data delegate
		@task Updates
	*/
	
	refreshRow: function(/**Integer*/whichRow)
	{
		this.refresh();	// right now, refresh the table. we'll fix this when we need it.
	},
	
	/**
		Force all rows to be repositioned - a "hard refresh".
		@private
	*/
	hardRefresh:	function()
	{
		for ( var i=0; i<this.cells.length; i++ )
			this.cells[i].index = -1;
		this.refresh();
	},
	
	/**
		Where to scroll a given cell into view.  See Xib.ListView#scrollToRowIndex.
		@namespace
	*/
	Position:
	{
		/** If the cell is visible already, do nothing.  If it's higher it moves to top, otherwise bottom */
		None:	0,
		
		/** Move it to the top of the visible area ("front" if horizontal scroller) */
		Top:	1,
		
		/** Move it to the center of the visible area */
		Middle:	2,
		
		/** Move it to the bottom of the visible area ("end" if horizontal) */
		Bottom:	3,
	},
	
	/**
		Scroll a row into view.
		Pass the row index to make visible, and a value from this.Position to indicate where in the view.
		Row indexes start at 0.
		@task Scrolling
	*/
	scrollToRowIndex:	function( /**int*/inRowNum, /**GL2.ListView#Position*/ inPosition )
	{
		if ( inPosition == undefined )
			inPosition = this.Position.None;
		
		if ( this._activeLoads > 0 || this.cells.length <= 0 || this.sizeView == NULL )
		{
			// 'store' the request for processing when loading is done.
			if ( this._pendingNotifications == NULL )
				this._pendingNotifications = new Array;
			this._pendingNotifications.push( {
				proc:this.scrollToRowIndex,
				param1:inRowNum,
				param2:inPosition
			});
			return;
		}
		
		if ( !this.dataDelegate )
			return;
		
		var	maxRows = Math.max(0,this.dataDelegate.numberOfListItems(this));
		if(inRowNum>=maxRows || inRowNum < 0)
		{
			log("Invalid scrollToRowIndex "+inRowNum);
			return;
		}
		
	//	this.log("scrollToRowIndex "+inRowNum+" with position "+inPosition);
		
		// find the entry corresponding to this desired row
		var	rowView;	// it may not really exist right now
		var	i;
		for ( i=0; i<this.cells.length; i++ )
		{
			if ( this.cells[i].index != inRowNum )
				continue;
			
			rowView = this.cells[i].getView();
			break;
		}
		
		var	at = this.getContentOffset();
		if ( rowView && 0 )	// the "work with the row" version appears to be broken.
		{
			//
			// the row exists - work with it directly
			//
			
			// is it visible where is it right now?
			if ( inPosition == this.Position.None )
			{
				if ( this.horzOrient )
				{
					if ( at.getX() < -rowView.getFrame().getMinX() )
						inPosition = this.Position.Top;
					else if ( at.getX() > (-rowView.getFrame().getMaxX() + this.getFrame().getSize().getWidth()) )
						inPosition = this.Position.Bottom;
					else
						return;	// it's visible.
				} else {
					if ( at.getY() < -rowView.getFrame().getMinY() )
						inPosition = this.Position.Top;
					else if ( at.getY() > (-rowView.getFrame().getMaxY() + this.getFrame().getSize().getHeight()) )
						inPosition = this.Position.Bottom;
					else
						return;	// it's visible.
				}
				this.log("chose position (visible): "+inPosition);
			}
			
			if ( this.horzOrient )
			{
				switch ( inPosition )
				{
					case this.Position.Top:
						at = new Core.Point( -rowView.getFrame().getMinX(), 0 );
						break;
					
					case this.Position.Middle:
						at = new Core.Point( -rowView.getFrame().getMidX()+
							(this.getFrame().getSize().getWidth()/2), 0);
						break;
					
					case this.Position.Bottom:
						at = new Core.Point( -rowView.getFrame().getMaxX()+
							this.getFrame().getSize().getWidth(), 0);
						break;
				}
			} else {
				switch ( inPosition )
				{
					case this.Position.Top:
						at = new Core.Point( 0, -rowView.getFrame().getMinY() );
						break;
					
					case this.Position.Middle:
						at = new Core.Point( 0, -rowView.getFrame().getMidY()+
							(this.getFrame().getSize().getHeight()/2));
						break;
					
					case this.Position.Bottom:
						at = new Core.Point( 0, -rowView.getFrame().getMaxY()+
							this.getFrame().getSize().getHeight());
						break;
				}
			}
			
			this.setContentOffset( at );
			
		} else {
			
			//
			// the row does not exist. where *will* it be?
			//
			
			var	size = this.sizeView.getFrame().getSize();
			
			// is it visible where is it right now?
			if ( inPosition == this.Position.None )
			{
				// doesn't exist, so it's offscreen.  Is it above or below current scroll pos?
				if ( this.horzOrient )
				{
					inPosition = ( at.getX() > (size.getWidth() * inRowNum) )?
						this.Position.Top : this.Position.Bottom;
						
				} else {
				
					inPosition = ( at.getY() > (size.getHeight() * inRowNum) )?
						this.Position.Top : this.Position.Bottom;
				}
				
				this.log("chose position (hidden): "+inPosition);
			}
			
			if ( this.horzOrient )
			{
				switch ( inPosition )
				{
					case this.Position.Top:
						at = new Core.Point( -size.getWidth() * inRowNum, 0 );
						break;
					
					case this.Position.Middle:
						at = new Core.Point( -size.getWidth() * (inRowNum+.5)+
							(this.getFrame().getSize().getWidth()/2), 0);
						break;
					
					case this.Position.Bottom:
						at = new Core.Point( -size.getWidth() * (inRowNum+1)-1+
							this.getFrame().getSize().getWidth(), 0);
						break;
				}
			} else {
				switch ( inPosition )
				{
					case this.Position.Top:
						at = new Core.Point( 0, -size.getHeight() * inRowNum );
						break;
					
					case this.Position.Middle:
						at = new Core.Point( 0, -size.getHeight() * (inRowNum+.5)+
							(this.getFrame().getSize().getHeight()/2));
						break;
					
					case this.Position.Bottom:
						at = new Core.Point( 0, -size.getHeight() * (inRowNum+1)-1+
							this.getFrame().getSize().getHeight());
						break;
				}
			}
			
			this.log("scroll "+at+" for "+inPosition);
			this.setContentOffset( at );
		}
	},
	
	/**
		Callback for asynchronous cell xib load
		@private
	*/
	
	listItemReady: function(/**ListViewElement*/element)
	{
		this._activeLoads --;
		this.log("listItemReady A, "+this._activeLoads+" active loads left");
		
		// add the list view to us.
		this.updateCellSize( element.getView() );
		this.addChild(element.getView());
		
		// Do we have a sizing view yet?
		if ( !this.sizeView )
		{
			this.sizeView = element.getView();
			this.refresh();	// will calculate full table size now
		} else {
			// force an update to fill this view in.
			this.updateScroll( this.mOffset, true );
		}
		
		//
		// send out notifications, as needed
		//
		
		if ( this._activeLoads )
			return;
		
		if ( this._pendingNotifications )
		{
			for ( var i=0; i<this._pendingNotifications.size(); i++ )
			{
				this._pendingNotifications[i].proc.call( this, 
					this._pendingNotifications[i].param1, this._pendingNotifications[i].param2 );
			}
			this._pendingNotifications = [];	// clear out
		}		
	},
	
		
	
	/**
		Invoke a method on the delegate in response to an action in a cell we manage
		@private
	*/
	
	cellActionInvoked: function(/**Xib.Button*/ sender, /**integer*/ index, /**string*/ callback)
	{
		eval("this.dataDelegate."+callback+"(sender, index)");
	},


	updateScroll:		function( /**Core.Point*/ inNewPos, /**bool*/ inForce )
	{
		if ( !this.dataDelegate )
			return;
		if ( !this.cells.length )
			return;
		if ( !this.sizeView )
			return;
		
		// pull useful numbers, and get the horizontal or vertical versions, as needed.
		var	cellSize = this.sizeView.getFrame().getSize();
		var	newPos;
		if (this.horzOrient)
		{
			newPos = inNewPos.getX();
			cellSize = cellSize.getWidth();
		} else {
			newPos = inNewPos.getY();
			cellSize = cellSize.getHeight();
		}
		
		// round the new position so it lies on a pixel boundary.
		newPos = Math.round(newPos);
		
		var	diff = newPos - this.lastPos;
		if ( (!inForce) && (!diff) )
			return;	// don't process unnecessarily.
		this.lastPos = newPos;
	//	this.log("diff: "+diff+" newPos:"+newPos);
		
		//
		// Process all previously setup cells.
		//
		
		// what's the limit before one of these is offscreen?
		var	scrollerSize = this.getFrame().getSize();
		scrollerSize = this.horzOrient? scrollerSize.getWidth():scrollerSize.getHeight();
		
		for ( var i=0; i<this.cells.length; i++ )
		{
			var	entry = this.cells[i];
			if ( entry.index < 0 )
				continue;
			
			var	view = entry.getView();
			if ( !view )
				continue;	// shouldn't happen, but just in case.
			
			// offset it.
			var	frame = view.getFrame();
			var	at = frame.getOrigin().clone();
			var	size = frame.getSize();
			
			// is it still onscreen?
			if ( this.allowCellReUse )
			{
				if ( this.horzOrient )
				{
					at.setX( at.getX() + diff );
					if ( (at.getX()+size.getWidth()) < 0 || at.getX() > scrollerSize )
						entry.index = -1;
				} else {
					at.setY( at.getY() + diff );
					if ( (at.getY()+size.getHeight()) < 0 || at.getY() > scrollerSize )
						entry.index = -1;
				}
				if ( entry.index < 0 )
				{
					this.log("cell (b) "+i+" fell offscreen");
					continue;
				}
			} else {
			
				// can't be removed. just update them.
				if ( this.horzOrient )
					at.setX( at.getX() + diff );
				else
					at.setY( at.getY() + diff );
			}
			
			view.setFrame( new Core.Rect( at, size ) );
			this.log(this+".updateScroll() "+view.getFrame());
		}
		
		//
		// Process any cells that are not yet setup.
		//
		
		// what's the first visible cell?
		// Base all this on the first cell object.
		// 0,0 will be no scroll.  As you scroll down, the values will go *negative*.
		// That is, a little bit of down scroll is 0, -5. But the first cell is still visible!
		// And it will be until you reach as much as the first cell's height.
		var	firstVisible = Math.floor( -newPos / cellSize );
		var	lastVisible = Math.ceil( (-newPos+scrollerSize) / cellSize );
		
		// get our true cell count.
		var	maxRows = Math.max(0,this.dataDelegate.numberOfListItems(this));
		if ( lastVisible >= maxRows )
			lastVisible = maxRows - 1;
			
		// where are we starting?
		var	at = this.horzOrient?
			new Core.Point( newPos % cellSize, 0 ) :
			new Core.Point( 0, newPos % cellSize );
		
		// if caller disabled cell re-use, then always line these up.
		if ( !this.allowCellReUse )
		{
			firstVisible = 0;
			lastVisible = maxRows-1;
			at = this.horzOrient?
				new Core.Point( newPos, 0 ) :
				new Core.Point( 0, newPos );
		}
		
	//	this.log("firstVisible:"+firstVisible+"\tlastVisible:"+lastVisible);
		
		// walk our cell list.
		for ( var n=firstVisible; n<=lastVisible; n++ )
		{
			// is this cell handled?
			// While searching, look for an available cell.
			var	good = -1;
			var	available = -1;
			for ( var i=0; i<this.cells.length; i++ )
			{
				if ( this.cells[i].index == n )
				{
					good = i;
					break;
				}
				if ( available < 0 && this.cells[i].index < 0 && this.cells[i].getView() )
					available = i;
			}
			
			var	view;
			// if it's not good and we have one available...
			if ( good < 0 )
			{
				if ( available < 0 )
					break;	// something's broke, dont' continue.
				
				// have delegate fill in the content.
				var	entry = this.cells[available];
				entry.index = n;
				this.dataDelegate.createListEntryAtIndex(this, entry.index, entry);
				
				// row is good.  place it where it belongs.
				view = entry.getView();
				view.setFrame( new Core.Rect( at, view.getFrame().getSize()) );	
				this.log("placed "+available+" at "+at);
			} else
				view = this.cells[good].getView();
			
			// update the origin of the next cell.
			if ( this.horzOrient )
				at.setX( at.getX() + view.getFrame().getSize().getWidth() );
			else
				at.setY( at.getY() + view.getFrame().getSize().getHeight() );
		}
		
		// hide any rows that were left unused.
		for ( var i=0; i<this.cells.length; i++ )
		{
			var	entry = this.cells[i];
			if ( entry.index >= 0 )
				continue;
			
			var	view = entry.getView();
			if ( !view )
				continue;
			if ( view.getFrame().getOrigin().getX() <= -10000 )
				continue;
			
			// hide the row.
			view.setFrame( new Core.Rect( [ -10000,-10000 ], view.getFrame().getSize()) );				
		}
	},
});

function _ListViewDelegate() {}	// for the xCode function popup

exports.ListViewDelegate = Core.Class.subclass(
/** @lends Xib.ListViewDelegate.prototype */
{
	classname: 'ListViewDelegate',
	
	/**
		@class The API that must be supported for a client object to be used as a data delegate for a listView.
		Note that you do not need to actually subclass from this - it is here for reference of the expected
		methods your class must provide.  (A "protocol", as it were.)
		@augments Core.Class
		@constructs the default constructor
	*/
	initialize:	function()
	{
	},
	
	/**
		How many rows to display?.
		Be fast, expect to be called early and often.
		<br><br>
		Required method.
		@task Raw Data
	*/
	numberOfListItems:	function( /**Xib.ListView*/ inTable ) /**int*/
	{
		return 0;
	},
	
	/**
		Prepare the content of the cell with the app-specific information.
		Be fast, expect to be called often.  Elements get re-used, so do not assume the view
		is in the same state it was when loaded from Xib.
		<br><br>
		Required method.
		@task Raw Data
	*/
	createListEntryAtIndex:	function( /**Xib.ListView*/ inTable, /**int*/ inIndex, /**Xib.ListViewElement*/ inOwner )
	{
		
	},
	
	/** 
		Returns if this is a horizontal (true) or vertical (false) scrolling list.
		Overrides Xib.ListView#setIsHorizontalOrientation().
		<br><br>
		Default is false.  Optional method. 
		@task ListView Setup
	*/
	isHorizontal:	function( /**Xib.ListView*/ inTable ) /**bool*/
	{
		return false;
	},
	
	/** 
		Do we want to allow the table to re-use cells so only the visible ones are created at any one time?.
		When off, all cells are created and managed in RAM, rather than just the visible ones.
		<br><br>
		Default is true.  Optional method. 
		@task ListView Setup
	*/
	allowCellReUse:	function( /**Xib.ListView*/ inTable ) /**bool*/
	{
		return true;
	},
	
	/**
		What cell xib template should we use?  Overrides ListView.setCellXib().
		<br><br>
		Optional method. 
		@task ListView Setup
	*/
	cellXibName:	function( /**Xib.ListView*/ inTable ) /**string*/
	{
		return "./Content/myXib.xib";
	},
	
	/**
		Move a row from one place to another in response to the user moving it with a Xib.MovableCellButton.
		<br><br>
		Optional method. 
		@task Data reordering
		@example
// You can reorder an array with...
var	wasEntry = myArray[fromRow];
myArray.splice( fromRow, 1 );
myArray.splice( toRow, 0, wasEntry );
	*/
	moveRowAtIndex:	function( /**Xib.ListView*/ inTable, /**int*/ fromRow, /**int*/ toRow )
	{
		
	},
});


function _ListViewElement() {}	// for the xCode function popup

exports.ListViewElement = Core.Class.subclass(
/** @lends Xib.ListViewElement.prototype */
{
	classname: 'ListViewElement',
	
	/**
		@class A class used as an owner for list cell xibs.
		An array of these will be created and used to load the subviews.
		@constructs
		@augments Core.Class
	*/
	initialize: function()
	{
		// this is a xib outlet that must be filled by user
		this.view = NULL;
		
		// don't use these connection names in the xib.  it would be bad.
		this.owner = NULL;
		this.index = 0;
	},
	
	destroy:	function()
	{
		if ( this.loader )
			this.loader.destroy();
		this.loader = NULL;
	},
	
	// @private
	setOwner: function(/** Object */newOwner)
	{
		this.owner = newOwner;
	},

	// @private
	loadXibNamed: function(/** String */xibName, /**object*/filesOwner)
	{
		//put a loader here, rely on awakefromxib
	//	log("Loading nib "+xibName+" for cell "+this.index);
		this.filesOwner = filesOwner;
		var Loader = require('ngCrunch/Xib/Loader').Loader;
		this.loader = new Loader();
		
		this.loader.parseXib(xibName, this, this, function(isOK) 
		{ 
			this.loader = NULL;	// done with it.
			
			if(!isOK) throw new Error("Failed to load table cell "+xibName); 
			
			// force the top level view to the correct autoresize values that
			// the scroller is expecting.
			this.getView()._AutoresizingMask = 
				DViewAutoresizingFlexibleRightMargin | DViewAutoresizingFlexibleBottomMargin;
			
			//check every xib.button (or other) we loaded for action records, remap them to calls to the owner redirector
			this.captureSentActions(this, this.getView());
			this.owner.listItemReady(this);
			
		}.bind(this));
	},

	// @private
	InstantiateXibClass: function InstantiateXibClass(classname)
	{
		if(typeof this.filesOwner.InstantiateXibClass == 'function')
			return this.filesOwner.InstantiateXibClass(classname);
		else
			return NULL;
	},
	
	/** Get the top level Node we manage. */
	getView: function()
	{
		return this.view;
	},
	
	/** Get our index (0-based) into the source data. */
	getIndex:	function()	/**int*/
	{
		return this.index;
	},
	
	// @private
	captureSentActions : function(/**ListViewElement*/target, /**GL2.Node*/ parent)
	{
		//Check every child of the view to see if it is an ACTION WIDGET. if it is, give us a method matching its selector which forwards the call to the owner
		
		var children = parent.getChildren();

		for(var i=0;i<children.length;i++)
		{
			var node = children[i];
			
			if(typeof node.getSelector == 'function')
			{
			//	log("Found a widget that invokes "+node.getSelector()+", capturing...");
				
				//we need to give ourselves a function with this name so the button can call it on us, then we can turn around
				//and have our owner call it on the datadelegate
				var assembleString = "this."+node.getSelector()+"=function(sender) { this.owner.cellActionInvoked(sender, this.index, \""+node.getSelector()+"\"); };";
				eval(assembleString);
			}
			else if(node.getChildren().length!=0)
				this.captureSentActions(target, node);
		}
	},
	
});


; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/Slider'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/Slider'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/Slider'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/Slider.js';

/*
 *  Slider.js
 *  syntaxCheck
 *
 *  Created by Mark on 4/19/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
var Core  = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Loader = require('ngCrunch/Xib/Loader').Loader;

//TODO: continuous or non-continuous flag
//TODO: snap behavior flag

var	SHOW_KNOB_FRAME = false;

/**
	Displays an interactive control which allows the user to select a value within an allowed range.
	The names of the graphical assets used to display the slider may be changed by subclassing it.
*/

var touchTrampoline = Core.MessageListener.subclass(
{
	classname: 'TouchTrampoline',
	
	initialize: function initialize(/**object*/ owner, /**GL2.TouchTarget*/toucher)
	{
		this.owner = owner;
		
		toucher.getTouchEmitter().addListener(this, this.redirect);
	},

	redirect: function redirect(/**GL2.Touch*/touch)
	{
		return this.owner.onTouch(touch);
	},
});

exports.Slider = GL2.Node.subclass(
{

	classname: 'Slider',
	
	Segments:
	{
		Background: {},				//An image which covers the entire frame of the slider and represents the portion of the bar not selected (to the right of the knob)
		BackgroundSelected: {},		//An optional image which covers the entire frame of the slider and represents the selected portion of the bar (to the left of the knob)
		Knob: {},					//An image which represents the manipulatable part of the slider.
		KnobHighlighted: {},		//An image which represents the manipulatable part of the slider while the user is pressing down on it.
	},

	/**
		Configure a sprite to be used as a component of a slider. The segment argument will be one of the constants in the Segments enumeration. The suggestedFrame argument is the frame of the entire widget.
		This should be overridden by subclasses to return custom graphics. Any optional image may be skipped by returning NULL.
		@task Configuration
	*/
	
	spriteForSegment: function spriteForSegment(/**Xib.Slider.Segment*/ segment, /**Core.Rect*/ suggestedFrame)
	{
		var sprite = NULL;
		
		switch(segment)
		{
			case this.Segments.Background:
				sprite = new GL2.Sprite();
				sprite.setImage('ngCrunch/XibSupport/sliderbackground.png', suggestedFrame.getSize(), new Core.Point(0, 0), new Core.Rect(0, 0, 1, 1));
				break;
			case this.Segments.Knob:
				sprite = new GL2.Sprite();
				sprite.setImage('ngCrunch/XibSupport/sliderknob.png', new Core.Size(suggestedFrame.getSize().getHeight(), suggestedFrame.getSize().getHeight()), new Core.Point(0.5, 0.0), new Core.Rect(0, 0, 1, 1));
				break;
		}
		
		return sprite;
	},

	initialize: function initialize()
	{
		this.minValue = 0;
		this.maxValue = 1.0;
		this.value = 0.5;
		this.background = NULL;
		this.knob = NULL;
		this._toucherSizeMultipler = new Core.Point(1,1);
		this.horzOrient = true;	// we have *not* updated code to handle vertical yet!
		this._isLiveInput = false;
	},

	destroy: function destroy()
	{
        //these have been killed by the recursive destroy in viewcontroller
//		this.knob.destroy();
//		this.background.destroy();
//		this.toucher.destroy();
	},

	initWithXib: function initWithXib($super,  /**xmlElement*/ group, /**Xib.Loader*/loader)
	{
		$super(group, loader);
		
		//iOS version
		this.value = loader.realForKey(group, "IBUIValue", 0.5);
		
		this.minValue = loader.realForKey(group, "IBUIMinValue", 0.0);
		
		this.maxValue = loader.realForKey(group, "IBUIMaxValue", 1.0);
        
		this.continuousFlag = loader.boolForKey(group, "IBUIContinuous", true);
        
		//cocoa version
		
		var cell = loader.objectElementForKey(group, "NSCell");
		
		if(cell)
		{
			this.minValue = loader.realForKey(cell, "NSMinValue", 0.0);
			this.maxValue = loader.realForKey(cell, "NSMaxValue", 1.0);
			this.value = loader.realForKey(cell, "NSValue", 0.5);
            this.continuousFlag = (loader.intForKey(cell, "NSCellFlags") & 0xA0100)===256;
		}
		
		// DDP save us some headaches.
		if ( _NODEJS )
			return;
			
		this.background = this.spriteForSegment(this.Segments.Background, this._frame);
		this.knob = this.spriteForSegment(this.Segments.Knob, this._frame);
		
		// let's be clear about this: we're using ngCrunch style nodes here.
		// If they don't have frames, convert them up
		upgradeToCrunch(this.background);
		upgradeToCrunch(this.knob);
		
		this.addChild(this.background);
		this.addChild(this.knob);
		
		//create a touch handler
		// Attach it to the knob so it moves at same time.
		this.toucher = new GL2.TouchTarget();
		this.toucher.init();
		this.knob.addChild(this.toucher);
		this.toucher.overridesScroller = true;
		
		this.touchMonitor = new touchTrampoline(this, this.toucher);
		
		this.transformChanged();	// this will update all positions.
	},
	
	getToucherSizeMultipler: function getToucherSizeMultipler()
	{
		return this._toucherSizeMultipler;
	},
	
	setToucherSizeMultiplier: function setToucherSizeMultiplier(/**Core.Point*/ newToucherSizeMultiplier)
	{
		switch(arguments.length)
		{
			case 1:
				if ( newToucherSizeMultiplier.getX )
					this._toucherSizeMultipler = newToucherSizeMultiplier;
				else {
					// assume it's a single float value
					this._toucherSizeMultipler = new Core.Point( arguments[0], arguments[0] );
				}
				break;
			
			case 2:
				this._toucherSizeMultipler = new Core.Point( arguments[0], arguments[1] );
				break;
		}
		this.transformChanged();	// this will update all positions.
	},
	
	connectFromXib:	function( /**Object*/ inThing, /**string*/ inConnectionName )	/**bool*/
	{
		this.target = inThing;
		this.selector = inConnectionName.replace(":","");	// remove trailing colon
		return true;
	},
	
	_sendMessageToTarget:	function( isLiveUserInput )
	{
		if(!this.target)			//send the message since we're done
			return;
		
		this._isLiveInput = isLiveUserInput || false;
		var program = "this.target."+this.selector+"(this);"
		eval(program);
		this._isLiveInput = false;
	},
	
	getIsLiveInput:	function()
	{
		return this._isLiveInput;
	},

	getSelector: function getSelector()
	{
		return this.selector;
	},

	setMinValue: function setMinValue(/**float*/newValue)
	{
		this.minValue = newValue;
		
		// do not enforce min/max reasonableness - this may be called in any order
		// We do however enforce current value
		if(this.value < this.minValue)
		{
			this.value = this.minValue;
			this._sendMessageToTarget();
		}
		
		this.transformChanged();	// this will update all positions.
	},

	setMaxValue: function setMaxValue(/**float*/newValue)
	{
		this.maxValue = newValue;

		// do not enforce min/max reasonableness - this may be called in any order
		// We do however enforce current value
		if(this.value > this.maxValue)
		{
			this.value = this.maxValue;
			this._sendMessageToTarget();
		}
		
		this.transformChanged();	// this will update all positions.
	},

	setValue: function setValue(/**float*/newValue)
	{
		this.value = newValue;
		
		if(this.value < this.minValue)
			this.value = this.minValue;
			
		if(this.value > this.maxValue)
			this.value = this.maxValue;

		this.transformChanged();	// this will update all positions.
	},

	getValue: function getValue()
	{
		return this.value;
	},

	transformChanged: function transformChanged($super)
	{
		$super();
		
		// if we aren't ready, do nothing.
		if ( !this.knob )
			return;
		
		if ( this.background )
		{
			// resize background to match new width, do not mess with height.
			// Center it on background.
			var	size = this.background.getFrame().getSize().getHeight();
			this.background.setFrame( 
				0, 
				this.getBounds().getMidY() - (size/2),
				this.getBounds().getSize().getWidth(),
				size );
			
			// make sure knob shows above background.
			this.knob.setDepth( this.background.getDepth() + 1 );
		}
		
		// set size of the touch target. Base on knob, scaled by _toucherSizeMultipler
		var	frame = this.knob.getBounds();
		var at = new Core.Rect( 0,0,
			frame.getSize().getWidth() * this._toucherSizeMultipler.getX(),
			frame.getSize().getHeight() * this._toucherSizeMultipler.getY());
		at.setOriginCentered( new Core.Point( frame.getMidX(), frame.getMidY() ));
		this.toucher.setFrame(at);
		
		// show the touch frame, if we have one.
		if ( SHOW_KNOB_FRAME && this._debugFrame == NULL )
		{
			this._debugFrame = (new GL2.Sprite).init();
			this._debugFrame.setImage( "./ngCrunch/XibSupport/standin.png" );
			this._debugFrame.setImage( "./Content/initial/white.png" );
			this._debugFrame.setAlpha(.7);
			this.toucher.addChild( this._debugFrame );
		}
		if ( this._debugFrame )
			this._debugFrame.setFrame( this.toucher.getBounds() );
		
		// make sure we're in right spot.
		this.updateSlider();
	},
	
	_getTrackBounds:	function()	/**Core.Point*/ 
	{
		// this is the horizontal version.
		return { 
			x: this.getBounds().getSize().getWidth() - this.knob.getFrame().getSize().getWidth(),
			y: this.getBounds().getSize().getHeight() - this.knob.getFrame().getSize().getHeight() 
		};
	},
	
	// called when slider values are changed programmatically.
	updateSlider: function updateSlider()
	{
		if(this.knob!=NULL)
		{
			var fraction = 0;
			var	diff = this.maxValue - this.minValue;
			if ( diff )	// prevent div/0
			{
				fraction = (this.value-this.minValue)/diff;
				if ( fraction < 0 )
					fraction = 0;
				else if ( fraction > 1 )
					fraction = 1;
			}
		
			//the knob is placed within the background so that its edges match at the two extremes
			// This is the horizontal version.
			var	size = this.knob.getFrame().getSize();
			this.knob.setFrame( 
				(this._getTrackBounds().x * fraction), 
				this.getBounds().getMidY() - (size.getHeight()/2),
				size.getWidth(),
				size.getHeight() );
		}
	},

	onTouch: function onTouch(touch)
	{
		switch(touch.getAction())
		{
			case touch.Action.Start:
				if ( this._trackingId && this._trackingId != touch.getId() )
					return true;	// eat it, but ignore content.
					
				var local = this.screenToLocal( touch.getPosition() );
				var current = this.knob.getFrame().getOrigin();
				this._trackingOffset = new Core.Point(
					current.getX() - (this.horzOrient?1:0)*local.getX(), 
					current.getY() - (this.horzOrient?0:1)*local.getY());
				this._trackingId = touch.getId();
				return true;
				
			case touch.Action.Move:
				if(this._trackingId != touch.getId())
					return;
				
				// move the view in question.
				var	wasAt = this.knob.getFrame().getOrigin();
				var local = this.screenToLocal( touch.getPosition() );
				var	current = new Core.Point( 
					(this.horzOrient?1:0)*local.getX() + this._trackingOffset.getX(),
					(this.horzOrient?0:1)*local.getY() + this._trackingOffset.getY() );
				
				// lock to our track
				var	bounds = this._getTrackBounds();
				if ( bounds )
				{
					if ( this.horzOrient )
					{
						if ( current.getX() < 0 )
							current.setX( 0 );
						if ( current.getX() > bounds.x )
							current.setX( bounds.x );
					} else {
						if ( current.getY() < 0 )
							current.setY( 0 );
						if ( current.getY() > bounds.y )
							current.setY( bounds.y );
					}
				}
				
				if ( current.getX() == wasAt.getX() && current.getY() == wasAt.getY() )
					break;
				
				// visually move it
				this.knob.setFrame( new Core.Rect( current, this.knob.getFrame().getSize() ) );
				
				// create a 0...1 range
				var	fraction = this.horzOrient?
					current.getX() / bounds.x :
					current.getY() / bounds.y;
				
				// set value directly, otherwise it transformChanged() and we don't want that.
				this.value = this.minValue + fraction * (this.maxValue - this.minValue);
						
                if(this.continuousFlag)
					this._sendMessageToTarget(true);
                
//				log("moved a touch! "+where+" mapped to progress "+fraction+" ("+(this.minValue + fraction * (this.maxValue - this.minValue))+" pixels)");
				break;
				
				
			case touch.Action.End:
				delete this._trackingId;	// reset for next time.
				
				//TODO: send the action
//				log("Ended a touch! progress: "+this.value);
				
				this._sendMessageToTarget();
				break;
		}
		
		return true;
	},

});

function upgradeToCrunch( node )
{
	if ( node._frame && (node.getFrame().getSize().getWidth() > 0 || node.getFrame().getSize().getHeight() ))
		return;	// already good.
	if ( !node._animation )
		return;	// something wrong with this sprite
	
	node.init();
	var	size = node._animation.getFrame(0).getSize();
	node.setImage( node.getImage() );	// reset anchor and other oddities
	node.setFrame( new Core.Rect( node.getPosition(), size ));
}
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/TabView'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/TabView'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/TabView'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/TabView.js';

/*
 *  TabView.js
 *  syntaxCheck
 *
 *  Created by Mark on 4/11/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
var Core  = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Loader = require('ngCrunch/Xib/Loader').Loader;


/**
	A tab view manages a collection of subviews. One subview is selected as the default view and the others may subsequently be shown programmatically, with the others
	automatically hidden when necessary.
	
	Tab views are only supported in desktop OS X xibs and cannot be created in iOS xibs.

*/


exports.TabView = GL2.Node.subclass(
{
	classname: 'TabView',
	
	initialize: function initialize()
	{
		//some stuff we need
		this.viewIdentifiers = new Array;
		this.subviews = new Array;
		this.currentIdentifier = NULL;
	},

	initWithXib: function initWithXib($super, /**xmlElement*/groupElement, /**Xib.Loader*/ inLoader)
	{
		$super(groupElement, inLoader);
		
		//all our subviews are stored in an array called NSSubviews
		//inside each of these is an NSTabView item and inside each of these is an NSView to load
		//these tab view items also contain the identifiers of the tabs
		var tabitems = inLoader.arrayElementForKey(groupElement, "NSTabViewItems");
		
		if(tabitems==NULL)
			return;
			
		for(var i=0;i<tabitems.length;i++)
		{
			var child = tabitems[i];
			
			if(child.name!="object")
				continue;
			
			//if we got an object, see if it's a tab view item
			
			if(child.attributes["class"].text=="NSTabViewItem")
			{
				//we found a tab view item! grab its label and create its subviews
				
				var label = inLoader.stringForKey(child, "NSLabel", "Tab "+i);			//defaults should probably be unique
				
				this.viewIdentifiers.push(label);
				
				//there is also an element "view" that we have to turn into an actual view
				
				var viewtag = inLoader.objectElementForKey(child, "NSView");
				
				var subview = inLoader.objectFrom(viewtag, inLoader.owner);
				
				subview.setFrame(this.getBounds());
				
				this.subviews.push(subview);
				subview.setPosition(0,0);//this._frame.getSize().getWidth()/2, this._frame.getSize().getHeight()/2);
//				this.addChild(subview);
			}
		}
		
		//one of the children of this element is a reference whose key is one of the tab view items
		//figure out which one it is, and select its tab
		
		var defaultTab = inLoader.objectElementForKey(groupElement, "NSSelectedTabViewItem");
		
		var defaultTabLabel = inLoader.stringForKey(defaultTab, "NSLabel", "DONTEVERNAMEATABTHISITWILLGETVERYCONFUSED");
		
		if(defaultTabLabel!="DONTEVERNAMEATABTHISITWILLGETVERYCONFUSED")
			this.showTab(defaultTabLabel);
		else
			this.showTab(this.viewIdentifiers[0]);			//default to first if we get too confused
		
		this.transformChanged();
	},

	/**
		Show the tab with the passed label, hiding the currently displayed tab. If that tab is currently displayed there is no effect.
		@task Configuration
	*/
	showTab: function showTab(/**string*/tab)
	{
		if(this.currentIdentifier==tab)
			return;
		
		if(this.currentIdentifier)
			this.hideTab(this.currentIdentifier);
		this.revealTab(tab);

		this.currentIdentifier = tab;
	},

	/**
		Remove a view from the screen by name
		@private
	*/

	hideTab: function hideTab(/**string*/tab)
	{
		//locate the tab and remove it from the heirarchy
		var i=0;
		
		for(i=0;i<this.viewIdentifiers.length;i++)
		{
			if(this.viewIdentifiers[i] == tab)
			{
				this.removeChild(this.subviews[i]);		
				return;
			}
		}
		log("Tab view "+tab+" not found");
	},
	
	revealTab: function revealTab(/**string*/tab)
	{
				//locate the tab and remove it from the heirarchy
		var i=0;
		
		for(i=0;i<this.viewIdentifiers.length;i++)
		{
			if(this.viewIdentifiers[i] == tab)
			{
				this.addChild(this.subviews[i]);
				return;
			}
		}
		log("Tab view "+tab+" not found");
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/ProgressBar'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/ProgressBar'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/ProgressBar.js';

/*
 *  ProgressBar.js
 *  syntaxCheck
 *
 *  Created by Mark on 4/11/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
var Core  = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var Loader = require('ngCrunch/Xib/Loader').Loader;
var MoreMath = require('ngCrunch/MoreMath').MoreMath;

/**
	Displays the a proportion of progress or completion as a horizontal thermometer bar.
	The names of the graphical assets used to display the bar may be changed by subclassing it.
*/

exports.ProgressBar = GL2.Node.subclass(
{
	classname: 'ProgressBar',

	
	/**
		The possible segments of the progress bar, which will be passed as arguments to spriteForSegment.
	*/

	Segments:
	{
		Background: {},					//An image which covers the entire frame of the progress view if no background endcaps are used. If they are, it covers the entire portion of the frame which is not covered by the endcaps.
		Progressor: {},					//An image which will be tiled to cover the entire frame of the progress bar if no progressor endcaps are used. If they are, it is tiled to cover the entire portion of the bar which is not covered by the endcaps.
		BackroundLeftCap: {},			//An optional image which will be placed to cover the left end of the view's frame, with the Background adjacent to its right.
		BackgroundRightCap: {},			//An optional image which will be placed to cover the right end of the view's frame, with the Background adjacent to its left. 
		ProgressorLeftCap: {},			//An optional image which will be placed to cover the left end of the view's frame, with the Progressor (or the ProgressorRightCap if it is provided and the length of the bar is zero) adjacent to its right.
		ProgressorRightCap: {},			//An optional image which will be placed to cover the left end of the view's frame, with the Progressor (or the ProgressorRightCap if it is provided and the length of the bar is zero) adjacent to its left.
	},
	
	/**
		Configure a sprite to be used as a component of a progress bar. The segment argument will be one of the constants in the Segments enumeration. The suggestedFrame argument is the frame of the entire widget.
		This should be overridden by subclasses to return custom graphics. Any optional image may be skipped by returning NULL.
		Sprites anchors should always have a horizontal value of zero; if something else is used, it'll be overriden.
		@task Configuration
	*/
	
	spriteForSegment: function(/**Xib.ProgressView.Segment*/ segment, /**Core.Rect*/ suggestedFrame)
	{
		var suggestedSize = suggestedFrame.getSize();
		
		var sprite;
		//label.setPosition(suggestedFrame);
		switch(segment)
		{
			case this.Segments.Background:
				sprite = new GL2.Sprite();
				sprite.setImage(
					'data/progressbackground.png',
					suggestedSize,
					new Core.Point(0.0, 0.0)//, // default anchor
					//new Core.Rect(0.0, 0.0, 20.0, 20.0) // default uvs
					
				);
				break;
			
			case this.Segments.Progressor:
				sprite = new GL2.Sprite();
				sprite.setImage(
					'data/progressbar.png',
					suggestedSize,
					new Core.Point(0.0, 0.0) // default anchor
					//new Core.Rect(0.0, 0.0,  191, 29.0) // default uvs
				);
				break;
			
			default:
				sprite = null;
		}
		
		return sprite;
	},
	
	/**
		Checks to see if the given Sprite is compatible with the needs of the ProgressBar.
		Currently for Background and Progressor sprites, this means checking that the sprite's anchor is horizontally zeroed-out.
		@private
	*/
	_isSpriteValid: function(/**GL2.Sprite*/ sprite, /**Xib.ProgressView.Segment*/ segment)
	{
		switch (segment)
		{
			case this.Segments.Background:
			case this.Segments.Progressor:
				var spriteFrame = sprite._animation.getFrame(0);
				return (spriteFrame.getAnchor().getX() == 0.0);
			
			default:
				return true;
		}
	},
	
	/**
		Corrects invalid traits of sprites to be compatible with the needs of the ProgressBar.
		Heavy-handed; only run if _isSpriteValid() says �no-go�.
		Currently for Background and Progressor sprites, this means re-constructing it using a horizontally zeroed-out anchor and the all the other existing datums.
		@private
	*/
	_validifySprite: function(/**GL2.Sprite*/ sprite, /**Xib.ProgressView.Segment*/ segment)
	{
		switch (segment)
		{
			case this.Segments.Background:
			case this.Segments.Progressor:
				var oldSpriteFrame = sprite._animation.getFrame(0);
				
				var horizontallyZeroedAnchor = new Core.Point(0.0, oldSpriteFrame.getAnchor().getY());
				sprite.setImage(
					oldSpriteFrame.getImage(),
					oldSpriteFrame.getSize(),
					horizontallyZeroedAnchor,
					oldSpriteFrame.getUVs()
				);
				return sprite;
			
			default:
				return sprite; // fine as-is
		}
	},
	
	/**
		Set up a new progress bar.
		@private
	*/
	
	initialize: function()
	{
		this.progressRatio = 0.0;
		this.barHeight = 10.0;
		this.bar = NULL;
		this.background = NULL;
	},

	/**
		Create a progress bar based on a xib record.
		@task Creation
	*/

	initWithXib: function($super, /**xmlElement*/ group, /**Xib.Loader*/loader)
	{
		$super(group, loader);
		
		
		//we now need to create a bunch of sub-objects based on the returns from the image lookup function
		//TODO: endcap support
		var suggestedFrame = this._frame;
		
		this.background = this.spriteForSegment(this.Segments.Background, suggestedFrame);
		if (!this._isSpriteValid(this.background, this.Segments.Background))
			this._validifySprite(this.background, this.Segments.Background);
		
		this.bar = this.spriteForSegment(this.Segments.Progressor, suggestedFrame);
		if (!this._isSpriteValid(this.bar, this.Segments.Progressor))
			this._validifySprite(this.bar, this.Segments.Progressor);
			
		this.addChild(this.background);
		this.background.addChild(this.bar);
		
		var backgroundSize = this.background._animation.getFrame(0).getSize();
		var newBackgroundOffset = new Core.Point(
			-(backgroundSize.getWidth() / 2.0),
			-(backgroundSize.getHeight() / 2.0)
		);
		this.background.setPosition(newBackgroundOffset);
		
		this.transformChanged();
	},
	
	/**
		Set the proportion of progress that the bar displays, which must be between 0 and 1.
		@task configuration.
	*/
	
	setProgress: function(/**float*/progressRatio)
	{
		this.progressRatio = MoreMath.clamp01(progressRatio);
		
		this.updateBar();
	},
	
	/**
		Update the bar's nodes to reflect the current progress.
		@private
	*/
	
	updateBar: function()
	{
		if(this.bar!=NULL)
		{
			this.bar.setScale(this.progressRatio, 1.0);
		}
	},
	
	transformChanged: function($super)
	{
		$super();
	
		this.updateBar();
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/ProgressSpinner'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/ProgressSpinner'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/ProgressSpinner'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/ProgressSpinner.js';

/*
 *  ProgressSpinner.js
 *  syntaxCheck
 *
 *  Created by Slipp on 7/21/2011. Based on ProgressBar.js.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
var Core  = require("NGCore/Client/Core").Core;
var GL2 = require("NGCore/Client/GL2").GL2;
var Loader = require("ngCrunch/Xib/Loader").Loader;


/**
	Displays an indeterminate progress "spinner" (like UIActivityIndicatorView or android.widget.ProgressBar or NSProgressIndicator in indetermine mode)
	The names of the graphical assets used to display the bar may be changed by subclassing it.
*/
exports.ProgressSpinner = GL2.Node.subclass(
{
	classname: "ProgressSpinner",
	
	/**
		Creates GL2.Animation.Framess to be used as graphics for the progress spinner.
		This should be overridden by subclasses in order to customize graphics.
		The number of frames in the animation is determined by the what 'animationFrameIndex' is when this method reports null.
			That is, given an animationFrameIndex higher than the number of frames wanted, this method will (and subclass's versions should) return null.
			For example, if 8 frames of animation are available, calling this method with animationFrameIndex of 0 to 7 should return a new Sprite, but calling with 8 or higher should give back null.
		
		@param animationFrameIndex: The zero-based index in the spinner animation that the sprite should be created for.
		@param suggestedFrame: The suggested layout frame for placement of the new Sprite (not to be confused with animation frames). Given as a suggestion because it may often better to respect the actual graphic dimensions.
		@returns {GL2.Animation.Frame}: The newly-constructed frame of animation.
		
		@task Configuration
	*/
	createFrame: function(/**integer*/ animationFrameIndex, /**Core.Rect*/ suggestedFrame)
	{
		var animFrameNumber = animationFrameIndex + 1; // one-based index, as opposed to the zero-based animationFrameIndex
		var animFrameCount = 6;
		var animFrameDurationMs = 200;
		
		if (animFrameNumber >= 1 && animFrameNumber <= animFrameCount)
		{
			var filepath = "ngCrunch/XibSupport/progressspinner_frame"+(animFrameNumber.toFixed())+".png";
			var frame = new GL2.Animation.Frame(
				filepath,
				animFrameDurationMs,
				suggestedFrame.getSize(),
				new Core.Point(0.0, 0.0), // default anchor
				new Core.Rect(0.0, 0.0, 1.0, 1.0) // default uvs
			);
			
			return frame;
		}
		else
		{
			return null;
		}
	},
	
	/**
		@private
		@task Creation
	*/
	initialize: function()
	{
		this._spinnerSprite = null;
	},
	
	/**
		Create, based on a XIB record.
		
		@task Creation
	*/
	initWithXib: function($super, /**xmlElement*/ group, /**Xib.Loader*/loader)
	{
		$super(group, loader);
		
		var suggestedFrame = this._frame;
		
		
		// Animation setup
		
		var spinnerAnimation = new GL2.Animation();
		spinnerAnimation.setLoopingEnabled(true);
		
		var newAnimFrame = null;
		var animFrameIndex = 0;
		do
		{
			newAnimFrame = this.createFrame(animFrameIndex, suggestedFrame);
			
			if (newAnimFrame == null)
				break;
			
			spinnerAnimation.pushFrame(newAnimFrame);
			
			++animFrameIndex;
		}
		while (true);
		
		this._spinnerAnimation = spinnerAnimation;
		
		
		// Sprite setup
		
		var spinnerSprite = new GL2.Sprite();
		spinnerSprite.setAnimation(this._spinnerAnimation);
		
		this.addChild(spinnerSprite);
		
		this._spinnerSprite = spinnerSprite;
		
		
		this.transformChanged();
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/MovableCellButton'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/MovableCellButton'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/MovableCellButton'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/MovableCellButton.js';

/*
 *  MovableCellButton.js
 *  BigClaw
 *
 *  Created by Dennis on 7/8/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core	= require('NGCore/Client/Core').Core;
var GL2		= require('NGCore/Client/GL2').GL2;
var Button	= require('ngCrunch/Xib/Button').Button;
var TouchListener	= require('ngCrunch/Xib/TouchListener').TouchListener;

var	kPriorityChange	= 20;
var	kTouchOffset = new Core.Point( -5, 5 );

exports.MovableCellButton = Button.subclass(
/** @lends Xib.MovableCellButton.prototype */
{
	classname: 'MovableCellButton',
	
	/**
		@class A button control that drags a listview cell along with it.
		@constructs The default constructor.
		@augments Xib.Button
		@task creation
	*/
	initialize: function()
	{
		// does this list scroll horizontally or vertically?
		// cached at the start of a tap and hold.
		this.horzOrient = false;
		
		// what view is mobile?
		// cached at the start of a tap and hold.
		this.movingView = NULL;
		
		// what scroller contains us?
		// cached at the start of a tap and hold.
		this.scroller = NULL;
		
		// squared because it's a qlen compare. in pels.
		this.kTapVsMoveThreshold = 5*5;
	},
	
	// a touch was found on us.  what now?
	onTouch:	function( /**GL2.Touch*/ touch )
	{
		if ( !this._enabled )
			return false;
		if ( !this.getVisible() )
			return false;
		
		switch ( touch.getAction() )
		{
			case GL2.Touch.Action.Start:
				//
				// get all the objects we're gonna need
				//
				
				// assume the view we'll move is our parent.
				this.movingView = this.getParent();
				
				// find the scroller
				this.scroller = this.movingView.getParent();
				while ( this.scroller && !this.scroller.getIsHorizontalOrientation )
					this.scroller = this.scroller.getParent();
				if ( !this.scroller )
					return false;	// no scroller, no go.
				
				this.horzOrient = this.scroller.getIsHorizontalOrientation();
				
				// does the delegate support reordering?
				if ( (!this.scroller.getDelegate()) || 
					( typeof this.scroller.getDelegate().moveRowAtIndex != 'function' ))
					return false;
				
				//
				// got what we need. start processing.
				//
				this.setHighlighted(true);
				
				this._trackingId = touch.getId();
				this._startPos = touch.getPosition().clone();
				
				var local = this.movingView.getParent().screenToLocal( touch.getPosition() );
				var current = this.movingView.getFrame().getOrigin();
				this._trackingOffset = new Core.Point(
					current.getX() - (this.horzOrient?1:0)*local.getX() + kTouchOffset.getX(), 
					current.getY() - (this.horzOrient?0:1)*local.getY() + kTouchOffset.getY());
			//	log("offset:"+this._trackingOffset);
				
				this.movingView.setDepth( this.movingView.getDepth() + kPriorityChange );
				
				//
				// do an immediate "move", so that the tracking offset is enacted.
				// Use fallthrough
				//
			//	break;
				
			case GL2.Touch.Action.Move:
				if(this._trackingId != touch.getId())
					return;
				
				// move the view in question.
				var local = this.movingView.getParent().screenToLocal( touch.getPosition() );
				var	current = new Core.Point( 
					(this.horzOrient?1:0)*local.getX() + this._trackingOffset.getX(),
					(this.horzOrient?0:1)*local.getY() + this._trackingOffset.getY() );
				
				//
				// have we passed one of the other cells?
				//
				
				// who is above and below me?
				var	myElement = this.scroller.getElementForView( this.movingView );
				var	wasIndex = myElement.getIndex();
				var	aboveElement = this.scroller.getElementForRow( wasIndex - 1 );
				var	belowElement = this.scroller.getElementForRow( wasIndex + 1 );
				var	newElement = NULL;
				
				if ( this.horzOrient )
				{
					if ( aboveElement && this.movingView.getFrame().getMidX() < 
						aboveElement.getView().getFrame().getMidX() )
					{
						newElement = aboveElement;
					}
					else if ( belowElement && this.movingView.getFrame().getMidX() >
						belowElement.getView().getFrame().getMidX() )
					{
						newElement = belowElement;
					}
					
				} else {
				
					if ( aboveElement && this.movingView.getFrame().getMidY() < 
						aboveElement.getView().getFrame().getMidY() )
					{
						newElement = aboveElement;
					}
					else if ( belowElement && this.movingView.getFrame().getMidY() > 
						belowElement.getView().getFrame().getMidY() )
					{
						newElement = belowElement;
					}
				}
				
				// did we change?
				if ( newElement )
				{
					var	newIndex = newElement.getIndex();
					
					// reset to normal
					this.movingView.setDepth( this.movingView.getDepth() - kPriorityChange );
					
					// do initial hard refresh to make cells line up in an expected order
					// Invalidates which cell movingView is connected to, but the view is still useable.
					this.scroller.hardRefresh();
					
					// swap the views around so that when the final animation/hardRefresh
					// happens, they will shift the views the way we want
					var	wasView = this.scroller.getElementForRow( wasIndex ).getView();
					var	otherView = this.scroller.getElementForRow( newIndex ).getView();
					wasView.setFrame( otherView.getFrame() );
					
					// have data delegate update
					this.scroller.getDelegate().moveRowAtIndex( 
						this.scroller, wasIndex, newIndex );
						
					// have table do it's job
					this.movingView.beginAnimation();
					this.scroller.hardRefresh();
					this.movingView.commitAnimation();
					
					// Also, update which is the movingView, as it may have changed.
					this.movingView = this.scroller.getElementForRow( newIndex ).getView();
					this.movingView.setDepth( this.movingView.getDepth() + kPriorityChange );
					this.movingView.removeAnimator();	// don't animate *our* view, we handle it.
				}
				
				// we do this last, as a refresh may happen as part of moveRowAtIndex.
				this.movingView.setFrame( new Core.Rect( current, this.movingView.getFrame().getSize() ) );
				
				//
				// is the user asking us to scroll the cells?
				//
				
				break;
				
			case GL2.Touch.Action.End:
				if(this._trackingId != touch.getId())
					return;
				
				this.movingView.setDepth( this.movingView.getDepth() - kPriorityChange );
				
				this.setHighlighted(false);
				
				// was this a "tap" as opposed to a move?
				var	d = touch.getPosition().sub(this._startPos);
				if ( d.qlen() < this.kTapVsMoveThreshold && this._ID &&
					this.scroller.getDelegate() &&
					typeof this.scroller.getDelegate().moveRowAtIndex == 'function' )
				{
					// move this the direction suggested.
					var	myElement = this.scroller.getElementForView( this.movingView );
					var	newIndex = myElement.getIndex() + (this._ID<0?-1:1);
					if ( newIndex >= 0 && newIndex < this.scroller.getDelegate().numberOfListItems(this.scroller) )
					{
						this.scroller.getDelegate().moveRowAtIndex( 
							this.scroller, myElement.getIndex(), newIndex );
					}
				}
				
				// update anyone who cares to know.
				this.scroller.hardRefresh();
				this.doActionWithDebounce();

				// clear things out
				this.scroller = NULL;
				this._trackingId = NULL;
				this.movingView = NULL;
				break;
			
			default:
				return false;	// we don't know this event. ignore it.
		}
		
		return true;			//ML: Claim this event so we are the target of subsequent move and end messages
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/LegacyNode'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/LegacyNode'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/LegacyNode'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/LegacyNode.js';

/*
 *  LegacyNode.js
 *  syntaxCheck
 *
 *  Created by Dennis on 7/10/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var GL2 = require('NGCore/Client/GL2').GL2;

exports.LegacyNode = GL2.Node.subclass(
/** @lends Xib.LegacyNode.prototype */
{
	classname: 'LegacyNode',

	/**
		@class Wrapper object to support non-frame based nodes
		@constructs The default constructor.
		@augments GL2.Node
	*/
	initialize: function()
	{
		this._anchor = new Core.Point(0.5, 0.5);
		this._baseSize = undefined;
	},
	
	/**
		Set this to change the anchor of subnodes.
		The origin of subviews in ngCrunch is always the center of the object.
		Sometimes it's helpful to lock that origin to a different anchor.
	*/
	setAnchor:	function( /**Core.Point*/ location )
	{
		this._anchor.setAll.apply(this._anchor, arguments);
		this.transformChanged();
		return this;
	},
	
	/**
		Get the anchor point.  
		@see Xib.LegacyNode#setAnchor
	*/
	getAnchor:	function()	/**Core.Point*/
	{
		return this._anchor;
	},
	
	/**
		Set the base size of the contained node.  When you do, it will use setScale on this
		object to keep the submode contained in this object's rectanges.  
		Setting to undefined turns off this ability (resetting scale to 1).
		@example 
			obj.setBaseSize( 100, 20 )
			// when this object's frame is 50x20, it will setScale( .5, 1 )
			// when this object's frame is 100x20, it will setScale( 1, 1 )
			// when this object's frame is 150x20, it will setScale( 1.5, 1 )
	*/
	setBaseSize:	function( /**Core.Point*/ size )
	{
		if ( size == undefined )
		{
			this.setScale(1,1);
			this._baseSize = undefined;
			return;
		}
		
		if ( !this._baseSize )
			this._baseSize = new Core.Point;
		this._baseSize.setAll.apply(this._baseSize, arguments);
		this.transformChanged();
	},
	
	
	transformChanged:	function()
	{
		// we don't actually want the standard behavior, we are overriding it completely.
		
		if ( this._frame == NULL )
			return;	// not setup yet.
		
		// get our key point.
		var	pos = new Core.Point(
			this._frame.getOrigin().getX() + this._frame.getSize().getWidth() * this._anchor.getX(),
			this._frame.getOrigin().getY() + this._frame.getSize().getHeight() * this._anchor.getY() );
		
		// update the transform to match.
		// In order for transforms to build on each other properly,
		// having a parent means our center is offset by the parent's.
		if ( this.getParent() && this.getParent()._frame )
		{
			var	parSize = this.getParent()._frame.getSize();
		//	parSize = parSize.clone();
		//	var	parScale = this.getParent().getScale();	// DDP not sure we need this.
		//	parSize.setWidth( parSize.getWidth() * parScale.getX() );
		//	parSize.setHeight( parSize.getHeight() * parScale.getY() );
			pos.setX( pos.getX() - parSize.getWidth()/2 );
			pos.setY( pos.getY() - parSize.getHeight()/2 );
		} else {
			
		}
		
		this.Node_setPosition( pos );
		
		// update our scale (if desired)
		if ( this._baseSize )
		{
			this.setScale( 
				this._frame.getSize().getWidth() / this._baseSize.getX(),
				this._frame.getSize().getHeight() / this._baseSize.getY() );
		}
	},
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/internal/base64'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/internal/base64'] || {}; $MODULE_REGISTRY['ngCrunch/internal/base64'] = exports; 
var __dirname = 'ngCrunch/internal';
var __filename = 'ngCrunch/internal/base64.js';

/**
* @description
* Takes a string and encodes or decodes base-64.
* @class base64
* @see http://www.webtoolkit.info/
*
**/
var Base64 = {
 
	// private property
	_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
 
	// public method for encoding
    /**
    * @description
    * Takes an input value and returns a base-64 encoded string.
    * @name Base64.encode
    * @function
    * @param String input The input to return as a base-64 encoded string.
    * @return String A base-64 encoded string of the input parameter.
    */
	encode : function (input) {
		if(!input){return "";}

		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		
		input = Base64._utf8_encode(input);
 
		while (i < input.length) {
 
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
 
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
 
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
 
			output = output +
			this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
			this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
 
		}
 
		return output;
	},
 
	// public method for decoding
	decode : function (input) {
		if(!input){return input;}

		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
 
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
 
		while (i < input.length) {
 
			enc1 = this._keyStr.indexOf(input.charAt(i++));
			enc2 = this._keyStr.indexOf(input.charAt(i++));
			enc3 = this._keyStr.indexOf(input.charAt(i++));
			enc4 = this._keyStr.indexOf(input.charAt(i++));
 
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
 
			output = output + String.fromCharCode(chr1);
 
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
 
		}
 
		output = Base64._utf8_decode(output);
 
		return output;
 
	},
 
	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		if(string == undefined) return undefined;
		if(typeof string != "string") string = string.toString();

		var utftext = "";
 
		for (var n = 0; n < string.length; n++) {
 
			var c = string.charCodeAt(n);
 
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
 
		}
 
		return utftext;
	},
 
	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
 
		while ( i < utftext.length ) {
 
			c = utftext.charCodeAt(i);
 
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
 
		}
 
		return string;
	}
 
};

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/Loader'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/Loader'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/Loader'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/Loader.js';

/*
 *  Loader.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/18/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core	= require('NGCore/Client/Core').Core;
var GL2		= require('NGCore/Client/GL2').GL2;
var Storage	= require('NGCore/Client/Storage').Storage;
var XML		= require('ngCrunch/XML').XML;
var TEXT	= require('ngCrunch/TEXT').TEXT;
var JSON	= require('ngCrunch/JSON').JSON;
var Button		= require('ngCrunch/Xib/Button').Button;
var Scroller	= require('ngCrunch/Xib/Scroller').Scroller;
var NSClipView	= require('ngCrunch/Xib/Scroller').NSClipView;
var ListView	= require('ngCrunch/Xib/ListView').ListView;
var Slider		= require('ngCrunch/Xib/Slider').Slider;
var TabView		= require('ngCrunch/Xib/TabView').TabView;
var ProgressBar	= require('ngCrunch/Xib/ProgressBar').ProgressBar;
var ProgressSpinner	= require('ngCrunch/Xib/ProgressSpinner').ProgressSpinner;
var MovableCellButton	= require('ngCrunch/Xib/MovableCellButton').MovableCellButton;
var LegacyNode	= require('ngCrunch/Xib/LegacyNode').LegacyNode;
var	toMD5		= require('NGCore/Shared/Lib/md5').toMD5;
var	base64		= require('ngCrunch/internal/base64').Base64;

// global list of synonyms.  not sure the best place to put this yet.
var	_ClassnameSynonyms = {
	// Cocoa versions
	"NSView":"GL2.Node",
	"NSCustomView":"GL2.Node",
	"NSImageView":"GL2.Sprite",
	"NSTextField":"GL2.Text",
	"NSButton":"Button",
	"NSScrollView":"Scroller",
	"NSClipView":"NSClipView",
	"NSScroller":"-",	// means it won't be created.
	"NSTableView":"ListView",
	"NSSlider": "Slider",
	"NSTabView": "TabView",
	"NSProgressIndicator" : "ProgressBar",

	// UIKit versions
	"IBUIView":"GL2.Node",
	"IBUIImageView":"GL2.Sprite",
	"IBUILabel":"GL2.Text",
	"IBUITextView":"GL2.Text",
	"IBUIButton":"Button",
	"IBUIScrollView":"Scroller",
	"IBUITableView":"ListView",
	"IBUIProgressView": "ProgressBar",
	"IBUIActivityIndicatorView": "ProgressSpinner",
	"IBUISlider": "Slider",

	// custom objects we've added for utility.
	"MovableCellButton":	"MovableCellButton",
	"LegacyNode":	"LegacyNode",

	// TEMP only temporary while testing from older sources
	"DText":"GL2.Text",
	"DSprite":"GL2.Sprite",
	"DButton":"Button",
};

// be sure to add one to this each time you change something in here.
var	kCurrentJsonVersion = 1;

// change this when we know we've broken compatibility with an older version.
var	kCompatibleJsonVersion = 1;


var	_registeredClasses = {};

var	jsonTable = NULL;
var	ramCache = {};
var	wantsCache = {};
var	loadStyle = {};
var	allWaitingLoaders = {};

var	useSmoothLoading = false;


function _Loader() {};	// for the xCode function popup

exports.Loader = Core.Class.subclass(
/** @lends Xib.Loader.prototype */
{
	classname: 'Loader',

	// use try/catch blocks when creating objects?
	useTryCatchOnCreate:	false,

	/**
		Register a custom object with all Loader instances.
		Once an object is registered, it can be used anywhere in the project.
		Typically done all together in the main() function of your app.
		@example
Xib.Loader.registerClass("customClass", function() { return new customClass; } );
	*/
	$registerClass:	function( /**string*/ inName, /**function*/ createProc )
	{
		if ( !_registeredClasses[ inName ] )	log("Xib.Loader registered custom class "+inName);
		_registeredClasses[ inName ] = createProc;
	},

	/**
		Should the loader prefer speed or smoothess?  Most times you want loading done
		as quickly as possible.  However, during transition animations you want it to
		prevent stutter.
		Default is false (fastest possible loading).
	*/
	$setSmoothLoading:	function( /**bool*/ inVal )
	{
		useSmoothLoading = inVal;
		log("Xib.Loader: using smooth loading set to "+inVal);
	},

	/**
		@class Xib file parser.

		<li>raw UI pixel positions don't belong in code, that's what Xibs are for.  Animating from point A to B is fine - but the locations of points A and B should be pulled from the Xib.
		<li>don't add nodes directly to GL2.Root. You're on a subscreen in almost every case imaginable - at most, add new nodes to your subscreen's main view.  Ideally, add a placeholder view to your Xib so you can connect and tweak it that way. (Top-level ViewController nodes are scaled and expanded to fill the target device's screen.  Attaching directly to Root loses all of that 'for free' functionality.)
		<li>Any 'singleton' nodes must be removed from their parent views in the ViewController.viewWillDisappear() methods.  A 'singleton' node is one that is shared between different screens or different instances of a given screen.  (When the ViewController unloads the view, it does a recursive destroy() on the entire view tree, which would destroy a shared node.)

		@constructs The default constructor.
		@task creation
	*/
	initialize: function()
	{
		this._macXib = false;
		this.root = undefined;
		this.mRefToElement = {};
		this.mSpecialObjs = {};
		this.mRefToObj = {};
		this.mRefToClassname = {};
		this.mLoadedObjects = new Array();						//ML: Gather objects for awaken callbacks
		this.taskMaster = new TaskMaster;
	},

	/**
		"cancel" loading a document.  Since we can have outstanding tasks, calling this clears them.
		Note that if you already got your 'complete' callback, you don't need to call this.
	*/
	destroy:	function()
	{
		this.taskMaster.cancelAllTasks();
	},


	/**
		Searches insideElement for the given key and returns the element that defines that
		object, following references.  Expects that the returned object is an array and will
		be iterated across.
		@task utilities
	*/
	arrayElementForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey ) /**xmlElement*/
	{
		var	ret = this.objectElementForKey( insideElement, inKey );
		if ( !ret )
			return ret;

		// convert this into
		return ret;
	},

	/**
		Searches insideElement for the given key and returns the element that defines that
		object, following references.
		@task utilities
	*/
	objectElementForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey ) /**xmlElement*/
	{
		if ( insideElement == undefined )
			return NULL;

		var	val = insideElement[inKey];
		if ( val )
		{
			// before returning, see if this has an object ref for some later part to request.
			if ( val.objectRef )
				this.mRefToElement[val.objectRef] = val;

			return val;
		}

		var	val = insideElement["ref_"+inKey];
		if ( val )
		{
			val = this.mRefToElement[val];
			if ( val )
				return val;

			// hasn't been found yet.
			val = insideElement["ref_"+inKey];
			log("error: objectElementForKey is asking for ref "+val);
		}

		return NULL;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	intForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**int*/
	{
		if ( insideElement == undefined )
			return inDefault;

		var	ret = insideElement[inKey];
		if ( ret != NULL )
			return ret;

		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	boolForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**float*/
	{
		if ( insideElement == undefined )
			return inDefault;

		var	ret = insideElement[inKey];
		if ( ret != NULL )
			return ret;

		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	realForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**float*/
	{
		if ( insideElement == undefined )
			return inDefault;

		var	ret = insideElement[inKey];
		if ( ret != NULL )
			return ret;

		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	stringForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**string*/
	{
		if ( insideElement == undefined )
			return inDefault;

		ret = insideElement[inKey];
		if ( ret != NULL )
		{
			if ( insideElement[inKey+"base64"] )
				return base64.decode( ret );

			return ret;
		}

		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	bytesForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**string*/
	{
		if ( insideElement == undefined )
			return inDefault;

		var	val = insideElement[inKey];
		if ( val != NULL )
			return base64.decode( val );

		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		Returns an object with r,g,b,a keys.
		@task utilities
	*/
	colorForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**Object*/ inDefault ) /**Object*/
	{
		var	val = this.objectElementForKey( insideElement, inKey );
		if ( val == NULL )
			return inDefault;

		// val is an object, get the string...
		val = val.color;
		if ( val )
		{
			var	l = val.split(",");
			if ( l && l.length >= 4 )
				return { r:parseFloat(l[0]), g:parseFloat(l[1]), b:parseFloat(l[2]), a:parseFloat(l[3]) };
		}

		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	colorObjForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**Core.Color*/ inDefault ) /**Core.Color*/
	{
		var	ret = this.colorForKey( insideElement, inKey, NULL );
		if ( !ret )
			return inDefault;

		return new Core.Color( ret.r, ret.g, ret.b );
	},

	////////////////////////////////////////////////////////////////////

	/**
		@private
	*/
	_logObjectCreateErr:	function( err, theClass )
	{
		log("Failing Xib loading registered with " + theClass);
		NgLogException(err,true);
	},

	/**
		@private
	*/
	_objectFrom:	function( /**xmlElement*/ element, /**string*/ theClass, /**object*/ owner )	/**object*/
	{
		var	obj, err;

		//the file's owner gets a chance to instantiate the class
		//this is a hack to get around namespace visibility in the require_ system
		if(obj == NULL && typeof owner.InstantiateXibClass == 'function')
		{
			if ( this.useTryCatchOnCreate )
			{
				try{
					obj = owner.InstantiateXibClass(theClass);
				} catch (er) {
					this._logObjectCreateErr(err, theClass);
					err = er;
				};
			} else
				obj = owner.InstantiateXibClass(theClass);
		}

		// check for an explicitly registered class.
		if ( _registeredClasses[theClass] )
		{
			if ( this.useTryCatchOnCreate )
			{
				try{
					obj = _registeredClasses[theClass]();
				} catch (er) {
					this._logObjectCreateErr(err, theClass);
					err = er;
				};
			} else
				obj = _registeredClasses[theClass]();
		}

		// check for a synonym.
		if ( obj == NULL && _ClassnameSynonyms[theClass] )
		{
			theClass = _ClassnameSynonyms[theClass];
			if ( theClass == "-" )	// check for "don't create" hack.
				return NULL;

			//known class, produce equivalent
		//	log("create object classname "+theClass);

            switch( theClass )
            {
                case "Button":
                    if( Button )
                        obj = new Button;
                    break;
                case "GL2.Text":
                    if( GL2.Text )
                        obj = new GL2.Text;
                    break;
                case "GL2.Sprite":
                    if( GL2.Sprite )
                        obj = new GL2.Sprite;
                    break;
                case "GL2.Node":
                    if( GL2.Node )
                        obj = new GL2.Node;
                    break;
                case "Scroller":
                    if( Scroller )
                        obj = new Scroller;
                    break;
                default:
                    console.log("WARNING ngCrunch: Class not recognized, using eval. theClass=" + theClass);
                    if( this.useTryCatchOnCreate )
                        eval( "try { obj = new " + theClass + "; } catch (er) { this._logObjectCreateErr(err, theClass); err=er; }" );
                    else
                        eval( "obj = new " + theClass + ";" );
                    break;
            }

			// create the object itself.
		}

		// if we got here, there was probably an error.
		if ( obj == NULL )
		{
			if ( err )
			{
				log("Xib loader could not create class "+theClass+", got error "+err);
				NgLogException(err,true);
			} else {
				log("Xib loader could not create class "+theClass+", was not registered or defined.");
			}
			return NULL;
		}

		// have the object initialize itself.
		if ( typeof obj.initWithXib == 'function' )
			obj.initWithXib(element, this);

		return obj;
	},

	objectFrom:	function( /**xmlElement*/ element, /**object*/owner, /**function*/ callback )	/**object*/
	{
		if (( !element.newObjectType ) || ( !element.objectRef ))
		{
			if ( callback )
				callback( NULL );
			return NULL;
		}

		var	refID = element.objectRef;

		// Mark us up so that later object ref requests can see this element.
		this.mRefToElement[refID] = element;

		var	finishTask = function()
		{
			// actually create it.
			var	ret = this._objectFrom( element, element.newObjectType, owner );

			// even if return is NULL, store it.
			this.mRefToObj[refID] = ret;

			//ML: if it wasn't null, queue it up for a callback
			if(ret!=NULL)
				this.mLoadedObjects.push(ret);

			if ( callback )
				callback( ret );
			return ret;

		}.bind(this);

		if ( callback )
			this.taskMaster.addTask( 1, finishTask );
		else
			return finishTask();
	},

	makeConnection:	function( src, dst, label )
	{
		// get the object mentioned as the 'source'.
		var	srcObj = this.mRefToObj[src];
		var	dstObj = this.mRefToObj[dst];
		if ( srcObj == NULL || dstObj == NULL )
		{
		//	log("Xib.Loader failed to connect \""+label+"\" between "+src+" and "+dst+" ("+srcObj+" and "+dstObj+")");
			return;	// one or both was not found.
		}

	//	log("Xib.Loader connecting \""+label+"\" between "+srcObj.classname+" and "+dstObj.classname);

		// for debugging, set the 'name' on the destination as the label here.
		dstObj._viewOwner = label;

		// 'source' is either asking to
		// - fill one of it's outlets, or
		// - set it's target.
		var	isHandled = false;
		if ( typeof srcObj.connectFromXib == 'function' )
			isHandled = srcObj.connectFromXib( dstObj, label );

		// if it wasn't handled, assume that the target object wants this thing
		// as an object property to be played with later.
		if ( !isHandled )
		{
			// build a 'setValue' style acessor method call
			var	callName = "set"+label.charAt(0).toUpperCase() + label.slice(1);

			// does it have the accessor?
			if ( typeof srcObj[callName] == 'function' )
			{
				// call it.  srcObj.callName(dstObj);
				try {
					eval( "srcObj."+callName+"(dstObj);" );
				} catch ( ex ) {
					NgLogException(ex);
				}
			} else {

				// do plain assign
				srcObj[label] = dstObj;
			}
		}
	},

	// actual processor. internal
	_parseXib:	function(hDoc)
	{
		this.root = hDoc;
		this._macXib = this.root.isMacXib;

		// fixup the object ref table for special objects
		for ( var k in this.mSpecialObjs )
		{
			if ( !this.root[k] )
				continue;

			var	refID = this.root[k];
			this.mRefToObj[refID] = this.mSpecialObjs[k];
		}

		//
		// phase: create this.root objects
		//

		for(var i=0;i<this.root.RootObjects.length;i++)
		{
			var element = this.root.RootObjects[i];

			// the object may already exist.
			var	refID = element.objectRef;
			if ( refID && this.mRefToObj[refID] )
				continue;

			// standard object. build it.
			this.objectFrom(element, this.owner);
		}

		//
		// phase: connect objects
		//

		this.taskMaster.addTask( 2, function()
		{
			for(var i=0;i<this.root.Connections.length;i++)
			{
				var element = this.root.Connections[i];

				// find the two references.
				var	src = element.src;
				var	dst = element.dst;
				var label = element.name;

				this.makeConnection( src, dst, label );
			}
		}.bind(this));

		//
		// awakeFromXib on all objects
		//
		this.awakeAllObjects();
	},

	awakeAllObjects:	function()
	{
		this.taskMaster.addTask(2, function()
		{
			//ML: Deliver awaken callback to all objects
			var i=0;
			for(i=0;i<this.mLoadedObjects.length;i++)
			{
				if(typeof this.mLoadedObjects[i].awakeFromXib == 'function' )
					this.mLoadedObjects[i].awakeFromXib();
			}

			//ML: Also deliver it to the owner
			if(typeof this.owner.awakeFromXib == 'function' )
				this.owner.awakeFromXib();

			// final xib load completed callback
			if ( typeof(this.completeProc) == 'function' )
				this.completeProc(true);

		}.bind(this));
	},


	_storeParams:	function(
		/**string*/ inXibPath,
		/**Object*/ inOwner,
		/**Object*/ inFirstResponder,
		/**function*/ inCompleteProc )
	{
		this.owner = inOwner;
		this.completeProc = inCompleteProc;
		this.xibPath = inXibPath;

		// add the passed parameters to the 'special objects' list.
		// Note that adding to this list is *not* retained.
		this.mSpecialObjs["File's Owner"] = inOwner;
		this.mSpecialObjs["First Responder"] = inFirstResponder;

		// create this fake object
		this.mSpecialObjs["Application"] = {};
	},

	/**
		Cache a xib from disk into memory.  Path should look like "Content/myXib.xib".
		Meant for locations where the xib is expected to be loaded often.
		Can remove from cache with removeXibFromCache().
	*/
	$addXibToCache:	function( /**string*/ inXibPath )
	{
		// flag we want to keep it.
		wantsCache[inXibPath] = true;

		// is the item in the cache yet?
		if ( ramCache[inXibPath] )
			return;	// either it's loading or loaded. either way, nothing to see here.

		// is it already being loaded?
		if ( allWaitingLoaders[inXibPath] )
			return;

		// load it.
	//	log("Xib.Loader: adding "+inXibPath+" to ram cache");
		new DiskLoader( inXibPath );
	},

	/**
		Remove a cached xib from memory.  Meant for when you know the xib will no longer
		be needed.  No error is thrown if the file is not in cache.
	*/
	$removeXibFromCache:	function( /**string*/ inXibPath )
	{
		// flag we can dump it.
		wantsCache[inXibPath] = false;
	},


	/**
		Load a xib from disk.  Path should look like "Content/myXib.xib".
		The Owner and FirstResponder will be used in place of the special Xib objects
		of those names.
		This is an asynchronous operation.  Pass a function closure to be called when
		loading is complete, in the form of method( inSuccess ).
		@example
// this is if you're calling from a method of a class
var	parser = new Xib.Loader;
parseXib( "Contents/thing.xib", (function(isOK){ if (isOK) setupFromXib(); }).bind(this));

		Implementors of loaded subclasses, keep in mind that the XML passed to you will
		be restricted as described in XML.serializeToJSON().
	*/
	parseXib:	function(
		/**string*/ inXibPath,
		/**Object*/ inOwner,
		/**Object*/ inFirstResponder,
		/**function*/ inCompleteProc )
	{
		this._storeParams.apply(this,arguments);

		// add this caller to the list of Loaders waiting for the data of the given xib.
		if ( allWaitingLoaders[inXibPath] )
		{
			allWaitingLoaders[inXibPath].push( this );
			return;
		}

		// we're the first one.  start the load
		allWaitingLoaders[inXibPath] = [ this ];

		// have the cache system do the real work.
		new DiskLoader( inXibPath );
	},


	/**
		Some special differences exist in Cocoa vs UIKit xibs.
		This returns true if it's cocoa.
		@task utilities
	*/
	isMacXib:	function()
	{
		return this._macXib;
	},

	/**
		Load a file from the local Contents directory into a buffer.
		This is an async operation, so you must pass a closure to call when loading is done.
		If there was an error, 'data' will be undefined.
		This is a static method, you don't need to allocate a Loader object.
		@example
// this is if you're calling from a method of a class
Xib.Loader.loadFile( "Contents/thing.txt", (function(data){ processData(data); }).bind(this));
		@function
		@name loadFile
		@memberOf Xib.Loader
		@private
	*/
	$loadFile:	function( /**string*/ inPath, /**function*/inClosure )
	{
		TEXT.loadFile( inPath, inClosure );
	},

	/**
		Load a file from the local Contents directory into a buffer.
		This is an async operation, so you must pass a closure to call when loading is done.
		If there was an error, 'data' will be undefined.
		This is a static method, you don't need to allocate a Loader object.
		@example
// this is if you're calling from a method of a class
Xib.Loader.loadXMLFile( "Contents/thing.xml", (function(data){ processData(data); }).bind(this));
		@function
		@name loadXMLFile
		@memberOf Xib.Loader
		@private
	*/
	$loadXMLFile:	function( /**string*/ inPath, /**function*/inClosure )
	{
		XML.loadFile( inPath, inClosure );
	},

	/**
		Load a file from the local Contents directory into a buffer.
		This is an async operation, so you must pass a closure to call when loading is done.
		If there was an error, 'data' will be undefined.
		This is a static method, you don't need to allocate a Loader object.
		@example
// this is if you're calling from a method of a class
Xib.Loader.loadJSONFile( "Contents/thing.json", (function(data){ processData(data); }).bind(this));
		@function
		@name loadJSONFile
		@memberOf Xib.Loader
		@private
	*/
	$loadJSONFile:	function( /**string*/ inPath, /**function*/inClosure )
	{
		JSON.loadFile( inPath, inClosure );
	},
});



function _XML_XibLoader() {};	// for the xCode function popup

exports.XML_XibLoader = exports.Loader.subclass(
{
	classname: 'XML_XibLoader',

	initialize: function()
	{
		this.knownObjRefs = {};
		this.readyToRecord = false;
	},

	/**
		Searches node for the given child node with the given name.
		@task utilities
	*/
	firstChild:	function( /**xmlElement*/ node, /**string*/ lookingFor )	/**xmlElement*/
	{
		if ( node == undefined )
			return undefined;

		var	list = node.childElements;
		var	i,count=list.length;	// it's not a standard 'Array' for some odd reason
		for ( i=0; i<count; i++ )
		{
			if ( list[i].name == lookingFor )
				return list[i];
		}
		return undefined;
	},

	/**
		Searches the root for the given key.
		@task utilities
	*/
	findSection:	function( /**string*/ sectionName )	/**xmlElement*/
	{
		var	list = this.root.childElements;
		var	i,count=list.length;	// it's not a standard 'Array' for some odd reason
		for ( i=0; i<count; i++ )
		{
			if ( !list[i].attributes )
				continue;

			if ( list[i].attributes.key.text == sectionName )
				return list[i];
		}
		return undefined;
	},

	/**
		Searches insideElement for the given key and returns the element that defines that
		object, following references.  Expects that the returned object is an array and will
		be iterated across.
		@task utilities
	*/
	arrayElementForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey ) /**xmlElement*/
	{
		var	ret = this.objectElementForKey( insideElement, inKey );
		if ( !ret )
			return ret;

		// is it a reference?
		if ( insideElement.cache["ref_"+inKey] )
			return ret;

		// add a cache entry
		delete ret.cache;	// dump the non-array it creates by default
		this.addCacheArrayTo( ret, inKey );

		// convert this child array thing to a normal array (remove the indirection)
		var	wasRet = ret;
		ret = ret.childElements;
		ret.parentElement = wasRet.parentElement;

		return ret;
	},

	/**
		Searches insideElement for the given key and returns the element that defines that
		object, following references.
		@task utilities
	*/
	objectElementForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey ) /**xmlElement*/
	{
//		var	group = insideElement.childElements[0];
//		for ( ; group; group=group.nextElementSibling )
		for(var i=0;i<insideElement.childElements.length;i++)
		{
			var group = insideElement.childElements[i];
			if ( group.attributes == NULL )
				continue;

			if(group.attributes.key == NULL)
				continue;
			var	theKey = group.attributes.key.text;
			if ( theKey == NULL )
				continue;

			// match desired key?
			if ( theKey != inKey )
				continue;

			// object or reference?
			switch ( group.name )
			{
				case "real":
					throw new Error("caller is using objectElementForKey when they should use realForKey");
				case "int":
					throw new Error("caller is using objectElementForKey when they should use intForKey");

				case "array":
				case "object":
				case "dictionary":

					// is this a known object reference?
					if ( group.attributes && group.attributes.id &&
						this.knownObjRefs[group.attributes.id.text] &&
						(!insideElement.cache[inKey]) )
					{
						// as far as the cache is concerned, it's a reference.
						this.addCacheTo( insideElement, "ref_"+inKey, group.attributes.id.text );
					//	log("Xib.Loader making a reference from known object "+group.attributes.id.text);

					} else {

						// flag a new subobject here
						this.addCacheObjectTo( group, inKey );

						// find my ID and attach it in case someone has a ref to me.
						if ( group.attributes && group.attributes.id )
						{
							group.cache.objectRef = group.attributes.id.text;
							this.knownObjRefs[group.cache.objectRef] = true;
						}
					}
				return group;
			}
			if ( group.name != "reference" )
				continue;
			if ( group.attributes == NULL )
				continue;
			if ( group.attributes.ref == NULL )
				continue;

			// reference.  where's the original?
			var	refText = group.attributes.ref.text;
			if ( refText == NULL )
				return NULL;	// rare, but does happen.

			// is this a known object reference? if not, the reference order is out of order
			if (( !this.knownObjRefs[refText] ) && this.readyToRecord )
			{
				// we have to attach this as a real defintion and not just a reference
				var	realElem = this.mRefToElement[ refText ];
				if ( realElem )
				{
				//	log("Xib.loader upgrading reference to full content for "+refText);

					// flag a new subobject here
					// We can't do the normal version tho, we have to attach to *this* cache object,
					// instead of it's normal tree parent.
					this.addCacheObjectTo( group, inKey );	// add a cache object to this *reference* obj

					// and then transfer the cache to realElement!
					realElem.cache = group.cache;
					delete group.cache;
					group = realElem;

					group.cache.objectRef = refText;
					this.knownObjRefs[refText] = true;
				}

			} else {
				// this is already known, so OK to passthrough to cache this way.
				this.addCacheTo( insideElement, "ref_"+inKey, refText );
			}
			return this.mRefToElement[ refText ];
		}
		return NULL;
	},

	propListFromGroup:	function( /**xmlElement*/ inSrc ) /**Object*/
	{
		if ( inSrc == NULL )
			return NULL;

		var	ret = {};

		// try the 3.0 interface builder version
		var	keyList = this.objectElementForKey( inSrc, "dict.sortedKeys" );
		var	valList = this.objectElementForKey( inSrc, "dict.values" );
		if ( keyList && valList )
		{
//			var	key = keyList.childElements[0];
//			var	val = valList.childElements[0];
//			for ( ; key && val;
//				key=key.nextElementSibling, val=val.nextElementSibling )
			for(var i=0;(i<keyList.childElements.length) && (i<valList.childElements.length);i++)
			{
				var key = keyList.childElements[i];
				var val = valList.childElements[i];
				if ( key.name != "string" )
					continue;
				switch ( val.name )
				{
					case "string":
						// remember that getting the actual text, you have to get childElements[0].
						ret[key.childElements[0].text] = val.childElements[0].text;
						break;

					// other types will go here.
				}
			}

			return ret;
		}

		// try the 3.2 interface builder
		// each entry is a key/value pair
		////  DDP UNTESTED
//		var	val = inSrc.childElements[0];
//		for ( ; val; val=val.nextElementSibling )
		for(var i=0;i<inSrc.childElements.length;i++)
		{
			var val = inSrc.childElements[i];
			if ( val.attributes == NULL || val.attributes.key == NULL )
				continue;

			// the text value here describes the *value* type. The key is actually an attribute.
            console.log("$$$$$$$$$$$$$$$$$$ > "+JSON.stringify(val.attributes.key));
			var	key = val.attributes.key.text;
			var	txt = val.childElements[0].text;
			ret[key] = txt;
		}

		return ret;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	intForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**int*/
	{
//		var	val = insideElement.childElements[0];
//		for ( ; val; val=val.nextElementSibling )
		for(var i=0;i<insideElement.childElements.length;i++)
		{
			var val = insideElement.childElements[i];
			if ( val.name != "int" )
				continue;

			if ( val.attributes == NULL || val.attributes.key == NULL )
				continue;

			if ( val.attributes.key.text != inKey )
				continue;

			// this is the one.
			var	ret = parseInt( val.childElements[0].text );
			this.addCacheTo( insideElement, inKey, ret );
			return ret;
		}
		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	boolForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**float*/
	{
//		var	val = insideElement.childElements[0];
//		for ( ; val; val=val.nextElementSibling )
		for(var i=0;i<insideElement.childElements.length;i++)
		{
			var val = insideElement.childElements[i];
			if ( val.name != "bool" )
				continue;

			if ( val.attributes == NULL || val.attributes.key == NULL )
				continue;

			if ( val.attributes.key.text != inKey )
				continue;

			// this is the one.
			var	ret = val.childElements[0].text.toLowerCase() == "yes";
			this.addCacheTo( insideElement, inKey, ret );
			return ret;
		}
		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	realForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**float*/
	{
//		var	val = insideElement.childElements[0];
//		for ( ; val; val=val.nextElementSibling )
		for(var i=0;i<insideElement.childElements.length;i++)
		{
			var val = insideElement.childElements[i];
			if ( val.name != "double" && val.name != "float")
				continue;

			if ( val.attributes == NULL || val.attributes.key == NULL )
				continue;

			if ( val.attributes.key.text != inKey )
				continue;

			// this is the one.
			var	ret = parseFloat( val.childElements[0].text );
			this.addCacheTo( insideElement, inKey, ret );
			return ret;
		}
		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	stringForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**string*/
	{
//		var	val = insideElement.childElements[0];
//		for ( ; val; val=val.nextElementSibling )
		for(var i=0;i<insideElement.childElements.length;i++)
		{
			var val = insideElement.childElements[i];
			if ( val.name != "string" )
				continue;
			if ( val.attributes == NULL || val.attributes.key == NULL )
				continue;

			if ( val.attributes.key.text != inKey )
				continue;

			// this is the one.
			// but is there any content?
			if ( val.childElements.length <= 0 )
				return "";

			// check for base64 encoded data.
			if ( val.attributes.type )
			switch ( val.attributes.type.text )
			{
				case "base64-UTF8":
					var	ret = val.childElements[0].text;
					this.addCacheTo( insideElement, inKey, ret );
					this.addCacheTo( insideElement, inKey+"base64", true );
					return base64.decode( ret );
			}

			var	ret = val.childElements[0].text;
			this.addCacheTo( insideElement, inKey, ret );
			return ret;
		}
		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		@task utilities
	*/
	bytesForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**string*/ inDefault ) /**string*/
	{
//		var	val = insideElement.childElements[0];
//		for ( ; val; val=val.nextElementSibling )
		for(var i=0;i<insideElement.childElements.length;i++)
		{
			var val = insideElement.childElements[i];
			if ( val.name != "bytes" )
				continue;
			if ( val.attributes == NULL || val.attributes.key == NULL )
				continue;

			if ( val.attributes.key.text != inKey )
				continue;

			// this is the one.
			var	ret = val.childElements[0].text;
			this.addCacheTo( insideElement, inKey, ret );
			return base64.decode( ret );
		}
		return inDefault;
	},

	/**
		Searches insideElement for the given key and returns the corresponding value.
		Returns an object with r,g,b,a keys.
		@task utilities
	*/
	colorForKey:	function( /**xmlElement*/ insideElement, /**string*/ inKey, /**Object*/ inDefault ) /**Object*/
	{
		var	group = this.objectElementForKey( insideElement, inKey );
		if ( group == NULL )
			return inDefault;

		// does it have an 'embedded' color?
		var	sub = this.objectElementForKey( group, "NSColor" );
		if ( sub )
			group = sub;

		var	r,g,b,a;
		var	d, match;
		var	ret;

		// we try each of the 'formats' as we go.
		{
			// the result is a string!  how crazy?
			d = this.bytesForKey( group, "NSWhite" );
			if ( d )
			{
				var	c = parseFloat(d);
			//	log("white color "+c+" from "+d);
				var	ret = { r:c, g:c, b:c, a:1 };
				this.addCacheTo( group, "color", ret.r+","+ret.g+","+ret.b+","+ret.a );
				delete group.cache.NSWhite;
				return ret;
			}
		}

		{
			// the result is a string!  how crazy?
			d = this.bytesForKey( group, "NSRGB" );
			match = /(.*?) (.*?) (.*?) (.*)/.exec(d);
			if ( match )
			{
				r = parseFloat(match[1]);
				g = parseFloat(match[2]);
				b = parseFloat(match[3]);
				a = parseFloat(match[4]);
				if ( a == NULL || a == NaN )
					a = 1;
			//	log("parsed color {"+r+","+g+","+b+","+a+"} from "+d);
				var	ret = { r:r, g:g, b:b, a:a };
				this.addCacheTo( group, "color", ret.r+","+ret.g+","+ret.b+","+ret.a );
				delete group.cache.NSWhite;
				return ret;
			}

			match = /(.*?) (.*?) (.*)/.exec(d);
			if ( match )
			{
				r = parseFloat(match[1]);
				g = parseFloat(match[2]);
				b = parseFloat(match[3]);
			//	log("parsed color {"+r+","+g+","+b+",+1} from "+d);
				var ret = { r:r, g:g, b:b, a:1 };
				this.addCacheTo( group, "color", ret.r+","+ret.g+","+ret.b+","+ret.a );
				delete group.cache.NSWhite;
				return ret;
			}
		}

		return inDefault;
	},

	////////////////////////////////////////////////////////////////////

	/**
		@private
	*/
	scanForIDs:	function( inParent )
	{
		var	list = inParent.childElements;
		var	i,count=list.length;	// it's not a standard 'Array' for some odd reason
		for ( i=0; i<count; i++ )
		{
			var	element = list[i];
			var	isOK = false;
			switch ( element.name )
			{
				case "object":
				case "array":
				case "set":
					isOK = true;
			}
			if ( !isOK )
				continue;

			if ( element.attributes && element.attributes.id )
			{
				var	idCode = element.attributes.id.text;
				this.mRefToElement[idCode] = element;	// store a ref so we can find it again later
			}

			// recursive search
			this.scanForIDs( element );
		}
	},

	/**
		@private
	*/
	scanCustomClassnames:	function()
	{
		// go find the the flattened objects dict
		var	groupElem = this.findSection("IBDocument.Objects");
		if ( groupElem == NULL )
			return;
		var	subElem = this.objectElementForKey( groupElem, "flattenedProperties" );
		if ( subElem == NULL )
			return;

		var	flatInfo = this.propListFromGroup( subElem );
		if ( flatInfo == NULL )
			return;

		// and the object records that lists keys for flattenedProperties
		subElem = this.objectElementForKey( groupElem, "objectRecords" );
		if ( subElem )
			subElem = this.objectElementForKey( subElem, "orderedObjects" );
		if ( subElem == NULL )
			return;

		// walk the source object records.
//		var	key = subElem.childElements[0];
//		for ( ; key; key=key.nextElementSibling )
		for(var i=0;i<subElem.childElements.length;i++)
		{
			var key = subElem.childElements[i];
			if ( key.name != 'object' )
				continue;

			// what's the reference ID?
			// have to scan child elements for the 'object' reference.
			// can't use objectElementForKey because the objects have already been created by then.
			var	refID = 0;

//			var	sub = key.childElements[0];
//			for ( ; sub; sub=sub.nextElementSibling )
			for(var j=0;j<key.childElements.length;j++)
			{
				var sub = key.childElements[j];
				if ( sub.name != "reference" )
					continue;
				if ( sub.attributes == NULL )
					continue;
				if ( sub.attributes.key == NULL )
					continue;
				if ( sub.attributes.key.text != "object" )
					continue;

				refID = sub.attributes.ref.text;
				break;
			}

			// to support Mac xibs, watch for some special objectNames.
			// (They happen to be the same IDs in iPhone xibs, but they're already handled.)
			var	objName = this.stringForKey( key, "objectName" );
			var	objElem = this.objectElementForKey( key, "object" );
			if ( this.mSpecialObjs[objName] && objElem.attributes && objElem.attributes.id )
			{
				var	refID = objElem.attributes.id.text;
				this.mRefToObj[refID] = this.mSpecialObjs[objName];
				this.cache[objName] = refID;
			}

			//
			// Back to regular task.
			// get the object ID.
			var	val = this.intForKey( key, "objectID" );

			// check for any "user defined runtime attributes"
		//	checkForUserRuntimeAttributes( val, this.mRefToElement[refID] );

			//
			// is there a custom classname recorded for this objectID?
			var	name = val+".CustomClassName";
			var	customClass = flatInfo[name];
			if ( customClass == NULL )
				continue;

			this.mRefToClassname[refID] = customClass;
		}
	},

	objectFrom:	function( /**xmlElement*/ element, /**object*/owner, /**function*/ callback )	/**object*/
	{
		if ( element.name != "object" || element.attributes == NULL || element.attributes.id == NULL )
		{
			if ( callback )
				callback( NULL );
			return NULL;
		}

		var	refID = element.attributes.id.text;

		// do we have a custom class for this ref?
		var	theClass;
		if ( this.mRefToClassname[refID] )
		{
			theClass = this.mRefToClassname[refID];
		} else {
			theClass = element.attributes["class"].text;

			// check for Mac nib's 'custom object' key.
			theClass = this.stringForKey(element, "NSClassName", theClass);
		}

		var	finishTask = function()
		{
		// actually create it.
		this.addCacheTo( element, "newObjectType", theClass );
		this.addCacheTo( element, "objectRef", refID );
		this.knownObjRefs[refID] = true;	// flag that this is a known one
		var	ret = this._objectFrom( element, theClass, owner );

		// even if return is NULL, store it.
		this.mRefToObj[refID] = ret;

		//ML: if it wasn't null, queue it up for a callback
		if(ret!=NULL)
			this.mLoadedObjects.push(ret);

			if ( callback )
				callback( ret );
		return ret;

		}.bind(this);

		if ( callback )
			this.taskMaster.addTask( 1, finishTask );
		else
			return finishTask();
	},

	// actual processor. internal
	_parseXib:	function(hDoc)
	{
		this.cache = {};	// explicitly *not* added to hDoc at the topmost level.

		// start the Cache object.
		this.cache.doc_version = kCurrentJsonVersion;

		//ML: new XML loader exposes root directly
		this.root = this.firstChild(hDoc, "data" );
		if ( this.root == undefined )
			throw new Error("can't find data root");

		// check for mac vs iPhone xib.
		var	archiveType = hDoc.attributes.type.text;
		this._macXib = archiveType.endsWith(".Cocoa.XIB");
		this.cache.isMacXib = this._macXib;
	//	log("archive type: "+(this._macXib?"cocoa":"uikit"));

		//
		// phase: get original object refs to populate this.mRefToElement
		//

		var	groupElem = this.findSection("IBDocument.RootObjects");
		if ( groupElem == undefined )
			throw new Error("can't find IBDocument.RootObjects");

		this.addCacheArrayTo( groupElem, "IBDocument.RootObjects" );
		this.cache.RootObjects = groupElem.cache;

		this.scanForIDs(groupElem);

		//
		// phase: get any custom classnames
		//

		this.scanCustomClassnames();

		//
		// phase: create this.root objects
		//

		this.readyToRecord = true;
		for(var i=0;i<groupElem.childElements.length;i++)
		{
			var element = groupElem.childElements[i];
			if ( element.name != "object" )
				continue;
			if ( element.attributes == NULL || element.attributes.id == NULL )
				continue;

			// the object may already exist.
			var	refID = element.attributes.id.text;
			if ( this.mRefToObj[refID] )
				continue;

			// handle special case of proxy objects.
			// The this.mSpecialObjs system makes this unnecessary, and it creates double-refs to the
			// proxy objects.
			if ( element.attributes["class"] && element.attributes["class"].text == "IBProxyObject" )
			{
				var	key = this.stringForKey(element, "IBProxiedObjectIdentifier");
				this.cache.RootObjects.pop();	// remove the key created by 'stringForKey'
				switch ( key )
				{
					case "IBFilesOwner":
						this.mRefToObj[refID] = this.mSpecialObjs["File's Owner"];
						this.cache["File's Owner"] = refID;
						break;

					case "IBFirstResponder":
						this.mRefToObj[refID] = this.mSpecialObjs["First Responder"];
						this.cache["First Responder"] = refID;
						break;
				}
				continue;	// move on
			}

			// standard object. build it.
			this.objectFrom(element, this.owner, function() {} );
		}

		this.taskMaster.addTask( 2, function()
		{

		// finish last phase
		this.readyToRecord = false;

		//
		// phase: connect objects
		//

		groupElem = this.findSection("IBDocument.Objects");
		if ( groupElem == NULL )
			throw new Error("can't find IBDocument.Objects");

		this.addCacheArrayTo( groupElem, "IBDocument.Objects" );
		this.cache.Connections = groupElem.cache;

		groupElem = this.objectElementForKey( groupElem, "connectionRecords" );
		if ( groupElem == NULL )
			throw new Error("can't find connectionRecords");

		for(var i=0;i<groupElem.childElements.length;i++)
		{
			var element = groupElem.childElements[i];
			if ( element.name != "object" )
				continue;
			if ( element.attributes == NULL || element.attributes["class"] == NULL )
				continue;
			if ( element.attributes["class"].text != "IBConnectionRecord" )
				continue;

			var	sub = this.objectElementForKey( element, "connection" );
			if ( sub == NULL )
				continue;

			// find the two references.
			var	src, dst;
			for(var j=0;j<sub.childElements.length;j++)
			{
				var list = sub.childElements[j];
				if ( list.name != "reference" )
					continue;
				if ( list.attributes == NULL || list.attributes.key == NULL )
					continue;

				var	type = list.attributes.key.text;
				if ( type == "source" )
					src = list.attributes.ref.text;
				else if ( type == "destination" )
					dst = list.attributes.ref.text;
			}

			if ( src == NULL || dst == NULL )
				continue;	// one or both was not found.

			// special case for mac nibs - action records reverse source/destination.
			if ( sub.attributes && sub.attributes["class"] &&
				sub.attributes["class"].text == "IBActionConnection" )
			{
				var	t = src;	src = dst;	dst = t;
			}

			var label = this.stringForKey( sub, "label" );

			// add the connection record to the saved cache.
			this.cache.Connections.push({
				name:label,
				src:src,
				dst:dst
			});

			this.makeConnection( src, dst, label );
		}
		}.bind(this));

		this.awakeAllObjects();
	},



	addCacheObjectTo:	function( /**xmlNode*/ srcElement, /**string*/ key )
	{
		if ( srcElement.cache == NULL )
		{
			srcElement.cache = {};

			// find a parent element to attach us to.
			var	parent = srcElement.parentElement;
			while ( parent )
			{
				if ( parent.cache )
					break;

				parent = parent.parentElement;
			}
			if ( parent && parent.cache )
				parent.cache[key] = srcElement.cache;
		}
	},

	addCacheArrayTo:	function( /**xmlNode*/ srcElement, /**string*/ key )
	{
		if ( srcElement.cache == NULL )
		{
			srcElement.cache = [];

			// find a parent element to attach us to.
			var	parent = srcElement.parentElement;
			while ( parent )
			{
				if ( parent.cache )
					break;

				parent = parent.parentElement;
			}
			if ( parent && parent.cache )
				parent.cache[key] = srcElement.cache;
		}
	},

	// add this element to the cached dictionary tree
	addCacheTo:	function( /**xmlNode*/ srcElement, /**string*/ key, /**Object*/value )
	{
		if ( srcElement.cache == NULL )
		{
			srcElement.cache = {};

			// find a parent element to attach us to.
			var	parent = srcElement.parentElement;
			while ( parent )
			{
				if ( parent.cache )
					break;

				parent = parent.parentElement;
			}
			if ( parent && parent.cache )
			{
				// if it's an array, add to it.
				if ( parent.cache.hasOwnProperty("length") )
					parent.cache.push( srcElement.cache );

			}
		}

		// does the item already exist in the target?
		if ( srcElement.cache[key] != NULL )
		{
			// TODO - make sure the target types are compatible.
		//	if ( typeof(srcElement.cache[key])
		}

		// assign it
		srcElement.cache[key] = value;
	},
});


function upconvertLoaderIfNeeded( srcObj, inXibPath )
{
	// do we need to convert the parse objects to RealLoaders?
	switch ( loadStyle[inXibPath] )
	{
		case "simple":
			return srcObj;

		default:
			if ( srcObj.classname == "XML_XibLoader" )
				return srcObj;
	}

	// make new object
	var	dstObj = new exports.XML_XibLoader;
	// copy across fields
	for ( var k in srcObj )
	{
		if ( typeof(srcObj[k]) == 'function' && k != 'completeProc' )
			continue;
		if ( k == 'classname' )
			continue;	// let this stick

		dstObj[k] = srcObj[k];
	}

	// replace with new obj
	return dstObj;
}

function distributeAllWaitingLoaders( hDoc, inXibPath )
{
	// is this requested to go to the xib cache?
	if ( wantsCache[inXibPath] && !ramCache[inXibPath] )
	{
		ramCache[inXibPath] = hDoc;
		log("Xib.Loader: ram cached "+inXibPath);
	}

	var	savedErr;
	var	list = allWaitingLoaders[inXibPath];
	if ( list == NULL )
		return;	// all done.

	while ( list.length )
	{
		// catch errors thrown by a completion proc
		try {
			// catch errors thrown by parser or awakeFromXib
			//try {

				// do the real processing
				var	srcObj = list.shift();
				srcObj = upconvertLoaderIfNeeded( srcObj, inXibPath );
				srcObj._parseXib(hDoc);

			//} catch ( err ) {

				// warn caller
			//	log("Error: parseXib "+err+" while loading "+inXibPath);
			//	NgLogException( err, true );
			//	if ( typeof(list[i].completeProc) == 'function' )
			//		list[i].completeProc(false);
			//}
		} catch ( err2 ) {
			// keep one so we can re-throw it
			if ( savedErr )
				NgLogException( err2, true );
			else
				savedErr = err2;
		}
	}
	delete allWaitingLoaders[inXibPath];	// all done.

	if ( savedErr )
		throw savedErr;
}

function _DiskLoader() {};	// for the xCode function popup

DiskLoader = Core.Class.subclass(
{
	classname: 'DiskLoader',

	initialize:	function( /**string*/ inXibPath )
	{
		this.xibPath = inXibPath;

		// does this xib exist in the RAM cache?
		if ( ramCache[inXibPath] )
		{
			this.log("using ram cache");
			distributeAllWaitingLoaders( ramCache[inXibPath], inXibPath );
			return;	// nobody will have references, this object will be deleted.
		}

		/* Psuedocode:
		Xib is requested
		Does json file match the xib?
			Check file ram cache.  Is it a known file?
			Not one loaded so far:
				Load xib. MD5 text, compare to a MD5 table on disk
		*/

		// in Flash, always use the original Xib,
		// to prevent an exception searching for the JSON file.
	//	if ( _FLASH )
	//		loadStyle[inXibPath] = "xml";

		// attempt to load a serialized json
		var	jsonPath = inXibPath + ".json";

		// check load style cache. what's is it's state?
		switch ( loadStyle[inXibPath] )
		{
			case "simple":
				// start the simplified json path
				this.log("using simple json");
				JSON.loadFile( jsonPath, function(hDoc)
				{
					// because of how this was called.
					var	inXibPath = this;

					// call all the parsers.
					distributeAllWaitingLoaders( hDoc, inXibPath );

				}.bind(inXibPath));
				return;

			case "json":
				// start the json path
				this.log("using json");
				JSON.loadFile( jsonPath, function(hDoc)
				{
					// because of how this was called.
					var	inXibPath = this;

					// reconsititute the XML extras as needed
					XML.deserializeJSON(hDoc);

					// call all the parsers.
					distributeAllWaitingLoaders( hDoc, inXibPath );

				}.bind(inXibPath));
				return;

			case "xml":
				// start the xml path
				this.log("using xml");
				XML.loadFile( this.xibPath, function(hDoc)
				{
					// because of how this was called.
					var	inXibPath = this;

					// call all the parsers.
					distributeAllWaitingLoaders( hDoc, inXibPath );

				}.bind(inXibPath));
				return;

			case "fnf":
				// simply cannot find the file.
				log("Exception: parseXib can't find any file for "+this.xibPath);
				if ( typeof(this.completeProc) == 'function' )
					this.completeProc(false);
				return;
		}

//
//		// is the MD5 table loaded yet?
//		if ( jsonTable == NULL )
//		{
//			jsonTable = {invalid:true};
//			JSON.loadFile("./xibCache.json", function(data)
//			{
//				if ( data == NULL )
//					data = {};
//				jsonTable = data;
//				this._testXib();
//
//			}.bind(this));
//		}

		// flag that we are "in process" with this xib.
		loadStyle[inXibPath] = [this];

		// load the original Xib *and* json, so that we can make accurate decisions.
		this._jsonContent = this._xmlContent = undefined;

		JSON.loadFile( jsonPath, function(data){
			if ( !data )
				data = {};
			this._jsonContent = data;
			this._testXib();
		}.bind(this) );

//		// load as *TEXT*.
//		TEXT.loadFile( this.xibPath, function(data){
//			if ( !data )
//				data = "";
//			this._xmlContent = data;
//			this._testXib();
//		}.bind(this) );
	},

	log:	function(message)
	{
		if ( _DEBUG && 0 )	// enable debug logging
			log( "Xib.Loader: "+message+" for "+this.xibPath );
	},

	_testXib:	function()
	{
		/*
			Test cases:
			- json not there
			- xml not there, json there
			- json out of sync with xml
			- xml not there, json not there
			- json in sync with xml
			- json only
			- failure inside an awakeFromXib
			- failure inside a "failed to load" callback
		*/

		// are both sides loaded yet?
		if ( this._jsonContent == NULL )	// actual objects
			return;
//		if ( this._xmlContent == NULL )	// Text source, not parsed XML
//			return;
//		if ( jsonTable == NULL || jsonTable.invalid )
//			return;

		var	jsonValid = this._jsonContent.name || this._jsonContent.doc_version? true:false;
//		var	xmlValid = this._xmlContent.length > 16;            //ML: reject xmlContent of "404 Not Found"
        var xmlValid = false;

		var	inXibPath = this.xibPath;	// convenience
		var	crc = undefined;

		// deal with plain old not found.
		if ( (!jsonValid) && ( !xmlValid ) )
		{
			// warn future callers
			loadStyle[inXibPath] = "fnf";
			this.log("file not found");

			// tell everyone waiting on it.
			var	list = allWaitingLoaders[inXibPath];
			var	savedErr;
			if ( list != undefined && list.length )
			{
				for ( var i=0; i<list.length; i++ )
				{
					if ( typeof(list[i].completeProc) == 'function' )
					{
						try {
							list[i].completeProc(false);
						} catch ( err ) {
							if ( savedErr )
								NgLogException( err, true );
							else
								savedErr = err;
						}
					}
				}
			}
			delete allWaitingLoaders[inXibPath];	// all done.

			if ( savedErr )	// re-throw it.
				throw savedErr;
			return;
		}

//		// if both json and xml exist, check if xib matches saved MD5 checksum.
//		if ( jsonValid && xmlValid )
//		{
//			// calc md5...
//			crc = toMD5( this._xmlContent );
//			if ( (jsonTable[inXibPath] == crc) || (jsonTable[inXibPath] == undefined))      //ML: missing table entry means JSON takes precedence
//			{
//				// it's good.  change flags so JSON is used,
//				// then fall through to that parser.
//				xmlValid = false;
//				this.log("xml crc matches stored, using json");
//			} else {
//				// does not match.  mark json invalid.
//				jsonValid = false;
//				this.log("xml crc bad, using xml");
//			}
//		}

		// check fairly obvious situation: JSON only, no Xib.
		// Must use JSON, like it or not.
		if ( jsonValid && ( !xmlValid ) )
		{
			// is this the 'simplified' version?
			var	isSimple = this._jsonContent.doc_version != NULL;

			loadStyle[inXibPath] = isSimple?"simple":"json";

			// do the conversion of json to full xml ourselves,
			// then pass through XML handler.
			this.log("using "+(isSimple?"simple ":"")+"json");

			// if it turns out we need to "reconstitute" anything into the json objects,
			// this is the place to do it.
			if ( !isSimple )
				XML.deserializeJSON( this._jsonContent );

			// Let all callers know.
			distributeAllWaitingLoaders( this._jsonContent, inXibPath );
			return;
		}
//
//		// at this point XML is good.
//		// Before caching a JSON file, make sure the XML parses.
//		loadStyle[inXibPath] = "xml";
//		this.log("using xml");
//		var	hDoc = XML.parseText( this._xmlContent );
//		distributeAllWaitingLoaders( hDoc, inXibPath );
	},
});


var	nameSrc = 1;

function _TaskMaster() {};	// for the xCode function popup
/**
	Tracks the tasks specific to the owning object
*/
var	TaskMaster = Core.Class.subclass(
{
	classname:	'TaskMaster',

	initialize:	function()
	{
		this.tasks = [];
		this.name = nameSrc;
		nameSrc ++;
		this.log("created");
	},

	cancelAllTasks:	function()
	{
		this.tasks = [];
	},

	log:	function( s )
	{
		if ( _DEBUG && 0 )	// enable logging
			log("TaskMaster"+this.name+" "+s);
	},

	/** add a proc. pass a low-numbered "phase", lower numbers are done first. */
	addTask:	function( phase, proc )
	{
		this.log("added task in phase "+phase);

		// make room for the phase
		while ( this.tasks.length <= phase )
			this.tasks.push([]);

		this.tasks[phase].push( proc );

		TaskManager.registerMaster(this);
	},

	/** Run a single task. Rarely needed, as addTask starts this per-frame. */
	runTask:	function() /**bool*/
	{
		// find lowest phase with something to do.
		for ( var i=0; i<this.tasks.length; i++ )
		{
			var	list = this.tasks[i];
			if ( list.length == 0 )
				continue;

			var	task = list.shift();
			task();

			this.log("Ran task, "+this.countTasks()+" tasks left");
			return true;
		}
		this.log("drained");
		return false;
	},

	countTasks:	function()	/**int*/
	{
		var	ret = 0;
		for ( var i=0; i<this.tasks.length; i++ )
		{
			var	list = this.tasks[i];
			ret += list.length;
		}
		return ret;
	},
});

function _TaskManager() {};	// for the xCode function popup
/**
	Hidden class used by TaskMaster that distributes time across all tasks.
*/
var	TaskManager = Core.MessageListener.singleton(
{
	// we're a singleton, OK to do this here.
	masters:	[],
	active:		false,
	kTasksPerFrame:	10,

	registerMaster:	function( who )
	{
		// OK to push same master multiple times
		this.masters.push(who);

		// are we currently active?
		if ( this.active )
			return;

		// make us active.
		this.active = true;

		if ( _NODEJS )
		{
			this.timer = setInterval( this.onFrame.bind(this), 1 );
			return;
		}

		Core.UpdateEmitter.addListener(this, this.onFrame, 0);
	},

	onFrame:	function()
	{
	//	log("TaskManager onFrame");

		// any tasks left?
		if ( this.masters.length <= 0 )
		{
			// remove us from active state.
			this.active = false;
			if ( _NODEJS )
			{
				clearInterval( this.timer );
				this.timer = NULL;
				return;
			}
			Core.UpdateEmitter.removeListener(this);
			return;
		}

		// how many tasks should we run?
		var	numDone = 0;
		var	numTasks = useSmoothLoading? this.kTasksPerFrame : 10000;
		for ( var i=0; i<numTasks; i++ )
		{
			// get topmost master
			var	master = this.masters[0];

			// Run task, and ask if more tasks to do
			if ( master.runTask() )
				continue;

			master.log("removed from list");
			// this one is empty on tasks. remove from list.
			this.masters.shift();
			if ( this.masters.length <= 0 )
				break;

			// give extra task for this frame.
			i --;
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/Alert'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/Alert'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/Alert'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/Alert.js';

/*
 *  Alert.js
 *
 *  Created by Mark on 3/11/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 

var Core  = require('NGCore/Client/Core').Core;
var Loader	= require('ngCrunch/Xib/Loader').Loader;
var Navigation = require('ngCrunch/Xib/Navigation').Navigation;
var ViewController = require('ngCrunch/Xib/ViewController').ViewController;
var Button = require('ngCrunch/Xib/Button').Button;

exports.Alert = ViewController.subclass(
/**@lends Xib.Alert.prototype*/
{
	classname: 'Alert',
	
	/**
		The possible replies passed to the callback to indicate the user's 
	*/
	
	Reply:
	{
		OK: {},
		Cancel: {},
		Other: {},
	},
	
	/**
		@class Generic alert dialog. Pass a method to handle the reply, a title, a message, and 0-3 buttons. The first button is the default. If there are zero buttons passed, one button titled "OK" will be created.
		@constructs Default initializer
		@task creation
		
		
	*/

	initialize: function(/**Callback*/replyHandler,/**String*/inTitle, /**String*/inBody, /**String*/inButton0, /**String*/inButton1, /**String*/inButton2, /**String*/baseXib)
	{
		//first, load our xib
		this.titleText = inTitle;
		this.bodyText = inBody;
		this.button0Name = inButton0;
		this.button1Name = inButton1;
		this.button2Name = inButton2;
		this.callback = replyHandler;
		
		//TODO: layouts based on button setup
		
        if(baseXib!=undefined)
            this.initWithXib(baseXib);            
        else
            this.initWithXib("./ngCrunch/XibSupport/alertview.xib");
		
		Navigation.presentModalView(this, false, false);
	},
	
	/**
		Handles initialization of the alert view
		@private
	*/
	awakeFromXib: function()
	{
		//on callback, configure
		this.title.setText(this.titleText);
		this.body.setText(this.bodyText);
		
		if(this.button0Name!=NULL)
			this.okButton.setText(this.button0Name);
		else
			this.okButton.setVisible(false);
			

		if(this.button1Name!=NULL)
			this.cancelButton.setText(this.button1Name);
		else
			this.cancelButton.setVisible(false);

		if(this.button2Name!=NULL)
			this.otherButton.setText(this.button2Name);
		else
			this.otherButton.setVisible(false);
	},

	/**
		A button was pressed. Notify caller and delete self.
		@private
	*/

	buttonClicked: function(/**Button*/sender)
	{
		var whichButton;
		
		if(sender==this.okButton)
			whichButton = this.Reply.OK;
		else if(sender==this.cancelButton)
			whichButton = this.Reply.Cancel;
		else if(sender==this.otherButton)
			whichButton = this.Reply.Other;
			
		//Notify caller
		if (this.callback != null)
		this.callback(whichButton);
		//Remove us
		
		Navigation.removeModalView(false);
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib/TouchCallbackManager'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib/TouchCallbackManager'] || {}; $MODULE_REGISTRY['ngCrunch/Xib/TouchCallbackManager'] = exports; 
var __dirname = 'ngCrunch/Xib';
var __filename = 'ngCrunch/Xib/TouchCallbackManager.js';

/*
 *  TouchCallbackManager.js
 *  syntaxCheck
 *
 *  Created by Mark Andersson on 12/7/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core  = require('NGCore/Client/Core').Core;


exports.TouchCallbackManager = Core.Class.singleton(
{
	classname:		'TouchCallbackManager',
	
	////////////////////////////////////////////////////////////////
	
	debugObject:	false,
	
	////////////////////////////////////////////////////////////////
	
	/**
		@class Class to add callback functions that are called when touch events are received.
		
		@constructs The default constructor.
		@augments Core.Class.singleton
		@task creation
	*/
	initialize:	function( )
	{
		if (this.debugObject)
		{
			log("TouchCallbackManager: initialize()");
		}
		
		// Make an empty list of callbacks:
		this._callbackList	= [];
	},
	
	////////////////////////////////////////////////////////////////
	
	/**
		Add another function to the callback list that should be
		called when touch events are received to do other
		processing such as visual effects. The called function should
		take a single touch object as an argument.
		@task Setup
	*/
	
	addCallback: function addCallback( /**Object*/ inOwner, /**function*/ inCallback )
	{
		if (this.debugObject)
		{
			log("TouchCallbackManager: addCallback()");
		}
		
		// See if the callback already exists.
		// If it does, update the callback.
		for ( var i = 0; i < this._callbackList.size(); i++ )
		{
			// See if this owner matches the one stored for this callback:
			if ( this._callbackList[i].owner == inOwner )
			{
				// Store the new callback function overwriting the old one:
				this._callbackList[i].proc = inCallback;
				
				return;
			}
		}
		
		// Add the callback to the list:
		this._callbackList.push( { owner:inOwner, proc:inCallback } );
		
		if (this.debugObject)
		{
			log("TouchCallbackManager: addCallback() - now have " + this._callbackList.size() + " items in the callback list.");
			log("TouchCallbackManager: addCallback() - added owner " + inOwner + " and function " + inCallback);
		}
	},
	
	////////////////////////////////////////////////////////////////
	
	/**
		Remove a callback function from the callback list.
		@task Teardown
	*/
	
	removeCallback: function removeCallback( /**Object*/ inOwner )
	{
		if (this.debugObject)
		{
			log("TouchCallbackManager: removeCallback()");
		}
		
		// See if the callback can be found:
		for ( var i = 0; i < this._callbackList.size(); i++ )
		{
			// See if this owner matches the one stored for this callback:
			if ( this._callbackList[i].owner == inOwner )
			{
				// First remove the entry:
				this._callbackList.splice( i, 1 );
				
				// Then recheck the entry:
				i--;
			}
		}
	},
	
	////////////////////////////////////////////////////////////////
	
	/**
		Internally called function that calls all the callback
		functions in the callback function list. There's no need
		to call this yourself.  This is called internally from
		Xib.TouchListener as well as Xib.Navigation in the case
		where a touch event falls to the input shield and is not
		captured by any other controls like buttons and the like.
		@private
	*/
	
	callCallbacks: function callCallbacks( /**GL2.Touch*/ touch )
	{
		if (this.debugObject)
		{
			log("TouchCallbackManager: callCallbacks() - have " + this._callbackList.size() + " items in the callback list.");
		}
		
		// Go through and call all the callbacks stored:
		for ( var i = 0; i < this._callbackList.size(); i++ )
		{
			this._callbackList[i].proc(touch);
			
			if (this.debugObject)
			{
				log("TouchCallbackManager: callCallbacks() - called callback number " + i);
			}
		}
	},
	
	////////////////////////////////////////////////////////////////
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/Xib'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/Xib'] || {}; $MODULE_REGISTRY['ngCrunch/Xib'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/Xib.js';

/*
 *  Xib.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/18/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */
 
/**
 * @name Xib
 * @namespace
 * Utilities for loading Interface Builder Xib files
 */
exports.Xib =
{
	// this is done separately because they do not actually define classes of their own.
	extensions:		require('ngCrunch/Xib/GL2Extensions'),
	nodeExtensions:			require('ngCrunch/Xib/nodeExtensions'),
	
	Loader:			require('ngCrunch/Xib/Loader').Loader,
	
	TouchListener:	require('ngCrunch/Xib/TouchListener').TouchListener,
	Button:			require('ngCrunch/Xib/Button').Button,
	Navigation:		require('ngCrunch/Xib/Navigation').Navigation,
	_Navigation:	require('ngCrunch/Xib/Navigation')._Navigation,
	ViewController:	require('ngCrunch/Xib/ViewController').ViewController,
	AnimatorMixin:	require('ngCrunch/Xib/ViewController').AnimatorMixin,
	Scroller:		require('ngCrunch/Xib/Scroller').Scroller,
	NSClipView:		require('ngCrunch/Xib/Scroller').NSClipView,
	Alert:			require('ngCrunch/Xib/Alert').Alert,
	ListView:		require('ngCrunch/Xib/ListView').ListView,
	ProgressBar:	require('ngCrunch/Xib/ProgressBar').ProgressBar,
	ProgressSpinner:require('ngCrunch/Xib/ProgressSpinner').ProgressSpinner,
	Slider:			require('ngCrunch/Xib/Slider').Slider,
	TabView:		require('ngCrunch/Xib/TabView').TabView,
	TouchCallbackManager:	require('ngCrunch/Xib/TouchCallbackManager').TouchCallbackManager,
	
	// private class for Xib script system
	XML_XibLoader:	require('ngCrunch/Xib/Loader').XML_XibLoader,
};


; return exports;};
$MODULE_FACTORY_REGISTRY['ngCrunch/BatchNetworkMessenger'] = function(){var exports = $MODULE_REGISTRY['ngCrunch/BatchNetworkMessenger'] || {}; $MODULE_REGISTRY['ngCrunch/BatchNetworkMessenger'] = exports; 
var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/BatchNetworkMessenger.js';

/*
 *  BatchNetworkMessenger.js
 *  Blackjack
 *
 *  Created by Dennis on 4/4/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

var Core	= require('NGCore/Client/Core').Core;
var XHR		= require('NGCore/Client/Network').Network.XHR;
var JSON	= require('ngCrunch/JSON').JSON;

/**
	@name BatchNetworkMessenger
	@class
	@augments Core.Class
*/

exports._BatchNetworkMessenger = Core.Class.subclass(
/** @lends BatchNetworkMessenger.prototype */
{
	classname: 'BatchNetworkMessenger',
	
	initialize: function()
	{
		XHR.prototype.DONE = 4;
		XHR.prototype.OK = 200;
		
		// are we done getting ready?
		this._isReady = false;
		
		// time between server calls in seconds.
		this.kBatchDelay=	30;
		
		// credentials
		this._credentials=	undefined;
		
		// plus+ session
		this._session=	undefined;
		
		// game server session
		this._request=   {}; //The GameServerRequest object that is used to communicate with game server
		
		// message list waiting to be sent
		this._sendList=	[];
		
		// message list that is currently being sent.
		this._curSend=	undefined;
		
		// message list waiting for client to process.
		this._recvList=	[];
		
		// number of items we're currently waiting on.
		// During startup, call startDone() otherwise call startRequest().
		// Started at one so we wait for setCredentials.
		this._waitItems=	1;
		
		// procs to call when new messages come in.
		this.loadedMessageProcs = [];
		
		// load up previous dataset
		this._loadState();
	},
	
	log:	function( message )
	{
		if ( debugSettings.BatchNetworkMessenger )
			log(this.classname+" "+message);
	},
	
	_loadState:	function()
	{
		// load the last dataset from disk.
		this._waitItems ++;
		Storage.KeyValueCache.local.getItem("batchNetworkMessenger.dump", function(err, value, key)
		{
			// error or not, startup the suspend listener.
			// listen for auto-save times
			new exports.BatchNetworkMessenger.suspendListener( this );
			
			if ( err )
			{
				log(this.classname+" failed to load previous data: "+err);
				this.startDone();
				return;
			}
			
			// parse it out.
			var	ret = JSON.parse( value );
			if ( ret._sendList )
				this._sendList = this._sendList.concat( ret._sendList );
			if ( ret._recvList )
				this._recvList = this._recvList.concat( ret._recvList );
			if ( ret._curSend )
				this._curSend = ret._curSend;
			
			this.log("loaded previous data " );
		//	this.log("loaded previous data "+value);
		//	this.log("loaded previous data "+JSON.stringify(this._recvList)+" from "+value);
			
			var	procList = this.loadedMessageProcs;	this.loadedMessageProcs = [];
			for ( var i=0; i<procList.length; i++ )
			{
				try {
					procList[i]( this._recvList );
				} catch ( err ) {
					NgLogException( err, true );
				}
			}
			
			// do tests.
		//	this.TestWaitingMessageQueue();
			
			this.startDone();
		}.bind(this));
	},
	
	_saveState:	function()
	{
		// snapshot our current state.
		var	dump = {
			_sendList:	this._sendList,
			_recvList:	this._recvList,
			_curSend:	this._curSend
		};
		dump = JSON.stringify( dump );
		Storage.KeyValueCache.local.setItem("batchNetworkMessenger.dump", dump, function(err, value, key)
		{
			if ( err )
				log( this.classname+" failed to write current data: "+err );
			else
				this.log( "saved current data "/*+dump*/ );
				
		}.bind(this));
	},
	
	/**
		set the plus+ login information for this app, gathered from the plus+ admin.  
		This is the point when the first server request will be sent.
		
		Required keys:
		<li>appName - "SmallClaw"
		<li>appVersion - "1.0"
		<li>consumerKey - "xxxxxxxxxxxxxxxxxxxxxx"
		<li>consumerSecret - "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
		<li>userName = "johnny"
		<li>userPass = "mnemonic"
	*/
	setCredentials:	function( /**Object*/ credentials )
	{
		this._credentials = credentials;

		if ( !credentials.userName )
		{
			if ( !_FLASH )
			{
				var Social = require('NGCore/Client/Social').Social;
				var	user = Social.US.Session.getCurrentSession().user();
				this._credentials.userName = user.gamertag;
			} else
				this._credentials.userName = Core.Capabilities.getUniqueId();
			this.log("got gamertag "+this._credentials.userName);
		}
		
		this.log( "setCredentials: "+this._credentials.userName );
		
		// were we given a list of ports?
		var	match = credentials.gameServerPort.toString().search(/\,/);
		if ( match != -1 )
		{
			this.log("matched at "+match+" from "+credentials.gameServerPort );
			credentials.gameServerPort = credentials.gameServerPort.split(",");
		} else {
			// make an array out of it
			credentials.gameServerPort = [ credentials.gameServerPort ];
		}
		
		// save
		if ( credentials.batchDelay )	this.kBatchDelay = credentials.batchDelay;
		
		// startup
		this.startDone();
	},
	
	/**
		Send a JSON message.  The passed 'type' value will be added to the message for you.
		'k', 'i', and 'a' are reserved keys, please don't use them in your messages.
	*/
	SendMessage:	function( /**string*/ inType, /**Object*/ inMessage )
	{
		inMessage.k = inType;
		this._sendList.push( inMessage );
	},
	
	/**
		Search the current message list for the next message with the given key.
		The message is automatically removed from the Queue.
		Returns NULL for none found.
	*/
	PullNextMessageOfType:	function( /**string*/ inType ) /**Object*/
	{
		// scan the message list.
		for ( var i=0; i<this._recvList.size(); i++ )
		{
			if ( this._recvList[i].k == inType )
			{
				var	ret = this._recvList[i];
				this._recvList.splice(i,1);
				this.log(".PullNextMessageOfType pulled "+inType)
				return ret;
			}
		}
		return NULL;
	},
	
	/**
		Search the current message list for the next message with the given key.
		Unlike PullNextMessageOfType, the message is left in the Queue.
		Returns NULL for none found.
	*/
	PeekNextMessageOfType:	function( /**string*/ inType ) /**Object*/
	{
		// scan the message list.
		for ( var i=0; i<this._recvList.size(); i++ )
		{
			if ( this._recvList[i].k == inType )
				return this._recvList[i];
		}
		return NULL;
	},
	
	
	/**
		Search the current message list for the last message with the given key.
		Any other messages with the same type are optionally deleted from the Queue.
		@param Boolean [inDeleteRest=false]
	*/
	PeekLastMessageOfType:	function( /**string*/ inType, inDeleteRest ) /**Object*/
	{
		var	ret = NULL;
		var	i;
		
		// scan the message list.
		for ( i=this._recvList.size()-1; i>=0; i-- )
		{
			if ( this._recvList[i].k == inType )
			{
				ret = this._recvList[i];
				break;
			}
		}
		
	//	if ( ret )	this.log(".PeekLastMessageOfType pulled "+inType)
		
		// delete rest?
		if ( !inDeleteRest )
			return ret;
		
		// yea, walk list.
		for ( i--; i>=0; i-- )
		{
			if ( this._recvList[i].k == inType )
				this._recvList.splice(i,1);
		}
		
		if ( _DEBUG && 1 )	// check that PeekLastMessageOfType left one there
		{
			if ( ret && this.PeekNextMessageOfType(inType) == NULL )
				log(this.classname+".PeekLastMessageOfType accidentally deleted last "+inType);
		}
		
		return ret;
	},
	
	/**
		Return a list of all message keys waiting to be processed.
	*/
	GetAllWaitingMessageTypes:	function() /**Array[string]*/
	{
		var	ret = [];
		for ( var i=0; i<this._recvList.size(); i++ )
			ret.push( this._recvList[i].k );
		return ret;
	},
	
	/**
		For debugging, push a fake server side message to the received list.
	*/
	DebugAddWaitingMessage:	function( /**string*/ inType, /**Object*/ inMessage )
	{
		inMessage.k = inType;
		this._recvList.push( inMessage );
	},
	
	TestWaitingMessageQueue:	function()
	{
		var	i, n, ret;
		var	types = [ "one", "two", "three" ];
		
		this._recvList = [];	// clear out so test is clearer
		for ( i=1,n=0; i<=10; i++,n++ )
			this.DebugAddWaitingMessage( types[n%types.length], { v:i } );
		
		this.log("TestWaitingMessageQueue, base list: \n"+JSON.stringify(this._recvList));
		
		ret = this.PeekNextMessageOfType( "two" );
		this.log("TestWaitingMessageQueue, peek \"two\", got "+JSON.stringify(ret)+", \nlist: "+JSON.stringify(this._recvList));
		ret = this.PullNextMessageOfType( "three" );
		this.log("TestWaitingMessageQueue, pull \"three\", got "+JSON.stringify(ret)+", \nlist: "+JSON.stringify(this._recvList));
		
		ret = this.PeekLastMessageOfType( "one", false );
		this.log("TestWaitingMessageQueue, peek last \"one\", got "+JSON.stringify(ret)+", \nlist: "+JSON.stringify(this._recvList));

		ret = this.PeekLastMessageOfType( "three", true );
		this.log("TestWaitingMessageQueue, peek last \"three\" delete others, got "+JSON.stringify(ret)+", \nlist: "+JSON.stringify(this._recvList));
	},
	
	/**
		Begin a new request earlier than standard.
	*/
	StartRequestEarly:	function()
	{
		if ( !this._isReady )
			return;
		
		// currently waiting on response?
		if ( this._waitItems > 0 )
			return;
		
		// actually start it.  Do *not* re-register the timer
		this.startRequest(false);
	},
	
	/**
		Add a callback for when new messages come in from the server.
		This list is cleared/reset once called.
	*/
	AddNewMessageProc:	function( /**function( Array allMessages)*/ proc )
	{
		this.loadedMessageProcs.push(proc);
	},
	
	/**
		Mixin class to save our data state.
		@private
	*/
	$suspendListener:	Core.MessageListener.subclass(
	{
		initialize:	function( inOwner )
		{
			this.owner = inOwner;
			Device.LifecycleEmitter.addListener(this, this.callback);			
		},
		
		callback: function(event)
		{
			switch ( event )
			{
				case Device.LifecycleEmitter.Event.Suspend:
				case Device.LifecycleEmitter.Event.Terminate:
					this.owner._saveState();
			}
		},
	}),
	
	startDone:	function()
	{
		this._waitItems --;
		if ( this._waitItems > 0 )
		{
			this.log("still waiting for "+this._waitItems+" startup items to complete");
			return;
		}
		this._waitItems = 0;	// just in case
		this._isReady = true;
		
		// start the real timer.
		this.startRequest();
	},
	
	startRequest:	function( /**bool*/ inStartTimer )
	{
		if ( inStartTimer == undefined || inStartTimer )
		{
			// start next timer.  yes, we have it call ourselves
			// We do this before waiting on next in case of any issues.
			invokeAfterDelay( this.kBatchDelay, this.startRequest.bind(this) );
		} else
			this.log("skipping timer start");
		
		// are we waiting on something still?
		if ( this._waitItems > 0 )
		{
			this.log("still waiting for "+this._waitItems+" to complete");
			return;
		}
		this._waitItems = 0;	// just in case.
		
		// verify we have require_d items
		// This shouldn't ever fail.
		if ( this._credentials == undefined )
			return;
		
		// begin a request
		var	req = new XHR;
		req.onreadystatechange = function()
		{
			// this is the callback after the request is complete
			if ( req.readyState != req.DONE )
				return;	// don't care about anything till it's done.
			
			// flag we're done with this request, allow a new one to begin.
			this._waitItems --;
			
			// all good?
			if ( req.status != req.OK )
			{
				log(this.classname+" comm failure: "+req.status+" "+req.responseText);
				return;
			}
			
			// parse the content out
			try {
				var	ret = JSON.parse( req.responseText );
				if ( typeof(ret) == 'object' && ret.length != null )
				{
					var	wasLen = this._recvList.length;
					this._recvList = this._recvList.concat( ret );
					if ( this._recvList.length < wasLen )
						throw new Error( "How did we go *down* after a concat? "+JSON.stringify(this._recvList));

					// success!
					this._curSend = undefined;	// mark the last data as sent.
					
				} else
					throw new Error( "list isn't an object? "+typeof(ret));
					
			} catch ( err ) {
				this.log("error parsing server response: "+err);
				NgLogException( err, true );
			}
			
			// log recieved messages
			if ( 1 )
			{
				var	list = [];
				for ( var i=0; i<this._recvList.length; i++ )
					list.push(this._recvList[i].k);
				this.log("now has messages of type:"+list.join(", "));
			}
			
			// save us.
			this._saveState();
			
			var	procList = this.loadedMessageProcs;	this.loadedMessageProcs = [];
			for ( var i=0; i<procList.length; i++ )
			{
				try {
					procList[i]( this._recvList );
				} catch ( err ) {
					NgLogException( err, true );
				}
			}
		}.bind(this);
		
		
		// what data shall we send?
		if ( this._curSend == undefined )
		{
			this._curSend = this._sendList;
			this._sendList = [];	// clear it
		}
				
		// choose a port to send on.
		var	port = this._credentials.gameServerPort;
		port = port[Math.round(Math.random()*(port.length-1))];
		
		// this is the rest of the callback creation.
		var	url = "http://"+this._credentials.gameServerAddress+":"+port+"/"+
			this._credentials.appVersion+"/"+
			this._credentials.appName+"/"+
			this._credentials.userName+"/group";
		this.log(url);
		req.open("POST", url, true );
		req.setRequestHeader("Content-Type","application/json");
		var	content = JSON.stringify(this._curSend);
		this._waitItems ++;
		req.send( content );
	},
});

exports.BatchNetworkMessenger = exports._BatchNetworkMessenger.singleton({});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Xib/XibUI'] = function(){var exports = $MODULE_REGISTRY['Code/Xib/XibUI'] || {}; $MODULE_REGISTRY['Code/Xib/XibUI'] = exports; 
var __dirname = 'Code/Xib';
var __filename = 'Code/Xib/XibUI.js';

exports.XibUI = Xib.ViewController.subclass(
    {
        classname: "XibUI",

        initialize: function()
        {
            info( "XibUI.initialize called. this.classname=%s", this.classname );
        },

        dismiss: function()
        {
            info( "XibUI.dismiss called. this.classname=%s", this.classname );
            this.setView( undefined );
        },

        fitToScreen: function()
        {
            this.getView().setFrame( new Core.Rect( 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT ) );
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Xib/ScrollableView'] = function(){var exports = $MODULE_REGISTRY['Code/Xib/ScrollableView'] || {}; $MODULE_REGISTRY['Code/Xib/ScrollableView'] = exports; 
var __dirname = 'Code/Xib';
var __filename = 'Code/Xib/ScrollableView.js';

/**
 * Moves a GL2.Node object to the position x,y. x and y are absolute coordinates
 * by modifying it's position attribute.
 */

var ccpSub = function( /*Core.Point*/a, /*Core.Point*/b )
{
    return new Core.Point( a.getX() - b.getX(), a.getY() - b.getY() );
};

var MoveInertiaTo = IntervalAction.subclass(
{
    classname : 'MoveInertiaTo',
    MAX_SPEED_Y: 30,
    OFFSET_SPEED_COF: 5,

    initialize : function()
    {
        this.startPosition = null;
        this.currentPosition = null;
        this.delta = null;
        this.speed = null;
    },

    /** creates the action */
    $actionWithDurationAndSpeed : function( /*Number*/duration, speed, topY, bottomY, expansion )
    {
        return new this().initWithDurationAndSpeed( duration, speed, topY, bottomY, expansion );
    },

    /** initializes the action */
    initWithDurationAndSpeed : function( $super, /*Number*/duration, speed, topY, bottomY, expansion )
    {
        info("MoveInertiaTo.initWithDurationAndSpeed called. duration=%d, speed=%d, expansion=%d",duration, speed, expansion );
        this.initWithDuration( duration );

        this.topY = topY;
        this.bottomY = bottomY;
        this.expansion = expansion;

        if( speed > this.MAX_SPEED_Y )
        {
            this.speed = this.MAX_SPEED_Y;
        }
        else if( speed < -this.MAX_SPEED_Y )
        {
            this.speed = -this.MAX_SPEED_Y;
        }
        else
        {
            this.speed = speed;
        }

        return this;
    },

    startWithTarget : function( $super, /*Node*/aTarget )
    {
        $super( aTarget );
        var offset = this.target.getContentOffset();
        this.startPosition = new Core.Point( offset._x, offset._y );
        this.currentPosition = this.startPosition;
    },

    update : function( /*Number*/t )
    {
        var deltaY  = 0;
        var speed   = this.speed * ( 1 - t );
        var newYPos = this.currentPosition._y + speed;

        if( newYPos > this.topY )
        {
            deltaY = newYPos - this.topY;
        }
        else if( newYPos < this.bottomY )
        {
            deltaY -= this.bottomY - newYPos;
        }

        if( Math.abs( deltaY ) > (this.expansion / 2) )
        {
            this.speed = 0;
        }

        newYPos -= (deltaY / this.OFFSET_SPEED_COF );

//        info( "MoveInertiaTo.update currentY=%d, newYPos=%d, deltaY=%d, t=%d, speed=%d, this.expansion=%d",
//            this.currentPosition._y, newYPos, deltaY, t, speed, this.expansion );

        this.currentPosition._y = newYPos;
        this.target.setContentOffset( this.currentPosition, false );
    }
}
);

var MoveScrollTo = IntervalAction.subclass(
    {
        classname: 'MoveScrollTo',

        initialize: function()
        {
            this.endPosition = null;
            this.startPosition = null;
            this.delta = null;
        },

        /** creates the action */
        $actionWithDuration: function( /*Number*/duration, /*Core.Point*/position )
        {
            return new this().initWithDuration( duration, position );
        },

        /** initializes the action */
        initWithDuration: function( $super, /*Number*/duration, /*Core.Point*/position )
        {
            $super( duration );
            this.endPosition = position;
            return this;
        },

        startWithTarget: function( $super, /*Node*/aTarget )
        {
            $super( aTarget );
            var offset = this.target.getContentOffset();
            this.startPosition = new Core.Point( offset._x , offset._y );
            this.delta = ccpSub( this.endPosition, this.startPosition );
        },

        update: function( /*Number*/t )
        {
            var newPosition = new Core.Point( (
                 this.startPosition.getX() + this.delta.getX() * t), (
                 this.startPosition.getY() + this.delta.getY() * t) );
            this.target.setContentOffset( newPosition, false );

//            info( "MoveScrollTo.update newPosition=%s", JSON.stringify( newPosition ) );
        }
    }
);

exports.ScrollableView = XibUI.subclass(
{
    classname: 'ScrollableView',

    m_frameTop: -1,
    m_frameBottom: -1,
    m_frameHeight: -1,
    m_scrollDirty: false,

    EASE_DURATION: 0.5,
    INERTIA_DURATION: 1,

    initialize: function()
    {
        info( "ScrollableView.initialize called. this.classname=%s", this.classname );
    },

    initWithXib: function( $super, xibPath, inFullscreenOpaque )
    {
        info( "ScrollableView.initWithXib called. this.classname=%s, xibPath=%s, inFullscreenOpaque=%s",
            this.classname, xibPath, inFullscreenOpaque );
        $super( xibPath, inFullscreenOpaque );
    },

    _setScrollerCallbacks: function()
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView._setScrollerCallbacks called. this.classname=%s", this.classname );
        }

        this.view_scroller.scrollingWillStart = function()
        {
            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "ScrollableView.scrollingWillStart called.");
            }
            this.m_scrollDirty = true;
            // TODO kill running animation ?
        }.bind( this );

        this.view_scroller.scrollingDidReleaseTouch = function()
        {
            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "ScrollableView.scrollingDidReleaseTouch called." );
            }

            if( this.m_scrollDirty )
            {
                this.m_scrollDirty = false;
                this._animateBounce();
            }
        }.bind( this );

        this.view_scroller.startAnimating = function(){};
    },

    _animateBounce: function()
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView._animateBounce called. this.classname=%s", this.classname );
        }

        var scroll          = this.view_scroller;
        var offset          = scroll.getContentOffset();
        var targetPos       = null;
        var duration        = this.EASE_DURATION;
        var action          = null;
        var targetBottomY   = 0;


//        if( this.m_frameTop - this.m_frameBottom <= this.getVisibleSize()._height || this.m_frameBottom > this.m_frameTop || this.m_frameBottom > 0 )
        if( this.m_frameBottom > this.m_frameTop || this.m_frameBottom > 0 )
        {
            targetBottomY = this.m_frameTop;
        }
        else
        {
            targetBottomY = this.m_frameBottom;
        }

        if( offset._y > this.m_frameTop )
        {
            targetPos = new Core.Point( 0, this.m_frameTop );
        }
        else if( offset._y < this.m_frameBottom )
        {
            targetPos = new Core.Point( 0, targetBottomY );
        }
        else
        {
            // TODO The inertia duration should be related with the momentum (and also take in account the bounce)
            duration = this.INERTIA_DURATION;
            action = MoveInertiaTo.actionWithDurationAndSpeed( duration, scroll.mLastVel._y, this.m_frameTop, targetBottomY, this.m_expansion);
        }

        if( targetPos !== null )
        {
            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "ScrollableView._animateBounce offset._y=%d, targetPos._y=%d, this.m_frameTop=%d, this.m_frameBottom=%d, targetBottomY=%d", offset._y, targetPos._y, this.m_frameTop, this.m_frameBottom, targetBottomY );
            }
            action = Action.EaseOutCubic.actionWithAction( MoveScrollTo.actionWithDuration( duration, targetPos ) );
        }
        else
        {
            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "ScrollableView._animateBounce offset._y=%d, this.m_frameTop=%d, this.m_frameBottom=%d, targetBottomY=%d", offset._y, this.m_frameTop, this.m_frameBottom, targetBottomY );
            }
        }

        if( action !== null )
        {
            Action.ActionManager.removeAllActionsFromTarget( scroll );
            Action.ActionManager.addAction( action, scroll );
        }
    },

    viewDidLoad: function()
    {
        info( "ScrollableView.viewDidLoad called. this.classname=%s", this.classname );

        // TODO FIXME: This breaks the TutorialLayerUI
        clipScreen( this.getView() );

        this.view_scroller.setPagingEnabled( false );

        this._setScrollerCallbacks();

        if( TutorialManager.getActiveStateId() != undefined )
        {
            var tutorialScreen = GameController.getTutorialScreen();
            tutorialScreen.adjustScrollableViewHeight( this );
        }

        // This must be after the resize of the scrollableView!
        this.setFrameTop();
    },

    reduceTop: function( distance )
    {
        this.moveElements( distance );
        this.m_frameBottom -= distance;

        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.reduceTop called. this.classname=%s, distance=%d", this.classname, distance );
            info( "ScrollableView.reduceTop this.m_frameBottom=%s", this.m_frameBottom );
        }
    },

    moveElements: function( distance )
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.moveElements called. this.classname=%s, distance=%d", this.classname, distance );
        }

        // move all elements inside the inner_view expansion / 2
        var i, nodes, node, frame;

        nodes = this.xib_viewScroll.getChildren();
        for( i = 0; i < nodes.length; i++ )
        {
            node = nodes[i];
            frame = node.getFrame();

            frame._origin._y += distance;
            node.setFrame( frame );
        }

        this.m_frameTop += distance;
    },

    getFirstElementY: function()
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.getFirstElementY called. this.classname=%s", this.classname );
        }

        // move all elements inside the inner_view expansion / 2
        var i, nodes, node, frame, minY;

        minY = 100000;
        nodes = this.xib_viewScroll.getChildren();
        for( i = 0; i < nodes.length; i++ )
        {
            node = nodes[i];
            if( node.getVisible() )
            {
                frame = node.getFrame();

                if( frame._origin._y < minY )
                {
                    minY = frame._origin._y;
                }
//                warn( "ScrollableView.getLastElement _y=%s, minY=%s", frame._origin._y, minY )
            }
        }

        minY = -1 * minY;
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.getFirstElementY returning. minY=%s. this.classname=%s", minY, this.classname );
        }

        return minY;
    },

    getLastElementY: function()
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.getLastElementY called. this.classname=%s", this.classname );
        }

        // move all elements inside the inner_view expansion / 2
        var i, nodes, node, frame, maxY;

        maxY = 0;
        nodes = this.xib_viewScroll.getChildren();
        for( i = 0; i < nodes.length; i++ )
        {
            node = nodes[i];
            if( node.getVisible() )
            {
                frame = node.getFrame();

                if( maxY < ( frame._origin._y + frame._size._height ) )
                {
                    maxY = frame._origin._y + frame._size._height;
                }
                warn( "ScrollableView.getLastElementY _y=%s, _height=%s, maxY=%s", frame._origin._y, frame._size._height, maxY )
            }
        }

        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.getLastElementY returning. maxY=%s. this.classname=%s", maxY, this.classname );
        }
        return -maxY;
    },

    /**
     * Expand the frame(view) containing the elements/nodes. Adding pixels to the
     * top of the frame will move the elements down.
     *
     * @param size._top number of pixels to prepend to the frame
     * @param size._bottom number of pixels to append to the frame
     * @param size._bottomContent number of pixels to append to the frame with content
     */
        // TODO Find a better name for var 'size'
        // TODO Check if the params are ok
    expandFrame : function( size )
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.expandFrame called. this.classname=%s, size=%s", this.classname, JSON.stringify( size ) );
        }

//        this.m_frameBottom = this.getLastElementY();
        size._top           = isFinite( size._top )             ? size._top             : 0;
        size._bottom        = isFinite( size._bottom )          ? size._bottom          : 0;
        size._bottomContent = isFinite( size._bottomContent )   ? size._bottomContent   : 0;

        var oldSize, newSize;

        oldSize = this.view_scroller.getContentSize().clone();
        newSize = this.view_scroller.getContentSize().clone();

        // Expand frame
        newSize._height += size._top;
        newSize._height += size._bottom + size._bottomContent;

        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.expandFrame oldSize=%s, newSize=%s", JSON.stringify( oldSize ), JSON.stringify( newSize ) );
        }

        this.view_scroller.setContentSize( newSize );

//        info( "ScrollableView.expandFrame Old: this.m_frameTop=%s, this.m_frameBottom=%s", this.m_frameTop, this.m_frameBottom );
        // Those are negative numbers, we are increasing not reducing.
//        this.m_frameTop     -= size._top;
//        this.m_frameBottom  -= ( size._top + size._bottomContent );
//        info( "ScrollableView.expandFrame New: this.m_frameTop=%s, this.m_frameBottom=%s", this.m_frameTop, this.m_frameBottom );

        // Move elements
        if( size._top != 0 )
        {
            this.moveElements( size._top );
        }

        this.m_frameTop = this.getFirstElementY();
        this.m_frameBottom = -1 * ( newSize._height - this.getVisibleSize()._height - this.m_expansion / 2 );

        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.expandFrame this.m_frameBottom=%s", this.m_frameBottom );
        }

//        this.m_frameBottom = this.getLastElementY();
    },

    getVisibleSize: function()
    {
        var visibleSize = this.view_scroller.getPagingSize();

        return visibleSize.clone();
    },

    setFrameTop: function()
    {
        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.setFrameTop called. this.classname=%s", this.classname );
        }

        var contentSize = this.view_scroller.getContentSize().clone();
        var visibleSize = this.getVisibleSize();
        var desiredHeight;

        if( visibleSize._height > contentSize._height )
        {
            desiredHeight = visibleSize._height * 1.1;
        }
        else
        {
            desiredHeight = contentSize._height + visibleSize._height * 0.1;
        }

        var expansion = desiredHeight - contentSize._height;

        if( DEBUG_SCROLLABLE_VIEW )
        {
            info("ScrollableView.setFrameTop expansion=%s", JSON.stringify( expansion ) );
            info("ScrollableView.setFrameTop desiredHeight=%s", JSON.stringify( desiredHeight ) );
            info("ScrollableView.setFrameTop contentSize=%s", JSON.stringify( contentSize ) );
            info("ScrollableView.setFrameTop visibleSize=%s", JSON.stringify( visibleSize ) );
        }

//        var visibleSize = this.view_scroller.getPagingSize();

        // 10% of visibleSize on each side
//        var expansion       = visibleSize._height * 0.1;
        this.m_expansion    = expansion * 2;
        this.m_frameTop     = 0;
        this.m_frameBottom  = -1 * ( contentSize._height - visibleSize._height );

        this.expandFrame( {"_top" : expansion, "_bottom" : expansion, "_bottomContent" : 0 } );

        if( DEBUG_SCROLLABLE_VIEW )
        {
            info( "ScrollableView.setFrameTop this.m_frameBottom=%s", this.m_frameBottom );
            info( "ScrollableView.setFrameTop this.classname=%s, contentSize=%s, m_expansion=%d, visibleSize=%s",
                this.classname, JSON.stringify( contentSize ), this.m_expansion, JSON.stringify( visibleSize ) );
        }

        this.scrollToTop( false );
    },

    scrollToTop: function( animated )
    {
        this.view_scroller.setContentOffset( new Core.Point( 0, this.m_frameTop ), animated );
    },

    scrollToBottom: function( animated )
    {
        this.view_scroller.setContentOffset( new Core.Point( 0, this.m_frameBottom ), animated );
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/LabelConfigurer'] = function(){var exports = $MODULE_REGISTRY['Code/Util/LabelConfigurer'] || {}; $MODULE_REGISTRY['Code/Util/LabelConfigurer'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/LabelConfigurer.js';

var oldInitialize = GL2.Text.prototype.initialize;
GL2.Text.prototype.initialize = function()
{
    oldInitialize.apply( this, arguments );
    //register for the next frame
    setTimeout( LabelConfigurer._adjustScale.bind( LabelConfigurer, this ), 0 );
    //set the Label to invisible until we adjust it.
    this.setVisible( false );
};


var oldSetFontSize = GL2.Text.prototype.setFontSize;
GL2.Text.prototype.setFontSize = function()
{
    oldSetFontSize.apply( this, arguments );
    //register for the next frame
    setTimeout( LabelConfigurer._adjustScale.bind( LabelConfigurer, this ), 0 );
    //set the Label to invisible until we adjust it.
    this.setVisible( false );
};


var MAX_ADJUST_SCALE_REPEAT = 25;
var LabelConfigurer = exports.LabelConfigurer = Core.Class.subclass( {
    classname: 'LabelConfigurer',

    $__knownProperties: ["size", "color", "hAlign", "vAlign", "anchor", "overflowMode", "fontName", "embedded" ],

    /**
     * Creates a GL2.Text object configured with the values given.
     *
     * @example
     * var text1 = LabelConfigurer.createLabel("Simple GL2.Text", 40);
     * var text2 = LabelConfigurer.createLabelWithConfig("Complex GL2.Text", 40,{overflowMode:GL2.Text.OverflowMode.ReduceFontSize , anchor:[0,0], hAlign: GL2.Text.HorizontalAlign.Right, size: [500,60]});
     *
     * @param text - the text to display
     * @param fontSize - the font size to use
     * @param [config = null] - an optional configuration object with this optional parameters:
     * {
     * size: [150,30], //the size of the box for the text.
     * color: new Core.Color(1,1,1), // the color for the label
     * hAlign: GL2.Text.HorizontalAlign, //Horizontal Align
     * vAlign: GL2.Text.VerticalAlign, //Horizontal Align
     * anchor: [0,0], // the anchor for this text texture
     * overflowMode: GL2.Text.OverflowMode.Multiline, //the overflow mode to use
     * fontName: "Arial" // the font name to use
     * embedded: false //flag this text to use and embedded font
     * }
     *
     *
     * @returns GL2.Text
     */
    $createLabelWithConfig: function( text, fontSize, config )
    {
        if( config != undefined )
        {
            var keys = Object.keys( config );
            for( var i in keys )
            {
                if( this.__knownProperties.indexOf( keys[i] ) == -1 )
                {
                    console.log( "WARNING!! LabelConfigurer.createLabelWithConfig: parameter not known: " + keys[i] );
                }
            }
        }
        else
        {
            config = {};
        }

        return this.createLabel( text, fontSize, config.size, config.color, config.hAlign, config.vAlign, config.anchor, config.overflowMode, config.fontName, config.embedded );
    },

    /**
     * Creates a GL2.Text object configured with the values given.
     * @see LabelConfigurer#createLabelWithConfig
     *
     * @param text - the text to display
     * @param fontSize - the font size to use
     * @param size: [150,30], //the size of the box for the text.
     * @param color: new Core.Color(1,1,1), // the color for the label
     * @param hAlign: GL2.Text.HorizontalAlign, //Horizontal Align
     * @param vAlign: GL2.Text.VerticalAlign, //Horizontal Align
     * @param anchor: [0,0], // the anchor for this text texture
     * @param overflowMode: GL2.Text.OverflowMode.Multiline, //the overflow mode to use
     * @param fontName: "Arial" // the font name to use
     * @param embedded: false //flag this text to use and embedded font
     *
     * @returns {GL2.Text}
     */
    $createLabel: function( /*String*/text, /*Number*/fontSize, /*Core.Size*/size, /*Core.Color*/color, /*GL2.Text.HorizontalAlign*/hAlign, /*GL2.Text.VerticalAlign*/vAlign, /*Core.Point*/anchor, /*GL2.Text.OverflowMode*/overflowMode, /*String*/fontName, /*Boolean*/embedded )
    {
        var gl2Text = new GL2.Text();
        gl2Text.setText( "" + text );
        gl2Text.setFontSize( fontSize );

        if( size != null )
        {
            gl2Text.setSize( size );
        }

        if( !embedded )
        {
            gl2Text.setFontFamily( fontName );
        }
        else
        {
            if( fontName != null )
            {
                gl2Text.setFontFamily( "./Content/fonts/" + fontName + ".ttf" );
                gl2Text.setFontLocation( GL2.Text.FontLocation.Manifest );
            }
        }

        gl2Text.setColor( color || new Core.Color( 1, 1, 1 ) );
        gl2Text.setAnchor( anchor || [ 0.5, 0.5 ] );

        //Hack for Flash
        if( anchor )
        {
            var p = new Core.Point( anchor );
            // Horizontal anchor
            if( p._x == 0 )
            {
                gl2Text.setHorizontalAlign( GL2.Text.HorizontalAlign.Left );
            } else if( p._x == 0.5 )
            {
                gl2Text.setHorizontalAlign( GL2.Text.HorizontalAlign.Center );
            } else if( p._x == 1 )
            {
                gl2Text.setHorizontalAlign( GL2.Text.HorizontalAlign.Right );
            }

            // Vertical anchor
            if( p._y == 0 )
            {
                gl2Text.setVerticalAlign( GL2.Text.VerticalAlign.Top );
            } else if( p._y == 0.5 )
            {
                gl2Text.setVerticalAlign( GL2.Text.VerticalAlign.Middle );
            } else if( p._y == 1 )
            {
                gl2Text.setVerticalAlign( GL2.Text.VerticalAlign.Bottom );
            }
        }
        //End hack

        if( hAlign != null )
        {
            gl2Text.setHorizontalAlign( hAlign );
        }

        if( vAlign != null )
        {
            gl2Text.setVerticalAlign( vAlign );
        }

        if( overflowMode != null )
        {
            gl2Text.setOverflowMode( overflowMode );
        }

        return gl2Text;
    },

    $_adjustScale: function( gl2Text, repeat )
    {
        var scaleFactor = this._calculateScaleFactor( gl2Text );
        if( scaleFactor == null )
        {
            var timeout;
            if( repeat == undefined || repeat == 0 )
            {
                repeat = 0;
                timeout = 0;
            }
            else
            {
                timeout = 120 * Math.pow( ( repeat * 10 ) / MAX_ADJUST_SCALE_REPEAT, 2 );
            }

            // TODO FIXME: This code is disable to avoid stupid loops.
            //register for next frame
            setTimeout( function()
            {
//                info( "LabelConfigurer._adjustScale.innerCallback repeat=%s", repeat );
                repeat++;
                if( repeat < MAX_ADJUST_SCALE_REPEAT )
                {
                    this._adjustScale( gl2Text, repeat );
                }
            }.bind( this ), timeout );
            return;
        }
        var scaleVector = gl2Text.getScale();
        if( scaleFactor > 1 && scaleFactor > Math.max( scaleVector._x, scaleVector._y ) )
        {

            //invert the scale to make the text use the same space as before
            gl2Text.setScale( 1 / scaleFactor, 1 / scaleFactor );

            var size = gl2Text._size;
            if( size )
            {
                size._width *= scaleFactor;
                size._height *= scaleFactor;
                gl2Text.setSize( size );
            }
//            console.log("LabelConfigurer._adjustScale: setting fontSize: " + (gl2Text._fontSize*scaleFactor) + ", for text: " + gl2Text._text);
            gl2Text.setFontSize( gl2Text._fontSize * scaleFactor );
        }
        gl2Text.setVisible( true );
    },

    $_calculateScaleFactor: function( gl2Text )
    {
        var point = new Core.Point( 0, 0 );
        var p1 = gl2Text.screenToLocal( point );

        //the node hasn't been added to the GL2.RootNode
        if( p1 == null )
        {
            return null;
        }

        point._x += 1;
        point._y += 1;

        var p2 = gl2Text.screenToLocal( point );

        var scaleFactorX = 1 / (
            p2._x - p1._x);
        var scaleFactorY = 1 / (
            p2._y - p1._y);

        scaleFactorX = Math.round( scaleFactorX * 1000000 ) / 1000000;
        scaleFactorY = Math.round( scaleFactorY * 1000000 ) / 1000000;

//        var digits = 6;
//
//        scaleFactorX = parseInt( (
//            Math.round( scaleFactorX * Math.pow( 10, digits ) )).toFixed( digits ) ) / Math.pow( 10, digits );
//        scaleFactorY = parseInt( (
//            Math.round( scaleFactorY * Math.pow( 10, digits ) )).toFixed( digits ) ) / Math.pow( 10, digits );
//
//        if( scaleFactorX != scaleFactorY )
//        {
//            console.log( "LabelConfigurer._calculateScaleFactor: WARNING!! GL2.Text with non equal scaling. [x,y]: [" + scaleFactorX + "," + scaleFactorY + "] Text: " + gl2Text._text );
//        }
        return Math.max( scaleFactorX, scaleFactorY );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/MainScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/MainScreen'] || {}; $MODULE_REGISTRY['Code/UI/MainScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/MainScreen.js';

exports.MainScreen = XibUI.subclass(
{

    classname: 'MainScreen',

    m_playerData: null,

    initialize: function()
    {
        info( "MainScreen.initialize called." );
        this.m_avoidClipping = true;
        this.initWithXib( "./Content/Xib/MainScreen.xib", false );

        info( "MainScreen.initialize called2." );
        this.setAllowTapPassthrough( true );

        info( "MainScreen.initialize called3." );
        this._currentScreen = null;
        this._progressBar = null;

        this.m_fuelAvailable = -1;
        this.m_fuelMax = -1;
    },

    moveToS1: function( /* Xib.Button */inSender )
    {
        info( "MainScreen.moveToS1 called." );

        var func = function()
        {
            var screen = new ControlRoom();
            Xib.Navigation.resetScreenStackTo( screen, false );
            info( "MainScreen.moveToS1 Screen Pushed: classname=" + screen.classname );
        }.bind( this );
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        this.highlightButton( HOME_SCREEN );
        // FIXME
        this.showPlayerInfo();
        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        this.button2.setImage( "hud_fusion_unselected.png" );
        this.button3.setImage( "hud_gasha_unselected.png" );
        this.button5.setImage( "hud_deck_unselected.png" );
        this.buttonBack.setEnabled( 1 );
    },

    moveToS2: function( /* Xib.Button */inSender )
    {
        var func = function()
        {
            var screen = new CardFusionBaseSelection();
            info( "MainScreen.moveToS2 Screen Pushed: classname=" + screen.classname );
            screen.m_cardsLoaded = true;
            screen._getUserCards();
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        // this.highlightButton(FUSION_SCREEN);
        // FIXME
        this.showPlayerInfo();
        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        this.button1.setImage( "hud_home_unselected.png" );
        this.button3.setImage( "hud_gasha_unselected.png" );
        this.button5.setImage( "hud_deck_unselected.png" );
        this.buttonBack.setEnabled( 1 );
    },

    moveToS3: function( /* Xib.Button */inSender )
    {
        var func = function()
        {
            var screen = new GashaStore( 1 );
            Xib.Navigation.resetScreenStackTo( screen, false );
            info( "MainScreen.moveToS3 Screen Pushed: classname=" + screen.classname );
        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        this.highlightButton( GASHA_SCREEN );
        // FIXME
        this.showPlayerInfo();
        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        this.button1.setImage( "hud_home_unselected.png" );
        this.button2.setImage( "hud_fusion_unselected.png" );
        this.button5.setImage( "hud_deck_unselected.png" );
        this.buttonBack.setEnabled( 1 );
    },

    moveToS4: function( /* Xib.Button */inSender )
    {
        var screen = new Menu();
        Xib.Navigation.setModalOverlay( screen );
        info( "MainScreen.moveToS4 Screen Pushed: classname=" + screen.classname );
        // FIXME
        this.showPlayerInfo();
        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        this.buttonBack.setEnabled( 1 );
    },

    moveToS5: function( /* Xib.Button */inSender )
    {
        var func = function()
        {
            var screen = new DeckManagerUI();
            Xib.Navigation.resetScreenStackTo( screen, false );
            info( "MainScreen.moveToS5 Screen Pushed: classname=" + screen.classname );
        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        this.highlightButton( DECK_MANAGER_SCREEN );
        // FIXME
        this.showPlayerInfo();
        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        this.button1.setImage( "hud_home_unselected.png" );
        this.button2.setImage( "hud_fusion_unselected.png" );
        this.button3.setImage( "hud_gasha_unselected.png" );
        this.buttonBack.setEnabled( 1 );
    },

    backButton: function( /* Xib.Button */inSender )
    {
        info( "MainScreen.backButton called." );

        var callback = ScreenManager.getCallback();
        if( typeof ( callback ) == "function" )
        {
            ScreenManager.resetCallBack();
            callback();
        }
    },

    setProgressBarXPColor: function()
    {
        this._progressBar.foreground.setImage( TEXTURE_COLOR.yellow );
        this._progressBar.background.setImage( TEXTURE_COLOR.blue );
    },

    setProgressBarFuelColor: function()
    {
        this._progressBar2.foreground.setImage( TEXTURE_COLOR.green );
        this._progressBar2.background.setImage( TEXTURE_COLOR.blue );
    },

    viewDidLoad: function()
    {
        info( "MainScreen.viewDidLoad called." );

        // FIXME: Hardcoded
        backButtonHard = this.buttonBack;

        this.playerHudStartingPos = this.playerInfoViewContainer.getPosition();
        this.buttonsStartingPos = new Core.Point( this.buttonsViewContainer.getPosition().getX(), this.buttonsViewContainer.getPosition().getY() );
        this._progressBar = new ProgressBar( "./Content/Xib/MainScreenProgressBar.xib", User.getProgressLevel(), this.progressBar.getFrame(), false, this.setProgressBarXPColor.bind( this ) );

        var view = this._progressBar.getView();
        this.progressBar.addChild( view );

        this._progressBar2 = new ProgressBar( "./Content/Xib/MainScreenProgressBar.xib", ( User.getExploreEnergy() / User.getMaxExplorationEnergy() ), this.progressBar2.getFrame(), false, this.setProgressBarFuelColor.bind( this ) );
        var view2 = this._progressBar2.getView();
        this.progressBar2.addChild( view2 );

        // Refresh position of the bottom hud
        this.showButtons();

        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
            this.fillPlayerData();
            this.moveToS1();
            this._setClipping();
        }
        else
        {
            var tutorialScreen = new TutorialLayerUI( false );
            tutorialScreen.getView();
            GameController.setTutorialScreen( tutorialScreen );
            this.hideButtons();
            this.hidePlayerInfo();
        }
    },

    viewDidAppear: function()
    {
        this._updateInterval = setInterval( this.updateUIFuel.bind( this ), 1000 );
    },

    setEnabledMenu: function( value )
    {
        this.button1.setEnabled( value );
        this.button2.setEnabled( value );
        this.button3.setEnabled( value );
        this.button4.setEnabled( value );
        this.button5.setEnabled( value );
        this.buttonBack.setEnabled( value );
    },

    fillPlayerData: function()
    {
        info( "MainScreen.fillPlayerData called." );

        var fighterList, weaponList;
        this.m_playerData = User.getUserData();

        this.updateUIFuel();
        this.setUIGoldLabel( User.getCurrency() );
        this.setUILevelLabel( User.getLevel() );
        this.setUIExperienceLabel( User.getXP() );
        this.setUIExperienceProgressBar( User.getProgressLevel() );

        fighterList = CardsManager.getFilteredPlayerCardsWithLimbo(
        {
            "type": 1
        } );
        this.setUIFighterLabel( sprintf( "%s / %s", fighterList.length, User.getMaxPilotCards() ) );

        weaponList = CardsManager.getFilteredPlayerCardsWithLimbo(
        {
            "type": 2
        } );
        this.setUIWeaponLabel( sprintf( "%s / %s", weaponList.length, User.getMaxGearCards() ) );
    },

    setUIExperienceProgressBar: function( value )
    {
        this._progressBar.updateProgress( value );
    },

    updateUIFuel: function()
    {
        var available = User.getExploreEnergy();
        var max = User.getMaxExplorationEnergy();
        var needToUpdate = false;

        if( this.m_fuelAvailable != available )
        {
            this.m_fuelAvailable = available;
            needToUpdate = true;
        }

        if( this.m_fuelMax != max )
        {
            this.m_fuelMax = max;
            needToUpdate = true;
        }

        if( needToUpdate )
        {
            this.setUIFuelProgressBar( this.m_fuelAvailable / this.m_fuelMax );
            this.setUIFuelLabel( sprintf( "%s / %s", this.m_fuelAvailable, this.m_fuelMax ) );
        }
    },

    setUIFuelProgressBar: function( value )
    {
        this._progressBar2.updateProgress( value );
    },

    setUIGoldLabel: function( text )
    {
        this.goldLabel.setText( text );
    },

    setUIWeaponLabel: function( text )
    {
        var index = text.indexOf( "/" );

        var number = parseInt( text.substring( 0, index ) );
        var maxNumber = parseInt( text.substring( index + 1 ) );
        var str = text.substring( index );
        this.weaponsLabel.setText( "" + number );
        this.weaponsLabel2.setText( str );

        if( number > maxNumber )
        {
            this.weaponsLabel.setColor( new Core.Color( 1, 0.38, 0 ) );
            this.weaponsLabel.setBold( true );
        }
        else
        {
            this.weaponsLabel.setColor( new Core.Color( 1, 1, 1 ) );
            this.weaponsLabel.setBold( false );
        }
    },

    setUIFighterLabel: function( text )
    {
        var index = text.indexOf( "/" );

        var number = parseInt( text.substring( 0, index ) );
        var maxNumber = parseInt( text.substring( index + 1 ) );
        var str = text.substring( index );

        this.fighterLabel.setText( "" + number );
        this.fighterLabel2.setText( str );

        if( number > maxNumber )
        {
            this.fighterLabel.setColor( new Core.Color( 1, 0.38, 0 ) );
            this.fighterLabel.setBold( true );
        }
        else
        {
            this.fighterLabel.setColor( new Core.Color( 1, 1, 1 ) );
            this.fighterLabel.setBold( false );
        }
    },

    setUIFuelLabel: function( text )
    {
        this.fuelLabel.setText( text );
    },

    setUIExperienceLabel: function( text )
    {
        this.expLabel.setText( text );
    },

    setUILevelLabel: function( text )
    {
        this.lvlLabel.setText( text );
    },

    hideButtons: function()
    {
        info( "MainScreen.hideButtons called." );

        var position = this.buttonsStartingPos;
        this.buttonsViewContainer.setPosition( position.getX(), position.getY() + this.buttonsViewContainer.getFrame()._size._height );
    },

    showButtons: function()
    {
        info( "MainScreen.showButtons called." );

        this.buttonsViewContainer.setPosition( this.buttonsStartingPos );
    },

    hidePlayerInfo: function()
    {
        info( "MainScreen.hidePlayerInfo called." );

        this.playerInfoViewContainer.setPosition( -this.playerInfoViewContainer.getFrame()._h, this.playerInfoViewContainer.getPosition().getY() );
    },

    showPlayerInfo: function()
    {
        info( "MainScreen.showPlayerInfo called." );

        // There's a weird bug that makes the X value of playerHudStartingPos be
        // NaN. This should be looked into.
        this.playerInfoViewContainer.setPosition( 0, this.playerHudStartingPos.getY() );
    },

    _setClipping: function()
    {
        info( "MainScreen._setClipping called." );

        // Clipping data
        var offsetFactor = 0;
        var footFrame = this.buttonsViewContainer.getFrame();
        var clipFootX = footFrame._size._width / 2;
        var clipFootY = -footFrame._size._height / 2 + footFrame._size._height * offsetFactor; // frame._origin._y;
        var footVector = this.buttonsViewContainer.localToScreen( new Core.Vector( clipFootX, clipFootY ) );

        var topFrame = this.playerInfoViewContainer.getFrame();
        var clipOriginX = -topFrame._size._width / 2; // frame2._origin._x;
        var clipOriginY = topFrame._size._height / 2 - topFrame._size._height * offsetFactor;
        var topVector = this.playerInfoViewContainer.localToScreen( new Core.Vector( clipOriginX, clipOriginY ) );

        warn( "MainScreen._setClipping footFrame=  %s", JSON.stringify( footFrame ) );
        warn( "MainScreen._setClipping footVector= %s", JSON.stringify( footVector ) );
        warn( "MainScreen._setClipping topFrame=   %s", JSON.stringify( topFrame ) );
        warn( "MainScreen._setClipping topVector=  %s", JSON.stringify( topVector ) );

        screenClipRect = new Core.Rect( topVector._x, topVector._y, footVector._x, footVector._y - topVector._y );
        screenClipRectFoot = new Core.Rect( topVector._x, 0, footVector._x, footVector._y );
        screenClipRectTop = new Core.Rect( topVector._x, topVector._y, footVector._x, SCREEN_HEIGHT - topVector._y );
    },

    highlightButton: function( screenID )
    {
        info( "MainScreen.highlightButton called. screenID=%s", screenID );

        switch( screenID )
        {
            case HOME_SCREEN:
                this.button1.setHighlighted( true );
                this.button2.setHighlighted( false );
                this.button3.setHighlighted( false );
                this.button5.setHighlighted( false );
                break;

            case FUSION_SCREEN:
                this.button1.setHighlighted( false );
                this.button2.setHighlighted( true );
                this.button3.setHighlighted( false );
                this.button5.setHighlighted( false );
                break;

            case GASHA_SCREEN:
                this.button1.setHighlighted( false );
                this.button2.setHighlighted( false );
                this.button3.setHighlighted( true );
                this.button5.setHighlighted( false );
                break;

            case DECK_MANAGER_SCREEN:
                this.button1.setHighlighted( false );
                this.button2.setHighlighted( false );
                this.button3.setHighlighted( false );
                this.button5.setHighlighted( true );
                break;

            default:
                this.button1.setHighlighted( false );
                this.button2.setHighlighted( false );
                this.button3.setHighlighted( false );
                this.button5.setHighlighted( false );
                break;
        }
    },

    destroy: function()
    {
        this._progressBar.destroy();
        this._progressBar2.destroy();

        clearInterval( this._updateInterval );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/SingleGasha'] = function(){var exports = $MODULE_REGISTRY['Code/UI/SingleGasha'] || {}; $MODULE_REGISTRY['Code/UI/SingleGasha'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/SingleGasha.js';

exports.SingleGasha = ScrollableView.subclass(
{
    classname: 'SingleGasha',

    /*
     * SingleGasha.initialize
     */

    MEDAL_ASSETS:
    {
        "medal_1": "medal_bronze_200.png",
        "medal_2": "medal_bronze_200.png",
        "medal_3": "medal_silver_200.png"
    },

    initialize: function( $super, cardInstance, gashaId )
    {
        info( "SingleGasha.initialize called. cardInstance=%s, gashaId=%s", JSON.stringify( cardInstance ), gashaId );
        $super();
        this.gashaId = gashaId;
        this.cardInstance = cardInstance;
        this.initWithXib( "./Content/Xib/SingleGasha.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "SingleGasha.viewDidLoad called." );
        $super();

        var backFunction = function()
        {
            var func = function()
            {
                var screen = new GashaStore( 0 );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
        this.setValues();
        this.setButtons();

        if( this.cardInstance.isNew )
        {
            this.newCardImage.setVisible( true );
            this.newCardImage.setAlpha( 1 );
        }
        else
        {
            this.newCardImage.setVisible( false );
            this.newCardImage.setAlpha( 0 );
        }

        if( TutorialManager.getActiveStateId() != undefined )
        {
            this.gashaStoreButton.setVisible( false );
        }
    },

    viewDidAppear: function()
    {
        info( "SingleGasha.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();

        var gasha = GashaManager.getGashaPackById( this.gashaId );
        var card;
        var maxCards =
        {
            "PILOT": User.getMaxPilotCards(),
            "GEAR": User.getMaxGearCards()
        };
        var currentCards =
        {
            "PILOT": CardsManager.getFilteredPlayerCardsWithLimbo(
            {
                "type": PILOT
            } ).length,
            "GEAR": CardsManager.getFilteredPlayerCardsWithLimbo(
            {
                "type": GEAR
            } ).length
        };
    },

    setValues: function()
    {
        info( "SingleGasha.setValues called." );

        this.cardImage.spinnerOn();
        CardsManager.loadCardImage( this.cardInstance.definitionId, IMAGE_SIZE.BIGGEST, function( picture, imageURL )
        {
            if( picture._destroyed )
            {
                return;
            }
            picture.setImage( imageURL );
            picture.spinnerOff();
        }.bind( this, this.cardImage ) );

        var cardDef = CardsManager.getCardDefinition( this.cardInstance.definitionId );

        info( "SingleGasha.setValues cardDef=%s", JSON.stringify( cardDef ) );

        if( cardDef.type == PILOT )
        {
            this.status1.setText( "" + Math.ceil( cardDef.statusInit.status1 * 100 ) + "%" );
            this.status2.setText( "" + Math.ceil( cardDef.statusInit.status2 * 100 ) + "%" );
            this.status3.setText( "" + Math.ceil( cardDef.statusInit.status3 * 100 ) + "%" );
        }
        else
        {
            this.status1.setText( cardDef.statusInit.status1 );
            this.status2.setText( cardDef.statusInit.status2 );
            this.status3.setText( cardDef.statusInit.status3 );
        }
        var rarity = "";
        if( cardDef.rarity == RARITY.common )
        {
            rarity = _loc( "rarity_" + RARITY.common );
        }
        else if( cardDef.rarity == RARITY.UNCOMMON )
        {
            rarity = _loc( "rarity_" + RARITY.UNCOMMON );
        }
        else if( cardDef.rarity == RARITY.RARE )
        {
            rarity = _loc( "rarity_" + RARITY.RARE );
        }
        else
        {
            rarity = _loc( "rarity_" + RARITY.SUPER_RARE );
        }

        this.rarity.setText( rarity );
        this.description.setText( _loc( cardDef.description ) );

        var gasha = GashaManager.getGashaPackById( this.gashaId );
        info( "SingleGasha.setValues gashaPack is " + JSON.stringify( gasha ) );
        var currencyType = gasha.currency;
        this.gashaType = gasha.gashaType;

        var currencyAmount = 0;

        if( currencyType == "free" )
        {
            this.currencyImage.setImage( "1pxalpha0.png" );
            currencyAmount = 0;
            this.gashaAmount = 0;
            this.currencyMessage.setText( _loc( "gasha_landing_free_pod" ) );
            this.currencyAmount.setText( _loc( "gasha_landing_free_pod_description" ) );
        }
        else if( currencyType == "gasha_point" )
        {
            this.currencyMessage.setText( _loc( "gasha_landing_you_have_left" ) );
            currencyAmount = User.getGashaPoints( currencyType );
            this.currencyAmount.setText( currencyAmount );
            this.gashaAmount = ( currencyAmount / gasha.value );
            this.currencyImage.setImage( "gasha_icon_pp.png" );
        }
        else if( currencyType == "moba" )
        {
            currencyAmount = User.getGashaPoints( currencyType );
            this.gashaAmount = ( currencyAmount / gasha.value );
            this.currencyMessage.setText( _loc( "gasha_landing_moba_pod" ) );
            this.currencyAmount.setText( gasha.value );
            this.currencyImage.setImage( "gasha_icon_mc.png" );
        }
        else
        {
            this.currencyMessage.setText( _loc( "gasha_landing_you_have_left" ) );
            currencyAmount = User.getMedalAmount( currencyType );
            this.currencyAmount.setText( currencyAmount );
            this.gashaAmount = ( currencyAmount / gasha.value );
            this.currencyImage.setImage( "gasha_icon_mdl.png" );
        }

        if( this.gashaAmount > 10 )
        {
            this.gashaAmount = 10;
        }

        if( this.gashaAmount != undefined )
        {
            if( cardDef.type == PILOT )
            {
                this.cards.setText( _loc( "gasha_landing_pilots_added" ) );
            }
            else
            {
                this.cards.setText( _loc( "gasha_landing_weapons_added" ) );
            }

            this.multiPack.setText( _loc( "%s_cards_X_%s_%s", this.gashaAmount, this.gashaAmount, currencyType ) );
            this.singlePack.setText( _loc( "cards_X_1_%s", currencyType ) );
        }
        this.cardName.setText( _loc( cardDef.name ) );
    },

    setButtons: function()
    {
        if( this.gashaAmount != undefined )
        {

            // Cards in Storage

            if( GashaManager.getGashaPackById( this.gashaId ).currency == "moba" ) // Extra condition to set the buttons invisible if we used moba
            {
                this.gashaStore.setPosition( this.gashaStore.getPosition().getX(), this.multiButton.getPosition().getY() );
                this.multiGasha.setEnabled( false );
                this.smallSingleGasha.setEnabled( false );
                this.singleButton.setVisible( false );
                this.multiButton.setVisible( false );
                this.singleButton.setAlpha( 0 );
            }

            else if( this.gashaAmount == 1 )
            {
                this.singleButton.setPosition( this.singleButton.getPosition().getX(), this.multiButton.getPosition().getY() );
                this.gashaStore.setPosition( this.gashaStore.getPosition().getX(), this.singleButton.getPosition().getY() + this.singleButton.getFrame()._size._height / 2 + this.gashaStore.getFrame()._size._height / 2 );
                this.multiButton.setVisible( false );
                this.multiGasha.setEnabled( false );
                this.gashaStoreButton.setImage( "gasha_button_double_gray.png" );
            }
            else if( this.gashaAmount > 1 )
            {
                this.multiButton.setVisible( true );
                this.singleButton.setVisible( true );
                this.singleButton.setVisible( true );
                this.gashaStoreButton.setImage( "gasha_button_double_gray.png" );

            }
            else
            {
                this.gashaStore.setPosition( this.gashaStore.getPosition().getX(), this.multiButton.getPosition().getY() );
                this.singleButton.setVisible( false );
                this.smallSingleGasha.setEnabled( false );
                this.multiButton.setVisible( false );
                this.multiGasha.setEnabled( false );
                this.singleButton.setAlpha( 0 );
            }
        }
        console.log( "The amount of pilot cards allowed is : " + User.getMaxPilotCards() + "and the user has " + ( CardsManager.getFilteredPlayerCardsWithLimbo(
        {
            "type": 1
        } ).length ) );
        console.log( "The amount of gears cards allowed is : " + User.getMaxGearCards() + "and the user has " + ( CardsManager.getFilteredPlayerCardsWithLimbo(
        {
            "type": 2
        } ).length ) );
        if( this.cardInstance.inLimbo == true )
        {
            info( "SingleGasha cards in Limbo " + JSON.stringify( this.cardInstance ) );
            cardsInVaultPopUp( this.cardInstance );
        }

    },

    getMultiGasha: function()
    {
        info( "SingleGasha.getMultiGasha called" );
        GashaManager.runGasha( this.gashaId, "multi" );
    },

    goToGashaScreen: function()
    {
        var func = function()
        {
            var tab = 0;
            if( this.gashaType == 1 )
            {
                tab = 0;
            }
            else if( this.gashaType == 2 )
            {
                tab = 1;
            }
            else if( this.gashaType == 3 )
            {
                tab = 2;
            }

            var screen = new GashaStore( tab );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    runNormalGasha: function()
    {
        var packId = this.gashaId;
        var amount = "single";
        info( "GashaStore.runNormalGasha called. packId=%s", packId );

        GashaManager.runGasha( packId, amount, false );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/MultiGasha'] = function(){var exports = $MODULE_REGISTRY['Code/UI/MultiGasha'] || {}; $MODULE_REGISTRY['Code/UI/MultiGasha'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/MultiGasha.js';

exports.MultiGasha = ScrollableView.subclass(
{
    classname: 'MultiGasha',
    m_screenNextInsertPosition: 0,

    initialize: function( $super, cards, gashaId )
    {
        info( "MultiGasha.initialize called." );
        $super();
        this.gashaId = gashaId;
        this.cards = cards;
        this.cardsInLimbo = false;
        this.initWithXib( "./Content/Xib/MultiGasha.xib", false );
    },

    viewDidLoad: function( $super )
    {
        info( "MultiGasha.viewDidLoad called." );
        $super();
        this.setValues();
    },

    cardPack: function()
    {
        var screen = new GashaStore(2);
        Xib.Navigation.resetScreenStackTo( screen, false );
    },

    setValues: function()
    {
        //this.xib_viewScroll.nodeWithTag( 1 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 2 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 3 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 4 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 5 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 6 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 7 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 8 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 9 ).setVisible(false);
        this.xib_viewScroll.nodeWithTag( 10 ).setVisible(false);
        
        var length = this.cards.length;
        var i, view;
        var lastView = 0;
        
        for( i = 0; i < length; i = i + 2 )
        {
            //first view
            view = this.xib_viewScroll.nodeWithTag( i + 1 );
            this.setViewValues( view, i );
            //second view
            view = this.xib_viewScroll.nodeWithTag( i + 2 );
            view.setVisible( true );

            this.setViewValues( view, ( i + 1 ) );
            lastView = i + 1;
        }
        if ( length % 2 == 1 )
        {
            //Hide the last card if there is an inpar number of cards.
            this.xib_viewScroll.nodeWithTag( lastView + 1 ).setVisible(false);
        }


        var lastCard = this.xib_viewScroll.nodeWithTag( lastView );
        var buttonPosition = ( lastCard.getFrame()._size._height / 2 ) + lastCard.getPosition().getY() + this.storeView.getFrame()._size._height / 2 ;


        var gasha = GashaManager.getGashaPackById(this.gashaId);
        var currencyType = gasha.currency;
        var currencyAmount = 0;
        
        if (currencyType == "free")
        {
            currencyAmount = 0;
            this.gashaAmount = 0;
        }
        else if(currencyType == "gasha_point")
        {
            currencyAmount = User.getGashaPoints(currencyType);
            this.gashaAmount = (currencyAmount / gasha.value);
        }
        else
        {
            currencyAmount = User.getMedalAmount(currencyType);
            this.gashaAmount = (currencyAmount / gasha.value);
        }

        if(this.gashaAmount > 10)
        {
            this.gashaAmount = 10;
        }

        if (this.gashaAmount == 1)
        {
            this.multiView.setVisible(true);
            //this.singleView.setPosition( this.multiView.getPosition().getX() , buttonPosition + 5 );
            this.buttonMultiGasha.setEnabled(false);
            this.multiView.setPosition( this.multiView.getPosition().getX(), buttonPosition + 5);   
            this.storeView.setPosition(  this.storeView.getPosition().getX() , this.multiView.getPosition().getY() + this.storeView.getFrame()._size._height  );
        }
        else if(this.gashaAmount == 0)
        {
            this.multiView.setVisible(false);
            //this.singleView.setVisible(false);
            this.storeView.setPosition( this.storeView.getPosition().getX() , buttonPosition + 5 );
        }
        else 
        {
            this.multiView.setPosition( this.multiView.getPosition().getX(), buttonPosition + 5);   
            //this.singleView.setPosition( this.multiView.getPosition().getX() , this.multiView.getPosition().getY() + this.singleView.getFrame()._size._height  );
            this.storeView.setPosition(  this.storeView.getPosition().getX() , this.multiView.getPosition().getY() + this.storeView.getFrame()._size._height  );
        }

        var bottomResize = (this.xib_viewScroll.nodeWithTag( 1 ).getFrame()._size._height * (10 - length - (length%2) )) / 2;
        this.expandFrame(
            {
                '_top': 0,
                '_bottom': 0,
                '_bottomContent': -bottomResize
            } );

    },

    setViewValues: function(view, i)
    {
        info("MultiGasha.setViews called " + JSON.stringify(this.cards[i]) );
        view.setVisible(true);
        if(this.cards[i] == undefined || this.cards[i] == null)
        {
            return;
        }
        cardsInVaultPopUp(this.cards[i], this.cards.length);
        var cardDef = CardsManager.getCardDefinition(this.cards[i].definitionId);
        if( cardDef == null || cardDef == undefined )
        {
            return;
        }
        var title   =   view.nodeWithTag(1);
        var rarity  =   view.nodeWithTag(2);
        var image   =   view.nodeWithTag(3);
        var strVal  =   view.nodeWithTag(4);
        var fpwVal  =   view.nodeWithTag(5);
        var mobVal  =   view.nodeWithTag(6);
        title.setText(_loc(cardDef.name));
        rarity.setText(_loc("rarity_" + cardDef.rarity));
        if(cardDef.type == PILOT)
        {
            strVal.setText( Math.floor(cardDef.statusInit.status1 * 100) + "%" );
            fpwVal.setText( Math.floor(cardDef.statusInit.status2 * 100) + "%" );
            mobVal.setText( Math.floor(cardDef.statusInit.status3 * 100) + "%" );
        }
        else
        {
            strVal.setText(cardDef.statusInit.status1);
            fpwVal.setText(cardDef.statusInit.status2);
            mobVal.setText(cardDef.statusInit.status3);
        }

        image.spinnerOn();
        CardsManager.loadCardImage( this.cards[i].definitionId, IMAGE_SIZE.BIG, function(picture, imageURL )
        {
            if( picture._destroyed )
            {
                return;
            }
            picture.setImage( imageURL );
            picture.spinnerOff();
        }.bind( this, image ) );
    },

    singlePod: function()
    {
        info("MultiGasha.SinglePod called");
        GashaManager.runGasha(this.gashaId,"single");
    },

    multiPod: function()
    {
        info("MultiGasha.MultiPod called");
        GashaManager.runGasha(this.gashaId,"multi");
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/HelpScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/HelpScreen'] || {}; $MODULE_REGISTRY['Code/UI/HelpScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/HelpScreen.js';

exports.HelpScreen = XibUI.subclass(
{
    classname: 'HelpScreen',

    initialize: function( cardDefinition )
    {
        this.initWithXib( "./Content/Xib/WebScreen.xib", true );


    },

    viewDidLoad: function()
    {
        Xib.Navigation.getOverlayView().hidePlayerInfo();
        createWebView(HELP_URL, this.screenTitle);
        this.addBackButton();        

    },

    addBackButton: function()
    {
        var backButton = new UI.Button();        
        backButton.setOnClick(
            function()
            {
                var childArray = UI.Window.document.getChildren();
                for(var i=0; i< childArray.length; i++)
                {
                    UI.Window.document.removeChild(childArray[i]);
                }
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );  
                Xib.Navigation.getOverlayView().showPlayerInfo();
                Xib.Navigation.getOverlayView().showButtons();
            }

        );
        Xib.Navigation.getOverlayView().button4.setImage("hud_menu_unselected.png");
        Xib.Navigation.getOverlayView().button1.setImage("hud_home_unselected.png");
        Xib.Navigation.getOverlayView().button3.setImage("hud_gasha_unselected.png");
        Xib.Navigation.getOverlayView().button2.setImage("hud_fusion_unselected.png");
        Xib.Navigation.getOverlayView().button5.setImage("hud_deck_unselected.png");
        backButton.setFrame([0, 0, 200, 2*this.screenTitle.getFrame()._size._height]);
        UI.Window.document.addChild(backButton);
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/LegalScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/LegalScreen'] || {}; $MODULE_REGISTRY['Code/UI/LegalScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/LegalScreen.js';

exports.LegalScreen = XibUI.subclass(
{
    classname: 'LegalScreen',

    initialize: function( cardDefinition )
    {
        this.initWithXib( "./Content/Xib/WebScreen.xib", true );


    },

    viewDidLoad: function()
    {
        createWebView(LEGAL_URL);
        this.addBackButton();
    },

    addBackButton: function()
    {
        var backButton = new UI.Button();
        backButton.setText("Back");
        backButton.setOnClick(
            function()
            {
                var childArray = UI.Window.document.getChildren();
                for(var i=0; i< childArray.length; i++)
                {
                    UI.Window.document.removeChild(childArray[i]);
                }
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );            }

        );
        backButton.setFrame([0, 0, 50, 100]);
        UI.Window.document.addChild(backButton);
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/GameInfoScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/GameInfoScreen'] || {}; $MODULE_REGISTRY['Code/UI/GameInfoScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/GameInfoScreen.js';

exports.GameInfoScreen = XibUI.subclass(
{
    classname: 'GameInfoScreen',

    initialize: function( cardDefinition )
    {
        this.initWithXib( "./Content/Xib/WebScreen.xib", true );


    },

    viewDidLoad: function()
    {
        createWebView(GAMEINFO_URL);
        this.addBackButton();
    },

    addBackButton: function()
    {
        var backButton = new UI.Button();
        backButton.setText("Back");
        backButton.setOnClick(
            function()
            {
                var childArray = UI.Window.document.getChildren();
                for(var i=0; i< childArray.length; i++)
                {
                    UI.Window.document.removeChild(childArray[i]);
                }
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }
        );
        backButton.setFrame([0, 0, 50, 100]);
        UI.Window.document.addChild(backButton);
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/Menu'] = function(){var exports = $MODULE_REGISTRY['Code/UI/Menu'] || {}; $MODULE_REGISTRY['Code/UI/Menu'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/Menu.js';

exports.Menu = XibUI.subclass(
{

    classname: 'Menu',

    initialize: function()
    {
        info( "Menu.initialize called." );
        this.initWithXib( "./Content/Xib/Menu.xib", false );

    },

    viewDidLoad: function()
    {
        info( "Menu.viewDidLoad called." );
        /*this.button_social.setEnabled(false);
        this.button_lucky.setEnabled(false);
        this.button_empty.setEnabled(false);*/
        Social.Common.Service.hideCommunityButton();
        Globals.actualScreen = "Menu";
        this.view.setPosition( SCREEN_WIDTH / 2, 1.5 * SCREEN_HEIGHT );
        this.view.runAction( Action.MoveBy.actionWithDuration( 0.5, new Core.Point( 0, -SCREEN_HEIGHT ) ) );
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(NO_SCREEN);
        Xib.Navigation.getOverlayView().button4.setImage("hud_menu_selected.png");
    },

    cardFussionScreen: function()
    {
        info( "Menu.cardFussionScreen called." );
        var screen = new CardFusionBaseSelection();
        screen.m_cardsLoaded = true;
        screen._getUserCards();
        this.gotoScreen( screen );
    },

    deckManagerUIScreen: function()
    {
        info( "Menu.deckManagerUIScreen called." );
        var screen = new DeckManagerUI();
        this.gotoScreen( screen );
    },

    cardScreen: function()
    {
        info( "Menu.cardScreen called." );
    },

    tutorialStart: function()
    {
        info( "Menu.tutorialStart called." );
        /*TutorialManager.setActiveState( TutorialManager.STATE_CARDS_EXPLANATION );
        this.resetHudButton();

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_CARDS_EXPLANATION )
        {
            Xib.Navigation.removeModalOverlay();
            TutorialManager.executeActiveStateAction();
        }*/
        //var screen = new CardScreenInstance( 12, CardsManager.getPlayerCardList(), "Gasha" );
        //this.gotoScreen( screen );
    },

    missionsScreen: function()
    {
        info( "Menu.missionsScreen called." );
        var screen = new ExplorationWorldUI();
        this.gotoScreen( screen );
    },

    socialScreen: function()
    {
        info( "Menu.socialScreen called." );
    },

    gashaScreen: function()
    {
        info( "Menu.gashaScreen called." );
        var screen = new GashaStore(1);
        this.gotoScreen( screen );
    },

    saleScreen: function()
    {
        info( "Menu.saleScreen called ");
        var screen = new SaleCardsScreen(1);
        this.gotoScreen( screen );
    },

    cardCollectionScreen: function()
    {
        info( "Menu.cardCollectionScreen called." );
        var screen = new CardCollectionUI();
        this.gotoScreen( screen );
    },

    controlRoomScreen: function()
    {
        info( "Menu.controlRoomScreen called." );
        var screen = new ControlRoom();
        this.gotoScreen( screen );
    },

    versusBattleMainScreen: function()
    {
        info( "Menu.versusBattleMainScreen called." );
        var screen = new VersusBattleMain( User.getLevel() );
        this.gotoScreen( screen );
    },

    itemStoreScreen: function()
    {
        info( "Menu.itemStoreScreen called." );
        var screen = new ItemStore();
        this.gotoScreen( screen );
    },

    luckyChanceScreen: function()
    {
        info( "Menu.luckyChanceScreen called." );
        var screen = new LuckyChance( 1 /* missionId */, 50010130 /* luckyChanceId */,
            function()
            {
                info( "Menu.luckyChanceScreen.callback called." );
            }
        );
        this.gotoScreen( screen );
    },

    helpScreen: function()
    {
        info( "Menu.helpScreen called." );
        var screen = new HelpScreen();
        Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        Xib.Navigation.getOverlayView().hideButtons();
        Xib.Navigation.removeModalOverlay();
        Xib.Navigation.resetScreenStackTo( screen, false );
    
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(NO_SCREEN);
    },

    gameInfoScreen: function()
    {
        info( "Menu.gameInfoScreen called." );
        var screen = new GameInfoScreen();
        this.gotoScreen( screen );
    },

    legalScreen: function()
    {
        info( "Menu.legalScreen called." );
        var screen = new LegalScreen();
        this.gotoScreen( screen );
    },

    back: function()
    {
        info( "Menu.back called." );
        this.resetHudButton();
        var animationCallBack = function()
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
            Xib.Navigation.removeModalOverlay();
        }.bind( this );
        this.view.runAction( Action.Sequence.actions( Action.MoveBy.actionWithDuration( 0.5, new Core.Point( 0, +SCREEN_HEIGHT ) ), Action.CallFunc.actionWithTarget( this, animationCallBack ) ) );

    },

    hudButton1: function()
    {
        info( "Menu.hudButton1 called." );

        Xib.Navigation.getOverlayView().button1.setImage("hud_home_selected.png");
        Xib.Navigation.getOverlayView().button2.setImage("hud_fusion_unselected.png");
        Xib.Navigation.getOverlayView().button3.setImage("hud_gasha_unselected.png");
        Xib.Navigation.getOverlayView().button5.setImage("hud_deck_unselected.png");
        this.controlRoomScreen();
    },

    hudButton2: function()
    {
        info( "Menu.hudButton2 called." );

        Xib.Navigation.getOverlayView().button1.setImage("hud_home_unselected.png");
        Xib.Navigation.getOverlayView().button3.setImage("hud_gasha_unselected.png");
        Xib.Navigation.getOverlayView().button2.setImage("hud_fusion_selected.png");
        Xib.Navigation.getOverlayView().button5.setImage("hud_deck_unselected.png");
        this.cardFussionScreen();
    },

    hudButton3: function()
    {
        info( "Menu.hudButton3 called." );

        Xib.Navigation.getOverlayView().button1.setImage("hud_home_unselected.png");
        Xib.Navigation.getOverlayView().button2.setImage("hud_fusion_unselected.png");
        Xib.Navigation.getOverlayView().button3.setImage("hud_gasha_selected.png");
        Xib.Navigation.getOverlayView().button5.setImage("hud_deck_unselected.png");
        this.gashaScreen();
    },

    hudButton4: function()
    {
        info( "Menu.hudButton4 called." );

        Xib.Navigation.getOverlayView().button1.setImage("hud_home_unselected.png");
        Xib.Navigation.getOverlayView().button2.setImage("hud_fusion_unselected.png");
        Xib.Navigation.getOverlayView().button3.setImage("hud_gasha_unselected.png");
        Xib.Navigation.getOverlayView().button5.setImage("hud_deck_selected.png");
        this.deckManagerUIScreen();
    },

    resetHudButton: function()
    {
        info( "Menu.resetHudButton called." );

        Xib.Navigation.getOverlayView().button4.setImage("hud_menu_unselected.png");
        Xib.Navigation.getOverlayView().button1.setImage("hud_home_unselected.png");
        Xib.Navigation.getOverlayView().button3.setImage("hud_gasha_unselected.png");
        Xib.Navigation.getOverlayView().button2.setImage("hud_fusion_unselected.png");
        Xib.Navigation.getOverlayView().button5.setImage("hud_deck_unselected.png");
    },

    gotoScreen: function( screen )
    {
        info( "Menu.gotoScreen called." );

        this.resetHudButton();
        Xib.Navigation.removeModalOverlay();
        var func = function()
        {
            info( "MainScreen.gotoScreen Pushed: classname=" + screen.classname );
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ControlRoom'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ControlRoom'] || {}; $MODULE_REGISTRY['Code/UI/ControlRoom'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ControlRoom.js';

exports.ControlRoom = ScrollableView.subclass(
{
    classname: 'ControlRoom',
    m_screenNextInsertPosition: 0,

    initialize: function( $super )
    {
        info( "ControlRoom.initialize called." );
        $super();
        this.initWithXib( "./Content/Xib/ControlRoom.xib", false );

        var backFunction = function()
        {

        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
    },

    viewDidLoad: function( $super )
    {
        info( "ControlRoom.viewDidLoad called." );
        $super();

        var overlayView = Xib.Navigation.getOverlayView();
        overlayView.showButtons();
        overlayView.showPlayerInfo();
        
        this.showViews();
        Analytics.reportGameEvent( "ACCESSMYPAGE", { "foo" : "bar" }, User.getAnalyticsPlayerState() );
    },

    showViews: function()
    {
        var removeToBottomScroll = 0;
        this.m_screenNextInsertPosition = ( this.topView.getFrame()._size._height / 2 ) + this.topView.getPosition().getY();

        for( var i = 1; i < this.xib_viewScroll.getChildren().length; i++ )
        {
            var iteratingView = this.xib_viewScroll.nodeWithTag( i );
            if( i == 2 )
            {
                // This view contains Free Card Pack
                if( User.isGashaAvailable() )
                {
                    this.addScreen( iteratingView );
                }
                else
                {
                    this.cardPack.setEnabled( false );
                }
            }
            else if( i == 3 )
            {
                // This view contains Medal Card Pack
                if( User.hasMedals() > 0 )
                {
                    this.addScreen( iteratingView );
                }
                else
                {
                    this.medalCardPackButton.setEnabled( false );
                }
            }
            else if( i == 4 )
            {
                // Gifts and Rewards

                this.giftButton.setEnabled( false );
                this.giftLabel.setAlpha( 0.5 );
                this.giftNumberLabel.setAlpha( 0.5 );
                this.rewardButton.setEnabled( false );
                this.rewardLabel.setAlpha( 0.5 );
                this.rewardNumberLabel.setAlpha( 0.5 );
                info( "Gifts/Rewards: " + gifts + "/" + rewards );

                var gifts = GiftManager.getAllGiftsNumber();
                var rewards = RewardManager.getAllRewardsNumber();

                var show = false;

                if( gifts > 0 )
                {
                    this.giftNumberLabel.setText( "" + gifts );

                    this.giftButton.setEnabled( true );
                    this.giftLabel.setAlpha( 1 );
                    this.giftNumberLabel.setAlpha( 1 );
                    show = true;
                }

                if( rewards > 0 )
                {
                    this.rewardNumberLabel.setText( "" + rewards );

                    this.rewardButton.setEnabled( true );
                    this.rewardLabel.setAlpha( 1 );
                    this.rewardNumberLabel.setAlpha( 1 );
                    show = true;
                }

                if( show )
                {
                    this.addScreen( iteratingView );
                }
            }
            else if( i == 5 )
            {
                // Events are not available
                this.eventButton.setEnabled( false );
            }
            else if( i == 6 || i == 7 || i == 8 || i == 9 )
            {
                this.notification1.setEnabled( false );
                this.notification2.setEnabled( false );
                this.notification3.setEnabled( false );
                this.notification4.setEnabled( false );
            }
            else if( i == 10 )
            {
                this.socialButton.setEnabled( false );
                // Social notifications are unavailable
            }
            else
            {
                this.addScreen( iteratingView );
            }

            if( iteratingView.getAlpha() == 0 )
            {
                removeToBottomScroll = removeToBottomScroll + iteratingView.getFrame()._size._height;
            }
        }
        this.expandFrame(
        {
            '_top': 0,
            '_bottom': 0,
            '_bottomContent': -removeToBottomScroll
        } );

        // FIXME: Harcoded
        this.m_weaponBounds = CardsManager.getAreaOfInterestSquare( 12000091 );
        this.m_pilotBounds = CardsManager.getAreaOfInterestSquare( 12000091 );

        this.view_scroller.setUpdateFunction( this._clippingUpdate.bind( this ) );
        this.weaponCard.setClipRectEnabled( true );
        this.pilotCard.setClipRectEnabled( true );
        this._clippingUpdate();

        this._setCardImages();

        this._setEnergyBars();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( HOME_SCREEN );
    },

    addScreen: function( view )
    {
        // fixme: need a JSON to verify which views do we need to show.
        view.setPosition( view.getPosition().getX(), this.m_screenNextInsertPosition + view.getFrame()._size._height / 2 );
        view.setAlpha( 1 );
        this.m_screenNextInsertPosition = this.m_screenNextInsertPosition + view.getFrame()._size._height;
    },

    battleButton: function()
    {
        var func = function()
        {
            var screen = new VersusBattleMain( User.getLevel() );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    explorationButton: function()
    {
        var func = null;
        var stageInfo = User.getCurrentStage();

        // world 0 is for tutorial only!
        if( stageInfo.worldId <= 0 || stageInfo.stageId < 0 )
        {
            func = function()
            {
                var screen = new ExplorationWorldUI();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
        }
        else
        {
            func = function()
            {
                var stageInfo = User.getCurrentStage();
                var screen = new MissionSelectionScreen( stageInfo.worldId, stageInfo.stageId );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
        }

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    freeGashaButton: function()
    {
        var func = function()
        {
            var screen = new GashaStore( 0 );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();

        this._updateInterval = setInterval( this._setEnergyBars.bind( this ), 1000 );
    },

    _clippingUpdate: function()
    {
        imageClipping( this.weaponCard, this.weaponCardFrame, this.m_weaponBounds );
        imageClipping( this.pilotCard, this.pilotCardFrame, this.m_pilotBounds );
    },

    _setCardImages: function()
    {
        var randomTuple = CardsManager.getRandomDeckTuple();
        this.pilotId = CardsManager.getPlayerCardById( randomTuple.pilot ).definitionId;
        this.gearId = CardsManager.getPlayerCardById( randomTuple.gear ).definitionId;


        this.weaponCardFrame.spinnerOn();
        this.pilotCardFrame.spinnerOn();
        CardsManager.loadCardImage( this.pilotId, IMAGE_SIZE.BIGGEST, function( imageURL )
        {
            if( this.weaponCard._destroyed )
            {
                return;
            }
            this.weaponCardFrame.spinnerOff();
            this.weaponCard.setImage( imageURL );
            this._clippingUpdate();
        }.bind( this ) );

        CardsManager.loadCardImage( this.gearId, IMAGE_SIZE.BIGGEST, function( imageURL )
        {
            if( this.pilotCard._destroyed )
            {
                return;
            }
            this.pilotCardFrame.spinnerOff();
            this.pilotCard.setImage( imageURL );
            this._clippingUpdate();
        }.bind( this ) );
        var pilot = CardsManager.getCardDefinition( this.pilotId );
        var gear = CardsManager.getCardDefinition( this.gearId );

        this.pilotName.setText( _loc( pilot.name ) );
        this.gearName.setText( _loc( gear.name ) );
    },
    _setEnergyBars: function()
    {
        var energy = User.getBattleEnergy();

        this.battleEnergy1.setImage( "croom_energy_empty.png" );
        this.battleEnergy2.setImage( "croom_energy_empty.png" );
        this.battleEnergy3.setImage( "croom_energy_empty.png" );

        if( energy > 0 )
        {
            this.battleEnergy1.setImage( "croom_energy_fill.png" );
        }
        if( energy > 1 )
        {
            this.battleEnergy2.setImage( "croom_energy_fill.png" );
        }
        if( energy > 2 )
        {
            this.battleEnergy3.setImage( "croom_energy_fill.png" );
        }
    },
    medalCardPack: function()
    {
        var func = function()
        {
            var screen = new GashaStore( 2 );
            Xib.Navigation.resetScreenStackTo( screen, false );
            info( "MainScreen.moveToS3 Screen Pushed: classname=" + screen.classname );
        }.bind( this );
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    destroy: function()
    {
        clearInterval( this._updateInterval );
    },

    viewWillAppear: function()
    {
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( HOME_SCREEN );
    },

    giftClicked: function()
    {
        var screen = new GiftStorage();
        Xib.Navigation.resetScreenStackTo( screen, false );
    },

    rewardClicked: function()
    {
        var rewardLength = RewardManager.getPlayerRewardLength();
        
        var type = GEAR;
        if( rewardLength[PILOT] != 0 )
        {
            type = PILOT;
        }
        if( rewardLength[STAGE_REWARDS] != 0 )
        {
            type = STAGE_REWARDS;
        }
        
        var screen = new RewardList(type);
        Xib.Navigation.resetScreenStackTo( screen, false );
    },

    gotoCard1: function()
    {
        var func = function()
        {
            var cardScreen = new CardScreenDefinition( this.gearId, undefined, "Menu" );
            Xib.Navigation.pushViewController( cardScreen, true );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    gotoCard2: function()
    {
        var func = function()
        {
            var cardScreen = new CardScreenDefinition( this.pilotId, null, "Menu" );
            Xib.Navigation.pushViewController( cardScreen, true );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/DeckManagerUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI/DeckManagerUI'] || {}; $MODULE_REGISTRY['Code/UI/DeckManagerUI'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/DeckManagerUI.js';

exports.DeckManagerUI = ScrollableView.subclass(
{
    classname: 'DeckManagerUI',

    FIGHTER_OFFSET : 0, // First column
    SHOOT_OFFSET   : 1, // Second column
    MANEUVER_OFFSET: 2, // Third column

    m_viewLoaded: false,
    m_cardsLoaded: false,
    m_UIPopulated: false,

    DEFAULT_CARD_IMAGE: 'democard.jpg',
    REGULAR_TEXT_COLOR: new Core.Color( ( 255/255 ), (255/255 ), ( 255/255 ) ),
    RED_TEXT_COLOR: new Core.Color( ( 255/255 ), ( 124/255 ), ( 124/255 ) ),
    GREEN_TEXT_COLOR: new Core.Color( ( 1/255 ), ( 255/255 ), ( 1/255 ) ),

    // TODO DeckManagerUI: What happens if the user has a non-complete deck ?
    initialize: function( $super, prevScreen )
    {
        info( "DeckManagerUI.initialize called." );
        $super();

        this.prevScreen = prevScreen;
        this.m_views = [];
        this.m_cards = [];
        this.m_numViews = 9;
        this.m_oldCards = null;
        this.m_viewLoaded = false;

        var backFunction = function()
        {
            var func = function()
            {
                var screen;
                if (prevScreen)
                    screen = prevScreen;
                else
                    screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind(this);
        ScreenManager.setBackInfo(backFunction);


        this._loadCards();
        this.initWithXib( "./Content/Xib/DeckManagerUI.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "DeckManagerUI.viewDidLoad called." );
        $super();

        if( TutorialManager.getActiveStateId() != undefined )
        {
            TutorialManager.setButtonAsUnblocked( this.recommendedDeckButton );
            TutorialManager.setButtonAsUnblocked( this.acceptButton );
            this.recommendedDeckButton.setEnabled( true );
        }

        if( !this.m_viewLoaded )
        {
            this.m_viewLoaded = true;
            this._mapViews();
            this._mapElements();
            this._mapActions();
        }

        this._setButtonStates();
        this._populateUI();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(DECK_MANAGER_SCREEN);
    },

    refresh : function()
    {
        info( "DeckManagerUI.refresh called." );

        this._drawCards();

        if( this.m_oldCards )
        {
            this.recommendedDeckButton.setEnabled( false );
            this.recommendedDeckButton.setAlpha( 0 );
            this.acceptButton.setEnabled( true );
            this.acceptButton.setAlpha( 1 );
            this.cancelButton.setEnabled( true );
            this.cancelButton.setAlpha( 1 );
        }
        else
        {
            this.recommendedDeckButton.setEnabled( true );
            this.recommendedDeckButton.setAlpha( 1 );
            this.acceptButton.setEnabled( false );
            this.acceptButton.setAlpha( 0 );
            this.cancelButton.setEnabled( false );
            this.cancelButton.setAlpha( 0 );
        }

        this.button_general.setEnabled( true );
        this.button_strength.setEnabled( true );
        this.button_firepower.setEnabled( true );
        this.button_mobility.setEnabled( true );
    },

    _setButtonStates: function()
    {
        var typeData =
        {
            "selected":
            {
                "image": "deck_button_tab_selected.png",
                "textColor": FONT_COLOR.white
            },
            "unselected":
            {
                "image": "deck_button_tab_unselected.png",
                "textColor": FONT_COLOR.white
            }
        };

        if( TutorialManager.getActiveStateId() == undefined )
        {
            this.button_general.setStateData( typeData, this.button_general._text );
            this.button_strength.setStateData( typeData, this.button_strength._text );
            this.button_firepower.setStateData( typeData, this.button_firepower._text );
            this.button_mobility.setStateData( typeData, this.button_mobility._text );
        }

    },

    viewButtonEvent: function( opts, inSender )
    {
        info( "DeckManagerUI.viewButtonEvent called. opts=%s", JSON.stringify( opts ) );

        var type        = null;
        var position    = ~~( opts.button / 3 ); // ~~() equals Math.floor()

        if( opts.button % 3 == 0 )
        {
            type = DeckManager.FIGHTER;
        }
        else if( opts.button % 3 == 1 )
        {
            type = DeckManager.SHOOTER;
        }
        else if( opts.button % 3 == 2 )
        {
            type = DeckManager.MANEUVER;
        }
        else
        {
            err( "DeckManagerUI.viewButtonEvent Error, cannot identify the position of the card! opts=%s", JSON.stringify( opts ) );
            type        = null;
            position    = -1;
        }

        var func = function()
        {
            var screen = new ItemDeckCategoryEdit( type, position, position, "DeckManagerUI", position, this.prevScreen );
            Xib.Navigation.pushViewController( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );

        info( "DeckManagerUI.viewButtonEvent type=%s, position=%d", type, position );
    },

    _drawCards: function()
    {
        info( "DeckManagerUI._drawCards this.m_cards=%s", JSON.stringify( this.m_cards ) );

        var oldFighters = null;
        var oldShooter = null;
        var oldManeuver = null;

        if( this.m_oldCards )
        {
            oldFighters = this.m_oldCards[ DeckManager.FIGHTER ];
            oldShooter = this.m_oldCards[ DeckManager.SHOOTER ];
            oldManeuver = this.m_oldCards[ DeckManager.MANEUVER ];
        }
        if( this.m_cardsLoaded && this.m_viewLoaded )
        {
            this._setPairsOfCards( this.FIGHTER_OFFSET, this.m_cards[ DeckManager.FIGHTER ], oldFighters  );
            this._setPairsOfCards( this.SHOOT_OFFSET, this.m_cards[ DeckManager.SHOOTER ], oldShooter );
            this._setPairsOfCards( this.MANEUVER_OFFSET, this.m_cards[ DeckManager.MANEUVER ], oldManeuver );
        }
    },

    _setPairsOfCards: function( offset, pairs, oldPairs )
    {
        var status = null;

        switch( offset )
        {
            case this.FIGHTER_OFFSET:
                status = "status1";
                break;
            case this.SHOOT_OFFSET:
                status = "status2";
                break;
            case this.MANEUVER_OFFSET:
                status = "status3";
                break;
        }

        if( oldPairs )
        {
            this._setCard( offset + 0, pairs[0]['gear'], pairs[0]['pilot'], oldPairs[0]['gear'], oldPairs[0]['pilot'], status, 1 );
            this._setCard( offset + 3, pairs[1]['gear'], pairs[1]['pilot'], oldPairs[1]['gear'], oldPairs[1]['pilot'], status, 2 );
            this._setCard( offset + 6, pairs[2]['gear'], pairs[2]['pilot'], oldPairs[2]['gear'], oldPairs[2]['pilot'], status, 3 );
        }
        else
        {
            this._setCard( offset + 0, pairs[0]['gear'], pairs[0]['pilot'], null, null, status, 1 );
            this._setCard( offset + 3, pairs[1]['gear'], pairs[1]['pilot'], null, null, status, 2 );
            this._setCard( offset + 6, pairs[2]['gear'], pairs[2]['pilot'], null, null, status, 3 );
        }
    },

    _loadCards: function()
    {
        info( "DeckManagerUI._loadCards called." );

        this.m_cards = DeckManager.getDeck();
        this.m_cardsLoaded = true;
        this._populateUI();
    },

    _populateUI: function()
    {
        info( "DeckManagerUI._populateUI called. this.m_cardsLoaded=%s, this.m_viewLoaded=%s, this.m_UIPopulated=%s",
            this.m_cardsLoaded, this.m_viewLoaded, this.m_UIPopulated );

        if( this.m_cardsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;
            this.refresh();
        }
    },

    _mapViews: function()
    {
        info( "DeckManagerUI._mapViews called." );

        for( var i = 0; i < this.m_numViews; i++ )
        {
            var view = eval( sprintf( "this.item_%d", i ) );
            this.m_views[i] = {"_view" : view };
        }
    },

    _mapElements: function()
    {
        info( "DeckManagerUI._mapElements called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var view = this.m_views[i];

            this.m_views[i]._button   = view._view.nodeWithTag( 1000 );
            this.m_views[i]._leftImg  = view._view.nodeWithTag( 1001 );
            this.m_views[i]._rightImg = view._view.nodeWithTag( 1002 );
            this.m_views[i]._value1   = view._view.nodeWithTag( 1003 );
            this.m_views[i]._value2   = view._view.nodeWithTag( 1004 );
        }
    },

    _mapActions: function()
    {
        info( "DeckManagerUI._mapActions called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var callback = sprintf( "viewButtonEvent.bind(this._target, {'button':%d})", i );

            this.m_views[i]._button.setTargetAction( this, callback );
        }
    },

    _setCard: function( cellIndex, gearId, pilotId, oldGearId, oldPilotId, status, position )
    {
        info( "DeckManagerUI._setCard called. cellIndex=%d, gearId=%d, pilotId=%d", cellIndex, gearId, pilotId );

        var view, gearCard, pilotCard, leftImage, rightImage;

        gearCard = CardsManager.getPlayerCardById( gearId );
        pilotCard = CardsManager.getPlayerCardById( pilotId );

        if( cellIndex < 0 || cellIndex >= this.m_numViews )
        {
            err( "DeckManagerUI._setCard Error, position out of bounds: cellIndex=", cellIndex );
            return false;
        }

        view = this.m_views[cellIndex];
        if( view === null )
        {
            err( "DeckManagerUI._setCard Error, view not loaded: cellIndex=%d", cellIndex );
            return false;
        }

        leftImage = this.DEFAULT_CARD_IMAGE;
        if( gearId >= 0 )
        {
            view._leftImg.spinnerOn();
            if( gearCard && gearCard.definitionId >= 0 )
            {
                leftImage = sprintf( gearCard.definitionId + "_" + IMAGE_SIZE.SMALL + ".jpg" );
            }
        }

        rightImage = this.DEFAULT_CARD_IMAGE;
        if( pilotId >= 0 )
        {
            view._rightImg.spinnerOn();
            if( pilotCard && pilotCard.definitionId >= 0 )
            {
                rightImage = sprintf( pilotCard.definitionId + "_" + IMAGE_SIZE.SMALL + ".jpg" );
            }
        }

        CardsManager.loadCardImage( gearCard.definitionId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( view._leftImg._destroyed )
            {
                return;
            }
            info( "CardCollection.getCardSlot.button.setImageCb.innerCallback called. leftImage=%s", imageURL );
            view._leftImg.setImage( imageURL );
            view._leftImg.spinnerOff();
        }.bind( view, leftImage ) );

        CardsManager.loadCardImage( pilotCard.definitionId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( view._rightImg._destroyed )
            {
                return;
            }
            info( "CardCollection.getCardSlot.button.setImageCb.innerCallback called. leftImage=%s", imageURL );
            view._rightImg.setImage( imageURL );
            view._rightImg.spinnerOff();
        }.bind( view, rightImage ) );

        var unitPower = null;
        if( pilotCard && gearCard )
        {
            unitPower = CardsManager.getUnitPower( pilotCard, gearCard, status, position );
            view._value1.setText( unitPower.attack + "" );
            view._value2.setText( unitPower.hp + "" );
        }
        else
        {
            view._value1.setText( "1" );
            view._value2.setText( "1" );
        }

        view._value1.setColor( this.REGULAR_TEXT_COLOR );
        view._value2.setColor( this.REGULAR_TEXT_COLOR );
        if( !oldGearId || !oldPilotId )
        {
            return;
        }
        var oldGearCard = CardsManager.getPlayerCardById( oldGearId );
        var oldPilotCard = CardsManager.getPlayerCardById( oldPilotId );
        var oldUnitPower = CardsManager.getUnitPower( oldPilotCard, oldGearCard, status, position );

        if( oldUnitPower.attack > unitPower.attack )
        {
            view._value1.setColor( this.RED_TEXT_COLOR );
        }
        else if( oldUnitPower.attack < unitPower.attack )
        {
            view._value1.setColor( this.GREEN_TEXT_COLOR );
        }

        if( oldUnitPower.hp > unitPower.hp )
        {
            view._value2.setColor( this.RED_TEXT_COLOR );
        }
        else if( oldUnitPower.hp < unitPower.hp )
        {
            view._value2.setColor( this.GREEN_TEXT_COLOR );
        }

    },

    firstDeckClicked: function()
    {
        info( "DeckManagerUI.firstDeckClicked called." );

        var func = function()
        {
            var screen = new DeckCategoryInfo( [DeckManager.FIGHTER], this.prevScreen );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    secondDeckClicked: function()
    {
        info( "DeckManagerUI.secondDeckClicked called." );

        var func = function()
        {
            var screen = new DeckCategoryInfo( [DeckManager.SHOOTER], this.prevScreen );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    thirdDeckClicked: function()
    {
        info( "DeckManagerUI.thirdDeckClicked called." );

        var func = function()
        {
            var screen = new DeckCategoryInfo( [DeckManager.MANEUVER], this.prevScreen );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    allDecksClicked: function()
    {
        info( "DeckManagerUI.allDecksClicked called." );

        var func = function()
        {
            var screen = new DeckCategoryInfo( [DeckManager.FIGHTER, DeckManager.SHOOTER, DeckManager.MANEUVER] );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    getRecommendedDeck: function( sender )
    {
        var popUp           = new PopUp(0, PopUp.INFO, _loc( "deck_manager_recommendeddeck_title" ),  _loc( "deck_manager_recommendeddeck_description" ));
        popUp.setAppearCallback( function(popUp)
        {
            info("HELLO");
            info( "DeckManagerUI.getRecomendedDeck called." );

            var recommendedDeck = DeckManager.getRecommendedDeck();

            info( "DeckManagerUI.getRecomendedDeck recommendedDeck=%s", JSON.stringify( recommendedDeck ) );

            this.m_oldCards = this.m_cards;
            this.m_cards    = recommendedDeck;

            this.refresh();

            if( TutorialManager.getActiveStateId() == TutorialManager.STATE_DECK_MANAGER )
            {
                info( "DeckManagerUI.getRecomendedDeck [TUTORIAL]" );
                TutorialManager.completeActiveState();
                TutorialManager.executeActiveStateAction();
            }
            
            popUp.closePopUp();
        }.bind(this, popUp));
        
        Xib.Navigation.removeModalOverlay();
        Xib.Navigation.setModalOverlay( popUp );
    },

    acceptRecommendedDeck: function( sender )
    {
        info( "DeckManagerUI.acceptRecommendedDeck called." );

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_DECK_MANAGER2 )
        {
            info( "DeckManagerUI.acceptRecommendedDeck [TUTORIAL] returning." );
            TutorialManager.completeActiveState();
            TutorialManager.executeActiveStateAction();

            DeckManager.setDeck( this.m_cards, new function(){} );
            return;
        }

        this.m_UIPopulated = false;
        var onSpinnerLoaded = function()
        {
            DeckManager.setDeck( this.m_cards,
                function( deck )
                {
                    info( "DeckManagerUI.onSpinnerLoaded._internalCallback called." );
                    this.m_oldCards = null;
                    this.m_cards = deck;
                    Xib.Navigation.removeModalOverlay();
                    this.refresh();
                }.bind( this )
            );
        }.bind(this);

        Xib.Navigation.setModalOverlay( new WaitingScreen( onSpinnerLoaded ) );
    },

    cancelRecommendedDeck: function( sender )
    {
        info( "DeckManagerUI.cancelRecommendedDeck called." );

        this.m_cards = DeckManager.getDeck();
        this.m_oldCards = null;
        this.refresh();
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    },

    viewWillAppear: function()
    {
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(DECK_MANAGER_SCREEN);
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ItemDeckCategoryEdit'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ItemDeckCategoryEdit'] || {}; $MODULE_REGISTRY['Code/UI/ItemDeckCategoryEdit'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ItemDeckCategoryEdit.js';

exports.ItemDeckCategoryEdit = ScrollableView.subclass(
{
    classname: 'ItemDeckCategoryEdit',

    initialize: function( $super, status, position, number, parentScreen, decks, prevScreen )
    {
        info( "ItemDeckCategoryEdit.initialize called" );
        $super();
        
        this.prevScreen = prevScreen;
        this.initWithXib( "./Content/Xib/ItemDeckCategoryEdit.xib", true );
        this.status = status;
        this.position = position;
        this.number = number;
        this.decks = decks;
        this.pilotId;
        this.gearId;
        this.initialPilotId;
        this.initialGearId;
        this.hasGotInitialCards = false;
        this.filteredCardList = null;
        this.filteredPilotList = null;
        this.filteredGearList = null;
        this.listPosition = 0;
        this.chosenCard = PILOT;
        this.parentScreen = parentScreen;
    },

    viewDidLoad: function( $super )
    {
        info( "ItemDeckCategoryEdit.viewDidLoad called." );
        $super();
        // Xib.Navigation.getOverlayView().hidePlayerInfo();

        if( this.number == 1 )
        {
            this.numberImage.setImage( "deck_position_1.png" );
        }
        else if( this.number == 2 )
        {
            this.numberImage.setImage( "deck_position_2.png" );
        }
        else
        {
            this.numberImage.setImage( "deck_position_3.png" );
        }
        info( "ItemDeckCategoryEdit loaded" );

        if( this.decks[0] == "status1" )
        {
            this.typeLabel.setText( _loc( "deck_status1_short" ) );
            this.title.setText( _loc( "deck_management_status1" ) );
        }
        if( this.decks[0] == "status2" )
        {
            this.typeLabel.setText( _loc( "deck_status2_short" ) );
            this.title.setText( _loc( "deck_management_status2" ) );
        }
        if( this.decks[0] == "status3" )
        {
            this.typeLabel.setText( _loc( "deck_status3_short" ) );
            this.title.setText( _loc( "deck_management_status3" ) );
        }

        var backFunction = function()
        {
            var func = function()
            {
                if( this.parentScreen == "DeckManagerUI" )
                {
                    var screen = new DeckManagerUI( this.prevScreen );
                } else
                {
                    var screen = new DeckCategoryInfo( this.decks, this.prevScreen );
                }
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );
        ScreenManager.setBackInfo( backFunction );

        // Get Cards
        this.getCards();
        this.getListCards( this.chosenCard );
        this.chosenCard = null;
        this.selectCard1();
    },

    getInitialCards: function( initialPilot, initialGear, initialPilotID, initialGearId )
    {
        this.initialPilot = initialPilot;
        this.initialGear = initialGear;
        this.initialPilotId = initialPilotID;
        this.initialGearId = initialGearId;
    },

    compareCards: function( actualPilotStatus, actualGearStatus )
    {
        if( actualGearStatus.status1 > this.initialGear.status1 )
        {
            this.strNumberLabel.setColor( BETTER_COLOR );
        }
        else if( actualGearStatus.status1 < this.initialGear.status1 )
        {
            this.strNumberLabel.setColor( WORST_COLOR );
        }
        else if( actualGearStatus.status1 == this.initialGear.status1 )
        {
            this.strNumberLabel.setColor( EQUAL_COLOR );
        }
        // next Gear status
        if( actualGearStatus.status2 > this.initialGear.status2 )
        {
            this.fpwNumberLabel.setColor( BETTER_COLOR );
        }
        else if( actualGearStatus.status2 < this.initialGear.status2 )
        {
            this.fpwNumberLabel.setColor( WORST_COLOR );
        }
        else if( actualGearStatus.status2 == this.initialGear.status2 )
        {
            this.fpwNumberLabel.setColor( EQUAL_COLOR );
        }
        // next Gear status
        if( actualGearStatus.status3 > this.initialGear.status3 )
        {
            this.mblNumberLabel.setColor( BETTER_COLOR );
        }
        else if( actualGearStatus.status3 < this.initialGear.status3 )
        {
            this.mblNumberLabel.setColor( WORST_COLOR );
        }
        else if( actualGearStatus.status3 == this.initialGear.status3 )
        {
            this.mblNumberLabel.setColor( EQUAL_COLOR );
        }
        // first pilot status
        if( actualPilotStatus.status1 > this.initialPilot.status1 )
        {
            this.strPercentLabel.setColor( BETTER_COLOR );
        }
        else if( actualPilotStatus.status1 < this.initialPilot.status1 )
        {
            this.strPercentLabel.setColor( WORST_COLOR );
        }
        else if( actualPilotStatus.status1 == this.initialPilot.status1 )
        {
            this.strPercentLabel.setColor( EQUAL_COLOR );
        }
        // next pilot status
        if( actualPilotStatus.status2 > this.initialPilot.status2 )
        {
            this.fpwPercentLabel.setColor( BETTER_COLOR );
        }
        else if( actualPilotStatus.status2 < this.initialPilot.status2 )
        {
            this.fpwPercentLabel.setColor( WORST_COLOR );
        }
        else if( actualPilotStatus.status2 == this.initialPilot.status2 )
        {
            this.fpwPercentLabel.setColor( EQUAL_COLOR );
        }
        // next pilot status
        if( actualPilotStatus.status3 > this.initialPilot.status3 )
        {
            this.mblPercentLabel.setColor( BETTER_COLOR );
        }
        else if( actualPilotStatus.status3 < this.initialPilot.status3 )
        {
            this.mblPercentLabel.setColor( WORST_COLOR );
        }
        else if( actualPilotStatus.status3 == this.initialPilot.status3 )
        {
            this.mblPercentLabel.setColor( EQUAL_COLOR );
        }
    },

    getCards: function()
    {
        var deck = DeckManager.getDeck(); // Gets the battle deck
        var deckKind = deck[this.status]; // Gets the kind of te deck

        info( "ItemDeckCategoryEdit.getCards() called and deckKind is " + JSON.stringify( deckKind ) );

        this.pilot = CardsManager.getPlayerCardById( deckKind[this.position][DeckManager.PILOT] );
        this.gear = CardsManager.getPlayerCardById( deckKind[this.position][DeckManager.GEAR] );
        this.pilotId = this.pilot.id;
        this.gearId = this.gear.id;
    },

    getListCards: function( type )
    {
        info( "ItemDeckCategoryEdit.getListCards called. kind=%s", JSON.stringify( type ) );
        if( !this.filteredCardList )
        {
            this.filteredPilotList = CardsManager.getFilteredPlayerCards(
            {
                "type": PILOT,
                "locked": false
            } );

            this.filteredGearList = CardsManager.getFilteredPlayerCards(
            {
                "type": GEAR,
                "locked": false
            } );

            this.filteredCardList = this.filteredPilotList.clone();
        }

        if( type == PILOT )
        {
            this.filteredCardList = this.filteredPilotList.clone();
        }
        else if( type == GEAR )
        {
            this.filteredCardList = this.filteredGearList.clone();
        }

        this.showCardList();
        this.setData();
    },

    clearCardList: function()
    {
        for (var i = 0; i < 4; i++)
        {
            var image = eval(sprintf("this.card%sImage", i + 1));
            if( image )
            {
                image.setImage("1pxalpha0.png");
            }
        }
    },

    showCardList: function()
    {
        this.clearCardList();
        if( this.filteredCardList != undefined && this.filteredCardList.length != 0 )

        {
            if( this.filteredCardList[this.listPosition] !== undefined )
            {
                this.card1Image.spinnerOn();
                CardsManager.loadCardImage( this.filteredCardList[this.listPosition].definitionId, IMAGE_SIZE.SMALL, function( imageURL )
                {
                    if( this.card1Image._destroyed )
                    {
                        return;
                    }
                    this.card1Image.setImage( imageURL );
                    this.card1Image.spinnerOff();
                }.bind( this ) );
            }
            else
            {
                this.card1Image.setImage( TEXTURE_COLOR.alpha );
            }

            if( this.filteredCardList[this.listPosition + 1] !== undefined )
            {
                this.card2Image.spinnerOn();
                CardsManager.loadCardImage( this.filteredCardList[this.listPosition + 1].definitionId, IMAGE_SIZE.SMALL, function( imageURL )
                {
                    if( this.card2Image._destroyed )
                    {
                        return;
                    }
                    this.card2Image.setImage( imageURL );
                    this.card2Image.spinnerOff();
                }.bind( this ) );
            }
            else
            {
                this.card2Image.setImage( TEXTURE_COLOR.alpha );
            }

            if( this.filteredCardList[this.listPosition + 2] !== undefined )
            {
                this.card3Image.spinnerOn();
                CardsManager.loadCardImage( this.filteredCardList[this.listPosition + 2].definitionId, IMAGE_SIZE.SMALL, function( imageURL )
                {
                    if( this.card3Image._destroyed )
                    {
                        return;
                    }
                    this.card3Image.setImage( imageURL );
                    this.card3Image.spinnerOff();
                }.bind( this ) );
            }
            else
            {
                this.card3Image.setImage( TEXTURE_COLOR.alpha );
            }

            if( this.filteredCardList[this.listPosition + 3] !== undefined )
            {
                this.card4Image.spinnerOn();
                CardsManager.loadCardImage( this.filteredCardList[this.listPosition + 3].definitionId, IMAGE_SIZE.SMALL, function( imageURL )
                {
                    if( this.card4Image._destroyed )
                    {
                        return;
                    }
                    this.card4Image.setImage( imageURL );
                    this.card4Image.spinnerOff();
                }.bind( this ) );
            }
            else
            {
                this.card4Image.setImage( TEXTURE_COLOR.alpha );
            }
        }
    },

    setData: function()
    {
        info( "ItemDeckCategoryEdit.setDada() called" );
        this.numberLabel.setText( this.number );

        this.firstCard.spinnerOn();
        CardsManager.loadCardImage( this.gear.definitionId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.firstCard._destroyed )
            {
                return;
            }
            this.firstCard.setImage( imageURL );
            this.firstCard.spinnerOff();
        }.bind( this ) );

        this.secondCard.spinnerOn();
        CardsManager.loadCardImage( this.pilot.definitionId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.secondCard._destroyed )
            {
                return;
            }
            this.secondCard.setImage( imageURL );
            this.secondCard.spinnerOff();
        }.bind( this ) );

        var pilotStatus = CardsManager.getCardStatus( this.pilot );
        var gearStatus = CardsManager.getCardStatus( this.gear );
        var unitStatus = CardsManager.getUnitStatusWithSkill( this.pilot, this.gear );

        if( !this.hasGotInitialCards )
        {
            this.getInitialCards( pilotStatus, gearStatus, this.pilot.id, this.gear.id );
            this.hasGotInitialCards = true;
        }
        this.strNumberLabel.setText( gearStatus.status1 );
        this.fpwNumberLabel.setText( gearStatus.status2 );
        this.mblNumberLabel.setText( gearStatus.status3 );

        this.strPercentLabel.setText( Math.floor( pilotStatus.status1 * 100 ) + "%" );
        this.fpwPercentLabel.setText( Math.floor( pilotStatus.status2 * 100 ) + "%" );
        this.mblPercentLabel.setText( Math.floor( pilotStatus.status3 * 100 ) + "%" );

        this.strSkill.setText( unitStatus.status1 );
        this.fpwSkill.setText( unitStatus.status2 );
        this.mblSkill.setText( unitStatus.status3 );

        this.pilotName.setText( _loc(CardsManager.getCardName( this.pilot.definitionId ) ) );
        this.gearName.setText( _loc(CardsManager.getCardName( this.gear.definitionId ) ) );
        this.compareCards( pilotStatus, gearStatus );

        var skillsInfo = CardsManager.getSkillsFromUnit( this.pilot.definitionId, this.gear.definitionId );
        var availableSkills = CardsManager.getCardDefinition( this.pilot.definitionId ).skillId;

        this.resetSkills();

        var skills                  = [];
        
        for(var g = 0; g < skillsInfo.length; ++g)
        {
            skills.push( skillsInfo[g].name );
        }

        var view = this.xib_viewScroll.nodeWithTag( 88 );
        for( var f = 0; f < availableSkills.length; ++f )
        {
            if( availableSkills[f] < 0 )
            {
                continue;
            }

            var skillInfo = SkillsManager.getSkillById( availableSkills[f] );

            view.nodeWithTag( f + 1 ).setImage( skillInfo.img + ".png" );
            if( skills.indexOf( skillInfo.name ) < 0 )
            {
                view.nodeWithTag( f + 1 ).setAlpha( 0.4 );
            }
            else
            {
                view.nodeWithTag( f + 1 ).setAlpha( 1 );   
            }
        }
    },

    resetSkills: function()
    {
        var view = this.xib_viewScroll.nodeWithTag( 88 );
        for( var i = 0; i < 4; ++i )
        {
            view.nodeWithTag( i + 1 ).setImage( TEXTURE_COLOR.alpha );
        }
    },

    nextAction: function()
    {
        info( "ItemDeckCategoryEdit.nextAction called." );
        if( this.listPosition + 4 < this.filteredCardList.length )
        {
            this.listPosition++;
            this.showCardList();
        }
    },

    prevAction: function()
    {
        info( "ItemDeckCategoryEdit.prevAction called." );
        if( this.listPosition > 0 )
        {
            this.listPosition--;
            this.showCardList();
        }
    },

    returnAction: function()
    {
        info( "ItemDeckCategoryEdit.returnAction called." );
        this.getListCards( this.chosenCard );
        this.getCards();
        this.setData();
        this.showCardList();
    },

    applyAction: function()
    {
        info( "ItemDeckCategoryEdit.returnAction Action." );
        DeckManager.addCardInSlot( this.pilotId, this.status, this.position, DeckManager.PILOT );
        DeckManager.addCardInSlot( this.gearId, this.status, this.position, DeckManager.GEAR );
        CardsManager.lockCard( this.initialGearId, false, "" );
        CardsManager.lockCard( this.gearId, true, "DECK" );
        CardsManager.lockCard( this.initialPilotId, false, "" );
        CardsManager.lockCard( this.pilotId, true, "DECK" );
        DeckManager.setDeck( DeckManager.getDeck() );
        
        if( this.parentScreen == "DeckManagerUI" )
        {
            var screen = new DeckManagerUI( this.prevScreen );
        } else
        {
            var screen = new DeckCategoryInfo( this.decks );
        }
        
        Xib.Navigation.resetScreenStackTo( screen, false );
    },

    skillClicked            : function(sender)
    {
        var pilotDefinitionId = CardsManager.getPlayerCardById( this.pilotId ).definitionId;
        var gearDefinitionId = CardsManager.getPlayerCardById( this.gearId ).definitionId;
        
        info( "DeckCategoryInfo.skillClicked view._pilotId=%s, view._gearId=%s", pilotDefinitionId, gearDefinitionId );

        var screen = new SkillsDetails( pilotDefinitionId, gearDefinitionId );
        Xib.Navigation.pushViewController( screen, true );
    },

    setNewDeckCards: function( position )
    {
        info( "ItemDeckCategoryEdit.setNewDeckCards called" );
        if( this.filteredCardList[this.listPosition + position] !== undefined )
        {
            if( this.chosenCard == PILOT )
            {
                var oldPilot = this.pilot;
                this.pilot = CardsManager.getPlayerCardById( this.filteredCardList[this.listPosition + position].id );
                this.pilotId = this.pilot.id;
                this.filteredCardList[this.listPosition + position] = CardsManager.getPlayerCardById( oldPilot.id );
            }
            else
            {
                var oldGear = this.gear;
                this.gear = CardsManager.getPlayerCardById( this.filteredCardList[this.listPosition + position].id );
                this.gearId = this.gear.id;
                this.filteredCardList[this.listPosition + position] = CardsManager.getPlayerCardById( oldGear.id );
            }
            this.showCardList();
            this.setData();
        }
    },

    button1Action: function()
    {
        info( "ItemDeckCategoryEdit.button1Action called." );
        this.setNewDeckCards( 0 );
    },

    button2Action: function()
    {
        info( "ItemDeckCategoryEdit.button2Action called." );
        this.setNewDeckCards( 1 );
    },

    button3Action: function()
    {
        info( "ItemDeckCategoryEdit.button2Action called." );
        this.setNewDeckCards( 2 );
    },

    button4Action: function()
    {
        info( "ItemDeckCategoryEdit.button2Action called." );
        this.setNewDeckCards( 3 );
    },

    selectCard1: function()
    {
        info( "ItemDeckCategoryEdit.selectCard1 called" );
        if( this.chosenCard != GEAR )
        {
            this.chosenCard = GEAR;
            this.listPosition = 0;
            this.getListCards( this.chosenCard );
            this.typeCardSelected.setText( _loc("deck_management_gears") );
            this.selectedCardGear.setImage( "deck_card_on.png" );
            this.selectedCardPilot.setImage( "deck_card_off.png" );

            this.firstCardButton.setImage( "deck_card_info_selected.png" );
            this.secondCardButton.setImage( "deck_card_info.png" );
        }
    },

    selectCard2: function()
    {
        info( "ItemDeckCategoryEdit.selectCard2 called" );
        if( this.chosenCard != PILOT )
        {
            this.chosenCard = PILOT;
            this.listPosition = 0;
            this.getListCards( this.chosenCard );
            this.typeCardSelected.setText( _loc("deck_management_pilots") );
            this.selectedCardGear.setImage( "deck_card_off.png" );
            this.selectedCardPilot.setImage( "deck_card_on.png" );

            this.firstCardButton.setImage( "deck_card_info.png" );
            this.secondCardButton.setImage( "deck_card_info_selected.png" );
        }
    },
    /*
     * _fixCardRatio: function( cardImage) { info( "CardScreen._fixCardRatio, called." );
     *  // Scale the card to keep the correct ratio var frame = cardImage.getFrame(); var size = frame._size; var origin = frame._origin; var frameRatio = size._height / size._width;
     *  // Taller // TODO FIXME apply this to this.detailView if( frameRatio > CARD_RATIO ) { var newHeight = size._width * CARD_RATIO; cardImage.setFrame( origin._x, origin._y + ( size._height -
     * newHeight ) / 2, size._width, newHeight ); } else { var newWidth = size._height / CARD_RATIO; cardImage.setFrame( origin._x + ( size._width - newWidth ) / 2, origin._y, newWidth, size._height ); //
     * this.mainCardButton.setPosition( this.mainCardButton.getPosition()._x + newWidth /2, this.mainCardButton.getPosition()._y ) } },
     */

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
        var backFunction = function()
        {
            var func = function()
            {
                if( this.parentScreen == "DeckManagerUI" )
                {
                    var screen = new DeckManagerUI( this.prevScreen );
                } else
                {
                    var screen = new DeckCategoryInfo( this.decks, this.prevScreen );
                }
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );
        ScreenManager.setBackInfo( backFunction );

    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/DeckCategoryInfo'] = function(){var exports = $MODULE_REGISTRY['Code/UI/DeckCategoryInfo'] || {}; $MODULE_REGISTRY['Code/UI/DeckCategoryInfo'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/DeckCategoryInfo.js';

exports.DeckCategoryInfo = ScrollableView.subclass(
{
    classname: "DeckCategoryInfo",
    currentDeck : 0,


    initialize: function( $super, deckTypes, prevScreen )
    {
        info( "DeckCategoryInfo.initialize called." );
        this.prevScreen = prevScreen;
        this.decks = deckTypes;
        this.typeDecksLoaded;
        this.decksLoaded;

        $super();

        this.initWithXib( "./Content/Xib/DeckCategoryInfo.xib", true );
    },

    setButtonStates: function()
    {
        if (this.decks.length == 3)
        {
            this.currentDeck = -1;
        }
        else if (this.decks.length == 1)
        {
            switch(this.decks[0])
            {
                case DeckManager.FIGHTER:
                    this.currentDeck = DeckManager.FIGHTER;
                    this.title.setText( _loc( "deck_title_status1" ) );
                    break;

                case DeckManager.SHOOTER:
                    this.currentDeck = DeckManager.SHOOTER;
                    this.title.setText( _loc( "deck_title_status2" ) );
                    break;

                case DeckManager.MANEUVER:
                    this.currentDeck = DeckManager.MANEUVER;
                    this.title.setText( _loc( "deck_title_status3" ) );
            }
        }

        this._setButtonStates();

        switch(this.currentDeck)
        {
            case DeckManager.FIGHTER:
                this.button_strength.setEnabled(false);
                this.button_strength.setHighlighted(true);
                this.button_general.setEnabled(true);
                this.button_mobility.setEnabled(true);
                this.button_firepower.setEnabled(true);
                break;

            case DeckManager.SHOOTER:
                this.button_firepower.setEnabled(false);
                this.button_firepower.setHighlighted(true);
                this.button_general.setEnabled(true);
                this.button_strength.setEnabled(true);
                this.button_mobility.setEnabled(true);
                break;

            case DeckManager.MANEUVER:
                this.button_mobility.setEnabled(false);
                this.button_mobility.setHighlighted(true);
                this.button_general.setEnabled(true);
                this.button_strength.setEnabled(true);
                this.button_firepower.setEnabled(true);
                break;

            default:
                this.button_general.setEnabled(false);
                this.button_general.setHighlighted(true);
                this.button_firepower.setEnabled(true);
                this.button_strength.setEnabled(true);
                this.button_mobility.setEnabled(true);
                break;
        }
    },

    viewDidLoad: function( $super )
    {
        info( "DeckCategoryInfo.viewDidLoad called." );
        $super();

        var backFunction = function()
        {
            var func = function()
            {
                var screen = new DeckManagerUI(this.prevScreen);
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
        this.setButtonStates();
        this.createCells();
    },

    _setButtonStates: function()
    {
        var typeData =
        {
            "selected":
            {
                "image": "deck_button_tab_selected.png",
                "textColor": FONT_COLOR.orange
            },
            "unselected":
            {
                "image": "deck_button_tab_unselected.png",
                "textColor": FONT_COLOR.blue
            }
        };

        this.button_general.setStateData( typeData, this.button_general._text );
        this.button_strength.setStateData( typeData, this.button_strength._text );
        this.button_firepower.setStateData( typeData, this.button_firepower._text );
        this.button_mobility.setStateData( typeData, this.button_mobility._text );
    },

    createCells: function()
    {
        var length = this.numberOfListItems();
        var view, weaponName, fighterName, firstView,
        secondView, thirdView, weaponPicture, fighterPicture ,
        weaponStr , weaponFpw, weaponMbl, fighterStr, fighterFpw,
        fighterMbl, skillsStr, skillsFpw, skillsMbl, editButton, kindLabel, totalPower;

        for( var i = 0; i < length; i++ )
        {
            view = this.xib_viewScroll.nodeWithTag( i + 1 );
            view.setVisible(true);
            weaponName = view.nodeWithTag( 1 );
            fighterName = view.nodeWithTag( 2 );
            firstView = view.nodeWithTag( 3 );
            secondView = view.nodeWithTag( 4 );
            thirdView = view.nodeWithTag( 5 );

            weaponPicture = firstView.nodeWithTag( 3 );
            fighterPicture = secondView.nodeWithTag( 4 );
            weaponStr = firstView.nodeWithTag( 9 );
            weaponFpw = firstView.nodeWithTag( 10 );
            weaponMbl = firstView.nodeWithTag( 11 );
            fighterStr = secondView.nodeWithTag( 12 );
            fighterFpw = secondView.nodeWithTag( 13 );
            fighterMbl = secondView.nodeWithTag( 14 );
            skillsStr = thirdView.nodeWithTag( 15 );
            skillsFpw = thirdView.nodeWithTag( 16 );
            skillsMbl = thirdView.nodeWithTag( 17 );
            editButton = view.nodeWithTag( 19 );
            kindLabel = view.nodeWithTag( 20 );
            totalPower = view.nodeWithTag( 21 );

            if( this.decks[0] == "status1" )
            {
                kindLabel.setText(_loc("deck_status1_short"));
                this.infoBox.setText(_loc("deck_management_assault_info_box"));
            }
            else if( this.decks[0] == "status2" )
            {
                kindLabel.setText(_loc("deck_status2_short"));
                this.infoBox.setText(_loc("deck_management_tactical_info_box"));
            }
            else if( this.decks[0] == "status3" )
            {
                kindLabel.setText(_loc("deck_status3_short"));
                this.infoBox.setText(_loc("deck_management_support_info_box"));
            }

            if( i == 0 )
            {
                this.typeDecksLoaded = 0;
                this.decksLoaded = 0;
            }
            else if( i == 1 )
            {
                this.typeDecksLoaded = 0;
                this.decksLoaded = 1;
            }
            else if( i == 2 )
            {
                this.typeDecksLoaded = 0;
                this.decksLoaded = 2;
            }

            editButton.status = this.decks[this.typeDecksLoaded]; // Save the kind of the deck
            editButton.position = this.decksLoaded;
            editButton.number = i + 1;
            var deck = DeckManager.getDeck();
            var deckKind = deck[this.decks[this.typeDecksLoaded]]; // Gets the kind of te deck
            this.pilotId = deckKind[this.decksLoaded][DeckManager.PILOT];
            this.gearId = deckKind[this.decksLoaded][DeckManager.GEAR];

            var pilot = CardsManager.getPlayerCardById( this.pilotId );
            var gear = CardsManager.getPlayerCardById( this.gearId );

            if( this.pilotId != -1 && this.gearId != -1 )
            {
                weaponPicture.spinnerOn();
                CardsManager.loadCardImage( gear.definitionId, IMAGE_SIZE.BIG, function(picture, imageURL )
                {
                    if( picture._destroyed )
                    {
                        return;
                    }
                    picture.setImage( imageURL );
                    picture.spinnerOff();
                }.bind( this, weaponPicture ) );

                fighterPicture.spinnerOn();
                CardsManager.loadCardImage( pilot.definitionId, IMAGE_SIZE.BIG, function(picture, imageURL )
                {
                    if( picture._destroyed )
                    {
                        return;
                    }
                    picture.setImage( imageURL );
                    picture.spinnerOff();
                }.bind( this, fighterPicture ) );

                // TODO fixme WTF, why we are recycling this.gearId (previously
                // it was instanceId)
                this.gearId = gear.definitionId;
                this.pilotId = pilot.definitionId;

                //SkillsIcons
                var skillsInfo              = CardsManager.getSkillsFromUnit(this.pilotId, this.gearId);
                var availableSkills         = CardsManager.getCardDefinition(this.pilotId).skillId;
                
                var skills                  = [];
                
                for(var g = 0; g < skillsInfo.length; ++g)
                {
                    skills.push( skillsInfo[g].name );
                }

                info( "DeckCategoryInfo.createCells skills=%s", JSON.stringify( skills ) );
                info( "DeckCategoryInfo.createCells availableSkills=%s", JSON.stringify( availableSkills ) );

                this._clearSkills( view.nodeWithTag( 5 ) );
                for( var f = 0; f < availableSkills.length; ++f )
                {
                    if( availableSkills[f] < 0 )
                    {
                        continue;
                    }
                    var skillInfo = SkillsManager.getSkillById( availableSkills[f] );

                    view.nodeWithTag( 5 ).nodeWithTag( 5 + f ).setImage( skillInfo.img + ".png" );
                    if( skills.indexOf( skillInfo.name ) < 0 )
                    {
                        view.nodeWithTag( 5 ).nodeWithTag( 5 + f ).setAlpha( 0.4 );
                    }
                    else
                    {
                        view.nodeWithTag( 5 ).nodeWithTag( 5 + f ).setAlpha( 1 );
                    }
                }

                view._pilotId       = pilot.definitionId;
                view._gearId        = gear.definitionId;

                weaponName.setText( CardsManager.getCardName( gear.definitionId ) );
                fighterName.setText( CardsManager.getCardName( pilot.definitionId ) );

                var pilotStatus = CardsManager.getCardStatus( pilot );
                var gearStatus = CardsManager.getCardStatus( gear );
                var unitStatus = CardsManager.getUnitStatusWithSkill( pilot,  gear );

                weaponStr.setText( gearStatus.status1 );
                weaponFpw.setText( gearStatus.status2 );
                weaponMbl.setText( gearStatus.status3 );

                fighterStr.setText( Math.floor(pilotStatus.status1 * 100) + "%"  );
                fighterFpw.setText( Math.floor(pilotStatus.status2 * 100) + "%"  );
                fighterMbl.setText( Math.floor(pilotStatus.status3 * 100) + "%"  );

                skillsStr.setText( unitStatus.status1 );
                skillsFpw.setText( unitStatus.status2 );
                skillsMbl.setText( unitStatus.status3 );

                var unitPower = unitStatus.status1 + unitStatus.status2 + unitStatus.status3;
                totalPower.setText( unitPower );
            }
        }
    },
    
    _clearSkills: function( view )
    {
        for( var f = 5; f < 9; ++f )
        {
            view.nodeWithTag( f ).setImage( TEXTURE_COLOR.alpha );
        }
    },

    numberOfListItems: function()
    {
        var numberListItems = 3;
        info( "DeckCategoryInfo.numberOfListItems numberListItems=%s", JSON.stringify( numberListItems ) );
        return numberListItems;
    },

    editAction: function( sender )
    {
        var func = function()
        {
            var screen = new ItemDeckCategoryEdit( sender.status, sender.position, sender.number, "DeckCategoryInfo", this.decks, this.prevScreen );
            Xib.Navigation.pushViewController( screen, false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    firstDeckClicked: function()
    {
        var func = function()
        {
            this.decks = [ DeckManager.FIGHTER ];
            this.setButtonStates();
            this.createCells();
            Xib.Navigation.removeModalOverlay();
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    secondDeckClicked: function()
    {
        var func = function()
        {
            this.decks = [ DeckManager.SHOOTER ];
            this.setButtonStates();
            this.createCells();
            Xib.Navigation.removeModalOverlay();
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    thirdDeckClicked: function()
    {
        var func = function()
        {
            this.decks = [ DeckManager.MANEUVER ];
            this.setButtonStates();
            this.createCells();
            Xib.Navigation.removeModalOverlay();
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    allDecksClicked: function()
    {
        var func = function()
        {
            Xib.Navigation.resetScreenStackTo( new DeckManagerUI(), false );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
        var backFunction = function()
        {
            var func = function()
            {
                var screen = new DeckManagerUI(this.prevScreen);
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
    },

    searchForViewWithSender : function(sender)
    {
        info( "DeckCategoryInfo.searchForViewWithSender sender=%s", sender );
        var view, i;

        for( i = 0; i < this.numberOfListItems(); ++i )
        {
            view = this.xib_viewScroll.nodeWithTag( i + 1 );

            if( view.nodeWithTag( 5 ).nodeWithTag( 100 ) == sender )
            {
                return view;
            }
        }
    },

    skillClicked            : function(sender)
    {
        var view, screen;

        view = this.searchForViewWithSender( sender );
        info( "DeckCategoryInfo.skillClicked view._pilotId=%s, view._gearId=%s", view._pilotId, view._gearId );
        
        screen = new SkillsDetails( view._pilotId, view._gearId );
        Xib.Navigation.pushViewController( screen, true );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardCollectionUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardCollectionUI'] || {}; $MODULE_REGISTRY['Code/UI/CardCollectionUI'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardCollectionUI.js';

exports.CardCollectionUI = ScrollableView.subclass(
{
    classname: 'CardCollectionUI',

    m_page: -1,
    m_numberOfPages: -1,
    m_maxCardsPerPage: 12,

    m_filterType: null,
    m_filterRarity: null,
    m_filterFaction: null,

    m_viewLoaded: false,
    m_cardsLoaded: false,
    m_UIPopulated: false,

    m_comboBoxFactions: null,
    m_comboBoxRarity: null,

    initialize: function( $super )
    {
        info( "CardCollectionUI.initialize called." );
        $super();

        this.m_cards            = [];   // All available cards
        this.m_filteredCards    = [];   // Cards after applying a filter
        this.m_filteredCardsIds = [];   // Cards after applying a filter (only the ids)
        this.m_displayedCards   = [];   // Cards currently displayed on screen
        this.m_userCards        = {};   // Cards owned by the user

        this._retrieveCards();
        this._getUserCards();

        this._userCardsPerType = CardsManager.getCollectionNumber();
        this._totalCards = CardsManager.getCardsNumber();
        this.initWithXib( "./Content/Xib/CardCollectionUI.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "CardCollectionUI.viewDidLoad called." );
        $super();

        var typeData =
        {
            "selected":
            {
                "image": "fusion_big_tab_selected.png",
                "textColor": FONT_COLOR.white
            },
            "unselected":
            {
                "image": "fusion_big_tab_unselected.png",
                "textColor": FONT_COLOR.white
            }
        };

        this.button_weapon.setStateData( typeData );
        this.button_fighter.setStateData( typeData );

        this._setupCardsCallbacks();
        this.m_viewLoaded = true;

        this._populateUI();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( NO_SCREEN );

        this.button_event.setEnabled( false );
        this.button_event.setAlpha( 0.5 );

        this.pilotsAmount.setText(_loc("card_collection_pilots", this._userCardsPerType["PILOT"], this._totalCards["PILOT"]));
        this.equipmentAmount.setText(_loc("card_collection_equipment", this._userCardsPerType["GEAR"], this._totalCards["GEAR"]));
    },

    _populateUI: function()
    {
        info( "CardCollectionUI._populateUI called." );

        if( this.m_cardsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;
            this._setupComboBoxFactions();
            this._setupComboBoxRarity();
            this.filterVehicle();
        }
    },

    _sortOptionCallback: function( data )
    {
        info( "CardCollectionUI._sortOptionCallback called. data=%s", JSON.stringify( data ) );
        if( data.type == "race" )
        {
            this.m_filterFaction = data.value;
        }
        else if( data.type == "rarity" )
        {
            this.m_filterRarity = data.value;
        }

        this._applyFilters();
        this.setPage( 0 );
    },

    _setupComboBoxFactions: function()
    {
        var key, sortOptionList, sortOption, comboBox;

        sortOptionList = [];
        var firstSortOption =
        {
            "text": _loc( "card_collection_faction_filter_label" ),
            "value": null,
            "type": "race", // TODO FIXME Replace with ENUM
            "selected": true
        };
        firstSortOption.callback = this._sortOptionCallback.bind( this, firstSortOption );
        sortOptionList.push( firstSortOption );

        for( var key in FACTIONS )
        {
            sortOption =
            {
                "text": key,
                "value": _loc(FACTIONS[key]),
                "type": "race",
                "selected": false
            };
            sortOption.callback = this._sortOptionCallback.bind( this, sortOption );
            sortOptionList.push( sortOption );
        }

        // Adding the comboBox to the comboBoxView
        this.m_comboBoxFactions = new ComboBox( sortOptionList, this.view_factionsComboBox );

        this.m_comboBoxFactions.setOnShowCallback( function()
        {
            this.m_comboBoxRarity.hide();
        }.bind( this ) );
    },

    _setupComboBoxRarity: function()
    {
        var rarity, sortOptionList, sortOption;

        sortOptionList = [];
        sortOption =
        {
            "text": _loc( "card_collection_rarity_filter_label" ),
            "value": null,
            "type": "rarity",
            "selected": true
        };
        sortOption.callback = this._sortOptionCallback.bind( this, sortOption );
        sortOptionList.push( sortOption );

        for( rarity = 1; rarity < 5; rarity++ )
        {
            sortOption =
            {
                "text": _loc(RARITY_TEXT[rarity]),
                "value": rarity,
                "type": "rarity",
                "selected": false
            };
            sortOption.callback = this._sortOptionCallback.bind( this, sortOption );
            sortOptionList.push( sortOption );
        }

        // Adding the comboBox to the comboBoxView
        this.m_comboBoxRarity = new ComboBox( sortOptionList, this.view_rarityComboBox );

        this.m_comboBoxRarity.setOnShowCallback( function()
        {
            this.m_comboBoxFactions.hide();
        }.bind( this ) );
    },

    /** Exposed Methods * */
    _cardClicked: function( cardPos, /* Xib.Button */ inSender )
    {
        var i, card, displayedCard, filteredCards;

        displayedCard = this.m_displayedCards[cardPos];
        info( "CardCollectionUI.cardClicked called. cardPos=%d, card=%s", cardPos, JSON.stringify( displayedCard ) );

        filteredCards = [];
        for( i = 0; i < this.m_filteredCards.length; i++ )
        {
            card = this.m_filteredCards[i];
            if( this.m_userCards[ card.id ] )
            {
                filteredCards.push( card );
            }
        }

        if( displayedCard.definitionId < 0 )
        {
            info( "CardCollectionUI._cardClicked Returning, displayedCard=%s", JSON.stringify( displayedCard ) );
        }
        else
        {
            var func = function()
            {
                var cardScreen = new CardScreenDefinition( displayedCard.definitionId, filteredCards, "CardCollection" );
                Xib.Navigation.pushViewController( cardScreen, true );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
    },

    _setupCardsCallbacks: function()
    {
        var i, callback;
        for( i = 0; i < this.m_maxCardsPerPage; i++ )
        {
            callback = sprintf( "_cardClicked.bind( this._target, %d )", i );
            this.getCardSlot( i ).setTargetAction( this, callback );
        }
    },

    _resetComboBoxFilters: function()
    {
        this.m_filterRarity = null;
        this.m_filterFaction = null;

        if( this.m_comboBoxFactions && this.m_comboBoxFactions.isLoaded && this.m_comboBoxFactions.isLoaded() )
        {
            this.m_comboBoxFactions.reset();
        }

        if( this.m_comboBoxRarity && this.m_comboBoxRarity.isLoaded && this.m_comboBoxRarity.isLoaded() )
        {
            this.m_comboBoxRarity.reset();
        }
    },

    filterVehicle: function()
    {
        this.m_filterType = GEAR;
        this._resetComboBoxFilters();

        this.button_weapon.setEnabled( 0 );
        this.button_fighter.setEnabled( 1 );

        this._applyFilters();
        this.setPage( 0 );
    },

    filterCharacter: function()
    {
        this.m_filterType = PILOT;
        this._resetComboBoxFilters();

        this.button_weapon.setEnabled( 1 );
        this.button_fighter.setEnabled( 0 );

        this._applyFilters();
        this.setPage( 0 );
    },

    nextPage: function( /* Xib.Button */inSender )
    {
        info( "CardCollectionUI.nextPage called." );
        this.button_next._lastTap = 0; // HACK to disable delay between touchs

        if( this.m_page < this.m_numberOfPages )
        {
            this.setPage( this.m_page + 1 );
        }
    },

    prevPage: function( /* Xib.Button */inSender )
    {
        info( "CardCollectionUI.prevPage called." );
        this.button_prev._lastTap = 0; // HACK to disable delay between touchs

        if( this.m_page > 0 )
        {
            this.setPage( this.m_page - 1 );
        }
    },
    /** Exposed Methods * */

    setPage: function( page )
    {
        info( "CardCollectionUI.setPage called. page=%d, this.m_page=%d", page, this.m_page );
        this.m_page = page;

        // Hide page buttons
        this._refreshPageButtons();

        this._refreshPageLabel();
        this._generateDisplayedCards();
        this._drawCards();
    },

    _retrieveCards: function()
    {
        info( "CardCollectionUI._retrieveCards called." );

        var i, len, cards;

        this.m_cards = [];
        cards = CardsManager.getCardDefinitionsArray();
        len = cards.length;

        for( i = 0; i < len; i++ )
        {
            this.m_cards.push( cards[i].id );
        }

        this._applyFilters();
    },

    _applyFilters: function()
    {
        var filter, i, filteredCards;

        filter = {};

        if( this.m_filterType )
        {
            filter.type = this.m_filterType;
        }

        if( this.m_filterRarity )
        {
            filter.rarity = this.m_filterRarity;
        }

        if( this.m_filterFaction )
        {
            filter.race = this.m_filterFaction;
        }

        filteredCards = CardsManager.getFilteredCards( filter, true );

        this.m_filteredCards = filteredCards.clone();
        this.m_filteredCardsIds = [];
        for( i = 0; i < filteredCards.length; i++ )
        {
            this.m_filteredCardsIds.push( filteredCards[i].id );
        }

        this.m_numberOfPages = Math.ceil( this.m_filteredCardsIds.length / this.m_maxCardsPerPage );
    },

    _refreshPageLabel: function()
    {
        info( "CardCollectionUI.refreshPageLabel called. this.m_page=%d this.m_numberOfPages=%d", this.m_page, this.m_numberOfPages );
        var labelStr = sprintf( "%d/%d", this.m_page + 1, this.m_numberOfPages ? this.m_numberOfPages : 1 );
        this.page_lbl.setText( labelStr );
    },

    _refreshPageButtons: function()
    {
        info( "CardCollectionUI._refreshPageButtons called." );

        var numberOfPages = this.m_numberOfPages ? this.m_numberOfPages : 1;
        if( this.m_page == 0 )
        {
            enabledPrev = 0;
            this.button_prev.setEnabled( 0 );
        }
        else
        {
            this.button_prev.setEnabled( 1 );
        }

        if( this.m_page == ( numberOfPages - 1 ) )
        {
            this.button_next.setEnabled( 0 );
        }
        else
        {
            this.button_next.setEnabled( 1 );
        }
    },

    _getUserCards: function()
    {
        info( "CardCollectionUI._getUserCards called." );

        this.m_userCards = {};
        var i, cards, definitionId;
        this.m_userCards = {};

        cards = CardsManager.getPlayerHistoryCardList();

        var keys = Object.keys( cards );
        info( "CardCollectionUI._getUserCards cards=%s", JSON.stringify( cards ) );
        info( "CardCollectionUI._getUserCards key=%s", JSON.stringify( keys ) );
        for( i = 0; i < keys.length; i++ )
        {
            // TODO This is quite stupid, if you have time, please remove this and use an array
            definitionId = keys[i];
            this.m_userCards[definitionId] = { 'definitionId': definitionId };
        }

        this.m_cardsLoaded = true;
        this._populateUI();
    },

    _generateDisplayedCards: function()
    {
        info( "CardCollectionUI._generateDisplayedCards called. this.m_page=%d", this.m_page );

        var i, j, definitionId, card, numberOfAvailableCards;

        // Set image cards
        numberOfAvailableCards = this.m_filteredCardsIds.length;

        for( i = 0; i < this.m_maxCardsPerPage; i++ )
        {
            j = i + this.m_maxCardsPerPage * this.m_page;

            if( j < numberOfAvailableCards )
            {
                definitionId = this.m_filteredCardsIds[j];
                card = this.m_userCards[definitionId];

                if( card )
                {
                    this.m_displayedCards[i] =
                    {
                        'definitionId': card.definitionId
                    };
                }
                else
                {
                    this.m_displayedCards[i] =
                    {
                        'definitionId': DEFAULT_CARD_ID
                    };
                }
            }
            else
            {
                this.m_displayedCards[i] =
                {
                    'definitionId': NON_EXISTENT_CARD_ID
                };
            }
        }
        info( "CardCollectionUI._generateDisplayedCards this.m_displayedCards=%s", JSON.stringify( this.m_displayedCards ) );
    },

    _drawCards: function()
    {
        info( "CardCollectionUI._drawCards called." );
        var position, cardSlot, displayedCard, cardButton, backCardImage;
        backCardImage = sprintf( "%s_%s.jpg", DEFAULT_CARD_IMAGE, IMAGE_SIZE.SMALL );

        for( position = 0; position < this.m_displayedCards.length; position++ )
        {
            displayedCard   = this.m_displayedCards[position];
            cardSlot        = this.getCardSlot( position );
            cardButton      = eval( sprintf( "this.button_%d", position ) );

            cardButton.setImage( backCardImage );

            if( displayedCard !== null && displayedCard.definitionId != NON_EXISTENT_CARD_ID && displayedCard.definitionId != DEFAULT_CARD_ID )
            {
                info( "CardCollectionUI._drawCards displayedCard.definitionId=%s, this.m_page=%s", JSON.stringify( displayedCard.definitionId ), this.m_page );

                CardsManager.loadCardImage( displayedCard.definitionId, IMAGE_SIZE.SMALL,
                    function( _cardButton, _page, imageURL )
                    {
                        if( this.m_page == _page )
                        {
                            info( "CardCollectionUI._drawCards._innerCallback page=%s, imageURL=%s", _page, imageURL );
                            _cardButton.setImage( imageURL );
                        }
                        else
                        {
                            warn( "CardCollectionUI._drawCards._innerCallback The page has changed! skipping image update. page=%s, this.m_page=%s", _page, this.m_page );
                        }
                    }.bind( this, cardButton, this.m_page )
                );
            }
        }
    },

    goToRewards: function()
    {
            var func = function()
            {
                var screen = new RewardList(STAGE_REWARDS);
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    getCardSlot: function( id )
    {
        var button = eval( sprintf( "this.button_%d", id ) );

        if( button == undefined )
        {
            err( "CardCollectionUI.getCardSlot Error, button not found. id=%d", id );
            return;
        }

        return button;
    },

    destroy: function()
    {
        if( this.m_comboBoxRarity != undefined )
        {
            this.m_comboBoxRarity.destroy();
        }
        if( this.m_comboBoxFactions != undefined )
        {
            this.m_comboBoxFactions.destroy();
        }
        this.m_comboBoxRarity = null;
        this.m_comboBoxFactions = null;
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
        var backFunction = function()
        {
            var func = function()
            {
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind(this);

        ScreenManager.setBackInfo(backFunction);
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/TestScreen2'] = function(){var exports = $MODULE_REGISTRY['Code/UI/TestScreen2'] || {}; $MODULE_REGISTRY['Code/UI/TestScreen2'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/TestScreen2.js';

exports.TestScreen2 = XibUI.subclass(
{
    classname: 'TestScreen2',
    
    initialize: function()
    {
        this.initWithXib("./Content/Xib/TestScreen2.xib", true);
        
    },
    
    viewDidLoad: function()
    {
        info( "TestView loaded" );
    }
}
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardScreen'] || {}; $MODULE_REGISTRY['Code/UI/CardScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardScreen.js';

exports.CardScreen = XibUI.subclass(
{
    classname: 'CardScreen',

    /**
     * CardScreen.initialize CardScreenInstance and CardScreenDefinition inherit from CardScreen
     */

    NUM_CARD_DISPLAY: 3,
    CARD_MOVEMENT_DURATION: 0.6,
    SCROLL_MIN_DISTANCE_FRACTION: 0.3,
    TOUCH_MAX_TIME: 300,
    DISTANCE_FACTOR : 1.2,

    initialize: function()
    {
        info( "CardScreen.initialize called." );

        this.m_animationDistance = 0;
        this.m_currentCardIndex = null;
        this.m_cardDefinition = null;
        this.m_LeftCardDefinition = null;
        this.m_RightCardDefinition = null;
        this.m_isShowingDetails = true;
        this.m_CardDisplays = [];
        this.m_CenterCardIndex = 0;
        this.m_PendingCardsToLoad = this.NUM_CARD_DISPLAY;
        this.m_touchTarget = null;
        this.m_touchId = null;
        this.m_touchStartTime = null;
        this.m_tochInitialPosition = null;
        this.m_cardInitialPosition = null;
        this.m_centerPosition = null;
        this.m_leftPosition = null;
        this.m_rightPosition = null;

        this.initWithXib( "./Content/Xib/CardScreen.xib", true );
    },

    _setupBackButton: function()
    {
        info( "CardScreen._setupBackButton called." );

        var backFunction = function()
        {
            var screen;

            switch( this.m_prevScreen )
            {
                case "Menu":
                    screen = new ControlRoom();
                    Xib.Navigation.resetScreenStackTo( screen, false );
                    break;

                case "Gasha":
                    screen = new GashaStore();
                    Xib.Navigation.resetScreenStackTo( screen, false );
                    break;

                case "CardCollection":
                    screen = new CardCollectionUI();
                    this.view.setVisible(false);
                    Xib.Navigation.popViewController( screen, true );
                    break;

                case "Fusion":

                    screen = new CardFusionBaseSelection();
                    screen.m_cardsLoaded = true;
                    screen._getUserCards();
                    Xib.Navigation.resetScreenStackTo( screen, false );
                    break;

                case "Pop":
                    this.view.setVisible(false);
                    Xib.Navigation.popViewController( false );
                    break;
            }
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
    },

    // Cardscreen is the base class, CardScreenInstance and CardScreenDefinition inherit from this class.
    // They both override viewDidLoad, and they call refresh form there.
    viewDidLoad: function()
    {
        info( "CardScreen.viewDidLoad called." );

        fixCardRatio( this.mainCardView );
        
        var parent = this.mainCardView.getParent();
        for( var i = 0; i < this.NUM_CARD_DISPLAY; ++i )
        {
            var card = this.createCardDisplay( this._onCardDisplayLoaded.bind( this ) );
            this.m_CardDisplays.push( card );
            parent.addChild( card.getView() );
        }
        this._setupTouchTarget();

        Xib.Navigation.removeModalOverlay();
    },

    _setupTouchTarget: function()
    {
        info( "CardScreen._setupTouchTarget called." );
        this.m_touchTarget = new GL2.TouchTarget();

        var parent = this.mainCardView.getParent();
        var anchor = new Core.Point(0.5, 0.5);
        var size = new Core.Size( this.getView().getFrame()._size._width, this.getView().getFrame()._size._height );
        this.m_touchTarget.setAnchor( anchor );
        this.m_touchTarget.setSize( size );
        this.m_touchTarget.setDepth( 500 );
        this.m_touchTarget.setVisible( true );
        this.m_touchTarget.setPosition( this.mainCardView.getPosition() );

        this.m_touchTarget.getTouchEmitter().addListener(this, this._onTouch.bind( this ) );
        parent.addChild( this.m_touchTarget );
    },

    _onTouch: function( touch )
    {
        switch ( touch.getAction() )
        {
            case GL2.Touch.Action.Start:
                info( "CardScreen._setupTouchTarget: Start" );
                if ( this.m_touchId && this.m_touchId != touch.getId() )
                {
                    break;
                }
                this._stopAllActions();
                this.m_tochInitialPosition = touch.getPosition();
                var pos = this.m_CardDisplays[this.m_CenterCardIndex].getView().getPosition();
                this.m_cardInitialPosition = new Core.Point( pos.getX(), pos.getY() );
                this.m_touchId = touch.getId();
                var currentDate = new Date();
                this.m_touchStartTime = currentDate.getTime();
                break;
                
            case GL2.Touch.Action.Move:
                if(this.m_touchId != touch.getId() )
                {
                    return;
                }
                this._OnTouchMoved( touch );
                break;
                
            case GL2.Touch.Action.End:
            case GL2.Touch.Action.Cancel:
                info( "CardScreen._setupTouchTarget: End/Cancel" );
                if( this.m_touchId != touch.getId() )
                {
                    return;
                }
                var date = new Date();
                var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
                var deltaTime = ( date.getTime() - this.m_touchStartTime );
                var distance = Math.abs( centerCard.getView().getPosition().getX() - this.m_cardInitialPosition.getX() );
                if( ( deltaTime < this.TOUCH_MAX_TIME ) && ( distance < 5 ) )
                {
                    //ToDO: check if the touch is in the card position
                    this.showHideDetails();
                }
                this._OnScrollTouchEnd();
                this.m_touchId = undefined;
                this.m_tochInitialPosition = null;
                this.m_cardInitialPosition = null;
                this.m_touchStartTime = 0;
                break;
            
            default:
                return false;
        }
        
        return true;
    },

    _OnScrollTouchEnd: function( touch )
    {
        var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
        var distance = ( centerCard.getView().getPosition().getX() - this._getPositionCenter().getX() );
        var screenWidth =  this.getView().getFrame()._size._width;
        if ( distance > ( screenWidth * 0.25 ) )
        {
            this.moveToPrevScreen();
        }
        else if ( distance < ( -screenWidth * 0.25 ) )
        {
            this.moveToNextScreen();
        }
        else
        {
            this.moveCardsToPosition();
        }
    },

    _stopAllActions: function()
    {
        var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
        centerCard.getView().stopAllActions();
        var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
        leftCard.getView().stopAllActions();
        var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
        rightCard.getView().stopAllActions();
    },

    _OnTouchMoved: function( touch )
    {
        var distance = ( this.m_touchTarget.screenToLocal( touch.getPosition() ).getX() -
                         this.m_touchTarget.screenToLocal( this.m_tochInitialPosition ).getX() );

        var screenWidth = this.getView().getFrame()._size._width;
        var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
        centerCard.getView().stopAllActions();
        var centerCardX = ( this.m_cardInitialPosition.getX() + distance );
        var newCenterPos = new Core.Point( centerCardX, this._getPositionCenter().getY() );
        centerCard.getView().setPosition( newCenterPos );

        var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
        leftCard.getView().stopAllActions();
        var leftCardX = ( centerCardX - ( screenWidth * this.DISTANCE_FACTOR ) );
        var newLeftPos = new Core.Point( leftCardX, this._getPositionLeft().getY() );
        leftCard.getView().setPosition( newLeftPos );
        
        var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
        rightCard.getView().stopAllActions();
        var rightCardX = ( centerCardX + ( screenWidth * this.DISTANCE_FACTOR ) );
        var newRightPos = new Core.Point( rightCardX, this._getPositionRight().getY() );
        rightCard.getView().setPosition( newRightPos );
    },

    _onCardDisplayLoaded: function()
    {
        info( "CardScreen._onCardDisplayLoaded called." );
        this.m_PendingCardsToLoad--;
        if( this.m_PendingCardsToLoad > 0 )
        {
            return;
        }
        info( "CardScreen._onCardDisplayLoaded... all CardsDisplays loaded" );

        this._setupBackButton();
        this.m_CenterCardIndex = 0;

        this._setupPositions();

        var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
        var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
        var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
        centerCard.getView().setPosition( this._getPositionCenter() );
        leftCard.getView().setPosition( this._getPositionLeft() );
        rightCard.getView().setPosition( this._getPositionRight() );

        this.refresh();
    },

    _setupPositions: function()
    {
        var screenWidth = this.getView().getFrame()._size._width;
        var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
        var position = centerCard.getView().getPosition();

        this.m_centerPosition = position.clone();
        this.m_leftPosition = new Core.Point( position.getX() - ( screenWidth * this.DISTANCE_FACTOR ), position.getY() );
        this.m_rightPosition = new Core.Point( position.getX() + ( screenWidth * this.DISTANCE_FACTOR ), position.getY() );
    },

    _getPositionCenter: function()
    {
        return this.m_centerPosition.clone();
    },

    _getPositionLeft: function()
    {
        return this.m_leftPosition.clone();
    },

    _getPositionRight: function()
    {
        return this.m_rightPosition.clone();
    },

    _getIndexLeftCard: function()
    {
        var index = this.m_CenterCardIndex - 1;
        index = ( index < 0 ) ? ( this.m_CardDisplays.length - 1 ) : index;
        return index;
    },

    _getIndexRightCard: function()
    {
        var index = this.m_CenterCardIndex + 1;
        index = ( index >= this.m_CardDisplays.length ) ? ( 0 ) : index;
        return index;
    },

    showHideDetails: function()
    {
        info( "CardScreen.showHideDetails called." );
        for( var i = 0; i < this.NUM_CARD_DISPLAY; ++i )
        {
            var card = this.m_CardDisplays[i];
            card.flipDetailsVisibility();
        }
    },

    // TODO Use global constants for rarity labels !
    getCurrentRarityText: function()
    {
        var rarity = this.m_cardDefinition.rarity;
        info( "CardScreen.getRarityText called. rarity=%s", rarity );
        var rarityLabels = [ _loc("unknown"), _loc("card_screen_rarity_1"), _loc("card_screen_rarity_2"), _loc("card_screen_rarity_3"), _loc("card_screen_rarity_4") ];
        var label = "unknown";

        if( rarityLabels[rarity] )
        {
            label = rarityLabels[rarity];
        }
        else
        {
            err( "CardScreen.getRarityText Error, cannot determine the rarity! rarity=%s", rarity );
        }

        info( "CardScreen.getRarityText returning. rarity=%s, label=%s", rarity, label );

        return label;
    },

    moveCardsToPosition: function()
    {
        info( "CardScreen.moveCardsToPosition called. this.m_currentCardIndex=%s", this.m_currentCardIndex );

        var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
        centerCard.getView().stopAllActions();
        centerCard.getView().runAction(
                Action.EaseOutQuad.actionWithAction( Action.MoveTo.actionWithDuration( this.CARD_MOVEMENT_DURATION, this._getPositionCenter() ) )
        );
        var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
        rightCard.getView().stopAllActions();
        rightCard.getView().runAction(
            Action.EaseOutQuad.actionWithAction( Action.MoveTo.actionWithDuration( this.CARD_MOVEMENT_DURATION, this._getPositionRight() ) )
        );
        var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
        leftCard.getView().stopAllActions();
        leftCard.getView().runAction(
            Action.EaseOutQuad.actionWithAction( Action.MoveTo.actionWithDuration( this.CARD_MOVEMENT_DURATION, this._getPositionLeft() ) )
        );
    },

    moveToNextScreen: function()
    {
        info( "CardScreen.moveToNextScreen called. this.m_currentCardIndex=%s", this.m_currentCardIndex );

        if( this.m_currentCardIndex >= ( this.getCurrentListLength() - 1 ) )
        {
            this.moveCardsToPosition();
            return;
        }

        var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
        var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
        var screenWidth =  this.getView().getFrame()._size._width;
        leftCard.getView().stopAllActions();
        var point = new Core.Point( rightCard.getView().getPosition().getX() + ( screenWidth * this.DISTANCE_FACTOR ), this._getPositionRight().getY() );
        leftCard.getView().setPosition( point );

        this.m_CenterCardIndex++;
        this.m_currentCardIndex++;
        if( this.m_CenterCardIndex >= this.m_CardDisplays.length )
        {
            this.m_CenterCardIndex = 0;
        }
        this.refresh();
        this.moveCardsToPosition();
    },

    moveToPrevScreen: function()
    {
        info( "CardScreen.moveToPrevScreen called. this.m_currentCardIndex=%d", this.m_currentCardIndex );

        if( this.m_currentCardIndex <= 0 )
        {
            this.moveCardsToPosition();
            return;
        }

        var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
        var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
        var screenWidth =  this.getView().getFrame()._size._width;
        rightCard.getView().stopAllActions();
        var point = new Core.Point( leftCard.getView().getPosition().getX() - ( screenWidth * this.DISTANCE_FACTOR ), this._getPositionLeft().getY() );
        rightCard.getView().setPosition( point );

        this.m_CenterCardIndex--;
        this.m_currentCardIndex--;
        if( this.m_CenterCardIndex < 0 )
        {
            this.m_CenterCardIndex = ( this.m_CardDisplays.length - 1 );
        }
        this.refresh();
        this.moveCardsToPosition();

        var onMovementFinished = function()
        {
            info( "CardScreen.moveToNextScreen.onMovementFinished called " );

            var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
            rightCard.getView().stopAllActions();
            rightCard.getView().setPosition( this._getPositionLeft() );

            this.m_CenterCardIndex--;
            this.m_currentCardIndex--;
            if( this.m_CenterCardIndex < 0 )
            {
                this.m_CenterCardIndex = ( this.m_CardDisplays.length - 1 );
            }
            this.refresh();
        }.bind( this );
    },

    // @override
    getCurrentListLength: function()
    {
        err( "CardScreen.getCurrentListLength called. ERROR Need to override this method!" );
        return 0;
    },

    // @override
    updateCurrentCard: function()
    {
        err( "CardScreen.updateCurrentCard called. ERROR Need to override this method!" );
        return 0;
    },

    // @override
    updateLeftCard: function()
    {
        err( "CardScreen.updateLeftCard called. ERROR Need to override this method!" );
        return 0;
    },

    // @override
    updateRightCard: function()
    {
        err( "CardScreen.updateRightCard called. ERROR Need to override this method!" );
        return 0;
    },

    getCardName: function()
    {
        return _loc( this.m_cardDefinition.name );
    },

    refresh: function()
    {
        info( "CardDisplay.refresh called" );
        //Do nothing
    },

    refreshCardImage: function()
    {
        this.mainCardView.visible = true;
        CardsManager.loadCardImage( this.m_cardDefinition.id, IMAGE_SIZE.BIGGEST, function( imageURL )
        {
            if( this.mainCardView._destroyed )
            {
                return;
            }
            this.mainCardView.setVisible( true );

            this.mainCardView.setImage( imageURL );
        }.bind( this ) );
    },

    destroy: function()
    {
        info( "CardScreen.destroy called" );
        // ToDo: Remove the CardDosplays?
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardScreenInstance'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardScreenInstance'] || {}; $MODULE_REGISTRY['Code/UI/CardScreenInstance'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardScreenInstance.js';

exports.CardScreenInstance = CardScreen.subclass(
    {
        classname : 'CardScreenInstance',

        /**
         * CardScreenInstance.initialize
         *
         */
        initialize : function( $super, cardInstanceId, cardInstanceList, prevScreen )
        {
            info( "CardScreenInstance.initialize called. cardInstanceId=%s, cardInstanceList=%s, prevScreen=%s",
                JSON.stringify( cardInstanceId ), JSON.stringify( cardInstanceList ), prevScreen );

            this.m_prevScreen       = prevScreen;
            this.m_cardInstanceId   = cardInstanceId;
            this.m_cardInstanceList = cardInstanceList;
            this.m_leftCardInstanceId = null;
            this.m_rightCardInstanceId = null;
            this.m_leftCardInstance = null;
            this.m_rightCardInstance = null;

            $super();
        },


        // @override
        viewDidLoad : function( $super )
        {
            info( "CardScreenInstance.viewDidLoad called. this.m_cardInstanceList=%s", JSON.stringify( this.m_cardInstanceList ) );
            $super();

            //this.refresh();
        },

        // @override
        createCardDisplay: function( cb )
        {
            return new CardDisplayInstance( cb, this, this.mainCardView.getFrame() );
        },

        // @override
        updateCurrentCard: function()
        {
            info( "CardScreenInstance.updateCurrentCard called. this.m_currentCardIndex=%s, this.m_cardInstanceId=%s",
                this.m_currentCardIndex, this.m_cardInstanceId );


            if( this.m_cardInstanceList == undefined || this.m_cardInstanceList.length < 2 )
            {
                // we have a card and we don't have a card list
                this.m_cardInstance = CardsManager.getPlayerCardById( this.m_cardInstanceId );
            }
            else
            {
                if( this.m_currentCardIndex == undefined )
                {
                    this.m_currentCardIndex = this.findCurrentCardIndex();
                }
                this.m_cardInstance = this.m_cardInstanceList[this.m_currentCardIndex];
                this.m_cardInstanceId = this.m_cardInstance.id;
            }
            this.m_cardDefinition = CardsManager.getCardDefinition( this.m_cardInstance.definitionId );
        },

        updateLeftCard: function()
        {
            info( "CardScreenInstance.updateLeftCard called. this.m_currentCardIndex=%s, this.m_cardInstanceId=%s",
            this.m_currentCardIndex, this.m_cardInstanceId );

            this.m_LeftCardDefinition = null;
            if( this.m_cardInstanceList == undefined || this.m_cardInstanceList.length < 2 )
            {
                // we have a card and we don't have a card list
                this.m_leftCardInstance = null;
            }
            else
            {
                if( this.m_currentCardIndex == undefined )
                {
                    this.m_currentCardIndex = this.findCurrentCardIndex();
                }
                this.m_leftCardInstance = this.m_cardInstanceList[this.m_currentCardIndex - 1];

                if( this.m_leftCardInstance )
                {
                    this.m_leftCardInstanceId = this.m_leftCardInstance.id;
                    this.m_LeftCardDefinition = CardsManager.getCardDefinition( this.m_leftCardInstance.definitionId );
                }
                else
                {
                    this.m_leftCardInstanceId = null;
                }
            }
        },

        updateRightCard: function()
        {
            info( "CardScreenInstance.updateRightCard called. this.m_currentCardIndex=%s, this.m_cardInstanceId=%s",
            this.m_currentCardIndex, this.m_cardInstanceId );

            this.m_RightCardDefinition = null;
            if( this.m_cardInstanceList == undefined || this.m_cardInstanceList.length < 2 )
            {
                // we have a card and we don't have a card list
                this.m_rightCardInstance = null;
            }
            else
            {
                if( this.m_currentCardIndex == undefined )
                {
                    this.m_currentCardIndex = this.findCurrentCardIndex();
                }
                this.m_rightCardInstance = this.m_cardInstanceList[this.m_currentCardIndex + 1];

                if( this.m_rightCardInstance )
                {
                    this.m_rightCardInstanceId = this.m_rightCardInstance.id;
                    this.m_RightCardDefinition = CardsManager.getCardDefinition( this.m_rightCardInstance.definitionId );
                }
                else
                {
                    this.m_rightCardInstanceId = null;
                }
            }
        },

        // @override
        findCurrentCardIndex: function()
        {
            info( "CardScreenInstance.findCurrentCardIndex called. m_currentCardIndex=%s, m_cardInstanceId=%s",
                this.m_currentCardIndex, this.m_cardInstanceId );

            return this.findCardIndex( this.m_cardInstanceId );
        },

        findCardIndex: function( cardInstanceId )
        {
            info( "CardScreenInstance.findCardIndex called");

            for( var i = 0; i < this.m_cardInstanceList.length; i++ )
            {
                if( this.m_cardInstanceList[i].id == cardInstanceId )
                {
                    info( "CardScreenInstance.findCardIndex Found! i=%s", i );
                    return i;
                }
            }
            return null;
        },

        // @override
        refresh: function( $super )
        {
            this.updateCurrentCard();
            this.updateLeftCard();
            this.updateRightCard();

            var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
            centerCard.refreshWithInstance( this.m_cardInstance, this.m_cardDefinition, function(){} );
            var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
            leftCard.refreshWithInstance( this.m_leftCardInstance, this.m_LeftCardDefinition );
            var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
            rightCard.refreshWithInstance( this.m_rightCardInstance, this.m_RightCardDefinition );

            $super();
        },

        // @override
        getCurrentListLength : function()
        {
            var length = 0;

            if( this.m_cardInstanceList != undefined )
            {
                length = this.m_cardInstanceList.length;
            }

            info( "CardScreenInstance.getCurrentListLength returning. length=%s", length );

            return length;
        },

        // @override
        getCardStatus : function()
        {
            var cardStatus = CardsManager.getCardStatus( this.m_cardInstance );
            var rtval = [ cardStatus.status1, cardStatus.status2, cardStatus.status3 ];

            info( "CardScreenInstance.getCardStatus returning. rtval=%s", JSON.stringify( rtval ) );
            return rtval;
        },

        // @override
        getSellingPrice : function()
        {
            var sellingPrice = CardsManager.getCardSellingPrice( this.m_cardInstance );

            info( "CardScreenInstance.getSellingPrice returning. sellingPrice=%s", sellingPrice );
            return sellingPrice;
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardScreenDefinition'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardScreenDefinition'] || {}; $MODULE_REGISTRY['Code/UI/CardScreenDefinition'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardScreenDefinition.js';

exports.CardScreenDefinition = CardScreen.subclass(
    {
        classname : 'CardScreenDefinition',

        /**
         * CardScreenDefinition.initialize
         *
         */
        initialize : function( $super, cardDefinitionId, cardDefinitionList, prevScreen )
        {
            info( "CardScreenDefinition.initialize called. cardDefinitionId=%s, cardDefinitionList=%s, prevScreen=%s",
                JSON.stringify( cardDefinitionId ), JSON.stringify( cardDefinitionList ), prevScreen );

            this.m_LeftCardDefinitionId = null;
            this.m_RightCardDefinitionId = null;
            this.m_prevScreen = prevScreen;
            this.m_cardDefinitionId = cardDefinitionId;
            this.m_cardDefinitionList = cardDefinitionList;

            $super();
        },


        viewDidLoad : function( $super )
        {
            info( "CardScreenDefinition.viewDidLoad called. this.m_cardInstanceList=%s",
                JSON.stringify( this.m_cardDefinitionList ) );
            $super();
        },

        createCardDisplay: function( cb )
        {
            info( "CardScreenDefinition.createCardDisplay" );
            return new CardDisplayDefinition( cb, this, this.mainCardView.getFrame() );
        },
 
        updateCurrentCard : function()
        {
            info( "CardScreenDefinition.updateCurrentCard called. this.m_currentCardIndex=%s, this.m_cardDefinitionId=%s",
                this.m_currentCardIndex, this.m_cardDefinitionId );

            if( this.m_cardDefinitionList == undefined || this.m_cardDefinitionList.length < 2 )
            {
                // we have a card and we don't have a card list
                this.m_cardDefinition = CardsManager.getCardDefinition( this.m_cardDefinitionId );
            }
            else
            {
                if( this.m_currentCardIndex == undefined )
                {
                    this.m_currentCardIndex = this.findCurrentCardIndex();
                }
                this.m_cardDefinition = this.m_cardDefinitionList[this.m_currentCardIndex];
                this.m_cardDefinitionId = this.m_cardDefinition.id;
            }
        },

        updateLeftCard : function()
        {
            info( "CardScreenDefinition.updateLeftCard called. this.m_currentCardIndex=%s, this.m_cardDefinitionId=%s",
                this.m_currentCardIndex, this.m_cardDefinitionId );

            if( this.m_cardDefinitionList == undefined || this.m_cardDefinitionList.length < 2 )
            {
                // we have a card and we don't have a card list
                this.m_LeftCardDefinition = null;
            }
            else
            {
                if( this.m_currentCardIndex == undefined )
                {
                    this.m_currentCardIndex = this.findCurrentCardIndex();
                }
                this.m_LeftCardDefinition = this.m_cardDefinitionList[this.m_currentCardIndex - 1];
                if( this.m_LeftCardDefinition )
                {
                    this.m_LeftCardDefinitionId = this.m_LeftCardDefinition.id;
                }
                else
                {
                    this.m_LeftCardDefinitionId = null;
                }
            }
        },

        updateRightCard : function()
        {
            info( "CardScreenDefinition.updateLeftCard called. this.m_currentCardIndex=%s, this.m_cardDefinitionId=%s",
                this.m_currentCardIndex, this.m_cardDefinitionId );

            if( this.m_cardDefinitionList == undefined || this.m_cardDefinitionList.length < 2 )
            {
                // we have a card and we don't have a card list
                this.m_RightCardDefinition = null;
            }
            else
            {
                if( this.m_currentCardIndex == undefined )
                {
                    this.m_currentCardIndex = this.findCurrentCardIndex();
                }
                this.m_RightCardDefinition = this.m_cardDefinitionList[this.m_currentCardIndex + 1];
                if( this.m_RightCardDefinition )
                {
                    this.m_RightCardDefinitionId = this.m_RightCardDefinition.id;
                }
                else
                {
                    this.m_RightCardDefinitionId = null;
                }
            }
        },

        // @override
        findCurrentCardIndex: function()
        {
            info( "CardScreenDefinition.findCurrentCardIndex called. m_currentCardIndex=%s, m_cardDefinitionId=%s",
                this.m_currentCardIndex, this.m_cardDefinitionId );

            return this.findCardIndex( this.m_cardDefinitionId );
        },

        findCardIndex : function( cardDefinitionId )
        {
            info( "CardScreenDefinition.findCardIndex called" );

            for( var i = 0; i < this.m_cardDefinitionList.length; i++ )
            {
                if( this.m_cardDefinitionList[i].id == cardDefinitionId )
                {
                    info( "CardScreenDefinition.findCardIndex Found! i=%s", i );
                    return i;
                }
            }
            return null;
        },

        // @override
        refresh: function( $super )
        {
            this.updateCurrentCard();
            this.updateLeftCard();
            this.updateRightCard();

            var centerCard = this.m_CardDisplays[this.m_CenterCardIndex];
            centerCard.refreshWithDefinition( this.m_cardDefinition, function(){} );
            var leftCard = this.m_CardDisplays[this._getIndexLeftCard()];
            leftCard.refreshWithDefinition( this.m_LeftCardDefinition );
            var rightCard = this.m_CardDisplays[this._getIndexRightCard()];
            rightCard.refreshWithDefinition( this.m_RightCardDefinition );

            $super();
        },

        // @override
        getCurrentListLength : function()
        {
            var length = 0;

            if( this.m_cardDefinitionList != undefined )
            {
                length = this.m_cardDefinitionList.length;
            }

            info( "CardScreenDefinition.getCurrentListLength returning. length=%s", length );
            return length;
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/MissionSelectionScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/MissionSelectionScreen'] || {}; $MODULE_REGISTRY['Code/UI/MissionSelectionScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/MissionSelectionScreen.js';

exports.MissionSelectionScreen = ScrollableView.subclass(
{
    classname: 'MissionSelectionScreen',

    initialize: function( $super, worldId, stageId )
    {
        this.m_currentStageInfo = {"worldId": worldId, "stageId": stageId};

        this.m_stageData                = null;
        this.m_worldData                = null;
        this.m_showBoss                 = true;     //Little flag to control wether to boss has to be shown or not
        this.isBossHidden               = false;
        this.m_totalUnlockedMissions    = 0;
        this.m_progressBars             = [];
        this.m_bossStatusChanged        = false;
        this.m_firstShow                = true;
        this.m_viewSize                 = null;
        this.m_oldNumberOfViews         = 0;
        this.m_baseMission              = 0;

        this.m_numViews                 = 5;
        this.m_views                    = [];

        $super();

        this.setIsFullscreenOpaque(true);
        this.initWithXib( "./Content/Xib/MissionSelectionScreen.xib", true );

        this.initialSetup( worldId, stageId );

        this.m_assetsLoaded             = 0;
        this.m_resourcesLoaded          = 0;


    },

    initialSetup: function(worldId, stageId )
    {
        this.m_stageData    = QuestManager.getStageOfWorld( worldId, stageId );
        this.m_worldData    = QuestManager.getWorldData( worldId );
        this.m_bossData     = this.m_stageData.boss;


        var playerProgress = QuestManager.getPlayerProgressForStage( worldId, stageId );
        if( (this.m_bossData === null || this.m_bossData === undefined ) || playerProgress.completedRounds < playerProgress.numberOfRounds)
        {
            this.m_showBoss = false;
        }

        this.m_totalUnlockedMissions = 0;
        for( var i = 0; i < this.m_stageData.missions.length; i++ )
        {
            if( this.m_stageData.missions[i].enabled && QuestManager.areMissionRequirementsPassed( this.m_stageData.missions[i].id ) )
            {
                this.m_totalUnlockedMissions++;
            }
        }
        User.setCurrentStage( this.m_currentStageInfo );
    },

    buildScreen: function()
    {
        this.setIsFullscreenOpaque(true);

        var backFunction = function()
        {
            var screen = new ExplorationStageUI( this.m_worldData );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );

        this.fillMissionData();

//        //FIXME: These buttons are not linked
//        this.xib_buttonChangeWorld.setEnabled(0);
//        this.xib_buttonChangeWorld.setAlpha(0);
//        this.xib_buttonChangeStage.setEnabled(0);
//        this.xib_buttonChangeStage.setAlpha(0);
    },

    goToWorlds: function()
    {
        var func = function()
        {
            var screen = new ExplorationWorldUI(this.m_worldData.id);
            Xib.Navigation.resetScreenStackTo(screen);
        }.bind(this);

        Xib.Navigation.setModalOverlay(new WaitingScreen(func));
    },

    goToStages: function()
    {
        var func = function()
        {
            var screen = new ExplorationStageUI(this.m_worldData);
            Xib.Navigation.resetScreenStackTo(screen);
        }.bind(this);

        Xib.Navigation.setModalOverlay(new WaitingScreen(func));
    },

    viewDidLoad: function( $super )
    {
        info( "MissionSelectionScreen.viewDidLoad called." );
        $super();

        this._mapViews();
        this._mapElements();
        this._mapActions();

        this.buildScreen();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(NO_SCREEN);

        //FIXME Hacky check for the boss. Should be someplace else.
        if( QuestManager.isBossPassed( this.m_stageData.id ) )
        {
            this.bossBattleButton.setEnabled( false );
        }
        else
        {
            this.bossBattleButton.setEnabled( true );
        }

        if( !this.m_showBoss || QuestManager.isBossPassed( this.m_stageData.id ) )
        {
            this.hideBossView();
        }

        if (TutorialManager.getActiveStateId() != undefined)
        {
            this.xib_buttonChangeWorld.setVisible(false);
            this.xib_buttonChangeStage.setVisible(false);
            this.xib_buttonChangeWorld.setEnabled(false);
            this.xib_buttonChangeStage.setEnabled(false);
            this.xib_buttonChangeWorldLabel.setVisible(false);
            this.xib_buttonChangeStageLabel.setVisible(false);
            this.xib_buttonChangeWorldLabel.setAlpha(0);
            this.xib_buttonChangeStageLabel.setAlpha(0);
        }
    },

    moveBottomButtons: function( deltaY )
    {
        info( "MissionSelectionScreen.moveBottomButtons called. deltaY=%s", deltaY );

        var worldButton                 = this.xib_buttonChangeWorld;
        var worldButtonLabel            = this.xib_buttonChangeWorldLabel;
        var buttonWorldFrame            = worldButton.getFrame();
        buttonWorldFrame._origin._y     += deltaY;
        worldButton.setFrame( buttonWorldFrame );
        worldButtonLabel.setFrame( buttonWorldFrame );

        var stageButton                 = this.xib_buttonChangeStage;
        var stageButtonLabel            = this.xib_buttonChangeStageLabel;
        var buttonStageFrame            = stageButton.getFrame();
        buttonStageFrame._origin._y     += deltaY;
        stageButton.setFrame( buttonStageFrame );
        stageButtonLabel.setFrame( buttonStageFrame );
    },

    hideBossView: function()
    {
        info( "MissionSelectionScreen.hideBossView called." );

        var bossView, bossFrame, frameHeight, missionView, missionFrame, i, bossButton;

        if( this.isBossHidden == true )
        {
            return;
        }

        this.isBossHidden = true;

        bossView    = this.bossDataContainer;
        bossFrame   = bossView.getFrame();
        frameHeight = bossFrame._size._height;
        bossButton  = this.bossBattleButton;

        bossView.setVisible( false );

        //Disable boss button
        bossButton.setEnabled(false);

        // Move all views
        for( i = 0; i < this.m_views.length; i++ )
        {
            missionView              = this.m_views[i]._view;
            missionFrame             = missionView.getFrame();
            missionFrame._origin._y -= frameHeight;
            missionView.setFrame( missionFrame );
        }

        // Reduce the scrollable view content height
        info( "MissionSelectionScreen.hideBossView frameHeight=%s", frameHeight );
        this.expandFrame( {'_top' : 0, '_bottom' : 0, '_b   ottomContent' : -frameHeight } );

        // Move buttons at the bottom
        this.moveBottomButtons( -frameHeight );
    },

    showBossView: function()
    {
        info( "MissionSelectionScreen.showBossView called." );
        if( !this.isBossHidden )
        {
            return;
        }

        var bossView, bossFrame, frameHeight, missionView, missionFrame, i;

        this.isBossHidden = false;

        bossView    = this.bossDataContainer;
        bossFrame   = bossView.getFrame();
        frameHeight = bossFrame._size._height;
        bossButton  = this.bossBattleButton;

        bossView.setVisible( true );

        if (QuestManager.isBossPassed(this.m_stageData.id))
            bossButton.setEnabled(false);
        else
            bossButton.setEnabled(true);

        // Move all views
        for( i = 0; i < this.m_views.length; i++ )
        {
            missionView              = this.m_views[i]._view;
            missionFrame             = missionView.getFrame();
            missionFrame._origin._y += frameHeight;
            missionView.setFrame( missionFrame );
        }

        // Reduce the scrollable view content height
        info( "MissionSelectionScreen.showBossView frameHeight=%s", frameHeight );
        this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : frameHeight } );

        // Move buttons at the bottom
        this.moveBottomButtons( frameHeight );
    },

    _mapViews : function()
    {
        info( "MissionSelectionScreen._mapViews called." );

        for( var i = 0; i < this.m_numViews; i++ )
        {
            var view = eval( sprintf( "this.dataContainer_%d", i + 1 ) );
            this.m_views[i] = {"_view" : view };
        }
    },

    _mapElements : function()
    {
        info( "MissionSelectionScreen._mapElements called. this.m_views.length=%s", this.m_views.length );
        this.m_viewSize = this.dataContainer_1.getFrame().getSize();
        for( var i = 0; i < this.m_views.length; i++ )
        {
            var view = this.m_views[i];

            this.m_views[i]._buttonExploreArea      = view._view.nodeWithTag( 4011 );
            this.m_views[i]._labelAreaName          = view._view.nodeWithTag( 4001 );
            this.m_views[i]._labelCost              = view._view.nodeWithTag( 4002 );
            this.m_views[i]._labelProgress          = view._view.nodeWithTag( 4003 );
            this.m_views[i]._viewProgressBar        = view._view.nodeWithTag( 4004 );
            this.m_views[i]._labelCardsCollected    = view._view.nodeWithTag( 4010 );

            this.m_views[i]._imageCard              = [];
            this.m_views[i]._imageCard[0]           = view._view.nodeWithTag( 4005 );
            this.m_views[i]._imageCard[1]           = view._view.nodeWithTag( 4006 );
            this.m_views[i]._imageCard[2]           = view._view.nodeWithTag( 4007 );
            this.m_views[i]._imageCard[3]           = view._view.nodeWithTag( 4008 );
            this.m_views[i]._imageCard[4]           = view._view.nodeWithTag( 4009 );
        }
    },

    _mapActions : function()
    {
        info( "MissionSelectionScreen._mapActions called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var callback = sprintf( "goToExplore.bind(this._target, {'button':%d})", i );
            this.m_views[i]._buttonExploreArea.setTargetAction( this, callback );
        }
    },

    // TODO FIXME cleanup this method please !
    preloadImages: function()
    {
        info( "MissionSelectionScreen.preloadImages called. this.m_stageData.missions.length=%d", this.m_stageData.missions.length );
        var i, j, card, element, missions, missionCards, isCardUnlocked;

        if (this.m_showBoss)
        {
                CardsManager.loadCardImage( this.m_bossData.pilotId, IMAGE_SIZE.BIGGEST,
                function( imageUrl )
                {
                    var bossPilotImage = eval( sprintf( "this.bossPilotImage"));
                    if( bossPilotImage._destroyed )
                    {
                        return;
                    }
                    if( bossPilotImage && bossPilotImage.setImage )
                    {
                        bossPilotImage.setImage( imageUrl );
                    }
                    else
                    {
                        err( "MissionSelectionScreen.preloadImages._innerCallbackA Error, Cannot set image! imageUrl=%s",
                            imageUrl );
                    }
                }.bind( this )
            );
            CardsManager.loadCardImage( this.m_bossData.gearId, IMAGE_SIZE.BIGGEST,
                function( imageUrl )
                {
                    var bossGearImage = eval( sprintf( "this.bossGearImage"));
                    if( bossGearImage._destroyed )
                    {
                        return;
                    }
                    if( bossGearImage && bossGearImage.setImage )
                    {
                        bossGearImage.setImage( imageUrl );
                    }
                    else
                    {
                        err( "MissionSelectionScreen.preloadImages._innerCallbackA Error, Cannot set image! imageUrl=%s",
                            imageUrl );
                    }
                }.bind( this )
            );
        }

        missions = this.m_stageData.missions;
        this.m_baseMission = missions[0].id;
        //We setup spinners for all cards before trying to add the real images
        for (i = 0; i < this.m_totalUnlockedMissions; i++ )
        {
            missionCards = missions[i].cards;
            for (j = 0; j < missionCards.length; j++)
            {
                var missionCardImage = this.m_views[this.m_totalUnlockedMissions - 1 - i]._imageCard[j];
                missionCardImage.spinnerOn();
                missionCardImage.setVisible(true);
            }
        }

        for( i = 0; i < this.m_totalUnlockedMissions; i++ )
        {
            missionCards = missions[i].cards;
            info( "MissionSelectionScreen.preloadImages this.m_stageData.missions[i].cards.length=%d", missionCards.length );
            for( j = 0; j < missionCards.length; j++ )
            {
                card = missionCards[j];
                isCardUnlocked = QuestManager.hasPlayerUnlockedCard( this.m_worldData.id, this.m_stageData.id, missions[i].id, card );

                var cardId = isCardUnlocked? card : DEFAULT_CARD_ID;

                if ( isCardUnlocked )
                {
                    CardsManager.loadCardImage( cardId, IMAGE_SIZE.SMALL,
                        function( _i, _j, imageUrl )
                        {
                            var missionCardImage = this.m_views[this.m_totalUnlockedMissions - 1 - _i]._imageCard[_j];
                            if( missionCardImage._destroyed )
                            {
                                return;
                            }
                            missionCardImage.spinnerOff();
                            if( missionCardImage && missionCardImage.setImage )
                            {
                                missionCardImage.setImage( imageUrl );
                            }
                            else
                            {
                                err( "MissionSelectionScreen.preloadImages._innerCallbackA Error, Cannot set text! _j=%d, _i=%d, imageUrl=%s",
                                    _j + 1, _i, imageUrl );
                            }
                        }.bind( this, i, j )
                    );
                }
                else
                {
                    var missionCardImage = this.m_views[this.m_totalUnlockedMissions - 1 - i]._imageCard[j];
                    missionCardImage.spinnerOff();

                    if( missionCardImage && missionCardImage.setImage )
                    {
                        missionCardImage.setImage(DEFAULT_CARD_IMAGE + "_" + IMAGE_SIZE.SMALL + ".jpg" );
                    }
                    else
                    {
                        err( "MissionSelectionScreen.preloadImages._innerCallbackA Error, Cannot set text! _j=%d, _i=%d, imageUrl=%s",
                            j + 1, i + 1, DEFAULT_CARD_IMAGE );
                    }
                }
            }
            for( j; j < 5; j++ )
            {
                var missionCardImage = this.m_views[this.m_totalUnlockedMissions - 1 - i]._imageCard[j];
                missionCardImage.setVisible( false );
            }
        }
    },

    setMissionsData: function()
    {
        info( "MissionSelectionScreen.setMissionsData called." );

        var missionId, mission, missionView, totalProgress, cardsProgressPercentage, missionProgress, missionIdLabel;

        for( missionId = 0; missionId < ( this.m_totalUnlockedMissions ) && missionId < this.m_numViews; missionId++ )
        {
            mission     = this.m_stageData.missions[missionId];
            missionView = this.m_views[(this.m_totalUnlockedMissions - 1) - missionId];

            missionIdLabel = sprintf("[%d-%d-%d] ", this.m_worldData.id, QuestManager.getFakeStageId(this.m_worldData.id, this.m_stageData.id), (missionId + 1));


            missionView._labelCost.setText( mission.energyPerRound );
            missionView._labelAreaName.setText( missionIdLabel + _loc( this.m_stageData.missions[missionId].missionName ) );

            totalProgress = QuestManager.getPlayerProgressForMission( this.m_worldData.id, this.m_stageData.id, mission.id );

            if (totalProgress.totalCards == 0)
                cardsProgressPercentage = 0;
            else
                cardsProgressPercentage = Math.round( ( ( totalProgress.collectedCards * 1.0 ) / ( totalProgress.totalCards * 1.0 ) ) * 100 );
            this.setMissionCardCollectedProgress( (this.m_totalUnlockedMissions - 1) - missionId, cardsProgressPercentage );

            missionProgress = Math.round( ( ( totalProgress.completedRounds * 1.0 ) / ( totalProgress.numberOfRounds * 1.0 ) ) * 100 );
            this.setMissionProgress( (this.m_totalUnlockedMissions - 1) - missionId, missionProgress );

            if( TutorialManager.getActiveStateId() != null && totalProgress.completedRounds == 3 )
            {
                missionView._buttonExploreArea.setEnabled( false );
            }
        }

        if (this.m_firstShow)
        {
            this.hideMissions();
        }
    },

    hideMissions: function()
    {
        info( "MissionSelectionScreen.hideMissions called." );

        var missionId;
        for ( missionId = 0; missionId < this.m_numViews; missionId++ )
        {
            if( missionId > ( this.m_totalUnlockedMissions - 1 ) )
            {
                this.hideMissionView( missionId );
            }
        }
    },

    showMissions: function()
    {
        info( "MissionSelectionScreen.showMissions called." );

        var missionId;
        for ( missionId = this.m_oldNumberOfViews; missionId < this.m_numViews; missionId++ )
        {
            if( missionId <= ( this.m_totalUnlockedMissions - 1 ) )
            {
                this.showMissionView( missionId );
            }
        }
    },

    getRealMissionHeight : function()
    {
        var missionFrameA = this.m_views[0]._view.getFrame();
        var missionFrameB = this.m_views[1]._view.getFrame();

        var missionHeightA = missionFrameA.getOrigin().getY();
        var missionHeightB = missionFrameB.getOrigin().getY();

        var height = missionHeightB - missionHeightA;

        info( "MissionSelectionScreen.getRealMissionHeight returning. height=%s, missionHeightA=%s, missionHeightB=%s", height, missionHeightA, missionHeightB );
        return height;
    },

    showMissionView: function( missionId )
    {
        info( "MissionSelectionScreen.showMissionView called. missionId=%s", missionId );
        var missionView, frameHeight;

        missionView  = this.m_views[missionId]._view;
        frameHeight = this.getRealMissionHeight();

        if( missionView.getVisible() )
        {
            info( "MissionSelectionScreen.showMissionView returning. Already visible" );
            return;
        }

        missionView.setVisible( true );
        this.m_views[missionId]._buttonExploreArea.setEnabled( true );

        info( "MissionSelectionScreen.showMissionView frameHeight=%s", frameHeight );
        this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : frameHeight } );

        // Move buttons at bottom
        this.moveBottomButtons( frameHeight );
    },

    hideMissionView: function( missionId )
    {
        info( "MissionSelectionScreen.hideMissionView called. missionId=%s", missionId );
        var missionView, missionFrame, frameHeight;

        missionView  = this.m_views[missionId]._view;

        frameHeight = this.getRealMissionHeight();


        if( !missionView.getVisible() )
        {
            return;
        }
        
        missionView.setVisible( false );
        this.m_views[missionId]._buttonExploreArea.setEnabled( false );

        info( "MissionSelectionScreen.hideMissionView frameHeight=%s", frameHeight );
        this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : -frameHeight } );

        // Move buttons at bottom
        this.moveBottomButtons( -frameHeight );
    },

    setMissionCardCollectedProgress: function( missionId, progress )
    {
        info( "MissionSelectionScreen.setMissionCardCollectedProgress called. missionId=%s, progress=%s", missionId, progress );
        var missionView;

        missionView = this.m_views[missionId];
        missionView._labelCardsCollected.setText( _loc( "explore_card_progress", progress ) );
    },

    setMissionProgress: function( missionId, progress )
    {
        info( "MissionSelectionScreen.setMissionProgress called. missionId=%s, progress=%s", missionId, progress );
        var progressBar, progressBarInstance, missionView, frame;

        missionView         = this.m_views[missionId];
        progressBar         = missionView._viewProgressBar;
        frame               = progressBar.getFrame();
        progressBarInstance = new ProgressBar( "./Content/Xib/ExplorationScreenProgressBar.xib", progress / 100, frame );

        missionView._labelProgress.setText( _loc( "%s%%", progress ) );

        progressBar.addChild( progressBarInstance.getView() );

        this.m_progressBars.push( progressBarInstance );
    },


    setBossData : function()
    {
        if( !this.m_showBoss )
        {
            return;
        }
        else
        {
            this.m_weaponBounds = CardsManager.getAreaOfInterestSquare( this.m_bossData.gearId );
            this.m_pilotBounds = CardsManager.getAreaOfInterestSquare(  this.m_bossData.pilotId );
            this.view_scroller.setUpdateFunction(   this._clippingUpdate.bind( this ) );
            this.bossPilotImage.setClipRectEnabled( true );
            this.bossGearImage.setClipRectEnabled(  true );

            this._clippingUpdate();

            var pilot = CardsManager.getCardDefinition( this.m_bossData.pilotId );
            var gear = CardsManager.getCardDefinition( this.m_bossData.gearId );

            this.bossPilotName.setText( _loc( pilot.name ) );
            this.bossGearName.setText( _loc( gear.name ) );

        }
    },

    _clippingUpdate: function()
    {
        imageClipping( this.bossPilotImage, this.bossPilotImage_frame, this.m_pilotBounds );
        imageClipping( this.bossGearImage, this.bossGearImage_frame, this.m_weaponBounds);
    },

    fillMissionData: function()
    {
        info( "MissionSelectionScreen.fillMissionData called." );

        this.preloadImages();
        //this.worldName.setText( _loc( this.m_worldData.worldName ) );
        this.stageName.setText( _loc( this.m_stageData.stageName ) );
        this.setMissionsData();
        this.setBossData();
    },

    goToExplore : function( opts )
    {
        info( "MissionSelectionScreen.goToExplore called. opts=%s", JSON.stringify( opts ) );

        if( TutorialManager.getActiveStateId() != undefined )
        {
            info( "MissionSelectionScreen.goToExplore returning. Skip on tutorial." );
            this.passToExplorationScreen( opts, null, true );
            return;
        }

        //FIXME: This should use the mission cost and not a hardcodded 10
        if( User.getExploreEnergy() < 10 )
        {
            var func = function()
            {
                var screen = new MissionFailedScreen();
                Xib.Navigation.resetScreenStackTo( screen, false );
            };
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
            return;
        }

        if( opts != undefined && opts.button != undefined && isFinite( opts.button ) )
        {
            var expIndex = opts.button;
            expIndex = this.m_totalUnlockedMissions - expIndex - 1; //The indexes come backwards, we use this to associate them to the proper number.
            var func = function()
            {
                Server.doMission(this.m_stageData.missions[expIndex].id, this.passToExplorationScreen.bind( this, opts ) );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen(func) );
        }
    },

    passToExplorationScreen : function( opts, error, accepted )
    {
        info( "MissionSelectionScreen.passToExplorationScreen called. accepted=%s", accepted );

        var expIndex = opts.button;
        expIndex = this.m_totalUnlockedMissions - expIndex - 1; //The indexes come backwards, we use this to associate them to the proper number.

        var explorationData;

        explorationData = this.m_stageData.missions[expIndex];

        this.preloadParallax( explorationData );
    },

    preloadParallax         : function(explorationData)
    {
        info( "MissionSelectionScreen.preloadParallax called. explorationData=%s", JSON.stringify( explorationData ) );

        ResourceManager.preLoadResource( explorationData.background,
            function( explorationData )
            {
                this.launchExploration( explorationData );
            }.bind( this, explorationData ),
            function()
            {
                err("MissionSelectionScreen.preloadParallax. Error downloading parallax sprites");
            }.bind( this )
        );
        ResourceManager.preLoadResource( explorationData.foreground,
            function( explorationData )
            {
                this.launchExploration( explorationData );
            }.bind( this, explorationData ),
            function()
            {
                err("MissionSelectionScreen.preloadParallax. Error downloading parallax sprites");
            }.bind( this )
        );
    },

    launchExploration       : function( explorationData )
    {
        info( "MissionSelectionScreen.launchExploration called. explorationData=%s", JSON.stringify( explorationData ) );

        this.m_resourcesLoaded++;
        if(this.m_resourcesLoaded == 2)
        {
            this.m_resourcesLoaded = 0;

            info( "MissionSelectionScreen.launchExploration this.m_stageData=%s", JSON.stringify( this.m_stageData ) );
            info( "MissionSelectionScreen.launchExploration this.m_worldData=%s", JSON.stringify( this.m_worldData ) );
            info( "MissionSelectionScreen.launchExploration this.m_currentStageInfo=%s", JSON.stringify( this.m_currentStageInfo ) );

            var analyticsData       = User.getAnalyticsPlayerState();
            analyticsData.region    = this.m_currentStageInfo.worldId;
            analyticsData.area      = this.m_currentStageInfo.stageId;
            analyticsData.zone      = explorationData.areaId;

            if( QuestManager.isMissionComplete( this.m_currentStageInfo.worldId, this.m_currentStageInfo.stageId, explorationData.id ) )
            {
                analyticsData.is_clrd = 1;
            }
            else
            {
                analyticsData.is_clrd = 0;
            }

            info( "MissionSelectionScreen.launchExploration analyticsData=%s", JSON.stringify( analyticsData ) );
            Analytics.reportGameEvent( "EXPLORATIONSTARTS", { "foo" : "bar" }, analyticsData );

            var screen = new ExplorationScreenAnimated( explorationData, this.m_currentStageInfo );
            screen.setParallaxSprites( explorationData.background, "1pxalpha0.png", explorationData.foreground );

            var activeState = TutorialManager.getActiveStateId();

            if( activeState == TutorialManager.STATE_MISSION_SELECTION || activeState == TutorialManager.STATE_MISSION_SELECTION2 )
            {
                Xib.Navigation.resetScreenStackTo( screen, false );
            }
            else
            {
                Xib.Navigation.pushViewController( screen, true );
            }
        }
    },

    viewDidAppear: function()
    {
        info( "MissionSelectionScreen.viewDidAppear called." );

        if (this.m_firstShow)
        {
            Xib.Navigation.removeModalOverlay();
            this.m_firstShow = false;
            
            /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // TODO FIXME: This hack is to reduce the bottom scroll. If you can, try to modify the universe and the scrollableView will work (it will be easier than fixing the scrollableView)
            var hackHeight = this.getRealMissionHeight() / 2;
            this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : -hackHeight } );
            /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        }
        else
        {
            var oldBossFlag = this.m_showBoss; //Check wether we should display the boss this time
            this.m_showBoss = true; //We assume we have to show it
            this.m_oldNumberOfViews = this.m_totalUnlockedMissions;
            this.initialSetup(this.m_worldData.id, this.m_stageData.id, this.m_worldData);
            this.buildScreen();

            if( QuestManager.isBossPassed( this.m_stageData.id ) )
            {
                this.hideBossView();
            }
            else if( this.m_showBoss && !oldBossFlag )
            {
                this.showBossView();
            }

            this.showMissions();
            Xib.Navigation.removeModalOverlay();
        }
    },


    destroy : function()
    {
        for( var i = 0; i < this.m_progressBars.length; i++ )
        {
            this.m_progressBars[i].destroy();
        }
    },

    ////////////////////////////////////////////////////////////////////////////////////////////////////////
    // THIS NEED TO BE ENCAPSULATED INTO A NEW CLASS. THIS CODE IS DUPLICATED IN ExplorationScreenAnimated

    enterBossFightScene         : function()
    {
        this.m_playerDeck       = DeckManager.getDeck();
        this.m_playerCards      = [];
        this.m_enemyCards       = [];

        this.preloadAssets();
    },

    preloadAssets           : function()
    {
        CardsManager.loadCardImage( this.m_bossData.gearId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
        this.m_enemyCards.push(
            {
                definitionId        : this.m_bossData.gearId,
                pilot               : this.m_bossData.pilotId,
                status              : 0,
                bossAttack          : this.m_bossData.attack,
                bossHP              : this.m_bossData.hp,
                race                : CardsManager.getCardDefinition( this.m_bossData.gearId ).race
            }
        );

        info( "MissionSelectionScreen.preloadAssets this.m_enemyCards=%s", JSON.stringify( this.m_enemyCards ) );

        for(var i = 0; i < this.m_playerDeck.status1.length; ++i)
        {
            this.m_playerCards.push(
                {
                    definitionId        : CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId,
                    id                  : CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).id,
                    status              : 0,
                    race                : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId ).race
                }
            );
            CardsManager.loadCardImage( CardsManager.getPlayerCardById(this.m_playerDeck.status1[i].gear).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
        }

        for(var i = 0; i < this.m_playerDeck.status2.length; ++i)
        {

            this.m_playerCards.push(
                {
                    definitionId        : CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId,
                    id                  : CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).id,
                    status              : 1,
                    race                : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId ).race
                }
            );
            CardsManager.loadCardImage( CardsManager.getPlayerCardById(this.m_playerDeck.status2[i].gear).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
        }

        for(var i = 0; i < this.m_playerDeck.status3.length; ++i)
        {
            this.m_playerCards.push(
                {
                    definitionId        : CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId,
                    id                  : CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).id,
                    status              : 2,
                    race                : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId ).race
                }
            );
            CardsManager.loadCardImage( CardsManager.getPlayerCardById(this.m_playerDeck.status3[i].gear).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
        }
    },

    assetLoadedCallback        : function()
    {
        if( this.getView()._destroyed )
        {
            return;
        }
        this.m_assetsLoaded++;

        if( this.m_assetsLoaded == 10 )
        {
            this.m_bossData.worldId         = this.m_worldData.id;
            this.m_bossData.stageId         = this.m_stageData.id;
            this.m_bossData.dummyMission    = this.m_baseMission;
            info( "MissionSelectionScreen.assetLoadedCallback this.m_enemyCards=%s", JSON.stringify( this.m_enemyCards ) );

            var screen          = new FightScene(this.m_playerCards, this.m_enemyCards, this.m_bossData, this.m_currentStageInfo, null, null );
            Xib.Navigation.pushViewController(screen);
            this.m_assetsLoaded = 0;
        }
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////
}
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionMenu'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionMenu'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionMenu'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionMenu.js';

exports.CardFusionMenu = ScrollableView.subclass(
{
    classname: 'CardFusionMenu',

    m_baseCardText: "",
    m_emptyImage: "fusion_button_pickcard.png",
    m_cardDictionary: null,
    m_itemsSelected: false,
    m_itemsCreated: false,
    m_cardType: null,
    m_materialCardsNumber: CardsManager.getMaxMaterialCardsNumber(),
    MATERIAL_MESSAGE: "USE MATERIAL CARD",
    ITEM_MESSAGE: "USE SPECIAL ITEM",
    m_cardOrigin:
    {
        "_x": 0,
        "_y": 0
    },

    initialize: function( $super, type )
    {
        $super();
        this.m_cardDictionary = CardsManager.getPlayerCardDictionary( "id"/* dictionaryKey */, null/* sortBy */, null/* previous list */).dictionary;
        var cardTypes = CardsManager.getCardTypes();
        this.m_type1 = cardTypes[0];
        this.m_type2 = cardTypes[1];
        this.m_cardType = type;

        CardsManager.setFusionItemType( this.m_cardType );
        // i18n
        this.MATERIAL_MESSAGE = _loc( this.MATERIAL_MESSAGE );
        this.ITEM_MESSAGE = _loc( this.ITEM_MESSAGE );

        this.initWithXib( "./Content/Xib/CardFusionMenu.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "CardFusionMenu.viewDidLoad called." );

        var backFunction = function()
        {
            var func = function()
            {

                var screen = new CardFusionBaseSelection(GEAR);
                screen.m_cardsLoaded = true;
                screen._getUserCards();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
        // Update when the scroll is moved
        this.view_scroller.setUpdateFunction( this._clippingUpdate.bind( this ) );
        this.imageView_baseCard.setClipRectEnabled( true );
        $super();

        if( TutorialManager.getActiveStateId() != undefined )
        {
            // TODO FIXME: Remove this hardcoded 9 items
            for( var i = 0; i < 10; i++ )
            {
                var button = this._getButtonAtIndex( i );
                TutorialManager.setButtonAsUnblocked( button );
            }
            TutorialManager.setButtonAsUnblocked( this.button_fusion );
            this.button_clear.setEnabled( false );
            this.button_clear.setAlpha( 0.5 );
        }

        // if( this.m_cardType == this.m_type2 )
        // {
        // this.button_item.destroy();
        // this.view_items.destroy();
        // }
        this._setupView();

    },

    // Clipping, scaling and positioning
    _clippingUpdate: function()
    {
        imageClipping( this.imageView_baseCard, this.view_baseCardFarme, this.m_cardOrigin );
    },

    // TODO FIXME Need to wait that the view is loaded and the data is retrieved!
    _setupView: function()
    {
        info( "CardFusionMenu._setupView called." );

        if( TutorialManager.getActiveStateId() == undefined )
        {
            var typeData =
            {
                "selected":
                {
                    "image": "fusion_big_tab_selected.png",
                    "textColor": FONT_COLOR.white
                },
                "unselected":
                {
                    "image": "fusion_big_tab_unselected.png",
                    "textColor": FONT_COLOR.white
                }
            };

            var typeData2 =
            {
                "selected":
                {
                    "image": "fusion_big_tab_selected.png",
                    "textColor": FONT_COLOR.white
                },
                "unselected":
                {
                    "image": "fusion_big_tab_unselected.png",
                    "textColor": FONT_COLOR.white
                }
            };

            this.button_weapon.setStateData( typeData, this.label_weapon );
            this.button_fighter.setStateData( typeData, this.label_fighter );
            this.button_useItem.setStateData( typeData2, this.label_useItem );
            this.button_useMaterial.setStateData( typeData2, this.label_useMaterial );
        }

        // Tabs
        this.button_weapon.setEnabled( this.m_cardType != this.m_type1 );
        this.button_fighter.setEnabled( this.m_cardType != this.m_type2 );

        this.button_useItem.setEnabled( 1 );
        this.button_useMaterial.setEnabled( 0 );

        // Text Alignment
        this.label_itemMessage.setOverflowMode( GL2.Text.OverflowMode.Multiline );
        this.label_itemMessage.setHorizontalAlign( GL2.Text.HorizontalAlign.Left );

        // Cards
        this.m_baseCardText = this.button_baseCard.getText();
        this._setBaseCard();
        this._setMaterialCards();

        this._enableFusionButton();
        this._setCost();
    },

    typeTabClicked: function( button )
    {
        info( "CardFusionMenu.typeTabClicked called." );
        if( button == this.button_weapon )
        {
            this.m_cardType = this.m_type1;
        }
        else if( button == this.button_fighter )
        {

            this.m_cardType = this.m_type2;
        }
        else
        {
            err( "CardFusionMenu.typeTabClicked Error, button not recognized !" );
        }

        var func = function()
        {
            var screen = new CardFusionBaseSelection( this.m_cardType );
            screen.m_cardsLoaded = true;
            screen._getUserCards();
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );

    },

    moveToCardSelection: function( /* Xib.Button */inSender )
    {
        /*
         * if( TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSION_SELECTION ) { TutorialManager.completeActiveState(); TutorialManager.executeActiveStateAction(); return; }
         */

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSION_MATERIAL )
        {
            TutorialManager.completeActiveState();
            TutorialManager.executeActiveStateAction();
        }

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSION_MATERIAL )
        {
            TutorialManager.completeActiveState();
            TutorialManager.executeActiveStateAction();
        }

        var screen;
        var materialCard = true;

        if( inSender == this.button_baseCard )
            materialCard = false;

        // screen = new CardFusionSelection( materialCard );
        // Xib.Navigation.pushViewController( screen, true );
        // info( "PUSHED screen " + screen.classname );

        if( !materialCard )
        {
            var func = function()
            {
                screen = new CardFusionBaseSelection( this.m_cardType );
                screen.m_cardsLoaded = true;
                screen._getUserCards();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
        else
        {
            var func = function()
            {
                screen = new CardFusionMaterialSelection( this.m_cardType );
                screen.m_cardsLoaded = true;
                screen._getUserCards();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );

            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }

    },

    _setBaseCard: function()
    {
        var baseCardInstanceId = CardsManager.getFusionBaseCard();
        if( baseCardInstanceId != undefined )
        {
            this.imageView_baseCard.setImage( "" );
            this.view_baseCardFarme.spinnerOn();
            var cardDefId = this.m_cardDictionary[baseCardInstanceId].definitionId;
            CardsManager.loadCardImage( cardDefId, IMAGE_SIZE.BIGGEST, function( imageURL )
            {
                if( this.imageView_baseCard._destroyed )
                {
                    return;
                }
                this.view_baseCardFarme.spinnerOff();
                this.imageView_baseCard.setImage( imageURL );

                // Offset to draw the image
                this.m_cardOrigin = CardsManager.getAreaOfInterestWide( cardDefId );

                this._clippingUpdate();
            }.bind( this ) );

            var cardInstance = CardsManager.getCardDefinition( cardDefId );
            this.label_level.setText( CardsManager.getCardLevel( this.m_cardDictionary[baseCardInstanceId] ) + " / " + cardInstance.maxLevel );

            // Rarity
            var rarity = cardInstance.rarity;
            this.image_rarity.setImage( "hud_rarityshield_" + rarity + ".png" );
        }
    },

    _setMaterialCards: function()
    {
        var materialCardsInstanceIds = CardsManager.getFusionMaterialCards();

        if( materialCardsInstanceIds != undefined && materialCardsInstanceIds.length != 0 )
        {
            var i;
            var j;

            var length = materialCardsInstanceIds.length;

            // Set image for materials cards
            for( i = 0; i < length; i++ )
            {
                var cardDefId = this.m_cardDictionary[materialCardsInstanceIds[i]].definitionId;

                var materialView = this._getButtonAtIndex( i );
                materialView.setImage( "" );
                materialView.spinnerOn();
                CardsManager.loadCardImage( cardDefId, IMAGE_SIZE.SMALL, function( materialView, imageURL )
                {
                    if( materialView._destroyed )
                    {
                        return;
                    }
                    materialView.spinnerOff();
                    materialView.setImage( imageURL );
                }.bind( this, materialView ) );
            }

            // Set the image for empty slots
            length = this.m_materialCardsNumber;
            for( j = i; j < length; j++ )
            {
                this._getButtonAtIndex( j ).setImage( this.m_emptyImage );
            }
        }
    },

    // Clear all values and images
    clear: function()
    {
        if( CardsManager.fusioning() )
        {
            return;
        }

        this.button_fusion.setEnabled( 0 );
        // Clear materials cards images
        var i;
        var length = this.m_materialCardsNumber;
        for( i = 0; i < length; i++ )
        {
            this._getButtonAtIndex( i ).setImage( this.m_emptyImage );
        }

        // Clear materials and items
        CardsManager.setFusionMaterialCards( [] );
        CardsManager.setFusionItemNumber( 0 );

        if( this.m_comboBox != undefined )
        {
            this.m_comboBox.reset();
        }

        // We know that the user has items
        if( this.m_itemsSelected )
        {
            // Set the base item number
            CardsManager.setFusionItemNumber( 1 );
        }

        this._enableFusionButton();
        this._setCost();
    },

    fusion: function()
    {
        info( "CardFusionMenu.fusion called" );
        this.button_fusion.setEnabled( false );
        
        var fusionBaseCard = CardsManager.getFusionBaseCard();
        var fusionMaterialCards = CardsManager.getFusionMaterialCards();
        var fusionItemNumber = CardsManager.getFusionItemNumber();
        var oldXp = CardsManager.getPlayerCardById( fusionBaseCard ).xp;

        var doAnimation = function( data )
        {
            info( "CardFusionMenu.fusion.doAnimation called. data=%s", JSON.stringify( data ) );

            fusionItemNumber = this.m_itemsSelected ? fusionItemNumber : 0;
            var definitionId = CardsManager.getPlayerCardById( data.baseCardId ).definitionId;
            var newData =
            {
                "old_xp": oldXp,
                "new_xp": data.xp,
                "definitionId": definitionId,
                "type": CardsManager.getCardDefinition( definitionId ).type
            };
            var cardFusionMenu = new CardFusionAnimation( this.m_cardDictionary, fusionBaseCard, fusionMaterialCards, fusionItemNumber, newData );
            Xib.Navigation.resetScreenStackTo( cardFusionMenu, false );
            // this.clear();
        };

        var cost = CardsManager.getFusionCost( this.m_itemsSelected );
        if( cost > User.getCurrency() )
        {
            var popUp = new PopUp( 1, PopUp.ALERT, _loc( "card_fusion_no_gp_title" ), _loc( "card_fusion_no_gp_description" ), null, _loc( "fusion_ok_button" ) );
            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( popUp );
            CardsManager.endFusion();
            this.button_fusion.setEnabled( true );
            return;
        }

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSE )
        {
            info( "CardFusionMenu.fusion In tutorial, skipping server calls." );

            this.clear();
            var data =
            {
                "baseCardId": fusionBaseCard,
                "xp": 200,
                "playerCurrency": 0
            };
            TutorialManager.completeActiveState();
            TutorialManager.executeActiveStateAction();

            Xib.Navigation.setModalOverlay( new WaitingScreen( doAnimation.bind( this, data ) ) );
            CardsManager.endFusion();
            this.button_fusion.setEnabled( true );
        }
        else
        {
            info( "CardFusionMenu.fusion Sending data to CardsManager" );

            CardsManager.fusion( function( success, data )
            {
                info( "CardFusionMenu.fusion.CardsManager.fusion.Callback called. success=%s", success );
                this.clear();

                if( success )
                {
                    Xib.Navigation.setModalOverlay( new WaitingScreen( doAnimation.bind( this, data ) ) );
                }
                CardsManager.endFusion();
                this.button_fusion.setEnabled( 1 );
            }.bind( this ), this.m_itemsSelected );
        }
    },

    changeItem: function( sender )
    {
        // If we are selecting an item, we have to disable the cards selection and enable the item selection
        if( !this.m_itemsSelected )
        {
            if( CardsManager.getFusionItemMaxNumber() > 0 )
            {
                // Set the base item number
                CardsManager.setFusionItemNumber( 1 );

                var i;
                var length = this.m_materialCardsNumber;
                for( i = 0; i < length; i++ )
                {
                    this._getButtonAtIndex( i ).setEnabled( 0 );
                }

                this.imageView_baseCardLeft.setAlpha( 0 );
                this.imageView_baseCardRight.setAlpha( 0 );

                this.button_useItem.setEnabled( 0 );
                this.button_useMaterial.setEnabled( 1 );

                this.m_itemsSelected = true;

                this._setItems();
                this.view_materials.setAlpha( 0 );
                this.view_items.setAlpha( 1 );

            }

            else
            {
                // FIXME: Implement this
                return;
                var popUp = new PopUp( 1, // numberOfButtons
                PopUp.INFO, // popUpType
                _loc( "fusion_no_items_title" ), // title
                _loc( "fusion_no_items_description" ), // description

                function() // button1 callback
                {
                }, _loc( "fusion_no_items_description" ), // button1 label
                true // autoDismiss
                );

                Xib.Navigation.setModalOverlay( popUp );
            }
        }

        else
        {
            this.button_useItem.setEnabled( 1 );
            this.button_useMaterial.setEnabled( 0 );

            this.m_itemsSelected = false;
            this.view_materials.setAlpha( 1 );
            this.view_items.setAlpha( 0 );

            var i;
            var length = this.m_materialCardsNumber;
            for( i = 0; i < length; i++ )
            {
                this._getButtonAtIndex( i ).setEnabled( 1 );
            }
            this.imageView_baseCardLeft.setAlpha( 1 );
            this.imageView_baseCardRight.setAlpha( 1 );
            this.m_comboBox.reset();
        }

        this._enableFusionButton();
        this._setCost();
    },

    _setItems: function( index )
    {
        if( this.m_itemsCreated )
        {
            return;
        }

        this.m_itemsCreated = true;

        // Get the information from a CardManager
        // image_itemImage;
        // button_itemComboBox;
        // label_itemNumber;
        // label_itemMessage;
        // label_itemTitle;
        // button_item
        // Show ComboBox

        var itemNumber = CardsManager.getFusionItemMaxNumber();
        var sortOptionList = [];
        var i;
        var length = itemNumber;
        for( i = 1; i <= length; i++ )
        {
            var sortOption =
            {
                "text": i,
                "value": i
            };
            if( i == 1 )
            {
                sortOption.selected = true;
            }

            sortOption.callback = function( option )
            {
                CardsManager.setFusionItemNumber( option.value );
                this._enableFusionButton();
                this._setCost();
            }.bind( this, sortOption );

            sortOptionList.push( sortOption );
        }

        // Adding the comboBox to the comboBoxView
        this.m_comboBox = new ComboBox( sortOptionList, this.button_itemComboBox );

        // Use this id to set the image
        var item = CardsManager.getFusionItem();
        this.label_itemMessage.setText( _loc( item.description ) );
        this.label_itemTitle.setText( _loc( item.name ) );
        this.label_itemNumber.setText( _loc( itemNumber ) );

        this.image_itemImage.spinnerOn();
        ItemManager.loadItemImage( item.id, 200, function( url )
        {
            if( this.image_itemImage._destroyed )
            {
                return;
            }
            this.image_itemImage.spinnerOff();
            this.image_itemImage.setImage( url );
        }.bind( this ) );
    },

    _getButtonAtIndex: function( index )
    {
        index++;
        info( "CardFusionMenu._getButtonAtIndex called. index=%d", index );
        var view = this.view_materials.nodeWithTag( index );
        var ret = view.nodeWithTag( 15 );
        return ret;
    },

    _enableFusionButton: function()
    {
        // If we don't have a base card, we can not make the fusion
        var fusionBaseCard = CardsManager.getFusionBaseCard();
        if( fusionBaseCard == undefined )
        {
            this.button_fusion.setEnabled( false );
            return;
        }

        var fusionMaterialCards = CardsManager.getFusionMaterialCards();
        var fusionItemNumber = CardsManager.getFusionItemNumber();

        // Fusion with items
        if( this.m_itemsSelected )
        {
            this.button_fusion.setEnabled( fusionItemNumber > 0 );
        }
        // Fusion with materials
        else
        {
            this.button_fusion.setEnabled( ( fusionMaterialCards && fusionMaterialCards.length > 0 ) );
        }
    },

    _setCost: function()
    {
        var cost = CardsManager.getFusionCost( this.m_itemsSelected );
        this.label_cost.setText( cost );
        // this.button_fusion.setEnabled( this.button_fusion.getEnabled() && cost <= User.getCurrency() );
    },

    destroy: function()
    {
        if( this.m_comboBox != undefined )
        {
            this.m_comboBox.destroy();
        }
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ItemStore'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ItemStore'] || {}; $MODULE_REGISTRY['Code/UI/ItemStore'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ItemStore.js';

exports.ItemStore = ScrollableView.subclass(
{
    classname: "ItemStore",

    USE_ITEMS: 0,
    SELL_ITEMS: 1,

    initialize: function( $super, startingTab )
    {
        info( "ItemStore.initialize called." );
        $super();

        var backFunction = function()
        {
            var func = function()
            {
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );
        ScreenManager.setBackInfo( backFunction );

        this.m_mode = (startingTab != undefined)? startingTab : this.SELL_ITEMS;
        this.m_lastReduce = 10;

        this.m_productList = ProductHandler.getStoreProductList();
        this.m_buyButtons = [];

        this.initWithXib( "./Content/Xib/ItemStore.xib", true );

        this.m_serverReady = false;
        this.m_screenReady = false;

        this.m_itemData = [];
        this.m_sellingData = [];

        this.retrieveItems();
    },

    retrieveItems: function()
    {
        this.m_serverReady = true;
        this.refresh();
        this.fillUpItems();
    },

    refresh: function()
    {
        this.m_itemData = ItemManager.getPlayerItemList( true );
        this.m_sellingData = ItemPackManager.getAllSellableItemPacks( true );
    },

    fillUpItems: function()
    {
        if( this.m_screenReady && this.m_serverReady )
        {
            if( this.m_mode == ItemStore.USE_ITEMS )
            {
                this.changeModeToUse();
            }
            else
            {
                this.changeModeToBuy();
            }
        }
    },

    fillUpOwnItems: function()
    {
        if( this.m_itemData.length == 0 )
        {
            var itemView = eval( sprintf( "this.item%d", 0 ) );

            itemView._itemImage.setImage( "hud_info_icon.png" );
            itemView._itemName.setText( _loc( "store_no_items_title" ) );
            itemView._itemDescription.setText( _loc( "store_no_items_description" ) );
            itemView._useBuyButton.setVisible( false );
        }

        for( var i = 0; i < this.m_itemData.length; ++i )
        {
            var itemDef = ItemManager.getItemDefinition( this.m_itemData[i].id );

            var itemView = eval( sprintf( "this.item%d", i ) );

            itemView._itemName.setText( _loc( itemDef.name ) );
            itemView._itemDescription.setText( _loc( "store_have" ) + " " + this.m_itemData[i].amount + "\n\n" + _loc( itemDef.description ) );
            itemView._itemQuantity.setText( "" );

            itemView._itemImage.spinnerOn();
            ItemManager.loadItemImage( itemDef.id, 200, function( sprite, url )
            {
                if( sprite._destroyed )
                {
                    return;
                }
                sprite.spinnerOff();
                sprite.setImage( url );
            }.bind( this, itemView._itemImage ) );

            itemView._useBuyButton.setTargetAction( this, sprintf( "useItem.bind(this._target, %d)", itemDef.id ) );
        }

        //Xib.Navigation.removeModalOverlay();
    },

    useItem: function( itemId )
    {
        
        var canUseError = ItemManager.verifyItem( itemId );
        if( canUseError != "" )
        {
            var popUp = new PopUp( 1, PopUp.ALERT, _loc( "item_cant_use_title" ), _loc( canUseError ), null, _loc( "item_cant_use_ok_button" ) );
            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( popUp );
            return;
        }
        
        //We can use the item
        var itemDef = ItemManager.getItemDefinition( itemId );

        if( itemDef.category != ITEM_TYPE.MISC )
        {
            var onOkButton = function()
            {
                var self = this;
                ItemManager.useItem( itemId, function()
                {
                    self.changeModeToUse();
                } );
            }.bind( this );

            var onCancelButton = function()
            {
                info( "ItemStore.useItem. User cancelled operation" );
            };
            var description = sprintf( _loc( "use_confirmation_%s" ), _loc( itemDef.name ) );

            var popUp = new PopUp( 2, PopUp.ALERT, sprintf( _loc( "use_%s" ), _loc( itemDef.name ) ), description,
                                   onCancelButton, _loc( "transaction_cancel_button" ),
                                   onOkButton, _loc( "transaction_ok_button" ) );
            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( popUp );
        }
        else
        {
            var func = function()
            {
                var screen = new CardFusionBaseSelection();
                screen.m_cardsLoaded = true;
                screen._getUserCards();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );

            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
    },

    fillUpSellingItems: function()
    {
        for( var i = 0; i < this.m_sellingData.length; ++i )
        {
            var sellDef = this.m_sellingData[i];

            var itemView = eval( sprintf( "this.item%d", i ) );

            Server.getPrice( sellDef.sku, false, this.putPriceToItem.bind( this, itemView ) );

            itemView._itemName.setText( _loc( sellDef.name ) );
            itemView._itemDescription.setText( _loc( sellDef.description ) ); // ADD DESCRIPTION ONCE ITS ADDED ON ItemsPack.json
            itemView._itemQuantity.setText( sellDef.price );
            itemView._useBuyButton.setTargetAction( this, sprintf( "buyItem.bind(this._target, %d)", i ) );

            itemView._itemImage.spinnerOn();
            ItemManager.loadItemImage( sellDef.id, 200, function( img )
            {
                itemView._itemImage.spinnerOff();
                itemView._itemImage.setImage( img );
            }.bind( this ), function( _err )
            {
                err( "Error loading item asset" );
            } );

            var optionList = [
            {
                "text": "1",
                "value": 1,
                "selected": true,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "2",
                "value": 2,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "3",
                "value": 3,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "4",
                "value": 4,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "5",
                "value": 5,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "10",
                "value": 10,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "20",
                "value": 20,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "30",
                "value": 30,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            },

            {
                "text": "50",
                "value": 50,
                "selected": false,
                "callback": function()
                {
                    info( "ItemStore > option Callback" );
                }
            } ];

            itemView._cboxOBJ = new ComboBox( optionList, itemView._cbox );
        }

        //Xib.Navigation.removeModalOverlay();
    },

    putPriceToItem: function( itemView, error, data )
    {
        if( this.m_mode == ItemStore.SELL_ITEMS )
        {
            data = JSON.parse( data );
            itemView._itemQuantity.setText( "" + data.price );
        }
    },

    buyItem: function( itemIndex )
    {
        info( "ItemStore.buyItem called. itemIndex=%s", itemIndex );

        if( !NetworkManager.networkAvailable() )
        {
            this.m_popUp = new PopUp(
                1, // numberOfButtons
                PopUp.ALERT, // popUpType
                _loc( "item_store_no_network_alert_dlg_title" ), // title
                _loc( "item_store_no_network_alert_dlg_description" ), // description

                function()                                                  // button1 callback
                {
                }.bind( this ),
                _loc( "item_store_no_network_alert_dlg_continue_button" ), // button1 label
                true                                                        // autoDismiss
            );

            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( this.m_popUp );
        }
        else
        {
            var itemView = eval( sprintf( "this.item%d", itemIndex ) );
            var amount = itemView._cboxOBJ.getSelectedInfo().value;

            var bankTransaction = new PaymentController(
                function()
                {
                    info( "ItemStore.buyItem.onProcess" );
                }.bind( this ),
                function()
                {
                    info( "ItemStore.buyItem.onClose" );
                }.bind( this ),
                this.onTransactionError.bind( this )
            );

            Xib.Navigation.setModalOverlay( new WaitingScreen() );
            bankTransaction.createSimpleTransaction( this.m_sellingData[itemIndex].sku, "comment", this.m_sellingData[itemIndex].id, this.transactionCreatedCallback.bind(this, amount) , amount);
        }
    },

    onTransactionError: function( error, transaction )
    {
        if( error.errorCode == -1 )
        {
            warn( "ItemStore.onTransactionError. Bank, user cancelled operation" );
            return;
        }
        var popUp = new PopUp( 1, PopUp.ERROR, _loc( "transaction_error" ), _loc( "transaction_try_again" ), function()
        {
        }, _loc( "transaction_ok_button" ) );
        Xib.Navigation.removeModalOverlay();
        Xib.Navigation.setModalOverlay( popUp );
    },

    transactionCreatedCallback: function( amount, itemId, transactionId )
    {
        info( "ItemStore.transactionCreatedCallback.  TransactionCreated with the following ID >  itemId : " + itemId + "  transactionId : " + transactionId );

        Server.purchaseItemPack( transactionId, this.deliverItem.bind( this, itemId, amount ) );
    },

    deliverItem: function( itemId, amount, _err, data )
    {
        if( _err )
        {
            err( "Server error trying to buy ItemPack" );
        }
        var itemPack = ItemPackManager.getPackWithId( itemId );

        var popUp = new PopUp( 1, PopUp.INFO, _loc( "transaction_completed" ), sprintf( _loc( "transaction_received_%s" ), _loc( itemPack.name ) ), this.changeModeToUse.bind( this ), _loc( "transaction_ok_button" ) );
        Xib.Navigation.removeModalOverlay();
        Xib.Navigation.setModalOverlay( popUp );

        info( "Delivering item : " + JSON.stringify( itemPack ) );
        for( var i = 0; i < itemPack.items.length; ++i )
        {
            ItemManager.modifyItemAmount( itemPack.items[i], amount );
        }
    },

    viewDidLoad: function( $super )
    {
        info( "ItemStore.viewDidLoad called." );
        $super();

        this.m_screenReady = true;

        this.mapScreenItems();

        this.fillUpItems();

        if (this.m_mode == this.SELL_ITEMS)
            this.changeModeToBuy();
        else if (this.m_mode == this.USE_ITEMS)
            this.changeModeToUse();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( NO_SCREEN );

        var test=ItemManager.getItemDefinition(3);
    },

    changeModeToBuy: function()
    {
        this.setMobaBalanceVisibility( true );
        this.m_mode = ItemStore.SELL_ITEMS;

        this.refresh();

        this.useButton.setImage( "storage_bigtab_unselected.png" );
        this.sellButton.setImage( "storage_bigtab_selected.png" );

        this.reduceItemsView();

        this.scrollToTop( false );

        var dataLength = 0;

        if( this.m_sellingData.length == 0 )
        {
            dataLength = 0;
        }
        else
        {
            dataLength = this.m_sellingData.length;
        }

        for( var i = 0; i < dataLength; ++i )
        {
            var itemView = eval( sprintf( "this.item%d", i ) );

            itemView._cbox.setVisible( true );
            itemView._mobaIcon.setVisible( true );
            itemView._mobaBackground.setVisible( true );
            itemView._useBuyButton.setVisible( true );
            itemView._itemImage.setImage( "1pxalpha0.png" );
            itemView._useBuyButton.setText( _loc( "store_buy_button" ) );
            itemView._itemQuantity.setText( "" );
        }

        this.fillUpSellingItems();
    },

    changeModeToUse: function()
    {
        this.setMobaBalanceVisibility( false );
        this.m_mode = ItemStore.USE_ITEMS;

        this.refresh();

        this.useButton.setImage( "storage_bigtab_selected.png" );
        this.sellButton.setImage( "storage_bigtab_unselected.png" );

        this.reduceItemsView();

        this.scrollToTop( false );

        var dataLength = 0;

        if( this.m_itemData.length == 0 )
        {
            dataLength = 1;
        }
        else
        {
            dataLength = this.m_itemData.length;
        }

        for( var i = 0; i < dataLength; ++i )
        {
            var itemView = eval( sprintf( "this.item%d", i ) );

            itemView._cbox.setVisible( false );
            itemView._mobaIcon.setVisible( false );
            itemView._mobaBackground.setVisible( false );
            itemView._useBuyButton.setVisible( true );
            itemView._itemImage.setImage( "1pxalpha0.png" );
            itemView._useBuyButton.setText( _loc( "store_use_button" ) );
            itemView._itemQuantity.setText( "" );
        }

        this.fillUpOwnItems();
    },

    mapScreenItems: function()
    {
        for( var i = 0; i < 10; ++i )
        {
            var itemView = eval( sprintf( "this.item%d", i ) );

            itemView._itemName = itemView.nodeWithTag( 42000 );
            itemView._itemImage = itemView.nodeWithTag( 42001 );
            itemView._itemDescription = itemView.nodeWithTag( 42002 );
            itemView._useBuyButton = itemView.nodeWithTag( 42003 );
            itemView._itemQuantity = itemView.nodeWithTag( 42004 );
            itemView._cbox = itemView.nodeWithTag( 42005 );
            itemView._mobaIcon = itemView.nodeWithTag( 42010 );
            itemView._mobaBackground = itemView.nodeWithTag( 42011 );
        }
    },

    reduceItemsView: function()
    {
        var itemLength = 0;

        if( this.m_mode == ItemStore.USE_ITEMS )
        {
            itemLength = this.m_itemData.length;
        }
        else
        {
            itemLength = this.m_sellingData.length;
        }

        if( itemLength == 0 )
        {
            itemLength = 1;
        }

        for( var i = 0; i < itemLength; ++i )
        {
            var itemView = eval( sprintf( "this.item%d", i ) );
            itemView.setVisible( true );
            itemView._useBuyButton.setEnabled( true );
        }

        for( var i = itemLength; i < 10; ++i )
        {
            var itemView = eval( sprintf( "this.item%d", i ) );
            itemView.setVisible( false );
            itemView._useBuyButton.setEnabled( false );
        }

        var itemView = eval( sprintf( "this.item%d", 0 ) );

        this.expandFrame(
        {
            '_top': 0,
            '_bottom': 0,
            '_bottomContent': -( this.m_lastReduce - itemLength ) * ( itemView.getFrame().getSize()._height )
        } );
        this.m_lastReduce = itemLength;
    },

    destroy: function()
    {
        this.setMobaBalanceVisibility( false );
    },

    setMobaBalanceVisibility: function( visible )
    {
        var scale = this.getView().getScale();

        if( visible )
        {
            var socialframe = this.mobaContainer.getFrame();
            var sfw = socialframe.getSize().getWidth() * scale._x;
            var sfh = socialframe.getSize().getHeight() * scale._y;

            var sfx = socialframe._origin._x * scale._x;
            var sfy = socialframe._origin._y * scale._y;

            var frame = new UI.ViewGeometry.Rect( sfx, sfy, sfw, sfh );

            info( "ItemStore.setMobaBalanceVisibility > frame " + JSON.stringify( frame ) );

            Social.US.Service.ButtonOverlays.showBalanceButton( frame, function()
            {
            } );
        }
        else
        {
            Social.US.Service.ButtonOverlays.hideBalanceButton();
        }
    },

    viewDidAppear   :  function()
    {
        Xib.Navigation.removeModalOverlay();
    },

    viewWillAppear: function()
    {
        if( this.m_mode == ItemStore.USE_ITEMS )
            this.setMobaBalanceVisibility( false );
        else
            this.setMobaBalanceVisibility( true );
    },

    viewWillDisappear: function()
    {
        this.setMobaBalanceVisibility( false );
    },
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ProgressBar'] || {}; $MODULE_REGISTRY['Code/UI/ProgressBar'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ProgressBar.js';

exports.ProgressBar = XibUI.subclass(
{
    classname: 'ProgressBar',

    m_baseFrame     : null,
    m_baseValue     : 0,
    m_currentValue  : 0,

    initialize : function( xib /*XibFile to load*/, base_value, frame, vertical, cb )
    {
        info( "ProgressBar.initialize called. base_value=%s", base_value );

        this.m_baseFrame = null;
        this.m_baseValue = null;
        this.m_currentValue = null;

        if( base_value == undefined )
        {
            this.m_baseValue = 0;
        }
        else
        {
            this.m_baseValue = base_value;
        }

        if( frame != undefined )
        {
            this.m_baseFrame = frame;
        }

        this.m_allLoaded = false;
        this.m_vertical  = vertical;

        this._onViewDidLoadCallBack = cb;
        this.initWithXib( xib, true );
    },

    viewDidLoad : function()
    {
        info( "ProgressBar.viewDidLoad called." );

        if( this._onViewDidLoadCallBack )
        {
            this._onViewDidLoadCallBack();
        }
        
        this.m_allLoaded = true;
        this.updateProgress( this.m_baseValue );
        
        if( this.m_baseFrame )
        {
            this.changeFrame( this.m_baseFrame );
        }

        this._zeroOutAnchor( this.foreground );
        this._zeroOutAnchor( this.background );

        if( this.foreground2 )
        {
            this._zeroOutAnchor( this.foreground2 );
        }
    },

    updateProgress : function( delta /*decimal from 0 to 1*/ )
    {
        if( !this.m_allLoaded )
        {
            warn( "ProgressBar.updateProgress Warning, this.m_allLoaded ==  false" );
            return;
        }

        if( delta > 1 )
        {
            delta = 1;
        }
        else if( delta < 0 )
        {
            delta = 0;
        }

        // Stop execution if there are no changes.
        if( this.m_currentValue == delta )
        {
            return;
        }

        this.m_currentValue = delta;

        if( !this.m_vertical )
        {
            this.foreground.setScale( delta, this.foreground.getScale().getY() );
        }
        else
        {
            this.foreground.setScale( this.foreground.getScale().getX(), delta );
        }
    },

    getCurrentProgress: function()
    {
        if( this.m_allLoaded )
        {
            return this.m_currentValue;
        }
        else
        {
            return -1;
        }
    },

    _zeroOutAnchor: function(sprite)
    {
        var oldSpriteFrame = sprite._animation.getFrame(0);
        var zeroedAnchor = null;

        if(!this.m_vertical)
        {
            zeroedAnchor        = new Core.Point(0, oldSpriteFrame.getAnchor().getY());
        }
        else
        {
            zeroedAnchor        = new Core.Point(oldSpriteFrame.getAnchor().getX(), 0);
        }

        sprite.setImage(
            oldSpriteFrame.getImage(),
            oldSpriteFrame.getSize(),
            zeroedAnchor,
            oldSpriteFrame.getUVs()
        );

        return sprite;
    },

    changeFrame: function(newFrame)
    {
        this.view.setFrame( newFrame );

        var xPos            = 0;
        var yPos            = 0;

        if(this.m_vertical)
        {
            xPos            = 0;
            yPos            = -this.view.getFrame().getSize()._height/2;
        }
        else
        {
            xPos            = -this.view.getFrame().getSize()._width/2;
            yPos            = 0;
        }

        this.view.setPosition( xPos, yPos );

        this.background.setFrame(newFrame);
        this.foreground.setFrame(new Core.Rect(newFrame._origin._x, newFrame._origin._y, newFrame._size._width*(this.m_vertical ? 0.7 : 0.98),newFrame._size._height*(this.m_vertical ? 0.98 : 0.6)) );
        this.foreground.setPosition( (this.m_vertical ? 0 : 0.03*newFrame._size._width) , (this.m_vertical ? 0.03*newFrame._size._height : 0));

        if(this.foreground2)
        {
            this.foreground2.setFrame(new Core.Rect(newFrame._origin._x, newFrame._origin._y, newFrame._size._width*(this.m_vertical ? 0.7 : 0.98),newFrame._size._height*(this.m_vertical ? 0.98 : 0.6)) );
            this.foreground2.setPosition( (this.m_vertical ? 0 : 0.01*newFrame._size._width) , (this.m_vertical ? 0.03*newFrame._size._height : 0));
            this.foreground2.setScale(1,1);
        }
        this.background.setPosition(0,0);
        this.foreground.setPosition(this.background.getFrame().getSize().getWidth() * 0.01,0);
    },

    destroy: function()
    {
        info("ProgressBar.destroy called");
    }
}
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/DynamicList'] = function(){var exports = $MODULE_REGISTRY['Code/UI/DynamicList'] || {}; $MODULE_REGISTRY['Code/UI/DynamicList'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/DynamicList.js';

exports.DynamicList = ScrollableView.subclass(
{
    classname: 'DynamicList',

    initialize: function( $super )
    {
        info( "DynamicList.initialize called" );

        this.m_hideAcceptButton = false;
        this.m_elementCell = null;
        this.m_controlCell = null;

        // Paginator
        this.m_numberOfColumns = 1;
        this.m_maxCellNumber = 10;
        this.m_pageNumber = 0;
        this.m_maxPageNumber = 0;

        $super();
    },

    /** CardFusionCell methods * */
    previousPage: function( /* Xib.Button */inSender )
    {
        this.m_pageNumber--;
        this._refreshTable( true );
    },

    /** CardFusionCell methods * */
    nextPage: function( /* Xib.Button */inSender )
    {
        this.m_pageNumber++;
        this._refreshTable( true );
    },

    // @@Overwrite
    _getNumberOfListItems: function()
    {
        return 0;
    },

    // @@Overwrite
    _setCell: function( index, cardIndex )
    {
    },

    setPageNumber: function( listLength )
    {
        // Recalculate the number of pages
        this.m_maxPageNumber = Math.ceil( listLength / this.m_maxCellNumber );
        if( this.m_maxPageNumber == 0 )
        {
            this.m_maxPageNumber = 1;
        }
    },

    /** We have n Views, so we will put each object in those views. * */
    _createCellAtIndex: function( index, cb )
    {
        info( "DynamicList._createCellAtIndex called. index=%d, this.m_pageNumber=%d", index, this.m_pageNumber );

        var elementIndex = ( this.m_pageNumber * this.m_maxCellNumber ) + index;

        this._getViewAtIndex( index ).setAlpha( 1 );

        if( this.m_elementCell && this.m_elementCell[index] != undefined )
        {
            if( this.m_elementCell[index].destroy )
            {
                this.m_elementCell[index].destroy();
            }
            this.m_elementCell[index] = null;
        }
        if( !this._destroyed )
        {
            this._setCell( index, elementIndex );

            if( index % this.m_numberOfColumns == 0 )
            {
                this.expandFrame(
                {
                    '_top': 0,
                    '_bottom': 0,
                    '_bottomContent': this._getViewAtIndex( index ).getFrame()._size._height
                } );
            }
        }
    },

    _createPaginatorControlAtIndex: function( index, text )
    {
        // If the panel exists we only change its status.
        if( this.m_controlCell != undefined )
        {
            this._setPaginatorControlPanel( text );
        }
        else
        {
            this.m_controlCell = this._getViewAtIndex( index );

            // If we are not setting material cards, we have to hide the accept
            // option
            if( !this.m_hideAcceptButton )
            {
                if( this.button_accept )
                {
                    this.button_accept.destroy();
                    this.button_accept = null;
                }
            }

            // Set pagination
            this._setPaginatorControlPanel( text );
        }

        this.expandFrame(
        {
            '_top': 0,
            '_bottom': 0,
            '_bottomContent': this._getViewAtIndex( index ).getFrame()._size._height
        } );
    },

    _createEmptyCellAtIndex: function( index )
    {
        info( "CardFusionSelection._createEmptyCellAtIndex called. index=%s", index );
        if( this.m_elementCell && this.m_elementCell[index] != undefined )
        {
            this.m_elementCell[index].destroy();
            this.m_elementCell[index] = null;
        }

        var view = this._getViewAtIndex( index );
        view.normalFrame = view.getFrame();
        view.setAlpha( 0 );
    },

    /** Set pagination * */
    _setPaginatorControlPanel: function( text )
    {
        if( text == undefined )
        {
            text = "fusion_page";
        }
        this.label_pageNumber.setText( _loc( text ) + " " + ( this.m_pageNumber + 1 ) + "/" + this.m_maxPageNumber );

        if( this.m_pageNumber <= 0 )
        {
            this.button_previous.setEnabled( 0 );
        }
        else
        {
            this.button_previous.setEnabled( 1 );
        }

        if( this.m_pageNumber >= this.m_maxPageNumber - 1 )
        {
            this.button_next.setEnabled( 0 );
        }
        else
        {
            this.button_next.setEnabled( 1 );
        }
    },

    /** Method to create and modify all cells * */
    _refreshTable: function( pageChanged )
    {
        if( !pageChanged )
        {
            this.m_pageNumber = 0;
        }
        // ReSize the scroll to the minimum size
        var oldFrame = this.view_scroller.getContentSize().clone();
        var scrollSize = this.xib_viewScroll.getFrame()._size._height;
        var viewSize = this._getViewAtIndex( 0 ).getFrame()._size._height;

        var viewListSize = Math.ceil( ( this.m_maxCellNumber ) * viewSize / this.m_numberOfColumns );
        this.expandFrame(
        {
            '_top': 0,
            '_bottom': 0,
            '_bottomContent': -oldFrame._height + scrollSize - viewListSize - viewSize
        } );

        // Set initial variables
        this.m_controlPanelPosition = null;
        this.tempFrame = null;
        var i, length;
        length = this._getNumberOfListItems();

        // Draw cards
        for( i = 0; i < length; i++ )
        {
            this._createCellAtIndex( i );

            // Save the first frame to get the height. We know that all frames
            // will be the same
            if( i == 0 )
            {
                var view = this._getViewAtIndex( i );
                this.tempFrame = view.getFrame();
            }
        }

        // If we don't have cards, save the first frame
        if( length == 0 )
        {
            var view = this._getViewAtIndex( 0 );
            this.tempFrame = view.getFrame();
            i = 0;

        }

        // If we have 10 cards, save the position of the control panel as the
        // last cell position plus its height
        var controlView = this._getViewAtIndex( this.m_maxCellNumber );
        if( i == this.m_maxCellNumber )
        {
            var view = this._getViewAtIndex( i - 1 );
            this.m_controlPanelPosition = new Core.Point( controlView.getPosition()._x, view.getPosition()._y + this.tempFrame._size._height );
        }
        // Else, we have to hide cells
        else
        {
            var j;
            for( j = i; j < this.m_maxCellNumber; j++ )
            {
                this._createEmptyCellAtIndex( j );

                // Save the first empty cell as the position of the control
                // panel
                if( j == length )
                {
                    lastShowedIndex = j;
                    var view = this._getViewAtIndex( lastShowedIndex );

                    // If the first element of the last row is shown, position the controlPanel in the next row
                    var elementRowPosition = ( lastShowedIndex ) % this.m_numberOfColumns;
                    var offset = 0;
                    if( elementRowPosition != 0 )
                    {
                        offset = this.tempFrame._size._height;
                    }
                    this.m_controlPanelPosition = new Core.Point( controlView.getPosition()._x, view.getPosition()._y + offset );
                }
            }
        }

        // Add the control panel on last cell with the saved position
        this._createPaginatorControlAtIndex( this.m_maxCellNumber );
        var view = this._getViewAtIndex( this.m_maxCellNumber );

        if( this.m_controlPanelPosition != undefined )
        {
            view.setPosition( this.m_controlPanelPosition );
        }

        // Set the initial position
        this.scrollToTop( false );

    },

    _getViewAtIndex: function( index )
    {
        info( "DynamicList._getViewAtIndex called. index=%d", index );

        var view = eval( sprintf( "this.view_cell%d", index ) );
        return view;
    },

    destroy: function( $super )
    {
        this._destroyed = true;

        if( this.m_elementCell != undefined )
        {
            var i, length;
            length = this._getNumberOfListItems();
            // Draw cards
            for( i = 0; i < length; i++ )
            {
                if( this.m_elementCell[i] != undefined )
                {
                    this.m_elementCell[i].destroy();
                    this.m_elementCell[i] = null;
                }
            }
        }
        $super();
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionAnimation'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionAnimation'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionAnimation'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionAnimation.js';

exports.CardFusionAnimation = XibUI.subclass(
{
    classname: 'CardFusionAnimation',

    m_emptyImage: "1pxwhite",

    initialize: function( cardDictionary, baseCard, materialCards, itemNumber, serverAnswer )
    {
        this.m_cardDictionary = null;
        this.m_materialCardsImages = [];
        this.m_materialCards = [];
        this.m_itemNumber = 0;
        this.m_baseCard = null;
        this.m_serverAnswer = null;
        this.m_progressBar = null;
        this.m_materialCardsNumber = 10;
        this.m_barFx = null;
        this.m_glowScaleBase = 0;

        this.m_materialCardFusion = false;
        this.m_firstTimePressed = true;
        this.m_initialPosition = null;
        this.m_finalPosition = null;
        this.m_middlePosition1 = null;
        this.m_middlePosition2 = null;

        this.m_arrowHidePosition = null;
        this.m_arrowFinalPosition = null;

        this.m_materialCount = 0;
        this.m_materialToBeCharged = 0;
        this.m_baseCardShowed = false;

        this.m_cardDictionary = cardDictionary;
        this.m_serverAnswer = serverAnswer;
        this.m_baseCard = baseCard;
        this.m_materialCards = materialCards;
        this.m_itemNumber = itemNumber;

        this.m_materialCardFusion = ( itemNumber == 0 );

        this.m_oldCardInstance =
        {
            "id": -1,
            "definitionId": this.m_serverAnswer.definitionId,
            "xp": this.m_serverAnswer.old_xp,
            "type": this.m_serverAnswer.type
        };
        this.m_newCardInstance =
        {
            "id": -1,
            "definitionId": this.m_serverAnswer.definitionId,
            "xp": this.m_serverAnswer.new_xp,
            "type": this.m_serverAnswer.type
        };

        this.initWithXib( "./Content/Xib/CardFusionAnimation.xib", true );
    },

    viewDidLoad: function( $super )
    {
        Social.Common.Service.hideCommunityButton();
        info( "CardFusionAnimation.viewDidLoad called." );
        this.m_initialPosition = this.xib_lvlUp.getPosition().clone();
        this.m_finalPosition = this.xib_lvlUpFinal.getPosition().clone();
        this.m_middlePosition1 = this.xib_lvlUpMiddle1.getPosition().clone();
        this.m_middlePosition2 = this.xib_lvlUpMiddle2.getPosition().clone();

        this.m_arrowHidePosition = this.xib_orangeArrow.getPosition().clone();
        this.m_arrowFinalPosition = this.xib_arrowFinal.getPosition().clone();

        this._setMaterialArray();
        this._setItemData();
        this._setupView();
        ScreenManager.resetCallBack();

        SoundManager.setMusicEnabled( true, SoundManager.BG_MUSIC_FUSION );

        GameController.getMainScreen().hideButtons();
        GameController.getMainScreen().hidePlayerInfo();
    },

    viewDidDisappear: function()
    {
        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
            GameController.getMainScreen().showButtons();
            GameController.getMainScreen().showPlayerInfo();
        }
    },

    // TODO FIXME Need to wait that the view is loaded and the data is retrieved!
    _setupView: function()
    {
        info( "CardFusionAnimation._setupView called." );
        this._setBaseCard();
        if( this.m_materialCardFusion )
        {
            this._setMaterialCards();
        }
        else
        {
            this._setItem();
        }
    },

    _setBaseCard: function()
    {
        var baseCardInstanceId = this.m_baseCard;
        if( baseCardInstanceId != undefined )
        {
            var cardDefId = this.m_cardDictionary[baseCardInstanceId].definitionId;
            CardsManager.loadCardImage( cardDefId, IMAGE_SIZE.BIGGEST, function( imageURL )
            {
                this.xib_baseCard.setImage( imageURL );
                this._removeSpinner( false );
            }.bind( this ) );
        }
    },

    _setMaterialCards: function()
    {
        var materialCardsInstanceIds = this.m_materialCards;
        if( materialCardsInstanceIds != undefined && materialCardsInstanceIds.length != 0 )
        {
            this.m_materialCount = 0;
            this.m_materialToBeCharged = this.m_materialCardsNumber;

            var i;
            var j;
            var length = materialCardsInstanceIds.length;
            // Set image for materials cards
            for( i = 0; i < length; i++ )
            {
                var cardDefId = this.m_cardDictionary[materialCardsInstanceIds[i]].definitionId;

                CardsManager.loadCardImage( cardDefId, IMAGE_SIZE.SMALL, function( index, imageURL )
                {
                    this.m_materialCardsImages[index].setImage( imageURL );
                    this._removeSpinner( true );
                }.bind( this, i ) );
            }

            // Set the image for empty slots
            length = this.m_materialCardsNumber;
            for( j = i; j < length; j++ )
            {
                this.m_materialCardsImages[j].setImage( this.m_emptyImage );
                this._removeSpinner( true );
            }
        }
        else
        {
            // Remove spinner
        }
    },

    _setItem: function()
    {
        info(">>>>>>> SetITEM");
        this.m_materialCount = 0;
        this.m_materialToBeCharged = 0;

        var definition = CardsManager.getCardDefinition( this.m_oldCardInstance.definitionId );
        if( definition.type == PILOT )
        {
            info(">>>>>>> SetITEM PILOT");
            var itemId = 7;
            ItemManager.loadItemImage( itemId, IMAGE_SIZE.BIG, function( url )
            {
                if( this.xib_item._destroyed )
                {
                    return;
                    this._removeSpinner( true );
                }
                this.xib_item.setImage( url );
                this._removeSpinner( true );
            }.bind( this ) );
        } else
        {
            info(">>>>>>> SetITEM GEAR");
            var itemId = 6;
            ItemManager.loadItemImage( itemId, IMAGE_SIZE.BIG, function( url )
            {
                if( this.xib_item._destroyed )
                {
                    return;
                    this._removeSpinner( true );
                }
                this.xib_item.setImage( url );
                this._removeSpinner( true );
            }.bind( this ) );
        }
    },

    accept: function()
    {
        if( this.m_firstTimePressed )
        {
            this.m_firstTimePressed = false;
            this.xib_acceptButton.setEnabled( false );
            this.xib_acceptButton.runAction( Action.FadeOut.actionWithDuration( 0.5 ) );
            // var cardScreen = new CardScreen( this.m_serverAnswer );
            // Xib.Navigation.pushViewController( cardScreen, true );
            var moveTime = 0.8;
            var shineInTime = 1.4;
            var shineOutTime = 0.6;
            var delayTimeBeforeShine = 0.05;
            var maxStartTime = 0;
            var basePosition = this.xib_baseCard.getPosition();

            if( this.m_materialCardFusion )
            {
                var i;
                var length = this.m_materialCardsNumber;

                for( i = 0; i < length; i++ )
                {
                    startTime = Math.random() * 1;
                    if( startTime > maxStartTime )
                    {
                        maxStartTime = startTime;
                    }

                    var image = this.m_materialCardsImages[i];
                    image.runAction( Action.Sequence.actions( Action.DelayTime.actionWithDuration( startTime ), Action.EaseOutSine.actionWithAction( Action.MoveTo.actionWithDuration( moveTime, basePosition ) ) ) );
                    image.runAction( Action.Sequence.actions( Action.DelayTime.actionWithDuration( startTime ), Action.FadeOut.actionWithDuration( moveTime + 0.6 ) ) );
                }
            }

            else
            {
                this.xib_item.runAction( Action.EaseOutSine.actionWithAction( Action.MoveTo.actionWithDuration( moveTime, basePosition ) ) );
                this.xib_item.runAction( Action.EaseOutSine.actionWithAction( Action.ScaleTo.actionWithDuration( moveTime, 0.3 ) ) );
                this.xib_item.runAction( Action.EaseOutSine.actionWithAction( Action.FadeOut.actionWithDuration( moveTime + 0.6 ) ) );
            }

            this.xib_shine.runAction( Action.Sequence.actions( Action.DelayTime.actionWithDuration( moveTime + maxStartTime ), Action.EaseOutSine.actionWithAction( Action.FadeIn.actionWithDuration( shineInTime ) ), Action.CallFunc.actionWithTarget(
                    this, this._destroyMaterials.bind( this ) ), Action.DelayTime.actionWithDuration( delayTimeBeforeShine ), Action.EaseOutSine.actionWithAction( Action.FadeOut.actionWithDuration( shineOutTime ) ), Action.CallFunc.actionWithTarget(
                    this, this._changeXP.bind( this ) ) ) );
        }
        else
        {
            if( TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSION_ANIMATION )
            {
                TutorialManager.completeActiveState();
                TutorialManager.executeActiveStateAction();
            }

//            this._changeXP();
//            return;

            this.xib_glow.stopAllActions();
            //FIXME:
            var cardFusionMenu = new FusionComplete( this.m_serverAnswer );
            Xib.Navigation.resetScreenStackTo( cardFusionMenu, false );
        }
    },

    _destroyMaterials: function()
    {
        if( this.m_materialCardFusion )
        {
            var i;
            var length = this.m_materialCardsNumber;
            for( i = 0; i < length; i++ )
            {
                this.m_materialCardsImages[i].destroy();
            }
        }
        else
        {
            this.xib_item.destroy();
        }

        this.xib_baseCard.setFrame( this.xib_baseCardFrame.getFrame() );

        var oldXpPercentage = CardsManager.getXpPercentage( this.m_oldCardInstance, true );
        this.m_progressBar = new ProgressBar( "/Content/Xib/ProgressBarFusion.xib", oldXpPercentage, this.xib_progressBar.getFrame() );
        var y = this.xib_baseCardFrame.getPosition().getY() + ( this.xib_baseCardFrame.getFrame()._size._height / 2 );
        var x = this.xib_progressBar.getPosition().getX();
        this.m_progressBar.getView().setPosition( x, y );

        this.xib_progressBar.addChild( this.m_progressBar.getView() );
        this.m_barFx = new GL2.Sprite();
        this.m_barFx.setFrame( this.xib_barFx.getFrame() );
        this.m_barFx.setPosition( x + ( this.xib_baseCardFrame.getFrame()._size._width / 2 ), y  );
        this.m_barFx.setAlpha( 0 );
        this.m_barFx.setDepth( this.xib_progressBar.getDepth() + 1 );
        this.xib_barFx.getParent().addChild( this.m_barFx );
        this.xib_glow.setAlpha( 1 );
        this.m_glowScaleBase = this.xib_glow.getScale().clone();
        var glowPeriod = 0.5;
        var playGlow = function()
        {
            this.xib_glow.stopAllActions();
            this.xib_glow.runAction(
                Action.Sequence.actions(
                    Action.ScaleTo.actionWithDuration( glowPeriod, this.m_glowScaleBase.getX(), this.m_glowScaleBase.getY() ),
                    Action.ScaleTo.actionWithDuration( glowPeriod, this.m_glowScaleBase.getX() * 1.04, this.m_glowScaleBase.getY() * 1.04 ),
                    Action.CallFunc.actionWithTarget( this, playGlow )
                )
            );
        }.bind( this );
        playGlow();


//        this.m_progressBar.foreground.setScale( oldXpPercentage, 1 );
    },

    // FIXME: Hardcoded
    _changeXP: function()
    {

        if (!this.m_progressBar || !this.m_progressBar.foreground)
            setTimeout(100, this._changeXP.bind(this));

        var barTime = 0.4;
        var delayTime = 1.2;
        var actions = "Action.Sequence.actions(";
        var levels = this._getDeltaLevels();
        var newXpPercentage = CardsManager.getXpPercentage( this.m_newCardInstance );
        var i;

        var onStarted = function()
        {
            this.m_progressBar.foreground.setScale( 0, 1 );
        }.bind( this );

        //Nota: Diego eris terrible de flaite
        for( i = 0; i < levels; i++ )
        {
            actions = actions + "Action.CallFunc.actionWithTarget( this, onStarted ),";
            actions = actions + "Action.ScaleTo.actionWithDuration(" + barTime + ",1,1),";
            actions = actions + "Action.CallFunc.actionWithTarget( this, this._levelUp.bind( this )),";
            actions = actions + "Action.DelayTime.actionWithDuration(" + delayTime + "),";
        }
        actions = actions + "Action.CallFunc.actionWithTarget( this, onStarted ),";
        actions = actions + "Action.ScaleTo.actionWithDuration(" + barTime * newXpPercentage + "," + newXpPercentage + ",1),";
        actions = actions + "Action.CallFunc.actionWithTarget( this, this._enableAcceptButton.bind( this )) );";
        ( this.m_progressBar.foreground ).runAction( Action.Sequence.actions( eval( actions ) ) );
    },

    _levelUp: function()
    {
        var initialDelay = 0.01;
        var blueArrowDelay = 0.1;
        var redArrowDelay = 0.4;
        var textTime1 = 0.2;
        var textTime2 = 0.733;
        var arrowTime = 0.7;

        this.xib_lvlUp.setScale( 1, 1 );
        this.xib_lvlUp.setAlpha( 1 );
        this.xib_lvlUp.stopAllActions();
        this.xib_lvlUp.setPosition( this.m_initialPosition );

        this.xib_blueArrow.stopAllActions();
        this.xib_blueArrow.setPosition( this.m_arrowHidePosition );

        this.xib_blueArrow2.stopAllActions();
        this.xib_blueArrow2.setPosition( this.m_arrowHidePosition );

        this.xib_orangeArrow.stopAllActions();
        this.xib_orangeArrow.setPosition( this.m_arrowHidePosition );

        this.xib_orangeArrow2.stopAllActions();
        this.xib_orangeArrow2.setPosition( this.m_arrowHidePosition );

        var removeAnimation = function()
        {
            this.m_barFx.setAlpha( 0 );
        }.bind( this );

        var onFinished = function()
        {
            this.m_progressBar.stopAllActions();
            this.m_progressBar.foreground.setScale( 0, 1 );
        }.bind( this );

        //play bar animation
        var animation = ResourceManager.getAnimationFor( "fusionani_shine_animation.png" );
        animation.setLoopingEnabled( false );
        this.m_barFx.setAnimation( animation );
        this.m_barFx.setAlpha( 1 );

        this.m_progressBar.foreground.setScale( 1, 1 );
        this.xib_lvlUp.runAction(
            Action.Sequence.actions(
                Action.DelayTime.actionWithDuration( initialDelay ),
                Action.MoveTo.actionWithDuration( textTime1, this.m_middlePosition1 ),
                Action.MoveTo.actionWithDuration( textTime2, this.m_middlePosition2 ),
                Action.MoveTo.actionWithDuration( textTime1, this.m_finalPosition ),
                Action.CallFunc.actionWithTarget( this, removeAnimation )
            )
        );

        this.xib_blueArrow.runAction(
            Action.Sequence.actions(
                Action.DelayTime.actionWithDuration( initialDelay + blueArrowDelay ),
                Action.MoveTo.actionWithDuration( textTime1, this.m_arrowFinalPosition )
            )
        );

        this.xib_blueArrow2.runAction(
            Action.Sequence.actions(
                Action.DelayTime.actionWithDuration( initialDelay + blueArrowDelay + 0.1 ),
                Action.MoveTo.actionWithDuration( textTime1, this.m_arrowFinalPosition )
            )
        );

        this.xib_orangeArrow.runAction(
            Action.Sequence.actions(
                Action.DelayTime.actionWithDuration( initialDelay + redArrowDelay ),
                Action.MoveTo.actionWithDuration( textTime1, this.m_arrowFinalPosition )
            )
        );

        this.xib_orangeArrow2.runAction(
            Action.Sequence.actions(
                Action.DelayTime.actionWithDuration( initialDelay + redArrowDelay + 0.1 ),
                Action.MoveTo.actionWithDuration( textTime1, this.m_arrowFinalPosition )
            )
        );

        // this.xib_lvlUp.runAction( Action.ScaleTo.actionWithDuration( scale1Time, 4 ) );
        // this.xib_lvlUp.runAction( Action.Sequence.actions( Action.FadeIn.actionWithDuration( scale1Time ), Action.FadeOut.actionWithDuration( scale2Time ) ) );

        /*this.xib_lvlUp.runAction( Action.Sequence.actions( Action.EaseOutSine.actionWithAction( Action.MoveTo.actionWithDuration( scale1Time, this.m_middlePosition ) ),

        Action.EaseOutSine.actionWithAction( Action.MoveTo.actionWithDuration( scale2Time, this.m_finalPosition ) ) ) );*/
    },

    _enableAcceptButton: function()
    {
        this.xib_acceptButton.setEnabled( true );
        this.xib_acceptButton.setAlpha( 0 );
        this.xib_acceptButton.setText( _loc("fusion_back") );
        this.xib_acceptButton.runAction( Action.FadeIn.actionWithDuration( 0.7 ) );

        SoundManager.setMusicEnabled( true, SoundManager.BG_MUSIC_NORMAL );
    },
    _setMaterialCardsPosition: function()
    {
        var cardsLength = this.m_materialCards.length;

        if( cardsLength < 5 )
        {
            switch( cardsLength )
            {
                case 1:
                    this.m_materialCardsImages.swap( 0, 2 );
                    break;
                case 2:
                    this.m_materialCardsImages.swap( 0, 3 );
                    break;
                case 3:
                    this.m_materialCardsImages.swap( 0, 3 );
                    break;
                case 4:
                    this.m_materialCardsImages.swap( 2, 4 );
                    break;
            }
        }

        if( cardsLength > 5 && cardsLength < 10 )
        {
            switch( cardsLength )
            {
                case 6:
                    this.m_materialCardsImages.swap( 5, 7 );
                    break;
                case 7:
                    this.m_materialCardsImages.swap( 5, 8 );
                    break;
                case 8:
                    this.m_materialCardsImages.swap( 5, 8 );
                    break;
                case 9:
                    this.m_materialCardsImages.swap( 7, 9 );
                    break;
            }
        }
    },

    _setMaterialArray: function()
    {
        var base = 1000;
        var i;
        var length = this.m_materialCardsNumber;
        for( i = 0; i < length; i++ )
        {
            if( this.m_materialCardFusion )
            {
                this.m_materialCardsImages[i] = this.view.nodeWithTag( base + i );
            }
            else
            {
                this.view.nodeWithTag( base + i ).destroy();
            }
        }

        if( this.m_materialCardFusion )
        {
            this._setMaterialCardsPosition();
        }
    },

    _setItemData: function()
    {
        if( this.m_materialCardFusion )
        {
            this.xib_item.destroy();
        }
    },

    viewDidAppear: function()
    {
        // Xib.Navigation.removeModalOverlay();
    },

    _getDeltaLevels: function()
    {
        var oldLevel = CardsManager.getCardLevel( this.m_oldCardInstance );
        var newLevel = CardsManager.getCardLevel( this.m_newCardInstance );

        return( newLevel - oldLevel );
    },

    _removeSpinner: function( material )
    {
        info( "CardFusionAnimation._removeSpinner: " + this.m_baseCardShowed + ", " + this.m_materialToBeCharged + "," + this.m_materialCount + ",  " + material );
        if( material )
        {
            this.m_materialCount++;
        }
        else
        {
            this.m_baseCardShowed = true;
        }

        if( this.m_materialCount >= this.m_materialToBeCharged && this.m_baseCardShowed )
        {
            info( "CardFusionSelection._removeSpinner: Removing spinner" );
            Xib.Navigation.removeModalOverlay();
        }
    },
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionSelection'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionSelection'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionSelection'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionSelection.js';

exports.CardFusionSelection = DynamicList.subclass(
{
    classname: 'CardFusionSelection',

    initialize: function( $super, type )
    {
        info( "CardFusionSelection.initialize called. type=%s", type );

        this.m_cardList = null;
        this.m_cardDictionary = null;

        this.m_materialCardsInititalState = null;

        this.m_cardType = "";

        this.m_sortBy =
        {
            "value": "overall",
            "invert": false
        };

        this.m_comboBox = null;

        this.m_viewLoaded = false;
        this.m_UIPopulated = false;

        // overwrite
        this.m_settingMaterialCard;
        this.m_inDeck;
        this.m_xib;
        this.m_cardsLoaded = false;

        $super();
        var cardTypes = CardsManager.getCardTypes();
        this.m_type1 = cardTypes[0];
        this.m_type2 = cardTypes[1];
        this.m_cardType = ( type != undefined ) ? type : this.m_type1;

        this.m_hideAcceptButton = this.m_settingMaterialCard;

        this.initWithXib( this.m_xib, true );
    },

    viewDidLoad: function( $super )
    {
        info( "CardFusionSelection.viewDidLoad called." );
        $super();

        if( this.m_refreshCards )
        {
            info( "CardsFusionSelection.RefreshCards" );
            var self = this;
            var func = function()
            {
                self.m_viewLoaded = true;
                self._populateUI();
            };
            CardsManager.syncPlayerCardList( func );
        }
        else
        {
            this.m_viewLoaded = true;
            this._populateUI();
        }
    },

    _populateUI: function()
    {
        info( "CardFusionSelection._populateUI called. this.m_cardsLoaded=%s, this.m_viewLoaded=%s, this.m_UIPopulated=%s", this.m_cardsLoaded, this.m_viewLoaded, this.m_UIPopulated );

        if( this.m_cardsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            info( "CardFusionSelection._populateUI Populating UI" );
            var i, length, sortOptions;

            this.m_UIPopulated = true;
            if( this.m_settingMaterialCard )
            {
                // Save the initial state of materials cards. For cancel.
                this.m_materialCardsInititalState = CardsManager.getFusionMaterialCards();
            }

            // Show ComboBox
            sortOptions = CardsManager.getSortOptions();

            length = sortOptions.length;
            for( i = 0; i < length; i++ )
            {
                if( !this.m_settingMaterialCard )
                {
                    if( sortOptions[i].text == "fusion_sort_filter_overall_high" )
                    {
                        sortOptions[i].selected = true;
                    }
                    else
                    {
                        sortOptions[i].selected = false;
                    }
                }

                sortOptions[i].callback = function( option )
                {
                    info( "CardFusionSelection._populateUI.sortSelectedCallback called. option=%s", JSON.stringify( option ) );
                    var sortBy = option.id;
                    var sortType = ( option.invert != undefined ) ? option.invert : false;

                    this.m_sortBy =
                    {
                        "value": sortBy,
                        "invert": sortType
                    };

                    this._setFilteredAndSortedCards();
                    this._refreshTable();
                }.bind( this, sortOptions[i] );
            }

            // Adding the comboBox to the comboBoxView
            this.m_comboBox = new ComboBox( sortOptions, this.comboBoxView );

            this._refreshSpecificsValues();
            this._refreshTable();
        }
    },

    // Called when the selection menu is opened
    _getUserCards: function()
    {
        info( "CardFusionSelection._getUserCards called." );

        this.m_sortBy =
        {
            "value": "overall",
            "invert": false
        };

        if( !this.m_settingMaterialCard )
        {
            this.m_sortBy =
            {
                "value": "overall",
                "invert": true
            };
        }

        this._setFilteredAndSortedCards();

        // Table Cells
        this.m_elementCell = [];
        this.m_cardsLoaded = true;

        this._populateUI();
    },

    // Called when the selection menu is opened, when a new filter is applied or
    // when the list is sorted
    _setFilteredAndSortedCards: function()
    {
        // Reset lists
        if( this.m_cardList != undefined )
        {
            this.m_cardList.length = 0;
        }
        this.m_cardList = null;
        this.m_cardDictionary = null;
        this.m_pageNumber = 0;

        var playerCards;

        if( TutorialManager.getActiveStateId() != undefined )
        {
            playerCards =
            {};
            var cardInstance1 = CardsManager.getPlayerCardById( 19 );
            var cardInstance2 = CardsManager.getPlayerCardById( 20 );
            playerCards.list = [ cardInstance1, cardInstance2 ];
            playerCards.dictionary =
            {
                "19": cardInstance1,
                "20": cardInstance2
            };
            /*
             * playerCards.list = [ { "id":12, "definitionId":11000461, "xp":0, "locked":true, "lockedStatus":"DECK" },{ "id":13, "definitionId":11000461, "xp":0, "locked":true, "lockedStatus":"DECK" } ];
             * playerCards.dictionary = [ { "12":{ "id":12, "definitionId":11000461, "xp":0, "locked":true, "lockedStatus":"DECK" }, "13":{ "id":13, "definitionId":11000461, "xp":0, "locked":true,
             * "lockedStatus":"DECK" } } ];
             */
        }
        else
        {
            // Prepare the filter
            var filters =
            {
                "type": this.m_cardType,
                "locked": this.m_inDeck
            };
            if( this.m_inDeck === true )
            {
                // FIXME: Harcoded
                filters.lockedStatus = "DECK";
            }

            info( this.classname + "._setFilteredAndSortedCards filters=" + JSON.stringify( filters ) );
            info( this.classname + "._setFilteredAndSortedCards this.m_sortBy=" + JSON.stringify( this.m_sortBy ) );
            // Obtain the filtered and sorted card list
            var unSortedPlayerCards = CardsManager.getFilteredCards( filters );
            playerCards = CardsManager.getPlayerCardDictionary( "id" /* dictKey */, this.m_sortBy/* sortBy */, unSortedPlayerCards );
        }

        info( this.classname + "._setFilteredAndSortedCards playerCards=" + JSON.stringify( playerCards ) );

        // Save the list and the dictionary
        this.m_cardList = playerCards.list;
        this.m_cardDictionary = playerCards.dictionary;

        // For materialCards: Remove the base card from the list and from the dictionary
        if( this.m_settingMaterialCard )
        {
            var i;
            var length = this.m_cardList.length;
            var baseInstanceId = CardsManager.getFusionBaseCard();
            for( i = 0; i < length; i++ )
            {
                var cardInfo = this.m_cardList[i];
                if( cardInfo.id == baseInstanceId )
                {
                    this.m_cardList.splice( i, 1 );
                    break;
                }
            }
            delete ( this.m_cardDictionary[baseInstanceId] );
        }

        // Recalculate the number of pages
        this.setPageNumber( this.m_cardList.length );
    },

    /** CardFusionCell methods * */
    // @@Overwrite
    selectButtonClicked: function( opt, /* Xib.Button */inSender )
    {
    },

    /** Back to the fusion menu * */
    _backToMenu: function()
    {
        // Back to the Menu, the card image will be showed after loading
        // We have to give it the dictionary, because it only will have the
        // instanceIds from the cardManager.
        // With the dictionary the menu can get the definitions ids and show the
        // right images.
        var func = function()
        {
            var cardFusionMenu = new CardFusionMenu( this.m_cardType );
            Xib.Navigation.resetScreenStackTo( cardFusionMenu, false );
        }.bind( this );
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    /** Return the number of items in the list * */
    _getNumberOfListItems: function()
    {
        var length;
        if( this.m_pageNumber == this.m_maxPageNumber - 1 )
        {
            length = this.m_cardList.length - this.m_pageNumber * this.m_maxCellNumber;
        }
        else
        {
            length = this.m_maxCellNumber;
        }

        return length;
    },

    /** Method to create and modify all cells * */
    _setCell: function( index, cardIndex )
    {
        if( !this.m_settingMaterialCard )
        {
            this.m_elementCell[index] = new CardFusionCell( this._getViewAtIndex( index ), this.m_cardList[cardIndex], this.m_settingMaterialCard );
        }
        else
        {
            this.m_elementCell[index] = new CardFusionMaterialCell( this._getViewAtIndex( index ), this.m_cardList[cardIndex], this.m_settingMaterialCard );
        }
        this.m_elementCell[index].selectButtonClicked = this.selectButtonClicked.bind( this );
    },

    // @@Overwrite
    _refreshSpecificsValues: function()
    {
        info( "CardFusionSelection._refreshSpecificsValues called." );

    },

    destroy: function( $super )
    {
        this._destroyed = true;
        if( this.m_comboBox != undefined )
        {
            this.m_comboBox.destroy();
        }

        $super();
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionMaterialSelection'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionMaterialSelection'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionMaterialSelection'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionMaterialSelection.js';

exports.CardFusionMaterialSelection = CardFusionSelection.subclass(
{
    classname: 'CardFusionMaterialSelection',

    m_selectedImage: "sale_cardframe_selected.png",
    m_unSelectedImage: "sale_cardframe_unselected.png",

    initialize: function( $super, type )
    {
        this.m_cellsOffsetY = 0.7 - 1.8;
        this.m_rarityOption = -1;

        this.m_settingMaterialCard = true;
        this.m_inDeck = false;
        this.m_xib = "./Content/Xib/CardFusionMaterialSelection.xib";

        $super( type );
        this.m_maxCellNumber = 12;
        this.m_numberOfColumns = 3;
        this.m_cardsLoaded = true;
        this._getUserCards();
    },

    viewDidLoad: function( $super )
    {
        info( "CardFusionSelection.viewDidLoad called." );
        var backFunction = this.moveToMenu.bind( this, null, true );

        ScreenManager.setBackInfo( backFunction );
        $super();

        if( TutorialManager.getActiveStateId() != undefined )
        {
            TutorialManager.setButtonAsUnblocked( this.button_accept_top );
            TutorialManager.setButtonAsUnblocked( this.button_accept_bottom );
            // this.button_recommendedCard.setEnabled( true );
        }

        var typeData =
        {
            "selected":
            {
                "image": "sale_button_sell.png",
                "textColor": FONT_COLOR.white,
                "text": _loc( "fusion_use_no_cards_button" ),
                "alpha": 0.35,
                "textAlpha": 1
            },
            "unselected":
            {
                "image": "sale_button_sell.png",
                "textColor": FONT_COLOR.white,
                "text": _loc( "fusion_use_selected_button" ),
                "alpha": 1,
                "textAlpha": 1
            }
        };

        this.button_accept_top.setStateData( typeData, this.label_accept_top );
        this.button_accept_bottom.setStateData( typeData, this.label_accept_bottom );

        this._setAcceptButtonState();
    },

    _populateUI: function( $super )
    {
        $super();
    },
    // @@Overwrite
    selectButtonClicked: function( opt, button )
    {
        if( opt.cardInstanceId == undefined )
        {
            return;
        }

        var cardInstanceId = opt.cardInstanceId;

        // If the card is not already selected
        if( !button.materialCard )
        {
            // Check if we can select more cards
            if( CardsManager.getFusionMaterialCards().length == CardsManager.getMaxMaterialCardsNumber() )
            {
                var popUp = new PopUp( 1, PopUp.ALERT, _loc( "card_fusion_no_more_material_title" ), _loc( "card_fusion_no_more_material_description" ), null, _loc( "fusion_ok_button" ) );
                Xib.Navigation.removeModalOverlay();
                Xib.Navigation.setModalOverlay( popUp );
                return;
            }

            // Check the user currency
            var cost = CardsManager.getFusionCost( false /* no items */) + CardsManager.getFusionCostByCard( this.m_cardDictionary[opt.cardInstanceId] );
            if( cost > User.getCurrency() )
            {
                var popUp = new PopUp( 1, PopUp.ALERT, _loc( "card_fusion_no_gp_title" ), _loc( "card_fusion_no_gp_description" ), null, _loc( "fusion_ok_button" ) );
                Xib.Navigation.removeModalOverlay();
                Xib.Navigation.setModalOverlay( popUp );
                return;
            }

            // Add it to the materials cards
            var position = CardsManager.setFusionMaterialCard( cardInstanceId );
            // If the card was added
            if( position != -1 )
            {
                button.m_background.setImage( this.m_selectedImage );
                button.materialCard = true;
            }

        }
        // If the card is selected
        else
        {
            // Remove it from the material cards
            CardsManager.removeFusionMaterialCard( cardInstanceId );
            button.m_background.setImage( this.m_unSelectedImage );
            button.materialCard = false;
        }

        this._setAcceptButtonState();
    },

    clearClick: function()
    {
        CardsManager.setFusionMaterialCards( [] );
        this._setAcceptButtonState();
        this._refreshTable();
    },

    _setAcceptButtonState: function()
    {
        // Accept buttons state
        var materialLength = CardsManager.getFusionMaterialCards().length;

        this.button_accept_top.setEnabled( materialLength );
        this.button_accept_bottom.setEnabled( materialLength );
    },

    /** CardFusionCell methods * */
    moveToMenu: function( /* Xib.Button */inSender, cancel )
    {
        // If cancel
        if( cancel )
        {
            // If we are setting materials cards, we have to reset them to the initial state
            if( this.m_settingMaterialCard )
            {
                CardsManager.setFusionMaterialCards( this.m_materialCardsInititalState.clone() );
            }
            // Don't change images
        }

        // Accept (and we know that we are setting materials cards)
        else
        {
            // We do not need the card list backup
            if( this.m_materialCardsInititalState )
            {
                this.m_materialCardsInititalState.length = 0;
            }
            this.m_materialCardsInititalState = null;

            if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MATERIAL_SELECTION )
            {
                TutorialManager.completeActiveState();
                TutorialManager.executeActiveStateAction();
            }
        }

        this._backToMenu();
    },

    autoSelect: function( button )
    {
        info( "CardFusionMaterialSelection.autoSelect" );

        CardsManager.setFusionMaterialCards( [] );
        var maxMaterialCards = CardsManager.getMaxMaterialCardsNumber();
        var rarity;

        var cost = CardsManager.getFusionCost( false /* no items */);
        var userCurrency = User.getCurrency();
        var materialCards = [];
        var i;
        var materialLength = 0;
        length = this._getNumberOfListItems();

        // Draw cards
        for( rarity = RARITY.COMMON; rarity <= RARITY.UNCOMMON; rarity++ )
        {
            for( i = 0; i < length; i++ )
            {
                var cardIndex = ( this.m_pageNumber * this.m_maxCellNumber ) + i;

                var card = this.m_cardList[cardIndex];
                cardInfo = CardsManager.getCardDefinition( card.definitionId );

                if( cardInfo.rarity == rarity )
                {
                    var cardCost = CardsManager.getFusionCostByCard( card );
                    cardCost = Math.floor( cardCost / 10 );
                    cardCost = cardCost * 10;
                    cost = cost + cardCost;

                    if( cost <= userCurrency )
                    {
                        materialLength++;
                        materialCards.push( card.id );
                    }
                }

                if( materialLength >= maxMaterialCards )
                {
                    break;
                }
            }

            if( materialLength >= maxMaterialCards )
            {
                break;
            }
        }

        CardsManager.setFusionMaterialCards( materialCards );

        this._setAcceptButtonState();
        this._refreshTable();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionBaseSelection'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionBaseSelection'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionBaseSelection'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionBaseSelection.js';

exports.CardFusionBaseSelection = CardFusionSelection.subclass(
{
    classname: 'CardFusionBaseSelection',

    initialize: function( $super, type )
    {
        info( "CardFusionBaseSelection.initialize called." );

        this.m_cellsOffsetY = 0.2;
        this.m_cardOrigin =
        {
            "_x": 0,
            "_y": 0
        };
        this.m_settingMaterialCard = false;

        // Always clear the card fusion
        CardsManager.clearFusion();
        this.m_inDeck = true;
        this.m_settingMaterialCard = false;
        this.m_xib = "./Content/Xib/CardFusionBaseSelection.xib";

        // Not called from fusion menu
        if( type == undefined )
        {
            this.m_refreshCards = true;
        }
        
        //Called from fusion menu
        else
        {
            this.m_refreshCards = false;
        }
        
        $super( type );
    },

    viewDidLoad: function( $super )
    {
        this._clippingUpdate();
        this.frame_recommendedCard.spinnerOn();
        this._setButtonStates();
        // Update when the scroll is moved
        this.view_scroller.setUpdateFunction( this._clippingUpdate.bind( this ) );

        var backFunction = function()
        {
            var func = function()
            {
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );

        $super();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( FUSION_SCREEN );

        if( TutorialManager.getActiveStateId() != undefined )
        {
            TutorialManager.setButtonAsUnblocked( this.button_recommendedCard );
            this.button_recommendedCard.setEnabled( true );
        }
    },

    _setButtonStates: function()
    {
        if( TutorialManager.getActiveStateId() == undefined )
        {
            var typeData =
            {
                "selected":
                {
                    "image": "fusion_big_tab_selected.png",
                    "textColor": FONT_COLOR.white
                },
                "unselected":
                {
                    "image": "fusion_big_tab_unselected.png",
                    "textColor": FONT_COLOR.white
                }
            };

            var deckData =
            {
                "selected":
                {
                    "image": "fusion_small_tab_selected.png",
                    "textColor": FONT_COLOR.white
                },
                "unselected":
                {
                    "image": "fusion_small_tab_unselected.png",
                    "textColor": FONT_COLOR.white
                }
            };

            this.button_weapon.setStateData( typeData, this.label_weapon );
            this.button_fighter.setStateData( typeData, this.label_fighter );

            this.button_inDeck.setStateData( deckData, this.label_inDeck );
            this.button_notInDeck.setStateData( deckData, this.label_notInDeck );
        }
    },

    // Clipping, scaling and positioning
    _clippingUpdate: function()
    {
        if( !this.m_settingMaterialCard )
        {
            imageClipping( this.view_recommendedCard, this.frame_recommendedCard, this.m_cardOrigin );
        }
    },

    _refreshTable: function( $super, pageChanged )
    {
        $super( pageChanged );
        this._clippingUpdate();
    },

    _setCardType: function( type )
    {
        info( "CardFusionBaseSelection._setCardType called. type=%s", type );
        this.m_cardType = type;

        this._setFilteredAndSortedCards();
        this._refreshSpecificsValues();
        this._refreshTable();
    },

    deckTabClicked: function( button )
    {
        var rightButton = false;

        if( button == this.button_inDeck )
        {
            rightButton = true;
            this.m_inDeck = true;
            this.button_inDeck.setEnabled( 0 );
            this.button_notInDeck.setEnabled( 1 );
            info( "CardFusionSelector.deckTabClicked: InDeck" );
        }

        if( button == this.button_notInDeck )
        {
            rightButton = true;
            this.m_inDeck = false;
            this.button_inDeck.setEnabled( 1 );
            this.button_notInDeck.setEnabled( 0 );
            info( "CardFusionSelector.deckTabClicked: NotInDeck" );
        }
        if( rightButton )
        {
            this._setFilteredAndSortedCards();
            this._refreshTable();
        }

    },

    typeTabClicked: function( button )
    {
        info( "CardFusionBaseSelector.typeTabClicked called." );
        if( button == this.button_weapon )
        {
            info( "CardFusionBaseSelector.typeTabClicked button=button_weapon" );
            this._setCardType( this.m_type1 );
        }
        else if( button == this.button_fighter )
        {
            info( "CardFusionBaseSelector.typeTabClicked button=button_fighter" );
            this._setCardType( this.m_type2 );
        }
        else
        {
            err( "CardFusionBaseSelector.typeTabClicked Error, button not recognized !" );
        }
    },

    // @@Overwrite
    selectButtonClicked: function( opt, button )
    {
        if( opt.cardInstanceId == undefined )
        {
            return;
        }

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSION_SELECTION )
        {
            TutorialManager.completeActiveState();
            TutorialManager.executeActiveStateAction();
        }

        var cardInstanceId = opt.cardInstanceId;
        // Set the card as the base card
        CardsManager.setFusionBaseCard( cardInstanceId );
        this._backToMenu();
    },

    // @@Overwrite
    // Set specificValues of the baseCard
    _refreshSpecificsValues: function()
    {
        info( "CardFusionBaseSelection._refreshSpecificsValues called." );
        this.button_inDeck.setEnabled( !this.m_inDeck );
        this.button_notInDeck.setEnabled( this.m_inDeck );

        this.button_weapon.setEnabled( this.m_cardType != this.m_type1 );
        this.button_fighter.setEnabled( this.m_cardType != this.m_type2 );

        this._refreshRecommendedCard();
    },

    _refreshRecommendedCard: function()
    {
        info( "CardFusionBaseSelection._refreshRecommendedCard called. this.m_cardDictionary=%s", JSON.stringify( this.m_cardDictionary ) );

        this.view_recommendedCard.setImage( "1pxalpha0.png" );

        var cardInstanceId;

        if( TutorialManager.getActiveStateId() != undefined )
        {
            cardInstanceId = 19;
        }
        else
        {
            cardInstanceId = CardsManager.getFusionRecommendedCard( this.m_cardType );
        }

        if( cardInstanceId != null )
        {
            var cardDictionary = CardsManager.getPlayerCardById( cardInstanceId );
            if( cardDictionary != undefined )
            {
                cardInfo = CardsManager.getCardDefinition( cardDictionary.definitionId );

                this.frame_recommendedCard.spinnerOn();
                CardsManager.loadCardImage( cardDictionary.definitionId, IMAGE_SIZE.BIGGEST, function( imageURL )
                {
                    if( this.view_recommendedCard._destroyed )
                    {
                        return;
                    }
                    this.frame_recommendedCard.spinnerOff();
                    this.view_recommendedCard.setImage( imageURL );

                    // Offset to draw the image
                    this.m_cardOrigin = CardsManager.getAreaOfInterestWide( cardDictionary.definitionId );
                    this._clippingUpdate();

                }.bind( this ) );

                // The same than CardFusionCell._setButtonsState()
                this.button_recommendedCard.cardInstanceId = cardInstanceId;
                this.button_recommendedCard.setEnabled( 1 );

                // FIXME: We can show more information using CardsManager.getInformation(cardDefinitionId);
            }
        }

        else
        {
            // We don't have a base recommended card to show
            this.label_level.setText( "" );
            this.button_recommendedCard.setEnabled( 0 );
            this.button_recommendedCard.cardInstanceId = null;
        }
    },

    viewWillAppear: function()
    {
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( FUSION_SCREEN );
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionCell'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionCell'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionCell.js';

exports.CardFusionCell = XibUI.subclass(
{
    classname: 'CardFusionCell',

    // TODO FIXME Move this vriables to the constructor ! Here they are static!
    m_selectedMessage: "fusion_selected",
    m_unSelectedMessage: "fusion_select",
    m_selectedImage: "fusion_button_selected.png",
    m_unSelectedImage: "fusion_button_unselected.png",
    m_blockedImage: "fusion_button_locked.png",

    initialize: function( obj, cardInstance, settingMaterialCard )
    {
        info( "CardFusionCell.initialize called. cardDict=%s, settingMaterialCard=%s", JSON.stringify( cardInstance ), JSON.stringify( settingMaterialCard ) );

        this.m_progressBar = null;
        this.label_stats = [];
        this.label_statsValues = [];
        this.m_callback = null;

        this.m_settingMaterialCard = settingMaterialCard;
        this.m_cardsInstance = cardInstance;
        this.m_obj = obj;
        this._setVariables();

        if( this.m_settingMaterialCard && TutorialManager.getActiveStateId() != undefined )
        {
            TutorialManager.setButtonAsUnblocked( this.button_select );
            this.button_select.setEnabled( true );
        }

        this._setStatsArray();
        this._setValues();
    },

    _setVariables: function()
    {

        this.view_card = this.m_obj.nodeWithTag( 13 );
        this.button_select = this.m_obj.nodeWithTag( 3 );

        this.label_level = this.m_obj.nodeWithTag( 15 );
        this.label_maxLevel = this.m_obj.nodeWithTag( 16 );
        this.button_details = this.m_obj.nodeWithTag( 18 );
        this.label_rarity = this.m_obj.nodeWithTag( 2 );
        this.label_description = this.m_obj.nodeWithTag( 1 );

        this.label_stats1 = this.m_obj.nodeWithTag( 7 );
        this.label_stats2 = this.m_obj.nodeWithTag( 9 );
        this.label_stats3 = this.m_obj.nodeWithTag( 11 );
        this.label_stats1Value = this.m_obj.nodeWithTag( 8 );
        this.label_stats2Value = this.m_obj.nodeWithTag( 10 );
        this.label_stats3Value = this.m_obj.nodeWithTag( 12 );
        this.progressBar = this.m_obj.nodeWithTag( 6 );

        this.recBg = this.m_obj.nodeWithTag( 20 );
        this.recLabel = this.m_obj.nodeWithTag( 21 );

        var typeData =
        {
            "selected":
            {},
            "unselected":
            {}
        };

        this.button_select.setStateData( typeData );

        var callback = sprintf( "selectButtonClicked.bind(this._target, {cardInstanceId: %d})", this.m_cardsInstance.id );
        this.button_select.setTargetAction( this, callback );

        var callback2 = "detailsCalled.bind(this._target, {})";
        this.button_details.setTargetAction( this, callback2 );
        
        this.button_select.setEnabled(1);
        this.button_details.setEnabled(1);
    },

    // Defined from CardFusionSelection
    selectButtonClicked: function( opt, inSender )
    {

    },

    setDictionary: function( cardDict )
    {
        this.m_cardsInstance = cardDict;
        this._setValues();
    },

    _setValues: function()
    {
        this._setInformation();
        this._drawCard();
        this._setButtonsState();
    },

    _setStatsArray: function()
    {
        this.label_stats[0] = this.label_stats1;
        this.label_statsValues[0] = this.label_stats1Value;
        this.label_statsValues[0].setHorizontalAlign( GL2.Text.HorizontalAlign.Left );

        this.label_stats[1] = this.label_stats2;
        this.label_statsValues[1] = this.label_stats2Value;
        this.label_statsValues[1].setHorizontalAlign( GL2.Text.HorizontalAlign.Left );

        this.label_stats[2] = this.label_stats3;
        this.label_statsValues[2] = this.label_stats3Value;
        this.label_statsValues[2].setHorizontalAlign( GL2.Text.HorizontalAlign.Left );
    },

    _setMaterialCard: function()
    {
        this.button_select.setText( _loc( this.m_selectedMessage ) );
        this.button_select.setImage( this.m_selectedImage );
        this.button_select.materialCard = true;

        // FIXME: Now is only for baseCards
        /*
         * // We can not choose a material card as a base card if( !this.m_settingMaterialCard ) { this.button_select.setEnabled( 0 ); } // We can remove a card from the material cards list else
         * this.button_select.setEnabled( 1 );
         */
    },

    _setBaseCard: function()
    {
        // A base card is always blocked
        this.button_select.setText( "" );
        this.button_select.setImage( this.m_blockedImage );
        this.button_select.setEnabled( 0 );
        this.button_select.baseCard = true;
    },

    _setRecommendedCard: function()
    {
        this.recBg.setAlpha( 1 );
        this.recLabel.setAlpha( 1 );
        this.button_select.setEnabled( 0 );
        this.button_select.setText( "" );
        this.button_select.setImage( this.m_blockedImage );
    },

    _setNormalCard: function()
    {
        this.button_select.materialCard = false;
        this.button_select.baseCard = false;
        this.button_select.setText( _loc( this.m_unSelectedMessage ) );
        this.button_select.setImage( this.m_unSelectedImage );
        this.button_select.setEnabled( 1 );
        this.recBg.setAlpha( 0 );
        this.recLabel.setAlpha( 0 );
        // FIXME: Now is only for base cards
        /*
         * // If we have the max number of materials selected, we can not select more if( CardsManager.getFusionMaterialCards().length == CardsManager.getMaxMaterialCardsNumber() &&
         * this.m_settingMaterialCard ) { this.button_select.setEnabled( 0 ); } // But we can select a base card else { this.button_select.setEnabled( 1 ); }
         */
    },

    _setInformation: function()
    {
        // Ask for the card info using the card id
        var cardInfo = CardsManager.getCardDefinition( this.m_cardsInstance.definitionId );
        if( cardInfo != undefined )
        {
            // Set the exp bar
            this._setExp();

            // Set some card values
            this.label_level.setText( CardsManager.getCardLevel( this.m_cardsInstance ) );
            this.label_maxLevel.setText( _loc( "fusion_max_level" ) + " " + cardInfo.maxLevel );
            this.label_rarity.setText( _loc( RARITY_TEXT[cardInfo.rarity] ) );

            var i = 0;
            var cardStatus = CardsManager.getCardStatus( this.m_cardsInstance );
            for( key in cardStatus )
            {
                var val = cardStatus[key];
                this.label_stats[i].setText( _loc( STATUS_DEFINITION[key] ) );

                if( cardInfo.type == PILOT )
                {
                    this.label_statsValues[i].setText( ( Math.floor( val * 100 ) ) + "%" );
                }
                else
                {
                    this.label_statsValues[i].setText( val );
                }

                i++;
            }

            this.label_description.setText( _loc( cardInfo.name ) );
        }
    },

    _setExp: function()
    {
        var exp = CardsManager.getXpPercentage( this.m_cardsInstance );

        if( this.m_progressBar == undefined )
        {
            this.m_progressBar = new ProgressBar( "./Content/Xib/ProgressBar.xib", exp, this.progressBar.getFrame() );
            this.progressBar.addChild( this.m_progressBar.getView() );
        }
        else
        {
            this.m_progressBar.updateProgress( exp );
        }

    },

    _drawCard: function()
    {
        this.view_card.setImage( "1pxalpha0.png" );
        if( this.m_cardsInstance.definitionId != undefined )
        {
            this.view_card.spinnerOn();
            CardsManager.loadCardImage( this.m_cardsInstance.definitionId, IMAGE_SIZE.BIG, function( imageURL )
            {
                if( this.view_card._destroyed )
                {
                    return;
                }
                this.view_card.spinnerOff();
                this.view_card.setImage( imageURL );
            }.bind( this ) );
        }
        else
        {
            this.m_callback();
        }
    },

    _setButtonsState: function()
    {
        // Add the card id as a property of the button
        this.button_select.cardInstanceId = this.m_cardsInstance.id;
        // Set the button normal state
        this._setNormalCard();

        var baseCardInstanceId = CardsManager.getFusionBaseCard();

        // If the card is the base card
        if( baseCardInstanceId == this.m_cardsInstance.id )
        {
            this._setBaseCard();
            return;
        }

        if( this.m_cardsInstance.id == CardsManager.getFusionRecommendedCard() )
        {
            this._setRecommendedCard();
            return;
        }
        // FIXME: Only for baseCard
        // var materialCardsInstanceIds = CardsManager.getFusionMaterialCards();

        // If the card is a material card
        // var i;
        // var length = materialCardsInstanceIds.length;
        // for( i = 0; i < length; i++ )
        // {
        // if( materialCardsInstanceIds[i] == this.m_cardsInstance.id )
        // {
        // this._setMaterialCard();
        // break;
        // }
        // }
    },

    detailsCalled: function()
    {
        var cardDetailMenu = new CardScreenInstance( this.m_cardsInstance.id, null, "Pop" );
        Xib.Navigation.pushViewController( cardDetailMenu, false );
    },

    destroy: function()
    {
        if( this.m_progressBar != undefined )
        {
            info( "CardFusionCell.destroy" );
            this.m_progressBar.destroy();
            this.m_progressBar = null;
            
            this.button_select.setEnabled(0);
            this.button_details.setEnabled(0);
        }
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardFusionMaterialCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardFusionMaterialCell'] || {}; $MODULE_REGISTRY['Code/UI/CardFusionMaterialCell'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardFusionMaterialCell.js';

exports.CardFusionMaterialCell = XibUI.subclass(
{
    classname: 'CardFusionMaterialCell',

    // TODO FIXME Move this vriables to the constructor ! Here they are static!
    m_obj: null,
    m_cardsInstance: null,
    m_settingMaterialCard: null,
    m_selectedImage: "sale_cardframe_selected.png",
    m_unSelectedImage: "sale_cardframe_unselected.png",
    m_callback: null,

    initialize: function( obj, cardInstance, settingMaterialCard )
    {
        info( "CardFusionCell.initialize called. cardDict=%s, settingMaterialCard=%s", JSON.stringify( cardInstance ), JSON.stringify( settingMaterialCard ) );

        this.m_settingMaterialCard = settingMaterialCard;
        this.m_cardsInstance = cardInstance;
        this.m_obj = obj;
        this._setVariables();

        if( this.m_settingMaterialCard && TutorialManager.getActiveStateId() != undefined )
        {
            TutorialManager.setButtonAsUnblocked( this.button_select );
            this.button_select.setEnabled( true );
        }

        this._setValues();
    },

    _setVariables: function()
    {

        this.view_card = this.m_obj.nodeWithTag( 9002 );
        this.button_select = this.m_obj.nodeWithTag( 9005 );
        this.background = this.m_obj.nodeWithTag( 9001 );
        this.label_level = this.m_obj.nodeWithTag( 9003 );
        this.label_cost = this.m_obj.nodeWithTag( 9004 );

        this.button_select.m_background = this.background;
        var callback = sprintf( "selectButtonClicked.bind(this._target, {cardInstanceId: %d})", this.m_cardsInstance.id );
        this.button_select.setTargetAction( this, callback );

    },

    // Defined from CardFusionSelection
    selectButtonClicked: function( opt, inSender )
    {

    },

    setDictionary: function( cardDict )
    {
        this.m_cardsInstance = cardDict;
        this._setValues();
    },

    _setValues: function()
    {
        this._setInformation();
        this._drawCard();
        this._setButtonsState();
    },

    _setMaterialCard: function()
    {
        // this.button_select.setText( _loc(this.m_selectedMessage) );
        this.button_select.m_background.setImage( this.m_selectedImage );
        this.button_select.materialCard = true;
    },

    _setNormalCard: function()
    {
        this.button_select.materialCard = false;
        this.button_select.baseCard = false;
        // this.button_select.setText( _loc(this.m_unSelectedMessage) );
        this.button_select.m_background.setImage( this.m_unSelectedImage );
    },

    _setInformation: function()
    {
        // Ask for the card info using the card id
        var cardInfo = CardsManager.getCardDefinition( this.m_cardsInstance.definitionId );
        if( cardInfo != undefined )
        {
            // Set some card values
            var level = CardsManager.getCardLevel( this.m_cardsInstance );
            var maxLevel = cardInfo.maxLevel;
            this.label_level.setText( level + "/" + maxLevel );
            
            var cost = CardsManager.getFusionCostByCard( this.m_cardsInstance );
            cost = Math.floor( cost / 10 );
            cost = cost * 10;
            this.label_cost.setText(cost);
        }
    },

    _drawCard: function()
    {
        this.view_card.setImage( "1pxalpha0.png" );
        if( this.m_cardsInstance.definitionId != undefined )
        {
            this.view_card.spinnerOn();
            CardsManager.loadCardImage( this.m_cardsInstance.definitionId, IMAGE_SIZE.BIG, function( imageURL )
            {
                if( this.view_card._destroyed )
                {
                    return;
                }
                this.view_card.spinnerOff();
                this.view_card.setImage( imageURL );
            }.bind( this ) );
        }
        else
        {
            this.m_callback();
        }
    },

    _setButtonsState: function()
    {
        // Add the card id as a property of the button
        this.button_select.cardInstanceId = this.m_cardsInstance.id;
        // Set the button normal state
        this._setNormalCard();

        var baseCardInstanceId = CardsManager.getFusionBaseCard();
        var materialCardsInstanceIds = CardsManager.getFusionMaterialCards();

        // If the card is the base card
        if( baseCardInstanceId == this.m_cardsInstance.id )
        {
            this._setBaseCard();
            return;
        }

        // If the card is a material card
        var i;
        var materialLength = materialCardsInstanceIds.length;
        for( i = 0; i < materialLength; i++ )
        {
            if( materialCardsInstanceIds[i] == this.m_cardsInstance.id )
            {
                this._setMaterialCard();
                break;
            }
        }
        
    },

    detailsCalled: function()
    {
        var cardDetailMenu = new CardScreenInstance( this.m_cardsInstance.id, null, "Pop" );
        Xib.Navigation.pushViewController( cardDetailMenu, false );
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ComboBoxTable'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ComboBoxTable'] || {}; $MODULE_REGISTRY['Code/UI/ComboBoxTable'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ComboBoxTable.js';

exports.ComboBoxTable = XibUI.subclass(
{
    classname: 'ComboBoxTable',

    m_options: null,
    m_showingOptions: false,
    m_width: 0,
    m_height: 0,
    m_originX: 0,
    m_originY: 0,
    m_parent: null,
    m_callback: null,
    m_showClip: null,
    m_hideClip: null,

    // FIXME: button and index to store values. It is not the best way
    m_lastButtonSelected: null,
    m_lastSelectedIndex: null,
    m_defaultButton: null,

    m_defaultText: null,
    // FIXME: Image or color to selected cells
    m_normalButtonImage: "popup_body.png",
    m_selectedButtonImage: "Textures/1pxorange.png",
    m_selectedImage: "cbox_selected.png",
    m_normalImage: "cbox_unselected.png",

    m_loaded: false,
    m_onShowCallback: null,

    /**
     * 
     * @param options: [ {
     *            "text": "button1 text", "callback": funtion(){...}, ... }, { "text": "button2 text", "callback": funtion(){...}, ... },
     * 
     * ... ]
     * 
     * @param parent:GL2.Node
     *            where the combobox will be added after loading
     */
    initialize: function( options, parent, callback )
    {
        info( "ComboBoxTable.initialize called." );

        this.m_options = options;
        this.m_parent = parent;
        this.m_callback = callback;
        // Table Cells
        this.m_optionListLength = options.length;
        this.m_optionCells = [];

        this.initWithXib( "./Content/Xib/ComboBoxTable.xib", false );

        this.loadView();
    },

    setOnShowCallback: function( onShowCallback )
    {
        this.m_onShowCallback = onShowCallback;
    },

    viewDidLoad: function()
    {
        info( "ComboBoxTable.viewDidLoad called." );

        var view = this.getView();
        this.m_parent.addChild( view );
        view.setDepth( 9999999999 );

        // view.setPosition(0,0);

        // Options Table
        if( this.table )
        {
            info( "ComboBoxTable.viewDidLoad this.ComboBoxTable exists" );
            view.setFrame( new Core.Rect( 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT ) );
            var myFrame = this.view_table.getFrame();

            this.m_height = myFrame._size._height;
            this.m_width = myFrame._size._width;
            // Anchor is in (0.5, 0.5)
            this.m_originX = -this.m_width / 2;
            this.m_originY = -this.m_height / 2;

            this.table.setCellXib( "Content/Xib/ComboBoxCell.xib" );
            this.table.refresh();

            // this.m_callback(this);

            this.m_showClip = new Core.Rect( this.m_originX, this.m_originY, this.m_width, this.m_height );
            this.m_hideClip = new Core.Rect( this.m_originX, this.m_originY + this.m_height, this.m_width, 0 );

            // Hide the table
            this.view_table.setClipRectEnabled( true );
            this.view_table.setClipRect2( this.m_hideClip );
            
            
            //Clipp cells
            var cellsFrame = this.view_cells.getFrame();

            var cellsHeight = cellsFrame._size._height;
            var cellsWidth = cellsFrame._size._width;
            // Anchor is in (0.5, 0.5)
            var cellsOriginX = -cellsWidth / 2;
            var cellsOriginY = -cellsHeight / 2;
            
            var cellsClipRect = new Core.Rect( cellsOriginX, cellsOriginY, cellsWidth, cellsHeight );
            this.view_cells.setClipRectEnabled( true );
            this.view_cells.setClipRect2( cellsClipRect );
        }

        this.m_loaded = true;
    },

    // Privated Method to show or hide the comboBox list
    showOptions: function()
    {
        info( "ComboBoxTable._showOptions called. this.m_showingOptions=%s", this.m_showingOptions );

        if( this.m_showingOptions )
        {
            // Hide the list
            this.view_table.runAction( Action.ClipTo.actionWithDuration( 0.4, this.m_hideClip ) );
            this.m_showingOptions = false;
        }
        else
        {
            // Show the list
            this.view_table.runAction( Action.ClipTo.actionWithDuration( 0.4, this.m_showClip ) );
            this.m_showingOptions = true;
            
            if( typeof ( this.m_onShowCallback ) == "function" )
            {
                this.m_onShowCallback();
            }
        }
    },
    
    hide: function()
    {
        this.view_table.setClipRect2( this.m_hideClip );
        this.m_showingOptions = false;
    },

    /** ComboBoxCell methods * */
    // Method called when the user selects an option
    selectOption: function( /* Xib.Button */inSender, avoidShowing )
    {
        info( "ComboBoxTable.selectOption called" );
        if( inSender.optionJSON != undefined && typeof ( inSender.optionJSON.callback ) == "function" )
        {

            this._setSelectedCell( inSender );

            if( avoidShowing === true )
            {
                return;
            }

            // Call the user method for that option
            inSender.optionJSON.callback();
        }

        // Hide the comboBox list
        this.showOptions();

    },

    numberOfListItems: function( /** Xib.ListView */ list )
    {
//        info( "ComboBoxTable.myDataSource.numberOfListItems called." );
        return this.m_optionListLength;
    },

    createListEntryAtIndex: function( /** Xib.ListView */
    inList, /** integer */
    index, /** Object */
    obj )
    {
//        info( "ComboBoxTable.myDataSource.createListEntryAtIndex called. index=%d", index );
        // Set the option text in the cell
        obj.label_option.setText( _loc( this.m_options[index].text ) );

        // Set the JSON. It is used in the function selectOption
        obj.button_option.optionJSON = this.m_options[index];
        obj.button_option.optionIndex = index;

        if( this.m_lastSelectedIndex == undefined )
        {
            if( this.m_options[index].selected == true )
            {
                // Set the default option
                this.m_defaultButton = obj.button_option;
                this._setSelectedCell( this.m_defaultButton );
            }
            else
            {
                obj.button_option.setImage( this.m_normalImage );
            }
        }
        else
        {
            if( this.m_lastSelectedIndex == index )
            {
                obj.button_option.setImage( this.m_selectedImage );
            }
            else
            {
                obj.button_option.setImage( this.m_normalImage );
            }
        }
    },

    reset: function( val )
    {
        // this.button_control.setEnabled(val);
        info( "ComboBoxTable.reset val=%s", val );

        if( this.m_defaultButton != undefined )
        {
            // Set default Values
            this._setSelectedCell( this.m_defaultButton );
            this.m_lastButtonSelected = null;
            this.m_lastSelectedIndex = null;
            this.table.scrollToRowIndex( 0 );
            this.table.hardRefresh();

            // Hide the table
            this.view_table.setClipRect2( this.m_hideClip );
            this.m_showingOptions = false;
        }
    },

    isLoaded: function()
    {
        return this.m_loaded;
    },

    _setSelectedCell: function( button )
    {
        if( this.m_lastButtonSelected != button )
        {
            // Change BackgroundButton
            button.setImage( this.m_selectedImage );
            if( this.m_lastButtonSelected != undefined )
            {
                this.m_lastButtonSelected.setImage( this.m_normalImage );
            }
            this.m_lastButtonSelected = button;
            this.m_lastSelectedIndex = button.optionIndex;

            // Show the option
            this.label_option.setText( _loc( button.optionJSON.text ) );
        }
    },
    
    getSelectedInfo     : function()
    {
        if( this.m_lastSelectedIndex != null )
        {
            return this.m_options[this.m_lastSelectedIndex];
        }
        else
        {
            return null;
        }
    },

    destroy: function( $super )
    {
        this.view_table.stopAllActions();
        $super();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ComboBox'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ComboBox'] || {}; $MODULE_REGISTRY['Code/UI/ComboBox'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ComboBox.js';

exports.ComboBox = XibUI.subclass(
{
    classname: 'ComboBoxTable',

    m_options: null,
    m_parent: null,
    m_onShowCallback : null,
    /**
     * Usage Example:
     * 
     * 
     * var i, sortOptionList, sortOptionsTexts, comboBox; sortOptionList = []; sortOptionsTexts = ['option 1', 'option 2', 'option 3'];
     * 
     * for( i = 0; i < sortOptionsTexts.length; i++ ) { var sortOption = { "text": sortOptionsTexts[i], "value": i };
     * 
     * if( i == 0 ) { sortOption.selected = true; }
     * 
     * sortOption.callback = function( option ) { console.log("ComboBox: sortOption.callback called. option=" + JSON.stringify( option ) ); }.bind( this, sortOption );
     * 
     * sortOptionList.push( sortOption ); } // Adding the comboBox to the comboBoxView comboBox = new ComboBox( sortOptionList, this.viewWhereComboBoxWillBeDisplayed );
     * 
     */

    m_table: null,

    /**
     * 
     * @param options: [ {
     *            "text": "button1 text", "callback": funtion(){...}, "selected": true... }, { "text": "button2 text", "callback": funtion(){...}, ... },
     * 
     * ... ]
     * 
     * @param parent:GL2.Node
     *            where the combobox will be added after loading
     */
    initialize: function( options, parent )
    {
        this.m_options = options;
        this.m_parent = parent;
        // Table Cells
        this.m_optionListLength = options.length;
        this.m_optionCells = [];

        this.initWithXib( "./Content/Xib/ComboBox.xib", false );

        this.loadView();
    },

    viewDidLoad: function()
    {
        info( "ComboBox.viewDidLoad called: " );

        var view = this.getView();
        this.m_parent.addChild( view );
        view.setFrame( this.m_parent.getFrame() );
        view.setPosition( 0, 0 );

        this.m_table = new ComboBoxTable( this.m_options, GL2.Root );
        this.m_table.label_option = this.label_option;
        
        this.m_table.setOnShowCallback(this.m_onShowCallback);
    },

    // Show or hide the comboBox list
    showOptions: function( /* Xib.Button */inSender )
    {
        info( "ComboBox.showOptions called" );
        this.m_table.showOptions();
    },

    hide: function()
    {
        if( this.m_table != undefined )
        {
            this.m_table.hide();
        }
    },

    setOnShowCallback: function( onShowCallback )
    {
        
        this.m_onShowCallback = onShowCallback;
        if( this.m_table != undefined )
        {
            this.m_table.setOnShowCallback(onShowCallback);
        }
    },
    
    isLoaded: function()
    {
        if( this.m_table != undefined )
        {
            return this.m_table.isLoaded();
        }
        else
        {
            return false;
        }
    },

    reset: function()
    {
        // this.button_control.setEnabled(val);
        info( "ComboBox.reset called." );
        this.m_table.reset();

        // this.m_table.destroy();
        // this.m_table.setEnabled2( val );
    },

    destroy: function()
    {
        if( this.m_table )
        {
            this.m_table.destroy();
        }
        this.m_table = null;
    },
    
    getSelectedInfo     : function()
    {
        return this.m_table.getSelectedInfo();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/LoadingScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/LoadingScreen'] || {}; $MODULE_REGISTRY['Code/UI/LoadingScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/LoadingScreen.js';

exports.LoadingScreen       = XibUI.subclass
({
    classname               : "LoadingScreen",

    initialize              : function()
    {
        this.m_actualProgress       = 0;

        this.m_progressBar  = new ProgressBar("./Content/Xib/ProgressBarLoadingScreen.xib", 1);
        this.initWithXib("./Content/Xib/LoadingScreen.xib", false);

        this.m_allLoaded    = false;
    },

    viewDidLoad             : function()
    {
        info("LoadingScreen.viewDidLoad called.");

        this.progressBar.addChild(this.m_progressBar.getView());

        this.m_allLoaded    = true;
    },

    updateActualProgressBar : function(newProgress)
    {
        this.m_actualProgress       = newProgress;

        if(this.m_allLoaded)
        {
            this.m_progressBar.updateProgress(newProgress/100);
        }
    },

    pushProgressBar         : function()
    {
        this.m_actualProgress       = 0;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/GashaStore'] = function(){var exports = $MODULE_REGISTRY['Code/UI/GashaStore'] || {}; $MODULE_REGISTRY['Code/UI/GashaStore'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/GashaStore.js';

exports.GashaStore = ScrollableView.subclass(
{
    classname : "GashaStore",

    NORMAL_STORE : 0,
    SPECIAL_STORE : 1,
    MEDALS_STORE : 2,

    m_views : {}, // NOTE this is a dictionary, not an array
    m_numViews : 3,

    m_viewLoaded : false,
    m_UIPopulated : false,

    GASHA_VIEW : 0,
    PREMIUM_GASHA : 1,
    MEDALS_VIEW : 2,

    TAB_SELECTED_IMAGE: "gasha_tab_selected.png",
    TAB_NOT_SELECTED_IMAGE: "gasha_tab_unselected.png",

    NORMAL_TAB: 0,
    PREMIUM_TAB: 1,
    MEDALS_TAB: 2,

    ALPHA_DISABLED: 0.5,

    TOTAL_MEDAL_CONTAINERS : 10,
    TOTAL_GASHA_CONTAINERS: 5,

    m_baseScrollDelta : 0,
    m_selectedGroup : 0,
    m_lastMedalContainerPos : new Core.Point(0,0),
    m_selectedTab : -1,

    BANNER_ASSETS:
    {
        "medal_1" : "gasha_tag_bronze.png",
        "medal_2" : "gasha_tag_bronze.png",
        "medal_3" : "gasha_tag_silver.png",
        "medal_4" : "gasha_tag_welcome.png"
    },

    initialize : function( $super, startingTab )
    {
        info( "GashaStore.initialize called." );
        $super();

        this.m_productList          = ProductHandler.getStoreProductList();
        this.m_specialProductList   = [];
        this.m_buyButtons           = [];

        this.m_currentElementsList  = this.m_productList;

        this.currentStore           = this.NORMAL_STORE;

        this._startingTab = startingTab;

        this.m_packs =
            [
				{
					"id" : 1,
					"name": "pack_name_1",
					"description": "pack_description_1",
					"gashaType": "2",
					"packType": "free",
					"value": 0,
					"currency": "",
					"img": "card_pack_gear_200.jpg"
				},
				{
					"id" : 2,
					"name": "pack_name_2",
					"description": "pack_description_2",
					"gashaType": "1",
					"packType": "free",
					"value": 0,
					"currency": "",
					"img": "card_pack_pilots_200.jpg"
				},
                {
                    "id" : 2,
                    "name": "pack_name_3",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                },
                {
                    "id" : 1,
                    "name": "pack_name_4",
                    "description": "pack_description_1",
                    "gashaType": "2",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_gear_200.jpg"
                },
                {
                    "id" : 2,
                    "name": "pack_name_5",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                },
                {
                    "id" : 2,
                    "name": "pack_name_6",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                },

                {
                    "id" : 2,
                    "name": "pack_name_2",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                },
                {
                    "id" : 2,
                    "name": "pack_name_3",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                },
                {
                    "id" : 1,
                    "name": "pack_name_4",
                    "description": "pack_description_1",
                    "gashaType": "2",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_gear_200.jpg"
                },
                {
                    "id" : 2,
                    "name": "pack_name_5",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                },
                {
                    "id" : 2,
                    "name": "pack_name_6",
                    "description": "pack_description_2",
                    "gashaType": "1",
                    "packType": "free",
                    "value": 0,
                    "currency": "",
                    "img": "card_pack_pilots_200.jpg"
                }
            ];

        this.initWithXib( "./Content/Xib/GashaStore.xib", true );

        this.m_packs = GashaManager.getUserAvailableMedals();
    },

    showNormalGashaContainers: function()
    {
        var data = GashaManager.getNormalGashaData();
    },

    viewDidLoad : function( $super )
    {
        info( "GashaStore.viewDidLoad called." );
        $super();

        var screen, backFunction;

        this._mapViews();

        this._mapElements( this.GASHA_VIEW );
        this._mapElements( this.MEDALS_VIEW );

        this._mapActions();


        this.m_viewLoaded = true;
        this._populateUI();

        this.m_lastMedalContainerPos = this.m_views[this.MEDALS_VIEW]._containers[0].getPosition();

        //this.baseScrollSize = new Core.Rect();
        //this.updateScroll(this.NORMAL_STORE);

        backFunction = function()
        {
            screen = new ControlRoom();
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );
        ScreenManager.setBackInfo( backFunction );

        this.setMobaBalanceVisibility( false );

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(GASHA_SCREEN);

        this.updatePagingButtonsStatus();
    },

    resetScroll: function()
    {
        this.expandFrame({'_top' : 0, '_bottom' : 0, '_bottomContent' : -this.m_baseScrollDelta });
    },

    updateScroll: function( screen, increase )
    {
        this.resetScroll();
        switch( screen )
        {
            case this.MEDALS_TAB:
                this.m_baseScrollDelta = increase;
                this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : increase } );
                this.moveButtons();
            break;

            default:
            this.m_baseScrollDelta = increase;
                this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : increase } );
            break;
        }
        this.updatePagingButtonsStatus();
    },

    moveButtons: function()
    {
        var increase = this.pagButtonPrev.getFrame().getSize().getHeight();
        this.m_baseScrollDelta += increase;

        var containerSize = this.m_views[this.MEDALS_VIEW]._containers[0].getFrame().getSize();

        this.currentPageLabel.setPosition(this.currentPageLabel.getPosition().getX(),
            this.m_lastMedalContainerPos.getY() + containerSize.getHeight() - increase * 1.5);

        this.pagButtonPrev.setPosition(this.pagButtonPrev.getPosition().getX(),
            this.m_lastMedalContainerPos.getY() + containerSize.getHeight() - increase * 1.5);

        this.pagButtonNext.setPosition(this.pagButtonNext.getPosition().getX(),
            this.m_lastMedalContainerPos.getY() + containerSize.getHeight() - increase * 1.5);

        this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : increase } );
    },

    destroy : function()
    {
        this.setMobaBalanceVisibility( false );
    },

    showContainers: function()
    {
        for (var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
            this.m_views[this.MEDALS_VIEW]._containers[i].setVisible(true);
    },

    fillMedalsInfo: function()
    {
        var onMedalImageLoaded = function( image, imageURL, medalId )
        {
            info("GashaStore.fillMedalsInfo.onMedalImageLoaded called... imageURL: " + imageURL + ", medalId: " + medalId );
            if( image == null )
            {
                return;
            }
            if( image._medalId != medalId )
            {
                return;
            }
            image.spinnerOff();
            image.setImage( imageURL );
        };
        for (var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
        {
            if (i == this.m_packs.length) break;
            if ((i + (10 * this.m_selectedGroup)) >= this.m_packs.length) break;

            var medalData = GashaManager.getDataForMedal(this.m_packs[i + (10 * this.m_selectedGroup)].currency);
            var container = this.m_views[this.MEDALS_VIEW]._containers[i];
            container._medalName.setText(_loc(this.m_packs[i + (10 * this.m_selectedGroup)].name));
            container._medalTypeLabel.setText(_loc(this.m_packs[i + (10 * this.m_selectedGroup)].currency));
            container._medalType.setImage(this.BANNER_ASSETS[this.m_packs[i + (10 * this.m_selectedGroup)].currency]);
            /*this.loadImage(this.m_packs[i + (10 * this.m_selectedGroup)].id,
                container._medalImage.setImage).bind(this);*/
            container._medalImage._medalId = this.m_packs[i + (10 * this.m_selectedGroup)].currency;
            container._medalImage.spinnerOn();
            GashaManager.loadMedalImage( this.m_packs[i + (10 * this.m_selectedGroup)].currency, onMedalImageLoaded.bind( this, container._medalImage ) );
            container._medalAmountLabel.setText(User.getMedalAmount(this.m_packs[i + (10 * this.m_selectedGroup)].currency));
            //container._useMultiButton.setEnabled(false)
            //container._useMultiButton.setEnabled(false);
            //container._useOneButton.setEnabled(false);
            if (medalData[0].value * 2 > User.getMedalAmount(this.m_packs[i + (10 * this.m_selectedGroup)].currency))
            {
                container._useMultiButton.setEnabled(false);
                container._useMultiButton.setAlpha(this.ALPHA_DISABLED);
            }
            else
            {
                container._useMultiButton.setEnabled(true);
            }

            if (User.getMedalAmount(this.m_packs[i + (10 * this.m_selectedGroup)].currency) > 0)
            {
                container._useOneButton.setEnabled(true);
            }


        }
    },

    loadMedalImage: function( card, cb )
    {
        var imageURL = id + "_medal.jpg";

        info( "GashaStore.loadMedalImage imageURL=%s.", imageURL );

        var wrap = function( imageURL )
        {
            cb( imageURL );
        }.bind( this, imageURL );
        ResourceManager.preLoadResource( imageURL, wrap );
    },

    hideAllContainers: function()
    {
        for (var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
        {
            if (i < this.TOTAL_GASHA_CONTAINERS)
                this.m_views[this.GASHA_VIEW]._containers[i].setVisible(false);
            this.m_views[this.MEDALS_VIEW]._containers[i].setVisible(false);
        }
    },

    showAllMedalContainers: function()
    {
        for (var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
        {
            this.m_views[this.MEDALS_VIEW]._containers[i].setVisible(true);
        }
    },

    // @override
    _populateUI : function()
    {
        info( "GashaStore._populateUI called." );
        this.hideAllContainers();

        if (!GashaManager.m_promoReady)
        {
            setTimeout(this._populateUI.bind(this), 100);
            return;
        }
        else if( this.m_viewLoaded && !this.m_UIPopulated)
        {
            Xib.Navigation.removeModalOverlay();
            this.m_UIPopulated = true;

            switch (this._startingTab)
            {
                case this.NORMAL_TAB:
                    this.refreshFreeGashaButtons();
                    this.selectTab( this.NORMAL_TAB );
                    break;

                case this.MEDALS_VIEW:
                    this.goToMedalsScreen();
                    break;

                case this.PREMIUM_TAB:
                    this.selectTab( this.PREMIUM_TAB );
                    break;
            }

            this.fillMedalsInfo();


            // TODO premiumTab is disabled
            //this.setEnableButton( this.xib_buttonGoPremium, false );

            // TODO MultiGasha button is disabled
            this.setEnableMultiGashaButton( this.GASHA_VIEW, false );
        }
    },

    _mapViews : function()
    {
        info( "GashaStore._mapViews called." );

        this.m_views[this.GASHA_VIEW]  = { "_view" : this.xib_viewGasha };
        this.m_views[this.MEDALS_VIEW]  = { "_view" : this.xib_viewMedals };
    },

    prevMedalSet: function()
    {
        if (this.m_selectedGroup == 0) return;

        this.showContainers();
        this.m_selectedGroup --;
        this.fillMedalsInfo();
        this.selectTab(this.MEDALS_TAB, this.hideMedalsView());
        this.scrollToTop();
    },

    nextMedalSet: function()
    {
        if ((this.m_selectedGroup + 1) >= this.m_packs.length / ( this.TOTAL_MEDAL_CONTAINERS )) return;

        this.showContainers();
        this.m_selectedGroup ++;
        this.fillMedalsInfo();
        this.selectTab(this.MEDALS_TAB, this.hideMedalsView());
        this.scrollToTop();
    },

    updatePagingButtonsStatus: function()
    {
        var currentPage = this.m_selectedGroup;
        if (Math.ceil(this.m_packs.length / ( this.TOTAL_MEDAL_CONTAINERS )) == 0)
            currentPage -= 1;

        this.currentPageLabel.setText((currentPage + 1) + "/" + Math.ceil(this.m_packs.length / ( this.TOTAL_MEDAL_CONTAINERS )));

        if (this.m_selectedGroup == 0)
        {
            this.pagButtonPrev.setEnabled(false);
            this.pagButtonPrev.setAlpha( this.ALPHA_DISABLED );
        }

        else
        {
            this.pagButtonPrev.setEnabled(true);
            this.pagButtonPrev.setAlpha( 1 );
        }

        if ((this.m_selectedGroup + 1) >= this.m_packs.length / ( this.TOTAL_MEDAL_CONTAINERS ))
        {
            this.pagButtonNext.setEnabled(false);
            this.pagButtonNext.setAlpha( this.ALPHA_DISABLED );
        }

        else
        {
            this.pagButtonNext.setEnabled(true);
            this.pagButtonNext.setAlpha( 1 );
        }
    },

    _mapElements : function( viewIndex )
    {
        info( "GashaStore._mapElements called. viewIndex=%s, this.m_views.length=%s", viewIndex, this.m_views.length );

        var view = this.m_views[viewIndex];

        if( view == undefined || view._view == undefined )
        {
            err( "GashaStore._mapElements Error, view not found! viewIndex=%s", viewIndex );
            return;
        }

        if ( viewIndex == this.MEDALS_VIEW )
        {
            var containers = [];
            for ( var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++ )
            {
                var container = eval(sprintf("this.medalContainer_%d", i));

                container._medalName        = container.nodeWithTag( 6001 );
                container._medalTypeLabel   = container.nodeWithTag( 6002 );
                container._medalImage       = container.nodeWithTag( 6003 );
                container._medalType        = container.nodeWithTag( 6004 );
                container._useMultiButton   = container.nodeWithTag( 6005 );
                container._useOneButton     = container.nodeWithTag( 6006 );
                container._medalAmountLabel = container.nodeWithTag( 6007 );

                container._useOneButton.setEnabled(false);
                container._useMultiButton.setEnabled(false);

                containers.push(container);
            }
            view._containers = containers;
            return;
        }

        var containers = [];
        for (var i = 0; i < this.TOTAL_GASHA_CONTAINERS; i++)
        {
            var container = eval(sprintf("this.gashaContainer_%d", i));
            container._topLabel                 = container.nodeWithTag( 4001 );
            container._descriptionLabel         = container.nodeWithTag( 4002 );
            container._boldDescriptionLabel     = container.nodeWithTag( 4003 );
            container._cardImage                = container.nodeWithTag( 4004 );

            container._premiumBuyGashaButton    = container.nodeWithTag( 4006 );
            container._premiumBuyGashaLabel     = container.nodeWithTag( 4007 );

            container._normalGashaButton        = container.nodeWithTag( 4011 );
            container._normalGashaLabel         = container.nodeWithTag( 4020 );

            container._normalMultiGashaButton   = container.nodeWithTag( 4010 );
            container._normalMultiGashaLabel    = container.nodeWithTag( 4021 );

            container._currentCurrencyAmount    = container.nodeWithTag( 4012 );
            container._priceAmount              = container.nodeWithTag( 4013 );

            container._costImage                = container.nodeWithTag( 4015 );
            container._amountImage              = container.nodeWithTag( 4016 );

            container._saleImage                = container.nodeWithTag( 4017 )

            containers.push(container);
        }
        view._containers = containers;
    },

    // TODO map buttons and card.
    _mapActions : function()
    {
        info( "GashaStore._mapActions called. this.m_views.length=%s", this.m_views.length );

        for (var i = 0; i < this.TOTAL_GASHA_CONTAINERS; i++)
        {
            var freeGashaButton = this.m_views[this.GASHA_VIEW]._containers[i]._normalGashaButton;
            var callbackFreeGasha = sprintf( "_buttonClicked.bind(this._target, {'button':%d, 'type':%s})", i, "'single'" );
            freeGashaButton.setTargetAction( this, callbackFreeGasha );

            var multiGashaButton = this.m_views[this.GASHA_VIEW]._containers[i]._normalMultiGashaButton;
            var callbackMultiGasha = sprintf( "_buttonClicked.bind(this._target, {'button':%d, 'type':%s})", i, "'multi'" );
            multiGashaButton.setTargetAction( this, callbackMultiGasha );

            var premiumGashaButton = this.m_views[this.GASHA_VIEW]._containers[i]._premiumBuyGashaButton;
            var callbackPremiumGasha = sprintf( "_buttonClicked.bind(this._target, {'button':%d, 'type':%s})", i, "'premium'" );
            premiumGashaButton.setTargetAction( this, callbackPremiumGasha );
        }

        for (i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
        {
            var multibutton = this.m_views[this.MEDALS_VIEW]._containers[i]._useMultiButton;
            var onebutton = this.m_views[this.MEDALS_VIEW]._containers[i]._useOneButton;

            var callback = sprintf( "useMultiMedal.bind(this._target, {'button':%d, 'type':%s})", i, "'single'" );
            multibutton.setTargetAction( this, callback );

            callback = sprintf( "useOneMedal.bind(this._target, {'button':%d, 'type':%s})", i, "'multi'" );
            onebutton.setTargetAction( this, callback );
        }
    },

    useMultiMedal: function(opts)
    {
        info("GashaStore.useMultiMedal called for container " + opts.button + " and medal id " + this.m_packs[opts.button + (10 * this.m_selectedGroup)].id);
        GashaManager.runGasha(this.m_packs[opts.button + (10 * this.m_selectedGroup)].id, "multi");
    },

    useOneMedal: function(opts)
    {
        info("GashaStore.useOneMedal called for container " + opts.button + " and medal id " + this.m_packs[opts.button + (10 * this.m_selectedGroup)].id);
        GashaManager.runGasha(this.m_packs[opts.button + (10 * this.m_selectedGroup)].id, "single");
    },

    _buttonClicked: function( opts )
    {
        info( "GashaStore._buttonClicked called. opts=%s", JSON.stringify( opts ) );

        switch(opts.type)
        {
            case "single":
                var data;
                if (User.isGashaAvailable())
                    data = GashaManager.getFreeGashaData();
                else
                {
                    data = GashaManager.getNormalGashaData();
                    data = data[opts.button];
                }
                GashaManager.runGasha(data.id, "single");
                break;

            case "multi":
                var data = GashaManager.getNormalGashaData();
                GashaManager.runGasha(data[opts.button].id, "multi");
                break;

            case "premium":
                var data = GashaManager.getPremiumGashaData();
                //GashaManager.runGasha(data[opts.button].id, "premium");
                this.buyPremiumGasha(data[opts.button].sku, data[opts.button].id);
                break;
        }
/*
        if( opts.button == this.GASHA_VIEW )
        {
            this.getFreeGasha();
        }
        else if( opts.button == this.FIGHTER_VIEW )
        {
            this.getMultiGasha();
        }*/
    },

    refreshFreeGashaButtons : function()
    {
        info( "GashaStore.refreshFreeGashaButtons called");
        var enabled;

        enabled = User.isGashaAvailable();

        info( "GashaStore.refreshFreeGashaButtons... enabled=%s", enabled );

        this.setEnableGashaButton( this.GASHA_VIEW, enabled );
        this.setEnableMultiGashaButton( this.GASHA_VIEW, !enabled );
        this.displayFreeGashaData();
        //this.setEnableGashaButton( this.FIGHTER_VIEW, enabled );

        if (enabled)
        {
            return;
        }

        var normalGashaData = GashaManager.getNormalGashaData();
        enabled = (User.getGashaPoints() > normalGashaData.value * 2)

        this.setEnableGashaButton( this.GASHA_VIEW, !enabled );
        //this.setEnableMultiGashaButton( this.GASHA_VIEW, !enabled );

        this.displayNormalGashaData();
    },

    displayFreeGashaData: function()
    {
        //this.resetScroll();
        //this.refreshFreeGashaButtons()


        var view = this.m_views[this.GASHA_VIEW];
        var data = GashaManager.getFreeGashaData();
        view._containers[0].setVisible(true);
        view._containers[0]._topLabel.setText(_loc(data.name));
        view._containers[0]._descriptionLabel.setText(_loc(data.description));
        view._containers[0]._cardImage.setImage(data.img);

        view._containers[0]._premiumBuyGashaButton.setVisible(false);
        view._containers[0]._premiumBuyGashaButton.setEnabled(false);
        view._containers[0]._premiumBuyGashaLabel.setAlpha(0);

        view._containers[0]._normalGashaLabel.setText(_loc("card_pack_free_pack_button"));
        view._containers[0]._normalMultiGashaButton.setVisible(true);
        view._containers[0]._normalMultiGashaButton.setEnabled(false);
        view._containers[0]._normalMultiGashaLabel.setAlpha(this.ALPHA_DISABLED);

        view._containers[0]._normalGashaButton.setVisible(true);
        view._containers[0]._normalGashaButton.setEnabled(true);
        view._containers[0]._normalGashaLabel.setAlpha(1);

        view._containers[0]._cardImage.setImage("pod_free_200.png");

        view._containers[0]._currentCurrencyAmount.setVisible(false);
        view._containers[0]._currentCurrencyAmount.setAlpha(0);
        view._containers[0]._priceAmount.setVisible(false);
        view._containers[0]._priceAmount.setAlpha(0);
        view._containers[0]._costImage.setVisible(false);
        view._containers[0]._amountImage.setVisible(false);

        for (var i = 1; i < this.TOTAL_GASHA_CONTAINERS; i++)
        {
            this.m_views[this.GASHA_VIEW]._containers[i].setVisible(false);
        }

        view._containers[0]._saleImage.setVisible(false);
        view._containers[0]._saleImage.setAlpha( 0 );

        this.setMobaBalanceVisibility( false );
    },

    displayNormalGashaData: function()
    {
        var view = this.m_views[this.GASHA_VIEW];
        var data = GashaManager.getNormalGashaData();
        var i;
        //this.resetScroll();

        for(i = 0; i < data.length; i++)
        {
            if (i >= this.TOTAL_GASHA_CONTAINERS) break;

            view._containers[i].setVisible(true);
            view._containers[i]._topLabel.setText(_loc(data[i].name));
            view._containers[i]._descriptionLabel.setText(_loc(data[i].description));
            view._containers[i]._cardImage.setImage(data[i].img);

            view._containers[i]._premiumBuyGashaButton.setVisible(false);
            view._containers[i]._premiumBuyGashaButton.setEnabled(false);
            view._containers[i]._premiumBuyGashaLabel.setAlpha(0);

            view._containers[i]._normalGashaLabel.setText(_loc("card_pack_normal_button"));
            view._containers[i]._normalGashaButton.setVisible(true);
            if (User.getGashaPoints() < data[i].value)
            {
                view._containers[i]._normalGashaButton.setEnabled(false);
                view._containers[i]._normalGashaLabel.setAlpha(this.ALPHA_DISABLED);
                view._containers[i]._currentCurrencyAmount.setColor(new Core.Color(1,0,0));
            }
            else
            {
                view._containers[i]._currentCurrencyAmount.setColor(new Core.Color(1,1,1));
                view._containers[i]._normalGashaLabel.setAlpha(1);
                view._containers[i]._normalGashaButton.setEnabled(true);
            }

            if (User.getGashaPoints() < ( data[i].value * 2 ) )
            {
                view._containers[i]._normalMultiGashaButton.setEnabled(false);
                view._containers[i]._normalMultiGashaLabel.setAlpha(this.ALPHA_DISABLED);
            }
            else
            {
                view._containers[i]._normalMultiGashaButton.setEnabled(true);
                view._containers[i]._normalMultiGashaLabel.setAlpha(1);
            }

            view._containers[i]._normalMultiGashaButton.setVisible(true);
            view._containers[i]._cardImage.setImage("pod_normal_200.png");

            view._containers[i]._currentCurrencyAmount.setVisible(true);
            view._containers[i]._currentCurrencyAmount.setAlpha( 1 );
            view._containers[i]._priceAmount.setAlpha( 1 );
            view._containers[i]._priceAmount.setVisible( true );
            view._containers[i]._currentCurrencyAmount.setText(_loc("card_pack_currentpp_amount", User.getGashaPoints()));
            view._containers[i]._priceAmount.setVisible(true);
            view._containers[i]._priceAmount.setText(_loc("card_pack_packpoints_cost", data[i].value));

            view._containers[i]._costImage.setImage("gasha_icon_pp.png");
            view._containers[i]._amountImage.setImage("gasha_icon_pp.png");
            view._containers[i]._amountImage.setVisible(true);
            view._containers[i]._costImage.setVisible(true);

            if (data[i].saleId)
            {
                 view._containers[i]._saleImage.setVisible(true);
                 view._containers[i]._saleImage.setAlpha( 1 );
            }
            else
            {
                view._containers[i]._saleImage.setVisible(false);
                view._containers[i]._saleImage.setAlpha( 0 );
            }

            // MUlti gasha is disabled
            // view._containers[i]._normalMultiGashaButton.setEnabled(false);
        }

        var increase;
        increase = (i - 1) * view._containers[i].getFrame().getSize().getHeight();

        this.updateScroll(this.NORMAL_STORE, increase);

        for (i; i < this.TOTAL_GASHA_CONTAINERS; i++)
        {
            view._containers[i].setVisible(false);
        }

        this.setMobaBalanceVisibility( false );
    },

    displayPremiumGashaData: function()
    {
        var view = this.m_views[this.GASHA_VIEW];
        var data = GashaManager.getPremiumGashaData();
        var i;

        //this.resetScroll();

        for(i = 0; i < data.length; i++)
        {
            if (i >= this.TOTAL_GASHA_CONTAINERS) break;


            view._containers[i].setVisible(true);
            view._containers[i]._topLabel.setText(_loc(data[i].name));
            view._containers[i]._descriptionLabel.setText(_loc(data[i].description));
            view._containers[i]._cardImage.setImage(data[i].img);

            view._containers[i]._premiumBuyGashaButton.setVisible(true);
            view._containers[i]._premiumBuyGashaButton.setEnabled(true);
            view._containers[i]._premiumBuyGashaLabel.setAlpha(1);

            view._containers[i]._normalGashaButton.setVisible(false);
            view._containers[i]._normalGashaButton.setEnabled(false);
            view._containers[i]._normalGashaLabel.setAlpha(0);

            view._containers[i]._normalMultiGashaButton.setVisible(false);
            view._containers[i]._normalMultiGashaButton.setEnabled(false);
            view._containers[i]._normalMultiGashaLabel.setAlpha(0);

            view._containers[i]._currentCurrencyAmount.setVisible(false);
            view._containers[i]._currentCurrencyAmount.setAlpha(0);
            view._containers[i]._priceAmount.setVisible(true);
            view._containers[i]._priceAmount.setAlpha( 1 );
            view._containers[i]._priceAmount.setText(_loc("card_pack_mobacoins_cost", data[i].value));

            view._containers[i]._costImage.setVisible(true);
            view._containers[i]._costImage.setImage("gasha_icon_mc.png");
            view._containers[i]._amountImage.setVisible(false);

            view._containers[i]._cardImage.setImage("pod_premium_200.png");

            if (data[i].saleId && User.m_firstTimePremiumGasha == true)
            {
                 view._containers[i]._saleImage.setVisible(true);
                 view._containers[i]._saleImage.setAlpha( 1 );
            }
            else
            {
                view._containers[i]._saleImage.setVisible(false);
                view._containers[i]._saleImage.setAlpha( 0 );
            }
        }

        var increase;
        increase = (i - 1) * view._containers[i].getFrame().getSize().getHeight();

        increase += this.xib_viewMobaContainer.getFrame().getSize().getHeight();

        this.updateScroll(this.NORMAL_STORE, increase);

        for (i; i < this.TOTAL_GASHA_CONTAINERS; i++)
        {
            view._containers[i].setVisible(false);
        }

        this.setMobaBalanceVisibility( true );
    },

    setEnableMultiGashaButton : function( viewIndex, enabled )
    {
        info( "GashaStore.setEnableMultiGashaButton called. viewIndex=%s, enabled=%s", viewIndex, enabled );

        var view = this.m_views[viewIndex];

        this.setEnableButton( view._normalMultiGashaButton, enabled );
        this.setEnableLabel( view._normalMultiGashaLabel, enabled );
    },

    setEnableGashaButton : function( viewIndex, enabled )
    {
        info( "GashaStore.setEnableGashaButton called. viewIndex=%s, enabled=%s", viewIndex, enabled );

        var view = this.m_views[viewIndex];

        this.setEnableButton( view._normalGashaButton, enabled );
        this.setEnableLabel( view._normalGashaLabel, enabled );
    },

    setEnableLabel: function( element, enabled )
    {
        info( "GashaStore.setEnableLabel called. enabled=%s", enabled );

        if( enabled )
        {
            //element.setAlpha( 1 );
        }
        else
        {
            //element.setAlpha( this.ALPHA_DISABLED );
        }
    },

    setEnableButton: function( element, enabled )
    {
        info( "GashaStore.setEnableButton called. enabled=%s", enabled );

        if( enabled )
        {
            //element.setAlpha( 1 );
        }
        else
        {
            //FIXME We need to disable but not necessarily set alpha to the buttons
            //element.setAlpha( this.ALPHA_DISABLED );
        }
        //element.setEnabled( enabled );
    },

    setShowViewPremiumButton: function( viewIndex, visible )
    {
        info( "GashaStore.setHideViewPremiumButton called. viewIndex=%s, visible=%s", viewIndex, visible );

        var view = this.m_views[viewIndex];
        if( view == undefined )
        {
            err( "GashaStore.setHideViewPremiumButton Error, view is undefined. viewIndex=%s, visible=%s", viewIndex, visible );
            return;
        }

        var enabledDepth = view._cardImage.getDepth() + 1;
        var disabledDepth = enabledDepth - 1000;

        var setEnabledElement = function( element, _visibled )
        {
            if( _visibled )
            {
                element.setAlpha( 1 );
                element.setDepth( enabledDepth );
            }
            else
            {
                element.setAlpha( 0 );
                element.setDepth( disabledDepth );
            }

            if( element.setVisible )
            {
                element.setVisible( _visibled );
            }

            if( element.setEnabled )
            {
                element.setEnabled( _visibled );
            }
        };

        //setEnabledElement( view._premiumBuyGashaButton,   visible );
        //setEnabledElement( view._premiumBuyGashaLabel,    visible );
    },

    selectTab: function( selected, increase )
    {
        info( "GashaStore.selectTab called. selected=%s", selected );

        this.updateScroll(selected, increase);
        
        if( selected == this.NORMAL_TAB )
        {
            this.xib_buttonGoNormal.setImage( this.TAB_SELECTED_IMAGE );
            this.xib_buttonGoPremium.setImage( this.TAB_NOT_SELECTED_IMAGE );
            this.xib_buttonGoMedals.setImage( this.TAB_NOT_SELECTED_IMAGE );

            this.xib_buttonGoNormalLabel.setAlpha( 1 );
            this.xib_buttonGoPremiumLabel.setAlpha( this.ALPHA_DISABLED );
            if (User.isGashaAvailable())
                this.displayFreeGashaData();
            else
                this.displayNormalGashaData();
            this.xib_buttonGoMedalsLabel.setAlpha( this.ALPHA_DISABLED );
            this.disableMedalButtons();

            //this.setShowViewPremiumButton( this.FIGHTER_VIEW, false );
        }
        else if( selected == this.PREMIUM_TAB )
        {
            this.xib_buttonGoNormal.setImage( this.TAB_NOT_SELECTED_IMAGE );
            this.xib_buttonGoMedals.setImage( this.TAB_NOT_SELECTED_IMAGE );
            this.xib_buttonGoPremium.setImage( this.TAB_SELECTED_IMAGE );

            this.xib_buttonGoNormalLabel.setAlpha( this.ALPHA_DISABLED );
            this.xib_buttonGoMedalsLabel.setAlpha( this.ALPHA_DISABLED );
            this.xib_buttonGoPremiumLabel.setAlpha( 1 );

            //this.setShowViewPremiumButton( this.FIGHTER_VIEW, true );
            this.displayPremiumGashaData();
            this.disableMedalButtons();
        }
        else if( selected == this.MEDALS_TAB )
        {
            this.enableMedalButtons();            
            this.xib_buttonGoNormal.setImage( this.TAB_NOT_SELECTED_IMAGE );
            this.xib_buttonGoPremium.setImage( this.TAB_NOT_SELECTED_IMAGE );
            this.xib_buttonGoMedals.setImage( this.TAB_SELECTED_IMAGE );


            this.xib_buttonGoNormalLabel.setAlpha( this.ALPHA_DISABLED );
            this.xib_buttonGoPremiumLabel.setAlpha( this.ALPHA_DISABLED );

            this.xib_buttonGoMedalsLabel.setAlpha( 1 );

            //this.setShowViewPremiumButton( this.FIGHTER_VIEW, false );
            
            this.m_selectedTab = selected;
        }
        else
        {
            err( "GashaStore.selectTab Error, unknown tab: selected=%s", selected );
        }
        this.m_selectedTab = selected;
    },

    buyItem                     : function(sender)
    {
        var index = this.m_buyButtons.indexOf( sender );
        info( "GashaStore.buyItem called. index=%s", index );

        ProductHandler.buyItem( this.m_currentElementsList[index], 1 );
    },

    setMobaBalanceVisibility: function(visible)
    {
        var scale = this.getView().getScale();

        this.xib_viewMobaContainer.setVisible( visible );
        if( visible )
        {
            var socialframe = this.xib_viewMobaContainer.getFrame();
            var sfw = socialframe.getSize().getWidth() * scale._x;
            var sfh = socialframe.getSize().getHeight() * scale._y;

            var sfx = socialframe._origin._x * scale._x;
            var sfy = socialframe._origin._y * scale._y;

            var frame = new UI.ViewGeometry.Rect( sfx, sfy, sfw, sfh );

            info( "GashaStore.setMobaBalanceVisibility. frame=%s", JSON.stringify( frame ) );

            Social.US.Service.ButtonOverlays.showBalanceButton( frame, function()
            {
            } );
        }
        else
        {
            Social.US.Service.ButtonOverlays.hideBalanceButton();
        }
    },

    goToGashaScreen : function( sender )
    {
        info( "GashaStore.goToGashaScreen called." );
        this.selectTab(this.NORMAL_TAB);


        //this.setEnableButton(this.xib_buttonGoNormal, false);
        //this.xib_buttonGoNormal.setEnabled(false);
        //this.setEnableButton(this.xib_buttonGoPremium, false);
        //this.setEnableButton(this.xib_buttonGoMedals, true);

        this.xib_viewGasha.setVisible(true);
        this.xib_viewMedals.setVisible(false);
//        this.normalView.setVisible( true );
//        this.premiumView.setVisible( false );
    },

    goToSpecialGashaScreen : function( sender )
    {
        //this.setEnableButton(this.xib_buttonGoNormal, true);
        //this.setEnableButton(this.xib_buttonGoPremium, false);
        //this.setEnableButton(this.xib_buttonGoMedals, true);
        info( "GashaStore.goToSpecialGashaScreen called." );
//        info( "GashaStore.goToSpecialGashaScreen...blocked for the moment")
//        return;
//        this.normalView.setVisible( false );
//        this.premiumView.setVisible( true );
    },

    hideMedalsView: function()
    {
        var border = 0;
        var multiplier = 0;

        var index = this.TOTAL_MEDAL_CONTAINERS * (this.m_selectedGroup);

        if ((this.m_packs.length - index) >= 10)
        {
            border = this.TOTAL_MEDAL_CONTAINERS;
        }
        else
        {
            border = this.m_packs.length - index;
        }

        if (border > 0)
            this.m_lastMedalContainerPos = this.m_views[this.MEDALS_VIEW]._containers[border - 1].getPosition();

        for (var i = border; i < this.TOTAL_MEDAL_CONTAINERS; i ++)
        {
            this.m_views[this.MEDALS_VIEW]._containers[i].setVisible(false);
            this.m_views[this.MEDALS_VIEW]._containers[i]._useOneButton.setEnabled(false);
            this.m_views[this.MEDALS_VIEW]._containers[i]._useMultiButton.setEnabled(false);
        }

        var containerFrame = this.m_views[this.MEDALS_VIEW]._containers[0].getFrame();

        if (border != 0)
            multiplier = Math.floor( (border - 1)/2 );

        if (border == 0)
        {
            this.noMedalsContainer.setVisible(true);
            this.currentPageLabel.setVisible(false);
            this.pagButtonPrev.setVisible(false);
            this.pagButtonNext.setVisible(false);
        }

        return multiplier * containerFrame.getSize().getHeight();
    },

    goToMedalsScreen: function( sender )
    {
        info( "GashaStore.goToMedalsScreen called." );
        this.showAllMedalContainers();
        this.fillMedalsInfo();
        this.selectTab(this.MEDALS_TAB, this.hideMedalsView());
        this.xib_viewGasha.setVisible(false);
        this.xib_viewMedals.setVisible(true);
        this.setMobaBalanceVisibility( false );
        this.disableNormalButtons();
        this.hideMedalsView();
    },

    disableNormalButtons: function()
    {
        for (var i = 0; i < this.TOTAL_GASHA_CONTAINERS; i++)
        {
            this.m_views[this.GASHA_VIEW]._containers[i]._premiumBuyGashaButton.setEnabled(false);
            this.m_views[this.GASHA_VIEW]._containers[i]._normalGashaButton.setEnabled(false);
            this.m_views[this.GASHA_VIEW]._containers[i]._normalMultiGashaButton.setEnabled(false);

        }
    },

    disableMedalButtons: function()
    {
        for (var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
        {
            this.m_views[this.MEDALS_VIEW]._containers[i]._useMultiButton.setEnabled(false);
            this.m_views[this.MEDALS_VIEW]._containers[i]._useOneButton.setEnabled(false);
        }
    },

    enableMedalButtons: function()
    {
        for (var i = 0; i < this.TOTAL_MEDAL_CONTAINERS; i++)
        {
            this.m_views[this.MEDALS_VIEW]._containers[i]._useMultiButton.setEnabled(true);
            this.m_views[this.MEDALS_VIEW]._containers[i]._useOneButton.setEnabled(true);
        }
    },

    goToPremiumScreen: function( sender )
    {
        this.selectTab(this.PREMIUM_TAB);
        this.xib_viewMedals.setVisible(false);
        this.xib_viewGasha.setVisible(true);
    },

    updateGashaContainersStatus: function()
    {
        if( !User.isGashaAvailable() )
        {
            this.displayNormalGashaData();
            this.setEnableButtonGashaButton(this.GASHA_VIEW, false);
        }
        else
        {
            this.displayFreeGashaData();
            this.setEnableButtonGashaButton(this.GASHA_VIEW, true);
        }
    },

    getFreeGasha              : function(sender)
    {
        info("GashaStore.getFreeGasha called. sender=" + sender);

        this.setEnableGashaButton( this.GASHA_VIEW, false );
        if( !User.isGashaAvailable() )
        {
            return;
        }

        GashaManager.runGasha( GashaManager.getFreeGashaId(), "multi" );

    },

    buyPremiumGasha             : function(sku, id)
    {
        info( "GashaStore.buyPremiumGasha called. sku=%s, id=%s", sku, id );

        if( !NetworkManager.networkAvailable() )
        {
            this.m_popUp = new PopUp(
                1, // numberOfButtons
                PopUp.ALERT, // popUpType
                _loc( "gasha_store_no_network_alert_dlg_title" ),           // title
                _loc( "gasha_store_no_network_alert_dlg_description" ),     // description

                function()                                                  // button1 callback
                {
                }.bind( this ),
                _loc( "gasha_store_no_network_alert_dlg_continue_button" ), // button1 label
                true                                                        // autoDismiss
            );

            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( this.m_popUp );
        }
        else
        {
            var bankTransaction = new PaymentController();
            Xib.Navigation.setModalOverlay( new WaitingScreen( function() {} ) );
            bankTransaction.createSimpleTransaction(sku, "comment", id, this.transactionCreatedCallback.bind(this));
        }
    },

    transactionCreatedCallback: function(packId, transactionId)
    {
        info("GashaStore.transactionCreatedCallback called. packId=%s, transactionId=%s", packId, transactionId );
        GashaManager.runGasha(packId, "single", transactionId, false);
    },

    viewWillAppear: function()
    {
        info( "GashaStore.viewWillAppear called." );

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(GASHA_SCREEN);
        if (this.m_selectedTab == this.PREMIUM_TAB)
            this.setMobaBalanceVisibility( true );
        else
            this.setMobaBalanceVisibility( false );
    },

    viewWillDisappear: function()
    {
        this.setMobaBalanceVisibility( false );
    },

    viewDidAppear: function()
    {
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ExplorationSelection'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ExplorationSelection'] || {}; $MODULE_REGISTRY['Code/UI/ExplorationSelection'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ExplorationSelection.js';

exports.ExplorationSelection = ScrollableView.subclass(
    {
        classname: 'ExplorationSelection',

        m_numViews: 3,

        initialize: function( $super )
        {
            info( "ExplorationSelection.initialize called." );
            this.m_views = [];
            this.m_viewLoaded = false;
            this.m_UIPopulated = false;

            $super();

            this.initWithXib( "./Content/Xib/ExplorationSelection.xib", true );
        },

        viewDidLoad: function( $super )
        {
            info( "ExplorationSelection.viewDidLoad called." );
            $super();

            this.m_viewLoaded = true;
            this._mapViews();
            this._mapElements();
            this._mapActions();
            this._populateUI();
        },


        // @override
        _populateUI: function()
        {
            info( "ExplorationSelection._populateUI called." );

            if( this.m_viewLoaded && !this.m_UIPopulated )
            {
                this.m_UIPopulated = true;
            }
        },

        _mapViews: function()
        {
            info( "ExplorationSelection._mapViews called." );

            for( var i = 0; i < this.m_numViews; i++ )
            {
                var view = eval( sprintf( "this.view_item_%d", i ) );
                this.m_views[i] = { "_view": view };
            }
        },

        _mapElements: function()
        {
            info( "ExplorationSelection._mapElements called. this.m_views.length=%s", this.m_views.length );

            for( var i = 0; i < this.m_views.length; i++ )
            {
                var view = this.m_views[i];

                view._topLabel                  = view._view.nodeWithTag( 5001 );
                view._exploredValueLabel        = view._view.nodeWithTag( 5002 );
                view._cardCollectedValueLabel   = view._view.nodeWithTag( 5003 );
                view._goButton                  = view._view.nodeWithTag( 5004 );
                view._bgImage                   = view._view.nodeWithTag( 5005 );
                view._goButtonLabel             = view._view.nodeWithTag( 5020 );
            }
        },

        _mapActions: function()
        {
            info( "ExplorationSelection._mapActions called. this.m_views.length=%s", this.m_views.length );

            for( var i = 0; i < this.m_views.length; i++ )
            {
                var callback = sprintf( "_buttonClicked.bind(this._target, {'button':%d})", i );

                this.m_views[i]._goButton.setTargetAction( this, callback );
            }
        },

        // @override
        _buttonClicked: function( opts, inSender )
        {
            info( "ExplorationSelection._buttonClicked called. opts=%s", JSON.stringify( opts ) );
        },

//        _updateFrameHeight: function( visibleItems )
//        {
//            var deletedSpace = (
//                this.m_views.length - visibleItems) * 145;
//            info( "ExplorationSelection._updateFrameHeight called. visibleItems=%d, deletedSpace=%d, m_frameHeight(old)=%d, m_frameHeight(new)=%d",
//                visibleItems, deletedSpace, this.m_frameHeight, this.m_frameHeight - deletedSpace );
//
//            this.m_frameHeight += deletedSpace;
//        },

        _setTitleVisible: function( visible )
        {
            info( "ExplorationSelection._setTitleVisible called. visible=%s", visible );
            if( this.view_title && this.view_title.setVisible )
            {
                if( this.view_title.getVisible() != visible )
                {
                    this.view_title.setVisible( visible );

                    var height = this.view_title.getFrame()._size._height;
                    if( visible )
                    {
                        //this.reduceTop( height );
                    }
                    else
                    {
                        //this.reduceTop( -height );
                    }
                }
            }
            else
            {
                err( "ExplorationSelection._setTitleVisible Error, could not set visibility ! visible=%s", JSON.stringify( visible ) );
            }
        },


        _setTitle: function( text )
        {
            if( this.titleLabel && this.titleLabel.setText )
            {
                this.titleLabel.setText( text );
            }
            else
            {
                err( "ExplorationSelection._setTopBannerLabel Error, could not set text ! text=%s", JSON.stringify( text ) );
            }
        },

        _setGoButtonLabel: function( viewIndex, text )
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._goButtonLabel )
            {
                this.m_views[viewIndex]._goButtonLabel.setText( text );
            }
            else
            {
                err( "ExplorationSelection._setGoButtonLabel Error, cannot set _goButtonLabel: viewIndex=%d, text=%s", viewIndex, text );
            }
        },

        _setBgImage: function( viewIndex, image)
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._bgImage )
            {
                this.m_views[viewIndex]._bgImage.setImage( image );
            }
            else
            {
                err( "ExplorationSelection._setTopLabel Error, cannot set _bgImage: viewIndex=%d, image=%s", viewIndex, image );
            }
        },

        _stopBgSpinner: function(viewIndex)
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._bgImage )
            {
                this.m_views[viewIndex]._bgImage.spinnerOff();
            }
            else
            {
                err( "ExplorationSelection._setTopLabel Error, cannot set _bgImage spinner: viewIndex=%d", viewIndex );
            }
        },

        _startBgSpinner: function(viewIndex)
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._bgImage )
            {
                this.m_views[viewIndex]._bgImage.spinnerOn();
            }
            else
            {
                err( "ExplorationSelection._setTopLabel Error, cannot set _bgImage spinner: viewIndex=%d", viewIndex );
            }
        },

        _setTopLabel: function( viewIndex, text )
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._topLabel )
            {
                this.m_views[viewIndex]._topLabel.setText( text );
            }
            else
            {
                err( "ExplorationSelection._setTopLabel Error, cannot set TopLabel: viewIndex=%d, text=%s", viewIndex, text );
            }
        },

        _setCardsCollected: function( viewIndex, text )
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._cardCollectedValueLabel )
            {
                this.m_views[viewIndex]._cardCollectedValueLabel.setText( text );
            }
            else
            {
                err( "ExplorationSelection._setTopLabel Error, cannot set CardCollectedLabel: viewIndex=%d, text=%s", viewIndex, text );
            }
        },

        _setExploredLabel: function( viewIndex, text )
        {
            if( viewIndex < this.m_numViews && this.m_views[viewIndex]._exploredValueLabel )
            {
                this.m_views[viewIndex]._exploredValueLabel.setText( text );
            }
            else
            {
                err( "ExplorationSelection._setExploredLabel Error, cannot set ExploredLabel: viewIndex=%d, text=%s", viewIndex, text );
            }
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ExplorationWorldUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ExplorationWorldUI'] || {}; $MODULE_REGISTRY['Code/UI/ExplorationWorldUI'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ExplorationWorldUI.js';

exports.ExplorationWorldUI = ExplorationSelection.subclass(
    {
        classname: 'ExplorationWorldUI',

        initialize: function( $super )
        {
            info( "ExplorationWorldUI.initialize called." );
            $super();

            this.m_worlds = [];

            var backFunction = function()
            {
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);

            ScreenManager.setBackInfo(backFunction);
        },

        viewDidLoad: function( $super )
        {
            info( "ExplorationWorldUI.viewDidLoad called." );
            $super();
            this._setTitleVisible( true );
            this._setTitle( _loc( "explore_title_world" ) );
            var overlay = Xib.Navigation.getOverlayView();
            overlay.highlightButton(NO_SCREEN);

            this.infoBoxLabel.setText(_loc("exploration_world_info_box"));
        },

        showInfoBox: function()
        {
            this.infoBoxContainer.setVisible(true);
            this.infoBoxContainer.setAlpha( 1 );

            for (var i = 0; i < this.m_views.length; i++)
            {
                this.m_views[i]._view.setPosition(this.m_views[i]._view.getPosition().getX(),
                    this.m_views[i]._view.getPosition().getY() + this.infoBoxContainer.getFrame().getSize().getHeight());
            }
        },

        _populateUI: function()
        {
            info( "ExplorationWorldUI._populateUI called." );

            var worldsKeys, key, i, playerProgress, cardsProgress, roundsProgress;

            if( this.m_viewLoaded && !this.m_UIPopulated )
            {
                this.m_UIPopulated = true;

                worldsKeys = QuestManager.getWorlds();

                this.showInfoBox();

//                this._updateFrameHeight( worldsKeys.length );

                //Removing world 0...only for tutorial
                for( i = 0; i < worldsKeys.length; ++i )
                {
                    if( worldsKeys[0] == "0" )
                    {
                        worldsKeys.splice( i, 1 );
                    }
                }

                for( i = 0; i < this.m_views.length && i < worldsKeys.length; i++ )
                {
                    key             = worldsKeys[i];
                    world           = QuestManager.getWorldData( key );
                    playerProgress  = QuestManager.getPlayerProgressForWorld( world.id );
                    cardsProgress   = Math.round( ( playerProgress.collectedCards / playerProgress.totalCards ) * 100 );
                    roundsProgress  = Math.round( ( playerProgress.completedRounds / playerProgress.numberOfRounds ) * 100 );

                    this.m_worlds[i] = world;

                    this._setGoButtonLabel(     i, _loc("explore_select_world_button" ) );
                    this._setTopLabel(          i, sprintf("[%d] %s", world.id, _loc( world.worldName ) ) );
                    this._setExploredLabel(     i, _loc("explore_stage_progress", roundsProgress ) );
                    this._setCardsCollected(    i, _loc("explore_card_progress", cardsProgress ) );
                    this._startBgSpinner(i);
                    QuestManager.loadBanner(world.id, function(imageURL)
                    {
                        this._stopBgSpinner(i);
                        this._setBgImage(           i, imageURL);
                    }.bind(this));
                }

                for( i = worldsKeys.length; i < this.m_views.length; i++ )
                {
                    this._setTopLabel( i, "--- HIDDEN ---" );
                    this.m_views[i]._view.setAlpha( 0 );
                }
            }
        },

        _buttonClicked: function( opts, inSender )
        {
            info( "ExplorationWorldUI._buttonClicked called. opts=%s", JSON.stringify( opts ) );
            var func =  function()
            {
                var stagesUI = new ExplorationStageUI( this.m_worlds[ opts.button ] );
                Xib.Navigation.pushViewController( stagesUI, true );
            }.bind(this);
            Xib.Navigation.setModalOverlay(new WaitingScreen(func));
        },

        viewDidAppear: function()
        {
            Xib.Navigation.removeModalOverlay();
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ExplorationStageUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ExplorationStageUI'] || {}; $MODULE_REGISTRY['Code/UI/ExplorationStageUI'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ExplorationStageUI.js';

exports.ExplorationStageUI = ExplorationSelection.subclass(
    {
        classname: 'ExplorationStageUI',

        initialize: function( $super, world )
        {
            info( "ExplorationStageUI.initialize called. world.id=%s", JSON.stringify( world.id ) );
            $super();

            this.m_world = world;
            this.m_stages = [];
        },

        viewDidLoad: function( $super )
        {
            info( "ExplorationStageUI.viewDidLoad called." );
            $super();

            var backFunction = function()
            {
                var func = function()
                {
                    var screen = new ExplorationWorldUI();
                    Xib.Navigation.resetScreenStackTo( screen, false );
                }.bind(this);
                Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
            }.bind(this);

            ScreenManager.setBackInfo(backFunction);

            this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : -this.infoBoxContainer.getFrame().getSize().getHeight() } );
        },

        _populateUI: function()
        {
            info( "ExplorationStageUI._populateUI called." );

            var stages, stage, keys, i;

            if( this.m_viewLoaded && !this.m_UIPopulated )
            {
                this.m_UIPopulated = true;

                if( !this.m_world )
                {
                    err( "ExplorationStageUI._populateUI Error, this.m_world is undefined/null ! Returning." );
                    return;
                }

                stages = QuestManager.getAvailableStagesForWorld( this.m_world.id );
                keys = Object.keys( stages );

//                this._updateFrameHeight( keys.length );

                for( i = 0; i < this.m_views.length && i < keys.length; i++ )
                {
                    stage               = stages[ keys[i] ];
                    stage.worldId       = this.m_world.id;
                    this.m_stages[i]    = stage;

                    playerProgress  = QuestManager.getPlayerProgressForStage( this.m_world.id, stage.id );
                    cardsProgress   = Math.round( ( playerProgress.collectedCards / playerProgress.totalCards ) * 100 );
                    roundsProgress  = Math.round( ( playerProgress.completedRounds / playerProgress.numberOfRounds ) * 100 );

                    this._setGoButtonLabel(     i, _loc("explore_select_stage_button" ) );
                    this._setTopLabel(          i, sprintf("[%d-%d] %s", stage.worldId, QuestManager.getFakeStageId(stage.worldId, stage.id), _loc( stage.stageName ) ) );
                    this._setExploredLabel(     i, _loc( "explore_stage_progress", roundsProgress ) );
                    this._setCardsCollected(    i, _loc( "explore_card_progress", cardsProgress ) );
                    this._startBgSpinner(i);
                    QuestManager.loadBanner(stage.worldId, stage.id, function(imageURL)
                    {
                        this._stopBgSpinner(i);
                        this._setBgImage(i, imageURL);
                    }.bind(this));
                }

                var viewHeight = this.m_views[i]._view.getFrame().getSize().getHeight();
                this.expandFrame( { "_bottomContent" : -viewHeight } );

                for( i = keys.length; i < this.m_views.length; i++ )
                {
                    this._setTopLabel( i, "--- HIDDEN ---" );
                    this.m_views[i]._view.setAlpha( 0 );
                    this.m_views[i]._goButton.setEnabled(false);
                }

                this._setTitleVisible( true );
                this._setTitle( _loc( this.m_world.worldName ) );
            }
        },

        _buttonClicked: function( opts, inSender )
        {
            var func = function()
            {
                info( "ExplorationStageUI._buttonClicked called. opts=%s", JSON.stringify( opts ) );
                var stage = this.m_stages[ opts.button ];
                var stagesUI = new MissionSelectionScreen( stage.worldId, stage.id, this.m_world );
                Xib.Navigation.pushViewController( stagesUI, true );
            }.bind(this);

            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        },

        viewDidAppear: function()
        {
            Xib.Navigation.removeModalOverlay();
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ExplorationScreenAnimated'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ExplorationScreenAnimated'] || {}; $MODULE_REGISTRY['Code/UI/ExplorationScreenAnimated'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ExplorationScreenAnimated.js';

exports.ExplorationScreenAnimated = XibUI.subclass(
{
    classname: "ExplorationScreenAnimated",

    initialize: function( data, missionSelectionScreen )
    {
        info( "ExplorationScreenAnimated.initialize data=%s", JSON.stringify( data ) );

        this.m_explorationData = data;

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION || TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION2 )
        {
            GameController.getTutorialScreen().setVisibleBottomFrame( false );
            GameController.getTutorialScreen().setVisibleTopFrame( false );
        }

        this.initWithXib( "./Content/Xib/ExplorationScreenAnimated.xib", true );

        // TODO FIXME TUTORIAL
        QuestManager.m_tutorialRound = 0;

        this.m_backgrounds  = [];
        this.m_sprites      = [];

        this.m_speedFactor  = 5;
        this.m_statBars     = [];

        this.m_targetPosition   = new Core.Point( 0, 0 );
        this.m_target           = new GL2.Sprite();
        this.m_targetAsset      = "explo_scan_searching.png";
        this.m_targetFoundAsset = "explo_scan_founded.png";
        this.m_xFactor = 1;
        this.m_yFactor = 1;

        this.m_rounds   = 0;

        this.m_isLevelUp        = false;
        this.m_missionDone      = false;
        this.m_newMissionDone   = false;
        this.m_returnToScreen   = true;
        this.m_timeoutDelay     = 1000;
        this.m_rewardType       = -1;
        this.m_luckyChanceId    = -1;
        this.m_animation        = null;

        this.m_gifts                        = null;
        this.m_isLevelUpAnimationFinished   = false;
        this.m_areLevelUpGiftsReceived      = false;
        this.m_noMoreFuel                   = false;

        this.m_displayNewCardBanner = false;

        this.m_missionSelectionScreen = missionSelectionScreen;
    },

    viewDidLoad: function()
    {
        info( "ExplorationScreenAnimated.viewDidLoad called." );

        this.showContinueButton( false );
        this.showAcceptCancelButton( false );

        Social.Common.Service.hideCommunityButton();

        var overlayView = Xib.Navigation.getOverlayView();
        overlayView.highlightButton( NO_SCREEN );
        overlayView.setEnabledMenu( 0 );
        ScreenManager.resetCallBack();


        QuestManager.getMissionData( this.m_explorationData.id, function( success, data )
        {
            var missionProgress = 0;
            if( success )
            {
                info( "ExplorationScreenAnimated.viewDidLoad.getMissionData called. data=%s", JSON.stringify( data ) );
                info( "ExplorationScreenAnimated.viewDidLoad.getMissionData worldData=%s", JSON.stringify( QuestManager.getWorldData( data.missionState.worldId ) ) );

                this.worldName.setText( _loc( QuestManager.getWorldData( data.missionState.worldId ).worldName ) );

                missionProgress = data.missionState.progress;

                if( missionProgress == 1 )
                {
                    this.m_missionDone = true;
                }
            }
            this._continueLoading( missionProgress );
        }.bind( this ) );

        var animationWidth  = this.getView().getFrame()._size._width;
        var animationHeight = this.getView().getFrame()._size._height;
        this.m_animation    = new LevelUpAnimation( animationWidth, animationHeight );
        this.m_animation.setDepth( 500 );
        this.getView().addChild( this.m_animation );

        this.stageName.setText( _loc( this.m_explorationData.missionName ) );
        
        SoundManager.setMusicEnabled(true, SoundManager.BG_MUSIC_EXPLORATION);
    },

    viewDidDisappear: function()
    {
        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        }
        
        SoundManager.setMusicEnabled(true, SoundManager.BG_MUSIC_NORMAL);
    },

    _continueLoading: function( missionProgress )
    {
        this.m_hidePosition     = this.xib_lvlUp.getPosition().clone();
        this.m_showPosition     = this.xib_lvlUpFinal.getPosition().clone();
        this.m_middlePosition   = this.xib_lvlUpMiddle.getPosition().clone();

        for( var f = 0; f < 9; f++ )
        {
            this.m_backgrounds[f] = new GL2.Sprite();
            this.explorationView.addChild( this.m_backgrounds[f] );
        }

        this.showContinueButton( false );
        this.showAcceptCancelButton( false );

        this.startParallax();
        this.setParallaxSprites();
        this.setTargetAsset();

        this.m_statBars[0] = new ProgressBar( "./Content/Xib/ExplorationProgressBar.xib", User.getExploreEnergy() / User.getMaxExplorationEnergy(), this.bar1.getFrame(), false, this.setProgressBarFuelColor.bind( this ) );
        this.bar1.addChild( this.m_statBars[0].getView() );

        this.m_statBars[1] = new ProgressBar( "./Content/Xib/ExplorationProgressBar.xib", User.getProgressLevel(), this.bar2.getFrame(), false, this.setProgressBarXPColor.bind( this ) );
        this.bar2.addChild( this.m_statBars[1].getView() );

        this.m_statBars[2] = new ProgressBar( "./Content/Xib/ExplorationProgressBar.xib", missionProgress, this.bar3.getFrame(), false, this.setProgressBarMissionColor.bind( this ) );
        this.bar3.addChild( this.m_statBars[2].getView() );

        this.m_timeout = setTimeout( this.popEvent.bind( this ), this.m_timeoutDelay );
    },

    startParallax: function()
    {
        this.m_parallaxUpdater = new Core.MessageListener();
        Core.UpdateEmitter.addListener( this.m_parallaxUpdater, this.onUpdate.bind( this ) );
    },

    setParallaxSprites: function( sprite1, sprite2, sprite3 )
    {
        if( sprite1 )
        {
            this.m_sprites[0] = sprite1;
        }
        if( sprite2 )
        {
            this.m_sprites[1] = sprite2;
        }
        if( sprite3 )
        {
            this.m_sprites[2] = sprite3;
        }

        if( this.m_parallaxUpdater )
        {
            var expFrame = this.explorationView.getFrame();
            var expView  = this.explorationView;

            for( var i = 0; i < this.m_backgrounds.length; ++i )
            {
                expView.addChild( this.m_backgrounds[i] );

                this.m_backgrounds[i].setFrame( expFrame._origin._x + expFrame._size._width * ( i % 3 ), expFrame._origin._y, expFrame._size._width, expFrame._size._height );
                this.m_backgrounds[i].setImage( this.m_sprites[Math.floor( i / 3 )] );
            }
        }
    },

    setTargetAsset: function( sprite )
    {
        if( sprite )
        {
            this.m_targetAsset = sprite;
        }

        if( this.m_parallaxUpdater )
        {
            this.m_target.setFrame( 0, 0, ResourceManager.getRealSizeFor( this.m_targetAsset ).w / 2, ResourceManager.getRealSizeFor( this.m_targetAsset ).h / 2 );
            this.m_target.setImage( this.m_targetAsset );
            this.pickRandomTarget();
            this.m_target.setPosition( this.m_targetPosition );
            this.pickRandomTarget();
            this.explorationView.addChild( this.m_target );
            this.m_target.setDepth( 10000 );
        }
    },

    pickRandomTarget: function()
    {
        var randomX = Math.floor( ( Math.random() * ( this.explorationView.getFrame()._size._width - 150 ) ) + 1 );
        var randomY = Math.floor( ( Math.random() * ( this.explorationView.getFrame()._size._height - 150 ) ) + 1 );
        this.m_targetPosition.setAll( randomX + 75 - this.explorationView.getFrame()._size._width / 2, randomY + 75 - this.explorationView.getFrame()._size._height / 2 );

        var angle = Math.atan( Math.abs( this.m_targetPosition._y - this.m_target._position._y ) / Math.abs( this.m_targetPosition._x - this.m_target._position._x ) );
        this.m_xFactor = Math.cos( angle );
        this.m_yFactor = Math.sin( angle );
    },

    onUpdate: function()
    {
        // Move scenario
        var realSize = this.explorationView.getFrame().getSize();

        for( var k = 0; k < 3; ++k )
        {
            if( this.m_backgrounds[0 + k * 3]._position._x < -realSize._width )
            {
                var aux = this.m_backgrounds[0 + k * 3];
                this.m_backgrounds[0 + k * 3] = this.m_backgrounds[1 + k * 3];
                this.m_backgrounds[1 + k * 3] = this.m_backgrounds[2 + k * 3];
                this.m_backgrounds[2 + k * 3] = aux;

                this.m_backgrounds[2 + k * 3].setPosition( this.m_backgrounds[1 + k * 3]._position._x + realSize._width, this.m_backgrounds[1 + k * 3]._position._y );
            }

            this.m_backgrounds[0 + k * 3].setPosition( this.m_backgrounds[0 + k * 3]._position._x - ( k + 1 ) * this.m_speedFactor / 3, this.m_backgrounds[0 + k * 3]._position._y );
            this.m_backgrounds[1 + k * 3].setPosition( this.m_backgrounds[1 + k * 3]._position._x - ( k + 1 ) * this.m_speedFactor / 3, this.m_backgrounds[1 + k * 3]._position._y );
            this.m_backgrounds[2 + k * 3].setPosition( this.m_backgrounds[2 + k * 3]._position._x - ( k + 1 ) * this.m_speedFactor / 3, this.m_backgrounds[2 + k * 3]._position._y );
        }

        // Move target
        var increase = 1 * this.m_speedFactor;

        var nextX = this.m_target._position._x;
        var nextY = this.m_target._position._y;

        if( Math.abs( this.m_targetPosition._y - this.m_target._position._y ) < increase * this.m_yFactor || Math.abs( this.m_targetPosition._x - this.m_target._position._x ) < increase * this.m_xFactor )
        {
            this.m_target.setPosition( this.m_targetPosition );
            this.pickRandomTarget();
            return;
        }

        if( nextX > this.m_targetPosition._x )
        {
            nextX -= increase * this.m_xFactor;
        }
        else if( nextX < this.m_targetPosition._x )
        {
            nextX += increase * this.m_xFactor;
        }

        if( nextY > this.m_targetPosition._y )
        {
            nextY -= increase * this.m_yFactor;
        }
        else if( nextY < this.m_targetPosition._y )
        {
            nextY += increase * this.m_yFactor;
        }

        this.m_target.setPosition( nextX, nextY );
    },

    popEvent: function()
    {
        info( "ExplorationScreenAnimated.popEvent called." );

        QuestManager.completeRound( this.m_explorationData.id, this.retrieveActionForPlayer.bind( this ) );
        this.m_targetAction = Action.RepeatForever.actionWithAction( Action.Sequence.actions( Action.CallFunc.actionWithTarget( this, this.alternateTarget.bind( this, false ) ), Action.DelayTime.actionWithDuration( 0.3 ), Action.CallFunc
                .actionWithTarget( this, this.alternateTarget.bind( this, true ) ), Action.DelayTime.actionWithDuration( 0.3 ) ) );
        this.m_target.runAction( this.m_targetAction );
    },

    alternateTarget: function( alternate )
    {
        if( alternate )
        {
            this.m_target.setImage( this.m_targetAsset );
        }
        else
        {
            this.m_target.setImage( this.m_targetFoundAsset );
        }
    },

    retrieveActionForPlayer: function( error, response )
    {
        info( "ExplorationScreenAnimated.retrieveActionForPlayer called. response=%s", response );
        if( error )
        {
            err( "ExplorationScreenAnimated.retrieveActionForPlayer ERROR. error=%s", JSON.stringify( error ) );
            this.areaCleared();
            return;
        }

        var serverData = JSON.parse( response );
        if( serverData.collectionRewards )
        {
            info( "ExplorationScreenAnimated.retrieveActionForPlayer serverData.collectionRewards=%s", JSON.stringify( serverData.collectionRewards ) );

            if( serverData.collectionRewards.rewards && serverData.collectionRewards.lastRewardsByType )
            {
                RewardManager.addReward( serverData.collectionRewards );
            }
        }

        if( serverData && serverData.missionState )
        {
            info( "ExplorationScreenAnimated.retrieveActionForPlayer serverData.missionState=%s", JSON.stringify( serverData.missionState ) );

            User.setExploreEnergy( serverData.energy );
            this.updateProgress( serverData );

            // No more fuel
            if( ( serverData.notEnoughEnergy != undefined && serverData.notEnoughEnergy == true ) || serverData.energy < 0 )
            {
                var func = function()
                {
                    Server.getMissionState(this.m_explorationData.id, function(error, data)
                        {
                            info( "LevelUpLanding.retrieveActionForPlayer.getMissionStat called, missions state: " + JSON.stringify( data ) );
                            if (error)
                            {
                                err("LevelUpLanding.continueAction error from server");
                            }
                            else
                            {
                                var dataObject = JSON.parse( data );
                                User.updateMissionState( this.m_explorationData.id, dataObject );
                            }
                        }.bind(this));
                    GameController.getMainScreen().showButtons();
                    GameController.getMainScreen().showPlayerInfo();
                    var screen = new MissionFailedScreen();
                    SoundManager.setMusicEnabled(true, SoundManager.BG_MUSIC_NORMAL);
                    Xib.Navigation.resetScreenStackTo( screen, false );
                }.bind(this);
                Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
                return;
            }

            // Mission done
            if( !this.m_missionDone && serverData.missionState.progress == 1 )
            {
                this.m_newMissionDone = true;
            }

            this.m_rewardType = serverData.newReward.type;
            if( this.m_rewardType == MISSION_REWARDS.CARD ||
                this.m_rewardType == MISSION_REWARDS.GOLD ||
                this.m_rewardType == MISSION_REWARDS.LUCKY_CHANCE ||
                this.m_rewardType == MISSION_REWARDS.ENEMY_CHANCE )
            {
                var rewardSprite = new GL2.Sprite();
                this.m_actualRewardSprite = rewardSprite;
                rewardSprite.setDepth( 20000 );
                rewardSprite.setFrame( this.cardSlot.getFrame() );


                switch( this.m_rewardType )
                {
                    case MISSION_REWARDS.CARD:
                        info( "ExplorationScreenAnimated.retrieveActionForPlayer this.m_rewardType=CARD" );
                        var cardInstance = serverData.newReward.value;

                        info( "ExplorationScreenAnimated.retrieveActionForPlayer cardInstance=%s", JSON.stringify( cardInstance ) );
                        if (CardsManager.isCardNew(cardInstance.definitionId))
                        {
                            this.m_displayNewCardBanner = true;
                        }
                        CardsManager.addPlayerCard( cardInstance );
                        CardsManager.loadCardImage( cardInstance.definitionId, IMAGE_SIZE.BIG, function( rewardSprite, imageUrl )
                        {
                            if( this.getView()._destroyed )
                            {
                                return;
                            }
                            rewardSprite.setImage( imageUrl );
                            this.infoLabel.setText( _loc( "explore_new_card_found" ) );

                            this.explorationView.addChild( rewardSprite );
                            this.popCardAnimation( rewardSprite, this.showContinueButton.bind( this, true) );
                        }.bind( this, rewardSprite ) );
                        if( cardInstance.inLimbo == true )
                        {
                            cardsInVaultPopUp(cardInstance);
                        }
                        break;

                    case MISSION_REWARDS.GOLD:
                        var currentGold = serverData.newReward.value;
                        info( "ExplorationScreenAnimated.retrieveActionForPlayer this.m_rewardType=GOLD, currentGold=%s", currentGold );

                        var oldGold   = User.getCurrency();
                        var deltaGold = Math.abs( currentGold - oldGold );
                        var goldText  = sprintf( _loc( "explore_gold" ), deltaGold );

                        User.setCurrency( currentGold );
                        this.infoLabel.setText( goldText );
                        rewardSprite.setImage( "GOLD_400.jpg" );

                        this.explorationView.addChild( rewardSprite );
                        this.popCardAnimation( rewardSprite, this.showContinueButton.bind( this, true ) );
                        break;

                    case MISSION_REWARDS.LUCKY_CHANCE:
                        this.m_luckyChanceId = serverData.newReward.value;
                        info( "ExplorationScreenAnimated.retrieveActionForPlayer this.m_rewardType=LUCKY_CHANCE, this.m_luckyChanceId=%s", this.m_luckyChanceId );
                        rewardSprite.setImage( "lucky_chance_400.jpg" );
                        this.explorationView.addChild( rewardSprite );
                        this.popCardAnimation( rewardSprite, this.showAcceptCancelButton.bind( this, true, MISSION_REWARDS.LUCKY_CHANCE  ) );
                        break;

                    case MISSION_REWARDS.ENEMY_CHANCE:
                        this.m_bossId = serverData.newReward.value;
                        info( "ExplorationScreenAnimated.retrieveActionForPlayer this.m_rewardType=ENEMY_CHANCE, this.m_bossId=%s", JSON.stringify( this.m_bossId ) );
                        rewardSprite.setImage( "enemychance_400.jpg" );
                        this.explorationView.addChild( rewardSprite );
                        this.popCardAnimation( rewardSprite, this.showAcceptCancelButton.bind( this, true, MISSION_REWARDS.ENEMY_CHANCE ) );
                        break;
                }
            }

            if( serverData.xp )
            {
                var oldLevel = User.getLevel();
                User.setXP( serverData.xp );
                var newLevel = User.getLevel();

                if( newLevel > oldLevel )
                {
                    info( "ExplorationScreenAnimated.retrieveActionForPlayer...Level Up!" );
                    this.m_isLevelUp                    = true;
                    this.m_gifts                        = null;
                    this.m_isLevelUpAnimationFinished   = false;
                    this.m_areLevelUpGiftsReceived      = false;

                    if( TutorialManager.getActiveStateId() == undefined )
                    {
                        Server.giveGiftsByLevel( newLevel, this.onLevelUpGiftsReceived.bind( this ) );
                    }

                    // info( "ExplorationScreenAnimated.areaCleared...Level Up Animation" );
                    // this.m_animation.playAnimation( LevelUpAnimation.LEVEL_UP, this.endExplorationScreen.bind( this ) );
                }
            }
        }
        else
        {
            this.areaCleared();
        }
    },

    onLevelUpGiftsReceived: function( error, data )
    {
        info( "ExplorationScreenAnimated.onLevelUpGiftsReceived error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

        if( error || data == undefined )
        {
            err( "LuckyChance._cardClicked.serverCallback Error!" );
            return;
        }

        dataObj      = JSON.parse( data );
        this.m_gifts = dataObj.gifts;
        GiftManager.addGift( this.m_gifts );
        this.m_areLevelUpGiftsReceived = true;

        if( this.m_isLevelUpAnimationFinished == false )
        {
            return;
        }

        this.openLevelUpLanding();
    },

    openLevelUpLanding: function()
    {
        info( "ExplorationScreenAnimated.openLevelUpLanding called" );
        User.updateMainStats();
        var onScreenShown = function()
        {
            info( "ExplorationScreenAnimated.openLevelUpLanding.onScreenShown called" );
            this.m_timeout = setTimeout( this.popEvent.bind( this ), this.m_timeoutDelay );
        }.bind( this );

        /*
         * if( this.m_gifts == null || this.m_gifts.length == 0 || this.m_returnToScreen == false ) { screen = new LevelUpLanding( this.m_gifts, this.m_missionSelectionScreen, null ); } else { screen =
         * new LevelUpLanding( this.m_gifts, this, onScreenShown ); }
         */
        Server.getMissionState( this.m_explorationData.id, function( error, data )
        {
            if( error )
            {
                err( "ExplorationScreenAnimated.openLevelUpLanding._innerCallback Error. error=%s", JSON.stringify( error ) );
                return;
            }

            if( data )
            {
                info( "ExplorationScreenAnimated.openLevelUpLanding._innerCallback data=", data );

                var parsedData = JSON.parse( data );
                User.updateMissionState( this.m_explorationData.id, parsedData );
            }
            else
            {
                info( "ExplorationScreenAnimated.openLevelUpLanding._innerCallback data=null" );
            }

            var screen = new LevelUpLanding( this.m_gifts, this.m_missionSelectionScreen, null );
            Xib.Navigation.pushViewController( screen, false );
        }.bind( this ) );


        if( TutorialManager.getActiveStateId() == undefined )
        {
            GameController.getMainScreen().showButtons();
            GameController.getMainScreen().showPlayerInfo();
        }
    },

    popCardAnimation: function( rewardSprite, continueFunction )
    {
        info( "ExplorationScreenAnimated.popCardAnimation called" );
        this.m_speedFactor = 0;
        var targetPosition = this.m_target._position.clone();

        rewardSprite.setPosition( targetPosition );
        rewardSprite.setScale( 0, 0 );
        rewardSprite.runAction( Action.Sequence.actions( Action.ScaleTo.actionWithDuration( 0.2, 1, 1 ) ) );
        rewardSprite.runAction( Action.Sequence.actions( Action.MoveTo.actionWithDuration( 0.2, this.cardSlot._position ), Action.CallFunc.actionWithTarget( this, continueFunction ) ) );

        this.m_rounds++;
    },

    updateProgress: function( serverData )
    {
        this.m_statBars[0].updateProgress( User.getExploreEnergy() / User.getMaxExplorationEnergy() );
        this.m_statBars[1].updateProgress( User.getProgressLevel() );
        this.m_statBars[2].updateProgress( serverData.missionState.progress );
    },

    showContinueButton: function( value, cardPrize )
    {
        info( "ExplorationScreenAnimated.showContinueButton called. value=%s", value );
        this.rewardView.setVisible( value );
        this.continueButton.setEnabled( value );

        if (this.m_displayNewCardBanner)
        {
            this.newCardImage.setVisible(true);
            this.newCardImage.setAlpha(1);
            this.newCardImage.setDepth(20100);
            this.m_displayNewCardBanner = false;
        }

        if( TutorialManager.getActiveStateId() == undefined )
        {
            this.cancelButton.setEnabled( true );
        }
    },

    showAcceptCancelButton: function( value, rewardType )
    {
        info( "ExplorationScreenAnimated.showAcceptCancelButton called. value=%s, rewardType=%s", value, rewardType );

        this.luckyChanceView.setVisible( value );
        this.luckyChanceButtonCancel.setEnabled( value );
        this.luckyChanceButtonAccept.setEnabled( value );

        if( TutorialManager.getActiveStateId() == undefined )
        {
            this.cancelButton.setEnabled( true );
        }

        if( rewardType == undefined )
        {
            warn( "ExplorationScreenAnimated.showAcceptCancelButton Warning, rewardType==undefined!" );
//            this.continueExploring();
            return;
        }

        switch( rewardType )
        {
            case MISSION_REWARDS.LUCKY_CHANCE:
                break;

            case MISSION_REWARDS.ENEMY_CHANCE:
                break;

            default:
                err("ExplorationScreenAnimated.showAcceptCancelButton Error, unknown rewardType! rewardType=%s", rewardType );
                this.continueExploring();
                return;
                break;
        }
    },

    goToLuckyChance: function( inSender )
    {
        info( "ExplorationScreenAnimated.goToLuckyChance called." );

        if( inSender == this.luckyChanceButtonCancel )
        {
            info( "ExplorationScreenAnimated.goToLuckyChance cancelled." );
            this.continueExploring();
        }
        else if( inSender == this.luckyChanceButtonAccept )
        {
            switch( this.m_rewardType )
            {
                case MISSION_REWARDS.LUCKY_CHANCE:
                    info( "ExplorationScreenAnimated.goToLuckyChance this.m_rewardType=MISSION_REWARDS.LUCKY_CHANCE" );
                    var func = function()
                    {
                        var missionId = this.m_explorationData.id;
                        screen = new LuckyChance( missionId, this.m_luckyChanceId, this.continueExploring.bind( this ) );
                        Xib.Navigation.pushViewController( screen, false );
                    }.bind( this );
                    Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
                    break;

                case MISSION_REWARDS.ENEMY_CHANCE:
                    info( "ExplorationScreenAnimated.goToLuckyChance this.m_rewardType=MISSION_REWARDS.ENEMY_CHANCE" );
                    this.enterBossFightScene();
                    break;

                default:
                    err( "ExplorationScreenAnimated.goToLuckyChance Error, unknown rewardType! this.m_rewardType=%s", this.m_rewardType );
                    this.continueExploring();
                    break;
            }
        }
    },

    continueExploring: function()
    {
        info( "ExplorationScreenAnimated.continueExploring called." );
        this.m_speedFactor = 5;

        this.showContinueButton( false );
        this.showAcceptCancelButton( false );

        this.newCardImage.setVisible(false);
        this.newCardImage.setAlpha(0);

        if( this.m_targetAction )
        {
            this.m_targetAction.destroy();
            this.m_targetAction = null;
            this.m_target.stopAllActions();
            this.m_target.setImage( this.m_targetAsset );
        }

        if( this.m_actualRewardSprite != null )
        {
            this.m_actualRewardSprite.destroy();
            this.m_actualRewardSprite = null;
        }

        if( this.m_newMissionDone == true )
        {
            if( this.m_isLevelUp == false )
            {
                this.areaCleared();
            }
            else
            {
                this.m_returnToScreen = false;
                this.m_newMissionDone = false;
                this.m_animation.playAnimation( LevelUpAnimation.AREA_CLEARED, this.continueExploring.bind( this ) );
            }

            return;
        }

        if( this.m_isLevelUp == true )
        {
            this.m_isLevelUp = false;
            info( "ExplorationScreenAnimated.continueExploring...Level Up Animation" );
            var onAnimationFinished = function()
            {
                if( TutorialManager.getActiveStateId() != TutorialManager.STATE_MISSION_SELECTION2 )
                {
                    this.m_isLevelUpAnimationFinished = true;
                    if( this.m_areLevelUpGiftsReceived == false )
                    {
                        //TODO: show spinner
                        return;
                    }
                    this.openLevelUpLanding();
                }
                else
                {
                    GameController.getTutorialScreen().setVisibleBottomFrame( false );
                    GameController.getTutorialScreen().setVisibleTopFrame( true );
                    TutorialManager.completeActiveState();
                    TutorialManager.executeActiveStateAction();
                }
            }.bind( this );
            this.m_animation.playAnimation( LevelUpAnimation.LEVEL_UP, onAnimationFinished );
            return;
        }

        if( this.m_areaCleared )
        {
            this.endExplorationScreen();
            return;
        }
        else
        {
            if( !this.m_newMissionDone )
            {
                this.cancelButton.setEnabled( false );
                this.m_timeout = setTimeout( this.popEvent.bind( this ), this.m_timeoutDelay );
            }
        }
    },

    areaCleared: function( text )
    {
        // Code to show a big sprite telling the user he cleared the stage

        /*
         * this.m_areaClearedSprite = new GL2.Sprite();
         * 
         * this.m_areaClearedSprite.setFrame(this.areaClearedView.getFrame());
         * 
         * this.m_areaClearedSprite.setImage("cleared.jpg");
         * 
         * this.explorationView.addChild(this.m_areaClearedSprite);
         * 
         * this.m_areaClearedSprite.setPosition(-800, this.explorationView.getFrame()._size._height/2 - this.m_areaClearedSprite.getFrame()._size._height/2);
         * 
         * this.m_areaClearedSprite.setDepth(30000);
         * 
         * this.m_areaClearedSprite.runAction( Action.Sequence.actions( Action.EaseOutSine.actionWithAction( Action.Sequence.actions( Action.MoveTo.actionWithDuration(1, new
         * Core.Point(this.areaClearedView.getFrame()._origin._x, this.areaClearedView.getFrame()._origin._y)), Action.DelayTime.actionWithDuration(3), Action.CallFunc.actionWithTarget(this,
         * this.endExplorationScreen) ) ) ) );
         */

        var onContinue = function()
        {
            info( "ExplorationScreenAnimated.areaCleared.onContinue called" );
            if( TutorialManager.getActiveStateId() == TutorialManager.STATE_MISSION_SELECTION )
            {

                GameController.getTutorialScreen().setVisibleBottomFrame( true );
                TutorialManager.completeActiveState();
                TutorialManager.executeActiveStateAction();

                GameController.getTutorialScreen().setVisibleTopFrame( true );
            }
            else
            {
                this.endExplorationScreen();
            }
        }.bind( this );

        if( text == undefined )
        {
            // text = "explore_area_cleared";
            info( "ExplorationScreenAnimated.areaCleared...Area Cleared Animation" );
            this.m_animation.playAnimation( LevelUpAnimation.AREA_CLEARED, onContinue );
            return;
        }
        this.m_areaCleared = true;

        this.showContinueButton( true );

        this.infoLabel.setText( _loc( text ) );
    },

    endExplorationScreen : function()
    {
        info( "ExplorationScreenAnimated.endExplorationScreen called." );

        Server.getMissionState( this.m_explorationData.id, function( error, data )
        {
            if( error )
            {
                err( "ExplorationScreenAnimated.endExplorationScreen._innerCallback Error. error=%s", JSON.stringify( error ) );
                return;
            }
            if( data )
            {
                info( "ExplorationScreenAnimated.endExplorationScreen._innerCallback data=%s", data );
                var parsedData = JSON.parse( data );
                User.updateMissionState( this.m_explorationData.id, parsedData );
            }

            if( TutorialManager.getActiveStateId() == undefined )
            {
                GameController.getMainScreen().showButtons();
                GameController.getMainScreen().showPlayerInfo();
            }
            Xib.Navigation.popViewController();
        }.bind( this ) );
    },

    destroy: function( $super )
    {
        info( "ExplorationScreenAnimated.destroy called." );

        if( TutorialManager.getActiveStateId() != TutorialManager.STATE_MISSION_SELECTION || TutorialManager.getActiveStateId() != TutorialManager.STATE_MISSION_SELECTION2 )
        {
            var overlayView = Xib.Navigation.getOverlayView();
            overlayView.setEnabledMenu( 1 );
        }

        this.m_target.stopAllActions();
        this.m_target.destroy();
        for( var i = 0; i < this.m_statBars[i]; i++ )
        {
            this.m_statBars[i].destroy();
        }
        Core.UpdateEmitter.removeListener( this.m_parallaxUpdater );
        this.m_parallaxUpdater.destroy();
        $super();
    },

    viewDidAppear: function()
    {
        info( "ExplorationScreenAnimated.viewDidAppear called." );

        Xib.Navigation.removeModalOverlay();

        if( TutorialManager.getActiveStateId() == undefined )
        {
            GameController.getMainScreen().hideButtons();
            GameController.getMainScreen().hidePlayerInfo();
            this.cancelButton.setEnabled( false );
        }
        else
        {
            GameController.getTutorialScreen().setVisibleTopFrame( false );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );
            this.cancelButton.setEnabled( false );
        }
        SoundManager.setMusicEnabled(true, SoundManager.BG_MUSIC_EXPLORATION);
    },

    setProgressBarXPColor: function()
    {
        this.m_statBars[1].foreground.setImage( TEXTURE_COLOR.yellow );
        this.m_statBars[1].background.setImage( TEXTURE_COLOR.lightblue );
        this.m_statBars[1].background.setAlpha( 0.6 );
    },

    setProgressBarFuelColor: function()
    {
        this.m_statBars[0].foreground.setImage( TEXTURE_COLOR.lightgreen );
        this.m_statBars[0].background.setImage( TEXTURE_COLOR.lightblue );
        this.m_statBars[0].background.setAlpha( 0.6 );
    },

    setProgressBarMissionColor: function()
    {
        this.m_statBars[2].foreground.setImage( TEXTURE_COLOR.orange );
        this.m_statBars[2].background.setImage( TEXTURE_COLOR.lightblue );
        this.m_statBars[2].background.setAlpha( 0.6 );
    },

    cancelExploration: function()
    {
        this.endExplorationScreen();
    },


    ////////////////////////////////////////////////////////////////////////////////////////////////////////
    // THIS NEED TO BE ENCAPSULATED INTO A NEW CLASS. THIS CODE IS DUPLICATED IN MissionSelectionScreen

    enterBossFightScene : function()
    {
        info( "ExplorationScreenAnimated.enterBossFightScene called." );

        this.m_playerDeck   = DeckManager.getDeck();
        this.m_playerCards  = [];
        this.m_enemyCards   = [];
        this.m_bossData     = QuestManager.m_enemyChanceData[ this.m_bossId ];

        this.preloadAssets();
    },

    preloadAssets : function()
    {
        info( "ExplorationScreenAnimated.preloadAssets called." );
        var i;

        this.m_loadingCards = 0;

        this.m_loadingCards++;
        CardsManager.loadCardImage( this.m_bossData.gearId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind( this ) );

        this.m_enemyCards.push(
            {
                definitionId : this.m_bossData.gearId,
                pilot        : this.m_bossData.pilotId,
                status       : 0,
                bossAttack   : this.m_bossData.attack,
                bossHP       : this.m_bossData.hp,
                race         : CardsManager.getCardDefinition( this.m_bossData.gearId ).race
            }
        );

        info( "ExplorationScreenAnimated.preloadAssets this.m_enemyCards=%s", JSON.stringify( this.m_enemyCards ) );

        for( i = 0; i < this.m_playerDeck.status1.length; ++i )
        {
            this.m_playerCards.push(
                {
                    definitionId : CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId,
                    id           : CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).id,
                    status       : 0,
                    race         : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId ).race
                }
            );
            this.m_loadingCards++;
            CardsManager.loadCardImage( CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind( this ) );
        }

        for( i = 0; i < this.m_playerDeck.status2.length; ++i )
        {
            this.m_playerCards.push(
                {
                    definitionId : CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId,
                    id           : CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).id,
                    status       : 1,
                    race         : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId ).race
                }
            );
            this.m_loadingCards++;
            CardsManager.loadCardImage( CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind( this ) );
        }

        for( i = 0; i < this.m_playerDeck.status3.length; ++i )
        {
            this.m_playerCards.push(
                {
                    definitionId : CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId,
                    id           : CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).id,
                    status       : 2,
                    race         : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId ).race
                }
            );
            this.m_loadingCards++;
            CardsManager.loadCardImage( CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind( this ) );
        }

        info( "ExplorationScreenAnimated.preloadAssets this.m_loadingCards=%s", this.m_loadingCards );
    },

    assetLoadedCallback : function()
    {
        this.m_loadingCards--;
        info( "ExplorationScreenAnimated.assetLoadedCallback called. this.m_loadingCards=%s", this.m_loadingCards );

        if( this.getView()._destroyed ) // ???
        {
            return;
        }

        if( this.m_loadingCards <= 0 )
        {
            info( "ExplorationScreenAnimated.assetLoadedCallback this.m_enemyCards=%s", JSON.stringify( this.m_enemyCards ) );
            this.m_loadingCards = 0;

            var func = function()
            {
                var screen = new FightScene( this.m_playerCards, this.m_enemyCards, this.m_bossData, this.m_bossData, this.m_bossId, this._fightReadyCallback.bind( this ) );
                Xib.Navigation.pushViewController( screen );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func.bind( this ) ) );
        }
    },
    ////////////////////////////////////////////////////////////////////////////////////////////////////////

    _fightReadyCallback : function( battleData )
    {
        info( "ExplorationScreenAnimated._fightReadyCallback battleData=%s", JSON.stringify( battleData ) );

        var newScreen = null, reward = null;

        var rewards     = battleData.rewards;
        var playerWins  = battleData.playerWins;

        info( "ExplorationScreenAnimated._fightReadyCallback called. rewards=%s, playerWins=%s, this.m_bossData.pilotId=%s, this.m_bossData.gearId=%s",
            JSON.stringify( rewards ), playerWins, this.m_bossData.pilotId, this.m_bossData.gearId );

        GameController.getMainScreen().hideButtons();
        GameController.getMainScreen().hidePlayerInfo();

        var bossPilotCardDefinition = CardsManager.getCardDefinition( this.m_bossData.pilotId );
        var bossGearCardDefinition  = CardsManager.getCardDefinition( this.m_bossData.gearId );


        if( rewards && rewards.enemyRewards && rewards.enemyRewards.length > 0 )
        {
            reward = rewards.enemyRewards[0];
        }

        if( reward != null )
        {
            info( "ExplorationScreenAnimated._fightReadyCallback reward=%s", JSON.stringify( reward ) );

            // TODO FIXME: Add this in a constant !
            switch( reward.type )
            {
                case 1: // GOLD
                    newScreen = new EnemyChanceLandingCredit( reward.value, bossPilotCardDefinition, bossGearCardDefinition, playerWins,
                        function()
                        {
                            info( "ExplorationScreenAnimated._fightReadyCallback._innerCallback called." );
                            Xib.Navigation.popViewController(); // pop fight scene
                            GameController.getMainScreen().hideButtons();
                            GameController.getMainScreen().hidePlayerInfo();
                            this.continueExploring();
                        }.bind( this )
                    );
                    break;

                case 2: // CARD
                    newScreen = new EnemyChanceLandingCard( reward.value, bossPilotCardDefinition, bossGearCardDefinition,
                        function()
                        {
                            info( "ExplorationScreenAnimated._fightReadyCallback._innerCallback called." );
                            Xib.Navigation.popViewController(); // pop fight scene
                            GameController.getMainScreen().hideButtons();
                            GameController.getMainScreen().hidePlayerInfo();
                            this.continueExploring();
                        }.bind( this )
                    );
                    break;

                default:
                    newScreen = null
                    break;
            }
        }

        if( newScreen != null )
        {
            info( "ExplorationScreenAnimated._fightReadyCallback Showing newScreen" );
            Xib.Navigation.pushViewController( newScreen, true );
//
//            Xib.Navigation.setModalOverlay(
//                new WaitingScreen(
//                    function()
//                    {
//                        info( "ExplorationScreenAnimated._fightReadyCallback,_innerCallback(Waiting) called." );
//                        Xib.Navigation.pushViewController( newScreen, true );
//                    }.bind( this )
//                )
//            );
        }
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/VersusBattleMain'] = function(){var exports = $MODULE_REGISTRY['Code/UI/VersusBattleMain'] || {}; $MODULE_REGISTRY['Code/UI/VersusBattleMain'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/VersusBattleMain.js';

exports.VersusBattleMain = ScrollableView.subclass(
{
    classname: 'VersusBattleMain',

    m_views: [],
    m_numViews: 10,

    m_viewLoaded: false,
    m_battleDataReady: false,
    m_UIPopulated: false,

    initialize: function( $super , level)
    {
        info( "VersusBattleMain.initialize called." );
        $super();
    
        if(!level)
        {
            level   = 1;
        }

        this._retrieveBattle( level );
        this.initWithXib( "./Content/Xib/VersusBattleMain.xib", true );
        
        this.m_uiTextField          = new UI.EditText();
        this.m_uiTextField.setInputType(UI.Commands.InputType.Numeric);
        
        UI.Window.document.addChild(this.m_uiTextField);
        this.m_uiTextField.setFrame( -1000,-1000,100,50 );
        this.m_uiTextField.setOnChange( this.onTextChange.bind( this ) );
        this.m_uiTextField.setOnAction( this.onTextChange.bind( this ) );
        
        this.m_lastText         = "";
    },

    _retrieveBattle: function( level )
    {
        BattleManager.retrieveBattle( level, function( error, data )
        {
            info( "VersusBattleMain._retrieveBattle._innerCallback called. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );

            if( error || data == undefined )
            {
                err( "VersusBattleMain._retrieveBattle._innerCallback Error. error=%s, data=%s", JSON.stringify( error ), JSON.stringify( data ) );
            }
            else
            {
                // TODO Add extra check if field exists
                this._enemiesList = data.enemies;
                this.m_battleDataReady = true;
                this._populateUI();
            }
        }.bind( this ) );
    },

    viewDidLoad: function( $super )
    {
        info( "VersusBattleMain.viewDidLoad called." );
        $super();

        var backFunction = function()
        {
            var func = function()
            {

                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );

        this.m_viewLoaded = true;
        this._mapViews();
        this._mapElements();
        this._mapActions();
        this._populateUI();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(NO_SCREEN);
    },

    _populateUI: function()
    {
        info( "VersusBattleMain._populateUI called." );

        if( this.m_viewLoaded && this.m_battleDataReady && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;
            this.setBattleEnergy();
            this.setCareerWins( User.getUserData().stats.wins );
            this.setPlayerCards();
            this._setOpponents();
            Xib.Navigation.removeModalOverlay();
        }
    },

    _mapViews: function()
    {
        info( "VersusBattleMain._mapViews called." );

        for( var i = 0; i < this.m_numViews; i++ )
        {
            var view = eval( sprintf( "this.view_item_%d", i ) );
            this.m_views[i] =
            {
                "_view": view
            };
        }
    },

    _mapElements: function()
    {
        info( "VersusBattleMain._mapElements called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var view = this.m_views[i];

            view._leftImage = view._view.nodeWithTag( 6001 );
            view._rightImage = view._view.nodeWithTag( 6002 );
            view._enemyLabel = view._view.nodeWithTag( 6003 );
            view._levelLabel = view._view.nodeWithTag( 6004 );
            view._winsLabel = view._view.nodeWithTag( 6005 );
            view._rewardLabel = view._view.nodeWithTag( 6006 );
            view._fightButton = view._view.nodeWithTag( 6007 );
        }
    },

    _setOpponents: function()
    {
        var i;
        for( i = 0; i < this.m_views.length && i < this._enemiesList.length; i++ )
        {
            this.setOpponent( i, this._enemiesList[i] );
            this.m_views[i]._fightButton.setEnabled(true);
        }
    },

    setOpponent: function( position, data )
    {
        info( "VersusBattleMain.setOpponent called. Data > " + JSON.stringify( data ) );

        var view;

        view = this.m_views[position];
        if( view && position >= 0 && position < this.m_views.length )
        {
            view._leftImage.spinnerOn();
            CardsManager.loadCardImage( data.pilot.definitionId, IMAGE_SIZE.SMALL, function( sprite, imageURL )
            {
                if( sprite._destroyed )
                {
                    return;
                }
                sprite.setImage( imageURL );
                view._leftImage.spinnerOff();
            }.bind( this, view._leftImage ) );

            view._rightImage.spinnerOn();
            CardsManager.loadCardImage( data.gear.definitionId, IMAGE_SIZE.SMALL, function( sprite, imageURL )
            {
                if( sprite._destroyed )
                {
                    return;
                }
                sprite.setImage( imageURL );
                view._rightImage.spinnerOff();
            }.bind( this, view._rightImage ) );

            view._winsLabel.setText( sprintf( "%d", data.wins ) );
            view._levelLabel.setText( sprintf( "%d", data.level ) );
            view._rewardLabel.setText( sprintf( "%d", data.reward ) );
            view._enemyLabel.setText( sprintf( "%s", data.name ) );
            view._opponentId = data.id;

            // view._fightButton;
        }
        else
        {
            err( "VersusBattleMain.setOpponent position=%d, data=%s", position, JSON.stringify( data ) );
        }
    },

    _mapActions: function()
    {
        info( "VersusBattleMain._mapActions called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var callback = sprintf( "_fightButtonClicked.bind(this._target, {'button':%d})", i );
            this.m_views[i]._fightButton.setTargetAction( this, callback );
            this.m_views[i]._fightButton.setEnabled(false);
        }
    },

    _fightButtonClicked: function( opts, inSender )
    {
        info( "VersusBattleMain._fightButtonClicked called. opts=%s", JSON.stringify( opts ) );
        var button;

        if( opts.button !== undefined )
        {
            button = opts.button;
        }
        else
        {
            err( "VersusBattleMain._fightButtonClicked Button not found! opts=%s", JSON.stringify( opts ) );
            return;
        }

        if( button < this.m_views.length && button >= 0 )
        {
            var func    = function( button )
            {
                var opponentId = this.m_views[button]._opponentId;
                info( "VersusBattleMain._fightButtonClicked opponentId=%s", opponentId );
    
                var screen = new VersusBattleFight( this._enemiesList[button] );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this, button );
            
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
        else
        {
            err( "VersusBattleMain._fightButtonClicked Button not recognized! opts=%s", JSON.stringify( opts ) );
        }
    },

    setCareerWins: function( _value )
    {
        info( "VersusBattleMain.setCareerWins called. _value=%s", JSON.stringify( _value ) );
        var careerWinsLabel, value;

        value = parseInt( _value );
        careerWinsLabel = this.label_career_wins;
        if( careerWinsLabel !== undefined && careerWinsLabel.setText )
        {
            careerWinsLabel.setText( sprintf( "%d", value ) );
        }
        else
        {
            err( "VersusBattleMain.setCareerWins Error, cannot set careerWinsLabel." );
        }
    },

    setBattleEnergy: function()
    {
        var energy = User.getBattleEnergy();

        var energyImages, energyImage, i;
        energyImages = [];

        energyImages[0] = this.image_battle_energy1;
        energyImages[1] = this.image_battle_energy2;
        energyImages[2] = this.image_battle_energy3;

        for( i = 0; i < energyImages.length; i++ )
        {
            energyImage = energyImages[i];
            if( energyImage !== undefined && energyImage.setImage )
            {
                if( i < energy )
                {
                    energyImage.setImage( 'battle_energy_fill.png' );
                }
                else
                {
                    energyImage.setImage( 'battle_energy_empty.png' );
                }
            }
            else
            {
                err( "VersusBattleMain.setBattleEnergy Error, cannot set energyImage. i=%d, energyImages.length=%d", i, energyImages.length );
            }
        }
    },

    setPlayerCards: function()
    {
        var pair = DeckManager.getRandomPair();

        info( "VersusBattleMain.setPlayerCards pair: " + JSON.stringify( pair ) );
        info( "VersusBattleMain.setPlayerCards pilot: " + JSON.stringify( CardsManager.getPlayerCardById( pair.pilot ) ) );

        var pilotId = CardsManager.getCardDefinition( CardsManager.getPlayerCardById( pair.pilot ).definitionId ).id;
        var gearId = CardsManager.getCardDefinition( CardsManager.getPlayerCardById( pair.gear ).definitionId ).id;

        this.image_left.spinnerOn();
        CardsManager.loadCardImage( pilotId, IMAGE_SIZE.SMALL, function( imageURL )
        {
            if( this.image_left._destroyed )
            {
                return;
            }
            this.image_left.setImage( imageURL );
            this.image_left.spinnerOff();
        }.bind( this ) );

        this.image_right.spinnerOn();
        CardsManager.loadCardImage( gearId, IMAGE_SIZE.SMALL, function( imageURL )
        {
            if( this.image_right._destroyed )
            {
                return;
            }
            this.image_right.setImage( imageURL );
            this.image_right.spinnerOff();
        }.bind( this ) );
    },

    viewDidAppear: function()
    {
        this._updateInterval = setInterval( this.setBattleEnergy.bind( this ), 1000 );
    },
    
    viewWillDisappear       : function()
    {
        clearInterval( this._updateInterval );
        this.m_uiTextField.blur();
    },
    
    destroy                 : function()
    {
        clearInterval( this._updateInterval );
        this.m_uiTextField.blur();
        this.m_uiTextField.destroy();
    },
    
    onTextFieldTouch        : function()
    {        
        this.m_uiTextField.focus();
        this.scrollToBottom( true );
    },
    
    onTextChange            : function(event)
    {  
        if(this.m_lastText.length > event.text.length)
        {
            this.level.setText( this.level.getText().substring(0, this.level.getText().length -1) );
            this.m_lastText = event.text;
            return;
        }
        
        if( "0123456789".indexOf( event.text.substring(event.text.length-1) ) < 0 )
        {
            this.m_lastText = event.text;
            return;
        }
        
        if(parseInt(this.level.getText() + "" + event.text.substring(event.text.length-1)) > 999)
        {
            this.m_lastText = event.text;
            return;
        }
        
        this.level.setText( this.level.getText() + event.text.substring(event.text.length-1) );
        
        this.m_lastText = event.text;
    },
    
    onSearchTouch           : function()
    {
        this.m_uiTextField.blur();
        
        var level           =  parseInt( this.level.getText() );
        
        this.canSearch( level );        
    },
    
    canSearch               : function( level )
    {         
        if(level <= 500)
        {
            this.goToSearch( level );
        }
        else
        {
            var popUp = new PopUp( 1, PopUp.ERROR, _loc( "battle_wrong_level_title" ), _loc( "battle_wrong_level_description" ), function(){ info("OK button pressed"); } , _loc( "transaction_ok_button" ) );
            Xib.Navigation.removeModalOverlay();
            Xib.Navigation.setModalOverlay( popUp );
        }
    },
    
    goToSearch              : function( level )
    {
        var func = function()
        {
            var screen          = new VersusBattleMain( level );
            Xib.Navigation.resetScreenStackTo( screen, true );
        }.bind(this);
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    }

// _updateFrameHeight: function( visibleItems )
// {
// var deletedSpace = (
// this.m_views.length - visibleItems) * 145;
// info( "ExplorationSelection._updateFrameHeight called. visibleItems=%d, deletedSpace=%d, m_frameHeight(old)=%d, m_frameHeight(new)=%d",
// visibleItems, deletedSpace, this.m_frameHeight, this.m_frameHeight - deletedSpace );
//
// this.m_frameHeight += deletedSpace;
// },

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/VersusBattleFight'] = function(){var exports = $MODULE_REGISTRY['Code/UI/VersusBattleFight'] || {}; $MODULE_REGISTRY['Code/UI/VersusBattleFight'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/VersusBattleFight.js';

 exports.VersusBattleFight = ScrollableView.subclass(
    {
        classname : "VersusBattleFight",
        
        PLAYER_WON          : 0,
        ENEMY_WON           : 1,

        initialize : function( $super, enemyData, result, showEnemyDeck )
        {
            info( "VersusBattleFight.initialize called. "+JSON.stringify( enemyData ) );
            $super();

            this.initWithXib( "./Content/Xib/VersusBattleFight.xib", true );
            
            this.m_playerDeck                   = DeckManager.getDeck();            
            this.m_enemyCards                   = [];
            this.m_playerCards                  = [];
            
            this.m_enemyData                    = enemyData;
            
            this.m_assetsLoaded                 = 0;
            
            this.m_result                       = result;
            this.m_showEnemyDeck                = showEnemyDeck;
            
            Server.getEnemyDeck( enemyData.name, false, this.retrieveEnemyDataFromServer.bind( this ) );
            
            
        }, 

        viewDidLoad : function( $super )
        {
            info( "VersusBattleFight.viewDidLoad called." );
            $super();
            this.unsetBold();

            var overlay = Xib.Navigation.getOverlayView();
            overlay.highlightButton(NO_SCREEN);
            
            if(this.m_result == undefined)
            {
                this.setTopBannerVisible( false );
            }
            else
            {
                this.titleView.setVisible(false);
                if( this.m_result == VersusBattleFight.PLAYER_WON )
                {
                    this.winLoseBannerImage.setImage( "bfight_victory_image.png" );
                    this.winLoseBannerResult.setText( _loc("battle_fight_prize_%s", this.m_enemyData.reward) );
                    this.winLoseBannerTitle.setText( _loc("battle_victory" ) );
                }
                else
                {
                    this.winLoseBannerImage.setImage( "bfight_defeated_image.png" );
                    this.winLoseBannerResult.setText( _loc("battle_fight_prize_%s", this.m_enemyData.reward) );
                    this.winLoseBannerTitle.setText( _loc("battle_defeated") );
                }
            }
            
            if( this.m_showEnemyDeck )
            {
                this.enemyDeckButton.setVisible(true);
                this.prize.setText( "" );
                this.prizeLabel.setText( "" );
                this.fightButton.setText( _loc("battle_fight_victory_fight_again") );
            }
            else
            {
                this.enemyDeckButton.setVisible(false);
                this.prize.setVisible(true);
                this.prizeLabel.setVisible(true);
                this.fightButton.setText( _loc("battle_fight_fight") );
            }

            var backFunction = function()
            {
                var func = function()
                {
                    var screen = new VersusBattleMain( User.getLevel() );
                    Xib.Navigation.resetScreenStackTo( screen, false );
                }.bind( this );
                Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
            }.bind( this );

            ScreenManager.setBackInfo( backFunction );
        },
        
        setTopBannerVisible: function( visible )
        {
            this.winLoseBannerFrame.setVisible(visible);
            this.winLoseBannerImage.setVisible(visible);
        },

        toMyDeck : function( sender )
        {
            var func = function()
            {
                var screen = new DeckManagerUI(this);
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        },

        toFight : function( sender )
        {
            if( this.m_showEnemyDeck )
            {
                var screen      = new VersusBattleMain( User.getLevel() );
                Xib.Navigation.resetScreenStackTo(screen, false);
                return;
            }
            
            Xib.Navigation.setModalOverlay( new WaitingScreen(this.preloadAssets.bind(this)) );            
        },

        fillInfo : function()
        {
            this.m_playerData = User.getUserData();

            this.battleEnergy.setText( User.getBattleEnergy() + "/3" );
            this.playerName.setText( User.getGamerTag() );
            
            this.enemyName.setText(this.m_enemyData.name);
            this.enemyLevel.setText(this.m_enemyData.level);
            this.enemyWins.setText(this.m_enemyData.wins);
            
            for(var i = 0; i < this.m_enemyDeck.status1.length; ++i)
            {
                CardsManager.loadCardImage( this.m_enemyDeck.status1[i].gearDefinitionId, IMAGE_SIZE.SMALL, this.setEnemyDeckCards.bind(this, eval( sprintf("this.status1card%d", i) )));
            }
            for(var i = 0; i < this.m_enemyDeck.status2.length; ++i)
            {
                CardsManager.loadCardImage( this.m_enemyDeck.status2[i].gearDefinitionId, IMAGE_SIZE.SMALL, this.setEnemyDeckCards.bind(this, eval( sprintf("this.status2card%d", i) )));
            } 
            for(var i = 0; i < this.m_enemyDeck.status3.length; ++i)
            {
                CardsManager.loadCardImage( this.m_enemyDeck.status3[i].gearDefinitionId, IMAGE_SIZE.SMALL, this.setEnemyDeckCards.bind(this, eval( sprintf("this.status3card%d", i) )));
            }
            
            this._setEnergyBars();
            
            if( !this.m_showEnemyDeck )
            {
                this.prize.setText(this.m_enemyData.reward);
            }
            this.playerWins.setText(this.m_playerData.stats.wins);
        },
        
        setEnemyDeckCards       : function(sprite, imageURL)
        {
            if(sprite)
            {
                if( sprite._destroyed )
                {
                    return;
                }
                
                sprite.setImage(imageURL);
            }
        },
        
        preloadAssets           : function()
        {
            for(var i = 0; i < this.m_playerDeck.status1.length; ++i)
            {
                CardsManager.loadCardImage( CardsManager.getPlayerCardById(this.m_playerDeck.status1[i].gear).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
                this.m_playerCards.push(
                    {
                        definitionId        : CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId,
                        id                  : CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).id,
                        status              : 0,
                        race                : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status1[i].gear ).definitionId ).race
                    }
                );
            }
            
            for(var i = 0; i < this.m_playerDeck.status2.length; ++i)
            {
                
                CardsManager.loadCardImage( CardsManager.getPlayerCardById(this.m_playerDeck.status2[i].gear).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
                this.m_playerCards.push(
                    {
                        definitionId        : CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId,
                        id                  : CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).id,
                        status              : 1,
                        race                : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status2[i].gear ).definitionId ).race
                    }
                );  
            }
            
            for(var i = 0; i < this.m_playerDeck.status3.length; ++i)
            {
                CardsManager.loadCardImage( CardsManager.getPlayerCardById(this.m_playerDeck.status3[i].gear).definitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
                this.m_playerCards.push(
                    {
                        definitionId        : CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId,
                        id                  : CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).id,
                        status              : 2,
                        race                : CardsManager.getCardDefinition( CardsManager.getPlayerCardById( this.m_playerDeck.status3[i].gear ).definitionId ).race
                    }
                );
            }
            
            for(var i = 0; i < this.m_enemyDeck.status1.length; ++i)
            {
                CardsManager.loadCardImage( this.m_enemyDeck.status1[i].gearDefinitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
                this.m_enemyCards.push( 
                    {
                        definitionId        : this.m_enemyDeck.status1[i].gearDefinitionId,
                        id                  : this.m_enemyDeck.status1[i].gear,
                        status              : 0,
                        race                : CardsManager.getCardDefinition( this.m_enemyDeck.status1[i].gearDefinitionId ).race
                    }
                ); 
            }
            
            for(var i = 0; i < this.m_enemyDeck.status2.length; ++i)
            {
                CardsManager.loadCardImage( this.m_enemyDeck.status2[i].gearDefinitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
                this.m_enemyCards.push( 
                    {
                        definitionId        : this.m_enemyDeck.status2[i].gearDefinitionId,
                        id                  : this.m_enemyDeck.status2[i].gear,
                        status              : 1,
                        race                : CardsManager.getCardDefinition( this.m_enemyDeck.status2[i].gearDefinitionId ).race
                    }
                );   
            }
            
            for(var i = 0; i < this.m_enemyDeck.status3.length; ++i)
            {
                CardsManager.loadCardImage( this.m_enemyDeck.status3[i].gearDefinitionId, IMAGE_SIZE.SMALL, this.assetLoadedCallback.bind(this));
                this.m_enemyCards.push( 
                    {
                        definitionId        : this.m_enemyDeck.status3[i].gearDefinitionId,
                        id                  : this.m_enemyDeck.status3[i].gear,
                        status              : 2,
                        race                : CardsManager.getCardDefinition( this.m_enemyDeck.status3[i].gearDefinitionId ).race
                    }
                );    
            }
        },
        
        assetLoadedCallback     : function()
        {
            if( this.getView()._destroyed )
            {
                return;
            }
            
            this.m_assetsLoaded++;
            if(this.m_assetsLoaded >= 18)
            {
                this.launchFight();
            }
        },
        
        launchFight             : function()
        {
            Xib.Navigation.removeModalOverlay();
            var func = function()
            {
                this.m_enemyData.deck       = this.m_enemyDeck;
                var screen = new FightScene(this.m_playerCards, this.m_enemyCards, this.m_enemyData, null, null);
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        },
        
        screenReadyToShow       : function()
        {
            if( this.m_serverReady && this.m_screenReady )
            {
                this.fillInfo();
                Xib.Navigation.removeModalOverlay();
            
                this._updateInterval = setInterval( this._setEnergyBars.bind( this ), 1000 );
            }
        },
        
        viewDidAppear           : function()
        {
            this.m_screenReady  = true;
            
            this.screenReadyToShow();
        },
        
        retrieveEnemyDataFromServer     : function( _error, data )
        {
            if( _error )
            {
                err( "VersusBattleFight.retrieveEnemyDataFromServer. Error retrieving data > "+JSON.stringify( _error ) );
            }
            
            this.m_serverReady  = true;
            
            this.m_enemyDeck    = JSON.parse( data ).deck;
            
            this.screenReadyToShow();
        },
        
        unsetBold               : function()
        {
           /* this.enemyWins.setBold(false);
            this.enemyLevel.setBold(false);
            this.notBold1.setBold(false);
            this.notBold2.setBold(false);
            this.notBold3.setBold(false);
            this.notBold4.setBold(false);
            this.notBold5.setBold(false);*/
        },
        
        _setEnergyBars          : function()
        {
            var energy = User.getBattleEnergy();

            this.battleEnergy.setText( energy + "/3" );
            
            this.energy0.setImage( "croom_energy_empty.png" );
            this.energy1.setImage( "croom_energy_empty.png" );
            this.energy2.setImage( "croom_energy_empty.png" );
            
            if( energy > 0 )
            {
                this.energy0.setImage( "croom_energy_fill.png" );
            }
            if( energy > 1 )
            {
                this.energy1.setImage( "croom_energy_fill.png" );
            }
            if( energy > 2 )
            {
                this.energy2.setImage( "croom_energy_fill.png" );
            }
            
            if( energy == 0)
            {
                this.fightButton.setText( _loc("battle_fight_no_energy") );
                this.fightButton.setTargetAction( this, "toStore.bind(this._target)" );
            }
            else if( this.fightButton.getText() == _loc("battle_fight_no_energy") && this.fightButton.getVisible() )
            {
                if( this.m_showEnemyDeck )
                {
                    this.fightButton.setText( _loc("battle_fight_victory_fight_again") );
                }
                else
                {
                    this.fightButton.setText( _loc("battle_fight_fight") );
                }
                
                this.fightButton.setTargetAction( this, "toFight.bind(this._target)" );
            }
        },
        
        toStore                 : function()
        {
            var screen          = new ItemStore();
            Xib.Navigation.resetScreenStackTo(screen, true);
        },
        
        toEnemyDeck             : function()
        {
            var screen = new EnemyDeck(this.m_enemyData);
            Xib.Navigation.resetScreenStackTo( screen, false );
        },
        
        destroy                 : function()
        {
            clearInterval( this._updateInterval );
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/ExplorationProgressBar'] = function(){var exports = $MODULE_REGISTRY['Code/UI/ExplorationProgressBar'] || {}; $MODULE_REGISTRY['Code/UI/ExplorationProgressBar'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/ExplorationProgressBar.js';

//FFFFFFFFFFFFFFFFFFFFFFIIIIIIIIIIXXXXXXX       XXXXXXX     MMMMMMMM               MMMMMMMMEEEEEEEEEEEEEEEEEEEEEE !!! 
//F::::::::::::::::::::FI::::::::IX:::::X       X:::::X     M:::::::M             M:::::::ME::::::::::::::::::::E!!:!!
//F::::::::::::::::::::FI::::::::IX:::::X       X:::::X     M::::::::M           M::::::::ME::::::::::::::::::::E!:::!
//FF::::::FFFFFFFFF::::FII::::::IIX::::::X     X::::::X     M:::::::::M         M:::::::::MEE::::::EEEEEEEEE::::E!:::!
//  F:::::F       FFFFFF  I::::I  XXX:::::X   X:::::XXX     M::::::::::M       M::::::::::M  E:::::E       EEEEEE!:::!
//  F:::::F               I::::I     X:::::X X:::::X        M:::::::::::M     M:::::::::::M  E:::::E             !:::!
//  F::::::FFFFFFFFFF     I::::I      X:::::X:::::X         M:::::::M::::M   M::::M:::::::M  E::::::EEEEEEEEEE   !:::!
//  F:::::::::::::::F     I::::I       X:::::::::X          M::::::M M::::M M::::M M::::::M  E:::::::::::::::E   !:::!
//  F:::::::::::::::F     I::::I       X:::::::::X          M::::::M  M::::M::::M  M::::::M  E:::::::::::::::E   !:::!
//  F::::::FFFFFFFFFF     I::::I      X:::::X:::::X         M::::::M   M:::::::M   M::::::M  E::::::EEEEEEEEEE   !:::!
//  F:::::F               I::::I     X:::::X X:::::X        M::::::M    M:::::M    M::::::M  E:::::E             !!:!!
//  F:::::F               I::::I  XXX:::::X   X:::::XXX     M::::::M     MMMMM     M::::::M  E:::::E       EEEEEE !!! 
//FF:::::::FF           II::::::IIX::::::X     X::::::X     M::::::M               M::::::MEE::::::EEEEEEEE:::::E     
//F::::::::FF           I::::::::IX:::::X       X:::::X     M::::::M               M::::::ME::::::::::::::::::::E !!! 
//F::::::::FF           I::::::::IX:::::X       X:::::X     M::::::M               M::::::ME::::::::::::::::::::E!!:!!
//FFFFFFFFFFF           IIIIIIIIIIXXXXXXX       XXXXXXX     MMMMMMMM               MMMMMMMMEEEEEEEEEEEEEEEEEEEEEE !!! 


//This class SHOULD NOT exist. ProgressBar.js must be able to resize it's elements without issues, the scaling factor 
//has to be calculated properly.


//Here be dragons.

exports.ExplorationProgressBar = ProgressBar.subclass(
{
    classname: 'ExplorationProgressBar',
    
    initialize: function(xib /*XibFile to load*/, base_value, frame)
    {

    },

    updateProgress: function(delta /*decimal from 0 to 1*/)
    {
        if( this.m_allLoaded )
        {
            this.foreground.setScale(delta, 0.3);
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/FightScene'] = function(){var exports = $MODULE_REGISTRY['Code/UI/FightScene'] || {}; $MODULE_REGISTRY['Code/UI/FightScene'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/FightScene.js';

exports.FightScene          = XibUI.subclass
({
    classname               : "FightScene",

    EFFECT                  : 1000,
    FIGHTING_CARD           : 120,
    HIT_CARD                : 110,
    CARDS_LAYER             : 100,
    BARS_LAYER              : 90,
    BARS_LAYER              : 0,


    initialize              : function( playerDeck, enemyDeck, enemyData, stageInfo, bossId, battleFinishCallback )
    {
        info( "FightScene.initialize called. playerDeck=%s", JSON.stringify( playerDeck ) );
        info( "FightScene.initialize called. enemyDeck=%s", JSON.stringify( enemyDeck ) );
        info( "FightScene.initialize called. enemyData=%s", JSON.stringify( enemyData ) );
        info( "FightScene.initialize called. stageInfo=%s, bossId=%s", JSON.stringify( stageInfo ), bossId );

        this.m_bossId               = bossId;
        this.m_battleFinishCallback = battleFinishCallback;

        this.m_enemyData            = enemyData;
        this.m_stageInfo            = stageInfo;

        this.m_playerCards          = [];
        this.m_enemyCards           = [];

        this.m_playerHPBars         = [];
        this.m_enemyHPBars          = [];

        this.m_enterAnimationReady  = false;
        this.m_serverReady          = false;

        this.m_battleData           = "";

        this.m_playerDeck           = playerDeck;
        this.m_enemyDeck            = enemyDeck;

        this.m_playerCardsHP        = [];
        this.m_enemyCardsHP         = [];

        this.m_playerCardsXP        = [];
        this.m_enemyCardsXP         = [];

        this.m_enterAnimationCounter= 0;

        if( TutorialManager.getActiveStateId() == undefined )
        {
            this.m_battleObject = Server.getRemoteBattleObject();
            if( enemyDeck.length == 9 )
            {
                info( "FightScene.initialize Requesting a fight: this.m_battleObject.requestFight" );
                this.m_battleObject.requestFight( enemyData.name, this.getServerData.bind( this ) );
            }
            else
            {
                if( this.m_bossId )
                {
                    info( " FightScene.initialize Requesting a boss fight. bossId=%s", this.m_bossId );
                    this.m_battleObject.requestBossFight( null, null, this.m_bossId, this.getServerData.bind( this ) );
                }
                else
                {
                    info( " FightScene.initialize Requesting a boss fight: this.m_battleObject.requestBossFight" );
                    this.m_battleObject.requestBossFight( enemyData.worldId, enemyData.stageId, null, this.getServerData.bind( this ) );
                }
            }
        }
        else
        {
            info( "FightScene.initialize In Tutorial." );
            this.getServerData( null, JSON.stringify( TutorialFightData ) );
        }

        this.initWithXib( "./Content/Xib/FightScene.xib", true );
    },

    getServerData           : function(_err, response)
    {
        info( "FightScene.getServerData called. response=%s", response );

        if( _err )
        {
            err( "FightScene.getServerData called. _err=%s", JSON.stringify( _err ) );
        }
        
        User.updateMainStats();

        if( User.getBattleEnergy() == 3 )
        {
            TimersController.restartAllTimeouts();
        }

        User.increaseBattleEnergy( -1 );

        this.m_battleData           = JSON.parse(response);
        this.m_playerCardsHP        = this.m_battleData.hp.player;
        this.m_enemyCardsHP         = this.m_battleData.hp.enemy;

        if( this.m_battleData.gearXP )
        {
            this.m_playerCardsXP = this.m_battleData.gearXP.player;
            this.m_enemyCardsXP  = this.m_battleData.gearXP.enemy;
        }

        this.serverDataReady();
    },

    viewDidLoad             : function()
    {
        info("FightScene.viewDidLoad called.");
        Social.Common.Service.hideCommunityButton();

        this.m_enemyHidePosition        = new Core.Point(0, -this.getView().getFrame()._size._height);
        this.m_playerHidePosition       = new Core.Point(0, this.getView().getFrame()._size._height * 1.5);

        if( this.m_enemyDeck.length == 1 )
        {
            this.enemyCard0                 = this.enemyBossCard;

            this.enemyHPBar0                = this.enemyBossHPBar;
        
            this.enemyUnit0                 = this.enemyDamageFrame;
        }

        this.ability.setAlpha(0);
        this.abilityBackground.setColor( 0, 151, 177 );

        this.prepareCards();

        SoundManager.setMusicEnabled(true, SoundManager.BG_MUSIC_BATTLE );

        if (TutorialManager.getActiveStateId() != undefined)
        {
            this.skipButtonLink.setEnabled(false);
            this.skipButtonLink.setVisible(false);
            this.skipButtonLink.setAlpha( 0 );
            this.skipButtonLinkLabel.setAlpha( 0 );
        }
    },

    viewDidDisappear: function()
    {
        info( "FightScene.viewDidDisappear called." );

        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        }
    },

    calculateRandomEntry    : function()
    {

    },

    prepareCards            : function()
    {
        info( "FightScene.prepareCards called." );

        for(var i = 0; i < this.m_enemyDeck.length; i++)
        {
            this.m_enemyCards[i]    = new GL2.Sprite();

            var enemyCard           = eval(sprintf("this.enemyCard%d",i));

            this.m_enemyCards[i].setFrame(enemyCard.getFrame());

            this.m_enemyCards[i].setImage(this.m_enemyDeck[i].definitionId+"_"+IMAGE_SIZE.SMALL+".jpg");

            this.getView().addChild(this.m_enemyCards[i]);

            this.m_enemyCards[i].setPosition(this.m_enemyHidePosition);
            this.m_enemyCards[i].setDepth(FightScene.CARDS_LAYER);

            this.m_enemyCards[i].runAction(
                    Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration(Math.floor(1+i/3)*0.5),
                            Action.EaseOutSine.actionWithAction(
                                    Action.MoveTo.actionWithDuration(1, new Core.Point(enemyCard.getFrame()._origin._x + enemyCard.getFrame()._size._width/2 - this.getView().getFrame()._size._width/2 , enemyCard.getFrame()._origin._y + enemyCard.getFrame()._size._height/2 - this.getView().getFrame()._size._height/2))
                            )
                    )
            );

            //Bar preparation
            var barContainer                    = eval(sprintf("this.enemyHPBar%d", i));
            this.m_enemyHPBars[i]               = new ProgressBar("./Content/Xib/FightHPBar.xib", 1, barContainer.getFrame());
            this.m_enemyHPBars[i].getView().setDepth(FightScene.BARS_LAYER);
            this.m_enemyHPBars[i].getView().setAlpha(0);
            this.m_enemyHPBars[i].damage        = 0;


            barContainer.addChild( this.m_enemyHPBars[i].getView() );

        }

        for(var i = 0; i < 9; i++)
        {
            this.m_playerCards[i]   = new GL2.Sprite();

            var playerCard          = eval(sprintf("this.playerCard%d",i));

            this.m_playerCards[i].setFrame(playerCard.getFrame());

            this.m_playerCards[i].setImage(this.m_playerDeck[i].definitionId+"_"+IMAGE_SIZE.SMALL+".jpg");

            this.getView().addChild(this.m_playerCards[i]);

            this.m_playerCards[i].setPosition(this.m_playerHidePosition);
            this.m_playerCards[i].setDepth(FightScene.CARDS_LAYER);

            this.m_playerCards[i].runAction(
                    Action.Sequence.actions(
                            Action.DelayTime.actionWithDuration(Math.floor(1+(8-i)/3)*0.5),
                            Action.EaseOutSine.actionWithAction(
                                    Action.MoveTo.actionWithDuration(1, new Core.Point(playerCard.getFrame()._origin._x + playerCard.getFrame()._size._width/2 - this.getView().getFrame()._size._width/2 , playerCard.getFrame()._origin._y + playerCard.getFrame()._size._height/2 - this.getView().getFrame()._size._height/2))
                            ),
                            Action.DelayTime.actionWithDuration(0.7),
                            Action.CallFunc.actionWithTarget(this, this.enterAnimationReady.bind(this) )
                    )
            );

            //Bar preparation
            var barContainer                    = eval(sprintf("this.playerHPBar%d", i));
            this.m_playerHPBars[i]              = new ProgressBar("./Content/Xib/FightHPBar.xib", 1, barContainer.getFrame());
            this.m_playerHPBars[i].getView().setDepth(FightScene.BARS_LAYER);
            this.m_playerHPBars[i].getView().setAlpha(0);
            this.m_playerHPBars[i].damage          = 0;


            barContainer.addChild( this.m_playerHPBars[i].getView() );
        }
    },

    hpBarsAppear                : function()
    {
        for(var i = 0; i < this.m_enemyDeck.length; i++)
        {
            this.m_enemyHPBars[i].getView().runAction(
                Action.Sequence.actions(
                    Action.DelayTime.actionWithDuration(0.1),
                    Action.FadeIn.actionWithDuration(0.3)
                )
            );
        }

        for(var i = 0; i < 9; i++)
        {
            this.m_playerHPBars[i].getView().runAction(
                Action.Sequence.actions(
                    Action.DelayTime.actionWithDuration(0.1),
                    Action.FadeIn.actionWithDuration(0.3)
                )
            );
        }
    },

    startBattle                 : function()
    {
        info( "FightScene.startBattle called. this.m_serverReady=" + this.m_serverReady + " this.m_enterAnimationReady=" + this.m_enterAnimationReady );

        info( "FightScene.startBattle this.m_playerCardsHP=%s", JSON.stringify( this.m_playerCardsHP ) );
        info( "FightScene.startBattle this.m_enemyCardsHP=%s", JSON.stringify( this.m_enemyCardsHP ) );

        if(!this.m_fightAnimation && this.m_enterAnimationReady && this.m_serverReady)
        {
            info( "FightScene.startBattle Creating Fight animation" );

            this.m_fightAnimation      = new FightAnimation();

            for( var s = 0; s < this.m_playerDeck.length; s++ )
            {
                if( s % 3 == 0 )
                {
                    this.m_fightAnimation.addAnimationFor( FightAnimation.BONUS_X3_PLAYER, null, this.m_playerCards[s] );
                }
                else
                {
                    this.m_fightAnimation.addAnimationFor( FightAnimation.BONUS_X2_PLAYER, null, this.m_playerCards[s] );
                }
            }

            this.m_fightAnimation.addAnimationFor( FightAnimation.DELAY, null, this.m_playerCards[0] );

            var maxLevelAnim = false;
            for( var s = 0; s < this.m_playerDeck.length; s++ )
            {
                var cardXP = this.m_playerCardsXP[s];
                if( cardXP )
                {
                    if( CardsManager.getCardDefinition( this.m_playerDeck[s].definitionId ).maxLevel <= CardsManager._getXPForLevel( cardXP ) )
                    {
                        maxLevelAnim    = true;
                        this.m_fightAnimation.addAnimationFor( FightAnimation.MAX_LEVEL_PLAYER, null, this.m_playerCards[s] );
                    }
                }
            }

            if( maxLevelAnim )
            {
                this.m_fightAnimation.addAnimationFor( FightAnimation.DELAY, null, this.m_playerCards[0] );
            }


            for( var s = 0; s < this.m_enemyDeck.length && this.m_enemyDeck.length > 1; s++ )
            {
                if( s % 3 == 0 )
                {
                    this.m_fightAnimation.addAnimationFor( FightAnimation.BONUS_X3_ENEMY, null, this.m_enemyCards[s] );
                }
                else
                {
                    this.m_fightAnimation.addAnimationFor( FightAnimation.BONUS_X2_ENEMY, null, this.m_enemyCards[s] );
                }
            }

            this.m_fightAnimation.addAnimationFor( FightAnimation.DELAY, null, this.m_playerCards[0] );

            maxLevelAnim = false;
            for( var s = 0; s < this.m_enemyDeck.length && this.m_enemyDeck.length > 1; s++ )
            {
                var cardXP = this.m_enemyCardsXP[s];

                if( cardXP )
                {
                    if( CardsManager.getCardDefinition( this.m_enemyDeck[s].definitionId ).maxLevel <= CardsManager._getXPForLevel( cardXP ) )
                    {
                        maxLevelAnim    = true;
                        this.m_fightAnimation.addAnimationFor( FightAnimation.MAX_LEVEL_ENEMY, null, this.m_enemyCards[s] );
                    }
                }
            }

            if( maxLevelAnim )
            {
                this.m_fightAnimation.addAnimationFor( FightAnimation.DELAY, null, this.m_playerCards[0] );
            }


            for(var step = 0; step < this.m_battleData.animations.length; ++step)
            {
                var animationStep       = this.m_battleData.animations[step];

                 info( "FightScene.startBattle animationStep=%s", JSON.stringify( animationStep ) );

                if( animationStep.type == "ability" )
                {
                    if( animationStep.turn == "player" )
                    {
                        this.m_fightAnimation.addAbilityAnim( FightAnimation.ABILITY_PLAYER, this.m_playerCards[ animationStep.abilityCardId ], this.ability, this.abilityDescription, _loc( sprintf("combat_bonus_%s", animationStep.ability ) ) );
                    }
                    else
                    {
                        this.m_fightAnimation.addAbilityAnim( FightAnimation.ABILITY_ENEMY, this.m_enemyCards[ animationStep.abilityCardId ], this.ability, this.abilityDescription, _loc( sprintf("combat_bonus_%s", animationStep.ability ) ) );
                    }
                    continue;
                }

                var damageGroup         = [];
                var damageFrame         = null;
                var attackType          = "";
                var damageGroupHPBars   = [];
                var damagePercent       = [];
                var HPLeft              = [];
                var raceType            = null;

                var randomAttackType    = Math.floor((Math.random()*9));

                if( randomAttackType >= 0 && randomAttackType <= 2 )
                {
                    attackType          = FightAnimation.FIGHT;
                }

                if( randomAttackType >= 3 && randomAttackType <= 5 )
                {
                    attackType          = FightAnimation.SHOOT;
                }

                if( randomAttackType >= 6 && randomAttackType <= 8 )
                {
                    attackType          = FightAnimation.MANEUVER;
                }

                if(animationStep.turn == "player")
                {
                    raceType            = this.m_playerDeck[animationStep.attackCardId].race;

                    for( var t = 0; t <  animationStep.damagedDealt.length ; ++t )
                    {
                        var cardIndex   = animationStep.damagedDealt[t].cardPosition;

                        this.m_enemyHPBars[cardIndex].damage   += animationStep.damagedDealt[t].damage / this.m_enemyCardsHP[cardIndex];
                        if( this.m_enemyHPBars[cardIndex].damage > 1 )
                        {
                            this.m_enemyHPBars[cardIndex].damage   = 1;
                        }
                    }

                    if(animationStep.damagedUnit == "status1")
                    {
                        damageFrame         = this.enemyUnit0;

                        for(var f = 0; f < 3; ++f)
                        {
                            if( this.m_enemyDeck.length == 1 && f == 1)
                            {
                                break;
                            }
                            damageGroup.push(this.m_enemyCards[f]);
                            damageGroupHPBars.push(this.m_enemyHPBars[f]);

                            damagePercent.push( this.m_enemyHPBars[f].damage );
                            HPLeft.push( this.m_enemyCardsHP[f] - this.m_enemyHPBars[f].damage * this.m_enemyCardsHP[f]);
                        }
                    }
                    else if(animationStep.damagedUnit == "status2")
                    {
                        damageFrame         = this.enemyUnit1;

                        for(var f = 3; f < 6; ++f)
                        {
                            damageGroup.push(this.m_enemyCards[f]);
                            damageGroupHPBars.push(this.m_enemyHPBars[f]);

                            damagePercent.push( this.m_enemyHPBars[f].damage );
                            HPLeft.push( this.m_enemyCardsHP[f] - this.m_enemyHPBars[f].damage * this.m_enemyCardsHP[f]);
                        }
                    }
                    else if(animationStep.damagedUnit == "status3")
                    {
                        damageFrame         = this.enemyUnit2;

                        for(var f = 6; f < 9; ++f)
                        {
                            damageGroup.push(this.m_enemyCards[f]);
                            damageGroupHPBars.push(this.m_enemyHPBars[f]);

                            damagePercent.push( this.m_enemyHPBars[f].damage );
                            HPLeft.push( this.m_enemyCardsHP[f] - this.m_enemyHPBars[f].damage * this.m_enemyCardsHP[f]);
                        }
                    }

                    info( "FightScene.startBattle damagePercent=%s", JSON.stringify( damagePercent ) );
                    info( "FightScene.startBattle HPLeft=%s", JSON.stringify( HPLeft ) );
                    info( "FightScene.startBattle race=%d", raceType );

                    this.m_fightAnimation.addAnimationFor(attackType, raceType, this.m_playerCards[parseInt(animationStep.attackCardId)], damageFrame, damageGroup, damageGroupHPBars, damagePercent, false);
                }
                else if(animationStep.turn == "enemy")
                {
                    raceType = this.m_enemyDeck[animationStep.attackCardId].race;

                    for( var t = 0; t <  animationStep.damagedDealt.length ; ++t )
                    {
                        var cardIndex   = animationStep.damagedDealt[t].cardPosition;

                        this.m_playerHPBars[cardIndex].damage   += animationStep.damagedDealt[t].damage / this.m_playerCardsHP[cardIndex];
                        if( this.m_playerHPBars[cardIndex].damage > 1 )
                        {
                            this.m_playerHPBars[cardIndex].damage   = 1;
                        }
                    }

                    if( animationStep.damagedUnit == "status1" )
                    {
                        damageFrame         = this.playerUnit0;

                        for(var f = 0; f < 3; ++f)
                        {
                            damageGroup.push(this.m_playerCards[f]);
                            damageGroupHPBars.push(this.m_playerHPBars[f]);

                            damagePercent.push( this.m_playerHPBars[f].damage );
                            HPLeft.push( this.m_playerCardsHP[f] - this.m_playerHPBars[f].damage * this.m_playerCardsHP[f]);
                        }
                    }
                    else if( animationStep.damagedUnit == "status2" )
                    {
                        damageFrame         = this.playerUnit1;

                        for(var f = 3; f < 6; ++f)
                        {
                            damageGroup.push(this.m_playerCards[f]);
                            damageGroupHPBars.push(this.m_playerHPBars[f]);

                            damagePercent.push( this.m_playerHPBars[f].damage );
                            HPLeft.push( this.m_playerCardsHP[f] - this.m_playerHPBars[f].damage * this.m_playerCardsHP[f]);
                        }
                    }
                    else if( animationStep.damagedUnit == "status3" )
                    {
                        damageFrame         = this.playerUnit2;

                        for(var f = 6; f < 9; ++f)
                        {
                            damageGroup.push(this.m_playerCards[f]);
                            damageGroupHPBars.push(this.m_playerHPBars[f]);

                            damagePercent.push( this.m_playerHPBars[f].damage );
                            HPLeft.push( this.m_playerCardsHP[f] - this.m_playerHPBars[f].damage * this.m_playerCardsHP[f]);
                        }
                    }

                    info( "FightScene.startBattle damagePercent=%s", JSON.stringify( damagePercent ) );
                    info( "FightScene.startBattle HPLeft=%s", JSON.stringify( HPLeft ) );
                    info( "FightScene.startBattle race=%d", raceType );

                    this.m_fightAnimation.addAnimationFor(attackType, raceType, this.m_enemyCards[animationStep.attackCardId], damageFrame, damageGroup, damageGroupHPBars, damagePercent, false);
                }

                //See if any card died in this round

                for( var i = 0; i < 3; ++i )
                {
                    if( damagePercent[i] == 1 )
                    {
                        this.m_fightAnimation.addAnimationFor( FightAnimation.DEAD, null, damageGroup[i] );
                    }
                }
            }
            this.m_fightAnimation.setFinishedAnimationCallback(this.finishBattleScene.bind(this));

            this.m_fightAnimation.executeFightAnimation();
        }
    },

    enterAnimationReady         : function()
    {
        info( "FightScene.enterAnimationReady called." );

        this.m_enterAnimationCounter++;
        if( this.m_enterAnimationCounter >= 9 ){
            this.m_enterAnimationReady      = true;

            this.hpBarsAppear();
            this.startBattle();
        }
    },

    serverDataReady             : function()
    {
        info( "FightScene.serverDataReady called." );
        this.m_serverReady              = true;

        this.startBattle();
    },

    finishBattleScene           : function()
    {
        info( "FightScene.finishBattleScene called." );
        this.skipButtonLink.setEnabled( false );
        
        var winSprite           = new GL2.Sprite();
        winSprite.setFrame(this.winLoseFrame.getFrame());

        if(this.m_battleData.playerWins)
        {
            winSprite.setImage("bfight_you_win.png");

            User.getUserData().stats.wins++;
        }
        else
        {
            winSprite.setImage("bfight_you_lose.png");
        }

        winSprite.setDepth(100000);

        this.getView().addChild(winSprite);

        winSprite.setPosition(-SCREEN_WIDTH*2, this.getView().getFrame()._origin._y/2);

        winSprite.runAction(
            Action.Sequence.actions(
                Action.MoveTo.actionWithDuration(1, new Core.Point(this.getView().getFrame()._origin._x/2, this.getView().getFrame()._origin._y/2)),
                Action.DelayTime.actionWithDuration(2),
                Action.CallFunc.actionWithTarget(this, this.changeScreenAfterBattle.bind(this))
            )
        );

    },

    changeScreenAfterBattle     : function()
    {
        info( "FightScene.changeScreenAfterBattle called." );

        GameController.playBgMusic();

        if( TutorialManager.getActiveStateId() == undefined )
        {
            GameController.getMainScreen().showButtons();
            GameController.getMainScreen().showPlayerInfo();
        }

        if( this.m_enemyDeck.length == 1 )
        {
            if( TutorialManager.getActiveStateId() != null )
            {
                TutorialManager.completeActiveState();
                if( TutorialManager.getActiveStateId() )
                {
                    TutorialManager.executeActiveStateAction();
                }
                return;
            }
            //var screen = new MissionSelectionScreen( this.m_enemyData.worldId, this.m_enemyData.stageId );
            Xib.Navigation.setModalOverlay(new WaitingScreen(function(){}));

            if( this.m_enemyData.dummyMission )
            {
                Server.getMissionState(this.m_enemyData.dummyMission,
                    function(error, data)
                    {
                        if(error)
                        {
                            err( "ExplorationScreenAnimated.endExplorationScreen Error. error=%s", JSON.stringify( error ) );
                            return;
                        }
                        if(data)
                        {
                            User.updateMissionState(this.m_enemyData.dummyMission, JSON.parse(data));
                            if( this.m_battleData.playerWins )
                            {
                                var stageBossRewards = this.m_battleData.stageBossRewards;
                                var screen = new BossLanding( stageBossRewards, this.m_enemyDeck[ 0 ], this.m_stageInfo );
                                Xib.Navigation.resetScreenStackTo( screen );
                            }
                            else
                            {
                                Xib.Navigation.popViewController();
                            }
                        }
                    }.bind(this)
                );
            }
            else
            {
                if( this.m_battleFinishCallback )
                {
                    this.m_battleFinishCallback( this.m_battleData );
                }
            }
            return;
        }
        else
        {
            var result, screen;
            if( this.m_battleData.playerWins )
            {
                result = VersusBattleFight.PLAYER_WON;
            }
            else
            {
                result = VersusBattleFight.ENEMY_WON;
            }
            
            this.m_enemyData.reward     = this.m_battleData.rewards;

            screen = new VersusBattleFight( this.m_enemyData, result, true );
            Xib.Navigation.resetScreenStackTo( screen, false );
        }
    },

    viewDidAppear: function()
    {
        info( "FightScene.viewDidAppear called." );

        Xib.Navigation.removeModalOverlay();

        if( TutorialManager.getActiveStateId() == undefined )
        {
            GameController.getMainScreen().hideButtons();
            GameController.getMainScreen().hidePlayerInfo();
        }
        else
        {
            GameController.getTutorialScreen().setVisibleTopFrame( false );
            GameController.getTutorialScreen().setVisibleBottomFrame( false );
        }
    },

    skipButton          : function()
    {
        this.skipButtonLink.setEnabled( false );
        info( "FightScene.skipButton called." );

        if( TutorialManager.getActiveStateId() != undefined )
        {
            info( "FightScene.skipButton returning. Button disabled on tutorial." );
            return;
        }

        for(var i = 0; i < this.m_playerCards.length; ++i)
        {
            this.m_playerCards[i].stopAllActions();

            for( var k = 0; k < this.m_playerCards[i]._children._length; ++k)
            {
                this.m_playerCards[i]._children[k].stopAllActions();
            }
        }

        for(var i = 0; i < this.m_enemyCards.length; ++i)
        {
            this.m_enemyCards[i].stopAllActions();

            for( var k = 0; k < this.m_enemyCards[i]._children._length; ++k)
            {
                this.m_enemyCards[i]._children[k].stopAllActions();
            }
        }

        for(var i=0; i < this.m_playerCards[0]._parent._children._length; ++i)
        {
            this.m_playerCards[0]._parent._children[i].stopAllActions();
        }
        
        this.playerUnit0.stopAllActions();
        this.playerUnit1.stopAllActions();
        this.playerUnit2.stopAllActions();
        
        this.enemyUnit0.stopAllActions();
        this.enemyUnit1.stopAllActions();
        this.enemyUnit2.stopAllActions();
        
        for(var i=0; i < this.playerUnit0._children._length; ++i)
        {
            this.playerUnit0._children[i].stopAllActions();
        }
        
        for(var i=0; i < this.playerUnit1._children._length; ++i)
        {
            this.playerUnit1._children[i].stopAllActions();
        }
        
        for(var i=0; i < this.playerUnit2._children._length; ++i)
        {
            this.playerUnit2._children[i].stopAllActions();
        }
        
        for(var i=0; i < this.enemyUnit0._children._length; ++i)
        {
            this.enemyUnit0._children[i].stopAllActions();
        }
        
        for(var i=0; i < this.enemyUnit1._children._length; ++i)
        {
            this.enemyUnit1._children[i].stopAllActions();
        }
        
        for(var i=0; i < this.enemyUnit2._children._length; ++i)
        {
            this.enemyUnit2._children[i].stopAllActions();
        }
        if( this.m_fightAnimation )
        {
            this.m_fightAnimation.cutFightAnimation();
        }
        this.finishBattleScene();
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/GashaResults'] = function(){var exports = $MODULE_REGISTRY['Code/UI/GashaResults'] || {}; $MODULE_REGISTRY['Code/UI/GashaResults'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/GashaResults.js';

exports.GashaResults = XibUI.subclass(
{

    classname: 'GashaResults',

    POD_MAX_ANGLE: 5,
    MOVEMENT_DURATION: 0.3,
    REGULAR_ANIMATION: "gasha_pod_text.png",
    PREMIUM_ANIMATION: "gold_pod_text.png",

    initialize: function( receivedCards, gashaId )
    {
        this.m_gashaId = gashaId;
        this.m_receivedCards = receivedCards;
        this.m_wasFirstCardShown = false;
        this.m_areCardsMoving = false;
        this.m_cardImage = null;
        this.m_nextCardImage = null;
        this.m_pod = null;
        this.m_podSound = null;
        this.m_animationUrl = this.REGULAR_ANIMATION;

        this.m_cardPreloadIndex = 0;
        this.m_cardIndex = 0;

        this.m_cardCenterPosition = null;
        this.m_cardInitialPosition = null;
        this.m_cardFinalPosition = null;

        info( "GashaResults.initialize called." );
        this.initWithXib( "./Content/Xib/GashaResults.xib", false );

        var gashaPack = GashaManager.getGashaPackById( gashaId );
        //TODO: "moba" should be a constant (need to check the rest of the classes )
        if( ( gashaPack != null ) && ( gashaPack.currency == "moba" ) )
        {
            this.m_animationUrl = this.PREMIUM_ANIMATION;
        }

        this.preloadNextCard();
    },

    viewDidLoad: function()
    {
        info( "GashaResults.viewDidLoad called." );

        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.hideCommunityButton();

            var overlayView = Xib.Navigation.getOverlayView();
            if( overlayView  )
            {
                if( overlayView.hidePlayerInfo )
                {
                    Xib.Navigation.getOverlayView().hidePlayerInfo();
                }
                if( overlayView.hideButtons )
                {
                    Xib.Navigation.getOverlayView().hideButtons();
                }
            }
        }

        fixCardRatio( this.cardOrigin );

        var remainingCards = 2;
        var onLoaded = function()
        {
            remainingCards--;
            if( remainingCards > 0)
            {
                return;
            }
            this.setupCardPositions();
            this.m_nextCardImage.getView().setPosition( this.m_cardInitialPosition.clone() );
            this.touchImage.setAlpha( 1 );
            this.touchLabel.setAlpha( 1 );
            this.continueButton.setEnabled( true );
        }.bind( this );

        this.touchImage.setAlpha( 0 );
        this.touchLabel.setAlpha( 0 );
        this.continueButton.setEnabled( false );

        var parent =  this.cardOrigin.getParent();
        this.m_cardImage = new GashaCardDisplay( this.cardOrigin.getFrame(), onLoaded );
        this.setupCard( this.m_cardImage );
        //this.m_cardImage.getView().setPosition( this.m_cardCenterPosition.clone() );
        this.m_cardImage.getView().setAlpha( 0 );
        parent.addChild( this.m_cardImage.getView() );

        this.m_nextCardImage = new GashaCardDisplay( this.cardOrigin.getFrame(), onLoaded );
        this.setupCard( this.m_nextCardImage );
        this.m_nextCardImage.getView().setAlpha( 0 );
        parent.addChild( this.m_nextCardImage.getView() );

        this.whiteScreen.setAlpha( 0 );

        this.setupPod();
    },

    viewDidAppear : function()
    {
        info( "GashaResults.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();
    },

    viewDidDisappear: function()
    {
        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        }
    },

    preloadNextCard: function()
    {
        info( "GashaResults.preloadNextCard called. preload card index: " + this.m_cardPreloadIndex );

        var onCardPreloaded = function()
        {
            info( "GashaResults.preloadNextCard. CARD PRELOADED! card index: " + this.m_cardPreloadIndex );

            if( this.getView()._destroyed == true )
            {
                return;
            }

            this.m_cardPreloadIndex++;
            this.preloadNextCard();
        }.bind( this );

        var card = this.m_receivedCards[ this.m_cardPreloadIndex ];
        if ( card == null )
        {
            info( "GashaResults.preloadNextCard. All cards loaded" );
            return;
        }
        CardsManager.loadCardImage( card.definitionId, IMAGE_SIZE.BIGGEST, onCardPreloaded );
    },

    setupCardPositions: function()
    {
        info( "GashaResults.setupCardPositions called.");
        var position = this.m_cardImage.getView().getPosition();
        var screenWidth = this.getView().getFrame()._size._width;

        this.m_cardCenterPosition = new Core.Point( position.getX(), position.getY() );
        this.m_cardInitialPosition = new Core.Point( ( position.getX() + screenWidth * 1.3 ), position.getY() );
        this.m_cardFinalPosition = new Core.Point( ( position.getX() - screenWidth * 1.3 ), position.getY() );
    },

    setupCard: function( cardImage )
    {
        info( "GashaResults.setupCard called. cardImage=%s", cardImage );

        /*var frame = this.cardOrigin.getFrame();
        var size = frame._size;
        var origin = frame._origin;
        var frameRatio = ( size._height / size._width );

        // Taller
        if( frameRatio > CARD_RATIO )
        {
            var newHeight = ( size._width * CARD_RATIO );
            cardImage.setFrame( origin._x, origin._y + (size._height - newHeight) / 2, size._width, newHeight );
        }
        else
        {
            var newWidth = ( size._height / CARD_RATIO );
            cardImage.setFrame(  origin._x + (size._width - newWidth)/2, origin._y, newWidth, size._height );
        }*/
        cardImage.getView().setDepth( this.cardOrigin.getDepth() );
    },

    setupPod: function()
    {
        info( "GashaResults.setupPod called.");
        var animation = ResourceManager.getAnimationFor( this.m_animationUrl );
        var frame = new GL2.Animation();
        frame.pushFrame( animation.getFrame(0) );
        frame.setLoopingEnabled( false );
        this.m_pod = new GL2.Sprite();
        this.m_pod.setAnimation( frame );
        this.getView().addChild( this.m_pod );
        this.m_pod.setDepth( -1 );
        this.m_pod.setPosition( 0, 0 );

        this.m_pod.setRotation( -this.POD_MAX_ANGLE );
        var rotatePod = function()
        {
            this.m_pod.stopAllActions();
            this.m_pod.runAction(
                Action.Sequence.actions(
                    Action.EaseInOutQuad.actionWithAction( Action.RotateTo.actionWithDuration( 7, this.POD_MAX_ANGLE ) ),
                    Action.EaseInOutQuad.actionWithAction( Action.RotateTo.actionWithDuration( 7, -this.POD_MAX_ANGLE ) ),
                    Action.CallFunc.actionWithTarget( null, rotatePod )
                )
            );
        }.bind( this );
        rotatePod();
        this.m_podSound = SoundManager.playSound(SoundManager.POD);
        this.m_podSound.setLoops( true );
    },

    loadFirstCard: function()
    {
        info( "GashaResults.loadFirstCard called.");
        var card = this.m_receivedCards[0];
        var definition = CardsManager.getCardDefinition( card.definitionId );
        this.m_cardImage.m_isNew = card.isNew;
        this.m_cardImage.refresh( definition, this.setFirstCard.bind(this), card.isNew );
        //CardsManager.loadCardImage( card.definitionId, IMAGE_SIZE.BIGGEST, this.setFirstCard.bind(this) );

        var secondCard = this.m_receivedCards[1];
        if( secondCard == null )
        {
            info( "GashaResults.loadFirstCard returning. secondCard=null" );
            return;
        }

        //ToDO: Spinner
        //this.m_nextCardImage.spinnerOn();
        var secondDefinition = CardsManager.getCardDefinition( secondCard.definitionId );
        this.m_nextCardImage.m_isNew = card.isNew;
        this.m_nextCardImage.getView().setAlpha( 1 );
        this.m_nextCardImage.getView().setPosition( this.m_cardInitialPosition.clone() );
        this.m_nextCardImage.refresh( secondDefinition );

        /*CardsManager.loadCardImage( secondCard.definitionId, IMAGE_SIZE.BIGGEST, function( imageUrl )
            {
                if( this.getView()._destroyed == true )
                {
                    return;
                }
                if( this.m_nextCardImage._cardId != secondCardId )
                {
                    return;
                }
                this.m_nextCardImage.spinnerOff();
                this.m_nextCardImage.setImage( imageUrl );
            }.bind( this)
        );*/
    },


    showNextCard: function()
    {
        info( "GashaResults.showNextCard called." );

        var onMovementFinished = function()
        {
            info( "GashaResults.showNextCard.onMovementFinished called." );

            //the card now in the center is the current card...
            var aux = this.m_nextCardImage;
            this.m_nextCardImage = this.m_cardImage;
            this.m_cardImage = aux;

            this.m_nextCardImage.getView().stopAllActions();
            this.m_cardImage.getView().stopAllActions();

            this.m_cardIndex++;

            this.m_nextCardImage.getView().setPosition( this.m_cardInitialPosition.clone() );
            var card = this.m_receivedCards[ this.m_cardIndex ];
            this.continueButton.setEnabled( true );
            this.touchImage.setAlpha( 1 );
            this.touchLabel.setAlpha( 1 );
            if( card == null )
            {
                info( "GashaResults.showNextCard.onMovementFinished...card does not exist." );
                return;
            }
            info( "GashaResults.showNextCard.onMovementFinished...updating with cardId= " + card.definitionId );
            var definition = CardsManager.getCardDefinition( card.definitionId );
            this.m_nextCardImage.m_isNew = card.isNew;
            this.m_nextCardImage.refresh( definition, null, card.isNew );
        }.bind( this );

        this.continueButton.setEnabled( false );
        this.touchImage.setAlpha( 0 );
        this.touchLabel.setAlpha( 0 );

        this.m_cardImage.getView().runAction( Action.MoveTo.actionWithDuration( this.MOVEMENT_DURATION, this.m_cardFinalPosition.clone() ) );
        this.m_nextCardImage.getView().runAction(
            Action.Sequence.actions(
                Action.MoveTo.actionWithDuration( this.MOVEMENT_DURATION, this.m_cardCenterPosition.clone() ),
                Action.CallFunc.actionWithTarget( null, onMovementFinished )
            )
        );


    },

    setFirstCard: function( imageUrl )
    {
        info( "GashaResults.setFirstCard called.");

        if( this.getView()._destroyed == true )
        {
            info( "GashaResults.setFirstCard returning. this.getView()._destroyed=true" );
            return;
        }
        this.m_cardImage.getView().setAlpha( 1 );

        this.m_cardImage.getView().setDepth( this.cardOrigin.getDepth() );

        var onAnimationFinished = function()
        {
            this.continueButton.setEnabled( true );
            this.touchImage.setAlpha( 1 );
            this.touchLabel.setAlpha( 1 );
            this.m_cardIndex++;
        }.bind( this );

       this.whiteScreen.runAction(
            Action.Sequence.actions(
                Action.FadeOut.actionWithDuration( 1 ),
                Action.CallFunc.actionWithTarget( null, onAnimationFinished )
            )
        );
        this.m_podSound.stop();
        this.m_podSound.destroy();
        SoundManager.playSound( SoundManager.OPEN );
    },

    continueAction: function( /* Xib.Button */inSender )
    {
        info( "GashaResults.continueAction called." );

        if( this.m_cardIndex == 0 )
        {
            this.playInitialAnimation();
        }
        else if( this.m_cardIndex < this.m_receivedCards.length )
        {
            this.showNextCard();
        }
        else
        {
            this.continueToDescription();
        }
    },

    playInitialAnimation: function()
    {
        info( "GashaResults.playInitialAnimation called." );
        var onAnimationFinished = function()
        {
            this.m_pod.stopAllActions();
            this.m_pod.setAlpha( 0 );
            this.loadFirstCard();
        }.bind( this );

        this.whiteScreen.runAction(
            Action.Sequence.actions(
                Action.DelayTime.actionWithDuration( 0.54 ),
                Action.FadeIn.actionWithDuration( 0.4 ),
                Action.DelayTime.actionWithDuration( 0.2 ),
                Action.CallFunc.actionWithTarget( null, onAnimationFinished )
            )
        );

        var animation = ResourceManager.getAnimationFor( this.m_animationUrl );
        animation.setLoopingEnabled( false );
        this.m_pod.setAnimation( animation );
        this.touchImage.setAlpha( 0 );
        this.touchLabel.setAlpha( 0 );


        this.continueButton.setEnabled( false );
        this.m_wasFirstCardShown = true;
    },

    continueToDescription: function()
    {
        info( "GashaResults.continueToDescription called.");
        this.m_pod.stopAllActions();
        this.getView().removeChild( this.m_pod );
        this.m_pod.destroy();

        if( TutorialManager.getActiveStateId() == TutorialManager.STATE_GASHA_ACQUIRED )
        {
            TutorialManager.executeActiveStateAction();
            return;
        }

        if( TutorialManager.getActiveStateId() == undefined )
        {
            var overlayView = Xib.Navigation.getOverlayView();
            if( overlayView   )
            {
                if( overlayView.showPlayerInfo )
                {
                    Xib.Navigation.getOverlayView().showPlayerInfo();
                }
                if( overlayView.showButtons )
                {
                    Xib.Navigation.getOverlayView().showButtons();
                }
            }
        }

        if(this.m_receivedCards.length > 1)
        {
            var card = this.m_receivedCards;
            info( "GashaResults.continueToDescription called. card=%s", JSON.stringify( card ) );

            var screen = null;

            var func = function()
            {
                if( !card )
                {
                    screen = new ControlRoom();
                }
                else
                {
    //                // Display only the card, without the user collection
    //                screen = new CardScreenInstance( card.id, null, "Gasha" );

                    console.log("GashaResults cards " + JSON.stringify( card ) );
                    screen = new MultiGasha( card, this.m_gashaId );
                }
                info( "GashaResults.backButton Screen Pushed: classname=" + screen.classname );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
        else
        {
            var card = this.m_receivedCards[0];
            info( "GashaResults.continueToDescription called. card=%s", JSON.stringify( card ) );

            var screen = null;

            var func = function()
            {
                if( !card )
                {
                    screen = new ControlRoom();
                }
                else
                {
    //                // Display only the card, without the user collection
    //                screen = new CardScreenInstance( card.id, null, "Gasha" );

                    console.log("GashaResults cards " + JSON.stringify( card ) );
                    screen = new SingleGasha( card, this.m_gashaId );
                }
                info( "GashaResults.backButton Screen Pushed: classname=" + screen.classname );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/LuckyChance'] = function(){var exports = $MODULE_REGISTRY['Code/UI/LuckyChance'] || {}; $MODULE_REGISTRY['Code/UI/LuckyChance'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/LuckyChance.js';

exports.LuckyChance = XibUI.subclass(
{
    classname: 'LuckyChance',

    NUMBER_OF_CARDS: 5,
    ANIMATION_TIME: 0.2,

    m_screenWidth: null,
    m_screenHeight: null,

    initialize: function( missionId, luckyId, callerCallback )
    {
        info( "LuckyChance.initialize called. missionId=%s, luckyId=%s", missionId, luckyId );

        this.m_cards = [];
        this.m_luckyId = luckyId;
        this.m_missionId = missionId;
        this.m_callerCallback = callerCallback;

        this.m_confirmationFromServer = false;
        this.m_luckyCardFromServer = null;
        this.m_remainingCards = 0;
        this.m_alreadyFlipped = false;
        this.m_cardsMoving = 0;
        this.m_luckyCards = QuestManager.getLuckyChanceDictionaries()[this.m_luckyId].cards;

        Server.doLuckyChance( this.m_missionId, this.m_luckyId, this.luckyChanceServerCallback.bind( this ) );

        this.initWithXib( "./Content/Xib/LuckyChance.xib", true );
    },

    viewDidLoad: function()
    {

        info( "LuckyChance.viewDidLoad called." );
        Social.Common.Service.hideCommunityButton();
        // Hide spinner
        Xib.Navigation.removeModalOverlay();

        this.xib_backButton.setVisible( false );
        this.xib_backButton.setEnabled( false );

        this._mapCards();
        this._setupCardsCallbacks();
        this.getCenter();
        this.moveCardsToStartPos( false );

        this.setCardsImages( this.startAnimation.bind( this ) );
    },

    viewDidDisappear: function()
    {
        if( TutorialManager.getActiveStateId() == undefined )
        {
            Social.Common.Service.showCommunityButton( UI.ViewGeometry.Gravity.TopRight );
        }
    },

    // TODO: Handle error from server
    // TODO: Handle error loading the image resource
    luckyChanceServerCallback: function( error, data )
    {
        info( "LuckyChance.luckyChanceServerCallback error=%s, data=%s",
                JSON.stringify( error ), JSON.stringify( data ) );
        this.m_luckyCardFromServer = JSON.parse( data );

        var cardImage = sprintf( "%s_%s.jpg", this.m_luckyCardFromServer.definitionId, IMAGE_SIZE.SMALL );
        ResourceManager.preLoadResource( cardImage,
            function()
            {
                info( "LuckyChance.luckyChanceServerCallback.preLoadResource called." );
            }.bind( this )
        );
    },

    _mapCards : function()
    {
        info( "LuckyChance._mapCards called." );
        var card, i, pos;

        for( i = 0; i < this.NUMBER_OF_CARDS; i++ )
        {
            card = eval( sprintf( "this.xib_card%d", i ) );
            pos  = card.getPosition();
            this.m_cards[i] = { "_card" : card };
            this.m_cards[i]._origPos = { "_x": pos._x, "_y": pos._y };
        }
    },

    _setupCardsCallbacks : function()
    {
        var i, callback;
        for( i = 0; i < this.m_cards.length; i++ )
        {
            callback = sprintf( "_cardClicked.bind( this._target, %d )", i );
            this.m_cards[i]._card.setTargetAction( this, callback );
//            this.m_cards[i]._card.setEnabled( false );
        }
    },

    xib_backButtonAction : function( /* Xib.Button */inSender )
    {
        info( "LuckyChance.xib_backButtonAction called." );
        Xib.Navigation.popViewController();

        this.m_callerCallback();
    },

    // TODO Handle errors
    // TODO add card to user deck
    /** Exposed Methods * */
    _cardClicked : function( cardPos, /* Xib.Button */inSender )
    {
        info("LuckyChance._cardClicked called. cardPos=%s", cardPos );
        var flipReady = function( _cardPos )
        {
            var luckyCard = this.m_luckyCards[_cardPos];
            info( "LuckyChance._cardClicked.flipReady luckyCard=%s", JSON.stringify( luckyCard ) );

            if( this.m_confirmationFromServer )
            {
                this.xib_backButton.setVisible( true );
                this.xib_backButton.setEnabled( true );
            }
        };

        var serverCallback = function( error, data )
        {
            info( "LuckyChance._cardClicked.serverCallback error=%s, data=%s",
                JSON.stringify( error ), JSON.stringify( data ) );

            if( error || data == undefined )
            {
                err( "LuckyChance._cardClicked.serverCallback Error 1 !" );
                return;
            }

            var _data = JSON.parse( data );
            var cardData = _data.card;
            
            info( "LuckyChance._cardClicked this.m_luckyCardFromServer :  "+JSON.stringify( this.m_luckyCardFromServer ) );

            if( cardData == undefined || cardData.definitionId != this.m_luckyCardFromServer.definitionId )
            {
                err( "LuckyChance._cardClicked.serverCallback Error 2 !" );
                return;
            }

            if( _data.collectionRewards )
            {
                if( _data.collectionRewards.rewards && _data.collectionRewards.lastRewardsByType )
                {
                    RewardManager.addReward( _data.collectionRewards );
                }
            }

            // Card added to the card collection in the server but not locally
            this.m_confirmationFromServer = true;

            // TODO Handle this error also
            CardsManager.addPlayerCard( cardData );

            if( cardData.inLimbo == true )
            {
                cardsInVaultPopUp(cardData);
            }


            this.xib_backButton.setVisible( true );
            this.xib_backButton.setEnabled( true )
        };

        if( this.m_cardsMoving == 0 && !this.m_alreadyFlipped )
        {
            this.m_alreadyFlipped = true;
            Server.confirmLuckyChance( this.m_luckyCardFromServer.id, serverCallback.bind( this ) );

            var cardImage = sprintf( "%s_%s.jpg", this.m_luckyCardFromServer.definitionId, IMAGE_SIZE.SMALL );
            this.flipCard( cardPos, null, flipReady.bind(this, cardPos), cardImage );
        }
        else
        {
            warn( "LuckyChance._cardClicked Warning, animation is not ready!" );
        }
    },

    setCardsImages: function( callback )
    {
        var i, cards, image, card, typeData;
        this.m_remainingCards = this.NUMBER_OF_CARDS;

        for( i = 0; i < this.NUMBER_OF_CARDS; i++ )
        {
            image = sprintf( "%s_%s.jpg", this.m_luckyCards[i].id, IMAGE_SIZE.SMALL );
            card = this.m_cards[i]._card;

            ResourceManager.preLoadResource( image, function( _card, _image )
            {
                info( "LuckyChance.setCardsImages.setImageCb called. image=%s", _image );
                _card.setImage( _image );

                this.m_remainingCards--;
                if( this.m_remainingCards == 0 )
                {
                    callback();
                }
            }.bind( this, card, image ) );
        }

    },

    getScreenWidth: function()
    {
        if( this.m_screenWidth == undefined )
        {
            var frame = this.view_inner.getFrame();
            this.m_screenWidth = frame._size._width;
        }

        info( "LuckyChance.getScreenWidth returning. this.m_screenWidth=%s", this.m_screenWidth );
        return this.m_screenWidth;
    },

    getScreenHeight: function()
    {
        if( this.m_screenHeight == undefined )
        {
            var frame = this.view_inner.getFrame();
            this.m_screenHeight = frame._size._height;
        }

        info( "LuckyChance.getScreenHeight returning. this.m_screenHeight=%s", this.m_screenHeight );
        return this.m_screenHeight;
    },

    getCenter: function()
    {
        var x       = this.getScreenWidth() / 2;
        var y       = this.getScreenHeight() / 2;
        var center  = new Core.Point( x, y );

        info( "LuckyChance.getCenter returning. point=%s", JSON.stringify( center ) );
        return center;
    },

    moveCardDelta: function( i, deltaX, deltaY )
    {
        info( "LuckyChance.moveCardDelta called. i=%s, deltaX=%s, deltaY=%s", i, deltaX, deltaY );
        var card = this.m_cards[i]._card;

        var oldFrame = card.getFrame().clone();
        var newFrame = card.getFrame().clone();

        newFrame._origin._x += deltaX;
        newFrame._origin._y += deltaY;

        info( "LuckyChance.moveCardDeltas oldFrame=%s, newFrame=%s", JSON.stringify( oldFrame ), JSON.stringify( newFrame ) );

        card.setFrame( newFrame );
    },

    moveCardsToStartPos: function( animated )
    {
        info( "LuckyChance.moveCardsToStartPos called." );


        // Move the cards from the first row to the right
        this.moveCardDelta( 0, this.getScreenWidth(), 0 );
        this.moveCardDelta( 1, this.getScreenWidth(), 0 );
        this.moveCardDelta( 2, this.getScreenWidth(), 0 );

        //Move the cards of the second row to the left
        this.moveCardDelta( 3, -this.getScreenWidth(), 0 );
        this.moveCardDelta( 4, -this.getScreenWidth(), 0 );
    },

    // Move first card to the left
    step1: function()
    {
        info( "LuckyChance.step1 called." );

        var card = this.m_cards[0]._card;
        var deltaPos = new Core.Point( -this.getScreenWidth(), 0 );

        card.runAction(
            Action.Sequence.actions(
                Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, deltaPos ),
                Action.CallFunc.actionWithTarget( this, this.step2.bind( this ) )
            )
        );
    },

    // Move second card to the left
    step2 : function()
    {
        info( "LuckyChance.step2 called." );

        var card = this.m_cards[1]._card;
        var deltaPos = new Core.Point( -this.getScreenWidth(), 0 );

        card.runAction(
            Action.Sequence.actions(
                Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, deltaPos ),
                Action.CallFunc.actionWithTarget( this, this.step3.bind( this ) )
            )
        );
    },

    // Move third card to the left and fourth card to the right
    step3 : function()
    {
        info( "LuckyChance.step3 called." );

        var card3 = this.m_cards[2]._card;
        var card4 = this.m_cards[3]._card;

        var deltaPos3 = new Core.Point( -this.getScreenWidth(), 0 );
        var deltaPos4 = new Core.Point(  this.getScreenWidth(), 0 );

        card3.runAction(
            Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, deltaPos3 )
        );

        card4.runAction(
            Action.Sequence.actions(
                Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, deltaPos4 ),
                Action.CallFunc.actionWithTarget( this, this.step4.bind( this ) )
            )
        );
    },

    step4 : function()
    {
        info( "LuckyChance.step4 called." );

        var card = this.m_cards[4]._card;
        var deltaPos = new Core.Point( this.getScreenWidth(), 0 );

        card.runAction(
            Action.Sequence.actions(
                Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, deltaPos ),
                Action.CallFunc.actionWithTarget( this, this.step5.bind( this ) )
            )
        );
    },

    step5 : function()
    {
        info( "LuckyChance.step5 called." );

        this.flipCard( 0, function()
            {
                this.flipCard( 1, function()
                    {
                        this.flipCard( 2, function()
                            {
                                this.flipCard( 3, function()
                                    {
                                        this.flipCard( 4, null, this.groupCards.bind( this ) );
                                    }.bind( this )
                                )
                            }.bind( this )
                        )
                    }.bind( this )
                )
            }.bind( this )
        );
    },

    bounceCard: function( node, deltaX, deltaY, callback )
    {
        info( "LuckyChance.bounceCard called. deltaX=%s, deltaY=%s", deltaX, deltaY );

        if( callback == undefined )
        {
            callback = function() { };
        }

        node.runAction(
            Action.Sequence.actions(
                Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, new Core.Point(  deltaX,  deltaY ) ),
                Action.MoveBy.actionWithDuration( this.ANIMATION_TIME, new Core.Point( -deltaX, -deltaY ) ),
                Action.CallFunc.actionWithTarget( this, callback )
            )
        );
    },

    enableButtons: function()
    {
        this.m_cardsMoving--;
        if( this.m_cardsMoving == 0 )
        {
            for( i = 0; i < this.m_cards.length; i++ )
            {
                this.m_cards[i]._card.setEnabled( true );
            }
        }
    },

    moveCardsOriginalPosition: function()
    {
        info( "LuckyChance.moveCardsOriginalPosition called." );
        var initialPos, i;

        for( i = 0; i < this.NUMBER_OF_CARDS; i++ )
        {
            initialPos = new Core.Point( this.m_cards[i]._origPos._x, this.m_cards[i]._origPos._y);

            this.m_cards[i]._card.runAction(
                Action.Sequence.actions(
                    Action.MoveTo.actionWithDuration( this.ANIMATION_TIME, initialPos ),
                    Action.CallFunc.actionWithTarget( this, this.enableButtons.bind( this ) )
                )
            );
        }
    },

    shuffleCards: function()
    {
        info( "LuckyChance.shuffleCards called." );

        this.bounceCard( this.m_cards[0]._card,  -150, 0, null );
        this.bounceCard( this.m_cards[1]._card,  -100, 0, null );
        this.bounceCard( this.m_cards[2]._card,   100, 0, null );
        this.bounceCard( this.m_cards[3]._card,   150, 0,
            function()
            {
                info( "LuckyChance.shuffleCards.innerCallback called." );
                this.moveCardsOriginalPosition();
            }.bind( this )
        );
    },

    groupCards: function()
    {
        info( "LuckyChance.groupCards called." );
//        var center = this.getCenter();
        var center = new Core.Point( 0, 0);

        for( var i = 0; i < this.NUMBER_OF_CARDS; i++ )
        {
            var card = this.m_cards[i]._card;
            if( i == 4 )
            {
                card.runAction(
                    Action.Sequence.actions(
                        Action.MoveTo.actionWithDuration( this.ANIMATION_TIME, center ),
                        Action.CallFunc.actionWithTarget( this, this.shuffleCards.bind( this ) )
                    )
                );
            }
            else
            {
                card.runAction( Action.MoveTo.actionWithDuration( this.ANIMATION_TIME, center ) );
            }
        }
    },

    flipCard: function( i, callback_half, callback_full, cardImage )
    {
        info( "LuckyChance.flipCard called." );

        var _changeCardImage = function( node, _cardImage )
        {
            var image = _cardImage;
            if( image == undefined )
            {
                image = sprintf( "%s_%s.jpg", DEFAULT_CARD_IMAGE, IMAGE_SIZE.SMALL );
            }
            node.setImage( image );
        };

        var card = this.m_cards[i]._card;

        if( callback_half == undefined )
        {
            callback_half = function() {};
        }
        if( callback_full == undefined )
        {
            callback_full = function() {};
        }

        card.runAction(
            Action.Sequence.actions(
                Action.ScaleTo.actionWithDuration( this.ANIMATION_TIME, 0, 1 ),
                Action.CallFunc.actionWithTarget(  this, _changeCardImage.bind( this, card, cardImage ) ),
                Action.CallFunc.actionWithTarget(  this, callback_half.bind( this ) ),
                Action.ScaleTo.actionWithDuration( this.ANIMATION_TIME, 1, 1 ),
                Action.CallFunc.actionWithTarget(  this, callback_full.bind( this ) )
            )
        );
    },



    startAnimation: function()
    {
        this.m_cardsMoving = 5;
        info( "LuckyChance.startAnimation called." );
        this.step1();
    },

    viewWillDisappear: function( /** bool */ inWillBeAnimated )
    {
        info( "LuckyChance.viewWillDisappear called." );
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/WaitingScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/WaitingScreen'] || {}; $MODULE_REGISTRY['Code/UI/WaitingScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/WaitingScreen.js';

exports.WaitingScreen           = XibUI.subclass
({
    classname               : "WaitingScreen",
    
    initialize              : function(cb)
    {
        this.initWithXib("./Content/Xib/WaitingScreen.xib", true);
        
        this.m_callback     = cb;
        
        this.m_destroyed    = false;
    },
    
    viewDidLoad             : function()
    {
        if( this.m_destroyed )
        {
            warn( "Waiting window previously destroyed, stoping exec of viewDidLoad" );
            
            this.getView().destroy();
            
            return;
        }
        
        this.m_wheel            = new GL2.Sprite();
        this.m_wheel.setFrame(this.waitingWheelFrame.getFrame());
        this.m_wheel.setImage("loading_m.png");
        this.getView().addChild(this.m_wheel);
        this.m_wheel.setDepth(200000);
        this.getView().setDepth(100000);
        
        this.m_wheelUpdater     = new Core.MessageListener();
        Core.UpdateEmitter.addListener( this.m_wheelUpdater , this.onUpdate.bind( this ));
        
        if(this.m_callback)
        {
            this.m_callback();
        }
    },
    
    onUpdate                : function()
    {
        this.m_wheel.setRotation(this.m_wheel._rotation + 2);
    },
    
    destroy                 : function()
    {
        this.m_destroyed    = true;
        
        if( this.m_wheelUpdater )
        {
            Core.UpdateEmitter.removeListener( this.m_wheelUpdater );
            this.m_wheelUpdater.destroy();
        }
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/WaitingSprite'] = function(){var exports = $MODULE_REGISTRY['Code/UI/WaitingSprite'] || {}; $MODULE_REGISTRY['Code/UI/WaitingSprite'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/WaitingSprite.js';

exports.WaitingSprite = GL2.Sprite.subclass(
{
    classname: "WaitingSprite",

    initialize: function( $super, parent )
    {
        $super();
        parentSize = parent.getFrame()._size;
        var frameSize = Math.min( parentSize._width, parentSize._height );
        this.setFrame( new Core.Rect( ( parentSize._width - frameSize ) / 2, ( parentSize._height - frameSize ) / 2, frameSize, frameSize ) );
        this.setImage( "loading_m.png" );
        parent.addChild( this );
        this.setDepth( 200000 );

        this.m_wheelUpdater = new Core.MessageListener();
        Core.UpdateEmitter.addListener( this.m_wheelUpdater, this.onUpdate.bind( this ) );
    },

    onUpdate: function()
    {
        this.setRotation( this._rotation + 2 );
    },

    destroy: function()
    {
        Core.UpdateEmitter.removeListener( this.m_wheelUpdater );
        this.m_wheelUpdater.destroy();
        this._destroyed = true;
    }
} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/FusionComplete'] = function(){var exports = $MODULE_REGISTRY['Code/UI/FusionComplete'] || {}; $MODULE_REGISTRY['Code/UI/FusionComplete'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/FusionComplete.js';

exports.FusionComplete = ScrollableView.subclass(
{
    classname: "FusionComplete",

    // Data should be in the form: {definitionId: "", old_xp: "", new_xp:""}
    initialize: function( $super, data )
    {
        info( "FusionComplete.initialize called data=%s", JSON.stringify( data ) );

        this.m_cardDefinition = null;
        this.m_progressBar = null;

        this.m_newCardInstance = null;
        this.m_oldCardInstance = null;
        this.m_newCardStatus = null;
        this.m_oldCardStatus = null;

        this.initWithXib( "./Content/Xib/FusionComplete.xib", false );

        this.m_cardDefinition = CardsManager.getCardDefinition( data.definitionId );

        this.m_oldCardInstance =
        {
            "id": -1,
            "definitionId": data.definitionId,
            "xp": data.old_xp,
        };

        this.m_newCardInstance =
        {
            "id": -1,
            "definitionId": data.definitionId,
            "xp": data.new_xp
        };

        this.m_oldCardStatus = CardsManager.getCardStatus( this.m_oldCardInstance );
        this.m_newCardStatus = CardsManager.getCardStatus( this.m_newCardInstance );

        var backFunction = function()
        {
            var func = function()
            {

                var screen = new CardFusionBaseSelection();
                screen.m_cardsLoaded = true;
                screen._getUserCards();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );

        $super();
    },

    viewDidLoad: function( $super )
    {
        $super();
        this._setCardImage();
        this._setCardName();
        this._setCardRarity();
        this._setStatus();
        this._setStatusDelta();
        this._setLevel();
        this._setProgress();

        if( TutorialManager.getActiveStateId() != null &&
            TutorialManager.getActiveStateId() == TutorialManager.STATE_FUSION_RESULTS)
        {
            this.completeButton.setEnabled(false);
            this.completeButton.setAlpha( 0 );
        }

    },

    _setCardImage: function()
    {
        if( this.cardImage && this.cardImage.setImage )
        {
            this.cardImage.spinnerOn();
            CardsManager.loadCardImage( this.m_cardDefinition.id, IMAGE_SIZE.BIGGEST, function( imageUrl )
            {
                if( this.cardImage._destroyed )
                {
                    return;
                }
                this.cardImage.spinnerOff();
                this.cardImage.setImage( imageUrl );
            }.bind( this ) );
        }
    },

    _setCardName: function()
    {
        if( this.cardName && this.cardName.setText )
        {
            this.cardName.setText( _loc( CardsManager.getCardName( this.m_cardDefinition.id ) ) );
        }
    },

    _setCardRarity: function()
    {
        if( this.cardRarity && this.cardRarity.setText )
        {
            this.cardRarity.setText( _loc( RARITY_TEXT[this.m_cardDefinition.rarity] ) );
        }
    },

    _setStatus: function()
    {
        switch( this.m_cardDefinition.type )
        {
            case PILOT:
                if( this.stats1old && this.stats1old.setText )
                    this.stats1old.setText( "" + Math.floor(this.m_newCardStatus.status1 * 100) + "%"  );

                if( this.stats2old && this.stats2old.setText )
                    this.stats2old.setText( "" + Math.floor(this.m_newCardStatus.status2 * 100) + "%"  );

                if( this.stats3old && this.stats3old.setText )
                    this.stats3old.setText( "" + Math.floor(this.m_newCardStatus.status3 * 100) + "%"  );
                break;

            case GEAR:
                if( this.stats1old && this.stats1old.setText )
                    this.stats1old.setText( sprintf( "%d", this.m_newCardStatus.status1 ) );

                if( this.stats2old && this.stats2old.setText )
                    this.stats2old.setText( sprintf( "%d", this.m_newCardStatus.status2 ) );

                if( this.stats3old && this.stats3old.setText )
                    this.stats3old.setText( sprintf( "%d", this.m_newCardStatus.status3 ) );
                break;
        }
    },

    _setStatusDelta: function()
    {
        var delta1 = this.m_newCardStatus.status1 - this.m_oldCardStatus.status1;
        var delta2 = this.m_newCardStatus.status2 - this.m_oldCardStatus.status2;
        var delta3 = this.m_newCardStatus.status3 - this.m_oldCardStatus.status3;

        switch( this.m_cardDefinition.type )
        {
            case PILOT:
                if( this.stats1new && this.stats1new.setText )
                    this.stats1new.setText( "(+" + Math.floor(delta1 * 100) + "%)");

                if( this.stats2new && this.stats2new.setText )
                    this.stats2new.setText( "(+" + Math.floor(delta1 * 100) + "%)");

                if( this.stats3new && this.stats3new.setText )
                    this.stats3new.setText( "(+" + Math.floor(delta1 * 100) + "%)");
                break;
            case GEAR:
                if( this.stats1new && this.stats1new.setText )
                    this.stats1new.setText( sprintf( "(+%d)", delta1 ) );

                if( this.stats2new && this.stats2new.setText )
                    this.stats2new.setText( sprintf( "(+%d)", delta2 ) );

                if( this.stats3new && this.stats3new.setText )
                    this.stats3new.setText( sprintf( "(+%d)", delta3 ) );
                break;
        }
    },

    _setLevel: function()
    {
        if( this.cardLevel && this.cardLevel.setText )
        {
            this.cardLevel.setText( CardsManager.getCardLevel( this.m_newCardInstance ) );
        }

        if( this.levelOld && this.levelOld.setText )
        {
            this.levelOld.setText( CardsManager.getCardLevel( this.m_oldCardInstance ) );
        }

        if( this.levelNow && this.levelNow.setText )
        {
            this.levelNow.setText( CardsManager.getCardLevel( this.m_newCardInstance ) );
        }
    },

    _setProgress: function()
    {
        var progress = CardsManager.getXpPercentage( this.m_newCardInstance, true );

        if( this.progressBar )
        {
            this.m_progressBar = new ProgressBar( "Content/Xib/ProgressBar.xib", progress, this.progressBar.getFrame(), false );
            this.progressBar.addChild( this.m_progressBar.getView() );
        }
        if( this.xpLabel && this.xpLabel.setText )
        {
            this.xpLabel.setText( Math.floor( progress * 100 ) + "%" );
        }
    },

    gotoFusionScreen: function( /* button */inSender )
    {
        this.m_progressBar.destroy();
        var func = function()
        {
            var screen = new CardFusionBaseSelection();
            screen.m_cardsLoaded = true;
            screen._getUserCards();
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/NoEnergyScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/NoEnergyScreen'] || {}; $MODULE_REGISTRY['Code/UI/NoEnergyScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/NoEnergyScreen.js';

exports.NoEnergyScreen = XibUI.subclass(
{
        classname : 'NoEnergyScreen',

        initialize: function()
        {
            this.initWithXib( "./Content/Xib/NoEnergyScreen.xib", true );
        },

        viewDidLoad: function()
        {

        },

        viewDidAppear: function()
        {
            Xib.Navigation.removeModalOverlay();
        },

        goToItemScreen: function(/*button*/ inSender)
        {
            var func = function()
            {
                var screen = new ItemStore();
                Xib.Navigation.resetScreenStackTo(screen, false);
            };
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardDisplay'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardDisplay'] || {}; $MODULE_REGISTRY['Code/UI/CardDisplay'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardDisplay.js';

exports.CardDisplay = XibUI.subclass(
{
    classname: 'CardDisplay',

    /**
     * CardDisplay.initialize
     */
    initialize: function( cb, cardScreen, frame )
    {
        this.m_cardDefinition = null;
        this.m_currentCardId = null;
        this.m_isShowingDetails = true;
        this.m_Cb = cb;
        this.m_cardScreen = cardScreen;
        this.m_SpecialCardDisplay = null;
        this.m_frame = frame;
        this.m_detailViewHiddenPos = null;
        this.m_detailViewShownPos = null;

        info( "CardDisplay.initialize called." );

        this.initWithXib( "./Content/Xib/CardDisplay.xib", true );
    },

    viewDidLoad: function()
    {
        info( "CardDisplay.viewDidLoad called." );

        this._fixCardRatio();
        this._setupSpecialCard();
        this.m_animationDistance = 1.5 * (
            this.detailView.getPosition().getY() - Xib.Navigation.getOverlayView().buttonsViewContainer.getPosition().getY() );
        this._setupDetailView();
        this._setupDetailViewPositions();
        this.flipDetailsVisibility( null, true );

        if( this.m_Cb )
        {
            this.m_Cb();
        }
    },

    _setupSpecialCard : function()
    {
        info( "CardDisplay._setupSpecialCard, called." );

        this.m_SpecialCardDisplay = new SpecialCard( this.m_frame );
        var parent = this.mainCardButton.getParent();
        parent.addChild( this.m_SpecialCardDisplay );

        this.m_SpecialCardDisplay.setDepth( this.mainCardButton.getDepth() - 0.1 );
        this.m_SpecialCardDisplay.setPosition( this.mainCardButton.getPosition() );
    },

    _setupDetailViewPositions: function()
    {
        var pos = this.detailView.getPosition();
        var distance = this.detailView.getFrame()._size._height;
        this.m_detailViewShownPos = new Core.Point( pos.getX(), pos.getY() );
        this.m_detailViewHiddenPos = new Core.Point( pos.getX(), ( pos.getY() + distance ) );
    },

    _setupDetailView : function()
    {
        info( "CardDisplay._setupDetailView, called." );

        var cardFrame = this.m_frame;
        var cardOrigin = cardFrame._origin;
        var cardHeight = cardFrame._size._height;
        var cardWidth = cardFrame._size._width;
        //Note: in ngCrunch, buttons have the anchor on (0,0)
        
        var detailFrame = this.detailView.getFrame();
        var ratio = ( detailFrame._size._height / detailFrame._size._width );
        var newWidth = cardFrame._size._width;
        var newHeight = ( ratio * newWidth );
        var newX = cardOrigin._x;
        var newY = cardOrigin._y + cardHeight - newHeight;
        this.detailView.setFrame( newX, newY, newWidth, newHeight );
       
        var parent = this.detailView.getParent();
        var cardCorner1 = this.mainCardButton.localToScreen( new Core.Point( 0, 0 ) );
        var cardCorner2 = this.mainCardButton.localToScreen( new Core.Point( cardWidth, cardHeight ) );
        this.detailView.setClipRectEnabled( true );
        this.detailView.setClipRect( 0,
                                     cardCorner1.getY(),
                                     SCREEN_WIDTH,
                                     ( cardCorner2.getY() - cardCorner1.getY() ) );

    },

    _fixCardRatio : function()
    {
        info( "CardDisplay._fixCardRatio, called." );

        var size, origin, frameRatio;

        // Scale the card to keep the correct ratio
        size        = this.m_frame._size;
        origin      = this.m_frame._origin;
        frameRatio  = size._height / size._width;

        this.mainCardButton.setFrame( origin._x, origin._y, size._width, size._height );
    },

    // TODO FIXME fix the xib to remove this method
    showHideDetails : function( isSender )
    {
        info( "CardDisplay.showHideDetails called." + this.m_cardScreen );
        this.m_cardScreen.showHideDetails();
    },

    flipDetailsVisibility : function( isSender, notAnimated )
    {
        info( "CardDisplay.flipDetailsVisibility called." );
        var time = 0.5;

        // FIXME this method is ugly and the following line is not better...
        if( notAnimated == true )
        {
            time = 0;
        }

        if( this.m_isShowingDetails )
        {
            this.detailView.runAction( Action.MoveTo.actionWithDuration( time, this.m_detailViewHiddenPos ) );
            this.m_isShowingDetails = false;
        }
        else
        {
            this.detailView.runAction( Action.MoveTo.actionWithDuration( time, this.m_detailViewShownPos ) );
            this.m_isShowingDetails = true;
        }
    },

    refreshDetails: function()
    {
        info( "CardDisplay.refreshDetails called." );
        this.setUIStatus( this.getCardStatus() );
        this.setUICardLevel( this.getCardLevel() );
        this.setUISellingPrice( this.getSellingPrice() );
        this.setUICardDescription( this.m_cardDefinition.description );
        this.setUICardName( this.m_cardDefinition.name );
        this.setUICardOwnedAmount( this.getOwnedCardNumber() );
    },

    refreshVisuals: function( cb )
    {
        info( "CardDisplay.refreshVisuals called." );
        this.mainCardButton.setImage( "1pxalpha0.png" );
        this.mainCardButton.spinnerOn();
        this.m_SpecialCardDisplay.setVisible( false );

        if ( this.m_cardDefinition.rarity != RARITY.superRare )
        {
            this.refreshCardImage( cb );
        }

        //always calling refresh on special card to remove the listener when the card is not special
        this.m_SpecialCardDisplay.refresh( this.m_cardDefinition, function( error )
        {
            if ( this.m_cardDefinition.rarity != RARITY.superRare )
            {
                //if the card is not special, refreshCardImage
                //calls onCardLoaded, so we just return
                return;
            }

            if ( error )
            {
                //In case we dont find the frames for the special card, we show the regular card
                info("CardScreen.refresh._innerCallback: missing special card assets, loading regular image");
                this.refreshCardImage( cb );
            }
            else
            {
                this.onCardLoaded();
                this.m_SpecialCardDisplay.setVisible( true );
                //setting the button visible (but without assets) to make it clickable
                this.mainCardButton.setImage( "1pxalpha0.png" );
                this.mainCardButton.setVisible( true );
                if( cb )
                {
                    cb();
                }
            }
        }.bind( this ) );
    },

    refreshCardImage : function( cb )
    {
        this.m_currentCardId = this.m_cardDefinition.id;
        var cardDefinitionId = this.m_cardDefinition.id;
        CardsManager.loadCardImage( cardDefinitionId, IMAGE_SIZE.BIGGEST, function( imageURL )
        {
            if( this.mainCardButton._destroyed )
            {
                return;
            }
            //to check if the loaded card is actually the current card
            if( cardDefinitionId != this.m_currentCardId )
            {
                return;
            }
            this.onCardLoaded();
            this.mainCardButton.setVisible( true );

            this.mainCardButton.setImage( imageURL );
            if( cb )
            {
                cb();
            }
        }.bind( this ) );
    },

    onCardLoaded : function()
    {
        this.mainCardButton.spinnerOff();
    },

    setUIStatus : function( status )
    {
        info( "CardDisplay.setUIStatus called. status=%s", JSON.stringify( status ) );

        if( status != undefined && status[0] != undefined )
        {
            this.firstDetailLabel.setText( status[0] );
        }
        else
        {
            this.firstDetailLabel.setText( "?" );
        }

        if( status != undefined && status[1] != undefined )
        {
            this.secondDetailLabel.setText( status[1] );
        }
        else
        {
            this.secondDetailLabel.setText( "?" );
        }

        if( status != undefined && status[2] != undefined )
        {
            this.thirdDetailLabel.setText( status[2] );
        }
        else
        {
            this.thirdDetailLabel.setText( "?" );
        }
    },

    setUISellingPrice : function( price )
    {
        info( "CardDisplay.setUISellingPrice called. price=%s", price );
        this.salePrice.setText( price );
    },

    setUICardOwnedAmount : function( amount )
    {
        info( "CardDisplay.setUICardOwnedAmount called. amount=%s", amount );
        this.owned.setText( amount );
    },

    setUICardDescription : function( description )
    {
        info( "CardDisplay.setUICardDescription called. description=%s", description );
        this.textDetailLabel.setText( _loc( description ) );
    },
    
    setUICardName : function( name )
    {
        info( "CardDisplay.setUICardDescription called. name=%s", name );
        this.nameLabel.setText( _loc( name ) );
    },

    setUICardLevel : function( level )
    {
        info( "CardDisplay.setUICardLevel called. level=%s", level );
        this.maxLevel.setText( level );
    },

    getOwnedCardNumber : function( definitionId )
    {
        var definitionId = this.m_cardDefinition.id;
        info( "CardDisplay.getOwnedCardNumber called. definitionId=%s", definitionId );
        var filteredCards, filter, amount;

        filter =
        {
            "definitionId" : definitionId
        };
        filteredCards = CardsManager.getFilteredPlayerCards( filter );
        amount = filteredCards.length;

        info( "CardDisplay.getOwnedCardNumber returning. definitionId=%s, amount=%s", definitionId, amount );
        return amount;
    },

    getCardLevel: function()
    {
        return this.m_cardDefinition.maxLevel;
    },

    // @override
    getCardStatus : function()
    {
        err( "CardDisplay.getCardStatus called. ERROR Need to override this method!" );
        return [ "-1", "-1", "-1" ];
    },

    // @override
    getSellingPrice : function()
    {
        err( "CardDisplay.getSellingPrice called. ERROR Need to override this method!" );
        return 0;
    },

    destroy : function( $super )
    {
        //ToDo: Check why this method isnt called
        info( "CardDisplay.destroy called");
        if( this.m_SpecialCardDisplay && this.m_SpecialCardDisplay.destroy )
        {
            this.m_SpecialCardDisplay.destroy();
        }
        $super();
        info( "CardDisplay.destroy done");
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardDisplayInstance'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardDisplayInstance'] || {}; $MODULE_REGISTRY['Code/UI/CardDisplayInstance'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardDisplayInstance.js';

exports.CardDisplayInstance = CardDisplay.subclass(
    {
        classname: 'CardDisplayInstance',

        /**
         * CardDisplayInstance.initialize
         */
        initialize: function( $super, cb, cardScreen, frame )
        {
            $super( cb, cardScreen, frame );
            this.m_Cb = cb;
            this.m_cardInstance;

            info( "CardDisplayInstance.initialize called." );

            this.initWithXib( "./Content/Xib/CardDisplay.xib", true );
        },

        refreshWithInstance: function( cardInstance, cardDefinition, cb )
        {
            info( "CardDisplayInstance.refreshWithDefinition called" );
            if( !cardInstance )
            {
                this.getView().setAlpha( 0 );
                info( "CardDisplay.refreshWithDefinition... null instance" );
                return;
            }
            this.getView().setAlpha( 1 );

            if( this.m_cardInstance == cardInstance )
            {
                return;
            }
            this.m_cardInstance = cardInstance;
            this.m_cardDefinition = cardDefinition;
            this.refreshDetails();
            this.refreshVisuals( cb );
        },

        // @override
        getCardStatus : function()
        {
            var cardDefinition = CardsManager.getCardDefinition( this.m_cardInstance.definitionId );
            var cardStatus = CardsManager.getCardStatus( this.m_cardInstance );
            var rtval = [ cardStatus.status1, cardStatus.status2, cardStatus.status3 ];

            switch( cardDefinition.type )
            {
                case PILOT:
                    rtval[0] = "" + Math.floor(rtval[0]*100) + "%";
                    rtval[1] = "" + Math.floor(rtval[1]*100) + "%";
                    rtval[2] = "" + Math.floor(rtval[2]*100) + "%";
                    break;

                case GEAR:
                    break;

                default:
                    break;
            }

            info( "CardScreenInstance.getCardStatus returning. rtval=%s", JSON.stringify( rtval ) );
            return rtval;
        },

        // @override
        getSellingPrice : function()
        {
            var sellingPrice = CardsManager.getCardSellingPrice( this.m_cardInstance );

            info( "CardScreenInstance.getSellingPrice returning. sellingPrice=%s", sellingPrice );
            return sellingPrice;
        }

    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/CardDisplayDefinition'] = function(){var exports = $MODULE_REGISTRY['Code/UI/CardDisplayDefinition'] || {}; $MODULE_REGISTRY['Code/UI/CardDisplayDefinition'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/CardDisplayDefinition.js';

exports.CardDisplayDefinition = CardDisplay.subclass(
    {
        classname: 'CardDisplayDefinition',

        /**
         * CardDisplayDefinition.initialize
         */
        initialize: function( $super, cb, cardScreen, frame )
        {
            $super( cb, cardScreen, frame );
            this.m_Cb = cb;

            info( "CardDisplayDefinition.initialize called." );

            this.initWithXib( "./Content/Xib/CardDisplay.xib", true );
        },

        refreshWithDefinition: function( cardDefinition, cb )
        {
            info( "CardDisplay.refreshWithDefinition called" );
            if( !cardDefinition )
            {
                this.getView().setAlpha( 0 );
                info( "CardDisplay.refreshWithDefinition... null definition" );
                return;
            }
            this.getView().setAlpha( 1 );

            if( this.m_cardDefinition == cardDefinition )
            {
                return;
            }
            this.m_cardDefinition = cardDefinition;
            this.refreshDetails();
            this.refreshVisuals( cb );
        },

        // @override
        getCardStatus : function()
        {
            var cardStatus = this.m_cardDefinition.statusInit;
            var rtval = [ cardStatus.status1, cardStatus.status2, cardStatus.status3 ];

            if(this.m_cardDefinition.type == PILOT)
            {
                rtval[0] = "" + Math.floor(rtval[0]*100) + "%";
                rtval[1] = "" + Math.floor(rtval[1]*100) + "%";
                rtval[2] = "" + Math.floor(rtval[2]*100) + "%";
            }

            info( "CardScreenDefinition.getCardStatus returning. rtval=%s", JSON.stringify( rtval ) );
            return rtval;
        },

        // @override
        getSellingPrice : function()
        {
            var sellingPrice = CardsManager.getCardMaxSellingPrice( this.m_cardDefinition );

            info( "CardScreenDefinition.getSellingPrice returning. sellingPrice=%s", sellingPrice );
            return sellingPrice;
        }
    }
);; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/TutorialLayerUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI/TutorialLayerUI'] || {}; $MODULE_REGISTRY['Code/UI/TutorialLayerUI'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/TutorialLayerUI.js';

exports.TutorialLayerUI = XibUI.subclass(
    {
        classname : 'TutorialLayerUI',

        initialize : function( visible )
        {
            info( "TutorialLayerUI.initialize called. visible=%s", visible );

            this.m_visible = visible;

            this.m_topFrameVisible = true;
            this.m_bottomFrameVisible = true;
            this.m_progressBar = null;
            this.m_bottomViewPosition = null;
            this.m_continueFunction = null;

            this.initWithXib( "./Content/Xib/TutorialLayerUI.xib", false );

            this.setAllowTapPassthrough( true );
        },

        viewDidLoad : function()
        {
            info( "TutorialLayerUI.viewDidLoad called." );

            var tutorialView    = this.getView();
            var mainScreen      = GameController.getMainScreen();
            var mainScreenView  = mainScreen.getView();

            // Hack to scale the tutorialLayer to the mainscreen
            mainFrame = mainScreenView.getFrame();
            tutorialView.setFrame( mainFrame );
            mainScreenView.addChild( tutorialView );

            var pos = this.xib_viewBottom.getPosition();
            this.m_bottomViewPosition = new Core.Point( pos.getX(), pos.getY() );
            this.xib_viewBottom.setPosition( this.m_bottomViewPosition );

            this.setVisibleTopFrame( this.m_visible );
            this.setVisibleBottomFrame( this.m_visible );

            this.m_progressBar = new ProgressBar( "./Content/Xib/MainScreenProgressBar.xib", 0, this.xib_viewProgressBar.getFrame() );
            this.xib_viewProgressBar.addChild( this.m_progressBar.getView() );

            ///////////////////////////////////////////////////
            // DEBUGGING SHOWING IMAGES FOR GUIDANCE
//            this.xib_topHudMarker.setImage( "1pxgreen.png" );
//            this.xib_topHudMarker.setAlpha( 0.4 );
//            this.xib_topHudMarker.setDepth( 1000 );
//            this.xib_bottomHudMarker.setImage( "1pxgreen.png" );
//            this.xib_bottomHudMarker.setAlpha( 0.4 );
//            this.xib_bottomHudMarker.setDepth( 1000 );
            ///////////////////////////////////////////////////

            this._setClipping();

            if( TutorialManager.getActiveStateId() )
            {
                TutorialManager.executeActiveStateAction();
            }
            else
            {
                err( "TutorialLayerUI.viewDidLoad Error: the Tutorial has ended, TutorialManager should not be used " );
            }
        },

        setProgress: function( value )
        {
            info( "TutorialLayerUI.setProgress called. value=%s", value );

            this.m_progressBar.updateProgress( value );
        },

        getTopFrame: function()
        {
            var frame = this.xib_viewTutorial.getFrame();
            return frame;
        },

        getTopHeight: function()
        {
            var height;
            try
            {
                var frame = this.getTopFrame();
                height = frame.getSize().getHeight();
                if( DEBUG_SCROLLABLE_VIEW )
                {
                    info( "TutorialLayerUI.getTopHeight frame=%s", JSON.stringify( frame ) );
                }
            }
            catch( ex )
            {
                err( "TutorialLayerUI.getTopHeight Error, cannot get xib_viewTutorial height! ex=%s", JSON.stringify( ex ) );
                height = 0;
            }

            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "TutorialLayerUI.getTopHeight returning. height=%s", height );
            }
            return height;
        },

        getBottomFrame : function()
        {
            var frame = this.xib_viewBottom.getFrame();
            return frame;
        },

        getBottomHeight: function()
        {
            var height;
            try
            {
                var frame = this.getBottomFrame();
                height = frame.getSize().getHeight();
                if( DEBUG_SCROLLABLE_VIEW )
                {
                    info( "TutorialLayerUI.getBottomHeight frame=%s", JSON.stringify( frame ) );
                }
            }
            catch( ex )
            {
                err( "TutorialLayerUI.getBottomHeight Error, cannot get xib_viewBottom height! ex=%s", JSON.stringify( ex ) );
                height = 0;
            }

            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "TutorialLayerUI.getBottomHeight returning. height=%s", height );
            }
            return height;
        },

        getTopHudHeight: function()
        {
            var frame = this.getTopHudFrame();
            var height = frame.getSize()._height;
            return height;
        },

        getTopHudFrame: function()
        {
            var frame = this.xib_topHudMarker.getFrame();
            return frame;
        },

        getBottomHudHeight : function()
        {
            var frame = this.getBottomHudFrame();
            var height = frame.getSize()._height;
            return height;
        },

        getBottomHudFrame: function()
        {
            return this.xib_bottomHudMarker.getFrame();
        },

        // This should move all childrens of view instead of moving only the viewScroller.
        adjustScrollableViewHeight: function( scrollableView )
        {
            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "TutorialLayerUI.adjustScrollableViewHeight called." );
            }

            var viewScroller = scrollableView.view_scroller;
            if( viewScroller == undefined )
            {
                err( "TutorialLayerUI.adjustScrollableViewHeight Error, cannot get scrollableView.view!" );
                return;
            }

            // Move scroll view down
            var topTutorialHeight;
            if( this.m_topFrameVisible )
            {
                topTutorialHeight = this.getTopHeight();
            }
            else
            {
                topTutorialHeight = 0;
            }
            var topHudHeight = this.getTopHudHeight();
            var deltaTop = topTutorialHeight - topHudHeight;

            var oldPosition = viewScroller.getPosition().clone();
            viewScroller.setPosition( new Core.Point(0, deltaTop + oldPosition._y ) );

            var newPosition = viewScroller.getPosition();

            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "TutorialLayerUI.adjustScrollableViewHeight oldPosition=%s, newPosition=%s",
                    JSON.stringify( oldPosition ), JSON.stringify( newPosition ) );
            }

            // Reduce scroll view bottom
            var bottomTutorialHeight;
            if( this.m_bottomFrameVisible )
            {
                bottomTutorialHeight = this.getBottomHeight();
            }
            else
            {
                bottomTutorialHeight = 0;
            }
            var bottomHudHeight = this.getBottomHudHeight();
            var deltaBottom = bottomTutorialHeight - bottomHudHeight;

            var viewScrollerFrame = viewScroller.getFrame();
            var newSize = viewScrollerFrame.getSize().clone();
            var oldSize = viewScrollerFrame.getSize().clone();
            newSize._height -= ( deltaTop + deltaBottom ) + 100;

            // TODO FIXME HACK ! This should be handled by ScrollableView! (fbarriga)
//            viewScroller.m_frameBottom -= (deltaTop + deltaBottom );
            viewScrollerFrame.setSize( newSize );


            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "TutorialLayerUI.adjustScrollableViewHeight oldSize=%s, newSize=%s",
                    JSON.stringify( oldSize ), JSON.stringify( newSize ) );
            }
        },

        _setClipping : function()
        {
            info( "TutorialLayerUI._setClipping called." );

            var topFrame  = this.getTopFrame();
            var topOrigin = this.xib_viewTutorial.localToScreen( new Core.Point( 0, 0 ) );
            var topDest   = this.xib_viewTutorial.localToScreen( new Core.Point( topFrame._size._width, topFrame._size._height ) );

            var bottomFrame  = this.getBottomFrame();
            var bottomOrigin = this.xib_viewBottom.localToScreen( new Core.Point( 0, 0 ) );
            var bottomDest   = this.xib_viewBottom.localToScreen( new Core.Point( bottomFrame._size._width, bottomFrame._size._height ) );

//            warn("TutorialLayerUI._setClipping bottomFrame=%s", JSON.stringify( bottomFrame ) );
//            warn("TutorialLayerUI._setClipping bottomDest=%s", JSON.stringify( bottomDest ) );
            // Used?
//
//            if( topOrigin._x == undefined || topOrigin._y == undefined || topDest._x == undefined || topDest._y == undefined )
//            {
//                err( "TutorialLayerUI._setClipping Error, cannot get topOrigin or topDest!" );
//                screenClipRectTop = new Core.Rect( 0, 0, 100, 100 );
//                screenClipRectFoot = new Core.Rect( 100, 100, 100, 100);
//                screenClipRect = new Core.Rect( 200, 200, 500, 500);
//                return;
//            }
//
            screenClipRectTop = new Core.Rect( topOrigin._x, topOrigin._y, topDest._x, topDest._y );
            screenClipRectFoot = new Core.Rect( bottomOrigin._x, bottomOrigin._y, bottomDest._x, bottomDest._y );

            var contentX1 = 0;
            var contentX2 = topDest._x;//topFrame._size._width; // TODO hardcoded VALUE!
            var contentY1 = topDest._y - topOrigin._y;
            var contentY2 = bottomOrigin._y - contentY1;
//            var contentY2 = contentY1 + bottomFrame._origin._y;

            if( DEBUG_CLIPPING )
            {
                info("TutorialLayerUI._setClipping contentX1=%s", contentX2);
                info("TutorialLayerUI._setClipping contentY1=%s", contentY1);
                info("TutorialLayerUI._setClipping contentY1=%s", contentY1);
                info("TutorialLayerUI._setClipping contentY2=%s", contentY2);

                info("TutorialLayerUI._setClipping topOrigin=%s", JSON.stringify( topOrigin ) );
                info("TutorialLayerUI._setClipping topDest=%s", JSON.stringify( topDest ) );

                info("TutorialLayerUI._setClipping bottomOrigin=%s", JSON.stringify( bottomOrigin ) );
                info("TutorialLayerUI._setClipping bottomDest=%s", JSON.stringify( bottomDest ) );
            }

            screenClipRect = new Core.Rect( contentX1, contentY1, contentX2, contentY2 );
        },


        // TODO FIXME Currently is blocked.
        setTutorialTopLabel: function( text )
        {
            info( "TutorialLayerUI.setTutorialTopLabel called. text=%s", text );

            text = _loc( "TUTORIAL PROGRESS" );
            try
            {
                this.xib_labelTopBanner.setText( text );
            }
            catch( ex )
            {
                err( "TutorialLayerUI.setTutorialTopLabel Error, cannot set text. ex=%s", JSON.stringify( ex ) );
            }
        },

        setTutorialBottomLabel : function( text )
        {
            info( "TutorialLayerUI.setTutorialBottomLabel called. text=%s", text );

            try
            {
                this.xib_continueButton.setText( text );
            }
            catch( ex )
            {
                err( "TutorialLayerUI.setTutorialBottomLabel Error, cannot set text. ex=%s", JSON.stringify( ex ) );
            }
        },

        setContinueAction: function( continueFunction )
        {
            info( "TutorialLayerUI.setContinueAction called. continueFunction=%s", continueFunction );
            this.m_continueFunction = continueFunction;
        },

        continueAction: function()
        {
            info( "TutorialLayerUI.continueAction called. continueFunction" );
            if( this.m_continueFunction )
            {
                this.m_continueFunction();
            }
        },

        setTutorialText : function( text )
        {
            info( "TutorialLayerUI.setTutorialText called. text=%s", text );

            try
            {
                this.xib_labelTutorialText.setText( text );
            }
            catch( ex )
            {
                err( "TutorialLayerUI.setTutorialText Error, cannot set text. ex=%s", JSON.stringify( ex ) );
            }
        },

        setCardImage : function( image )
        {
            info( "TutorialLayerUI.setCardImage called. image=%s", image );

            /*try
            {
                this.xib_imageCard.setImage( image );
            }
            catch( ex )
            {
                err( "TutorialLayerUI.setCardImage Error, cannot set text. ex=%s", JSON.stringify( ex ) );
            }*/
        },

        setVisibleTopFrame : function( visible )
        {
            info( "TutorialLayerUI.setVisibleTopFrame called. visible=%s", visible );
            if( visible )
            {
                this.xib_viewTutorial.setAlpha( 1 );
                this.xib_viewTutorial.setVisible( true );
            }
            else
            {
                this.xib_viewTutorial.setAlpha( 0 );
                this.xib_viewTutorial.setVisible( false );
            }
        },

        setVisibleBottomFrame: function( visible )
        {
            info( "TutorialLayerUI.setVisibleBottomFrame called. visible=%s", visible );
            if( visible )
            {
                this.xib_viewBottom.setPosition( this.m_bottomViewPosition );
            }
            else
            {
                this.xib_viewBottom.setPosition( this.m_bottomViewPosition.getX(), this.m_bottomViewPosition.getY() + this.xib_viewBottom.getFrame()._size._height );
            }
        },

        destroy : function()
        {
            this.m_progressBar.destroy();
        },

        hideButtons: function()
        {
            info( "TutorialLayerUI.hideButtons called. Dummy method." );
            this.setVisibleBottomFrame( false );
        },

        showButtons: function()
        {
            info( "TutorialLayerUI.showButtons called. Dummy method." );
            this.setVisibleBottomFrame( true );
        },

        hidePlayerInfo: function()
        {
            info( "TutorialLayerUI.hidePlayerInfo called. Dummy method." );
            this.setVisibleTopFrame( false );
        },

        showPlayerInfo: function()
        {
            info( "TutorialLayerUI.showPlayerInfo called. Dummy method." );
            this.setVisibleTopFrame( true );
        }
    }
);
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/EnemyDeck'] = function(){var exports = $MODULE_REGISTRY['Code/UI/EnemyDeck'] || {}; $MODULE_REGISTRY['Code/UI/EnemyDeck'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/EnemyDeck.js';

exports.EnemyDeck = ScrollableView.subclass(
{
    classname: 'EnemyDeck',

    FIGHTER_OFFSET : 0, // First column
    SHOOT_OFFSET   : 1, // Second column
    MANEUVER_OFFSET: 2, // Third column

    m_viewLoaded: false,
    m_cardsLoaded: false,
    m_UIPopulated: false,

    DEFAULT_CARD_IMAGE: 'democard.jpg',
    REGULAR_TEXT_COLOR: new Core.Color( ( 164/255 ), ( 224/255 ), ( 237/255 ) ),
    RED_TEXT_COLOR: new Core.Color( ( 255/255 ), ( 124/255 ), ( 124/255 ) ),
    GREEN_TEXT_COLOR: new Core.Color( ( 1/255 ), ( 255/255 ), ( 1/255 ) ),

    initialize: function( $super, enemyData)
    {
        info( "EnemyDeck.initialize called. >>> "+JSON.stringify( enemyData ) );
        $super();
        
        //EnemyData
        this.m_enemyData        = enemyData;

        this.m_views = [];
        this.m_cards = [];
        this.m_numViews = 9;

        var backFunction = function()
        {
            var func = function()
            {
                var screen = new VersusBattleFight( this.m_enemyData, null, true );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind(this);
            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }.bind(this);
        ScreenManager.setBackInfo(backFunction);


        this._loadCards();
        this.initWithXib( "./Content/Xib/EnemyDeck.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "EnemyDeck.viewDidLoad called." );
        $super();

        this.m_viewLoaded = true;
        this._mapViews();
        this._mapElements();
        this._mapActions();
        this._populateUI();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton(NO_SCREEN);
        
        this.enemyName.setText( sprintf( _loc( "enemy_deck_title_%s" ), this.m_enemyData.name ) );
    },

    viewButtonEvent: function( opts, inSender )
    {
        info( "EnemyDeck.viewButtonEvent called. opts=%s", JSON.stringify( opts ) );

        var type        = null;
        var position    = ~~( opts.button / 3 ); // ~~() equals Math.floor()

        if( opts.button % 3 == 0 )
        {
            type = DeckManager.FIGHTER;
        }
        else if( opts.button % 3 == 1 )
        {
            type = DeckManager.SHOOTER;
        }
        else if( opts.button % 3 == 2 )
        {
            type = DeckManager.MANEUVER;
        }
        else
        {
            err( "EnemyDeck.viewButtonEvent Error, cannot identify the position of the card! opts=%s", JSON.stringify( opts ) );
            type        = null;
            position    = -1;
        }

        info( "EnemyDeck.viewButtonEvent type=%s, position=%d", type, position );
    },

    _drawCards: function()
    {
        info( "EnemyDeck._drawCards this.m_cards: " + this.m_cards );

        if( this.m_cardsLoaded && this.m_viewLoaded )
        {
            this._setPairsOfCards( this.FIGHTER_OFFSET, this.m_cards[ DeckManager.FIGHTER ] );
            this._setPairsOfCards( this.SHOOT_OFFSET, this.m_cards[ DeckManager.SHOOTER ] );
            this._setPairsOfCards( this.MANEUVER_OFFSET, this.m_cards[ DeckManager.MANEUVER ] );
        }
    },

    _setPairsOfCards: function( offset, pairs )
    {
        var status = null;

        switch( offset )
        {
            case this.FIGHTER_OFFSET:
                status = DeckManager.FIGHTER;
                break;
            case this.SHOOT_OFFSET:
                status = DeckManager.SHOOTER;
                break;
            case this.MANEUVER_OFFSET:
                status = DeckManager.MANEUVER;
                break;
        }

        this._setCard( offset + 0, pairs[0]['gearDefinitionId'], pairs[0]['pilotDefinitionId'], pairs[0]['gearXp'], pairs[0]['pilotXp'], status, 1 );
        this._setCard( offset + 3, pairs[1]['gearDefinitionId'], pairs[1]['pilotDefinitionId'], pairs[1]['gearXp'], pairs[1]['pilotXp'], status, 2 );
        this._setCard( offset + 6, pairs[2]['gearDefinitionId'], pairs[2]['pilotDefinitionId'], pairs[2]['gearXp'], pairs[2]['pilotXp'], status, 3 );
    },

    _loadCards: function()
    {
        this.m_cards        = this.m_enemyData.deck;
        this.m_cardsLoaded  = true;
        this._populateUI();
    },

    _populateUI: function()
    {
        if( this.m_cardsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;
            this._drawCards();

        }
    },

    _mapViews: function()
    {
        info( "EnemyDeck._mapViews called." );

        for( var i = 0; i < this.m_numViews; i++ )
        {
            var view = eval( sprintf( "this.item_%d", i ) );
            this.m_views[i] = {"_view" : view };
        }
    },

    _mapElements: function()
    {
        info( "EnemyDeck._mapElements called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var view = this.m_views[i];

            this.m_views[i]._button   = view._view.nodeWithTag( 1000 );
            this.m_views[i]._leftImg  = view._view.nodeWithTag( 1001 );
            this.m_views[i]._rightImg = view._view.nodeWithTag( 1002 );
            this.m_views[i]._value1   = view._view.nodeWithTag( 1003 );
            this.m_views[i]._value2   = view._view.nodeWithTag( 1004 );
        }
    },

    _mapActions: function()
    {
        info( "EnemyDeck._mapActions called. this.m_views.length=%s", this.m_views.length );

        for( var i = 0; i < this.m_views.length; i++ )
        {
            var callback = sprintf( "viewButtonEvent.bind(this._target, {'button':%d})", i );

            this.m_views[i]._button.setTargetAction( this, callback );
        }
    },

    _setCard: function( cellIndex, gearId, pilotId, gearXP, pilotXP, status, position )
    {
        info( "EnemyDeck._setCard called. cellIndex=%d, gearId=%d, pilotId=%d", cellIndex, gearId, pilotId );

        var view, gearCard, pilotCard, leftImage, rightImage;

        if( cellIndex < 0 || cellIndex >= this.m_numViews )
        {
            err( "EnemyDeck._setCard Error, position out of bounds: cellIndex=", cellIndex );
            return false;
        }

        view = this.m_views[cellIndex];
        if( view === null )
        {
            err( "EnemyDeck._setCard Error, view not loaded: cellIndex=%d", cellIndex );
            return false;
        }

        leftImage = this.DEFAULT_CARD_IMAGE;
        if( gearId >= 0 )
        {
            view._leftImg.spinnerOn();
            if( gearId )
            {
                leftImage = sprintf( gearId + "_" + IMAGE_SIZE.SMALL + ".jpg" );
            }
        }

        rightImage = this.DEFAULT_CARD_IMAGE;
        if( pilotId >= 0 )
        {
            view._rightImg.spinnerOn();
            if( pilotId )
            {
                rightImage = sprintf( pilotId + "_" + IMAGE_SIZE.SMALL + ".jpg" );
            }
        }

        CardsManager.loadCardImage( gearId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( view._leftImg._destroyed )
            {
                return;
            }
            info( "CardCollection.getCardSlot.button.setImageCb.innerCallback called. leftImage=%s", imageURL );
            view._leftImg.setImage( imageURL );
            view._leftImg.spinnerOff();
        }.bind( view, leftImage ) );

        CardsManager.loadCardImage( pilotId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( view._rightImg._destroyed )
            {
                return;
            }
            info( "CardCollection.getCardSlot.button.setImageCb.innerCallback called. leftImage=%s", imageURL );
            view._rightImg.setImage( imageURL );
            view._rightImg.spinnerOff();
        }.bind( view, rightImage ) );

        var unitPower = null;
        if( pilotId && gearId )
        {
            unitPower = CardsManager.getAttackAndHPWithStatus( CardsManager.getUnitStatus_with_Definition_XP( pilotId, gearId, pilotXP, gearXP ) , position, status);
            view._value1.setText( Math.floor( unitPower.attack ) + "" );
            view._value2.setText( Math.floor( unitPower.hp ) + "" );
        }
        else
        {
            view._value1.setText( "1" );
            view._value2.setText( "1" );
        }

        view._value1.setColor( this.REGULAR_TEXT_COLOR );
        view._value2.setColor( this.REGULAR_TEXT_COLOR );

    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/PurchaseConfirmationScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/PurchaseConfirmationScreen'] || {}; $MODULE_REGISTRY['Code/UI/PurchaseConfirmationScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/PurchaseConfirmationScreen.js';

exports.PurchaseConfirmationScreen = XibUI.subclass(
{
        classname: 'PurchaseConfirmationScreen',

        m_dummyData: {
            "id" : 1,
            "title" : "Test Item",
            "price" : 100,
            "amount": 2,
            "description": "This is a test item",
            "oldTotal": 0,
            "importantInfo" : "This is really important!"
        },

        initialize: function(data, hasMobacoin)
        {
            this.m_purchaseData = null;
            this.m_moveElements = false;

            this.initWithXib("./Content/Xib/PurchaseConfirmationScreen.xib", true);

            if (!data)
                this.m_purchaseData = this.m_dummyData;
            else
                this.m_purchaseData = data;

            this.m_moveElements = !hasMobacoin;
        },

        viewDidLoad: function()
        {
            this.setConfirmationData();
            this.setMoreInfoData();
            this.setImportantData();
            this.moveElements();
        },

        moveElements: function()
        {
            if (!this.m_moveElements) return;

            console.log("zzz Exce");
            this.priceContainer.setVisible(false);
            this.mobacoinsButtonContainer.setVisible(true);
            this.purchaseButton.setVisible(false);
            var newPos = this.mobacoinsButtonContainer.getPosition().getY() + this.mobacoinsButtonContainer.getFrame().getSize().getHeight() / 2;
            newPos += this.infoContainer.getFrame().getSize().getHeight() / 2;
            this.infoContainer.setPosition(0, newPos);
        },

        setImportantData: function()
        {
            if (this.importantInfoLabel && this.importantInfoLabel.setText)
                this.importantInfoLabel.setText(this.m_purchaseData.importantInfo);
        },

        setMoreInfoData: function()
        {
            if ( this.descriptionLabel && this.descriptionLabel.setText )
                this.descriptionLabel.setText(this.m_purchaseData.description);

            if (this.quantityLabel && this.quantityLabel.setText)
                this.quantityLabel.setText(sprintf("%d -> %d", this.m_purchaseData.oldTotal, this.m_purchaseData.oldTotal + this.m_purchaseData.amount));

            if (this.priceLabel && this.priceLabel.setText)
            {
                var price = "";
                if (this.m_purchaseData.amount > 1) price = sprintf("%d each", this.m_purchaseData.price);
                else price = sprintf("%d", this.m_purchaseData.price);
                this.priceLabel.setText(price);
            }
        },

        setConfirmationData: function()
        {
            if (this.itemTitle && this.itemTitle.setText)
                this.itemTitle.setText(this.m_purchaseData.title);

            if (this.itemAmount && this.itemAmount.setText)
                this.itemAmount.setText(sprintf("(x%d)", this.m_purchaseData.amount));

            if (this.goldCost && this.goldCost.setText)
                this.goldCost.setText(sprintf("%d", this.m_purchaseData.amount * this.m_purchaseData.price ));
        },

        viewDidAppear: function()
        {
            Xib.Navigation.removeModalOverlay();
        },

        doPurchase: function(/*button*/ inSender)
        {
            info( "PurchaseConfirmationScreen.doPurchase called" );
        }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/TutorialExplanationScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/TutorialExplanationScreen'] || {}; $MODULE_REGISTRY['Code/UI/TutorialExplanationScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/TutorialExplanationScreen.js';

exports.TutorialExplanationScreen = XibUI.subclass(
{
    classname: 'TutorialExplanationScreen',

    initialize: function( titleText, descriptionText, buttonText, backgroundImageUrl, cb )
    {
        info( "TutorialExplanationScreen.initialize called. titleText=%s, descriptionText=%s, buttonText=%s, backgroundImageUrl=%s",
            JSON.stringify( titleText ), JSON.stringify( descriptionText ), JSON.stringify( buttonText ), JSON.stringify( backgroundImageUrl ) );

        this.m_titleText = titleText;
        this.m_buttonText= buttonText;
        this.m_descriptionText = descriptionText;
        this.m_backgroundImageUrl = backgroundImageUrl;
        this.m_cb = cb;

        this.initWithXib( "./Content/Xib/TutorialExplanationScreen.xib", false );
    },

    viewDidLoad: function()
    {
        info( "TutorialExplanationScreen.viewDidLoad called." );
        this._setUI();
        GameController.getTutorialScreen().getView().setVisible( false );
    },

    _setUI: function()
    {
        info( "TutorialExplanationScreen._setUI called." );

        if( this.m_titleText )
        {
            this.titleLabel.setText( this.m_titleText );
        }

        if( this.m_backgroundImageUrl )
        {
            this.background.setImage( this.m_backgroundImageUrl );
        }

        if( this.m_descriptionText )
        {
            this.descriptionLabel.setText( _loc( this.m_descriptionText ) );
        }

        if ( this.m_titleText || this.m_descriptionText )
        {
            GameController.getTutorialScreen().setVisibleTopFrame( true );
        }
        else
        {
            GameController.getTutorialScreen().setVisibleTopFrame( false );
        }

        if( this.m_buttonText )
        {
            GameController.getTutorialScreen().setVisibleBottomFrame( true );
            //this.continueButton.setText( this.m_buttonText )
        }
        else
        {
            GameController.getTutorialScreen().setVisibleBottomFrame( false );
        }
    },

    refresh: function( titleText, descriptionText, buttonText, backgroundImageUrl, cb )
    {
        info( "TutorialExplanationScreen.refresh called." );
        this.m_titleText = titleText;
        this.m_buttonText= buttonText;
        this.m_descriptionText = descriptionText;
        this.m_backgroundImageUrl = backgroundImageUrl;
        this.m_cb = cb;
        this._setUI();
    },

    continueAction: function()
    {
        info( "TutorialExplanationScreen.continueAction called." );

//        Xib.Navigation.setModalOverlay(
//            new WaitingScreen(
//                function()
//                {
                    if( this.m_cb )
                    {
                        this.m_cb();
                    }
//                }.bind( this )
//            )
//        );
    },

    viewDidDisappear: function()
    {
        info( "TutorialExplanationScreen.viewDidDisappear called." );
        GameController.getTutorialScreen().getView().setVisible( true );
        TutorialExplanationAction.clearExplanationScreen();
    },

    viewDidAppear : function()
    {
        info( "TutorialExplanationScreen.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/TutorialPictureScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/TutorialPictureScreen'] || {}; $MODULE_REGISTRY['Code/UI/TutorialPictureScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/TutorialPictureScreen.js';

exports.TutorialPictureScreen = XibUI.subclass(
{
    classname: 'TutorialPictureScreen',

    initialize: function( buttonText, imageUrl, cb )
    {
        info( "TutorialPictureScreen.initialize called. this.getActiveStateId()=%s", JSON.stringify( TutorialManager.getActiveStateId() ) );

        this.m_buttonText = buttonText;
        this.m_imageUrl = imageUrl;
        this.m_cb = cb;
        this.initWithXib( "./Content/Xib/TutorialPictureScreen.xib", false );

        this._updateTutorialScreen();
    },

    viewDidLoad: function()
    {
        info( "TutorialPictureScreen.viewDidLoad called. this.getActiveStateId()=%s", JSON.stringify( TutorialManager.getActiveStateId() ) );
        this._setUI();
    },

    _updateTutorialScreen: function()
    {
        info( "TutorialPictureScreen._updateTutorialScreen called." );
        var tutorialScreen = GameController.getTutorialScreen();

        if( tutorialScreen )
        {
            tutorialScreen.setVisibleBottomFrame( false );
            tutorialScreen.setTutorialBottomLabel( this.m_buttonText );
            tutorialScreen.setContinueAction( this.m_cb );
        }
    },


    _setUI: function()
    {
        info( "TutorialPictureScreen._setUI called." );

        this._updateTutorialScreen();

        if( this.m_imageUrl )
        {
            this.image.setImage( this.m_imageUrl );
        }

        var tutorialScreen = GameController.getTutorialScreen();
        if( this.m_buttonText && tutorialScreen )
        {
            tutorialScreen.setVisibleBottomFrame( true );
        }
        else
        {
            tutorialScreen.setVisibleBottomFrame( false );
        }

    },

    refresh: function( buttonText, imageUrl, cb )
    {
        info( "TutorialPictureScreen.refresh called. this.getActiveStateId()=%s", JSON.stringify( TutorialManager.getActiveStateId() ) );
        this.m_buttonText = buttonText;
        this.m_imageUrl = imageUrl;
        this.m_cb = cb;
        this._setUI();
    },

    viewDidDisappear: function()
    {
        info( "TutorialPictureScreen.viewDidDisappear called. this.getActiveStateId()=%s", JSON.stringify( TutorialManager.getActiveStateId() ) );
        TutorialPictureAction.clearPictureScreen();
    },

    viewDidAppear : function()
    {
        info( "TutorialPictureScreen.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/SkillsDetails'] = function(){var exports = $MODULE_REGISTRY['Code/UI/SkillsDetails'] || {}; $MODULE_REGISTRY['Code/UI/SkillsDetails'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/SkillsDetails.js';

exports.SkillsDetails   = ScrollableView.subclass(
{
    classname           : 'SkillsDetails',

    initialize          : function( pilotId, gearId, backcb )
    {
        info("SkillsDetails.initialize called. pilotId: " + pilotId );
        
        this.m_pilotId          = pilotId;
        this.m_gearId           = gearId;
        this.m_backCallback     = backcb;
        
        this.m_skills           = CardsManager.getCardDefinition( this.m_pilotId ).skillId;
        
        this.m_activeSkillsInfo = CardsManager.getSkillsFromUnit( this.m_pilotId, this.m_gearId );
        this.m_activeSkills     = [];
        
        for(var i = 0; i < this.m_activeSkillsInfo.length; ++i)
        {
            this.m_activeSkills.push( this.m_activeSkillsInfo[i].name );
        }
        
        this.initWithXib( "./Content/Xib/SkillsDetails.xib", true );
    },
    
    viewDidLoad         : function($super)
    {
        info("SkillsDetails.viewDidLoad called.");
        
        $super();
        
        var backFunction = function()
        {
             Xib.Navigation.popViewController();
        }.bind( this );
        ScreenManager.setBackInfo( backFunction );        
        this.loadSkillsInfo();
    },
    
    loadSkillsInfo      : function()
    {
        for(var i = 0; i < 4; ++i)
        {
           
            var view        = eval( sprintf( "this.skill%d" , i ) );
            
            if( this.m_skills[i] < 0 )
            {
                view.setVisible(false);
                continue;
            }
            
            var skillInfo   = SkillsManager.getSkillById( this.m_skills[i] );


            view.nodeWithTag( 42000 ).setText( _loc( skillInfo.name ) );
            view.nodeWithTag( 42001 ).setText( _loc( skillInfo.description ) );
            
            if( this.m_activeSkills.indexOf( skillInfo.name ) >= 0 )
            {
                view.nodeWithTag( 42002 ).setText( "ENABLED" );
                view.nodeWithTag( 42002 ).setColor( 1, 228/255, 207/255 );
                view.nodeWithTag( 42004 ).setImage( "deck_skillbox_active.png" );
            }
            else
            {
                view.nodeWithTag( 42002 ).setText( "DISABLED" );
                view.nodeWithTag( 42002 ).setColor( 107/255, 214/255, 240/255 );
                view.nodeWithTag( 42004 ).setImage( "deck_skillbox_inactive.png" );
            }
            
            view.nodeWithTag( 42003 ).setImage( skillInfo.img+".png" );
            
        }
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/StarterPackConfirmation'] = function(){var exports = $MODULE_REGISTRY['Code/UI/StarterPackConfirmation'] || {}; $MODULE_REGISTRY['Code/UI/StarterPackConfirmation'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/StarterPackConfirmation.js';

exports.StarterPackConfirmation = ScrollableView.subclass(
{
    classname: 'StarterPackConfirmation',

    initialize: function( $super, deck, deckIndex )
    {
        info( "StarterPackConfirmationScreen.initialize called." );
        $super();
        this.initWithXib( "./Content/Xib/StarterPackConfirmation.xib", false );

        this.m_deck = deck;
        this.m_deckIndex = deckIndex;
    },

    viewDidLoad: function( $super )
    {
        info( "StarterPackConfirmation.viewDidLoad called." );
        $super();
        this.m_viewLoaded = true;
        this._populateUI();

        var tutorialScreen = GameController.getTutorialScreen();
        tutorialScreen.setTutorialText( _loc( "tutorial_select_pack_confirm" ) );
    },

    _populateUI: function()
    {
        info( "StarterPackConfirmation._populateUI called." );

        this._populateGear();
        this._populatePilots();
    },

    _populatePilots: function()
    {
        this.pilotsView.nodeWithTag( 1 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status1[0].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 1 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 1 ).spinnerOff();
            this.pilotsView.nodeWithTag( 1 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 2 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status1[1].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 2 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 2 ).spinnerOff();
            this.pilotsView.nodeWithTag( 2 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 3 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status1[2].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 3 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 3 ).spinnerOff();
            this.pilotsView.nodeWithTag( 3 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 4 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status2[0].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 4 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 4 ).spinnerOff();
            this.pilotsView.nodeWithTag( 4 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 5 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status2[1].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 5 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 5 ).spinnerOff();
            this.pilotsView.nodeWithTag( 5 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 6 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status2[2].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 6 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 6 ).spinnerOff();
            this.pilotsView.nodeWithTag( 6 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 7 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status3[0].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 7 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 7 ).spinnerOff();
            this.pilotsView.nodeWithTag( 7 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 8 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status3[1].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 8 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 8 ).spinnerOff();
            this.pilotsView.nodeWithTag( 8 ).setImage( imageURL );
        }.bind( this ) );

        this.pilotsView.nodeWithTag( 9 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status3[2].pilot, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.pilotsView.nodeWithTag( 9 )._destroyed )
            {
                return;
            }
            this.pilotsView.nodeWithTag( 9 ).spinnerOff();
            this.pilotsView.nodeWithTag( 9 ).setImage( imageURL );
        }.bind( this ) );
    },

    _populateGear: function()
    {
        this.gearView.nodeWithTag( 1 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status1[0].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 1 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 1 ).spinnerOff();
            this.gearView.nodeWithTag( 1 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 2 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status1[1].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 2 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 2 ).spinnerOff();
            this.gearView.nodeWithTag( 2 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 3 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status1[2].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 3 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 3 ).spinnerOff();
            this.gearView.nodeWithTag( 3 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 4 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status2[0].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 4 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 4 ).spinnerOff();
            this.gearView.nodeWithTag( 4 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 5 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status2[1].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 5 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 5 ).spinnerOff();
            this.gearView.nodeWithTag( 5 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 6 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status2[2].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 6 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 6 ).spinnerOff();
            this.gearView.nodeWithTag( 6 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 7 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status3[0].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 7 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 7 ).spinnerOff();
            this.gearView.nodeWithTag( 7 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 8 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status3[1].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 8 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 8 ).spinnerOff();
            this.gearView.nodeWithTag( 8 ).setImage( imageURL );
        }.bind( this ) );

        this.gearView.nodeWithTag( 9 ).spinnerOn();
        CardsManager.loadCardImage( this.m_deck.status3[2].gear, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.gearView.nodeWithTag( 9 )._destroyed )
            {
                return;
            }
            this.gearView.nodeWithTag( 9 ).spinnerOff();
            this.gearView.nodeWithTag( 9 ).setImage( imageURL );
        }.bind( this ) );
    },

    back: function( sender )
    {
        info( "StarterPackConfirmation.back called." );
        var screen = new StarterPackSelection();
        Xib.Navigation.resetScreenStackTo( screen, false );
    },

    confirm: function( sender )
    {
        info( "StarterPackConfirmation.confirm called" );

        var self = this;
        var cb = function(error, data)
        {
            info("StarterPackConfirmation.confirm: ResetUser: " + JSON.stringify(error) + ", " + JSON.stringify(data));

            if (error == undefined)
            {
                DeckManager.setInitialDeck( self.m_deckIndex, function( success )
                {
                    info("StarterPackConfirmation.confirm: Starter Pack finished");
                    TutorialManager.completeActiveState();
                    TutorialManager.executeActiveStateAction();
                });
            }
        };

        User.resetUser( cb );
    },

    destroy: function()
    {

    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/StarterPackSelection'] = function(){var exports = $MODULE_REGISTRY['Code/UI/StarterPackSelection'] || {}; $MODULE_REGISTRY['Code/UI/StarterPackSelection'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/StarterPackSelection.js';

exports.StarterPackSelection = ScrollableView.subclass(
{
    classname: 'StarterPackSelection',

    initialize: function( $super )
    {
        info( "StarterPackSelection.initialize called." );
        $super();
        this.initWithXib( "./Content/Xib/StarterPackSelection.xib", false );
    },

    viewDidLoad: function( $super )
    {
        info( "StarterPackSelection.viewDidLoad called." );
        $super();
        this.m_viewLoaded = true;
        this._populateUI();

        var tutorialScreen = GameController.getTutorialScreen();
        tutorialScreen.setTutorialText( _loc( "tutorial_select_pack" ) );
    },

    _populateUI: function()
    {
        info( "StarterPackSelection._populateUI called." );

        var pack = TutorialManager.getStarterPacks();

        this.pack1Label.setText( _loc( pack["1"].name ) );
        this.pack2Label.setText( _loc( pack["2"].name ) );
        this.pack3Label.setText( _loc( pack["3"].name ) );

        this.pack1Image.setImage( pack["1"].img );
        this.pack2Image.setImage( pack["2"].img );
        this.pack3Image.setImage( pack["3"].img );

        // Save the deck in each button. It will be used in the method packSelected.
        this.pack1Button._deck = pack["1"].deck[0];
        this.pack1Button._deckIndex = 1;
        this.pack2Button._deck = pack["2"].deck[0];
        this.pack2Button._deckIndex = 2;
        this.pack3Button._deck = pack["3"].deck[0];
        this.pack3Button._deckIndex = 3;
    },

    packSelected: function( sender )
    {
        info( "StarterPackSelection.packSelected called." );

        // We added this variable to each button
        var deck = sender._deck;
        var deckIndex = sender._deckIndex;

        Xib.Navigation.setModalOverlay(
            new WaitingScreen(
                function()
                {
                    var screen = new StarterPackConfirmation( deck, deckIndex );
                    Xib.Navigation.resetScreenStackTo( screen, false );
                }.bind( this )
            )
        );
    },

    destroy: function()
    {
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/PopUp'] = function(){var exports = $MODULE_REGISTRY['Code/UI/PopUp'] || {}; $MODULE_REGISTRY['Code/UI/PopUp'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/PopUp.js';

exports.PopUp               = XibUI.subclass
({
    classname               : "PopUp",

    INFO                    : 0,
    ALERT                   : 1,
    ERROR                   : 2,

    initialize              : function( numberOfButtons, popUpType, title, description,
                                        button1Cb, button1Label, button2Cb, button2Label, button3Cb, button3Label,
                                        autoDismiss )
    {
        info( "PopUp.initialize called." );

        this.initWithXib("./Content/Xib/PopUp.xib", true);

        this.m_numberOfButtons      = numberOfButtons;
        this.m_type                 = popUpType;

        this.m_button1Cb            = button1Cb;
        this.m_button2Cb            = button2Cb;
        this.m_button3Cb            = button3Cb;

        this.m_button1Label         = button1Label;
        this.m_button2Label         = button2Label;
        this.m_button3Label         = button3Label;

        this.m_title                = title;
        this.m_description          = description;

        this.m_autoDismiss          = true;
    },

    setAutoDismiss : function( value )
    {
        info( "PopUp.setAutoDismiss called. value=" + value );
        this.m_autoDismiss = value;
    },

    viewDidLoad             : function()
    {
        info( "PopUp.viewDidLoad called." );

        if( this.m_numberOfButtons == 0 )
        {
            this.left.setVisible( false );
            this.mid.setVisible( false );
            this.right.setVisible( false );
        }

        if( this.m_numberOfButtons == 1 )
        {
            this.left.setVisible( false );
            this.right.setVisible( false );

            this.mid.setText( this.m_button1Label );
        }
        else if( this.m_numberOfButtons == 2 )
        {
            this.mid.setVisible( false );

            this.left.setText( this.m_button1Label );
            this.right.setText( this.m_button2Label );
        }
        else if( this.m_numberOfButtons == 3 )
        {
            this.left.setText( this.m_button1Label );
            this.mid.setText( this.m_button2Label );
            this.right.setText( this.m_button3Label );
        }

        if( this.m_type == PopUp.ERROR)
        {
            this.titleBackground.setImage( "popup_error.png" );
        }
        else if( this.m_type == PopUp.ALERT )
        {
            this.titleBackground.setImage( "popup_alert.png" );
        }
        else
        {
            this.titleBackground.setImage( "popup_info.png" );
        }

        this.title.setText( this.m_title );
        this.description.setText( this.m_description );
        
        if( this.m_appearCallback )
        {
            this.m_appearCallback();
        }
    },

    destroy                 : function()
    {
        info( "PopUp.destroy called." );
    },

    leftAction              : function()
    {
        info( "PopUp.leftAction called. this.m_autoDismiss=%s", JSON.stringify( this.m_autoDismiss ) );

        if( this.m_autoDismiss )
        {
            this.closePopUp();
        }

        if( this.m_numberOfButtons >= 2 )
        {
            if( this.m_button1Cb )
            {
                this.m_button1Cb();
            }
            else
            {
                warn( "PopUp.leftAction called. No callback for button 1" );
            }
        }
    },

    midAction               : function()
    {
        info( "PopUp.midAction called. this.m_autoDismiss=%s", JSON.stringify( this.m_autoDismiss ) );

        if( this.m_autoDismiss )
        {
            this.closePopUp();
        }

        if( this.m_numberOfButtons == 1 )
        {
            if( this.m_button1Cb )
            {
                this.m_button1Cb();
            }
            else
            {
                warn( "PopUp.midAction called. No callback for button 1" );
            }
        }
        else if( this.m_numberOfButtons == 3 )
        {
            if( this.m_button2Cb )
            {
                this.m_button2Cb();
            }
            else
            {
                warn( "PopUp.midAction called. No callback for button 2" );
            }
        }
    },

    rightAction             : function()
    {
        info( "PopUp.rightAction called. this.m_autoDismiss=%s", JSON.stringify( this.m_autoDismiss ) );

        if( this.m_autoDismiss )
        {
            this.closePopUp();
        }

        if( this.m_numberOfButtons == 3 )
        {
            if( this.m_button3Cb )
            {
                this.m_button3Cb();
            }
            else
            {
                warn( "PopUp.rightAction called. No callback for button 3" );
            }
        }
        else if( this.m_numberOfButtons == 2 )
        {
            if( this.m_button2Cb )
            {
                this.m_button2Cb();
            }
            else
            {
                warn( "PopUp.rightAction called. No callback for button 2" );
            }
        }
    },

    closePopUp              : function()
    {
        info( "PopUp.closePopUp called. Closing pop up after button press" );
        Xib.Navigation.removeModalOverlay( true );
    },
    
    setAppearCallback       : function( cb )
    {
        this.m_appearCallback   = cb;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/GiftStorage'] = function(){var exports = $MODULE_REGISTRY['Code/UI/GiftStorage'] || {}; $MODULE_REGISTRY['Code/UI/GiftStorage'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/GiftStorage.js';

exports.GiftStorage = DynamicList.subclass(
{
    classname: 'GiftStorage',

    initialize: function( $super, prevList )
    {
        info( "GiftStorage.initialize called" );
        $super();

        this.m_giftCell = null;
        this.m_controlCell = null;

        this.m_giftList = null;

        // To know what does it have to open.
        this.m_xib = null;

        this.m_viewLoaded = false;
        this.m_giftsLoaded = false;
        this.m_UIPopulated = false;

        this.m_imageSize = 200;

        this.m_canModify = true;
        if( prevList != undefined )
        {
            this.m_canModify = false;
            this.m_giftList = prevList;
        }

        this.initWithXib( "./Content/Xib/GiftStorage.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "GiftStorage.viewDidLoad called." );
        $super();
        ScreenManager.setBackInfo( this._backToMenu.bind( this ) );
        this.m_viewLoaded = true;
        this._populateUI();
        this._getUserGifts();
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( NO_SCREEN );
    },

    _populateUI: function()
    {
        info( "GiftStorage._populateUI called. this.m_giftsLoaded=%s, this.m_viewLoaded=%s, this.m_UIPopulated=%s", this.m_giftsLoaded, this.m_viewLoaded, this.m_UIPopulated );

        if( this.m_giftsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;

            var unselectedText;

            if( this.m_canModify )
            {
                unselectedText = _loc( "gift_storage_recieve_all_gifts" );
            }

            else
            {
                unselectedText = _loc( "gift_storage_accept_rewards" );
                this.label_description.setText( _loc( "reward_confirmation_description" ) );
                this.label_title.setText( _loc( "title_reward" ) );
            }

            this._setGeneralData( unselectedText );

            
            this._setButtonsAndRefresh();
        }
    },

    // Called when the selection menu is opened
    _getUserGifts: function()
    {
        info( "GiftStorage._getUserGifts called." );

        // Table Cells
        this.m_giftsLoaded = true;

        this._populateUI();
    },

    // Set global texts and button states
    _setGeneralData: function( unselectedText )
    {
        // SellectAll button
        var typeData =
        {
            "unselected":
            {
                "image": "gift_button_all.png",
                "text": unselectedText
            },
            "selected":
            {
                "image": "gift_button_nogift.png",
                "text": _loc( "gift_storage_no_available" )
            }
        };

        this.button_receiveAll.setStateData( typeData, this.label_receiveAll );
        this.button_receiveAll.setText( unselectedText );
    },

    receiveButtonClicked: function( arguments )
    {
        info( "GiftStorage.receiveButtonClicked: " + JSON.stringify( arguments ) );
        if( this.m_canModify )
        {
            var self = this;
            var argumentList = arguments;
            var func = function()
            {
                GiftManager.claimGift( argumentList.id, function( answer )
                {
                    if( answer == true )
                    {
                        self._setButtonsAndRefresh();
                    }
                    Xib.Navigation.removeModalOverlay();
                } );
            };

            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
        }
    },

    receiveAllButtonClicked: function( opt, button )
    {
        info( "GiftStorage.receiveAllButtonClicked" );
        var self = this;

        var func = function()
        {
            if( self.m_canModify )
            {

                GiftManager.claimAllGifts( function( answer )
                {
                    if( answer == true )
                    {
                        self._setButtonsAndRefresh();
                    }
                    Xib.Navigation.removeModalOverlay();
                } );

            }
            else
            {
                var controlRoom = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( controlRoom, false );
            }
        };

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    _setButtonsAndRefresh: function()
    {
        if( this.m_canModify )
        {
            // Save the list and the dictionary
            this.m_giftList = GiftManager.getPlayerGiftList();
        }
        
        // Recalculate the number of pages
        this.setPageNumber( this.m_giftList.length );
        
        this.button_receiveAll.setEnabled( ( this.m_giftList.length > 0 ) ? true : false );
        this._refreshTable();
    },

    _backToMenu: function()
    {
        // Back to the Menu, the card image will be showed after loading
        // We have to give it the dictionary, because it only will have the
        // instanceIds from the cardManager.
        // With the dictionary the menu can get the definitions ids and show the
        // right images.
        var self = this;
        var func = function()
        {

                var controlRoom = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( controlRoom, false );

        };
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    /** Method to create and modify all cells * */
    _setCell: function( index, giftIndex )
    {
        var view = this._getViewAtIndex( index );

        var title = view.nodeWithTag( 3 );
        var description = view.nodeWithTag( 4 );
        var expiration = view.nodeWithTag( 5 );
        var quantity = view.nodeWithTag( 2 );
        var imageView = view.nodeWithTag( 1 );
        var button = view.nodeWithTag( 6 );
        var background = view.nodeWithTag( 7 );
        
        imageView.spinnerOn();
        var giftInformation = GiftManager.getGiftInformation( this.m_giftList[giftIndex], this.m_imageSize, function( imageUrl )
        {
            imageView.spinnerOff();
            imageView.setImage( imageUrl );
        } );

        title.setText( _loc( giftInformation.title ) );
        description.setText( _loc( "gifts_" + giftInformation.origin ) );
        quantity.setText( sprintf( _loc( "gift_storage_quantity" ) + " " + giftInformation.amount ) );
        // imageView.setImage(giftInformation);

        if( this.m_canModify )
        {
            var callback2 = "receiveButtonClicked.bind(this._target, {id:" + giftInformation.id + "})";
            button.setTargetAction( this, callback2 );
            
            if( giftInformation.timestamp != undefined )
            {
                var date = new Date( giftInformation.timestamp );
                var strDate = _loc( "gift_storage_date_%s_%s_%s", date.getMonth() + 1, date.getDate(), date.getFullYear() );
                expiration.setText( sprintf( _loc( "gift_storage_expires" ) + " " + strDate ) );
                background.setImage( "gift_window.png" );
            }
            else
            {
                expiration.setText( "" );
                background.setImage( "gift_window_noexpire.png" );
            }
        }
        else
        {
            // TODO:
            // Modify the background image
            background.setImage( "gift_window_noexpire.png" );
            expiration.destroy();
            button.destroy();
        }
    },

    /** Return the number of items in the list * */
    _getNumberOfListItems: function()
    {
        var length;
        if( this.m_pageNumber == this.m_maxPageNumber - 1 )
        {
            length = this.m_giftList.length - this.m_pageNumber * this.m_maxCellNumber;
        }
        else
        {
            length = this.m_maxCellNumber;
        }

        return length;
    },

    viewDidAppear: function()
    {
        Xib.Navigation.removeModalOverlay();
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/LevelUpAnimation'] = function(){var exports = $MODULE_REGISTRY['Code/UI/LevelUpAnimation'] || {}; $MODULE_REGISTRY['Code/UI/LevelUpAnimation'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/LevelUpAnimation.js';

exports.LevelUpAnimation     = GL2.Node.subclass
({
    classname : "LevelUpAnimation",

    LEVEL_UP: 0,
    AREA_CLEARED: 1,
    BASE_HEIGHT: 480,
    BASE_WIDTH: 320,
    BLOCK_HEIGHT: 240,
    BLOCK_WIDTH: 510,
    BIG_STRIPES_HEIGHT: 101,
    BIG_STRIPES_WIDTH: 488,
    SMALL_STRIPES_HEIGHT: 38,
    SMALL_STRIPES_BLOCK_WIDTH: 414,
    TEXT_HEIGHT: 42,
    TEXT_WIDTH: 320,

    BLOCK_ANIMATION_TIME: 0.5,
    BIG_STRIPES_ANIMATION_TIME: 1.3,
    FADE_IN_TIME: 0.5,

    INITIAL_ANGLE: ( ( -20 * Math.PI ) / 180 ),

    initialize : function( width, height )
    {
        info("LevelUpAnimation.initialize called: width = " + width + " height " + height );

        this.m_width = width;
        this.m_height = height;
        this.m_cb = null;
        this.m_touchTarget = new GL2.TouchTarget();
        this.m_AnimationEnded = false;
        this.m_touchListener = new Core.MessageListener();

        this.m_container = new GL2.Node();
        this.m_blueBlock = new GL2.Sprite();
        this.m_orangeBlock = new GL2.Sprite();
        this.m_blueBigStripes = new GL2.Sprite();
        this.m_orangeBigStripes = new GL2.Sprite();
        this.m_blueSmallStripes = new GL2.Sprite();
        this.m_orangeSmallStripes = new GL2.Sprite();
        this.m_topTextImage = new GL2.Sprite();
        this.m_bottomTextImage = new GL2.Sprite();
        this.m_touchLabel = new GL2.Text();

        this._reset();
        this._setImages();

        this.m_container.setRotation( this.INITIAL_ANGLE * 180 / Math.PI );
        this.addChild( this.m_container );

        var size = new Core.Size( width, height );
        var anchor = new Core.Point(0.5, 0.5);
        this.m_touchTarget.setSize( size );
        this.m_touchTarget.setAnchor( anchor );
        this.m_touchTarget.getTouchEmitter().addListener( this.m_touchListener, this._onTouch.bind( this ) );
        this.addChild( this.m_touchTarget );


        this.m_touchLabel.setSize( width , 200 );
        this.m_touchLabel.setPosition( new Core.Point( 0, height / 4 ) );
        this.m_touchLabel.setFontSize(24);
        this.m_touchLabel.setText(_loc( "level_up_animation_touch" ) );
        this.m_touchLabel.setColor( 1, 1, 1 );
        this.m_touchLabel.setFontFamily( "./Content/font/eurostile.ttf" );

        this.m_container.addChild( this.m_touchLabel );

        this.m_container.setVisible( false );

        this._adjustScale( width, height );
    },

    _adjustScale: function( width, height )
    {
        info("LevelUpAnimation._adjustScale called" );
        var scaleX = width / this.BASE_WIDTH;
        var scaleY = height / this.BASE_HEIGHT;
        var scale = Math.max( scaleX, scaleY, 1.0 );

        this.m_container.setScale( scale, scale );
    },

    _onTouch: function( touch )
    {

        switch ( touch.getAction() )
        {
            case GL2.Touch.Action.Start:
                break;
            case GL2.Touch.Action.End:
            case GL2.Touch.Action.Cancel:
                
                if( this.m_AnimationEnded == false )
                {
                    info( "LevelUpAnimation._onTouch: Dismissed Touch...." );
                    break;
                }

                info( "LevelUpAnimation._onTouch: calling CB!!!" );
                this._reset();
                if( this.m_cb != null )
                {
                    this.m_cb();
                }
                break;
            
            default:
                break;
        }
        
        return true;
    },

    _reset: function()
    {
        this.m_container.setVisible( false );
        this.m_AnimationEnded = false;

        var initialBlockDistance = ( this.m_width / ( Math.cos( this.INITIAL_ANGLE ) * 2 ) );
        this.m_blueBlock.setFrame( initialBlockDistance, 0, this.BLOCK_WIDTH, this.BLOCK_HEIGHT );
        this.m_orangeBlock.setFrame( -initialBlockDistance - this.BLOCK_WIDTH, -this.BLOCK_HEIGHT, this.BLOCK_WIDTH, this.BLOCK_HEIGHT );
        this.m_blueBigStripes.setFrame(  -initialBlockDistance - this.BIG_STRIPES_WIDTH, ( this.BLOCK_HEIGHT - this.BIG_STRIPES_HEIGHT ), this.BIG_STRIPES_WIDTH, this.BIG_STRIPES_HEIGHT );
        this.m_orangeBigStripes.setFrame( initialBlockDistance, -this.BLOCK_HEIGHT, this.BIG_STRIPES_WIDTH, this.BIG_STRIPES_HEIGHT );
        this.m_blueSmallStripes.setFrame( initialBlockDistance, 0, this.SMALL_STRIPES_BLOCK_WIDTH, this.SMALL_STRIPES_HEIGHT );
        this.m_orangeSmallStripes.setFrame( -initialBlockDistance - this.SMALL_STRIPES_BLOCK_WIDTH, -this.SMALL_STRIPES_HEIGHT, this.SMALL_STRIPES_BLOCK_WIDTH, this.SMALL_STRIPES_HEIGHT );
        this.m_topTextImage.setFrame( initialBlockDistance, -this.TEXT_HEIGHT, this.TEXT_WIDTH, this.TEXT_HEIGHT );
        this.m_bottomTextImage.setFrame( -initialBlockDistance - this.TEXT_WIDTH, 0, this.TEXT_WIDTH, this.TEXT_HEIGHT );

        this.m_touchTarget.setTouchable( false );
        this.m_touchLabel.setAlpha( 0 );
    },
    _setImages: function()
    {
        info("LevelUpAnimation._setImages called " );
        
        this.m_blueBlock.setImage( "tran_blue_bg.png" );
        this.m_container.addChild( this.m_blueBlock );
        
        this.m_orangeBlock.setImage( "tran_orange_bg.png" );
        this.m_container.addChild( this.m_orangeBlock );

        this.m_blueBigStripes.setImage( "tran_blue_big.png" );
        this.m_container.addChild( this.m_blueBigStripes );

        
        this.m_orangeBigStripes.setImage( "tran_orange_big.png" );
        this.m_container.addChild( this.m_orangeBigStripes );

        
        this.m_blueSmallStripes.setImage( "tran_blue_small.png" );
        this.m_container.addChild( this.m_blueSmallStripes );

        this.m_orangeSmallStripes.setImage( "tran_orange_small.png" );
        this.m_container.addChild( this.m_orangeSmallStripes );
        
        this.m_container.addChild( this.m_topTextImage );
        this.m_container.addChild( this.m_bottomTextImage );

    },

    _setTextImages: function( type )
    {
        switch( type )
        {
            case this.LEVEL_UP:
                this.m_topTextImage.setImage( "tran_level.png" );
                this.m_bottomTextImage.setImage( "tran_up.png" );
            break;
            case this.AREA_CLEARED:
                this.m_topTextImage.setImage( "tran_area.png" );
                this.m_bottomTextImage.setImage( "tran_clear.png" );
            break;
            default:
                this.m_topTextImage.setImage( "1pxalpha0.png" );
                this.m_bottomTextImage.setImage( "1pxalpha0.png" );
            break;
        }
    },

    playAnimation: function( type, cb )
    {
        info("LevelUpAnimation.playAnimation called " );
        this.m_cb = cb;
        this._setTextImages( type );
        this.m_container.setVisible( true );
        this.m_touchTarget.setTouchable( true );

        this.m_container.runAction( Action.RotateTo.actionWithDuration( this.BLOCK_ANIMATION_TIME, 0 ) );

        var initialBlockDistance = ( this.BASE_WIDTH / ( Math.cos( this.INITIAL_ANGLE ) * 2 ) );
        var animationDistance = ( this.BLOCK_WIDTH/2 -this.m_width/2 - this.m_orangeBlock.getPosition().getX() );
        var blockPosBlue = new Core.Point( -animationDistance, 0 );
        var blockPosOrange = new Core.Point( animationDistance, 0 );

        this.m_blueBlock.runAction( Action.MoveBy.actionWithDuration( this.BLOCK_ANIMATION_TIME, blockPosBlue ) );
        this.m_orangeBlock.runAction( Action.MoveBy.actionWithDuration( this.BLOCK_ANIMATION_TIME, blockPosOrange ) );

        var stripesMovBlue = new Core.Point( 2 * animationDistance, 0 );
        var stripesMovOrange = new Core.Point( -2 * animationDistance, 0 );

        this.m_blueBigStripes.runAction( Action.MoveBy.actionWithDuration( this.BIG_STRIPES_ANIMATION_TIME, stripesMovBlue ) );
        this.m_orangeBigStripes.runAction( Action.MoveBy.actionWithDuration( this.BIG_STRIPES_ANIMATION_TIME, stripesMovOrange ) );

        this.m_blueSmallStripes.runAction( Action.MoveBy.actionWithDuration( this.BIG_STRIPES_ANIMATION_TIME, stripesMovOrange ) );
        this.m_orangeSmallStripes.runAction( Action.MoveBy.actionWithDuration( this.BIG_STRIPES_ANIMATION_TIME, stripesMovBlue ) );

        var onFinished = function()
        {
            this.m_AnimationEnded = true;
        }.bind( this );

        var onAnimationEnded = function()
        {
            this.m_touchLabel.runAction(
                Action.Sequence.actions(
                    Action.FadeIn.actionWithDuration( this.FADE_IN_TIME ),
                    Action.CallFunc.actionWithTarget( null, onFinished )
                )
        );
        }.bind( this );

        var topPos1 = new Core.Point( this.m_width/20, ( -this.TEXT_HEIGHT / 2 ) );
        var topPos2 = new Core.Point( -this.m_width/20, ( -this.TEXT_HEIGHT / 2 ) );
        var bottomPos1 = new Core.Point( -this.m_width/20, this.TEXT_HEIGHT / 2 );
        var bottomPos2 = new Core.Point( this.m_width/20, this.TEXT_HEIGHT / 2 );
        this.m_topTextImage.runAction(
            Action.Sequence.actions(
                Action.MoveTo.actionWithDuration( this.BLOCK_ANIMATION_TIME, topPos1 ),
                Action.MoveTo.actionWithDuration( this.BIG_STRIPES_ANIMATION_TIME - this.BLOCK_ANIMATION_TIME, topPos2 )
            )
        );
        this.m_bottomTextImage.runAction(
            Action.Sequence.actions(
                Action.MoveTo.actionWithDuration( this.BLOCK_ANIMATION_TIME, bottomPos1 ),
                Action.MoveTo.actionWithDuration( this.BIG_STRIPES_ANIMATION_TIME - this.BLOCK_ANIMATION_TIME, bottomPos2 ),
                Action.CallFunc.actionWithTarget( null, onAnimationEnded )
            )
        );

    },

    destroy: function()
    {
        //ToDo: destroy stuff
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/RewardList'] = function(){var exports = $MODULE_REGISTRY['Code/UI/RewardList'] || {}; $MODULE_REGISTRY['Code/UI/RewardList'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/RewardList.js';

exports.RewardList = DynamicList.subclass(
{
    classname: 'RewardList',

    initialize: function( $super, type )
    {
        info( "RewardList.initialize called" );
        $super();
        this.m_shownFromPop = false;

        this.m_controlCell = null;

        this.m_rewardList = null;

        // To know what does it have to open.
        this.m_xib = null;

        this.m_viewLoaded = false;
        this.m_rewardsLoaded = false;
        this.m_UIPopulated = false;

        this.m_maxCellNumber = 3;
        this.m_rewardsPerCell = 4;
        this.m_rewardsToClaim = [];
        this.m_cardCounter = null;

        this.m_imageSize = 200;

        this.m_loaded = false;

        this.m_windowsType = type;
        
        if( type == undefined )
        {
            this.m_windowsType = GEAR;
        }
        
        this.initWithXib( "./Content/Xib/RewardList.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "RewardList.viewDidLoad called." );
        $super();
        ScreenManager.setBackInfo( this._backToMenu.bind( this ) );
        this.m_viewLoaded = true;
        this.m_type = GEAR;
        this._populateUI();

        this._getUserRewards();
        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( NO_SCREEN );
    },

    _populateUI: function()
    {
        info( "RewardList._populateUI called. this.m_rewardsLoaded=%s, this.m_viewLoaded=%s, this.m_UIPopulated=%s", this.m_rewardsLoaded, this.m_viewLoaded, this.m_UIPopulated );

        if( this.m_rewardsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;

            // Set general information
            this._setGeneralData();
            // Create lists. This method will refresh the table
            this._createRewardLists();
        }
    },

    // Called when the selection menu is opened
    _getUserRewards: function()
    {
        info( "RewardList._getUserRewards called." );

        // Table Cells
        this.m_rewardsLoaded = true;
        this._populateUI();
    },

    // Set global texts and button states
    _setGeneralData: function()
    {
        // Type tabs
        var typeData =
        {
            "selected":
            {
                "image": "reward_tab_selected.png",
            },
            "unselected":
            {
                "image": "reward_tab_unselected.png",
            }
        };

        this.button_changeTypeEquipment.setStateData( typeData );
        this.button_changeTypeFighter.setStateData( typeData );
        this.button_changeTypeEquipment.setEnabled( this.m_type != GEAR );
        this.button_changeTypeFighter.setEnabled( this.m_type != PILOT );

        // SellectAll button
        var typeData2 =
        {
            "unselected":
            {
                "image": "reward_button_all.png",
                "text": _loc( "reward_receive_all" )
            },
            "selected":
            {
                "image": "reward_button_noreward.png",
                "text": _loc( "reward_no_available" )
            }
        };

        this.button_receiveAll.setStateData( typeData2, this.label_receiveAll );
        this.button_receiveAll.setEnabled( 1 );

        this.m_cardCounter = CardsManager.getCollectionNumber();
        this.label_pilotCount.setText( this.m_cardCounter.PILOT );
        this.label_gearCount.setText( this.m_cardCounter.GEAR );
    },

    // Create the list of rewards. Call it when the list changes.
    _createRewardLists: function()
    {
        this.m_rewardLists = [];

        this.m_rewardLists[PILOT] = RewardManager.getFilteredPlayerRewardList( PILOT );
        this.m_rewardLists[GEAR] = RewardManager.getFilteredPlayerRewardList( GEAR );

        if( this.m_loaded )
        {
            this._createFilteredListAndRefresh();
        }
        else
        {
            this.m_loaded = true;
            // If is the first time, set the window that the user wants.
            switch( this.m_windowsType )
            {
                case PILOT:
                    this.changeTypeTab();
                    break;
                case GEAR:
                    this._createFilteredListAndRefresh();
                    break;
                case STAGE_REWARDS:
                    Xib.Navigation.removeModalOverlay();
                    this.changeRewardTab();
                    this.m_loaded = true;
                    return;
            }

        }

    },

    changeTypeTab: function()
    {
        this.m_type = ( this.m_type == GEAR ) ? PILOT : GEAR;

        this.button_changeTypeEquipment.setEnabled( this.m_type != GEAR );
        this.button_changeTypeFighter.setEnabled( this.m_type != PILOT );
        this._createFilteredListAndRefresh();
    },

    _createFilteredListAndRefresh: function()
    {
        // Reset Lists
        this.m_rewardList = [];
        this.m_rewardsToClaim = [];

        // Fill the rewards to claim. We have to use the indexes of the entire list and call the method RewardManager.claimRewards with them.
        this.m_rewardList = this.m_rewardLists[this.m_type];

        var i = 0;
        var length = this.m_rewardList.length;
        for( i = 0; i < length; i++ )
        {
            this.m_rewardsToClaim.push( this.m_rewardList[i].index );
        }

        // Enable the claimAll button and views
        rewardsNumber = this.m_rewardLists[this.m_type].length;
        this.button_receiveAll.setEnabled( rewardsNumber );
        this.view_unlocked.setAlpha( rewardsNumber );
        var controlView = this._getViewAtIndex( this.m_maxCellNumber );
        controlView.setAlpha( rewardsNumber );

        // Set pageLabel and refresh
        this.m_pageNumber = 0;
        this.setPageNumber( length );
        this._refreshTable();
    },

    changeRewardTab: function()
    {
        var self = this;

        var func = function()
        {
            var screen = new RewardStage();
            self.m_shownFromPop = true;
            Xib.Navigation.pushViewController( screen, false );
        };

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    receiveButtonClicked: function( arguments )
    {
        info( "RewardList.receiveButtonClicked: " + JSON.stringify( arguments ) );
        var self = this;
        var argumentList = arguments;

        var func = function()
        {
            RewardManager.claimRewards( [ argumentList.rewardInfo.index ], function( answer )
            {
                if( answer == true )
                {
                    self.goToConfirmation( [ argumentList.rewardInfo ] );
                }
                else
                {
                    Xib.Navigation.removeModalOverlay();
                }
            } );
        };

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    receiveAllButtonClicked: function()
    {
        info( "RewardList.receiveAllButtonClicked" );
        if( this.m_rewardsToClaim.length != 0 )
        {
            var self = this;
            var func = function()
            {

                RewardManager.claimRewards( self.m_rewardsToClaim, function( answer )
                {
                    if( answer == true )
                    {
                        self.goToConfirmation();
                    }
                    else
                    {
                        Xib.Navigation.removeModalOverlay();
                    }
                } );
            };

            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );

        }
    },

    goToConfirmation: function( rewardList )
    {
        var giftList = this._createGiftListFromRewards( rewardList );
        var screen = new GiftStorage( giftList );
        this.m_shownFromPop = true;
        Xib.Navigation.pushViewController( screen, false );
    },

    viewDidAppear: function()
    {
        if( this.m_shownFromPop )
        {
            this.m_shownFromPop = false;
            // FIXME: We set the type as PILOT, and then call changeTypeTab. This function will change the value to GEAR.
            this.m_type = PILOT;
            this.changeTypeTab();
            this._createRewardLists();
        }
    },

    _createGiftListFromRewards: function( rewardList )
    {
        if( rewardList == undefined )
        {
            rewardList = this.m_rewardList;
        }

        var giftList = [];

        var i;
        var length = rewardList.length;
        var id = 0;
        for( i = 0; i < length; i++ )
        {
            var rewards = rewardList[i].rewards;
            var j;
            var rewardsLength = rewards.length;

            for( j = 0; j < rewardsLength; j++ )
            {
                var gift = dictionaryClone( rewards[j] );
                gift.id = id;
                gift.origin = REWARD_TYPE_TEXT[this.m_type];
                giftList.push( gift );
                id++;
            }
        }

        return giftList;
    },

    _backToMenu: function()
    {
        // Back to the Menu, the card image will be showed after loading
        // We have to give it the dictionary, because it only will have the
        // instanceIds from the cardManager.
        // With the dictionary the menu can get the definitions ids and show the
        // right images.
        var self = this;
        var func = function()
        {
            var screen = new ControlRoom( self.m_cardType );
            Xib.Navigation.resetScreenStackTo( screen, false );
        };

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    _refreshTable: function( $super, pageChanged )
    {
        this._setCell( -1, -1 );
        $super(pageChanged);
        Xib.Navigation.removeModalOverlay();
    },
    /** Method to create and modify all cells * */
    _setCell: function( index, rewardIndex )
    {
        var rewardInfo;
        var view;

        if( index == -1 && rewardIndex == -1 )
        {
            rewardInfo = RewardManager.getNextReward( this.m_type );
            view = this.view_nextReward;
            var requireLabel = view.nodeWithTag( 3 );

            // If we don't have a next reward, reset the screen and finish
            if( rewardInfo == undefined )
            {
                // TODO: Hide the interface
                return;
            }

            var currentCardsNumber = 0;

            if( this.m_type == PILOT )
            {
                currentCardsNumber = this.m_cardCounter.PILOT;
            }
            if( this.m_type == GEAR )
            {
                currentCardsNumber = this.m_cardCounter.GEAR;
            }

            var deltaCards = rewardInfo.value - currentCardsNumber;
            requireLabel.setText( _loc( "reward_%s_more_cards_required", deltaCards ) );
        }
        else
        {
            rewardInfo = this.m_rewardList[rewardIndex];
            view = this._getViewAtIndex( index );

            var button = view.nodeWithTag( 4 );
            var callback = "receiveButtonClicked.bind(this._target, {rewardInfo:" + JSON.stringify( rewardInfo ) + "})";
            button.setTargetAction( this, callback );
        }

        // Set general information
        var numberCollectedLabel = view.nodeWithTag( 2 );
        var typeCollectedLabel = view.nodeWithTag( 1 );

        numberCollectedLabel.setText( "+ " + rewardInfo.value );
        numberCollectedLabel.setBold(true);
        if( this.m_type == PILOT )
        {
            typeCollectedLabel.setText( _loc( "reward_fighter_cards_collected" ) );
        }
        if( this.m_type == GEAR )
        {
            typeCollectedLabel.setText( _loc( "reward_equipment_cards_collected" ) );
        }

        // Set each reward information
        var rewards = rewardInfo.rewards;
        var i;
        var length = rewards.length;
        for( i = 0; i < length; i++ )
        {
            var rewardInstance = rewards[i];

            var rewardView = view.nodeWithTag( 1001 + i );
            var rewardImage = rewardView.nodeWithTag( 1 );
            var rewardDescription = rewardView.nodeWithTag( 2 );

            rewardImage.spinnerOn();
            var rewardInformation = GiftManager.getGiftInformation( rewardInstance, this.m_imageSize, function( imageUrl )
            {
                rewardImage.spinnerOff();
                rewardImage.setImage( imageUrl );
            } );

            rewardDescription.setText( rewardInformation.amount + " " + _loc( rewardInformation.title ) );
            rewardView.setAlpha( 1 );
        }

        // Hide rewards that we don't have
        var length = this.m_rewardsPerCell;
        var j;
        for( j = i; j < length; j++ )
        {
            var rewardView = view.nodeWithTag( 1001 + j );
            rewardView.setAlpha( 0 );
        }
    },

    /** Return the number of items in the list * */
    _getNumberOfListItems: function()
    {
        var length;
        if( this.m_pageNumber == this.m_maxPageNumber - 1 )
        {
            length = this.m_rewardList.length - this.m_pageNumber * this.m_maxCellNumber;
        }
        else
        {
            length = this.m_maxCellNumber;
        }

        return length;
    },

    _setCollectionNumber: function()
    {
        var filter, i, filteredCards;

        filter =
        {};

        filter.type = this.m_filterType;

        filteredCards = CardsManager.getFilteredCards( filter, true );

        this.m_filteredCards = filteredCards.clone();
        this.m_filteredCardsIds = [];
        for( i = 0; i < filteredCards.length; i++ )
        {
            this.m_filteredCardsIds.push( filteredCards[i].id );
        }

        this.m_numberOfPages = Math.ceil( this.m_filteredCardsIds.length / this.m_maxCardsPerPage );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/RewardStage'] = function(){var exports = $MODULE_REGISTRY['Code/UI/RewardStage'] || {}; $MODULE_REGISTRY['Code/UI/RewardStage'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/RewardStage.js';

exports.RewardStage = DynamicList.subclass(
{
    classname: 'RewardStage',

    initialize: function( $super )
    {
        info( "RewardStage.initialize called" );
        $super();
        this.m_shownFromPop = false;
        this.m_controlCell = null;
        this.m_rewardList = null;
        this.m_rewardDict = null;

        // To know what does it have to open.
        this.m_xib = null;

        this.m_viewLoaded = false;
        this.m_rewardsLoaded = false;
        this.m_UIPopulated = false;

        this.m_maxCellNumber = 3;
        this.m_rewardsPerCell = 4;
        this.m_rewardsToClaim = [];

        this.m_stageRewardsNumber = 2;

        this.m_imageSize = 200;

        this.initWithXib( "./Content/Xib/RewardStage.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "RewardStage.viewDidLoad called." );
        $super();
        ScreenManager.setBackInfo( this._backToMenu.bind( this ) );
        this.m_viewLoaded = true;
        this._populateUI();
        this._getUserRewards();

        var overlay = Xib.Navigation.getOverlayView();
        overlay.highlightButton( NO_SCREEN );
    },

    _populateUI: function()
    {
        info( "RewardStage._populateUI called. this.m_rewardsLoaded=%s, this.m_viewLoaded=%s, this.m_UIPopulated=%s", this.m_rewardsLoaded, this.m_viewLoaded, this.m_UIPopulated );

        if( this.m_rewardsLoaded && this.m_viewLoaded && !this.m_UIPopulated )
        {
            this.m_UIPopulated = true;

            // Set general information
            this._setGeneralData();

            this.m_worldList = QuestManager.getWorlds();

            this.setPageNumber( this.m_worldList.length );
            // Create lists. This method will refresh the table
            this._createListAndRefresh();
        }
    },

    // Called when the selection menu is opened
    _getUserRewards: function()
    {
        info( "RewardStage._getUserRewards called." );

        // Table Cells
        this.m_rewardsLoaded = true;
        this._populateUI();
    },

    // Set global texts and button states
    _setGeneralData: function()
    {
        // SellectAll button
        var typeData =
        {
            "unselected":
            {
                "image": "reward_button_all.png",
                "text": _loc( "reward_receive_all" )
            },
            "selected":
            {
                "image": "reward_button_noreward.png",
                "text": _loc( "reward_no_available" )
            }
        };

        this.button_receiveAll.setStateData( typeData, this.label_receiveAll );

        var rewards = RewardManager.getStageRewardsInformation();

        var i;
        var length = this.m_stageRewardsNumber;
        for( i = 0; i < length; i++ )
        {
            var rewardInstance = rewards[i];
            var rewardView = eval( "this.view_stageReward" + ( i + 1 ) );

            var rewardImage = rewardView.nodeWithTag( 1 );
            var rewardDescription = rewardView.nodeWithTag( 2 );

            rewardImage.spinnerOn();
            var rewardInformation = GiftManager.getGiftInformation( rewardInstance, this.m_imageSize, function( imageUrl )
            {
                rewardImage.spinnerOff();
                rewardImage.setImage( imageUrl );
            } );

            rewardDescription.setText( rewardInformation.amount + " " + rewardInformation.title );
        }
    },

    _createListAndRefresh: function()
    {
        // Reset Lists
        this.m_rewardDict =
        {};
        this.m_rewardList = [];
        this.m_rewardsToClaim = [];

        // Fill the rewards to claim. We have to use the indexes of the entire list and call the method RewardManager.claimRewards with them.
        this.m_rewardList = RewardManager.getFilteredPlayerRewardList( STAGE_REWARDS );

        var i = 0;
        var rewardsNumber = this.m_rewardList.length;
        for( i = 0; i < rewardsNumber; i++ )
        {
            var rewardInfo = this.m_rewardList[i];
            this.m_rewardsToClaim.push( rewardInfo.index );
            this.m_rewardDict[rewardInfo.value] = rewardInfo;
        }

        // Enable the claimAll button
        this.button_receiveAll.setEnabled( ( rewardsNumber > 0 ) ? true : false );

        // Set pageLabel and refresh
        this.m_pageNumber = 0;

        this._refreshTable();
    },

    changeRewardTab: function()
    {
        var func = function()
        {
            Xib.Navigation.popViewController( false );
        };

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    receiveButtonClicked: function( arguments )
    {
        info( "RewardStage.receiveButtonClicked: " + JSON.stringify( arguments ) );
        var self = this;
        var argumentList = arguments;

        var func = function()
        {
            RewardManager.claimRewards( [ argumentList.rewardInfo.index ], function( answer )
            {
                if( answer == true )
                {
                    self.goToConfirmation( [ argumentList.rewardInfo ] );
                }
                else
                {
                    Xib.Navigation.removeModalOverlay();
                }
            } );
        };

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );

    },

    receiveAllButtonClicked: function()
    {
        info( "RewardStage.receiveAllButtonClicked" );
        if( this.m_rewardsToClaim.length != 0 )
        {
            self = this;

            var func = function()
            {
                RewardManager.claimRewards( self.m_rewardsToClaim, function( answer )
                {
                    if( answer == true )
                    {
                        self.goToConfirmation();
                    }
                    else
                    {
                        Xib.Navigation.removeModalOverlay();
                    }
                } );
            };

            Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );

        }
    },

    goToConfirmation: function( rewardList )
    {
        var giftList = this._createGiftListFromRewards( rewardList );
        var screen = new GiftStorage( giftList );
        this.m_shownFromPop = true;
        Xib.Navigation.pushViewController( screen, false );
    },

    viewDidAppear: function()
    {
        if( this.m_shownFromPop )
        {
            this.m_shownFromPop = false;
            this._createListAndRefresh();
        }
    },

    _createGiftListFromRewards: function( rewardList )
    {
        if( rewardList == undefined )
        {
            rewardList = this.m_rewardList;
        }

        var giftList = [];

        var i;
        var length = rewardList.length;
        var id = 0;
        for( i = 0; i < length; i++ )
        {
            var rewards = rewardList[i].rewards;
            var j;
            var rewardsLength = rewards.length;

            for( j = 0; j < rewardsLength; j++ )
            {
                var gift = dictionaryClone( rewards[j] );
                gift.id = id;
                gift.origin = REWARD_TYPE_TEXT[STAGE_REWARDS];
                giftList.push( gift );
                id++;
            }
        }

        return giftList;
    },

    _backToMenu: function()
    {
        // Back to the Menu, the card image will be showed after loading
        // We have to give it the dictionary, because it only will have the
        // instanceIds from the cardManager.
        // With the dictionary the menu can get the definitions ids and show the
        // right images.
        var self = this;
        var func = function()
        {
            var screen = new ControlRoom( self.m_cardType );
            Xib.Navigation.resetScreenStackTo( screen, false );
        };
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    _refreshTable: function( $super, pageChanged )
    {
        $super(pageChanged);
        Xib.Navigation.removeModalOverlay();
    },
    /** Method to create and modify all cells * */
    _setCell: function( index, rewardIndex )
    {
        var worldId = this.m_worldList[rewardIndex];
        var view = this._getViewAtIndex( index );

        var worldInfo = QuestManager.getWorldData( worldId );

        // Set general information
        var worldNameLabel = view.nodeWithTag( 2 );
        var worldImage = view.nodeWithTag( 1 );

        worldNameLabel.setText( _loc( worldInfo.worldName ) );
        worldImage.spinnerOn();
        QuestManager.loadBanner( worldId, function( url )
        {
            worldImage.spinnerOff();
            worldImage.setImage( url );
        } );

        // Set stage information
        var stages = worldInfo.stages;
        var i;
        var length = stages.length;

        for( i = 0; i < length; i++ )
        {
            var stageInfo = stages[i];
            var rewardInfo = this.m_rewardDict[stageInfo.id];

            var stageView = view.nodeWithTag( 1001 + i );

            if( stageView != undefined )
            {
                var completeImage = stageView.nodeWithTag( 1 );
                var completeLabel = stageView.nodeWithTag( 3 );
                var stageNameLabel = stageView.nodeWithTag( 2 );
                var button = stageView.nodeWithTag( 4 );

                var playerStage = QuestManager.getPlayerProgressForStage( worldId, stageInfo.id );
                var completed = playerStage.collectedCards / playerStage.totalCards;
                completed = Math.floor( completed * 100 );

                var completeImageUrl = "reward_red_tag.png";
                if( completed >= 100 )
                {
                    completeImageUrl = "reward_green_tag.png";
                }
                completeImage.setImage( completeImageUrl );
                completeLabel.setText( completed + "%" );

                stageNameLabel.setText( _loc( stageInfo.stageName ) );

                if( button._stateData == undefined )
                {
                    var typeData =
                    {
                        "unselected":
                        {
                            "image": "reward_button_get.png",
                            "text": _loc( "reward_get" )
                        },
                        "selected":
                        {}
                    };

                    button.setStateData( typeData );
                }

                if( rewardInfo != undefined )
                {
                    button.setEnabled( 1 );
                    button.setImage( "reward_button_get.png" );
                    button.setText( _loc( "reward_get" ) );

                    var callback = "receiveButtonClicked.bind(this._target, {rewardInfo:" + JSON.stringify( rewardInfo ) + "})";
                    button.setTargetAction( this, callback );
                }
                else
                {
                    button.setEnabled( 0 );
                    var buttonText = _loc( "reward_locked" );

                    var buttonImageUrl = "reward_button_lock.png";

                    if( completed >= 100 )
                    {
                        buttonImageUrl = "reward_button_collected.png";
                        buttonText = _loc( "reward_collected" );
                    }

                    button.setImage( buttonImageUrl );
                    button.setText( buttonText );
                }
            }
        }

        // FIXME: removing final stage
        var stageView = view.nodeWithTag( 1003 );

        if( stageView != undefined )
        {
            var button = stageView.nodeWithTag( 4 );
            button.setAlpha(0);
        }
    },

    /** Return the number of items in the list * */
    _getNumberOfListItems: function()
    {
        var length;
        if( this.m_pageNumber == this.m_maxPageNumber - 1 )
        {
            length = this.m_worldList.length - this.m_pageNumber * this.m_maxCellNumber;
        }
        else
        {
            length = this.m_maxCellNumber;
        }

        return length;
    },

    _setCollectionNumber: function()
    {
        var filter, i, filteredCards;

        filter =
        {};

        filter.type = this.m_filterType;

        filteredCards = CardsManager.getFilteredCards( filter, true );

        this.m_filteredCards = filteredCards.clone();
        this.m_filteredCardsIds = [];
        for( i = 0; i < filteredCards.length; i++ )
        {
            this.m_filteredCardsIds.push( filteredCards[i].id );
        }

        this.m_numberOfPages = Math.ceil( this.m_filteredCardsIds.length / this.m_maxCardsPerPage );
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/LevelUpLanding'] = function(){var exports = $MODULE_REGISTRY['Code/UI/LevelUpLanding'] || {}; $MODULE_REGISTRY['Code/UI/LevelUpLanding'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/LevelUpLanding.js';

exports.LevelUpLanding = XibUI.subclass(
{
    classname: 'LevelUpLanding',

    NUM_REWARDS: 2,
    /**
     * CardDisplay.initialize
     */
    initialize: function( gifts, nextScreen, onContinue )
    {
        info( "LevelUpLanding.initialize called." );

        this.m_nextScreen = nextScreen;
        this.m_gifts = gifts;
        this.m_onContinue = onContinue;

        this.initWithXib( "./Content/Xib/LevelUpLanding.xib", true );
    },

    viewDidDisappear: function()
    {
        info( "LevelUpLanding.viewDidDisappear called." );
        if( this.m_onContinue != null )
        {
            info( "LevelUpLanding.viewDidDisappear... calling callback" );
            this.m_onContinue();
        }
    },

    viewDidLoad: function()
    {
        info( "LevelUpLanding.viewDidLoad called." );

        //Same than continue
        ScreenManager.setBackInfo( this.continueAction.bind(this) );
        GameController.getMainScreen().setEnabledMenu( true );
    },

    viewDidAppear: function()
    {
        info( "LevelUpLanding.viewDidAppear called." + this.m_gifts );
        Xib.Navigation.removeModalOverlay();
        var i = 0;
        var label = null;

        //clearing the labels...
        this.medalRewardLabel.setText( "" );
        for( i = 0; i < this.NUM_REWARDS; ++i )
        {
            label = this.screenView.nodeWithTag( 100 + i );
            if( label == null )
            {
                continue;
            }
            label.setText( "" );
        }

        var onMedalImageLoaded = function( type, imageURL )
        {
            if( type != GIFT_TYPE.MEDALS )
            {
                return;
            }
            info( "LevelUpLanding.viewDidAppear.onMedalImageLoaded..called: " + imageURL );
            this.rewardImage.spinnerOff();
            this.rewardImage.setImage( imageURL );
        };

        //using the gifts info for setting up the screen
        var labelCounter = 0;
        var numGifts = this.m_gifts.length;
        for( i = 0; i < numGifts; ++i )
        {
            if( i > 3 )
            {
                info( "LevelUpLanding.viewDidAppear: this screen can only display 3 gifts..." );
            }

            var gift = this.m_gifts[ i ];
            this.rewardImage.spinnerOn();
            var giftInformation = GiftManager.getGiftInformation( gift, null, onMedalImageLoaded.bind( this, this.m_gifts[ i ].type ) );
            if( giftInformation == null )
            {
                info( "LevelUpLanding.viewDidAppear: invalid Gift" );
                continue;
            }

            if( this.m_gifts[ i ].type == GIFT_TYPE.MEDALS )
            {
                info( "LevelUpLanding.viewDidAppear...medal found :" + MEDAL_ASSETS[ gift.value ] );
                //this.medalRewardLabel.setText( _loc( giftInformation.title ) );
                //this.medalRewardLabel.setText( _loc( level_up_landing_medal ) );
                //TODO FIXME:
                this.medalRewardLabel.setText( sprintf( _loc( "level_up_landing_medal_text" ), _loc( "gift_" + gift.value ) ) );
                continue;
            }
            label = this.screenView.nodeWithTag( 100 + labelCounter );
            labelCounter++;
            if( label == null || !gift.value )
            {
                continue;
            }
            label.setText( sprintf( _loc( "level_up_reward_description" ), giftInformation.title ) );

        }

        this.levelIncreasedLabel.setText( sprintf( _loc( "level_up_current_level" ), User.getLevel() ) );

    },

    continueAction: function()
    {
        info( "LevelUpLanding.continueAction called." );

        var func = function()
        {
            Server.getExplorationState(function(error, data)
                    {
                        info( "LevelUpLanding.continueAction called, missions state: " + JSON.stringify( data ) );
                        if (error)
                        {
                            err("LevelUpLanding.continueAction error from server");
                        }
                        else
                        {
                            var dataObject = JSON.parse( data );
                            User.updateMissionsState( dataObject );
                        }
                    });
            var screen = new MissionSelectionScreen(this.m_nextScreen.worldId, this.m_nextScreen.stageId);
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind(this);

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },
    
    goToGiftStorage: function()
    {
        var func = function()
        {
            var screen = new GiftStorage();
            Xib.Navigation.resetScreenStackTo( screen, false );
            info( "LevelUpLanding.continueToGasha Screen Pushed: classname=" + screen.classname );
        }.bind( this );

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    } 

} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/MissionFailedScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/MissionFailedScreen'] || {}; $MODULE_REGISTRY['Code/UI/MissionFailedScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/MissionFailedScreen.js';

exports.MissionFailedScreen = XibUI.subclass(
{
    classname: 'MissionFailedScreen',
    /**
     * CardDisplay.initialize
     */

     ITEM_STORE_TABS_USE: 1,
     ITEM_STORE_TABS_BUY: 0,

    initialize: function( gifts )
    {
        info( "MissionFailedScreen.initialize called." );
        this.initWithXib( "./Content/Xib/MissionFailedScreen.xib", true );
    },

    viewDidLoad: function()
    {
        info( "MissionFailedScreen.viewDidLoad called." );
        ScreenManager.setBackInfo( this.continueAction.bind( this ) );
        GameController.getMainScreen().setEnabledMenu( true );
        Xib.Navigation.removeModalOverlay();
        var backFunction = function()
        {
            this.setBackButton();
        }.bind( this );

        ScreenManager.setBackInfo( backFunction );
    },

    continueAction: function()
    {
        info( "MissionFailedScreen.continueAction called." );
        var func = function()
        {
            var exploreItems, startingTab;
            exploreItems = ItemManager.getUserExploreEnergyItems();
            startingTab = (exploreItems.length < 1)?  1 : 0;
            var screen = new ItemStore(startingTab);
            Xib.Navigation.resetScreenStackTo( screen, false );
        };
        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    },

    setBackButton: function()
    {
        var func = null;
        var stageInfo = User.getCurrentStage();

        // world 0 is for tutorial only!
        if( stageInfo.worldId <= 0 || stageInfo.stageId < 0 )
        {
            func = function()
            {
                var screen = new ExplorationWorldUI();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
        }
        else
        {
            func = function()
            {
                var stageInfo = User.getCurrentStage();
                var screen = new MissionSelectionScreen( stageInfo.worldId, stageInfo.stageId );
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
        }

        Xib.Navigation.setModalOverlay( new WaitingScreen( func ) );
    }

} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/SaleCardsScreen'] = function(){var exports = $MODULE_REGISTRY['Code/UI/SaleCardsScreen'] || {}; $MODULE_REGISTRY['Code/UI/SaleCardsScreen'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/SaleCardsScreen.js';

exports.SaleCardsScreen = ScrollableView.subclass(
    {
        classname : "SaleCardsScreen",

        VIEWS : {
            EQUIPMENT : 1,
            FIGHTERS : 2
        },

        ALPHA_DISABLED : 0.5,

        CARDS_PER_ROW: 3,
        MAX_CONTAINERS : 12,

        initialize : function( $super, selectedTab )
        {
            info( "SaleCardsScreen.initialize called." );
            $super();
            this.initWithXib( "./Content/Xib/SaleCardsScreen.xib", true );

            this.m_selectedTab = selectedTab;

            //Variable instantiation
            this.m_playerCards = null;
            this.m_sortOptions = null;
            this.m_selectedCards = null;
            this.m_view = null;
            this.m_currentPage = 0;
            this.m_baseScrollDelta = 0;
            this.m_enableButtons = false;
            this.m_expansionsSum = 0;

            //Variable initialization

            this.m_playerCards = CardsManager.getAllFilteredPlayerCards( { "type" : GEAR } );
            this.m_sortBy =
            {
                "value" : "overall",
                "invert" : false
            };

            this.setSortedCards();

            this.m_sortOptions = CardsManager.getSortOptions();
            this.m_selectedCards = [];
            this.m_view = {};
            this.m_enableButtons = false;
        },

        _populateUI : function()
        {
            info( "SaleCardsScreen._populateUI called." );

            if( this.m_viewLoaded && !this.m_UIPopulated )
            {
                this.m_UIPopulated = true;
                this.fillContainersInfo();
            }
        },

        equipmentTabPressed : function()
        {
            info( "SaleCardsScreen.equipmentTabPressed called." );

            this.m_currentPage = 0;
            this.m_playerCards = CardsManager.getAllFilteredPlayerCards( { "type" : GEAR } );

            this.setSortedCards();
            this.showContainers();
            this.fillContainersInfo();
            this.updateScroll( this.hideContainers() );
            this.updateHighlights();
            this.equipmentTab.setImage( "sale_tab_selected.png" );
            this.fightersTab.setImage( "sale_tab_unselected.png" );
        },

        fightersTabPressed : function()
        {
            info( "SaleCardsScreen.fightersTabPressed called." );

            this.m_currentPage = 0;
            this.m_playerCards = CardsManager.getAllFilteredPlayerCards( { "type" : PILOT } );

            this.setSortedCards();
            this.showContainers();
            this.fillContainersInfo();
            this.updateScroll( this.hideContainers() );
            this.updateHighlights();
            this.equipmentTab.setImage( "sale_tab_unselected.png" );
            this.fightersTab.setImage( "sale_tab_selected.png" );
        },

        fillContainersInfo : function()
        {
            info( "SaleCardsScreen.fillContainersInfo called." );

            var imageCallback = function( cardImage, imageURL )
            {
                cardImage.spinnerOff();
                cardImage.setImage( imageURL );
            };

            var i, globalCardPos;

            for( i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                if( i >= this.m_playerCards.length )
                {
                    return;
                }

                globalCardPos = i + (this.MAX_CONTAINERS * this.m_currentPage );

                if( globalCardPos >= this.m_playerCards.length )
                {
                    break;
                }

                var cardData = this.m_playerCards[globalCardPos];
                var container = this.m_view._containers[i];

                var cardMaxLevel = CardsManager.getMaxCardLevel( cardData );
                var cardLevel = CardsManager.getCardLevel( cardData );

                container._salePrice.setText( CardsManager.getCardSellingPrice( cardData ) );
                container._cardLevel.setText( sprintf( "%d/%d", cardLevel, cardMaxLevel ) );

                container._cardImage.spinnerOn();
                container._cardImage.setImage( NON_EXISTENT_CARD_IMAGE );
                CardsManager.loadCardImage( cardData.definitionId, IMAGE_SIZE.BIG, imageCallback.bind( this, container._cardImage ) );
            }
        },

        /**
         * autoCombo will select all the displayed cards with rarity={common, uncommon}
         * @param sender
         */
        autoCombo : function( sender )
        {
            info( "SaleCardsScreen.autoCombo called." );

            var container, card, cardDef, globalCardPos, i;

            this.clearCombo();
            for( i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                container = this.m_view._containers[i];
                if( !container.getVisible() )
                {
                    info( "SaleCardsScreen.autoCombo break. container.getVisible()=false. i=%s", i );
                    break;
                }

                globalCardPos = i + ( this.MAX_CONTAINERS * this.m_currentPage );
                card = this.m_playerCards[globalCardPos];
                cardDef = CardsManager.getCardDefinition( card.definitionId );

                if( cardDef.rarity == RARITY.common || cardDef.rarity == RARITY.uncommon )
                {
                    this.selectCard( i );
                }
            }
        },

        hideContainers : function()
        {
            info( "SaleCardsScreen.hideContainers called. this.MAX_CONTAINERS=%s, this.m_currentPage=%s", this.MAX_CONTAINERS, this.m_currentPage );

            var index, i, rtval;

            index = this.MAX_CONTAINERS * this.m_currentPage;

            if( (this.m_playerCards.length - index) >= this.MAX_CONTAINERS )
            {
                this.m_visibleCards = this.MAX_CONTAINERS;
            }
            else
            {
                this.m_visibleCards = this.m_playerCards.length - index;
            }

            this.m_visibleRows = Math.ceil( this.m_visibleCards / this.CARDS_PER_ROW );

            info( "SaleCardsScreen.hideContainers this.m_playerCards.length=%s, this.m_visibleCards=%s, this.m_visibleRows=%s", this.m_playerCards.length, this.m_visibleCards, this.m_visibleRows );

            for( i = this.m_visibleCards; i < this.MAX_CONTAINERS; i++ )
            {
                this.m_view._containers[i].setVisible( false );
                this.m_view._containers[i]._selectButton.setEnabled( false );
            }

            if( this.m_visibleCards !== 0 )
            {
                this.prevButton.setVisible( true );
                this.nextButton.setVisible( true );

                if( this.m_enableButtons )
                {
                    this.enableButtons();
                }
                this.sellCardsTop.setVisible( true );
                this.topSaleButtonLabel.setText( _loc( "sale_button_sale" ) );
                this.saleButtonBottomContainer.setVisible( true );
                this.saleButtonBottomContainer.setAlpha( 1 );
                this.pageCounter.setVisible( true );
                this.pageCounter.setAlpha( 1 );
            }
            else
            {
                this.prevButton.setVisible( false );
                this.nextButton.setVisible( false );

                this.sellCardsTop.setEnabled( false );
                this.sellCardsTop.setVisible( false );
                this.topSaleButtonLabel.setText( _loc( "sale_screen_no_cards_to_sell" ) );
                this.saleButtonBottomContainer.setVisible( false );
                this.pageCounter.setVisible( false );
                this.pageCounter.setAlpha( 0 );
                this.resetScroll();
                this.updateScroll( -this.getRealContainerHeight() );
            }

            if( this.m_visibleRows > 0 )
            {
                rtval = ( this.m_visibleRows - 1 ) * this.getRealContainerHeight();
            }
            else
            {
                rtval = 0;
            }

            info( "SaleCardsScreen.hideContainers returning. rtval=%s", rtval );

            return rtval;
        },

        /**
         * getRealContainerHeight return the size of the container and the space between 2 containers
         */
        getRealContainerHeight: function()
        {
            var height, containerA, containerB;

            containerA = this.m_view._containers[0].getFrame().getOrigin().getY()
            containerB = this.m_view._containers[4].getFrame().getOrigin().getY()
            height = Math.abs( containerB - containerA );

            if( DEBUG_SCROLLABLE_VIEW )
            {
                info( "SaleCardsScreen.getRealContainerHeight returning. height=%s, containerA=%s, containerB=%s", height, containerA, containerB );
            }

            return height;
        },

        updatePagingButtonStatus : function()
        {
            info( "SaleCardsScreen.updatePagingButtonStatus called." );

            var currentPage = this.m_currentPage;

            if( Math.ceil( this.m_playerCards.length / (this.MAX_CONTAINERS) ) === 0 )
            {
                currentPage--;
            }

            this.pageCounter.setText( (currentPage + 1) + "/" + Math.ceil( this.m_playerCards.length / this.MAX_CONTAINERS ) );

            if( this.m_currentPage === 0 )
            {
                this.prevButton.setEnabled( false );
                this.prevButton.setAlpha( this.ALPHA_DISABLED );
            }
            else
            {
                this.prevButton.setEnabled( true );
                this.prevButton.setAlpha( 1 );
            }

            if( (this.m_currentPage + 1) >= this.m_playerCards.length / this.MAX_CONTAINERS )
            {
                this.nextButton.setEnabled( false );
                this.nextButton.setAlpha( this.ALPHA_DISABLED );
            }
            else
            {
                this.nextButton.setEnabled( true );
                this.nextButton.setAlpha( 1 );
            }
        },

        resetScroll : function()
        {
            info( "SaleCardsScreen.resetScroll called. this.m_expansionsSum=%s", this.m_expansionsSum );

            if( Math.abs( this.m_expansionsSum ) > 0 )
            {
                this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : -this.m_expansionsSum } );
                this.m_expansionsSum = 0;
            }
        },

        updateScroll : function( delta )
        {
            info( "SaleCardsScreen.updateScroll called. this.m_expansionsSum=%s, delta=%s", this.m_expansionsSum, delta );

            this.resetScroll();
            this.m_expansionsSum += delta;
            this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : delta} );
            this.moveButtons();
            this.updatePagingButtonStatus();
        },

        moveButtons : function()
        {
            info( "SaleCardsScreen.moveButtons called." );

//            if( !this.saleButtonBottomContainer.getVisible() )
//            {
//                return;
//            }

            if( this.m_visibleCards > 0 )
            {
                var lastCardContainer           = this.m_view._containers[this.m_visibleCards - 1];
                var lastCardY                   = lastCardContainer.getFrame().getOrigin().getY();
                var lastCardHeight              = lastCardContainer.getFrame().getSize().getHeight();
                var saleButtonContainerHeight   = this.saleButtonBottomContainer.getFrame().getSize().getHeight();
                var prevButtonHeight            = this.prevButton.getFrame().getSize().getHeight();
                var saleButtonContainerNewY     = lastCardY + ( lastCardHeight / 2 ); // Why half lastCardHeight

                info( "SaleCardsScreen.moveButtons lastCardY=%s, lastCardHeight=%s, saleButtonContainerHeight=%s", lastCardY, lastCardHeight, saleButtonContainerHeight );

                this.saleButtonBottomContainer.setPosition( this.saleButtonBottomContainer.getPosition().getX(),
                    saleButtonContainerNewY );

                this.pageCounter.setPosition( this.pageCounter.getPosition().getX(),
                    saleButtonContainerNewY + saleButtonContainerHeight
                );

                this.prevButton.setPosition( this.prevButton.getPosition().getX(),
                    saleButtonContainerNewY + saleButtonContainerHeight
                );

                this.nextButton.setPosition( this.nextButton.getPosition().getX(),
                    saleButtonContainerNewY + saleButtonContainerHeight
                );

                var delta = saleButtonContainerHeight + ( prevButtonHeight * 4 ); // prevButtonHeight x 3 to add a small margin at the bottom
                this.m_expansionsSum += delta;
                this.expandFrame( {'_top' : 0, '_bottom' : 0, '_bottomContent' : delta } );
            }

            return;
        },

        shouldResetScroll : function()
        {
            info( "SaleCardsScreen.shouldResetScroll called." );

            var visibleContainers = 0;

            for( var i = 0; i < this.m_view._containers.length; i++ )
            {
                if( this.m_view._containers[i].getVisible() )
                {
                    visibleContainers++;
                }
            }

            if( visibleContainers <= this.MAX_CONTAINERS / 2 )
            {
                return true;
            }

            return false;
        },

        _mapElements : function()
        {
            info( "SaleCardsScreen._mapElements called." );

            var containers = [];
            for( var i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                var container = eval( sprintf( "this.cardContainer%d", i ) );

                container._frameImage = container.nodeWithTag( 9001 );
                container._cardImage = container.nodeWithTag( 9002 );
                container._cardLevel = container.nodeWithTag( 9003 );
                container._salePrice = container.nodeWithTag( 9004 );
                container._selectButton = container.nodeWithTag( 9005 );

                containers.push( container );
            }
            this.m_view._containers = containers;
        },

        _mapActions : function()
        {
            info( "SaleCardsScreen._mapActions called." );

            for( var i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                var selectButton = this.m_view._containers[i]._selectButton;
                var selectButtonCallback = sprintf( "_buttonClicked.bind(this._target, {'button':%d})", i );
                selectButton.setTargetAction( this, selectButtonCallback );
            }
        },

        _buttonClicked : function( opts )
        {
            info( "SaleCardsScreen._buttonClicked: opts: " + JSON.stringify( opts ) );
            if( !this.isCardSelected( opts.button ) )
            {
                this.selectCard( opts.button );
            }
            else
            {
                this.unselectCard( opts.button );
            }
        },

        unselectCard : function( containerId )
        {
            var frame = this.m_view._containers[containerId]._frameImage;
            var card = this.m_playerCards[containerId + (this.MAX_CONTAINERS * this.m_currentPage)];
            for( var i = 0; i < this.m_selectedCards.length; i++ )
            {
                if( this.m_selectedCards[i] == card )
                {
                    this.m_selectedCards.splice( i, 1 );
                    break; //We only want to remove 1
                }
            }
            frame.setImage( "sale_cardframe_unselected.png" );
            if( this.m_selectedCards.length === 0 )
            {
                this.disableButtons();
            }
        },

        selectCard : function( containerId )
        {
            var frame = this.m_view._containers[containerId]._frameImage;
            var card = this.m_playerCards[containerId + (this.MAX_CONTAINERS * this.m_currentPage)];
            frame.setImage( "sale_cardframe_selected.png" );
            this.m_selectedCards.push( card );
            this.enableButtons();
        },

        setComboBox : function()
        {
            info( "SaleCardsScreen.setComboBox called" );

            var totalSortOptionsList = CardsManager.getSortOptions();
            var sortOptionsList = [];
            for( var i = 0; i < totalSortOptionsList.length; i++ )
            {
                var sortOption = totalSortOptionsList[i];

                sortOption.callback = function( option )
                {
                    info( "SaleCardsScreen.setComboBox._innerCallback called. option=%s", JSON.stringify( option ) );

                    var sortBy = option.id;
                    var sortType = (option.invert !== undefined ) ? option.invert: false;

                    this.m_sortBy =
                    {
                        "value" : sortBy,
                        "invert" : sortType
                    };

                    this.setSortedCards();

                    this.showContainers();
                    this.fillContainersInfo();
                    this.updateScroll( this.hideContainers() );
                    this.updateHighlights();
                }.bind( this, sortOption );

                sortOptionsList.push( sortOption );
            }

            this.m_comboBox = new ComboBox( sortOptionsList, this.comboBox2 );
        },

        setSortedCards : function()
        {
            this.m_playerCards = CardsManager.getPlayerCardList( this.m_sortBy, this.m_playerCards );
        },

        isCardSelected : function( containerId )
        {
            var card = this.m_playerCards[containerId + (this.MAX_CONTAINERS * this.m_currentPage)];
            for( var i = 0; i < this.m_selectedCards.length; i++ )
            {
                if( this.m_selectedCards[i] == card )
                {
                    return true;
                }
            }
            return false;
        },

        updateHighlights : function()
        {
            info( "SaleCardsScreen.updateHighlights called." );

            var frame;
            for( var i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                frame = this.m_view._containers[i]._frameImage;
                if( this.isCardSelected( i ) )
                {
                    frame.setImage( "sale_cardframe_selected.png" );
                }
                else
                {
                    frame.setImage( "sale_cardframe_unselected.png" );
                }
            }
        },

        clearCombo : function( sender )
        {
            info( "SaleCardsScreen.clearCombo called." );

            var frame;
            for( var i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                frame = this.m_view._containers[i]._frameImage;
                frame.setImage( "sale_cardframe_unselected.png" );
            }

            this.m_selectedCards = [];
            this.disableButtons();
        },

        prevPage : function( sender )
        {
            info( "SaleCardsScreen.prevPage called." );

            if( this.m_currentPage === 0 )
            {
                return;
            }

            this.showContainers();
            this.m_currentPage--;

            this.fillContainersInfo();
            this.updateScroll( this.hideContainers() );
            this.updateHighlights();

            if( this.shouldResetScroll() )
            {
                this.scrollToTop();
            }
        },

        nextPage : function( sender )
        {
            info( "SaleCardsScreen.nextPage called." );

            if( (this.m_currentPage + 1) >= this.m_playerCards.length / this.MAX_CONTAINERS )
            {
                return;
            }

            this.showContainers();
            this.m_currentPage++;
            this.fillContainersInfo();
            this.updateScroll( this.hideContainers() );
            this.updateHighlights();

            if( this.shouldResetScroll() )
            {
                this.scrollToTop();
            }
        },

        showContainers : function()
        {
            for( var i = 0; i < this.MAX_CONTAINERS; i++ )
            {
                this.m_view._containers[i].setVisible( true );
                this.m_view._containers[i]._selectButton.setEnabled( true );
            }
        },

        getSeparateLists : function()
        {
            var normalList = [];
            var limboList = [];
            var retData = {};

            for( var i = 0; i < this.m_selectedCards.length; i++ )
            {
                if( this.m_selectedCards[i].inLimbo && this.m_selectedCards[i].inLimbo === true )
                {
                    limboList.push( this.m_selectedCards[i].id );
                }
                else
                {
                    normalList.push( this.m_selectedCards[i].id );
                }
            }
            retData.normalList = normalList;
            retData.limboList = limboList;

            return retData;
        },

        sellCards : function( sender )
        {
            info( "SaleCardsScreen.sellCards called." );

            var data = this.getSeparateLists();

            var cancelCallback = function()
            {
                return;
            };

            var self = this;

            var func = function()
            {
                Server.sellAll( data.normalList, data.limboList, function( error, _data )
                {
                    var retData;

                    if( error )
                    {
                        err( "SaleCardsScreen.sellCards Error. error=" + JSON.stringify( error ) );
                        return;
                    }

                    try
                    {
                        retData = JSON.parse( _data );
                    }
                    catch( except )
                    {
                        err( "SaleCardsScreen.sellCards: Error trying to parse server response. error=" + error );
                        err_full( "SaleCardsScreen.sellCards: Error=", _data );
                        return;
                    }

                    if( retData && retData.cards && retData.cardsLimbo && retData.cardsHistory )
                    {
                        info( "SalesCardScreen.sellCards: server returned: " + JSON.stringify( retData ) );
                        info( "SalesCardScreen.sellCards: server returned: cardsLength=" + retData.cards.length + "limboLength=" + retData.cardsLimbo.length );
                        CardsManager.initWithData( retData.cards, retData.cardsHistory, retData.cardsLimbo );
                        self.clearCombo();
                        if( self.m_selectedTab == self.VIEWS.EQUIPMENT )
                        {
                            self.equipmentTabPressed();
                        }
                        else
                        {
                            self.fightersTabPressed();
                        }
                        self.scrollToTop();

                        User.setCurrency( retData.currency );
                    }

                    Xib.Navigation.removeModalOverlay();
                } );
            };

            var acceptCallback = function( _func )
            {
                Xib.Navigation.setModalOverlay( new WaitingScreen( _func ) );
            }.bind( this, func );

            var popUp = new PopUp(
                2,
                PopUp.INFO,
                _loc( "sale_screen_confirmation" ),
                _loc( "sale_screen_confirmation_description", this.m_selectedCards.length ),
                cancelCallback,
                _loc( "sale_screen_cancel" ),
                acceptCallback,
                _loc( "sale_screen_accept" )
            );

            Xib.Navigation.setModalOverlay( popUp );
        },

        viewDidLoad : function( $super )
        {
            info( "SaleCardsScreen.viewDidLoad called." );
            $super();

            this._mapElements();
            this._mapActions();

            this.m_viewLoaded = true;
            this._populateUI();
            this.setComboBox();

            if( this.m_selectedTab == this.VIEWS.EQUIPMENT )
            {
                this.equipmentTabPressed();
            }
            else
            {
                this.fightersTabPressed();
            }

            this.updatePagingButtonStatus();
            this.disableButtons();

            var typeData =
            {
                "selected":
                {
                },
                "unselected":
                {
                }
            };

            this.equipmentTab.setStateData( typeData );
            this.fightersTab.setStateData( typeData );

            var backFunction = function()
            {
                var screen = new ControlRoom();
                Xib.Navigation.resetScreenStackTo( screen, false );
            }.bind( this );
            ScreenManager.setBackInfo( backFunction );

            var overlay = Xib.Navigation.getOverlayView();
            overlay.highlightButton( NO_SCREEN );
        },

        disableButtons : function()
        {
            this.m_enableButtons = false;
            this.sellCardsTop.setEnabled( false );
            this.sellCardsTop.setAlpha( this.ALPHA_DISABLED );

            this.sellCardsBottom.setEnabled( false );
            this.sellCardsBottom.setAlpha( this.ALPHA_DISABLED );
        },

        enableButtons : function()
        {
            this.m_enableButtons = true;
            this.sellCardsTop.setEnabled( true );
            this.sellCardsTop.setAlpha( 1 );

            this.sellCardsBottom.setEnabled( true );
            this.sellCardsBottom.setAlpha( 1 );
        },

        viewDidAppear : function()
        {
            Xib.Navigation.removeModalOverlay();
        }
    } );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/GashaCardDisplay'] = function(){var exports = $MODULE_REGISTRY['Code/UI/GashaCardDisplay'] || {}; $MODULE_REGISTRY['Code/UI/GashaCardDisplay'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/GashaCardDisplay.js';

exports.GashaCardDisplay = XibUI.subclass(
{
    classname: 'GashaCardDisplay',

    initialize: function( frame, cb )
    {
        this.m_cardDefinition = null;
        this.m_SpecialCardDisplay = null;
        this.m_frame = frame;
        this.m_Cb = cb;
        this.m_isNew = false;

        info( "GashaCardDisplay.initialize called." );

        this.initWithXib( "./Content/Xib/GashaCardDisplay.xib", true );
    },

    viewDidLoad: function()
    {
        info( "GashaCardDisplay.viewDidLoad called." );

        this._fixCardRatio();
        this._setupSpecialCard();

        if( this.m_Cb )
        {
            this.m_Cb();
        }
    },

    _setupSpecialCard : function()
    {
        info( "CardDisplay._setupSpecialCard, called." );

        this.m_SpecialCardDisplay = new SpecialCard( this.m_frame );
        var parent = this.cardImage.getParent();
        parent.addChild( this.m_SpecialCardDisplay );

        this.m_SpecialCardDisplay.setDepth( this.cardImage.getDepth() - 0.1 );
        this.m_SpecialCardDisplay.setPosition( this.cardImage.getPosition() );
    },

    _fixCardRatio : function()
    {
        info( "GashaCardDisplay._fixCardRatio, called." );

        var size, origin, frameRatio;

        // Scale the card to keep the correct ratio
        size        = this.m_frame._size;
        origin      = this.m_frame._origin;
        frameRatio  = size._height / size._width;

        this.cardImage.setFrame( origin._x, origin._y, size._width, size._height );

        var pos = this.cardImage.getPosition();
        var newWidth = this.newCardImage.getFrame().getSize().getWidth();
        this.newCardImage.setPosition( pos.getX() + size._width * 0.5 - newWidth * 0.5,
            pos.getY() - size._height * 0.4);
    },

    refresh: function( cardDefinition, cb )
    {
        info( "GashaCardDisplay.refreshWithDefinition called" );
        if( !cardDefinition )
        {
            this.getView().setAlpha( 0 );
            info( "GashaCardDisplay.refreshWithDefinition... null definition" );
            return;
        }
        this.getView().setAlpha( 1 );

        if( this.m_cardDefinition == cardDefinition )
        {
            return;
        }
        this.m_cardDefinition = cardDefinition;
        this.refreshVisuals( cb );
    },

    refreshVisuals: function( cb )
    {
        info( "GashaCardDisplay.refreshVisuals called." );
        this.cardImage.setImage( "1pxalpha0.png" );
        this.cardImage.spinnerOn();
        this.m_SpecialCardDisplay.setVisible( false );

        if ( this.m_cardDefinition.rarity != RARITY.superRare )
        {
            this.refreshCardImage( cb );
        }

        //always calling refresh on special card to remove the listener when the card is not special
        this.m_SpecialCardDisplay.refresh( this.m_cardDefinition, function( error )
        {
            if( this.getView()._destroyed == true )
            {
                return;
            }

            if ( this.m_cardDefinition.rarity != RARITY.superRare )
            {
                //if the card is not special, refreshCardImage
                //calls onCardLoaded, so we just return
                return;
            }

            if ( error )
            {
                //In case we dont find the frames for the special card, we show the regular card
                info("GashaCardDisplay.refresh._innerCallback: missing special card assets, loading regular image");
                this.refreshCardImage( cb );
            }
            else
            {
                this.onCardLoaded();
                this.m_SpecialCardDisplay.setVisible( true );
                //setting the button visible (but without assets) to make it clickable
                this.cardImage.setImage( "1pxalpha0.png" );
                this.cardImage.setVisible( true );
                if( cb )
                {
                    cb();
                }
            }
        }.bind( this ) );
    },

    refreshCardImage : function( cb )
    {
        this.m_currentCardId = this.m_cardDefinition.id;
        var cardDefinitionId = this.m_cardDefinition.id;

        CardsManager.loadCardImage( cardDefinitionId, IMAGE_SIZE.BIGGEST, function( imageURL )
        {
            if( this.cardImage._destroyed )
            {
                return;
            }
            //to check if the loaded card is actually the current card
            if( cardDefinitionId != this.m_currentCardId )
            {
                return;
            }
            this.onCardLoaded();
            this.cardImage.setVisible( true );

            this.cardImage.setImage( imageURL );
            if( cb )
            {
                cb();
            }
        }.bind( this ) );

        if (this.m_isNew)
        {
            this.newCardImage.setVisible(true);
            this.newCardImage.setAlpha( 1 );
            this.m_isNew = false;
        }
        else
        {
            this.newCardImage.setVisible(false);
            this.newCardImage.setAlpha( 0 );
            this.m_isNew = false;
        }
    },

    onCardLoaded : function()
    {
        this.cardImage.spinnerOff();
    },


    destroy : function( $super )
    {
        //ToDo: Check why this method isnt called
        info( "GashaCardDisplay.destroy called");
        if( this.m_SpecialCardDisplay && this.m_SpecialCardDisplay.destroy )
        {
            this.m_SpecialCardDisplay.destroy();
        }
        $super();
    }

} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/BossLanding'] = function(){var exports = $MODULE_REGISTRY['Code/UI/BossLanding'] || {}; $MODULE_REGISTRY['Code/UI/BossLanding'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/BossLanding.js';

exports.BossLanding = ScrollableView.subclass(
{
    classname: 'BossLanding',

    /**
     * BossLanding.initialize
     */
    initialize: function( $super, stageBossRewards, bossCard, stageInfo )
    {
        info( "BossLanding.initialize called." );
        info( "BossLanding.initialize ...stageBossRewards: " + JSON.stringify( stageBossRewards ) );
        info( "BossLanding.initialize ...bossCard: " + JSON.stringify( bossCard ) );
        info( "BossLanding.initialize ...stageInfo: " + JSON.stringify( stageInfo ) );

        this.m_stageBossRewards = stageBossRewards;
        this.m_bossCard = bossCard;
        this.m_stageInfo = stageInfo;
        this.m_nextStageInfo = null;

        $super();
        this.initWithXib( "./Content/Xib/BossLanding.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "BossLanding.viewDidLoad called." );
        $super();
        Xib.Navigation.removeModalOverlay();

        if( this.m_stageBossRewards == null )
        {
            return;
        }
        var cardInstance = this.m_stageBossRewards.card;
        this.setupCard( cardInstance );
        if( cardInstance != null )
        {
            if( CardsManager.isCardNew( cardInstance.definitionId ) == false )
            {
                this.newCardView.setVisible( false );
            }
            CardsManager.addPlayerCard( cardInstance );
        }

        if( cardInstance.inLimbo == true )
        {
            cardsInVaultPopUp(cardInstance);
        }

        var bossDefinition = CardsManager.getCardDefinition( this.m_bossCard.definitionId );
        var name = "";
        var cardDefinition = CardsManager.getCardDefinition( cardInstance.definitionId );
        if( cardDefinition != null )
        {
            name += _loc( cardDefinition.name ) + " x ";
        }
        name += _loc( bossDefinition.name );
        this.bossNameLabel.setText( name );
        
        var capacity = this.m_stageBossRewards.maxExploreEnergy;
        User.setMaxExplorationEnergy( capacity );
        GameController.getMainScreen().updateUIFuel();
        this.capacityLabel.setText( sprintf( _loc( "boss_landing_%s_capacity"), capacity ) );
        
        var collectionRewards = this.m_stageBossRewards.collectionRewards;
        RewardManager.addReward( collectionRewards );

        this.m_nextStageInfo = QuestManager.getNextStage( this.m_stageInfo.worldId, this.m_stageInfo.stageId );
    },

    setupCard: function( cardInstance )
    {
        if ( cardInstance == null )
        {
            return;
        }

        if ( cardInstance.definitionId == null )
        {
            return;
        }

        this.cardImage.spinnerOn();
        CardsManager.loadCardImage( cardInstance.definitionId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.cardImage._destroyed )
            {
                return;
            }
            this.cardImage.spinnerOff();
            this.cardImage.setImage( imageURL );
        }.bind( this ) );

        var cardDefinition = CardsManager.getCardDefinition( cardInstance.definitionId );
        if( cardDefinition == null )
        {
            return;
        }
        this.cardNameLabel.setText( _loc( cardDefinition.name ) );

        var cardStatus = CardsManager.getCardStatus( cardInstance );
        if( cardStatus == null )
        {
            return;
        }

        if( cardDefinition.type == PILOT )
        {
            var status1 = "" + Math.floor(cardStatus.status1*100) + "%";
            var status2 = "" + Math.floor(cardStatus.status2*100) + "%";
            var status3 = "" + Math.floor(cardStatus.status3*100) + "%";
            this.strengthNumLabel.setText( status1 );
            this.firePowerNumLabel.setText( status2 );
            this.mobilityNumLabel.setText( status3 );
        }
        else
        {
            this.strengthNumLabel.setText( sprintf( "%.2f", cardStatus.status1 ) );
            this.firePowerNumLabel.setText( sprintf( "%.2f", cardStatus.status2 ) );
            this.mobilityNumLabel.setText( sprintf( "%.2f", cardStatus.status3 ) );
        }
    },

    viewDidAppear: function()
    {
        info( "BossLanding.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();
    },

    controlRoomAction: function()
    {
        info( "BossLanding.controlRoomAction called." );

        Xib.Navigation.setModalOverlay( new WaitingScreen(function()
        {
            var screen = new ControlRoom();
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this ) ) );
    },

    continueAction: function()
    {
        info( "BossLanding.continueAction called....m_nextStageInfo: " + JSON.stringify( this.m_nextStageInfo ) );

        Xib.Navigation.setModalOverlay( new WaitingScreen(function()
        {
            var screen = null;
            if( this.m_nextStageInfo == null )
            {
                screen = new ControlRoom();
            }
            else if ( this.m_nextStageInfo.stageId != null && this.m_nextStageInfo.worldId != null )
            {
                var worldData = QuestManager.getWorldData( this.m_nextStageInfo.worldId );
                if( worldData )
                {
                    screen = new ExplorationStageUI( worldData );
                }
                else
                {
                    screen = new ExplorationWorldUI();
                }
            }
            else
            {
                screen = new ExplorationWorldUI();
            }
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this ) ) );
    }

} );; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/EnemyChanceLandingCredit'] = function(){var exports = $MODULE_REGISTRY['Code/UI/EnemyChanceLandingCredit'] || {}; $MODULE_REGISTRY['Code/UI/EnemyChanceLandingCredit'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/EnemyChanceLandingCredit.js';

exports.EnemyChanceLandingCredit = ScrollableView.subclass(
{
    classname: 'EnemyChanceLandingCredit',

    /**
     * EnemyChanceLandingCredit.initialize
     */
    initialize: function( $super, creditNumber, bossPilotCard, bossGearCard, win, finishCallback )
    {
        info( "EnemyChanceLandingCredit.initialize called. creditNumber=%s, win=%s", creditNumber, win );
        info( "EnemyChanceLandingCredit.initialize bossPilotCard=%s", JSON.stringify( bossPilotCard ) );
        info( "EnemyChanceLandingCredit.initialize bossGearCard =%s", JSON.stringify( bossGearCard ) );

        this.m_bossPilotCard  = bossPilotCard;
        this.m_bossGearCard   = bossGearCard;
        this.m_creditNumber   = creditNumber;
        this.m_win            = win;
        this.m_nextStageInfo  = null;
        this.m_finishCallback = finishCallback;

        $super();
        this.initWithXib( "./Content/Xib/EnemyChanceLandingCredit.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "EnemyChanceLandingCredit.viewDidLoad called." );
        $super();

        Xib.Navigation.removeModalOverlay();

        // Set titles
        var title    = "title_boss_defeat";
        var subTitle = "boss_landing_unbeaten";
        if( this.m_win )
        {
            title    = "title_boss_win";
            subTitle = "boss_landing_beaten";
        }
        this.screenTitle.setText( _loc(title) );
        
        this.screenSubTitle.setText( _loc(subTitle) );

        // Set Credit Text
        this.creditsLabel.setText( _loc( "boss_landing_%s_credits_acquired", this.m_creditNumber ) );

        // Set Credit Image
        this.cardImage.setImage( "GOLD_400.jpg" );

        // Set boss name
        this.bossNameLabel.setText( _loc( this.m_bossPilotCard.name ) + " X " + _loc( this.m_bossGearCard.name ) );
    },

    viewDidAppear: function()
    {
        info( "EnemyChanceLandingCredit.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();

        GameController.getMainScreen().showButtons();
        GameController.getMainScreen().showPlayerInfo();
    },

    controlRoomAction: function()
    {
        info( "EnemyChanceLandingCredit.controlRoomAction called." );

        Xib.Navigation.setModalOverlay( new WaitingScreen( function()
        {
            var screen = new ControlRoom();
            Xib.Navigation.resetScreenStackTo( screen, false );
        } ) );
    },

    continueAction: function()
    {
        info( "EnemyChanceLandingCredit.continueAction called." );
        Xib.Navigation.popViewController();

        if( this.m_finishCallback )
        {
            this.m_finishCallback();
        }
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI/EnemyChanceLandingCard'] = function(){var exports = $MODULE_REGISTRY['Code/UI/EnemyChanceLandingCard'] || {}; $MODULE_REGISTRY['Code/UI/EnemyChanceLandingCard'] = exports; 
var __dirname = 'Code/UI';
var __filename = 'Code/UI/EnemyChanceLandingCard.js';

exports.EnemyChanceLandingCard = ScrollableView.subclass(
{
    classname: 'EnemyChanceLandingCard',

    /**
     * EnemyChanceLandingCard.initialize
     */
    initialize: function( $super, rewardCard, bossPilotCard, bossGearCard, finishCallback )
    {
        info( "EnemyChanceLandingCard.initialize called. rewardCard=%s", JSON.stringify( rewardCard ) );
        info( "EnemyChanceLandingCard.initialize ...bossPilotCard=%s", JSON.stringify( bossPilotCard ) );
        info( "EnemyChanceLandingCard.initialize ...bossGearCard=%s", JSON.stringify( bossGearCard ) );

        this.m_bossPilotCard  = bossPilotCard;
        this.m_bossGearCard   = bossGearCard;
        this.m_rewardCard     = rewardCard;
        this.m_finishCallback = finishCallback;

        $super();
        this.initWithXib( "./Content/Xib/EnemyChanceLandingCard.xib", true );
    },

    viewDidLoad: function( $super )
    {
        info( "EnemyChanceLandingCard.viewDidLoad called." );
        $super();

        Xib.Navigation.removeModalOverlay();

        var cardInstance = this.m_rewardCard;
        this.setupCard( cardInstance );
        if( cardInstance != null )
        {
            if( CardsManager.isCardNew( cardInstance.definitionId ) == false )
            {
                this.newCardView.setVisible( false );
            }
            //CardsManager.addPlayerCard( cardInstance );
        }

        if( cardInstance.inLimbo == true )
        {
            cardsInVaultPopUp(cardInstance);
        }

        this.bossNameLabel.setText( _loc( this.m_bossPilotCard.name ) + " X " + _loc( this.m_bossGearCard.name ) );
    },

    setupCard: function( cardInstance )
    {
        if ( cardInstance == null )
        {
            return;
        }

        if ( cardInstance.definitionId == null )
        {
            return;
        }

        this.cardImage.spinnerOn();
        CardsManager.loadCardImage( cardInstance.definitionId, IMAGE_SIZE.BIG, function( imageURL )
        {
            if( this.cardImage._destroyed )
            {
                return;
            }
            this.cardImage.spinnerOff();
            this.cardImage.setImage( imageURL );
        }.bind( this ) );

        var cardDefinition = CardsManager.getCardDefinition( cardInstance.definitionId );
        if( cardDefinition == null )
        {
            return;
        }
        this.cardNameLabel.setText( _loc( cardDefinition.name ) );

        var cardStatus = CardsManager.getCardStatus( cardInstance );
        if( cardStatus == null )
        {
            return;
        }

        if( cardDefinition.type == PILOT )
        {
            var status1 = "" + Math.floor(cardStatus.status1*100) + "%";
            var status2 = "" + Math.floor(cardStatus.status2*100) + "%";
            var status3 = "" + Math.floor(cardStatus.status3*100) + "%";
            this.strengthNumLabel.setText( status1 );
            this.firePowerNumLabel.setText( status2 );
            this.mobilityNumLabel.setText( status3 );
        }
        else
        {
            this.strengthNumLabel.setText( sprintf( "%.2f", cardStatus.status1 ) );
            this.firePowerNumLabel.setText( sprintf( "%.2f", cardStatus.status2 ) );
            this.mobilityNumLabel.setText( sprintf( "%.2f", cardStatus.status3 ) );
        }
    },

    viewDidAppear: function()
    {
        info( "EnemyChanceLandingCard.viewDidAppear called." );
        Xib.Navigation.removeModalOverlay();

        GameController.getMainScreen().showButtons();
        GameController.getMainScreen().showPlayerInfo();
    },

    controlRoomAction: function()
    {
        info( "EnemyChanceLandingCard.controlRoomAction called." );

        Xib.Navigation.setModalOverlay( new WaitingScreen(function()
        {
            var screen = new ControlRoom();
            Xib.Navigation.resetScreenStackTo( screen, false );
        }.bind( this ) ) );
    },

    continueAction: function()
    {
        info( "EnemyChanceLandingCard.continueAction called." );
        Xib.Navigation.popViewController();

        if( this.m_finishCallback )
        {
            this.m_finishCallback();
        }
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Resources/ResourceManager'] = function(){var exports = $MODULE_REGISTRY['Code/Resources/ResourceManager'] || {}; $MODULE_REGISTRY['Code/Resources/ResourceManager'] = exports; 
var __dirname = 'Code/Resources';
var __filename = 'Code/Resources/ResourceManager.js';

exports.ResourceManager = Core.Class.singleton(
{
    classname: "ResourceManager",

    m_defaultSprite: "./Content/Textures/1pxalpha0.png",

    initialize: function()
    {
        info( "ResourceManager.initialize called." );

        this.m_currentManifest      = {};
        this.m_manifestProgress     = {};
        this.m_registry             = {};
        this.m_downloaders          = {};
        this.m_manifestFiles        = {};
        this.m_resourcesQueue       = [];

        this.loadMainManifest();
    },

    loadManifest: function( manifestData, cb, errorCb)
    {
        info( "ResourceManager.loadManifest called. manifest=" + manifestData.manifest );

        var manifest                            = manifestData.manifest;
        var dl                                  = new DownloadFileSet();
        this.m_currentManifest                  = manifest;
        this.m_manifestProgress[manifest]       = 0;
        this.m_downloaders[manifest]            = dl;
        
        var progressCallback    = function( manifest, cur, total )
        {
            if( cur > 0 )
            {
                if( !this.m_manifestFiles[manifest] )
                {
                    this.processManifestFiles( manifest, this.m_downloaders[manifest].mRemoteText, null, false );
                    this.m_manifestFiles[manifest]      = true;
                    info( "ResourceManager.loadManifest._innerCallback Registering manifest before download. manifest=%s", manifest );
                    this.retryPendingQuerys();
                }
            }

            if( total > 0 )
            {
                this.m_manifestProgress[manifest] = cur / total * 100;
            }
            else
            {
                this.m_manifestProgress[manifest] = 100;
            }
        }.bind( this, manifest );
        
        var doneCallback        = function( manifest, cb, errorCb, _error, man )
        {
            if( _error )
            {
                warn( "ResourceManager.loadManifest. Manifest download error, retrying." );
                
                var manifestURL     =   this.m_downloaders[manifest].mRemoteUrl;
                
                errorCb();
                
                this.m_downloaders[manifest].abort();
                
                setTimeout( this.loadManifest.bind( this, {
                    manifest    : manifest,
                    url         : manifestURL,
                }, cb, errorCb ), 2000 );
                                                
                return;
            }
            
            this.processManifestFiles( manifest, this.m_downloaders[manifest].mRemoteText, cb, true );
            this.retryPendingQuerys();
            info( "ResourceManager.loadManifest._innerCallback Registering manifest. manifest=%s", manifest );
        }.bind( this, manifest, cb, errorCb);

        dl.start( manifestData.url, "./", manifestData.manifest, progressCallback, doneCallback );

        return dl;
    },
    
    eraseResourceQueue          : function()
    {
        this.m_resourcesQueue.length    = 0;
    },

    loadMainManifest: function()
    {
        Storage.FileSystem.readFile( './webgame.ngmanifest', BLOCKING_READ, function( error, data )
        {
            if( !error )
            {
                if( data )
                {
                    this.processManifestFiles( "webgame.ngmanifest", data , null, true);
                    info( "ResourceManager.loadManifest._innerCallback registering manifest : webgame.ngmanifest  " );
                }
            }
            else
            {
                err( "ResourceManager.loadRegistry._innerCallback manifest webgame.ngmanifest not found" );
            }
        }.bind( this ) );
    },

    processManifestFiles: function( manifest, man, cb, alreadyDownloaded )
    {
        info( "ResourceManager.processManifestFiles called. manifest=%s, man=%s", JSON.stringify( manifest ), JSON.stringify( man ) );
        var manifestDict, file, path, name;
        try
        {
            manifestDict    = JSON.parse( man );
            
            var counter     = 0;

            for( file in manifestDict )
            {
                path = this.extractPath( file );
                name = path.pop();

                this.m_registry[name] =
                {
                    origin      : "Manifest",
                    path        : file,
                    downloaded  : alreadyDownloaded,
                    manifest    : manifest
                };
                
                info( "ASSET INFO >>> "+name+" >>> "+JSON.stringify( this.m_registry[name] ) );
                
                counter++;
            }
            info( "ResourceManager.processManifestFiles manifest : "+manifest+", with "+counter+" elements." );
        }
        catch( ex )
        {
            err( "ResourceManager.processManifestFiles Error, ex=%s", JSON.stringify( ex ) );
        }

        if( cb )
        {
            cb();
        }
    },

    extractPath: function( fileP )
    {
        var file, path;

        file = fileP.replace( './', '' ).replace( /[^\/]+\/\.\.\//, '' );
        path = file.split( '/' );

        if( path[0] == '' || path[0] == '.' )
        {
            path.shift();
        }

        return path;
    },

    getPathFor: function( spriteName, useDefaultSprite )
    {
        var originalPath = spriteName;
        var index = spriteName.lastIndexOf( "/" );
        spriteName = spriteName.substring( index >= 0 ? index + 1 : 0 );
        if( this.m_registry[spriteName] )
        {
            return this.m_registry[spriteName].path;
        }
        else
        {
            for( var i = 0; i < spritesheetsDefinitions.length; ++i )
            {
                sprite = spritesheetsDefinitions[i];
                if( sprite["frames"][spriteName] )
                {
                    spriteImage = sprite["meta"]["image"];
                    return ResourceManager.getPathFor( spriteImage );
                }
            }

            if( useDefaultSprite )
            {
                return this.m_defaultSprite;
            }
            else
            {
                return originalPath;
            }
        }
    },

    preLoadResource: function( spriteName, cb, errorCb )
    {
        spriteNameNoExt = spriteName.substring( 0, spriteName.lastIndexOf( '.' ) );
//        var manifestName = "webgame." + spriteNameNoExt + ".ngmanifest";

        var index = spriteName.lastIndexOf( "/" );
        spriteName = spriteName.substring( index >= 0 ? index + 1 : 0 );
        
        if( this.m_registry[spriteName] )
        {
            if( this.m_registry[spriteName].downloaded )
            {
                cb();
            }
            else
            {
                this.m_downloaders[this.m_registry[spriteName].manifest].onNotifyFileReady(this.m_registry[spriteName].path, cb);
            }
            return;
        }

        warn( "ResourceManager.preLoadResource Error. resource %s not found in any remote manifest, queueing", spriteName );


        var obj =
        {
            sprite          : spriteName,
            callback        : cb,
            error_callback  : errorCb
        };

        var onTimeOut = function()
        {
            var length = this.m_resourcesQueue.length;
            for( var i = 0; i < length; ++i )
            {
                var queueObj = this.m_resourcesQueue[i];
                if( queueObj == obj )
                {
                    if( queueObj.error_callback )
                    {
                        queueObj.error_callback();
                    }
                    this.m_resourcesQueue.splice( i, 1 );
                    return;
                }
            }
        }.bind( this );
        t = setTimeout( onTimeOut, 3000 );
        obj.timeout  = t;

        this.m_resourcesQueue.push( obj );


    },

    getUVSFor: function( image )
    {
        var index = image.lastIndexOf( "/" );
        image = image.substring( index >= 0 ? index + 1 : 0 );

        for( var i = 0; i < spritesheetsDefinitions.length; ++i )
        {
            if( spritesheetsDefinitions[i]["frames"][image] )
            {
                var bigSize = spritesheetsDefinitions[i]["meta"]["size"];
                var texFrame = spritesheetsDefinitions[i]["frames"][image]["frame"];
                return [ texFrame.x / bigSize.w, texFrame.y / bigSize.h, texFrame.w / bigSize.w, texFrame.h / bigSize.h ];
            }
        }

        return [ 0, 0, 1, 1 ];
    },

    getRealSizeFor: function( image )
    {
        var index = image.lastIndexOf( "/" );
        image = image.substring( index >= 0 ? index + 1 : 0 );

        for( var i = 0; i < spritesheetsDefinitions.length; ++i )
        {
            if( spritesheetsDefinitions[i]["frames"][image] )
            {
                return spritesheetsDefinitions[i]["frames"][image]["frame"];
            }
        }

        return null;
    },

    getAnimationFor: function( image )
    {
        var path = ResourceManager.getPathFor( image );

        var index = image.lastIndexOf( "/" );
        image = image.substring( index >= 0 ? index + 1 : 0 );

        var size = new Core.Size( animationDefinitions[image].width, animationDefinitions[image].height );
        var anchor = [ 0.5, 0.5 ];

        var animation = new GL2.Animation();
        animation.setFilteringEnabled( true );

        for( var k = 0; k < animationDefinitions[image].frames; ++k )
        {
            var i = k % ( animationDefinitions[image].grid[0] * animationDefinitions[image].grid[1] );

            if( k >= animationDefinitions[image].grid[0] * animationDefinitions[image].grid[1] )
            {
                path = ResourceManager.getPathFor( animationDefinitions[image].extraAssets[Math.floor( k / ( animationDefinitions[image].grid[0] * animationDefinitions[image].grid[1] ) - 1 )] );
            }

            var uvsX = ( animationDefinitions[image].spriteSheetWidth / animationDefinitions[image].grid[0] ) * ( i % animationDefinitions[image].grid[0] ) / animationDefinitions[image].spriteSheetWidth;
            var uvsY = ( animationDefinitions[image].spriteSheetHeight / animationDefinitions[image].grid[1] ) * ( Math.floor( i / animationDefinitions[image].grid[0] ) ) / animationDefinitions[image].spriteSheetHeight;
            var uvsW = ( animationDefinitions[image].spriteSheetWidth / animationDefinitions[image].grid[0] ) / animationDefinitions[image].spriteSheetWidth;
            var uvsH = ( animationDefinitions[image].spriteSheetHeight / animationDefinitions[image].grid[1] ) / animationDefinitions[image].spriteSheetHeight;

            animation.pushFrame( new GL2.Animation.Frame( path, ( 1 / animationDefinitions[image].fps ) * 1000, size, anchor, [ uvsX, uvsY, uvsW, uvsH ] ) );
        }

        return animation;
    },

    retryPendingQuerys : function()
    {
        var pending = [];
        for( var i = 0; i < this.m_resourcesQueue.length; ++i )
        {
            pending.push( this.m_resourcesQueue[i] );
        }

        this.m_resourcesQueue.length = 0;

        for( var i = 0; i < pending.length; ++i )
        {
            this.preLoadResource( pending[i].sprite, pending[i].callback, pending[i].error_callback );
            clearTimeout( pending[i].timeout );
        }
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Resources/ManifestManager'] = function(){var exports = $MODULE_REGISTRY['Code/Resources/ManifestManager'] || {}; $MODULE_REGISTRY['Code/Resources/ManifestManager'] = exports; 
var __dirname = 'Code/Resources';
var __filename = 'Code/Resources/ManifestManager.js';

exports.ManifestManager = Core.Class.singleton(
{
    classname: "ManifestManager",

    initialize: function()
    {
        this.m_manifestSet = null;
        this.m_manifestLoaded = 0;
        this.m_remoteManifestLoaded = 0;

        this.m_remoteManifestSet = null;
        this.m_currentDl =
        {};

        this.m_pauseTicket = 0;
    },

    loadManifestSet: function( filename, cb )
    {
        var downloader = new Network.DownloadFile();
        downloader.start( filename, "GET", MANIFEST_SET_URL, [], function( cb, status, md5, responseHeaders )
        {
            if( status != 200 )
            {
                err( "COULD NOT DOWNLOAD ASSETS, PLEASE RESTART THE GAME" );
                return;
            }

            Storage.FileSystem.readFile( filename, BLOCKING_READ, function( cb, error, data )
            {
                if( !error )
                {
                    if( data )
                    {
                        var dataParsed = JSON.parse( data );
                        this.m_manifestSet = dataParsed["local"];
                        this.m_remoteManifestSet = dataParsed["remote"];
                    }
                    else
                    {
                        this.m_manifestSet =
                        {};
                    }

                    info( "ManifestManager.loadManifestSet._innerCallback manifestSet Loaded successfully" );
                }
                else
                {
                    this.m_manifestSet =
                    {};
                    warn( "ManifestManager.loadManifestSet._innerCallback manifestSet not found, creating an empty list" );
                }

                this.processManifestSet( this.m_manifestSet, this.finishManifestLoading.bind( this ), this.onStartManifestError.bind( this ) );
                cb();
            }.bind( this, cb ) );
        }.bind( this, cb ) );
    },

    onStartManifestError: function()
    {
        warn( "ManifestManager.onStartManifestError called. Error loading manifest. Restarting game." );
    },

    processManifestSet: function( manifestSet, cb, errorCb )
    {
        if( manifestSet.length == 0 )
        {
            cb();
            return;
        }
        for( var i = 0; i < manifestSet.length; i++ )
        {
            this.m_currentDl[manifestSet[i]] = ResourceManager.loadManifest( manifestSet[i], cb, errorCb );
        }
    },

    finishManifestLoading: function()
    {
        this.m_manifestLoaded++;

        if( this.m_manifestLoaded == this.m_manifestSet.length || this.m_manifestSet.length == 0 )
        {
            info( "STARTING GAME AFTER MANIFEST DOWNLOAD WITH SCREEN_WIDTH=" + SCREEN_WIDTH + " SCREEN_HEIGHT=" + SCREEN_HEIGHT );

            DataLoader.loadLenguage( function()
            {
                var func = function()
                {
                    User.instantiate();

                    // GameController.removeLoadingScreen();
                    // GameController.m_background.setBackgrounds();

                    validFonts =
                    {
                        "default": "Content/font/font_300.ttf"
                    };

                    GameController.playBgMusic();
                };

                if( HUD_READY == true )
                {
                    func();
                }
                else
                {
                    INIT_FUNC_ARRAY.push( func );
                }
            } );
        }
    },

    startLoadRemoteManifestSet: function()
    {
        this.processManifestSet( this.m_remoteManifestSet, this.finishRemoteManifestLoading.bind( this ), this.onRemoteManifestError.bind( this ) );
    },

    onRemoteManifestError: function()
    {
        warn( "ManifestManager.onRemoteManifestError called. Error loading remote manifests. Restarting download." );
    },

    finishRemoteManifestLoading: function()
    {
        this.m_remoteManifestLoaded++;

        if( this.m_remoteManifestLoaded == this.m_remoteManifestSet.length )
        {
            info( "ManifestManager.finishRemoteManifestLoading Remote manifest download finished." );
        }
    },

    pauseRemoteLoading: function()
    {
        if( this.m_pauseTicket == 0 )
        {
            warn( "ManifestManager.pauseRemoteLoading Pausing remote manifest download" );
            for( var man in this.m_currentDl )
            {
                var manifest = this.m_currentDl[man];
                manifest.pause();
            }
        }

        this.m_pauseTicket++;
    },

    resumeRemoteLoading: function()
    {
        this.m_pauseTicket--;

        if( this.m_pauseTicket == 0 )
        {
            warn( "ManifestManager.resumeRemoteLoading Resuming remote manifest download" );
            for( var man in this.m_currentDl )
            {
                var manifest = this.m_currentDl[man];
                manifest.resume();
            }
        }
    }
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Resources/DataLoader'] = function(){var exports = $MODULE_REGISTRY['Code/Resources/DataLoader'] || {}; $MODULE_REGISTRY['Code/Resources/DataLoader'] = exports; 
var __dirname = 'Code/Resources';
var __filename = 'Code/Resources/DataLoader.js';

exports.DataLoader = Core.Class.singleton(
{
    classname: "DataLoader",

    initialize: function()
    {
        info( "DataLoader.initialize" );
        self = this;
        this.m_filesToLoad =
        {
            "cards.json": function( data )
            {
                CardsManager.loadCardListDetails( data );
                self._loadFileCallback();
            },
            "levelsGear.json": function( data )
            {
                CardsManager.loadGearLevel( data );
                self._loadFileCallback();
            },
            "levelsPilots.json": function( data )
            {
                CardsManager.loadPilotLevel( data );
                self._loadFileCallback();
            },
            "missions.json": function( data )
            {
                QuestManager.loadMissionsListDetails( data );
                self._loadFileCallback();
            },
            "lucky.json": function( data )
            {
                QuestManager.loadLuckyChanceListDetails( data );
                self._loadFileCallback();
            },
            "gashaPacks.json": function( data )
            {
                GashaManager.loadGashaListDetails( data );
                self._loadFileCallback();
            },
            "levels.json": function( data )
            {
                User.loadLevelListDetails( data );
                User.calculateLevel();
                User.calculateProgressLevel();
                self._loadFileCallback();
            },
            "skills.json": function( data )
            {
                SkillsManager.loadSkillsListDetails( data );
                self._loadFileCallback();
            },
            "items.json": function( data )
            {
                ItemManager.loadItemListDetails( data );
                self._loadFileCallback();
            },
            "starterPacks.json": function( data )
            {
                TutorialManager.loadStarterPacksListDetails( data );
                self._loadFileCallback();
            },
            "config.json": function( data )
            {
                TimersController.initWithData( data );
                self._loadFileCallback();
            },
            "itemPacks.json": function( data )
            {
                ItemPackManager.initWithData( data );
                self._loadFileCallback();
            },
            "gearCardsCollectionRewards.json": function( data )
            {
                RewardManager.loadGearRewardDefinition( data );
                self._loadFileCallback();
            },
            "pilotCardsCollectionRewards.json": function( data )
            {
                RewardManager.loadPilotRewardDefinition( data );
                self._loadFileCallback();
            },
            "stageRewards.json": function( data )
            {
                RewardManager.loadStageRewardDefinition( data );
                self._loadFileCallback();
            },
            "enemyChance.json": function( data )
            {
                QuestManager.loadEnemyChance( data );
                self._loadFileCallback();
            }
        };

        this.m_filesLoaded = 0;
        this.m_numberToLoad = Object.keys( this.m_filesToLoad ).length;

    },

    loadFiles: function()
    {
        info( "DataLoader.loadFiles" );
        var filesToLoad = this.m_filesToLoad;
        for( var key in filesToLoad )
        {
            var callback = filesToLoad[key];
            var fileName = key;
            this._readFile( fileName, callback );
        }

    },

    _readFile: function( fileName, callback )
    {
        var JSONPath = ResourceManager.getPathFor( fileName );
        info( "DataLoader.loadFiles JSONPath=%s", JSONPath );

        Storage.FileSystem.readFile( JSONPath, true, function( callback, _JSONPath, error, data )
        {
            if( error != undefined )
            {
                if( ( typeof data === "string" ) && ( data != "" ) )
                {
                    data = JSON.parse( data );
                }
                callback( data, JSONPath );
            }
            else
            {
                err( "DataLoader.loadFiles Error, cannot load file. _JSONPath=%s, error=%s", _JSONPath, JSON.stringify( error ) );
            }
        }.bind( this, callback, JSONPath ) );
    },

    _loadFileCallback: function()
    {
        this.m_filesLoaded++;
        info( "DataLoader._loadFileCallback: " + this.m_filesLoaded + "/" + this.m_numberToLoad );
        if( this.m_filesLoaded >= this.m_numberToLoad )
        {
            info( "DataLoader._loadFileCallback: loading the initial screen" );
            GameController.LoadInitialScreen();
        }
    },

    loadLenguage: function( cb )
    {
        // Localization
        var language = Capabilities.getLanguage();
        var key = language + ".json";
        self = this;
        
        this._readFile( key, function( data, JSONPath )
        {
            info( "DataLoader.setDictionary: JSONPath: " + JSONPath + ", language: " + language + ", key: " + key );

            // If we don't have the file for the device language, use en.
            if( JSONPath == key )
            {
                language2 = "en";
                var key2 = language2 + ".json";
                self._readFile( key2, function( data2, JSONPath2 )
                {
                    info( "DataLoader.setDictionary: setting default language: " + JSONPath2 );
                    Localization.setDictionary( language2, data2 );
                    cb();
                } );
            }
            else
            {
                info( "DataLoader.setDictionary: setting language: " + JSONPath );
                Localization.setDictionary( language, data );
                cb();
            }
        } );
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/_Prototypes'] = function(){var exports = $MODULE_REGISTRY['Code/Util/_Prototypes'] || {}; $MODULE_REGISTRY['Code/Util/_Prototypes'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/_Prototypes.js';

exports._Prototypes = {
    load: loadPrototypes

};


function loadPrototypes()
{
    if( this._loaded )
    {
        return;
    }

    this._loaded = true;
    //Node
    var nodesLiveInstances = 0;
    GL2.Node.getLiveInstances = function()
    {
        return nodesLiveInstances;
    };

    function _countVisible( node, isRoot )
    {
        var i, counter = 0;
        if( node && (
            node._visible || isRoot) )
        {
            counter++;
            if( node._children )
            {
                for( i = 0; i < node._children.length; i++ )
                {
                    counter += this._countVisible( node._children[i], false );
                }
            }
        }
        return counter;
    }

    var nodesVisibleInstances = 0;
    GL2.Node.getVisibleInstances = function()
    {
        nodesVisibleInstances = this._countVisible( GL2.Root, true );

        return nodesVisibleInstances;
    };

    var __GL2Nodeinitialize = GL2.Node.prototype.initialize;
    GL2.Node.prototype.initialize = function()
    {
        if( FPS.leakCheck )
        {
            try
            {
                throw new Error();
            }
            catch( e )
            {
                FPS.trackObj( this, 'Node', e );
            }
        }
        nodesLiveInstances++;
        __GL2Nodeinitialize.apply( this, arguments );
    };

    var __GL2Nodedestroy = GL2.Node.prototype.destroy;
    GL2.Node.prototype.destroy = function()
    {
        if( FPS.leakCheck )
        {
            FPS.untrackObj( this );
        }
        nodesLiveInstances--;
        __GL2Nodedestroy.apply( this, arguments );
    };

    //Sprites
    var spritesLiveInstances = 0;
    GL2.Sprite.getLiveInstances = function()
    {
        return spritesLiveInstances;
    };

    var __GL2Spriteinitialize = GL2.Sprite.prototype.initialize;
    GL2.Sprite.prototype.initialize = function()
    {
        if( FPS.leakCheck )
        {
            try
            {
                throw new Error();
            }
            catch( e )
            {
                FPS.trackObj( this, 'Sprite', e );
            }
        }
        spritesLiveInstances++;
        __GL2Spriteinitialize.apply( this, arguments );
    };

    var __GL2Spritedestroy = GL2.Sprite.prototype.destroy;
    GL2.Sprite.prototype.destroy = function()
    {
        if( FPS.leakCheck )
        {
            FPS.untrackObj( this );
        }
        spritesLiveInstances--;
        __GL2Spritedestroy.apply( this, arguments );
    };

    //Texts
    textsLiveInstances = 0;
    GL2.Text.getLiveInstances = function()
    {
        return textsLiveInstances;
    };

    var __GL2Textinitialize = GL2.Text.prototype.initialize;
    GL2.Text.prototype.initialize = function()
    {
        if( FPS.leakCheck )
        {
            try
            {
                throw new Error();
            }
            catch( e )
            {
                FPS.trackObj( this, 'Text', e );
            }
        }
        textsLiveInstances++;
        __GL2Textinitialize.apply( this, arguments );
    };

    var __GL2Textdestroy = GL2.Text.prototype.destroy;
    GL2.Text.prototype.destroy = function()
    {
        if( FPS.leakCheck )
        {
            FPS.untrackObj( this );
        }
        textsLiveInstances--;
        __GL2Textdestroy.apply( this, arguments );
    };

    //Animations
    animsliveInstances = 0;
    GL2.Animation.getLiveInstances = function()
    {
        return animsliveInstances;
    };

    var __GL2Animationinitialize = GL2.Animation.prototype.initialize;
    GL2.Animation.prototype.initialize = function()
    {
        if( FPS.leakCheck )
        {
            try
            {
                throw new Error();
            }
            catch( e )
            {
                FPS.trackObj( this, 'Animation', e );
            }
        }
        animsliveInstances++;
        __GL2Animationinitialize.apply( this, arguments );
    };

    var __GL2Animationdestroy = GL2.Animation.prototype.destroy;
    GL2.Animation.prototype.destroy = function()
    {
        if( FPS.leakCheck )
        {
            FPS.untrackObj( this );
        }
        animsliveInstances--;
        __GL2Animationdestroy.apply( this, arguments );
    };
}
;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/FPS'] = function(){var exports = $MODULE_REGISTRY['Code/Util/FPS'] || {}; $MODULE_REGISTRY['Code/Util/FPS'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/FPS.js';

var _Prototypes = require( "Code/Util/_Prototypes" )._Prototypes;

var FPS = exports.FPS = Core.MessageListener.singleton( {

    classname: "FPS",

    initialize: function()
    {
        this._doConsole = true;
        this._doGLText = true;
        this._doNodeIntacesProfiling = false;
        this._consoleFormat = "///FPS avg: %d, max: %d, min: %d";
        this._consoleFormatNIP = "///FPS avg: %d, max: %d, min: %d; Instances nodes: %d/%d, sprite: %d, anims: %d, texts: %d";
        this._currentConsoleFormat = this._consoleFormat;

        this._glTextPD = this._createProfileData( 500 );
        this._consolePD = this._createProfileData( 8000 );

        // Subscribe to per frame updates.
        Core.UpdateEmitter.addListener( this, this._onUpdate );

        var glText = new GL2.Text( "60.0 fps" );
        this._glText = glText;

        glText.setFontSize( ~~(
            20 * Core.Capabilities.getScreenUnits()) );
        glText.setHorizontalAlign( GL2.Text.HorizontalAlign.Right );
        glText.setAnchor( 1, 1 );

        glText.setColor( 1, 1, 1 );
        glText.setDepth( 10000 );

        /*setTimeout( function()
        {
            //less one to fix for a bug on ngcore
            glText.setPosition( UI.Window._width - 1, UI.Window._height - 1 );
            GL2.Root.addChild( glText );
        }, 1500 );*/
    },

    _createProfileData: function( interval )
    {
        return {
            _duration: 0,
            _durationMax: 0,
            _durationMin: Number.MAX_VALUE,
            _interval: interval,
            _ticks: 0
        };
    },

    getGLText: function()
    {
        return this._glText;
    },

    setGLTextUpdateInterval: function( delta )
    {
        this._glTextPD._interval = delta;
    },

    setConsoleUpdateInterval: function( delta )
    {
        this._consolePD._interval = delta;
    },

    setDoNodeIntacesProfiling: function( boolean )
    {
        this._doNodeIntacesProfiling = boolean;
        if( boolean )
        {
            _Prototypes.load();
            this._currentConsoleFormat = this._consoleFormatNIP;
        }
        else
        {
            this._currentConsoleFormat = this._consoleFormat;
        }
    },

    setDoGLText: function( doGLText )
    {
        this._doGLText = doGLText;
    },

    setDoConsole: function( doConsole )
    {
        this._doConsole = doConsole;
    },

    _onUpdate: function( dt )
    {
        var gpd = this._glTextPD;
        var cpd = this._consolePD;

        gpd._duration += dt;
        gpd._ticks++;

        // add frame data
        cpd._duration += dt;
        cpd._ticks++;

        cpd._durationMax = Math.max( cpd._durationMax, dt );
        cpd._durationMin = Math.min( cpd._durationMin, dt );

        if( this._doGLText && gpd._duration > gpd._interval )
        {
            var fps = (
                ~~(
                    gpd._ticks / gpd._duration * 1000 * 10)) / 10 + "";
            if( fps.indexOf( "." ) == -1 )
            {
                fps = fps.concat( ".0" );
            }
            this._glText.setText( fps + " fps" );

            gpd._duration = 0;
            gpd._ticks = 0;
        }

        if( this._doConsole && cpd._duration > cpd._interval )
        {
            var fps = ~~(
                cpd._ticks / cpd._duration * 1000);
            if( this._doNodeIntacesProfiling )
            {
                console.log( this._currentConsoleFormat,
                    fps,
                    Math.round( 1000 / cpd._durationMin ),
                    Math.round( 1000 / cpd._durationMax ),
                    GL2.Node.getLiveInstances(),
                    GL2.Node.getLiveInstances(),
                    GL2.Sprite.getLiveInstances(),
                    GL2.Animation.getLiveInstances(), GL2.Text.getLiveInstances() );
            }
            else
            {
                console.log( this._currentConsoleFormat, fps, Math.round( 1000 / cpd._durationMin ), Math.round( 1000 / cpd._durationMax ) );
            }

            cpd._duration = 0;
            cpd._ticks = 0;
            cpd._durationMax = 0;
            cpd._durationMin = Number.MAX_VALUE;
        }
    }
} );


; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/_Visualizer'] = function(){var exports = $MODULE_REGISTRY['Code/Util/_Visualizer'] || {}; $MODULE_REGISTRY['Code/Util/_Visualizer'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/_Visualizer.js';

var _Visualizer = exports._Visualizer = Core.Class.subclass( {
    classname: "_Visualizer",

    initialize: function( classObject )
    {
        this._classObject = classObject;
        console.log( "Initializing debug visualization for: " + classObject.classname );

        classObject.prototype._showVisualization = function()
        {
            if( this._visualization ) return;
            this._visualization = new GL2.Primitive();
            this._visualization.setType( GL2.Primitive.Type.TriangleStrip );
            this._visualization.pushVertex( new GL2.Primitive.Vertex( [0, 0] ) );
            this._visualization.pushVertex( new GL2.Primitive.Vertex( [1, 0] ) );
            this._visualization.pushVertex( new GL2.Primitive.Vertex( [0, 1] ) );
            this._visualization.pushVertex( new GL2.Primitive.Vertex( [1, 1] ) );
            this._visualization.setAlpha( 0.5 );
            this._visualization.setDepth( Infinity );
            this._visualization.setColor( Math.random(), Math.random(), Math.random() );
            this.addChild( this._visualization );
            this._correctVisualization();
        };

        classObject.prototype._hideVisualization = function()
        {
            if( !this._visualization ) return;
            if( this._visualization.__objectRegistryId )
            {
                this._visualization.destroy();
            }
            delete this._visualization;
        };

        classObject.prototype._correctVisualization = function()
        {
            var s = this.getSize();
            var a = this.getAnchor();

            this._visualization.setScale( s._width, s._height );
            this._visualization.setPosition( -a._x * s._width, -a._y * s._height );
        };
    },

    show: function()
    {
        if( this.showing ) return;
        this.showing = true;

        var self = this;

        self._oldInitialize = this._classObject.prototype.initialize;
        this._classObject.prototype.initialize = function()
        {
            self._oldInitialize.apply( this, arguments );
            this._showVisualization();
        };

        self._oldDestroy = this._classObject.prototype.destroy;
        this._classObject.prototype.destroy = function()
        {
            self._oldDestroy.apply( this, arguments );
            this._hideVisualization();
        };

        self._oldSetAnchor = this._classObject.prototype.setAnchor;
        this._classObject.prototype.setAnchor = function()
        {
            self._oldSetAnchor.apply( this, arguments );
            this._correctVisualization();
        };

        self._oldSetSize = this._classObject.prototype.setSize;
        this._classObject.prototype.setSize = function()
        {
            self._oldSetSize.apply( this, arguments );
            this._correctVisualization();
        };

        var objs = Core.ObjectRegistry._objects;
        for( var i in objs )
        {
            if( !objs.hasOwnProperty( i ) ) continue;
            if( !(
                objs[i] instanceof this._classObject) ) continue;
            objs[i]._showVisualization();
        }
    },

    hide: function()
    {
        if( !this.showing ) return;
        this.showing = false;

        this._classObject.prototype.initialize = this._oldInitialize;
        this._classObject.prototype.destroy = this._oldDestroy;
        this._classObject.prototype.setAnchor = this._oldSetAnchor;

        var objs = Core.ObjectRegistry._objects;
        for( var i in objs )
        {
            if( !objs.hasOwnProperty( i ) ) continue;
            if( !(
                objs[i] instanceof this._classObject) ) continue;
            objs[i]._hideVisualization();
        }
    },
} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/TouchTargetVisualizer'] = function(){var exports = $MODULE_REGISTRY['Code/Util/TouchTargetVisualizer'] || {}; $MODULE_REGISTRY['Code/Util/TouchTargetVisualizer'] = exports; 
var __dirname = 'Code/Util';
var __filename = 'Code/Util/TouchTargetVisualizer.js';

var _Visualizer = require("Code/Util/_Visualizer")._Visualizer;

exports.TouchTargetVisualizer = _Visualizer.singleton({
	classname: "TouchTargetVisualizer",
	
	/**
	 * Shows a rectangle where the touch target should fit. 
	 * @example
	 * TouchTargetVisualizer.instantiate();
	 * 
	 * If you need to hide the visualization, then call: TouchTargetVisualizer.hide();
	 * If you need to show the visualization again, then call: TouchTargetVisualizer.show();
	 */
	initialize: function ($super) {
		$super(GL2.TouchTarget);
		
		this.show();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/Server'] = function(){var exports = $MODULE_REGISTRY['Code/Server/Server'] || {}; $MODULE_REGISTRY['Code/Server/Server'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/Server.js';

exports.Server = Core.Class.singleton(
{
    classname: 'Server',
    exposedClassname: 'Server',

    initialize: function()
    {
        info( "Server.initialize called." );

        this.m_remoteDeck = null;
        this.m_remoteItem = null;
        this.m_remoteCard = null;
        this.m_remoteUser = null;
        this.m_remoteBattle = null;
        this.m_remoteGasha = null;
        this.m_remoteMission = null;
        this.m_remoteGift = null;
        this.m_remoteReward = null;

        m_ReceivedServerTime = 0;
        m_CheckpointTime = 0;

        //var serverURL = "http://10.80.1.15:8090";
        var serverURL = "http://sp-live.aws.ngmoco.com";
        // var serverURL   = "http://10.80.1.238:8090";
        //var serverURL = "http://sp-stage.aws.ngmoco.com";

        var configs = Core.Capabilities.getConfigs();
        var credentials =
        {
            // consumerKey: configs.socialConsumerKey,
            // consumerSecret: configs.socialConsumerSecret,

            consumerKey: "jAyGDJ70A2FliRSmaTSVw",
            consumerSecret: "AujcCMf1QTukNbj6GkRFYhSopIkoJ4j8drCXWnn9Q",
            token: ""
        };

        // TODO Put this url in configuration.json
        // RemoteCall.setup( serverURL, credentials );
        // RemoteCall.setup( "http://sp-dev.aws.ngmoco.com", credentials );
        RemoteCall.setup( serverURL, credentials );
        // RemoteCall.setup( "http://192.168.1.134:8090", credentials );

        var oauthServer = new NgServer( serverURL );

        // Authenticate the current user
        oauthServer.authenticate( function( error, credentials, oauthTokens )
        {
            info( "Server.initialize.oauthServer.authenticate called." );

            if( error )
            {
                err( "Server.initialize.oauthServer.authenticate Error, cannot retrieve OAuth Tokens: %s", JSON.stringify( error ) );
                return;
            }

            info( "Server.initialize.oauthServer.authenticate credentials.token=%s, credentials.tokenSecret=%s", credentials.token, credentials.tokenSecret );

            this.m_session = new ServerSession( User.getGamerTag() );
            this.m_session.login( /* mobageId */User.m_userId, credentials.token, credentials.tokenSecret, function( error, data )
            {
                // TODO Handle error
                info( "Server.initialize.oauthServer.authenticate.m_session.login called. error=%s, data=%s", JSON.stringify( error ), data );
                var dataObject = JSON.parse( data );
                var func = function()
                {
                    User.m_userData = dataObject;
                    Server.setUpServerTime( dataObject.serverTime );
                    User.setUpManagers();
                    User.updateGashaDates();

                    DataLoader.loadFiles();

                    TutorialManager.instantiate();

                    info( "Server.initialize.oauthServer.authenticate.m_session.login  User.m_userData.tutorialState=%s", User.m_userData.tutorialState );
                    if( User.m_userData.tutorialState == TutorialManager.STATE_TUTORIAL_END )
                    {
                        TutorialManager.setActiveState( null );
                    }
                    else
                    {
                        TutorialManager.setActiveState( TutorialManager.STATE_START );
                    }
                };
                if( HUD_READY == true )
                {
                    func();
                }
                else
                {
                    INIT_FUNC_ARRAY.push(func);
                }
            }.bind( this ) );
        }.bind( this ) );
    },

    getRemoteDeckObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteDeck == null )
        {
            this.m_remoteDeck = new RemoteDeck( this.m_session );
        }
        return this.m_remoteDeck;
    },

    getRemoteItemObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteItem == null )
        {
            this.m_remoteItem = new RemoteItem( this.m_session );
        }
        return this.m_remoteItem;
    },

    getRemoteGiftObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteGift == null )
        {
            this.m_remoteGift = new RemoteGift( this.m_session );
        }
        return this.m_remoteGift;
    },

    getRemoteRewardObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteReward == null )
        {
            this.m_remoteReward = new RemoteReward( this.m_session );
        }
        return this.m_remoteReward;
    },

    getRemoteCardObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteCard == null )
        {
            this.m_remoteCard = new RemoteCard( this.m_session );
        }
        return this.m_remoteCard;
    },

    getRemoteUserObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteUser == null )
        {
            this.m_remoteUser = new RemoteUser( this.m_session );
        }
        return this.m_remoteUser;
    },

    getRemoteBattleObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteBattle == null )
        {
            this.m_remoteBattle = new RemoteBattle( this.m_session );
        }
        return this.m_remoteBattle;
    },

    getRemoteGashaObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteGasha == null )
        {
            this.m_remoteGasha = new RemoteGasha( this.m_session );
        }
        return this.m_remoteGasha;
    },

    getRemoteMissionObject: function( remake /* Boolean */)
    {
        if( remake || this.m_remoteMission == null )
        {
            this.m_remoteMission = new RemoteMission( this.m_session );
        }
        return this.m_remoteMission;
    },

    /*
     * Battle methods
     */
    getBattleEnemies: function( level, remake, cb )
    {
        var battle = this.getRemoteBattleObject( remake );
        battle.requestEnemies( level, cb );
    },

    getEnemyDeck            : function( enemy, remake, cb )
    {
        var battle = this.getRemoteBattleObject( remake );
        battle.requestEnemyDeck( enemy, cb );
    },
    
    hasEnoughEnemies        : function( level, remake, cb )
    {
        var battle  = this.getRemoteBattleObject( remake );
        battle.hasEnoughEnemies( level, cb );
    },
    

    /*
     * Deck methods
     */
    setDeck: function( index, deckData, remake, cb )
    {
        var deck = this.getRemoteDeckObject( remake );
        deck.setDeck( index, deckData, cb );
    },

    getDeck: function( index, remake, cb )
    {
        var deck = this.getRemoteDeckObject( remake );
        deck.getDeck( index, cb );
    },

    recommendDeck: function( remake, cb )
    {
        var deck = this.getRemoteDeckObject( remake );
        deck.recommend( cb );
    },

    setInitialDeck: function( index, packIndex, remake, cb )
    {
        var deck = this.getRemoteDeckObject( remake );
        deck.setInitialDeck( index, packIndex, cb );
    },

    /*
     * Item methods
     */
    get: function( itemId, remake, cb )
    {
        var item = this.getRemoteItemObject( remake );
        item.get( itemId, cb );
    },

    getPrice                : function( itemId, remake, cb )
    {
        var item    = this.getRemoteItemObject( remake );
        item.getPrice( itemId, cb );
    },

    useItem: function( itemId, cb, remake )
    {
        var item = this.getRemoteItemObject( remake );
        item.useItem( itemId, cb );
    },

    purchaseItemPack: function( transactionId, cb, remake )
    {
        var item = this.getRemoteItemObject( remake );
        item.purchase( transactionId, cb );
    },

    /*
     * Gift methods
     */
    claimGift: function( giftList, remake, cb )
    {
        var gift = this.getRemoteGiftObject( remake );
        gift.claim( giftList, cb );
    },

    /*
     * Reward methods
     */
    claimReward: function( rewardList, remake, cb )
    {
        var reward = this.getRemoteRewardObject( remake );
        reward.claim( rewardList, cb );
    },

    /*
     * Card methods
     */

    getCardDefinitionId: function( cardDefinitionId, remake, cb )
    {
        var card = this.getRemoteCardObject( remake );
        card.getDefinitionId( cardDefinitionId, cb );
    },

    setCardExperience: function( cardDefinitionId, value, remake, cb )
    {
        var card = this.getRemoteCardObject( remake );
        card.setExperience( cardDefinitionId, value.cb );
    },

    fusionCard: function( baseId, evolverId, items, remake, cb )
    {
        var card = this.getRemoteCardObject( remake );
        card.fusion( baseId, evolverId, items, cb );
    },

    sellCard: function( cardDefinitionId, remake, cb )
    {
        var card = this.getRemoteCardObject( remake );
        card.sell( cardDefinitionId, cb );
    },


    sellAll: function(normalList, limboList, cb, remake)
    {
        var card = this.getRemoteCardObject( remake );
        card.sellAll(normalList, limboList, cb);
    },

    runGasha: function( cb, gashaId, type, bankTransactionId, remake)
    {
        var gasha = this.getRemoteGashaObject( remake );
        gasha.requestCards( gashaId, type, bankTransactionId, cb );
    },

    runFreeGasha: function( cb, cardType, remake )
    {
        var gasha = this.getRemoteGashaObject( remake );
        gasha.requestCards( "free", cardType, cb );
    },

    runPaidGasha: function( cb, cardType, remake )
    {
        var gasha = this.getRemoteGashaObject( remake );
        gasha.requestCards( "paid", cardType, cb );
    },

    getLastAndNextFreeGashaDates: function( cb, remake )
    {
        var gasha = this.getRemoteGashaObject( remake );
        gasha.getLastAndNextFreeGashaDates( cb );
    },

    /*
     * User methods
     */

    getExplorationState: function( cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.getExplorationState( cb );
    },

    getCurrentUser: function( remake, cb )
    {
        var user = this.getRemoteUserObject( remake );
        user.get( cb );
    },

    addCardToUser: function( cardDefinitionId, remake, cb )
    {
        var user = this.getRemoteUserObject( remake );
        user.addCard( cardDefinitionId, cb );
    },

    removeCardFromUser: function( cardDefinitionId, remake, cb )
    {
        var user = this.getRemoteUserObject( remake );
        user.removeCard( cardDefinitionId, cb );
    },

    getAllUserCards: function( cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.getAllCards( cb );
    },

    getAllUserDecks: function( remake, cb )
    {
        var user = this.getRemoteUserObject( remake );
        user.getAllDecks( cb );
    },

    getAllUserDecksLength: function( remake, cb )
    {
        var user = this.getRemoteUserObject( remake );
        user.getAllDecksLength( cb );
    },

    getAllItems: function( remake, cb )
    {
        var user = this.getRemoteUserObject( remake );
        user.getAllItems( cb );
    },

    increaseUserExperience: function( expDelta, cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.increaseExperience( expDelta, cb );
    },

    setUpServerTime: function( date )
    {
        var serverDate = new Date( date );
        this.m_ReceivedServerTime = serverDate.getTime();
        var checkPointDate = new Date();
        this.m_CheckpointTime = checkPointDate.getTime();
    },

    getUserFromServer: function( cb )
    {
        info( "Server.getUserFromServer" );
        var user = this.getRemoteUserObject( true );
        user.get( cb );
    },

    getServerTime: function()
    {
        var currentDate = new Date();
        return( ( currentDate.getTime() - this.m_CheckpointTime ) + this.m_ReceivedServerTime );
    },

    setCurrentStage: function( currentStageInfo, cb )
    {
        var user = this.getRemoteUserObject( false );
        user.setCurrentStage( currentStageInfo, cb );
    },

    getGashaInfo: function( cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.getGashaInfo( cb );
    },

    getMainStats: function(cb, remake)
    {
        var user = this.getRemoteUserObject( remake );
        user.getMainStats( cb );
    },

    /*
     * Mission methods
     */
    doMission: function( missionId, cb, remake )
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.doMission( missionId, cb );
    },

    completeRound: function( missionId, cb, remake )
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.roundCompleted( missionId, cb );
    },

    getMissionData: function( missionId, cb, remake )
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.get( missionId, cb );
    },

    getMissionState: function(missionId, cb, remake)
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.getExplorationState( missionId, cb );
    },

    doLuckyChance: function( missionId, luckyChanceId, cb, remake )
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.doLuckyChance( missionId, luckyChanceId, cb );
    },

    confirmLuckyChance: function( id, cb, remake )
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.confirmLuckyChance( id, cb );
    },

    giveGiftsByLevel : function( level, cb, remake )
    {
        var mission = this.getRemoteMissionObject( remake );
        mission.giveGiftsByLevel( level, cb );
    },

    destroy: function()
    {

    },

    updateTutorialState: function( tutorialStateId, cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.updateTutorialState( tutorialStateId, cb );
    },

    getLastExploreDate: function( cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.getLastExploreDate( cb );
    },

    getLastBattleDate: function( cb, remake )
    {
        var user = this.getRemoteUserObject( remake );
        user.getLastBattleDate( cb );
    },

    resetUser: function( cb )
    {
        info( "Server.resetUser" );
        var user = this.getRemoteUserObject( true );
        user.reset( this.resetServerUserInfo.bind( this, cb ) );
    },

    resetServerUserInfo: function( cb, error, data )
    {
        if( cb && typeof ( cb ) == "function" )
        {
            cb( error, data );
        }

        info( "Server.resetServerUserInfo" )
    }

} );
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/Base/ErrorCodes'] = function(){var exports = $MODULE_REGISTRY['Code/Server/Base/ErrorCodes'] || {}; $MODULE_REGISTRY['Code/Server/Base/ErrorCodes'] = exports; 
var __dirname = 'Code/Server/Base';
var __filename = 'Code/Server/Base/ErrorCodes.js';

var ErrorCodes = {
    UNKNOWN_ERROR: 0,
    VALIDATION_FAILED: 1,
    MISSING_PARAMETERS: 2,
    WRONG_TYPE: 3,
    ALREADY_EXISTS: 4,
    DOES_NOT_EXIST: 5,
    NOT_ENOUGH_ENERGY: 6,
    LIMIT_REACHED: 7,
    DAILY_FREE_GASHA_REACHED: 7,
    DUPLICATE_ACTION: 8,
    NOT_ENOUGH_CREDITS: 9,
    DATABASE_ERROR: 1001,
    MOBAGE_ERROR: 1002
};

exports.ErrorCodes = ErrorCodes;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/Base/ObjectRequestXhr'] = function(){var exports = $MODULE_REGISTRY['Code/Server/Base/ObjectRequestXhr'] || {}; $MODULE_REGISTRY['Code/Server/Base/ObjectRequestXhr'] = exports; 
var __dirname = 'Code/Server/Base';
var __filename = 'Code/Server/Base/ObjectRequestXhr.js';

function ObjectRequestXhr( oauthCredentials )
{
    info( "ObjectRequestXhr.ObjectRequestXhr called. oauthCredentials=%s", JSON.stringify( oauthCredentials ) );
    this.oauthCredentials = oauthCredentials;
}

ObjectRequestXhr.prototype.request = function( method, url, data, headers, cb )
{
    var message, xhrRequest;

    //
    //  oauth
    //
    message = {
        action: url,
        method: method,
        parameters: data
    };

    // To track the requests
    this.m_uid = Math.round( Math.random() * 10000 );
    this.m_handler = "unknown";
    if( data && data.handler )
    {
        this.m_handler = data.handler;
    }

    info( "ObjectRequestXhr.prototype.request called. uid=%s, handler=%s, message=%s", this.m_uid, this.m_handler, JSON.stringify( message ) );

    OAuth.completeRequest( message, this.oauthCredentials );

    xhrRequest = new Network.XHR();
    xhrRequest.onreadystatechange = function( callback )
    {
        info( "ObjectRequestXhr.onreadystatechange called. uid=%s, handler=%s, this.readyState=%s, message.action=%s",
            this.m_uid, this.m_handler, xhrRequest.readyState, message.action );

        if( xhrRequest.readyState == 4 )
        {
            var response, error;
            response   = { 'status': xhrRequest.status, 'headers': xhrRequest.getUnflattenedResponseHeaders() };
            error = null;

            info( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s, response.status=%d", this.m_uid, this.m_handler, response.status );

            // This should prevent to receive more data while we are displaying an error dialog (and then send the user to the Control Room
            if( NetworkManager.isCurrentlyDisplayingError() )
            {
                warn( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s Already displaying an error dialog, returning.", this.m_uid, this.m_handler );
                return;
            }

            try
            {
                info( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s, typeof(xhrRequest.responseText)=%s",
                    this.m_uid, this.m_handler, typeof( xhrRequest.responseText ) );
                response.data = xhrRequest.responseText;

                if( response.status == 200 )
                {
                    // all ok
                }
                else if( response.status == 500 )
                {
                    // Try to determine if the class will handle this error
                    var data = JSON.parse( response.data );
                    if( data._code == ErrorCodes.NOT_ENOUGH_ENERGY )
                    {
                        info( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s Known error, passing it...", this.m_uid, this.m_handler );
                        error = "XXX UNKNOWN XXX"; // TODO FIXME
                        // pass this error to the class
                    }
                    else
                    {
                        response = {};
                        error = "IOError";
                    }
                }
                else
                {
                    response = {};
                    error = "IOError";
                }

                if( error == "IOError" ) // TODO FIXME This shouldn't be here....
                {
                    err( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s Error, xhrRequest.status=%s", this.m_uid, this.m_handler, xhrRequest.status );
                    err( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s Error, xhrRequest=%s", this.m_uid, this.m_handler, JSON.stringify( xhrRequest ) );

                    if( this.m_handler == "updateTutorialState" )
                    {
                        warn("ObjectRequestXhr.onreadystatechange uid=%s, handler=%s Skipping showServerErrorDialog if it's an statistical message.", this.m_uid, this.m_handler );
                    }
                    else
                    {
                        NetworkManager.showServerErrorDialog();
                    }
                    return;
                }
            }
            catch( ex )
            {
                response = {};
                error = JSON.stringify( ex );
            }

            if( error != undefined )
            {
                err( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s Error, exception parsing response. error=%s", this.m_uid, this.m_handler, error );
            }

            if( callback && typeof (callback) == 'function' )
            {
                info( "ObjectRequestXhr.onreadystatechange uid=%s, handler=%s. Calling callback.", this.m_uid, this.m_handler );
                callback( error, response );
            }
        }
    }.bind (this, cb );

    xhrRequest.open( method, url, true );
    xhrRequest.setRequestHeader( 'Content-Type', 'application/json' );
    xhrRequest.setRequestHeader( 'Authorization', OAuth.getAuthorizationHeader( undefined, message.parameters ) );

    for( var header in headers )
    {
        xhrRequest.setRequestHeader( header, headers[header] );
    }

    if( data != null )
    {
        xhrRequest.send( JSON.stringify( data ) );
    }
};

exports.ObjectRequestXhr = ObjectRequestXhr;


; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/Base/RemoteCall'] = function(){var exports = $MODULE_REGISTRY['Code/Server/Base/RemoteCall'] || {}; $MODULE_REGISTRY['Code/Server/Base/RemoteCall'] = exports; 
var __dirname = 'Code/Server/Base';
var __filename = 'Code/Server/Base/RemoteCall.js';

//
//  singleton object for accessing remote objects
//
var RemoteCall = Core.Class.singleton( {

    classname: 'RemoteCall',

    initialize: function()
    {

        this.request = null;
        this.headers = {};
    },

    setup: function( server, credentials )
    {
        var ObjectRequestXhr = require( 'Code/Server/Base/ObjectRequestXhr' ).ObjectRequestXhr;

        this.setObjectRequest( ObjectRequestXhr );
        this.setServer( server );
        this.setOauthCredentials( credentials );
        this.setHeaders( {'X-Content-Tag': 'default'} );

    },

    //
    //   set object request (ObjectRequestXhr on device and ObjectRequestNodeHttp in node)
    //
    setObjectRequest: function( request )
    {
        this.request = request;
    },

    //
    // set oauth credentials {consumerKey: "", consumerSecret: "", token: ""};
    //
    setOauthCredentials: function( oauthCredentials )
    {
        this.oauthCredentials = oauthCredentials;
    },

    //
    //   set server url
    //
    setServer: function( url )
    {
        this.serverUrl = url;
    },

    //
    //   set  headers for all server requests
    //
    setHeaders: function( headers )
    {
        this.headers = headers;
    },

    //
    //   set header
    //
    setHeader: function( header, value )
    {
        this.headers[header] = value;
    },

    //
    //   call remote method on an object
    //   params:
    //   @name object name
    //   @method method name
    //   @id id
    //   @args arguments array
    //   @cb callback
    rpc: function( name, method, id, args, cb )
    {
        info( "RemoteCall.rpc called. name=%s, method=%s, id=%s, args=%s", name, method, id, args.toString() );

        var url, data, self, request;

        data = { handler: method, args: args };

        request = new this.request( this.oauthCredentials );
        url = sprintf( "%s/objects/%s/%s", this.serverUrl, name, id );


        request.request( 'PUT', url, data, this.headers,
            function( callback, error, response )
            {
                info( "RemoteCall.rpc._innerCallback called. error=%s, response=%s",
                    JSON.stringify( error ), JSON.stringify( response ) );
                dump_full( "info", "RemoteCall.rpc [" + url + "] ", response );

                if( error )
                {
                    err( "RemoteCall.rpc._innerCallback Error: error=%s", JSON.stringify( error ) );
                    callback && callback( error, null );
                    return;
                }

                if( response.status != 200 )
                {
                    warn( "RemoteCall.rpc._innerCallback Error, status=%s", response.status );

                    // FIXME Pass an enum instead of an string to callback
                    callback && callback( "server error, status: " + response.status, null );
                }
                else
                {
                    callback && callback( error, response.data );
                }
            }.bind( this, cb )
        );
    }
} );

exports.RemoteCall = RemoteCall;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/Base/RemoteObject'] = function(){var exports = $MODULE_REGISTRY['Code/Server/Base/RemoteObject'] || {}; $MODULE_REGISTRY['Code/Server/Base/RemoteObject'] = exports; 
var __dirname = 'Code/Server/Base';
var __filename = 'Code/Server/Base/RemoteObject.js';

//
// base class for remote objects (that are essentially models)
//
var RemoteObject = Core.Class.subclass( {
    classname: 'RemoteObject',

    initialize: function()
    {
        this._factory = RemoteCall;

        if( this.exposedClassname )
        {
            this._name = this.exposedClassname.toLowerCase();
        }
        else
        {
            this._name = this.classname.toLowerCase();
        }
        this._id = 0;
    },

    invoke: function( method, args, cb )
    {
        this._factory.rpc( this._name, method, this._id, args,
            function( error, data )
            {
                info( "RemoteObject.invoke._innerCallback called. method=%s, error=%s, data=%s",
                    JSON.stringify( method ),
                    JSON.stringify( error ),
                    data
                );
                dump_full( "info", "RemoteObject.invoke [" + method + "] ", data );

                    /*  if (!error) {
                    this._data = data;
                    }
                    */
                cb( error, data );
            }
        );
    }
} );

exports.RemoteObject = RemoteObject;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteUser'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteUser'] || {}; $MODULE_REGISTRY['Code/Server/RemoteUser'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteUser.js';

var RemoteUser = RemoteObject.subclass( {

    classname: 'RemoteUser',
    exposedClassname: 'User',

    initialize              : function( session )
    {
        info( "RemoteUser.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    get                     : function( cb )
    {
        this.invoke( "get", [], cb );
    },

    addCard                 : function( cardDefinitionId, cb )
    {
        this.invoke( "addCard", [ cardDefinitionId ], cb );
    },

    removeCard              : function( cardDefinitionId, cb )
    {
        this.invoke( "removeCard", [ cardDefinitionId ], cb );
    },

    getAllCards             : function( cb )
    {
        this.invoke( "getAllCards", [], cb );
    },

    getAllDecks             : function( cb )
    {
        this.invoke( "getAllDecks", [], cb );
    },

    getAllDecksLength       : function( cb )
    {
        this.invoke( "getAllDecksLength", [], cb );
    },

    getAllItems             : function ( cb )
    {
        this.invoke( "getAllItems", [], cb );
    },

    increaseExperience      : function(expDelta, cb)
    {
        this.invoke( "increaseExperience", expDelta, cb);
    },

    getExplorationState     : function( cb )
    {
        this.invoke( "getExplorationState", [], cb );
    },

    setCurrentStage         : function( currentStageInfo, cb )
    {
        this.invoke( "setCurrentStage", [currentStageInfo.worldId, currentStageInfo.stageId], cb );
    },

    updateTutorialState     : function( tutorialStateId, cb )
    {
        this.invoke( "updateTutorialState", [ tutorialStateId ], cb );
    },

    getGashaInfo: function(cb)
    {
        this.invoke( "getGashaInfo", [], cb );
    },
    
    getLastExploreDate      : function( cb )
    {
        this.invoke( "getLastExploreDate", [], cb );
    },
    
    getLastBattleDate       : function( cb )
    {
        this.invoke( "getLastBattleDate", [], cb );
    },
    
    getMainStats: function( cb )
    {
        this.invoke( "getMainStats", [], cb );
    },

    reset                   : function( cb )
    {
        this.invoke( "reset", [], cb );
    }
} );

exports.RemoteUser = RemoteUser;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/ServerSession'] = function(){var exports = $MODULE_REGISTRY['Code/Server/ServerSession'] || {}; $MODULE_REGISTRY['Code/Server/ServerSession'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/ServerSession.js';

var ServerSession = RemoteObject.subclass( {

    classname: 'ServerSession',
    exposedClassname: 'Session',

    initialize: function( gamerTag )
    {
        info( "ServerSession.initialize called. gamerTag=%s", gamerTag );
        this._id    = gamerTag;
        this._token = this._id;
    },

    login: function( mobageId, token, secret, cb )
    {
        this.invoke( "init", [ mobageId, {oauth_token: token,  oauth_secret: secret } ], cb );
    }
} );

exports.ServerSession = ServerSession;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteCard'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteCard'] || {}; $MODULE_REGISTRY['Code/Server/RemoteCard'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteCard.js';

var RemoteCard = RemoteObject.subclass(
{

    classname: 'RemoteCard',
    exposedClassname: 'Card',

    initialize: function( session )
    {
        this._id = session._token;
    },

    getDefinitionId: function( cardDefinitionId, cb )
    {
        this.invoke( "getDefinitionId", [ cardDefinitionId ], cb );
    },

    setExperience: function( cardDefinitionId, value, cb )
    {
        this.invoke( "setExperience", [ cardDefinitionId, value ], cb );
    },

    sell: function( cardDefinitionId, cb )
    {
        // this.invoke( "sell", [ cardId ], cb );
        cb( null,
        {
            ok: true
        } );
    },

    sellAll: function(normalList, limboList, cb)
    {
        this.invoke("sellAll", [normalList, limboList], cb);
    },

    fusion: function( baseCardId, materialCardsId, itemsId, cb )
    {
        this.invoke( "fusion", [ baseCardId, materialCardsId, itemsId ], cb );
    }
} );

exports.RemoteCard = RemoteCard;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteDeck'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteDeck'] || {}; $MODULE_REGISTRY['Code/Server/RemoteDeck'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteDeck.js';

var RemoteDeck = RemoteObject.subclass( {

    classname: 'RemoteDeck',
    exposedClassname: 'Deck',

    initialize: function( session )
    {
        info( "RemoteDeck.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    getDeck: function( index, cb )
    {
        this.invoke( "getDeck", [ index ], cb );
    },

    setDeck: function( index, deckData, cb )
    {
        this.invoke( "setDeck", [ index, deckData ], cb );
    },

    recommend: function( cb )
    {
        this.invoke( "recommend", [ ], cb );
    },
    
    setInitialDeck: function ( index, packIndex, cb )
    {
        this.invoke("setInitialDeck", [index, packIndex], cb);
    }
} );

exports.RemoteDeck = RemoteDeck;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteBattle'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteBattle'] || {}; $MODULE_REGISTRY['Code/Server/RemoteBattle'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteBattle.js';

var RemoteBattle = RemoteObject.subclass( {

    classname: 'RemoteBattle',
    exposedClassname: 'Battle',

    initialize          : function( session )
    {
        info( "RemoteBattle.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    requestEnemies      : function( level, cb )
    {
        info( "RemoteBattle.requestEnemies called. level=%d", level );
        this.invoke( "requestEnemies", [ level ], cb );
    },
    
    requestFight        : function( enemy, cb )
    {
        info( "RemoteBattle.requestFight called. Enemy : %s", enemy );
        this.invoke( "fight", [enemy], cb );
    },
    
    requestBossFight    : function( worldId, stageId, bossId, cb )
    {
        info( "RemoteBattle.requestBossFight called. World : "+worldId+"  Stage : "+stageId+" bossId:"+bossId+"  cb : "+cb);
        this.invoke( "fightBoss", [worldId, stageId, bossId], cb );
    },
    
    requestEnemyDeck    : function( enemy, cb )
    {
        info( "RemoteBattle.requestEnemyDeck called. Enemy : "+enemy );
        this.invoke( "requestEnemyDeck", [enemy], cb );
    },
    
    hasEnoughEnemies    : function( level, cb )
    {
        info( "RemoteBattle.hasEnoughEnemies called. Level : "+level );
        this.invoke( "hasEnoughEnemies", [level], cb );
    }
} );

exports.RemoteBattle = RemoteBattle;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteGasha'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteGasha'] || {}; $MODULE_REGISTRY['Code/Server/RemoteGasha'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteGasha.js';

var RemoteGasha = RemoteObject.subclass( {

    classname: 'RemoteGasha',
    exposedClassname: 'Gasha',

    initialize: function( session )
    {
        info( "RemoteGasha.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    requestCards : function( packId, type, bankId, cb )
    {
        this.invoke( "requestCards", [ packId, type, bankId ], cb );
    },

    getLastAndNextFreeGashaDates : function( cb )
    {
        this.invoke( "getLastAndNextFreeGashaDates", [], cb );
    }
} );

exports.RemoteGasha = RemoteGasha;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteItem'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteItem'] || {}; $MODULE_REGISTRY['Code/Server/RemoteItem'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteItem.js';

var RemoteItem = RemoteObject.subclass( {

    classname: 'RemoteItem',
    exposedClassname: 'Item',

    initialize: function( session )
    {
        info( "RemoteItem.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    get             : function( itemId, cb )
    {
        this.invoke( "get", [ itemId ], cb );
    },
    
    getPrice        : function( itemId, cb )
    {
        this.invoke( "getPrice", [ itemId ], cb );
    },
    
    useItem         : function( itemId, cb )
    {
        this.invoke( "use", [ itemId ], cb );
    },
    
    purchase        : function( transactionId, cb )
    {
        this.invoke( "purchase", [transactionId], cb );
    }
} );

exports.RemoteItem = RemoteItem;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteGift'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteGift'] || {}; $MODULE_REGISTRY['Code/Server/RemoteGift'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteGift.js';

var RemoteGift = RemoteObject.subclass( {

    classname: 'RemoteGift',
    exposedClassname: 'Gift',

    initialize: function( session )
    {
        info( "RemoteGift.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    claim             : function( regards, cb )
    {
        this.invoke( "claim", [regards], cb );
    },
} );

exports.RemoteGift = RemoteGift;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteReward'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteReward'] || {}; $MODULE_REGISTRY['Code/Server/RemoteReward'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteReward.js';

var RemoteReward = RemoteObject.subclass( {

    classname: 'RemoteReward',
    exposedClassname: 'Reward',

    initialize: function( session )
    {
        info( "RemoteReward.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    claim             : function( regards, cb )
    {
        this.invoke( "claim", [regards], cb );
    },
} );

exports.RemoteReward = RemoteReward;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/RemoteMission'] = function(){var exports = $MODULE_REGISTRY['Code/Server/RemoteMission'] || {}; $MODULE_REGISTRY['Code/Server/RemoteMission'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/RemoteMission.js';

var RemoteMission = RemoteObject.subclass( {

    classname: 'RemoteMission',
    exposedClassname: 'Mission',


    initialize: function( session )
    {
        info( "RemoteMission.initialize called. session=%s", JSON.stringify( session ) );
        this._id = session._token;
    },

    get: function( missionId, cb )
    {
        this.invoke( "get", [ missionId ], cb );
    },

    getByWorldId: function( missionId, cb )
    {
        this.invoke( "getByWorldId", [ missionId ], cb );
    },

    doMission: function( missionId, cb )
    {
        this.invoke( "doMission", [ missionId ], cb );
    },

    roundCompleted: function( missionId, cb )
    {
        this.invoke( "roundCompleted", [ missionId ], cb );
    },

    doLuckyChance : function( missionId, luckyChanceId, cb )
    {
        this.invoke( "doLuckyChance", [ missionId, luckyChanceId ], cb );
    },

    confirmLuckyChance : function( id, cb )
    {
        this.invoke( "confirmLuckyChance", [ id ], cb );
    },

    giveGiftsByLevel : function(level,  cb )
    {
        this.invoke( "giveGiftsByLevel", [ level ], cb );
    },

    getExplorationState : function(missionId,  cb )
    {
        this.invoke( "getExplorationState", [ missionId ], cb );
    }

} );

exports.RemoteMission = RemoteMission;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Server/NgServer'] = function(){var exports = $MODULE_REGISTRY['Code/Server/NgServer'] || {}; $MODULE_REGISTRY['Code/Server/NgServer'] = exports; 
var __dirname = 'Code/Server';
var __filename = 'Code/Server/NgServer.js';

/**
 * @fileOverview The NgServer object creates a convenient way for clients to log 
 * onto NgServers and asynchronously interact with its HTTP end-points.
 *
 */
var Core = require('NGCore/Client/Core').Core;           // Core module provides base functionality
var XHR = require('NGCore/Client/Network/XHR').XHR;      // Make HTTP requests
var Social = require('NGCore/Client/Social').Social;     // NgCore social functionality
var OAuthReq = require('NGCore/Client/Plus/oauth');      // NgCore OAuth functionality

/**
 * The constructor for NgServer. A very verbose way to set the host and port number.
 * @param {string} host The host name you wish to communicate with.
 * @param {number} [port] The port number on the host you wish to send to. The default is 8090.
 */
function NgServer( url ) {

    var s1 = url.lastIndexOf("/");
    var s2 = url.lastIndexOf(':');
    var host = s2 - s1 > 2 ? url.substring( s1 + 1, s2 ) :  url.substring( s1 + 1 );
    var port = s2 - s1 > 2 ? url.substring( s2 + 1 ): 80 ;
    port = parseInt(port);

    this._authenticated = false;        // is true after 3-legged OAuth completes

    if (typeof host === 'object') {     // we're getting a JSON config object
        if (host.host === undefined)
            throw new Error('NgServer: config object must have a host and a port');

        if (typeof host.host !== 'string' || !host.host.length)
            throw new Error('NgServer: The host parameter must be a non-empty string.');
        this._host = host.host;

        if (host.port !== undefined) {
            if (typeof host.port !== 'number' || host.port < 0 || host.port > 65535 || host.port % 1 !== 0)
                throw new Error('NgServer: The port parameter must be an integer within the range of 0 to 65535.');
            this._port = host._port;
        } else {
            this._port = 8090;
        }

        return;
    }

    if (port === undefined)     // The default port for NgServer is 8090
        port = 8090;

    if (typeof host !== 'string' || !host.length)
        throw new Error('NgServer: The host parameter must be a non-empty string.');

    if (typeof port !== 'number' || port < 0 || port > 65535 || port % 1 !== 0)
        throw new Error('NgServer: The port parameter must be an integer within the range of 0 to 65535.');

    this._host = host;
    this._port = port;
}

/**
 * Authenticate performs the 3-legged oAuth sequence and stores the OAuth tokens for later use.
 * @param {function} cb A callback which executes after the OAuth authentication is done.
 */
NgServer.prototype.authenticate = function(cb) {

    if (typeof cb !== 'function')
        throw new Error('NgServer.authenticate: cb parameter must be a callback function.');

    var self = this;        // needed as the callbacks lack the this reference
    var oauthparams = {
        oauth_token: '',
        oauth_token_secret: ''
    };

    self._getCredentials(oauthparams, function( error, credentials, temp_tokens) {
        if ( error) {
            cb('NgServer.authenticate: '+ error);
            return;
        }
        self._getTempTokens(credentials, function( error, verifier, tokens, credentials) {
            if ( error) {
                cb('NgServer.authenticate: '+ error);
                return;
            }
            self._getOAuthTokens(verifier, tokens, credentials, function( error, credentials, oauthparams) {
                if ( error) {
                    cb('NgServer.authenticate: '+ error);
                    return;
                }

                self._authenticated = true;                     // Yep, we're authenticated
                credentials.token = oauthparams.oauth_token;    // Update the credentials
                credentials.tokenSecret = oauthparams.oauth_token_secret;
                self._credentials = credentials;                // Save the credentials
                self._oauthTokens = tokens;                     // Save the oauh tokens

                cb( null, self._credentials, self._oauthTokens );
            });
        });
    });
};

/**
 * sends a command to an HTTP end-point that requires authorization.
 * @param {string} httpMethod An http method, e.g. "GET", "DEL", etc.
 * @param {string} uriPath Path that defines the HTTP endpoint.
 * @param {function} cb The callback
 */
NgServer.prototype.send = function(httpMethod, uriPath, cb) {

    if (!this._authenticated) {
        cb('NgServer.getCurrentUser: not logged in.');
        return;
    }

    if (typeof httpMethod !== 'string' || !httpMethod.length) {
        cb('NgServer.send: The parameter httpMethod must be a non-empty string.');
        return;
    }

    if (typeof uriPath !== 'string' || !uriPath.length || uriPath.charAt(0) !== '/') {
        cb('NgServer.send: The parameter uriPath must be a non-empty string starting with \'/\'.');
        return;
    }

    if (typeof cb !== 'function') {
        cb('NgServer.send: The parameter cb must be a function.');
        return;
    }

    var req = new XHR();
    var message = {
        action: 'http://'+this._host+':'+this._port+uriPath,
        method: httpMethod 
    };

    OAuthReq.OAuth.completeRequest(message, this._credentials);   // create auth header for request

    // Callback to handle state changes in the request - we only care about completion
    req.onreadystatechange = function() {
        if (req.readyState != 4)    // 4 == request is complete
            return;

        if (req.status < 200 || req.status >= 300) {    // we'll take any 2xx status as successful
            cb('Error: '+req.status);
            return;
        }

        var responseText = null;                        // grab the responseText for the user, if present
        if (req.responseText !== undefined)
            responseText = req.responseText;

        cb(null, responseText, req);                    // also send the req, in case the user is curious
        return;
    };

    // steps to sed the request to the server
    req.open(message.method, message.action, true);
    // add the OAuth header info
    req.setRequestHeader('Authorization', OAuthReq.OAuth.getAuthorizationHeader(undefined, message.parameters));
    req.send(null);     // and send!
};

/**
 * sends a command to an HTTP end-point that does not require authorization.
 * @param {string} httpMethod An http method, e.g. "GET", "DEL", etc.
 * @param {string} uriPath Path that defines the HTTP endpoint.
 * @param {function} cb The callback
 */
NgServer.prototype.sendNoAuth = function(httpMethod, uriPath, cb) {

    if (typeof httpMethod !== 'string' || !httpMethod.length) {
        cb('NgServer.sendNoAuth: The parameter httpMethod must be a non-empty string.');
        return;
    }

    if (typeof uriPath !== 'string' || !uriPath.length || uriPath.charAt(0) !== '/') {
        cb('NgServer.sendNoAuth: The parameter uriPath must be a non-empty string starting with \'/\'.');
        return;
    }

    if (typeof cb !== 'function') {
        cb('NgServer.sendNoAuth: The parameter cb must be a function.');
        return;
    }

    var req = new XHR();
    var message = {
        action: 'http://'+this._host+':'+this._port+uriPath,
        method: httpMethod 
    };

    // Callback to handle state changes in the request - we only care about completion
    req.onreadystatechange = function() {
        if (req.readyState != 4)    // 4 == request is complete
            return;

        if (req.status < 200 || req.status >= 300) {    // we'll take any 2xx status as successful
            cb('NgServer.sendNoAuth: '+req.status);
            return;
        }

        var responseText = null;                        // grab the responseText for the user, if present
        if (req.responseText !== undefined)
            responseText = req.responseText;

        cb(null, responseText, req);                    // also send the req, in case the user is curious
        return;
    };

    // steps to sed the request to the server
    req.open(message.method, message.action, true);
    req.send(null);     // and send!
};

/**
 * Requests the temp token to start the oauth sequence.
 * @param {object} credentials An object with the oauth tokens and consumer key & secret.
 * @param {function} cb The callback.
 */
NgServer.prototype._getTempTokens = function(credentials, cb) {
    var message = {                 // build the OAuth signature
        action: 'http://'+this._host+':'+this._port+'/OAuth/request_temp_token',
        method: 'GET',
        parameters: {oauth_token:'', oauth_callback: 'oob'}
    };

    var self = this; // for use in callbacks that have a different 'this' 

    // completeRequest fills in parameters to help construct a request message. This function doesn't 
    // fill in every parameter. The credentials object should contain:
    // {consumerKey:'foo', consumerSecret:'bar', accessorSecret:'nurn', token:'krelm', tokenSecret:'blah'}
    // The accessorSecret property is optional (require_d only where oauth is needed).
    OAuthReq.OAuth.completeRequest(message, credentials);

    var req = new XHR();    // create the object to wrap XMLHttpRequest request

    // Define the callback to handle the request state changes. We only care about and
    // handle the completion state.
    req.onreadystatechange = function(){
        if (req.readyState != 4)  // When the state is 4, the request is complete
            return;

        if (req.status != 200) {    // did the http request fail?
            cb('Error: '+req.status);
            return;
        }

        // The HTTP response will have the oauth tokens to use on the next step in JSON
        var tokens = JSON.parse(req.responseText);

        // Authorizes a temporary credential and returns a verification code using the
        // temporary tokens.
        Social.Common.Auth.authorizeToken(tokens.oauth_token, function(error, verifier){
            if (error) {
                cb(error);
                return;
            }
            cb(null, verifier, tokens, credentials);
            return;
        });
    };

    req.open(message.method, message.action, true);
    req.setRequestHeader('Authorization', OAuthReq.OAuth.getAuthorizationHeader(undefined, message.parameters));
    req.send(null);
};

/**
 * Using the temp OAuth tokens, get the actual OAuth tokens.
 * @param {string} verifier a query string parameter to verify the request
 * @param {object} temp_tokens stores the OAuth temp tokens for this call
 * @param {object} credentials stores the consumer key & secret and the oauth tokens
 * @param {function} cb The callback
 */
NgServer.prototype._getOAuthTokens = function(verifier, temp_tokens, credentials, cb) {

    // create authentication header
    var oauthparams = {
        oauth_token: temp_tokens.oauth_token,
        oauth_token_secret: temp_tokens.oauth_token_secret
    };

    credentials.token = temp_tokens.oauth_token;
    credentials.tokenSecret = temp_tokens.oauth_token_secret;

    //var credentials = getCredential(oauthparams);
    var path = 'http://'+this._host+':'+this._port+'/OAuth/request_token?oauth_verifier='+verifier;
    var method = 'GET';

    // build the OAuth signature
    var message = {
        action: path,
        method: method,
        parameters: oauthparams
    };

    OAuthReq.OAuth.completeRequest(message, credentials);

    var req = new XHR();
    req.onreadystatechange = function() {
        if (req.readyState != 4)
            return;

        if (req.status != 200) {
            cb('error: '+req.status);
            return;
        }

        var oauthTokens = JSON.parse(req.responseText);
        cb(null, credentials, oauthTokens);
    };

    req.open(message.method, message.action, true);
    req.setRequestHeader('Authorization', OAuthReq.OAuth.getAuthorizationHeader(undefined, message.parameters));
    req.send(null);
};

/**
 * Gets the credentials for the user, specifically the consumer key and the 
 * consumer secret for OAuth.
 * @param {object} oauthparams Empty tokens for initial request
 * @param {function} cb The callback.
 */
NgServer.prototype._getCredentials = function(oauthparams, cb) {

    // Retrieve the application's consumer key, then retrieve the OAuth
    // session tokens.
    var config = Core.Capabilities.getConfigs();
    var consumerKey = config.socialConsumerKey;
//    var session = Social.US.Session.getCurrentSession();
//
//    session.getSessionTokensForConsumerKey(consumerKey, function(error, tokens) {
//        if (error) {
//            cb('Error getting tokens.');
//            return;
//        }

        var credentials = {
            token: oauthparams.oauth_token,
            tokenSecret: oauthparams.oauth_token_secret,
            consumerKey: "jAyGDJ70A2FliRSmaTSVw",
            consumerSecret: "AujcCMf1QTukNbj6GkRFYhSopIkoJ4j8drCXWnn9Q",
            //consumerKey: config.socialConsumerKey,
            //consumerSecret:  config.socialConsumerSecret
        };

        cb(null, credentials);
//    });
};

exports.NgServer = NgServer;
; return exports;};

var __dirname = 'NGCore/Client';
var __filename = 'NGCore/Client/Legacy.js';

(function()
{
	if(!Function.prototype.hasOwnProperty('bind'))
	{
		var slice = Array.prototype.slice;
		Function.prototype.bind = function(context)
		{
			var func = this;
			if(arguments.length > 1)
			{
				var args = slice.call(arguments, 1);
				return function()
				{
					if(arguments.length)
					{
						var finalArgs = args.concat(slice.call(arguments));
						return func.apply(context, finalArgs);
					}
					else
					{
						return func.apply(context, args);
					}
				};
			}
			else
			{
				return function()
				{
					if(arguments.length)
						return func.apply(context, arguments);
					else
						return func.call(context);
				};
			}
		};
	}
})();

(function()
{
	if(!Array.prototype.hasOwnProperty('indexOf'))
	{
		Array.prototype.indexOf = function(obj)
		{
			var len = this.length;
			for(var i=0; i < this.length; ++i)
			{
				if(obj === this[i])
					return i;
			}
			return -1;
		};
	}
})();

function userGameInit()
{
	console.log("ngCore calling main()");
	main();
}
//////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-0?
 *  @file:      NgWebEngine.js
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;
var SystemBinding = require('NGCore/Client/UI/SystemBinding').SystemBinding;
var Downloader = require("NGCore/Client/Network/DownloadManifest").Downloader;
var LocalGameList = require("NGCore/Client/Core/LocalGameList").LocalGameList;
var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Localization = require('NGCore/Client/Core/Localization').Localization;

// Global until oauth does not depend on storage.
var Storage = require('NGCore/Client/Storage').Storage;

//////////////////////////////////////////////////////////////////////////////////////////////////
// App switching.

var NgProcID =
{
    PersistProc: -1,
    GameProc: -2
};

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

var gNgShutdownPending = false;


/////////////////////////////////////////////////////////////////////////////////////////////////
// Global data.
//////////////////////////////////////////////////////////////////////////////////////////////////

var gNgEngineEntities;
var gNgAddedEngineEntities;
var gNgRemovedEngineEntities;

var gNgUpdateEngineEntities;
var gNgTouchEngineEntities;
var gNgKeyPressEngineEntities;


//////////////////////////////////////////////////////////////////////////////////////////////////
// This function is called once by the html container to initialize the game.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineInitPrivate()
{
	NgLogInit();

	NgApplication.getInstance().restart();

	gNgEngineEntities = [];
	gNgAddedEngineEntities = [];
	gNgRemovedEngineEntities = [];

	gNgUpdateEngineEntities = [];
	gNgTouchEngineEntities = [];
    gNgKeyPressEngineEntities = [];
}

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineProcessEntityAddRemove()
{
        var i, e;
	for(i in gNgAddedEngineEntities)
	{
		e = gNgAddedEngineEntities[i];
		if(e.mIsUpdatable) gNgUpdateEngineEntities[e.mId] = e;
	}
	gNgAddedEngineEntities = [];

	for(i in gNgRemovedEngineEntities)
	{
		e = gNgRemovedEngineEntities[i];

		if(e.mIsUpdatable) delete gNgUpdateEngineEntities[e.mId];
	}
	gNgRemovedEngineEntities = [];
}

/**
  * @private
  */

function NgHandleException(ex)
{
	if (Core.Proc.isPrivileged()) {
		NgLogException( ex );
	}
	else {
		NgLogException( ex );
		var exStr = JSON.stringify(ex);
		Core.LocalGameList._forwardException(exStr);
	}
}

function NgEngineInit(inputs)
{
	NgLogD("NgEngineInit beg");
	try
	{
		NgEngineInitPrivate();

		//NgLogD("Initializing Storage");
		//Storage.init();
		//NgLogD("Storage initialized");
		NgLogD("KeyValue Storage initializing...");
		Storage.KeyValueCache.init();
		NgLogD("KeyValue Storage initialized...");
	
		Core.Time.instantiate();
	
		NgLogD("Instantiate the Localization context (singleton), depends on Capabilities");
		Localization.instantiate();

	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgEngineInit end");	
	
	return NgEngineUpdate(inputs);
}

function NgPreInit(inputs)
{
	NgLogD("Localization NgPreInit beg");
	return update(inputs);
}

/**
  * @private
  */

function NgGameInit(inputs)
{
	NgLogD("NgGameInit beg");

	Core.Analytics.instantiate();

	try
	{

		userGameInit();
	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgGameInit end");

	return update(inputs);
}

/**
  * @private
  */

// TEMPORARY: Until native code is updated to call NgEngineUpdate.
function update ( inputs )
{
	return NgEngineUpdate ( inputs );
}

//Frame loop calls this every time, get the object out of require_ once ahead of time.
var NGSetTimeoutRunTimers = require("NGCore/Client/UI/NGJSEnvironmentSupport").NGSetTimeoutRunTimers;

var setTimeoutOrig = setTimeout;
setTimeout  = function(fn, time)
{
	return setTimeoutOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
};


var setIntervalOrig = setInterval;
setInterval  = function(fn, time)
{
	return setIntervalOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
};



/**
  *	Main entry point for native to invoke JS.
  * @private
  */
var NgEngineUpdate = (function()
{
	var Core = require('NGCore/Client/Core').Core;
	
return function ( inputs )
{
	// time causes a racehorse-sized leak in v8. Only use this for single profiling runs. DO NOT CHECK IN.
//	time.stop('frame');
//	time.start('frame');
	var i;
	try {
		NGSetTimeoutRunTimers();

		if (typeof inputs === "function")
		{
			inputs();
		}
		else if (inputs.length)
		{
			NgEngineProcessEntityAddRemove();
			var commands = inputs.split(':');
			for(i=0; i<commands.length; ++i)
			{
				var command = commands[i];

				// Make sure this isn't an empty input.
				if(0 === command.length) {
					continue;
				}

				switch(parseInt(command))
				{
					case NgEntityTypes.App:
						NgApplication.getInstance().handleCommand(command);
						break;
					case NgEntityTypes.NgFileSys:
						NgApplication.getInstance().getFileSys().handleCommand(command);
                        break;
					case NgEntityTypes.Storage:
						NgLogD("Command for storage is " + command);
						Storage.getInstanceForCommand(command).handleCommand(command);
						break;
					case NgEntityTypes.NgUI:
						var Window = require('NGCore/Client/UI/Window').Window;
						Window.handleCommand(command);
						break;
					case NgEntityTypes.NgSystemBinding:
						SystemBinding.handleCommand(command);
						break;
					case 3117:
						console.log('got leet response');
						if(typeof(_WifiDiagCallback) != 'undefined')
							_WifiDiagCallback(command);
						break;
					default:
						Core.Proc._classRecvGen( command.split( ',' ) );
						break;
				}
			}
		}

		if( gNgShutdownPending )
		{
			gNgShutdownPending = false;
		}
		else	// Don't do updates if we're resetting.
		{
			NgEngineProcessEntityAddRemove();
			for(i in gNgUpdateEngineEntities)
			{
				var entity = gNgUpdateEngineEntities[i];
				if(!entity.mRegistered) continue;
				entity.onUpdate();
			}
		}
	}
	catch(ex)
	{
		NgHandleException(ex);
	}
		
	var commandsFromJS = Core.Proc.getCommandString() + NgFlushCommandsToString();
	Core.Proc.clearCommandString();

	return commandsFromJS;
};
})();


//////////////////////////////////////////////////////////////////////////////////////////////////
////	NgApplication class
//////////////////////////////////////////////////////////////////////////////////////////////////

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Logger = require('NGCore/Client/Core/Logger').Logger;

/** @private */

var NgApplicationCommands = {
	Caps : 0,
	Debug : 1,
	FrameTime : 2,
	FrameRate : 3,
	Start : 4,
	DeviceOrientation: 10,
	SetOrientation: 11,
	BackPress: 12,
	OnBackPressed: 13,
	LaunchExternalNativeApp: 15,
	ExitSystemProcess: 16
};

/**
  * Enumeration values for orientation change events received by
  * {@link NgApplicationObserver}.
  */

var NgApplicationOrientation = {
	Portrait : 0,
	PortraitUpsideDown : 1,
	LandscapeLeft : 2,
	LandscapeRight : 3,
	FaceUp : 4,
	FaceDown : 5
};

/**
  * The NgApplication constructor is invoked during application bootstrap and
  * should not be created by the ngGame application.  Access to the application
  * object should be through the singleton accessor {@link NgApplication#getInstance}.
  * @constructor
  *
  * @class
  * The NgApplication class represents global state and services that are available to
  * ngGame applications.  This includes file system operations,
  * download services, etc.  The application class also manages a time source
  * that is synchronized between the native engine and the ngGame application. <br>
  * The application object is a singleton and should only be accessed through the
  * {@link NgApplication#getInstance} method.
  */

function NgApplication()
{
	/** @private */
	this.mFileSys = Storage.FileSystem;
	/** @private */
	this.mFrameTime = 0.0;
	/** @private */
	this.mObservers = [];
}

// Singleton instance.
/** @private */
NgApplication.sInstance = null;

/**
  * Acquire the singleton instance of the application class.
  * @type NgApplication
  * @return The global application object.
  */

NgApplication.getInstance = function()
{
	if( NgApplication.sInstance === null )
		NgApplication.sInstance = new NgApplication();

	return NgApplication.sInstance;
};

// APITODO: Switch these methods to be defined out-of-line, not by an object literal.

NgApplication.prototype =
{
	mFileSys : null,
	mObservers : [],
	mFrameTime : 0.0,
	
	/** @private */
	restart : function()
	{
	},
	
	/** @private */
	handleCommand : function(command)
	{
		//		NgLogD( "NgApplication command = " + command );

		var commandId = NgPeekCommandId( command );

		switch( commandId )
		{
			case NgApplicationCommands.FrameTime:
				this.parseFrameTime( command );
				break;
			case NgApplicationCommands.Start:
				this.onApplicationStart();
				break;
			case NgApplicationCommands.OnBackPressed:
				this.onApplicationBackPressed();
				break;
			default:
				NgLogE( "NgApplication command unknown: " + command);
				break;
		}
	},
	
	/**
	  * Acquire the file system object.
	  * @type NgFileSys
	  * @return The file system instance.
	  */
	getFileSys : function()
	{
		return this.mFileSys;
	},

	/** @private */
	ngLog : function( level, dbgStr )
	{
		NgPushCommand4( NgEntityTypes.App, NgApplicationCommands.Debug, Core.Base64.encode( dbgStr ), level );
	},
	
	/** @private */
	parseFrameTime : function( command )
	{
		var fields = NgParseCommand2(command,parseInt,parseFloat);
		var frameTime = fields[1];

		if(this.mFrameDelta === undefined)
			this.mFrameDelta = 0;
		else
			this.mFrameDelta = frameTime - this.mFrameTime;

		this.mFrameTime = frameTime;
	},
	
	/**
	  * Get the application time for the current frame.
	  * @type number
	  * @return The time in milliseconds.
	  */
	getFrameTime : function()
	{
		return this.mFrameTime;
	},
	
	/**
	  * Get the application time delta between the current frame and the last frame.
	  * @type number
	  * @return The time delta in milliseconds.
	  */
	getFrameDelta : function()
	{
		return this.mFrameDelta;
	},

	/**
	  * Set the desired application frame rate. <br>
	  * Note: The frame rate specification is not currently fully functional on all 
	  * platforms.
	  * @param {number} frameRate The desired frame rate in hz.
	  * @type void
	  */
	setFrameRate : function(frameRate)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.FrameRate, frameRate);
	},

	/**
	  * Set the current device orientation for the application. <br>
	  * Note: Setting the orientation is not currently fully functional on all
	  * platforms.
	  * @param {NgApplicationOrientation} orientation The desired orientation.
	  * @type void
	  */
	setOrientation : function(orientation)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.SetOrientation, orientation);
	},

	/**
	  * Register an application observer to receive application callbacks.
	  * @param {NgApplicationObserver} obs The observer to register.
	  * @type void
	  */
	registerObserver : function(obs)
	{
		obs.index = this.mObservers.push(obs);
	},

	unregisterObserver : function(obs)
	{
		if (obs.index)
			delete this.mObservers[obs.index - 1];
	},

	/** @private */
	onApplicationStart : function()
	{
		// NgUI.onLoad(); // it should be obsolete
		for (var i in this.mObservers)
		{
			// TODO is this even possible?
			this.mObservers[i].onApplicationStart();
		}
	},
	
	/** @private */
	onApplicationReceivedCustomMessage : function( message )
	{
		for (var i in this.mObservers)
		{
			this.mObservers[i].onApplicationReceivedCustomMessage( message );
		}
	},
	
	/** @private */
	onApplicationBackPressed : function()
	{
			var observerResult = false;
			for (var i in this.mObservers)
			{
				 if (this.mObservers[i].onApplicationBackPressed())
				 {
					observerResult = true;
					break;
				 }
			}
			if (!observerResult)
			{
				// back button was not fully handled. Ask the native application to handle it.
				NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
			}
	},
	
	/** @private */
	exitSystemProcess : function ()
	{
		NgLogD ( "pushing exit command" );
		//This makes java exit the app through android lifecycle
		NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
		NgLogD ( "pushed exit command" );
	}
};

// Observer base class for application events.

/**
  * Initialize a new application observer.
  * @constructor
  *
  * @class
  * The NgApplicationObserver class is used as the base class for any user-defined
  * class that receives application-level callbacks.  This currently includes
  * notifications on all application lifecycle events and device orientation
  * changes. <br>
  * Register the application observer by calling {@link NgApplication#registerObserver}.
  */

function NgApplicationObserver() {}

NgApplicationObserver.prototype =
{
	index: 0,
	/**
	  * Callback for application lifecycle start event.
	  * @type void
	  */
	onApplicationStart:function() {},

	/** @private */
	onApplicationReceivedCustomMessage:function( message ) {},

	/**
	  * Callback for device orientation change events.
	  * @param {NgApplicationOrientation} orientation Orientation enumeration value.
	  * @type void
	  */
	onApplicationDeviceOrientation:function( orientation ) {},

	/*
	 * Listener for when the user pushes the HW back button. Currently Android only.
	 *
	 * @return boolean true if back was handled entirely (eat the event), 
	 * false if it was not
	 *
	 */
	onApplicationBackPressed:function()
	{
		return false;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// class Entity
// Base class for other entity types.
//////////////////////////////////////////////////////////////////////////////////////////////////

// ObjectTypes
// Defined in
//		JS:  NgEntityTypes in NgWebEngine.js and
//		C++: EntityCommandIds in GameView.h
// 1 = App
// 2 = NgTouchEvent
// 3 = NgKeyPressEvent
// 4 = Accel
// 5 = NgTextInputBox2D
// 6 = Animation (completion events)
// 7 = Sound (completion events)
// 8 = EngineEntity
// 9 = DrawableEntity2D
// 10 = NgCanvas2D
// 11 = NgCamera2D
// 12 = NgSprite2D
// 13 = NgText2D
// 14 = NgWebView2D
// 15 = NgAudioManager
// 16 = NgGroup2D
// 100 = LoadApp

// App Commands
// in:
// capabilities = 0, command dictionary format
// frameTime = 2, double
// out:
// NgLogD = 1, string

// NgTouchEvent Commands
// non-native
//	action: 1 = add, 2 = remove, 3 = modify
//	id: touch instance ID
//	x: x position
//	y: y position
// native
//	action: 4 = add, 5 = remove, 6 = modify
//	id: touch instance ID
//	x: x pos
//	y: y pos
//  eid: entity instance ID
//	lx: local x pos
//  ly: local y pos

// NgKeyPressEvent Commands
// action: 1 = down, 2 = up
// id: instance ID
// value: key value

// InputText Box Commands

// Animation
// in:
// only one kind of event, so first value is id of sprite to callback.

// Sound
// in:
//

// Accel Commands
// out:
// SetEventRate = 0, rate (hz)
// in:
// x, y, z position (floats)

// EngineEntity commands

// DrawableEntity2D commands:
// SetNativeTouchType=1,id,value (None=1, Enable = 2, EnableBounds = 3)

// NgCanvas2D Commands
// NewNgCanvas2D=1, id
// DeleteNgCanvas2D=2, id
// Update=3, id, args... not used currently
// SetRoot=4, id, grp id
// ClearRoot=5, id
// EnableNativePicking=6, id, bool

// NgCamera2D Commands
// NewNgCamera2D=1,		id, canvasId, porperties
// DeleteNgCamera2D=2,	id
// UpdateNgCamera2D=3,	id, properties
//	Properties: vx, vy, vz, vh, vw, cx, cy, ch, cw

// NgSprite2D Commands
// NewNgSprite2D=1,		id, canvasId, texture, properties
// DeleteNgSprite2D=2,	id
// UpdateNgSprite2D=3,	id, properties
//   Properties: x, y, z, w, h, r, a

// NgText2D Operations
// NewNgText2D=1		id, canvasId, properties
// DeleteNgText2D=2	id
// UpdateNgText2D=3	id, properties
//  Properties: x, y, z, w, h, justify, text

// NgGroup2D Operations
// New = 1			id, canvasId, [properties/todo]
// Delete = 2		id
// Update = 3		id, [properties/todo]
// Child = 4		id, subcmd, [child id]
//						subcmd 0 = add, 1 = rem, 2 = remAll (no child id)
// Rot = 5			id, anglef
// Pos = 6			id, xf, yf, zf
// Alpha = 7		id, alphaf
// Scale = 8		id, xf, yf

// APITODO: Clean up these identifiers.
// APITODO: Sound is probably not used any more.
// APITODO: Animation is probably not used any more.

var NgEntityTypes = {
	App : 1,
	NgTouchEvent : 2,
	NgKeyPressEvent : 3,
	Accel : 4,
	NgTextInputBox2D : 5,
	Animation : 6,
	Sound : 7,
	NgEngineEntity : 8,
	NgDrawableEntity2D : 9,
	NgCanvas2D : 10,
	NgCamera2D : 11,
	NgSprite2D : 12,
	NgText2D : 13,
	NgWebView2D : 14,
	NgGroup2D : 16,
	NgPhysics2D: 17,
	NgPrimitive2D: 18,
	NgFileSys: 19,
	Gyro : 22,
	NgUI : 23,
	Storage: 24,
	NgSystemBinding: 25,
	NgCustomMessage : 50,
	LoadApp : 100
};

var NgEngineEntityCommandIDs = {
	SetNativeTouchType : 1
};

/**
 * Initializes instance to default values. <br>
 * mId member defaults to 0 but can be set by application before calling {@link NgEngineEntity#register}.
 * @constructor
 *
 * @class
 * NgEngineEntity is the base class for all game entities, such as NgSprite2D and NgText2D. <br>
 * This class introduces key callback functions for touch, key press and per-frame update
 * notification. <br>
 * Additionally, the class introduces a register/unregister mechanism
 * for controlling the existence of the entity in the native game engine.
 *
 */

function NgEngineEntity()
{
	/** The entity id.  Used by the native engine for identification.  @type number */
	this.mId = 0;
	/** The touch priority.  Touches are routed first to the highest priority entities.  @type number */
	this.mTouchPriority = 0;
	/** The key press priority.  Key presses are routed first to the highest priority entities.  @type number */
	this.mKeyPressPriority = 0;
	/** @private */
	this.mIsTouchable = false;
	/** @private */
	this.mIsKeyable = false;
	/** @private */
	this.mIsUpdatable = false;
	/** @private */
	this.mNativeTouchType = NgEngineEntity.NativeTouchType.Enable;
	/** @private */
	this.mRegistered = false;
}

// Static methods and data.

/**
  * NgEngineEntity touch policy enumeration. <br>
  * Used with {@link NgEngineEntity#setNativeTouchType} and {@link NgCanvas2D#enableNativePicking}. <br>
  * Values: <br>
  * None : Disables native touches for this entity (and its children). <br>
  * Enable : Enables this entity to receive touches (or visits child entities) <br>
  * EnableBounds : Enables this entity to receive touches on its axis-aligned bounding box.  If
  * a touch is received on a group, it will report the touch and _not_ visit the group's children.
  */

NgEngineEntity.NativeTouchType = {
	None : 0,
	Enable : 1,
	EnableBounds : 2
};

/**
  * @private
  */

NgEngineEntity.engineCurrentId = 1;

/**
  * Allocate a unique ID for an entity.
  * @return ID value.
  * @type number
  * @private
  */

NgEngineEntity.newEngineId = function ()
{
	return NgEngineEntity.engineCurrentId++;
};

/**
  * Reclaim an entity ID.
  * @private
  */

NgEngineEntity.deleteEngineId = function ()
{
	// Nothing.
};

// Instance methods.

// Basic entity callbacks.

/** @private */

NgEngineEntity.prototype.newEntity = function() {};

/** @private */

NgEngineEntity.prototype.deleteEntity = function() {};

/**
  *	Callback for standard touch events. <br>
  * Standard touch events correspond to all touches
  * within the game view.  For each touch on the game view, all registered touchable
  * entities will receive the event.  Application logic must perform filtering to determine
  * if a particular entity corresponds to the touch event. <br>
  * Refer to {@link NgEngineEntity#toggleTouchable} for control of an entity's touchable state.
  * @param {NgTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onTouch = function(touch)
{
	return false;
};

/**
  * Callback for native touch events. <br>
  * Native touch events are pre-filtered by the game engine
  * to correspond to a specific touchable entity.  For each touch on the game view, the game
  * engine will determine which game entities are selected by the touch event.  Only the 
  * selected entities will receive the onNativeTouch event callback. <br>
  * Native touch capability is not affected by touchable state of the entity determined by
  * {@link NgEngineEntity#toggleTouchable}.  Refer to {@link NgEngineEntity#setNativeTouchType} 
  * for management of an entity's native touch policy.
  * @param {NgNativeTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onNativeTouch = function(touch)
{

};

/**
  * Callback for keyboard events. <br>These events correspond to physical or software keyboard events. <br>
  * Enable/disable key press events for an entity with {@link NgEngineEntity#toggleKeyable}.
  * @param {NgKeyPressEvent} keyPress The key press event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onKeyPress = function(keyPress)
{
	return false;
};

/**
  *	Callback for update events. <br>Per-frame entity logic should be implemented in this callback. <br>
  * Enable/disable update events for an entity with {@link NgEngineEntity#toggleUpdatable}.
  * The return value of this method is ignored.
  * @type void
  */

NgEngineEntity.prototype.onUpdate = function()
{
};

/**
  *	Register this entity instance with the native game engine. <br>
  * The initialization sequence of engine entities has specific constraints: <br>
  * After construction and before calling
  * the register method, class methods that affect the native engine state cannot be called.  
  * During this period, changes to entity state by changing instance variables will be
  * sent to the native engine on the call to register. <br>
  * After register is called, 
  * changes to instance variables will be ignored.  During this phase, the only
  * way to affect native engine state is through methods that push commands to
  * the native side.
  * @type void
  */

NgEngineEntity.prototype.register = function()
{
	this.mParents = [];

	if( this.mId >= 0 )
	{
		this.mId = NgEngineEntity.newEngineId();
	}

	this.mRegistered = true;
	gNgEngineEntities[this.mId] = this;
	gNgAddedEngineEntities[this.mId] = this;
	this.newEntity();
};

/**
  * Unregister this entity from the native game engine.
  * @type void
  */

NgEngineEntity.prototype.unregister = function()
{
	var parents = this.mParents.concat([]);

	for (var i in parents)
	{
		NgLogD ( "Removing child " + this.mId + " from parent Group " + parents[i].mId + " because the Entity was unregistered");
		parents[i].removeChild( this );
	}

	this.mRegistered = false;
	delete gNgEngineEntities[this.mId];
	// CAUTION : DO NOT SPLICE gNgEngineEntities EVER.
	//gNgEngineEntities.splice(this.mId,1);

	gNgRemovedEngineEntities[this.mId] = this;
	this.deleteEntity();

	if(this.mId >= 0)
		NgEngineEntity.deleteEngineId(this.mId);
};

/**
  * Enable/disable update callbacks for this entity. <br>
  * This method flips the enable state
  * for update events. <br>
  * In order to receive update callbacks, an entity
  * must override the onUpdate event and enable updatable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleUpdatable = function()
{
	if(this.mIsUpdatable)
	{
		delete gNgUpdateEngineEntities[this.mId];
	}
	else
	{
		gNgUpdateEngineEntities[this.mId] = this;
	}
	this.mIsUpdatable = !this.mIsUpdatable;
};

/**
  * Set native touch traversal policy. <br>
  * This method controls how the native game engine
  * traverses the game scene graph. <br>
  * The policies are described in further detail with {@link NgEngineEntity#NativeTouchType}. <br>
  * The default state is "Enable".
  * @param {NativeTouchType} type The policy enum for native touch processing.
  * @type void
  */

NgEngineEntity.prototype.setNativeTouchType = function( type )
{
	this.mNativeTouchType = type;
	NgPushCommand4(NgEntityTypes.NgDrawableEntity2D, NgEngineEntityCommandIDs.SetNativeTouchType, this.mId, this.mNativeTouchType );
};
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
var Core = require('NGCore/Client/Core').Core;

// These methods handle all composition for commands being sent back to the
// native engine.

/**
  * @private
  */

var gNgCommandStrings = [];

/**
  * @private
  */

var gNgCommandString = '';

// 0 deferred string composition via user loop
// 1 deferred string composition via internal loop
// 2 on-the-fly string composition.

// TODO: Benchmark all variation on all platforms.  Choose appropriate one(s)
// and prune code for others.

// UPDATE: ALL variations on contructing a string performed IDENTICALLY in
// the iPhone's UIWebView.  Unbelievable.

/**
  * @private
  */

var gNgCommandMode = 2;

/**
  * @private
  */

function NgQueueCommandText(command)
{
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings.push( command );
			break;
		case 2:
			gNgCommandString += command;
			break;
	}
}

/**
  * @private
  */

function NgFlushCommandsToString()
{
	var outputString = '';
	
	switch(gNgCommandMode)
	{	
		case 0:
			for( var num = 0, end = gNgCommandStrings.length; num < end; ++num )
			{
				outputString += gNgCommandStrings[ num ];
			}
			break;
			
		case 1:
			outputString = String.prototype.concat.apply(gNgCommandStrings);
			break;
	}
	
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings = [];
			break;
		case 2:
			outputString = gNgCommandString;
			gNgCommandString = '';
			break;
	}
	
	return outputString;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function NgParseString(txt)
{
	return txt;
}

/**
  * @private
  */

function NgParseBase64(txt)
{
	if( txt )
		return Core.Base64.decode(txt);
	else
		return "";
}

/**
  * @private
  */

function NgParseBool(txt)
{
	return parseInt(txt) ? true : false;
}

function NgParseInt(txt)
{
	return parseInt(txt, 10);
}

function NgKVArrayToCmd(kvArray)
{
	var out = "";
	var count = 0;
	for (var s in kvArray)
	{
		var value = kvArray[s];
		
		out += "," + s + "," + Core.Base64.encode(value);
		++count;
	}
	return count + out;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Submit a command with 1 argument to the native engine.
 * @private
 */
function NgPushCommand1(arg1)
{
	gNgCommandString += ":" + arg1;
}

/**
 * Submit a command with 2 arguments to the native engine.
 * @private
 */
function NgPushCommand2(arg1, arg2)
{
	gNgCommandString += ":" + arg1 + "," + arg2;
}

/**
 * Submit a command with 3 arguments to the native engine.
 * @private
 */
function NgPushCommand3(arg1, arg2, arg3)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3;
}

/**
 * Submit a command with 4 arguments to the native engine.
 * @private
 */
function NgPushCommand4(arg1, arg2, arg3, arg4)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4;
}

/**
 * Submit a command with 5 arguments to the native engine.
 * @private
 */
function NgPushCommand5(arg1, arg2, arg3, arg4, arg5)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5;
}

/**
 * Submit a command with 6 arguments to the native engine.
 * @private
 */
function NgPushCommand6(arg1, arg2, arg3, arg4, arg5, arg6)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6;
}

/**
 * Submit a command with 7 arguments to the native engine.
 * @private
 */
function NgPushCommand7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand8(arg1, arg2, arg3, arg4, arg5, arg6, arg7,arg8)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8 + "," + arg9;
}

/**
 * Submit a command with n arguments to the native engine.
 * @private
 */
function NgPushCommandN()
{
	var argv = arguments;
	var argc = argv.length;
	
	var tmp = ":";
	
	if( argc > 0 )
	{
		tmp += argv[ 0 ];
		
		for( var num = 1; num < argc; ++num )
		{
			tmp += "," + argv[ num ];
		}
	}
	
	gNgCommandString += tmp;
}

/**
 * Peek at the command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Command id or null if parsing failed.
 * @private
 */

function NgPeekCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
		return parseInt ( vals[ 1 ] );
	else
		return null;
}

/**
 * Peek at the class and command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Two-element array of ids or null if parsing failed.
 * @private
 */

function NgPeekClassAndCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
	{
		vals[ 0 ] = parseInt ( vals[ 0 ] );
		vals[ 1 ] = parseInt ( vals[ 1 ] );
		return vals;
	}
	else
		return null;
}


/**
 * Parse an incoming command string to individual strings.
 * @return an array of fields in serialization order.
 * @private
 */
function NgParseCommandToStrings(src)
{
	return src.split(",");
}

/**
  * @private
  */

function NgParseCommand1(src, func1)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand2(src, func1, func2)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand3(src, func1, func2, func3)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand4(src, func1, func2, func3, func4)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand5(src, func1, func2, func3, func4, func5)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	ret[ 4 ] = func5( fields[ 5 ] );
	
	return ret;
}


/**
 * Parse an incoming command string to typed values based on passed-in functions.
 * ex: NgParseCommandN("1:1,1.0,ACFHENA==",parseInt, parseFloat, NgParseString);
 * NOTE: The first item is assumed to be the command type, and will be
 * discarded in the output.  I.e., the output starts with the second src element.
 * @return an array of parsed fields in serialization order.
 * @private
 */

function NgParseCommandN(src)
{
	var ret = [];
	
	var argv = arguments;
	var argc = argv.length;
	
	var fields = src.split(",");
	for( var num = 1; num < argc; ++num )
	{
		ret[ num - 1 ] = argv[ num ]( fields[ num ] );
	}
	
	return ret;
}

/**
 * Parse an incoming typed dictionary.  The format of the dictionary is:
 * type,field name,value,type,field name,value[...]
 * Parsed values will be asigned to the field name in the dst array/object.
 * NOTE: Strings passed in this format must not have embedded commas (use
 * base64 encoding if arbitrary strings are being used.
 * @arg src The source command string.
 * @arg srcStart The field index to start parsing dictionary entries from.
 * @arg dst The destination object/array for parsed values.
 * @arg initialFields Optionally store the fields before srcStart in the passed-in array.
 * @return true if all fields were successfully parsed.
 * @private
 */

function NgParseCommandDictionary(src,srcStart,dst,initialFields)
{
	var ret = true;
	var fields = src.split(",");
	var end = fields.length;
	var num;

	if(initialFields)
	{
		for( num = 0; num < srcStart; ++num )
		{
			initialFields[ num ] = fields[ num ];
		}
	}
	
	for( num = srcStart; num < end; )
	{
		var type = fields[ num++ ];
		var name = fields[ num++ ];
		var val = fields[ num++ ];
		var good = true;
		
		switch(type)
		{
			case 'i':	// int
				val = parseInt( val );
				break;
			case 'f':	// float
				val = parseFloat( val );
				break;
			case 's':	// string
				break;
			case 'S':	// base64 string
				val = Core.Base64.decode(val);
				break;
			case 'b':	// bool
				val = parseInt(val) ? true : false;
				break;
			default:
				//				NgLogD("NgParseCommandDictionary unknown type for " + type + " " + name + " " + val);
				ret = false;
				good = false;
				break;
		}
		
		if( good )
		{
			dst[ name ] = val;
			
			// TEMP PRW
			NgLogD( "dict: " + name + " : " + dst[ name ] );
		}
		else
		{
			NgLogD("dict: could not process " + type );
		}
	}
	
	return ret;
}
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var FileSystem   = require('NGCore/Client/Storage/FileSystem').FileSystem;

/**
  * @private
  */

var gNgTrace=null;

//////////////////////////////////////////////////////////////////////////////////////////////////
// Logging functions.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */
var NgDebugModes = {
	BrowserTrace : {},
	NgCommand : {},
	NgCommandDocLoc : {}
};

/**
  * @private
  */
var NgLogLevel = {
	Verbose : 5,
	Debug : 4,
	Info : 3,
	Warning : 2,
	Error : 1
};

/**
  * @private
  */
var NgLogStr = [ '', 'e', 'w', 'i', 'd', 'v'];


/**
  * @private
  */

// TEMP... this is not how we want to do this long-term.
function NgSetDebugDefaultDestination()
{
	if (typeof navigator == 'undefined')
	{
		return NgDebugModes.NgCommand;
	}

	var agent=navigator.userAgent.toLowerCase();
	if( ! ( (agent.indexOf('iphone') >=0) || (agent.indexOf('ipad') >= 0) ) )
	{
		return NgDebugModes.BrowserTrace;
	}
	else
	{
		return NgDebugModes.NgCommand;
	}
}

/**
  * @private
  */

var gNgDebugMode = NgSetDebugDefaultDestination();

/**
  * @private
  */

function NgLogInit()
{
	if( gNgDebugMode == NgDebugModes.BrowserTrace )
	{
		gNgTrace = document.getElementById("trace");
	}

	// Other modes don't need initialization.
}

var NgDoVerboseLog = function ( msg ) {
	NgLog(NgLogLevel.Verbose, msg);
};

var NgDoDebugLog = function ( msg ) {
	NgLog(NgLogLevel.Debug, msg);
};

var NgDoInfoLog = function ( msg ) {
	NgLog(NgLogLevel.Info, msg);
};

var NgDoWarningLog = function ( msg ) {
	NgLog(NgLogLevel.Warning, msg);
};

var NgDoErrorLog = function ( msg ) {
	NgLog(NgLogLevel.Error, msg);
};

var NgDoTimingLog = function ( msg ) {
	timingLog(msg);
};

var NgNoLog = function() {};

// defaults
var NgLogV = NgDoVerboseLog;
var NgLogD = NgDoDebugLog;
var NgLogI = NgDoInfoLog;
var NgLogW = NgDoWarningLog;
var NgLogE = NgDoErrorLog;
var NgLogT = NgDoTimingLog;

function NgLogSetLevel(level)
{
	switch( level )
	{
		case NgLogLevel.Debug:
			NgLogV = NgNoLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
            NgLogT = NgDoTimingLog;
			break;

		case NgLogLevel.Info:
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
            NgLogT = NgDoTimingLog;
			break;

		case NgLogLevel.Warning:
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
            NgLogT = NgDoTimingLog;
			break;

		case NgLogLevel.Error:
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgNoLog;
			NgLogE = NgDoErrorLog;
            NgLogT = NgDoTimingLog;
			break;

		default:
		case NgLogLevel.Verbose:
			NgLogV = NgDoVerboseLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
            NgLogT = NgDoTimingLog;
			break;
	}
}

NgLogSetLevel(NgLogLevel.Verbose);

var useConsole = ((typeof console != 'undefined') && (typeof console.log == 'function'));

function NgLog( level, msg )
{
	console.log(NgLogStr[level] + ": " + msg);
}
function _exceptionNameDemangleHelper(ex,key){
	try {
		var filename = exception_demangle_require(ex[key]);
		return filename;
	} catch(e){
		//Don't cause exceptions when we're already logging an exception!
	}
	return "";
}
var NgLogException = (function() {
    function ignoreLines(data, lines, start)
    {
        var pos = start;
        var ignoredLines = 0;
        while (ignoredLines < lines) {
            pos = data.indexOf("\n", pos);
            if (pos < 0) {
                break;
            }

            ++pos;
            ++ignoredLines;
        }

        return {
            nextPosition: pos,
            ignoredLines: ignoredLines
        };
    }

		var sourceCodeReadError = function(ex, cb, msg) {
			NgLogV(msg);
			return cb(ex);
		};

    var dumpSourceCodeAroundException =
        function(ex, cb, relFilePath, absFilePath, functionName, lineNumber)
    {
        relFilePath =  relFilePath  || '';
        absFilePath =  absFilePath  || '';
        functionName = functionName || '';
        lineNumber =   +(lineNumber || 0);

		if (parseInt(lineNumber, 10) <= 1) {
			// line breaks may have been removed, do not show source code (this will result in entire code base being printed)
			NgLogV('Line breaks in source may have been removed, source dump not shown');
			return cb(ex);
		}

        if (absFilePath === '' ||  relFilePath === '' || lineNumber <= 0) {
            var msg = 'source dump error: ' +
                      "Could not read '" + absFilePath + "' " +
                      'at ' + lineNumber +
                      "\n";
            return sourceCodeReadError(ex, cb, msg);
        }

        FileSystem.readFile(relFilePath, { binary: false }, function(error, data) {
            if (error) {
                return sourceCodeReadError(ex, cb, 'source dump error: ' + error + "\n");
            }

            var BEFORE_AFTER_LINES = 8;

            var expectBeforeLineNumber = Math.max(lineNumber - BEFORE_AFTER_LINES, 1);
            var beforeRes = ignoreLines(data, expectBeforeLineNumber - 1, 0);
            var beforeLineNumber = beforeRes.ignoredLines + 1;

            if (beforeLineNumber !== expectBeforeLineNumber) {
                var msg = "source dump error: " +
                          "Could not read '" + absFilePath + "' " +
                          'until ' + lineNumber +
                          "\n";
                return sourceCodeReadError(ex, cb, msg);
            }

            var LINE_SIZE = 50;
            var DECORATOR = new Array(50).join('*');

            var totalLines = (lineNumber - beforeLineNumber) + 1 + BEFORE_AFTER_LINES;
            var dumpedSource = ''.concat(
                DECORATOR + "\n",
                'File: ' + absFilePath + "\n",
                functionName ? 'Function: ' + functionName + "\n" : '',
                'Line: ' + lineNumber + "\n",
                "\n"
            );

            var pos = beforeRes.nextPosition;

            for (var i = 0; i < totalLines; ++i) {
                var currLineNumber = beforeLineNumber + i;
                var newlinePos = data.indexOf("\n", pos);
                var currLine =
                    data.substring(pos, newlinePos >= 0 ? newlinePos : data.length);

                dumpedSource = dumpedSource.concat(
                    currLineNumber,
                    currLineNumber === lineNumber ? '> ' : ': ',
                    currLine,
                    "\n"
                );

                if (newlinePos === -1) {
                    break;
                }

                pos = newlinePos + 1;
            }

            dumpedSource += DECORATOR + "\n";

            cb(ex, dumpedSource);
        });
    };

    function dumpForSpiderMonkey(ex, cb)
    {
      var stackTrace = ex.stack || '';
      var matchRes = /^([^\(\s]*)\(.*\)@([^:]*\/([^\/]+\.[^\.:]*)):(\d+)$/m.exec(stackTrace);

      ex.stackWithParams = ex.stack;
      ex.stack = ex.toString() + '\n' + ex.stack.replace(/([^\(\s]*)\(.*\)@([^:]*\/([^\/]+\.[^\.:]*)):(\d+)/g, '\t at $1 ($2:$4)');

      if (matchRes) {
        return dumpSourceCodeAroundException(ex, cb, matchRes[3], matchRes[2], matchRes[1], matchRes[4]);
      } else {
				return cb(ex);
      }
    }

    function dumpForUIWebView(ex, cb)
    {
        var sourceURL = ex.sourceURL || '';

        var jsExtension = '.js';
        var jsEndPos = sourceURL.lastIndexOf(jsExtension);

        if (jsEndPos < 0) {
					return cb(ex);
        }

        jsEndPos = jsEndPos + jsExtension.length;

        var dirSeparator = '/';
        var lastDirPos = sourceURL.lastIndexOf(dirSeparator, jsEndPos);
        var jsStartPos = lastDirPos < 0 ? 0 : lastDirPos + dirSeparator.length;

        var relFilePath = sourceURL.substring(jsStartPos, jsEndPos);
        var absFilePath = sourceURL.substring(0, jsEndPos);

        return dumpSourceCodeAroundException(ex, cb, relFilePath, absFilePath, ex.sourceURL, ex.line);
    }

    function dumpForV8(ex, cb)
    {
        var stackTrace = ex.stack || '';
        var matchRes = /^\s*at\s+([^\(\/]*)\s?\(?([^:]*\/([^\/]+\.js)):(\d+):\d+\)?\s*$/m.exec(stackTrace);

        if (matchRes) {
            return dumpSourceCodeAroundException(ex, cb, matchRes[3], matchRes[2], matchRes[1], matchRes[4]);
        } else {
					return cb(ex); 
        }
    }

    function dumpForFlash(ex, cb)
    {
        var stackTrace = ex.stack || '';
        var matchRes = /^\s*at\s+([^\(\/]*)\s?\(?([^\?]*\/([^\/]+\.js)\?h=[^:]*):(\d+):\d+\)?\s*$/m.exec(stackTrace);

        if (matchRes) {
          return dumpSourceCodeAroundException(ex, cb, matchRes[3], matchRes[2], matchRes[1], matchRes[4]);
        } else {
					return cb(ex);
        }
    }

		function applyStackLevel(ex)
		{
			var stacklevel = ex.stacklevel;
			if (ex.stack && stacklevel && stacklevel > 0) {
				var spiderMatch = /^[^\(\s]*\(.*\)@[^:]*\/[^\/]+\.[^\.:]*:\d+$/;
				var v8Match = /^\s*at\s+[^\(\/]*\s?\(?[^:]*\/[^\/]+\.js:\d+:\d+\)?\s*$/;
				var lines = ex.stack.split('\n');
				for (var i=0, l=lines.length; i<l; ++i) {
					var line = lines[i];
					if ((line.match(spiderMatch) || line.match(v8Match)) && (i + stacklevel) < l) {
						lines.splice(i, stacklevel);
						ex.stack = lines.join('\n');
						break;
					}
				}
			}
		}

		function NgLogExceptionCallback( ex, dumpedSource )
		{
			var exception;
			if (!ex) {
				exception = "NgLogException called with nil exception.\n";
				ex = {toString:function(){
					return exception;
				}};
			} else if (ex.stack) {
				exception = ex.stack;
				if (exception.charAt(exception.length-1) !== '\n') {
					exception += '\n';
				}
			} else {
        exception = ex.toString() + '\n[NO STACK TRACE AVAILABLE]\n';
      }
      // Add exception description/stack trace
			var str = '';
			var handleExceptionStr = '';
			var stackTrace = "\n\nEXCEPTION: " + exception;
			if (Capabilities.getPlatformOS().match(/android/i)) {
				// logcat in Android has a characer limit for each entry so print the exception in two parts: 1) stacktrace and 2) code snippet/properties
				NgLogE(stackTrace);
				handleExceptionStr += stackTrace;
				str += '\n';
			} else {
				// print both the stacktrace and code snippet/properties in one part
				str += stackTrace;
			}

      // Add file info and code snippet
      for (var key in ['sourceFile', 'sourceURL', 'fileName']) {
        if (ex[key]) {
          str += _exceptionNameDemangleHelper(ex, key) + "\n";
          break;
        }
      }
      if (ex.relatedFile) {
        str += "\trelated to file: "+_exceptionNameDemangleHelper(ex,"relatedFile") + "\n";
      }
      str += dumpedSource || '';

      // Add exception properties and values
      for( var prop in ex ) {
        if (prop !== 'stack') {
          str += "PROPERTY: "+ prop+ " VALUE: ["+ ex[prop]+ "]\n";
        }
      }
			str += '\n';

			NgLogE( str );
			handleExceptionStr += str;

      if (! Core.Proc.isPrivileged()) {
        var ErrorEmitter = require('NGCore/Client/Core/ErrorEmitter').ErrorEmitter;
        ErrorEmitter._handleUncaughtException(handleExceptionStr);
      }
    }

    return function( ex )
    {
        var os = Capabilities.getPlatformOS();
        var sourceDumper = function( ex, cb ) { cb(ex, ''); };

				applyStackLevel(ex);

        if (os.match(/iphone/i)) {
            if (ex.stack) {
              sourceDumper = dumpForSpiderMonkey;
            } else {
              // UIWebView errors don't have stacktraces
              sourceDumper = dumpForUIWebView;
            }
        } else if (os.match(/android/i)) {
            sourceDumper = dumpForV8;
        } else if (os.match(/flash/i)) {
            sourceDumper = dumpForFlash;
        }

        sourceDumper(ex, NgLogExceptionCallback);
    };
})();


var __dirname = 'Code/Util';
var __filename = 'Code/Util/profiling.js';

//////////////////////////////////////////////////////////////////////////////////
/* Add this to main.js
 *

function main()
{
	var glView = new UI.GLView();
	glView.setFrame(0, 0, UI.Window.getWidth(), UI.Window.getHeight());
	glView.setOnLoad(function()
	{
		try
		{
			gApplicationDebugging = new ApplicationDebugging();
			gApplicationDebugging.showDebugUI();
		}
		catch(ex)
		{
			console.log("**************** PROFILING DISABLED ****************")
		}
	});

	glView.setActive(true);
}
*/

//////////////////////////////////////////////////////////////////////////////////



// enable strict mode for JavaScript.
"use strict";

var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;
var UI = require('NGCore/Client/UI').UI;
var Device = require('NGCore/Client/Device').Device;

var g_StatCalls = {};
var g_StatTimes = {};
var gApplicationDebugging;

var ApplicationDebugging = Core.MessageListener.subclass(
{
	initialize: function(w, h)
	{
		this._w = UI.Window.getWidth();
		this._h = UI.Window.getHeight();
	},

	showDebugUI: function()
	{
		// Start recording an event.
		// @since SDK 1.7.5
		//Core.DiagnosticEmitter.startEvent("showDebugUI");

		var reloadButton = new UI.Button();
		reloadButton.setText("r");
		reloadButton.setOnClick(function()
		{
			console.log('reloading');
			//Core.LocalGameList.runUpdatedGame('/' + Core.Capabilities.getBundleGame());
			var contentUrl = Core.Capabilities.getContentUrl();
			var slash = contentUrl.lastIndexOf('/');
			contentUrl=contentUrl.slice(0,slash);
			console.log(contentUrl);
			Core.LocalGameList.runUpdatedGame(contentUrl);
		});
		reloadButton.setFrame([0,0,30,30]);
		reloadButton.setBackgroundColor('FFFFFFFF');
		reloadButton.setTextColor('FFFF0000', UI.Commands.State.Pressed);
		UI.Window.document.addChild(reloadButton);


		// Add a button to the screen that will terminate the process.
		var exitButton = new UI.Button();
		exitButton.setText("e");
		exitButton.setOnClick(function()
		{
			console.log('exiting');
			Device.LifecycleEmitter.exitProcess();
		});
		exitButton.setFrame([32,0,30,30]);
		exitButton.setBackgroundColor('FFFFFFFF');
		exitButton.setTextColor('FFFF0000', UI.Commands.State.Pressed);
		UI.Window.document.addChild(exitButton);

		var printStats = new UI.Button();
		printStats.setText("ps");
		printStats.setOnClick(function()
		{
			var key;
			console.log('printing stats');
			for (key in g_StatCalls)
			{
				console.log('PROFILING: STATS CALLS: ' + key + '=' + g_StatCalls[key]);
			}

			for (key in g_StatTimes)
			{
				console.log('PROFILING: STATS TIMES: ' + key + '=' + g_StatTimes[key]);
			}
		});
		printStats.setFrame([64,0,30,30]);
		printStats.setBackgroundColor('FFFFFFFF');
		printStats.setTextColor('FFFF0000', UI.Commands.State.Pressed);
		UI.Window.document.addChild(printStats);

		var resetStats = new UI.Button();
		resetStats.setText("rs");
		resetStats.setOnClick(function()
		{
			g_StatCalls = {};
			g_StatTimes = {};
		});
		resetStats.setFrame([96,0,30,30]);
		resetStats.setBackgroundColor('FFFFFFFF');
		resetStats.setTextColor('FFFF0000', UI.Commands.State.Pressed);
		UI.Window.document.addChild(resetStats)

		// Stop recording an event.
		// @since SDK 1.7.5
		//Core.DiagnosticEmitter.stopEvent("showDebugUI");
	}
});

/* Example for time profiling
 *
 *
 * function demoFunction()
 * {
 *     var mN='Classname_Method';
 *     if (!g_StatTimes[mN]) { g_StatTimes[mN] = 0; };
 *     var profilingTime = Date.now();
 *
 *     // my ugly and slow code
 *
 *     g_StatTimes[mN] += Date.now() - profilingTime;
 *     return;
 * }
 */


var __dirname = 'ngCrunch';
var __filename = 'ngCrunch/core.js';

/*
 *  core.js
 *  syntaxCheck
 *
 *  Created by Dennis on 2/15/11.
 *  Copyright 2011 Freeverse. All rights reserved.
 *
 */

// force the ngCrunch/ngCrunch.js content to be evaluated immediately.
require('ngCrunch/ngCrunch').baseInit();


var __dirname = 'Code';
var __filename = 'Code/Constants.js';

var TUTORIAL_FORCED = false;

// File read style
var BLOCKING_READ = false;

// Content URL
var CONTENT_URL         = "http://werule-cdn.ngmoco.com/dlccontent/supremacy_client/gasha300V8/";

// ManifestSet URL
var MANIFEST_SET_URL    = "http://sp-live.aws.ngmoco.com/content/manifest";

var DEBUG_SCROLLABLE_VIEW = false;
var DEBUG_CLIPPING = false;

// Used by Debugging.js
var DEV_DEBUG_WARN = false;
var DEV_DEBUG_ERR  = false;
var TRACE_LEVEL = 3;
var SVN_REVISION = "----";

// Workaround to test in flash
var _NG_TARGET_FLASH = true;

var NETWORK_DISABLED = false;

var PILOT = 1;
var GEAR = 2;

var FACTIONS =
{
    "factions_coalition": 1,
    "factions_scourge": 2,
    "factions_elders": 3
};

var IMAGE_SIZE =
{
    "SMALLEST": 36,
    "SMALL": 200,
    "BIG": 200,
    "BIGGEST": 400
};

//TODO FIXME Just use UpperCase
var RARITY =
{
    "COMMON": 1,
    "UNCOMMON": 2,
    "RARE": 3,
    "SUPER_RARE": 4,
    "common": 1,
    "uncommon": 2,
    "rare": 3,
    "superRare": 4
};

var RARITY_TEXT = {};
RARITY_TEXT[RARITY.COMMON] = "sort_common";
RARITY_TEXT[RARITY.UNCOMMON] = "sort_uncommon";
RARITY_TEXT[RARITY.RARE] = "sort_rare";
RARITY_TEXT[RARITY.SUPER_RARE] = "sort_super_rare";
/* END RARITY */

var NON_EXISTENT_CARD_ID = -2;
var NON_EXISTENT_CARD_IMAGE = '1pxalpha0.png';

var DEFAULT_CARD_ID = -1;
// FIXME This doesn't work by itself, we have to attach the size to it.
var DEFAULT_CARD_IMAGE = 'card_back';

var BIGGEST_CARD_SIZE =
{
    "_x": 1024,
    "_y": 1024
};
var EQUAL_COLOR = new Core.Color( [ 155, 234, 254 ] );
var BETTER_COLOR = new Core.Color( ( 1 / 255 ), ( 255 / 255 ), ( 1 / 255 ) );
var WORST_COLOR = new Core.Color( ( 255 / 255 ), ( 124 / 255 ), ( 124 / 255 ) );

// DEFAULT_CARD_IMAGE: 'democard.jpg',
var CARD_RATIO = 9 / 8; // 1.42; //height/width

var BACK_ACTION =
{
    "pop": 1,
    "swap": 2,
    "reset": 3
};
var GROWTH_FACTOR =
{
    "early": 0.4,
    "linear": 0.0,
    "late": -0.4
};

/* LOCK STATUS */

var LOCK_STATUS_DECK = "DECK";

/* END LOCK STATUS */

/* FONTS */

var FONT_COLOR =
{
    "blue"  : new Core.Color( 1, 1, 1 ),    // ( 108 / 255, 211 / 255, 237 / 255 ),
    "orange": new Core.Color( 1, 1, 1 ),    // ( 255 / 255, 228 / 255, 207 / 255 ),
    "white" : new Core.Color( 1, 1, 1 )     // ( 255 / 255, 255 / 255, 255 / 255 )
};
/* END FONTS */

/* SCREEN IDENTIFIERS */
var HOME_SCREEN         = 1;
var FUSION_SCREEN       = 2;
var GASHA_SCREEN        = 3;
var DECK_MANAGER_SCREEN = 4;
var NO_SCREEN           = -1;
/* END SCREEN IDENTIFIERS */

/* STATUS */
var STATUS_DEFINITION =
{
    "status1": "deck_management_status1",
    "status2": "deck_management_status2",
    "status3": "deck_management_status3"
};
/* END STATUS */

/* DECK POSITION BONUS */
var DECK_POSITION_MULTIPLIER =
{
    "1": 3,
    "2": 2,
    "3": 2
};
/* END DECK POSITION BONUS */

var localizationDict =
{};

/* TEXTURE CONSTANTS */
var TEXTURE_COLOR =
{
    "alpha"     : "1pxalpha0.png",
    "black"     : "1pxblack.png",
    "green"     : "1pxgreen.png",
    "lightgreen": "1pxlightgreen.png",
    "grey"      : "1pxgrey.png",
    "white"     : "1pxwhite.png",
    "yellow"    : "1pxyellow.png",
    "orange"    : "1pxorange.png",
    "blue"      : "1pxblue.png",
    "lightblue" : "1pxlightblue.png"
};
/* END TEXTURE CONSTANTS */

/* WEB VIEW CONSTANTS */

var HELP_URL = "http://sp-dev.aws.ngmoco.com/info/help/en_help.html";
var LEGAL_URL = "http://www.google.com";
var GAMEINFO_URL = "http://www.google.com";

/* END WEB VIEW CONSTANTS */

/* MISSION CONSTANTS */
var MISSION_REWARDS =
{
    "ENEMY_CHANCE": 5,
    "-ADD-A-VALUE-HERE-": 4,
    "LUCKY_CHANCE": 3,
    "CARD": 2,
    "GOLD": 1
};
/* END MISSION CONSTANTS */

/* CLIPPING CONSTANTS */
var CLIPPING_TYPE =
{
    "TOP": 0,
    "FOOT": 1,
    "BOTH": 2
};
/* END CLIPPING CONSTANTS */

/* ITEM CONSTANTS */
var ITEM_STATS =
{
    "EXPLORE_ENERGY": "explore_energy",
    "BATTLE_ENERGY" : "battle_energy",
    "COINS"         : "coins",
    "TOTAL_RECOVERY": "total_recovery"
};

/* GIFT AND REWARDS CONSTANTS */
var GIFT_TYPE =
{
    "COINS"             : 10,
    "GASHA"             : 20,
    "ITEM"              : 30,
    "INVENTORY_SPACE"   : 40,
    "MEDALS"            : 50,
    "FELLOWS_SPACE"     : 60,
    "CARD"              : 70
};

//GEAR AND PILOTS ARE ALREADY DEFINED
var STAGE_REWARDS = 3;

var REWARD_TYPE_TEXT = {};

REWARD_TYPE_TEXT[PILOT]         = "reward_type_fighter";
REWARD_TYPE_TEXT[GEAR]          = "reward_type_gears";
REWARD_TYPE_TEXT[STAGE_REWARDS] = "reward_type_stages";

/* END GIFT AND REWARDS CONSTANTS */

/* ITEM CONSTANTS */
var ITEM_STATS =
{
    "EXPLORE_ENERGY": "explore_energy",
    "BATTLE_ENERGY": "battle_energy",
    "COINS": "coins",
    "TOTAL_RECOVERY": "total_recovery"
};
var ITEM_INCREASE_TYPE =
{
    "PERCENTAGE": "percentage",
    "QUANTITY": "quantity"
};

var ITEM_TYPE =
{
    "STAT": "stat",
    "MISC": "fusion"
};

var MEDAL_ASSETS =
{
    "medal_1" : "medal_bronze_200.png",
    "medal_2" : "medal_bronze_200.png",
    "medal_3" : "medal_silver_200.png",
    "medal_4" : "medal_welcome_200.png"
};
/* END ITEM CONSTANTS */


var __dirname = 'Code/Util';
var __filename = 'Code/Util/HelperFunctions.js';

/**
 * sprintf() for JavaScript 0.7-beta1 http://www.diveintojavascript.com/projects/javascript-sprintf
 *
 * Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com> All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: Redistributions of source code must retain the above
 * copyright notice, this list of conditions and the following disclaimer. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided with the distribution. Neither the name of sprintf() for JavaScript nor the names of its contributors may be used to endorse or
 * promote products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * Changelog: 2010.09.06 - 0.7-beta1 - features: vsprintf, support for named placeholders - enhancements: format cache, reduced global namespace pollution
 *
 * 2010.05.22 - 0.6: - reverted to 0.4 and fixed the bug regarding the sign of the number 0 Note: Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/) who warned me about a bug
 * in 0.5, I discovered that the last update was a regress. I appologize for that.
 *
 * 2010.05.09 - 0.5: - bug fix: 0 is now preceeded with a + sign - bug fix: the sign was not at the right position on padded results (Kamal Abdali) - switched from GPL to BSD license
 *
 * 2007.10.21 - 0.4: - unit test and patch (David Baird)
 *
 * 2007.09.17 - 0.3: - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
 *
 * 2007.09.11 - 0.2: - feature: added argument swapping
 *
 * 2007.04.03 - 0.1: - initial release
 */

var sprintf = ( function()
{
    function get_type( variable )
    {
        return Object.prototype.toString.call( variable ).slice( 8, -1 ).toLowerCase();
    }

    function str_repeat( input, multiplier )
    {
        for( var output = []; multiplier > 0; output[--multiplier] = input )
        {/* do nothing */
        }
        return output.join( '' );
    }

    function str_format()
    {
        if( !str_format.cache.hasOwnProperty( arguments[0] ) )
        {
            str_format.cache[arguments[0]] = str_format.parse( arguments[0] );
        }
        return str_format.format.call( null, str_format.cache[arguments[0]], arguments );
    }

    str_format.format = function( parse_tree, argv )
    {
        var cursor = 1, tree_length = parse_tree.length, node_type = '', arg, output = [], i, k, match, pad, pad_character, pad_length;
        for( i = 0; i < tree_length; i++ )
        {
            node_type = get_type( parse_tree[i] );
            if( node_type === 'string' )
            {
                output.push( parse_tree[i] );
            }
            else if( node_type === 'array' )
            {
                match = parse_tree[i]; // convenience purposes only
                if( match[2] )
                { // keyword argument
                    arg = argv[cursor];
                    for( k = 0; k < match[2].length; k++ )
                    {
                        if( !arg.hasOwnProperty( match[2][k] ) )
                        {
                            throw new Error( sprintf( '[sprintf] property "%s" does not exist', match[2][k] ) );
                        }
                        arg = arg[match[2][k]];
                    }
                }
                else if( match[1] )
                { // positional argument (explicit)
                    arg = argv[match[1]];
                }
                else
                { // positional argument (implicit)
                    arg = argv[cursor++];
                }

                if( /[^s]/.test( match[8] ) && ( get_type( arg ) != 'number' ) )
                {
                    console.log( "Base/HelperFunctions.str_format.format Error, expecting number. parse_tree=" + JSON.stringify( parse_tree ) );
                    throw new Error( sprintf( '[sprintf] expecting number but found %s', get_type( arg ) ) );
                }
                switch( match[8] )
                {
                    case 'b':
                        arg = arg.toString( 2 );
                        break;
                    case 'c':
                        arg = String.fromCharCode( arg );
                        break;
                    case 'd':
                        arg = parseInt( arg, 10 );
                        break;
                    case 'e':
                        arg = match[7] ? arg.toExponential( match[7] ) : arg.toExponential();
                        break;
                    case 'f':
                        arg = match[7] ? parseFloat( arg ).toFixed( match[7] ) : parseFloat( arg );
                        break;
                    case 'o':
                        arg = arg.toString( 8 );
                        break;
                    case 's':
                        arg = ( ( arg = String( arg ) ) && match[7] ? arg.substring( 0, match[7] ) : arg );
                        break;
                    case 'u':
                        arg = Math.abs( arg );
                        break;
                    case 'x':
                        arg = arg.toString( 16 );
                        break;
                    case 'X':
                        arg = arg.toString( 16 ).toUpperCase();
                        break;
                }
                arg = ( /[def]/.test( match[8] ) && match[3] && arg >= 0 ? '+' + arg : arg );
                pad_character = match[4] ? match[4] == '0' ? '0' : match[4].charAt( 1 ) : ' ';
                pad_length = match[6] - String( arg ).length;
                pad = match[6] ? str_repeat( pad_character, pad_length ) : '';
                output.push( match[5] ? arg + pad : pad + arg );
            }
        }
        return output.join( '' );
    };

    str_format.cache =
    {};

    str_format.parse = function( fmt )
    {

        // FIXME: monkey patch, replace %@ by %s
        var _fmt = fmt;
        _fmt = _fmt.replace( /%(\d?\$?)@/g, "%$1s" );
        _fmt = _fmt.replace( /%(\d?\$?)i/g, "%$1d" );

        var match = [], parse_tree = [], arg_names = 0;
        while( _fmt )
        {
            if( ( match = /^[^\x25]+/.exec( _fmt ) ) !== null )
            {
                parse_tree.push( match[0] );
            }
            else if( ( match = /^\x25{2}/.exec( _fmt ) ) !== null )
            {
                parse_tree.push( '%' );
            }
            else if( ( match = /^\x25(?:([1-9]\d*)\$|\(([^\)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec( _fmt ) ) !== null )
            {
                if( match[2] )
                {
                    arg_names |= 1;
                    var field_list = [], replacement_field = match[2], field_match = [];
                    if( ( field_match = /^([a-z_][a-z_\d]*)/i.exec( replacement_field ) ) !== null )
                    {
                        field_list.push( field_match[1] );
                        while( ( replacement_field = replacement_field.substring( field_match[0].length ) ) !== '' )
                        {
                            if( ( field_match = /^\.([a-z_][a-z_\d]*)/i.exec( replacement_field ) ) !== null )
                            {
                                field_list.push( field_match[1] );
                            }
                            else if( ( field_match = /^\[(\d+)\]/.exec( replacement_field ) ) !== null )
                            {
                                field_list.push( field_match[1] );
                            }
                            else
                            {
                                console.log( "HelperFunctions.str_format [1] Error, _fmt=" + _fmt );
                                throw new Error( '[sprintf] huh?' );
                            }
                        }
                    }
                    else
                    {
                        console.log( "HelperFunctions.str_format [2] Error, _fmt=" + _fmt );
                        throw new Error( '[sprintf] huh?' );
                    }
                    match[2] = field_list;
                }
                else
                {
                    arg_names |= 2;
                }
                if( arg_names === 3 )
                {
                    console.log( "HelperFunctions.str_format [3] Error, _fmt=" + _fmt );
                    throw new Error( '[sprintf] mixing positional and named placeholders is not (yet) supported' );
                }
                parse_tree.push( match );
            }
            else
            {
                console.log( "HelperFunctions.str_format [4] Error, _fmt=" + _fmt );
                throw new Error( '[sprintf] huh?' );
            }
            _fmt = _fmt.substring( match[0].length );
        }
        return parse_tree;
    };

    return str_format;
} )();

var vsprintf = function( fmt, argv )
{
    argv.unshift( fmt );
    return sprintf.apply( null, argv );
};

function numberAddCommas( nStr )
{
    nStr = nStr + "";
    x = nStr.split( '.' );
    x1 = x[0];
    x2 = x.length > 1 ? '' : '';
    var rgx = /(\d+)(\d{3})/;
    while( rgx.test( x1 ) )
    {
        x1 = x1.replace( rgx, '$1' + ',' + '$2' );
    }
    return x1 + x2;
};

function _partition( array, begin, end, pivot )
{
    var piv = array[pivot];
    array.swap( pivot, end - 1 );
    var store = begin;
    var ix;
    for( ix = begin; ix < end - 1; ++ix )
    {
        var element = array[ix];
        var comparePiv;
        var compareElement;

        if( array.compareValue )
        {
            if( typeof ( array.compareValue ) == "function" )
            {
                comparePiv = array.compareValue( piv );
                compareElement = array.compareValue( element );
            }
            else
            {
                comparePiv = piv[array.compareValue];
                compareElement = element[array.compareValue];
            }

        }
        else
        {
            comparePiv = piv;
            compareElement = element;
        }

        var compare = ( compareElement <= comparePiv );

        if( array.inverted == true )
        {
            compare = !compare;
        }

        if( compare )
        {
            array.swap( store, ix );
            ++store;
        }
    }
    array.swap( end - 1, store );

    return store;
}

function _quickSort( array, begin, end )
{
    if( end - 1 > begin )
    {
        var pivot = Math.floor( ( end + begin ) / 2 );

        pivot = _partition( array, begin, end, pivot );

        _quickSort( array, begin, pivot );
        _quickSort( array, pivot + 1, end );
    }
}

function quickSort( array, compareFunc )
{
    _quickSort( array, 0, array.length );
}

/**
 *
 * @param view
 *            View to be clipped
 * @param type
 *            Type of clipping: 0: top, 1: foot, 2, both
 */
function clipScreen( view, type )
{
    view.setClipRectEnabled( true );
    var rect = screenClipRect;

    if( type != undefined )
    {
        switch( type )
        {
            case CLIPPING_TYPE.TOP:
                rect = screenClipRectTop;
                break;
            case CLIPPING_TYPE.FOOT:
                rect = screenClipRectFoot;
                break;
            case CLIPPING_TYPE.BOTH:
                rect = screenClipRect;
                break;
        }
    }
    view.setClipRect( rect );
}

/**
 * Param: image: ImageView with the image Param: Frame: View with same dimensions than the clipping rect Param: Offste: Point with the image offsets as a factor of width and height ( {_x: 0, _y: 0.3 })
 */
function imageClipping( image, frame, offset )
{
    if( offset != undefined )
    {
        // Clipping and scale ******************************
        var scale = 1;
        var cardFrame = frame.getFrame();
        frameOriginX = -cardFrame._size._width / 2;
        frameOriginY = -cardFrame._size._height / 2;
        frameWidth = cardFrame._size._width;
        frameHeight = cardFrame._size._height;

        // Scale the image to keep the ratio
        var imageRatio = CARD_RATIO; // Height/Width
        var fixedHeight = cardFrame._size._width * imageRatio;
        image.setFrame( new Core.Rect( cardFrame._origin._x, cardFrame._origin._y, cardFrame._size._width, fixedHeight ) );

        // Scale the image with the values of offset
        if( offset._width != undefined )
        {
            scale = 1 / offset._width;
            image.setScale( scale, scale );
            var position = image.getPosition();
            // Re-Position to keep the origin
            image.setPosition( position._x + frameWidth * ( scale - 1 ) / 2, position._y + fixedHeight * ( scale - 1 ) / 2 );
        }

        // Clipping
        var vector1 = frame.localToScreen( new Core.Vector( frameOriginX, frameOriginY ) );
        var vector2 = frame.localToScreen( new Core.Vector( frameWidth / 2, frameHeight / 2 ) );

        if( vector1 != undefined && vector2 != undefined )
        {
            image.setClipRectEnabled( true );
            image.setClipRect( new Core.Rect( vector1._x, vector1._y, vector2._x - vector1._x, vector2._y - vector1._y ) );

            // Re-Positioning
            var position = image.getPosition();
            image.setPosition( position._x - scale * frameWidth * offset._x, position._y - scale * fixedHeight * offset._y );
        }
    }
}

// TODO Should skip numbers with period, comma, / and % (i.e. "95%", "100.1", "99,000", "12/65")
// NOTE Some numbers must be localized: US: 100.000 ; CL: 100,000 ; SWISS: 100'000
var _loc = function()
{
    var i, len, args;
    if( arguments == undefined )
    {
        return "";
    }
    len = Object.keys( arguments ).length;
    // Note: This if is to prevent a weird bug where len was 0 always...
    if( len == 0 && arguments.length )
    {
        len = arguments.length;
    }
    if( len == 0 )
    {
        return "";
    }
    if( len == 1 )
    {
        if( arguments == undefined )
        {
            return "";
        }
        else if( isFinite( arguments[0] ) )
        {
            // Don't translate numbers
            return arguments[0];
        }
        else
        {
            return Localization.getString( arguments[0] );
        }
    }

    args = [ Localization.getString( arguments[0] ) ];
    args.push();
    for( i = 1; i < len; i++ )
    {
        args.push( arguments[i] );
    }

    return sprintf.apply( this, args );
};


/**
 * Binary search implementation that handles ranges of values
 *
 * @param dictionary
 *            Dictionary with the structure {"key1": value1, "key1": value1, ...}, ordered by ascending values.
 * @param value
 *            Value to look for in the dictionary
 * @returns key Dictionary key related to the value
 *
 */
binaryRangeSearch = function( dictionary, value, debug )
{
    var keys = Object.keys( dictionary );
    var min = 0;
    var max = keys.length - 1;

    var minKey = keys[min];
    var minValue = dictionary[minKey];
    var maxKey = keys[max];
    var maxValue = dictionary[maxKey];

    if( value > parseInt( maxValue ) )
    {
        return -1;
    }
    else if( value < parseInt( minValue ) )
    {
        return -2;
    }

    while( max > min )
    {
        var mid = Math.floor( ( min + max ) / 2 );
        var midKey = keys[mid];
        var midValue = dictionary[midKey];

        if( midValue < value )
        {
            var nextValue = dictionary[keys[( mid + 1 )]];
            if( nextValue > value )
            {
                return keys[( mid )];
            }
            min = mid + 1;
        }
        else if( midValue > value )
        {
            var nextValue = dictionary[keys[( mid - 1 )]];
            if( nextValue <= value )
            {
                return keys[( mid - 1 )];
            }
            max = mid - 1;
        }
        else
        {
            return midKey;
        }
    }

    // Return null if value not found
    return null;
};

fixCardRatio = function( cardImage, ratio )
{
    if( ratio == undefined )
    {
        ratio = CARD_RATIO;
    }
    info( "HelperFunctions.fixCardRatio, called." );

    // Scale the card to keep the correct ratio
    var frame = cardImage.getFrame();
    var size = frame._size;
    var origin = frame._origin;
    var frameRatio = size._height / size._width;

    // Taller
    if( frameRatio > ratio )
    {
        var newHeight = size._width * ratio;
        cardImage.setFrame( origin._x, origin._y + ( size._height - newHeight ) / 2, size._width, newHeight );
    }
    else
    {
        var newWidth = size._height / ratio;
        cardImage.setFrame( origin._x + ( size._width - newWidth ) / 2, origin._y, newWidth, size._height );
    }
};

createWebView = function( url, title )
{
    var vector = title.localToScreen( new Core.Vector( 0,  title.getFrame()._size._height / 2 ) );
    var cornerX = 0;
    var cornerY = vector._y;
    cornerYOffset = 0;
    var width = SCREEN_WIDTH;
    var height = SCREEN_HEIGHT;
    var mainRect = new UI.ViewGeometry.Rect( cornerX + cornerYOffset, cornerY + cornerYOffset, width, height );
    this._baseView = new UI.View();
    this._baseView.setFrame( mainRect.array() );

    UI.Window.document.addChild( this._baseView );

    // Sets up web view
    var webRect = new UI.ViewGeometry.Rect( 0, 0, width, height );

    this._webView = new UI.WebView();
    this._webView.setFrame( webRect.array() );
    this._baseView.addChild( this._webView );
    this._webView.setGradient(
    {
        gradient: [ "00000000 0", ]
    }, UI.State.Normal );
    // this._webView.setAlpha(0);
    UI.Window.document.addChild( this._baseView );

    this._webView.loadUrl( url );
};

dictionaryClone = function( dict )
{
    var keys, i, len, clone;

    clone = {};
    keys = Object.keys( dict );
    len = keys.length;

    for( i = 0; i < len; i++ )
    {
        clone[keys[i]] = dict[keys[i]];
    }

    return clone;
};

destroyChildren = function(destroyable)
{
    //console.log("�� destroyWithChildren");
    //console.log(destroyable);
    return;
    if(destroyable)
    {
        if(destroyable._children){
            var length = destroyable._children.length;
            for(var i = length - 1;i>=0; i--)
            {
                destroyChildren(destroyable._children[i]);
            }
        }
        //destroy(destroyable);
    }
};

var err_full = function( title, data )
{
    dump_full( "err", title, data );
};

var dump_full = function( type, title, data )
{
    info( "dump_full called. type=%s, title=%s", type, title );
    var data_substr, data_str, chunk_size, len, i;

    if( data && data.length > 0 )
    {
        data_str = data;
        chunk_size = 512;

        len = data_str.length;
        for( i = 0; i < Math.ceil( len / chunk_size ); i++ )
        {
            data_substr = data_str.substr( i * chunk_size, chunk_size );
            if( type == "err" )
            {
                err( "%s %s %s", i, title, data_substr );
            }
            else if( type == "warn" )
            {
                warn( "%s %s %s", i, title, data_substr );
            }
            else if( type == "info" )
            {
                info( "%s %s %s", i, title, data_substr );
            }
            else
            {
                console.log( "" + i + " " + title + " " + data_substr );
            }
        }
    }
    else
    {
        info( "HelperFunctions.err_full No data provided to output. title=" + title );
    }
};

var cardsInVaultPopUp = function(cardInstance, range)
{
    if(range == undefined)
    {       
        info("HelperFunctions cards in Limbo " + JSON.stringify(cardInstance) );
        if (cardInstance.inLimbo == true)
        {            
            if(cardInstance.type == PILOT)
            {
                fighterAmount = CardsManager.getFilteredPlayerCardsWithLimbo( { "type": 1 } ).length;
                if((User.getMaxPilotCards() + 1) == fighterAmount )
                {
                    var popUp = new PopUp( 1, PopUp.ALERT, _loc( "single_gasha_vault_pilot_title" ), _loc( "single_gasha_vault_pilot_message" ), null, _loc( "single_gasha_vault_ok_button" ) );
                    Xib.Navigation.removeModalOverlay();
                    Xib.Navigation.setModalOverlay( popUp );
                }
            }
            if(cardInstance.type == GEAR)
            {
                weaponAmount  = CardsManager.getFilteredPlayerCardsWithLimbo( { "type": 2 } ).length;
                if((User.getMaxGearCards() + 1 ) == weaponAmount )
                {
                    var popUp = new PopUp( 1, PopUp.ALERT, _loc( "single_gasha_vault_gear_title" ), _loc( "single_gasha_vault_gear_message" ), null, _loc( "single_gasha_vault_ok_button" ) );
                    Xib.Navigation.removeModalOverlay();
                    Xib.Navigation.setModalOverlay( popUp );
                }
            }
        }
    }
    else
    {
        info("HelperFunctions cards in Limbo " + JSON.stringify(cardInstance) );
        if (cardInstance.inLimbo == true)
        {            
            if(cardInstance.type == PILOT)
            {
                fighterAmount = CardsManager.getFilteredPlayerCardsWithLimbo( { "type": 1 } ).length;
                if( ((fighterAmount - User.getMaxPilotCards()) > 0) && ((fighterAmount - User.getMaxPilotCards()) <= range) )
                {
                    var popUp = new PopUp( 1, PopUp.ALERT, _loc( "single_gasha_vault_pilot_title" ), _loc( "single_gasha_vault_pilot_message" ), null, _loc( "single_gasha_vault_ok_button" ) );
                    Xib.Navigation.removeModalOverlay();
                    Xib.Navigation.setModalOverlay( popUp );
                }
            }
            if(cardInstance.type == GEAR)
            {
                weaponAmount  = CardsManager.getFilteredPlayerCardsWithLimbo( { "type": 2 } ).length;
                if( ((weaponAmount - User.getMaxGearCards()) > 0) && ((weaponAmount - User.getMaxGearCards()) <= range) )
                {
                    var popUp = new PopUp( 1, PopUp.ALERT, _loc( "single_gasha_vault_gear_title" ), _loc( "single_gasha_vault_gear_message" ), null, _loc( "single_gasha_vault_ok_button" ) );
                    Xib.Navigation.removeModalOverlay();
                    Xib.Navigation.setModalOverlay( popUp );
                }
            }
        }
    }
};


var __dirname = 'Code';
var __filename = 'Code/Main.js';

/**
 * 
 * Import area, add every single class require here
 * 
 */

/*
 * Framework Classes
 */

var Core = require( 'NGCore/Client/Core' ).Core;
var Storage = require( 'NGCore/Client/Storage' ).Storage;
var Device = require( 'NGCore/Client/Device' ).Device;
var GL2 = require( 'NGCore/Client/GL2' ).GL2;
var UI = require( 'NGCore/Client/UI' ).UI;
var Audio = require( 'NGCore/Client/Audio' ).Audio;
var Network = require( 'NGCore/Client/Network' ).Network;
var Bank = require( 'NGCore/Client/Bank' ).Bank;
var Social = require( 'NGCore/Client/Social' ).Social;
var Analytics = require( 'NGCore/Client/Core/Analytics' ).Analytics;
var Capabilities = require( 'NGCore/Client/Core/Capabilities' ).Capabilities;
var OAuth = require( 'NGCore/Client/Plus/oauth' ).OAuth;
var Localization = require( 'NGCore/Client/Core/Localization' ).Localization;
var LocalizationEngine      = require( 'NGCore/Client/Core/Localization' ).LocalizationEngine;
var BaseClass = require( 'Code/Util/BaseClass' ).BaseClass;
var Prototypes = require( "Code/Util/Prototypes" ).Prototypes;
var DownloadFileSet = require( "Code/Network/DownloadFileSet" ).DownloadFileSet;
var Manifest = require( "Code/Network/DownloadFileSet" ).Manifest;
var NetworkManager = require( "Code/Network/NetworkManager" ).NetworkManager;
var IntroCutScene = require( 'Code/IntroCutScene' ).IntroCutScene;
/*
 * Action classes
 */
var Action = require( 'Code/Action' ).Action;
var IntervalAction = require( 'Code/Action/IntervalAction' ).IntervalAction;

/*
 * Animation classes
 */
var FightAnimation = require( 'Code/Animation/FightAnimation' ).FightAnimation;

/*
 * Banking classes
 */
var PaymentController = require( 'Code/Bank/PaymentController' ).PaymentController;
var ProductHandler = require( 'Code/Bank/ProductHandler' ).ProductHandler;

/*
 * Game classes
 */
var ScreenManager = require( "Code/Game/ScreenManager" ).ScreenManager;
var GameController = require( 'Code/Game/GameController' ).GameController;
var User = require( 'Code/Game/User' ).User;
var CardsManager = require( "Code/Game/CardsManager" ).CardsManager;
var SkillsManager = require( "Code/Game/SkillsManager" ).SkillsManager;
var DeckManager = require( 'Code/Game/DeckManager' ).DeckManager;
var SpecialCard = require( 'Code/Game/SpecialCard' ).SpecialCard;
var Background = require( 'Code/Game/Background' ).Background;
var QuestManager = require( "Code/Game/QuestManager" ).QuestManager;
var BattleManager = require( "Code/Game/BattleManager" ).BattleManager;
var DeckManager = require( "Code/Game/DeckManager" ).DeckManager;
var ItemManager = require( "Code/Game/ItemManager" ).ItemManager;
var GiftManager = require( "Code/Game/GiftManager" ).GiftManager;
var RewardManager = require( "Code/Game/RewardManager" ).RewardManager;
var GashaManager = require( "Code/Game/GashaManager" ).GashaManager;
var TimersController = require( "Code/Game/TimersController" ).TimersController;
var ItemPackManager = require( "Code/Game/ItemPackManager" ).ItemPackManager;

/*
 * Tutorial classes
 */
var TutorialManager = require( "Code/Tutorial/TutorialManager" ).TutorialManager;
var TutorialState = require( "Code/Tutorial/TutorialState" ).TutorialState;
var TutorialAction = require( "Code/Tutorial/TutorialAction" ).TutorialAction;
var TutorialExplanationAction = require( "Code/Tutorial/TutorialExplanationAction" ).TutorialExplanationAction;
var TutorialPictureAction = require( "Code/Tutorial/TutorialPictureAction" ).TutorialPictureAction;
var TutorialOpenScreenAction = require( "Code/Tutorial/TutorialOpenScreenAction" ).TutorialOpenScreenAction;

/*
 * Sound and Sprite Cache
 */
var SoundManager = require( 'Code/Sound/SoundManager' ).SoundManager;

var SpriteFactoryCache = require( 'Code/Sprite/SpriteFactoryCache' ).SpriteFactoryCache;
var LocalStorage = require( "Code/Storage/LocalStorage" ).LocalStorage;
var USRemoteStorage = require( "Code/Storage/USRemoteStorage" ).USRemoteStorage;

var SXHR = require( "Code/Network/SXHR" ).SXHR;
/*
 * ngCrunch
 */
var Xib = require( 'ngCrunch/Xib' ).Xib;
var JSON = require( 'ngCrunch/JSON' ).JSON;
var Loader = require( 'ngCrunch/Xib/Loader' ).Loader;

var Messenger = require( 'ngCrunch/BatchNetworkMessenger' ).BatchNetworkMessenger;
/*
 * Xib Utils
 */
var XibUI = require( "Code/Xib/XibUI" ).XibUI;
var ScrollableView = require( "Code/Xib/ScrollableView" ).ScrollableView;

var LabelConfigurer = require( 'Code/Util/LabelConfigurer' ).LabelConfigurer;

/*
 * UI
 */
var MainScreen = require( "Code/UI/MainScreen" ).MainScreen;
var SingleGasha = require( "Code/UI/SingleGasha" ).SingleGasha;
var MultiGasha = require( "Code/UI/MultiGasha" ).MultiGasha;
var HelpScreen = require( "Code/UI/HelpScreen" ).HelpScreen;
var LegalScreen = require( "Code/UI/LegalScreen" ).LegalScreen;
var GameInfoScreen = require( "Code/UI/GameInfoScreen" ).GameInfoScreen;
var Menu = require( "Code/UI/Menu" ).Menu;
var ControlRoom = require( "Code/UI/ControlRoom" ).ControlRoom;
var DeckManagerUI = require( "Code/UI/DeckManagerUI" ).DeckManagerUI;
var ItemDeckCategoryEdit = require( "Code/UI/ItemDeckCategoryEdit" ).ItemDeckCategoryEdit;
var DeckCategoryInfo = require( "Code/UI/DeckCategoryInfo" ).DeckCategoryInfo;
var CardCollectionUI = require( "Code/UI/CardCollectionUI" ).CardCollectionUI;
var TestScreen2 = require( "Code/UI/TestScreen2" ).TestScreen2;
var CardScreen = require( "Code/UI/CardScreen" ).CardScreen;
var CardScreenInstance = require( "Code/UI/CardScreenInstance" ).CardScreenInstance;
var CardScreenDefinition = require( "Code/UI/CardScreenDefinition" ).CardScreenDefinition;
var MissionSelectionScreen = require( "Code/UI/MissionSelectionScreen" ).MissionSelectionScreen;
var CardFusionMenu = require( "Code/UI/CardFusionMenu" ).CardFusionMenu;
var ItemStore = require( "Code/UI/ItemStore" ).ItemStore;
var ProgressBar = require( "Code/UI/ProgressBar" ).ProgressBar;
var DynamicList = require( "Code/UI/DynamicList" ).DynamicList;
var CardFusionAnimation = require( "Code/UI/CardFusionAnimation" ).CardFusionAnimation;
var CardFusionMenu = require( "Code/UI/CardFusionMenu" ).CardFusionMenu;
var CardFusionSelection = require( "Code/UI/CardFusionSelection" ).CardFusionSelection;
var CardFusionMaterialSelection = require( "Code/UI/CardFusionMaterialSelection" ).CardFusionMaterialSelection;
var CardFusionBaseSelection = require( "Code/UI/CardFusionBaseSelection" ).CardFusionBaseSelection;
var CardFusionCell = require( "Code/UI/CardFusionCell" ).CardFusionCell;
var CardFusionMaterialCell = require( "Code/UI/CardFusionMaterialCell" ).CardFusionMaterialCell;
var ComboBoxTable = require( "Code/UI/ComboBoxTable" ).ComboBoxTable;
var ComboBox = require( "Code/UI/ComboBox" ).ComboBox;
var LoadingScreen = require( "Code/UI/LoadingScreen" ).LoadingScreen;
var GashaStore = require( "Code/UI/GashaStore" ).GashaStore;
var ExplorationSelection = require( "Code/UI/ExplorationSelection" ).ExplorationSelection;
var ExplorationWorldUI = require( "Code/UI/ExplorationWorldUI" ).ExplorationWorldUI;
var ExplorationStageUI = require( "Code/UI/ExplorationStageUI" ).ExplorationStageUI;
var ExplorationScreenAnimated = require( "Code/UI/ExplorationScreenAnimated" ).ExplorationScreenAnimated;
var VersusBattleMain = require( "Code/UI/VersusBattleMain" ).VersusBattleMain;
var VersusBattleFight = require( "Code/UI/VersusBattleFight" ).VersusBattleFight;
var ExplorationProgressBar = require( "Code/UI/ExplorationProgressBar" ).ExplorationProgressBar;
var FightScene = require( "Code/UI/FightScene" ).FightScene;
var GashaResults = require( "Code/UI/GashaResults" ).GashaResults;
var LuckyChance = require( "Code/UI/LuckyChance" ).LuckyChance;
var WaitingScreen = require( "Code/UI/WaitingScreen" ).WaitingScreen;
var WaitingSprite = require( "Code/UI/WaitingSprite" ).WaitingSprite;
var FusionComplete = require( "Code/UI/FusionComplete" ).FusionComplete;
var NoEnergyScreen = require( "Code/UI/NoEnergyScreen" ).NoEnergyScreen;
var CardDisplay = require( "Code/UI/CardDisplay" ).CardDisplay;
var CardDisplayInstance = require( "Code/UI/CardDisplayInstance" ).CardDisplayInstance;
var CardDisplayDefinition = require( "Code/UI/CardDisplayDefinition" ).CardDisplayDefinition;
var TutorialLayerUI = require( "Code/UI/TutorialLayerUI" ).TutorialLayerUI;
var EnemyDeck = require( "Code/UI/EnemyDeck" ).EnemyDeck;
var PurchaseConfirmationScreen = require( "Code/UI/PurchaseConfirmationScreen" ).PurchaseConfirmationScreen;
var TutorialExplanationScreen = require( "Code/UI/TutorialExplanationScreen" ).TutorialExplanationScreen;
var TutorialPictureScreen = require( "Code/UI/TutorialPictureScreen" ).TutorialPictureScreen;
var SkillsDetails = require( "Code/UI/SkillsDetails" ).SkillsDetails;
var StarterPackConfirmation = require( "Code/UI/StarterPackConfirmation" ).StarterPackConfirmation;
var StarterPackSelection = require( "Code/UI/StarterPackSelection" ).StarterPackSelection;
var PopUp = require( "Code/UI/PopUp" ).PopUp;
var GiftStorage = require( "Code/UI/GiftStorage" ).GiftStorage;
var LevelUpAnimation = require( "Code/UI/LevelUpAnimation" ).LevelUpAnimation;
var RewardList = require( "Code/UI/RewardList" ).RewardList;
var RewardStage = require( "Code/UI/RewardStage" ).RewardStage;
var LevelUpLanding = require( "Code/UI/LevelUpLanding" ).LevelUpLanding;
var MissionFailedScreen = require( "Code/UI/MissionFailedScreen" ).MissionFailedScreen;
var SaleCardsScreen = require( "Code/UI/SaleCardsScreen" ).SaleCardsScreen;
var GashaCardDisplay = require( "Code/UI/GashaCardDisplay" ).GashaCardDisplay;
var BossLanding = require( "Code/UI/BossLanding" ).BossLanding;
var EnemyChanceLandingCredit = require( "Code/UI/EnemyChanceLandingCredit" ).EnemyChanceLandingCredit;
var EnemyChanceLandingCard = require( "Code/UI/EnemyChanceLandingCard" ).EnemyChanceLandingCard;
/*
 * Resources
 */
var ResourceManager = require( "Code/Resources/ResourceManager" ).ResourceManager;
var ManifestManager = require( "Code/Resources/ManifestManager" ).ManifestManager;
var DataLoader = require( "Code/Resources/DataLoader" ).DataLoader;

/*
 * External and utility classes
 */
var FPS = require( 'Code/Util/FPS' ).FPS;
var TouchTargetVisualizer = require( 'Code/Util/TouchTargetVisualizer' ).TouchTargetVisualizer;

/*
 * Game Server Communication
 */
var Server = require( "Code/Server/Server" ).Server;
var ErrorCodes = require( "Code/Server/Base/ErrorCodes" ).ErrorCodes;
var RemoteCall = require( "Code/Server/Base/RemoteCall" ).RemoteCall;
var RemoteObject = require( "Code/Server/Base/RemoteObject" ).RemoteObject;
var RemoteUser = require( "Code/Server/RemoteUser" ).RemoteUser;
var ServerSession = require( "Code/Server/ServerSession" ).ServerSession;
var RemoteCard = require( "Code/Server/RemoteCard" ).RemoteCard;
var RemoteDeck = require( "Code/Server/RemoteDeck" ).RemoteDeck;
var RemoteBattle = require( "Code/Server/RemoteBattle" ).RemoteBattle;
var RemoteGasha = require( "Code/Server/RemoteGasha" ).RemoteGasha;
var RemoteItem = require( "Code/Server/RemoteItem" ).RemoteItem;
var RemoteGift = require( "Code/Server/RemoteGift" ).RemoteGift;
var RemoteReward = require( "Code/Server/RemoteReward" ).RemoteReward;
var RemoteMission = require( "Code/Server/RemoteMission" ).RemoteMission;
var NgServer = require( "Code/Server/NgServer" ).NgServer;

/*
 * Global variables
 */
var SCREEN_WIDTH = 0;
var SCREEN_HEIGHT = 0;
var glViewInitialized = false;
var HUD_READY = false;
var INIT_FUNC_ARRAY = [];
var PLAYED_BEFORE = "PLAYED_BEFORE";
// FIXME: move it to globals
var screenClipRect = null;
var screenClipRectTop = null;
var screenClipRectFoot = null;

// debugging options. In released apps, will always be empty.
debugSettings =
{};

// FIXME: HARDCODED
var backButtonHard;

/*
 * Main function
 */
function main()
{
    info( "Main.main called." );
    
     LocalizationEngine.prototype.setLanguage = function()
        {           
            console.log("SET LANGUAGE ERASED");
        };
    

    ManifestManager.loadManifestSet( "ManifestSetSD.json", function()
    {
        ManifestManager.startLoadRemoteManifestSet();
    }.bind( this ) );

    // Localization.setLanguage( "de" );

    // Set the tickRate (application's expected frames per second)
    // Core.UpdateEmitter.setTickRate(1.0/60.0);

    // Layout changer code section (By default set to Portrait)
    if( Device.OrientationEmitter.getInterfaceOrientation() != Device.OrientationEmitter.Orientation.Portrait || Core.Capabilities.getPlatformOS() == "Android" )
    {
        new LayoutListener();
        Device.OrientationEmitter.setInterfaceOrientation( Device.OrientationEmitter.Orientation.Portrait );
    }
    else
    {
        makeView();
    }

    // if( Core.Capabilities.getPlatformOS() == "flash" )
    // {
    // Device.OrientationEmitter.setInterfaceOrientation( Device.OrientationEmitter.Orientation.Portrait );
    // makeView();
    // }
    // else
    // {
    // new LayoutListener(); // FIXME Why this variable is not used ?
    // Device.OrientationEmitter.setInterfaceOrientation( Device.OrientationEmitter.Orientation.Portrait );
    // }

    // Instance for FPS-meter
    FPS.instantiate();
    FPS.setDoNodeIntacesProfiling( true );

    // Uncomment this line if you want to see node's touch-targets
    // TouchTargetVisualizer.show();
}

/*
 * Layout changer code
 */
var LayoutListener = Core.MessageListener.subclass(
{
    initialize: function()
    {
        info( "Main.LayoutListener.initialize called." );
        Device.LayoutEmitter.addListener( this, this.onUpdate, -1 );
    },

    onUpdate: function( layout )
    {
        info( "Main.LayoutListener.onUpdate called." );
        UI.Window._width = layout.width;
        UI.Window._height = layout.height;
        if( !glViewInitialized && UI.Window._width < UI.Window._height )
        {
            // Now all is ready to start the game
            info( "Main.LayoutListener.onUpdate Main. Now all is ready to start the game" );
            makeView();
            glViewInitialized = true;
        }
    }
} );

/*
 * Once the layout is set, the GL2.View is created
 */
var makeView = function()
{
    this.glView = new UI.GLView();
    this.glView.setAttribute( 'frame', [ 0, 0, UI.Window._width, UI.Window._height ] );
    this.glView.onload = function()
    {
        info( "Main.makeView.onload called." );
        startGame();
    };

    var self = this;
    // var intro = new IntroCutScene( "./Content/Video/intro_coalition.mp4", function()
    // {
    LocalStorage.read( function( error, data )
    {
        info( "Main.makeView.LocalStorage.read: error->" + JSON.stringify( error[PLAYED_BEFORE] ) + ", data->" + JSON.stringify( data[PLAYED_BEFORE] ) );

        if( data[PLAYED_BEFORE] != true )
        {
            var intro2 = new IntroCutScene( "./Content/Video/intro.mp4", function()
            {
                self.glView.setActive( true );
            } );
            intro2.play();
        }
        else
        {
            self.glView.setActive( true );
        }
    }, [ PLAYED_BEFORE ] );
    // } );
    // intro.play();
};

/*
 * Now all is ready to run the game
 */
var background = null;
var background2 = null;
var background3 = null;
var startGame = function()
{
    info( "START GAME" );

    var dict =
    {};
    dict[PLAYED_BEFORE] = true;
    LocalStorage.write( dict, function( error )
    {
        info( "Main.startGame.LocalStorage.write: " + JSON.stringify( dict ) );
    } );

    // Global vars with screen WIDTH and HEIGHT
    SCREEN_WIDTH = UI.Window._width;
    SCREEN_HEIGHT = UI.Window._height;

    try
    {
        gApplicationDebugging = new ApplicationDebugging();
        // gApplicationDebugging.showDebugUI();
    }
    catch( ex )
    {
        console.log( "**************** PROFILING DISABLED ****************" );
    }

    /*
     * var reloadButton = new UI.Button();
     * 
     * reloadButton.setText("r");
     * 
     * reloadButton.setOnClick(function() { console.log('reloading');
     * 
     * Core.LocalGameList.runUpdatedGame('/Apps/gasha'); });
     * 
     * reloadButton.setFrame([0,0,30,30]);
     * 
     * reloadButton.setBackgroundColor('FFFFFFFF');
     * 
     * reloadButton.setTextColor('FFFF0000', UI.Commands.State.Pressed);
     * 
     * UI.Window.document.addChild(reloadButton);
     */
    // set background image
    background = new GL2.Sprite();

    background.setImage( "./Content/Textures/loadingBackground.jpg", [ SCREEN_WIDTH, SCREEN_HEIGHT ], [ 0, 0 ], [ 0, 0, 1, 1 ] );
    GL2.Root.addChild( background );

    addXibFilesToCache();
    Xib.Navigation.instantiate();
    Prototypes.setupXibPrototypes();
    NetworkManager.ngCrunchReady();

    HUD_READY = true;
    var i;
    var length = INIT_FUNC_ARRAY.length;

    for( i = 0; i < length; i++ )
    {
        var func = INIT_FUNC_ARRAY[i];
        func();
    }
};

var addXibFilesToCache = function()
{
    info( "Main.addXibFilesToCache called." );

    // Only load the Xibs that we need at this step
    Loader.addXibToCache( "./Content/Xib/LoadingScreen.xib" );
    Loader.addXibToCache( "./Content/Xib/Menu.xib" );
    Loader.addXibToCache( "./Content/Xib/ProgressBar.xib" );
    Loader.addXibToCache( "./Content/Xib/ProgressBarLoadingScreen.xib" );
    Loader.addXibToCache( "./Content/Xib/WaitingScreen.xib" );
};


var __dirname = 'Code';
var __filename = 'Code/Globals.js';

var Globals =
{

};

var __dirname = 'Code/Util';
var __filename = 'Code/Util/Debugging.js';

/**
 * Creates a trace message
 * @param {String} message - Message
 */


function info( /*String*/message )
{
    if( TRACE_LEVEL > 2 )
    {
        arguments[0] = '|' + SVN_REVISION + '|INFO|' + arguments[0];
        console.log.apply( console, arguments );
    }
}

function warn( /*String*/message )
{
    if( TRACE_LEVEL > 1 )
    {
        arguments[0] = '|' + SVN_REVISION + '|WARN|' + arguments[0];

        if( DEV_DEBUG_WARN )
        {
            var dialog = new UI.AlertDialog();
            dialog.setTitle( "WARNING" );
            dialog.setText( JSON.stringify( arguments ) );
            dialog.setChoices( [('OK')] );
            dialog.show();
        }

        console.log.apply( console, arguments );
    }
}

function err( /*String*/message )
{
    if( TRACE_LEVEL > 0 )
    {
        arguments[0] = '|' + SVN_REVISION + '|ERR |' + arguments[0];

        if( DEV_DEBUG_ERR )
        {
            var dialog = new UI.AlertDialog();
            dialog.setTitle( "ERROR" );
            dialog.setText( JSON.stringify( arguments ) );
            dialog.setChoices( [('OK')] );
            dialog.show();
        }

        console.log.apply( console, arguments );
    }
}


var __dirname = 'Code/Resources';
var __filename = 'Code/Resources/SpriteSheetsDefinitions.js';

var spritesheetsDefinitions = [

{
    "frames":
    {

        "battle_button_fight.png":
        {
            "frame":
            {
                "x": 606,
                "y": 408,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "battle_button_search.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "battle_energy_empty.png":
        {
            "frame":
            {
                "x": 924,
                "y": 2,
                "w": 68,
                "h": 16
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 68,
                "h": 16
            },
            "sourceSize":
            {
                "w": 68,
                "h": 16
            }
        },
        "battle_energy_fill.png":
        {
            "frame":
            {
                "x": 854,
                "y": 2,
                "w": 68,
                "h": 16
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 68,
                "h": 16
            },
            "sourceSize":
            {
                "w": 68,
                "h": 16
            }
        },
        "battle_oponents_title.png":
        {
            "frame":
            {
                "x": 2,
                "y": 646,
                "w": 514,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 514,
                "h": 68
            },
            "sourceSize":
            {
                "w": 514,
                "h": 68
            }
        },
        "battle_profile_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 408,
                "w": 602,
                "h": 236
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 236
            },
            "sourceSize":
            {
                "w": 602,
                "h": 236
            }
        },
        "battle_profile_oponent.png":
        {
            "frame":
            {
                "x": 2,
                "y": 148,
                "w": 620,
                "h": 258
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 620,
                "h": 258
            },
            "sourceSize":
            {
                "w": 620,
                "h": 258
            }
        },
        "battle_search_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 144
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 144
            },
            "sourceSize":
            {
                "w": 640,
                "h": 144
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_battle_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:b998dc21e4e564f3eabfc62df6cb212b$"
    }
}

,
{
    "frames":
    {

        "bfight_button_enemy_deck.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "bfight_button_mydeck.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "bfight_defeated_image.png":
        {
            "frame":
            {
                "x": 2,
                "y": 694,
                "w": 598,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 598,
                "h": 104
            },
            "sourceSize":
            {
                "w": 598,
                "h": 104
            }
        },
        "bfight_enemy_deck_name.png":
        {
            "frame":
            {
                "x": 2,
                "y": 906,
                "w": 602,
                "h": 58
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 58
            },
            "sourceSize":
            {
                "w": 602,
                "h": 58
            }
        },
        "bfight_enemy_display.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 574
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 574
            },
            "sourceSize":
            {
                "w": 640,
                "h": 574
            }
        },
        "bfight_energy_empty.png":
        {
            "frame":
            {
                "x": 924,
                "y": 2,
                "w": 68,
                "h": 16
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 68,
                "h": 16
            },
            "sourceSize":
            {
                "w": 68,
                "h": 16
            }
        },
        "bfight_energy_fill.png":
        {
            "frame":
            {
                "x": 854,
                "y": 2,
                "w": 68,
                "h": 16
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 68,
                "h": 16
            },
            "sourceSize":
            {
                "w": 68,
                "h": 16
            }
        },
        "bfight_fight.png":
        {
            "frame":
            {
                "x": 606,
                "y": 578,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "bfight_player_info.png":
        {
            "frame":
            {
                "x": 2,
                "y": 578,
                "w": 602,
                "h": 114
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 114
            },
            "sourceSize":
            {
                "w": 602,
                "h": 114
            }
        },
        "bfight_store_icon.png":
        {
            "frame":
            {
                "x": 854,
                "y": 20,
                "w": 46,
                "h": 38
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 46,
                "h": 38
            },
            "sourceSize":
            {
                "w": 46,
                "h": 38
            }
        },
        "bfight_victory_image.png":
        {
            "frame":
            {
                "x": 2,
                "y": 800,
                "w": 598,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 598,
                "h": 104
            },
            "sourceSize":
            {
                "w": 598,
                "h": 104
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_bfight_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:5cbf4829a16997f1fb0ebf9d3e63f3ad$"
    }
}

,

{
    "frames":
    {

        "cbox_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 776
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 776
            },
            "sourceSize":
            {
                "w": 640,
                "h": 776
            }
        },
        "cbox_button_selected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 986,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "cbox_button_unselected.png":
        {
            "frame":
            {
                "x": 66,
                "y": 986,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "cbox_footer.png":
        {
            "frame":
            {
                "x": 2,
                "y": 940,
                "w": 640,
                "h": 44
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 44
            },
            "sourceSize":
            {
                "w": 640,
                "h": 44
            }
        },
        "cbox_header.png":
        {
            "frame":
            {
                "x": 130,
                "y": 986,
                "w": 640,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 30
            },
            "sourceSize":
            {
                "w": 640,
                "h": 30
            }
        },
        "cbox_selected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 860,
                "w": 640,
                "h": 78
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 78
            },
            "sourceSize":
            {
                "w": 640,
                "h": 78
            }
        },
        "cbox_unselected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 780,
                "w": 640,
                "h": 78
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 78
            },
            "sourceSize":
            {
                "w": 640,
                "h": 78
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_cbox_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:1fb9988e0095229d7ff24c4afe7cf26a$"
    }
}

,

{
    "frames":
    {

        "ccollection_button_event.png":
        {
            "frame":
            {
                "x": 644,
                "y": 148,
                "w": 218,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 218,
                "h": 56
            },
            "sourceSize":
            {
                "w": 218,
                "h": 56
            }
        },
        "ccollection_cards_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 504
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 504
            },
            "sourceSize":
            {
                "w": 640,
                "h": 504
            }
        },
        "ccollection_info_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 598,
                "w": 602,
                "h": 85
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 85
            },
            "sourceSize":
            {
                "w": 602,
                "h": 85
            }
        },
        "ccollection_left_arrow.png":
        {
            "frame":
            {
                "x": 864,
                "y": 162,
                "w": 84,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 84,
                "h": 46
            },
            "sourceSize":
            {
                "w": 84,
                "h": 46
            }
        },
        "ccollection_right_arrow.png":
        {
            "frame":
            {
                "x": 922,
                "y": 114,
                "w": 84,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 84,
                "h": 46
            },
            "sourceSize":
            {
                "w": 84,
                "h": 46
            }
        },
        "ccollection_sort_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 508,
                "w": 602,
                "h": 88
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 88
            },
            "sourceSize":
            {
                "w": 602,
                "h": 88
            }
        },
        "ccollection_sort_button_selected.png":
        {
            "frame":
            {
                "x": 940,
                "y": 36,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "ccollection_sort_button_unselected.png":
        {
            "frame":
            {
                "x": 940,
                "y": 2,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "ccollection_sort_container.png":
        {
            "frame":
            {
                "x": 644,
                "y": 114,
                "w": 276,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 276,
                "h": 32
            },
            "sourceSize":
            {
                "w": 276,
                "h": 32
            }
        },
        "ccollection_tab_selected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 58,
                "w": 294,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 54
            },
            "sourceSize":
            {
                "w": 294,
                "h": 54
            }
        },
        "ccollection_tab_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 294,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 54
            },
            "sourceSize":
            {
                "w": 294,
                "h": 54
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_ccollection_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:d882d71af98612ef75b19b35d408cd64$"
    }
}

,

{
    "frames":
    {

        "cdetail_buttons_detail_box.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 182,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 182,
                "h": 68
            },
            "sourceSize":
            {
                "w": 182,
                "h": 68
            }
        },
        "cdetail_detail_bar.png":
        {
            "frame":
            {
                "x": 2,
                "y": 328,
                "w": 640,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 68
            },
            "sourceSize":
            {
                "w": 640,
                "h": 68
            }
        },
        "cdetail_detail_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 324
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 324
            },
            "sourceSize":
            {
                "w": 640,
                "h": 324
            }
        },
        "cdetail_detail_icon.png":
        {
            "frame":
            {
                "x": 918,
                "y": 46,
                "w": 36,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 36,
                "h": 46
            },
            "sourceSize":
            {
                "w": 36,
                "h": 46
            }
        },
        "cdetail_name_card_box.png":
        {
            "frame":
            {
                "x": 2,
                "y": 398,
                "w": 418,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 418,
                "h": 68
            },
            "sourceSize":
            {
                "w": 418,
                "h": 68
            }
        },
        "cdetail_next_arrow_selected.png":
        {
            "frame":
            {
                "x": 988,
                "y": 46,
                "w": 30,
                "h": 106
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 106
            },
            "sourceSize":
            {
                "w": 30,
                "h": 106
            }
        },
        "cdetail_next_arrow_unselected.png":
        {
            "frame":
            {
                "x": 956,
                "y": 46,
                "w": 30,
                "h": 106
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 106
            },
            "sourceSize":
            {
                "w": 30,
                "h": 106
            }
        },
        "cdetail_previous_arrow_selected.png":
        {
            "frame":
            {
                "x": 676,
                "y": 72,
                "w": 30,
                "h": 106
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 106
            },
            "sourceSize":
            {
                "w": 30,
                "h": 106
            }
        },
        "cdetail_previous_arrow_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 72,
                "w": 30,
                "h": 106
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 106
            },
            "sourceSize":
            {
                "w": 30,
                "h": 106
            }
        },
        "cdetail_zoomin_icon.png":
        {
            "frame":
            {
                "x": 918,
                "y": 2,
                "w": 42,
                "h": 42
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 42,
                "h": 42
            },
            "sourceSize":
            {
                "w": 42,
                "h": 42
            }
        },
        "cdetail_zoomout_box.png":
        {
            "frame":
            {
                "x": 828,
                "y": 2,
                "w": 88,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 88,
                "h": 68
            },
            "sourceSize":
            {
                "w": 88,
                "h": 68
            }
        },
        "cdetail_zoomout_icon.png":
        {
            "frame":
            {
                "x": 962,
                "y": 2,
                "w": 42,
                "h": 42
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 42,
                "h": 42
            },
            "sourceSize":
            {
                "w": 42,
                "h": 42
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_cdetail_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:4e0f3e6e74468502d500d39f8f4a11a2$"
    }
}

,

{
    "frames":
    {

        "croom_banner_frame.png":
        {
            "frame":
            {
                "x": 2,
                "y": 171,
                "w": 616,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 616,
                "h": 108
            },
            "sourceSize":
            {
                "w": 616,
                "h": 108
            }
        },
        "croom_button_battle.png":
        {
            "frame":
            {
                "x": 2,
                "y": 695,
                "w": 602,
                "h": 170
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 170
            },
            "sourceSize":
            {
                "w": 602,
                "h": 170
            }
        },
        "croom_button_big.png":
        {
            "frame":
            {
                "x": 606,
                "y": 281,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "croom_button_explore.png":
        {
            "frame":
            {
                "x": 2,
                "y": 523,
                "w": 602,
                "h": 170
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 170
            },
            "sourceSize":
            {
                "w": 602,
                "h": 170
            }
        },
        "croom_button_gift.png":
        {
            "frame":
            {
                "x": 620,
                "y": 194,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "croom_button_medalgasha.png":
        {
            "frame":
            {
                "x": 624,
                "y": 130,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "croom_button_rewards.png":
        {
            "frame":
            {
                "x": 644,
                "y": 66,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "croom_energy_empty.png":
        {
            "frame":
            {
                "x": 914,
                "y": 222,
                "w": 108,
                "h": 26
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 26
            },
            "sourceSize":
            {
                "w": 108,
                "h": 26
            }
        },
        "croom_energy_fill.png":
        {
            "frame":
            {
                "x": 914,
                "y": 194,
                "w": 108,
                "h": 26
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 26
            },
            "sourceSize":
            {
                "w": 108,
                "h": 26
            }
        },
        "croom_freegasha.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "croom_notif_background.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 119
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 119
            },
            "sourceSize":
            {
                "w": 640,
                "h": 119
            }
        },
        "croom_notification.png":
        {
            "frame":
            {
                "x": 2,
                "y": 123,
                "w": 620,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 620,
                "h": 46
            },
            "sourceSize":
            {
                "w": 620,
                "h": 46
            }
        },
        "croom_profile_frame.png":
        {
            "frame":
            {
                "x": 2,
                "y": 281,
                "w": 602,
                "h": 240
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 240
            },
            "sourceSize":
            {
                "w": 602,
                "h": 240
            }
        },
        "croom_social_notification.png":
        {
            "frame":
            {
                "x": 2,
                "y": 867,
                "w": 594,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 594,
                "h": 62
            },
            "sourceSize":
            {
                "w": 594,
                "h": 62
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_croom_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:dee72e59a6ca47321441a2a35c589d24$"
    }
}

,

{
    "frames":
    {

        "deck_button_autoselect.png":
        {
            "frame":
            {
                "x": 606,
                "y": 332,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "deck_button_edit.png":
        {
            "frame":
            {
                "x": 792,
                "y": 520,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "deck_button_rec.png":
        {
            "frame":
            {
                "x": 606,
                "y": 274,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "deck_button_recom_confirm.png":
        {
            "frame":
            {
                "x": 624,
                "y": 82,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "deck_button_replacement.png":
        {
            "frame":
            {
                "x": 624,
                "y": 210,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "deck_button_reset.png":
        {
            "frame":
            {
                "x": 624,
                "y": 146,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "deck_button_skills.png":
        {
            "frame":
            {
                "x": 2,
                "y": 978,
                "w": 72,
                "h": 22
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 72,
                "h": 22
            },
            "sourceSize":
            {
                "w": 72,
                "h": 22
            }
        },
        "deck_button_tab_selected.png":
        {
            "frame":
            {
                "x": 346,
                "y": 618,
                "w": 156,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 156,
                "h": 56
            },
            "sourceSize":
            {
                "w": 156,
                "h": 56
            }
        },
        "deck_button_tab_unselected.png":
        {
            "frame":
            {
                "x": 188,
                "y": 618,
                "w": 156,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 156,
                "h": 56
            },
            "sourceSize":
            {
                "w": 156,
                "h": 56
            }
        },
        "deck_card_info.png":
        {
            "frame":
            {
                "x": 340,
                "y": 702,
                "w": 150,
                "h": 310
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 310
            },
            "sourceSize":
            {
                "w": 150,
                "h": 310
            }
        },
        "deck_card_info_selected.png":
        {
            "frame":
            {
                "x": 188,
                "y": 702,
                "w": 150,
                "h": 310
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 310
            },
            "sourceSize":
            {
                "w": 150,
                "h": 310
            }
        },
        "deck_card_off.png":
        {
            "frame":
            {
                "x": 918,
                "y": 222,
                "w": 50,
                "h": 28
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 50,
                "h": 28
            },
            "sourceSize":
            {
                "w": 50,
                "h": 28
            }
        },
        "deck_card_on.png":
        {
            "frame":
            {
                "x": 960,
                "y": 70,
                "w": 50,
                "h": 28
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 50,
                "h": 28
            },
            "sourceSize":
            {
                "w": 50,
                "h": 28
            }
        },
        "deck_cards_selection.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 620,
                "h": 240
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 620,
                "h": 240
            },
            "sourceSize":
            {
                "w": 620,
                "h": 240
            }
        },
        "deck_categories_container.png":
        {
            "frame":
            {
                "x": 918,
                "y": 100,
                "w": 104,
                "h": 120
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 120
            },
            "sourceSize":
            {
                "w": 104,
                "h": 120
            }
        },
        "deck_column_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 396,
                "w": 184,
                "h": 580
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 184,
                "h": 580
            },
            "sourceSize":
            {
                "w": 184,
                "h": 580
            }
        },
        "deck_left_arrow_selected.png":
        {
            "frame":
            {
                "x": 732,
                "y": 856,
                "w": 30,
                "h": 94
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 94
            },
            "sourceSize":
            {
                "w": 30,
                "h": 94
            }
        },
        "deck_left_arrow_unselected.png":
        {
            "frame":
            {
                "x": 856,
                "y": 396,
                "w": 30,
                "h": 94
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 94
            },
            "sourceSize":
            {
                "w": 30,
                "h": 94
            }
        },
        "deck_names_main.png":
        {
            "frame":
            {
                "x": 188,
                "y": 548,
                "w": 510,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 510,
                "h": 68
            },
            "sourceSize":
            {
                "w": 510,
                "h": 68
            }
        },
        "deck_number_1.png":
        {
            "frame":
            {
                "x": 656,
                "y": 618,
                "w": 34,
                "h": 152
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 34,
                "h": 152
            },
            "sourceSize":
            {
                "w": 34,
                "h": 152
            }
        },
        "deck_number_2.png":
        {
            "frame":
            {
                "x": 736,
                "y": 548,
                "w": 34,
                "h": 152
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 34,
                "h": 152
            },
            "sourceSize":
            {
                "w": 34,
                "h": 152
            }
        },
        "deck_number_3.png":
        {
            "frame":
            {
                "x": 700,
                "y": 548,
                "w": 34,
                "h": 152
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 34,
                "h": 152
            },
            "sourceSize":
            {
                "w": 34,
                "h": 152
            }
        },
        "deck_number_tag.png":
        {
            "frame":
            {
                "x": 732,
                "y": 702,
                "w": 34,
                "h": 152
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 34,
                "h": 152
            },
            "sourceSize":
            {
                "w": 34,
                "h": 152
            }
        },
        "deck_position_1.png":
        {
            "frame":
            {
                "x": 612,
                "y": 790,
                "w": 118,
                "h": 186
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 118,
                "h": 186
            },
            "sourceSize":
            {
                "w": 118,
                "h": 186
            }
        },
        "deck_position_2.png":
        {
            "frame":
            {
                "x": 492,
                "y": 790,
                "w": 118,
                "h": 186
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 118,
                "h": 186
            },
            "sourceSize":
            {
                "w": 118,
                "h": 186
            }
        },
        "deck_position_3.png":
        {
            "frame":
            {
                "x": 900,
                "y": 332,
                "w": 118,
                "h": 186
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 118,
                "h": 186
            },
            "sourceSize":
            {
                "w": 118,
                "h": 186
            }
        },
        "deck_right_arrow_selected.png":
        {
            "frame":
            {
                "x": 824,
                "y": 396,
                "w": 30,
                "h": 94
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 94
            },
            "sourceSize":
            {
                "w": 30,
                "h": 94
            }
        },
        "deck_right_arrow_unselected.png":
        {
            "frame":
            {
                "x": 792,
                "y": 396,
                "w": 30,
                "h": 94
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 30,
                "h": 94
            },
            "sourceSize":
            {
                "w": 30,
                "h": 94
            }
        },
        "deck_skillbox_active.png":
        {
            "frame":
            {
                "x": 188,
                "y": 396,
                "w": 602,
                "h": 150
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 150
            },
            "sourceSize":
            {
                "w": 602,
                "h": 150
            }
        },
        "deck_skillbox_inactive.png":
        {
            "frame":
            {
                "x": 2,
                "y": 244,
                "w": 602,
                "h": 150
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 150
            },
            "sourceSize":
            {
                "w": 602,
                "h": 150
            }
        },
        "deck_skills_container.png":
        {
            "frame":
            {
                "x": 504,
                "y": 618,
                "w": 150,
                "h": 170
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 170
            },
            "sourceSize":
            {
                "w": 150,
                "h": 170
            }
        },
        "deck_sort_button_selected.png":
        {
            "frame":
            {
                "x": 960,
                "y": 36,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "deck_sort_button_unselected.png":
        {
            "frame":
            {
                "x": 960,
                "y": 2,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "deck_total.png":
        {
            "frame":
            {
                "x": 624,
                "y": 2,
                "w": 334,
                "h": 78
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 334,
                "h": 78
            },
            "sourceSize":
            {
                "w": 334,
                "h": 78
            }
        },
        "pixels_bar.png":
        {
            "frame":
            {
                "x": 1012,
                "y": 70,
                "w": 4,
                "h": 4
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 4,
                "h": 4
            },
            "sourceSize":
            {
                "w": 4,
                "h": 4
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_deck_management_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:28ced0e4388e55df136a6a80cfe0d045$"
    }
}

,

{
    "frames":
    {

        "fusion_big_tab_selected.png":
        {
            "frame":
            {
                "x": 624,
                "y": 118,
                "w": 294,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 56
            },
            "sourceSize":
            {
                "w": 294,
                "h": 56
            }
        },
        "fusion_big_tab_unselected.png":
        {
            "frame":
            {
                "x": 624,
                "y": 60,
                "w": 294,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 56
            },
            "sourceSize":
            {
                "w": 294,
                "h": 56
            }
        },
        "fusion_border_left.png":
        {
            "frame":
            {
                "x": 970,
                "y": 170,
                "w": 10,
                "h": 168
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 10,
                "h": 168
            },
            "sourceSize":
            {
                "w": 10,
                "h": 168
            }
        },
        "fusion_border_right.png":
        {
            "frame":
            {
                "x": 984,
                "y": 156,
                "w": 10,
                "h": 168
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 10,
                "h": 168
            },
            "sourceSize":
            {
                "w": 10,
                "h": 168
            }
        },
        "fusion_button_card_detail.png":
        {
            "frame":
            {
                "x": 816,
                "y": 640,
                "w": 132,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 132,
                "h": 30
            },
            "sourceSize":
            {
                "w": 132,
                "h": 30
            }
        },
        "fusion_button_clear.png":
        {
            "frame":
            {
                "x": 606,
                "y": 600,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "fusion_button_fusion.png":
        {
            "frame":
            {
                "x": 606,
                "y": 552,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "fusion_button_fusion_2.png":
        {
            "frame":
            {
                "x": 624,
                "y": 256,
                "w": 246,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 246,
                "h": 46
            },
            "sourceSize":
            {
                "w": 246,
                "h": 46
            }
        },
        "fusion_button_fusion_3.png":
        {
            "frame":
            {
                "x": 606,
                "y": 398,
                "w": 220,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 220,
                "h": 56
            },
            "sourceSize":
            {
                "w": 220,
                "h": 56
            }
        },
        "fusion_button_locked.png":
        {
            "frame":
            {
                "x": 116,
                "y": 850,
                "w": 112,
                "h": 128
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 128
            },
            "sourceSize":
            {
                "w": 112,
                "h": 128
            }
        },
        "fusion_button_pickcard.png":
        {
            "frame":
            {
                "x": 230,
                "y": 850,
                "w": 104,
                "h": 116
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 116
            },
            "sourceSize":
            {
                "w": 104,
                "h": 116
            }
        },
        "fusion_button_selected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 850,
                "w": 112,
                "h": 128
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 128
            },
            "sourceSize":
            {
                "w": 112,
                "h": 128
            }
        },
        "fusion_button_unselected.png":
        {
            "frame":
            {
                "x": 606,
                "y": 648,
                "w": 112,
                "h": 128
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 128
            },
            "sourceSize":
            {
                "w": 112,
                "h": 128
            }
        },
        "fusion_card_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 516,
                "w": 602,
                "h": 194
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 194
            },
            "sourceSize":
            {
                "w": 602,
                "h": 194
            }
        },
        "fusion_card_container_nolvl.png":
        {
            "frame":
            {
                "x": 2,
                "y": 304,
                "w": 602,
                "h": 210
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 210
            },
            "sourceSize":
            {
                "w": 602,
                "h": 210
            }
        },
        "fusion_card_display.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 620,
                "h": 300
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 620,
                "h": 300
            },
            "sourceSize":
            {
                "w": 620,
                "h": 300
            }
        },
        "fusion_cardlvl_box.png":
        {
            "frame":
            {
                "x": 828,
                "y": 398,
                "w": 186,
                "h": 70
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 186,
                "h": 70
            },
            "sourceSize":
            {
                "w": 186,
                "h": 70
            }
        },
        "fusion_cbox_big_text.png":
        {
            "frame":
            {
                "x": 624,
                "y": 222,
                "w": 276,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 276,
                "h": 32
            },
            "sourceSize":
            {
                "w": 276,
                "h": 32
            }
        },
        "fusion_cbox_text.png":
        {
            "frame":
            {
                "x": 807,
                "y": 304,
                "w": 128,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 128,
                "h": 32
            },
            "sourceSize":
            {
                "w": 128,
                "h": 32
            }
        },
        "fusion_large_button.png":
        {
            "frame":
            {
                "x": 336,
                "y": 850,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "fusion_line.png":
        {
            "frame":
            {
                "x": 2,
                "y": 1014,
                "w": 422,
                "h": 2
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 422,
                "h": 2
            },
            "sourceSize":
            {
                "w": 422,
                "h": 2
            }
        },
        "fusion_material_tab_selected.png":
        {
            "frame":
            {
                "x": 624,
                "y": 118,
                "w": 294,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 56
            },
            "sourceSize":
            {
                "w": 294,
                "h": 56
            }
        },
        "fusion_material_tab_unselected.png":
        {
            "frame":
            {
                "x": 624,
                "y": 2,
                "w": 294,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 56
            },
            "sourceSize":
            {
                "w": 294,
                "h": 56
            }
        },
        "fusion_medal_number.png":
        {
            "frame":
            {
                "x": 816,
                "y": 610,
                "w": 150,
                "h": 28
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 28
            },
            "sourceSize":
            {
                "w": 150,
                "h": 28
            }
        },
        "fusion_numbertag_card.png":
        {
            "frame":
            {
                "x": 920,
                "y": 170,
                "w": 48,
                "h": 26
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 48,
                "h": 26
            },
            "sourceSize":
            {
                "w": 48,
                "h": 26
            }
        },
        "fusion_other_card_title.png":
        {
            "frame":
            {
                "x": 624,
                "y": 176,
                "w": 290,
                "h": 44
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 290,
                "h": 44
            },
            "sourceSize":
            {
                "w": 290,
                "h": 44
            }
        },
        "fusion_pager_arrow_left.png":
        {
            "frame":
            {
                "x": 606,
                "y": 504,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "fusion_pager_arrow_right.png":
        {
            "frame":
            {
                "x": 606,
                "y": 456,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "fusion_rarity_box.png":
        {
            "frame":
            {
                "x": 920,
                "y": 2,
                "w": 98,
                "h": 98
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 98,
                "h": 98
            },
            "sourceSize":
            {
                "w": 98,
                "h": 98
            }
        },
        "fusion_small_button.png":
        {
            "frame":
            {
                "x": 606,
                "y": 340,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "fusion_small_tab_selected.png":
        {
            "frame":
            {
                "x": 816,
                "y": 554,
                "w": 156,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 156,
                "h": 54
            },
            "sourceSize":
            {
                "w": 156,
                "h": 54
            }
        },
        "fusion_small_tab_unselected.png":
        {
            "frame":
            {
                "x": 816,
                "y": 498,
                "w": 156,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 156,
                "h": 54
            },
            "sourceSize":
            {
                "w": 156,
                "h": 54
            }
        },
        "fusion_sort_box.png":
        {
            "frame":
            {
                "x": 2,
                "y": 712,
                "w": 602,
                "h": 136
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 136
            },
            "sourceSize":
            {
                "w": 602,
                "h": 136
            }
        },
        "fusion_sort_box_big.png":
        {
            "frame":
            {
                "x": 2,
                "y": 980,
                "w": 578,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 578,
                "h": 32
            },
            "sourceSize":
            {
                "w": 578,
                "h": 32
            }
        },
        "fusion_sort_button_selected.png":
        {
            "frame":
            {
                "x": 920,
                "y": 136,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "fusion_sort_button_unselected.png":
        {
            "frame":
            {
                "x": 920,
                "y": 102,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "fusion_tag_recom_big.png":
        {
            "frame":
            {
                "x": 606,
                "y": 304,
                "w": 199,
                "h": 33
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 199,
                "h": 33
            },
            "sourceSize":
            {
                "w": 199,
                "h": 33
            }
        },
        "fusion_tag_recom_card.png":
        {
            "frame":
            {
                "x": 816,
                "y": 470,
                "w": 185,
                "h": 26
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 185,
                "h": 26
            },
            "sourceSize":
            {
                "w": 185,
                "h": 26
            }
        },
        "fusion_touch_icon.png":
        {
            "frame":
            {
                "x": 984,
                "y": 102,
                "w": 34,
                "h": 52
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 34,
                "h": 52
            },
            "sourceSize":
            {
                "w": 34,
                "h": 52
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_fusion_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:8b38f3987d9b9c276d68926e2ad1275b$"
    }
}

,

{
    "frames":
    {

        "fusion_landing_button.png":
        {
            "frame":
            {
                "x": 204,
                "y": 852,
                "w": 528,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 528,
                "h": 46
            },
            "sourceSize":
            {
                "w": 528,
                "h": 46
            }
        },
        "fusion_landing_frame_card.png":
        {
            "frame":
            {
                "x": 2,
                "y": 794,
                "w": 200,
                "h": 226
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 226
            },
            "sourceSize":
            {
                "w": 200,
                "h": 226
            }
        },
        "fusion_landing_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 518
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 518
            },
            "sourceSize":
            {
                "w": 640,
                "h": 518
            }
        },
        "fusion_material_button_fusion.png":
        {
            "frame":
            {
                "x": 204,
                "y": 794,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "fusion_material_button_left.png":
        {
            "frame":
            {
                "x": 606,
                "y": 726,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "fusion_material_button_right.png":
        {
            "frame":
            {
                "x": 606,
                "y": 678,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "fusion_material_buttonbg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 522,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "fusion_material_main.png":
        {
            "frame":
            {
                "x": 2,
                "y": 600,
                "w": 602,
                "h": 192
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 192
            },
            "sourceSize":
            {
                "w": 602,
                "h": 192
            }
        },
        "fusion_materialcard_selected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 340,
                "w": 252,
                "h": 336
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 252,
                "h": 336
            },
            "sourceSize":
            {
                "w": 252,
                "h": 336
            }
        },
        "fusion_materialcard_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 252,
                "h": 336
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 252,
                "h": 336
            },
            "sourceSize":
            {
                "w": 252,
                "h": 336
            }
        },
        "fusion_materialcheck_selected.png":
        {
            "frame":
            {
                "x": 962,
                "y": 40,
                "w": 36,
                "h": 36
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 36,
                "h": 36
            },
            "sourceSize":
            {
                "w": 36,
                "h": 36
            }
        },
        "fusion_materialcheck_unselected.png":
        {
            "frame":
            {
                "x": 962,
                "y": 2,
                "w": 36,
                "h": 36
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 36,
                "h": 36
            },
            "sourceSize":
            {
                "w": 36,
                "h": 36
            }
        },
        "fusion_sort_button_selected.png":
        {
            "frame":
            {
                "x": 898,
                "y": 2,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        },
        "fusion_sort_button_unselected.png":
        {
            "frame":
            {
                "x": 898,
                "y": 36,
                "w": 62,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 62,
                "h": 32
            },
            "sourceSize":
            {
                "w": 62,
                "h": 32
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_fusion2_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:4c5c57b558af64d9a5c16d5648a713df$"
    }
}

,

{
    "frames":
    {

        "gasha_button_buy.png":
        {
            "frame":
            {
                "x": 2,
                "y": 898,
                "w": 528,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 528,
                "h": 46
            },
            "sourceSize":
            {
                "w": 528,
                "h": 46
            }
        },
        "gasha_button_double.png":
        {
            "frame":
            {
                "x": 2,
                "y": 898,
                "w": 528,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 528,
                "h": 46
            },
            "sourceSize":
            {
                "w": 528,
                "h": 46
            }
        },
        "gasha_button_double_gray.png":
        {
            "frame":
            {
                "x": 2,
                "y": 850,
                "w": 528,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 528,
                "h": 46
            },
            "sourceSize":
            {
                "w": 528,
                "h": 46
            }
        },
        "gasha_button_left.png":
        {
            "frame":
            {
                "x": 532,
                "y": 898,
                "w": 296,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 296,
                "h": 46
            },
            "sourceSize":
            {
                "w": 296,
                "h": 46
            }
        },
        "gasha_button_right.png":
        {
            "frame":
            {
                "x": 532,
                "y": 850,
                "w": 296,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 296,
                "h": 46
            },
            "sourceSize":
            {
                "w": 296,
                "h": 46
            }
        },
        "gasha_buttons_frame.png":
        {
            "frame":
            {
                "x": 2,
                "y": 766,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "gasha_icon_mc.png":
        {
            "frame":
            {
                "x": 960,
                "y": 662,
                "w": 40,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 40,
                "h": 30
            },
            "sourceSize":
            {
                "w": 40,
                "h": 30
            }
        },
        "gasha_icon_mdl.png":
        {
            "frame":
            {
                "x": 940,
                "y": 708,
                "w": 40,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 40,
                "h": 30
            },
            "sourceSize":
            {
                "w": 40,
                "h": 30
            }
        },
        "gasha_icon_pp.png":
        {
            "frame":
            {
                "x": 846,
                "y": 734,
                "w": 40,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 40,
                "h": 30
            },
            "sourceSize":
            {
                "w": 40,
                "h": 30
            }
        },
        "gasha_landing_frame_card.png":
        {
            "frame":
            {
                "x": 644,
                "y": 566,
                "w": 200,
                "h": 226
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 226
            },
            "sourceSize":
            {
                "w": 200,
                "h": 226
            }
        },
        "gasha_medal_button_left.png":
        {
            "frame":
            {
                "x": 846,
                "y": 614,
                "w": 130,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 130,
                "h": 46
            },
            "sourceSize":
            {
                "w": 130,
                "h": 46
            }
        },
        "gasha_medal_button_right.png":
        {
            "frame":
            {
                "x": 846,
                "y": 566,
                "w": 130,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 130,
                "h": 46
            },
            "sourceSize":
            {
                "w": 130,
                "h": 46
            }
        },
        "gasha_medal_frame.png":
        {
            "frame":
            {
                "x": 830,
                "y": 826,
                "w": 132,
                "h": 132
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 132,
                "h": 132
            },
            "sourceSize":
            {
                "w": 132,
                "h": 132
            }
        },
        "gasha_medal_window.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 298,
                "h": 282
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 298,
                "h": 282
            },
            "sourceSize":
            {
                "w": 298,
                "h": 282
            }
        },
        "gasha_multi_window.png":
        {
            "frame":
            {
                "x": 644,
                "y": 286,
                "w": 308,
                "h": 278
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 308,
                "h": 278
            },
            "sourceSize":
            {
                "w": 308,
                "h": 278
            }
        },
        "gasha_normal_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 440,
                "w": 640,
                "h": 324
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 324
            },
            "sourceSize":
            {
                "w": 640,
                "h": 324
            }
        },
        "gasha_sale_pink.png":
        {
            "frame":
            {
                "x": 846,
                "y": 662,
                "w": 112,
                "h": 44
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 44
            },
            "sourceSize":
            {
                "w": 112,
                "h": 44
            }
        },
        "gasha_single_button_left.png":
        {
            "frame":
            {
                "x": 532,
                "y": 898,
                "w": 296,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 296,
                "h": 46
            },
            "sourceSize":
            {
                "w": 296,
                "h": 46
            }
        },
        "gasha_single_button_right.png":
        {
            "frame":
            {
                "x": 532,
                "y": 850,
                "w": 296,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 296,
                "h": 46
            },
            "sourceSize":
            {
                "w": 296,
                "h": 46
            }
        },
        "gasha_single_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 436
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 436
            },
            "sourceSize":
            {
                "w": 640,
                "h": 436
            }
        },
        "gasha_single_window_bottom.png":
        {
            "frame":
            {
                "x": 2,
                "y": 766,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "gasha_tab_selected.png":
        {
            "frame":
            {
                "x": 782,
                "y": 960,
                "w": 186,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 186,
                "h": 56
            },
            "sourceSize":
            {
                "w": 186,
                "h": 56
            }
        },
        "gasha_tab_unselected.png":
        {
            "frame":
            {
                "x": 594,
                "y": 946,
                "w": 186,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 186,
                "h": 56
            },
            "sourceSize":
            {
                "w": 186,
                "h": 56
            }
        },
        "gasha_tabs_line.png":
        {
            "frame":
            {
                "x": 2,
                "y": 844,
                "w": 640,
                "h": 4
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 4
            },
            "sourceSize":
            {
                "w": 640,
                "h": 4
            }
        },
        "gasha_tag_bronze.png":
        {
            "frame":
            {
                "x": 298,
                "y": 946,
                "w": 294,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 30
            },
            "sourceSize":
            {
                "w": 294,
                "h": 30
            }
        },
        "gasha_tag_event.png":
        {
            "frame":
            {
                "x": 298,
                "y": 978,
                "w": 294,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 30
            },
            "sourceSize":
            {
                "w": 294,
                "h": 30
            }
        },
        "gasha_tag_gold.png":
        {
            "frame":
            {
                "x": 2,
                "y": 946,
                "w": 294,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 30
            },
            "sourceSize":
            {
                "w": 294,
                "h": 30
            }
        },
        "gasha_tag_new.png":
        {
            "frame":
            {
                "x": 846,
                "y": 708,
                "w": 92,
                "h": 24
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 92,
                "h": 24
            },
            "sourceSize":
            {
                "w": 92,
                "h": 24
            }
        },
        "gasha_tag_silver.png":
        {
            "frame":
            {
                "x": 2,
                "y": 978,
                "w": 294,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 30
            },
            "sourceSize":
            {
                "w": 294,
                "h": 30
            }
        },
        "gasha_tag_welcome.png":
        {
            "frame":
            {
                "x": 644,
                "y": 794,
                "w": 294,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 30
            },
            "sourceSize":
            {
                "w": 294,
                "h": 30
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_gasha_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:3c3b4b54868f1d89929020021b984d8d$"
    }
}

,

{
    "frames":
    {

        "gift_button.png":
        {
            "frame":
            {
                "x": 644,
                "y": 60,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "gift_button_all.png":
        {
            "frame":
            {
                "x": 606,
                "y": 496,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "gift_button_nogift.png":
        {
            "frame":
            {
                "x": 606,
                "y": 438,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "gift_frame_card.png":
        {
            "frame":
            {
                "x": 854,
                "y": 60,
                "w": 150,
                "h": 168
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 168
            },
            "sourceSize":
            {
                "w": 150,
                "h": 168
            }
        },
        "gift_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 680,
                "w": 602,
                "h": 240
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 240
            },
            "sourceSize":
            {
                "w": 602,
                "h": 240
            }
        },
        "gift_window_noexpire.png":
        {
            "frame":
            {
                "x": 2,
                "y": 438,
                "w": 602,
                "h": 240
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 240
            },
            "sourceSize":
            {
                "w": 602,
                "h": 240
            }
        },
        "reward_button_getone.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 318,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 318,
                "h": 56
            },
            "sourceSize":
            {
                "w": 318,
                "h": 56
            }
        },
        "reward_window_buttonback.png":
        {
            "frame":
            {
                "x": 2,
                "y": 364,
                "w": 640,
                "h": 72
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 72
            },
            "sourceSize":
            {
                "w": 640,
                "h": 72
            }
        },
        "reward_window_rewardlist.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 360
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 360
            },
            "sourceSize":
            {
                "w": 640,
                "h": 360
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_giftreward_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:8adba0bd7fdacb4a516b42baf2cda665$"
    }
}

,

{
    "frames":
    {

        "reward_button_all.png":
        {
            "frame":
            {
                "x": 476,
                "y": 778,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "reward_button_collected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 322,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "reward_button_get.png":
        {
            "frame":
            {
                "x": 644,
                "y": 274,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "reward_button_lock.png":
        {
            "frame":
            {
                "x": 644,
                "y": 226,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "reward_button_noreward.png":
        {
            "frame":
            {
                "x": 2,
                "y": 778,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "reward_green_tag.png":
        {
            "frame":
            {
                "x": 854,
                "y": 226,
                "w": 100,
                "h": 64
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 100,
                "h": 64
            },
            "sourceSize":
            {
                "w": 100,
                "h": 64
            }
        },
        "reward_itemcontainer.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 316,
                "h": 110
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 316,
                "h": 110
            },
            "sourceSize":
            {
                "w": 316,
                "h": 110
            }
        },
        "reward_maininfo.png":
        {
            "frame":
            {
                "x": 2,
                "y": 548,
                "w": 640,
                "h": 160
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 160
            },
            "sourceSize":
            {
                "w": 640,
                "h": 160
            }
        },
        "reward_mainstageinfo.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 280
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 280
            },
            "sourceSize":
            {
                "w": 640,
                "h": 280
            }
        },
        "reward_red_tag.png":
        {
            "frame":
            {
                "x": 854,
                "y": 292,
                "w": 100,
                "h": 64
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 100,
                "h": 64
            },
            "sourceSize":
            {
                "w": 100,
                "h": 64
            }
        },
        "reward_stagerewardinfo.png":
        {
            "frame":
            {
                "x": 2,
                "y": 710,
                "w": 640,
                "h": 66
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 66
            },
            "sourceSize":
            {
                "w": 640,
                "h": 66
            }
        },
        "reward_tab_selected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 170,
                "w": 294,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 54
            },
            "sourceSize":
            {
                "w": 294,
                "h": 54
            }
        },
        "reward_tab_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 114,
                "w": 294,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 54
            },
            "sourceSize":
            {
                "w": 294,
                "h": 54
            }
        },
        "reward_titles.png":
        {
            "frame":
            {
                "x": 2,
                "y": 836,
                "w": 640,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 46
            },
            "sourceSize":
            {
                "w": 640,
                "h": 46
            }
        },
        "rewards_stagecontainer.png":
        {
            "frame":
            {
                "x": 2,
                "y": 284,
                "w": 640,
                "h": 262
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 262
            },
            "sourceSize":
            {
                "w": 640,
                "h": 262
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_giftreward2_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:47337b594730a441edb6d0c59040d19d$"
    }
}

,

{
    "frames":
    {

        "100_skill_icon.png":
        {
            "frame":
            {
                "x": 2,
                "y": 903,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "10_skill_icon.png":
        {
            "frame":
            {
                "x": 204,
                "y": 552,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "110_skill_icon.png":
        {
            "frame":
            {
                "x": 552,
                "y": 2,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "120_skill_icon.png":
        {
            "frame":
            {
                "x": 442,
                "y": 2,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "130_skill_icon.png":
        {
            "frame":
            {
                "x": 332,
                "y": 882,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "140_skill_icon.png":
        {
            "frame":
            {
                "x": 332,
                "y": 772,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "150_skill_icon.png":
        {
            "frame":
            {
                "x": 332,
                "y": 662,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "160_skill_icon.png":
        {
            "frame":
            {
                "x": 314,
                "y": 552,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "170_skill_icon.png":
        {
            "frame":
            {
                "x": 314,
                "y": 442,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "180_skill_icon.png":
        {
            "frame":
            {
                "x": 314,
                "y": 332,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "190_skill_icon.png":
        {
            "frame":
            {
                "x": 314,
                "y": 222,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "200_skill_icon.png":
        {
            "frame":
            {
                "x": 314,
                "y": 112,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "20_skill_icon.png":
        {
            "frame":
            {
                "x": 204,
                "y": 442,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "210_skill_icon.png":
        {
            "frame":
            {
                "x": 314,
                "y": 2,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "220_skill_icon.png":
        {
            "frame":
            {
                "x": 222,
                "y": 882,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "230_skill_icon.png":
        {
            "frame":
            {
                "x": 222,
                "y": 772,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "240_skill_icon.png":
        {
            "frame":
            {
                "x": 222,
                "y": 662,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "250_skill_icon.png":
        {
            "frame":
            {
                "x": 2,
                "y": 793,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "260_skill_icon.png":
        {
            "frame":
            {
                "x": 2,
                "y": 683,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "30_skill_icon.png":
        {
            "frame":
            {
                "x": 204,
                "y": 332,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "40_skill_icon.png":
        {
            "frame":
            {
                "x": 204,
                "y": 222,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "50_skill_icon.png":
        {
            "frame":
            {
                "x": 204,
                "y": 112,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "60_skill_icon.png":
        {
            "frame":
            {
                "x": 204,
                "y": 2,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "70_skill_icon.png":
        {
            "frame":
            {
                "x": 112,
                "y": 903,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "80_skill_icon.png":
        {
            "frame":
            {
                "x": 112,
                "y": 793,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "90_skill_icon.png":
        {
            "frame":
            {
                "x": 112,
                "y": 683,
                "w": 108,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 108,
                "h": 108
            },
            "sourceSize":
            {
                "w": 108,
                "h": 108
            }
        },
        "pod_free_200.png":
        {
            "frame":
            {
                "x": 2,
                "y": 229,
                "w": 200,
                "h": 225
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 225
            },
            "sourceSize":
            {
                "w": 200,
                "h": 225
            }
        },
        "pod_normal_200.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 200,
                "h": 225
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 225
            },
            "sourceSize":
            {
                "w": 200,
                "h": 225
            }
        },
        "pod_premium_200.png":
        {
            "frame":
            {
                "x": 2,
                "y": 456,
                "w": 200,
                "h": 225
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 225
            },
            "sourceSize":
            {
                "w": 200,
                "h": 225
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_icons_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:d07cb253815291c22910493819863438$"
    }
}

,

{
    "frames":
    {

        "lvlup_box.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 468
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 468
            },
            "sourceSize":
            {
                "w": 640,
                "h": 468
            }
        },
        "lvlup_buttonmid.png":
        {
            "frame":
            {
                "x": 2,
                "y": 608,
                "w": 528,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 528,
                "h": 46
            },
            "sourceSize":
            {
                "w": 528,
                "h": 46
            }
        },
        "lvlup_description_level.png":
        {
            "frame":
            {
                "x": 2,
                "y": 560,
                "w": 640,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 46
            },
            "sourceSize":
            {
                "w": 640,
                "h": 46
            }
        },
        "lvlup_energy_info.png":
        {
            "frame":
            {
                "x": 2,
                "y": 472,
                "w": 640,
                "h": 86
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 86
            },
            "sourceSize":
            {
                "w": 640,
                "h": 86
            }
        },
        "lvlup_medalframe.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 230,
                "h": 230
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 230,
                "h": 230
            },
            "sourceSize":
            {
                "w": 230,
                "h": 230
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_lvlup_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:a78c3effd443353c59456fb5796a25c5$"
    }
}

,

{
    "frames":
    {

        "explo_button_fight.png":
        {
            "frame":
            {
                "x": 644,
                "y": 66,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "explo_button_ignore.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "explo_info_text.png":
        {
            "frame":
            {
                "x": 2,
                "y": 408,
                "w": 640,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 46
            },
            "sourceSize":
            {
                "w": 640,
                "h": 46
            }
        },
        "explo_newcard_tag.png":
        {
            "frame":
            {
                "x": 2,
                "y": 808,
                "w": 182,
                "h": 63
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 182,
                "h": 63
            },
            "sourceSize":
            {
                "w": 182,
                "h": 63
            }
        },
        "explo_pb_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 286,
                "w": 640,
                "h": 120
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 120
            },
            "sourceSize":
            {
                "w": 640,
                "h": 120
            }
        },
        "explo_scan_founded.png":
        {
            "frame":
            {
                "x": 618,
                "y": 462,
                "w": 252,
                "h": 140
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 252,
                "h": 140
            },
            "sourceSize":
            {
                "w": 252,
                "h": 140
            }
        },
        "explo_scan_searching.png":
        {
            "frame":
            {
                "x": 644,
                "y": 320,
                "w": 252,
                "h": 140
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 252,
                "h": 140
            },
            "sourceSize":
            {
                "w": 252,
                "h": 140
            }
        },
        "miss_boss_frames.png":
        {
            "frame":
            {
                "x": 2,
                "y": 566,
                "w": 602,
                "h": 240
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 240
            },
            "sourceSize":
            {
                "w": 602,
                "h": 240
            }
        },
        "miss_button_change_stage.png":
        {
            "frame":
            {
                "x": 644,
                "y": 194,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "miss_button_change_world.png":
        {
            "frame":
            {
                "x": 644,
                "y": 130,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "miss_button_explore.png":
        {
            "frame":
            {
                "x": 606,
                "y": 604,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "miss_button_fight.png":
        {
            "frame":
            {
                "x": 644,
                "y": 258,
                "w": 260,
                "h": 60
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 260,
                "h": 60
            },
            "sourceSize":
            {
                "w": 260,
                "h": 60
            }
        },
        "miss_container_detail.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 282
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 282
            },
            "sourceSize":
            {
                "w": 640,
                "h": 282
            }
        },
        "miss_stage_world_namebox.png":
        {
            "frame":
            {
                "x": 2,
                "y": 873,
                "w": 584,
                "h": 40
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 584,
                "h": 40
            },
            "sourceSize":
            {
                "w": 584,
                "h": 40
            }
        },
        "miss_world_image_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 456,
                "w": 614,
                "h": 108
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 614,
                "h": 108
            },
            "sourceSize":
            {
                "w": 614,
                "h": 108
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_missions_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:aab13da65421ad5c35a6a9e098a47e61$"
    }
}

,

{
    "frames":
    {

        "noenergy_button_noenergy.png":
        {
            "frame":
            {
                "x": 2,
                "y": 408,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "noenergy_graphicnoenergy.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 350,
                "h": 394
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 350,
                "h": 394
            },
            "sourceSize":
            {
                "w": 350,
                "h": 394
            }
        },
        "noenergy_landing_windows.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 404
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 404
            },
            "sourceSize":
            {
                "w": 640,
                "h": 404
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_noenergy_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:f28ad292c70eca5ca854df278db1a0e7$"
    }
}

,

{
    "frames":
    {

        "popup_alert.png":
        {
            "frame":
            {
                "x": 2,
                "y": 300,
                "w": 490,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 490,
                "h": 54
            },
            "sourceSize":
            {
                "w": 490,
                "h": 54
            }
        },
        "popup_button_left.png":
        {
            "frame":
            {
                "x": 2,
                "y": 404,
                "w": 154,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 154,
                "h": 46
            },
            "sourceSize":
            {
                "w": 154,
                "h": 46
            }
        },
        "popup_button_mid.png":
        {
            "frame":
            {
                "x": 2,
                "y": 452,
                "w": 148,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 148,
                "h": 46
            },
            "sourceSize":
            {
                "w": 148,
                "h": 46
            }
        },
        "popup_button_right.png":
        {
            "frame":
            {
                "x": 2,
                "y": 356,
                "w": 154,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 154,
                "h": 46
            },
            "sourceSize":
            {
                "w": 154,
                "h": 46
            }
        },
        "popup_error.png":
        {
            "frame":
            {
                "x": 2,
                "y": 244,
                "w": 490,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 490,
                "h": 54
            },
            "sourceSize":
            {
                "w": 490,
                "h": 54
            }
        },
        "popup_info.png":
        {
            "frame":
            {
                "x": 2,
                "y": 188,
                "w": 490,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 490,
                "h": 54
            },
            "sourceSize":
            {
                "w": 490,
                "h": 54
            }
        },
        "popup_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 490,
                "h": 184
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 490,
                "h": 184
            },
            "sourceSize":
            {
                "w": 490,
                "h": 184
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_popup_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 512,
            "h": 512
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:d8411f1c62bedccf979e46aabe91378c$"
    }
}

,

{
    "frames":
    {

        "sale_button_auto.png":
        {
            "frame":
            {
                "x": 606,
                "y": 162,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "sale_button_clear.png":
        {
            "frame":
            {
                "x": 606,
                "y": 114,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "sale_button_sell.png":
        {
            "frame":
            {
                "x": 2,
                "y": 337,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "sale_buttonbg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "sale_cardframe_selected.png":
        {
            "frame":
            {
                "x": 567,
                "y": 306,
                "w": 190,
                "h": 278
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 190,
                "h": 278
            },
            "sourceSize":
            {
                "w": 190,
                "h": 278
            }
        },
        "sale_cardframe_unselected.png":
        {
            "frame":
            {
                "x": 816,
                "y": 114,
                "w": 190,
                "h": 278
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 190,
                "h": 278
            },
            "sourceSize":
            {
                "w": 190,
                "h": 278
            }
        },
        "sale_mini_infobox.jpg":
        {
            "frame":
            {
                "x": 2,
                "y": 274,
                "w": 563,
                "h": 61
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 563,
                "h": 61
            },
            "sourceSize":
            {
                "w": 563,
                "h": 61
            }
        },
        "sale_pager_left.png":
        {
            "frame":
            {
                "x": 606,
                "y": 258,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "sale_pager_right.png":
        {
            "frame":
            {
                "x": 606,
                "y": 210,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "sale_sortwindow.png":
        {
            "frame":
            {
                "x": 2,
                "y": 80,
                "w": 602,
                "h": 192
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 192
            },
            "sourceSize":
            {
                "w": 602,
                "h": 192
            }
        },
        "sale_tab_selected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 58,
                "w": 294,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 54
            },
            "sourceSize":
            {
                "w": 294,
                "h": 54
            }
        },
        "sale_tab_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 294,
                "h": 54
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 54
            },
            "sourceSize":
            {
                "w": 294,
                "h": 54
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_sale_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:8470b12bc92e67130c3f820c0a4b996b$"
    }
}

,

{
    "frames":
    {

        "deck_bottom_box.png":
        {
            "frame":
            {
                "x": 2,
                "y": 456,
                "w": 640,
                "h": 92
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 92
            },
            "sourceSize":
            {
                "w": 640,
                "h": 92
            }
        },
        "deck_button_back.png":
        {
            "frame":
            {
                "x": 846,
                "y": 2,
                "w": 172,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 172,
                "h": 46
            },
            "sourceSize":
            {
                "w": 172,
                "h": 46
            }
        },
        "deck_button_purchase.png":
        {
            "frame":
            {
                "x": 606,
                "y": 550,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "deck_confirm_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 452
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 452
            },
            "sourceSize":
            {
                "w": 640,
                "h": 452
            }
        },
        "deck_frame_big.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 200,
                "h": 226
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 226
            },
            "sourceSize":
            {
                "w": 200,
                "h": 226
            }
        },
        "deck_frame_selected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 348,
                "w": 104,
                "h": 116
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 116
            },
            "sourceSize":
            {
                "w": 104,
                "h": 116
            }
        },
        "deck_frame_small.png":
        {
            "frame":
            {
                "x": 750,
                "y": 230,
                "w": 94,
                "h": 106
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 94,
                "h": 106
            },
            "sourceSize":
            {
                "w": 94,
                "h": 106
            }
        },
        "deck_frame_unselected.png":
        {
            "frame":
            {
                "x": 846,
                "y": 286,
                "w": 104,
                "h": 116
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 116
            },
            "sourceSize":
            {
                "w": 104,
                "h": 116
            }
        },
        "deck_pack_1.png":
        {
            "frame":
            {
                "x": 644,
                "y": 230,
                "w": 104,
                "h": 116
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 116
            },
            "sourceSize":
            {
                "w": 104,
                "h": 116
            }
        },
        "deck_pack_2.png":
        {
            "frame":
            {
                "x": 846,
                "y": 168,
                "w": 104,
                "h": 116
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 116
            },
            "sourceSize":
            {
                "w": 104,
                "h": 116
            }
        },
        "deck_pack_3.png":
        {
            "frame":
            {
                "x": 846,
                "y": 50,
                "w": 104,
                "h": 116
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 104,
                "h": 116
            },
            "sourceSize":
            {
                "w": 104,
                "h": 116
            }
        },
        "deck_pack_selected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 702,
                "w": 602,
                "h": 150
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 150
            },
            "sourceSize":
            {
                "w": 602,
                "h": 150
            }
        },
        "deck_pack_unselected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 550,
                "w": 602,
                "h": 150
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 150
            },
            "sourceSize":
            {
                "w": 602,
                "h": 150
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_starterpack_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:d7b10b936376ecdd9c0118bbbfa017c4$"
    }
}

,

{
    "frames":
    {

        "storage_bigtab_selected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 60,
                "w": 294,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 56
            },
            "sourceSize":
            {
                "w": 294,
                "h": 56
            }
        },
        "storage_bigtab_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 294,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 294,
                "h": 56
            },
            "sourceSize":
            {
                "w": 294,
                "h": 56
            }
        },
        "storage_button_usebuy.png":
        {
            "frame":
            {
                "x": 644,
                "y": 182,
                "w": 208,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 208,
                "h": 46
            },
            "sourceSize":
            {
                "w": 208,
                "h": 46
            }
        },
        "storage_cbox_box.png":
        {
            "frame":
            {
                "x": 846,
                "y": 392,
                "w": 128,
                "h": 32
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 128,
                "h": 32
            },
            "sourceSize":
            {
                "w": 128,
                "h": 32
            }
        },
        "storage_confirm_button_buymc.png":
        {
            "frame":
            {
                "x": 644,
                "y": 118,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "storage_confirm_button_purchase.png":
        {
            "frame":
            {
                "x": 606,
                "y": 578,
                "w": 414,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 414,
                "h": 56
            },
            "sourceSize":
            {
                "w": 414,
                "h": 56
            }
        },
        "storage_confirm_item_frame.png":
        {
            "frame":
            {
                "x": 644,
                "y": 230,
                "w": 200,
                "h": 226
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 200,
                "h": 226
            },
            "sourceSize":
            {
                "w": 200,
                "h": 226
            }
        },
        "storage_confirm_mobacoins.png":
        {
            "frame":
            {
                "x": 940,
                "y": 2,
                "w": 50,
                "h": 38
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 50,
                "h": 38
            },
            "sourceSize":
            {
                "w": 50,
                "h": 38
            }
        },
        "storage_confirm_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 574
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 574
            },
            "sourceSize":
            {
                "w": 640,
                "h": 574
            }
        },
        "storage_item_frame.png":
        {
            "frame":
            {
                "x": 854,
                "y": 182,
                "w": 150,
                "h": 168
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 168
            },
            "sourceSize":
            {
                "w": 150,
                "h": 168
            }
        },
        "storage_mc_container.png":
        {
            "frame":
            {
                "x": 846,
                "y": 352,
                "w": 150,
                "h": 38
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 150,
                "h": 38
            },
            "sourceSize":
            {
                "w": 150,
                "h": 38
            }
        },
        "storage_mobacoins.png":
        {
            "frame":
            {
                "x": 940,
                "y": 42,
                "w": 40,
                "h": 30
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 40,
                "h": 30
            },
            "sourceSize":
            {
                "w": 40,
                "h": 30
            }
        },
        "storage_object_window.png":
        {
            "frame":
            {
                "x": 2,
                "y": 578,
                "w": 602,
                "h": 240
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 240
            },
            "sourceSize":
            {
                "w": 602,
                "h": 240
            }
        },
        "storage_smalltab_selected.png":
        {
            "frame":
            {
                "x": 832,
                "y": 458,
                "w": 186,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 186,
                "h": 56
            },
            "sourceSize":
            {
                "w": 186,
                "h": 56
            }
        },
        "storage_smalltab_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 458,
                "w": 186,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 186,
                "h": 56
            },
            "sourceSize":
            {
                "w": 186,
                "h": 56
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_storage_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:761167ae06e2227e18980aa2678bd3ad$"
    }
}

,

{
    "frames":
    {

        "tran_area.png":
        {
            "frame":
            {
                "x": 2,
                "y": 910,
                "w": 640,
                "h": 84
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 84
            },
            "sourceSize":
            {
                "w": 640,
                "h": 84
            }
        },
        "tran_blue_big.png":
        {
            "frame":
            {
                "x": 2,
                "y": 206,
                "w": 976,
                "h": 202
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 976,
                "h": 202
            },
            "sourceSize":
            {
                "w": 976,
                "h": 202
            }
        },
        "tran_blue_small.png":
        {
            "frame":
            {
                "x": 2,
                "y": 488,
                "w": 828,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 828,
                "h": 76
            },
            "sourceSize":
            {
                "w": 828,
                "h": 76
            }
        },
        "tran_button_touch.png":
        {
            "frame":
            {
                "x": 644,
                "y": 566,
                "w": 292,
                "h": 62
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 292,
                "h": 62
            },
            "sourceSize":
            {
                "w": 292,
                "h": 62
            }
        },
        "tran_clear.png":
        {
            "frame":
            {
                "x": 2,
                "y": 824,
                "w": 640,
                "h": 84
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 84
            },
            "sourceSize":
            {
                "w": 640,
                "h": 84
            }
        },
        "tran_level.png":
        {
            "frame":
            {
                "x": 2,
                "y": 738,
                "w": 640,
                "h": 84
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 84
            },
            "sourceSize":
            {
                "w": 640,
                "h": 84
            }
        },
        "tran_orange_big.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 976,
                "h": 202
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 976,
                "h": 202
            },
            "sourceSize":
            {
                "w": 976,
                "h": 202
            }
        },
        "tran_orange_small.png":
        {
            "frame":
            {
                "x": 2,
                "y": 410,
                "w": 828,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 828,
                "h": 76
            },
            "sourceSize":
            {
                "w": 828,
                "h": 76
            }
        },
        "tran_stage.png":
        {
            "frame":
            {
                "x": 2,
                "y": 652,
                "w": 640,
                "h": 84
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 84
            },
            "sourceSize":
            {
                "w": 640,
                "h": 84
            }
        },
        "tran_up.png":
        {
            "frame":
            {
                "x": 2,
                "y": 566,
                "w": 640,
                "h": 84
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 84
            },
            "sourceSize":
            {
                "w": 640,
                "h": 84
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_transitions_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:cef06439e90c681aca8e01b9260b4373$"
    }
}

,

{
    "frames":
    {

        "tran_blue_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 1020,
                "h": 480
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 1020,
                "h": 480
            },
            "sourceSize":
            {
                "w": 1020,
                "h": 480
            }
        },
        "tran_orange_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 484,
                "w": 1020,
                "h": 480
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 1020,
                "h": 480
            },
            "sourceSize":
            {
                "w": 1020,
                "h": 480
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_transitions_bg_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:b8260f53c23d9c0bfd7d6bb75c0c6100$"
    }
}

,

{
    "frames":
    {

        "tutorial_arrow.png":
        {
            "frame":
            {
                "x": 644,
                "y": 90,
                "w": 110,
                "h": 52
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 110,
                "h": 52
            },
            "sourceSize":
            {
                "w": 110,
                "h": 52
            }
        },
        "tutorial_bottom_box.png":
        {
            "frame":
            {
                "x": 2,
                "y": 252,
                "w": 640,
                "h": 90
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 90
            },
            "sourceSize":
            {
                "w": 640,
                "h": 90
            }
        },
        "tutorial_bottom_button.png":
        {
            "frame":
            {
                "x": 548,
                "y": 344,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "tutorial_button_next.png":
        {
            "frame":
            {
                "x": 756,
                "y": 90,
                "w": 88,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 88,
                "h": 68
            },
            "sourceSize":
            {
                "w": 88,
                "h": 68
            }
        },
        "tutorial_logo.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 322,
                "h": 86
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 322,
                "h": 86
            },
            "sourceSize":
            {
                "w": 322,
                "h": 86
            }
        },
        "tutorial_text_bottom.png":
        {
            "frame":
            {
                "x": 2,
                "y": 344,
                "w": 544,
                "h": 222
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 544,
                "h": 222
            },
            "sourceSize":
            {
                "w": 544,
                "h": 222
            }
        },
        "tutorial_top_box.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 248
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 248
            },
            "sourceSize":
            {
                "w": 640,
                "h": 248
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_tutorial_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:1735f477453245b3e74a2058d0e71d98$"
    }
}

,

{
    "frames":
    {

        "bfight_you_lose.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 276
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 276
            },
            "sourceSize":
            {
                "w": 640,
                "h": 276
            }
        },
        "bfight_you_win.png":
        {
            "frame":
            {
                "x": 2,
                "y": 280,
                "w": 640,
                "h": 276
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 276
            },
            "sourceSize":
            {
                "w": 640,
                "h": 276
            }
        },
        "fusion_lvlup.png":
        {
            "frame":
            {
                "x": 2,
                "y": 558,
                "w": 440,
                "h": 190
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 440,
                "h": 190
            },
            "sourceSize":
            {
                "w": 440,
                "h": 190
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_win_lose_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:fd564ce5fea88a1039e4c342809e67ff$"
    }
}

,

{
    "frames":
    {

        "ui_bg.jpg":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 1020,
                "h": 766
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 1020,
                "h": 766
            },
            "sourceSize":
            {
                "w": 1020,
                "h": 766
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "texture_00_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:fb6ddc94c749c93eb653b795de255d3c$"
    }
},

{
    "frames":
    {

        "fusion_bottom_display.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 332
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 332
            },
            "sourceSize":
            {
                "w": 640,
                "h": 332
            }
        },
        "hud_back_arrow.png":
        {
            "frame":
            {
                "x": 941,
                "y": 2,
                "w": 80,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 80,
                "h": 100
            },
            "sourceSize":
            {
                "w": 80,
                "h": 100
            }
        },
        "hud_bfight_button_back.png":
        {
            "frame":
            {
                "x": 392,
                "y": 724,
                "w": 90,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 90,
                "h": 68
            },
            "sourceSize":
            {
                "w": 90,
                "h": 68
            }
        },
        "hud_bfight_button_skip.png":
        {
            "frame":
            {
                "x": 766,
                "y": 497,
                "w": 120,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 120,
                "h": 68
            },
            "sourceSize":
            {
                "w": 120,
                "h": 68
            }
        },
        "hud_bfight_infobar.png":
        {
            "frame":
            {
                "x": 2,
                "y": 654,
                "w": 514,
                "h": 68
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 514,
                "h": 68
            },
            "sourceSize":
            {
                "w": 514,
                "h": 68
            }
        },
        "hud_deck_selected.png":
        {
            "frame":
            {
                "x": 766,
                "y": 567,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_deck_unselected.png":
        {
            "frame":
            {
                "x": 888,
                "y": 497,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_fusion_selected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 873,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_fusion_unselected.png":
        {
            "frame":
            {
                "x": 734,
                "y": 771,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_gasha_selected.png":
        {
            "frame":
            {
                "x": 620,
                "y": 719,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_gasha_unselected.png":
        {
            "frame":
            {
                "x": 848,
                "y": 701,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_home_selected.png":
        {
            "frame":
            {
                "x": 734,
                "y": 669,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_home_unselected.png":
        {
            "frame":
            {
                "x": 620,
                "y": 617,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_info_icon.png":
        {
            "frame":
            {
                "x": 644,
                "y": 497,
                "w": 120,
                "h": 118
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 120,
                "h": 118
            },
            "sourceSize":
            {
                "w": 120,
                "h": 118
            }
        },
        "hud_infobox.png":
        {
            "frame":
            {
                "x": 2,
                "y": 542,
                "w": 616,
                "h": 110
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 616,
                "h": 110
            },
            "sourceSize":
            {
                "w": 616,
                "h": 110
            }
        },
        "hud_menu_bg_pixel.png":
        {
            "frame":
            {
                "x": 942,
                "y": 105,
                "w": 4,
                "h": 4
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 4,
                "h": 4
            },
            "sourceSize":
            {
                "w": 4,
                "h": 4
            }
        },
        "hud_menu_button_selected.png":
        {
            "frame":
            {
                "x": 798,
                "y": 299,
                "w": 152,
                "h": 196
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 152,
                "h": 196
            },
            "sourceSize":
            {
                "w": 152,
                "h": 196
            }
        },
        "hud_menu_button_unselected.png":
        {
            "frame":
            {
                "x": 644,
                "y": 299,
                "w": 152,
                "h": 196
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 152,
                "h": 196
            },
            "sourceSize":
            {
                "w": 152,
                "h": 196
            }
        },
        "hud_menu_selected.png":
        {
            "frame":
            {
                "x": 880,
                "y": 599,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_menu_unselected.png":
        {
            "frame":
            {
                "x": 2,
                "y": 756,
                "w": 112,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 112,
                "h": 100
            },
            "sourceSize":
            {
                "w": 112,
                "h": 100
            }
        },
        "hud_profile_frame.png":
        {
            "frame":
            {
                "x": 2,
                "y": 336,
                "w": 640,
                "h": 126
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 126
            },
            "sourceSize":
            {
                "w": 640,
                "h": 126
            }
        },
        "hud_rarityshield_1.png":
        {
            "frame":
            {
                "x": 208,
                "y": 756,
                "w": 90,
                "h": 90
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 90,
                "h": 90
            },
            "sourceSize":
            {
                "w": 90,
                "h": 90
            }
        },
        "hud_rarityshield_2.png":
        {
            "frame":
            {
                "x": 208,
                "y": 873,
                "w": 90,
                "h": 90
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 90,
                "h": 90
            },
            "sourceSize":
            {
                "w": 90,
                "h": 90
            }
        },
        "hud_rarityshield_3.png":
        {
            "frame":
            {
                "x": 116,
                "y": 756,
                "w": 90,
                "h": 90
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 90,
                "h": 90
            },
            "sourceSize":
            {
                "w": 90,
                "h": 90
            }
        },
        "hud_rarityshield_4.png":
        {
            "frame":
            {
                "x": 116,
                "y": 873,
                "w": 90,
                "h": 90
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 90,
                "h": 90
            },
            "sourceSize":
            {
                "w": 90,
                "h": 90
            }
        },
        "hud_rarityshield_5.png":
        {
            "frame":
            {
                "x": 300,
                "y": 873,
                "w": 90,
                "h": 90
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 90,
                "h": 90
            },
            "sourceSize":
            {
                "w": 90,
                "h": 90
            }
        },
        "hud_titlebox.png":
        {
            "frame":
            {
                "x": 2,
                "y": 464,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "loading_m.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 295,
                "h": 295
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 295,
                "h": 295
            },
            "sourceSize":
            {
                "w": 295,
                "h": 295
            }
        },
        "loading_s.png":
        {
            "frame":
            {
                "x": 518,
                "y": 654,
                "w": 100,
                "h": 100
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 100,
                "h": 100
            },
            "sourceSize":
            {
                "w": 100,
                "h": 100
            }
        },
        "pixel_pb_bg.png":
        {
            "frame":
            {
                "x": 958,
                "y": 105,
                "w": 2,
                "h": 2
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 2,
                "h": 2
            },
            "sourceSize":
            {
                "w": 2,
                "h": 2
            }
        },
        "pixel_pb_fill.png":
        {
            "frame":
            {
                "x": 952,
                "y": 105,
                "w": 2,
                "h": 2
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 2,
                "h": 2
            },
            "sourceSize":
            {
                "w": 2,
                "h": 2
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_hud_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:04a9d852ecb2454cbf35e8c81ec6432f$"
    }
}

,

{
    "frames":
    {

        "fusionani_back_glow.png":
        {
            "frame":
            {
                "x": 644,
                "y": 142,
                "w": 304,
                "h": 384
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 304,
                "h": 384
            },
            "sourceSize":
            {
                "w": 304,
                "h": 384
            }
        },
        "fusionani_blue_arrow.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 500
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 500
            },
            "sourceSize":
            {
                "w": 640,
                "h": 500
            }
        },
        "fusionani_lvlup.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 378,
                "h": 138
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 378,
                "h": 138
            },
            "sourceSize":
            {
                "w": 378,
                "h": 138
            }
        },
        "fusionani_orange_arrow.png":
        {
            "frame":
            {
                "x": 2,
                "y": 504,
                "w": 640,
                "h": 500
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 500
            },
            "sourceSize":
            {
                "w": 640,
                "h": 500
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_fusionlvlup_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:13fb19f76176c6ab9b99bb0a53a7a68b$"
    }
}

,

{
    "frames":
    {
        "help_bar_title.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "hud_menu_button_battle.png":
        {
            "frame":
            {
                "x": 2,
                "y": 916,
                "w": 106,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 106,
                "h": 104
            },
            "sourceSize":
            {
                "w": 106,
                "h": 104
            }
        },
        "hud_menu_button_collection.png":
        {
            "frame":
            {
                "x": 2,
                "y": 810,
                "w": 106,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 106,
                "h": 104
            },
            "sourceSize":
            {
                "w": 106,
                "h": 104
            }
        },
        "hud_menu_button_explore.png":
        {
            "frame":
            {
                "x": 2,
                "y": 704,
                "w": 106,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 106,
                "h": 104
            },
            "sourceSize":
            {
                "w": 106,
                "h": 104
            }
        },
        "hud_menu_button_help.png":
        {
            "frame":
            {
                "x": 860,
                "y": 2,
                "w": 106,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 106,
                "h": 104
            },
            "sourceSize":
            {
                "w": 106,
                "h": 104
            }
        },
        "hud_menu_button_sale.png":
        {
            "frame":
            {
                "x": 752,
                "y": 2,
                "w": 106,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 106,
                "h": 104
            },
            "sourceSize":
            {
                "w": 106,
                "h": 104
            }
        },
        "hud_menu_button_store.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 106,
                "h": 104
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 106,
                "h": 104
            },
            "sourceSize":
            {
                "w": 106,
                "h": 104
            }
        },
        "hud_menu_container.png":
        {
            "frame":
            {
                "x": 2,
                "y": 80,
                "w": 602,
                "h": 622
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 602,
                "h": 622
            },
            "sourceSize":
            {
                "w": 602,
                "h": 622
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_hud2_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:ee1c83279006162d8a205db5a1ee2ad4$"
    }
}

,

{
    "frames":
    {

        "stageclear_body.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 574
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 574
            },
            "sourceSize":
            {
                "w": 640,
                "h": 574
            }
        },
        "stageclear_button.png":
        {
            "frame":
            {
                "x": 2,
                "y": 802,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "stageclear_button_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 724,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "stageclear_expansion_info.png":
        {
            "frame":
            {
                "x": 2,
                "y": 860,
                "w": 640,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 46
            },
            "sourceSize":
            {
                "w": 640,
                "h": 46
            }
        },
        "stageclear_header.png":
        {
            "frame":
            {
                "x": 2,
                "y": 578,
                "w": 640,
                "h": 144
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 144
            },
            "sourceSize":
            {
                "w": 640,
                "h": 144
            }
        },
        "stageclear_newtag.png":
        {
            "frame":
            {
                "x": 738,
                "y": 2,
                "w": 92,
                "h": 24
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 92,
                "h": 24
            },
            "sourceSize":
            {
                "w": 92,
                "h": 24
            }
        },
        "stageclear_newtag_flip.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 92,
                "h": 24
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 92,
                "h": 24
            },
            "sourceSize":
            {
                "w": 92,
                "h": 24
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_stageclear_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:909f0cbb16fa04d424202721c5a1efa4$"
    }
}

,

{
    "frames":
    {

        "stageclear_2_body_small.png":
        {
            "frame":
            {
                "x": 2,
                "y": 2,
                "w": 640,
                "h": 447
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 447
            },
            "sourceSize":
            {
                "w": 640,
                "h": 447
            }
        },
        "stageclear_2_button.png":
        {
            "frame":
            {
                "x": 2,
                "y": 675,
                "w": 472,
                "h": 56
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 472,
                "h": 56
            },
            "sourceSize":
            {
                "w": 472,
                "h": 56
            }
        },
        "stageclear_2_button_bg.png":
        {
            "frame":
            {
                "x": 2,
                "y": 597,
                "w": 640,
                "h": 76
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 76
            },
            "sourceSize":
            {
                "w": 640,
                "h": 76
            }
        },
        "stageclear_2_button_left.png":
        {
            "frame":
            {
                "x": 644,
                "y": 50,
                "w": 296,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 296,
                "h": 46
            },
            "sourceSize":
            {
                "w": 296,
                "h": 46
            }
        },
        "stageclear_2_button_right.png":
        {
            "frame":
            {
                "x": 644,
                "y": 2,
                "w": 296,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 296,
                "h": 46
            },
            "sourceSize":
            {
                "w": 296,
                "h": 46
            }
        },
        "stageclear_2_expansion_info.png":
        {
            "frame":
            {
                "x": 2,
                "y": 733,
                "w": 640,
                "h": 46
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 46
            },
            "sourceSize":
            {
                "w": 640,
                "h": 46
            }
        },
        "stageclear_2_header.png":
        {
            "frame":
            {
                "x": 2,
                "y": 451,
                "w": 640,
                "h": 144
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 640,
                "h": 144
            },
            "sourceSize":
            {
                "w": 640,
                "h": 144
            }
        },
        "stageclear_2_newtag.png":
        {
            "frame":
            {
                "x": 644,
                "y": 98,
                "w": 92,
                "h": 24
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 92,
                "h": 24
            },
            "sourceSize":
            {
                "w": 92,
                "h": 24
            }
        },
        "stageclear_2_newtag_flip.png":
        {
            "frame":
            {
                "x": 738,
                "y": 98,
                "w": 92,
                "h": 24
            },
            "rotated": false,
            "trimmed": false,
            "spriteSourceSize":
            {
                "x": 0,
                "y": 0,
                "w": 92,
                "h": 24
            },
            "sourceSize":
            {
                "w": 92,
                "h": 24
            }
        }
    },
    "meta":
    {
        "app": "http://www.texturepacker.com",
        "version": "1.0",
        "image": "text_stageclear_2_200.png",
        "format": "RGBA8888",
        "size":
        {
            "w": 1024,
            "h": 1024
        },
        "scale": "1",
        "smartupdate": "$TexturePacker:SmartUpdate:d65053bc117c65ec0d137657408daf31$"
    }
}

];

var __dirname = 'Code/Resources';
var __filename = 'Code/Resources/AnimationDefinitions.js';

var animationDefinitions        = {
        "test_effect.png"       : {
            frames              : 14,
            grid                : [7 , 2],
            fps                 : 6,
            spriteSheetWidth    : 560,
            spriteSheetHeight   : 180,
            width               : 80,
            height              : 90
        },
        "gasha_pod_text.png"    : {
            frames              : 39,
            grid                : [3 , 3],
            fps                 : 30,
            spriteSheetWidth    : 1020,
            spriteSheetHeight   : 840,
            width               : 170,
            height              : 140,
            extraAssets         : [
                "gasha_pod_text_02.png",
                "gasha_pod_text_03.png",
                "gasha_pod_text_04.png",
                "gasha_pod_text_05.png"
            ]
        },
        "fusion_dna_chain_200.png"  : {
            frames                  : 21,
            grid                    : [9 , 3],
            fps                     : 30,
            spriteSheetWidth        : 1008,
            spriteSheetHeight       : 720,
            width                   : 56,
            height                  : 120
        },
        "coallition_bullet.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "coallition_hit.png"       : {
            frames              : 13,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "coallition_shoot.png"       : {
            frames              : 10,
            grid                : [10 , 1],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 112,
            width               : 100,
            height              : 112
        },
        "elder_bullet.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "elder_hit.png"       : {
            frames              : 13,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "elder_shoot.png"       : {
            frames              : 10,
            grid                : [10 , 1],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 112,
            width               : 100,
            height              : 112
        },
        "hit_melee.png"       : {
            frames              : 13,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "swarm_bullet.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "swarm_hit.png"       : {
            frames              : 13,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "swarm_shoot.png"       : {
            frames              : 10,
            grid                : [10 , 1],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 112,
            width               : 100,
            height              : 112
        },
        "fusionani_shine_animation.png"       : {
            frames              : 10,
            grid                : [5 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 400,
            width               : 200,
            height              : 200
        },
        "bonus_x3_red.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "bonus_x3_blue.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "bonus_x2_red.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "bonus_x2_blue.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "bonus_maxlvl.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "ability_blue.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "ability_red.png"       : {
            frames              : 16,
            grid                : [10 , 2],
            fps                 : 30,
            spriteSheetWidth    : 1000,
            spriteSheetHeight   : 224,
            width               : 100,
            height              : 112
        },
        "gold_pod_text.png"    : {
            frames              : 39,
            grid                : [3 , 3],
            fps                 : 30,
            spriteSheetWidth    : 1020,
            spriteSheetHeight   : 840,
            width               : 170,
            height              : 140,
            extraAssets         : [
                "gold_pod_text_02.png",
                "gold_pod_text_03.png",
                "gold_pod_text_04.png",
                "gold_pod_text_05.png"
            ]
        }
};

var __dirname = 'Code/Tutorial';
var __filename = 'Code/Tutorial/TutorialFightData.js';

var TutorialFightData = { playerWins: true,
  stageBossRewards:
   { card:
      { id: 35,
        definitionId: 11000211,
        xp: 0,
        locked: false,
        lockedStatus: '' },
     maxExploreEnergy: 142,
     collectionRewards: {} },
  animations:
   [ { turn: 'player',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 966 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 1,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 104 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 2,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 25 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 3,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 82 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 4,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 62 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 5,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 23 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 6,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 42 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 7,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 22 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 8,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 21 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'enemy',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status2',
       skillId: 0,
       damagedDealt:
        [ { cardPosition: 3, damage: 24 },
          { cardPosition: 4, damage: 33 },
          { cardPosition: 5, damage: 30 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'enemy',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt:
        [ { cardPosition: 0, damage: 36 },
          { cardPosition: 1, damage: 36 },
          { cardPosition: 2, damage: 33 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'enemy',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status3',
       skillId: 0,
       damagedDealt:
        [ { cardPosition: 6, damage: 36 },
          { cardPosition: 7, damage: 36 },
          { cardPosition: 8, damage: 36 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 1087 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 1,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 96 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 2,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 25 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 3,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 100 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 4,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 82 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 5,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 19 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 6,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 47 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 7,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 26 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 8,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 25 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'enemy',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status2',
       skillId: 0,
       damagedDealt:
        [ { cardPosition: 3, damage: 30 },
          { cardPosition: 4, damage: 36 },
          { cardPosition: 5, damage: 33 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'enemy',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt:
        [ { cardPosition: 0, damage: 27 },
          { cardPosition: 1, damage: 33 },
          { cardPosition: 2, damage: 27 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'enemy',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status3',
       skillId: 0,
       damagedDealt:
        [ { cardPosition: 6, damage: 33 },
          { cardPosition: 7, damage: 24 },
          { cardPosition: 8, damage: 30 } ],
       attackTags: [],
       damageTags: [] },
     { turn: 'player',
       type: 'attack',
       attackCardId: 0,
       damagedUnit: 'status1',
       skillId: 0,
       damagedDealt: [ { cardPosition: 0, damage: 1208 } ],
       attackTags: [],
       damageTags: [] } ],
  hp:
   { player: [ 5180, 532, 213, 532, 508, 213, 532, 222, 213 ],
     enemy: [ 4000 ] },
  rewards:
   { card:
      { id: 35,
        definitionId: 11000211,
        xp: 0,
        locked: false,
        lockedStatus: '' },
     maxExploreEnergy: 142,
     collectionRewards: {} },
  gearXP: { player: [ 0, 0, 0, 0, 0, 0, 0, 0, 0 ], enemy: [ 0 ] } };



